/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/remote/common/remoteHosts","vs/platform/window/common/window","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/backup/electron-main/backup","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],ae=function(Q){for(var e=[],C=0,L=Q.length;C<L;C++)e[C]=oe[Q[C]];return e};define(oe[135],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFindFirst=e.findMaxIdxBy=e.findFirstMinBy=e.findLastMaxBy=e.findFirstMaxBy=e.MonotonousArray=e.findFirstIdxMonotonous=e.findFirstIdxMonotonousOrArrLen=e.findFirstMonotonous=e.findLastIdxMonotonous=e.findLastMonotonous=e.findLastIdx=e.findLast=void 0;function C(v,m,g){const h=L(v,m);if(h!==-1)return v[h]}e.findLast=C;function L(v,m,g=v.length-1){for(let h=g;h>=0;h--){const d=v[h];if(m(d))return h}return-1}e.findLastIdx=L;function r(v,m){const g=O(v,m);return g===-1?void 0:v[g]}e.findLastMonotonous=r;function O(v,m,g=0,h=v.length){let d=g,p=h;for(;d<p;){const a=Math.floor((d+p)/2);m(v[a])?d=a+1:p=a}return d-1}e.findLastIdxMonotonous=O;function M(v,m){const g=I(v,m);return g===v.length?void 0:v[g]}e.findFirstMonotonous=M;function I(v,m,g=0,h=v.length){let d=g,p=h;for(;d<p;){const a=Math.floor((d+p)/2);m(v[a])?p=a:d=a+1}return d}e.findFirstIdxMonotonousOrArrLen=I;function f(v,m,g=0,h=v.length){const d=I(v,m,g,h);return d===v.length?-1:d}e.findFirstIdxMonotonous=f;class l{static{this.assertInvariants=!1}constructor(m){this._array=m,this._findLastMonotonousLastIdx=0}findLastMonotonous(m){if(l.assertInvariants){if(this._prevFindLastPredicate){for(const h of this._array)if(this._prevFindLastPredicate(h)&&!m(h))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=m}const g=O(this._array,m,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=g+1,g===-1?void 0:this._array[g]}}e.MonotonousArray=l;function w(v,m){if(v.length===0)return;let g=v[0];for(let h=1;h<v.length;h++){const d=v[h];m(d,g)>0&&(g=d)}return g}e.findFirstMaxBy=w;function b(v,m){if(v.length===0)return;let g=v[0];for(let h=1;h<v.length;h++){const d=v[h];m(d,g)>=0&&(g=d)}return g}e.findLastMaxBy=b;function E(v,m){return w(v,(g,h)=>-m(g,h))}e.findFirstMinBy=E;function u(v,m){if(v.length===0)return-1;let g=0;for(let h=1;h<v.length;h++){const d=v[h];m(d,v[g])>0&&(g=h)}return g}e.findMaxIdxBy=u;function y(v,m){for(const g of v){const h=m(g);if(h!==void 0)return h}}e.mapFindFirst=y}),define(oe[136],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.intersection=e.diffMaps=e.diffSets=e.groupBy=void 0;function C(M,I){const f=Object.create(null);for(const l of M){const w=I(l);let b=f[w];b||(b=f[w]=[]),b.push(l)}return f}e.groupBy=C;function L(M,I){const f=[],l=[];for(const w of M)I.has(w)||f.push(w);for(const w of I)M.has(w)||l.push(w);return{removed:f,added:l}}e.diffSets=L;function r(M,I){const f=[],l=[];for(const[w,b]of M)I.has(w)||f.push(b);for(const[w,b]of I)M.has(w)||l.push(b);return{removed:f,added:l}}e.diffMaps=r;function O(M,I){const f=new Set;for(const l of I)M.has(l)&&f.add(l);return f}e.intersection=O}),define(oe[137],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function C(I,f){const l=Math.pow(10,f);return Math.round(I*l)/l}class L{constructor(f,l,w,b=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,w))|0,this.a=C(Math.max(Math.min(1,b),0),3)}static equals(f,l){return f.r===l.r&&f.g===l.g&&f.b===l.b&&f.a===l.a}}e.RGBA=L;class r{constructor(f,l,w,b){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=C(Math.max(Math.min(1,l),0),3),this.l=C(Math.max(Math.min(1,w),0),3),this.a=C(Math.max(Math.min(1,b),0),3)}static equals(f,l){return f.h===l.h&&f.s===l.s&&f.l===l.l&&f.a===l.a}static fromRGBA(f){const l=f.r/255,w=f.g/255,b=f.b/255,E=f.a,u=Math.max(l,w,b),y=Math.min(l,w,b);let v=0,m=0;const g=(y+u)/2,h=u-y;if(h>0){switch(m=Math.min(g<=.5?h/(2*g):h/(2-2*g),1),u){case l:v=(w-b)/h+(w<b?6:0);break;case w:v=(b-l)/h+2;break;case b:v=(l-w)/h+4;break}v*=60,v=Math.round(v)}return new r(v,m,g,E)}static _hue2rgb(f,l,w){return w<0&&(w+=1),w>1&&(w-=1),w<1/6?f+(l-f)*6*w:w<1/2?l:w<2/3?f+(l-f)*(2/3-w)*6:f}static toRGBA(f){const l=f.h/360,{s:w,l:b,a:E}=f;let u,y,v;if(w===0)u=y=v=b;else{const m=b<.5?b*(1+w):b+w-b*w,g=2*b-m;u=r._hue2rgb(g,m,l+1/3),y=r._hue2rgb(g,m,l),v=r._hue2rgb(g,m,l-1/3)}return new L(Math.round(u*255),Math.round(y*255),Math.round(v*255),E)}}e.HSLA=r;class O{constructor(f,l,w,b){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=C(Math.max(Math.min(1,l),0),3),this.v=C(Math.max(Math.min(1,w),0),3),this.a=C(Math.max(Math.min(1,b),0),3)}static equals(f,l){return f.h===l.h&&f.s===l.s&&f.v===l.v&&f.a===l.a}static fromRGBA(f){const l=f.r/255,w=f.g/255,b=f.b/255,E=Math.max(l,w,b),u=Math.min(l,w,b),y=E-u,v=E===0?0:y/E;let m;return y===0?m=0:E===l?m=((w-b)/y%6+6)%6:E===w?m=(b-l)/y+2:m=(l-w)/y+4,new O(Math.round(m*60),v,E,f.a)}static toRGBA(f){const{h:l,s:w,v:b,a:E}=f,u=b*w,y=u*(1-Math.abs(l/60%2-1)),v=b-u;let[m,g,h]=[0,0,0];return l<60?(m=u,g=y):l<120?(m=y,g=u):l<180?(g=u,h=y):l<240?(g=y,h=u):l<300?(m=y,h=u):l<=360&&(m=u,h=y),m=Math.round((m+v)*255),g=Math.round((g+v)*255),h=Math.round((h+v)*255),new L(m,g,h,E)}}e.HSVA=O;class M{static fromHex(f){return M.Format.CSS.parseHex(f)||M.red}static equals(f,l){return!f&&!l?!0:!f||!l?!1:f.equals(l)}get hsla(){return this._hsla?this._hsla:r.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:O.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof L)this.rgba=f;else if(f instanceof r)this._hsla=f,this.rgba=r.toRGBA(f);else if(f instanceof O)this._hsva=f,this.rgba=O.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&L.equals(this.rgba,f.rgba)&&r.equals(this.hsla,f.hsla)&&O.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=M._relativeLuminanceForComponent(this.rgba.r),l=M._relativeLuminanceForComponent(this.rgba.g),w=M._relativeLuminanceForComponent(this.rgba.b),b=.2126*f+.7152*l+.0722*w;return C(b,4)}static _relativeLuminanceForComponent(f){const l=f/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(f){const l=this.getRelativeLuminance(),w=f.getRelativeLuminance();return l>w?(l+.05)/(w+.05):(w+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const l=this.getRelativeLuminance(),w=f.getRelativeLuminance();return l>w}isDarkerThan(f){const l=this.getRelativeLuminance(),w=f.getRelativeLuminance();return l<w}lighten(f){return new M(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new M(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:l,g:w,b,a:E}=this.rgba;return new M(new L(l,w,b,E*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new M(new L(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const l=f.rgba,w=this.rgba.a,b=l.a,E=w+b*(1-w);if(E<1e-6)return M.transparent;const u=this.rgba.r*w/E+l.r*b*(1-w)/E,y=this.rgba.g*w/E+l.g*b*(1-w)/E,v=this.rgba.b*w/E+l.b*b*(1-w)/E;return new M(new L(u,y,v,E))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:l,g:w,b,a:E}=this.rgba;return new M(new L(f.rgba.r-E*(f.rgba.r-l),f.rgba.g-E*(f.rgba.g-w),f.rgba.b-E*(f.rgba.b-b),1))}flatten(...f){const l=f.reduceRight((w,b)=>M._flatten(b,w));return M._flatten(this,l)}static _flatten(f,l){const w=1-f.rgba.a;return new M(new L(w*l.rgba.r+f.rgba.a*f.rgba.r,w*l.rgba.g+f.rgba.a*f.rgba.g,w*l.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this._toString||(this._toString=M.Format.CSS.format(this)),this._toString}static getLighterColor(f,l,w){if(f.isLighterThan(l))return f;w=w||.5;const b=f.getRelativeLuminance(),E=l.getRelativeLuminance();return w=w*(E-b)/E,f.lighten(w)}static getDarkerColor(f,l,w){if(f.isDarkerThan(l))return f;w=w||.5;const b=f.getRelativeLuminance(),E=l.getRelativeLuminance();return w=w*(b-E)/b,f.darken(w)}static{this.white=new M(new L(255,255,255,1))}static{this.black=new M(new L(0,0,0,1))}static{this.red=new M(new L(255,0,0,1))}static{this.blue=new M(new L(0,0,255,1))}static{this.green=new M(new L(0,255,0,1))}static{this.cyan=new M(new L(0,255,255,1))}static{this.lightgrey=new M(new L(211,211,211,1))}static{this.transparent=new M(new L(0,0,0,0))}}e.Color=M,function(I){let f;(function(l){let w;(function(b){function E(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:I.Format.CSS.formatRGBA(t)}b.formatRGB=E;function u(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}b.formatRGBA=u;function y(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:I.Format.CSS.formatHSLA(t)}b.formatHSL=y;function v(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}b.formatHSLA=v;function m(t){const o=t.toString(16);return o.length!==2?"0"+o:o}function g(t){return`#${m(t.rgba.r)}${m(t.rgba.g)}${m(t.rgba.b)}`}b.formatHex=g;function h(t,o=!1){return o&&t.rgba.a===1?I.Format.CSS.formatHex(t):`#${m(t.rgba.r)}${m(t.rgba.g)}${m(t.rgba.b)}${m(Math.round(t.rgba.a*255))}`}b.formatHexA=h;function d(t){return t.isOpaque()?I.Format.CSS.formatHex(t):I.Format.CSS.formatRGBA(t)}b.format=d;function p(t){const o=t.length;if(o===0||t.charCodeAt(0)!==35)return null;if(o===7){const s=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),n=16*a(t.charCodeAt(5))+a(t.charCodeAt(6));return new I(new L(s,i,n,1))}if(o===9){const s=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),n=16*a(t.charCodeAt(5))+a(t.charCodeAt(6)),c=16*a(t.charCodeAt(7))+a(t.charCodeAt(8));return new I(new L(s,i,n,c/255))}if(o===4){const s=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),n=a(t.charCodeAt(3));return new I(new L(16*s+s,16*i+i,16*n+n))}if(o===5){const s=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),n=a(t.charCodeAt(3)),c=a(t.charCodeAt(4));return new I(new L(16*s+s,16*i+i,16*n+n,(16*c+c)/255))}return null}b.parseHex=p;function a(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(w=l.CSS||(l.CSS={}))})(f=I.Format||(I.Format={}))}(M||(e.Color=M={}))}),define(oe[50],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function C(M){return(I,f,l)=>{let w=null,b=null;if(typeof l.value=="function"?(w="value",b=l.value):typeof l.get=="function"&&(w="get",b=l.get),!b)throw new Error("not supported");l[w]=M(b,f)}}function L(M,I,f){let l=null,w=null;if(typeof f.value=="function"?(l="value",w=f.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(l="get",w=f.get),!w)throw new Error("not supported");const b=`$memoize$${I}`;f[l]=function(...E){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,E)}),this[b]}}e.memoize=L;function r(M,I,f){return C((l,w)=>{const b=`$debounce$${w}`,E=`$debounce$result$${w}`;return function(...u){this[E]||(this[E]=f?f():void 0),clearTimeout(this[b]),I&&(this[E]=I(this[E],...u),u=[this[E]]),this[b]=setTimeout(()=>{l.apply(this,u),this[E]=f?f():void 0},M)}})}e.debounce=r;function O(M,I,f){return C((l,w)=>{const b=`$throttle$timer$${w}`,E=`$throttle$result$${w}`,u=`$throttle$lastRun$${w}`,y=`$throttle$pending$${w}`;return function(...v){if(this[E]||(this[E]=f?f():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),I&&(this[E]=I(this[E],...v)),this[y])return;const m=this[u]+M;m<=Date.now()?(this[u]=Date.now(),l.apply(this,[this[E]]),this[E]=f?f():void 0):(this[y]=!0,this[b]=setTimeout(()=>{this[y]=!1,this[u]=Date.now(),l.apply(this,[this[E]]),this[E]=f?f():void 0},m-Date.now()))}})}e.throttle=O}),define(oe[14],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.ReadonlyError=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class C{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?d.isErrorNoTelemetry(t)?new d(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(o=>{o(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=C,e.errorHandler=new C;function L(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=L;function r(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=r;function O(a){l(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=O;function M(a){l(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=M;function I(a){if(a instanceof Error){const{name:t,message:o}=a,s=a.stacktrace||a.stack;return{$isError:!0,name:t,message:o,stack:s,noTelemetry:d.isErrorNoTelemetry(a)}}return a}e.transformErrorForSerialization=I;const f="Canceled";function l(a){return a instanceof w?!0:a instanceof Error&&a.name===f&&a.message===f}e.isCancellationError=l;class w extends Error{constructor(){super(f),this.name=this.message}}e.CancellationError=w;function b(){const a=new Error(f);return a.name=a.message,a}e.canceled=b;function E(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=E;function u(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=u;class y extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=y;function v(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=v;class m extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.NotImplementedError=m;class g extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.NotSupportedError=g;class h extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=h;class d extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof d)return t;const o=new d;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.ErrorNoTelemetry=d;class p extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype)}}e.BugIndicatingError=p}),define(oe[22],ae([0,1,14,135]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.reverseOrder=e.booleanComparator=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.forEachWithNeighbors=e.forEachAdjacent=e.groupAdjacentBy=e.groupBy=e.quickSelect=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function r(z,J=0){return z[z.length-(1+J)]}e.tail=r;function O(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.tail2=O;function M(z,J,B=($,K)=>$===K){if(z===J)return!0;if(!z||!J||z.length!==J.length)return!1;for(let $=0,K=z.length;$<K;$++)if(!B(z[$],J[$]))return!1;return!0}e.equals=M;function I(z,J){const B=z.length-1;J<B&&(z[J]=z[B]),z.pop()}e.removeFastWithoutKeepingOrder=I;function f(z,J,B){return l(z.length,$=>B(z[$],J))}e.binarySearch=f;function l(z,J){let B=0,$=z-1;for(;B<=$;){const K=(B+$)/2|0,re=J(K);if(re<0)B=K+1;else if(re>0)$=K-1;else return K}return-(B+1)}e.binarySearch2=l;function w(z,J,B){if(z=z|0,z>=J.length)throw new TypeError("invalid index");const $=J[Math.floor(J.length*Math.random())],K=[],re=[],le=[];for(const ge of J){const we=B(ge,$);we<0?K.push(ge):we>0?re.push(ge):le.push(ge)}return z<K.length?w(z,K,B):z<K.length+le.length?le[0]:w(z-(K.length+le.length),re,B)}e.quickSelect=w;function b(z,J){const B=[];let $;for(const K of z.slice(0).sort(J))!$||J($[0],K)!==0?($=[K],B.push($)):$.push(K);return B}e.groupBy=b;function*E(z,J){let B,$;for(const K of z)$!==void 0&&J($,K)?B.push(K):(B&&(yield B),B=[K]),$=K;B&&(yield B)}e.groupAdjacentBy=E;function u(z,J){for(let B=0;B<=z.length;B++)J(B===0?void 0:z[B-1],B===z.length?void 0:z[B])}e.forEachAdjacent=u;function y(z,J){for(let B=0;B<z.length;B++)J(B===0?void 0:z[B-1],z[B],B+1===z.length?void 0:z[B+1])}e.forEachWithNeighbors=y;function v(z,J,B){const $=[];function K(ge,we,Ie){if(we===0&&Ie.length===0)return;const De=$[$.length-1];De&&De.start+De.deleteCount===ge?(De.deleteCount+=we,De.toInsert.push(...Ie)):$.push({start:ge,deleteCount:we,toInsert:Ie})}let re=0,le=0;for(;;){if(re===z.length){K(re,0,J.slice(le));break}if(le===J.length){K(re,z.length-re,[]);break}const ge=z[re],we=J[le],Ie=B(ge,we);Ie===0?(re+=1,le+=1):Ie<0?(K(re,1,[]),re+=1):Ie>0&&(K(re,0,[we]),le+=1)}return $}e.sortedDiff=v;function m(z,J,B){const $=v(z,J,B),K=[],re=[];for(const le of $)K.push(...z.slice(le.start,le.start+le.deleteCount)),re.push(...le.toInsert);return{removed:K,added:re}}e.delta=m;function g(z,J,B){if(B===0)return[];const $=z.slice(0,B).sort(J);return d(z,J,$,B,z.length),$}e.top=g;function h(z,J,B,$,K){return B===0?Promise.resolve([]):new Promise((re,le)=>{(async()=>{const ge=z.length,we=z.slice(0,B).sort(J);for(let Ie=B,De=Math.min(B+$,ge);Ie<ge;Ie=De,De=Math.min(De+$,ge)){if(Ie>B&&await new Promise(We=>setTimeout(We)),K&&K.isCancellationRequested)throw new C.CancellationError;d(z,J,we,Ie,De)}return we})().then(re,le)})}e.topAsync=h;function d(z,J,B,$,K){for(const re=B.length;$<K;$++){const le=z[$];if(J(le,B[re-1])<0){B.pop();const ge=(0,L.findFirstIdxMonotonousOrArrLen)(B,we=>J(le,we)<0);B.splice(ge,0,le)}}}function p(z){return z.filter(J=>!!J)}e.coalesce=p;function a(z){let J=0;for(let B=0;B<z.length;B++)z[B]&&(z[J]=z[B],J+=1);z.length=J}e.coalesceInPlace=a;function t(z,J,B){z.splice(B,0,z.splice(J,1)[0])}e.move=t;function o(z){return!Array.isArray(z)||z.length===0}e.isFalsyOrEmpty=o;function s(z){return Array.isArray(z)&&z.length>0}e.isNonEmptyArray=s;function i(z,J=B=>B){const B=new Set;return z.filter($=>{const K=J($);return B.has(K)?!1:(B.add(K),!0)})}e.distinct=i;function n(z){const J=new Set;return B=>{const $=z(B);return J.has($)?!1:(J.add($),!0)}}e.uniqueFilter=n;function c(z,J){return z.length>0?z[0]:J}e.firstOrDefault=c;function S(z,J){return z.length>0?z[z.length-1]:J}e.lastOrDefault=S;function R(z,J,B=($,K)=>$===K){let $=0;for(let K=0,re=Math.min(z.length,J.length);K<re&&B(z[K],J[K]);K++)$++;return $}e.commonPrefixLength=R;function k(z){return[].concat(...z)}e.flatten=k;function P(z,J){let B=typeof J=="number"?z:0;typeof J=="number"?B=z:(B=0,J=z);const $=[];if(B<=J)for(let K=B;K<J;K++)$.push(K);else for(let K=B;K>J;K--)$.push(K);return $}e.range=P;function D(z,J,B){return z.reduce(($,K)=>($[J(K)]=B?B(K):K,$),Object.create(null))}e.index=D;function _(z,J){return z.push(J),()=>N(z,J)}e.insert=_;function N(z,J){const B=z.indexOf(J);if(B>-1)return z.splice(B,1),J}e.remove=N;function U(z,J,B){const $=z.slice(0,J),K=z.slice(J);return $.concat(B,K)}e.arrayInsert=U;function j(z,J){let B;if(typeof J=="number"){let $=J;B=()=>{const K=Math.sin($++)*179426549;return K-Math.floor(K)}}else B=Math.random;for(let $=z.length-1;$>0;$-=1){const K=Math.floor(B()*($+1)),re=z[$];z[$]=z[K],z[K]=re}}e.shuffle=j;function V(z,J){const B=z.indexOf(J);B>-1&&(z.splice(B,1),z.unshift(J))}e.pushToStart=V;function ce(z,J){const B=z.indexOf(J);B>-1&&(z.splice(B,1),z.push(J))}e.pushToEnd=ce;function se(z,J){for(const B of J)z.push(B)}e.pushMany=se;function ue(z,J){return Array.isArray(z)?z.map(J):J(z)}e.mapArrayOrNot=ue;function X(z){return Array.isArray(z)?z:[z]}e.asArray=X;function Y(z){return z[Math.floor(Math.random()*z.length)]}e.getRandomElement=Y;function x(z,J,B){const $=F(z,J),K=z.length,re=B.length;z.length=K+re;for(let le=K-1;le>=$;le--)z[le+re]=z[le];for(let le=0;le<re;le++)z[le+$]=B[le]}e.insertInto=x;function W(z,J,B,$){const K=F(z,J);let re=z.splice(K,B);return re===void 0&&(re=[]),x(z,K,$),re}e.splice=W;function F(z,J){return J<0?Math.max(J+z.length,0):Math.min(J,z.length)}var H;(function(z){function J(re){return re<0}z.isLessThan=J;function B(re){return re<=0}z.isLessThanOrEqual=B;function $(re){return re>0}z.isGreaterThan=$;function K(re){return re===0}z.isNeitherLessOrGreaterThan=K,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(H||(e.CompareResult=H={}));function q(z,J){return(B,$)=>J(z(B),z($))}e.compareBy=q;function ee(...z){return(J,B)=>{for(const $ of z){const K=$(J,B);if(!H.isNeitherLessOrGreaterThan(K))return K}return H.neitherLessOrGreaterThan}}e.tieBreakComparators=ee;const de=(z,J)=>z-J;e.numberComparator=de;const G=(z,J)=>(0,e.numberComparator)(z?1:0,J?1:0);e.booleanComparator=G;function A(z){return(J,B)=>-z(J,B)}e.reverseOrder=A;class T{constructor(J){this.items=J,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(J){let B=this.firstIdx;for(;B<this.items.length&&J(this.items[B]);)B++;const $=B===this.firstIdx?null:this.items.slice(this.firstIdx,B);return this.firstIdx=B,$}takeFromEndWhile(J){let B=this.lastIdx;for(;B>=0&&J(this.items[B]);)B--;const $=B===this.lastIdx?null:this.items.slice(B+1,this.lastIdx+1);return this.lastIdx=B,$}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const J=this.items[this.firstIdx];return this.firstIdx++,J}removeLast(){const J=this.items[this.lastIdx];return this.lastIdx--,J}takeCount(J){const B=this.items.slice(this.firstIdx,this.firstIdx+J);return this.firstIdx+=J,B}}e.ArrayQueue=T;class Z{static{this.empty=new Z(J=>{})}constructor(J){this.iterate=J}forEach(J){this.iterate(B=>(J(B),!0))}toArray(){const J=[];return this.iterate(B=>(J.push(B),!0)),J}filter(J){return new Z(B=>this.iterate($=>J($)?B($):!0))}map(J){return new Z(B=>this.iterate($=>B(J($))))}some(J){let B=!1;return this.iterate($=>(B=J($),!B)),B}findFirst(J){let B;return this.iterate($=>J($)?(B=$,!1):!0),B}findLast(J){let B;return this.iterate($=>(J($)&&(B=$),!0)),B}findLastMaxBy(J){let B,$=!0;return this.iterate(K=>(($||H.isGreaterThan(J(K,B)))&&($=!1,B=K),!0)),B}}e.CallbackIterable=Z}),define(oe[138],ae([0,1,14]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.softAssert=e.assert=e.assertNever=e.ok=void 0;function L(l,w){if(!l)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=L;function r(l,w="Unreachable"){throw new Error(w)}e.assertNever=r;function O(l){if(!l)throw new C.BugIndicatingError("Assertion Failed")}e.assert=O;function M(l){l||(0,C.onUnexpectedError)(new C.BugIndicatingError("Assertion Failed"))}e.softAssert=M;function I(l){if(!l()){debugger;l(),(0,C.onUnexpectedError)(new C.BugIndicatingError("Assertion Failed"))}}e.assertFn=I;function f(l,w){let b=0;for(;b<l.length-1;){const E=l[b],u=l[b+1];if(!w(E,u))return!1;b++}return!0}e.checkAdjacentItems=f}),define(oe[84],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=void 0;function C(L,r){const O=this;let M=!1,I;return function(){if(M)return I;if(M=!0,r)try{I=L.apply(O,arguments)}finally{r()}else I=L.apply(O,arguments);return I}}e.createSingleCallFunction=C}),define(oe[72],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var C;(function(L){function r(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}L.is=r;const O=Object.freeze([]);function M(){return O}L.empty=M;function*I(t){yield t}L.single=I;function f(t){return r(t)?t:I(t)}L.wrap=f;function l(t){return t||O}L.from=l;function*w(t){for(let o=t.length-1;o>=0;o--)yield t[o]}L.reverse=w;function b(t){return!t||t[Symbol.iterator]().next().done===!0}L.isEmpty=b;function E(t){return t[Symbol.iterator]().next().value}L.first=E;function u(t,o){for(const s of t)if(o(s))return!0;return!1}L.some=u;function y(t,o){for(const s of t)if(o(s))return s}L.find=y;function*v(t,o){for(const s of t)o(s)&&(yield s)}L.filter=v;function*m(t,o){let s=0;for(const i of t)yield o(i,s++)}L.map=m;function*g(...t){for(const o of t)yield*o}L.concat=g;function h(t,o,s){let i=s;for(const n of t)i=o(i,n);return i}L.reduce=h;function*d(t,o,s=t.length){for(o<0&&(o+=t.length),s<0?s+=t.length:s>t.length&&(s=t.length);o<s;o++)yield t[o]}L.slice=d;function p(t,o=Number.POSITIVE_INFINITY){const s=[];if(o===0)return[s,t];const i=t[Symbol.iterator]();for(let n=0;n<o;n++){const c=i.next();if(c.done)return[s,L.empty()];s.push(c.value)}return[s,{[Symbol.iterator](){return i}}]}L.consume=p;async function a(t){const o=[];for await(const s of t)o.push(s);return Promise.resolve(o)}L.asyncToArray=a})(C||(e.Iterable=C={}))}),define(oe[42],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var C;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(C||(e.ScanError=C={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var r;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(r||(e.ParseErrorCode=r={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function M(t,o=!1){let s=0;const i=t.length;let n="",c=0,S=16,R=0;function k(V){let ce=0,se=0;for(;ce<V;){const ue=t.charCodeAt(s);if(ue>=48&&ue<=57)se=se*16+ue-48;else if(ue>=65&&ue<=70)se=se*16+ue-65+10;else if(ue>=97&&ue<=102)se=se*16+ue-97+10;else break;s++,ce++}return ce<V&&(se=-1),se}function P(V){s=V,n="",c=0,S=16,R=0}function D(){const V=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&l(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&l(t.charCodeAt(s)))for(s++;s<t.length&&l(t.charCodeAt(s));)s++;else return R=3,t.substring(V,s);let ce=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&l(t.charCodeAt(s))){for(s++;s<t.length&&l(t.charCodeAt(s));)s++;ce=s}else R=3;return t.substring(V,ce)}function _(){let V="",ce=s;for(;;){if(s>=i){V+=t.substring(ce,s),R=2;break}const se=t.charCodeAt(s);if(se===34){V+=t.substring(ce,s),s++;break}if(se===92){if(V+=t.substring(ce,s),s++,s>=i){R=2;break}switch(t.charCodeAt(s++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:{const X=k(4);X>=0?V+=String.fromCharCode(X):R=4;break}default:R=5}ce=s;continue}if(se>=0&&se<=31)if(f(se)){V+=t.substring(ce,s),R=2;break}else R=6;s++}return V}function N(){if(n="",R=0,c=s,s>=i)return c=i,S=17;let V=t.charCodeAt(s);if(I(V)){do s++,n+=String.fromCharCode(V),V=t.charCodeAt(s);while(I(V));return S=15}if(f(V))return s++,n+=String.fromCharCode(V),V===13&&t.charCodeAt(s)===10&&(s++,n+=`
`),S=14;switch(V){case 123:return s++,S=1;case 125:return s++,S=2;case 91:return s++,S=3;case 93:return s++,S=4;case 58:return s++,S=6;case 44:return s++,S=5;case 34:return s++,n=_(),S=10;case 47:{const ce=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!f(t.charCodeAt(s));)s++;return n=t.substring(ce,s),S=12}if(t.charCodeAt(s+1)===42){s+=2;const se=i-1;let ue=!1;for(;s<se;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,ue=!0;break}s++}return ue||(s++,R=1),n=t.substring(ce,s),S=13}return n+=String.fromCharCode(V),s++,S=16}case 45:if(n+=String.fromCharCode(V),s++,s===i||!l(t.charCodeAt(s)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=D(),S=11;default:for(;s<i&&U(V);)s++,V=t.charCodeAt(s);if(c!==s){switch(n=t.substring(c,s),n){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return n+=String.fromCharCode(V),s++,S=16}}function U(V){if(I(V)||f(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let V;do V=N();while(V>=12&&V<=15);return V}return{setPosition:P,getPosition:()=>s,scan:o?j:N,getToken:()=>S,getTokenValue:()=>n,getTokenOffset:()=>c,getTokenLength:()=>s-c,getTokenError:()=>R}}e.createScanner=M;function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var w;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(w||(w={}));function b(t,o){const s=[],i=new Object;let n;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function R(k,P,D,_){c.value=k,c.offset=P,c.length=D,c.type=_,c.colonOffset=void 0,n=c}try{d(t,{onObjectBegin:(k,P)=>{if(o<=k)throw i;n=void 0,S=o>k,s.push("")},onObjectProperty:(k,P,D)=>{if(o<P||(R(k,P,D,"property"),s[s.length-1]=k,o<=P+D))throw i},onObjectEnd:(k,P)=>{if(o<=k)throw i;n=void 0,s.pop()},onArrayBegin:(k,P)=>{if(o<=k)throw i;n=void 0,s.push(0)},onArrayEnd:(k,P)=>{if(o<=k)throw i;n=void 0,s.pop()},onLiteralValue:(k,P,D)=>{if(o<P||(R(k,P,D,a(k)),o<=P+D))throw i},onSeparator:(k,P,D)=>{if(o<=P)throw i;if(k===":"&&n&&n.type==="property")n.colonOffset=P,S=!1,n=void 0;else if(k===","){const _=s[s.length-1];typeof _=="number"?s[s.length-1]=_+1:(S=!0,s[s.length-1]=""),n=void 0}}})}catch(k){if(k!==i)throw k}return{path:s,previousNode:n,isAtPropertyKey:S,matches:k=>{let P=0;for(let D=0;P<k.length&&D<s.length;D++)if(k[P]===s[D]||k[P]==="*")P++;else if(k[P]!=="**")return!1;return P===k.length}}}e.getLocation=b;function E(t,o=[],s=O.DEFAULT){let i=null,n=[];const c=[];function S(k){Array.isArray(n)?n.push(k):i!==null&&(n[i]=k)}return d(t,{onObjectBegin:()=>{const k={};S(k),c.push(n),n=k,i=null},onObjectProperty:k=>{i=k},onObjectEnd:()=>{n=c.pop()},onArrayBegin:()=>{const k=[];S(k),c.push(n),n=k,i=null},onArrayEnd:()=>{n=c.pop()},onLiteralValue:S,onError:(k,P,D)=>{o.push({error:k,offset:P,length:D})}},s),n[0]}e.parse=E;function u(t,o=[],s=O.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(k){i.type==="property"&&(i.length=k-i.offset,i=i.parent)}function c(k){return i.children.push(k),k}d(t,{onObjectBegin:k=>{i=c({type:"object",offset:k,length:-1,parent:i,children:[]})},onObjectProperty:(k,P,D)=>{i=c({type:"property",offset:P,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:k,offset:P,length:D,parent:i})},onObjectEnd:(k,P)=>{i.length=k+P-i.offset,i=i.parent,n(k+P)},onArrayBegin:(k,P)=>{i=c({type:"array",offset:k,length:-1,parent:i,children:[]})},onArrayEnd:(k,P)=>{i.length=k+P-i.offset,i=i.parent,n(k+P)},onLiteralValue:(k,P,D)=>{c({type:a(k),offset:P,length:D,parent:i,value:k}),n(P+D)},onSeparator:(k,P,D)=>{i.type==="property"&&(k===":"?i.colonOffset=P:k===","&&n(P))},onError:(k,P,D)=>{o.push({error:k,offset:P,length:D})}},s);const R=i.children[0];return R&&delete R.parent,R}e.parseTree=u;function y(t,o){if(!t)return;let s=t;for(const i of o)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let n=!1;for(const c of s.children)if(Array.isArray(c.children)&&c.children[0].value===i){s=c.children[1],n=!0;break}if(!n)return}else{const n=i;if(s.type!=="array"||n<0||!Array.isArray(s.children)||n>=s.children.length)return;s=s.children[n]}return s}e.findNodeAtLocation=y;function v(t){if(!t.parent||!t.parent.children)return[];const o=v(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;o.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&o.push(s)}return o}e.getNodePath=v;function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const o=Object.create(null);for(const s of t.children){const i=s.children[1];i&&(o[s.children[0].value]=m(i))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=m;function g(t,o,s=!1){return o>=t.offset&&o<t.offset+t.length||s&&o===t.offset+t.length}e.contains=g;function h(t,o,s=!1){if(g(t,o,s)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=o;n++){const c=h(i[n],o,s);if(c)return c}return t}}e.findNodeAtOffset=h;function d(t,o,s=O.DEFAULT){const i=M(t,!1);function n(q){return q?()=>q(i.getTokenOffset(),i.getTokenLength()):()=>!0}function c(q){return q?ee=>q(ee,i.getTokenOffset(),i.getTokenLength()):()=>!0}const S=n(o.onObjectBegin),R=c(o.onObjectProperty),k=n(o.onObjectEnd),P=n(o.onArrayBegin),D=n(o.onArrayEnd),_=c(o.onLiteralValue),N=c(o.onSeparator),U=n(o.onComment),j=c(o.onError),V=s&&s.disallowComments,ce=s&&s.allowTrailingComma;function se(){for(;;){const q=i.scan();switch(i.getTokenError()){case 4:ue(14);break;case 5:ue(15);break;case 3:ue(13);break;case 1:V||ue(11);break;case 2:ue(12);break;case 6:ue(16);break}switch(q){case 12:case 13:V?ue(10):U();break;case 16:ue(1);break;case 15:case 14:break;default:return q}}}function ue(q,ee=[],de=[]){if(j(q),ee.length+de.length>0){let G=i.getToken();for(;G!==17;){if(ee.indexOf(G)!==-1){se();break}else if(de.indexOf(G)!==-1)break;G=se()}}}function X(q){const ee=i.getTokenValue();return q?_(ee):R(ee),se(),!0}function Y(){switch(i.getToken()){case 11:{let q=0;try{q=JSON.parse(i.getTokenValue()),typeof q!="number"&&(ue(2),q=0)}catch{ue(2)}_(q);break}case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return se(),!0}function x(){return i.getToken()!==10?(ue(3,[],[2,5]),!1):(X(!1),i.getToken()===6?(N(":"),se(),H()||ue(4,[],[2,5])):ue(5,[],[2,5]),!0)}function W(){S(),se();let q=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(q||ue(4,[],[]),N(","),se(),i.getToken()===2&&ce)break}else q&&ue(6,[],[]);x()||ue(4,[],[2,5]),q=!0}return k(),i.getToken()!==2?ue(7,[2],[]):se(),!0}function F(){P(),se();let q=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(q||ue(4,[],[]),N(","),se(),i.getToken()===4&&ce)break}else q&&ue(6,[],[]);H()||ue(4,[],[4,5]),q=!0}return D(),i.getToken()!==4?ue(8,[4],[]):se(),!0}function H(){switch(i.getToken()){case 3:return F();case 1:return W();case 10:return X(!0);default:return Y()}}return se(),i.getToken()===17?s.allowEmptyContent?!0:(ue(4,[],[]),!1):H()?(i.getToken()!==17&&ue(9,[],[]),!0):(ue(4,[],[]),!1)}e.visit=d;function p(t,o){const s=M(t),i=[];let n,c=0,S;do switch(S=s.getPosition(),n=s.scan(),n){case 12:case 13:case 17:c!==S&&i.push(t.substring(c,S)),o!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,o)),c=s.getPosition();break}while(n!==17);return i.join("")}e.stripComments=p;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(oe[139],ae([0,1,42]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function L(l,w,b){let E,u,y,v,m;if(w){for(v=w.offset,m=v+w.length,y=v;y>0&&!f(l,y-1);)y--;let S=m;for(;S<l.length&&!f(l,S);)S++;u=l.substring(y,S),E=M(u,b)}else u=l,E=0,y=0,v=0,m=l.length;const g=I(b,l);let h=!1,d=0,p;b.insertSpaces?p=O(" ",b.tabSize||4):p="	";const a=(0,C.createScanner)(u,!1);let t=!1;function o(){return g+O(p,E+d)}function s(){let S=a.scan();for(h=!1;S===15||S===14;)h=h||S===14,S=a.scan();return t=S===16||a.getTokenError()!==0,S}const i=[];function n(S,R,k){!t&&R<m&&k>v&&l.substring(R,k)!==S&&i.push({offset:R,length:k-R,content:S})}let c=s();if(c!==17){const S=a.getTokenOffset()+y,R=O(p,E);n(R,y,S)}for(;c!==17;){let S=a.getTokenOffset()+a.getTokenLength()+y,R=s(),k="";for(;!h&&(R===12||R===13);){const D=a.getTokenOffset()+y;n(" ",S,D),S=a.getTokenOffset()+a.getTokenLength()+y,k=R===12?o():"",R=s()}if(R===2)c!==1&&(d--,k=o());else if(R===4)c!==3&&(d--,k=o());else{switch(c){case 3:case 1:d++,k=o();break;case 5:case 12:k=o();break;case 13:h?k=o():k=" ";break;case 6:k=" ";break;case 10:if(R===6){k="";break}case 7:case 8:case 9:case 11:case 2:case 4:R===12||R===13?k=" ":R!==5&&R!==17&&(t=!0);break;case 16:t=!0;break}h&&(R===12||R===13)&&(k=o())}const P=a.getTokenOffset()+y;n(k,S,P),c=R}return i}e.format=L;function r(l,w){const b=JSON.stringify(l,void 0,w.insertSpaces?w.tabSize||4:"	");return w.eol!==void 0?b.replace(/\r\n|\r|\n/g,w.eol):b}e.toFormattedString=r;function O(l,w){let b="";for(let E=0;E<w;E++)b+=l;return b}function M(l,w){let b=0,E=0;const u=w.tabSize||4;for(;b<l.length;){const y=l.charAt(b);if(y===" ")E++;else if(y==="	")E+=u;else break;b++}return Math.floor(E/u)}function I(l,w){for(let b=0;b<w.length;b++){const E=w.charAt(b);if(E==="\r")return b+1<w.length&&w.charAt(b+1)===`
`?`\r
`:"\r";if(E===`
`)return`
`}return l&&l.eol||`
`}e.getEOL=I;function f(l,w){return`\r
`.indexOf(l.charAt(w))!==-1}e.isEOL=f}),define(oe[101],ae([0,1,42,139]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function r(l,w,b){return O(l,w,void 0,b)}e.removeProperty=r;function O(l,w,b,E,u){const y=w.slice(),v=[],m=(0,C.parseTree)(l,v);let g,h;for(;y.length>0&&(h=y.pop(),g=(0,C.findNodeAtLocation)(m,y),g===void 0&&b!==void 0);)typeof h=="string"?b={[h]:b}:b=[b];if(g)if(g.type==="object"&&typeof h=="string"&&Array.isArray(g.children)){const d=(0,C.findNodeAtLocation)(g,[h]);if(d!==void 0)if(b===void 0){if(!d.parent)throw new Error("Malformed AST");const p=g.children.indexOf(d.parent);let a,t=d.parent.offset+d.parent.length;if(p>0){const o=g.children[p-1];a=o.offset+o.length}else a=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return M(l,{offset:a,length:t-a,content:""},E)}else return M(l,{offset:d.offset,length:d.length,content:JSON.stringify(b)},E);else{if(b===void 0)return[];const p=`${JSON.stringify(h)}: ${JSON.stringify(b)}`,a=u?u(g.children.map(o=>o.children[0].value)):g.children.length;let t;if(a>0){const o=g.children[a-1];t={offset:o.offset+o.length,length:0,content:","+p}}else g.children.length===0?t={offset:g.offset+1,length:0,content:p}:t={offset:g.offset+1,length:0,content:p+","};return M(l,t,E)}}else if(g.type==="array"&&typeof h=="number"&&Array.isArray(g.children))if(b!==void 0){const d=`${JSON.stringify(b)}`;let p;if(g.children.length===0||h===0)p={offset:g.offset+1,length:0,content:g.children.length===0?d:d+","};else{const a=h===-1||h>g.children.length?g.children.length:h,t=g.children[a-1];p={offset:t.offset+t.length,length:0,content:","+d}}return M(l,p,E)}else{const d=h,p=g.children[d];let a;if(g.children.length===1)a={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===d){const t=g.children[d-1],o=t.offset+t.length,s=g.offset+g.length;a={offset:o,length:s-2-o,content:""}}else a={offset:p.offset,length:g.children[d+1].offset-p.offset,content:""};return M(l,a,E)}else throw new Error(`Can not add ${typeof h!="number"?"index":"property"} to parent of type ${g.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return M(l,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(b)},E)}}e.setProperty=O;function M(l,w,b){let E=I(l,w),u=w.offset,y=w.offset+w.content.length;if(w.length===0||w.content.length===0){for(;u>0&&!(0,L.isEOL)(E,u-1);)u--;for(;y<E.length&&!(0,L.isEOL)(E,y);)y++}const v=(0,L.format)(E,{offset:u,length:y-u},b);for(let g=v.length-1;g>=0;g--){const h=v[g];E=I(E,h),u=Math.min(u,h.offset),y=Math.max(y,h.offset+h.length),y+=h.content.length-h.length}const m=l.length-(E.length-y)-u;return[{offset:u,length:m,content:E.substring(u,y)}]}e.withFormatting=M;function I(l,w){return l.substring(0,w.offset)+w.content+l.substring(w.offset+w.length)}e.applyEdit=I;function f(l,w){const b=w.slice(0).sort((u,y)=>{const v=u.offset-y.offset;return v===0?u.length-y.length:v});let E=l.length;for(let u=b.length-1;u>=0;u--){const y=b[u];if(y.offset+y.length<=E)l=I(l,y);else throw new Error("Overlapping edit");E=y.offset}return l}e.applyEdits=f}),define(oe[62],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class C{constructor(r){this.executor=r,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(r){this._error=r}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=C}),define(oe[102],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class C{static{this.Undefined=new C(void 0)}constructor(O){this.element=O,this.next=C.Undefined,this.prev=C.Undefined}}class L{constructor(){this._first=C.Undefined,this._last=C.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===C.Undefined}clear(){let O=this._first;for(;O!==C.Undefined;){const M=O.next;O.prev=C.Undefined,O.next=C.Undefined,O=M}this._first=C.Undefined,this._last=C.Undefined,this._size=0}unshift(O){return this._insert(O,!1)}push(O){return this._insert(O,!0)}_insert(O,M){const I=new C(O);if(this._first===C.Undefined)this._first=I,this._last=I;else if(M){const l=this._last;this._last=I,I.prev=l,l.next=I}else{const l=this._first;this._first=I,I.next=l,l.prev=I}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(I))}}shift(){if(this._first!==C.Undefined){const O=this._first.element;return this._remove(this._first),O}}pop(){if(this._last!==C.Undefined){const O=this._last.element;return this._remove(this._last),O}}_remove(O){if(O.prev!==C.Undefined&&O.next!==C.Undefined){const M=O.prev;M.next=O.next,O.next.prev=M}else O.prev===C.Undefined&&O.next===C.Undefined?(this._first=C.Undefined,this._last=C.Undefined):O.next===C.Undefined?(this._last=this._last.prev,this._last.next=C.Undefined):O.prev===C.Undefined&&(this._first=this._first.next,this._first.prev=C.Undefined);this._size-=1}*[Symbol.iterator](){let O=this._first;for(;O!==C.Undefined;)yield O.element,O=O.next}}e.LinkedList=L}),define(oe[31],ae([0,1]),function(Q,e){"use strict";var C,L,r;Object.defineProperty(e,"__esModule",{value:!0}),e.mapsStrictEqualIgnoreOrder=e.SetMap=e.BidirectionalMap=e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function O(d,p,a){let t=d.get(p);return t===void 0&&(t=a,d.set(p,t)),t}e.getOrSet=O;function M(d){const p=[];return d.forEach((a,t)=>{p.push(`${t} => ${a}`)}),`Map(${d.size}) {${p.join(", ")}}`}e.mapToString=M;function I(d){const p=[];return d.forEach(a=>{p.push(a)}),`Set(${d.size}) {${p.join(", ")}}`}e.setToString=I;class f{constructor(p,a){this.uri=p,this.value=a}}function l(d){return Array.isArray(d)}class w{static{this.defaultToKey=p=>p.toString()}constructor(p,a){if(this[C]="ResourceMap",p instanceof w)this.map=new Map(p.map),this.toKey=a??w.defaultToKey;else if(l(p)){this.map=new Map,this.toKey=a??w.defaultToKey;for(const[t,o]of p)this.set(t,o)}else this.map=new Map,this.toKey=p??w.defaultToKey}set(p,a){return this.map.set(this.toKey(p),new f(p,a)),this}get(p){return this.map.get(this.toKey(p))?.value}has(p){return this.map.has(this.toKey(p))}get size(){return this.map.size}clear(){this.map.clear()}delete(p){return this.map.delete(this.toKey(p))}forEach(p,a){typeof a<"u"&&(p=p.bind(a));for(const[t,o]of this.map)p(o.value,o.uri,this)}*values(){for(const p of this.map.values())yield p.value}*keys(){for(const p of this.map.values())yield p.uri}*entries(){for(const p of this.map.values())yield[p.uri,p.value]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(const[,p]of this.map)yield[p.uri,p.value]}}e.ResourceMap=w;class b{constructor(p,a){this[L]="ResourceSet",!p||typeof p=="function"?this._map=new w(p):(this._map=new w(a),p.forEach(this.add,this))}get size(){return this._map.size}add(p){return this._map.set(p,p),this}clear(){this._map.clear()}delete(p){return this._map.delete(p)}forEach(p,a){this._map.forEach((t,o)=>p.call(a,o,o,this))}has(p){return this._map.has(p)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=b;var E;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(E||(e.Touch=E={}));class u{constructor(){this[r]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(p){return this._map.has(p)}get(p,a=0){const t=this._map.get(p);if(t)return a!==0&&this.touch(t,a),t.value}set(p,a,t=0){let o=this._map.get(p);if(o)o.value=a,t!==0&&this.touch(o,t);else{switch(o={key:p,value:a,next:void 0,previous:void 0},t){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(p,o),this._size++}return this}delete(p){return!!this.remove(p)}remove(p){const a=this._map.get(p);if(a)return this._map.delete(p),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const p=this._head;return this._map.delete(p.key),this.removeItem(p),this._size--,p.value}forEach(p,a){const t=this._state;let o=this._head;for(;o;){if(a?p.bind(a)(o.value,o.key,this):p(o.value,o.key,this),this._state!==t)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const p=this,a=this._state;let t=this._head;const o={[Symbol.iterator](){return o},next(){if(p._state!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.key,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return o}values(){const p=this,a=this._state;let t=this._head;const o={[Symbol.iterator](){return o},next(){if(p._state!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.value,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return o}entries(){const p=this,a=this._state;let t=this._head;const o={[Symbol.iterator](){return o},next(){if(p._state!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:[t.key,t.value],done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return o}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(p){if(p>=this.size)return;if(p===0){this.clear();return}let a=this._head,t=this.size;for(;a&&t>p;)this._map.delete(a.key),a=a.next,t--;this._head=a,this._size=t,a&&(a.previous=void 0),this._state++}addItemFirst(p){if(!this._head&&!this._tail)this._tail=p;else if(this._head)p.next=this._head,this._head.previous=p;else throw new Error("Invalid list");this._head=p,this._state++}addItemLast(p){if(!this._head&&!this._tail)this._head=p;else if(this._tail)p.previous=this._tail,this._tail.next=p;else throw new Error("Invalid list");this._tail=p,this._state++}removeItem(p){if(p===this._head&&p===this._tail)this._head=void 0,this._tail=void 0;else if(p===this._head){if(!p.next)throw new Error("Invalid list");p.next.previous=void 0,this._head=p.next}else if(p===this._tail){if(!p.previous)throw new Error("Invalid list");p.previous.next=void 0,this._tail=p.previous}else{const a=p.next,t=p.previous;if(!a||!t)throw new Error("Invalid list");a.previous=t,t.next=a}p.next=void 0,p.previous=void 0,this._state++}touch(p,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(p===this._head)return;const t=p.next,o=p.previous;p===this._tail?(o.next=void 0,this._tail=o):(t.previous=o,o.next=t),p.previous=void 0,p.next=this._head,this._head.previous=p,this._head=p,this._state++}else if(a===2){if(p===this._tail)return;const t=p.next,o=p.previous;p===this._head?(t.previous=void 0,this._head=t):(t.previous=o,o.next=t),p.next=void 0,p.previous=this._tail,this._tail.next=p,this._tail=p,this._state++}}}toJSON(){const p=[];return this.forEach((a,t)=>{p.push([t,a])}),p}fromJSON(p){this.clear();for(const[a,t]of p)this.set(a,t)}}e.LinkedMap=u;class y extends u{constructor(p,a=1){super(),this._limit=p,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(p){this._limit=p,this.checkTrim()}get ratio(){return this._ratio}set ratio(p){this._ratio=Math.min(Math.max(0,p),1),this.checkTrim()}get(p,a=2){return super.get(p,a)}peek(p){return super.get(p,0)}set(p,a){return super.set(p,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=y;class v{constructor(){this.map=new Map}add(p){return this.map.set(p,(this.map.get(p)||0)+1),this}delete(p){let a=this.map.get(p)||0;return a===0?!1:(a--,a===0?this.map.delete(p):this.map.set(p,a),!0)}has(p){return this.map.has(p)}}e.CounterSet=v;class m{constructor(p){if(this._m1=new Map,this._m2=new Map,p)for(const[a,t]of p)this.set(a,t)}clear(){this._m1.clear(),this._m2.clear()}set(p,a){this._m1.set(p,a),this._m2.set(a,p)}get(p){return this._m1.get(p)}getKey(p){return this._m2.get(p)}delete(p){const a=this._m1.get(p);return a===void 0?!1:(this._m1.delete(p),this._m2.delete(a),!0)}forEach(p,a){this._m1.forEach((t,o)=>{p.call(a,t,o,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=m;class g{constructor(){this.map=new Map}add(p,a){let t=this.map.get(p);t||(t=new Set,this.map.set(p,t)),t.add(a)}delete(p,a){const t=this.map.get(p);t&&(t.delete(a),t.size===0&&this.map.delete(p))}forEach(p,a){const t=this.map.get(p);t&&t.forEach(a)}get(p){const a=this.map.get(p);return a||new Set}}e.SetMap=g;function h(d,p){if(d===p)return!0;if(d.size!==p.size)return!1;for(const[a,t]of d)if(!p.has(a)||p.get(a)!==t)return!1;for(const[a]of p)if(!d.has(a))return!1;return!0}e.mapsStrictEqualIgnoreOrder=h}),define(oe[2],ae([0,1,22,136,31,84,72]),function(Q,e,C,L,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.markAsDisposed=e.trackDisposable=e.setDisposableTracker=e.DisposableTracker=void 0;const I=!1;let f=null;class l{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(_){let N=this.livingDisposables.get(_);return N||(N={parent:null,source:null,isSingleton:!1,value:_,idx:l.idx++},this.livingDisposables.set(_,N)),N}trackDisposable(_){const N=this.getDisposableData(_);N.source||(N.source=new Error().stack)}setParent(_,N){const U=this.getDisposableData(_);U.parent=N}markAsDisposed(_){this.livingDisposables.delete(_)}markAsSingleton(_){this.getDisposableData(_).isSingleton=!0}getRootParent(_,N){const U=N.get(_);if(U)return U;const j=_.parent?this.getRootParent(this.getDisposableData(_.parent),N):_;return N.set(_,j),j}getTrackedDisposables(){const _=new Map;return[...this.livingDisposables.entries()].filter(([,U])=>U.source!==null&&!this.getRootParent(U,_).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(_=10,N){let U;if(N)U=N;else{const ue=new Map,X=[...this.livingDisposables.values()].filter(x=>x.source!==null&&!this.getRootParent(x,ue).isSingleton);if(X.length===0)return;const Y=new Set(X.map(x=>x.value));if(U=X.filter(x=>!(x.parent&&Y.has(x.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function j(ue){function X(x,W){for(;x.length>0&&W.some(F=>typeof F=="string"?F===x[0]:x[0].match(F));)x.shift()}const Y=ue.source.split(`
`).map(x=>x.trim().replace("at ","")).filter(x=>x!=="");return X(Y,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Y.reverse()}const V=new r.SetMap;for(const ue of U){const X=j(ue);for(let Y=0;Y<=X.length;Y++)V.add(X.slice(0,Y).join(`
`),ue)}U.sort((0,C.compareBy)(ue=>ue.idx,C.numberComparator));let ce="",se=0;for(const ue of U.slice(0,_)){se++;const X=j(ue),Y=[];for(let x=0;x<X.length;x++){let W=X[x];W=`(shared with ${V.get(X.slice(0,x+1).join(`
`)).size}/${U.length} leaks) at ${W}`;const H=V.get(X.slice(0,x).join(`
`)),q=(0,L.groupBy)([...H].map(ee=>j(ee)[x]),ee=>ee);delete q[X[x]];for(const[ee,de]of Object.entries(q))Y.unshift(`    - stacktraces of ${de.length} other leaks continue with ${ee}`);Y.unshift(W)}ce+=`


==================== Leaking disposable ${se}/${U.length}: ${ue.value.constructor.name} ====================
${Y.join(`
`)}
============================================================

`}return U.length>_&&(ce+=`


... and ${U.length-_} more leaking disposables

`),{leaks:U,details:ce}}}e.DisposableTracker=l;function w(D){f=D}if(e.setDisposableTracker=w,I){const D="__is_disposable_tracked__";w(new class{trackDisposable(_){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{_[D]||console.log(N)},3e3)}setParent(_,N){if(_&&_!==t.None)try{_[D]=!0}catch{}}markAsDisposed(_){if(_&&_!==t.None)try{_[D]=!0}catch{}}markAsSingleton(_){}})}function b(D){return f?.trackDisposable(D),D}e.trackDisposable=b;function E(D){f?.markAsDisposed(D)}e.markAsDisposed=E;function u(D,_){f?.setParent(D,_)}function y(D,_){if(f)for(const N of D)f.setParent(N,_)}function v(D){return f?.markAsSingleton(D),D}e.markAsSingleton=v;function m(D){return typeof D.dispose=="function"&&D.dispose.length===0}e.isDisposable=m;function g(D){if(M.Iterable.is(D)){const _=[];for(const N of D)if(N)try{N.dispose()}catch(U){_.push(U)}if(_.length===1)throw _[0];if(_.length>1)throw new AggregateError(_,"Encountered errors while disposing of store");return Array.isArray(D)?[]:D}else if(D)return D.dispose(),D}e.dispose=g;function h(D){for(const _ of D)m(_)&&_.dispose();return[]}e.disposeIfDisposable=h;function d(...D){const _=p(()=>g(D));return y(D,_),_}e.combinedDisposable=d;function p(D){const _=b({dispose:(0,O.createSingleCallFunction)(()=>{E(_),D()})});return _}e.toDisposable=p;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,b(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{g(this._toDispose)}finally{this._toDispose.clear()}}add(_){if(!_)return _;if(_===this)throw new Error("Cannot register a disposable on itself!");return u(_,this),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(_),_}delete(_){if(_){if(_===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(_),_.dispose()}}deleteAndLeak(_){_&&this._toDispose.has(_)&&(this._toDispose.delete(_),u(_,null))}}e.DisposableStore=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new a,b(this),u(this._store,this)}dispose(){E(this),this._store.dispose()}_register(_){if(_===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(_)}}e.Disposable=t;class o{constructor(){this._isDisposed=!1,b(this)}get value(){return this._isDisposed?void 0:this._value}set value(_){this._isDisposed||_===this._value||(this._value?.dispose(),_&&u(_,this),this._value=_)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const _=this._value;return this._value=void 0,_&&u(_,null),_}}e.MutableDisposable=o;class s{constructor(_){this._disposable=new o,this._isDisposed=!1,this._disposable.value=_}get value(){return this._disposable.value}set value(_){this._isDisposed||_===this._disposable.value||(this._disposable.value=_)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=s;class i{constructor(_){this._disposable=_,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=i;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(_){let N=_;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,E(this))},this}}e.SafeDisposable=n;class c{constructor(){this.references=new Map}acquire(_,...N){let U=this.references.get(_);U||(U={counter:0,object:this.createReferencedObject(_,...N)},this.references.set(_,U));const{object:j}=U,V=(0,O.createSingleCallFunction)(()=>{--U.counter===0&&(this.destroyReferencedObject(_,U.object),this.references.delete(_))});return U.counter++,{object:j,dispose:V}}}e.ReferenceCollection=c;class S{constructor(_){this.referenceCollection=_}async acquire(_,...N){const U=this.referenceCollection.acquire(_,...N);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(j){throw U.dispose(),j}}}e.AsyncReferenceCollection=S;class R{constructor(_){this.object=_}dispose(){}}e.ImmortalReference=R;function k(D){const _=new a;try{D(_)}finally{_.dispose()}}e.disposeOnReturn=k;class P{constructor(){this._store=new Map,this._isDisposed=!1,b(this)}dispose(){E(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{g(this._store.values())}finally{this._store.clear()}}has(_){return this._store.has(_)}get size(){return this._store.size}get(_){return this._store.get(_)}set(_,N,U=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this._store.get(_)?.dispose(),this._store.set(_,N)}deleteAndDispose(_){this._store.get(_)?.dispose(),this._store.delete(_)}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=P}),define(oe[85],ae([0,1,31]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new C.LRUCache(1e4);function r(l){return f(l,"NFC",L)}e.normalizeNFC=r;const O=new C.LRUCache(1e4);function M(l){return f(l,"NFD",O)}e.normalizeNFD=M;const I=/[^\u0000-\u0080]/;function f(l,w,b){if(!l)return l;const E=b.get(l);if(E)return E;let u;return I.test(l)?u=l.normalize(w):u=l,b.set(l,u),u}e.removeAccents=function(){const l=/[\u0300-\u036f]/g;return function(w){return M(w).replace(l,"")}}()}),define(oe[140],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function C(I,f,l){return Math.min(Math.max(I,f),l)}e.clamp=C;function L(I,f){return(f+I%f)%f}e.rot=L;class r{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=r;class O{constructor(){this._n=1,this._val=0}update(f){return this._val=this._val+(f-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=O;class M{constructor(f){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(f),this._values.fill(0,0,f)}update(f){const l=this._values[this._index];return this._values[this._index]=f,this._index=(this._index+1)%this._values.length,this._sum-=l,this._sum+=f,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=M}),function(){function Q(r){const O=[];typeof r=="number"&&O.push("code/timeOrigin",r);function M(f){O.push(f,Date.now())}function I(){const f=[];for(let l=0;l<O.length;l+=2)f.push({name:O[l],startTime:O[l+1]});return f}return{mark:M,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(r){performance.mark(r)},getMarks(){let r=performance.timeOrigin;typeof r!="number"&&(r=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(r)}];for(const M of performance.getEntriesByType("mark"))O.push({name:M.name,startTime:Math.round(r+M.startTime)});return O}};if(typeof process=="object"){const r=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(r)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function C(r){return r.MonacoPerformanceMarks||(r.MonacoPerformanceMarks=e()),r.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=C(L))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var C=e();for(var L in C)(typeof exports=="object"?exports:Q)[L]=C[L]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function C(L){if(e[L])return e[L].exports;var r=e[L]={i:L,l:!1,exports:{}};return Q[L].call(r.exports,r,r.exports,C),r.l=!0,r.exports}return C.m=Q,C.c=e,C.d=function(L,r,O){C.o(L,r)||Object.defineProperty(L,r,{enumerable:!0,get:O})},C.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},C.t=function(L,r){if(1&r&&(L=C(L)),8&r||4&r&&typeof L=="object"&&L&&L.__esModule)return L;var O=Object.create(null);if(C.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:L}),2&r&&typeof L!="string")for(var M in L)C.d(O,M,function(I){return L[I]}.bind(null,M));return O},C.n=function(L){var r=L&&L.__esModule?function(){return L.default}:function(){return L};return C.d(r,"a",r),r},C.o=function(L,r){return Object.prototype.hasOwnProperty.call(L,r)},C.p="",C(C.s=0)}([function(Q,e,C){(function(L){var r;e=Q.exports=de,r=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var te=Array.prototype.slice.call(arguments,0);te.unshift("SEMVER"),console.log.apply(console,te)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],f=e.src=[],l=0,w=l++;f[w]="0|[1-9]\\d*";var b=l++;f[b]="[0-9]+";var E=l++;f[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var u=l++;f[u]="("+f[w]+")\\.("+f[w]+")\\.("+f[w]+")";var y=l++;f[y]="("+f[b]+")\\.("+f[b]+")\\.("+f[b]+")";var v=l++;f[v]="(?:"+f[w]+"|"+f[E]+")";var m=l++;f[m]="(?:"+f[b]+"|"+f[E]+")";var g=l++;f[g]="(?:-("+f[v]+"(?:\\."+f[v]+")*))";var h=l++;f[h]="(?:-?("+f[m]+"(?:\\."+f[m]+")*))";var d=l++;f[d]="[0-9A-Za-z-]+";var p=l++;f[p]="(?:\\+("+f[d]+"(?:\\."+f[d]+")*))";var a=l++,t="v?"+f[u]+f[g]+"?"+f[p]+"?";f[a]="^"+t+"$";var o="[v=\\s]*"+f[y]+f[h]+"?"+f[p]+"?",s=l++;f[s]="^"+o+"$";var i=l++;f[i]="((?:<|>)?=?)";var n=l++;f[n]=f[b]+"|x|X|\\*";var c=l++;f[c]=f[w]+"|x|X|\\*";var S=l++;f[S]="[v=\\s]*("+f[c]+")(?:\\.("+f[c]+")(?:\\.("+f[c]+")(?:"+f[g]+")?"+f[p]+"?)?)?";var R=l++;f[R]="[v=\\s]*("+f[n]+")(?:\\.("+f[n]+")(?:\\.("+f[n]+")(?:"+f[h]+")?"+f[p]+"?)?)?";var k=l++;f[k]="^"+f[i]+"\\s*"+f[S]+"$";var P=l++;f[P]="^"+f[i]+"\\s*"+f[R]+"$";var D=l++;f[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=l++;f[_]="(?:~>?)";var N=l++;f[N]="(\\s*)"+f[_]+"\\s+",I[N]=new RegExp(f[N],"g");var U=l++;f[U]="^"+f[_]+f[S]+"$";var j=l++;f[j]="^"+f[_]+f[R]+"$";var V=l++;f[V]="(?:\\^)";var ce=l++;f[ce]="(\\s*)"+f[V]+"\\s+",I[ce]=new RegExp(f[ce],"g");var se=l++;f[se]="^"+f[V]+f[S]+"$";var ue=l++;f[ue]="^"+f[V]+f[R]+"$";var X=l++;f[X]="^"+f[i]+"\\s*("+o+")$|^$";var Y=l++;f[Y]="^"+f[i]+"\\s*("+t+")$|^$";var x=l++;f[x]="(\\s*)"+f[i]+"\\s*("+o+"|"+f[S]+")",I[x]=new RegExp(f[x],"g");var W=l++;f[W]="^\\s*("+f[S]+")\\s+-\\s+("+f[S]+")\\s*$";var F=l++;f[F]="^\\s*("+f[R]+")\\s+-\\s+("+f[R]+")\\s*$";var H=l++;f[H]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)r(q,f[q]),I[q]||(I[q]=new RegExp(f[q]));function ee(te,he){if(te instanceof de)return te;if(typeof te!="string"||te.length>O||!(he?I[s]:I[a]).test(te))return null;try{return new de(te,he)}catch{return null}}function de(te,he){if(te instanceof de){if(te.loose===he)return te;te=te.version}else if(typeof te!="string")throw new TypeError("Invalid Version: "+te);if(te.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof de))return new de(te,he);r("SemVer",te,he),this.loose=he;var me=te.trim().match(he?I[s]:I[a]);if(!me)throw new TypeError("Invalid Version: "+te);if(this.raw=te,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Oe=+Ce;if(Oe>=0&&Oe<M)return Oe}return Ce}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=ee,e.valid=function(te,he){var me=ee(te,he);return me?me.version:null},e.clean=function(te,he){var me=ee(te.trim().replace(/^[=v]+/,""),he);return me?me.version:null},e.SemVer=de,de.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},de.prototype.toString=function(){return this.version},de.prototype.compare=function(te){return r("SemVer.compare",this.version,this.loose,te),te instanceof de||(te=new de(te,this.loose)),this.compareMain(te)||this.comparePre(te)},de.prototype.compareMain=function(te){return te instanceof de||(te=new de(te,this.loose)),A(this.major,te.major)||A(this.minor,te.minor)||A(this.patch,te.patch)},de.prototype.comparePre=function(te){if(te instanceof de||(te=new de(te,this.loose)),this.prerelease.length&&!te.prerelease.length)return-1;if(!this.prerelease.length&&te.prerelease.length)return 1;if(!this.prerelease.length&&!te.prerelease.length)return 0;var he=0;do{var me=this.prerelease[he],Ce=te.prerelease[he];if(r("prerelease compare",he,me,Ce),me===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(me===void 0)return-1;if(me!==Ce)return A(me,Ce)}while(++he)},de.prototype.inc=function(te,he){switch(te){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",he);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",he);break;case"prepatch":this.prerelease.length=0,this.inc("patch",he),this.inc("pre",he);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",he),this.inc("pre",he);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}he&&(this.prerelease[0]===he?isNaN(this.prerelease[1])&&(this.prerelease=[he,0]):this.prerelease=[he,0]);break;default:throw new Error("invalid increment argument: "+te)}return this.format(),this.raw=this.version,this},e.inc=function(te,he,me,Ce){typeof me=="string"&&(Ce=me,me=void 0);try{return new de(te,me).inc(he,Ce).version}catch{return null}},e.diff=function(te,he){if(J(te,he))return null;var me=ee(te),Ce=ee(he);if(me.prerelease.length||Ce.prerelease.length){for(var Oe in me)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&me[Oe]!==Ce[Oe])return"pre"+Oe;return"prerelease"}for(var Oe in me)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&me[Oe]!==Ce[Oe])return Oe},e.compareIdentifiers=A;var G=/^[0-9]+$/;function A(te,he){var me=G.test(te),Ce=G.test(he);return me&&Ce&&(te=+te,he=+he),me&&!Ce?-1:Ce&&!me?1:te<he?-1:te>he?1:0}function T(te,he,me){return new de(te,me).compare(new de(he,me))}function Z(te,he,me){return T(te,he,me)>0}function z(te,he,me){return T(te,he,me)<0}function J(te,he,me){return T(te,he,me)===0}function B(te,he,me){return T(te,he,me)!==0}function $(te,he,me){return T(te,he,me)>=0}function K(te,he,me){return T(te,he,me)<=0}function re(te,he,me,Ce){var Oe;switch(he){case"===":typeof te=="object"&&(te=te.version),typeof me=="object"&&(me=me.version),Oe=te===me;break;case"!==":typeof te=="object"&&(te=te.version),typeof me=="object"&&(me=me.version),Oe=te!==me;break;case"":case"=":case"==":Oe=J(te,me,Ce);break;case"!=":Oe=B(te,me,Ce);break;case">":Oe=Z(te,me,Ce);break;case">=":Oe=$(te,me,Ce);break;case"<":Oe=z(te,me,Ce);break;case"<=":Oe=K(te,me,Ce);break;default:throw new TypeError("Invalid operator: "+he)}return Oe}function le(te,he){if(te instanceof le){if(te.loose===he)return te;te=te.value}if(!(this instanceof le))return new le(te,he);r("comparator",te,he),this.loose=he,this.parse(te),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,r("comp",this)}e.rcompareIdentifiers=function(te,he){return A(he,te)},e.major=function(te,he){return new de(te,he).major},e.minor=function(te,he){return new de(te,he).minor},e.patch=function(te,he){return new de(te,he).patch},e.compare=T,e.compareLoose=function(te,he){return T(te,he,!0)},e.rcompare=function(te,he,me){return T(he,te,me)},e.sort=function(te,he){return te.sort(function(me,Ce){return e.compare(me,Ce,he)})},e.rsort=function(te,he){return te.sort(function(me,Ce){return e.rcompare(me,Ce,he)})},e.gt=Z,e.lt=z,e.eq=J,e.neq=B,e.gte=$,e.lte=K,e.cmp=re,e.Comparator=le;var ge={};function we(te,he){if(te instanceof we)return te.loose===he?te:new we(te.raw,he);if(te instanceof le)return new we(te.value,he);if(!(this instanceof we))return new we(te,he);if(this.loose=he,this.raw=te,this.set=te.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+te);this.format()}function Ie(te){return!te||te.toLowerCase()==="x"||te==="*"}function De(te,he,me,Ce,Oe,Ne,_e,Ve,$e,xe,He,ie,fe){return((he=Ie(me)?"":Ie(Ce)?">="+me+".0.0":Ie(Oe)?">="+me+"."+Ce+".0":">="+he)+" "+(Ve=Ie($e)?"":Ie(xe)?"<"+(+$e+1)+".0.0":Ie(He)?"<"+$e+"."+(+xe+1)+".0":ie?"<="+$e+"."+xe+"."+He+"-"+ie:"<="+Ve)).trim()}function We(te,he){for(var me=0;me<te.length;me++)if(!te[me].test(he))return!1;if(he.prerelease.length){for(me=0;me<te.length;me++)if(r(te[me].semver),te[me].semver!==ge&&te[me].semver.prerelease.length>0){var Ce=te[me].semver;if(Ce.major===he.major&&Ce.minor===he.minor&&Ce.patch===he.patch)return!0}return!1}return!0}function Ee(te,he,me){try{he=new we(he,me)}catch{return!1}return he.test(te)}function Se(te,he,me,Ce){var Oe,Ne,_e,Ve,$e;switch(te=new de(te,Ce),he=new we(he,Ce),me){case">":Oe=Z,Ne=K,_e=z,Ve=">",$e=">=";break;case"<":Oe=z,Ne=$,_e=Z,Ve="<",$e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ee(te,he,Ce))return!1;for(var xe=0;xe<he.set.length;++xe){var He=he.set[xe],ie=null,fe=null;if(He.forEach(function(ve){ve.semver===ge&&(ve=new le(">=0.0.0")),ie=ie||ve,fe=fe||ve,Oe(ve.semver,ie.semver,Ce)?ie=ve:_e(ve.semver,fe.semver,Ce)&&(fe=ve)}),ie.operator===Ve||ie.operator===$e||(!fe.operator||fe.operator===Ve)&&Ne(te,fe.semver)||fe.operator===$e&&_e(te,fe.semver))return!1}return!0}le.prototype.parse=function(te){var he=this.loose?I[X]:I[Y],me=te.match(he);if(!me)throw new TypeError("Invalid comparator: "+te);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new de(me[2],this.loose):this.semver=ge},le.prototype.toString=function(){return this.value},le.prototype.test=function(te){return r("Comparator.test",te,this.loose),this.semver===ge||(typeof te=="string"&&(te=new de(te,this.loose)),re(te,this.operator,this.semver,this.loose))},le.prototype.intersects=function(te,he){if(!(te instanceof le))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new we(te.value,he),Ee(this.value,me,he);if(te.operator==="")return me=new we(this.value,he),Ee(te.semver,me,he);var Ce=!(this.operator!==">="&&this.operator!==">"||te.operator!==">="&&te.operator!==">"),Oe=!(this.operator!=="<="&&this.operator!=="<"||te.operator!=="<="&&te.operator!=="<"),Ne=this.semver.version===te.semver.version,_e=!(this.operator!==">="&&this.operator!=="<="||te.operator!==">="&&te.operator!=="<="),Ve=re(this.semver,"<",te.semver,he)&&(this.operator===">="||this.operator===">")&&(te.operator==="<="||te.operator==="<"),$e=re(this.semver,">",te.semver,he)&&(this.operator==="<="||this.operator==="<")&&(te.operator===">="||te.operator===">");return Ce||Oe||Ne&&_e||Ve||$e},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(te){return te.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(te){var he=this.loose;te=te.trim(),r("range",te,he);var me=he?I[F]:I[W];te=te.replace(me,De),r("hyphen replace",te),te=te.replace(I[x],"$1$2$3"),r("comparator trim",te,I[x]),te=(te=(te=te.replace(I[N],"$1~")).replace(I[ce],"$1^")).split(/\s+/).join(" ");var Ce=he?I[X]:I[Y],Oe=te.split(" ").map(function(Ne){return function(_e,Ve){return r("comp",_e),_e=function($e,xe){return $e.trim().split(/\s+/).map(function(He){return function(ie,fe){r("caret",ie,fe);var ve=fe?I[ue]:I[se];return ie.replace(ve,function(Pe,ye,Le,Ue,qe){var Ke;return r("caret",ie,Pe,ye,Le,Ue,qe),Ie(ye)?Ke="":Ie(Le)?Ke=">="+ye+".0.0 <"+(+ye+1)+".0.0":Ie(Ue)?Ke=ye==="0"?">="+ye+"."+Le+".0 <"+ye+"."+(+Le+1)+".0":">="+ye+"."+Le+".0 <"+(+ye+1)+".0.0":qe?(r("replaceCaret pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Ke=ye==="0"?Le==="0"?">="+ye+"."+Le+"."+Ue+qe+" <"+ye+"."+Le+"."+(+Ue+1):">="+ye+"."+Le+"."+Ue+qe+" <"+ye+"."+(+Le+1)+".0":">="+ye+"."+Le+"."+Ue+qe+" <"+(+ye+1)+".0.0"):(r("no pr"),Ke=ye==="0"?Le==="0"?">="+ye+"."+Le+"."+Ue+" <"+ye+"."+Le+"."+(+Ue+1):">="+ye+"."+Le+"."+Ue+" <"+ye+"."+(+Le+1)+".0":">="+ye+"."+Le+"."+Ue+" <"+(+ye+1)+".0.0"),r("caret return",Ke),Ke})}(He,xe)}).join(" ")}(_e,Ve),r("caret",_e),_e=function($e,xe){return $e.trim().split(/\s+/).map(function(He){return function(ie,fe){var ve=fe?I[j]:I[U];return ie.replace(ve,function(Pe,ye,Le,Ue,qe){var Ke;return r("tilde",ie,Pe,ye,Le,Ue,qe),Ie(ye)?Ke="":Ie(Le)?Ke=">="+ye+".0.0 <"+(+ye+1)+".0.0":Ie(Ue)?Ke=">="+ye+"."+Le+".0 <"+ye+"."+(+Le+1)+".0":qe?(r("replaceTilde pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Ke=">="+ye+"."+Le+"."+Ue+qe+" <"+ye+"."+(+Le+1)+".0"):Ke=">="+ye+"."+Le+"."+Ue+" <"+ye+"."+(+Le+1)+".0",r("tilde return",Ke),Ke})}(He,xe)}).join(" ")}(_e,Ve),r("tildes",_e),_e=function($e,xe){return r("replaceXRanges",$e,xe),$e.split(/\s+/).map(function(He){return function(ie,fe){ie=ie.trim();var ve=fe?I[P]:I[k];return ie.replace(ve,function(Pe,ye,Le,Ue,qe,Ke){r("xRange",ie,Pe,ye,Le,Ue,qe,Ke);var Je=Ie(Le),Qe=Je||Ie(Ue),Xe=Qe||Ie(qe);return ye==="="&&Xe&&(ye=""),Je?Pe=ye===">"||ye==="<"?"<0.0.0":"*":ye&&Xe?(Qe&&(Ue=0),Xe&&(qe=0),ye===">"?(ye=">=",Qe?(Le=+Le+1,Ue=0,qe=0):Xe&&(Ue=+Ue+1,qe=0)):ye==="<="&&(ye="<",Qe?Le=+Le+1:Ue=+Ue+1),Pe=ye+Le+"."+Ue+"."+qe):Qe?Pe=">="+Le+".0.0 <"+(+Le+1)+".0.0":Xe&&(Pe=">="+Le+"."+Ue+".0 <"+Le+"."+(+Ue+1)+".0"),r("xRange return",Pe),Pe})}(He,xe)}).join(" ")}(_e,Ve),r("xrange",_e),_e=function($e,xe){return r("replaceStars",$e,xe),$e.trim().replace(I[H],"")}(_e,Ve),r("stars",_e),_e}(Ne,he)}).join(" ").split(/\s+/);return this.loose&&(Oe=Oe.filter(function(Ne){return!!Ne.match(Ce)})),Oe=Oe.map(function(Ne){return new le(Ne,he)})},we.prototype.intersects=function(te,he){if(!(te instanceof we))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(Ce){return te.set.some(function(Oe){return Oe.every(function(Ne){return Ce.intersects(Ne,he)})})})})},e.toComparators=function(te,he){return new we(te,he).set.map(function(me){return me.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},we.prototype.test=function(te){if(!te)return!1;typeof te=="string"&&(te=new de(te,this.loose));for(var he=0;he<this.set.length;he++)if(We(this.set[he],te))return!0;return!1},e.satisfies=Ee,e.maxSatisfying=function(te,he,me){var Ce=null,Oe=null;try{var Ne=new we(he,me)}catch{return null}return te.forEach(function(_e){Ne.test(_e)&&(Ce&&Oe.compare(_e)!==-1||(Oe=new de(Ce=_e,me)))}),Ce},e.minSatisfying=function(te,he,me){var Ce=null,Oe=null;try{var Ne=new we(he,me)}catch{return null}return te.forEach(function(_e){Ne.test(_e)&&(Ce&&Oe.compare(_e)!==1||(Oe=new de(Ce=_e,me)))}),Ce},e.validRange=function(te,he){try{return new we(te,he).range||"*"}catch{return null}},e.ltr=function(te,he,me){return Se(te,he,"<",me)},e.gtr=function(te,he,me){return Se(te,he,">",me)},e.outside=Se,e.prerelease=function(te,he){var me=ee(te,he);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(te,he,me){return te=new we(te,me),he=new we(he,me),te.intersects(he)},e.coerce=function(te){if(te instanceof de)return te;if(typeof te!="string")return null;var he=te.match(I[D]);return he==null?null:ee((he[1]||"0")+"."+(he[2]||"0")+"."+(he[3]||"0"))}}).call(this,C(1))},function(Q,e){var C,L,r=Q.exports={};function O(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function I(m){if(C===setTimeout)return setTimeout(m,0);if((C===O||!C)&&setTimeout)return C=setTimeout,setTimeout(m,0);try{return C(m,0)}catch{try{return C.call(null,m,0)}catch{return C.call(this,m,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:O}catch{C=O}try{L=typeof clearTimeout=="function"?clearTimeout:M}catch{L=M}})();var f,l=[],w=!1,b=-1;function E(){w&&f&&(w=!1,f.length?l=f.concat(l):b=-1,l.length&&u())}function u(){if(!w){var m=I(E);w=!0;for(var g=l.length;g;){for(f=l,l=[];++b<g;)f&&f[b].run();b=-1,g=l.length}f=null,w=!1,function(h){if(L===clearTimeout)return clearTimeout(h);if((L===M||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(h);try{L(h)}catch{try{return L.call(null,h)}catch{return L.call(this,h)}}}(m)}}function y(m,g){this.fun=m,this.array=g}function v(){}r.nextTick=function(m){var g=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)g[h-1]=arguments[h];l.push(new y(m,g)),l.length!==1||w||I(u)},y.prototype.run=function(){this.fun.apply(null,this.array)},r.title="browser",r.browser=!0,r.env={},r.argv=[],r.version="",r.versions={},r.on=v,r.addListener=v,r.once=v,r.off=v,r.removeListener=v,r.removeAllListeners=v,r.emit=v,r.prependListener=v,r.prependOnceListener=v,r.listeners=function(m){return[]},r.binding=function(m){throw new Error("process.binding is not supported")},r.cwd=function(){return"/"},r.chdir=function(m){throw new Error("process.chdir is not supported")},r.umask=function(){return 0}}])}),define(oe[141],ae([0,1]),function(Q,e){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(I,f,l){this.level=I,this.key=f,this.value=l,this.forward=[]}}const r=void 0;class O{constructor(I,f=2**16){this.comparator=I,this[C]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(f)|0),this._header=new L(this._maxLevel,r,r)}get size(){return this._size}clear(){this._header=new L(this._maxLevel,r,r),this._size=0}has(I){return!!O._search(this,I,this.comparator)}get(I){return O._search(this,I,this.comparator)?.value}set(I,f){return O._insert(this,I,f,this.comparator)&&(this._size+=1),this}delete(I){const f=O._delete(this,I,this.comparator);return f&&(this._size-=1),f}forEach(I,f){let l=this._header.forward[0];for(;l;)I.call(f,l.value,l.key,this),l=l.forward[0]}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this._header.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this._header.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this._header.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",f=this._header.forward[0];for(;f;)I+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return I}static _search(I,f,l){let w=I._header;for(let b=I._level-1;b>=0;b--)for(;w.forward[b]&&l(w.forward[b].key,f)<0;)w=w.forward[b];if(w=w.forward[0],w&&l(w.key,f)===0)return w}static _insert(I,f,l,w){const b=[];let E=I._header;for(let u=I._level-1;u>=0;u--){for(;E.forward[u]&&w(E.forward[u].key,f)<0;)E=E.forward[u];b[u]=E}if(E=E.forward[0],E&&w(E.key,f)===0)return E.value=l,!1;{const u=O._randomLevel(I);if(u>I._level){for(let y=I._level;y<u;y++)b[y]=I._header;I._level=u}E=new L(u,f,l);for(let y=0;y<u;y++)E.forward[y]=b[y].forward[y],b[y].forward[y]=E;return!0}}static _randomLevel(I,f=.5){let l=1;for(;Math.random()<f&&l<I._maxLevel;)l+=1;return l}static _delete(I,f,l){const w=[];let b=I._header;for(let E=I._level-1;E>=0;E--){for(;b.forward[E]&&l(b.forward[E].key,f)<0;)b=b.forward[E];w[E]=b}if(b=b.forward[0],!b||l(b.key,f)!==0)return!1;for(let E=0;E<I._level&&w[E].forward[E]===b;E++)w[E].forward[E]=b.forward[E];for(;I._level>0&&I._header.forward[I._level-1]===r;)I._level-=1;return!0}}e.SkipList=O}),define(oe[73],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const C=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(O){return new L(O)}constructor(O){this._now=C&&O===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=L}),define(oe[3],ae([0,1,14,84,2,102,73]),function(Q,e,C,L,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const I=!1,f=!1;var l;(function(k){k.None=()=>r.Disposable.None;function P(K){if(f){const{onDidAddListener:re}=K,le=y.create();let ge=0;K.onDidAddListener=()=>{++ge===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),le.print()),re?.()}}}function D(K,re){return Y(K,()=>{},0,void 0,!0,void 0,re)}k.defer=D;function _(K){return(re,le=null,ge)=>{let we=!1,Ie;return Ie=K(De=>{if(!we)return Ie?Ie.dispose():we=!0,re.call(le,De)},null,ge),we&&Ie.dispose(),Ie}}k.once=_;function N(K,re,le){return ue((ge,we=null,Ie)=>K(De=>ge.call(we,re(De)),null,Ie),le)}k.map=N;function U(K,re,le){return ue((ge,we=null,Ie)=>K(De=>{re(De),ge.call(we,De)},null,Ie),le)}k.forEach=U;function j(K,re,le){return ue((ge,we=null,Ie)=>K(De=>re(De)&&ge.call(we,De),null,Ie),le)}k.filter=j;function V(K){return K}k.signal=V;function ce(...K){return(re,le=null,ge)=>{const we=(0,r.combinedDisposable)(...K.map(Ie=>Ie(De=>re.call(le,De))));return X(we,ge)}}k.any=ce;function se(K,re,le,ge){let we=le;return N(K,Ie=>(we=re(we,Ie),we),ge)}k.reduce=se;function ue(K,re){let le;const ge={onWillAddFirstListener(){le=K(we.fire,we)},onDidRemoveLastListener(){le?.dispose()}};re||P(ge);const we=new d(ge);return re?.add(we),we.event}function X(K,re){return re instanceof Array?re.push(K):re&&re.add(K),K}function Y(K,re,le=100,ge=!1,we=!1,Ie,De){let We,Ee,Se,te=0,he;const me={leakWarningThreshold:Ie,onWillAddFirstListener(){We=K(Oe=>{te++,Ee=re(Ee,Oe),ge&&!Se&&(Ce.fire(Ee),Ee=void 0),he=()=>{const Ne=Ee;Ee=void 0,Se=void 0,(!ge||te>1)&&Ce.fire(Ne),te=0},typeof le=="number"?(clearTimeout(Se),Se=setTimeout(he,le)):Se===void 0&&(Se=0,queueMicrotask(he))})},onWillRemoveListener(){we&&te>0&&he?.()},onDidRemoveLastListener(){he=void 0,We.dispose()}};De||P(me);const Ce=new d(me);return De?.add(Ce),Ce.event}k.debounce=Y;function x(K,re=0,le){return k.debounce(K,(ge,we)=>ge?(ge.push(we),ge):[we],re,void 0,!0,void 0,le)}k.accumulate=x;function W(K,re=(ge,we)=>ge===we,le){let ge=!0,we;return j(K,Ie=>{const De=ge||!re(Ie,we);return ge=!1,we=Ie,De},le)}k.latch=W;function F(K,re,le){return[k.filter(K,re,le),k.filter(K,ge=>!re(ge),le)]}k.split=F;function H(K,re=!1,le=[],ge){let we=le.slice(),Ie=K(Ee=>{we?we.push(Ee):We.fire(Ee)});ge&&ge.add(Ie);const De=()=>{we?.forEach(Ee=>We.fire(Ee)),we=null},We=new d({onWillAddFirstListener(){Ie||(Ie=K(Ee=>We.fire(Ee)),ge&&ge.add(Ie))},onDidAddFirstListener(){we&&(re?setTimeout(De):De())},onDidRemoveLastListener(){Ie&&Ie.dispose(),Ie=null}});return ge&&ge.add(We),We.event}k.buffer=H;function q(K,re){return(ge,we,Ie)=>{const De=re(new de);return K(function(We){const Ee=De.evaluate(We);Ee!==ee&&ge.call(we,Ee)},void 0,Ie)}}k.chain=q;const ee=Symbol("HaltChainable");class de{constructor(){this.steps=[]}map(re){return this.steps.push(re),this}forEach(re){return this.steps.push(le=>(re(le),le)),this}filter(re){return this.steps.push(le=>re(le)?le:ee),this}reduce(re,le){let ge=le;return this.steps.push(we=>(ge=re(ge,we),ge)),this}latch(re=(le,ge)=>le===ge){let le=!0,ge;return this.steps.push(we=>{const Ie=le||!re(we,ge);return le=!1,ge=we,Ie?we:ee}),this}evaluate(re){for(const le of this.steps)if(re=le(re),re===ee)break;return re}}function G(K,re,le=ge=>ge){const ge=(...We)=>De.fire(le(...We)),we=()=>K.on(re,ge),Ie=()=>K.removeListener(re,ge),De=new d({onWillAddFirstListener:we,onDidRemoveLastListener:Ie});return De.event}k.fromNodeEventEmitter=G;function A(K,re,le=ge=>ge){const ge=(...We)=>De.fire(le(...We)),we=()=>K.addEventListener(re,ge),Ie=()=>K.removeEventListener(re,ge),De=new d({onWillAddFirstListener:we,onDidRemoveLastListener:Ie});return De.event}k.fromDOMEventEmitter=A;function T(K){return new Promise(re=>_(K)(re))}k.toPromise=T;function Z(K){const re=new d;return K.then(le=>{re.fire(le)},()=>{re.fire(void 0)}).finally(()=>{re.dispose()}),re.event}k.fromPromise=Z;function z(K,re,le){return re(le),K(ge=>re(ge))}k.runAndSubscribe=z;class J{constructor(re,le){this._observable=re,this._counter=0,this._hasChanged=!1;const ge={onWillAddFirstListener:()=>{re.addObserver(this)},onDidRemoveLastListener:()=>{re.removeObserver(this)}};le||P(ge),this.emitter=new d(ge),le&&le.add(this.emitter)}beginUpdate(re){this._counter++}handlePossibleChange(re){}handleChange(re,le){this._hasChanged=!0}endUpdate(re){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function B(K,re){return new J(K,re).emitter.event}k.fromObservable=B;function $(K){return(re,le,ge)=>{let we=0,Ie=!1;const De={beginUpdate(){we++},endUpdate(){we--,we===0&&(K.reportChanges(),Ie&&(Ie=!1,re.call(le)))},handlePossibleChange(){},handleChange(){Ie=!0}};K.addObserver(De),K.reportChanges();const We={dispose(){K.removeObserver(De)}};return ge instanceof r.DisposableStore?ge.add(We):Array.isArray(ge)&&ge.push(We),We}}k.fromObservableLight=$})(l||(e.Event=l={}));class w{static{this.all=new Set}static{this._idPool=0}constructor(P){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${P}_${w._idPool++}`,w.all.add(this)}start(P){this._stopWatch=new M.StopWatch,this.listenerCount=P}stop(){if(this._stopWatch){const P=this._stopWatch.elapsed();this.durations.push(P),this.elapsedOverall+=P,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=w;let b=-1;function E(k){const P=b;return b=k,{dispose(){b=P}}}e.setGlobalLeakWarningThreshold=E;class u{constructor(P,D=Math.random().toString(18).slice(2,5)){this.threshold=P,this.name=D,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(P,D){const _=this.threshold;if(_<=0||D<_)return;this._stacks||(this._stacks=new Map);const N=this._stacks.get(P.value)||0;if(this._stacks.set(P.value,N+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=_*.5;let U,j=0;for(const[V,ce]of this._stacks)(!U||j<ce)&&(U=V,j=ce);console.warn(`[${this.name}] potential listener LEAK detected, having ${D} listeners already. MOST frequent listener (${j}):`),console.warn(U)}return()=>{const U=this._stacks.get(P.value)||0;this._stacks.set(P.value,U-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(P){this.value=P}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let v=0;class m{constructor(P){this.value=P,this.id=v++}}const g=2,h=(k,P)=>{if(k instanceof m)P(k);else for(let D=0;D<k.length;D++){const _=k[D];_&&P(_)}};class d{constructor(P){this._size=0,this._options=P,this._leakageMon=b>0||this._options?.leakWarningThreshold?new u(this._options?.leakWarningThreshold??b):void 0,this._perfMon=this._options?._profName?new w(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(I){const P=this._listeners;queueMicrotask(()=>{h(P,D=>D.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(P,D,_)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.Disposable.None;if(this._disposed)return r.Disposable.None;D&&(P=P.bind(D));const N=new m(P);let U,j;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(N.stack=y.create(),U=this._leakageMon.check(N.stack,this._size+1)),I&&(N.stack=j??y.create()),this._listeners?this._listeners instanceof m?(this._deliveryQueue??=new a,this._listeners=[this._listeners,N]):this._listeners.push(N):(this._options?.onWillAddFirstListener?.(this),this._listeners=N,this._options?.onDidAddFirstListener?.(this)),this._size++;const V=(0,r.toDisposable)(()=>{U?.(),this._removeListener(N)});return _ instanceof r.DisposableStore?_.add(V):Array.isArray(_)&&_.push(V),V},this._event}_removeListener(P){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const D=this._listeners,_=D.indexOf(P);if(_===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,D[_]=void 0;const N=this._deliveryQueue.current===this;if(this._size*g<=D.length){let U=0;for(let j=0;j<D.length;j++)D[j]?D[U++]=D[j]:N&&(this._deliveryQueue.end--,U<this._deliveryQueue.i&&this._deliveryQueue.i--);D.length=U}}_deliver(P,D){if(!P)return;const _=this._options?.onListenerError||C.onUnexpectedError;if(!_){P.value(D);return}try{P.value(D)}catch(N){_(N)}}_deliverQueue(P){const D=P.current._listeners;for(;P.i<P.end;)this._deliver(D[P.i++],P.value);P.reset()}fire(P){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof m)this._deliver(this._listeners,P);else{const D=this._deliveryQueue;D.enqueue(this,P,this._listeners.length),this._deliverQueue(D)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=d;const p=()=>new a;e.createEventDeliveryQueue=p;class a{constructor(){this.i=-1,this.end=0}enqueue(P,D,_){this.i=0,this.end=_,this.current=P,this.value=D}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends d{async fireAsync(P,D,_){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new O.LinkedList),h(this._listeners,N=>this._asyncDeliveryQueue.push([N.value,P]));this._asyncDeliveryQueue.size>0&&!D.isCancellationRequested;){const[N,U]=this._asyncDeliveryQueue.shift(),j=[],V={...U,token:D,waitUntil:ce=>{if(Object.isFrozen(j))throw new Error("waitUntil can NOT be called asynchronous");_&&(ce=_(ce,N)),j.push(ce)}};try{N(V)}catch(ce){(0,C.onUnexpectedError)(ce);continue}Object.freeze(j),await Promise.allSettled(j).then(ce=>{for(const se of ce)se.status==="rejected"&&(0,C.onUnexpectedError)(se.reason)})}}}e.AsyncEmitter=t;class o extends d{get isPaused(){return this._isPaused!==0}constructor(P){super(P),this._isPaused=0,this._eventQueue=new O.LinkedList,this._mergeFn=P?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const P=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(P))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(P){this._size&&(this._isPaused!==0?this._eventQueue.push(P):super.fire(P))}}e.PauseableEmitter=o;class s extends o{constructor(P){super(P),this._delay=P.delay??100}fire(P){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(P)}}e.DebounceEmitter=s;class i extends d{constructor(P){super(P),this._queuedEvents=[],this._mergeFn=P?.merge}fire(P){this.hasListeners()&&(this._queuedEvents.push(P),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(D=>super.fire(D)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=i;class n{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(P){const D={event:P,listener:null};this.events.push(D),this.hasListeners&&this.hook(D);const _=()=>{this.hasListeners&&this.unhook(D);const N=this.events.indexOf(D);this.events.splice(N,1)};return(0,r.toDisposable)((0,L.createSingleCallFunction)(_))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(P=>this.hook(P))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(P=>this.unhook(P))}hook(P){P.listener=P.event(D=>this.emitter.fire(D))}unhook(P){P.listener&&P.listener.dispose(),P.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=n;class c{constructor(P,D,_,N){this._store=new r.DisposableStore;const U=this._store.add(new n),j=this._store.add(new r.DisposableMap);function V(ce){j.set(ce,U.add(N(ce)))}for(const ce of P)V(ce);this._store.add(D(ce=>{V(ce)})),this._store.add(_(ce=>{j.deleteAndDispose(ce)})),this.event=U.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=c;class S{constructor(){this.buffers=[]}wrapEvent(P){return(D,_,N)=>P(U=>{const j=this.buffers[this.buffers.length-1];j?j.push(()=>D.call(_,U)):D.call(_,U)},void 0,N)}bufferEvents(P){const D=[];this.buffers.push(D);const _=P();return this.buffers.pop(),D.forEach(N=>N()),_}}e.EventBufferer=S;class R{constructor(){this.listening=!1,this.inputEvent=l.None,this.inputEventListener=r.Disposable.None,this.emitter=new d({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(P){this.inputEvent=P,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=P(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=R}),define(oe[23],ae([0,1,3]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(I,f){const l=setTimeout(I.bind(f),0);return{dispose(){clearTimeout(l)}}});var r;(function(I){function f(l){return l===I.None||l===I.Cancelled||l instanceof O?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}I.isCancellationToken=f,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:C.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(r||(e.CancellationToken=r={}));class O{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new C.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new O),this._token}cancel(){this._token?this._token instanceof O&&this._token.cancel():this._token=r.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof O&&this._token.dispose():this._token=r.None}}e.CancellationTokenSource=M}),define(oe[142],ae([0,1,23]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class L{constructor(I){this.task=I,this.result=null}get(){if(this.result)return this.result;const I=new C.CancellationTokenSource,f=this.task(I.token);return this.result={promise:f,dispose:()=>{this.result=null,I.cancel(),I.dispose()}},this.result}}e.Cache=L;class r{constructor(I){this.fn=I,this.lastCache=void 0,this.lastArgKey=void 0}get(I){const f=JSON.stringify(I);return this.lastArgKey!==f&&(this.lastArgKey=f,this.lastCache=this.fn(I)),this.lastCache}}e.LRUCachedFunction=r;class O{get cachedValues(){return this._map}constructor(I){this.fn=I,this._map=new Map}get(I){if(this._map.has(I))return this._map.get(I);const f=this.fn(I);return this._map.set(I,f),f}}e.CachedFunction=O}),define(oe[63],ae([0,1,14,2]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function r(p){const a=p;return a?typeof a.read=="function":!1}e.isReadable=r;function O(p){const a=p;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=O;function M(p){const a=p;return a?O(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=M;function I(p,a){return new f(p,a)}e.newWriteableStream=I;class f{constructor(a,t){this.reducer=a,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a<"u"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(t=>t(a))}emitError(a){this.listeners.error.length===0?(0,C.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(t=>t(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,t){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(a,t){if(this.state.destroyed)return;let o;switch(a){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const s=o.indexOf(t);s>=0&&o.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(p,a){const t=[];let o;for(;(o=p.read())!==null;)t.push(o);return a(t)}e.consumeReadable=l;function w(p,a,t){const o=[];let s;for(;(s=p.read())!==null&&o.length<t;)o.push(s);return s===null&&o.length>0?a(o):{read:()=>{if(o.length>0)return o.shift();if(typeof s<"u"){const i=s;return s=void 0,i}return p.read()}}}e.peekReadable=w;function b(p,a){return new Promise((t,o)=>{const s=[];E(p,{onData:i=>{a&&s.push(i)},onError:i=>{a?o(i):t(void 0)},onEnd:()=>{t(a?a(s):void 0)}})})}e.consumeStream=b;function E(p,a,t){p.on("error",o=>{t?.isCancellationRequested||a.onError(o)}),p.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),p.on("data",o=>{t?.isCancellationRequested||a.onData(o)})}e.listenStream=E;function u(p,a){return new Promise((t,o)=>{const s=new L.DisposableStore,i=[],n=R=>{if(i.push(R),i.length>a)return s.dispose(),p.pause(),t({stream:p,buffer:i,ended:!1})},c=R=>(s.dispose(),o(R)),S=()=>(s.dispose(),t({stream:p,buffer:i,ended:!0}));s.add((0,L.toDisposable)(()=>p.removeListener("error",c))),p.on("error",c),s.add((0,L.toDisposable)(()=>p.removeListener("end",S))),p.on("end",S),s.add((0,L.toDisposable)(()=>p.removeListener("data",n))),p.on("data",n)})}e.peekStream=u;function y(p,a){const t=I(a);return t.end(p),t}e.toStream=y;function v(){const p=I(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=v;function m(p){let a=!1;return{read:()=>a?null:(a=!0,p)}}e.toReadable=m;function g(p,a,t){const o=I(t);return E(p,{onData:s=>o.write(a.data(s)),onError:s=>o.error(a.error?a.error(s):s),onEnd:()=>o.end()}),o}e.transform=g;function h(p,a,t){let o=!1;return{read:()=>{const s=a.read();return o?s:(o=!0,s!==null?t([p,s]):p)}}}e.prefixedReadable=h;function d(p,a,t){let o=!1;const s=I(t);return E(a,{onData:i=>o?s.write(i):(o=!0,s.write(t([p,i]))),onError:i=>s.error(i),onEnd:()=>{o||(o=!0,s.write(p)),s.end()}}),s}e.prefixedStream=d}),define(oe[17],ae([0,1,62,63]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const r=typeof Buffer<"u",O=new C.Lazy(()=>new Uint8Array(256));let M,I;class f{static alloc(D){return r?new f(Buffer.allocUnsafe(D)):new f(new Uint8Array(D))}static wrap(D){return r&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new f(D)}static fromString(D,_){return!(_?.dontUseNodeBuffer||!1)&&r?new f(Buffer.from(D)):(M||(M=new TextEncoder),new f(M.encode(D)))}static fromByteArray(D){const _=f.alloc(D.length);for(let N=0,U=D.length;N<U;N++)_.buffer[N]=D[N];return _}static concat(D,_){if(typeof _>"u"){_=0;for(let j=0,V=D.length;j<V;j++)_+=D[j].byteLength}const N=f.alloc(_);let U=0;for(let j=0,V=D.length;j<V;j++){const ce=D[j];N.set(ce,U),U+=ce.byteLength}return N}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=f.alloc(this.byteLength);return D.set(this),D}toString(){return r?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(D,_){return new f(this.buffer.subarray(D,_))}set(D,_){if(D instanceof f)this.buffer.set(D.buffer,_);else if(D instanceof Uint8Array)this.buffer.set(D,_);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),_);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),_);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return E(this.buffer,D)}writeUInt32BE(D,_){u(this.buffer,D,_)}readUInt32LE(D){return y(this.buffer,D)}writeUInt32LE(D,_){v(this.buffer,D,_)}readUInt8(D){return m(this.buffer,D)}writeUInt8(D,_){g(this.buffer,D,_)}indexOf(D,_=0){return l(this.buffer,D instanceof f?D.buffer:D,_)}}e.VSBuffer=f;function l(P,D,_=0){const N=D.byteLength,U=P.byteLength;if(N===0)return 0;if(N===1)return P.indexOf(D[0]);if(N>U-_)return-1;const j=O.value;j.fill(D.length);for(let ue=0;ue<D.length;ue++)j[D[ue]]=D.length-ue-1;let V=_+D.length-1,ce=V,se=-1;for(;V<U;)if(P[V]===D[ce]){if(ce===0){se=V;break}V--,ce--}else V+=Math.max(D.length-ce,j[P[V]]),ce=D.length-1;return se}e.binaryIndexOf=l;function w(P,D){return P[D+0]<<0>>>0|P[D+1]<<8>>>0}e.readUInt16LE=w;function b(P,D,_){P[_+0]=D&255,D=D>>>8,P[_+1]=D&255}e.writeUInt16LE=b;function E(P,D){return P[D]*2**24+P[D+1]*2**16+P[D+2]*2**8+P[D+3]}e.readUInt32BE=E;function u(P,D,_){P[_+3]=D,D=D>>>8,P[_+2]=D,D=D>>>8,P[_+1]=D,D=D>>>8,P[_]=D}e.writeUInt32BE=u;function y(P,D){return P[D+0]<<0>>>0|P[D+1]<<8>>>0|P[D+2]<<16>>>0|P[D+3]<<24>>>0}e.readUInt32LE=y;function v(P,D,_){P[_+0]=D&255,D=D>>>8,P[_+1]=D&255,D=D>>>8,P[_+2]=D&255,D=D>>>8,P[_+3]=D&255}e.writeUInt32LE=v;function m(P,D){return P[D]}e.readUInt8=m;function g(P,D,_){P[_]=D}e.writeUInt8=g;function h(P){return L.consumeReadable(P,D=>f.concat(D))}e.readableToBuffer=h;function d(P){return L.toReadable(P)}e.bufferToReadable=d;function p(P){return L.consumeStream(P,D=>f.concat(D))}e.streamToBuffer=p;async function a(P){return P.ended?f.concat(P.buffer):f.concat([...P.buffer,await p(P.stream)])}e.bufferedStreamToBuffer=a;function t(P){return L.toStream(P,D=>f.concat(D))}e.bufferToStream=t;function o(P){return L.transform(P,{data:D=>typeof D=="string"?f.fromString(D):f.wrap(D)},D=>f.concat(D))}e.streamToBufferReadableStream=o;function s(P){return L.newWriteableStream(D=>f.concat(D),P)}e.newWriteableBufferStream=s;function i(P,D){return L.prefixedReadable(P,D,_=>f.concat(_))}e.prefixedBufferReadable=i;function n(P,D){return L.prefixedStream(P,D,_=>f.concat(_))}e.prefixedBufferStream=n;function c(P){let D=0,_=0,N=0;const U=new Uint8Array(Math.floor(P.length/4*3)),j=ce=>{switch(_){case 3:U[N++]=D|ce,_=0;break;case 2:U[N++]=D|ce>>>2,D=ce<<6,_=3;break;case 1:U[N++]=D|ce>>>4,D=ce<<4,_=2;break;default:D=ce<<2,_=1}};for(let ce=0;ce<P.length;ce++){const se=P.charCodeAt(ce);if(se>=65&&se<=90)j(se-65);else if(se>=97&&se<=122)j(se-97+26);else if(se>=48&&se<=57)j(se-48+52);else if(se===43||se===45)j(62);else if(se===47||se===95)j(63);else{if(se===61)break;throw new SyntaxError(`Unexpected base64 character ${P[ce]}`)}}const V=N;for(;_>0;)j(0);return f.wrap(U).slice(0,V)}e.decodeBase64=c;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:P},D=!0,_=!1){const N=_?R:S;let U="";const j=P.byteLength%3;let V=0;for(;V<P.byteLength-j;V+=3){const ce=P[V+0],se=P[V+1],ue=P[V+2];U+=N[ce>>>2],U+=N[(ce<<4|se>>>4)&63],U+=N[(se<<2|ue>>>6)&63],U+=N[ue&63]}if(j===1){const ce=P[V+0];U+=N[ce>>>2],U+=N[ce<<4&63],D&&(U+="==")}else if(j===2){const ce=P[V+0],se=P[V+1];U+=N[ce>>>2],U+=N[(ce<<4|se>>>4)&63],U+=N[se<<2&63],D&&(U+="=")}return U}e.encodeBase64=k}),define(oe[25],ae([0,1,142,62]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncateMiddle=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.htmlAttributeEncodeValue=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function r(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.isFalsyOrWhitespace=r;const O=/{(\d+)}/g;function M(ie,...fe){return fe.length===0?ie:ie.replace(O,function(ve,Pe){const ye=parseInt(Pe,10);return isNaN(ye)||ye<0||ye>=fe.length?ve:fe[ye]})}e.format=M;const I=/{([^}]+)}/g;function f(ie,fe){return Object.keys(fe).length===0?ie:ie.replace(I,(ve,Pe)=>fe[Pe]??ve)}e.format2=f;function l(ie){return ie.replace(/[<>"'&]/g,fe=>{switch(fe){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return fe})}e.htmlAttributeEncodeValue=l;function w(ie){return ie.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.escape=w;function b(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=b;function E(ie,fe){let ve=0;const Pe=fe.charCodeAt(0);for(let ye=ie.length-1;ye>=0;ye--)ie.charCodeAt(ye)===Pe&&ve++;return ve}e.count=E;function u(ie,fe,ve="\u2026"){return ie.length<=fe?ie:`${ie.substr(0,fe)}${ve}`}e.truncate=u;function y(ie,fe,ve="\u2026"){if(ie.length<=fe)return ie;const Pe=Math.ceil(fe/2)-ve.length/2,ye=Math.floor(fe/2)-ve.length/2;return`${ie.substr(0,Pe)}${ve}${ie.substr(ie.length-ye)}`}e.truncateMiddle=y;function v(ie,fe=" "){const ve=m(ie,fe);return g(ve,fe)}e.trim=v;function m(ie,fe){if(!ie||!fe)return ie;const ve=fe.length;if(ve===0||ie.length===0)return ie;let Pe=0;for(;ie.indexOf(fe,Pe)===Pe;)Pe=Pe+ve;return ie.substring(Pe)}e.ltrim=m;function g(ie,fe){if(!ie||!fe)return ie;const ve=fe.length,Pe=ie.length;if(ve===0||Pe===0)return ie;let ye=Pe,Le=-1;for(;Le=ie.lastIndexOf(fe,ye-1),!(Le===-1||Le+ve!==ye);){if(Le===0)return"";ye=Le}return ie.substring(0,ye)}e.rtrim=g;function h(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function d(ie){return ie.replace(/\*/g,"")}e.stripWildcards=d;function p(ie,fe,ve={}){if(!ie)throw new Error("Cannot create regex from empty string");fe||(ie=b(ie)),ve.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let Pe="";return ve.global&&(Pe+="g"),ve.matchCase||(Pe+="i"),ve.multiline&&(Pe+="m"),ve.unicode&&(Pe+="u"),new RegExp(ie,Pe)}e.createRegExp=p;function a(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.regExpLeadsToEndlessLoop=a;function t(ie){return ie.split(/\r\n|\r|\n/)}e.splitLines=t;function o(ie){for(let fe=0,ve=ie.length;fe<ve;fe++){const Pe=ie.charCodeAt(fe);if(Pe!==32&&Pe!==9)return fe}return-1}e.firstNonWhitespaceIndex=o;function s(ie,fe=0,ve=ie.length){for(let Pe=fe;Pe<ve;Pe++){const ye=ie.charCodeAt(Pe);if(ye!==32&&ye!==9)return ie.substring(fe,Pe)}return ie.substring(fe,ve)}e.getLeadingWhitespace=s;function i(ie,fe=ie.length-1){for(let ve=fe;ve>=0;ve--){const Pe=ie.charCodeAt(ve);if(Pe!==32&&Pe!==9)return ve}return-1}e.lastNonWhitespaceIndex=i;function n(ie,fe,ve){const Pe=[];let ye=0;for(const Le of ie.matchAll(fe)){if(Pe.push(ie.slice(ye,Le.index)),Le.index===void 0)throw new Error("match.index should be defined");ye=Le.index+Le[0].length,Pe.push(ve(Le[0],...Le.slice(1),Le.index,ie,Le.groups))}return Pe.push(ie.slice(ye)),Promise.all(Pe).then(Le=>Le.join(""))}e.replaceAsync=n;function c(ie,fe){return ie<fe?-1:ie>fe?1:0}e.compare=c;function S(ie,fe,ve=0,Pe=ie.length,ye=0,Le=fe.length){for(;ve<Pe&&ye<Le;ve++,ye++){const Ke=ie.charCodeAt(ve),Je=fe.charCodeAt(ye);if(Ke<Je)return-1;if(Ke>Je)return 1}const Ue=Pe-ve,qe=Le-ye;return Ue<qe?-1:Ue>qe?1:0}e.compareSubstring=S;function R(ie,fe){return k(ie,fe,0,ie.length,0,fe.length)}e.compareIgnoreCase=R;function k(ie,fe,ve=0,Pe=ie.length,ye=0,Le=fe.length){for(;ve<Pe&&ye<Le;ve++,ye++){let Ke=ie.charCodeAt(ve),Je=fe.charCodeAt(ye);if(Ke===Je)continue;if(Ke>=128||Je>=128)return S(ie.toLowerCase(),fe.toLowerCase(),ve,Pe,ye,Le);D(Ke)&&(Ke-=32),D(Je)&&(Je-=32);const Qe=Ke-Je;if(Qe!==0)return Qe}const Ue=Pe-ve,qe=Le-ye;return Ue<qe?-1:Ue>qe?1:0}e.compareSubstringIgnoreCase=k;function P(ie){return ie>=48&&ie<=57}e.isAsciiDigit=P;function D(ie){return ie>=97&&ie<=122}e.isLowerAsciiLetter=D;function _(ie){return ie>=65&&ie<=90}e.isUpperAsciiLetter=_;function N(ie,fe){return ie.length===fe.length&&k(ie,fe)===0}e.equalsIgnoreCase=N;function U(ie,fe){const ve=fe.length;return fe.length>ie.length?!1:k(ie,fe,0,ve)===0}e.startsWithIgnoreCase=U;function j(ie,fe){const ve=Math.min(ie.length,fe.length);let Pe;for(Pe=0;Pe<ve;Pe++)if(ie.charCodeAt(Pe)!==fe.charCodeAt(Pe))return Pe;return ve}e.commonPrefixLength=j;function V(ie,fe){const ve=Math.min(ie.length,fe.length);let Pe;const ye=ie.length-1,Le=fe.length-1;for(Pe=0;Pe<ve;Pe++)if(ie.charCodeAt(ye-Pe)!==fe.charCodeAt(Le-Pe))return Pe;return ve}e.commonSuffixLength=V;function ce(ie){return 55296<=ie&&ie<=56319}e.isHighSurrogate=ce;function se(ie){return 56320<=ie&&ie<=57343}e.isLowSurrogate=se;function ue(ie,fe){return(ie-55296<<10)+(fe-56320)+65536}e.computeCodePoint=ue;function X(ie,fe,ve){const Pe=ie.charCodeAt(ve);if(ce(Pe)&&ve+1<fe){const ye=ie.charCodeAt(ve+1);if(se(ye))return ue(Pe,ye)}return Pe}e.getNextCodePoint=X;function Y(ie,fe){const ve=ie.charCodeAt(fe-1);if(se(ve)&&fe>1){const Pe=ie.charCodeAt(fe-2);if(ce(Pe))return ue(Pe,ve)}return ve}class x{get offset(){return this._offset}constructor(fe,ve=0){this._str=fe,this._len=fe.length,this._offset=ve}setOffset(fe){this._offset=fe}prevCodePoint(){const fe=Y(this._str,this._offset);return this._offset-=fe>=65536?2:1,fe}nextCodePoint(){const fe=X(this._str,this._len,this._offset);return this._offset+=fe>=65536?2:1,fe}eol(){return this._offset>=this._len}}e.CodePointIterator=x;class W{get offset(){return this._iterator.offset}constructor(fe,ve=0){this._iterator=new x(fe,ve)}nextGraphemeLength(){const fe=Ce.getInstance(),ve=this._iterator,Pe=ve.offset;let ye=fe.getGraphemeBreakType(ve.nextCodePoint());for(;!ve.eol();){const Le=ve.offset,Ue=fe.getGraphemeBreakType(ve.nextCodePoint());if(he(ye,Ue)){ve.setOffset(Le);break}ye=Ue}return ve.offset-Pe}prevGraphemeLength(){const fe=Ce.getInstance(),ve=this._iterator,Pe=ve.offset;let ye=fe.getGraphemeBreakType(ve.prevCodePoint());for(;ve.offset>0;){const Le=ve.offset,Ue=fe.getGraphemeBreakType(ve.prevCodePoint());if(he(Ue,ye)){ve.setOffset(Le);break}ye=Ue}return Pe-ve.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=W;function F(ie,fe){return new W(ie,fe).nextGraphemeLength()}e.nextCharLength=F;function H(ie,fe){return new W(ie,fe).prevGraphemeLength()}e.prevCharLength=H;function q(ie,fe){fe>0&&se(ie.charCodeAt(fe))&&fe--;const ve=fe+F(ie,fe);return[ve-H(ie,ve),ve]}e.getCharContainingOffset=q;function ee(ie){const fe=new W(ie);let ve=0;for(;!fe.eol();)ve++,fe.nextGraphemeLength();return ve}e.charCount=ee;let de;function G(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function A(ie){return de||(de=G()),de.test(ie)}e.containsRTL=A;const T=/^[\t\n\r\x20-\x7E]*$/;function Z(ie){return T.test(ie)}e.isBasicASCII=Z,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function z(ie){return e.UNUSUAL_LINE_TERMINATORS.test(ie)}e.containsUnusualLineTerminators=z;function J(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.isFullWidthCharacter=J;function B(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.isEmojiImprecise=B;function $(ie,fe,ve=""){const Pe=ie.trimStart();if(Pe.length<fe)return Pe;const ye=/\b/g;let Le=0;for(;ye.test(Pe)&&!(Pe.length-ye.lastIndex<fe);)Le=ye.lastIndex,ye.lastIndex+=1;return Le===0?Pe:ve+Pe.substring(Le).trimStart()}e.lcut=$;const K=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,re=/\x1b\].*?\x07/g;function le(ie){return ie&&(ie=ie.replace(K,"").replace(re,"")),ie}e.removeAnsiEscapeCodes=le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ge(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ge;function we(ie){return ge(ie)?ie.substr(1):ie}e.stripUTF8BOM=we;function Ie(ie,fe){if(!ie||!fe||ie.length<fe.length)return!1;const ve=fe.length,Pe=ie.toLowerCase();let ye=0,Le=-1;for(;ye<ve;){const Ue=Pe.indexOf(fe[ye],Le+1);if(Ue<0)return!1;Le=Ue,ye++}return!0}e.fuzzyContains=Ie;function De(ie,fe=!1){return ie?(fe&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.containsUppercaseCharacter=De;function We(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.uppercaseFirstLetter=We;function Ee(ie,fe=1){if(fe===0)return"";let ve=-1;do ve=ie.indexOf(`
`,ve+1),fe--;while(fe>0&&ve>=0);return ve===-1?ie:(ie[ve-1]==="\r"&&ve--,ie.substr(0,ve))}e.getNLines=Ee;function Se(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}e.singleLetterHash=Se;function te(ie){return Ce.getInstance().getGraphemeBreakType(ie)}e.getGraphemeBreakType=te;function he(ie,fe){return ie===0?fe!==5&&fe!==7:ie===2&&fe===3?!1:ie===4||ie===2||ie===3||fe===4||fe===2||fe===3?!0:!(ie===8&&(fe===8||fe===9||fe===11||fe===12)||(ie===11||ie===9)&&(fe===9||fe===10)||(ie===12||ie===10)&&fe===10||fe===5||fe===13||fe===7||ie===1||ie===13&&fe===14||ie===6&&fe===6)}var me;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(me||(e.GraphemeBreakType=me={}));class Ce{static{this._INSTANCE=null}static getInstance(){return Ce._INSTANCE||(Ce._INSTANCE=new Ce),Ce._INSTANCE}constructor(){this._data=Oe()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const ve=this._data,Pe=ve.length/3;let ye=1;for(;ye<=Pe;)if(fe<ve[3*ye])ye=2*ye;else if(fe>ve[3*ye+1])ye=2*ye+1;else return ve[3*ye+2];return 0}}function Oe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ne(ie,fe){if(ie===0)return 0;const ve=_e(ie,fe);if(ve!==void 0)return ve;const Pe=new x(fe,ie);return Pe.prevCodePoint(),Pe.offset}e.getLeftDeleteOffset=Ne;function _e(ie,fe){const ve=new x(fe,ie);let Pe=ve.prevCodePoint();for(;Ve(Pe)||Pe===65039||Pe===8419;){if(ve.offset===0)return;Pe=ve.prevCodePoint()}if(!B(Pe))return;let ye=ve.offset;return ye>0&&ve.prevCodePoint()===8205&&(ye=ve.offset),ye}function Ve(ie){return 127995<=ie&&ie<=127999}var $e;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})($e||($e={})),e.noBreakWhitespace="\xA0";class xe{static{this.ambiguousCharacterData=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new C.LRUCachedFunction(fe=>{function ve(Qe){const Xe=new Map;for(let nt=0;nt<Qe.length;nt+=2)Xe.set(Qe[nt],Qe[nt+1]);return Xe}function Pe(Qe,Xe){const nt=new Map(Qe);for(const[rt,ot]of Xe)nt.set(rt,ot);return nt}function ye(Qe,Xe){if(!Qe)return Xe;const nt=new Map;for(const[rt,ot]of Qe)Xe.has(rt)&&nt.set(rt,ot);return nt}const Le=this.ambiguousCharacterData.value;let Ue=fe.filter(Qe=>!Qe.startsWith("_")&&Qe in Le);Ue.length===0&&(Ue=["_default"]);let qe;for(const Qe of Ue){const Xe=ve(Le[Qe]);qe=ye(qe,Xe)}const Ke=ve(Le._common),Je=Pe(Ke,qe);return new xe(Je)})}static getInstance(fe){return xe.cache.get(Array.from(fe))}static{this._locales=new L.Lazy(()=>Object.keys(xe.ambiguousCharacterData.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return xe._locales.value}constructor(fe){this.confusableDictionary=fe}isAmbiguous(fe){return this.confusableDictionary.has(fe)}getPrimaryConfusable(fe){return this.confusableDictionary.get(fe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=xe;class He{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(He.getRawData())),this._data}static isInvisibleCharacter(fe){return He.getData().has(fe)}static get codePoints(){return He.getData()}}e.InvisibleCharacters=He}),define(oe[45],ae([0,1,25]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(g){return r(g,0)}e.hash=L;function r(g,h){switch(typeof g){case"object":return g===null?O(349,h):Array.isArray(g)?f(g,h):l(g,h);case"string":return I(g,h);case"boolean":return M(g,h);case"number":return O(g,h);case"undefined":return O(937,h);default:return O(617,h)}}e.doHash=r;function O(g,h){return(h<<5)-h+g|0}e.numberHash=O;function M(g,h){return O(g?433:863,h)}function I(g,h){h=O(149417,h);for(let d=0,p=g.length;d<p;d++)h=O(g.charCodeAt(d),h);return h}e.stringHash=I;function f(g,h){return h=O(104579,h),g.reduce((d,p)=>r(p,d),h)}function l(g,h){return h=O(181387,h),Object.keys(g).sort().reduce((d,p)=>(d=I(p,d),r(g[p],d)),h)}class w{constructor(){this._value=0}get value(){return this._value}hash(h){return this._value=r(h,this._value),this._value}}e.Hasher=w;var b;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function E(g,h,d=32){const p=d-h,a=~((1<<p)-1);return(g<<h|(a&g)>>>p)>>>0}function u(g,h=0,d=g.byteLength,p=0){for(let a=0;a<d;a++)g[h+a]=p}function y(g,h,d="0"){for(;g.length<h;)g=d+g;return g}function v(g,h=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(d=>d.toString(16).padStart(2,"0")).join(""):y((g>>>0).toString(16),h/4)}e.toHexString=v;class m{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(h){const d=h.length;if(d===0)return;const p=this._buff;let a=this._buffLen,t=this._leftoverHighSurrogate,o,s;for(t!==0?(o=t,s=-1,t=0):(o=h.charCodeAt(0),s=0);;){let i=o;if(C.isHighSurrogate(o))if(s+1<d){const n=h.charCodeAt(s+1);C.isLowSurrogate(n)?(s++,i=C.computeCodePoint(o,n)):i=65533}else{t=o;break}else C.isLowSurrogate(o)&&(i=65533);if(a=this._push(p,a,i),s++,s<d)o=h.charCodeAt(s);else break}this._buffLen=a,this._leftoverHighSurrogate=t}_push(h,d,p){return p<128?h[d++]=p:p<2048?(h[d++]=192|(p&1984)>>>6,h[d++]=128|(p&63)>>>0):p<65536?(h[d++]=224|(p&61440)>>>12,h[d++]=128|(p&4032)>>>6,h[d++]=128|(p&63)>>>0):(h[d++]=240|(p&1835008)>>>18,h[d++]=128|(p&258048)>>>12,h[d++]=128|(p&4032)>>>6,h[d++]=128|(p&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,u(this._buff,this._buffLen),this._buffLen>56&&(this._step(),u(this._buff));const h=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(h/4294967296),!1),this._buffDV.setUint32(60,h%4294967296,!1),this._step()}_step(){const h=m._bigBlock32,d=this._buffDV;for(let S=0;S<64;S+=4)h.setUint32(S,d.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)h.setUint32(S,E(h.getUint32(S-12,!1)^h.getUint32(S-32,!1)^h.getUint32(S-56,!1)^h.getUint32(S-64,!1),1),!1);let p=this._h0,a=this._h1,t=this._h2,o=this._h3,s=this._h4,i,n,c;for(let S=0;S<80;S++)S<20?(i=a&t|~a&o,n=1518500249):S<40?(i=a^t^o,n=1859775393):S<60?(i=a&t|a&o|t&o,n=2400959708):(i=a^t^o,n=3395469782),c=E(p,5)+i+s+n+h.getUint32(S*4,!1)&4294967295,s=o,o=t,t=E(a,30),a=p,p=c;this._h0=this._h0+p&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=m}),define(oe[74],ae([0,1,25]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(r){r[r.Ignore=0]="Ignore",r[r.Info=1]="Info",r[r.Warning=2]="Warning",r[r.Error=3]="Error"})(L||(L={})),function(r){const O="error",M="warning",I="warn",f="info",l="ignore";function w(E){return E?C.equalsIgnoreCase(O,E)?r.Error:C.equalsIgnoreCase(M,E)||C.equalsIgnoreCase(I,E)?r.Warning:C.equalsIgnoreCase(f,E)?r.Info:r.Ignore:r.Ignore}r.fromValue=w;function b(E){switch(E){case r.Error:return O;case r.Warning:return M;case r.Info:return f;default:return l}}r.toString=b}(L||(L={})),e.default=L}),define(oe[143],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(oe[58],ae([0,1,22,25]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class r{constructor(){this._value="",this._pos=0}reset(u){return this._value=u,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(u){const y=u.charCodeAt(0),v=this._value.charCodeAt(this._pos);return y-v}value(){return this._value[this._pos]}}e.StringIterator=r;class O{constructor(u=!0){this._caseSensitive=u}reset(u){return this._value=u,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let u=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(u)this._from++;else break;else u=!1;return this}cmp(u){return this._caseSensitive?(0,L.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=O;class M{constructor(u=!0,y=!0){this._splitOnBackslash=u,this._caseSensitive=y}reset(u){this._from=0,this._to=0,this._value=u,this._valueLen=u.length;for(let y=u.length-1;y>=0;y--,this._valueLen--){const v=this._value.charCodeAt(y);if(!(v===47||this._splitOnBackslash&&v===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let u=!0;for(;this._to<this._valueLen;this._to++){const y=this._value.charCodeAt(this._to);if(y===47||this._splitOnBackslash&&y===92)if(u)this._from++;else break;else u=!1}return this}cmp(u){return this._caseSensitive?(0,L.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=M;var I;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(I||(I={}));class f{constructor(u,y){this._ignorePathCasing=u,this._ignoreQueryAndFragment=y,this._states=[],this._stateIdx=0}reset(u){return this._value=u,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new M(!1,!this._ignorePathCasing(u)),this._pathIterator.reset(u.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(u)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(u){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(u,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(u,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(u);if(this._states[this._stateIdx]===4)return(0,L.compare)(u,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(u,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(w||(w={}));class b{static forUris(u=()=>!1,y=()=>!1){return new b(new f(u,y))}static forPaths(u=!1){return new b(new M(void 0,!u))}static forStrings(){return new b(new r)}static forConfigKeys(){return new b(new O)}constructor(u){this._iter=u}clear(){this._root=void 0}fill(u,y){if(y){const v=y.slice(0);(0,C.shuffle)(v);for(const m of v)this.set(m,u)}else{const v=u.slice(0);(0,C.shuffle)(v);for(const m of v)this.set(m[0],m[1])}}set(u,y){const v=this._iter.reset(u);let m;this._root||(this._root=new l,this._root.segment=v.value());const g=[];for(m=this._root;;){const d=v.cmp(m.segment);if(d>0)m.left||(m.left=new l,m.left.segment=v.value()),g.push([-1,m]),m=m.left;else if(d<0)m.right||(m.right=new l,m.right.segment=v.value()),g.push([1,m]),m=m.right;else if(v.hasNext())v.next(),m.mid||(m.mid=new l,m.mid.segment=v.value()),g.push([0,m]),m=m.mid;else break}const h=m.value;m.value=y,m.key=u;for(let d=g.length-1;d>=0;d--){const p=g[d][1];p.updateHeight();const a=p.balanceFactor();if(a<-1||a>1){const t=g[d][0],o=g[d+1][0];if(t===1&&o===1)g[d][1]=p.rotateLeft();else if(t===-1&&o===-1)g[d][1]=p.rotateRight();else if(t===1&&o===-1)p.right=g[d+1][1]=g[d+1][1].rotateRight(),g[d][1]=p.rotateLeft();else if(t===-1&&o===1)p.left=g[d+1][1]=g[d+1][1].rotateLeft(),g[d][1]=p.rotateRight();else throw new Error;if(d>0)switch(g[d-1][0]){case-1:g[d-1][1].left=g[d][1];break;case 1:g[d-1][1].right=g[d][1];break;case 0:g[d-1][1].mid=g[d][1];break}else this._root=g[0][1]}}return h}get(u){return this._getNode(u)?.value}_getNode(u){const y=this._iter.reset(u);let v=this._root;for(;v;){const m=y.cmp(v.segment);if(m>0)v=v.left;else if(m<0)v=v.right;else if(y.hasNext())y.next(),v=v.mid;else break}return v}has(u){const y=this._getNode(u);return!(y?.value===void 0&&y?.mid===void 0)}delete(u){return this._delete(u,!1)}deleteSuperstr(u){return this._delete(u,!0)}_delete(u,y){const v=this._iter.reset(u),m=[];let g=this._root;for(;g;){const h=v.cmp(g.segment);if(h>0)m.push([-1,g]),g=g.left;else if(h<0)m.push([1,g]),g=g.right;else if(v.hasNext())v.next(),m.push([0,g]),g=g.mid;else break}if(g){if(y?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const h=this._min(g.right);if(h.key){const{key:d,value:p,segment:a}=h;this._delete(h.key,!1),g.key=d,g.value=p,g.segment=a}}else{const h=g.left??g.right;if(m.length>0){const[d,p]=m[m.length-1];switch(d){case-1:p.left=h;break;case 0:p.mid=h;break;case 1:p.right=h;break}}else this._root=h}for(let h=m.length-1;h>=0;h--){const d=m[h][1];d.updateHeight();const p=d.balanceFactor();if(p>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),m[h][1]=d.rotateLeft()):p<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),m[h][1]=d.rotateRight()),h>0)switch(m[h-1][0]){case-1:m[h-1][1].left=m[h][1];break;case 1:m[h-1][1].right=m[h][1];break;case 0:m[h-1][1].mid=m[h][1];break}else this._root=m[0][1]}}}_min(u){for(;u.left;)u=u.left;return u}findSubstr(u){const y=this._iter.reset(u);let v=this._root,m;for(;v;){const g=y.cmp(v.segment);if(g>0)v=v.left;else if(g<0)v=v.right;else if(y.hasNext())y.next(),m=v.value||m,v=v.mid;else break}return v&&v.value||m}findSuperstr(u){return this._findSuperstrOrElement(u,!1)}_findSuperstrOrElement(u,y){const v=this._iter.reset(u);let m=this._root;for(;m;){const g=v.cmp(m.segment);if(g>0)m=m.left;else if(g<0)m=m.right;else if(v.hasNext())v.next(),m=m.mid;else return m.mid?this._entries(m.mid):y?m.value:void 0}}hasElementOrSubtree(u){return this._findSuperstrOrElement(u,!0)!==void 0}forEach(u){for(const[y,v]of this)u(v,y)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(u){const y=[];return this._dfsEntries(u,y),y[Symbol.iterator]()}_dfsEntries(u,y){u&&(u.left&&this._dfsEntries(u.left,y),u.value&&y.push([u.key,u.value]),u.mid&&this._dfsEntries(u.mid,y),u.right&&this._dfsEntries(u.right,y))}_isBalanced(){const u=y=>{if(!y)return!0;const v=y.balanceFactor();return v<-1||v>1?!1:u(y.left)&&u(y.right)};return u(this._root)}}e.TernarySearchTree=b}),define(oe[12],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function C(a){return typeof a=="string"}e.isString=C;function L(a){return Array.isArray(a)&&a.every(t=>C(t))}e.isStringArray=L;function r(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=r;function O(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.isTypedArray=O;function M(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=M;function I(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=I;function f(a){return a===!0||a===!1}e.isBoolean=f;function l(a){return typeof a>"u"}e.isUndefined=l;function w(a){return!b(a)}e.isDefined=w;function b(a){return l(a)||a===null}e.isUndefinedOrNull=b;function E(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=E;function u(a){if(b(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=u;function y(...a){const t=[];for(let o=0;o<a.length;o++){const s=a[o];if(b(s))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(s)}return t}e.assertAllDefined=y;const v=Object.prototype.hasOwnProperty;function m(a){if(!r(a))return!1;for(const t in a)if(v.call(a,t))return!1;return!0}e.isEmptyObject=m;function g(a){return typeof a=="function"}e.isFunction=g;function h(...a){return a.length>0&&a.every(g)}e.areFunctions=h;function d(a,t){const o=Math.min(a.length,t.length);for(let s=0;s<o;s++)p(a[s],t[s])}e.validateConstraints=d;function p(a,t){if(C(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(g(t)){try{if(a instanceof t)return}catch{}if(!b(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=p}),define(oe[75],ae([0,1,12]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const L=Object.create(null);function r(I,f){if((0,C.isString)(f)){const l=L[f];if(l===void 0)throw new Error(`${I} references an unknown codicon: ${f}`);f=l}return L[I]=f,{id:I}}function O(){return L}e.getCodiconFontCharacters=O;function M(){return Object.values(e.Codicon)}e.getAllCodicons=M,e.Codicon={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugBreakpointPending:r("debug-breakpoint-pending",60377),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),thumbsDownFilled:r("thumbsdown-filled",60435),thumbsUpFilled:r("thumbsup-filled",60436),coffee:r("coffee",60437),snake:r("snake",60438),game:r("game",60439),vr:r("vr",60440),chip:r("chip",60441),piano:r("piano",60442),music:r("music",60443),micFilled:r("mic-filled",60444),gitFetch:r("git-fetch",60445),copilot:r("copilot",60446),lightbulbSparkle:r("lightbulb-sparkle",60447),lightbulbSparkleAutofix:r("lightbulb-sparkle-autofix",60447),robot:r("robot",60448),sparkleFilled:r("sparkle-filled",60449),diffSingle:r("diff-single",60450),diffMultiple:r("diff-multiple",60451),surroundWith:r("surround-with",60452),gitStash:r("git-stash",60454),gitStashApply:r("git-stash-apply",60455),gitStashPop:r("git-stash-pop",60456),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),define(oe[35],ae([0,1,12]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const h=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([d,p])=>{h[d]=p&&typeof p=="object"?L(p):p}),h}e.deepClone=L;function r(g){if(!g||typeof g!="object")return g;const h=[g];for(;h.length>0;){const d=h.shift();Object.freeze(d);for(const p in d)if(O.call(d,p)){const a=d[p];typeof a=="object"&&!Object.isFrozen(a)&&!(0,C.isTypedArray)(a)&&h.push(a)}}return g}e.deepFreeze=r;const O=Object.prototype.hasOwnProperty;function M(g,h){return I(g,h,new Set)}e.cloneAndChange=M;function I(g,h,d){if((0,C.isUndefinedOrNull)(g))return g;const p=h(g);if(typeof p<"u")return p;if(Array.isArray(g)){const a=[];for(const t of g)a.push(I(t,h,d));return a}if((0,C.isObject)(g)){if(d.has(g))throw new Error("Cannot clone recursive data-structure");d.add(g);const a={};for(const t in g)O.call(g,t)&&(a[t]=I(g[t],h,d));return d.delete(g),a}return g}function f(g,h,d=!0){return(0,C.isObject)(g)?((0,C.isObject)(h)&&Object.keys(h).forEach(p=>{p in g?d&&((0,C.isObject)(g[p])&&(0,C.isObject)(h[p])?f(g[p],h[p],d):g[p]=h[p]):g[p]=h[p]}),g):h}e.mixin=f;function l(g,h){if(g===h)return!0;if(g==null||h===null||h===void 0||typeof g!=typeof h||typeof g!="object"||Array.isArray(g)!==Array.isArray(h))return!1;let d,p;if(Array.isArray(g)){if(g.length!==h.length)return!1;for(d=0;d<g.length;d++)if(!l(g[d],h[d]))return!1}else{const a=[];for(p in g)a.push(p);a.sort();const t=[];for(p in h)t.push(p);if(t.sort(),!l(a,t))return!1;for(d=0;d<a.length;d++)if(!l(g[a[d]],h[a[d]]))return!1}return!0}e.equals=l;function w(g){const h=new Set;return JSON.stringify(g,(d,p)=>{if((0,C.isObject)(p)||Array.isArray(p)){if(h.has(p))return"[Circular]";h.add(p)}return p})}e.safeStringify=w;function b(g,h){const d=Object.create(null);return!g||!h||Object.keys(h).forEach(a=>{const t=g[a],o=h[a];l(t,o)||(d[a]=o)}),d}e.distinct=b;function E(g,h){const d=h.toLowerCase(),p=Object.keys(g).find(a=>a.toLowerCase()===d);return p?g[p]:g[h]}e.getCaseInsensitive=E;function u(g,h){const d=Object.create(null);for(const[p,a]of Object.entries(g))h(p,a)&&(d[p]=a);return d}e.filter=u;function y(g){let h=[];for(;Object.prototype!==g;)h=h.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return h}e.getAllPropertyNames=y;function v(g){const h=[];for(const d of y(g))typeof g[d]=="function"&&h.push(d);return h}e.getAllMethodNames=v;function m(g,h){const d=a=>function(){const t=Array.prototype.slice.call(arguments,0);return h(a,t)},p={};for(const a of g)p[a]=d(a);return p}e.createProxyObject=m}),define(oe[103],ae([0,1,75]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var L;(function(M){function I(f){return f&&typeof f=="object"&&typeof f.id=="string"}M.isThemeColor=I})(L||(e.ThemeColor=L={}));function r(M){return{id:M}}e.themeColorFromId=r;var O;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function f(h){const d=I.exec(h.id);if(!d)return f(C.Codicon.error);const[,p,a]=d,t=["codicon","codicon-"+p];return a&&t.push("codicon-modifier-"+a.substring(1)),t}M.asClassNameArray=f;function l(h){return f(h).join(" ")}M.asClassName=l;function w(h){return"."+f(h).join(".")}M.asCSSSelector=w;function b(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||L.isThemeColor(h.color))}M.isThemeIcon=b;const E=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function u(h){const d=E.exec(h);if(!d)return;const[,p]=d;return{id:p}}M.fromString=u;function y(h){return{id:h}}M.fromId=y;function v(h,d){let p=h.id;const a=p.lastIndexOf("~");return a!==-1&&(p=p.substring(0,a)),d&&(p=`${p}~${d}`),{id:p}}M.modify=v;function m(h){const d=h.id.lastIndexOf("~");if(d!==-1)return h.id.substring(d+1)}M.getModifier=m;function g(h,d){return h.id===d.id&&h.color?.id===d.color?.id}M.isEqual=g})(O||(e.ThemeIcon=O={}))}),define(oe[32],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(r){return C.test(r)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let r;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?r=crypto.getRandomValues.bind(crypto):r=function(I){for(let f=0;f<I.length;f++)I[f]=Math.floor(Math.random()*256);return I};const O=new Uint8Array(16),M=[];for(let I=0;I<256;I++)M.push(I.toString(16).padStart(2,"0"));return function(){r(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let f=0,l="";return l+=M[O[f++]],l+=M[O[f++]],l+=M[O[f++]],l+=M[O[f++]],l+="-",l+=M[O[f++]],l+=M[O[f++]],l+="-",l+=M[O[f++]],l+=M[O[f++]],l+="-",l+=M[O[f++]],l+=M[O[f++]],l+="-",l+=M[O[f++]],l+=M[O[f++]],l+=M[O[f++]],l+=M[O[f++]],l+=M[O[f++]],l+=M[O[f++]],l}}()}),define(oe[144],ae([0,1,86,46,84]),function(Q,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function O(M,I){if(await new Promise((w,b)=>{const E=L.createReadStream(M),u=C.createHash("sha256");E.pipe(u);const y=(0,r.createSingleCallFunction)((v,m)=>{E.removeAllListeners(),u.removeAllListeners(),v?b(v):w(m)});E.once("error",y),E.once("end",y),u.once("error",y),u.once("data",v=>y(void 0,v.toString("hex")))})!==I)throw new Error("Hash mismatch")}e.checksum=O}),define(oe[145],ae([0,1,26]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function r(M){const I=M.replace(/\-/g,":").toLowerCase();return!L.has(I)}function O(){const M=(0,C.networkInterfaces)();for(const I in M){const f=M[I];if(f){for(const{mac:l}of f)if(r(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=O}),define(oe[104],ae([0,1,87]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function L(I,f,l,w=1){let b=!1;return new Promise(E=>{const u=setTimeout(()=>{if(!b)return b=!0,E(0)},l);r(I,f,w,y=>{if(!b)return b=!0,clearTimeout(u),E(y)})})}e.findFreePort=L;function r(I,f,l,w){if(f===0)return w(0);const b=new C.Socket;b.once("connect",()=>(M(b),r(I+l,f-1,l,w))),b.once("data",()=>{}),b.once("error",E=>(M(b),E.code!=="ECONNREFUSED"?r(I+l,f-1,l,w):w(I))),b.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function O(I,f,l,w="127.0.0.1"){let b=!1,E,u=1;const y=C.createServer({pauseOnConnect:!0});function v(m,g){b||(b=!0,y.removeAllListeners(),y.close(),E&&clearTimeout(E),g(m))}return new Promise(m=>{E=setTimeout(()=>{v(0,m)},l),y.on("listening",()=>{v(I,m)}),y.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&u<f?(I++,u++,y.listen(I,w)):v(0,m)}),y.on("close",()=>{v(0,m)}),y.listen(I,w)})}e.findFreePortFaster=O;function M(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(f){console.error(f)}}}),function(){function Q(){function e(){return process.uncHostAllowlist}function C(f){const l=new Set;if(Array.isArray(f))for(const w of f)typeof w=="string"&&l.add(w);return Array.from(l)}function L(){const f=e();return f?Array.from(f):[]}function r(f){if(process.platform!=="win32")return;const l=e();if(l)if(typeof f=="string")l.add(f.toLowerCase());else for(const w of C(f))r(w)}function O(f){if(typeof f!="string")return;const l=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let w;for(const b of l){if(f.indexOf(b)!==0)continue;const u=f.indexOf("\\",b.length);if(u===-1)continue;const y=f.substring(b.length,u);if(y){w=y;break}}return w}function M(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function I(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:L,addUNCHostToAllowlist:r,getUNCHost:O,disableUNCAccessRestrictions:M,isUNCAccessRestrictionsDisabled:I}}typeof define=="function"?define("vs/base/node/unc",[],function(){return Q()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=Q():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(oe[146],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(oe[147],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class C{constructor(r,O){this.sender=r,this.onMessage=O}send(r){try{this.sender.send("vscode:message",r.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=C}),define(oe[148],ae([11,10]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(oe[149],ae([0,1,148]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,r=L*60,O=r*24,M=O*7,I=O*30,f=O*365;function l(b,E,u,y){typeof b!="number"&&(b=b.getTime());const v=Math.round((new Date().getTime()-b)/1e3);if(v<-30)return(0,C.localize)(0,null,l(new Date().getTime()+v*1e3,!1));if(!y&&v<30)return(0,C.localize)(1,null);let m;return v<L?(m=v,E?m===1?u?(0,C.localize)(2,null,m):(0,C.localize)(3,null,m):u?(0,C.localize)(4,null,m):(0,C.localize)(5,null,m):m===1?u?(0,C.localize)(6,null,m):(0,C.localize)(7,null,m):u?(0,C.localize)(8,null,m):(0,C.localize)(9,null,m)):v<r?(m=Math.floor(v/L),E?m===1?u?(0,C.localize)(10,null,m):(0,C.localize)(11,null,m):u?(0,C.localize)(12,null,m):(0,C.localize)(13,null,m):m===1?u?(0,C.localize)(14,null,m):(0,C.localize)(15,null,m):u?(0,C.localize)(16,null,m):(0,C.localize)(17,null,m)):v<O?(m=Math.floor(v/r),E?m===1?u?(0,C.localize)(18,null,m):(0,C.localize)(19,null,m):u?(0,C.localize)(20,null,m):(0,C.localize)(21,null,m):m===1?u?(0,C.localize)(22,null,m):(0,C.localize)(23,null,m):u?(0,C.localize)(24,null,m):(0,C.localize)(25,null,m)):v<M?(m=Math.floor(v/O),E?m===1?(0,C.localize)(26,null,m):(0,C.localize)(27,null,m):m===1?(0,C.localize)(28,null,m):(0,C.localize)(29,null,m)):v<I?(m=Math.floor(v/M),E?m===1?u?(0,C.localize)(30,null,m):(0,C.localize)(31,null,m):u?(0,C.localize)(32,null,m):(0,C.localize)(33,null,m):m===1?u?(0,C.localize)(34,null,m):(0,C.localize)(35,null,m):u?(0,C.localize)(36,null,m):(0,C.localize)(37,null,m)):v<f?(m=Math.floor(v/I),E?m===1?u?(0,C.localize)(38,null,m):(0,C.localize)(39,null,m):u?(0,C.localize)(40,null,m):(0,C.localize)(41,null,m):m===1?u?(0,C.localize)(42,null,m):(0,C.localize)(43,null,m):u?(0,C.localize)(44,null,m):(0,C.localize)(45,null,m)):(m=Math.floor(v/f),E?m===1?u?(0,C.localize)(46,null,m):(0,C.localize)(47,null,m):u?(0,C.localize)(48,null,m):(0,C.localize)(49,null,m):m===1?u?(0,C.localize)(50,null,m):(0,C.localize)(51,null,m):u?(0,C.localize)(52,null,m):(0,C.localize)(53,null,m))}e.fromNow=l;function w(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=w}),define(oe[150],ae([11,10]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(oe[51],ae([0,1,22,12,150]),function(Q,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function O(b,E){return E&&(b.stack||b.stacktrace)?r.localize(0,null,I(b),M(b.stack)||M(b.stacktrace)):I(b)}function M(b){return Array.isArray(b)?b.join(`
`):b}function I(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?r.localize(1,null,b.message):b.message||r.localize(2,null)}function f(b=null,E=!1){if(!b)return r.localize(3,null);if(Array.isArray(b)){const u=C.coalesce(b),y=f(u[0],E);return u.length>1?r.localize(4,null,y,u.length):y}if(L.isString(b))return b;if(b.detail){const u=b.detail;if(u.error)return O(u.error,E);if(u.exception)return O(u.exception,E)}return b.stack?O(b,E):b.message?b.message:r.localize(5,null)}e.toErrorMessage=f;function l(b){const E=b;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=l;function w(b,E){let u;return typeof b=="string"?u=new Error(b):u=b,u.actions=E,u}e.createErrorWithActions=w}),define(oe[151],ae([11,10]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(oe[152],ae([0,1,151]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function L(r){switch(r){case 1:return(0,C.localize)(0,null);case 2:return(0,C.localize)(1,null);case 3:return(0,C.localize)(2,null);case 4:return(0,C.localize)(3,null);case 5:return(0,C.localize)(4,null);case 6:return(0,C.localize)(5,null);case 7:return(0,C.localize)(6,null);case 8:return(0,C.localize)(7,null);case 9:return(0,C.localize)(8,null);default:return""}}e.getParseErrorMessage=L}),define(oe[153],ae([11,10]),function(Q,e){return Q.create("vs/base/common/platform",e)}),define(oe[4],ae([0,1,153]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isBigSurOrNewer=e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let L=!1,r=!1,O=!1,M=!1,I=!1,f=!1,l=!1,w=!1,b=!1,E=!1,u,y=e.LANGUAGE_DEFAULT,v=e.LANGUAGE_DEFAULT,m,g;const h=globalThis;let d;typeof h.vscode<"u"&&typeof h.vscode.process<"u"?d=h.vscode.process:typeof process<"u"&&(d=process);const p=typeof d?.versions?.electron=="string",a=p&&d?.type==="renderer";if(typeof d=="object"){L=d.platform==="win32",r=d.platform==="darwin",O=d.platform==="linux",M=O&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,l=p,b=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.LANGUAGE_DEFAULT,y=e.LANGUAGE_DEFAULT;const P=d.env.VSCODE_NLS_CONFIG;if(P)try{const D=JSON.parse(P),_=D.availableLanguages["*"];u=D.locale,v=D.osLocale,y=_||e.LANGUAGE_DEFAULT,m=D._translationsConfigFile}catch{}I=!0}else typeof navigator=="object"&&!a?(g=navigator.userAgent,L=g.indexOf("Windows")>=0,r=g.indexOf("Macintosh")>=0,w=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=g.indexOf("Linux")>=0,E=g?.indexOf("Mobi")>=0,f=!0,u=C.getConfiguredDefaultLocale(C.localize(0,null))||e.LANGUAGE_DEFAULT,y=u,v=navigator.language):console.error("Unable to resolve platform.");var t;(function(P){P[P.Web=0]="Web",P[P.Mac=1]="Mac",P[P.Linux=2]="Linux",P[P.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(P){switch(P){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=o;let s=0;r?s=1:L?s=3:O&&(s=2),e.isWindows=L,e.isMacintosh=r,e.isLinux=O,e.isLinuxSnap=M,e.isNative=I,e.isElectron=l,e.isWeb=f,e.isWebWorker=f&&typeof h.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?h.origin:void 0,e.isIOS=w,e.isMobile=E,e.isCI=b,e.platform=s,e.userAgent=g,e.language=y;var i;(function(P){function D(){return e.language}P.value=D;function _(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}P.isDefaultVariant=_;function N(){return e.language==="en"}P.isDefault=N})(i||(e.Language=i={})),e.locale=u,e.platformLocale=v,e.translationsConfigFile=m,e.setTimeout0IsFaster=typeof h.postMessage=="function"&&!h.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const P=[];h.addEventListener("message",_=>{if(_.data&&_.data.vscodeScheduleAsyncWork)for(let N=0,U=P.length;N<U;N++){const j=P[N];if(j.id===_.data.vscodeScheduleAsyncWork){P.splice(N,1),j.callback();return}}});let D=0;return _=>{const N=++D;P.push({id:N,callback:_}),h.postMessage({vscodeScheduleAsyncWork:N},"*")}}return P=>setTimeout(P)})();var n;(function(P){P[P.Windows=1]="Windows",P[P.Macintosh=2]="Macintosh",P[P.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=r||w?2:L?1:3;let c=!0,S=!1;function R(){if(!S){S=!0;const P=new Uint8Array(2);P[0]=1,P[1]=2,c=new Uint16Array(P.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=R,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function k(P){return parseFloat(P)>=20}e.isBigSurOrNewer=k}),define(oe[36],ae([0,1,4]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;const r=globalThis.vscode;if(typeof r<"u"&&typeof r.process<"u"){const O=r.process;L={get platform(){return O.platform},get arch(){return O.arch},get env(){return O.env},cwd(){return O.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return C.isWindows?"win32":C.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(oe[9],ae([0,1,36]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,r=97,O=90,M=122,I=46,f=47,l=92,w=58,b=63;class E extends Error{constructor(o,s,i){let n;typeof s=="string"&&s.indexOf("not ")===0?(n="must not be",s=s.replace(/^not /,"")):n="must be";const c=o.indexOf(".")!==-1?"property":"argument";let S=`The "${o}" ${c} ${n} of type ${s}`;S+=`. Received type ${typeof i}`,super(S),this.code="ERR_INVALID_ARG_TYPE"}}function u(t,o){if(t===null||typeof t!="object")throw new E(o,"Object",t)}function y(t,o){if(typeof t!="string")throw new E(o,"string",t)}const v=C.platform==="win32";function m(t){return t===f||t===l}function g(t){return t===f}function h(t){return t>=L&&t<=O||t>=r&&t<=M}function d(t,o,s,i){let n="",c=0,S=-1,R=0,k=0;for(let P=0;P<=t.length;++P){if(P<t.length)k=t.charCodeAt(P);else{if(i(k))break;k=f}if(i(k)){if(!(S===P-1||R===1))if(R===2){if(n.length<2||c!==2||n.charCodeAt(n.length-1)!==I||n.charCodeAt(n.length-2)!==I){if(n.length>2){const D=n.lastIndexOf(s);D===-1?(n="",c=0):(n=n.slice(0,D),c=n.length-1-n.lastIndexOf(s)),S=P,R=0;continue}else if(n.length!==0){n="",c=0,S=P,R=0;continue}}o&&(n+=n.length>0?`${s}..`:"..",c=2)}else n.length>0?n+=`${s}${t.slice(S+1,P)}`:n=t.slice(S+1,P),c=P-S-1;S=P,R=0}else k===I&&R!==-1?++R:R=-1}return n}function p(t,o){u(o,"pathObject");const s=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return s?s===o.root?`${s}${i}`:`${s}${t}${i}`:i}e.win32={resolve(...t){let o="",s="",i=!1;for(let n=t.length-1;n>=-1;n--){let c;if(n>=0){if(c=t[n],y(c,"path"),c.length===0)continue}else o.length===0?c=C.cwd():(c=C.env[`=${o}`]||C.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==o.toLowerCase()&&c.charCodeAt(2)===l)&&(c=`${o}\\`));const S=c.length;let R=0,k="",P=!1;const D=c.charCodeAt(0);if(S===1)m(D)&&(R=1,P=!0);else if(m(D))if(P=!0,m(c.charCodeAt(1))){let _=2,N=_;for(;_<S&&!m(c.charCodeAt(_));)_++;if(_<S&&_!==N){const U=c.slice(N,_);for(N=_;_<S&&m(c.charCodeAt(_));)_++;if(_<S&&_!==N){for(N=_;_<S&&!m(c.charCodeAt(_));)_++;(_===S||_!==N)&&(k=`\\\\${U}\\${c.slice(N,_)}`,R=_)}}}else R=1;else h(D)&&c.charCodeAt(1)===w&&(k=c.slice(0,2),R=2,S>2&&m(c.charCodeAt(2))&&(P=!0,R=3));if(k.length>0)if(o.length>0){if(k.toLowerCase()!==o.toLowerCase())continue}else o=k;if(i){if(o.length>0)break}else if(s=`${c.slice(R)}\\${s}`,i=P,P&&o.length>0)break}return s=d(s,!i,"\\",m),i?`${o}\\${s}`:`${o}${s}`||"."},normalize(t){y(t,"path");const o=t.length;if(o===0)return".";let s=0,i,n=!1;const c=t.charCodeAt(0);if(o===1)return g(c)?"\\":t;if(m(c))if(n=!0,m(t.charCodeAt(1))){let R=2,k=R;for(;R<o&&!m(t.charCodeAt(R));)R++;if(R<o&&R!==k){const P=t.slice(k,R);for(k=R;R<o&&m(t.charCodeAt(R));)R++;if(R<o&&R!==k){for(k=R;R<o&&!m(t.charCodeAt(R));)R++;if(R===o)return`\\\\${P}\\${t.slice(k)}\\`;R!==k&&(i=`\\\\${P}\\${t.slice(k,R)}`,s=R)}}}else s=1;else h(c)&&t.charCodeAt(1)===w&&(i=t.slice(0,2),s=2,o>2&&m(t.charCodeAt(2))&&(n=!0,s=3));let S=s<o?d(t.slice(s),!n,"\\",m):"";return S.length===0&&!n&&(S="."),S.length>0&&m(t.charCodeAt(o-1))&&(S+="\\"),i===void 0?n?`\\${S}`:S:n?`${i}\\${S}`:`${i}${S}`},isAbsolute(t){y(t,"path");const o=t.length;if(o===0)return!1;const s=t.charCodeAt(0);return m(s)||o>2&&h(s)&&t.charCodeAt(1)===w&&m(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,s;for(let c=0;c<t.length;++c){const S=t[c];y(S,"path"),S.length>0&&(o===void 0?o=s=S:o+=`\\${S}`)}if(o===void 0)return".";let i=!0,n=0;if(typeof s=="string"&&m(s.charCodeAt(0))){++n;const c=s.length;c>1&&m(s.charCodeAt(1))&&(++n,c>2&&(m(s.charCodeAt(2))?++n:i=!1))}if(i){for(;n<o.length&&m(o.charCodeAt(n));)n++;n>=2&&(o=`\\${o.slice(n)}`)}return e.win32.normalize(o)},relative(t,o){if(y(t,"from"),y(o,"to"),t===o)return"";const s=e.win32.resolve(t),i=e.win32.resolve(o);if(s===i||(t=s.toLowerCase(),o=i.toLowerCase(),t===o))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===l;)n++;let c=t.length;for(;c-1>n&&t.charCodeAt(c-1)===l;)c--;const S=c-n;let R=0;for(;R<o.length&&o.charCodeAt(R)===l;)R++;let k=o.length;for(;k-1>R&&o.charCodeAt(k-1)===l;)k--;const P=k-R,D=S<P?S:P;let _=-1,N=0;for(;N<D;N++){const j=t.charCodeAt(n+N);if(j!==o.charCodeAt(R+N))break;j===l&&(_=N)}if(N!==D){if(_===-1)return i}else{if(P>D){if(o.charCodeAt(R+N)===l)return i.slice(R+N+1);if(N===2)return i.slice(R+N)}S>D&&(t.charCodeAt(n+N)===l?_=N:N===2&&(_=3)),_===-1&&(_=0)}let U="";for(N=n+_+1;N<=c;++N)(N===c||t.charCodeAt(N)===l)&&(U+=U.length===0?"..":"\\..");return R+=_,U.length>0?`${U}${i.slice(R,k)}`:(i.charCodeAt(R)===l&&++R,i.slice(R,k))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.win32.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===l){if(o.charCodeAt(1)===l){const s=o.charCodeAt(2);if(s!==b&&s!==I)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(h(o.charCodeAt(0))&&o.charCodeAt(1)===w&&o.charCodeAt(2)===l)return`\\\\?\\${o}`;return t},dirname(t){y(t,"path");const o=t.length;if(o===0)return".";let s=-1,i=0;const n=t.charCodeAt(0);if(o===1)return m(n)?t:".";if(m(n)){if(s=i=1,m(t.charCodeAt(1))){let R=2,k=R;for(;R<o&&!m(t.charCodeAt(R));)R++;if(R<o&&R!==k){for(k=R;R<o&&m(t.charCodeAt(R));)R++;if(R<o&&R!==k){for(k=R;R<o&&!m(t.charCodeAt(R));)R++;if(R===o)return t;R!==k&&(s=i=R+1)}}}}else h(n)&&t.charCodeAt(1)===w&&(s=o>2&&m(t.charCodeAt(2))?3:2,i=s);let c=-1,S=!0;for(let R=o-1;R>=i;--R)if(m(t.charCodeAt(R))){if(!S){c=R;break}}else S=!1;if(c===-1){if(s===-1)return".";c=s}return t.slice(0,c)},basename(t,o){o!==void 0&&y(o,"ext"),y(t,"path");let s=0,i=-1,n=!0,c;if(t.length>=2&&h(t.charCodeAt(0))&&t.charCodeAt(1)===w&&(s=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let S=o.length-1,R=-1;for(c=t.length-1;c>=s;--c){const k=t.charCodeAt(c);if(m(k)){if(!n){s=c+1;break}}else R===-1&&(n=!1,R=c+1),S>=0&&(k===o.charCodeAt(S)?--S===-1&&(i=c):(S=-1,i=R))}return s===i?i=R:i===-1&&(i=t.length),t.slice(s,i)}for(c=t.length-1;c>=s;--c)if(m(t.charCodeAt(c))){if(!n){s=c+1;break}}else i===-1&&(n=!1,i=c+1);return i===-1?"":t.slice(s,i)},extname(t){y(t,"path");let o=0,s=-1,i=0,n=-1,c=!0,S=0;t.length>=2&&t.charCodeAt(1)===w&&h(t.charCodeAt(0))&&(o=i=2);for(let R=t.length-1;R>=o;--R){const k=t.charCodeAt(R);if(m(k)){if(!c){i=R+1;break}continue}n===-1&&(c=!1,n=R+1),k===I?s===-1?s=R:S!==1&&(S=1):s!==-1&&(S=-1)}return s===-1||n===-1||S===0||S===1&&s===n-1&&s===i+1?"":t.slice(s,n)},format:p.bind(null,"\\"),parse(t){y(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const s=t.length;let i=0,n=t.charCodeAt(0);if(s===1)return m(n)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(m(n)){if(i=1,m(t.charCodeAt(1))){let _=2,N=_;for(;_<s&&!m(t.charCodeAt(_));)_++;if(_<s&&_!==N){for(N=_;_<s&&m(t.charCodeAt(_));)_++;if(_<s&&_!==N){for(N=_;_<s&&!m(t.charCodeAt(_));)_++;_===s?i=_:_!==N&&(i=_+1)}}}}else if(h(n)&&t.charCodeAt(1)===w){if(s<=2)return o.root=o.dir=t,o;if(i=2,m(t.charCodeAt(2))){if(s===3)return o.root=o.dir=t,o;i=3}}i>0&&(o.root=t.slice(0,i));let c=-1,S=i,R=-1,k=!0,P=t.length-1,D=0;for(;P>=i;--P){if(n=t.charCodeAt(P),m(n)){if(!k){S=P+1;break}continue}R===-1&&(k=!1,R=P+1),n===I?c===-1?c=P:D!==1&&(D=1):c!==-1&&(D=-1)}return R!==-1&&(c===-1||D===0||D===1&&c===R-1&&c===S+1?o.base=o.name=t.slice(S,R):(o.name=t.slice(S,c),o.base=t.slice(S,R),o.ext=t.slice(c,R))),S>0&&S!==i?o.dir=t.slice(0,S-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(v){const t=/\\/g;return()=>{const o=C.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>C.cwd()})();e.posix={resolve(...t){let o="",s=!1;for(let i=t.length-1;i>=-1&&!s;i--){const n=i>=0?t[i]:a();y(n,"path"),n.length!==0&&(o=`${n}/${o}`,s=n.charCodeAt(0)===f)}return o=d(o,!s,"/",g),s?`/${o}`:o.length>0?o:"."},normalize(t){if(y(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===f,s=t.charCodeAt(t.length-1)===f;return t=d(t,!o,"/",g),t.length===0?o?"/":s?"./":".":(s&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return y(t,"path"),t.length>0&&t.charCodeAt(0)===f},join(...t){if(t.length===0)return".";let o;for(let s=0;s<t.length;++s){const i=t[s];y(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.posix.normalize(o)},relative(t,o){if(y(t,"from"),y(o,"to"),t===o||(t=e.posix.resolve(t),o=e.posix.resolve(o),t===o))return"";const s=1,i=t.length,n=i-s,c=1,S=o.length-c,R=n<S?n:S;let k=-1,P=0;for(;P<R;P++){const _=t.charCodeAt(s+P);if(_!==o.charCodeAt(c+P))break;_===f&&(k=P)}if(P===R)if(S>R){if(o.charCodeAt(c+P)===f)return o.slice(c+P+1);if(P===0)return o.slice(c+P)}else n>R&&(t.charCodeAt(s+P)===f?k=P:P===0&&(k=0));let D="";for(P=s+k+1;P<=i;++P)(P===i||t.charCodeAt(P)===f)&&(D+=D.length===0?"..":"/..");return`${D}${o.slice(c+k)}`},toNamespacedPath(t){return t},dirname(t){if(y(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===f;let s=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===f){if(!i){s=n;break}}else i=!1;return s===-1?o?"/":".":o&&s===1?"//":t.slice(0,s)},basename(t,o){o!==void 0&&y(o,"ext"),y(t,"path");let s=0,i=-1,n=!0,c;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let S=o.length-1,R=-1;for(c=t.length-1;c>=0;--c){const k=t.charCodeAt(c);if(k===f){if(!n){s=c+1;break}}else R===-1&&(n=!1,R=c+1),S>=0&&(k===o.charCodeAt(S)?--S===-1&&(i=c):(S=-1,i=R))}return s===i?i=R:i===-1&&(i=t.length),t.slice(s,i)}for(c=t.length-1;c>=0;--c)if(t.charCodeAt(c)===f){if(!n){s=c+1;break}}else i===-1&&(n=!1,i=c+1);return i===-1?"":t.slice(s,i)},extname(t){y(t,"path");let o=-1,s=0,i=-1,n=!0,c=0;for(let S=t.length-1;S>=0;--S){const R=t.charCodeAt(S);if(R===f){if(!n){s=S+1;break}continue}i===-1&&(n=!1,i=S+1),R===I?o===-1?o=S:c!==1&&(c=1):o!==-1&&(c=-1)}return o===-1||i===-1||c===0||c===1&&o===i-1&&o===s+1?"":t.slice(o,i)},format:p.bind(null,"/"),parse(t){y(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const s=t.charCodeAt(0)===f;let i;s?(o.root="/",i=1):i=0;let n=-1,c=0,S=-1,R=!0,k=t.length-1,P=0;for(;k>=i;--k){const D=t.charCodeAt(k);if(D===f){if(!R){c=k+1;break}continue}S===-1&&(R=!1,S=k+1),D===I?n===-1?n=k:P!==1&&(P=1):n!==-1&&(P=-1)}if(S!==-1){const D=c===0&&s?1:c;n===-1||P===0||P===1&&n===S-1&&n===c+1?o.base=o.name=t.slice(D,S):(o.name=t.slice(D,n),o.base=t.slice(D,S),o.ext=t.slice(n,S))}return c>0?o.dir=t.slice(0,c-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v?e.win32.normalize:e.posix.normalize,e.isAbsolute=v?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v?e.win32.join:e.posix.join,e.resolve=v?e.win32.resolve:e.posix.resolve,e.relative=v?e.win32.relative:e.posix.relative,e.dirname=v?e.win32.dirname:e.posix.dirname,e.basename=v?e.win32.basename:e.posix.basename,e.extname=v?e.win32.extname:e.posix.extname,e.format=v?e.win32.format:e.posix.format,e.parse=v?e.win32.parse:e.posix.parse,e.toNamespacedPath=v?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v?e.win32.sep:e.posix.sep,e.delimiter=v?e.win32.delimiter:e.posix.delimiter}),define(oe[33],ae([0,1,9,4,25,12]),function(Q,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(c){return c===47||c===92}e.isPathSeparator=M;function I(c){return c.replace(/[\\/]/g,C.posix.sep)}e.toSlashes=I;function f(c){return c.indexOf("/")===-1&&(c=I(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=f;function l(c,S=C.posix.sep){if(!c)return"";const R=c.length,k=c.charCodeAt(0);if(M(k)){if(M(c.charCodeAt(1))&&!M(c.charCodeAt(2))){let D=3;const _=D;for(;D<R&&!M(c.charCodeAt(D));D++);if(_!==D&&!M(c.charCodeAt(D+1))){for(D+=1;D<R;D++)if(M(c.charCodeAt(D)))return c.slice(0,D+1).replace(/[\\/]/g,S)}}return S}else if(g(k)&&c.charCodeAt(1)===58)return M(c.charCodeAt(2))?c.slice(0,2)+S:c.slice(0,2);let P=c.indexOf("://");if(P!==-1){for(P+=3;P<R;P++)if(M(c.charCodeAt(P)))return c.slice(0,P+1)}return""}e.getRoot=l;function w(c){if(!L.isWindows||!c||c.length<5)return!1;let S=c.charCodeAt(0);if(S!==92||(S=c.charCodeAt(1),S!==92))return!1;let R=2;const k=R;for(;R<c.length&&(S=c.charCodeAt(R),S!==92);R++);return!(k===R||(S=c.charCodeAt(R+1),isNaN(S)||S===92))}e.isUNC=w;const b=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(c,S=L.isWindows){const R=S?b:E;return!(!c||c.length===0||/^\s+$/.test(c)||(R.lastIndex=0,R.test(c))||S&&u.test(c)||c==="."||c===".."||S&&c[c.length-1]==="."||S&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=y;function v(c,S,R){const k=c===S;return!R||k?k:!c||!S?!1:(0,r.equalsIgnoreCase)(c,S)}e.isEqual=v;function m(c,S,R,k=C.sep){if(c===S)return!0;if(!c||!S||S.length>c.length)return!1;if(R){if(!(0,r.startsWithIgnoreCase)(c,S))return!1;if(S.length===c.length)return!0;let D=S.length;return S.charAt(S.length-1)===k&&D--,c.charAt(D)===k}return S.charAt(S.length-1)!==k&&(S+=k),c.indexOf(S)===0}e.isEqualOrParent=m;function g(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=g;function h(c,S){return L.isWindows&&c.endsWith(":")&&(c+=C.sep),(0,C.isAbsolute)(c)||(c=(0,C.join)(S,c)),c=(0,C.normalize)(c),L.isWindows?(c=(0,r.rtrim)(c,C.sep),c.endsWith(":")&&(c+=C.sep)):(c=(0,r.rtrim)(c,C.sep),c||(c=C.sep)),c}e.sanitizeFilePath=h;function d(c){const S=(0,C.normalize)(c);return L.isWindows?c.length>3?!1:p(S)&&(c.length===2||S.charCodeAt(2)===92):S===C.posix.sep}e.isRootOrDriveLetter=d;function p(c,S=L.isWindows){return S?g(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function a(c,S=L.isWindows){return p(c,S)?c[0]:void 0}e.getDriveLetter=a;function t(c,S,R){return S.length>c.length?-1:c===S?0:(R&&(c=c.toLowerCase(),S=S.toLowerCase()),c.indexOf(S))}e.indexOfPath=t;function o(c){const S=c.split(":");let R,k,P;for(const D of S){const _=Number(D);(0,O.isNumber)(_)?k===void 0?k=_:P===void 0&&(P=_):R=R?[R,D].join(":"):D}if(!R)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:R,line:k!==void 0?k:void 0,column:P!==void 0?P:k!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(c,S,R=8){let k="";for(let D=0;D<R;D++){let _;D===0&&L.isWindows&&!S&&(R===3||R===4)?_=i:_=s,k+=_.charAt(Math.floor(Math.random()*_.length))}let P;return S?P=`${S}-${k}`:P=k,c?(0,C.join)(c,P):P}e.randomPath=n}),define(oe[76],ae([0,1,4]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(L||(e.Source=L={}));var r;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(r||(e.TerminateResponseCode=r={}));function O(I,...f){const l=f.reduce((E,u)=>(E[u]=!0,E),{}),w=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(E=>!l[E]).forEach(E=>{for(let u=0;u<w.length;u++)if(E.search(w[u])!==-1){delete I[E];break}})}e.sanitizeProcessEnvironment=O;function M(I){I&&(delete I.DEBUG,C.isMacintosh&&delete I.DYLD_LIBRARY_PATH,C.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=M}),define(oe[7],ae([0,1,9,4]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const r=/^\w[\w\d+.-]*$/,O=/^\//,M=/^\/\//;function I(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!r.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!O.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(i,n){return!i&&!n?"file":i}function l(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==b&&(n=b+n):n=b;break}return n}const w="",b="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(n){return n instanceof u?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,c,S,R,k,P=!1){typeof n=="object"?(this.scheme=n.scheme||w,this.authority=n.authority||w,this.path=n.path||w,this.query=n.query||w,this.fragment=n.fragment||w):(this.scheme=f(n,P),this.authority=c||w,this.path=l(this.scheme,S||w),this.query=R||w,this.fragment=k||w,I(this,P))}get fsPath(){return p(this,!1)}with(n){if(!n)return this;let{scheme:c,authority:S,path:R,query:k,fragment:P}=n;return c===void 0?c=this.scheme:c===null&&(c=w),S===void 0?S=this.authority:S===null&&(S=w),R===void 0?R=this.path:R===null&&(R=w),k===void 0?k=this.query:k===null&&(k=w),P===void 0?P=this.fragment:P===null&&(P=w),c===this.scheme&&S===this.authority&&R===this.path&&k===this.query&&P===this.fragment?this:new m(c,S,R,k,P)}static parse(n,c=!1){const S=E.exec(n);return S?new m(S[2]||w,s(S[4]||w),s(S[5]||w),s(S[7]||w),s(S[9]||w),c):new m(w,w,w,w,w)}static file(n){let c=w;if(L.isWindows&&(n=n.replace(/\\/g,b)),n[0]===b&&n[1]===b){const S=n.indexOf(b,2);S===-1?(c=n.substring(2),n=b):(c=n.substring(2,S),n=n.substring(S)||b)}return new m("file",c,n,w,w)}static from(n,c){return new m(n.scheme,n.authority,n.path,n.query,n.fragment,c)}static joinPath(n,...c){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let S;return L.isWindows&&n.scheme==="file"?S=u.file(C.win32.join(p(n,!0),...c)).path:S=C.posix.join(n.path,...c),n.with({path:S})}toString(n=!1){return a(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof u)return n;{const c=new m(n);return c._formatted=n.external??null,c._fsPath=n._sep===v?n.fsPath??null:null,c}}else return n}}e.URI=u;function y(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.isUriComponents=y;const v=L.isWindows?1:void 0;class m extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(n=!1){return n?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=v),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(i,n,c){let S,R=-1;for(let k=0;k<i.length;k++){const P=i.charCodeAt(k);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||n&&P===47||c&&P===91||c&&P===93||c&&P===58)R!==-1&&(S+=encodeURIComponent(i.substring(R,k)),R=-1),S!==void 0&&(S+=i.charAt(k));else{S===void 0&&(S=i.substr(0,k));const D=g[P];D!==void 0?(R!==-1&&(S+=encodeURIComponent(i.substring(R,k)),R=-1),S+=D):R===-1&&(R=k)}}return R!==-1&&(S+=encodeURIComponent(i.substring(R))),S!==void 0?S:i}function d(i){let n;for(let c=0;c<i.length;c++){const S=i.charCodeAt(c);S===35||S===63?(n===void 0&&(n=i.substr(0,c)),n+=g[S]):n!==void 0&&(n+=i[c])}return n!==void 0?n:i}function p(i,n){let c;return i.authority&&i.path.length>1&&i.scheme==="file"?c=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?c=i.path.substr(1):c=i.path[1].toLowerCase()+i.path.substr(2):c=i.path,L.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=p;function a(i,n){const c=n?d:h;let S="",{scheme:R,authority:k,path:P,query:D,fragment:_}=i;if(R&&(S+=R,S+=":"),(k||R==="file")&&(S+=b,S+=b),k){let N=k.indexOf("@");if(N!==-1){const U=k.substr(0,N);k=k.substr(N+1),N=U.lastIndexOf(":"),N===-1?S+=c(U,!1,!1):(S+=c(U.substr(0,N),!1,!1),S+=":",S+=c(U.substr(N+1),!1,!0)),S+="@"}k=k.toLowerCase(),N=k.lastIndexOf(":"),N===-1?S+=c(k,!1,!0):(S+=c(k.substr(0,N),!1,!0),S+=k.substr(N))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const N=P.charCodeAt(1);N>=65&&N<=90&&(P=`/${String.fromCharCode(N+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const N=P.charCodeAt(0);N>=65&&N<=90&&(P=`${String.fromCharCode(N+32)}:${P.substr(2)}`)}S+=c(P,!0,!1)}return D&&(S+="?",S+=c(D,!1,!1)),_&&(S+="#",S+=n?_:h(_,!1,!1)),S}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(o)?i.replace(o,n=>t(n)):i}}),define(oe[154],ae([0,1,7]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(l){const w=l;return w&&typeof w.type=="string"&&typeof w.severity=="string"}e.isRemoteConsoleLog=L;function r(l){const w=[];let b;try{const E=JSON.parse(l.arguments),u=E[E.length-1];u&&u.__$stack&&(E.pop(),b=u.__$stack),w.push(...E)}catch{w.push("Unable to log remote console arguments",l.arguments)}return{args:w,stack:b}}e.parse=r;function O(l){if(typeof l!="string")return O(r(l).stack);const w=l;if(w){const b=M(w),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(E&&E.length===4)return{uri:C.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=O;function M(l){if(!l)return l;const w=l.indexOf(`
`);return w===-1?l:l.substring(0,w)}function I(l,w){const{args:b,stack:E}=r(l),u=typeof b[0]=="string"&&b.length===1;let y=M(E);y&&(y=`(${y.trim()})`);let v=[];if(typeof b[0]=="string"?y&&u?v=[`%c[${w}] %c${b[0]} %c${y}`,f("blue"),f(""),f("grey")]:v=[`%c[${w}] %c${b[0]}`,f("blue"),f(""),...b.slice(1)]:v=[`%c[${w}]%`,f("blue"),...b],y&&!u&&v.push(y),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,v)}e.log=I;function f(l){return`color: ${l}`}}),define(oe[77],ae([0,1,17,7]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function r(f){return JSON.stringify(f,M)}e.stringify=r;function O(f){let l=JSON.parse(f);return l=I(l),l}e.parse=O;function M(f,l){return l instanceof RegExp?{$mid:2,source:l.source,flags:l.flags}:l}function I(f,l=0){if(!f||l>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return L.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof C.VSBuffer||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let w=0;w<f.length;++w)f[w]=I(f[w],l+1);else for(const w in f)Object.hasOwnProperty.call(f,w)&&(f[w]=I(f[w],l+1))}return f}e.revive=I}),define(oe[13],ae([0,1,14,4,25,7]),function(Q,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.matchesSomeScheme=e.matchesScheme=e.Schemas=void 0;var M;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.vscodeManagedRemoteResource="vscode-managed-remote-resource",E.vscodeUserData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.vscodeChatSesssion="vscode-chat-editor",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls",E.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={}));function I(E,u){return O.URI.isUri(E)?(0,r.equalsIgnoreCase)(E.scheme,u):(0,r.startsWithIgnoreCase)(E,u+":")}e.matchesScheme=I;function f(E,...u){return u.some(y=>I(E,y))}e.matchesSomeScheme=f,e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class l{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(u){this._preferredWebSchema=u}setDelegate(u){this._delegate=u}setServerRootPath(u){this._remoteResourcesPath=`${u}/${M.vscodeRemoteResource}`}set(u,y,v){this._hosts[u]=y,this._ports[u]=v}setConnectionToken(u,y){this._connectionTokens[u]=y}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(u){if(this._delegate)try{return this._delegate(u)}catch(d){return C.onUnexpectedError(d),u}const y=u.authority;let v=this._hosts[y];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const m=this._ports[y],g=this._connectionTokens[y];let h=`path=${encodeURIComponent(u.path)}`;return typeof g=="string"&&(h+=`&${e.connectionTokenQueryName}=${encodeURIComponent(g)}`),O.URI.from({scheme:L.isWeb?this._preferredWebSchema:M.vscodeRemoteResource,authority:`${v}:${m}`,path:this._remoteResourcesPath,query:h})}}e.RemoteAuthorities=new l,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class w{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(u){const y=this.toUri(u,Q);return this.uriToBrowserUri(y)}uriToBrowserUri(u){return u.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(u):u.scheme===M.file&&(L.isNative||L.webWorkerOrigin===`${M.vscodeFileResource}://${w.FALLBACK_AUTHORITY}`)?u.with({scheme:M.vscodeFileResource,authority:u.authority||w.FALLBACK_AUTHORITY,query:null,fragment:null}):u}asFileUri(u){const y=this.toUri(u,Q);return this.uriToFileUri(y)}uriToFileUri(u){return u.scheme===M.vscodeFileResource?u.with({scheme:M.file,authority:u.authority!==w.FALLBACK_AUTHORITY?u.authority:null,query:null,fragment:null}):u}toUri(u,y){return O.URI.isUri(u)?u:O.URI.parse(y.toUrl(u))}}e.FileAccess=new w;var b;(function(E){const u=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);E.CoopAndCoep=Object.freeze(u.get("3"));const y="vscode-coi";function v(g){let h;typeof g=="string"?h=new URL(g).searchParams:g instanceof URL?h=g.searchParams:O.URI.isUri(g)&&(h=new URL(g.toString(!0)).searchParams);const d=h?.get(y);if(d)return u.get(d)}E.getHeadersFromQuery=v;function m(g,h,d){if(!globalThis.crossOriginIsolated)return;const p=h&&d?"3":d?"2":"1";g instanceof URLSearchParams?g.set(y,p):g[y]=p}E.addSearchParam=m})(b||(e.COI=b={}))}),define(oe[19],ae([0,1,33,13,9,4,25,7]),function(Q,e,C,L,r,O,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(u){return(0,I.uriToFsPath)(u,!0)}e.originalFSPath=f;class l{constructor(y){this._ignorePathCasing=y}compare(y,v,m=!1){return y===v?0:(0,M.compare)(this.getComparisonKey(y,m),this.getComparisonKey(v,m))}isEqual(y,v,m=!1){return y===v?!0:!y||!v?!1:this.getComparisonKey(y,m)===this.getComparisonKey(v,m)}getComparisonKey(y,v=!1){return y.with({path:this._ignorePathCasing(y)?y.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(y){return this._ignorePathCasing(y)}isEqualOrParent(y,v,m=!1){if(y.scheme===v.scheme){if(y.scheme===L.Schemas.file)return C.isEqualOrParent(f(y),f(v),this._ignorePathCasing(y))&&y.query===v.query&&(m||y.fragment===v.fragment);if((0,e.isEqualAuthority)(y.authority,v.authority))return C.isEqualOrParent(y.path,v.path,this._ignorePathCasing(y),"/")&&y.query===v.query&&(m||y.fragment===v.fragment)}return!1}joinPath(y,...v){return I.URI.joinPath(y,...v)}basenameOrAuthority(y){return(0,e.basename)(y)||y.authority}basename(y){return r.posix.basename(y.path)}extname(y){return r.posix.extname(y.path)}dirname(y){if(y.path.length===0)return y;let v;return y.scheme===L.Schemas.file?v=I.URI.file(r.dirname(f(y))).path:(v=r.posix.dirname(y.path),y.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),v="/")),y.with({path:v})}normalizePath(y){if(!y.path.length)return y;let v;return y.scheme===L.Schemas.file?v=I.URI.file(r.normalize(f(y))).path:v=r.posix.normalize(y.path),y.with({path:v})}relativePath(y,v){if(y.scheme!==v.scheme||!(0,e.isEqualAuthority)(y.authority,v.authority))return;if(y.scheme===L.Schemas.file){const h=r.relative(f(y),f(v));return O.isWindows?C.toSlashes(h):h}let m=y.path||"/";const g=v.path||"/";if(this._ignorePathCasing(y)){let h=0;for(const d=Math.min(m.length,g.length);h<d&&!(m.charCodeAt(h)!==g.charCodeAt(h)&&m.charAt(h).toLowerCase()!==g.charAt(h).toLowerCase());h++);m=g.substr(0,h)+m.substr(h)}return r.posix.relative(m,g)}resolvePath(y,v){if(y.scheme===L.Schemas.file){const m=I.URI.file(r.resolve(f(y),v));return y.with({authority:m.authority,path:m.path})}return v=C.toPosixPath(v),y.with({path:r.posix.resolve(y.path,v)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,v){return y===v||y!==void 0&&v!==void 0&&(0,M.equalsIgnoreCase)(y,v)}hasTrailingPathSeparator(y,v=r.sep){if(y.scheme===L.Schemas.file){const m=f(y);return m.length>C.getRoot(m).length&&m[m.length-1]===v}else{const m=y.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,v=r.sep){return(0,e.hasTrailingPathSeparator)(y,v)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,v=r.sep){let m=!1;if(y.scheme===L.Schemas.file){const g=f(y);m=g!==void 0&&g.length===C.getRoot(g).length&&g[g.length-1]===v}else{v="/";const g=y.path;m=g.length===1&&g.charCodeAt(g.length-1)===47}return!m&&!(0,e.hasTrailingPathSeparator)(y,v)?y.with({path:y.path+"/"}):y}}e.ExtUri=l,e.extUri=new l(()=>!1),e.extUriBiasedIgnorePathCase=new l(u=>u.scheme===L.Schemas.file?!O.isLinux:!0),e.extUriIgnorePathCase=new l(u=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function w(u,y){const v=[];for(let m=0;m<u.length;m++){const g=y(u[m]);u.some((h,d)=>d===m?!1:(0,e.isEqualOrParent)(g,y(h)))||v.push(u[m])}return v}e.distinctParents=w;var b;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function y(v){const m=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(d=>{const[p,a]=d.split(":");p&&a&&m.set(p,a)});const h=v.path.substring(0,v.path.indexOf(";"));return h&&m.set(u.META_DATA_MIME,h),m}u.parseMetaData=y})(b||(e.DataUri=b={}));function E(u,y,v){if(y){let m=u.path;return m&&m[0]!==r.posix.sep&&(m=r.posix.sep+m),u.with({scheme:v,authority:y,path:m})}return u.with({scheme:v})}e.toLocalResource=E}),define(oe[8],ae([0,1,23,14,3,2,19,4,143,62]),function(Q,e,C,L,r,O,M,I,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(B){return!!B&&typeof B.then=="function"}e.isThenable=w;function b(B){const $=new C.CancellationTokenSource,K=B($.token),re=new Promise((le,ge)=>{const we=$.token.onCancellationRequested(()=>{we.dispose(),ge(new L.CancellationError)});Promise.resolve(K).then(Ie=>{we.dispose(),$.dispose(),le(Ie)},Ie=>{we.dispose(),$.dispose(),ge(Ie)})});return new class{cancel(){$.cancel(),$.dispose()}then(le,ge){return re.then(le,ge)}catch(le){return this.then(void 0,le)}finally(le){return re.finally(le)}}}e.createCancelablePromise=b;function E(B,$,K){return new Promise((re,le)=>{const ge=$.onCancellationRequested(()=>{ge.dispose(),re(K)});B.then(re,le).finally(()=>ge.dispose())})}e.raceCancellation=E;function u(B,$){return new Promise((K,re)=>{const le=$.onCancellationRequested(()=>{le.dispose(),re(new L.CancellationError)});B.then(K,re).finally(()=>le.dispose())})}e.raceCancellationError=u;async function y(B){let $=-1;const K=B.map((re,le)=>re.then(ge=>($=le,ge)));try{return await Promise.race(K)}finally{B.forEach((re,le)=>{le!==$&&re.cancel()})}}e.raceCancellablePromises=y;function v(B,$,K){let re;const le=setTimeout(()=>{re?.(void 0),K?.()},$);return Promise.race([B.finally(()=>clearTimeout(le)),new Promise(ge=>re=ge)])}e.raceTimeout=v;function m(B){return new Promise(($,K)=>{const re=B();w(re)?re.then($,K):$(re)})}e.asPromise=m;class g{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue($){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=$,!this.queuedPromise){const K=()=>{if(this.queuedPromise=null,this.isDisposed)return;const re=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,re};this.queuedPromise=new Promise(re=>{this.activePromise.then(K,K).then(re)})}return new Promise((K,re)=>{this.queuedPromise.then(K,re)})}return this.activePromise=$(),new Promise((K,re)=>{this.activePromise.then(le=>{this.activePromise=null,K(le)},le=>{this.activePromise=null,re(le)})})}dispose(){this.isDisposed=!0}}e.Throttler=g;class h{constructor(){this.current=Promise.resolve(null)}queue($){return this.current=this.current.then(()=>$(),()=>$())}}e.Sequencer=h;class d{constructor(){this.promiseMap=new Map}queue($,K){const le=(this.promiseMap.get($)??Promise.resolve()).catch(()=>{}).then(K).finally(()=>{this.promiseMap.get($)===le&&this.promiseMap.delete($)});return this.promiseMap.set($,le),le}}e.SequencerByKey=d;const p=(B,$)=>{let K=!0;const re=setTimeout(()=>{K=!1,$()},B);return{isTriggered:()=>K,dispose:()=>{clearTimeout(re),K=!1}}},a=B=>{let $=!0;return queueMicrotask(()=>{$&&($=!1,B())}),{isTriggered:()=>$,dispose:()=>{$=!1}}};class t{constructor($){this.defaultDelay=$,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger($,K=this.defaultDelay){this.task=$,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((le,ge)=>{this.doResolve=le,this.doReject=ge}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const le=this.task;return this.task=null,le()}}));const re=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=K===f.MicrotaskDelay?a(re):p(K,re),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new L.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=t;class o{constructor($){this.delayer=new t($),this.throttler=new g}trigger($,K){return this.delayer.trigger(()=>this.throttler.queue($),K)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=o;class s{constructor(){this._isOpen=!1,this._promise=new Promise(($,K)=>{this._completePromise=$})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class i extends s{constructor($){super(),this._timeout=setTimeout(()=>this.open(),$)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=i;function n(B,$){return $?new Promise((K,re)=>{const le=setTimeout(()=>{ge.dispose(),K()},B),ge=$.onCancellationRequested(()=>{clearTimeout(le),ge.dispose(),re(new L.CancellationError)})}):b(K=>n(B,K))}e.timeout=n;function c(B,$=0,K){const re=setTimeout(()=>{B(),K&&le.dispose()},$),le=(0,O.toDisposable)(()=>{clearTimeout(re),K?.deleteAndLeak(le)});return K?.add(le),le}e.disposableTimeout=c;function S(B){const $=[];let K=0;const re=B.length;function le(){return K<re?B[K++]():null}function ge(we){we!=null&&$.push(we);const Ie=le();return Ie?Ie.then(ge):Promise.resolve($)}return Promise.resolve(null).then(ge)}e.sequence=S;function R(B,$=re=>!!re,K=null){let re=0;const le=B.length,ge=()=>{if(re>=le)return Promise.resolve(K);const we=B[re++];return Promise.resolve(we()).then(De=>$(De)?Promise.resolve(De):ge())};return ge()}e.first=R;function k(B,$=re=>!!re,K=null){if(B.length===0)return Promise.resolve(K);let re=B.length;const le=()=>{re=-1;for(const ge of B)ge.cancel?.()};return new Promise((ge,we)=>{for(const Ie of B)Ie.then(De=>{--re>=0&&$(De)?(le(),ge(De)):re===0&&ge(K)}).catch(De=>{--re>=0&&(le(),we(De))})})}e.firstParallel=k;class P{constructor($){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=$,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new r.Emitter}whenIdle(){return this.size>0?r.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue($){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((K,re)=>{this.outstandingPromises.push({factory:$,c:K,e:re}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const $=this.outstandingPromises.shift();this.runningPromises++;const K=$.factory();K.then($.c,$.e),K.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=P;class D extends P{constructor(){super(1)}}e.Queue=D;class _{constructor(){this.sequentializer=new W,this.tasks=0}queue($){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,$())):this.sequentializer.run(this.tasks++,$())}}e.LimitedQueue=_;class N{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const $=new q;return this.drainers.add($),$.p}isDrained(){for(const[,$]of this.queues)if($.size>0)return!1;return!0}queueSize($,K=M.extUri){const re=K.getComparisonKey($);return this.queues.get(re)?.size??0}queueFor($,K,re=M.extUri){const le=re.getComparisonKey($);let ge=this.queues.get(le);if(!ge){ge=new D;const we=this.drainListenerCount++,Ie=r.Event.once(ge.onDrained)(()=>{ge?.dispose(),this.queues.delete(le),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(we),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new O.DisposableMap),this.drainListeners.set(we,Ie),this.queues.set(le,ge)}return ge.queue(K)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const $ of this.drainers)$.complete();this.drainers.clear()}dispose(){for(const[,$]of this.queues)$.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=N;class U{constructor($,K){this._token=-1,typeof $=="function"&&typeof K=="number"&&this.setIfNotSet($,K)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet($,K){this.cancel(),this._token=setTimeout(()=>{this._token=-1,$()},K)}setIfNotSet($,K){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,$()},K))}}e.TimeoutTimer=U;class j{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet($,K,re=globalThis){this.cancel();const le=re.setInterval(()=>{$()},K);this.disposable=(0,O.toDisposable)(()=>{re.clearInterval(le),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=j;class V{constructor($,K){this.timeoutToken=-1,this.runner=$,this.timeout=K,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule($=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,$)}get delay(){return this.timeout}set delay($){this.timeout=$}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=V;class ce{constructor($,K){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.runner=$,this.timeout=K,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule($=this.timeout){$%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil($/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=ce;class se extends V{constructor($,K){super($,K),this.units=[]}work($){this.units.push($),this.isScheduled()||this.schedule()}doRun(){const $=this.units;this.units=[],this.runner?.($)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=se;class ue extends O.Disposable{constructor($,K){super(),this.options=$,this.handler=K,this.pendingWork=[],this.throttler=this._register(new O.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work($){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+$.length>this.options.maxBufferedWork)return!1}else if(this.pending+$.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const K of $)this.pendingWork.push(K);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new V(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ue,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(B,$)=>{(0,I.setTimeout0)(()=>{if(K)return;const re=Date.now()+15;$(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,re-Date.now())}}))});let K=!1;return{dispose(){K||(K=!0)}}}:e._runWhenIdle=(B,$,K)=>{const re=B.requestIdleCallback($,typeof K=="number"?{timeout:K}:void 0);let le=!1;return{dispose(){le||(le=!0,B.cancelIdleCallback(re))}}},e.runWhenGlobalIdle=B=>(0,e._runWhenIdle)(globalThis,B)}();class X{constructor($,K){this._didRun=!1,this._executor=()=>{try{this._value=K()}catch(re){this._error=re}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)($,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=X;class Y extends X{constructor($){super(globalThis,$)}}e.GlobalIdleValue=Y;async function x(B,$,K){let re;for(let le=0;le<K;le++)try{return await B()}catch(ge){re=ge,await n($)}throw re}e.retry=x;class W{isRunning($){return typeof $=="number"?this._running?.taskId===$:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run($,K,re){return this._running={taskId:$,cancel:()=>re?.(),promise:K},K.then(()=>this.doneRunning($),()=>this.doneRunning($)),K}doneRunning($){this._running&&$===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const $=this._queued;this._queued=void 0,$.run().then($.promiseResolve,$.promiseReject)}}queue($){if(this._queued)this._queued.run=$;else{let K,re;const le=new Promise((ge,we)=>{K=ge,re=we});this._queued={run:$,promise:le,promiseResolve:K,promiseReject:re}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=W;class F{constructor($,K=()=>Date.now()){this.interval=$,this.nowFn=K,this.lastIncrementTime=0,this.value=0}increment(){const $=this.nowFn();return $-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=$,this.value=0),this.value++,this.value}}e.IntervalCounter=F;var H;(function(B){B[B.Resolved=0]="Resolved",B[B.Rejected=1]="Rejected"})(H||(H={}));class q{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise(($,K)=>{this.completeCallback=$,this.errorCallback=K})}complete($){return new Promise(K=>{this.completeCallback($),this.outcome={outcome:0,value:$},K()})}error($){return new Promise(K=>{this.errorCallback($),this.outcome={outcome:1,value:$},K()})}cancel(){return this.error(new L.CancellationError)}}e.DeferredPromise=q;var ee;(function(B){async function $(re){let le;const ge=await Promise.all(re.map(we=>we.then(Ie=>Ie,Ie=>{le||(le=Ie)})));if(typeof le<"u")throw le;return ge}B.settled=$;function K(re){return new Promise(async(le,ge)=>{try{await re(le,ge)}catch(we){ge(we)}})}B.withAsyncBody=K})(ee||(e.Promises=ee={}));class de{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor($){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=$.then(K=>(this._value=K,this._isResolved=!0,K),K=>{throw this._error=K,this._isResolved=!0,K})}requireValue(){if(!this._isResolved)throw new L.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=de;class G{constructor($){this._compute=$,this._promise=new l.Lazy(()=>new de(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=G;var A;(function(B){B[B.Initial=0]="Initial",B[B.DoneOK=1]="DoneOK",B[B.DoneError=2]="DoneError"})(A||(A={}));class T{static fromArray($){return new T(K=>{K.emitMany($)})}static fromPromise($){return new T(async K=>{K.emitMany(await $)})}static fromPromises($){return new T(async K=>{await Promise.all($.map(async re=>K.emitOne(await re)))})}static merge($){return new T(async K=>{await Promise.all($.map(async re=>{for await(const le of re)K.emitOne(le)}))})}static{this.EMPTY=T.fromArray([])}constructor($){this._state=0,this._results=[],this._error=null,this._onStateChanged=new r.Emitter,queueMicrotask(async()=>{const K={emitOne:re=>this.emitOne(re),emitMany:re=>this.emitMany(re),reject:re=>this.reject(re)};try{await Promise.resolve($(K)),this.resolve()}catch(re){this.reject(re)}finally{K.emitOne=void 0,K.emitMany=void 0,K.reject=void 0}})}[Symbol.asyncIterator](){let $=0;return{next:async()=>{do{if(this._state===2)throw this._error;if($<this._results.length)return{done:!1,value:this._results[$++]};if(this._state===1)return{done:!0,value:void 0};await r.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map($,K){return new T(async re=>{for await(const le of $)re.emitOne(K(le))})}map($){return T.map(this,$)}static filter($,K){return new T(async re=>{for await(const le of $)K(le)&&re.emitOne(le)})}filter($){return T.filter(this,$)}static coalesce($){return T.filter($,K=>!!K)}coalesce(){return T.coalesce(this)}static async toPromise($){const K=[];for await(const re of $)K.push(re);return K}toPromise(){return T.toPromise(this)}emitOne($){this._state===0&&(this._results.push($),this._onStateChanged.fire())}emitMany($){this._state===0&&(this._results=this._results.concat($),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject($){this._state===0&&(this._state=2,this._error=$,this._onStateChanged.fire())}}e.AsyncIterableObject=T;class Z extends T{constructor($,K){super(K),this._source=$}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Z;function z(B){const $=new C.CancellationTokenSource,K=B($.token);return new Z($,async re=>{const le=$.token.onCancellationRequested(()=>{le.dispose(),$.dispose(),re.reject(new L.CancellationError)});try{for await(const ge of K){if($.token.isCancellationRequested)return;re.emitOne(ge)}le.dispose(),$.dispose()}catch(ge){le.dispose(),$.dispose(),re.reject(ge)}})}e.createCancelableAsyncIterable=z;class J{constructor(){this._deferred=new q,this._asyncIterable=new T(re=>{if($){re.reject($);return}return K&&re.emitMany(K),this._errorFn=le=>re.reject(le),this._emitFn=le=>re.emitOne(le),this._deferred.p});let $,K;this._emitFn=re=>{K||(K=[]),K.push(re)},this._errorFn=re=>{$||($=re)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject($){this._errorFn($),this._deferred.complete()}emitOne($){this._emitFn($)}}e.AsyncIterableSource=J}),define(oe[105],ae([0,1,22,8,33,31,9,4,25]),function(Q,e,C,L,r,O,M,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function l(){return Object.create(null)}e.getEmptyExpression=l,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const w="[/\\\\]",b="[^/\\\\]",E=/\//g;function u(Y,x){switch(Y){case 0:return"";case 1:return`${b}*?`;default:return`(?:${w}|${b}+${w}${x?`|${w}${b}+`:""})*?`}}function y(Y,x){if(!Y)return[];const W=[];let F=!1,H=!1,q="";for(const ee of Y){switch(ee){case x:if(!F&&!H){W.push(q),q="";continue}break;case"{":F=!0;break;case"}":F=!1;break;case"[":H=!0;break;case"]":H=!1;break}q+=ee}return q&&W.push(q),W}e.splitGlobAware=y;function v(Y){if(!Y)return"";let x="";const W=y(Y,e.GLOB_SPLIT);if(W.every(F=>F===e.GLOBSTAR))x=".*";else{let F=!1;W.forEach((H,q)=>{if(H===e.GLOBSTAR){if(F)return;x+=u(2,q===W.length-1)}else{let ee=!1,de="",G=!1,A="";for(const T of H){if(T!=="}"&&ee){de+=T;continue}if(G&&(T!=="]"||!A)){let Z;T==="-"?Z=T:(T==="^"||T==="!")&&!A?Z="^":T===e.GLOB_SPLIT?Z="":Z=(0,f.escapeRegExpCharacters)(T),A+=Z;continue}switch(T){case"{":ee=!0;continue;case"[":G=!0;continue;case"}":{const z=`(?:${y(de,",").map(J=>v(J)).join("|")})`;x+=z,ee=!1,de="";break}case"]":{x+="["+A+"]",G=!1,A="";break}case"?":x+=b;continue;case"*":x+=u(1);continue;default:x+=(0,f.escapeRegExpCharacters)(T)}}q<W.length-1&&(W[q+1]!==e.GLOBSTAR||q+2<W.length)&&(x+=w)}F=H===e.GLOBSTAR})}return x}const m=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new O.LRUCache(1e4),o=function(){return!1},s=function(){return null};function i(Y,x){if(!Y)return s;let W;typeof Y!="string"?W=Y.pattern:W=Y,W=W.trim();const F=`${W}_${!!x.trimForExclusions}`;let H=t.get(F);if(H)return n(H,Y);let q;return m.test(W)?H=S(W.substr(4),W):(q=g.exec(c(W,x)))?H=R(q[1],W):(x.trimForExclusions?d:h).test(W)?H=k(W,x):(q=p.exec(c(W,x)))?H=P(q[1].substr(1),W,!0):(q=a.exec(c(W,x)))?H=P(q[1],W,!1):H=D(W),t.set(F,H),n(H,Y)}function n(Y,x){if(typeof x=="string")return Y;const W=function(F,H){return(0,r.isEqualOrParent)(F,x.base,!I.isLinux)?Y((0,f.ltrim)(F.substr(x.base.length),M.sep),H):null};return W.allBasenames=Y.allBasenames,W.allPaths=Y.allPaths,W.basenames=Y.basenames,W.patterns=Y.patterns,W}function c(Y,x){return x.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function S(Y,x){return function(W,F){return typeof W=="string"&&W.endsWith(Y)?x:null}}function R(Y,x){const W=`/${Y}`,F=`\\${Y}`,H=function(ee,de){return typeof ee!="string"?null:de?de===Y?x:null:ee===Y||ee.endsWith(W)||ee.endsWith(F)?x:null},q=[Y];return H.basenames=q,H.patterns=[x],H.allBasenames=q,H}function k(Y,x){const W=ue(Y.slice(1,-1).split(",").map(de=>i(de,x)).filter(de=>de!==s),Y),F=W.length;if(!F)return s;if(F===1)return W[0];const H=function(de,G){for(let A=0,T=W.length;A<T;A++)if(W[A](de,G))return Y;return null},q=W.find(de=>!!de.allBasenames);q&&(H.allBasenames=q.allBasenames);const ee=W.reduce((de,G)=>G.allPaths?de.concat(G.allPaths):de,[]);return ee.length&&(H.allPaths=ee),H}function P(Y,x,W){const F=M.sep===M.posix.sep,H=F?Y:Y.replace(E,M.sep),q=M.sep+H,ee=M.posix.sep+Y;let de;return W?de=function(G,A){return typeof G=="string"&&(G===H||G.endsWith(q)||!F&&(G===Y||G.endsWith(ee)))?x:null}:de=function(G,A){return typeof G=="string"&&(G===H||!F&&G===Y)?x:null},de.allPaths=[(W?"*/":"./")+Y],de}function D(Y){try{const x=new RegExp(`^${v(Y)}$`);return function(W){return x.lastIndex=0,typeof W=="string"&&x.test(W)?Y:null}}catch{return s}}function _(Y,x,W){return!Y||typeof x!="string"?!1:N(Y)(x,void 0,W)}e.match=_;function N(Y,x={}){if(!Y)return o;if(typeof Y=="string"||U(Y)){const W=i(Y,x);if(W===s)return o;const F=function(H,q){return!!W(H,q)};return W.allBasenames&&(F.allBasenames=W.allBasenames),W.allPaths&&(F.allPaths=W.allPaths),F}return ce(Y,x)}e.parse=N;function U(Y){const x=Y;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.isRelativePattern=U;function j(Y){return Y.allBasenames||[]}e.getBasenameTerms=j;function V(Y){return Y.allPaths||[]}e.getPathTerms=V;function ce(Y,x){const W=ue(Object.getOwnPropertyNames(Y).map(de=>se(de,Y[de],x)).filter(de=>de!==s)),F=W.length;if(!F)return s;if(!W.some(de=>!!de.requiresSiblings)){if(F===1)return W[0];const de=function(T,Z){let z;for(let J=0,B=W.length;J<B;J++){const $=W[J](T,Z);if(typeof $=="string")return $;(0,L.isThenable)($)&&(z||(z=[]),z.push($))}return z?(async()=>{for(const J of z){const B=await J;if(typeof B=="string")return B}return null})():null},G=W.find(T=>!!T.allBasenames);G&&(de.allBasenames=G.allBasenames);const A=W.reduce((T,Z)=>Z.allPaths?T.concat(Z.allPaths):T,[]);return A.length&&(de.allPaths=A),de}const H=function(de,G,A){let T,Z;for(let z=0,J=W.length;z<J;z++){const B=W[z];B.requiresSiblings&&A&&(G||(G=(0,M.basename)(de)),T||(T=G.substr(0,G.length-(0,M.extname)(de).length)));const $=B(de,G,T,A);if(typeof $=="string")return $;(0,L.isThenable)($)&&(Z||(Z=[]),Z.push($))}return Z?(async()=>{for(const z of Z){const J=await z;if(typeof J=="string")return J}return null})():null},q=W.find(de=>!!de.allBasenames);q&&(H.allBasenames=q.allBasenames);const ee=W.reduce((de,G)=>G.allPaths?de.concat(G.allPaths):de,[]);return ee.length&&(H.allPaths=ee),H}function se(Y,x,W){if(x===!1)return s;const F=i(Y,W);if(F===s)return s;if(typeof x=="boolean")return F;if(x){const H=x.when;if(typeof H=="string"){const q=(ee,de,G,A)=>{if(!A||!F(ee,de))return null;const T=H.replace("$(basename)",()=>G),Z=A(T);return(0,L.isThenable)(Z)?Z.then(z=>z?Y:null):Z?Y:null};return q.requiresSiblings=!0,q}}return F}function ue(Y,x){const W=Y.filter(de=>!!de.basenames);if(W.length<2)return Y;const F=W.reduce((de,G)=>{const A=G.basenames;return A?de.concat(A):de},[]);let H;if(x){H=[];for(let de=0,G=F.length;de<G;de++)H.push(x)}else H=W.reduce((de,G)=>{const A=G.patterns;return A?de.concat(A):de},[]);const q=function(de,G){if(typeof de!="string")return null;if(!G){let T;for(T=de.length;T>0;T--){const Z=de.charCodeAt(T-1);if(Z===47||Z===92)break}G=de.substr(T)}const A=F.indexOf(G);return A!==-1?H[A]:null};q.basenames=F,q.patterns=H,q.allBasenames=F;const ee=Y.filter(de=>!de.basenames);return ee.push(q),ee}function X(Y,x){return(0,C.equals)(Y,x,(W,F)=>typeof W=="string"&&typeof F=="string"?W===F:typeof W!="string"&&typeof F!="string"?W.base===F.base&&W.pattern===F.pattern:!1)}e.patternsEquals=X}),define(oe[47],ae([0,1,22,33,9,4,19,25]),function(Q,e,C,L,r,O,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function f(i,n){const{os:c,tildify:S,relative:R}=n;if(R){const D=l(i,R,c);if(typeof D=="string")return D}let k=i.fsPath;if(c===1&&!O.isWindows?k=k.replace(/\//g,"\\"):c!==1&&O.isWindows&&(k=k.replace(/\\/g,"/")),c!==1&&S?.userHome){const D=S.userHome.fsPath;let _;i.scheme!==S.userHome.scheme&&i.path[0]===r.posix.sep&&i.path[1]!==r.posix.sep?_=S.userHome.with({path:i.path}).fsPath:_=k,k=E(_,D,c)}return(c===1?r.win32:r.posix).normalize(w(k,c===1))}e.getPathLabel=f;function l(i,n,c){const S=c===1?r.win32:r.posix,R=c===3?M.extUri:M.extUriIgnorePathCase,k=n.getWorkspace(),P=(0,C.firstOrDefault)(k.folders);if(!P)return;i.scheme!==P.uri.scheme&&i.path[0]===r.posix.sep&&i.path[1]!==r.posix.sep&&(i=P.uri.with({path:i.path}));const D=n.getWorkspaceFolder(i);if(!D)return;let _;if(R.isEqual(D.uri,i)?_="":_=R.relativePath(D.uri,i)??"",_&&(_=S.normalize(_)),k.folders.length>1&&!n.noPrefix){const N=D.name?D.name:R.basenameOrAuthority(D.uri);_=_?`${N} \u2022 ${_}`:N}return _}function w(i,n=O.isWindows){return(0,L.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=w;let b=Object.create(null);function E(i,n,c=O.OS){if(c===1||!i||!n)return i;let S=b.original===n?b.normalized:void 0;S||(S=n,O.isWindows&&(S=(0,L.toSlashes)(S)),S=`${(0,I.rtrim)(S,r.posix.sep)}${r.posix.sep}`,b={original:n,normalized:S});let R=i;return O.isWindows&&(R=(0,L.toSlashes)(R)),(c===3?R.startsWith(S):(0,I.startsWithIgnoreCase)(R,S))?`~/${R.substr(S.length)}`:i}e.tildify=E;function u(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=u;const y="\u2026",v="\\\\",m="~";function g(i,n=r.sep){const c=new Array(i.length);let S=!1;for(let R=0;R<i.length;R++){const k=i[R];if(k===""){c[R]=`.${n}`;continue}if(!k){c[R]=k;continue}S=!0;let P="",D=k;D.indexOf(v)===0?(P=D.substr(0,D.indexOf(v)+v.length),D=D.substr(D.indexOf(v)+v.length)):D.indexOf(n)===0?(P=D.substr(0,D.indexOf(n)+n.length),D=D.substr(D.indexOf(n)+n.length)):D.indexOf(m)===0&&(P=D.substr(0,D.indexOf(m)+m.length),D=D.substr(D.indexOf(m)+m.length));const _=D.split(n);for(let N=1;S&&N<=_.length;N++)for(let U=_.length-N;S&&U>=0;U--){S=!1;let j=_.slice(U,U+N).join(n);for(let V=0;!S&&V<i.length;V++)if(V!==R&&i[V]&&i[V].indexOf(j)>-1){const ce=U+N===_.length,se=U>0&&i[V].indexOf(n)>-1?n+j:j,ue=i[V].endsWith(se);S=!ce||ue}if(!S){let V="";(_[0].endsWith(":")||P!=="")&&(U===1&&(U=0,N++,j=_[0]+n+j),U>0&&(V=_[0]+n),V=P+V),U>0&&(V=V+y+n),V=V+j,U+N<_.length&&(V=V+n+y),c[R]=V}}S&&(c[R]=k)}return c}e.shorten=g;var h;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function d(i,n=Object.create(null)){const c=[];let S=!1,R="";for(const k of i)if(k==="$"||S&&k==="{")R&&c.push({value:R,type:h.TEXT}),R="",S=!0;else if(k==="}"&&S){const P=n[R];if(typeof P=="string")P.length&&c.push({value:P,type:h.VARIABLE});else if(P){const D=c[c.length-1];(!D||D.type!==h.SEPARATOR)&&c.push({value:P.label,type:h.SEPARATOR})}R="",S=!1}else R+=k;return R&&!S&&c.push({value:R,type:h.TEXT}),c.filter((k,P)=>{if(k.type===h.SEPARATOR){const D=c[P-1],_=c[P+1];return[D,_].every(N=>N&&(N.type===h.VARIABLE||N.type===h.TEXT)&&N.value.length>0)}return!0}).map(k=>k.value).join("")}e.template=d;function p(i,n){return O.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.isMacintosh?"&":"&&"):i.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=p;function a(i,n){return O.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):O.isWindows?i.replace(/&&|&/g,c=>c==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function o(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const c=s(i.substring(0,n)),S=i.substring(n);return{name:c.name+S,parentPath:c.parentPath}}}return s(i)}e.splitRecentLabel=o;function s(i){const n=i.indexOf("/")!==-1?r.posix:r.win32,c=n.basename(i),S=n.dirname(i);return c.length?{name:c,parentPath:S}:{name:S,parentPath:""}}}),define(oe[155],ae([0,1,17,7]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function r(b){return b.toJSON()}class O{constructor(E){this._uriTransformer=E}transformIncoming(E){const u=this._uriTransformer.transformIncoming(E);return u===E?E:r(L.URI.from(u))}transformOutgoing(E){const u=this._uriTransformer.transformOutgoing(E);return u===E?E:r(L.URI.from(u))}transformOutgoingURI(E){const u=this._uriTransformer.transformOutgoing(E);return u===E?E:L.URI.from(u)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=O,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function M(b,E,u){if(!b||u>200)return null;if(typeof b=="object"){if(b instanceof L.URI)return E.transformOutgoing(b);for(const y in b)if(Object.hasOwnProperty.call(b,y)){const v=M(b[y],E,u+1);v!==null&&(b[y]=v)}}return null}function I(b,E){const u=M(b,E,0);return u===null?b:u}e.transformOutgoingURIs=I;function f(b,E,u,y){if(!b||y>200)return null;if(typeof b=="object"){if(b.$mid===1)return u?L.URI.revive(E.transformIncoming(b)):E.transformIncoming(b);if(b instanceof C.VSBuffer)return null;for(const v in b)if(Object.hasOwnProperty.call(b,v)){const m=f(b[v],E,u,y+1);m!==null&&(b[v]=m)}}return null}function l(b,E){const u=f(b,E,!1,0);return u===null?b:u}e.transformIncomingURIs=l;function w(b,E){const u=f(b,E,!0,0);return u===null?b:u}e.transformAndReviveIncomingURIs=w}),define(oe[88],ae([0,1,26,58,32,145,4]),function(Q,e,C,L,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSqmMachineId=e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(E){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(E)}value(){if(this._value===void 0){let E=0,u=0;const y=(0,C.networkInterfaces)();for(const v in y){const m=y[v];if(m)for(const{mac:g,internal:h}of m)h||(u+=1,this._isVirtualMachineMacAddress(g.toUpperCase())&&(E+=1))}this._value=u>0?E/u:0}return this._value}};let I;async function f(E){return I||(I=(async()=>await l(E)||r.generateUuid())()),I}e.getMachineId=f;async function l(E){try{const u=await new Promise((v,m)=>{Q(["crypto"],v,m)}),y=(0,O.getMac)();return u.createHash("sha256").update(y,"utf8").digest("hex")}catch(u){E(u);return}}const w="Software\\Microsoft\\SQMClient";async function b(E){if(M.isWindows){const u=await new Promise((y,v)=>{Q(["@vscode/windows-registry"],y,v)});try{return u.GetStringRegKey("HKEY_LOCAL_MACHINE",w,"MachineId")||""}catch(y){return E(y),""}}return""}e.getSqmMachineId=b}),define(oe[21],ae([0,1,46,26,156,8,33,85,9,4,19,7]),function(Q,e,C,L,r,O,M,I,f,l,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(E||(e.RimRafMode=E={}));async function u(se,ue=E.UNLINK,X){if((0,M.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");return ue===E.UNLINK?v(se):y(se,X)}async function y(se,ue=(0,M.randomPath)((0,L.tmpdir)())){try{try{await C.promises.rename(se,ue)}catch(X){return X.code==="ENOENT"?void 0:v(se)}v(ue).catch(X=>{})}catch(X){if(X.code!=="ENOENT")throw X}}async function v(se){return(0,r.promisify)(C.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function m(se){if((0,M.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");C.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=m;async function g(se,ue){return p(await(ue?h(se):(0,r.promisify)(C.readdir)(se)))}async function h(se){try{return await(0,r.promisify)(C.readdir)(se,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const ue=[],X=await g(se);for(const Y of X){let x=!1,W=!1,F=!1;try{const H=await e.Promises.lstat((0,f.join)(se,Y));x=H.isFile(),W=H.isDirectory(),F=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}ue.push({name:Y,isFile:()=>x,isDirectory:()=>W,isSymbolicLink:()=>F})}return ue}function d(se){return p(C.readdirSync(se))}e.readdirSync=d;function p(se){return se.map(ue=>typeof ue=="string"?l.isMacintosh?(0,I.normalizeNFC)(ue):ue:(ue.name=l.isMacintosh?(0,I.normalizeNFC)(ue.name):ue.name,ue))}async function a(se){const ue=await g(se),X=[];for(const Y of ue)await o.existsDirectory((0,f.join)(se,Y))&&X.push(Y);return X}function t(se,ue=1e3){return new Promise(X=>{let Y=!1;const x=setInterval(()=>{Y||(Y=!0,C.access(se,W=>{Y=!1,W&&(clearInterval(x),X(void 0))}))},ue)})}e.whenDeleted=t;var o;(function(se){async function ue(x){let W;try{if(W=await e.Promises.lstat(x),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(F){if(F.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(l.isWindows&&F.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw H}throw F}}se.stat=ue;async function X(x){try{const{stat:W,symbolicLink:F}=await se.stat(x);return W.isFile()&&F?.dangling!==!0}catch{}return!1}se.existsFile=X;async function Y(x){try{const{stat:W,symbolicLink:F}=await se.stat(x);return W.isDirectory()&&F?.dangling!==!0}catch{}return!1}se.existsDirectory=Y})(o||(e.SymlinkSupport=o={}));const s=new O.ResourceQueue;function i(se,ue,X){return s.queueFor(b.URI.file(se),()=>{const Y=k(X);return new Promise((x,W)=>S(se,ue,Y,F=>F?W(F):x()))},w.extUriBiasedIgnorePathCase)}let n=!0;function c(se){n=se}e.configureFlushOnWrite=c;function S(se,ue,X,Y){if(!n)return C.writeFile(se,ue,{mode:X.mode,flag:X.flag},Y);C.open(se,X.flag,X.mode,(x,W)=>{if(x)return Y(x);C.writeFile(W,ue,F=>{if(F)return C.close(W,()=>Y(F));C.fdatasync(W,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),c(!1)),C.close(W,q=>Y(q))))})})}function R(se,ue,X){const Y=k(X);if(!n)return C.writeFileSync(se,ue,{mode:Y.mode,flag:Y.flag});const x=C.openSync(se,Y.flag,Y.mode);try{C.writeFileSync(x,ue);try{C.fdatasyncSync(x)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),c(!1)}}finally{C.closeSync(x)}}e.writeFileSync=R;function k(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function P(se,ue,X=6e4){if(se!==ue)try{l.isWindows&&typeof X=="number"?await D(se,ue,Date.now(),X):await(0,r.promisify)(C.rename)(se,ue)}catch(Y){if(se.toLowerCase()!==ue.toLowerCase()&&Y.code==="EXDEV"||se.endsWith("."))await _(se,ue,{preserveSymlinks:!1}),await u(se,E.MOVE);else throw Y}}async function D(se,ue,X,Y,x=0){try{return await(0,r.promisify)(C.rename)(se,ue)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-X>=Y)throw console.error(`[node.js fs] rename failed after ${x} retries with error: ${W}`),W;if(x===0){let F=!1;try{const{stat:H}=await o.stat(ue);H.isFile()||(F=!0)}catch{}if(F)throw W}return await(0,O.timeout)(Math.min(100,x*10)),D(se,ue,X,Y,x+1)}}async function _(se,ue,X){return U(se,ue,{root:{source:se,target:ue},options:X,handledSourcePaths:new Set})}const N=511;async function U(se,ue,X){if(X.handledSourcePaths.has(se))return;X.handledSourcePaths.add(se);const{stat:Y,symbolicLink:x}=await o.stat(se);if(x){if(X.options.preserveSymlinks)try{return await ce(se,ue,X)}catch{}if(x.dangling)return}return Y.isDirectory()?j(se,ue,Y.mode&N,X):V(se,ue,Y.mode&N)}async function j(se,ue,X,Y){await e.Promises.mkdir(ue,{recursive:!0,mode:X});const x=await g(se);for(const W of x)await U((0,f.join)(se,W),(0,f.join)(ue,W),Y)}async function V(se,ue,X){await e.Promises.copyFile(se,ue),await e.Promises.chmod(ue,X)}async function ce(se,ue,X){let Y=await e.Promises.readlink(se);(0,M.isEqualOrParent)(Y,X.root.source,!l.isLinux)&&(Y=(0,f.join)(X.root.target,Y.substr(X.root.source.length+1))),await e.Promises.symlink(Y,ue)}e.Promises=new class{get access(){return(0,r.promisify)(C.access)}get stat(){return(0,r.promisify)(C.stat)}get lstat(){return(0,r.promisify)(C.lstat)}get utimes(){return(0,r.promisify)(C.utimes)}get read(){return(se,ue,X,Y,x)=>new Promise((W,F)=>{C.read(se,ue,X,Y,x,(H,q,ee)=>H?F(H):W({bytesRead:q,buffer:ee}))})}get readFile(){return(0,r.promisify)(C.readFile)}get write(){return(se,ue,X,Y,x)=>new Promise((W,F)=>{C.write(se,ue,X,Y,x,(H,q,ee)=>H?F(H):W({bytesWritten:q,buffer:ee}))})}get appendFile(){return(0,r.promisify)(C.appendFile)}get fdatasync(){return(0,r.promisify)(C.fdatasync)}get truncate(){return(0,r.promisify)(C.truncate)}get copyFile(){return(0,r.promisify)(C.copyFile)}get open(){return(0,r.promisify)(C.open)}get close(){return(0,r.promisify)(C.close)}get symlink(){return(0,r.promisify)(C.symlink)}get readlink(){return(0,r.promisify)(C.readlink)}get chmod(){return(0,r.promisify)(C.chmod)}get mkdir(){return(0,r.promisify)(C.mkdir)}get unlink(){return(0,r.promisify)(C.unlink)}get rmdir(){return(0,r.promisify)(C.rmdir)}get realpath(){return(0,r.promisify)(C.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return a}get writeFile(){return i}get rm(){return u}get rename(){return P}get copy(){return _}}}),define(oe[106],ae([0,1,46,9,4,25,21]),function(Q,e,C,L,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(E){if(r.isLinux)return E;const u=(0,L.dirname)(E);if(E===u)return E;const y=((0,L.basename)(E)||E).toLowerCase();try{const m=(0,M.readdirSync)(u).filter(g=>g.toLowerCase()===y);if(m.length===1){const g=I(u);if(g)return(0,L.join)(g,m[0])}else if(m.length>1){const g=m.indexOf(y);if(g>=0){const h=I(u);if(h)return(0,L.join)(h,m[g])}}}catch{}return null}e.realcaseSync=I;async function f(E){if(r.isLinux)return E;const u=(0,L.dirname)(E);if(E===u)return E;const y=((0,L.basename)(E)||E).toLowerCase();try{const m=(await M.Promises.readdir(u)).filter(g=>g.toLowerCase()===y);if(m.length===1){const g=await f(u);if(g)return(0,L.join)(g,m[0])}else if(m.length>1){const g=m.indexOf(y);if(g>=0){const h=await f(u);if(h)return(0,L.join)(h,m[g])}}}catch{}return null}e.realcase=f;async function l(E){try{return await M.Promises.realpath(E)}catch{const y=b(E);return await M.Promises.access(y,C.constants.R_OK),y}}e.realpath=l;function w(E){try{return C.realpathSync(E)}catch{const y=b(E);return C.accessSync(y,C.constants.R_OK),y}}e.realpathSync=w;function b(E){return(0,O.rtrim)((0,L.normalize)(E),L.sep)}}),define(oe[107],ae([0,1,26,9,21]),function(Q,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const O=/^\d+$/,M=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var f;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(f||(f={}));let l;switch(process.arch){case"ia32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let w;process.env.PROCESSOR_ARCHITEW6432?w=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?w=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?w=1:w=0;class b{constructor(a,t,o){this.exePath=a,this.displayName=t,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await r.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function E({useAlternateBitness:p=!1}={}){return p?l===0?process.env["ProgramFiles(x86)"]||null:w===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function u({useAlternateBitness:p=!1,findPreview:a=!1}={}){const t=E({useAlternateBitness:p});if(!t)return null;const o=L.join(t,"PowerShell");if(!await r.SymlinkSupport.existsDirectory(o))return null;let s=-1,i=null;for(const S of await r.Promises.readdir(o)){let R=-1;if(a){const P=S.indexOf("-");if(P<0)continue;const D=S.substring(0,P);if(!O.test(D)||S.substring(P+1)!=="preview")continue;R=parseInt(D,10)}else{if(!O.test(S))continue;R=parseInt(S,10)}if(R<=s)continue;const k=L.join(o,S,"pwsh.exe");await r.SymlinkSupport.existsFile(k)&&(i=k,s=R)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",c=a?" Preview":"";return new b(i,`PowerShell${c}${n}`,!0)}async function y({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const a=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await r.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=p?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const s of await r.Promises.readdir(a))if(t.test(s)){const i=L.join(a,s,"pwsh.exe");return new b(i,o)}return null}function v(){const p=L.join(C.homedir(),".dotnet","tools","pwsh.exe");return new b(p,".NET Core PowerShell Global Tool")}function m(){const p=L.join(process.env.windir,l===1&&w!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(p,"Windows PowerShell",!0)}async function*g(){let p=await u();p&&(yield p),p=await u({useAlternateBitness:!0}),p&&(yield p),p=await y(),p&&(yield p),p=v(),p&&(yield p),p=await u({findPreview:!0}),p&&(yield p),p=await y({findPreview:!0}),p&&(yield p),p=await u({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=m(),p&&(yield p)}async function*h(){for await(const p of g())await p.exists()&&(yield p)}e.enumeratePowerShellInstallations=h;async function d(){for await(const p of h())return p;return null}e.getFirstAvailablePowerShellInstallation=d}),define(oe[89],ae([0,1,9,4,36,76,12,21]),function(Q,e,C,L,r,O,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function f(b=r.env){return b.comspec||"cmd.exe"}e.getWindowsShell=f;function l(b){let E=[],u=!1;const y=function(v){if(u){E.push(v);return}(!b.send(v,g=>{if(g&&console.error(g),u=!1,E.length>0){const h=E.slice(0);E=[],h.forEach(d=>y(d))}})||L.isWindows)&&(u=!0)};return{send:y}}e.createQueuedSender=l;var w;(function(b){async function E(u,y,v){if(C.isAbsolute(u))return u;if(y===void 0&&(y=r.cwd()),C.dirname(u)!=="."||(v===void 0&&M.isString(r.env.PATH)&&(v=r.env.PATH.split(C.delimiter)),v===void 0||v.length===0))return C.join(y,u);async function g(h){if(await I.Promises.exists(h)){let d;try{d=await I.Promises.stat(h)}catch(p){p.message.startsWith("EACCES")&&(d=await I.Promises.lstat(h))}return d?!d.isDirectory():!1}return!1}for(const h of v){let d;if(C.isAbsolute(h)?d=C.join(h,u):d=C.join(y,h,u),await g(d))return d;let p=d+".com";if(await g(p)||(p=d+".exe",await g(p)))return p}return C.join(y,u)}b.findExecutable=E})(w||(e.win32=w={}))}),define(oe[108],ae([0,1,48,13]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function r(M){return new Promise((I,f)=>{let l;const w=new Map;function b(u,y,v,m,g){const h=w.get(y);if(u===M||h){const d={name:E(v),cmd:v,pid:u,ppid:y,load:m,mem:g};w.set(u,d),u===M&&(l=d),h&&(h.children||(h.children=[]),h.children.push(d),h.children.length>1&&(h.children=h.children.sort((p,a)=>p.pid-a.pid)))}}function E(u){const y=/--utility-sub-type=network/i,v=/--crashes-directory/i,m=/\\pipe\\winpty-control/i,g=/conhost\.exe.+--headless/i,h=/--type=([a-zA-Z-]+)/;if(v.exec(u))return"electron-crash-reporter";if(m.exec(u))return"winpty-agent";if(g.exec(u))return"conpty-agent";let d=h.exec(u);if(d&&d.length===2)return d[1]==="renderer"?"window":d[1]==="utility"?y.exec(u)?"utility-network-service":"utility-process":d[1]==="extensionHost"?"extension-host":d[1];const p=/[a-zA-Z-]+\.js/g;let a="";do d=p.exec(u),d&&(a+=d+" ");while(d);return a&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron-nodejs (${a})`:u}if(process.platform==="win32"){const u=y=>y.indexOf("\\\\?\\")===0||y.indexOf("\\??\\")===0?y.substring(4):y.indexOf('"\\\\?\\')===0||y.indexOf('"\\??\\')===0?'"'+y.substring(5):y;new Promise((y,v)=>{Q(["@vscode/windows-process-tree"],y,v)}).then(y=>{y.getProcessList(M,v=>{if(!v){f(new Error(`Root process ${M} not found`));return}y.getProcessCpuUsage(v,m=>{const g=new Map;m.forEach(h=>{const d=u(h.commandLine||"");g.set(h.pid,{name:E(d),cmd:d,pid:h.pid,ppid:h.ppid,load:h.cpu||0,mem:h.memory||0})}),l=g.get(M),l?(g.forEach(h=>{const d=g.get(h.ppid);d&&(d.children||(d.children=[]),d.children.push(h))}),g.forEach(h=>{h.children&&(h.children=h.children.sort((d,p)=>d.pid-p.pid))}),I(l)):f(new Error(`Root process ${M} not found`))})},y.ProcessDataFlag.CommandLine|y.ProcessDataFlag.Memory)})}else{let u=function(){let y=[l];const v=[];for(;y.length;){const g=y.shift();g&&(v.push(g.pid),g.children&&(y=y.concat(g.children)))}let m=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);m+=" "+v.join(" "),(0,C.exec)(m,{},(g,h,d)=>{if(g||d)f(g||new Error(d.toString()));else{const p=h.toString().split(`
`);for(let a=0;a<v.length;a++){const t=w.get(v[a]);t.load=parseFloat(p[a])}if(!l){f(new Error(`Root process ${M} not found`));return}I(l)}})};(0,C.exec)("which ps",{},(y,v,m)=>{if(y||m)if(process.platform!=="linux")f(y||new Error(m.toString()));else{const g=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,C.exec)(g,{},(h,d,p)=>{h||p?f(h||new Error(p.toString())):(O(d,b),u())})}else{const g=v.toString().trim(),h="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,C.exec)(`${g} ${h}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,p,a)=>{d||a&&!a.includes("screen size is bogus")?f(d||new Error(a.toString())):(O(p,b),process.platform==="linux"?u():l?I(l):f(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=r;function O(M,I){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,l=M.toString().split(`
`);for(const w of l){const b=f.exec(w.trim());b&&b.length===6&&I(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(oe[109],ae([0,1,26,4,107,89]),function(Q,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function M(b,E){return b===1?L.isWindows?w():O.getWindowsShell(E):f(b,E)}e.getSystemShell=M;let I=null;function f(b,E){if(L.isLinux&&b===2||L.isMacintosh&&b===3)return"/bin/bash";if(!I){let u;if(L.isWindows)u="/bin/bash";else{if(u=E.SHELL,!u)try{u=(0,C.userInfo)().shell}catch{}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}I=u}return I}let l=null;async function w(){return l||(l=(await(0,r.getFirstAvailablePowerShellInstallation)()).exePath),l}});var be=this&&this.__decorate||function(Q,e,C,L){var r=arguments.length,O=r<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,C):L,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(Q,e,C,L);else for(var I=Q.length-1;I>=0;I--)(M=Q[I])&&(O=(r<3?M(O):r>3?M(e,C,O):M(e,C))||O);return r>3&&O&&Object.defineProperty(e,C,O),O};define(oe[43],ae([0,1,22,8,17,23,50,14,3,2,77,25,12]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var u;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(u||(u={}));function y(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(v||(v={}));function m(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(g||(g={}));function h(x){let W=0;for(let F=0;;F+=7){const H=x.read(1);if(W|=(H.buffer[0]&127)<<F,!(H.buffer[0]&128))return W}}const d=s(0);function p(x,W){if(W===0){x.write(d);return}let F=0;for(let q=W;q!==0;q=q>>>7)F++;const H=r.VSBuffer.alloc(F);for(let q=0;W!==0;q++)H.buffer[q]=W&127,W=W>>>7,W>0&&(H.buffer[q]|=128);x.write(H)}class a{constructor(W){this.buffer=W,this.pos=0}read(W){const F=this.buffer.slice(this.pos,this.pos+W);return this.pos+=F.byteLength,F}}e.BufferReader=a;class t{constructor(){this.buffers=[]}get buffer(){return r.VSBuffer.concat(this.buffers)}write(W){this.buffers.push(W)}}e.BufferWriter=t;var o;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(o||(o={}));function s(x){const W=r.VSBuffer.alloc(1);return W.writeUInt8(x,0),W}const i={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object),Uint:s(o.Int)},n=typeof Buffer<"u";function c(x,W){if(typeof W>"u")x.write(i.Undefined);else if(typeof W=="string"){const F=r.VSBuffer.fromString(W);x.write(i.String),p(x,F.byteLength),x.write(F)}else if(n&&Buffer.isBuffer(W)){const F=r.VSBuffer.wrap(W);x.write(i.Buffer),p(x,F.byteLength),x.write(F)}else if(W instanceof r.VSBuffer)x.write(i.VSBuffer),p(x,W.byteLength),x.write(W);else if(Array.isArray(W)){x.write(i.Array),p(x,W.length);for(const F of W)c(x,F)}else if(typeof W=="number"&&(W|0)===W)x.write(i.Uint),p(x,W);else{const F=r.VSBuffer.fromString(JSON.stringify(W));x.write(i.Object),p(x,F.byteLength),x.write(F)}}e.serialize=c;function S(x){switch(x.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return x.read(h(x)).toString();case o.Buffer:return x.read(h(x)).buffer;case o.VSBuffer:return x.read(h(x));case o.Array:{const F=h(x),H=[];for(let q=0;q<F;q++)H.push(S(x));return H}case o.Object:return JSON.parse(x.read(h(x)).toString());case o.Int:return h(x)}}e.deserialize=S;class R{constructor(W,F,H=null,q=1e3){this.protocol=W,this.ctx=F,this.logger=H,this.timeoutDelay=q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ee=>this.onRawMessage(ee)),this.sendResponse({type:200})}registerChannel(W,F){this.channels.set(W,F),setTimeout(()=>this.flushPendingRequests(W),0)}sendResponse(W){switch(W.type){case 200:{const F=this.send([W.type]);this.logger?.logOutgoing(F,0,1,m(W.type));return}case 201:case 202:case 204:case 203:{const F=this.send([W.type,W.id],W.data);this.logger?.logOutgoing(F,W.id,1,m(W.type),W.data);return}}}send(W,F=void 0){const H=new t;return c(H,W),c(H,F),this.sendBuffer(H.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onRawMessage(W){const F=new a(W),H=S(F),q=S(F),ee=H[0];switch(ee){case 100:return this.logger?.logIncoming(W.byteLength,H[1],1,`${y(ee)}: ${H[2]}.${H[3]}`,q),this.onPromise({type:ee,id:H[1],channelName:H[2],name:H[3],arg:q});case 102:return this.logger?.logIncoming(W.byteLength,H[1],1,`${y(ee)}: ${H[2]}.${H[3]}`,q),this.onEventListen({type:ee,id:H[1],channelName:H[2],name:H[3],arg:q});case 101:return this.logger?.logIncoming(W.byteLength,H[1],1,`${y(ee)}`),this.disposeActiveRequest({type:ee,id:H[1]});case 103:return this.logger?.logIncoming(W.byteLength,H[1],1,`${y(ee)}`),this.disposeActiveRequest({type:ee,id:H[1]})}}onPromise(W){const F=this.channels.get(W.channelName);if(!F){this.collectPendingRequest(W);return}const H=new O.CancellationTokenSource;let q;try{q=F.call(this.ctx,W.name,W.arg,H.token)}catch(G){q=Promise.reject(G)}const ee=W.id;q.then(G=>{this.sendResponse({id:ee,data:G,type:201})},G=>{G instanceof Error?this.sendResponse({id:ee,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.sendResponse({id:ee,data:G,type:203})}).finally(()=>{de.dispose(),this.activeRequests.delete(W.id)});const de=(0,l.toDisposable)(()=>H.cancel());this.activeRequests.set(W.id,de)}onEventListen(W){const F=this.channels.get(W.channelName);if(!F){this.collectPendingRequest(W);return}const H=W.id,ee=F.listen(this.ctx,W.name,W.arg)(de=>this.sendResponse({id:H,data:de,type:204}));this.activeRequests.set(W.id,ee)}disposeActiveRequest(W){const F=this.activeRequests.get(W.id);F&&(F.dispose(),this.activeRequests.delete(W.id))}collectPendingRequest(W){let F=this.pendingRequests.get(W.channelName);F||(F=[],this.pendingRequests.set(W.channelName,F));const H=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.sendResponse({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);F.push({request:W,timeoutTimer:H})}flushPendingRequests(W){const F=this.pendingRequests.get(W);if(F){for(const H of F)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(W)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=R;var k;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(k||(e.RequestInitiator=k={}));class P{constructor(W,F=null){this.protocol=W,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=F}getChannel(W){const F=this;return{call(H,q,ee){return F.isDisposed?Promise.reject(new I.CancellationError):F.requestPromise(W,H,q,ee)},listen(H,q){return F.isDisposed?f.Event.None:F.requestEvent(W,H,q)}}}requestPromise(W,F,H,q=O.CancellationToken.None){const ee=this.lastRequestId++,G={id:ee,type:100,channelName:W,name:F,arg:H};if(q.isCancellationRequested)return Promise.reject(new I.CancellationError);let A;return new Promise((Z,z)=>{if(q.isCancellationRequested)return z(new I.CancellationError);const J=()=>{const re=le=>{switch(le.type){case 201:this.handlers.delete(ee),Z(le.data);break;case 202:{this.handlers.delete(ee);const ge=new Error(le.data.message);ge.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,ge.name=le.data.name,z(ge);break}case 203:this.handlers.delete(ee),z(le.data);break}};this.handlers.set(ee,re),this.sendRequest(G)};let B=null;this.state===g.Idle?J():(B=(0,L.createCancelablePromise)(re=>this.whenInitialized()),B.then(()=>{B=null,J()}));const $=()=>{B?(B.cancel(),B=null):this.sendRequest({id:ee,type:101}),z(new I.CancellationError)},K=q.onCancellationRequested($);A=(0,l.combinedDisposable)((0,l.toDisposable)($),K),this.activeRequests.add(A)}).finally(()=>{A.dispose(),this.activeRequests.delete(A)})}requestEvent(W,F,H){const q=this.lastRequestId++,de={id:q,type:102,channelName:W,name:F,arg:H};let G=null;const A=new f.Emitter({onWillAddFirstListener:()=>{G=(0,L.createCancelablePromise)(Z=>this.whenInitialized()),G.then(()=>{G=null,this.activeRequests.add(A),this.sendRequest(de)})},onDidRemoveLastListener:()=>{G?(G.cancel(),G=null):(this.activeRequests.delete(A),this.sendRequest({id:q,type:103}))}}),T=Z=>A.fire(Z.data);return this.handlers.set(q,T),A.event}sendRequest(W){switch(W.type){case 100:case 102:{const F=this.send([W.type,W.id,W.channelName,W.name],W.arg);this.logger?.logOutgoing(F,W.id,0,`${y(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const F=this.send([W.type,W.id]);this.logger?.logOutgoing(F,W.id,0,y(W.type));return}}}send(W,F=void 0){const H=new t;return c(H,W),c(H,F),this.sendBuffer(H.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onBuffer(W){const F=new a(W),H=S(F),q=S(F),ee=H[0];switch(ee){case 200:return this.logger?.logIncoming(W.byteLength,0,0,m(ee)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(W.byteLength,H[1],0,m(ee),q),this.onResponse({type:H[0],id:H[1],data:q})}}onResponse(W){if(W.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}this.handlers.get(W.id)?.(W)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=P,be([M.memoize],P.prototype,"onDidInitializePromise",null);class D{get connections(){const W=[];return this._connections.forEach(F=>W.push(F)),W}constructor(W){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new l.DisposableStore,this.disposables.add(W(({protocol:F,onDidClientDisconnect:H})=>{const q=f.Event.once(F.onMessage);this.disposables.add(q(ee=>{const de=new a(ee),G=S(de),A=new R(F,G),T=new P(F);this.channels.forEach((z,J)=>A.registerChannel(J,z));const Z={channelServer:A,channelClient:T,ctx:G};this._connections.add(Z),this._onDidAddConnection.fire(Z),this.disposables.add(H(()=>{A.dispose(),T.dispose(),this._connections.delete(Z),this._onDidRemoveConnection.fire(Z)}))}))}))}getChannel(W,F){const H=this;return{call(q,ee,de){let G;if((0,E.isFunction)(F)){const T=(0,C.getRandomElement)(H.connections.filter(F));G=T?Promise.resolve(T):f.Event.toPromise(f.Event.filter(H.onDidAddConnection,F))}else G=F.routeCall(H,q,ee);const A=G.then(T=>T.channelClient.getChannel(W));return N(A).call(q,ee,de)},listen(q,ee){if((0,E.isFunction)(F))return H.getMulticastEvent(W,F,q,ee);const de=F.routeEvent(H,q,ee).then(G=>G.channelClient.getChannel(W));return N(de).listen(q,ee)}}}getMulticastEvent(W,F,H,q){const ee=this;let de;const G=new f.Emitter({onWillAddFirstListener:()=>{de=new l.DisposableStore;const A=new f.EventMultiplexer,T=new Map,Z=J=>{const $=J.channelClient.getChannel(W).listen(H,q),K=A.add($);T.set(J,K)},z=J=>{const B=T.get(J);B&&(B.dispose(),T.delete(J))};ee.connections.filter(F).forEach(Z),f.Event.filter(ee.onDidAddConnection,F)(Z,void 0,de),ee.onDidRemoveConnection(z,void 0,de),A.event(G.fire,G,de),de.add(A)},onDidRemoveLastListener:()=>{de?.dispose(),de=void 0}});return G.event}registerChannel(W,F){this.channels.set(W,F);for(const H of this._connections)H.channelServer.registerChannel(W,F)}dispose(){this.disposables.dispose();for(const W of this._connections)W.channelClient.dispose(),W.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=D;class _{constructor(W,F,H=null){const q=new t;c(q,F),W.send(q.buffer),this.channelClient=new P(W,H),this.channelServer=new R(W,F,H)}getChannel(W){return this.channelClient.getChannel(W)}registerChannel(W,F){this.channelServer.registerChannel(W,F)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function N(x){return{call(W,F,H){return x.then(q=>q.call(W,F,H))},listen(W,F){const H=new f.Relay;return x.then(q=>H.input=q.listen(W,F)),H.event}}}e.getDelayedChannel=N;function U(x){let W=!1;return{call(F,H,q){return W?x.call(F,H,q):(0,L.timeout)(0).then(()=>W=!0).then(()=>x.call(F,H,q))},listen(F,H){if(W)return x.listen(F,H);const q=new f.Relay;return(0,L.timeout)(0).then(()=>W=!0).then(()=>q.input=x.listen(F,H)),q.event}}}e.getNextTickChannel=U;class j{constructor(W){this.fn=W}routeCall(W){return this.route(W)}routeEvent(W){return this.route(W)}async route(W){for(const F of W.connections)if(await Promise.resolve(this.fn(F.ctx)))return Promise.resolve(F);return await f.Event.toPromise(W.onDidAddConnection),await this.route(W)}}e.StaticRouter=j;var V;(function(x){function W(ee,de,G){const A=ee,T=G&&G.disableMarshalling,Z=new Map;for(const z in A)H(z)&&Z.set(z,f.Event.buffer(A[z],!0,void 0,de));return new class{listen(z,J,B){const $=Z.get(J);if($)return $;if(q(J)){const K=A[J];if(typeof K=="function")return K.call(A,B)}throw new I.ErrorNoTelemetry(`Event not found: ${J}`)}call(z,J,B){const $=A[J];if(typeof $=="function"){if(!T&&Array.isArray(B))for(let re=0;re<B.length;re++)B[re]=(0,w.revive)(B[re]);let K=$.apply(A,B);return K instanceof Promise||(K=Promise.resolve(K)),K}throw new I.ErrorNoTelemetry(`Method not found: ${J}`)}}}x.fromService=W;function F(ee,de){const G=de&&de.disableMarshalling;return new Proxy({},{get(A,T){if(typeof T=="string")return de?.properties?.has(T)?de.properties.get(T):q(T)?function(Z){return ee.listen(T,Z)}:H(T)?ee.listen(T):async function(...Z){let z;de&&!(0,E.isUndefinedOrNull)(de.context)?z=[de.context,...Z]:z=Z;const J=await ee.call(T,z);return G?J:(0,w.revive)(J)};throw new I.ErrorNoTelemetry(`Property not found: ${String(T)}`)}})}x.toService=F;function H(ee){return ee[0]==="o"&&ee[1]==="n"&&b.isUpperAsciiLetter(ee.charCodeAt(2))}function q(ee){return/^onDynamic/.test(ee)&&b.isUpperAsciiLetter(ee.charCodeAt(9))}})(V||(e.ProxyChannel=V={}));const ce=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const W=x.toString();if(W!=="[object Object]")return W}return x}function ue(x){return Array.isArray(x)?x.map(se):se(x)}function X(x,W,F,H,q,ee,de){de=ue(de);const G=ce[q],A=G[H%G.length];let T=[`%c[${x}]%c[${String(W).padStart(7," ")}]%c[len: ${String(F).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${A}`];/\($/.test(ee)?(T=T.concat(de),T.push(")")):T.push(de),console.log.apply(console,T)}class Y{constructor(W,F){this._outgoingPrefix=W,this._incomingPrefix=F,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(W,F,H,q,ee){this._totalOutgoing+=W,X(this._outgoingPrefix,this._totalOutgoing,W,F,H,q,ee)}logIncoming(W,F,H,q,ee){this._totalIncoming+=W,X(this._incomingPrefix,this._totalIncoming,W,F,H,q,ee)}}e.IPCLogger=Y}),define(oe[157],ae([0,1,17,3,43]),function(Q,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class O{constructor(f){this.port=f,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",l=>l.data?C.VSBuffer.wrap(l.data):C.VSBuffer.alloc(0)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}e.Protocol=O;class M extends r.IPCClient{constructor(f,l){const w=new O(f);super(w,l),this.protocol=w}dispose(){this.protocol.disconnect(),super.dispose()}}e.Client=M}),define(oe[110],ae([0,1,17,3,2,43]),function(Q,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(M||(e.SocketDiagnosticsEventType=M={}));var I;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let c=0;function S(k,P){if(!n.has(k)){const D=String(++c);n.set(k,D)}return n.get(k)}function R(k,P,D,_){if(!i.enableDiagnostics)return;const N=S(k,P);if(_ instanceof C.VSBuffer||_ instanceof Uint8Array||_ instanceof ArrayBuffer||ArrayBuffer.isView(_)){const U=C.VSBuffer.alloc(_.byteLength);U.set(_),i.records.push({timestamp:Date.now(),id:N,label:P,type:D,buff:U})}else i.records.push({timestamp:Date.now(),id:N,label:P,type:D,data:_})}i.traceSocketEvent=R})(I||(e.SocketDiagnostics=I={}));var f;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f||(e.SocketCloseEventType=f={}));let l=null;function w(){return l||(l=C.VSBuffer.alloc(0)),l}class b{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,c){if(n===0)return w();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const P=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=n),P}if(this._chunks[0].byteLength>n){const P=this._chunks[0].slice(0,n);return c&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),P}const S=C.VSBuffer.alloc(n);let R=0,k=0;for(;n>0;){const P=this._chunks[k];if(P.byteLength>n){const D=P.slice(0,n);S.set(D,R),R+=n,c&&(this._chunks[k]=P.slice(n),this._totalLength-=n),n-=n}else S.set(P,R),R+=P.byteLength,c?(this._chunks.shift(),this._totalLength-=P.byteLength):k++,n-=P.byteLength}return S}}e.ChunkStream=b;var E;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(E||(E={}));function u(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var y;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(y||(e.ProtocolConstants=y={}));class v{constructor(n,c,S,R){this.type=n,this.id=c,this.ack=S,this.data=R,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends r.Disposable{constructor(n){super(),this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:u(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const S=this._state.messageType,R=this._state.id,k=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",c),this._onMessage.fire(new v(S,R,k,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(n){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=C.VSBuffer.alloc(13);c.writeUInt8(n.type,0),c.writeUInt32BE(n.id,1),c.writeUInt32BE(n.ack,5),c.writeUInt32BE(n.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:u(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",n.data),this._writeSoon(c,n.data)}_bufferAdd(n,c){const S=this._totalLength===0;return this._data.push(n,c),this._totalLength+=n.byteLength+c.byteLength,S}_bufferTake(){const n=C.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,c){this._bufferAdd(n,c)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const n=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this._socket.write(n)}}class h extends r.Disposable{constructor(n){super(),this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new m(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new v(1,0,0,n))}}e.Protocol=h;class d extends O.IPCClient{static fromSocket(n,c){return new d(new h(n),c)}get onDidDispose(){return this.protocol.onDidDispose}constructor(n,c,S=null){super(n,c,S),this.protocol=n}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=d;class p{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=p;class a{constructor(n){this.data=n,this.next=null}}class t{constructor(){this._first=null,this._last=null}length(){let n=0,c=this._first;for(;c;)c=c.next,n++;return n}peek(){return this._first?this._first.data:null}toArray(){const n=[];let c=0,S=this._first;for(;S;)n[c++]=S.data,S=S.next;return n}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const c=new a(n);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class o{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}constructor(){this.lastRuns=[];const n=Date.now();for(let c=0;c<o._HISTORY_LENGTH;c++)this.lastRuns[c]=n-1e3*c;setInterval(()=>{for(let c=o._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}load(){const n=Date.now(),c=(1+o._HISTORY_LENGTH)*1e3;let S=0;for(let R=0;R<o._HISTORY_LENGTH;R++)n-this.lastRuns[R]<=c&&S++;return 1-S/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class s{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(n){this._onControlMessage=new p,this.onControlMessage=this._onControlMessage.event,this._onMessage=new p,this.onMessage=this._onMessage.event,this._onDidDispose=new p,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new p,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new p,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=n.loadEstimator??o.getInstance(),this._shouldSendKeepAlive=n.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new r.DisposableStore,this._socket=n.socket,this._socketWriter=this._socketDisposables.add(new g(this._socket)),this._socketReader=this._socketDisposables.add(new m(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.add(this._socket.onClose(c=>this._onSocketClose.fire(c))),n.initialChunk&&this._socketReader.acceptChunk(n.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new v(5,0,0,w());this._socketWriter.write(n),this._socketWriter.flush()}sendPause(){const n=new v(7,0,0,w());this._socketWriter.write(n)}sendResume(){const n=new v(8,0,0,w());this._socketWriter.write(n)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,c){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new r.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=n,this._socketWriter=this._socketDisposables.add(new g(this._socket)),this._socketReader=this._socketDisposables.add(new m(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(S=>this._receiveMessage(S))),this._socketDisposables.add(this._socket.onClose(S=>this._onSocketClose.fire(S))),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const n=new v(3,0,this._incomingAckId,w());this._socketWriter.write(n);const c=this._outgoingUnackMsg.toArray();for(let S=0,R=c.length;S<R;S++)this._socketWriter.write(c[S]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new v(6,0,0,w())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data);break}case 2:{this._onControlMessage.fire(n.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const c=this._outgoingUnackMsg.toArray();for(let S=0,R=c.length;S<R;S++)this._socketWriter.write(c[S]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const S=new v(1,c,this._incomingAckId,n);this._outgoingUnackMsg.push(S),this._isReconnecting||(this._socketWriter.write(S),this._recvAckCheck())}sendControl(n){const c=new v(2,0,0,n);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const n=this._outgoingUnackMsg.peek(),c=Date.now()-n.writtenTime,S=Date.now()-this._socketReader.lastReadTime,R=Date.now()-this._lastSocketTimeoutTime;if(c>=2e4&&S>=2e4&&R>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:S});return}const k=Math.max(2e4-c,2e4-S,2e4-R,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},k)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new v(3,0,this._incomingAckId,w());this._socketWriter.write(n)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const n=new v(9,0,this._incomingAckId,w());this._socketWriter.write(n)}}e.PersistentProtocol=s}),define(oe[37],ae([0,1,15,14,13]),function(Q,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class O{constructor(){this.mapListenerToWrapper=new WeakMap}on(I,f){const l=(w,...b)=>{this.validateEvent(I,w)&&f(w,...b)};return this.mapListenerToWrapper.set(f,l),C.ipcMain.on(I,l),this}once(I,f){return C.ipcMain.once(I,(l,...w)=>{this.validateEvent(I,l)&&f(l,...w)}),this}handle(I,f){return C.ipcMain.handle(I,(l,...w)=>this.validateEvent(I,l)?f(l,...w):Promise.reject(`Invalid channel '${I}' or sender for ipcMain.handle() usage.`)),this}removeHandler(I){return C.ipcMain.removeHandler(I),this}removeListener(I,f){const l=this.mapListenerToWrapper.get(f);return l&&(C.ipcMain.removeListener(I,l),this.mapListenerToWrapper.delete(f)),this}validateEvent(I,f){if(!I||!I.startsWith("vscode:"))return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${I}' because the channel is unknown.`),!1;const l=f.senderFrame,w=l.url;if(!w||w==="about:blank")return!0;let b="unknown";try{b=new URL(w).host}catch{return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${I}' because of a malformed URL '${w}'.`),!1}return b!==r.VSCODE_AUTHORITY?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${I}' because of a bad origin of '${b}'.`),!1):l.parent!==null?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${I}' because sender of origin '${b}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new O}),define(oe[158],ae([0,1,15,37,146]),function(Q,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function O(){L.validatedIpcMain.on(r.CONTEXT_MENU_CHANNEL,(I,f,l,w,b)=>{const E=M(I,w,l);E.popup({x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{E&&I.sender.send(r.CONTEXT_MENU_CLOSE_CHANNEL,f)}})})}e.registerContextMenuListener=O;function M(I,f,l){const w=new C.Menu;return l.forEach(b=>{let E;b.type==="separator"?E=new C.MenuItem({type:b.type}):Array.isArray(b.submenu)?E=new C.MenuItem({submenu:M(I,f,b.submenu),label:b.label}):E=new C.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(u,y,v)=>I.sender.send(f,b.id,v)}),w.append(E)}),w}}),define(oe[159],ae([0,1,37,17,3,2,43,147]),function(Q,e,C,L,r,O,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(w,b){const E=r.Event.fromNodeEventEmitter(C.validatedIpcMain,b,(y,v)=>({event:y,message:v})),u=r.Event.filter(E,({event:y})=>y.sender.id===w);return r.Event.map(u,({message:y})=>y&&L.VSBuffer.wrap(y))}class l extends M.IPCServer{static{this.Clients=new Map}static getOnDidClientConnect(){const b=r.Event.fromNodeEventEmitter(C.validatedIpcMain,"vscode:hello",({sender:E})=>E);return r.Event.map(b,E=>{const u=E.id;l.Clients.get(u)?.dispose();const v=new r.Emitter;l.Clients.set(u,(0,O.toDisposable)(()=>v.fire()));const m=f(u,"vscode:message"),g=r.Event.any(r.Event.signal(f(u,"vscode:disconnect")),v.event);return{protocol:new I.Protocol(E,m),onDidClientDisconnect:g}})}constructor(){super(l.getOnDidClientConnect())}}e.Server=l}),define(oe[111],ae([0,1,37,3,32,157]),function(Q,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends O.Client{constructor(l,w){super({addEventListener:(b,E)=>l.addListener(b,E),removeEventListener:(b,E)=>l.removeListener(b,E),postMessage:b=>l.postMessage(b),start:()=>l.start(),close:()=>l.close()},w)}}e.Client=M;async function I(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const l=(0,r.generateUuid)();f.webContents.send("vscode:createMessageChannel",l);const w=L.Event.fromNodeEventEmitter(C.validatedIpcMain,"vscode:createMessageChannelResult",(E,u)=>({nonce:u,port:E.ports[0]})),{port:b}=await L.Event.toPromise(L.Event.once(L.Event.filter(w,E=>E.nonce===l)));return b}e.connect=I}),define(oe[160],ae([0,1,48,8,17,23,154,14,3,2,35,89,76,43]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class y extends u.ChannelServer{constructor(g){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",h=>r.VSBuffer.wrap(Buffer.from(h,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.Server=y;class v{constructor(g,h){this.modulePath=g,this.options=h,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const d=h&&h.timeout?h.timeout:6e4;this.disposeDelayer=new L.Delayer(d),this.child=null,this._client=null}getChannel(g){const h=this;return{call(d,p,a){return h.requestPromise(g,d,p,a)},listen(d,p){return h.requestEvent(g,d,p)}}}requestPromise(g,h,d,p=O.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(g),t=(0,L.createCancelablePromise)(i=>a.call(h,d,i)),o=p.onCancellationRequested(()=>t.cancel()),s=(0,l.toDisposable)(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{o.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(g,h,d){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let p;const a=new f.Emitter({onWillAddFirstListener:()=>{p=this.getCachedChannel(g).listen(h,d)(a.fire,a),this.activeRequests.add(p)},onDidRemoveLastListener:()=>{this.activeRequests.delete(p),p.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const g=this.options&&this.options.args?this.options.args:[],h=Object.create(null);h.env={...(0,w.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(h.env={...h.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(h.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,E.removeDangerousEnvVariables)(h.env),this.child=(0,C.fork)(this.modulePath,g,h);const d=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,M.isRemoteConsoleLog)(n)){(0,M.log)(n,`IPC Library: ${this.options.serverName}`);return}d.fire(r.VSBuffer.wrap(Buffer.from(n,"base64")))});const a=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,t=n=>this.child&&this.child.connected&&a.send(n.buffer.toString("base64")),o=d.event,s={send:t,onMessage:o};this._client=new u.ChannelClient(s);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,c)=>{process.removeListener("exit",i),this.activeRequests.forEach(S=>(0,l.dispose)(S)),this.activeRequests.clear(),n!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+c),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:c})})}return this._client}getCachedChannel(g){let h=this.channels.get(g);return h||(h=this.client.getChannel(g),this.channels.set(g,h)),h}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=v}),define(oe[112],ae([0,1,8,3,2,77,12]),function(Q,e,C,L,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var I;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",E[E.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function f(E){const u=E;return u?.changed instanceof Map||u?.deleted instanceof Set}e.isStorageItemsChangeEvent=f;var l;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(l||(e.StorageState=l={}));class w extends r.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(u,y=Object.create(null)){super(),this.database=u,this.options=y,this._onDidChangeStorage=this._register(new L.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=this._register(new C.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(u=>this.onDidChangeItemsExternal(u)))}onDidChangeItemsExternal(u){this._onDidChangeStorage.pause();try{u.changed?.forEach((y,v)=>this.acceptExternal(v,y)),u.deleted?.forEach(y=>this.acceptExternal(y,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(u,y){if(this.state===l.Closed)return;let v=!1;(0,M.isUndefinedOrNull)(y)?v=this.cache.delete(u):this.cache.get(u)!==y&&(this.cache.set(u,y),v=!0),v&&this._onDidChangeStorage.fire({key:u,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(u,y){const v=this.cache.get(u);return(0,M.isUndefinedOrNull)(v)?y:v}getBoolean(u,y){const v=this.get(u);return(0,M.isUndefinedOrNull)(v)?y:v==="true"}getNumber(u,y){const v=this.get(u);return(0,M.isUndefinedOrNull)(v)?y:parseInt(v,10)}getObject(u,y){const v=this.get(u);return(0,M.isUndefinedOrNull)(v)?y:(0,O.parse)(v)}async set(u,y,v=!1){if(this.state===l.Closed)return;if((0,M.isUndefinedOrNull)(y))return this.delete(u,v);const m=(0,M.isObject)(y)||Array.isArray(y)?(0,O.stringify)(y):String(y);if(this.cache.get(u)!==m)return this.cache.set(u,m),this.pendingInserts.set(u,m),this.pendingDeletes.delete(u),this._onDidChangeStorage.fire({key:u,external:v}),this.doFlush()}async delete(u,y=!1){if(!(this.state===l.Closed||!this.cache.delete(u)))return this.pendingDeletes.has(u)||this.pendingDeletes.add(u),this.pendingInserts.delete(u),this._onDidChangeStorage.fire({key:u,external:y}),this.doFlush()}async optimize(){if(this.state!==l.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const u={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(u).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(u){if(this.hasPending)return this.doFlush(u)}async doFlush(u){return this.options.hint===I.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),u)}async whenFlushed(){if(this.hasPending)return new Promise(u=>this.whenFlushedCallbacks.push(u))}isInMemory(){return this.options.hint===I.STORAGE_IN_MEMORY}}e.Storage=w;class b{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(u){u.insert?.forEach((y,v)=>this.items.set(v,y)),u.delete?.forEach(y=>this.items.delete(y))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=b}),define(oe[161],ae([0,1,8,3,31,9,21]),function(Q,e,C,L,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class I{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return L.Event.None}static{this.BUSY_OPEN_TIMEOUT=2e3}static{this.MAX_HOST_PARAMETERS=256}constructor(w,b=Object.create(null)){this.path=w,this.options=b,this.name=(0,O.basename)(this.path),this.logger=new f(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const w=await this.whenConnected,b=new Map;return(await this.all(w,"SELECT * FROM ItemTable")).forEach(u=>b.set(u.key,u.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${b.size} rows`),b}async updateItems(w){const b=await this.whenConnected;return this.doUpdateItems(b,w)}doUpdateItems(w,b){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${b.insert?(0,r.mapToString)(b.insert):"0"}), delete(${b.delete?(0,r.setToString)(b.delete):"0"})`),this.transaction(w,()=>{const E=b.insert,u=b.delete;if(E&&E.size>0){const y=[];y.push([]);let v=0;E.forEach((m,g)=>{let h=y[v];h.length>I.MAX_HOST_PARAMETERS&&(v++,h=[],y.push(h)),h.push(g,m)}),y.forEach(m=>{this.prepare(w,`INSERT INTO ItemTable VALUES ${new Array(m.length/2).fill("(?,?)").join(",")}`,g=>g.run(m),()=>{const g=[];let h=0;return E.forEach((d,p)=>{g.push(p),h+=d.length}),`Keys: ${g.join(", ")} Length: ${h}`})})}if(u&&u.size){const y=[];y.push([]);let v=0;u.forEach(m=>{let g=y[v];g.length>I.MAX_HOST_PARAMETERS&&(v++,g=[],y.push(g)),g.push(m)}),y.forEach(m=>{this.prepare(w,`DELETE FROM ItemTable WHERE key IN (${new Array(m.length).fill("?").join(",")})`,g=>g.run(m),()=>{const g=[];return u.forEach(h=>{g.push(h)}),`Keys: ${g.join(", ")}`})})}})}async optimize(){this.logger.trace(`[storage ${this.name}] vacuum()`);const w=await this.whenConnected;return this.exec(w,"VACUUM")}async close(w){this.logger.trace(`[storage ${this.name}] close()`);const b=await this.whenConnected;return this.doClose(b,w)}doClose(w,b){return new Promise((E,u)=>{w.db.close(y=>(y&&this.handleSQLiteError(w,`[storage ${this.name}] close(): ${y}`),this.path===I.IN_MEMORY_PATH?E():!w.isErroneous&&!w.isInMemory?this.backup().then(E,v=>(this.logger.error(`[storage ${this.name}] backup(): ${v}`),E())):typeof b=="function"?M.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(v=>{const m=()=>this.doClose(v,void 0);return this.doUpdateItems(v,{insert:b()}).then(()=>m(),g=>(m(),Promise.reject(g)))})).then(E,u):u(y||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const w=this.toBackupPath(this.path);return M.Promises.copy(this.path,w,{preserveSymlinks:!1})}toBackupPath(w){return`${w}.backup`}async checkIntegrity(w){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${w})`);const b=await this.whenConnected,E=await this.get(b,w?"PRAGMA integrity_check":"PRAGMA quick_check"),u=w?E.integrity_check:E.quick_check;return b.isErroneous?`${u} (last error: ${b.lastError})`:b.isInMemory?`${u} (in-memory!)`:u}async connect(w,b=!0){this.logger.trace(`[storage ${this.name}] open(${w}, retryOnBusy: ${b})`);try{return await this.doConnect(w)}catch(E){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${E}`),E.code==="SQLITE_BUSY"&&b)return await(0,C.timeout)(I.BUSY_OPEN_TIMEOUT),this.connect(w,!1);try{await M.Promises.unlink(w);try{await M.Promises.rename(this.toBackupPath(w),w,!1)}catch{}return await this.doConnect(w)}catch(u){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${u}`),this.doConnect(I.IN_MEMORY_PATH)}}}handleSQLiteError(w,b){w.isErroneous=!0,w.lastError=b,this.logger.error(b)}doConnect(w){return new Promise((b,E)=>{new Promise((u,y)=>{Q(["@vscode/sqlite3"],u,y)}).then(u=>{const y={db:new(this.logger.isTracing?u.verbose().Database:u.Database)(w,v=>v?y.db&&v.code!=="SQLITE_CANTOPEN"?y.db.close(()=>E(v)):E(v):this.exec(y,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>b(y),m=>y.db.close(()=>E(m)))),isInMemory:w===I.IN_MEMORY_PATH};y.db.on("error",v=>this.handleSQLiteError(y,`[storage ${this.name}] Error (event): ${v}`)),this.logger.isTracing&&y.db.on("trace",v=>this.logger.trace(`[storage ${this.name}] Trace (event): ${v}`))},E)})}exec(w,b){return new Promise((E,u)=>{w.db.exec(b,y=>y?(this.handleSQLiteError(w,`[storage ${this.name}] exec(): ${y}`),u(y)):E())})}get(w,b){return new Promise((E,u)=>{w.db.get(b,(y,v)=>y?(this.handleSQLiteError(w,`[storage ${this.name}] get(): ${y}`),u(y)):E(v))})}all(w,b){return new Promise((E,u)=>{w.db.all(b,(y,v)=>y?(this.handleSQLiteError(w,`[storage ${this.name}] all(): ${y}`),u(y)):E(v))})}transaction(w,b){return new Promise((E,u)=>{w.db.serialize(()=>{w.db.run("BEGIN TRANSACTION"),b(),w.db.run("END TRANSACTION",y=>y?(this.handleSQLiteError(w,`[storage ${this.name}] transaction(): ${y}`),u(y)):E())})})}prepare(w,b,E,u){const y=w.db.prepare(b),v=m=>{this.handleSQLiteError(w,`[storage ${this.name}] prepare(): ${m} (${b}). Details: ${u()}`)};y.on("error",v),E(y),y.finalize(m=>{m&&v(m),y.removeListener("error",v)})}}e.SQLiteStorageDatabase=I;class f{static{this.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}constructor(w){w&&typeof w.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.logTrace=w.logTrace),w&&typeof w.logError=="function"&&(this.logError=w.logError)}get isTracing(){return!!this.logTrace}trace(w){this.logTrace?.(w)}error(w){this.logError?.(w)}}}),define(oe[162],ae([11,10]),function(Q,e){return Q.create("vs/code/electron-main/app",e)}),define(oe[163],ae([11,10]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[164],ae([11,10]),function(Q,e){return Q.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[165],ae([11,10]),function(Q,e){return Q.create("vs/platform/contextkey/common/scanner",e)}),define(oe[166],ae([11,10]),function(Q,e){return Q.create("vs/platform/dialogs/common/dialogs",e)}),define(oe[167],ae([11,10]),function(Q,e){return Q.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(oe[168],ae([11,10]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(oe[169],ae([11,10]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(oe[170],ae([11,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[171],ae([11,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[172],ae([11,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[173],ae([11,10]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[174],ae([11,10]),function(Q,e){return Q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(oe[175],ae([11,10]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(oe[176],ae([11,10]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(oe[177],ae([11,10]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(oe[178],ae([11,10]),function(Q,e){return Q.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(oe[179],ae([11,10]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[180],ae([11,10]),function(Q,e){return Q.create("vs/platform/issue/electron-main/issueMainService",e)}),define(oe[181],ae([11,10]),function(Q,e){return Q.create("vs/platform/menubar/electron-main/menubar",e)}),define(oe[182],ae([11,10]),function(Q,e){return Q.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(oe[183],ae([11,10]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(oe[184],ae([11,10]),function(Q,e){return Q.create("vs/platform/shell/node/shellEnv",e)}),define(oe[185],ae([11,10]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[186],ae([11,10]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(oe[187],ae([11,10]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalProfiles",e)}),define(oe[188],ae([11,10]),function(Q,e){return Q.create("vs/platform/update/common/update.config.contribution",e)}),define(oe[189],ae([11,10]),function(Q,e){return Q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[190],ae([11,10]),function(Q,e){return Q.create("vs/platform/windows/electron-main/windowImpl",e)}),define(oe[191],ae([11,10]),function(Q,e){return Q.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(oe[192],ae([11,10]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(oe[193],ae([11,10]),function(Q,e){return Q.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(oe[194],ae([11,10]),function(Q,e){return Q.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(oe[195],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function C(r){return r&&r.hasOwnProperty("folderUri")}e.isFolderBackupInfo=C;function L(r){return r&&r.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=L}),define(oe[196],ae([0,1,7]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function L(M){return typeof M?.backupFolder=="string"}e.isEmptyWindowBackupInfo=L;function r(M){let I=[];try{Array.isArray(M.workspaces)&&(I=M.workspaces.map(f=>({workspace:{id:f.id,configPath:C.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}return I}e.deserializeWorkspaceInfos=r;function O(M){let I=[];try{Array.isArray(M.folders)&&(I=M.folders.map(f=>({folderUri:C.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})))}catch{}return I}e.deserializeFolderInfos=O}),define(oe[197],ae([0,1,14,165]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var r;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(r||(e.TokenType=r={}));function O(...l){switch(l.length){case 1:return(0,L.localize)(0,null,l[0]);case 2:return(0,L.localize)(1,null,l[0],l[1]);case 3:return(0,L.localize)(2,null,l[0],l[1],l[2]);default:return}}const M=(0,L.localize)(3,null),I=(0,L.localize)(4,null);class f{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(w){switch(w.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return w.isTripleEq?"===":"==";case 4:return w.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return w.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return w.lexeme;case 18:return w.lexeme;case 19:return w.lexeme;case 20:return"EOF";default:throw(0,C.illegalState)(`unhandled token type: ${JSON.stringify(w)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(w=>w.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(w){return this._input=w,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const b=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:b})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const b=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:b})}else this._match(126)?this._addToken(9):this._error(O("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(O("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(w){return this._isAtEnd()||this._input.charCodeAt(this._current)!==w?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(w){this._tokens.push({type:w,offset:this._start})}_error(w){const b=this._start,E=this._input.substring(this._start,this._current),u={type:19,offset:this._start,lexeme:E};this._errors.push({offset:b,lexeme:E,additionalInfo:w}),this._tokens.push(u)}_string(){this.stringRe.lastIndex=this._start;const w=this.stringRe.exec(this._input);if(w){this._current=this._start+w[0].length;const b=this._input.substring(this._start,this._current),E=f._keywords.get(b);E?this._addToken(E):this._tokens.push({type:17,lexeme:b,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(M);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let w=this._current,b=!1,E=!1;for(;;){if(w>=this._input.length){this._current=w,this._error(I);return}const y=this._input.charCodeAt(w);if(b)b=!1;else if(y===47&&!E){w++;break}else y===91?E=!0:y===92?b=!0:y===93&&(E=!1);w++}for(;w<this._input.length&&f._regexFlags.has(this._input.charCodeAt(w));)w++;this._current=w;const u=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:u,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=f}),define(oe[198],ae([0,1,3,2]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class r{constructor(){this._onCloseEmitter=new C.Emitter,this._onReloadEmitter=new C.Emitter,this._onTerminateEmitter=new C.Emitter,this._onAttachEmitter=new C.Emitter}static{this.ChannelName="extensionhostdebugservice"}call(I,f,l){switch(f){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:l[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:l[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:l[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:l[0],port:l[1],subId:l[2]}))}throw new Error("Method not implemented.")}listen(I,f,l){switch(f){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=r;class O extends L.Disposable{constructor(I){super(),this.channel=I}reload(I){this.channel.call("reload",[I])}get onReload(){return this.channel.listen("reload")}close(I){this.channel.call("close",[I])}get onClose(){return this.channel.listen("close")}attachSession(I,f,l){this.channel.call("attach",[I,f,l])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(I,f){this.channel.call("terminate",[I,f])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(I,f){return this.channel.call("openExtensionDevelopmentHostWindow",[I,f])}}e.ExtensionHostDebugChannelClient=O}),define(oe[199],ae([0,1,149,50,13,9,36,19,7]),function(Q,e,C,L,r,O,M,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class l{get appRoot(){return(0,O.dirname)(r.FileAccess.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,O.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:r.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const u=(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,O.join)(this.userDataPath,"logs",u)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(f.URI.file((0,O.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=M.env.VSCODE_PORTABLE;return u?f.URI.file((0,O.join)(u,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,O.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,O.resolve)(u):(0,O.normalize)((0,O.join)(r.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const u=this.args["extensions-download-dir"];return u?f.URI.file((0,O.resolve)(u)):f.URI.file((0,O.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,O.resolve)(u);const y=M.env.VSCODE_EXTENSIONS;if(y)return y;const v=M.env.VSCODE_PORTABLE;return v?(0,O.join)(v,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(y=>/^[^:/?#]+?:\/\//.test(y)?f.URI.parse(y):f.URI.file((0,O.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?f.URI.parse(u):f.URI.file((0,O.normalize)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return w(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(u=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(u))}get extensionLogLevel(){const u=[];for(const y of this.args.log||[]){const v=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(y);v&&v[1]&&v[2]&&u.push([v[1],v[2]])}return u.length?u:void 0}get serviceMachineIdResource(){return(0,I.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const u=M.env.VSCODE_PORTABLE;return u?f.URI.file((0,O.join)(u,"policy.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(u){this.args.continueOn=u}get args(){return this._args}constructor(u,y,v){this._args=u,this.paths=y,this.productService=v,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=l,be([L.memoize],l.prototype,"appRoot",null),be([L.memoize],l.prototype,"userHome",null),be([L.memoize],l.prototype,"userDataPath",null),be([L.memoize],l.prototype,"appSettingsHome",null),be([L.memoize],l.prototype,"tmpDir",null),be([L.memoize],l.prototype,"cacheHome",null),be([L.memoize],l.prototype,"stateResource",null),be([L.memoize],l.prototype,"userRoamingDataHome",null),be([L.memoize],l.prototype,"userDataSyncHome",null),be([L.memoize],l.prototype,"sync",null),be([L.memoize],l.prototype,"machineSettingsResource",null),be([L.memoize],l.prototype,"workspaceStorageHome",null),be([L.memoize],l.prototype,"localHistoryHome",null),be([L.memoize],l.prototype,"keyboardLayoutResource",null),be([L.memoize],l.prototype,"argvResource",null),be([L.memoize],l.prototype,"isExtensionDevelopment",null),be([L.memoize],l.prototype,"untitledWorkspacesHome",null),be([L.memoize],l.prototype,"builtinExtensionsPath",null),be([L.memoize],l.prototype,"extensionsPath",null),be([L.memoize],l.prototype,"extensionDevelopmentLocationURI",null),be([L.memoize],l.prototype,"extensionDevelopmentKind",null),be([L.memoize],l.prototype,"extensionTestsLocationURI",null),be([L.memoize],l.prototype,"debugExtensionHost",null),be([L.memoize],l.prototype,"logLevel",null),be([L.memoize],l.prototype,"extensionLogLevel",null),be([L.memoize],l.prototype,"serviceMachineIdResource",null),be([L.memoize],l.prototype,"disableTelemetry",null),be([L.memoize],l.prototype,"disableWorkspaceTrust",null),be([L.memoize],l.prototype,"useInMemorySecretStorage",null),be([L.memoize],l.prototype,"policyFile",null);function w(E,u){return b(E["inspect-extensions"],E["inspect-brk-extensions"],5870,u,E.debugId,E.extensionEnvironment)}e.parseExtensionHostDebugPort=w;function b(E,u,y,v,m,g){const d=Number(u||E)||(v?null:y),p=d?!!u:!1;let a;if(g)try{a=JSON.parse(g)}catch{}return{port:d,break:p,debugId:m,env:a}}e.parseDebugParams=b}),define(oe[113],ae([0,1,309,4,168]),function(Q,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=e.NATIVE_CLI_COMMANDS=void 0;const O={o:(0,r.localize)(0,null),e:(0,r.localize)(1,null),t:(0,r.localize)(2,null)};e.NATIVE_CLI_COMMANDS=["tunnel","serve-web"],e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,r.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,r.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,r.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,r.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,r.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,r.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,r.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,r.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,r.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,r.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,r.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,r.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,r.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,r.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,r.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,r.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,r.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,r.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,r.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,r.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,r.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,r.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,r.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,r.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,r.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,r.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,r.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,r.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,r.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,r.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,r.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,r.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,r.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(v,m,g=M){const h=v.find(c=>c.length>0&&c[0]!=="-"),d={},p=["_"],a=[],t={};let o;for(const c in m){const S=m[c];S.type==="subcommand"?c===h&&(o=S):(S.alias&&(d[c]=S.alias),S.type==="string"||S.type==="string[]"?(p.push(c),S.deprecates&&p.push(...S.deprecates)):S.type==="boolean"&&(a.push(c),S.deprecates&&a.push(...S.deprecates)),S.global&&(t[c]=S))}if(o&&h){const c=t;for(const P in o.options)c[P]=o.options[P];const S=v.filter(P=>P!==h),R=g.getSubcommandReporter?g.getSubcommandReporter(h):void 0,k=I(S,c,R);return{[h]:k,_:[]}}const s=C(v,{string:p,boolean:a,alias:d}),i={},n=s;i._=s._.map(c=>String(c)).filter(c=>c.length>0),delete n._;for(const c in m){const S=m[c];if(S.type==="subcommand")continue;S.alias&&delete n[S.alias];let R=n[c];if(S.deprecates)for(const k of S.deprecates)n.hasOwnProperty(k)&&(R||(R=n[k],R&&g.onDeprecatedOption(k,S.deprecationMessage||(0,r.localize)(38,null,c))),delete n[k]);if(typeof R<"u"){if(S.type==="string[]"){if(Array.isArray(R)||(R=[R]),!S.allowEmptyValue){const k=R.filter(P=>P.length>0);k.length!==R.length&&(g.onEmptyValue(c),R=k.length>0?k:void 0)}}else S.type==="string"&&(Array.isArray(R)?(R=R.pop(),g.onMultipleValues(c,R)):!R&&!S.allowEmptyValue&&(g.onEmptyValue(c),R=void 0));i[c]=R,S.deprecationMessage&&g.onDeprecatedOption(c,S.deprecationMessage)}delete n[c]}for(const c in n)g.onUnknownOption(c);return i}e.parseArgs=I;function f(v,m){let g="";return m.args&&(Array.isArray(m.args)?g=` <${m.args.join("> <")}>`:g=` <${m.args}>`),m.alias?`-${m.alias} --${v}${g}`:`--${v}${g}`}function l(v,m){const g=[];for(const h in v){const d=v[h],p=f(h,d);g.push([p,d.description])}return w(g,m)}e.formatOptions=l;function w(v,m){const h=v.reduce((a,t)=>Math.max(a,t[0].length),12)+2+1;if(m-h<25)return v.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const d=m-h-1,p=[];for(const a of v){const t=a[0],o=E(a[1],d),s=b(h-t.length-2);p.push("  "+t+s+o[0]);for(let i=1;i<o.length;i++)p.push(b(h)+o[i])}return p}function b(v){return" ".repeat(v)}function E(v,m){const g=[];for(;v.length;){const h=v.length<m?v.length:v.lastIndexOf(" ",m),d=v.slice(0,h).trim();v=v.slice(h),g.push(d)}return g}function u(v,m,g,h,d){const p=process.stdout.isTTY&&process.stdout.columns||80,a=d?.noInputFiles!==!0?`[${(0,r.localize)(39,null)}...]`:"",t=[`${v} ${g}`];t.push(""),t.push(`${(0,r.localize)(40,null)}: ${m} [${(0,r.localize)(41,null)}]${a}`),t.push(""),d?.noPipe!==!0&&(L.isWindows?t.push((0,r.localize)(42,null,m)):t.push((0,r.localize)(43,null,m)),t.push(""));const o={},s=[];for(const i in h){const n=h[i];if(n.type==="subcommand")n.description&&s.push({command:i,description:n.description});else if(n.description&&n.cat){let c=o[n.cat];c||(o[n.cat]=c={}),c[i]=n}}for(const i in o){const n=i,c=o[n];c&&(t.push(O[n]),t.push(...l(c,p)),t.push(""))}return s.length&&(t.push((0,r.localize)(44,null)),t.push(...w(s.map(i=>[i.command,i.description]),p)),t.push("")),t.join(`
`)}e.buildHelpMessage=u;function y(v,m){return`${v||(0,r.localize)(45,null)}
${m||(0,r.localize)(46,null)}
${process.arch}`}e.buildVersionMessage=y}),define(oe[200],ae([0,1,87,198,113]),function(Q,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class O extends L.ExtensionHostDebugBroadcastChannel{constructor(I){super(),this.windowsMainService=I}call(I,f,l){return f==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(l[0],l[1]):super.call(I,f,l)}async openExtensionDevelopmentHostWindow(I,f){const l=(0,r.parseArgs)(I,r.OPTIONS);l.debugRenderer=f;const w=l.extensionDevelopmentPath;if(!w)return{success:!1};const[b]=await this.windowsMainService.openExtensionDevelopmentHostWindow(w,{context:5,cli:l,forceProfile:l.profile,forceTempProfile:l["profile-temp"]});if(!f)return{success:!0};const E=b.win;if(!E)return{success:!0};const u=E.webContents.debugger;let y=u.isAttached()?1/0:0;const v=(0,C.createServer)(m=>{y++===0&&u.attach();let g=!1;const h=a=>{g||m.write(JSON.stringify(a)+"\0")},d=(a,t,o,s)=>h({method:t,params:o,sessionId:s});E.on("close",()=>{u.removeListener("message",d),m.end(),g=!0}),u.addListener("message",d);let p=Buffer.alloc(0);m.on("data",a=>{p=Buffer.concat([p,a]);for(let t=p.indexOf(0);t!==-1;t=p.indexOf(0)){let o;try{const s=p.slice(0,t).toString("utf8");p=p.slice(t+1),o=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}u.sendCommand(o.method,o.params,o.sessionId).then(s=>h({id:o.id,sessionId:o.sessionId,result:s})).catch(s=>h({id:o.id,sessionId:o.sessionId,error:{code:0,message:s.message}}))}}),m.on("error",a=>{console.error("error on cdp pipe:",a)}),m.on("close",()=>{g=!0,--y===0&&u.detach()})});return await new Promise(m=>v.listen(0,m)),E.on("close",()=>v.close()),{rendererDebugPort:v.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=O}),define(oe[64],ae([0,1,310,169,113]),function(Q,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function O(b,E){const u=(d,p)=>{console.warn((0,L.localize)(0,null,d,p))},y=d=>{console.warn((0,L.localize)(1,null,d))},v=(d,p)=>{console.warn((0,L.localize)(2,null,d,p))},m=d=>({onUnknownOption:p=>{r.NATIVE_CLI_COMMANDS.includes(d)||console.warn((0,L.localize)(3,null,p,d))},onMultipleValues:u,onEmptyValue:y,onDeprecatedOption:v,getSubcommandReporter:r.NATIVE_CLI_COMMANDS.includes(d)?m:void 0}),g={onUnknownOption:d=>{console.warn((0,L.localize)(4,null,d))},onMultipleValues:u,onEmptyValue:y,onDeprecatedOption:v,getSubcommandReporter:m},h=(0,r.parseArgs)(b,r.OPTIONS,E?g:void 0);return h.goto&&h._.forEach(d=>C(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(d),(0,L.localize)(5,null))),h}function M(b){const E=b.findIndex(u=>!/^-/.test(u));if(E>-1)return[...b.slice(0,E),...b.slice(E+1)]}function I(b){let[,...E]=b;process.env.VSCODE_DEV&&(E=M(E)||[]);const u=!w(process.env);return O(E,u)}e.parseMainProcessArgv=I;function f(b){let[,,...E]=b;return process.env.VSCODE_DEV&&(E=M(E)||[]),O(E,!0)}e.parseCLIProcessArgv=f;function l(b,...E){const u=b.indexOf("--");return u===-1?b.push(...E):b.splice(u,0,...E),b}e.addArg=l;function w(b){return b.VSCODE_CLI==="1"}e.isLaunchedFromCli=w}),function(){"use strict";function Q(e,C,L){function r(M,I){const f=O(M,I),l=[f];return e.isAbsolute(f)||l.unshift(L),e.resolve(...l)}function O(M,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,I);const w=M["user-data-dir"];if(w)return w;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(b,"AppData","Roaming")}break;case"darwin":l=e.join(C.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(C.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,I)}return{getUserDataPath:r}}if(typeof define=="function")define(oe[201],ae([114,26,36]),function(e,C,L){return Q(e,C,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),C=require("os");module.exports=Q(e,C,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[90],ae([0,1,26,199,201]),function(Q,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class O extends L.AbstractNativeEnvironmentService{constructor(l,w){super(l,{homeDir:(0,C.homedir)(),tmpDir:(0,C.tmpdir)(),userDataDir:(0,r.getUserDataPath)(l,w.nameShort)},w)}}e.NativeEnvironmentService=O;function M(f,l){return(0,L.parseDebugParams)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,l,f.extensionEnvironment)}e.parsePtyHostDebugPort=M;function I(f,l){return(0,L.parseDebugParams)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,l,f.extensionEnvironment)}e.parseSharedProcessDebugPort=I}),define(oe[202],ae([0,1,46,26,33]),function(Q,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function O(M){const I=(0,r.randomPath)((0,L.tmpdir)());try{return(0,C.writeFileSync)(I,""),M&&console.log(`Marker file for --wait created: ${I}`),I}catch(f){M&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFileSync=O}),define(oe[203],ae([0,1,12,171]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function r(M,I,f,l){try{O(M,I,f,l)}catch(w){M.error(w?.message??w)}return I}e.localizeManifest=r;function O(M,I,f,l){const w=(b,E,u)=>{const y=b[E];if((0,C.isString)(y)){const v=y,m=v.length;if(m>1&&v[0]==="%"&&v[m-1]==="%"){const g=v.substr(1,m-2);let h=f[g];h===void 0&&l&&(h=l[g]);const d=typeof h=="string"?h:h?.message,p=l?.[g],a=typeof p=="string"?p:p?.message;if(!d){a||M.warn(`[${I.name}]: ${(0,L.localize)(0,null,g)}`);return}if(u&&(E==="title"||E==="category")&&a&&a!==d){const t={value:d,original:a};b[E]=t}else b[E]=d}}else if((0,C.isObject)(y))for(const v in y)y.hasOwnProperty(v)&&(v==="commands"?w(y,v,!0):w(y,v,u));else if(Array.isArray(y))for(let v=0;v<y.length;v++)w(y,v,u)};for(const b in I)I.hasOwnProperty(b)&&w(I,b)}}),define(oe[204],ae([0,1,19,74,173,205]),function(Q,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function f(g){return g=g.trim(),g==="*"||M.test(g)}e.isValidVersionStr=f;function l(g){if(!f(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=g.match(M);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=l;function w(g){if(!g)return null;const h=g.majorBase,d=g.majorMustEqual,p=g.minorBase;let a=g.minorMustEqual;const t=g.patchBase;let o=g.patchMustEqual;g.hasCaret&&(h===0||(a=!1),o=!1);let s=0;if(g.preRelease){const i=I.exec(g.preRelease);if(i){const[,n,c,S]=i;s=Date.UTC(Number(n),Number(c)-1,Number(S))}}return{majorBase:h,majorMustEqual:d,minorBase:p,minorMustEqual:a,patchBase:t,patchMustEqual:o,isMinimum:g.hasGreaterEquals,notBefore:s}}e.normalizeVersion=w;function b(g,h,d){let p;typeof g=="string"?p=w(l(g)):p=g;let a;h instanceof Date?a=h.getTime():typeof h=="string"&&(a=new Date(h).getTime());let t;if(typeof d=="string"?t=w(l(d)):t=d,!p||!t)return!1;const o=p.majorBase,s=p.minorBase,i=p.patchBase;let n=t.majorBase,c=t.minorBase,S=t.patchBase;const R=t.notBefore;let k=t.majorMustEqual,P=t.minorMustEqual,D=t.patchMustEqual;return t.isMinimum?o>n?!0:o<n?!1:s>c?!0:s<c||a&&a<R?!1:i>=S:(o===1&&n===0&&(!k||!P||!D)&&(n=1,c=0,S=0,k=!0,P=!1,D=!1),o<n?!1:o>n?!k:s<c?!1:s>c?!P:i<S?!1:i>S?!D:!(a&&a<R))}e.isValidVersion=b;function E(g,h,d,p,a){const t=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return t.push([L.default.Error,r.localize(0,null)]),t;if(typeof p.name!="string")return t.push([L.default.Error,r.localize(1,null,"name")]),t;if(typeof p.version!="string")return t.push([L.default.Error,r.localize(2,null,"version")]),t;if(!p.engines)return t.push([L.default.Error,r.localize(3,null,"engines")]),t;if(typeof p.engines.vscode!="string")return t.push([L.default.Error,r.localize(4,null,"engines.vscode")]),t;if(typeof p.extensionDependencies<"u"&&!m(p.extensionDependencies))return t.push([L.default.Error,r.localize(5,null,"extensionDependencies")]),t;if(typeof p.activationEvents<"u"){if(!m(p.activationEvents))return t.push([L.default.Error,r.localize(6,null,"activationEvents")]),t;if(typeof p.main>"u"&&typeof p.browser>"u")return t.push([L.default.Error,r.localize(7,null,"activationEvents","main","browser")]),t}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&t.push([L.default.Warning,r.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return t.push([L.default.Error,r.localize(9,null,"main")]),t;{const i=(0,C.joinPath)(d,p.main);(0,C.isEqualOrParent)(i,d)||t.push([L.default.Warning,r.localize(10,null,i.path,d.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return t.push([L.default.Error,r.localize(11,null,"browser")]),t;{const i=(0,C.joinPath)(d,p.browser);(0,C.isEqualOrParent)(i,d)||t.push([L.default.Warning,r.localize(12,null,i.path,d.path)])}}if(!O.valid(p.version))return t.push([L.default.Error,r.localize(13,null)]),t;const o=[];if(!u(g,h,p,a,o))for(const i of o)t.push([L.default.Error,i]);return t}e.validateExtensionManifest=E;function u(g,h,d,p,a){return p||typeof d.main>"u"&&typeof d.browser>"u"?!0:v(g,h,d.engines.vscode,a)}e.isValidExtensionVersion=u;function y(g,h,d){return g==="*"||v(h,d,g)}e.isEngineValid=y;function v(g,h,d,p=[]){const a=w(l(d));if(!a)return p.push(r.localize(14,null,d)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return p.push(r.localize(15,null,d)),!1}else if(!a.majorMustEqual)return p.push(r.localize(16,null,d)),!1;return b(g,h,a)?!0:(p.push(r.localize(17,null,g,d)),!1)}function m(g){if(!Array.isArray(g))return!1;for(let h=0,d=g.length;h<d;h++)if(typeof g[h]!="string")return!1;return!0}}),define(oe[206],ae([0,1,17,32]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function r(O,M,I){let f=I&&I.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const w=(await M.readFile(O.serviceMachineIdResource)).value.toString();f=(0,L.isUUID)(w)?w:null}catch{f=null}if(!f){f=(0,L.generateUuid)();try{await M.writeFile(O.serviceMachineIdResource,C.VSBuffer.fromString(f))}catch{}}return I?.store("storage.serviceMachineId",f,-1,1),f}e.getServiceMachineId=r}),define(oe[78],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class C{constructor(r,O=[],M=!1){this.ctor=r,this.staticArguments=O,this.supportsDelayedInstantiation=M}}e.SyncDescriptor=C}),define(oe[207],ae([0,1,78]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var r;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(r||(e.InstantiationType=r={}));function O(I,f,l){f instanceof C.SyncDescriptor||(f=new C.SyncDescriptor(f,[],!!l)),L.push([I,f])}e.registerSingleton=O;function M(){return L}e.getSingletonServiceDescriptors=M}),define(oe[208],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class C{constructor(O,M){this.key=O,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.Node=C;class L{constructor(O){this._hashFn=O,this._nodes=new Map}roots(){const O=[];for(const M of this._nodes.values())M.outgoing.size===0&&O.push(M);return O}insertEdge(O,M){const I=this.lookupOrInsertNode(O),f=this.lookupOrInsertNode(M);I.outgoing.set(f.key,f),f.incoming.set(I.key,I)}removeNode(O){const M=this._hashFn(O);this._nodes.delete(M);for(const I of this._nodes.values())I.outgoing.delete(M),I.incoming.delete(M)}lookupOrInsertNode(O){const M=this._hashFn(O);let I=this._nodes.get(M);return I||(I=new C(M,O),this._nodes.set(M,I)),I}lookup(O){return this._nodes.get(this._hashFn(O))}isEmpty(){return this._nodes.size===0}toString(){const O=[];for(const[M,I]of this._nodes)O.push(`${M}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,M]of this._nodes){const I=new Set([O]),f=this._findCycle(M,I);if(f)return f}}_findCycle(O,M){for(const[I,f]of O.outgoing){if(M.has(I))return[...M,I].join(" -> ");M.add(I);const l=this._findCycle(f,M);if(l)return l;M.delete(I)}}}e.Graph=L}),define(oe[6],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var C;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function I(f){return f[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=I})(C||(e._util=C={})),e.IInstantiationService=r("instantiationService");function L(M,I,f){I[C.DI_TARGET]===I?I[C.DI_DEPENDENCIES].push({id:M,index:f}):(I[C.DI_DEPENDENCIES]=[{id:M,index:f}],I[C.DI_TARGET]=I)}function r(M){if(C.serviceIds.has(M))return C.serviceIds.get(M);const I=function(f,l,w){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(I,f,w)};return I.toString=()=>M,C.serviceIds.set(M,I),I}e.createDecorator=r;function O(M){return M}e.refineServiceDecorator=O}),define(oe[65],ae([0,1,13,6]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAuxiliaryWindow=e.IAuxiliaryWindowsMainService=void 0,e.IAuxiliaryWindowsMainService=(0,L.createDecorator)("auxiliaryWindowsMainService");function r(O){return O?.opener?.url.startsWith(`${C.Schemas.vscodeFileResource}://${C.VSCODE_AUTHORITY}/`)}e.isAuxiliaryWindow=r}),define(oe[66],ae([0,1,6]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,C.createDecorator)("backupMainService")}),define(oe[18],ae([0,1,12,7,6]),function(Q,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,r.createDecorator)("configurationService");function O(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof L.URI)}e.isConfigurationOverrides=O;function M(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=M;var I;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function f(g){switch(g){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=f;function l(g){return g.applicationValue!==void 0||g.userValue!==void 0||g.userLocalValue!==void 0||g.userRemoteValue!==void 0||g.workspaceValue!==void 0||g.workspaceFolderValue!==void 0}e.isConfigured=l;function w(g,h){const d=Object.create(null);for(const p in g)b(d,p,g[p],h);return d}e.toValuesTree=w;function b(g,h,d,p){const a=h.split("."),t=a.pop();let o=g;for(let s=0;s<a.length;s++){const i=a[s];let n=o[i];switch(typeof n){case"undefined":n=o[i]=Object.create(null);break;case"object":break;default:p(`Ignoring ${h} as ${a.slice(0,s+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[t]=d}catch{p(`Ignoring ${h} as ${a.join(".")} is ${JSON.stringify(o)}`)}else p(`Ignoring ${h} as ${a.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=b;function E(g,h){const d=h.split(".");u(g,d)}e.removeFromValueTree=E;function u(g,h){const d=h.shift();if(h.length===0){delete g[d];return}if(Object.keys(g).indexOf(d)!==-1){const p=g[d];typeof p=="object"&&!Array.isArray(p)&&(u(p,h),Object.keys(p).length===0&&delete g[d])}}function y(g,h,d){function p(o,s){let i=o;for(const n of s){if(typeof i!="object"||i===null)return;i=i[n]}return i}const a=h.split("."),t=p(g,a);return typeof t>"u"?d:t}e.getConfigurationValue=y;function v(g,h,d){Object.keys(h).forEach(p=>{p!=="__proto__"&&(p in g?C.isObject(g[p])&&C.isObject(h[p])?v(g[p],h[p],d):d&&(g[p]=h[p]):g[p]=h[p])})}e.merge=v;function m(g){return g.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=m}),define(oe[115],ae([0,1,4,25,197,6,164,14]),function(Q,e,C,L,r,O,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",C.isMacintosh),f.set("isLinux",C.isLinux),f.set("isWindows",C.isWindows),f.set("isWeb",C.isWeb),f.set("isMacNative",C.isMacintosh&&!C.isWeb),f.set("isEdge",C.isEdge),f.set("isFirefox",C.isFirefox),f.set("isChrome",C.isChrome),f.set("isSafari",C.isSafari);function l(G,A){if(f.get(G)!==void 0)throw(0,I.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(G,A)}e.setConstant=l;const w=Object.prototype.hasOwnProperty;var b;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(b||(e.ContextKeyExprType=b={}));const E={regexParsingWithErrorRecovery:!0},u=(0,M.localize)(0,null),y=(0,M.localize)(1,null),v=(0,M.localize)(2,null),m=(0,M.localize)(3,null),g=(0,M.localize)(4,null),h=(0,M.localize)(5,null),d=(0,M.localize)(6,null),p=(0,M.localize)(7,null);class a{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(A=E){this._config=A,this._scanner=new r.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(A){if(A===""){this._parsingErrors.push({message:u,offset:0,lexeme:"",additionalInfo:y});return}this._tokens=this._scanner.reset(A).scan(),this._current=0,this._parsingErrors=[];try{const T=this._expr();if(!this._isAtEnd()){const Z=this._peek(),z=Z.type===17?h:void 0;throw this._parsingErrors.push({message:g,offset:Z.offset,lexeme:r.Scanner.getLexeme(Z),additionalInfo:z}),a._parseError}return T}catch(T){if(T!==a._parseError)throw T;return}}_expr(){return this._or()}_or(){const A=[this._and()];for(;this._matchOne(16);){const T=this._and();A.push(T)}return A.length===1?A[0]:t.or(...A)}_and(){const A=[this._term()];for(;this._matchOne(15);){const T=this._term();A.push(T)}return A.length===1?A[0]:t.and(...A)}_term(){if(this._matchOne(2)){const A=this._peek();switch(A.type){case 11:return this._advance(),n.INSTANCE;case 12:return this._advance(),c.INSTANCE;case 0:{this._advance();const T=this._expr();return this._consume(1,m),T?.negate()}case 17:return this._advance(),_.create(A.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",A)}}return this._primary()}_primary(){const A=this._peek();switch(A.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const T=this._expr();return this._consume(1,m),T}case 17:{const T=A.lexeme;if(this._advance(),this._matchOne(9)){const z=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),z.type!==10)throw this._errExpectedButGot("REGEX",z);const J=z.lexeme,B=J.lastIndexOf("/"),$=B===J.length-1?void 0:this._removeFlagsGY(J.substring(B+1));let K;try{K=new RegExp(J.substring(1,B),$)}catch{throw this._errExpectedButGot("REGEX",z)}return se.create(T,K)}switch(z.type){case 10:case 19:{const J=[z.lexeme];this._advance();let B=this._peek(),$=0;for(let we=0;we<z.lexeme.length;we++)z.lexeme.charCodeAt(we)===40?$++:z.lexeme.charCodeAt(we)===41&&$--;for(;!this._isAtEnd()&&B.type!==15&&B.type!==16;){switch(B.type){case 0:$++;break;case 1:$--;break;case 10:case 18:for(let we=0;we<B.lexeme.length;we++)B.lexeme.charCodeAt(we)===40?$++:z.lexeme.charCodeAt(we)===41&&$--}if($<0)break;J.push(r.Scanner.getLexeme(B)),this._advance(),B=this._peek()}const K=J.join(""),re=K.lastIndexOf("/"),le=re===K.length-1?void 0:this._removeFlagsGY(K.substring(re+1));let ge;try{ge=new RegExp(K.substring(1,re),le)}catch{throw this._errExpectedButGot("REGEX",z)}return t.regex(T,ge)}case 18:{const J=z.lexeme;this._advance();let B=null;if(!(0,L.isFalsyOrWhitespace)(J)){const $=J.indexOf("/"),K=J.lastIndexOf("/");if($!==K&&$>=0){const re=J.slice($+1,K),le=J[K+1]==="i"?"i":"";try{B=new RegExp(re,le)}catch{throw this._errExpectedButGot("REGEX",z)}}}if(B===null)throw this._errExpectedButGot("REGEX",z);return se.create(T,B)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,v);const z=this._value();return t.notIn(T,z)}switch(this._peek().type){case 3:{this._advance();const z=this._value();if(this._previous().type===18)return t.equals(T,z);switch(z){case"true":return t.has(T);case"false":return t.not(T);default:return t.equals(T,z)}}case 4:{this._advance();const z=this._value();if(this._previous().type===18)return t.notEquals(T,z);switch(z){case"true":return t.not(T);case"false":return t.has(T);default:return t.notEquals(T,z)}}case 5:return this._advance(),V.create(T,this._value());case 6:return this._advance(),ce.create(T,this._value());case 7:return this._advance(),U.create(T,this._value());case 8:return this._advance(),j.create(T,this._value());case 13:return this._advance(),t.in(T,this._value());default:return t.has(T)}}case 20:throw this._parsingErrors.push({message:d,offset:A.offset,lexeme:"",additionalInfo:p}),a._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const A=this._peek();switch(A.type){case 17:case 18:return this._advance(),A.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(A){return A.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(A){return this._check(A)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(A,T){if(this._check(A))return this._advance();throw this._errExpectedButGot(T,this._peek())}_errExpectedButGot(A,T,Z){const z=(0,M.localize)(8,null,A,r.Scanner.getLexeme(T)),J=T.offset,B=r.Scanner.getLexeme(T);return this._parsingErrors.push({message:z,offset:J,lexeme:B,additionalInfo:Z}),a._parseError}_check(A){return this._peek().type===A}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=a;class t{static false(){return n.INSTANCE}static true(){return c.INSTANCE}static has(A){return S.create(A)}static equals(A,T){return R.create(A,T)}static notEquals(A,T){return D.create(A,T)}static regex(A,T){return se.create(A,T)}static in(A,T){return k.create(A,T)}static notIn(A,T){return P.create(A,T)}static not(A){return _.create(A)}static and(...A){return Y.create(A,null,!0)}static or(...A){return x.create(A,null,!0)}static greater(A,T){return U.create(A,T)}static greaterEquals(A,T){return j.create(A,T)}static smaller(A,T){return V.create(A,T)}static smallerEquals(A,T){return ce.create(A,T)}static{this._parser=new a({regexParsingWithErrorRecovery:!1})}static deserialize(A){return A==null?void 0:this._parser.parse(A)}}e.ContextKeyExpr=t;function o(G){const A=new a({regexParsingWithErrorRecovery:!1});return G.map(T=>(A.parse(T),A.lexingErrors.length>0?A.lexingErrors.map(Z=>({errorMessage:Z.additionalInfo?(0,M.localize)(9,null,Z.additionalInfo):(0,M.localize)(10,null),offset:Z.offset,length:Z.lexeme.length})):A.parsingErrors.length>0?A.parsingErrors.map(Z=>({errorMessage:Z.additionalInfo?`${Z.message}. ${Z.additionalInfo}`:Z.message,offset:Z.offset,length:Z.lexeme.length})):[]))}e.validateWhenClauses=o;function s(G,A){const T=G?G.substituteConstants():void 0,Z=A?A.substituteConstants():void 0;return!T&&!Z?!0:!T||!Z?!1:T.equals(Z)}e.expressionsAreEqualWithConstantSubstitution=s;function i(G,A){return G.cmp(A)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return c.INSTANCE}}e.ContextKeyFalseExpr=n;class c{static{this.INSTANCE=new c}constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=c;class S{static create(A,T=null){const Z=f.get(A);return typeof Z=="boolean"?Z?c.INSTANCE:n.INSTANCE:new S(A,T)}constructor(A,T){this.key=A,this.negated=T,this.type=2}cmp(A){return A.type!==this.type?this.type-A.type:F(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=f.get(this.key);return typeof A=="boolean"?A?c.INSTANCE:n.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.negated||(this.negated=_.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=S;class R{static create(A,T,Z=null){if(typeof T=="boolean")return T?S.create(A,Z):_.create(A,Z);const z=f.get(A);return typeof z=="boolean"?T===(z?"true":"false")?c.INSTANCE:n.INSTANCE:new R(A,T,Z)}constructor(A,T,Z){this.key=A,this.value=T,this.negated=Z,this.type=4}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=f.get(this.key);if(typeof A=="boolean"){const T=A?"true":"false";return this.value===T?c.INSTANCE:n.INSTANCE}return this}evaluate(A){return A.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(A){return A.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=R;class k{static create(A,T){return new k(A,T)}constructor(A,T){this.key=A,this.valueKey=T,this.type=10,this.negated=null}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.valueKey,A.key,A.valueKey)}equals(A){return A.type===this.type?this.key===A.key&&this.valueKey===A.valueKey:!1}substituteConstants(){return this}evaluate(A){const T=A.getValue(this.valueKey),Z=A.getValue(this.key);return Array.isArray(T)?T.includes(Z):typeof Z=="string"&&typeof T=="object"&&T!==null?w.call(T,Z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(A){return A.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=P.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=k;class P{static create(A,T){return new P(A,T)}constructor(A,T){this.key=A,this.valueKey=T,this.type=11,this._negated=k.create(A,T)}cmp(A){return A.type!==this.type?this.type-A.type:this._negated.cmp(A._negated)}equals(A){return A.type===this.type?this._negated.equals(A._negated):!1}substituteConstants(){return this}evaluate(A){return!this._negated.evaluate(A)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(A){return A.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=P;class D{static create(A,T,Z=null){if(typeof T=="boolean")return T?_.create(A,Z):S.create(A,Z);const z=f.get(A);return typeof z=="boolean"?T===(z?"true":"false")?n.INSTANCE:c.INSTANCE:new D(A,T,Z)}constructor(A,T,Z){this.key=A,this.value=T,this.negated=Z,this.type=5}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=f.get(this.key);if(typeof A=="boolean"){const T=A?"true":"false";return this.value===T?n.INSTANCE:c.INSTANCE}return this}evaluate(A){return A.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(A){return A.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=R.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=D;class _{static create(A,T=null){const Z=f.get(A);return typeof Z=="boolean"?Z?n.INSTANCE:c.INSTANCE:new _(A,T)}constructor(A,T){this.key=A,this.negated=T,this.type=3}cmp(A){return A.type!==this.type?this.type-A.type:F(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=f.get(this.key);return typeof A=="boolean"?A?n.INSTANCE:c.INSTANCE:this}evaluate(A){return!A.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(A){return A.mapNot(this.key)}negate(){return this.negated||(this.negated=S.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=_;function N(G,A){if(typeof G=="string"){const T=parseFloat(G);isNaN(T)||(G=T)}return typeof G=="string"||typeof G=="number"?A(G):n.INSTANCE}class U{static create(A,T,Z=null){return N(T,z=>new U(A,z,Z))}constructor(A,T,Z){this.key=A,this.value=T,this.negated=Z,this.type=12}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=ce.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=U;class j{static create(A,T,Z=null){return N(T,z=>new j(A,z,Z))}constructor(A,T,Z){this.key=A,this.value=T,this.negated=Z,this.type=13}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=V.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=j;class V{static create(A,T,Z=null){return N(T,z=>new V(A,z,Z))}constructor(A,T,Z){this.key=A,this.value=T,this.negated=Z,this.type=14}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=j.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=V;class ce{static create(A,T,Z=null){return N(T,z=>new ce(A,z,Z))}constructor(A,T,Z){this.key=A,this.value=T,this.negated=Z,this.type=15}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=U.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=ce;class se{static create(A,T){return new se(A,T)}constructor(A,T){this.key=A,this.regexp=T,this.type=7,this.negated=null}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.key<A.key)return-1;if(this.key>A.key)return 1;const T=this.regexp?this.regexp.source:"",Z=A.regexp?A.regexp.source:"";return T<Z?-1:T>Z?1:0}equals(A){if(A.type===this.type){const T=this.regexp?this.regexp.source:"",Z=A.regexp?A.regexp.source:"";return this.key===A.key&&T===Z}return!1}substituteConstants(){return this}evaluate(A){const T=A.getValue(this.key);return this.regexp?this.regexp.test(T):!1}serialize(){const A=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${A}`}keys(){return[this.key]}map(A){return A.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=ue.create(this)),this.negated}}e.ContextKeyRegexExpr=se;class ue{static create(A){return new ue(A)}constructor(A){this._actual=A,this.type=8}cmp(A){return A.type!==this.type?this.type-A.type:this._actual.cmp(A._actual)}equals(A){return A.type===this.type?this._actual.equals(A._actual):!1}substituteConstants(){return this}evaluate(A){return!this._actual.evaluate(A)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(A){return new ue(this._actual.map(A))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=ue;function X(G){let A=null;for(let T=0,Z=G.length;T<Z;T++){const z=G[T].substituteConstants();if(G[T]!==z&&A===null){A=[];for(let J=0;J<T;J++)A[J]=G[J]}A!==null&&(A[T]=z)}return A===null?G:A}class Y{static create(A,T,Z){return Y._normalizeArr(A,T,Z)}constructor(A,T){this.expr=A,this.negated=T,this.type=6}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let T=0,Z=this.expr.length;T<Z;T++){const z=i(this.expr[T],A.expr[T]);if(z!==0)return z}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let T=0,Z=this.expr.length;T<Z;T++)if(!this.expr[T].equals(A.expr[T]))return!1;return!0}return!1}substituteConstants(){const A=X(this.expr);return A===this.expr?this:Y.create(A,this.negated,!1)}evaluate(A){for(let T=0,Z=this.expr.length;T<Z;T++)if(!this.expr[T].evaluate(A))return!1;return!0}static _normalizeArr(A,T,Z){const z=[];let J=!1;for(const B of A)if(B){if(B.type===1){J=!0;continue}if(B.type===0)return n.INSTANCE;if(B.type===6){z.push(...B.expr);continue}z.push(B)}if(z.length===0&&J)return c.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(i);for(let B=1;B<z.length;B++)z[B-1].equals(z[B])&&(z.splice(B,1),B--);if(z.length===1)return z[0];for(;z.length>1;){const B=z[z.length-1];if(B.type!==9)break;z.pop();const $=z.pop(),K=z.length===0,re=x.create(B.expr.map(le=>Y.create([le,$],null,Z)),null,K);re&&(z.push(re),z.sort(i))}if(z.length===1)return z[0];if(Z){for(let B=0;B<z.length;B++)for(let $=B+1;$<z.length;$++)if(z[B].negate().equals(z[$]))return n.INSTANCE;if(z.length===1)return z[0]}return new Y(z,T)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const T of this.expr)A.push(...T.keys());return A}map(A){return new Y(this.expr.map(T=>T.map(A)),null)}negate(){if(!this.negated){const A=[];for(const T of this.expr)A.push(T.negate());this.negated=x.create(A,this,!0)}return this.negated}}e.ContextKeyAndExpr=Y;class x{static create(A,T,Z){return x._normalizeArr(A,T,Z)}constructor(A,T){this.expr=A,this.negated=T,this.type=9}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let T=0,Z=this.expr.length;T<Z;T++){const z=i(this.expr[T],A.expr[T]);if(z!==0)return z}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let T=0,Z=this.expr.length;T<Z;T++)if(!this.expr[T].equals(A.expr[T]))return!1;return!0}return!1}substituteConstants(){const A=X(this.expr);return A===this.expr?this:x.create(A,this.negated,!1)}evaluate(A){for(let T=0,Z=this.expr.length;T<Z;T++)if(this.expr[T].evaluate(A))return!0;return!1}static _normalizeArr(A,T,Z){let z=[],J=!1;if(A){for(let B=0,$=A.length;B<$;B++){const K=A[B];if(K){if(K.type===0){J=!0;continue}if(K.type===1)return c.INSTANCE;if(K.type===9){z=z.concat(K.expr);continue}z.push(K)}}if(z.length===0&&J)return n.INSTANCE;z.sort(i)}if(z.length!==0){if(z.length===1)return z[0];for(let B=1;B<z.length;B++)z[B-1].equals(z[B])&&(z.splice(B,1),B--);if(z.length===1)return z[0];if(Z){for(let B=0;B<z.length;B++)for(let $=B+1;$<z.length;$++)if(z[B].negate().equals(z[$]))return c.INSTANCE;if(z.length===1)return z[0]}return new x(z,T)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const T of this.expr)A.push(...T.keys());return A}map(A){return new x(this.expr.map(T=>T.map(A)),null)}negate(){if(!this.negated){const A=[];for(const T of this.expr)A.push(T.negate());for(;A.length>1;){const T=A.shift(),Z=A.shift(),z=[];for(const J of de(T))for(const B of de(Z))z.push(Y.create([J,B],null,!1));A.unshift(x.create(z,null,!1))}this.negated=x.create(A,this,!0)}return this.negated}}e.ContextKeyOrExpr=x;class W extends S{static{this._info=[]}static all(){return W._info.values()}constructor(A,T,Z){super(A,null),this._defaultValue=T,typeof Z=="object"?W._info.push({...Z,key:A}):Z!==!0&&W._info.push({key:A,description:Z,type:T!=null?typeof T:void 0})}bindTo(A){return A.createKey(this.key,this._defaultValue)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return R.create(this.key,A)}notEqualsTo(A){return D.create(this.key,A)}}e.RawContextKey=W,e.IContextKeyService=(0,O.createDecorator)("contextKeyService");function F(G,A){return G<A?-1:G>A?1:0}function H(G,A,T,Z){return G<T?-1:G>T?1:A<Z?-1:A>Z?1:0}function q(G,A){if(G.type===0||A.type===1)return!0;if(G.type===9)return A.type===9?ee(G.expr,A.expr):!1;if(A.type===9){for(const T of A.expr)if(q(G,T))return!0;return!1}if(G.type===6){if(A.type===6)return ee(A.expr,G.expr);for(const T of G.expr)if(q(T,A))return!0;return!1}return G.equals(A)}e.implies=q;function ee(G,A){let T=0,Z=0;for(;T<G.length&&Z<A.length;){const z=G[T].cmp(A[Z]);if(z<0)return!1;z===0&&T++,Z++}return T===G.length}function de(G){return G.type===9?G.expr:[G]}}),define(oe[91],ae([0,1,6]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,C.createDecorator)(e.ID);function L(O){return!!O.hostName&&!!O.errorMessage}e.isRemoteDiagnosticError=L;class r{async getPerformanceInfo(M,I){return{}}async getSystemInfo(M,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(M,I){return""}async getWorkspaceFileExtensions(M){return{extensions:[]}}async reportWorkspaceStats(M){}}e.NullDiagnosticsService=r}),define(oe[116],ae([0,1,19,74,166,6,47,4,35]),function(Q,e,C,L,r,O,M,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,O.createDecorator)("dialogService");var l;(function(v){v[v.Confirmation=1]="Confirmation",v[v.Prompt=2]="Prompt",v[v.Input=3]="Input"})(l||(l={}));class w{getConfirmationButtons(m){return this.getButtons(m,l.Confirmation)}getPromptButtons(m){return this.getButtons(m,l.Prompt)}getInputButtons(m){return this.getButtons(m,l.Input)}getButtons(m,g){const h=[];switch(g){case l.Confirmation:{const d=m;d.primaryButton?h.push(d.primaryButton):h.push((0,r.localize)(0,null)),d.cancelButton?h.push(d.cancelButton):h.push((0,r.localize)(1,null));break}case l.Prompt:{const d=m;Array.isArray(d.buttons)&&d.buttons.length>0&&h.push(...d.buttons.map(p=>p.label)),d.cancelButton&&(d.cancelButton===!0?h.push((0,r.localize)(2,null)):typeof d.cancelButton=="string"?h.push(d.cancelButton):d.cancelButton.label?h.push(d.cancelButton.label):h.push((0,r.localize)(3,null))),h.length===0&&h.push((0,r.localize)(4,null));break}case l.Input:{const d=m;d.primaryButton?h.push(d.primaryButton):h.push((0,r.localize)(5,null)),d.cancelButton?h.push(d.cancelButton):h.push((0,r.localize)(6,null));break}}return h}getDialogType(m){if(typeof m=="string")return m;if(typeof m=="number")return m===L.default.Info?"info":m===L.default.Error?"error":m===L.default.Warning?"warning":"none"}getPromptResult(m,g,h){const d=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&d.push(m.cancelButton);let p=d[g]?.run({checkboxChecked:h});return p instanceof Promise||(p=Promise.resolve(p)),{result:p,checkboxChecked:h}}}e.AbstractDialogHandler=w,e.IFileDialogService=(0,O.createDecorator)("fileDialogService");var b;(function(v){v[v.SAVE=0]="SAVE",v[v.DONT_SAVE=1]="DONT_SAVE",v[v.CANCEL=2]="CANCEL"})(b||(e.ConfirmResult=b={}));const E=10;function u(v){const m=[];return m.push(...v.slice(0,E).map(g=>typeof g=="string"?g:(0,C.basename)(g))),v.length>E&&(v.length-E===1?m.push((0,r.localize)(7,null)):m.push((0,r.localize)(8,null,v.length-E))),m.push(""),m.join(`
`)}e.getFileNamesMessage=u;function y(v,m){const g=(0,f.deepClone)(v);let h=(g.buttons??[]).map(t=>(0,M.mnemonicButtonLabel)(t)),d=(v.buttons||[]).map((t,o)=>o),p=0,a=g.cancelId??h.length-1;if(h.length>1){const t=typeof a=="number"?h[a]:void 0;if(I.isLinux||I.isMacintosh){if(typeof t=="string"&&h.length>1&&a!==1){h.splice(a,1),h.splice(1,0,t);const o=d[a];d.splice(a,1),d.splice(1,0,o),a=1}I.isLinux&&h.length>1&&(h=h.reverse(),d=d.reverse(),p=h.length-1,typeof t=="string"&&(a=p-1))}else if(I.isWindows&&typeof t=="string"&&h.length>1&&a!==h.length-1){h.splice(a,1),h.push(t);const o=d[a];d.splice(a,1),d.push(o),a=h.length-1}}return g.buttons=h,g.defaultId=p,g.cancelId=a,g.noLink=!0,g.title=g.title||m.nameLong,{options:g,buttonIndeces:d}}e.massageMessageBoxOptions=y}),define(oe[117],ae([0,1,6]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isGnome=e.isKwallet=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.IEncryptionMainService=e.IEncryptionService=void 0,e.IEncryptionService=(0,C.createDecorator)("encryptionService"),e.IEncryptionMainService=(0,C.createDecorator)("encryptionMainService");var L;(function(I){I.kwallet="kwallet",I.kwallet5="kwallet5",I.gnome="gnome",I.gnomeKeyring="gnome-keyring",I.gnomeLibsecret="gnome-libsecret",I.basic="basic"})(L||(e.PasswordStoreCLIOption=L={}));var r;(function(I){I.unknown="unknown",I.basicText="basic_text",I.gnomeAny="gnome_any",I.gnomeLibsecret="gnome_libsecret",I.gnomeKeyring="gnome_keyring",I.kwallet="kwallet",I.kwallet5="kwallet5",I.kwallet6="kwallet6",I.dplib="dpapi",I.keychainAccess="keychain_access"})(r||(e.KnownStorageProvider=r={}));function O(I){return I==="kwallet"||I==="kwallet5"||I==="kwallet6"}e.isKwallet=O;function M(I){return I==="gnome_any"||I==="gnome_libsecret"||I==="gnome_keyring"}e.isGnome=M}),define(oe[38],ae([0,1,6]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,C.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,C.refineServiceDecorator)(e.IEnvironmentService)}),define(oe[118],ae([0,1,170,6]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function r(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=r;function O(d){switch(d){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=O;function M(d,p){switch(d){case 3:return p==="x64"?"win32-x64":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":p==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=M;function I(d,p){return p==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function f(d,p,a){return I(p,a)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===a}e.isTargetPlatformCompatible=f;function l(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=l;var w;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var b;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var E;(function(d){d.Install="install",d.Uninstall="uninstall"})(E||(e.StatisticType=E={}));var u;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(u||(e.InstallOperation=u={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var y;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.DownloadSignature="DownloadSignature",d.UpdateMetadata="UpdateMetadata",d.Extract="Extract",d.Scanning="Scanning",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Signature="Signature",d.NotAllowed="NotAllowed",d.Gallery="Gallery",d.Unknown="Unknown",d.Internal="Internal"})(y||(e.ExtensionManagementErrorCode=y={}));var v;(function(d){d.UnknownError="UnknownError",d.PackageIsInvalidZip="PackageIsInvalidZip",d.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(v||(e.ExtensionSignaturetErrorCode=v={}));class m extends Error{constructor(p,a){super(p),this.code=a,this.name=a}}e.ExtensionManagementError=m;var g;(function(d){d.Timeout="Timeout",d.Cancelled="Cancelled",d.Failed="Failed"})(g||(e.ExtensionGalleryErrorCode=g={}));class h extends Error{constructor(p,a){super(p),this.code=a,this.name=a}}e.ExtensionGalleryError=h,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,C.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel=(0,C.localize2)(1,"Preferences")}),define(oe[209],ae([0,1,6]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,C.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(oe[210],ae([0,1,6]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,C.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(oe[211],ae([0,1,6]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=void 0,e.IExternalTerminalMainService=(0,C.createDecorator)("externalTerminal")}),define(oe[212],ae([0,1,48,50,13,9,4,76,21,89,174,210]),function(Q,e,C,L,r,O,M,I,f,l,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const E=w.localize(0,null);class u{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends u{static{this.CMD="cmd.exe"}openTerminal(a,t){return this.spawnTerminal(C,a,l.getWindowsShell(),t)}spawnTerminal(a,t,o,s){const i=t.windowsExec||y.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const n=O.basename(i,".exe").toLowerCase();if(n==="cmder")return a.spawn(i,s?[s]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return i.indexOf(" ")>=0&&c.push('""'),c.push(i),n==="wt"&&c.push("-d ."),new Promise((S,R)=>{const k=g(process),P=a.spawn(o,c,{cwd:s,env:k,detached:!0});P.on("error",R),P.on("exit",()=>S())})}async runInTerminal(a,t,o,s,i){const n="windowsExec"in i&&i.windowsExec?i.windowsExec:y.getDefaultTerminalWindows(),c=await y.getWtExePath();return new Promise((S,R)=>{const k=`"${t} - ${E}"`,P=`""${o.join('" "')}" & pause"`,D=Object.assign({},g(process),s);Object.keys(D).filter(V=>D[V]===null).forEach(V=>delete D[V]);const _={cwd:t,env:D,windowsVerbatimArguments:!0};let N,U;O.basename(n,".exe")==="wt"?(N=n,U=["-d",".",y.CMD,"/c",P]):c?(N=c,U=["-d",t,n,"/c",P]):(N=y.CMD,U=["/c","start",k,"/wait",n,"/c",P]),C.spawn(N,U,_).on("error",V=>{R(h(V))}),S(void 0)})}static getDefaultTerminalWindows(){if(!y._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return y._DEFAULT_TERMINAL_WINDOWS}static async getWtExePath(){try{const a=await l.win32.findExecutable("wt");return await f.Promises.exists(a)?a:void 0}catch{return}}}e.WindowsExternalTerminalService=y,be([L.memoize],y,"getWtExePath",null);class v extends u{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(a,t){return this.spawnTerminal(C,a,t)}runInTerminal(a,t,o,s,i){const n=i.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((c,S)=>{if(n===b.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const R=n===b.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",P=[r.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${R}.scpt`).fsPath,"-t",a||E,"-w",t];for(const N of o)P.push("-a"),P.push(N);if(s){const N=Object.assign({},g(process),s);for(const U in N){const j=N[U];j===null?(P.push("-u"),P.push(U)):(P.push("-e"),P.push(`${U}=${j}`))}}let D="";const _=C.spawn(v.OSASCRIPT,P);_.on("error",N=>{S(h(N))}),_.stderr.on("data",N=>{D+=N.toString()}),_.on("exit",N=>{if(N===0)c(void 0);else if(D){const U=D.split(`
`,1);S(new Error(U[0]))}else S(new Error(w.localize(1,null,R,N)))})}else S(new Error(w.localize(2,null,n)))})}spawnTerminal(a,t,o){const s=t.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((i,n)=>{const c=["-a",s];o&&c.push(o);const S=g(process),R=a.spawn("/usr/bin/open",c,{cwd:o,env:S});R.on("error",n),R.on("exit",()=>i())})}}e.MacExternalTerminalService=v;class m extends u{static{this.WAIT_MESSAGE=w.localize(3,null)}openTerminal(a,t){return this.spawnTerminal(C,a,t)}runInTerminal(a,t,o,s,i){const n=i.linuxExec?Promise.resolve(i.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((c,S)=>{const R=[];n.then(k=>{k.indexOf("gnome-terminal")>=0?R.push("-x"):R.push("-e"),R.push("bash"),R.push("-c");const P=`${d(o)}; echo; read -p "${m.WAIT_MESSAGE}" -n1;`;R.push(`''${P}''`);const D=Object.assign({},g(process),s);Object.keys(D).filter(j=>D[j]===null).forEach(j=>delete D[j]);const _={cwd:t,env:D};let N="";const U=C.spawn(k,R,_);U.on("error",j=>{S(h(j))}),U.stderr.on("data",j=>{N+=j.toString()}),U.on("exit",j=>{if(j===0)c(void 0);else if(N){const V=N.split(`
`,1);S(new Error(V[0]))}else S(new Error(w.localize(4,null,k,j)))})})})}static async getDefaultTerminalLinuxReady(){if(!m._DEFAULT_TERMINAL_LINUX_READY)if(!M.isLinux)m._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const a=await f.Promises.exists("/etc/debian_version");m._DEFAULT_TERMINAL_LINUX_READY=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return m._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,t,o){const s=t.linuxExec?Promise.resolve(t.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((i,n)=>{s.then(c=>{const S=g(process),R=a.spawn(c,[],{cwd:o,env:S});R.on("error",n),R.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=m;function g(p){const a={...p.env};return(0,I.sanitizeProcessEnvironment)(a),a}function h(p){return"errno"in p&&p.errno==="ENOENT"&&"path"in p&&typeof p.path=="string"?new Error(w.localize(5,null,p.path)):p}function d(p){let a="";for(const t of p)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(oe[16],ae([0,1,58,9,25,12,7,176,6,4,13,62]),function(Q,e,C,L,r,O,M,I,f,l,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.isFileSystemWatcher=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function E(q){return q.create===!0}e.isFileOpenForWriteOptions=E;var u;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(u||(e.FileType=u={}));var y;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(y||(e.FilePermission=y={}));function v(q){const ee=q;return!!ee&&typeof ee.onDidChange=="function"}e.isFileSystemWatcher=v;var m;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function g(q){return!!(q.capabilities&2)}e.hasReadWriteCapability=g;function h(q){return!!(q.capabilities&8)}e.hasFileFolderCopyCapability=h;function d(q){return!!(q.capabilities&131072)}e.hasFileCloneCapability=d;function p(q){return!!(q.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function a(q){return!!(q.capabilities&16)}e.hasFileReadStreamCapability=a;function t(q){return g(q)?!!(q.capabilities&16384):!1}e.hasFileAtomicReadCapability=t;function o(q){return g(q)?!!(q.capabilities&32768):!1}e.hasFileAtomicWriteCapability=o;function s(q){return!!(q.capabilities&65536)}e.hasFileAtomicDeleteCapability=s;function i(q){return!!(q.capabilities&2048)}e.hasReadonlyCapability=i;var n;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class c extends Error{static create(ee,de){const G=new c(ee.toString(),de);return k(G,de),G}constructor(ee,de){super(ee),this.code=de}}e.FileSystemProviderError=c;function S(q,ee){return c.create(q,ee)}e.createFileSystemProviderError=S;function R(q){return q||S((0,I.localize)(0,null),n.Unknown)}e.ensureFileSystemProviderError=R;function k(q,ee){return q.name=ee?`${ee} (FileSystemError)`:"FileSystemError",q}e.markAsFileSystemProviderError=k;function P(q){if(!q)return n.Unknown;if(q instanceof c)return q.code;const ee=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!ee)return n.Unknown;switch(ee[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.toFileSystemProviderErrorCode=P;function D(q){if(q instanceof ce)return q.fileOperationResult;switch(P(q)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=D;var _;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(_||(e.FileOperation=_={}));class N{constructor(ee,de,G){this.resource=ee,this.operation=de,this.target=G}isOperation(ee){return this.operation===ee}}e.FileOperationEvent=N;var U;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class j{static{this.MIXED_CORRELATION=null}constructor(ee,de){this.ignorePathCasing=de,this.correlationId=void 0,this.added=new b.Lazy(()=>{const G=C.TernarySearchTree.forUris(()=>this.ignorePathCasing);return G.fill(this.rawAdded.map(A=>[A,!0])),G}),this.updated=new b.Lazy(()=>{const G=C.TernarySearchTree.forUris(()=>this.ignorePathCasing);return G.fill(this.rawUpdated.map(A=>[A,!0])),G}),this.deleted=new b.Lazy(()=>{const G=C.TernarySearchTree.forUris(()=>this.ignorePathCasing);return G.fill(this.rawDeleted.map(A=>[A,!0])),G}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const G of ee){switch(G.type){case 1:this.rawAdded.push(G.resource);break;case 0:this.rawUpdated.push(G.resource);break;case 2:this.rawDeleted.push(G.resource);break}this.correlationId!==j.MIXED_CORRELATION&&(typeof G.cId=="number"?this.correlationId===void 0?this.correlationId=G.cId:this.correlationId!==G.cId&&(this.correlationId=j.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=j.MIXED_CORRELATION))}}contains(ee,...de){return this.doContains(ee,{includeChildren:!1},...de)}affects(ee,...de){return this.doContains(ee,{includeChildren:!0},...de)}doContains(ee,de,...G){if(!ee)return!1;const A=G.length>0;return!!((!A||G.includes(1))&&(this.added.value.get(ee)||de.includeChildren&&this.added.value.findSuperstr(ee))||(!A||G.includes(0))&&(this.updated.value.get(ee)||de.includeChildren&&this.updated.value.findSuperstr(ee))||(!A||G.includes(2))&&(this.deleted.value.findSubstr(ee)||de.includeChildren&&this.deleted.value.findSuperstr(ee)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ee){return this.correlationId===ee}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=j;function V(q,ee,de){return!q||!ee||q===ee||ee.length>q.length?!1:(ee.charAt(ee.length-1)!==L.sep&&(ee+=L.sep),de?(0,r.startsWithIgnoreCase)(q,ee):q.indexOf(ee)===0)}e.isParent=V;class ce extends Error{constructor(ee,de,G){super(ee),this.fileOperationResult=de,this.options=G}}e.FileOperationError=ce;class se extends ce{constructor(ee,de,G,A){super(ee,de,A),this.fileOperationResult=de,this.size=G}}e.TooLargeFileOperationError=se;class ue extends ce{constructor(ee,de,G){super(ee,2,G),this.stat=de}}e.NotModifiedSinceFileOperationError=ue;var X;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(X||(e.FileOperationResult=X={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var Y;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(Y||(e.FileKind=Y={})),e.ETAG_DISABLED="";function x(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.etag=x;async function W(q,ee){if(!ee.hasProvider(M.URI.from({scheme:q.scheme})))return new Promise(de=>{const G=ee.onDidChangeFileSystemProviderRegistrations(A=>{A.scheme===q.scheme&&A.added&&(G.dispose(),de())})})}e.whenProviderRegistered=W;class F{static{this.KB=1024}static{this.MB=F.KB*F.KB}static{this.GB=F.MB*F.KB}static{this.TB=F.GB*F.KB}static formatSize(ee){return(0,O.isNumber)(ee)||(ee=0),ee<F.KB?(0,I.localize)(1,null,ee.toFixed(0)):ee<F.MB?(0,I.localize)(2,null,(ee/F.KB).toFixed(2)):ee<F.GB?(0,I.localize)(3,null,(ee/F.MB).toFixed(2)):ee<F.TB?(0,I.localize)(4,null,(ee/F.GB).toFixed(2)):(0,I.localize)(5,null,(ee/F.TB).toFixed(2))}}e.ByteSize=F;function H(q){const ee=typeof q=="string"||q?.scheme===w.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===w.Schemas.file?1024*F.MB:ee?10*F.MB:l.isWeb?50*F.MB:1024*F.MB}e.getLargeFileConfirmationLimit=H}),define(oe[119],ae([0,1,17,14,177,16]),function(Q,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function M(w,b,E,u,y,v){let m;try{await I(w,b,E,u,y,v)}catch(g){m=g}finally{m&&y.errorTransformer&&(m=y.errorTransformer(m)),typeof m<"u"&&E.error(m),E.end()}}e.readFileIntoStream=M;async function I(w,b,E,u,y,v){f(v);const m=await w.open(b,{create:!1});try{f(v);let g=0,h=0,d=y&&typeof y.length=="number"?y.length:void 0,p=C.VSBuffer.alloc(Math.min(y.bufferSize,typeof d=="number"?d:y.bufferSize)),a=y&&typeof y.position=="number"?y.position:0,t=0;do h=await w.read(m,a,p.buffer,t,p.byteLength-t),a+=h,t+=h,g+=h,typeof d=="number"&&(d-=h),t===p.byteLength&&(await E.write(u(p)),p=C.VSBuffer.alloc(Math.min(y.bufferSize,typeof d=="number"?d:y.bufferSize)),t=0);while(h>0&&(typeof d!="number"||d>0)&&f(v)&&l(g,y));if(t>0){let o=t;typeof d=="number"&&(o=Math.min(t,d)),E.write(u(p.slice(0,o)))}}catch(g){throw(0,O.ensureFileSystemProviderError)(g)}finally{await w.close(m)}}function f(w){if(w.isCancellationRequested)throw(0,L.canceled)();return!0}function l(w,b){if(typeof b?.limits?.size=="number"&&w>b.limits.size)throw(0,O.createFileSystemProviderError)((0,r.localize)(0,null),O.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[67],ae([0,1,105,2,9,4,7,16]),function(Q,e,C,L,r,O,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.reviveFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function f(g){return g.recursive===!0}e.isRecursiveWatchRequest=f;class l extends L.Disposable{static{this.MAX_RESTARTS=5}constructor(h,d,p,a){super(),this.onFileChanges=h,this.onLogMessage=d,this.verboseLogging=p,this.options=a,this.watcherDisposables=this._register(new L.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const h=new L.DisposableStore;this.watcherDisposables.value=h,this.watcher=this.createWatcher(h),this.watcher.setVerboseLogging(this.verboseLogging),h.add(this.watcher.onDidChangeFile(d=>this.onFileChanges(d))),h.add(this.watcher.onDidLogMessage(d=>this.onLogMessage(d))),h.add(this.watcher.onDidError(d=>this.onError(d)))}onError(h){this.options.restartOnError?this.restartCounter<l.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${h}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${h}`):this.error(h)}restart(h){this.restartCounter++,this.init(),this.watch(h)}async watch(h){this.requests=h,await this.watcher?.watch(h)}async setVerboseLogging(h){this.verboseLogging=h,await this.watcher?.setVerboseLogging(h)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${h}`})}trace(h){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${h}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=l;class w extends l{constructor(h,d,p){super(h,d,p,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=w;class b extends l{constructor(h,d,p){super(h,d,p,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=b;function E(g){return g.map(h=>({type:h.type,resource:M.URI.revive(h.resource),cId:h.cId}))}e.reviveFileChanges=E;function u(g){const h=new m;for(const d of g)h.processEvent(d);return h.coalesce()}e.coalesceEvents=u;function y(g,h){return typeof h=="string"&&!h.startsWith(C.GLOBSTAR)&&!(0,r.isAbsolute)(h)?{base:g,pattern:h}:h}e.normalizeWatcherPattern=y;function v(g,h){const d=[];for(const p of h)d.push((0,C.parse)(y(g,p)));return d}e.parseWatcherPatterns=v;class m{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(h){return O.isLinux?h.resource.fsPath:h.resource.fsPath.toLowerCase()}processEvent(h){const d=this.mapPathToChange.get(this.toKey(h));let p=!1;if(d){const a=d.type,t=h.type;d.resource.fsPath!==h.resource.fsPath&&(h.type===2||h.type===1)?p=!0:a===1&&t===2?(this.mapPathToChange.delete(this.toKey(h)),this.coalesced.delete(d)):a===2&&t===1?d.type=0:a===1&&t===0||(d.type=t)}else p=!0;p&&(this.coalesced.add(h),this.mapPathToChange.set(this.toKey(h),h))}coalesce(){const h=[],d=[];return Array.from(this.coalesced).filter(p=>p.type!==2?(h.push(p),!1):!0).sort((p,a)=>p.resource.fsPath.length-a.resource.fsPath.length).filter(p=>d.some(a=>(0,I.isParent)(p.resource.fsPath,a,!O.isLinux))?!1:(d.push(p.resource.fsPath),!0)).concat(h)}}}),define(oe[213],ae([0,1,17,51,14,3,2,63,32,16,67]),function(Q,e,C,L,r,O,M,I,f,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class b extends M.Disposable{constructor(u,y){super(),this.channel=u,this.extraCapabilities=y,this.onDidChangeCapabilities=O.Event.None,this._onDidChange=this._register(new O.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new O.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,f.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=253982,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(u){return this.channel.call("stat",[u])}readdir(u){return this.channel.call("readdir",[u])}async readFile(u,y){const{buffer:v}=await this.channel.call("readFile",[u,y]);return v}readFileStream(u,y,v){const m=(0,I.newWriteableStream)(h=>C.VSBuffer.concat(h.map(d=>C.VSBuffer.wrap(d))).buffer),g=new M.DisposableStore;return g.add(this.channel.listen("readFileStream",[u,y])(h=>{if(h instanceof C.VSBuffer)m.write(h.buffer);else{if(h==="end")m.end();else{let d;if(h instanceof Error)d=h;else{const p=h;d=(0,l.createFileSystemProviderError)(p.message??(0,L.toErrorMessage)(p),p.code??l.FileSystemProviderErrorCode.Unknown)}m.error(d),m.end()}g.dispose()}})),g.add(v.onCancellationRequested(()=>{m.error((0,r.canceled)()),m.end(),g.dispose()})),m}writeFile(u,y,v){return this.channel.call("writeFile",[u,C.VSBuffer.wrap(y),v])}open(u,y){return this.channel.call("open",[u,y])}close(u){return this.channel.call("close",[u])}async read(u,y,v,m,g){const[h,d]=await this.channel.call("read",[u,y,g]);return v.set(h.buffer.slice(0,d),m),d}write(u,y,v,m,g){return this.channel.call("write",[u,y,C.VSBuffer.wrap(v),m,g])}mkdir(u){return this.channel.call("mkdir",[u])}delete(u,y){return this.channel.call("delete",[u,y])}rename(u,y,v){return this.channel.call("rename",[u,y,v])}copy(u,y,v){return this.channel.call("copy",[u,y,v])}cloneFile(u,y){return this.channel.call("cloneFile",[u,y])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(u=>{if(Array.isArray(u)){const y=u;this._onDidChange.fire((0,w.reviveFileChanges)(y))}else{const y=u;this._onDidWatchError.fire(y)}}))}watch(u,y){const v=(0,f.generateUuid)();return this.channel.call("watch",[this.sessionId,v,u,y]),(0,M.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,v]))}}e.DiskFileSystemProviderClient=b}),define(oe[214],ae([0,1,46,8,23,33,2,85,9,4,19,7,106,21,67]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class v extends M.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(h,d,p,a){super(),this.request=h,this.onDidFilesChange=d,this.onLogMessage=p,this.verboseLogging=a,this.throttledFileChangesEmitter=this._register(new L.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.onDidFilesChange(t))),this.fileChangesAggregator=this._register(new L.RunOnceWorker(t=>this.handleFileChanges(t),v.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,y.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,y.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new r.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const h=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const d=await u.Promises.stat(h);this._register(await this.doWatch(h,d.isDirectory()))}catch(h){h.code!=="ENOENT"?this.error(h):this.trace(h)}}async normalizePath(h){let d=h.path;try{d=await u.Promises.realpath(h.path),h.path===d&&(d=await(0,E.realcase)(h.path)??h.path),h.path!==d&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${h.path}, real: ${d})`)}catch{}return d}async doWatch(h,d){if(l.isMacintosh&&(0,O.isEqualOrParent)(h,"/Volumes/",!0))return this.error(`Refusing to watch ${h} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const p=new r.CancellationTokenSource(this.cts.token),a=new M.DisposableStore;try{const t=b.URI.file(this.request.path),o=(0,f.basename)(h),s=(0,C.watch)(h);a.add((0,M.toDisposable)(()=>{s.removeAllListeners(),s.close()})),this.trace(`Started watching: '${h}'`);const i=new Set;if(d)try{for(const c of await u.Promises.readdir(h))i.add(c)}catch(c){this.error(c)}const n=new Map;a.add((0,M.toDisposable)(()=>{for(const[,c]of n)c.dispose();n.clear()})),s.on("error",(c,S)=>{this.error(`Failed to watch ${h} for changes using fs.watch() (${c}, ${S})`),this.dispose()}),s.on("change",(c,S)=>{if(p.token.isCancellationRequested)return;this.trace(`[raw] ["${c}"] ${S}`);let R="";if(S&&(R=S.toString(),l.isMacintosh&&(R=(0,I.normalizeNFC)(R))),!(!R||c!=="change"&&c!=="rename"))if(d)if(c==="rename"){n.get(R)?.dispose();const k=setTimeout(async()=>{if(n.delete(R),R===o&&!await u.Promises.exists(h)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const P=await this.existsChildStrictCase((0,f.join)(h,R));if(p.token.isCancellationRequested)return;let D;P?i.has(R)?D=0:(D=1,i.add(R)):(i.delete(R),D=2),this.onFileChange({resource:(0,w.joinPath)(t,R),type:D,cId:this.request.correlationId})},v.FILE_DELETE_HANDLER_DELAY);n.set(R,(0,M.toDisposable)(()=>clearTimeout(k)))}else{let k;i.has(R)?k=0:(k=1,i.add(R)),this.onFileChange({resource:(0,w.joinPath)(t,R),type:k,cId:this.request.correlationId})}else if(c==="rename"||R!==o){const k=setTimeout(async()=>{const P=await u.Promises.exists(h);p.token.isCancellationRequested||(P?(this.onFileChange({resource:t,type:0,cId:this.request.correlationId},!0),a.add(await this.doWatch(h,!1))):(this.onFileChange({resource:t,type:2,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.dispose()))},v.FILE_DELETE_HANDLER_DELAY);a.clear(),a.add((0,M.toDisposable)(()=>clearTimeout(k)))}else this.onFileChange({resource:t,type:0,cId:this.request.correlationId},!0)})}catch(t){await u.Promises.exists(h)&&!p.token.isCancellationRequested&&this.error(`Failed to watch ${h} for changes using fs.watch() (${t.toString()})`)}return(0,M.toDisposable)(()=>{p.dispose(!0),a.dispose()})}onFileChange(h,d=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`),!d&&this.excludes.some(p=>p(h.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${h.resource.fsPath}`):!d&&this.includes&&this.includes.length>0&&!this.includes.some(p=>p(h.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (not included) ${h.resource.fsPath}`):this.fileChangesAggregator.work(h))}handleFileChanges(h){const d=(0,y.coalesceEvents)(h);if(d.length>0){if(this.verboseLogging)for(const a of d)this.trace(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.throttledFileChangesEmitter.work(d)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${d.length}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(h){if(l.isLinux)return u.Promises.exists(h);try{const d=(0,f.basename)(h);return(await u.Promises.readdir((0,f.dirname)(h))).some(a=>a===d)}catch(d){return this.trace(d),!1}}setVerboseLogging(h){this.verboseLogging=h}error(h){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${h}`})}warn(h){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${h}`})}trace(h){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${h}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=v;async function m(g,h,d,p,a=512){const t=await u.Promises.open(g,"r"),o=Buffer.allocUnsafe(a),s=new r.CancellationTokenSource(p);let i,n=!1;const c={path:g,excludes:[],recursive:!1},S=new v(c,R=>{(async()=>{for(const{type:k}of R)if(k===0){if(n)return;n=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:P}=await u.Promises.read(t,o,0,a,null);if(!P||s.token.isCancellationRequested)break;h(o.slice(0,P))}}catch(P){i=new Error(P),s.dispose(!0)}finally{n=!1}}})()});return await S.ready,d(),new Promise((R,k)=>{s.token.onCancellationRequested(async()=>{S.dispose();try{await u.Promises.close(t)}catch(P){i=new Error(P)}i?k(i):R()})})}e.watchFileContents=m}),define(oe[215],ae([0,1,3,105,2,4,214]),function(Q,e,C,L,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends r.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new C.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=C.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(l){const w=this.normalizeRequests(l),b=w.filter(u=>{const y=this.watchers.get(u.path);return y?!(0,L.patternsEquals)(y.request.excludes,u.excludes)||!(0,L.patternsEquals)(y.request.includes,u.includes):!0}),E=Array.from(this.watchers.values()).filter(({request:u})=>!w.find(y=>y.path===u.path&&(0,L.patternsEquals)(y.excludes,u.excludes)&&(0,L.patternsEquals)(y.includes,u.includes))).map(({request:u})=>u.path);b.length&&this.trace(`Request to start watching: ${b.map(u=>`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"}, correlationId: ${typeof u.correlationId=="number"?u.correlationId:"<none>"})`).join(",")}`),E.length&&this.trace(`Request to stop watching: ${E.join(",")}`);for(const u of E)this.stopWatching(u);for(const u of b)this.startWatching(u)}startWatching(l){const w=new M.NodeJSFileWatcherLibrary(l,E=>this._onDidChangeFile.fire(E),E=>this._onDidLogMessage.fire(E),this.verboseLogging),b={request:l,instance:w};this.watchers.set(l.path,b)}async stop(){for(const[l]of this.watchers)this.stopWatching(l);this.watchers.clear()}stopWatching(l){const w=this.watchers.get(l);w&&(this.watchers.delete(l),w.instance.dispose())}normalizeRequests(l){const w=new Map;for(const b of l){const E=O.isLinux?b.path:b.path.toLowerCase();let u=w.get(b.correlationId);u||(u=new Map,w.set(b.correlationId,u)),u.set(E,b)}return Array.from(w.values()).map(b=>Array.from(b.values())).flat()}async setVerboseLogging(l){this.verboseLogging=l;for(const[,w]of this.watchers)w.instance.setVerboseLogging(l)}trace(l){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(l)})}toMessage(l,w){return w?`[File Watcher (node.js)] ${l} (path: ${w.request.path})`:`[File Watcher (node.js)] ${l}`}}e.NodeJSWatcher=I}),define(oe[216],ae([0,1,67,215]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class r extends C.AbstractNonRecursiveWatcherClient{constructor(M,I,f){super(M,I,f),this.init()}createWatcher(M){return M.add(new L.NodeJSWatcher)}}e.NodeJSWatcherClient=r}),define(oe[217],ae([0,1,13,43,160,67]),function(Q,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class M extends O.AbstractUniversalWatcherClient{constructor(f,l,w){super(f,l,w),this.init()}createWatcher(f){const l=f.add(new r.Client(C.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(l.onDidProcessExit(({code:w,signal:b})=>this.onError(`terminated by itself with code ${w}, signal: ${b}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(l.getChannel("watcher")))}}e.UniversalWatcherClient=M}),define(oe[92],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class C{constructor(...r){this._entries=new Map;for(const[O,M]of r)this.set(O,M)}set(r,O){const M=this._entries.get(r);return this._entries.set(r,O),M}has(r){return this._entries.has(r)}get(r){return this._entries.get(r)}}e.ServiceCollection=C}),define(oe[218],ae([0,1,8,14,2,78,208,6,92,102]),function(Q,e,C,L,r,O,M,I,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const w=!1;class b extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class E{constructor(m=new f.ServiceCollection,g=!1,h,d=w){this._services=m,this._strict=g,this._parent=h,this._enableTracing=d,this._activeInstantiations=new Set,this._services.set(I.IInstantiationService,this),this._globalGraph=d?h?._globalGraph??new M.Graph(p=>p):void 0}createChild(m){return new E(m,this._strict,this,this._enableTracing)}invokeFunction(m,...g){const h=y.traceInvocation(this._enableTracing,m);let d=!1;try{return m({get:a=>{if(d)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(a,h);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...g)}finally{d=!0,h.stop()}}createInstance(m,...g){let h,d;return m instanceof O.SyncDescriptor?(h=y.traceCreation(this._enableTracing,m.ctor),d=this._createInstance(m.ctor,m.staticArguments.concat(g),h)):(h=y.traceCreation(this._enableTracing,m),d=this._createInstance(m,g,h)),h.stop(),d}_createInstance(m,g=[],h){const d=I._util.getServiceDependencies(m).sort((t,o)=>t.index-o.index),p=[];for(const t of d){const o=this._getOrCreateServiceInstance(t.id,h);o||this._throwIfStrict(`[createInstance] ${m.name} depends on UNKNOWN service ${t.id}.`,!1),p.push(o)}const a=d.length>0?d[0].index:g.length;if(g.length!==a){console.trace(`[createInstance] First service dependency of ${m.name} at position ${a+1} conflicts with ${g.length} static arguments`);const t=a-g.length;t>0?g=g.concat(new Array(t)):g=g.slice(0,a)}return Reflect.construct(m,g.concat(p))}_setServiceInstance(m,g){if(this._services.get(m)instanceof O.SyncDescriptor)this._services.set(m,g);else if(this._parent)this._parent._setServiceInstance(m,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(m){const g=this._services.get(m);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(m):g}_getOrCreateServiceInstance(m,g){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(m));const h=this._getServiceInstanceOrDescriptor(m);return h instanceof O.SyncDescriptor?this._safeCreateAndCacheServiceInstance(m,h,g.branch(m,!0)):(g.branch(m,!1),h)}_safeCreateAndCacheServiceInstance(m,g,h){if(this._activeInstantiations.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this._activeInstantiations.add(m);try{return this._createAndCacheServiceInstance(m,g,h)}finally{this._activeInstantiations.delete(m)}}_createAndCacheServiceInstance(m,g,h){const d=new M.Graph(t=>t.id.toString());let p=0;const a=[{id:m,desc:g,_trace:h}];for(;a.length;){const t=a.pop();if(d.lookupOrInsertNode(t),p++>1e3)throw new b(d);for(const o of I._util.getServiceDependencies(t.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(o.id);if(s||this._throwIfStrict(`[createInstance] ${m} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),s instanceof O.SyncDescriptor){const i={id:o.id,desc:s,_trace:t._trace.branch(o.id,!0)};d.insertEdge(t,i),a.push(i)}}}for(;;){const t=d.roots();if(t.length===0){if(!d.isEmpty())throw new b(d);break}for(const{data:o}of t){if(this._getServiceInstanceOrDescriptor(o.id)instanceof O.SyncDescriptor){const i=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,i)}d.removeNode(o)}}return this._getServiceInstanceOrDescriptor(m)}_createServiceInstanceWithOwner(m,g,h=[],d,p){if(this._services.get(m)instanceof O.SyncDescriptor)return this._createServiceInstance(m,g,h,d,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(m,g,h,d,p);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(m,g,h=[],d,p){if(d){const a=new E(void 0,this._strict,this,this._enableTracing);a._globalGraphImplicitDependency=String(m);const t=new Map,o=new C.GlobalIdleValue(()=>{const s=a._createInstance(g,h,p);for(const[i,n]of t){const c=s[i];if(typeof c=="function")for(const S of n)S.disposable=c.apply(s,S.listener)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let S=t.get(i);return S||(S=new l.LinkedList,t.set(i,S)),(k,P,D)=>{if(o.isInitialized)return o.value[i](k,P,D);{const _={listener:[k,P,D],disposable:void 0},N=S.push(_);return(0,r.toDisposable)(()=>{N(),_.disposable?.dispose()})}}}if(i in s)return s[i];const n=o.value;let c=n[i];return typeof c!="function"||(c=c.bind(n),s[i]=c),c},set(s,i,n){return o.value[i]=n,!0},getPrototypeOf(s){return g.prototype}})}else return this._createInstance(g,h,p)}_throwIfStrict(m,g){if(g&&console.warn(m),this._strict)throw new Error(m)}}e.InstantiationService=E;var u;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(u||(u={}));class y{static{this.all=new Set}static{this._None=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,g){return m?new y(2,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y._None}static traceCreation(m,g){return m?new y(1,g.name):y._None}static{this._totals=0}constructor(m,g){this.type=m,this.name=g,this._start=Date.now(),this._dep=[]}branch(m,g){const h=new y(3,m.toString());return this._dep.push([m,g,h]),h}stop(){const m=Date.now()-this._start;y._totals+=m;let g=!1;function h(p,a){const t=[],o=new Array(p+1).join("	");for(const[s,i,n]of a._dep)if(i&&n){g=!0,t.push(`${o}CREATES -> ${s}`);const c=h(p+1,n);c&&t.push(c)}else t.push(`${o}uses -> ${s}`);return t.join(`
`)}const d=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${y._totals.toFixed(2)}ms)`];(m>2||g)&&y.all.add(d.join(`
`))}}e.Trace=y}),define(oe[219],ae([0,1,6]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IIssueMainService=e.IssueType=void 0;var L;(function(r){r[r.Bug=0]="Bug",r[r.PerformanceIssue=1]="PerformanceIssue",r[r.FeatureRequest=2]="FeatureRequest"})(L||(e.IssueType=L={})),e.IIssueMainService=(0,C.createDecorator)("issueService")}),define(oe[5],ae([0,1,51,3,45,2,31,4,19,12,7,115,6]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function u(){return new Date().toISOString()}function y(k){return(0,l.isNumber)(k)}e.isLogLevel=y;var v;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(v||(e.LogLevel=v={})),e.DEFAULT_LOG_LEVEL=v.Info;function m(k,P,D){switch(P){case v.Trace:k.trace(D);break;case v.Debug:k.debug(D);break;case v.Info:k.info(D);break;case v.Warning:k.warn(D);break;case v.Error:k.error(D);break;case v.Off:break;default:throw new Error(`Invalid log level ${P}`)}}e.log=m;function g(k,P=!1){let D="";for(let _=0;_<k.length;_++){let N=k[_];if(N instanceof Error&&(N=(0,C.toErrorMessage)(N,P)),typeof N=="object")try{N=JSON.stringify(N)}catch{}D+=(_>0?" ":"")+N}return D}class h extends O.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(P){this.level!==P&&(this.level=P,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(P){return this.level!==v.Off&&this.level<=P}}e.AbstractLogger=h;class d extends h{constructor(P){super(),this.logAlways=P}checkLogLevel(P){return this.logAlways||super.checkLogLevel(P)}trace(P,...D){this.checkLogLevel(v.Trace)&&this.log(v.Trace,g([P,...D],!0))}debug(P,...D){this.checkLogLevel(v.Debug)&&this.log(v.Debug,g([P,...D]))}info(P,...D){this.checkLogLevel(v.Info)&&this.log(v.Info,g([P,...D]))}warn(P,...D){this.checkLogLevel(v.Warning)&&this.log(v.Warning,g([P,...D]))}error(P,...D){if(this.checkLogLevel(v.Error))if(P instanceof Error){const _=Array.prototype.slice.call(arguments);_[0]=P.stack,this.log(v.Error,g(_))}else this.log(v.Error,g([P,...D]))}flush(){}}e.AbstractMessageLogger=d;class p extends h{constructor(P=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(P),this.useColors=!I.isWindows}trace(P,...D){this.checkLogLevel(v.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,P,...D):console.log(`[main ${u()}]`,P,...D))}debug(P,...D){this.checkLogLevel(v.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,P,...D):console.log(`[main ${u()}]`,P,...D))}info(P,...D){this.checkLogLevel(v.Info)&&(this.useColors?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,P,...D):console.log(`[main ${u()}]`,P,...D))}warn(P,...D){this.checkLogLevel(v.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${u()}]\x1B[0m`,P,...D):console.warn(`[main ${u()}]`,P,...D))}error(P,...D){this.checkLogLevel(v.Error)&&(this.useColors?console.error(`\x1B[91m[main ${u()}]\x1B[0m`,P,...D):console.error(`[main ${u()}]`,P,...D))}flush(){}}e.ConsoleMainLogger=p;class a extends h{constructor(P=e.DEFAULT_LOG_LEVEL,D=!0){super(),this.useColors=D,this.setLevel(P)}trace(P,...D){this.checkLogLevel(v.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",P,...D):console.log(P,...D))}debug(P,...D){this.checkLogLevel(v.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",P,...D):console.log(P,...D))}info(P,...D){this.checkLogLevel(v.Info)&&(this.useColors?console.log("%c INFO","color: #33f",P,...D):console.log(P,...D))}warn(P,...D){this.checkLogLevel(v.Warning)&&(this.useColors?console.log("%c WARN","color: #993",P,...D):console.log(P,...D))}error(P,...D){this.checkLogLevel(v.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",P,...D):console.error(P,...D))}flush(){}}e.ConsoleLogger=a;class t extends h{constructor(P,D=e.DEFAULT_LOG_LEVEL){super(),this.adapter=P,this.setLevel(D)}trace(P,...D){this.checkLogLevel(v.Trace)&&this.adapter.log(v.Trace,[this.extractMessage(P),...D])}debug(P,...D){this.checkLogLevel(v.Debug)&&this.adapter.log(v.Debug,[this.extractMessage(P),...D])}info(P,...D){this.checkLogLevel(v.Info)&&this.adapter.log(v.Info,[this.extractMessage(P),...D])}warn(P,...D){this.checkLogLevel(v.Warning)&&this.adapter.log(v.Warning,[this.extractMessage(P),...D])}error(P,...D){this.checkLogLevel(v.Error)&&this.adapter.log(v.Error,[this.extractMessage(P),...D])}extractMessage(P){return typeof P=="string"?P:(0,C.toErrorMessage)(P,this.checkLogLevel(v.Trace))}flush(){}}e.AdapterLogger=t;class o extends h{constructor(P){super(),this.loggers=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const D of this.loggers)D.setLevel(P);super.setLevel(P)}trace(P,...D){for(const _ of this.loggers)_.trace(P,...D)}debug(P,...D){for(const _ of this.loggers)_.debug(P,...D)}info(P,...D){for(const _ of this.loggers)_.info(P,...D)}warn(P,...D){for(const _ of this.loggers)_.warn(P,...D)}error(P,...D){for(const _ of this.loggers)_.error(P,...D)}flush(){for(const P of this.loggers)P.flush()}dispose(){for(const P of this.loggers)P.dispose();super.dispose()}}e.MultiplexLogger=o;class s extends O.Disposable{constructor(P,D,_){if(super(),this.logLevel=P,this.logsHome=D,this._loggers=new M.ResourceMap,this._onDidChangeLoggers=this._register(new L.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new L.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,_)for(const N of _)this._loggers.set(N.resource,{logger:void 0,info:N})}getLoggerEntry(P){return(0,l.isString)(P)?[...this._loggers.values()].find(D=>D.info.id===P):this._loggers.get(P)}getLogger(P){return this.getLoggerEntry(P)?.logger}createLogger(P,D){const _=this.toResource(P),N=(0,l.isString)(P)?P:D?.id??(0,r.hash)(_.toString()).toString(16);let U=this._loggers.get(_)?.logger;const j=D?.logLevel==="always"?v.Trace:D?.logLevel;U||(U=this.doCreateLogger(_,j??this.getLogLevel(_)??this.logLevel,{...D,id:N}));const V={logger:U,info:{resource:_,id:N,logLevel:j,name:D?.name,hidden:D?.hidden,extensionId:D?.extensionId,when:D?.when}};return this.registerLogger(V.info),this._loggers.set(_,V),U}toResource(P){return(0,l.isString)(P)?(0,f.joinPath)(this.logsHome,`${P}.log`):P}setLogLevel(P,D){if(w.URI.isUri(P)){const _=P,N=D,U=this._loggers.get(_);U&&N!==U.info.logLevel&&(U.info.logLevel=N===this.logLevel?void 0:N,U.logger?.setLevel(N),this._loggers.set(U.info.resource,U),this._onDidChangeLogLevel.fire([_,N]))}else{this.logLevel=P;for(const[_,N]of this._loggers.entries())this._loggers.get(_)?.info.logLevel===void 0&&N.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(P,D){const _=this.getLoggerEntry(P);_&&D!==!_.info.hidden&&(_.info.hidden=!D,this._loggers.set(_.info.resource,_),this._onDidChangeVisibility.fire([_.info.resource,D]))}getLogLevel(P){let D;return P&&(D=this._loggers.get(P)?.info.logLevel),D??this.logLevel}registerLogger(P){const D=this._loggers.get(P.resource);D?D.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this._loggers.set(P.resource,{info:P,logger:void 0}),this._onDidChangeLoggers.fire({added:[P],removed:[]}))}deregisterLogger(P){const D=this._loggers.get(P);D&&(D.logger&&D.logger.dispose(),this._loggers.delete(P),this._onDidChangeLoggers.fire({added:[],removed:[D.info]}))}*getRegisteredLoggers(){for(const P of this._loggers.values())yield P.info}getRegisteredLogger(P){return this._loggers.get(P)?.info}dispose(){this._loggers.forEach(P=>P.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=s;class i{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(P){}getLevel(){return v.Info}trace(P,...D){}debug(P,...D){}info(P,...D){}warn(P,...D){}error(P,...D){}critical(P,...D){}dispose(){}flush(){}}e.NullLogger=i;class n extends i{}e.NullLogService=n;function c(k){if(k.verbose)return v.Trace;if(typeof k.logLevel=="string"){const P=R(k.logLevel.toLowerCase());if(P!==void 0)return P}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function S(k){switch(k){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.LogLevelToString=S;function R(k){switch(k){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.parseLogLevel=R,e.CONTEXT_LOG_LEVEL=new b.RawContextKey("logLevel",S(v.Info))});var ne=this&&this.__param||function(Q,e){return function(C,L){e(C,L,Q)}};define(oe[220],ae([0,1,15,4,5]),function(Q,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;const O=C.safeStorage;let M=class{constructor(f){this.logService=f,C.app.commandLine.getSwitchValue("password-store")==="basic"&&O.setUsePlainTextEncryption?.(!0)}async encrypt(f){this.logService.trace("[EncryptionMainService] Encrypting value.");try{const l=JSON.stringify(O.encryptString(f));return this.logService.trace("[EncryptionMainService] Encrypted value."),l}catch(l){throw this.logService.error(l),l}}async decrypt(f){let l;try{if(l=JSON.parse(f),!l.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${f}`);const w=Buffer.from(l.data);this.logService.trace("[EncryptionMainService] Decrypting value.");const b=O.decryptString(w);return this.logService.trace("[EncryptionMainService] Decrypted value."),b}catch(w){throw this.logService.error(w),w}}isEncryptionAvailable(){return Promise.resolve(O.isEncryptionAvailable())}getKeyStorageProvider(){if(L.isWindows)return Promise.resolve("dpapi");if(L.isMacintosh)return Promise.resolve("keychain_access");if(O.getSelectedStorageBackend)try{const f=O.getSelectedStorageBackend();return Promise.resolve(f)}catch(f){this.logService.error(f)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(L.isWindows)throw new Error("Setting plain text encryption is not supported on Windows.");if(L.isMacintosh)throw new Error("Setting plain text encryption is not supported on macOS.");if(!O.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");O.setUsePlainTextEncryption(!0)}};e.EncryptionMainService=M,e.EncryptionMainService=M=be([ne(0,r.ILogService)],M)}),define(oe[221],ae([0,1,22,8,14,3,2,9,67,5]),function(Q,e,C,L,r,O,M,I,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class w extends M.Disposable{constructor(E,u){super(),this.logService=E,this.options=u,this._onDidChangeFile=this._register(new O.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new O.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new L.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}watch(E,u){return u.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(E,u):this.watchNonRecursive(E,u)}watchUniversal(E,u){const y={path:this.toFilePath(E),excludes:u.excludes,includes:u.includes,recursive:u.recursive,correlationId:u.correlationId},v=(0,C.insert)(this.universalPathsToWatch,y);return this.refreshUniversalWatchers(),(0,M.toDisposable)(()=>{v(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(E=>(0,r.onUnexpectedError)(E))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(u=>this._onDidChangeFile.fire((0,f.reviveFileChanges)(u)),u=>this.onWatcherLogMessage(u),this.logService.getLevel()===l.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===l.LogLevel.Trace)})));const E=this.options?.watcher?.recursive?.usePolling;if(E===!0)for(const u of this.universalPathsToWatch)(0,f.isRecursiveWatchRequest)(u)&&(u.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(E))for(const u of this.universalPathsToWatch)(0,f.isRecursiveWatchRequest)(u)&&E.includes(u.path)&&(u.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(E,u){const y={path:this.toFilePath(E),excludes:u.excludes,includes:u.includes,recursive:!1,correlationId:u.correlationId},v=(0,C.insert)(this.nonRecursivePathsToWatch,y);return this.refreshNonRecursiveWatchers(),(0,M.toDisposable)(()=>{v(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(E=>(0,r.onUnexpectedError)(E))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(E=>this._onDidChangeFile.fire((0,f.reviveFileChanges)(E)),E=>this.onWatcherLogMessage(E),this.logService.getLevel()===l.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===l.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(E){E.type==="error"&&this._onDidWatchError.fire(E.message),this.logService[E.type](E.message)}toFilePath(E){return(0,I.normalize)(E.fsPath)}}e.AbstractDiskFileSystemProvider=w}),define(oe[222],ae([0,1,22,8,17,23,3,45,72,2,58,13,68,19,63,175,16,119,5,14]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y,v,m,g,h,d){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let a=class extends l.Disposable{static{p=this}constructor(o){super(),this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new M.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new M.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new M.Emitter),this._onDidUncorrelatedFilesChange=this._register(new M.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new M.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(o,s){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${o}`);const i=new l.DisposableStore;return this.provider.set(o,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:s}),i.add(s.onDidChangeFile(n=>{const c=new m.FileChangesEvent(n,!this.isPathCaseSensitive(s));this.internalOnDidFilesChange.fire(c),c.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(c)})),typeof s.onDidWatchError=="function"&&i.add(s.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),i.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:o}))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:s}),this.provider.delete(o),(0,l.dispose)(i)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(i){s.push(i)}}),!this.provider.has(o)&&await L.Promises.settled(s)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,s){const i=this.provider.get(o.scheme);return!!(i&&i.capabilities&s)}listCapabilities(){return f.Iterable.map(this.provider,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async withProvider(o){if(!(0,u.isAbsolutePath)(o))throw new m.FileOperationError((0,v.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const s=this.provider.get(o.scheme);if(!s){const i=new d.ErrorNoTelemetry;throw i.message=(0,v.localize)(1,null,o.toString()),i}return s}async withReadProvider(o){const s=await this.withProvider(o);if((0,m.hasOpenReadWriteCloseCapability)(s)||(0,m.hasReadWriteCapability)(s)||(0,m.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const s=await this.withProvider(o);if((0,m.hasOpenReadWriteCloseCapability)(s)||(0,m.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.doResolveFile(o,s)}catch(i){throw(0,m.toFileSystemProviderErrorCode)(i)===m.FileSystemProviderErrorCode.FileNotFound?new m.FileOperationError((0,v.localize)(2,null,this.resourceForError(o)),1):(0,m.ensureFileSystemProviderError)(i)}}async doResolveFile(o,s){const i=await this.withProvider(o),n=this.isPathCaseSensitive(i),c=s?.resolveTo,S=s?.resolveSingleChildDescendants,R=s?.resolveMetadata,k=await i.stat(o);let P;return this.toFileStat(i,o,k,void 0,!!R,(D,_)=>(P||(P=w.TernarySearchTree.forUris(()=>!n),P.set(o,!0),c&&P.fill(!0,c)),P.get(D.resource)||P.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&S?_===1:!1))}async toFileStat(o,s,i,n,c,S){const{providerExtUri:R}=this.getExtUri(o),k={resource:s,name:R.basename(s),isFile:(i.type&m.FileType.File)!==0,isDirectory:(i.type&m.FileType.Directory)!==0,isSymbolicLink:(i.type&m.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&m.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&m.FilePermission.Locked),etag:(0,m.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(k.isDirectory&&S(k,n)){try{const P=await o.readdir(s),D=await L.Promises.settled(P.map(async([_,N])=>{try{const U=R.joinPath(s,_),j=c?await o.stat(U):{type:N};return await this.toFileStat(o,U,j,P.length,c,S)}catch(U){return this.logService.trace(U),null}}));k.children=(0,C.coalesce)(D)}catch(P){this.logService.trace(P),k.children=[]}return k}return k}async resolveAll(o){return L.Promises.settled(o.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const s=await this.withProvider(o),i=await s.stat(o);return this.toFileStat(s,o,i,void 0,!0,()=>!1)}async exists(o){const s=await this.withProvider(o);try{return!!await s.stat(o)}catch{return!1}}async canCreateFile(o,s){try{await this.doValidateCreateFile(o,s)}catch(i){return i}return!0}async doValidateCreateFile(o,s){if(!s?.overwrite&&await this.exists(o))throw new m.FileOperationError((0,v.localize)(3,null,this.resourceForError(o)),3,s)}async createFile(o,s=r.VSBuffer.fromString(""),i){await this.doValidateCreateFile(o,i);const n=await this.writeFile(o,s);return this._onDidRunOperation.fire(new m.FileOperationEvent(o,0,n)),n}async writeFile(o,s,i){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:c}=this.getExtUri(n);let S=i;if((0,m.hasFileAtomicWriteCapability)(n)&&!S?.atomic){const R=n.enforceAtomicWriteFile?.(o);R&&(S={...i,atomic:R})}try{await this.validateWriteFile(n,o,S)||await this.mkdirp(n,c.dirname(o));let k;if((0,m.hasReadWriteCapability)(n)&&!(s instanceof r.VSBuffer))if((0,y.isReadableStream)(s)){const P=await(0,y.peekStream)(s,3);P.ended?k=r.VSBuffer.concat(P.buffer):k=P}else k=(0,y.peekReadable)(s,P=>r.VSBuffer.concat(P),3);else k=s;!(0,m.hasOpenReadWriteCloseCapability)(n)||(0,m.hasReadWriteCapability)(n)&&k instanceof r.VSBuffer||(0,m.hasReadWriteCapability)(n)&&(0,m.hasFileAtomicWriteCapability)(n)&&S?.atomic?await this.doWriteUnbuffered(n,o,S,k):await this.doWriteBuffered(n,o,S,k instanceof r.VSBuffer?(0,r.bufferToReadable)(k):k),this._onDidRunOperation.fire(new m.FileOperationEvent(o,4))}catch(R){throw new m.FileOperationError((0,v.localize)(4,null,this.resourceForError(o),(0,m.ensureFileSystemProviderError)(R).toString()),(0,m.toFileOperationResult)(R),S)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,s,i){const n=!!i?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,v.localize)(5,null,this.resourceForError(s)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,v.localize)(6,null,this.resourceForError(s)));if(!(o.capabilities&2))throw new Error((0,v.localize)(7,null,this.resourceForError(s)));if(n)throw new Error((0,v.localize)(8,null,this.resourceForError(s)))}let S;try{S=await o.stat(s)}catch{return}if(S.type&m.FileType.Directory)throw new m.FileOperationError((0,v.localize)(9,null,this.resourceForError(s)),0,i);if(this.throwIfFileIsReadonly(s,S),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==m.ETAG_DISABLED&&typeof S.mtime=="number"&&typeof S.size=="number"&&i.mtime<S.mtime&&i.etag!==(0,m.etag)({mtime:i.mtime,size:S.size}))throw new m.FileOperationError((0,v.localize)(10,null),3,i);return S}async readFile(o,s,i){const n=await this.withReadProvider(o);return s?.atomic?this.doReadFileAtomic(n,o,s,i):this.doReadFile(n,o,s,i)}async doReadFileAtomic(o,s,i,n){return new Promise((c,S)=>{this.writeQueue.queueFor(s,async()=>{try{const R=await this.doReadFile(o,s,i,n);c(R)}catch(R){S(R)}},this.getExtUri(o).providerExtUri)})}async doReadFile(o,s,i,n){const c=await this.doReadFileStream(o,s,{...i,preferUnbuffered:!0},n);return{...c,value:await(0,r.streamToBuffer)(c.value)}}async readFileStream(o,s,i){const n=await this.withReadProvider(o);return this.doReadFileStream(n,o,s,i)}async doReadFileStream(o,s,i,n){const c=new O.CancellationTokenSource(n);let S=i;(0,m.hasFileAtomicReadCapability)(o)&&o.enforceAtomicReadFile?.(s)&&(S={...i,atomic:!0});const R=this.validateReadFile(s,S).then(P=>P,P=>{throw c.dispose(!0),P});let k;try{return typeof S?.etag=="string"&&S.etag!==m.ETAG_DISABLED&&await R,S?.atomic&&(0,m.hasFileAtomicReadCapability)(o)||!((0,m.hasOpenReadWriteCloseCapability)(o)||(0,m.hasFileReadStreamCapability)(o))||(0,m.hasReadWriteCapability)(o)&&S?.preferUnbuffered?k=this.readFileUnbuffered(o,s,S):(0,m.hasFileReadStreamCapability)(o)?k=this.readFileStreamed(o,s,c.token,S):k=this.readFileBuffered(o,s,c.token,S),k.on("end",()=>c.dispose()),k.on("error",()=>c.dispose()),{...await R,value:k}}catch(P){throw k&&await(0,y.consumeStream)(k),this.restoreReadError(P,s,S)}}restoreReadError(o,s,i){const n=(0,v.localize)(11,null,this.resourceForError(s),(0,m.ensureFileSystemProviderError)(o).toString());return o instanceof m.NotModifiedSinceFileOperationError?new m.NotModifiedSinceFileOperationError(n,o.stat,i):o instanceof m.TooLargeFileOperationError?new m.TooLargeFileOperationError(n,o.fileOperationResult,o.size,o.options):new m.FileOperationError(n,(0,m.toFileOperationResult)(o),i)}readFileStreamed(o,s,i,n=Object.create(null)){const c=o.readFileStream(s,n,i);return(0,y.transform)(c,{data:S=>S instanceof r.VSBuffer?S:r.VSBuffer.wrap(S),error:S=>this.restoreReadError(S,s,n)},S=>r.VSBuffer.concat(S))}readFileBuffered(o,s,i,n=Object.create(null)){const c=(0,r.newWriteableBufferStream)();return(0,g.readFileIntoStream)(o,s,c,S=>S,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:S=>this.restoreReadError(S,s,n)},i),c}readFileUnbuffered(o,s,i){const n=(0,y.newWriteableStream)(c=>r.VSBuffer.concat(c));return(async()=>{try{let c;i?.atomic&&(0,m.hasFileAtomicReadCapability)(o)?c=await o.readFile(s,{atomic:!0}):c=await o.readFile(s),typeof i?.position=="number"&&(c=c.slice(i.position)),typeof i?.length=="number"&&(c=c.slice(0,i.length)),this.validateReadFileLimits(s,c.byteLength,i),n.end(r.VSBuffer.wrap(c))}catch(c){n.error(c),n.end()}})(),n}async validateReadFile(o,s){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new m.FileOperationError((0,v.localize)(12,null,this.resourceForError(o)),0,s);if(typeof s?.etag=="string"&&s.etag!==m.ETAG_DISABLED&&s.etag===i.etag)throw new m.NotModifiedSinceFileOperationError((0,v.localize)(13,null),i,s);return this.validateReadFileLimits(o,i.size,s),i}validateReadFileLimits(o,s,i){if(typeof i?.limits?.size=="number"&&s>i.limits.size)throw new m.TooLargeFileOperationError((0,v.localize)(14,null,this.resourceForError(o)),7,s,i)}async canMove(o,s,i){return this.doCanMoveCopy(o,s,"move",i)}async canCopy(o,s,i){return this.doCanMoveCopy(o,s,"copy",i)}async doCanMoveCopy(o,s,i,n){if(o.toString()!==s.toString())try{const c=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),S=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(c,o,S,s,i,n)}catch(c){return c}return!0}async move(o,s,i){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),S=await this.doMoveCopy(n,o,c,s,"move",!!i),R=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(o,S==="move"?2:3,R)),R}async copy(o,s,i){const n=await this.withReadProvider(o),c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),S=await this.doMoveCopy(n,o,c,s,"copy",!!i),R=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(o,S==="copy"?3:2,R)),R}async doMoveCopy(o,s,i,n,c,S){if(s.toString()===n.toString())return c;const{exists:R,isSameResourceWithDifferentPathCase:k}=await this.doValidateMoveCopy(o,s,i,n,c,S);if(R&&!k&&S&&await this.del(n,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(n)),c==="copy"){if(o===i&&(0,m.hasFileFolderCopyCapability)(o))await o.copy(s,n,{overwrite:S});else{const P=await this.resolve(s);P.isDirectory?await this.doCopyFolder(o,P,i,n):await this.doCopyFile(o,s,i,n)}return c}else return o===i?(await o.rename(s,n,{overwrite:S}),c):(await this.doMoveCopy(o,s,i,n,"copy",S),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(o,s,i,n){if((0,m.hasOpenReadWriteCloseCapability)(o)&&(0,m.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(o,s,i,n);if((0,m.hasOpenReadWriteCloseCapability)(o)&&(0,m.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(o,s,i,n);if((0,m.hasReadWriteCapability)(o)&&(0,m.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(o,s,i,n);if((0,m.hasReadWriteCapability)(o)&&(0,m.hasReadWriteCapability)(i))return this.doPipeUnbuffered(o,s,i,n)}async doCopyFolder(o,s,i,n){await i.mkdir(n),Array.isArray(s.children)&&await L.Promises.settled(s.children.map(async c=>{const S=this.getExtUri(i).providerExtUri.joinPath(n,c.name);return c.isDirectory?this.doCopyFolder(o,await this.resolve(c.resource),i,S):this.doCopyFile(o,c.resource,i,S)}))}async doValidateMoveCopy(o,s,i,n,c,S){let R=!1;if(o===i){const{providerExtUri:P,isPathCaseSensitive:D}=this.getExtUri(o);if(D||(R=P.isEqual(s,n)),R&&c==="copy")throw new Error((0,v.localize)(15,null,this.resourceForError(s),this.resourceForError(n)));if(!R&&P.isEqualOrParent(n,s))throw new Error((0,v.localize)(16,null,this.resourceForError(s),this.resourceForError(n)))}const k=await this.exists(n);if(k&&!R){if(!S)throw new m.FileOperationError((0,v.localize)(17,null,this.resourceForError(s),this.resourceForError(n)),4);if(o===i){const{providerExtUri:P}=this.getExtUri(o);if(P.isEqualOrParent(s,n))throw new Error((0,v.localize)(18,null,this.resourceForError(s),this.resourceForError(n)))}}return{exists:k,isSameResourceWithDifferentPathCase:R}}getExtUri(o){const s=this.isPathCaseSensitive(o);return{providerExtUri:s?u.extUri:u.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(s,o);const i=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(o,0,i)),i}async mkdirp(o,s){const i=[],{providerExtUri:n}=this.getExtUri(o);for(;!n.isEqual(s,n.dirname(s));)try{if(!((await o.stat(s)).type&m.FileType.Directory))throw new Error((0,v.localize)(19,null,this.resourceForError(s)));break}catch(c){if((0,m.toFileSystemProviderErrorCode)(c)!==m.FileSystemProviderErrorCode.FileNotFound)throw c;i.push(n.basename(s)),s=n.dirname(s)}for(let c=i.length-1;c>=0;c--){s=n.joinPath(s,i[c]);try{await o.mkdir(s)}catch(S){if((0,m.toFileSystemProviderErrorCode)(S)!==m.FileSystemProviderErrorCode.FileExists)throw S}}}async canDelete(o,s){try{await this.doValidateDelete(o,s)}catch(i){return i}return!0}async doValidateDelete(o,s){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o),n=!!s?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,v.localize)(20,null,this.resourceForError(o)));const c=s?.atomic;if(c&&!(i.capabilities&65536))throw new Error((0,v.localize)(21,null,this.resourceForError(o)));if(n&&c)throw new Error((0,v.localize)(22,null,this.resourceForError(o)));let S;try{S=await i.stat(o)}catch{}if(S)this.throwIfFileIsReadonly(o,S);else throw new m.FileOperationError((0,v.localize)(23,null,this.resourceForError(o)),1);if(!!!s?.recursive){const k=await this.resolve(o);if(k.isDirectory&&Array.isArray(k.children)&&k.children.length>0)throw new Error((0,v.localize)(24,null,this.resourceForError(o)))}return i}async del(o,s){const i=await this.doValidateDelete(o,s);let n=s;if((0,m.hasFileAtomicDeleteCapability)(i)&&!n?.atomic){const k=i.enforceAtomicDelete?.(o);k&&(n={...s,atomic:k})}const c=!!n?.useTrash,S=!!n?.recursive,R=n?.atomic??!1;await i.delete(o,{recursive:S,useTrash:c,atomic:R}),this._onDidRunOperation.fire(new m.FileOperationEvent(o,1))}async cloneFile(o,s){const i=await this.withProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);if(!(i===n&&this.getExtUri(i).providerExtUri.isEqual(o,s)))return i===n&&(0,m.hasFileCloneCapability)(i)?i.cloneFile(o,s):(await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(s)),i===n&&(0,m.hasFileFolderCopyCapability)(i)?this.writeQueue.queueFor(o,()=>i.copy(o,s,{overwrite:!0}),this.getExtUri(i).providerExtUri):this.writeQueue.queueFor(o,()=>this.doCopyFile(i,o,n,s),this.getExtUri(i).providerExtUri))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(o,s){return this.watch(o,{...s,correlationId:p.WATCHER_CORRELATION_IDS++})}watch(o,s={recursive:!1,excludes:[]}){const i=new l.DisposableStore;let n=!1,c=()=>{n=!0};i.add((0,l.toDisposable)(()=>c())),(async()=>{try{const R=await this.doWatch(o,s);n?(0,l.dispose)(R):c=()=>(0,l.dispose)(R)}catch(R){this.logService.error(R)}})();const S=s.correlationId;if(typeof S=="number"){const R=i.add(new M.Emitter);return i.add(this.internalOnDidFilesChange.event(P=>{P.correlates(S)&&R.fire(P)})),{onDidChange:R.event,dispose:()=>i.dispose()}}return i}async doWatch(o,s){const i=await this.withProvider(o),n=(0,I.hash)([this.getExtUri(i).providerExtUri.getComparisonKey(o),s]);let c=this.activeWatchers.get(n);return c||(c={count:0,disposable:i.watch(o,s)},this.activeWatchers.set(n,c)),c.count+=1,(0,l.toDisposable)(()=>{c&&(c.count--,c.count===0&&((0,l.dispose)(c.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,l.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,s,i,n){return this.writeQueue.queueFor(s,async()=>{const c=await o.open(s,{create:!0,unlock:i?.unlock??!1});try{(0,y.isReadableStream)(n)||(0,y.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(o,c,n):await this.doWriteReadableBufferedQueued(o,c,n)}catch(S){throw(0,m.ensureFileSystemProviderError)(S)}finally{await o.close(c)}},this.getExtUri(o).providerExtUri)}async doWriteStreamBufferedQueued(o,s,i){let n=0,c;if((0,y.isReadableBufferedStream)(i)){if(i.buffer.length>0){const S=r.VSBuffer.concat(i.buffer);await this.doWriteBuffer(o,s,S,S.byteLength,n,0),n+=S.byteLength}if(i.ended)return;c=i.stream}else c=i;return new Promise((S,R)=>{(0,y.listenStream)(c,{onData:async k=>{c.pause();try{await this.doWriteBuffer(o,s,k,k.byteLength,n,0)}catch(P){return R(P)}n+=k.byteLength,setTimeout(()=>c.resume())},onError:k=>R(k),onEnd:()=>S()})})}async doWriteReadableBufferedQueued(o,s,i){let n=0,c;for(;(c=i.read())!==null;)await this.doWriteBuffer(o,s,c,c.byteLength,n,0),n+=c.byteLength}async doWriteBuffer(o,s,i,n,c,S){let R=0;for(;R<n;){const k=await o.write(s,c+R,i.buffer,S+R,n-R);R+=k}}async doWriteUnbuffered(o,s,i,n){return this.writeQueue.queueFor(s,()=>this.doWriteUnbufferedQueued(o,s,i,n),this.getExtUri(o).providerExtUri)}async doWriteUnbufferedQueued(o,s,i,n){let c;n instanceof r.VSBuffer?c=n:(0,y.isReadableStream)(n)?c=await(0,r.streamToBuffer)(n):(0,y.isReadableBufferedStream)(n)?c=await(0,r.bufferedStreamToBuffer)(n):c=(0,r.readableToBuffer)(n),await o.writeFile(s,c.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async doPipeBuffered(o,s,i,n){return this.writeQueue.queueFor(n,()=>this.doPipeBufferedQueued(o,s,i,n),this.getExtUri(i).providerExtUri)}async doPipeBufferedQueued(o,s,i,n){let c,S;try{c=await o.open(s,{create:!1}),S=await i.open(n,{create:!0,unlock:!1});const R=r.VSBuffer.alloc(this.BUFFER_SIZE);let k=0,P=0,D=0;do D=await o.read(c,k,R.buffer,P,R.byteLength-P),await this.doWriteBuffer(i,S,R,D,k,P),k+=D,P+=D,P===R.byteLength&&(P=0);while(D>0)}catch(R){throw(0,m.ensureFileSystemProviderError)(R)}finally{await L.Promises.settled([typeof c=="number"?o.close(c):Promise.resolve(),typeof S=="number"?i.close(S):Promise.resolve()])}}async doPipeUnbuffered(o,s,i,n){return this.writeQueue.queueFor(n,()=>this.doPipeUnbufferedQueued(o,s,i,n),this.getExtUri(i).providerExtUri)}async doPipeUnbufferedQueued(o,s,i,n){return i.writeFile(n,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(o,s,i,n){return this.writeQueue.queueFor(n,()=>this.doPipeUnbufferedToBufferedQueued(o,s,i,n),this.getExtUri(i).providerExtUri)}async doPipeUnbufferedToBufferedQueued(o,s,i,n){const c=await i.open(n,{create:!0,unlock:!1});try{const S=await o.readFile(s);await this.doWriteBuffer(i,c,r.VSBuffer.wrap(S),S.byteLength,0,0)}catch(S){throw(0,m.ensureFileSystemProviderError)(S)}finally{await i.close(c)}}async doPipeBufferedToUnbuffered(o,s,i,n){const c=await(0,r.streamToBuffer)(this.readFileBuffered(o,s,O.CancellationToken.None));await this.doWriteUnbuffered(i,n,void 0,c)}throwIfFileSystemIsReadonly(o,s){if(o.capabilities&2048)throw new m.FileOperationError((0,v.localize)(25,null,this.resourceForError(s)),6);return o}throwIfFileIsReadonly(o,s){if((s.permissions??0)&m.FilePermission.Readonly)throw new m.FileOperationError((0,v.localize)(26,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===b.Schemas.file?o.fsPath:o.toString(!0)}};e.FileService=a,e.FileService=a=p=be([ne(0,h.ILogService)],a)}),define(oe[93],ae([0,1,46,311,8,31,17,3,33,2,9,4,19,63,21,179,16,119,221,51,217,216]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y,v,m,g,h,d,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(C)}catch(o){console.error(`Error enabling graceful-fs: ${(0,d.toErrorMessage)(o)}`)}})();class t extends h.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(s,i){super(s,i),this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new O.ResourceMap(n=>E.extUriBiasedIgnorePathCase.getComparisonKey(n)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:i,symbolicLink:n}=await y.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:m.FilePermission.Locked}}catch(i){throw this.toFileSystemProviderError(i)}}async statIgnoreError(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const i=await y.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async c=>{try{let S;c.isSymbolicLink()?S=(await this.stat((0,E.joinPath)(s,c.name))).type:S=this.toType(c),n.push([c.name,S])}catch(S){this.logService.trace(S)}})),n}catch(i){throw this.toFileSystemProviderError(i)}}toType(s,i){let n;return i?.dangling?n=m.FileType.Unknown:s.isFile()?n=m.FileType.File:s.isDirectory()?n=m.FileType.Directory:n=m.FileType.Unknown,i&&(n|=m.FileType.SymbolicLink),n}async createResourceLock(s){const i=this.toFilePath(s);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.resourceLocks.get(s);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const c=new r.Barrier;return this.resourceLocks.set(s,c),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,l.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(s)===c&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(s)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),c.open()})}async readFile(s,i){let n;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(s)})`),n=await this.createResourceLock(s));const c=this.toFilePath(s);return await y.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{n?.dispose()}}traceLock(s){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(s)}readFileStream(s,i,n){const c=(0,u.newWriteableStream)(S=>M.VSBuffer.concat(S.map(R=>M.VSBuffer.wrap(R))).buffer);return(0,g.readFileIntoStream)(this,s,c,S=>S.buffer,{...i,bufferSize:256*1024},n),c}async writeFile(s,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.canWriteFileAtomic(s)?this.doWriteFileAtomic(s,(0,E.joinPath)((0,E.dirname)(s),`${(0,E.basename)(s)}${n.atomic.postfix}`),i,n):this.doWriteFile(s,i,n)}async canWriteFileAtomic(s){try{const i=this.toFilePath(s),{symbolicLink:n}=await y.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async doWriteFileAtomic(s,i,n,c){const S=new l.DisposableStore;try{S.add(await this.createResourceLock(s)),S.add(await this.createResourceLock(i)),await this.doWriteFile(i,n,c,!0);try{await this.rename(i,s,{overwrite:!0})}catch(R){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw R}}finally{S.dispose()}}async doWriteFile(s,i,n,c){let S;try{const R=this.toFilePath(s);if(!n.create||!n.overwrite){if(await y.Promises.exists(R)){if(!n.overwrite)throw(0,m.createFileSystemProviderError)((0,v.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,m.createFileSystemProviderError)((0,v.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}S=await this.open(s,{create:!0,unlock:n.unlock},c),await this.write(S,0,i,0,i.byteLength)}catch(R){throw await this.toFileSystemProviderWriteError(s,R)}finally{typeof S=="number"&&await this.close(S)}}static{this.canFlush=!0}static configureFlushOnWrite(s){t.canFlush=s}async open(s,i,n){const c=this.toFilePath(s);let S;(0,m.isFileOpenForWriteOptions)(i)&&!n&&(S=await this.createResourceLock(s));let R;try{if((0,m.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:P}=await y.SymlinkSupport.stat(c);P.mode&128||await y.Promises.chmod(c,P.mode|128)}catch(P){P.code!=="ENOENT"&&this.logService.trace(P)}let k;if((0,m.isFileOpenForWriteOptions)(i)){if(b.isWindows)try{await y.Promises.truncate(c,0),k="r+"}catch(P){P.code!=="ENOENT"&&this.logService.trace(P)}k||(k="w")}else k="r";R=await y.Promises.open(c,k)}catch(k){throw S?.dispose(),(0,m.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(s,k):this.toFileSystemProviderError(k)}if(this.mapHandleToPos.set(R,0),(0,m.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(R,s),S){const k=this.mapHandleToLock.get(R);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${R} (${c})`),this.mapHandleToLock.set(R,S),k&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${R} (${c})`),k.dispose())}return R}async close(s){const i=this.mapHandleToLock.get(s);try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&t.canFlush)try{await y.Promises.fdatasync(s)}catch(n){t.configureFlushOnWrite(!1),this.logService.error(n)}return await y.Promises.close(s)}catch(n){throw this.toFileSystemProviderError(n)}finally{i&&(this.mapHandleToLock.get(s)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.mapHandleToLock.delete(s)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),i.dispose())}}async read(s,i,n,c,S){const R=this.normalizePos(s,i);let k=null;try{k=(await y.Promises.read(s,n,c,S,R)).bytesRead}catch(P){throw this.toFileSystemProviderError(P)}finally{this.updatePos(s,R,k)}return k}normalizePos(s,i){return i===this.mapHandleToPos.get(s)?null:i}updatePos(s,i,n){const c=this.mapHandleToPos.get(s);typeof c=="number"&&(typeof i=="number"||(typeof n=="number"?this.mapHandleToPos.set(s,c+n):this.mapHandleToPos.delete(s)))}async write(s,i,n,c,S){return(0,r.retry)(()=>this.doWrite(s,i,n,c,S),100,3)}async doWrite(s,i,n,c,S){const R=this.normalizePos(s,i);let k=null;try{k=(await y.Promises.write(s,n,c,S,R)).bytesWritten}catch(P){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),P)}finally{this.updatePos(s,R,k)}return k}async mkdir(s){try{await y.Promises.mkdir(this.toFilePath(s))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(s,i){try{const n=this.toFilePath(s);if(i.recursive){let c;i?.atomic!==!1&&i.atomic.postfix&&(c=(0,w.join)((0,w.dirname)(n),`${(0,w.basename)(n)}${i.atomic.postfix}`)),await y.Promises.rm(n,y.RimRafMode.MOVE,c)}else try{await y.Promises.unlink(n)}catch(c){if(c.code==="EPERM"||c.code==="EISDIR"){let S=!1;try{const{stat:R,symbolicLink:k}=await y.SymlinkSupport.stat(n);S=R.isDirectory()&&!k}catch{}if(S)await y.Promises.rmdir(n);else throw c}else throw c}}catch(n){throw this.toFileSystemProviderError(n)}}async rename(s,i,n){const c=this.toFilePath(s),S=this.toFilePath(i);if(c!==S)try{await this.validateMoveCopy(s,i,"move",n.overwrite),await y.Promises.rename(c,S)}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,v.localize)(2,null,(0,w.basename)(c),(0,w.basename)((0,w.dirname)(S)),R.toString()))),this.toFileSystemProviderError(R)}}async copy(s,i,n){const c=this.toFilePath(s),S=this.toFilePath(i);if(c!==S)try{await this.validateMoveCopy(s,i,"copy",n.overwrite),await y.Promises.copy(c,S,{preserveSymlinks:!0})}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,v.localize)(3,null,(0,w.basename)(c),(0,w.basename)((0,w.dirname)(S)),R.toString()))),this.toFileSystemProviderError(R)}}async validateMoveCopy(s,i,n,c){const S=this.toFilePath(s),R=this.toFilePath(i);let k=!1;if(!!(this.capabilities&1024)||(k=(0,f.isEqual)(S,R,!0)),k){if(n==="copy")throw(0,m.createFileSystemProviderError)((0,v.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const D=await this.statIgnoreError(s);if(!D)throw(0,m.createFileSystemProviderError)((0,v.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const _=await this.statIgnoreError(i);if(_){if(!c)throw(0,m.createFileSystemProviderError)((0,v.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);D.type&m.FileType.File&&_.type&m.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,i){return this.doCloneFile(s,i,!1)}async doCloneFile(s,i,n){const c=this.toFilePath(s),S=this.toFilePath(i),R=!!(this.capabilities&1024);if((0,f.isEqual)(c,S,!R))return;const k=new l.DisposableStore;try{k.add(await this.createResourceLock(s)),k.add(await this.createResourceLock(i)),n&&await y.Promises.mkdir((0,w.dirname)(S),{recursive:!0}),await y.Promises.copyFile(c,S)}catch(P){if(P.code==="ENOENT"&&!n)return this.doCloneFile(s,i,!0);throw this.toFileSystemProviderError(P)}finally{k.dispose()}}createUniversalWatcher(s,i,n){return new p.UniversalWatcherClient(c=>s(c),c=>i(c),n)}createNonRecursiveWatcher(s,i,n){return new a.NodeJSWatcherClient(c=>s(c),c=>i(c),n)}toFileSystemProviderError(s){if(s instanceof m.FileSystemProviderError)return s;let i=s,n;switch(s.code){case"ENOENT":n=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=m.FileSystemProviderErrorCode.Unknown;break;default:n=m.FileSystemProviderErrorCode.Unknown}return(0,m.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(s,i){let n=this.toFileSystemProviderError(i);if(s&&n.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await y.SymlinkSupport.stat(this.toFilePath(s));c.mode&128||(n=(0,m.createFileSystemProviderError)(i,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return n}}e.DiskFileSystemProvider=t}),define(oe[223],ae([0,1,3,93,2,17,63,23]),function(Q,e,C,L,r,O,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class f extends r.Disposable{constructor(b,E){super(),this.provider=b,this.logService=E,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(b,E,u){const y=this.getUriTransformer(b);switch(E){case"stat":return this.stat(y,u[0]);case"readdir":return this.readdir(y,u[0]);case"open":return this.open(y,u[0],u[1]);case"close":return this.close(u[0]);case"read":return this.read(u[0],u[1],u[2]);case"readFile":return this.readFile(y,u[0],u[1]);case"write":return this.write(u[0],u[1],u[2],u[3],u[4]);case"writeFile":return this.writeFile(y,u[0],u[1],u[2]);case"rename":return this.rename(y,u[0],u[1],u[2]);case"copy":return this.copy(y,u[0],u[1],u[2]);case"cloneFile":return this.cloneFile(y,u[0],u[1]);case"mkdir":return this.mkdir(y,u[0]);case"delete":return this.delete(y,u[0],u[1]);case"watch":return this.watch(y,u[0],u[1],u[2],u[3]);case"unwatch":return this.unwatch(u[0],u[1])}throw new Error(`IPC Command ${E} not found`)}listen(b,E,u){const y=this.getUriTransformer(b);switch(E){case"fileChange":return this.onFileChange(y,u[0]);case"readFileStream":return this.onReadFileStream(y,u[0],u[1])}throw new Error(`Unknown event ${E}`)}stat(b,E){const u=this.transformIncoming(b,E,!0);return this.provider.stat(u)}readdir(b,E){const u=this.transformIncoming(b,E);return this.provider.readdir(u)}async readFile(b,E,u){const y=this.transformIncoming(b,E,!0),v=await this.provider.readFile(y,u);return O.VSBuffer.wrap(v)}onReadFileStream(b,E,u){const y=this.transformIncoming(b,E,!0),v=new I.CancellationTokenSource,m=new C.Emitter({onDidRemoveLastListener:()=>{v.cancel()}}),g=this.provider.readFileStream(y,u,v.token);return(0,M.listenStream)(g,{onData:h=>m.fire(O.VSBuffer.wrap(h)),onError:h=>m.fire(h),onEnd:()=>{m.fire("end"),m.dispose(),v.dispose()}}),m.event}writeFile(b,E,u,y){const v=this.transformIncoming(b,E);return this.provider.writeFile(v,u.buffer,y)}open(b,E,u){const y=this.transformIncoming(b,E,!0);return this.provider.open(y,u)}close(b){return this.provider.close(b)}async read(b,E,u){const y=O.VSBuffer.alloc(u),v=0,m=await this.provider.read(b,E,y.buffer,v,u);return[y,m]}write(b,E,u,y,v){return this.provider.write(b,E,u.buffer,y,v)}mkdir(b,E){const u=this.transformIncoming(b,E);return this.provider.mkdir(u)}delete(b,E,u){const y=this.transformIncoming(b,E);return this.provider.delete(y,u)}rename(b,E,u,y){const v=this.transformIncoming(b,E),m=this.transformIncoming(b,u);return this.provider.rename(v,m,y)}copy(b,E,u,y){const v=this.transformIncoming(b,E),m=this.transformIncoming(b,u);return this.provider.copy(v,m,y)}cloneFile(b,E,u){const y=this.transformIncoming(b,E),v=this.transformIncoming(b,u);return this.provider.cloneFile(y,v)}onFileChange(b,E){const u=new C.Emitter({onWillAddFirstListener:()=>{this.sessionToWatcher.set(E,this.createSessionFileWatcher(b,u))},onDidRemoveLastListener:()=>{(0,r.dispose)(this.sessionToWatcher.get(E)),this.sessionToWatcher.delete(E)}});return u.event}async watch(b,E,u,y,v){const m=this.sessionToWatcher.get(E);if(m){const g=this.transformIncoming(b,y),h=m.watch(u,g,v);this.watchRequests.set(E+u,h)}}async unwatch(b,E){const u=b+E,y=this.watchRequests.get(u);y&&((0,r.dispose)(y),this.watchRequests.delete(u))}dispose(){super.dispose();for(const[,b]of this.watchRequests)b.dispose();this.watchRequests.clear();for(const[,b]of this.sessionToWatcher)b.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=f;class l extends r.Disposable{constructor(b,E,u,y){super(),this.uriTransformer=b,this.logService=u,this.environmentService=y,this.watcherRequests=new Map,this.fileWatcher=this._register(new L.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(E)}registerListeners(b){const E=this._register(new C.Emitter);this._register(E.event(u=>{b.fire(u.map(y=>({resource:this.uriTransformer.transformOutgoingURI(y.resource),type:y.type,cId:y.cId})))})),this._register(this.fileWatcher.onDidChangeFile(u=>E.fire(u))),this._register(this.fileWatcher.onDidWatchError(u=>b.fire(u)))}getRecursiveWatcherOptions(b){}getExtraExcludes(b){}watch(b,E,u){const y=this.getExtraExcludes(this.environmentService);return Array.isArray(y)&&(u.excludes=[...u.excludes,...y]),this.watcherRequests.set(b,this.fileWatcher.watch(E,u)),(0,r.toDisposable)(()=>{(0,r.dispose)(this.watcherRequests.get(b)),this.watcherRequests.delete(b)})}dispose(){for(const[,b]of this.watcherRequests)b.dispose();this.watcherRequests.clear(),super.dispose()}}e.AbstractSessionFileWatcher=l}),define(oe[224],ae([0,1,15,178,4,7,16,9,223,155]),function(Q,e,C,L,r,O,M,I,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class w extends f.AbstractDiskFileSystemProviderChannel{constructor(u,y,v){super(u,y),this.environmentService=v}getUriTransformer(u){return l.DefaultURITransformer}transformIncoming(u,y){return O.URI.revive(y)}async delete(u,y,v){if(!v.useTrash)return super.delete(u,y,v);const m=this.transformIncoming(u,y),g=(0,I.normalize)(m.fsPath);try{await C.shell.trashItem(g)}catch{throw(0,M.createFileSystemProviderError)(r.isWindows?(0,L.localize)(0,null,(0,I.basename)(g)):(0,L.localize)(1,null,(0,I.basename)(g)),M.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(u,y){return new b(u,y,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=w;class b extends f.AbstractSessionFileWatcher{watch(u,y,v){if(v.recursive)throw(0,M.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",M.FileSystemProviderErrorCode.Unavailable);return super.watch(u,y,v)}}}),define(oe[225],ae([0,1,5]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class L extends C.AbstractMessageLogger{constructor(O=C.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(O),this._register(this.onDidChangeLogLevel(M=>{this._logger?.setLevel(M)}))}set logger(O){this._logger=O;for(const{level:M,message:I}of this.buffer)(0,C.log)(O,M,I);this.buffer=[]}log(O,M){this._logger?(0,C.log)(this._logger,O,M):this.getLevel()<=O&&this.buffer.push({level:O,message:M})}dispose(){this._logger?.dispose(),super.dispose()}flush(){this._logger?.flush()}}e.BufferLogger=L}),define(oe[226],ae([0,1,7,3,5,2]),function(Q,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class M extends r.AbstractLoggerService{constructor(b,E,u,y,v){super(E,u,y),this.windowId=b,this.channel=v,this._register(v.listen("onDidChangeLogLevel",b)(m=>{(0,r.isLogLevel)(m)?super.setLogLevel(m):super.setLogLevel(C.URI.revive(m[0]),m[1])})),this._register(v.listen("onDidChangeVisibility",b)(([m,g])=>super.setVisibility(C.URI.revive(m),g))),this._register(v.listen("onDidChangeLoggers",b)(({added:m,removed:g})=>{for(const h of m)super.registerLogger({...h,resource:C.URI.revive(h.resource)});for(const h of g)super.deregisterLogger(h.resource)}))}createConsoleMainLogger(){return new r.AdapterLogger({log:(b,E)=>{this.channel.call("consoleLog",[b,E])}})}registerLogger(b){super.registerLogger(b),this.channel.call("registerLogger",[b,this.windowId])}deregisterLogger(b){super.deregisterLogger(b),this.channel.call("deregisterLogger",[b,this.windowId])}setLogLevel(b,E){super.setLogLevel(b,E),this.channel.call("setLogLevel",[b,E])}setVisibility(b,E){super.setVisibility(b,E),this.channel.call("setVisibility",[this.toResource(b),E])}doCreateLogger(b,E,u){return new I(this.channel,b,E,u,this.windowId)}static setLogLevel(b,E,u){return b.call("setLogLevel",[E,u])}}e.LoggerChannelClient=M;class I extends r.AbstractMessageLogger{constructor(b,E,u,y,v){super(y?.logLevel==="always"),this.channel=b,this.file=E,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[E,y,v]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(b,E){const u=[[b,E]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(b){this.channel.call("log",[this.file,b])}}class f{constructor(b,E){this.loggerService=b,this.getUriTransformer=E}listen(b,E){const u=this.getUriTransformer(b);switch(E){case"onDidChangeLoggers":return L.Event.map(this.loggerService.onDidChangeLoggers,y=>({added:[...y.added].map(v=>this.transformLogger(v,u)),removed:[...y.removed].map(v=>this.transformLogger(v,u))}));case"onDidChangeVisibility":return L.Event.map(this.loggerService.onDidChangeVisibility,y=>[u.transformOutgoingURI(y[0]),y[1]]);case"onDidChangeLogLevel":return L.Event.map(this.loggerService.onDidChangeLogLevel,y=>(0,r.isLogLevel)(y)?y:[u.transformOutgoingURI(y[0]),y[1]])}throw new Error(`Event not found: ${E}`)}async call(b,E,u){const y=this.getUriTransformer(b);switch(E){case"setLogLevel":return(0,r.isLogLevel)(u[0])?this.loggerService.setLogLevel(u[0]):this.loggerService.setLogLevel(C.URI.revive(y.transformIncoming(u[0][0])),u[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(v=>this.transformLogger(v,y)))}throw new Error(`Call not found: ${E}`)}transformLogger(b,E){return{...b,resource:E.transformOutgoingURI(b.resource)}}}e.LoggerChannel=f;class l extends O.Disposable{constructor(b,E){super(),E.call("setLogLevel",[b.getLogLevel()]),this._register(b.onDidChangeLogLevel(u=>E.call("setLogLevel",[u]))),E.call("getRegisteredLoggers").then(u=>{for(const y of u)b.registerLogger({...y,resource:C.URI.revive(y.resource)})}),this._register(E.listen("onDidChangeVisibility")(([u,y])=>b.setVisibility(C.URI.revive(u),y))),this._register(E.listen("onDidChangeLoggers")(({added:u,removed:y})=>{for(const v of u)b.registerLogger({...v,resource:C.URI.revive(v.resource)});for(const v of y)b.deregisterLogger(v.resource)}))}}e.RemoteLoggerChannelClient=l}),define(oe[227],ae([0,1,2,5]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class r extends C.Disposable{constructor(M,I=[]){super(),this.logger=new L.MultiplexLogger([M,...I]),this._register(M.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(M){this.logger.setLevel(M)}getLevel(){return this.logger.getLevel()}trace(M,...I){this.logger.trace(M,...I)}debug(M,...I){this.logger.debug(M,...I)}info(M,...I){this.logger.info(M,...I)}warn(M,...I){this.logger.warn(M,...I)}error(M,...I){this.logger.error(M,...I)}flush(){this.logger.flush()}}e.LogService=r}),define(oe[228],ae([0,1,31,7,5]),function(Q,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class O{constructor(I){this.loggerService=I,this.loggers=new C.ResourceMap}listen(I,f,l){switch(f){case"onDidChangeLoggers":return l?this.loggerService.getOnDidChangeLoggersEvent(l):this.loggerService.onDidChangeLoggers;case"onDidChangeLogLevel":return l?this.loggerService.getOnDidChangeLogLevelEvent(l):this.loggerService.onDidChangeLogLevel;case"onDidChangeVisibility":return l?this.loggerService.getOnDidChangeVisibilityEvent(l):this.loggerService.onDidChangeVisibility}throw new Error(`Event not found: ${f}`)}async call(I,f,l){switch(f){case"createLogger":this.createLogger(L.URI.revive(l[0]),l[1],l[2]);return;case"log":return this.log(L.URI.revive(l[0]),l[1]);case"consoleLog":return this.consoleLog(l[0],l[1]);case"setLogLevel":return(0,r.isLogLevel)(l[0])?this.loggerService.setLogLevel(l[0]):this.loggerService.setLogLevel(L.URI.revive(l[0]),l[1]);case"setVisibility":return this.loggerService.setVisibility(L.URI.revive(l[0]),l[1]);case"registerLogger":return this.loggerService.registerLogger({...l[0],resource:L.URI.revive(l[0].resource)},l[1]);case"deregisterLogger":return this.loggerService.deregisterLogger(L.URI.revive(l[0]))}throw new Error(`Call not found: ${f}`)}createLogger(I,f,l){this.loggers.set(I,this.loggerService.createLogger(I,f,l))}consoleLog(I,f){let l=console.log;switch(I){case r.LogLevel.Error:l=console.error;break;case r.LogLevel.Warning:l=console.warn;break;case r.LogLevel.Info:l=console.info;break}l.call(console,...f)}log(I,f){const l=this.loggers.get(I);if(!l)throw new Error("Create the logger before logging");for(const[w,b]of f)(0,r.log)(l,w,b)}}e.LoggerChannel=O}),define(oe[229],ae([0,1,16,5]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var r;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(r||(r={}));async function O(l,w,b,E,u){try{const y=await new Promise((m,g)=>{Q(["@vscode/spdlog"],m,g)});y.setFlushOn(r.Trace);const v=await y.createAsyncRotatingLogger(l,w,b,E);return u?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(y){console.error(y)}return null}function M(l,w,b){switch(w){case L.LogLevel.Trace:l.trace(b);break;case L.LogLevel.Debug:l.debug(b);break;case L.LogLevel.Info:l.info(b);break;case L.LogLevel.Warning:l.warn(b);break;case L.LogLevel.Error:l.error(b);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function I(l,w){switch(w){case L.LogLevel.Trace:l.setLevel(r.Trace);break;case L.LogLevel.Debug:l.setLevel(r.Debug);break;case L.LogLevel.Info:l.setLevel(r.Info);break;case L.LogLevel.Warning:l.setLevel(r.Warning);break;case L.LogLevel.Error:l.setLevel(r.Error);break;case L.LogLevel.Off:l.setLevel(r.Off);break;default:throw new Error(`Invalid log level ${w}`)}}class f extends L.AbstractMessageLogger{constructor(w,b,E,u,y){super(),this.buffer=[],this.setLevel(y),this._loggerCreationPromise=this._createSpdLogLogger(w,b,E,u),this._register(this.onDidChangeLogLevel(v=>{this._logger&&I(this._logger,v)}))}async _createSpdLogLogger(w,b,E,u){const y=E?6:1,v=30/y*C.ByteSize.MB,m=await O(w,b,v,y,u);if(m){this._logger=m,I(this._logger,this.getLevel());for(const{level:g,message:h}of this.buffer)M(this._logger,g,h);this.buffer=[]}}log(w,b){this._logger?M(this._logger,w,b):this.getLevel()<=w&&this.buffer.push({level:w,message:b})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=f}),define(oe[230],ae([0,1,32,5,229]),function(Q,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class O extends L.AbstractLoggerService{doCreateLogger(I,f,l){return new r.SpdLogLogger((0,C.generateUuid)(),I.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,f)}}e.LoggerService=O}),define(oe[69],ae([0,1,31,3,6,5,230]),function(Q,e,C,L,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,r.refineServiceDecorator)(O.ILoggerService);class I extends M.LoggerService{constructor(){super(...arguments),this.loggerResourcesByWindow=new C.ResourceMap}createLogger(l,w,b){b!==void 0&&this.loggerResourcesByWindow.set(this.toResource(l),b);try{return super.createLogger(l,w)}catch(E){throw this.loggerResourcesByWindow.delete(this.toResource(l)),E}}registerLogger(l,w){w!==void 0&&this.loggerResourcesByWindow.set(l.resource,w),super.registerLogger(l)}deregisterLogger(l){this.loggerResourcesByWindow.delete(l),super.deregisterLogger(l)}getRegisteredLoggers(l){const w=[];for(const b of super.getRegisteredLoggers())l===this.loggerResourcesByWindow.get(b.resource)&&w.push(b);return w}getOnDidChangeLogLevelEvent(l){return L.Event.filter(this.onDidChangeLogLevel,w=>(0,O.isLogLevel)(w)||this.isInterestedLoggerResource(w[0],l))}getOnDidChangeVisibilityEvent(l){return L.Event.filter(this.onDidChangeVisibility,([w])=>this.isInterestedLoggerResource(w,l))}getOnDidChangeLoggersEvent(l){return L.Event.filter(L.Event.map(this.onDidChangeLoggers,w=>({added:[...w.added].filter(E=>this.isInterestedLoggerResource(E.resource,l)),removed:[...w.removed].filter(E=>this.isInterestedLoggerResource(E.resource,l))})),w=>w.added.length>0||w.removed.length>0)}deregisterLoggers(l){for(const[w,b]of this.loggerResourcesByWindow)b===l&&this.deregisterLogger(w)}isInterestedLoggerResource(l,w){const b=this.loggerResourcesByWindow.get(l);return b===void 0||b===w}dispose(){super.dispose(),this.loggerResourcesByWindow.clear()}}e.LoggerMainService=I}),define(oe[231],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function C(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=C;function L(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function r(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=r;function O(M){return!C(M)&&!L(M)&&!r(M)}e.isMenubarMenuItemAction=O}),define(oe[39],ae([0,1,3,72,2,6]),function(Q,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,O.createDecorator)("policy");class M extends r.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(l){const w=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...l,...this.policyDefinitions},w!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(l),L.Iterable.reduce(this.policies.entries(),(b,[E,u])=>({...b,[E]:u}),{})}getPolicyValue(l){return this.policies.get(l)}serialize(){return L.Iterable.reduce(Object.entries(this.policyDefinitions),(l,[w,b])=>({...l,[w]:{definition:b,value:this.policies.get(w)}}),{})}}e.AbstractPolicyService=M;class I{constructor(){this.onDidChange=C.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=I}),define(oe[232],ae([0,1,8,3,72,12,16,5,39]),function(Q,e,C,L,r,O,M,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function l(b,E){const u=[];for(const y of new Set(r.Iterable.concat(b.keys(),E.keys())))b.get(y)!==E.get(y)&&u.push(y);return u}let w=class extends f.AbstractPolicyService{constructor(E,u,y){super(),this.file=E,this.fileService=u,this.logService=y,this.throttledDelayer=this._register(new C.ThrottledDelayer(500));const v=L.Event.filter(u.onDidFilesChange,m=>m.affects(E));this._register(u.watch(E)),this._register(v(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const E=new Map;try{const u=await this.fileService.readFile(this.file),y=JSON.parse(u.value.toString());if(!(0,O.isObject)(y))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(y))this.policyDefinitions[v]&&E.set(v,y[v])}catch(u){u.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",u)}return E}async refresh(){const E=await this.read(),u=l(this.policies,E);this.policies=E,u.length>0&&this._onDidChange.fire(u)}};e.FilePolicyService=w,e.FilePolicyService=w=be([ne(1,M.IFileService),ne(2,I.ILogService)],w)}),define(oe[233],ae([0,1,3,2,39]),function(Q,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class O{constructor(f){this.service=f,this.disposables=new L.DisposableStore}listen(f,l){switch(l){case"onDidChange":return C.Event.map(this.service.onDidChange,w=>w.reduce((b,E)=>({...b,[E]:this.service.getPolicyValue(E)??null}),{}),this.disposables)}throw new Error(`Event not found: ${l}`)}call(f,l,w){switch(l){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(w)}throw new Error(`Call not found: ${l}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=O;class M extends r.AbstractPolicyService{constructor(f,l){super(),this.channel=l;for(const w in f){const{definition:b,value:E}=f[w];this.policyDefinitions[w]=b,E!==void 0&&this.policies.set(w,E)}this.channel.listen("onDidChange")(w=>{for(const b in w){const E=w[b];E===null?this.policies.delete(b):this.policies.set(b,E)}this._onDidChange.fire(Object.keys(w))})}async _updatePolicyDefinitions(f){const l=await this.channel.call("updatePolicyDefinitions",f);for(const w in l)this.policies.set(w,l[w])}}e.PolicyChannelClient=M}),define(oe[234],ae([0,1,39,8,2,5]),function(Q,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let M=class extends C.AbstractPolicyService{constructor(f,l){super(),this.logService=f,this.productName=l,this.throttler=new L.Throttler,this.watcher=this._register(new r.MutableDisposable)}async _updatePolicyDefinitions(f){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(f).length} policy definitions`);const{createWatcher:l}=await new Promise((w,b)=>{Q(["@vscode/policy-watcher"],w,b)});await this.throttler.queue(()=>new Promise((w,b)=>{try{this.watcher.value=l(this.productName,f,E=>{this._onDidPolicyChange(E),w()})}catch(E){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",E),b(E)}}))}_onDidPolicyChange(f){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(f)}`);for(const l in f){const w=f[l];w===void 0?this.policies.delete(l):this.policies.set(l,w)}this._onDidChange.fire(Object.keys(f))}};e.NativePolicyService=M,e.NativePolicyService=M=be([ne(0,O.ILogService)],M)}),define(oe[79],ae([0,1,36]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;const r=globalThis.vscode;if(typeof r<"u"&&typeof r.context<"u"){const O=r.context.configuration();if(O)L=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){L=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:O,searchUrl:M,itemUrl:I,controlUrl:f}=L.extensionsGallery||{};Object.assign(L,{extensionsGallery:{serviceUrl:C.env.VSCODE_GALLERY_SERVICE_URL||O,searchUrl:C.env.VSCODE_GALLERY_SEARCH_URL||M,itemUrl:C.env.VSCODE_GALLERY_ITEM_URL||I,controlUrl:C.env.VSCODE_GALLERY_CONTROL_URL||f}});try{const l=(...b)=>b.reduce((E,u)=>(Object.keys(u).forEach(y=>{Array.isArray(E[y])&&Array.isArray(u[y])?E[y]=u[y]:typeof E[y]=="object"&&typeof u[y]=="object"?E[y]=l(E[y],u[y]):E[y]=u[y]}),E),{}),w=globalThis._VSCODE_USER_PRODUCT_JSON||{};L=l(L,w)}catch{}if(C.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`,serverDataFolderName:L.serverDataFolderName?`${L.serverDataFolderName}-dev`:void 0}),!L.version){const l=globalThis._VSCODE_PACKAGE_JSON;Object.assign(L,{version:l.version,release:l.release})}}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=L}),define(oe[27],ae([0,1,6]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,C.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(oe[235],ae([0,1,8,5]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let r=class{constructor(M,I,f){this._window=M,this._sessionId=I,this._logService=f}async inspect(M){await this._connect();const I=this._window.webContents.debugger;await I.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,C.timeout)(M);const f=await I.sendCommand("Profiler.stop");return this._logService.warn("[perf] profiling DONE",this._sessionId),await this._disconnect(),f.profile}async _connect(){const M=this._window.webContents.debugger;M.attach(),await M.sendCommand("Profiler.enable")}async _disconnect(){const M=this._window.webContents.debugger;await M.sendCommand("Profiler.disable"),M.detach()}};e.WindowProfiler=r,e.WindowProfiler=r=be([ne(2,L.ILogService)],r)}),define(oe[80],ae([0,1,6]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,C.createDecorator)("protocolMainService")}),define(oe[44],ae([0,1,138,12]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class r{constructor(){this.data=new Map}add(M,I){C.ok(L.isString(M)),C.ok(L.isObject(I)),C.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,I)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new r}),define(oe[236],ae([0,1,3,44]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function r(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class O{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,l){this.schemasById[r(f)]=l,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const M=new O;L.Registry.add(e.Extensions.JSONContribution,M)}),define(oe[52],ae([0,1,22,3,12,163,18,236,44]),function(Q,e,C,L,r,O,M,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var l;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.Extensions={Configuration:"base.contributions.configuration"};var w;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(w||(e.ConfigurationScope=w={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=f.Registry.as(I.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const s=new Set;this.doRegisterConfigurations(t,o,s),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(t){const o=new Set;this.doDeregisterConfigurations(t,o),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:t,remove:o}){const s=new Set;this.doDeregisterConfigurations(o,s),this.doRegisterConfigurations(t,!1,s),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}registerDefaultConfigurations(t){const o=new Set;this.doRegisterDefaultConfigurations(t,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,o){const s=[];for(const{overrides:i,source:n}of t)for(const c in i)if(o.add(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const S=this.configurationDefaultsOverrides.get(c),R=S?.valuesSources??new Map;if(n)for(const _ of Object.keys(i[c]))R.set(_,n);const k={...S?.value||{},...i[c]};this.configurationDefaultsOverrides.set(c,{source:n,value:k,valuesSources:R});const P=(0,M.getLanguageTagSettingPlainKey)(c),D={type:"object",default:k,description:O.localize(1,null,P),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:k,source:r.isString(n)?void 0:n,defaultValueSource:n};s.push(...v(c)),this.configurationProperties[c]=D,this.defaultLanguageConfigurationOverridesNode.properties[c]=D}else{this.configurationDefaultsOverrides.set(c,{value:i[c],source:n});const S=this.configurationProperties[c];S&&(this.updatePropertyDefaultValue(c,S),this.updateSchema(c,S))}this.doRegisterOverrideIdentifiers(s)}deregisterDefaultConfigurations(t){const o=new Set;this.doDeregisterDefaultConfigurations(t,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,o){for(const{overrides:s,source:i}of t)for(const n in s){const c=this.configurationDefaultsOverrides.get(n),S=r.isString(i)?i:i?.id,R=r.isString(c?.source)?c?.source:c?.source?.id;if(S===R)if(o.add(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const k=this.configurationProperties[n];k&&(this.updatePropertyDefaultValue(n,k),this.updateSchema(n,k))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let o=!1;const s=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,s),o=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,s),o=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,s),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const o of t)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,o,s){t.forEach(i=>{this.validateAndRegisterProperties(i,o,i.extensionInfo,i.restrictedProperties,void 0,s),this.configurationContributors.push(i),this.registerJSONConfiguration(i)})}doDeregisterConfigurations(t,o){const s=i=>{if(i.properties)for(const n in i.properties){o.add(n);const c=this.configurationProperties[n];c?.policy?.name&&this.policyConfigurations.delete(c.policy.name),delete this.configurationProperties[n],this.removeFromSchema(n,i.properties[n])}i.allOf?.forEach(n=>s(n))};for(const i of t){s(i);const n=this.configurationContributors.indexOf(i);n!==-1&&this.configurationContributors.splice(n,1)}}validateAndRegisterProperties(t,o=!0,s,i,n=3,c){n=r.isUndefinedOrNull(t.scope)?n:t.scope;const S=t.properties;if(S)for(const k in S){const P=S[k];if(o&&d(k,P)){delete S[k];continue}if(P.source=s,P.defaultDefaultValue=S[k].default,this.updatePropertyDefaultValue(k,P),e.OVERRIDE_PROPERTY_REGEX.test(k)?P.scope=void 0:(P.scope=r.isUndefinedOrNull(P.scope)?n:P.scope,P.restricted=r.isUndefinedOrNull(P.restricted)?!!i?.includes(k):P.restricted),S[k].hasOwnProperty("included")&&!S[k].included){this.excludedConfigurationProperties[k]=S[k],delete S[k];continue}else this.configurationProperties[k]=S[k],S[k].policy?.name&&this.policyConfigurations.set(S[k].policy.name,k);!S[k].deprecationMessage&&S[k].markdownDeprecationMessage&&(S[k].deprecationMessage=S[k].markdownDeprecationMessage),c.add(k)}const R=t.allOf;if(R)for(const k of R)this.validateAndRegisterProperties(k,o,s,i,n,c)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const o=s=>{const i=s.properties;if(i)for(const c in i)this.updateSchema(c,i[c]);s.allOf?.forEach(o)};o(t)}updateSchema(t,o){switch(e.allSettings.properties[t]=o,o.scope){case 1:e.applicationSettings.properties[t]=o;break;case 2:e.machineSettings.properties[t]=o;break;case 6:e.machineOverridableSettings.properties[t]=o;break;case 3:e.windowSettings.properties[t]=o;break;case 4:e.resourceSettings.properties[t]=o;break;case 5:e.resourceSettings.properties[t]=o,this.resourceLanguageSettingsSchema.properties[t]=o;break}}removeFromSchema(t,o){switch(delete e.allSettings.properties[t],o.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const o=`[${t}]`,s={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,s),e.allSettings.properties[o]=s,e.applicationSettings.properties[o]=s,e.machineSettings.properties[o]=s,e.machineOverridableSettings.properties[o]=s,e.windowSettings.properties[o]=s,e.resourceSettings.properties[o]=s}}registerOverridePropertyPatternKey(){const t={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,o){const s=this.configurationDefaultsOverrides.get(t);let i=s?.value,n=s?.source;r.isUndefined(i)&&(i=o.defaultDefaultValue,n=void 0),r.isUndefined(i)&&(i=g(o.type)),o.default=i,o.defaultValueSource=n}}const u="\\[([^\\]]+)\\]",y=new RegExp(u,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${u})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function v(a){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(a)){let o=y.exec(a);for(;o?.length;){const s=o[1].trim();s&&t.push(s),o=y.exec(a)}}return(0,C.distinct)(t)}e.overrideIdentifiersFromKey=v;function m(a){return a.reduce((t,o)=>`${t}[${o}]`,"")}e.keyFromOverrideIdentifiers=m;function g(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const h=new E;f.Registry.add(e.Extensions.Configuration,h);function d(a,t){return a.trim()?e.OVERRIDE_PROPERTY_REGEX.test(a)?O.localize(7,null,a):h.getConfigurationProperties()[a]!==void 0?O.localize(8,null,a):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?O.localize(9,null,a,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:O.localize(6,null)}e.validateProperty=d;function p(){const a=[],t=h.getConfigurationProperties();for(const o of Object.keys(t))a.push([o,t[o].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.getScopes=p}),define(oe[120],ae([0,1,22,3,42,2,31,35,12,7,18,52,44]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function u(o){return Object.isFrozen(o)?o:I.deepFreeze(o)}class y{constructor(s={},i=[],n=[],c){this._contents=s,this._keys=i,this._overrides=n,this.raw=c,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const s=this.raw.map(i=>{if(i instanceof y)return i;const n=new v("");return n.parseRaw(i),n.configurationModel});this._rawConfiguration=s.reduce((i,n)=>n===i?n:i.merge(n),s[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,w.getConfigurationValue)(this.contents,s):this.contents}inspect(s,i){const n=this.rawConfiguration.getValue(s),c=i?this.rawConfiguration.getOverrideValue(s,i):void 0,S=i?this.rawConfiguration.override(i).getValue(s):n;return{value:n,override:c,merged:S}}getOverrideValue(s,i){const n=this.getContentsForOverrideIdentifer(i);return n?s?(0,w.getConfigurationValue)(n,s):n:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const n of this.overrides)n.identifiers.includes(s)&&i.push(...n.keys);return C.distinct(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return C.distinct(s)}override(s){let i=this.overrideConfigurations.get(s);return i||(i=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,i)),i}merge(...s){const i=I.deepClone(this.contents),n=I.deepClone(this.overrides),c=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const R of s)if(S.push(...R.raw?.length?R.raw:[R]),!R.isEmpty()){this.mergeContents(i,R.contents);for(const k of R.overrides){const[P]=n.filter(D=>C.equals(D.identifiers,k.identifiers));P?(this.mergeContents(P.contents,k.contents),P.keys.push(...k.keys),P.keys=C.distinct(P.keys)):n.push(I.deepClone(k))}for(const k of R.keys)c.indexOf(k)===-1&&c.push(k)}return new y(i,c,n,S.every(R=>R instanceof y)?void 0:S)}createOverrideConfigurationModel(s){const i=this.getContentsForOverrideIdentifer(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const c of C.distinct([...Object.keys(this.contents),...Object.keys(i)])){let S=this.contents[c];const R=i[c];R&&(typeof S=="object"&&typeof R=="object"?(S=I.deepClone(S),this.mergeContents(S,R)):S=R),n[c]=S}return new y(n,this.keys,this.overrides)}mergeContents(s,i){for(const n of Object.keys(i)){if(n in s&&f.isObject(s[n])&&f.isObject(i[n])){this.mergeContents(s[n],i[n]);continue}s[n]=I.deepClone(i[n])}}getContentsForOverrideIdentifer(s){let i=null,n=null;const c=S=>{S&&(n?this.mergeContents(n,S):n=I.deepClone(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===s?i=S.contents:S.identifiers.includes(s)&&c(S.contents);return c(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,i){this.updateValue(s,i,!0)}setValue(s,i){this.updateValue(s,i,!1)}removeValue(s){const i=this.keys.indexOf(s);i!==-1&&(this.keys.splice(i,1),(0,w.removeFromValueTree)(this.contents,s),b.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(n=>C.equals(n.identifiers,(0,b.overrideIdentifiersFromKey)(s))),1))}updateValue(s,i,n){(0,w.addToValueTree)(this.contents,s,i,c=>console.error(c)),n=n||this.keys.indexOf(s)===-1,n&&this.keys.push(s),b.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,b.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,w.toValuesTree)(this.contents[s],c=>console.error(c))})}}e.ConfigurationModel=y;class v{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,i){if(!f.isUndefinedOrNull(s)){const n=this.doParseContent(s);this.parseRaw(n,i)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,i){this._raw=s;const{contents:n,keys:c,overrides:S,restricted:R,hasExcludedProperties:k}=this.doParseRaw(s,i);this._configurationModel=new y(n,c,S,k?[s]:void 0),this._restrictedConfigurations=R||[]}doParseContent(s){let i={},n=null,c=[];const S=[],R=[];function k(D){Array.isArray(c)?c.push(D):n!==null&&(c[n]=D)}const P={onObjectBegin:()=>{const D={};k(D),S.push(c),c=D,n=null},onObjectProperty:D=>{n=D},onObjectEnd:()=>{c=S.pop()},onArrayBegin:()=>{const D=[];k(D),S.push(c),c=D,n=null},onArrayEnd:()=>{c=S.pop()},onLiteralValue:k,onError:(D,_,N)=>{R.push({error:D,offset:_,length:N})}};if(s)try{r.visit(s,P),i=c[0]||{}}catch(D){console.error(`Error while parsing settings file ${this._name}: ${D}`),this._parseErrors=[D]}return i}doParseRaw(s,i){const n=E.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),c=this.filter(s,n,!0,i);s=c.raw;const S=(0,w.toValuesTree)(s,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),R=Object.keys(s),k=this.toOverrides(s,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:S,keys:R,overrides:k,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}filter(s,i,n,c){let S=!1;if(!c?.scopes&&!c?.skipRestricted&&!c?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:S};const R={},k=[];for(const P in s)if(b.OVERRIDE_PROPERTY_REGEX.test(P)&&n){const D=this.filter(s[P],i,!1,c);R[P]=D.raw,S=S||D.hasExcludedProperties,k.push(...D.restricted)}else{const D=i[P],_=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&k.push(P),!c.exclude?.includes(P)&&(c.include?.includes(P)||(_===void 0||c.scopes===void 0||c.scopes.includes(_))&&!(c.skipRestricted&&D?.restricted))?R[P]=s[P]:S=!0}return{raw:R,restricted:k,hasExcludedProperties:S}}toOverrides(s,i){const n=[];for(const c of Object.keys(s))if(b.OVERRIDE_PROPERTY_REGEX.test(c)){const S={};for(const R in s[c])S[R]=s[c][R];n.push({identifiers:(0,b.overrideIdentifiersFromKey)(c),keys:Object.keys(S),contents:(0,w.toValuesTree)(S,i)})}return n}}e.ConfigurationModelParser=v;class m extends O.Disposable{constructor(s,i,n,c){super(),this.userSettingsResource=s,this.parseOptions=i,this.fileService=c,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.any(L.Event.filter(this.fileService.onDidFilesChange,S=>S.contains(this.userSettingsResource)),L.Event.filter(this.fileService.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&n.isEqual(S.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(s){return s&&(this.parseOptions=s),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=m;class g{constructor(s,i,n,c,S,R,k,P,D,_,N,U,j){this.key=s,this.overrides=i,this._value=n,this.overrideIdentifiers=c,this.defaultConfiguration=S,this.policyConfiguration=R,this.applicationConfiguration=k,this.userConfiguration=P,this.localUserConfiguration=D,this.remoteUserConfiguration=_,this.workspaceConfiguration=N,this.folderConfigurationModel=U,this.memoryConfigurationModel=j}get value(){return u(this._value)}inspect(s,i,n){const c=s.inspect(i,n);return{get value(){return u(c.value)},get override(){return u(c.override)},get merged(){return u(c.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class h{constructor(s,i,n,c,S=new y,R=new y,k=new M.ResourceMap,P=new y,D=new M.ResourceMap){this._defaultConfiguration=s,this._policyConfiguration=i,this._applicationConfiguration=n,this._localUserConfiguration=c,this._remoteUserConfiguration=S,this._workspaceConfiguration=R,this._folderConfigurations=k,this._memoryConfiguration=P,this._memoryConfigurationByResource=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new M.ResourceMap,this._userConfiguration=null}getValue(s,i,n){return this.getConsolidatedConfigurationModel(s,i,n).getValue(s)}updateValue(s,i,n={}){let c;n.resource?(c=this._memoryConfigurationByResource.get(n.resource),c||(c=new y,this._memoryConfigurationByResource.set(n.resource,c))):c=this._memoryConfiguration,i===void 0?c.removeValue(s):c.setValue(s,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,i,n){const c=this.getConsolidatedConfigurationModel(s,i,n),S=this.getFolderConfigurationModelForResource(i.resource,n),R=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,k=new Set;for(const P of c.overrides)for(const D of P.identifiers)c.getOverrideValue(s,D)!==void 0&&k.add(D);return new g(s,i,c.getValue(s),k.size?[...k]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this._workspaceConfiguration:void 0,S||void 0,R)}keys(s){const i=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(s){this._policyConfiguration=s}updateApplicationConfiguration(s){this._applicationConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,i){this._folderConfigurations.set(s,i),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const n=[];if(!i){const{added:c,updated:S,removed:R}=a(this._defaultConfiguration,s);i=[...c,...S,...R]}for(const c of i)for(const S of(0,b.overrideIdentifiersFromKey)(c)){const R=this._defaultConfiguration.getKeysForOverrideIdentifier(S),k=s.getKeysForOverrideIdentifier(S),P=[...k.filter(D=>R.indexOf(D)===-1),...R.filter(D=>k.indexOf(D)===-1),...R.filter(D=>!I.equals(this._defaultConfiguration.override(S).getValue(D),s.override(S).getValue(D)))];n.push([S,P])}return this.updateDefaultConfiguration(s),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(s){const{added:i,updated:n,removed:c}=a(this._policyConfiguration,s),S=[...i,...n,...c];return S.length&&this.updatePolicyConfiguration(s),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:i,updated:n,removed:c,overrides:S}=a(this.applicationConfiguration,s),R=[...i,...n,...c];return R.length&&this.updateApplicationConfiguration(s),{keys:R,overrides:S}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:n,removed:c,overrides:S}=a(this.localUserConfiguration,s),R=[...i,...n,...c];return R.length&&this.updateLocalUserConfiguration(s),{keys:R,overrides:S}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:n,removed:c,overrides:S}=a(this.remoteUserConfiguration,s),R=[...i,...n,...c];return R.length&&this.updateRemoteUserConfiguration(s),{keys:R,overrides:S}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:n,removed:c,overrides:S}=a(this.workspaceConfiguration,s),R=[...i,...n,...c];return R.length&&this.updateWorkspaceConfiguration(s),{keys:R,overrides:S}}compareAndUpdateFolderConfiguration(s,i){const n=this.folderConfigurations.get(s),{added:c,updated:S,removed:R,overrides:k}=a(n,i),P=[...c,...S,...R];return(P.length||!n)&&this.updateFolderConfiguration(s,i),{keys:P,overrides:k}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:n,updated:c,removed:S,overrides:R}=a(i,void 0);return{keys:[...n,...c,...S],overrides:R}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(s,i,n){let c=this.getConsolidatedConfigurationModelForResource(i,n);return i.overrideIdentifier&&(c=c.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(s)!==void 0&&(c=c.merge(this._policyConfiguration)),c}getConsolidatedConfigurationModelForResource({resource:s},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&s){const c=i.getFolder(s);c&&(n=this.getFolderConsolidatedConfiguration(c.uri)||n);const S=this._memoryConfigurationByResource.get(s);S&&(n=n.merge(S))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let i=this._foldersConsolidatedConfigurations.get(s);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),c=this._folderConfigurations.get(s);c?(i=n.merge(c),this._foldersConsolidatedConfigurations.set(s,i)):i=n}return i}getFolderConfigurationModelForResource(s,i){if(i&&s){const n=i.getFolder(s);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,i)=>{const{contents:n,overrides:c,keys:S}=this._folderConfigurations.get(i);return s.push([i,{contents:n,overrides:c,keys:S}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.keys.forEach(i=>s.add(i)),this.userConfiguration.keys.forEach(i=>s.add(i)),this._workspaceConfiguration.keys.forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.keys.forEach(n=>s.add(n))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>s.add(n))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(s).forEach(c=>i.add(c))),[...i.values()]}static parse(s){const i=this.parseConfigurationModel(s.defaults),n=this.parseConfigurationModel(s.policy),c=this.parseConfigurationModel(s.application),S=this.parseConfigurationModel(s.user),R=this.parseConfigurationModel(s.workspace),k=s.folders.reduce((P,D)=>(P.set(l.URI.revive(D[0]),this.parseConfigurationModel(D[1])),P),new M.ResourceMap);return new h(i,n,c,S,new y,R,k,new y,new M.ResourceMap)}static parseConfigurationModel(s){return new y(s.contents,s.keys,s.overrides)}}e.Configuration=h;function d(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,i=new Map;for(const c of o)c.keys.forEach(S=>s.add(S)),c.overrides.forEach(([S,R])=>{const k=(0,M.getOrSet)(i,S,new Set);R.forEach(P=>k.add(P))});const n=[];return i.forEach((c,S)=>n.push([S,[...c.values()]])),{keys:[...s.values()],overrides:n}}e.mergeChanges=d;class p{constructor(s,i,n,c){this.change=s,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=c,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const S of s.keys)this.affectedKeys.add(S);for(const[,S]of s.overrides)for(const R of S)this.affectedKeys.add(R);this._affectsConfigStr=this._marker;for(const S of this.affectedKeys)this._affectsConfigStr+=S+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=h.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,i){const n=this._marker+s,c=this._affectsConfigStr.indexOf(n);if(c<0)return!1;const S=c+n.length;if(S>=this._affectsConfigStr.length)return!1;const R=this._affectsConfigStr.charCodeAt(S);if(R!==this._markerCode1&&R!==this._markerCode2)return!1;if(i){const k=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.previous?.workspace):void 0,P=this.currentConfiguraiton.getValue(s,i,this.currentWorkspace);return!I.equals(k,P)}return!0}}e.ConfigurationChangeEvent=p;function a(o,s){const{added:i,removed:n,updated:c}=t(s?.rawConfiguration,o?.rawConfiguration),S=[],R=o?.getAllOverrideIdentifiers()||[],k=s?.getAllOverrideIdentifiers()||[];if(s){const P=k.filter(D=>!R.includes(D));for(const D of P)S.push([D,s.getKeysForOverrideIdentifier(D)])}if(o){const P=R.filter(D=>!k.includes(D));for(const D of P)S.push([D,o.getKeysForOverrideIdentifier(D)])}if(s&&o){for(const P of R)if(k.includes(P)){const D=t({contents:o.getOverrideValue(void 0,P)||{},keys:o.getKeysForOverrideIdentifier(P)},{contents:s.getOverrideValue(void 0,P)||{},keys:s.getKeysForOverrideIdentifier(P)});S.push([P,[...D.added,...D.removed,...D.updated]])}}return{added:i,removed:n,updated:c,overrides:S}}function t(o,s){const i=o?s?o.keys.filter(S=>s.keys.indexOf(S)===-1):[...o.keys]:[],n=s?o?s.keys.filter(S=>o.keys.indexOf(S)===-1):[...s.keys]:[],c=[];if(o&&s){for(const S of s.keys)if(o.keys.indexOf(S)!==-1){const R=(0,w.getConfigurationValue)(s.contents,S),k=(0,w.getConfigurationValue)(o.contents,S);I.equals(R,k)||c.push(S)}}return{added:i,removed:n,updated:c}}}),define(oe[237],ae([0,1,22,3,2,35,12,120,52,5,39,44]),function(Q,e,C,L,r,O,M,I,f,l,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class E extends r.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new I.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(b.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:g})=>this.onDidUpdateConfiguration(Array.from(m),g))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(m,g){this.updateConfigurationModel(m,b.Registry.as(f.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:m})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new I.ConfigurationModel;const m=b.Registry.as(f.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(m),m)}updateConfigurationModel(m,g){const h=this.getConfigurationDefaultOverrides();for(const d of m){const p=h[d],a=g[d];p!==void 0?this._configurationModel.addValue(d,p):a?this._configurationModel.addValue(d,a.default):this._configurationModel.removeValue(d)}}}e.DefaultConfiguration=E;class u{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new I.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=u;let y=class extends r.Disposable{get configurationModel(){return this._configurationModel}constructor(m,g,h){super(),this.defaultConfiguration=m,this.policyService=g,this.logService=h,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new I.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(m=>this.onDidChangePolicies(m))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:m})=>this.update(await this.updatePolicyDefinitions(m),!0))),this._configurationModel}async updatePolicyDefinitions(m){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",m);const g={},h=[],d=b.Registry.as(f.Extensions.Configuration).getConfigurationProperties();for(const p of m){const a=d[p];if(!a){h.push(p);continue}if(a.policy){if(a.type!=="string"&&a.type!=="number"){this.logService.warn(`Policy ${a.policy.name} has unsupported type ${a.type}`);continue}h.push(p),g[a.policy.name]={type:a.type}}}return(0,M.isEmptyObject)(g)||await this.policyService.updatePolicyDefinitions(g),h}onDidChangePolicies(m){this.logService.trace("PolicyConfiguration#onDidChangePolicies",m);const g=b.Registry.as(f.Extensions.Configuration).getPolicyConfigurations(),h=(0,C.coalesce)(m.map(d=>g.get(d)));this.update(h,!0)}update(m,g){this.logService.trace("PolicyConfiguration#update",m);const h=b.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),d=[],p=this._configurationModel.isEmpty();for(const a of m){const t=h[a]?.policy?.name;if(t){const o=this.policyService.getPolicyValue(t);(p?o!==void 0:!(0,O.equals)(this._configurationModel.getValue(a),o))&&d.push([a,o])}else this._configurationModel.getValue(a)!==void 0&&d.push([a,void 0])}if(d.length){this.logService.trace("PolicyConfiguration#changed",d);const a=this._configurationModel;this._configurationModel=new I.ConfigurationModel;for(const t of a.keys)this._configurationModel.setValue(t,a.getValue(t));for(const[t,o]of d)o===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,o);g&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=y,e.PolicyConfiguration=y=be([ne(1,w.IPolicyService),ne(2,l.ILogService)],y)}),define(oe[238],ae([0,1,22,8,17,3,42,101,2,35,4,19,18,120,52,237,39]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class g extends f.Disposable{constructor(p,a,t,o){super(),this.settingsResource=p,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new v.DefaultConfiguration),this.policyConfiguration=t instanceof m.NullPolicyService?new v.NullPolicyConfiguration:this._register(new v.PolicyConfiguration(this.defaultConfiguration,t,o)),this.userConfiguration=this._register(new u.UserSettings(this.settingsResource,{},b.extUriBiasedIgnorePathCase,a)),this.configuration=new u.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new u.ConfigurationModel,new u.ConfigurationModel),this.configurationEditing=new h(p,a,this),this.reloadConfigurationScheduler=this._register(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:s,properties:i})=>this.onDidDefaultConfigurationChange(s,i))),this._register(this.policyConfiguration.onDidChangeConfiguration(s=>this.onDidPolicyConfigurationChange(s))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[p,a,t]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new u.Configuration(p,a,new u.ConfigurationModel,t)}getConfigurationData(){return this.configuration.toData()}getValue(p,a){const t=typeof p=="string"?p:void 0,o=(0,E.isConfigurationOverrides)(p)?p:(0,E.isConfigurationOverrides)(a)?a:{};return this.configuration.getValue(t,o,void 0)}async updateValue(p,a,t,o,s){const i=(0,E.isConfigurationUpdateOverrides)(t)?t:(0,E.isConfigurationOverrides)(t)?{resource:t.resource,overrideIdentifiers:t.overrideIdentifier?[t.overrideIdentifier]:void 0}:void 0,n=i?o:t;if(n!==void 0&&n!==3&&n!==2)throw new Error(`Unable to write ${p} to target ${n}.`);i?.overrideIdentifiers&&(i.overrideIdentifiers=(0,C.distinct)(i.overrideIdentifiers),i.overrideIdentifiers=i.overrideIdentifiers.length?i.overrideIdentifiers:void 0);const c=this.inspect(p,{resource:i?.resource,overrideIdentifier:i?.overrideIdentifiers?i.overrideIdentifiers[0]:void 0});if(c.policyValue!==void 0)throw new Error(`Unable to write ${p} because it is configured in system policy.`);if((0,l.equals)(a,c.defaultValue)&&(a=void 0),i?.overrideIdentifiers?.length&&i.overrideIdentifiers.length>1){const R=i.overrideIdentifiers.sort(),k=this.configuration.localUserConfiguration.overrides.find(P=>(0,C.equals)([...P.identifiers].sort(),R));k&&(i.overrideIdentifiers=k.identifiers)}const S=i?.overrideIdentifiers?.length?[(0,y.keyFromOverrideIdentifiers)(i.overrideIdentifiers),p]:[p];await this.configurationEditing.write(S,a),await this.reloadConfiguration()}inspect(p,a={}){return this.configuration.inspect(p,a,void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const p=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(p)}onDidChangeUserConfiguration(p){const a=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(p);this.trigger(t,a,2)}onDidDefaultConfigurationChange(p,a){const t=this.configuration.toData(),o=this.configuration.compareAndUpdateDefaultConfiguration(p,a);this.trigger(o,t,7)}onDidPolicyConfigurationChange(p){const a=this.configuration.toData(),t=this.configuration.compareAndUpdatePolicyConfiguration(p);this.trigger(t,a,7)}trigger(p,a,t){const o=new u.ConfigurationChangeEvent(p,{data:a},this.configuration);o.source=t,this._onDidChangeConfiguration.fire(o)}}e.ConfigurationService=g;class h{constructor(p,a,t){this.settingsResource=p,this.fileService=a,this.configurationService=t,this.queue=new L.Queue}write(p,a){return this.queue.queue(()=>this.doWriteConfiguration(p,a))}async doWriteConfiguration(p,a){let t;try{t=(await this.fileService.readFile(this.settingsResource)).value.toString()}catch(i){if(i.fileOperationResult===1)t="{}";else throw i}const o=[];if((0,M.parse)(t,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.getEdits(t,p,a);t=(0,I.applyEdits)(t,s),await this.fileService.writeFile(this.settingsResource,r.VSBuffer.fromString(t))}getEdits(p,a,t){const{tabSize:o,insertSpaces:s,eol:i}=this.formattingOptions;if(!a.length){const n=JSON.stringify(t,null,s?" ".repeat(o):"	");return[{content:n,length:n.length,offset:0}]}return(0,I.setProperty)(p,a,t,{tabSize:o,insertSpaces:s,eol:i})}get formattingOptions(){if(!this._formattingOptions){let p=w.OS===3||w.OS===2?`
`:`\r
`;const a=this.configurationService.getValue("files.eol",{overrideIdentifier:"jsonc"});a&&typeof a=="string"&&a!=="auto"&&(p=a),this._formattingOptions={eol:p,insertSpaces:!!this.configurationService.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.configurationService.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this._formattingOptions}}}),define(oe[239],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeRemoteResourceRouter=e.NODE_REMOTE_RESOURCE_CHANNEL_NAME=e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME=void 0,e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME="request",e.NODE_REMOTE_RESOURCE_CHANNEL_NAME="remoteResourceHandler";class C{async routeCall(r,O,M){if(O!==e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME)throw new Error(`Call not found: ${O}`);const I=M[0];if(I?.authority){const f=r.connections.find(l=>l.ctx===I.authority);if(f)return f}throw new Error("Caller not found")}routeEvent(r,O){throw new Error(`Event not found: ${O}`)}}e.NodeRemoteResourceRouter=C}),define(oe[240],ae([0,1,14,6]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var r;(function(w){w[w.WebSocket=0]="WebSocket",w[w.Managed=1]="Managed"})(r||(e.RemoteConnectionType=r={}));class O{constructor(b){this.id=b,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=O;class M{constructor(b,E){this.host=b,this.port=E,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=M;var I;(function(w){w.Unknown="Unknown",w.NotAvailable="NotAvailable",w.TemporarilyNotAvailable="TemporarilyNotAvailable",w.NoResolverFound="NoResolverFound",w.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class f extends C.ErrorNoTelemetry{static isNotAvailable(b){return b instanceof f&&b._code===I.NotAvailable}static isTemporarilyNotAvailable(b){return b instanceof f&&b._code===I.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof f&&b._code===I.NoResolverFound}static isInvalidAuthority(b){return b instanceof f&&b._code===I.InvalidAuthority}static isHandled(b){return b instanceof f&&b.isHandled}constructor(b,E=I.Unknown,u){super(b),this._message=b,this._code=E,this._detail=u,this.isHandled=E===I.NotAvailable&&u===!0,Object.setPrototypeOf(this,f.prototype)}}e.RemoteAuthorityResolverError=f;function l(w){const b=w.indexOf("+");return b===-1?w:w.substring(0,b)}e.getRemoteAuthorityPrefix=l}),define(oe[59],ae([0,1,13]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(l){return l.scheme===C.Schemas.vscodeRemote?l.authority:void 0}e.getRemoteAuthority=L;function r(l){if(!l)return;const w=l.indexOf("+");return w<0?l:l.substr(0,w)}e.getRemoteName=r;function O(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.getRemoteServerRootPath=O;function M(l){const{host:w,port:b}=f(l);if(typeof b>"u")throw new Error(`Invalid remote authority: ${l}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:w,port:b}}e.parseAuthorityWithPort=M;function I(l,w){let{host:b,port:E}=f(l);return typeof E>"u"&&(E=w),{host:b,port:E}}e.parseAuthorityWithOptionalPort=I;function f(l){const w=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(w)return{host:w[1],port:parseInt(w[2],10)};const b=l.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const E=l.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:l,port:void 0}}}),define(oe[121],ae([0,1,25,6,59]),function(Q,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function O(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=O,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var M;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(M||(e.ExtensionType=M={}));var I;(function(v){v.WIN32_X64="win32-x64",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.LINUX_PPC64LE="linux-ppc64le",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class f{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,g){if(typeof m>"u"||m===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof m=="string"||typeof g=="string"){const h=typeof m=="string"?m:m.value,d=typeof g=="string"?g:g.value;return C.equalsIgnoreCase(h,d)}return m._lower===g._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=f;class l{get size(){return this._set.size}constructor(m){if(this._set=new Set,m)for(const g of m)this.add(g)}add(m){this._set.add(f.toKey(m))}delete(m){return this._set.delete(f.toKey(m))}has(m){return this._set.has(f.toKey(m))}}e.ExtensionIdentifierSet=l;class w{constructor(){this._map=new Map}clear(){this._map.clear()}delete(m){this._map.delete(f.toKey(m))}get(m){return this._map.get(f.toKey(m))}has(m){return this._map.has(f.toKey(m))}set(m,g){this._map.set(f.toKey(m),g)}values(){return this._map.values()}forEach(m){this._map.forEach(m)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=w;function b(v){return E(v)}e.isApplicationScopedExtension=b;function E(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function u(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=u;function y(v,m){if(m){const g=`onResolveRemoteAuthority:${(0,r.getRemoteName)(m)}`;return!!v.activationEvents?.includes(g)}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(oe[241],ae([0,1,8,17,23,14,3,2,68,73,32,110,240,59]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const y=30*1e3;var v;(function(G){G[G.Management=1]="Management",G[G.ExtensionHost=2]="ExtensionHost",G[G.Tunnel=3]="Tunnel"})(v||(e.ConnectionType=v={}));function m(G){switch(G){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(G){const A=new r.CancellationTokenSource;return setTimeout(()=>A.cancel(),G),A.token}function h(G,A){if(G.isCancellationRequested||A.isCancellationRequested)return r.CancellationToken.Cancelled;const T=new r.CancellationTokenSource;return G.onCancellationRequested(()=>T.cancel()),A.onCancellationRequested(()=>T.cancel()),T.token}class d{get didTimeout(){return this._state==="timedout"}constructor(A){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((T,Z)=>{this._resolvePromise=T,this._rejectPromise=Z}),A.isCancellationRequested?this._timeout():this._disposables.add(A.onCancellationRequested(()=>this._timeout()))}registerDisposable(A){this._state==="pending"?this._disposables.add(A):A.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(A))}reject(A){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(A))}}function p(G,A){const T=new d(A);return T.registerDisposable(G.onControlMessage(Z=>{const z=JSON.parse(Z.toString()),J=W(z);J?T.reject(J):T.resolve(z)})),T.promise}function a(G,A,T,Z,z,J,B,$){const K=new d($),re=l.StopWatch.create(!1);return G.info(`Creating a socket (${B})...`),f.mark(`code/willCreateSocket/${J}`),A.connect(T,Z,z,B).then(le=>{K.didTimeout?(f.mark(`code/didCreateSocketError/${J}`),G.info(`Creating a socket (${B}) finished after ${re.elapsed()} ms, but this is too late and has timed out already.`),le?.dispose()):(f.mark(`code/didCreateSocketOK/${J}`),G.info(`Creating a socket (${B}) was successful after ${re.elapsed()} ms.`),K.resolve(le))},le=>{f.mark(`code/didCreateSocketError/${J}`),G.info(`Creating a socket (${B}) returned an error after ${re.elapsed()} ms.`),G.error(le),K.reject(le)}),K.promise}function t(G,A){const T=new d(A);return G.then(Z=>{T.didTimeout||T.resolve(Z)},Z=>{T.didTimeout||T.reject(Z)}),T.promise}async function o(G,A,T,Z){const z=ee(G,A);G.logService.trace(`${z} 1/6. invoking socketFactory.connect().`);let J;try{J=await a(G.logService,G.remoteSocketFactoryService,G.connectTo,(0,u.getRemoteServerRootPath)(G),`reconnectionToken=${G.reconnectionToken}&reconnection=${G.reconnectionProtocol?"true":"false"}`,m(A),`renderer-${m(A)}-${G.reconnectionToken}`,Z)}catch(le){throw G.logService.error(`${z} socketFactory.connect() failed or timed out. Error:`),G.logService.error(le),le}G.logService.trace(`${z} 2/6. socketFactory.connect() was successful.`);let B,$;G.reconnectionProtocol?(G.reconnectionProtocol.beginAcceptReconnection(J,null),B=G.reconnectionProtocol,$=!1):(B=new b.PersistentProtocol({socket:J}),$=!0),G.logService.trace(`${z} 3/6. sending AuthRequest control message.`);const K=await t(G.signService.createNewMessage((0,w.generateUuid)()),Z),re={type:"auth",auth:G.connectionToken||"00000000000000000000",data:K.data};B.sendControl(L.VSBuffer.fromString(JSON.stringify(re)));try{const le=await p(B,h(Z,g(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const De=new Error("Unexpected handshake message");throw De.code="VSCODE_CONNECTION_ERROR",De}if(G.logService.trace(`${z} 4/6. received SignRequest control message.`),!await t(G.signService.validate(K,le.signedData),Z)){const De=new Error("Refused to connect to unsupported server");throw De.code="VSCODE_CONNECTION_ERROR",De}const we=await t(G.signService.sign(le.data),Z),Ie={type:"connectionType",commit:G.commit,signedData:we,desiredConnectionType:A};return T&&(Ie.args=T),G.logService.trace(`${z} 5/6. sending ConnectionTypeRequest control message.`),B.sendControl(L.VSBuffer.fromString(JSON.stringify(Ie))),{protocol:B,ownsProtocol:$}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(G.logService.error(`${z} the handshake timed out. Error:`),G.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(G.logService.error(`${z} received error control message when negotiating connection. Error:`),G.logService.error(le)),$&&x(B),le}}async function s(G,A,T,Z){const z=Date.now(),J=ee(G,A),{protocol:B,ownsProtocol:$}=await o(G,A,T,Z),K=new d(Z);return K.registerDisposable(B.onControlMessage(re=>{const le=JSON.parse(re.toString()),ge=W(le);ge?(G.logService.error(`${J} received error control message when negotiating connection. Error:`),G.logService.error(ge),$&&x(B),K.reject(ge)):(G.reconnectionProtocol?.endAcceptReconnection(),G.logService.trace(`${J} 6/6. handshake finished, connection is up and running after ${de(z)}!`),K.resolve({protocol:B,firstMessage:le}))})),K.promise}async function i(G,A){const{protocol:T}=await s(G,1,void 0,A);return{protocol:T}}async function n(G,A,T){const{protocol:Z,firstMessage:z}=await s(G,2,A,T),J=z&&z.debugPort;return{protocol:Z,debugPort:J}}async function c(G,A,T){const Z=Date.now(),z=ee(G,3),{protocol:J}=await o(G,3,A,T);return G.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${de(Z)}!`),J}async function S(G,A,T){const{connectTo:Z,connectionToken:z}=await G.addressProvider.getAddress();return{commit:G.commit,quality:G.quality,connectTo:Z,connectionToken:z,reconnectionToken:A,reconnectionProtocol:T,remoteSocketFactoryService:G.remoteSocketFactoryService,signService:G.signService,logService:G.logService}}async function R(G,A,T){return P(G,async Z=>{const{protocol:z}=await i(Z,r.CancellationToken.None);return new X(G,A,T,Z.reconnectionToken,z)})}e.connectRemoteAgentManagement=R;async function k(G,A){return P(G,async T=>{const{protocol:Z,debugPort:z}=await n(T,A,r.CancellationToken.None);return new Y(G,A,T.reconnectionToken,Z,z)})}e.connectRemoteAgentExtensionHost=k;async function P(G,A){for(let Z=1;;Z++)try{const z=(0,w.generateUuid)(),J=await S(G,z,null);return await A(J)}catch(z){if(Z<5)G.logService.error(`[remote-connection][attempt ${Z}] An error occurred in initial connection! Will retry... Error:`),G.logService.error(z);else throw G.logService.error(`[remote-connection][attempt ${Z}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),G.logService.error(z),ue.triggerPermanentFailure(0,0,E.RemoteAuthorityResolverError.isHandled(z)),z}}async function D(G,A,T){const Z=await S(G,(0,w.generateUuid)(),null);return await c(Z,{host:A,port:T},r.CancellationToken.None)}e.connectRemoteAgentTunnel=D;function _(G){return(0,C.createCancelablePromise)(A=>new Promise((T,Z)=>{const z=setTimeout(T,G*1e3);A.onCancellationRequested(()=>{clearTimeout(z),T()})}))}var N;(function(G){G[G.ConnectionLost=0]="ConnectionLost",G[G.ReconnectionWait=1]="ReconnectionWait",G[G.ReconnectionRunning=2]="ReconnectionRunning",G[G.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",G[G.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class U{constructor(A,T){this.reconnectionToken=A,this.millisSinceLastIncomingData=T,this.type=0}}e.ConnectionLostEvent=U;class j{constructor(A,T,Z,z){this.reconnectionToken=A,this.millisSinceLastIncomingData=T,this.durationSeconds=Z,this.cancellableTimer=z,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=j;class V{constructor(A,T,Z){this.reconnectionToken=A,this.millisSinceLastIncomingData=T,this.attempt=Z,this.type=2}}e.ReconnectionRunningEvent=V;class ce{constructor(A,T,Z){this.reconnectionToken=A,this.millisSinceLastIncomingData=T,this.attempt=Z,this.type=4}}e.ConnectionGainEvent=ce;class se{constructor(A,T,Z,z){this.reconnectionToken=A,this.millisSinceLastIncomingData=T,this.attempt=Z,this.handled=z,this.type=3}}e.ReconnectionPermanentFailureEvent=se;class ue extends I.Disposable{static triggerPermanentFailure(A,T,Z){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=A,this._permanentFailureAttempt=T,this._permanentFailureHandled=Z,this._instances.forEach(z=>z._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(A=>A._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(A=>A._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||ue._permanentFailure}constructor(A,T,Z,z,J){super(),this._connectionType=A,this._options=T,this.reconnectionToken=Z,this.protocol=z,this._reconnectionFailureIsFatal=J,this._onDidStateChange=this._register(new M.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new ce(this.reconnectionToken,0,0)),this._register(z.onSocketClose(B=>{const $=q(this._connectionType,this.reconnectionToken,!0);B?B.type===0?(this._options.logService.info(`${$} received socket close event (hadError: ${B.hadError}).`),B.error&&this._options.logService.error(B.error)):(this._options.logService.info(`${$} received socket close event (wasClean: ${B.wasClean}, code: ${B.code}, reason: ${B.reason}).`),B.event&&this._options.logService.error(B.event)):this._options.logService.info(`${$} received socket close event.`),this._beginReconnecting()})),this._register(z.onSocketTimeout(B=>{const $=q(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${$} received socket timeout event (unacknowledgedMsgCount: ${B.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${B.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${B.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),ue._instances.push(this),this._register((0,I.toDisposable)(()=>{const B=ue._instances.indexOf(this);B>=0&&ue._instances.splice(B,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(ue._permanentFailureMillisSinceLastIncomingData,ue._permanentFailureAttempt,ue._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const A=q(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const T=[0,5,5,10,10,10,10,10,30];let Z=-1;do{Z++;const z=Z<T.length?T[Z]:T[T.length-1];try{if(z>0){const B=_(z);this._onDidStateChange.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z,B)),this._options.logService.info(`${A} waiting for ${z} seconds before reconnecting...`);try{await B}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z+1)),this._options.logService.info(`${A} resolving connection...`);const J=await S(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${A} connecting to ${J.connectTo}...`),await this._reconnect(J,g(y)),this._options.logService.info(`${A} reconnected!`),this._onDidStateChange.fire(new ce(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z+1));break}catch(J){if(J.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(J),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Z+1,!1);break}if(Z>360){this._options.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(J),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Z+1,!1);break}if(E.RemoteAuthorityResolverError.isTemporarilyNotAvailable(J)){this._options.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(J);continue}if((J.code==="ETIMEDOUT"||J.code==="ENETUNREACH"||J.code==="ECONNREFUSED"||J.code==="ECONNRESET")&&J.syscall==="connect"){this._options.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(J);continue}if((0,O.isCancellationError)(J)){this._options.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(J);continue}if(J instanceof E.RemoteAuthorityResolverError){this._options.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(J),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Z+1,E.RemoteAuthorityResolverError.isHandled(J));break}this._options.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(J),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Z+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(A,T,Z){this._reconnectionFailureIsFatal?ue.triggerPermanentFailure(A,T,Z):this._gotoPermanentFailure(A,T,Z)}_gotoPermanentFailure(A,T,Z){this._onDidStateChange.fire(new se(this.reconnectionToken,A,T,Z)),x(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ue;class X extends ue{constructor(A,T,Z,z,J){super(1,A,z,J,!0),this.client=this._register(new b.Client(J,{remoteAuthority:T,clientId:Z},A.ipcLogger))}async _reconnect(A,T){await i(A,T)}}e.ManagementPersistentConnection=X;class Y extends ue{constructor(A,T,Z,z,J){super(2,A,Z,z,!1),this._startArguments=T,this.debugPort=J}async _reconnect(A,T){await n(A,this._startArguments,T)}}e.ExtensionHostPersistentConnection=Y;function x(G){try{G.acceptDisconnect();const A=G.getSocket();G.dispose(),A.dispose()}catch(A){(0,O.onUnexpectedError)(A)}}function W(G){if(G&&G.type==="error"){const A=new Error(`Connection error: ${G.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function F(G,A){for(;G.length<A;)G+=" ";return G}function H(G,A){return`[remote-connection][${F(m(G),13)}][${A.substr(0,5)}\u2026]`}function q(G,A,T){return`${H(G,A)}[${T?"reconnect":"initial"}]`}function ee(G,A){return`${q(A,G.reconnectionToken,!!G.reconnectionProtocol)}[${G.connectTo}]`}function de(G){return`${Date.now()-G} ms`}}),define(oe[242],ae([0,1,2,6]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,L.createDecorator)("remoteSocketFactoryService");class r{constructor(){this.factories={}}register(M,I){return this.factories[M]??=[],this.factories[M].push(I),(0,C.toDisposable)(()=>{const f=this.factories[M]?.indexOf(I);typeof f=="number"&&f>=0&&this.factories[M]?.splice(f,1)})}getSocketFactory(M){return(this.factories[M.type]||[]).find(f=>f.supports(M))}connect(M,I,f,l){const w=this.getSocketFactory(M);if(!w)throw new Error(`No socket factory found for ${M}`);return w.connect(M,I,f,l)}}e.RemoteSocketFactoryService=r}),define(oe[243],ae([0,1,26,48,21,114]),function(Q,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let M;async function I(u=!1){return(M===void 0||u)&&(M=f()),M}e.hasWSLFeatureInstalled=I;async function f(){const u=l();if(u===void 0)return!1;if(u>=22e3){const y=b();if(y)return new Promise(v=>{L.execFile(y,["--status"],m=>v(!m))})}else{const y=E();if(y)try{if((await r.Promises.stat(y)).isFile())return!0}catch{}}return!1}function l(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(C.release());if(u)return parseInt(u[3])}function w(u){const y=process.env.SystemRoot;if(y){const v=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return O.join(y,v?"Sysnative":"System32",u)}}function b(){return w("wsl.exe")}function E(){return w("lxss\\LxssManager.dll")}}),define(oe[53],ae([0,1,17,14,2,183,52,6,5,44]),function(Q,e,C,L,r,O,M,I,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.hasNoContent=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,I.createDecorator)("requestService");class w{constructor(a){this.original=a}toJSON(){if(!this.headers){const a=Object.create(null);for(const t in this.original)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?a[t]="*****":a[t]=this.original[t];this.headers=a}return this.headers}}class b extends r.Disposable{constructor(a){super(),this.counter=0,this.logger=a.createLogger("network",{name:(0,O.localize)(0,null),when:f.CONTEXT_LOG_LEVEL.isEqualTo((0,f.LogLevelToString)(f.LogLevel.Trace)).serialize()})}async logAndRequest(a,t,o){const s=`${a} #${++this.counter}: ${t.url}`;this.logger.trace(`${s} - begin`,t.type,new w(t.headers??{}));try{const i=await o();return this.logger.trace(`${s} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.logger.error(`${s} - error`,t.type,(0,L.getErrorMessage)(i)),i}}}e.AbstractRequestService=b;function E(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.isSuccess=E;function u(p){return p.res.statusCode===204}e.hasNoContent=u;async function y(p){return u(p)?null:(await(0,C.streamToBuffer)(p.stream)).toString()}e.asText=y;async function v(p){if(!E(p))throw new Error("Server returned "+p.res.statusCode);return y(p)}e.asTextOrError=v;async function m(p){if(!E(p))throw new Error("Server returned "+p.res.statusCode);if(u(p))return null;const t=(await(0,C.streamToBuffer)(p.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}e.asJson=m;function g(p){d(p)}e.updateProxyConfigurationsScope=g;let h;function d(p){const a=l.Registry.as(M.Extensions.Configuration),t=h;h={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},a.updateConfigurations({add:[h],remove:t?[t]:[]})}d(1)}),define(oe[244],ae([0,1,17,23]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class r{constructor(I){this.service=I}listen(I,f){throw new Error("Invalid listen")}call(I,f,l,w=L.CancellationToken.None){switch(f){case"request":return this.service.request(l[0],w).then(async({res:b,stream:E})=>{const u=await(0,C.streamToBuffer)(E);return[{statusCode:b.statusCode,headers:b.headers},u]});case"resolveProxy":return this.service.resolveProxy(l[0]);case"loadCertificates":return this.service.loadCertificates()}throw new Error("Invalid call")}}e.RequestChannel=r;class O{constructor(I){this.channel=I}async request(I,f){const[l,w]=await this.channel.call("request",[I],f);return{res:l,stream:(0,C.bufferToStream)(w)}}async resolveProxy(I){return this.channel.call("resolveProxy",[I])}async loadCertificates(){return this.channel.call("loadCertificates")}}e.RequestChannelClient=O}),define(oe[245],ae([0,1,246,12]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function r(M,I){return M.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:M.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function O(M,I,f={}){const l=(0,C.parse)(M),w=f.proxyUrl||r(l,I);if(!w)return null;const b=(0,C.parse)(w);if(!/^https?:$/.test(b.protocol||""))return null;const E={host:b.hostname||"",port:(b.port?+b.port:0)||(b.protocol==="https"?443:80),auth:b.auth,rejectUnauthorized:(0,L.isBoolean)(f.strictSSL)?f.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((u,y)=>{Q(["http-proxy-agent"],u,y)})).HttpProxyAgent(w,E):new(await new Promise((u,y)=>{Q(["https-proxy-agent"],u,y)})).HttpsProxyAgent(w,E)}e.getProxyAgent=O}),define(oe[247],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRawConnection=e.SharedProcessChannelConnection=e.SharedProcessLifecycle=void 0,e.SharedProcessLifecycle={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.SharedProcessChannelConnection={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.SharedProcessRawConnection={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(oe[94],ae([0,1,48,9,184,23,51,14,4,32,109,64,8,140]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let y;async function v(g,h,d,p){return d["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.isWindows?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(p)&&!d["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(p)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=E.Promises.withAsyncBody(async(a,t)=>{const o=new O.CancellationTokenSource;let s=1e4;const i=g.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(s=(0,u.clamp)(i,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),t(new Error((0,r.localize)(0,null)))},s);try{a(await m(h,o.token))}catch(c){!(0,I.isCancellationError)(c)&&!o.token.isCancellationRequested?t(new Error((0,r.localize)(1,null,(0,M.toErrorMessage)(c)))):a({})}finally{clearTimeout(n),o.dispose()}})),y)}e.getResolvedShellEnv=v;async function m(g,h){const d=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",d);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",p);const a=(0,l.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"({.*})"+a),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",o);const s=await(0,w.getSystemShell)(f.OS,o);return g.trace("getUnixShellEnvironment#shell",s),new Promise((i,n)=>{if(h.isCancellationRequested)return n(new I.CancellationError);const c=(0,L.basename)(s);let S,R;const k="";/^pwsh(-preview)?$/.test(c)?(S=`& '${process.execPath}' ${k} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,R=["-Login","-Command"]):c==="nu"?(S=`^'${process.execPath}' ${k} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,R=["-i","-l","-c"]):c==="xonsh"?(S=`import os, json; print("${a}", json.dumps(dict(os.environ)), "${a}")`,R=["-i","-l","-c"]):(S=`'${process.execPath}' ${k} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,c==="tcsh"||c==="csh"?R=["-ic"]:R=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(R),S);const P=(0,C.spawn)(s,[...R,S],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});h.onCancellationRequested(()=>(P.kill(),n(new I.CancellationError))),P.on("error",N=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)(N)),n(N)});const D=[];P.stdout.on("data",N=>D.push(N));const _=[];P.stderr.on("data",N=>_.push(N)),P.on("close",(N,U)=>{const j=Buffer.concat(D).toString("utf8");g.trace("getUnixShellEnvironment#raw",j);const V=Buffer.concat(_).toString("utf8");if(V.trim()&&g.trace("getUnixShellEnvironment#stderr",V),N||U)return n(new Error((0,r.localize)(2,null,N,U)));const ce=t.exec(j),se=ce?ce[1]:"{}";try{const ue=JSON.parse(se);d?ue.ELECTRON_RUN_AS_NODE=d:delete ue.ELECTRON_RUN_AS_NODE,p?ue.ELECTRON_NO_ATTACH_CONSOLE=p:delete ue.ELECTRON_NO_ATTACH_CONSOLE,delete ue.VSCODE_RESOLVING_ENVIRONMENT,delete ue.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",ue),i(ue)}catch(ue){g.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(ue)),n(ue)}})})}}),define(oe[248],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class C{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(r){try{const O=await this.getValidator();if(O){const M=String(C._nextId++);return this.validators.set(M,O),{id:M,data:O.createNewMessage(r)}}}catch{}return{id:"",data:r}}async validate(r,O){if(!r.id)return!0;const M=this.validators.get(r.id);if(!M)return!1;this.validators.delete(r.id);try{return M.validate(O)==="ok"}catch{return!1}finally{M.dispose?.()}}async sign(r){try{return await this.signValue(r)}catch{}return r}}e.AbstractSignService=C}),define(oe[95],ae([0,1,6]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,C.createDecorator)(e.SIGN_SERVICE_ID)}),define(oe[249],ae([0,1,248]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class L extends C.AbstractSignService{getValidator(){return this.vsda().then(O=>new O.validator)}signValue(O){return this.vsda().then(M=>new M.signer().sign(O))}vsda(){return new Promise((O,M)=>Q(["vsda"],O,M))}}e.SignService=L}),define(oe[34],ae([0,1,6]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,C.createDecorator)("stateReadService"),e.IStateService=(0,C.createDecorator)("stateService")}),define(oe[122],ae([0,1,8,17,2,12,38,16,5]),function(Q,e,C,L,r,O,M,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var l;(function(u){u[u.IMMEDIATE=0]="IMMEDIATE",u[u.DELAYED=1]="DELAYED"})(l||(e.SaveStrategy=l={}));class w extends r.Disposable{constructor(y,v,m,g){super(),this.storagePath=y,this.saveStrategy=v,this.logService=m,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=this._register(new C.ThrottledDelayer(this.saveStrategy===0?0:100)),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}}getItem(y,v){const m=this.storage[y];return(0,O.isUndefinedOrNull)(m)?v:m}setItem(y,v){this.setItems([{key:y,data:v}])}setItems(y){let v=!1;for(const{key:m,data:g}of y)this.storage[m]!==g&&((0,O.isUndefinedOrNull)(g)?(0,O.isUndefined)(this.storage[m])||(this.storage[m]=void 0,v=!0):(this.storage[m]=g,v=!0));v&&this.save()}removeItem(y){(0,O.isUndefined)(this.storage[y])||(this.storage[y]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const y=JSON.stringify(this.storage,null,4);if(y!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(y),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=y}catch(v){this.logService.error(v)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=w;let b=class extends r.Disposable{constructor(y,v,m,g){super(),this.fileStorage=this._register(new w(v.stateResource,y,m,g))}async init(){await this.fileStorage.init()}getItem(y,v){return this.fileStorage.getItem(y,v)}};e.StateReadonlyService=b,e.StateReadonlyService=b=be([ne(1,M.IEnvironmentService),ne(2,f.ILogService),ne(3,I.IFileService)],b);class E extends b{setItem(y,v){this.fileStorage.setItem(y,v)}setItems(y){this.fileStorage.setItems(y)}removeItem(y){this.fileStorage.removeItem(y)}close(){return this.fileStorage.close()}}e.StateService=E}),define(oe[123],ae([0,1,4,36,32]),function(Q,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function O(f){if(C.platform===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function M(f,l,w,b,E,u,y,v,m){const g=Object.create(null);g["common.machineId"]=u,g["common.sqmId"]=y,g.sessionID=(0,r.generateUuid)()+Date.now(),g.commitHash=b,g.version=E,g["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,C.PlatformToString)(C.platform),g["common.nodePlatform"]=L.platform,g["common.nodeArch"]=w,g["common.product"]=m||"desktop",v&&(g["common.msftInternal"]=v);let h=0;const d=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-d,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),C.isLinuxSnap&&(g["common.snap"]="true");const p=O(l);return p&&(g["common.platformDetail"]=p),g}e.resolveCommonProperties=M;function I(f){const l=L.env.USERDNSDOMAIN;if(!l)return!1;const w=l.toLowerCase();return f.some(b=>w===b)}e.verifyMicrosoftInternalDomain=I}),define(oe[28],ae([0,1,6]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,C.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,C.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var r;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(r||(e.TelemetryConfiguration=r={}))}),define(oe[250],ae([0,1,26,8,42,13,9,4,7,88,21,108,91,16,27,28]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const m=new Map;async function g(t,o){const s=`${t}::${o.join(":")}`,i=m.get(s);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,S=new Map,R=2e4;function k(D,_,N,U){const j=_.substring(D.length+1);return L.Promises.withAsyncBody(async V=>{let ce;try{ce=await w.Promises.readdir(_,{withFileTypes:!0})}catch{V();return}if(U.count>=R){U.count+=ce.length,U.maxReached=!0,V();return}let se=ce.length;if(se===0){V();return}let ue=ce;U.count+ce.length>R&&(U.maxReached=!0,se=R-U.count,ue=ce.slice(0,se)),U.count+=ce.length;for(const X of ue)if(X.isDirectory()){if(N.includes(X.name)||await k(D,(0,M.join)(_,X.name),N,U),--se===0){V();return}}else{const Y=X.name.lastIndexOf(".");if(Y>=0){const x=X.name.substring(Y+1);x&&c.set(x,(c.get(x)??0)+1)}for(const x of n)x.relativePathPattern?.test(j)!==!1&&x.filePattern.test(X.name)&&S.set(x.tag,(S.get(x.tag)??0)+1);if(--se===0){V();return}}})}const P=L.Promises.withAsyncBody(async D=>{const _={count:0,maxReached:!1};await k(t,t,o,_);const N=await p(t);D({configFiles:h(S),fileTypes:h(c),fileCount:_.count,maxFilesReached:_.maxReached,launchConfigFiles:N})});return m.set(s,P),P}e.collectWorkspaceStats=g;function h(t){return Array.from(t.entries(),([o,s])=>({name:o,count:s})).sort((o,s)=>s.count-o.count)}function d(){const t={os:`${C.type()} ${C.arch()} ${C.release()}`,memory:`${(C.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(C.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(l.virtualMachineHint.value()*100)}%`},o=C.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}e.getMachineInfo=d;async function p(t){try{const o=new Map,s=(0,M.join)(t,".vscode","launch.json"),i=await w.Promises.readFile(s),n=[],c=(0,r.parse)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${s}`),[];if((0,r.getNodeType)(c)==="object"&&c.configurations)for(const S of c.configurations){const R=S.type;R&&(o.has(R)?o.set(R,o.get(R)+1):o.set(R,1))}return h(o)}catch{return[]}}e.collectLaunchConfigs=p;let a=class{constructor(o,s){this.telemetryService=o,this.productService=s}formatMachineInfo(o){const s=[];return s.push(`OS Version:       ${o.os}`),s.push(`CPUs:             ${o.cpus}`),s.push(`Memory (System):  ${o.memory}`),s.push(`VM:               ${o.vmHint}`),s.join(`
`)}formatEnvironment(o){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${C.type()} ${C.arch()} ${C.release()}`);const i=C.cpus();return i&&i.length>0&&s.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),s.push(`Memory (System):  ${(C.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(C.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`),I.isWindows||s.push(`Load (avg):       ${C.loadavg().map(n=>Math.round(n)).join(", ")}`),s.push(`VM:               ${Math.round(l.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${o.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(o.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(o,s){return Promise.all([(0,b.listProcesses)(o.mainPID),this.formatWorkspaceMetadata(o)]).then(async i=>{let[n,c]=i,S=this.formatProcessList(o,n);return s.forEach(R=>{if((0,E.isRemoteDiagnosticError)(R))S+=`
${R.errorMessage}`,c+=`
${R.errorMessage}`;else if(S+=`

Remote: ${R.hostName}`,R.processes&&(S+=`
${this.formatProcessList(o,R.processes)}`),R.workspaceMetadata){c+=`
|  Remote: ${R.hostName}`;for(const k of Object.keys(R.workspaceMetadata)){const P=R.workspaceMetadata[k];let D=`${P.fileCount} files`;P.maxFilesReached&&(D=`more than ${D}`),c+=`|    Folder (${k}): ${D}`,c+=this.formatWorkspaceStats(P)}}}),{processInfo:S,workspaceInfo:c}})}async getSystemInfo(o,s){const{memory:i,vmHint:n,os:c,cpus:S}=d(),R={os:c,memory:i,cpus:S,vmHint:n,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:s};return I.isWindows||(R.load=`${C.loadavg().map(k=>Math.round(k)).join(", ")}`),I.isLinux&&(R.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(R)}async getDiagnostics(o,s){const i=[];return(0,b.listProcesses)(o.mainPID).then(async n=>(i.push(""),i.push(this.formatEnvironment(o)),i.push(""),i.push(this.formatProcessList(o,n)),o.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(o))),s.forEach(c=>{if((0,E.isRemoteDiagnosticError)(c))i.push(`
${c.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${c.hostName}`),i.push(this.formatMachineInfo(c.machineInfo)),c.processes&&i.push(this.formatProcessList(o,c.processes)),c.workspaceMetadata)for(const S of Object.keys(c.workspaceMetadata)){const R=c.workspaceMetadata[S];let k=`${R.fileCount} files`;R.maxFilesReached&&(k=`more than ${k}`),i.push(`Folder (${S}): ${k}`),i.push(this.formatWorkspaceStats(R))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(o){const s=[];let n=0;const c=(P,D)=>{const _=` ${P}(${D})`;n+_.length>60?(s.push(S),S="|                 ",n=S.length):n+=_.length,S+=_};let S="|      File types:";const R=10,k=o.fileTypes.length>R?R:o.fileTypes.length;for(let P=0;P<k;P++){const D=o.fileTypes[P];c(D.name,D.count)}if(s.push(S),o.configFiles.length>=0&&(S="|      Conf files:",n=0,o.configFiles.forEach(P=>{c(P.name,P.count)}),s.push(S)),o.launchConfigFiles.length>0){let P="|      Launch Configs:";o.launchConfigFiles.forEach(D=>{const _=D.count>1?` ${D.name}(${D.count})`:` ${D.name}`;P+=_}),s.push(P)}return s.join(`
`)}expandGPUFeatures(o){const s=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(s-i.length)}  ${o[i]}`).join(`
                  `)}formatWorkspaceMetadata(o){const s=[],i=[];return o.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(s.push(`|  Window (${n.title})`),n.folderURIs.forEach(c=>{const S=f.URI.revive(c);if(S.scheme===O.Schemas.file){const R=S.fsPath;i.push(g(R,["node_modules",".git"]).then(k=>{let P=`${k.fileCount} files`;k.maxFilesReached&&(P=`more than ${P}`),s.push(`|    Folder (${(0,M.basename)(R)}): ${P}`),s.push(this.formatWorkspaceStats(k))}).catch(k=>{s.push(`|      Error: Unable to collect workspace stats for folder ${R} (${k.toString()})`)}))}else s.push(`|    Folder (${S.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>s.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}formatProcessList(o,s){const i=new Map;o.windows.forEach(c=>i.set(c.pid,`window [${c.id}] (${c.title})`)),o.pidToNames.forEach(({pid:c,name:S})=>i.set(c,S));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(o.mainPID,i,n,s,0),n.join(`
`)}formatProcessItem(o,s,i,n,c){const S=c===0;let R;S?R=n.pid===o?`${this.productService.applicationName} main`:"remote agent":s.has(n.pid)?R=s.get(n.pid):R=`${"  ".repeat(c)} ${n.name}`;const k=process.platform==="win32"?n.mem:C.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(k/u.ByteSize.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${R}`),Array.isArray(n.children)&&n.children.forEach(P=>this.formatProcessItem(o,s,i,P,c+1))}async getWorkspaceFileExtensions(o){const s=new Set;for(const{uri:i}of o.folders){const n=f.URI.revive(i);if(n.scheme!==O.Schemas.file)continue;const c=n.fsPath;try{(await g(c,["node_modules",".git"])).fileTypes.forEach(R=>s.add(R.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(o){for(const{uri:s}of o.folders){const i=f.URI.revive(s);if(i.scheme!==O.Schemas.file)continue;const n=i.fsPath;try{const c=await g(n,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),c.fileTypes.forEach(S=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:S.name,count:S.count})}),c.launchConfigFiles.forEach(S=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:S.name,count:S.count})}),c.configFiles.forEach(S=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:S.name,count:S.count})})}catch{}}}};e.DiagnosticsService=a,e.DiagnosticsService=a=be([ne(0,v.ITelemetryService),ne(1,y.IProductService)],a)}),define(oe[251],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class C{constructor(O){this.appenders=O}listen(O,M){throw new Error(`Event not found: ${M}`)}call(O,M,{eventName:I,data:f}){return this.appenders.forEach(l=>l.log(I,f)),Promise.resolve(null)}}e.TelemetryAppenderChannel=C;class L{constructor(O){this.channel=O}log(O,M){return this.channel.call("log",{eventName:O,data:M}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(oe[54],ae([0,1,35,12,59,123,28]),function(Q,e,C,L,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class I{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=I;class f{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=f,e.NullTelemetryService=new f;class l{async publicLog(o,s,i){}async publicLogError(o,s,i){}}e.NullEndpointTelemetryService=l,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(t,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!t.enableTelemetry)}e.supportsTelemetry=w;function b(t,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.isLoggingOnly=b;function E(t){const o=t.getValue(M.TELEMETRY_SETTING_ID),s=t.getValue(M.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(t.getValue(M.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function u(t){const o={},s={},i={};m(t,i);for(let n in i){n=n.length>150?n.substr(n.length-149):n;const c=i[n];typeof c=="number"?s[n]=c:typeof c=="boolean"?s[n]=c?1:0:typeof c=="string"?(c.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${c.length}`),o[n]=c.substring(0,8191)):typeof c<"u"&&c!==null&&(o[n]=c)}return{properties:o,measurements:s}}e.validateTelemetryData=u;const y=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function v(t){if(!t)return"none";const o=(0,r.getRemoteName)(t);return y.has(o)?o:"other"}e.cleanRemoteAuthority=v;function m(t,o,s=0,i){if(t)for(const n of Object.getOwnPropertyNames(t)){const c=t[n],S=i?i+n:n;Array.isArray(c)?o[S]=(0,C.safeStringify)(c):c instanceof Date?o[S]=c.toISOString():(0,L.isObject)(c)?s<2?m(c,o,s+1,S+"."):o[S]=(0,C.safeStringify)(c):o[S]=c}}function g(t,o){const s=t.msftInternalDomains||[],i=o.getValue("telemetry.internalTesting");return(0,O.verifyMicrosoftInternalDomain)(s)||i}e.isInternalTelemetry=g;function h(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.getPiiPathsFromEnvironment=h;function d(t,o){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const i=[];for(const R of o)for(;;){const k=R.exec(t);if(!k)break;i.push([k.index,R.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(s="";;){const R=c.exec(t);if(!R)break;const k=i.some(([P,D])=>R.index<D&&P<c.lastIndex);!n.test(R[0])&&!k&&(s+=t.substring(S,R.index)+"<REDACTED: user-file-path>",S=c.lastIndex)}return S<t.length&&(s+=t.substr(S)),s}function p(t){if(!t)return t;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of o)if(s.regex.test(t))return`<REDACTED: ${s.label}>`;return t}function a(t,o){return(0,C.cloneAndChange)(t,s=>{if(s instanceof I||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let i=s.replaceAll("%20"," ");i=d(i,o);for(const n of o)i=i.replace(n,"");return i=p(i),i}})}e.cleanData=a}),define(oe[124],ae([0,1,25,118,121,4,7,14,36,54]),function(Q,e,C,L,r,O,M,I,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function w(s,i){return s.uuid&&i.uuid?s.uuid===i.uuid:s.id===i.id?!0:(0,C.compareIgnoreCase)(s.id,i.id)===0}e.areSameExtensions=w;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class E{static create(i){const n=i.manifest?i.manifest.version:i.version,c=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new E(i.identifier,n,c)}static parse(i){const n=b.exec(i);return n&&n[1]&&n[2]?new E({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,c="undefined"){this.version=n,this.targetPlatform=c,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof E?w(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=E;const u=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(s){const i=u.exec(s);return i&&i[1]?[m(i[1]),i[2]]:[m(s),void 0]}e.getIdAndVersion=y;function v(s,i){return`${s}.${i}`}e.getExtensionId=v;function m(s){return s.toLowerCase()}e.adoptToGalleryExtensionId=m;function g(s,i){return m(v(s??r.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=g;function h(s,i){const n=[],c=S=>{for(const R of n)if(R.some(k=>w(i(k),i(S))))return R;return null};for(const S of s){const R=c(S);R?R.push(S):n.push([S])}return n}e.groupByExtension=h;function d(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=d;function p(s){return{id:new l.TelemetryTrustedValue(s.identifier.id),name:new l.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=p,e.BetterMergeId=new r.ExtensionIdentifier("pprice.better-merge");function a(s,i){const n=[],c=i.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const S=c.shift();if(S&&n.every(R=>!w(R.identifier,{id:S}))){const R=s.filter(k=>w(k.identifier,{id:S}));R.length===1&&(n.push(R[0]),c.push(...R[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=a;async function t(s,i){if(!O.isLinux)return!1;let n;try{n=(await s.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await s.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){i.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(S))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(s,i){const n=await t(s,i),c=(0,L.getTargetPlatform)(n?"alpine":O.platform,f.arch);return i.debug("ComputeTargetPlatform:",c),c}e.computeTargetPlatform=o}),define(oe[252],ae([0,1,206,54]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function r(O,M,I,f,l,w,b){const E={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${M.nameShort})`};if((0,L.supportsTelemetry)(M,I)&&(0,L.getTelemetryLevel)(f)===3){const u=await(0,C.getServiceMachineId)(I,l,w);E["X-Market-User-Id"]=u,E["VSCode-SessionId"]=b.machineId||u}return E}e.resolveMarketplaceHeaders=r}),define(oe[253],ae([0,1,2,35,4,25,185,18,52,79,27,44,28,54]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(g,h,d){this._configurationService=h,this._productService=d,this._experimentProperties={},this._disposables=new C.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=g.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,O.escapeRegExpCharacters)(p),"gi")),p.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,O.escapeRegExpCharacters)(p.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(p=>{(p.affectsConfiguration(E.TELEMETRY_SETTING_ID)||p.affectsConfiguration(E.TELEMETRY_OLD_SETTING_ID)||p.affectsConfiguration(E.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(g,h){this._experimentProperties[g]=h}_updateTelemetryLevel(){let g=(0,u.getTelemetryLevel)(this._configurationService);const h=this._productService.enabledTelemetryLevels;if(h){this._sendErrorTelemetry=this.sendErrorTelemetry?h.error:!1;const d=h.usage?3:h.error?2:0;g=Math.min(g,d)}this._telemetryLevel=g}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(g,h,d){this._telemetryLevel<h||(d=(0,L.mixin)(d,this._experimentProperties),d=(0,u.cleanData)(d,this._cleanupPatterns),d=(0,L.mixin)(d,this._commonProperties),this._appenders.forEach(p=>p.log(g,d)))}publicLog(g,h){this._log(g,3,h)}publicLog2(g,h){this.publicLog(g,h)}publicLogError(g,h){this._sendErrorTelemetry&&this._log(g,2,h)}publicLogError2(g,h){this.publicLogError(g,h)}};e.TelemetryService=y,e.TelemetryService=y=be([ne(1,I.IConfigurationService),ne(2,w.IProductService)],y);function v(){const m=(0,M.localize)(0,null,l.default.nameLong),g=l.default.privacyStatementUrl?(0,M.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,M.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=r.isWeb?"":(0,M.localize)(3,null),d=(0,M.localize)(4,null),p=(0,M.localize)(5,null),a=(0,M.localize)(6,null),t=(0,M.localize)(7,null),o=`
|       | ${d} | ${p} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,M.localize)(8,null);return`
${m} ${g} ${h}

&nbsp;

${t}
${o}

&nbsp;

${s}
`}b.Registry.as(f.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,M.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,M.localize)(10,null),(0,M.localize)(11,null),(0,M.localize)(12,null),(0,M.localize)(13,null)],markdownDescription:v(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(f.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,M.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,M.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,M.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,M.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[254],ae([0,1,4,88,28]),function(Q,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveSqmId=e.resolveMachineId=void 0;async function O(I,f){let l=I.getItem(r.machineIdKey);return(typeof l!="string"||C.isMacintosh&&l==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(l=await(0,L.getMachineId)(f.error.bind(f))),l}e.resolveMachineId=O;async function M(I,f){let l=I.getItem(r.sqmIdKey);return typeof l!="string"&&(l=await(0,L.getSqmMachineId)(f.error.bind(f))),l}e.resolveSqmId=M}),define(oe[255],ae([0,1,28,254]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveSqmId=e.resolveMachineId=void 0;async function r(M,I){const f=await(0,L.resolveMachineId)(M,I);return M.setItem(C.machineIdKey,f),f}e.resolveMachineId=r;async function O(M,I){const f=await(0,L.resolveSqmId)(M,I);return M.setItem(C.sqmIdKey,f),f}e.resolveSqmId=O}),define(oe[125],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var C;(function(L){L[L.Replace=1]="Replace",L[L.Append=2]="Append",L[L.Prepend=3]="Prepend"})(C||(e.EnvironmentVariableMutatorType=C={}))}),define(oe[256],ae([0,1,4,125]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;const r=new Map([[L.EnvironmentVariableMutatorType.Append,"APPEND"],[L.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[L.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class O{constructor(w){this.collections=w,this.map=new Map,this.descriptionMap=new Map,w.forEach((b,E)=>{this.populateDescriptionMap(b,E);const u=b.map.entries();let y=u.next();for(;!y.done;){const v=y.value[1],m=y.value[0];let g=this.map.get(m);if(g||(g=[],this.map.set(m,g)),g.length>0&&g[0].type===L.EnvironmentVariableMutatorType.Replace){y=u.next();continue}const h={extensionIdentifier:E,value:v.value,type:v.type,scope:v.scope,variable:v.variable,options:v.options};h.scope||delete h.scope,g.unshift(h),y=u.next()}})}async applyToProcessEnvironment(w,b,E){let u;C.isWindows&&(u={},Object.keys(w).forEach(y=>u[y.toLowerCase()]=y));for(const[y,v]of this.getVariableMap(b)){const m=C.isWindows&&u[y.toLowerCase()]||y;for(const g of v){const h=E?await E(g.value):g.value;if(g.options?.applyAtProcessCreation??!0)switch(g.type){case L.EnvironmentVariableMutatorType.Append:w[m]=(w[m]||"")+h;break;case L.EnvironmentVariableMutatorType.Prepend:w[m]=h+(w[m]||"");break;case L.EnvironmentVariableMutatorType.Replace:w[m]=h;break}if(g.options?.applyAtShellIntegration??!1){const d=`VSCODE_ENV_${r.get(g.type)}`;w[d]=(w[d]?w[d]+":":"")+y+"="+this._encodeColons(h)}}}}_encodeColons(w){return w.replaceAll(":","\\x3a")}diff(w,b){const E=new Map,u=new Map,y=new Map;if(w.getVariableMap(b).forEach((v,m)=>{const g=this.getVariableMap(b).get(m),h=I(v,g);h&&E.set(m,h)}),this.getVariableMap(b).forEach((v,m)=>{const g=w.getVariableMap(b).get(m),h=I(v,g);h&&y.set(m,h)}),this.getVariableMap(b).forEach((v,m)=>{const g=w.getVariableMap(b).get(m),h=f(v,g);h&&u.set(m,h)}),!(E.size===0&&u.size===0&&y.size===0))return{added:E,changed:u,removed:y}}getVariableMap(w){const b=new Map;for(const E of this.map.values()){const u=E.filter(y=>M(y,w));u.length>0&&b.set(u[0].variable,u)}return b}getDescriptionMap(w){const b=new Map;for(const E of this.descriptionMap.values()){const u=E.filter(y=>M(y,w,!0));for(const y of u)b.set(y.extensionIdentifier,y.description)}return b}populateDescriptionMap(w,b){if(!w.descriptionMap)return;const E=w.descriptionMap.entries();let u=E.next();for(;!u.done;){const y=u.value[1],v=u.value[0];let m=this.descriptionMap.get(v);m||(m=[],this.descriptionMap.set(v,m));const g={extensionIdentifier:b,scope:y.scope,description:y.description};g.scope||delete g.scope,m.push(g),u=E.next()}}}e.MergedEnvironmentVariableCollection=O;function M(l,w,b=!1){return l.scope?!!(l.scope.workspaceFolder&&w?.workspaceFolder&&l.scope.workspaceFolder.index===w.workspaceFolder.index):b?w===l.scope:!0}function I(l,w){if(!w)return l;const b=new Set;w.forEach(u=>b.add(u.extensionIdentifier));const E=[];return l.forEach(u=>{b.has(u.extensionIdentifier)||E.push(u)}),E.length===0?void 0:E}function f(l,w){if(!w)return;const b=new Map;w.forEach(u=>b.set(u.extensionIdentifier,u));const E=[];return l.forEach(u=>{const y=b.get(u.extensionIdentifier);y&&(u.type!==y.type||u.value!==y.value||u.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index)&&E.push(y)}),E.length===0?void 0:E}}),define(oe[257],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function C(f){return[...f.entries()]}e.serializeEnvironmentVariableCollection=C;function L(f){return f?[...f.entries()]:[]}e.serializeEnvironmentDescriptionMap=L;function r(f){return new Map(f)}e.deserializeEnvironmentVariableCollection=r;function O(f){return new Map(f??[])}e.deserializeEnvironmentDescriptionMap=O;function M(f){return Array.from(f.entries()).map(l=>[l[0],C(l[1].map),L(l[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=M;function I(f){return new Map(f.map(l=>[l[0],{map:r(l[1]),descriptionMap:O(l[2])}]))}e.deserializeEnvironmentVariableCollections=I}),define(oe[258],ae([0,1,8,23,3,2,5]),function(Q,e,C,L,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let I=class extends O.Disposable{constructor(l,w){super(),this._logService=w,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new r.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=l===void 0?15e3:l,this._register((0,O.toDisposable)(()=>{for(const b of this._pendingRequestDisposables.values())(0,O.dispose)(b)}))}createRequest(l){return new Promise((w,b)=>{const E=++this._lastRequestId;this._pendingRequests.set(E,w),this._onCreateRequest.fire({requestId:E,...l});const u=new L.CancellationTokenSource;(0,C.timeout)(this._timeout,u.token).then(()=>b(`Request ${E} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(E,[(0,O.toDisposable)(()=>u.cancel())])})}acceptReply(l,w){const b=this._pendingRequests.get(l);b?(this._pendingRequests.delete(l),(0,O.dispose)(this._pendingRequestDisposables.get(l)||[]),this._pendingRequestDisposables.delete(l),b(w)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${l}`)}};e.RequestStore=I,e.RequestStore=I=be([ne(1,M.ILogService)],I)}),define(oe[126],ae([0,1,6,115,44]),function(Q,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new L.RawContextKey("terminalTabFocusMode",!1,!0);var O;(function(a){a.AutomationProfile="terminal.integrated.automationProfile.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var M;(function(a){a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.TabStopWidth="terminal.integrated.tabStopWidth",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorStyleInactive="terminal.integrated.cursorStyleInactive",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.TabFocusMode="terminal.integrated.tabFocusMode",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",a.LocalEchoEnabled="terminal.integrated.localEchoEnabled",a.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",a.LocalEchoStyle="terminal.integrated.localEchoStyle",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.HideOnStartup="terminal.integrated.hideOnStartup",a.CustomGlyphs="terminal.integrated.customGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",a.EnableImages="terminal.integrated.enableImages",a.SmoothScrolling="terminal.integrated.smoothScrolling",a.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",a.FocusAfterRun="terminal.integrated.focusAfterRun",a.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",a.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",a.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",a.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",a.MouseWheelZoom="terminal.integrated.mouseWheelZoom",a.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",a.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",a.DevMode="terminal.integrated.developer.devMode"})(M||(e.TerminalSettingId=M={}));var I;(function(a){a.PowerShell="pwsh",a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh"})(I||(e.PosixShellType=I={}));var f;(function(a){a.CommandPrompt="cmd",a.PowerShell="pwsh",a.Wsl="wsl",a.GitBash="gitbash"})(f||(e.WindowsShellType=f={}));var l;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(l||(e.TitleEventSource=l={}));var w;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.PtyHostWindow="ptyHostWindow",a.Logger="logger",a.Heartbeat="heartbeat"})(w||(e.TerminalIpcChannels=w={}));var b;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(b||(e.ProcessPropertyType=b={})),e.IPtyService=(0,C.createDecorator)("ptyService");var E;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E||(e.HeartbeatConstants=E={}));var u;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})(u||(e.TerminalLocation=u={}));var y;(function(a){a.TerminalView="view",a.Editor="editor"})(y||(e.TerminalLocationString=y={}));var v;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(v||(e.LocalReconnectConstants=v={}));var m;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(m||(e.FlowControlConstants=m={}));var g;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})(g||(e.ProfileSource=g={}));var h;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var d;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(d||(e.TerminalExitReason=d={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class p{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(t){const o=this._sanitizeRemoteAuthority(t.remoteAuthority);if(this._backends.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this._backends.set(o,t)}getTerminalBackend(t){return this._backends.get(this._sanitizeRemoteAuthority(t))}_sanitizeRemoteAuthority(t){return t?.toLowerCase()??""}}r.Registry.add(e.TerminalExtensions.Backend,new p),e.ILocalPtyService=(0,C.createDecorator)("localPtyService"),e.ITerminalLogService=(0,C.createDecorator)("terminalLogService")}),define(oe[259],ae([0,1,75,7,187,103]),function(Q,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function M(E,u){const y=[{name:null,description:(0,r.localize)(0,null)}];return y.push(...E.map(v=>({name:v.profileName,description:I(v)}))),u&&y.push(...u.map(v=>({name:v.title,description:f(v)}))),{values:y.map(v=>v.name),markdownDescriptions:y.map(v=>v.description)}}e.createProfileSchemaEnums=M;function I(E){let u=`$(${O.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:C.Codicon.terminal.id}) ${E.profileName}
- path: ${E.path}`;return E.args&&(typeof E.args=="string"?u+=`
- args: "${E.args}"`:u+=`
- args: [${E.args.length===0?"":`'${E.args.join("','")}'`}]`),E.overrideName!==void 0&&(u+=`
- overrideName: ${E.overrideName}`),E.color&&(u+=`
- color: ${E.color}`),E.env&&(u+=`
- env: ${JSON.stringify(E.env)}`),u}function f(E){return`$(${O.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:C.Codicon.terminal.id}) ${E.title}
- extensionIdentifier: ${E.extensionIdentifier}`}function l(E,u){if(!E&&!u)return!0;if(typeof E=="string"&&typeof u=="string")return E===u;if(Array.isArray(E)&&Array.isArray(u)){if(E.length!==u.length)return!1;for(let y=0;y<E.length;y++)if(E[y]!==u[y])return!1;return!0}return!1}e.terminalProfileArgsMatch=l;function w(E,u){if(!E&&!u)return!0;if(!E||!u)return!1;if(O.ThemeIcon.isThemeIcon(E)&&O.ThemeIcon.isThemeIcon(u))return E.id===u.id&&E.color===u.color;if(typeof E=="object"&&"light"in E&&"dark"in E&&typeof u=="object"&&"light"in u&&"dark"in u){const y=E,v=u;if((L.URI.isUri(y.light)||b(y.light))&&(L.URI.isUri(y.dark)||b(y.dark))&&(L.URI.isUri(v.light)||b(v.light))&&(L.URI.isUri(v.dark)||b(v.dark)))return y.light.path===v.light.path&&y.dark.path===v.dark.path}if(L.URI.isUri(E)&&L.URI.isUri(u)||b(E)||b(u)){const y=E,v=u;return y.path===v.path&&y.scheme===v.scheme}return!1}e.terminalIconsEqual=w;function b(E){return E?typeof E.path=="string"&&typeof E.scheme=="string":!1}e.isUriComponents=b}),define(oe[260],ae([0,1,75,4,186,52,44,259]),function(Q,e,C,L,r,O,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,C.getAllCodicons)(),m=>m.id),markdownEnumDescriptions:Array.from((0,C.getAllCodicons)(),m=>`$(${m.id})`)};const f={args:{description:(0,r.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,r.localize)(1,null),type:"boolean"},icon:{description:(0,r.localize)(2,null),...e.terminalIconSchema},color:{description:(0,r.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,r.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},l={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(5,null),type:["string","array"],items:{type:"string"}},...f}},w={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(6,null),type:["string"],items:{type:"string"}},...f}};function b(m){const g=m===2?"linux":m===1?"osx":"windows";return(0,r.localize)(7,null,(0,L.PlatformToString)(m),'```json\n"terminal.integrated.profile.'+g+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const E={id:"terminal",order:100,title:(0,r.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:b(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,r.localize)(12,null),enum:["PowerShell","Git Bash"]},...f}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(13,null),type:"string"},id:{description:(0,r.localize)(14,null),type:"string"},title:{description:(0,r.localize)(15,null),type:"string"},...f}},{type:"null"},l]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:b(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(16,null),type:"string"},id:{description:(0,r.localize)(17,null),type:"string"},title:{description:(0,r.localize)(18,null),type:"string"},...f}},{type:"null"},l]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:b(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(19,null),type:"string"},id:{description:(0,r.localize)(20,null),type:"string"},title:{description:(0,r.localize)(21,null),type:"string"},...f}},{type:"null"},l]}},["terminal.integrated.useWslProfiles"]:{description:(0,r.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,r.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,r.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,r.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,r.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function u(){M.Registry.as(O.Extensions.Configuration).registerConfiguration(E),v()}e.registerTerminalPlatformConfiguration=u;let y;function v(m,g){const h=M.Registry.as(O.Extensions.Configuration);let d;m&&(d=(0,I.createProfileSchemaEnums)(m?.profiles,g));const p=y;y={id:"terminal",order:100,title:(0,r.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(28,null),type:["string","null"],default:null,enum:m?.os===3?d?.values:void 0,markdownEnumDescriptions:m?.os===3?d?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(29,null),type:["string","null"],default:null,enum:m?.os===2?d?.values:void 0,markdownEnumDescriptions:m?.os===2?d?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(30,null),type:["string","null"],default:null,enum:m?.os===1?d?.values:void 0,markdownEnumDescriptions:m?.os===1?d?.markdownDescriptions:void 0}}},h.updateConfigurations({add:[y],remove:p?[p]:[]})}e.registerTerminalDefaultProfileConfiguration=v}),define(oe[261],ae([0,1,26,13,35,9,4,36,25,12,21,125,257,256]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function y(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(C.release());let n=0;return i&&i.length===4&&(n=parseInt(i[3])),n}e.getWindowsBuildNumber=y;async function v(i,n,c,S=I.env,R=w.Promises.exists){if(O.isAbsolute(i))return await R(i)?i:void 0;if(n===void 0&&(n=I.cwd()),O.dirname(i)!=="."){const _=O.join(n,i);return await R(_)?_:void 0}const P=(0,r.getCaseInsensitive)(S,"PATH");if(c===void 0&&(0,l.isString)(P)&&(c=P.split(O.delimiter)),c===void 0||c.length===0){const _=O.join(n,i);return await R(_)?_:void 0}for(const _ of c){let N;if(O.isAbsolute(_)?N=O.join(_,i):N=O.join(n,_,i),await R(N))return N;if(M.isWindows){let U=N+".com";if(await R(U)||(U=N+".exe",await R(U)))return U}}const D=O.join(n,i);return await R(D)?D:void 0}e.findExecutable=v;function m(i,n,c,S,R){const k=M.isWindows&&(!n.windowsEnableConpty||y()<18309);if(!n.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||k)return;const P=i.args,D=I.platform==="win32"?O.basename(i.executable).toLowerCase():O.basename(i.executable),_=O.dirname(L.FileAccess.asFileUri("").fsPath);let N;const U={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(U.VSCODE_NONCE=n.shellIntegration.nonce),M.isWindows){if(D==="pwsh.exe"||D==="powershell.exe")return!P||o(P)?N=d.get(h.WindowsPwsh):t(P)&&(N=d.get(h.WindowsPwshLogin)),N?(N=[...N],N[N.length-1]=(0,f.format)(N[N.length-1],_,""),n.shellIntegration.suggestEnabled&&(U.VSCODE_SUGGEST="1"),{newArgs:N,envMixin:U}):void 0;S.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(D){case"bash":return!P||P.length===0?N=d.get(h.Bash):s(P)&&(U.VSCODE_SHELL_LOGIN="1",g(n,U),N=d.get(h.Bash)),N?(N=[...N],N[N.length-1]=(0,f.format)(N[N.length-1],_),{newArgs:N,envMixin:U}):void 0;case"fish":{const j=c?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",V=O.join(_,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return U.XDG_DATA_DIRS=`${j}:${V}`,g(n,U),{newArgs:void 0,envMixin:U}}case"pwsh":return!P||o(P)?N=d.get(h.Pwsh):t(P)&&(N=d.get(h.PwshLogin)),N?(n.shellIntegration.suggestEnabled&&(U.VSCODE_SUGGEST="1"),N=[...N],N[N.length-1]=(0,f.format)(N[N.length-1],_,""),{newArgs:N,envMixin:U}):void 0;case"zsh":{if(!P||P.length===0?N=d.get(h.Zsh):s(P)?(N=d.get(h.ZshLogin),g(n,U)):(P===d.get(h.Zsh)||P===d.get(h.ZshLogin))&&(N=P),!N)return;N=[...N],N[N.length-1]=(0,f.format)(N[N.length-1],_);let j;try{j=C.userInfo().username}catch{j="unknown"}const V=O.join(C.tmpdir(),`${j}-${R.applicationName}-zsh`);U.ZDOTDIR=V;const ce=c?.ZDOTDIR??C.homedir()??"~";U.USER_ZDOTDIR=ce;const se=[];return se.push({source:O.join(_,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:O.join(V,".zshrc")}),se.push({source:O.join(_,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:O.join(V,".zprofile")}),se.push({source:O.join(_,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:O.join(V,".zshenv")}),se.push({source:O.join(_,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:O.join(V,".zlogin")}),{newArgs:N,envMixin:U,filesToCopy:se}}}S.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.getShellIntegrationInjection=m;function g(i,n){if(M.isMacintosh&&i.environmentVariableCollections){const c=(0,E.deserializeEnvironmentVariableCollections)(i.environmentVariableCollections),R=new u.MergedEnvironmentVariableCollection(c).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),k=[];if(R)for(const P of R)P.type===b.EnvironmentVariableMutatorType.Prepend&&k.push(P.value);k.length>0&&(n.VSCODE_PATH_PREFIX=k.join(""))}}var h;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(h||(h={}));const d=new Map;d.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),d.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),d.set(h.Zsh,["-i"]),d.set(h.ZshLogin,["-il"]),d.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const p=["-login","-l"],a=["-nol","-nologo"];function t(i){return typeof i=="string"?p.includes(i.toLowerCase()):i.length===1&&p.includes(i[0].toLowerCase())||i.length===2&&(p.includes(i[0].toLowerCase())||p.includes(i[1].toLowerCase()))&&(a.includes(i[0].toLowerCase())||a.includes(i[1].toLowerCase()))}function o(i){return typeof i=="string"?a.includes(i.toLowerCase()):i.length===0||i?.length===1&&a.includes(i[0].toLowerCase())}function s(i){return i==="string"&&p.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&p.includes(i[0].toLowerCase())}}),define(oe[262],ae([0,1,48,75,9,4,12,21,107,261,114]),function(Q,e,C,L,r,O,M,I,f,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;var b;(function(c){c.UnixShellsPath="/etc/shells"})(b||(b={}));let E,u=!0;function y(c,S,R,k,P=process.env,D,_,N,U){return D=D||{existsFile:I.SymlinkSupport.existsFile,readFile:I.Promises.readFile},O.isWindows?v(R,D,P,_,k.getValue("terminal.integrated.useWslProfiles")!==!1,c&&typeof c=="object"?{...c}:k.getValue("terminal.integrated.profiles.windows"),typeof S=="string"?S:k.getValue("terminal.integrated.defaultProfile.windows"),U,N):s(D,_,R,c&&typeof c=="object"?{...c}:k.getValue(O.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof S=="string"?S:k.getValue(O.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),U,N,P)}e.detectAvailableProfiles=y;async function v(c,S,R,k,P,D,_,N,U){const j=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),V=`${process.env.windir}\\${j?"Sysnative":"System32"}`;let ce=!1;(0,l.getWindowsBuildNumber)()>=16299&&(ce=!0),await d(N);const se=new Map;if(c){se.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),se.set("Windows PowerShell",{path:`${V}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),se.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),se.set("Command Prompt",{path:`${V}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0}),se.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),se.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:L.Codicon.terminalBash,isAutoDetected:!0});const X=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;se.set("Cmder",{path:`${V}\\cmd.exe`,args:["/K",X],requiresPath:process.env.CMDER_ROOT?X:{path:X,isUnsafe:!0},isAutoDetected:!0})}i(D,se);const ue=await m(se.entries(),_,S,R,k,U);if(c&&P)try{const X=await t(`${V}\\${ce?"wsl":"bash"}.exe`,_);for(const Y of X)(!D||!(Y.profileName in D))&&ue.push(Y)}catch{u&&(k?.info("WSL is not installed, so could not detect WSL profiles"),u=!1)}return ue}async function m(c,S,R,k=process.env,P,D){const _=[];for(const[N,U]of c)_.push(g(N,U,S,R,k,P,D));return(await Promise.all(_)).filter(N=>!!N)}async function g(c,S,R,k,P=process.env,D,_){if(S===null)return;let N,U,j;if("source"in S&&!("path"in S)){const ue=E?.get(S.source);if(!ue)return;N=ue.paths,U=S.args||ue.args,S.icon?j=h(S.icon):ue.icon&&(j=ue.icon)}else N=Array.isArray(S.path)?S.path:[S.path],U=O.isWindows||Array.isArray(S.args)?S.args:void 0,j=h(S.icon);let V;if(_){const ue=N.map(Y=>typeof Y=="string"?Y:Y.path),X=await _(ue);V=new Array(N.length);for(let Y=0;Y<N.length;Y++)typeof N[Y]=="string"?V[Y]=X[Y]:V[Y]={path:X[Y],isUnsafe:!0}}else V=N.slice();let ce;if(S.requiresPath){let ue;if((0,M.isString)(S.requiresPath)?ue=S.requiresPath:(ue=S.requiresPath.path,S.requiresPath.isUnsafe&&(ce=ue)),!await k.existsFile(ue))return}const se=await n(c,R,V,k,P,U,S.env,S.overrideName,S.isAutoDetected,ce);if(!se){D?.debug("Terminal profile not validated",c,N);return}return se.isAutoDetected=S.isAutoDetected,se.icon=j,se.color=S.color,se}function h(c){return typeof c=="string"?{id:c}:c}async function d(c){if(E&&!c)return;const[S,R]=await Promise.all([p(),c||a()]);E=new Map,E.set("Git Bash",{profileName:"Git Bash",paths:S,args:["--login","-i"]}),E.set("PowerShell",{profileName:"PowerShell",paths:R,icon:L.Codicon.terminalPowershell})}async function p(){const c=new Set,S=await(0,l.findExecutable)("git.exe");if(S){const P=(0,w.dirname)(S);c.add((0,w.resolve)(P,"../.."))}function R(P,D){D&&P.add(D)}R(c,process.env.ProgramW6432),R(c,process.env.ProgramFiles),R(c,process.env["ProgramFiles(X86)"]),R(c,`${process.env.LocalAppData}\\Program`);const k=[];for(const P of c)k.push(`${P}\\Git\\bin\\bash.exe`,`${P}\\Git\\usr\\bin\\bash.exe`,`${P}\\usr\\bin\\bash.exe`);return k.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),k.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),k}async function a(){const c=[];for await(const S of(0,f.enumeratePowerShellInstallations)())c.push(S.exePath);return c}async function t(c,S){const R=[],k=await new Promise((_,N)=>{C.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(U,j)=>{if(U)return N("Problem occurred when getting wsl distros");_(j)})});if(!k)return[];const P=new RegExp(/[\r?\n]/),D=k.split(P).filter(_=>_.trim().length>0&&_!=="");for(const _ of D){if(_===""||_.startsWith("docker-desktop"))continue;const N=`${_} (WSL)`,U={profileName:N,path:c,args:["-d",`${_}`],isDefault:N===S,icon:o(_),isAutoDetected:!1};R.push(U)}return R}function o(c){return c.includes("Ubuntu")?L.Codicon.terminalUbuntu:c.includes("Debian")?L.Codicon.terminalDebian:L.Codicon.terminalLinux}async function s(c,S,R,k,P,D,_,N){const U=new Map;if(R&&await c.existsFile("/etc/shells")){const j=(await c.readFile("/etc/shells")).toString(),V=(D||j.split(`
`)).map(se=>{const ue=se.indexOf("#");return ue===-1?se:se.substring(0,ue)}).filter(se=>se.trim().length>0),ce=new Map;for(const se of V){let ue=(0,r.basename)(se),X=ce.get(ue)||0;X++,X>1&&(ue=`${ue} (${X})`),ce.set(ue,X),U.set(ue,{path:se,isAutoDetected:!0})}}return i(k,U),await m(U.entries(),P,c,N,S,_)}function i(c,S){if(c)for(const[R,k]of Object.entries(c))k===null||typeof k!="object"||!("path"in k)&&!("source"in k)?S.delete(R):(k.icon=k.icon||S.get(R)?.icon,S.set(R,k))}async function n(c,S,R,k,P,D,_,N,U,j){if(R.length===0)return Promise.resolve(void 0);const V=R.shift();if(V==="")return n(c,S,R,k,P,D,_,N,U);const ce=typeof V!="string"&&V.isUnsafe,se=typeof V=="string"?V:V.path,ue={profileName:c,path:se,args:D,env:_,overrideName:N,isAutoDetected:U,isDefault:c===S,isUnsafePath:ce,requiresUnsafePath:j};if((0,r.basename)(se)===se){const Y=P.PATH?P.PATH.split(r.delimiter):void 0,x=await(0,l.findExecutable)(se,void 0,Y,void 0,k.existsFile);return x?(ue.path=x,ue.isFromPath=!0,ue):n(c,S,R,k,P,D)}return await k.existsFile((0,r.normalize)(se))?ue:n(c,S,R,k,P,D,_,N,U)}}),define(oe[263],ae([0,1,3,2,4,43,18,5,226,94,258,126,260,262,109,73]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var m;(function(h){h[h.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let g=class extends L.Disposable{get _connection(){return this._ensurePtyHost(),this.__connection}get _proxy(){return this._ensurePtyHost(),this.__proxy}get _optionalProxy(){return this.__proxy}_ensurePtyHost(){this.__connection||this._startPtyHost()}constructor(d,p,a,t){super(),this._ptyHostStarter=d,this._configurationService=p,this._logService=a,this._loggerService=t,this._wasQuitRequested=!1,this._restartCount=0,this._isResponsive=!0,this._onPtyHostExit=this._register(new C.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new C.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new C.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new C.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new C.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new C.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new C.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new C.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new C.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new C.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new C.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new C.Emitter),this.onProcessExit=this._onProcessExit.event,(0,E.registerTerminalPlatformConfiguration)(),this._register(this._ptyHostStarter),this._register((0,L.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new w.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),this._ptyHostStarter.onRequestConnection&&C.Event.once(this._ptyHostStarter.onRequestConnection)(()=>this._ensurePtyHost()),this._ptyHostStarter.onWillShutdown?.(()=>this._wasQuitRequested=!0)}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._optionalProxy?.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(r.isWindows)return process.env;try{return await(0,l.getResolvedShellEnv)(this._configurationService,this._logService,{_:[]},process.env)}catch(d){return this._logService.error("ptyHost was unable to resolve shell environment",d),{}}}_startPtyHost(){const d=this._ptyHostStarter.start(),p=d.client;this._logService.getLevel()===I.LogLevel.Trace&&this._logService.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),O.ProxyChannel.toService(p.getChannel(b.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(!0),this._register(d.onDidProcessExit(o=>{this._onPtyHostExit.fire(o.code),!this._wasQuitRequested&&!this._store.isDisposed&&(this._restartCount<=m.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${o.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const t=O.ProxyChannel.toService(p.getChannel(b.TerminalIpcChannels.PtyHost));return this._register(t.onProcessData(o=>this._onProcessData.fire(o))),this._register(t.onProcessReady(o=>this._onProcessReady.fire(o))),this._register(t.onProcessExit(o=>this._onProcessExit.fire(o))),this._register(t.onDidChangeProperty(o=>this._onDidChangeProperty.fire(o))),this._register(t.onProcessReplay(o=>this._onProcessReplay.fire(o))),this._register(t.onProcessOrphanQuestion(o=>this._onProcessOrphanQuestion.fire(o))),this._register(t.onDidRequestDetach(o=>this._onDidRequestDetach.fire(o))),this._register(new f.RemoteLoggerChannelClient(this._loggerService,p.getChannel(b.TerminalIpcChannels.Logger))),this.__connection=d,this.__proxy=t,this._onPtyHostStart.fire(),this._register(this._configurationService.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()})),this._refreshIgnoreProcessNames(),[d,t]}async createProcess(d,p,a,t,o,s,i,n,c,S,R){const k=setTimeout(()=>this._handleUnresponsiveCreateProcess(),b.HeartbeatConstants.CreateProcessTimeout),P=await this._proxy.createProcess(d,p,a,t,o,s,i,n,c,S,R);return clearTimeout(k),P}updateTitle(d,p,a){return this._proxy.updateTitle(d,p,a)}updateIcon(d,p,a,t){return this._proxy.updateIcon(d,p,a,t)}attachToProcess(d){return this._proxy.attachToProcess(d)}detachFromProcess(d,p){return this._proxy.detachFromProcess(d,p)}shutdownAll(){return this._proxy.shutdownAll()}listProcesses(){return this._proxy.listProcesses()}async getPerformanceMarks(){return this._optionalProxy?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this._optionalProxy?.reduceConnectionGraceTime()}start(d){return this._proxy.start(d)}shutdown(d,p){return this._proxy.shutdown(d,p)}input(d,p){return this._proxy.input(d,p)}processBinary(d,p){return this._proxy.processBinary(d,p)}resize(d,p,a){return this._proxy.resize(d,p,a)}clearBuffer(d){return this._proxy.clearBuffer(d)}acknowledgeDataEvent(d,p){return this._proxy.acknowledgeDataEvent(d,p)}setUnicodeVersion(d,p){return this._proxy.setUnicodeVersion(d,p)}getInitialCwd(d){return this._proxy.getInitialCwd(d)}getCwd(d){return this._proxy.getCwd(d)}async getLatency(){const d=new v.StopWatch,p=await this._proxy.getLatency();return d.stop(),[{label:"ptyhostservice<->ptyhost",latency:d.elapsed()},...p]}orphanQuestionReply(d){return this._proxy.orphanQuestionReply(d)}installAutoReply(d,p){return this._proxy.installAutoReply(d,p)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(d){return this._proxy.uninstallAutoReply(d)}getDefaultSystemShell(d){return this._optionalProxy?.getDefaultSystemShell(d)??(0,y.getSystemShell)(d??r.OS,process.env)}async getProfiles(d,p,a,t=!1){const o=await this._resolveShellEnv();return(0,u.detectAvailableProfiles)(p,a,t,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,d))}async getEnvironment(){return this.__proxy?this._proxy.getEnvironment():{...process.env}}getWslPath(d,p){return this._proxy.getWslPath(d,p)}getRevivedPtyNewId(d,p){return this._proxy.getRevivedPtyNewId(d,p)}setTerminalLayoutInfo(d){return this._proxy.setTerminalLayoutInfo(d)}async getTerminalLayoutInfo(d){return this._optionalProxy?.getTerminalLayoutInfo(d)}async requestDetachInstance(d,p){return this._proxy.requestDetachInstance(d,p)}async acceptDetachInstanceReply(d,p){return this._proxy.acceptDetachInstanceReply(d,p)}async freePortKillProcess(d){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(d)}async serializeTerminalState(d){return this._proxy.serializeTerminalState(d)}async reviveTerminalProcesses(d,p,a){return this._proxy.reviveTerminalProcesses(d,p,a)}async refreshProperty(d,p){return this._proxy.refreshProperty(d,p)}async updateProperty(d,p,a){return this._proxy.updateProperty(d,p,a)}async restartPtyHost(){this._disposePtyHost(),this._isResponsive=!0,this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll(),this._connection.store.dispose()}_handleHeartbeat(d){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),d?b.HeartbeatConstants.ConnectingBeatInterval:b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier+b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${b.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(d,p){return this._resolveVariablesRequestStore.createRequest({workspaceId:d,originalText:p})}async acceptPtyHostResolvedVariables(d,p){this._resolveVariablesRequestStore.acceptReply(d,p)}};e.PtyHostService=g,e.PtyHostService=g=be([ne(1,M.IConfigurationService),ne(2,I.ILogService),ne(3,I.ILoggerService)],g)}),define(oe[70],ae([0,1,15,3,2,4,18,6,34]),function(Q,e,C,L,r,O,M,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const l="#FFFFFF",w="#1E1E1E",b="#000000",E="#FFFFFF",u="theme",y="themeBackground",v="windowSplash";e.IThemeMainService=(0,I.createDecorator)("themeMainService");let m=class extends r.Disposable{constructor(h,d){super(),this.stateService=h,this.configurationService=d,this._onDidChangeColorScheme=this._register(new L.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._register(this.configurationService.onDidChangeConfiguration(p=>{p.affectsConfiguration("window.systemColorTheme")&&this.updateSystemColorTheme()})),this.updateSystemColorTheme(),this._register(L.Event.fromNodeEventEmitter(C.nativeTheme,"updated")(()=>this._onDidChangeColorScheme.fire(this.getColorScheme())))}updateSystemColorTheme(){switch(this.configurationService.getValue("window.systemColorTheme")){case"dark":C.nativeTheme.themeSource="dark";break;case"light":C.nativeTheme.themeSource="light";break;case"auto":switch(this.getBaseTheme()){case"vs":C.nativeTheme.themeSource="light";break;case"vs-dark":C.nativeTheme.themeSource="dark";break;default:C.nativeTheme.themeSource="system"}break;default:C.nativeTheme.themeSource="system";break}}getColorScheme(){if(O.isWindows){if(C.nativeTheme.shouldUseHighContrastColors)return{dark:C.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(O.isMacintosh){if(C.nativeTheme.shouldUseInvertedColorScheme||C.nativeTheme.shouldUseHighContrastColors)return{dark:C.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(O.isLinux&&C.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:C.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const h=this.getColorScheme();if(h.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return h.dark?b:E;let d=this.stateService.getItem(y,null);if(!d)switch(this.getBaseTheme()){case"vs":d=l;break;case"hc-black":d=b;break;case"hc-light":d=E;break;default:d=w}return O.isMacintosh&&d.toUpperCase()===w&&(d="#171717"),d}getBaseTheme(){switch(this.stateService.getItem(u,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(h,d){this.stateService.setItems([{key:u,data:d.baseTheme},{key:y,data:d.colorInfo.background},{key:v,data:d}]),typeof h=="number"&&this.updateBackgroundColor(h,d),this.updateSystemColorTheme()}updateBackgroundColor(h,d){for(const p of C.BrowserWindow.getAllWindows())if(p.id===h){p.setBackgroundColor(d.colorInfo.background);break}}getWindowSplash(){return this.stateService.getItem(v)}};e.ThemeMainService=m,e.ThemeMainService=m=be([ne(0,f.IStateService),ne(1,M.IConfigurationService)],m)}),define(oe[127],ae([0,1,3,18,6,5]),function(Q,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,r.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,r.createDecorator)("sharedTunnelsService");var M;(function(m){m.Http="http",m.Https="https"})(M||(e.TunnelProtocol=M={}));var I;(function(m){m.ConstantPrivate="constantPrivate",m.Private="private",m.Public="public"})(I||(e.TunnelPrivacyId=I={}));function f(m){return!!m.forwardPort}e.isTunnelProvider=f;var l;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(l||(e.ProvidedOnAutoForward=l={}));function w(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=w,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(m){return e.LOCALHOST_ADDRESSES.indexOf(m)>=0}e.isLocalhost=b,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(m){return e.ALL_INTERFACES_ADDRESSES.indexOf(m)>=0}e.isAllInterfaces=E;function u(m,g,h,d){if(h===1)return!1;if(h===2&&E(g)){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(p?.length===4&&parseInt(p[1])>=18)return!1}return m<1024}e.isPortPrivileged=u;class y{constructor(g,h,d){this.remoteAddress=g,this.localAddress=h,this._dispose=d,this._onDispose=new C.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=y;let v=class{constructor(g,h){this.logService=g,this.configurationService=h,this._onTunnelOpened=new C.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new C.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new C.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const g=this.configurationService.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(g){return this._tunnelProvider=g,g?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this._canElevate=g.elevation,this._privacyOptions=g.privacyOptions,this._canChangeProtocol=g.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const g=[],h=Array.from(this._tunnels.values());for(const d of h){const p=Array.from(d.values());for(const a of p){const t=await a.value;t&&typeof t!="string"&&g.push(t)}}return g}async dispose(){for(const g of this._tunnels.values()){for(const{value:h}of g.values())await h.then(d=>typeof d!="string"?d?.dispose():void 0);g.clear()}this._tunnels.clear()}setEnvironmentTunnel(g,h,d,p,a){this.addTunnelToMap(g,h,Promise.resolve({tunnelRemoteHost:g,tunnelRemotePort:h,localAddress:d,privacy:p,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(g,h){(E(g)||b(g))&&(g=e.LOCALHOST_ADDRESSES[0]);const d=this.getTunnelFromMap(g,h);if(d)return++d.refcount,d.value}openTunnel(g,h,d,p,a,t=!1,o,s){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${d} on local port ${a}.`);const i=this._tunnelProvider??g;if(!i)return;if(h||(h="localhost"),p||(p=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(d)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.retainOrCreateTunnel(i,h,d,p,a,t,o,s);return n?n.then(c=>{if(c){if(typeof c=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(h,d),c}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(h,d);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.makeTunnel(c);return(c.tunnelRemoteHost!==h||c.tunnelRemotePort!==d)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&c.privacy!==o&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(S),S}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const h=this._tunnels.get(g.tunnelRemoteHost);if(h){const d=h.get(g.tunnelRemotePort);d&&(d.refcount--,await this.tryDisposeTunnel(g.tunnelRemoteHost,g.tunnelRemotePort,d))}}}}async tryDisposeTunnel(g,h,d){if(d.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${h}.`);const p=d.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this._onTunnelClosed.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this._tunnels.has(g)&&this._tunnels.get(g).delete(h),p}}async closeTunnel(g,h){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${h} `);const d=this._tunnels.get(g);if(d&&d.has(h)){const p=d.get(h);p.refcount=0,await this.tryDisposeTunnel(g,h,p)}}addTunnelToMap(g,h,d){this._tunnels.has(g)||this._tunnels.set(g,new Map),this._tunnels.get(g).set(h,{refcount:1,value:d})}async removeEmptyOrErrorTunnelFromMap(g,h){const d=this._tunnels.get(g);if(d){const p=d.get(h),a=p?await p.value:void 0;(!a||typeof a=="string")&&d.delete(h),d.size===0&&this._tunnels.delete(g)}}getTunnelFromMap(g,h){const d=[g];b(g)?(d.push(...e.LOCALHOST_ADDRESSES),d.push(...e.ALL_INTERFACES_ADDRESSES)):E(g)&&d.push(...e.ALL_INTERFACES_ADDRESSES);const p=d.map(a=>this._tunnels.get(a));for(const a of p){const t=a?.get(h);if(t)return t}}canTunnel(g){return!!w(g)}createWithProvider(g,h,d,p,a,t,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${d} on local port ${p}.`);const s=d;this._factoryInProgress.add(s);const i=p===void 0?d:p,n={elevationRequired:a?this.isPortPrivileged(i):!1},c={remoteAddress:{host:h,port:d},localAddressPort:p,privacy:t,public:t?t!==I.Private:void 0,protocol:o},S=g.forwardPort(c,n);return S?(this.addTunnelToMap(h,d,S),S.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),S}};e.AbstractTunnelService=v,e.AbstractTunnelService=v=be([ne(0,O.ILogService),ne(1,L.IConfigurationService)],v)}),define(oe[49],ae([0,1,6]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.DisablementReason=e.UpdateType=e.StateType=void 0;var L;(function(M){M.Uninitialized="uninitialized",M.Idle="idle",M.Disabled="disabled",M.CheckingForUpdates="checking for updates",M.AvailableForDownload="available for download",M.Downloading="downloading",M.Downloaded="downloaded",M.Updating="updating",M.Ready="ready"})(L||(e.StateType=L={}));var r;(function(M){M[M.Setup=0]="Setup",M[M.Archive=1]="Archive",M[M.Snap=2]="Snap",M[M.WindowsInstaller=3]="WindowsInstaller"})(r||(e.UpdateType=r={}));var O;(function(M){M[M.NotBuilt=0]="NotBuilt",M[M.DisabledByEnvironment=1]="DisabledByEnvironment",M[M.ManuallyDisabled=2]="ManuallyDisabled",M[M.MissingConfiguration=3]="MissingConfiguration",M[M.InvalidConfiguration=4]="InvalidConfiguration",M[M.RunningAsAdmin=5]="RunningAsAdmin"})(O||(e.DisablementReason=O={})),e.State={Uninitialized:{type:"uninitialized"},Disabled:M=>({type:"disabled",reason:M}),Idle:(M,I)=>({type:"idle",updateType:M,error:I}),CheckingForUpdates:M=>({type:"checking for updates",explicit:M}),AvailableForDownload:M=>({type:"available for download",update:M}),Downloading:M=>({type:"downloading",update:M}),Downloaded:M=>({type:"downloaded",update:M}),Updating:M=>({type:"updating",update:M}),Ready:M=>({type:"ready",update:M})},e.IUpdateService=(0,C.createDecorator)("updateService")}),define(oe[264],ae([0,1,4,188,52,44]),function(Q,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),O.Registry.as(r.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:C.isWindows&&!C.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(oe[265],ae([0,1,3,49]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class r{constructor(I){this.service=I}listen(I,f){switch(f){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${f}`)}call(I,f,l){switch(f){case"checkForUpdates":return this.service.checkForUpdates(l);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(l)}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=r;class O{get state(){return this._state}set state(I){this._state=I,this._onStateChange.fire(I)}constructor(I){this.channel=I,this._onStateChange=new C.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(f=>this.state=f),this.channel.call("_getInitialState").then(f=>this.state=f)}checkForUpdates(I){return this.channel.call("checkForUpdates",I)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(I){return this.channel.call("_applySpecificUpdate",I)}}e.UpdateChannelClient=O}),define(oe[40],ae([0,1,6]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,C.createDecorator)("IUriIdentityService")}),define(oe[266],ae([0,1,40,207,16,19,141,3,2]),function(Q,e,C,L,r,O,M,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class l{static{this._clock=0}constructor(E){this.uri=E,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let w=class{constructor(E){this._fileService=E,this._dispooables=new f.DisposableStore,this._limit=2**16;const u=new Map,y=v=>{let m=u.get(v.scheme);return m===void 0&&(m=E.hasProvider(v)&&!this._fileService.hasCapability(v,1024),u.set(v.scheme,m)),m};this._dispooables.add(I.Event.any(E.onDidChangeFileSystemProviderRegistrations,E.onDidChangeFileSystemProviderCapabilities)(v=>{u.delete(v.scheme)})),this.extUri=new O.ExtUri(y),this._canonicalUris=new M.SkipList((v,m)=>this.extUri.compare(v,m,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(E){this._fileService.hasProvider(E)&&(E=(0,O.normalizePath)(E));const u=this._canonicalUris.get(E);return u?u.touch().uri.with({fragment:E.fragment}):(this._canonicalUris.set(E,new l(E)),this._checkTrim(),E)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const E=[...this._canonicalUris.entries()].sort((y,v)=>y[1].time<v[1].time?1:y[1].time>v[1].time?-1:0);l._clock=0,this._canonicalUris.clear();const u=this._limit*.5;for(let y=0;y<u;y++)this._canonicalUris.set(E[y][0],E[y][1].touch())}};e.UriIdentityService=w,e.UriIdentityService=w=be([ne(0,r.IFileService)],w),(0,L.registerSingleton)(C.IUriIdentityService,w,1)}),define(oe[128],ae([0,1,6]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,C.createDecorator)("urlService")}),define(oe[267],ae([0,1,7]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(I){this.handler=I}listen(I,f){throw new Error(`Event not found: ${f}`)}call(I,f,l){switch(f){case"handleURL":return this.handler.handleURL(C.URI.revive(l[0]),l[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=L;class r{constructor(I){this.channel=I}handleURL(I,f){return this.channel.call("handleURL",[I.toJSON(),f])}}e.URLHandlerChannelClient=r;class O{constructor(I,f){this.next=I,this.logService=f}async routeCall(I,f,l,w){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(Array.isArray(l)&&l.length>0){const b=C.URI.revive(l[0]);if(this.logService.trace("URLHandlerRouter#routeCall() with URI argument",b.toString(!0)),b.query){const E=/\bwindowId=(\d+)/.exec(b.query);if(E){const u=E[1];this.logService.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${u}"`,b.toString(!0));const y=new RegExp(`window:${u}`),v=I.connections.find(m=>(this.logService.trace("URLHandlerRouter#routeCall(): testing connection",m.ctx),y.test(m.ctx)));if(v)return this.logService.trace("URLHandlerRouter#routeCall(): found a connection to route",b.toString(!0)),v;this.logService.trace("URLHandlerRouter#routeCall(): did not find a connection to route",b.toString(!0))}else this.logService.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",b.toString(!0))}}else this.logService.trace("URLHandlerRouter#routeCall() without URI argument");return this.next.routeCall(I,f,l,w)}routeEvent(I,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=O}),define(oe[268],ae([0,1,8,2,7,27]),function(Q,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends L.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(l,w){const b=[...this.handlers.values()];return(0,C.first)(b.map(E=>()=>E.handleURL(l,w)),void 0,!1).then(E=>E||!1)}registerHandler(l){return this.handlers.add(l),(0,L.toDisposable)(()=>this.handlers.delete(l))}}e.AbstractURLService=M;let I=class extends M{constructor(l){super(),this.productService=l}create(l){let{authority:w,path:b,query:E,fragment:u}=l||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return w&&b&&b.indexOf("/")!==0&&(b=`/${b}`),r.URI.from({scheme:this.productService.urlProtocol,authority:w,path:b,query:E,fragment:u})}};e.NativeURLService=I,e.NativeURLService=I=be([ne(0,O.IProductService)],I)}),define(oe[269],ae([0,1,15,8,3,2,4,7]),function(Q,e,C,L,r,O,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class f extends O.Disposable{constructor(w,b,E,u,y,v){if(super(),this.urlService=b,this.logService=v,this.uris=[],this.retryCount=0,w&&(v.trace("ElectronURLListener initialUrisToHandle:",w.map(h=>h.originalUrl)),this.uris=w),M.isWindows){const h=u.isBuilt?[]:[`"${u.appRoot}"`];h.push("--open-url","--"),C.app.setAsDefaultProtocolClient(y.urlProtocol,process.execPath,h)}const m=r.Event.map(r.Event.fromNodeEventEmitter(C.app,"open-url",(h,d)=>({event:h,url:d})),({event:h,url:d})=>(h.preventDefault(),d));this._register(m(h=>{const d=this.uriFromRawUrl(h);d&&this.urlService.open(d,{originalUrl:h})})),E.getWindows().filter(h=>h.isReady).length>0?(v.trace("ElectronURLListener: window is ready to handle URLs"),this.flush()):(v.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this._register(r.Event.once(E.onDidSignalReadyWindow)(()=>this.flush())))}uriFromRawUrl(w){try{return I.URI.parse(w)}catch{return}}async flush(){if(this.retryCount++>10){this.logService.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.logService.trace("ElectronURLListener#flush(): flushing URLs");const w=[];for(const b of this.uris)await this.urlService.open(b.uri,{originalUrl:b.originalUrl})?this.logService.trace("ElectronURLListener#flush(): URL was handled",b.originalUrl):(this.logService.trace("ElectronURLListener#flush(): URL was not yet handled",b.originalUrl),w.push(b));w.length!==0&&(this.uris=w,(0,L.disposableTimeout)(()=>this.flush(),500,this._store))}}e.ElectronURLListener=f}),define(oe[270],ae([0,1,3,2,16,58,31]),function(Q,e,C,L,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class I extends L.Disposable{constructor(l,w,b,E,u,y){super(),this.fileSystemScheme=l,this.fileSystemProvider=w,this.userDataScheme=b,this.userDataProfilesService=E,this.uriIdentityService=u,this.logService=y,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=O.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.atomicReadWriteResources=new M.ResourceSet(v=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(v))),this.updateAtomicReadWritesResources(),this._register(E.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(v=>this.handleFileChanges(v)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const l of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(l.settingsResource),this.atomicReadWriteResources.add(l.keybindingsResource),this.atomicReadWriteResources.add(l.tasksResource),this.atomicReadWriteResources.add(l.extensionsResource)}open(l,w){return this.fileSystemProvider.open(this.toFileSystemResource(l),w)}close(l){return this.fileSystemProvider.close(l)}read(l,w,b,E,u){return this.fileSystemProvider.read(l,w,b,E,u)}write(l,w,b,E,u){return this.fileSystemProvider.write(l,w,b,E,u)}watch(l,w){this.watchResources.set(l,l);const b=this.fileSystemProvider.watch(this.toFileSystemResource(l),w);return(0,L.toDisposable)(()=>{this.watchResources.delete(l),b.dispose()})}stat(l){return this.fileSystemProvider.stat(this.toFileSystemResource(l))}mkdir(l){return this.fileSystemProvider.mkdir(this.toFileSystemResource(l))}rename(l,w,b){return this.fileSystemProvider.rename(this.toFileSystemResource(l),this.toFileSystemResource(w),b)}readFile(l,w){return this.fileSystemProvider.readFile(this.toFileSystemResource(l),w)}readFileStream(l,w,b){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(l),w,b)}readdir(l){return this.fileSystemProvider.readdir(this.toFileSystemResource(l))}enforceAtomicReadFile(l){return this.atomicReadWriteResources.has(l)}writeFile(l,w,b){return this.fileSystemProvider.writeFile(this.toFileSystemResource(l),w,b)}enforceAtomicWriteFile(l){return this.atomicReadWriteResources.has(l)?{postfix:".vsctmp"}:!1}delete(l,w){return this.fileSystemProvider.delete(this.toFileSystemResource(l),w)}copy(l,w,b){if((0,r.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(l),this.toFileSystemResource(w),b);throw new Error("copy not supported")}cloneFile(l,w){if((0,r.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(l),this.toFileSystemResource(w));throw new Error("clone not supported")}handleFileChanges(l){const w=[];for(const b of l){if(b.resource.scheme!==this.fileSystemScheme)continue;const E=this.toUserDataResource(b.resource);this.watchResources.findSubstr(E)&&w.push({resource:E,type:b.type,cId:b.cId})}w.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(w))}toFileSystemResource(l){return l.with({scheme:this.fileSystemScheme})}toUserDataResource(l){return l.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=I}),define(oe[271],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(oe[272],ae([0,1,6]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,C.createDecorator)("webviewManagerService")}),define(oe[273],ae([0,1,15,2,13,7]),function(Q,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class M extends L.Disposable{static{this.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const f=this.handleWebviewRequest.bind(this);C.protocol.registerFileProtocol(r.Schemas.vscodeWebview,f)}handleWebviewRequest(f,l){try{const w=O.URI.parse(f.url),b=M.validWebviewFilePaths.get(w.path);if(typeof b=="string"){const E=`vs/workbench/contrib/webview/browser/pre/${b}`,u=r.FileAccess.asFileUri(E);return l({path:u.fsPath,headers:{...r.COI.getHeadersFromQuery(f.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return l({error:-10})}catch{}return l({error:-2})}}e.WebviewProtocolProvider=M}),define(oe[60],ae([0,1,4]),function(Q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useNativeFullScreen=e.useWindowControlsOverlay=e.getTitleBarStyle=e.hasNativeTitlebar=e.hasCustomTitlebar=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.isOpenedAuxiliaryWindow=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(g){return typeof g.parentId=="number"}e.isOpenedAuxiliaryWindow=L;function r(g){return!!g.workspaceUri}e.isWorkspaceToOpen=r;function O(g){return!!g.folderUri}e.isFolderToOpen=O;function M(g){return!!g.fileUri}e.isFileToOpen=M;function I(g){const h=E(g),d=g.getValue("window.menuBarVisibility");return d==="default"||h&&d==="compact"||C.isMacintosh&&C.isNative?"classic":d}e.getMenuBarVisibility=I;var f;(function(g){g.TITLE_BAR_STYLE="window.titleBarStyle",g.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(f||(e.TitleBarSetting=f={}));var l;(function(g){g.NATIVE="native",g.CUSTOM="custom"})(l||(e.TitlebarStyle=l={}));var w;(function(g){g.AUTO="auto",g.WINDOWED="windowed",g.NEVER="never"})(w||(e.CustomTitleBarVisibility=w={}));function b(g,h){return!0}e.hasCustomTitlebar=b;function E(g,h){return h||(h=u(g)),h==="native"}e.hasNativeTitlebar=E;function u(g){if(C.isWeb)return"custom";const h=g.getValue("window");if(h){if(C.isMacintosh&&h.nativeTabs===!0||C.isMacintosh&&h.nativeFullScreen===!1)return"native";const a=h.titleBarStyle;if(a==="native"||a==="custom")return a}return C.isLinux?"native":"custom"}e.getTitleBarStyle=u;function y(g){return!(!C.isWindows||C.isWeb||E(g))}e.useWindowControlsOverlay=y;function v(g){const h=g.getValue("window");return!h||typeof h.nativeFullScreen!="boolean"||h.nativeTabs?!0:h.nativeFullScreen!==!1}e.useNativeFullScreen=v;function m(g=0){return Math.pow(1.2,g)}e.zoomLevelToZoomFactor=m}),define(oe[129],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var C;(function(I){I[I.INITIAL=1]="INITIAL",I[I.LOAD=2]="LOAD",I[I.RELOAD=3]="RELOAD"})(C||(e.LoadReason=C={}));var L;(function(I){I[I.CLOSE=1]="CLOSE",I[I.QUIT=2]="QUIT",I[I.RELOAD=3]="RELOAD",I[I.LOAD=4]="LOAD"})(L||(e.UnloadReason=L={}));const r=function(I=1){return{width:1024,height:768,mode:I}};e.defaultWindowState=r;var O;(function(I){I[I.Maximized=0]="Maximized",I[I.Normal=1]="Normal",I[I.Minimized=2]="Minimized",I[I.Fullscreen=3]="Fullscreen"})(O||(e.WindowMode=O={}));var M;(function(I){I[I.UNRESPONSIVE=1]="UNRESPONSIVE",I[I.PROCESS_GONE=2]="PROCESS_GONE",I[I.LOAD=3]="LOAD"})(M||(e.WindowError=M={}))}),define(oe[274],ae([0,1,8,3,2]),function(Q,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class O extends r.Disposable{constructor({onDidOpenMainWindow:I,onDidFocusMainWindow:f,getActiveWindowId:l}){super(),this.disposables=this._register(new r.DisposableStore),L.Event.latch(L.Event.any(I,f))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,C.createCancelablePromise)(()=>l()),(async()=>{try{const b=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:b}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=O}),define(oe[30],ae([0,1,192,9,58,19,7,6,13]),function(Q,e,C,L,r,O,M,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function l(i){const n=i;return typeof n?.id=="string"&&M.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=l;function w(i){return typeof i?.id=="string"&&!l(i)&&!E(i)}e.isEmptyWorkspaceIdentifier=w,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function b(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,L.basename)(i)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const c=i;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}e.toWorkspaceIdentifier=b;function E(i){const n=i;return typeof n?.id=="string"&&M.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=E;function u(i){const n=i;if(n?.uri)return{id:n.id,uri:M.URI.revive(n.uri)};const c=i;if(c?.configPath)return{id:c.id,configPath:M.URI.revive(c.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=u;var y;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function v(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=v;function m(i){const n=i;return!!(n&&typeof n=="object"&&M.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=m;class g{constructor(n,c,S,R,k){this._id=n,this._transient=S,this._configuration=R,this._ignorePathCasing=k,this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=c}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class h{constructor(n,c){this.raw=c,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,O.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function d(i){return new h({uri:i,index:0,name:(0,O.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=d,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,C.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(i,n){return O.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=p;function a(i){let n;return M.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===f.Schemas.tmp}e.isTemporaryWorkspace=a,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function o(i,n){return!p(i,n)&&!a(i)}e.isSavedWorkspace=o;function s(i){return(typeof i=="string"?(0,L.extname)(i):(0,O.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(oe[55],ae([0,1,15,8,45,47,2,85,4,21,167,116,6,5,27,30]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,E.createDecorator)("dialogMainService");let m=class{constructor(h,d){this.logService=h,this.productService=d,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(h,d){return this.doPick({...h,pickFolders:!0,pickFiles:!0,title:(0,w.localize)(0,null)},d)}pickFolder(h,d){return this.doPick({...h,pickFolders:!0,title:(0,w.localize)(1,null)},d)}pickFile(h,d){return this.doPick({...h,pickFiles:!0,title:(0,w.localize)(2,null)},d)}pickWorkspace(h,d){const p=(0,w.localize)(3,null),a=(0,O.mnemonicButtonLabel)((0,w.localize)(4,null)),t=v.WORKSPACE_FILTER;return this.doPick({...h,pickFiles:!0,title:p,filters:t,buttonLabel:a},d)}async doPick(h,d){const p={title:h.title,buttonLabel:h.buttonLabel,filters:h.filters,defaultPath:h.defaultPath};(typeof h.pickFiles=="boolean"||typeof h.pickFolders=="boolean")&&(p.properties=void 0,h.pickFiles&&h.pickFolders&&(p.properties=["multiSelections","openDirectory","openFile","createDirectory"])),p.properties||(p.properties=["multiSelections",h.pickFolders?"openDirectory":"openFile","createDirectory"]),f.isMacintosh&&p.properties.push("treatPackageAsDirectory");const a=await this.showOpenDialog(p,(d||C.BrowserWindow.getFocusedWindow())??void 0);if(a&&a.filePaths&&a.filePaths.length>0)return a.filePaths}getWindowDialogQueue(h){if(h){let d=this.windowDialogQueues.get(h.id);return d||(d=new L.Queue,this.windowDialogQueues.set(h.id,d)),d}else return this.noWindowDialogueQueue}showMessageBox(h,d){return this.getWindowDialogQueue(d).queue(async()=>{const{options:p,buttonIndeces:a}=(0,b.massageMessageBoxOptions)(h,this.productService);let t;return d?t=await C.dialog.showMessageBox(d,p):t=await C.dialog.showMessageBox(p),{response:a[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(h,d){const p=this.acquireFileDialogLock(h,d);if(!p)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(d).queue(async()=>{let a;return d?a=await C.dialog.showSaveDialog(d,h):a=await C.dialog.showSaveDialog(h),a.filePath=this.normalizePath(a.filePath),a})}finally{(0,M.dispose)(p)}}normalizePath(h){return h&&f.isMacintosh&&(h=(0,I.normalizeNFC)(h)),h}normalizePaths(h){return h.map(d=>this.normalizePath(d))}async showOpenDialog(h,d){h.defaultPath&&(await l.Promises.exists(h.defaultPath)||(h.defaultPath=void 0));const p=this.acquireFileDialogLock(h,d);if(!p)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(d).queue(async()=>{let a;return d?a=await C.dialog.showOpenDialog(d,h):a=await C.dialog.showOpenDialog(h),a.filePaths=this.normalizePaths(a.filePaths),a})}finally{(0,M.dispose)(p)}}acquireFileDialogLock(h,d){if(!d)return M.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",h);let p=this.windowFileDialogLocks.get(d.id);p||(p=new Set,this.windowFileDialogLocks.set(d.id,p));const a=(0,r.hash)(h);if(!p.has(a))return this.logService.trace("[DialogMainService]: new file dialog lock created",h),p.add(a),(0,M.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",h),p?.delete(a),p?.size===0&&this.windowFileDialogLocks.delete(d.id)})}};e.DialogMainService=m,e.DialogMainService=m=be([ne(0,u.ILogService),ne(1,y.IProductService)],m)}),define(oe[275],ae([0,1,3,2,77,30]),function(Q,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends L.Disposable{static{this.STORAGE_CHANGE_DEBOUNCE_TIME=100}constructor(f,l){super(),this.logService=f,this.storageMainService=l,this.onDidChangeApplicationStorageEmitter=this._register(new C.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(l.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(f,l){this._register(C.Event.debounce(f.onDidChangeStorage,(w,b)=>(w?w.push(b):w=[b],w),M.STORAGE_CHANGE_DEBOUNCE_TIME)(w=>{w.length&&l.fire(this.serializeStorageChangeEvents(w,f))}))}serializeStorageChangeEvents(f,l){const w=new Map,b=new Set;return f.forEach(E=>{const u=l.get(E.key);typeof u=="string"?w.set(E.key,u):b.add(E.key)}),{changed:Array.from(w.entries()),deleted:Array.from(b.values())}}listen(f,l,w){switch(l){case"onDidChangeStorage":{const b=w.profile?(0,r.revive)(w.profile):void 0;if(!b)return this.onDidChangeApplicationStorageEmitter.event;let E=this.mapProfileToOnDidChangeProfileStorageEmitter.get(b.id);return E||(E=this._register(new C.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(b),E),this.mapProfileToOnDidChangeProfileStorageEmitter.set(b.id,E)),E.event}}throw new Error(`Event not found: ${l}`)}async call(f,l,w){const b=w.profile?(0,r.revive)(w.profile):void 0,E=(0,O.reviveIdentifier)(w.workspace),u=await this.withStorageInitialized(b,E);switch(l){case"getItems":return Array.from(u.items.entries());case"updateItems":{const y=w;if(y.insert)for(const[v,m]of y.insert)u.set(v,m);y.delete?.forEach(v=>u.delete(v));break}case"optimize":return u.optimize();case"isUsed":{const y=w.payload;if(typeof y=="string")return this.storageMainService.isUsed(y)}default:throw new Error(`Call not found: ${l}`)}}async withStorageInitialized(f,l){let w;l?w=this.storageMainService.workspaceStorage(l):f?w=this.storageMainService.profileStorage(f):w=this.storageMainService.applicationStorage;try{await w.init()}catch(b){this.logService.error(`StorageIPC#init: Unable to init ${l?"workspace":f?"profile":"application"} storage due to ${b}`)}return w}}e.StorageDatabaseChannel=M}),define(oe[41],ae([0,1,45,3,2,19,7,189,38,16,6,5,30,31,40,8,32,25,12]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y,v,m,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var d;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(d||(e.ProfileResourceType=d={}));function p(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&M.URI.isUri(n.location)&&M.URI.isUri(n.globalStorageHome)&&M.URI.isUri(n.settingsResource)&&M.URI.isUri(n.keybindingsResource)&&M.URI.isUri(n.tasksResource)&&M.URI.isUri(n.snippetsHome)&&M.URI.isUri(n.extensionsResource))}e.isUserDataProfile=p,e.IUserDataProfilesService=(0,w.createDecorator)("IUserDataProfilesService");function a(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:M.URI.revive(i.location).with({scheme:n}),globalStorageHome:M.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:M.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:M.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:M.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:M.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:M.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:M.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=a;function t(i,n,c,S,R,k){return{id:i,name:n,location:c,isDefault:!1,shortName:R?.shortName,icon:R?.icon,globalStorageHome:k&&R?.useDefaultFlags?.globalState?k.globalStorageHome:(0,O.joinPath)(c,"globalStorage"),settingsResource:k&&R?.useDefaultFlags?.settings?k.settingsResource:(0,O.joinPath)(c,"settings.json"),keybindingsResource:k&&R?.useDefaultFlags?.keybindings?k.keybindingsResource:(0,O.joinPath)(c,"keybindings.json"),tasksResource:k&&R?.useDefaultFlags?.tasks?k.tasksResource:(0,O.joinPath)(c,"tasks.json"),snippetsHome:k&&R?.useDefaultFlags?.snippets?k.snippetsHome:(0,O.joinPath)(c,"snippets"),extensionsResource:k&&R?.useDefaultFlags?.extensions?k.extensionsResource:(0,O.joinPath)(c,"extensions.json"),cacheHome:(0,O.joinPath)(S,i),useDefaultFlags:R?.useDefaultFlags,isTransient:R?.transient}}e.toUserDataProfile=t;let o=class extends r.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,c,S,R){super(),this.environmentService=n,this.fileService=c,this.uriIdentityService=S,this.logService=R,this.enabled=!0,this._onDidChangeProfiles=this._register(new L.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new L.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new L.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new L.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new u.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,O.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,O.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const n=this.createDefaultProfile(),c=[n];if(this.enabled)try{for(const k of this.getStoredProfiles()){if(!k.name||!(0,h.isString)(k.name)||!k.location){this.logService.warn("Skipping the invalid stored profile",k.location||k.name);continue}c.push(t((0,O.basename)(k.location),k.name,k.location,this.profilesCacheHome,{shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags},n))}}catch(k){this.logService.error(k)}const S=new u.ResourceMap,R=new Map;if(c.length)try{const k=this.getStoredProfileAssociations();if(k.workspaces)for(const[P,D]of Object.entries(k.workspaces)){const _=M.URI.parse(P),N=c.find(U=>U.id===D);N&&S.set(_,N)}if(k.emptyWindows)for(const[P,D]of Object.entries(k.emptyWindows)){const _=c.find(N=>N.id===D);_&&R.set(P,_)}}catch(k){this.logService.error(k)}this._profilesObject={profiles:c,workspaces:S,emptyWindows:R}}return this._profilesObject}createDefaultProfile(){const n=t("__default__profile__",(0,I.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...n,extensionsResource:this.getDefaultProfileExtensionsLocation()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const c="Temp",S=new RegExp(`${(0,g.escapeRegExpCharacters)(c)}\\s(\\d+)`);let R=0;for(const P of this.profiles){const D=S.exec(P.name),_=D?parseInt(D[1]):0;R=_>R?_:R}const k=`${c} ${R+1}`;return this.createProfile((0,C.hash)((0,m.generateUuid)()).toString(16),k,{transient:!0},n)}async createNamedProfile(n,c,S){return this.createProfile((0,C.hash)((0,m.generateUuid)()).toString(16),n,c,S)}async createProfile(n,c,S,R){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const k=await this.doCreateProfile(n,c,S);return R&&await this.setProfileForWorkspace(R,k),k}async doCreateProfile(n,c,S){if(!(0,h.isString)(c)||!c)throw new Error("Name of the profile is mandatory and must be of type `string`");let R=this.profileCreationPromises.get(c);return R||(R=(async()=>{try{const k=this.profiles.find(_=>_.name===c||_.id===n);if(k)return k;const P=t(n,c,(0,O.joinPath)(this.profilesHome,n),this.profilesCacheHome,S,this.defaultProfile);await this.fileService.createFolder(P.location);const D=[];return this._onWillCreateProfile.fire({profile:P,join(_){D.push(_)}}),await v.Promises.settled(D),this.updateProfiles([P],[],[]),P}finally{this.profileCreationPromises.delete(c)}})(),this.profileCreationPromises.set(c,R)),R}async updateProfile(n,c){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(R=>R.id===n.id);if(!S)throw new Error(`Profile '${n.name}' does not exist`);return S=t(S.id,c.name??S.name,S.location,this.profilesCacheHome,{shortName:c.shortName??S.shortName,icon:c.icon===null?void 0:c.icon??S.icon,transient:c.transient??S.isTransient,useDefaultFlags:c.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[S]),S}async removeProfile(n){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const c=this.profiles.find(R=>R.id===n.id);if(!c)throw new Error(`Profile '${n.name}' does not exist`);const S=[];this._onWillRemoveProfile.fire({profile:c,join(R){S.push(R)}});try{await Promise.allSettled(S)}catch(R){this.logService.error(R)}for(const R of[...this.profilesObject.emptyWindows.keys()])c.id===this.profilesObject.emptyWindows.get(R)?.id&&this.profilesObject.emptyWindows.delete(R);for(const R of[...this.profilesObject.workspaces.keys()])c.id===this.profilesObject.workspaces.get(R)?.id&&this.profilesObject.workspaces.delete(R);this.updateStoredProfileAssociations(),this.updateProfiles([],[c],[]);try{await this.fileService.del(c.cacheHome,{recursive:!0})}catch(R){(0,l.toFileOperationResult)(R)!==1&&this.logService.error(R)}}async setProfileForWorkspace(n,c){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(R=>R.id===c.id);if(!S)throw new Error(`Profile '${c.name}' does not exist`);this.updateWorkspaceAssociation(n,S)}unsetWorkspace(n,c){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(n,void 0,c)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(c=>c.isDirectory&&this.profiles.every(S=>!this.uriIdentityService.extUri.isEqual(S.location,c.resource))).map(c=>this.fileService.del(c.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(c=>!this.isProfileAssociatedToWorkspace(c));await Promise.allSettled(n.map(c=>this.removeProfile(c)))}getProfileForWorkspace(n){const c=this.getWorkspace(n);return M.URI.isUri(c)?this.transientProfilesObject.workspaces.get(c)??this.profilesObject.workspaces.get(c):this.transientProfilesObject.emptyWindows.get(c)??this.profilesObject.emptyWindows.get(c)}getWorkspace(n){return(0,E.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,E.isWorkspaceIdentifier)(n)?n.configPath:n.id}isProfileAssociatedToWorkspace(n){return!!([...this.transientProfilesObject.emptyWindows.values()].some(c=>this.uriIdentityService.extUri.isEqual(c.location,n.location))||[...this.transientProfilesObject.workspaces.values()].some(c=>this.uriIdentityService.extUri.isEqual(c.location,n.location))||[...this.profilesObject.emptyWindows.values()].some(c=>this.uriIdentityService.extUri.isEqual(c.location,n.location))||[...this.profilesObject.workspaces.values()].some(c=>this.uriIdentityService.extUri.isEqual(c.location,n.location)))}updateProfiles(n,c,S){const R=[...this.profiles,...n],k=[];this.transientProfilesObject.profiles=[];for(let P of R)P.isDefault||c.some(D=>P.id===D.id)||(P=S.find(D=>P.id===D.id)??P,P.isTransient?this.transientProfilesObject.profiles.push(P):k.push({location:P.location,name:P.name,shortName:P.shortName,icon:P.icon,useDefaultFlags:P.useDefaultFlags}));this.saveStoredProfiles(k),this._profilesObject=void 0,this.triggerProfilesChanges(n,c,S)}triggerProfilesChanges(n,c,S){this._onDidChangeProfiles.fire({added:n,removed:c,updated:S,all:this.profiles})}updateWorkspaceAssociation(n,c,S){S=c?.isTransient?!0:S,S||this.updateWorkspaceAssociation(n,void 0,!0);const R=this.getWorkspace(n),k=S?this.transientProfilesObject:this.profilesObject;M.URI.isUri(R)?(k.workspaces.delete(R),c&&k.workspaces.set(R,c)):(k.emptyWindows.delete(R),c&&k.emptyWindows.set(R,c)),S||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[S,R]of this.profilesObject.workspaces.entries())n[S.toString()]=R.id;const c={};for(const[S,R]of this.profilesObject.emptyWindows.entries())c[S.toString()]=R.id;this.saveStoredProfileAssociations({workspaces:n,emptyWindows:c}),this._profilesObject=void 0}migrateStoredProfileAssociations(n){const c={},S=this.createDefaultProfile();if(n.workspaces)for(const[k,P]of Object.entries(n.workspaces)){const D=M.URI.parse(P);c[k]=this.uriIdentityService.extUri.isEqual(D,S.location)?S.id:this.uriIdentityService.extUri.basename(D)}const R={};if(n.emptyWindows)for(const[k,P]of Object.entries(n.emptyWindows)){const D=M.URI.parse(P);R[k]=this.uriIdentityService.extUri.isEqual(D,S.location)?S.id:this.uriIdentityService.extUri.basename(D)}return{workspaces:c,emptyWindows:R}}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=o,e.UserDataProfilesService=o=be([ne(0,f.IEnvironmentService),ne(1,l.IFileService),ne(2,y.IUriIdentityService),ne(3,b.ILogService)],o);class s extends o{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}e.InMemoryUserDataProfilesService=s}),define(oe[81],ae([0,1,8,17,2,3,31,7,118,124,16,6,5,41,40,12,14,28]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y,v,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h||(e.ExtensionsProfileScanningErrorCode=h={}));class d extends Error{constructor(s,i){super(s),this.code=i}}e.ExtensionsProfileScanningError=d,e.IExtensionsProfileScannerService=(0,b.createDecorator)("IExtensionsProfileScannerService");let p=class extends r.Disposable{constructor(s,i,n,c,S,R){super(),this.extensionsLocation=s,this.fileService=i,this.userDataProfilesService=n,this.uriIdentityService=c,this.telemetryService=S,this.logService=R,this._onAddExtensions=this._register(new O.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new O.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new O.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new O.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new M.ResourceMap}scanProfileExtensions(s,i){return this.withProfileExtensions(s,void 0,i)}async addExtensionsToProfile(s,i){const n=[],c=[];try{return await this.withProfileExtensions(i,S=>{const R=[];for(const k of S)s.some(([P])=>(0,l.areSameExtensions)(P.identifier,k.identifier)&&P.manifest.version!==k.version)?n.push(k):R.push(k);for(const[k,P]of s){const D=R.findIndex(N=>(0,l.areSameExtensions)(N.identifier,k.identifier)&&N.version===k.manifest.version),_={identifier:k.identifier,version:k.manifest.version,location:k.location,metadata:P};D===-1?(c.push(_),R.push(_)):R.splice(D,1,_)}return c.length&&this._onAddExtensions.fire({extensions:c,profileLocation:i}),n.length&&this._onRemoveExtensions.fire({extensions:n,profileLocation:i}),R}),c.length&&this._onDidAddExtensions.fire({extensions:c,profileLocation:i}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,profileLocation:i}),c}catch(S){throw c.length&&this._onDidAddExtensions.fire({extensions:c,error:S,profileLocation:i}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,error:S,profileLocation:i}),S}}async updateMetadata(s,i){const n=[];return await this.withProfileExtensions(i,c=>{const S=[];for(const R of c){const k=s.find(([P])=>(0,l.areSameExtensions)(P.identifier,R.identifier)&&P.manifest.version===R.version);k&&(R.metadata={...R.metadata,...k[1]},n.push(R)),S.push(R)}return S}),n}async removeExtensionFromProfile(s,i){const n=[];try{await this.withProfileExtensions(i,c=>{const S=[];for(const R of c)(0,l.areSameExtensions)(R.identifier,s.identifier)?n.push(R):S.push(R);return n.length&&this._onRemoveExtensions.fire({extensions:n,profileLocation:i}),S}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,profileLocation:i})}catch(c){throw n.length&&this._onDidRemoveExtensions.fire({extensions:n,error:c,profileLocation:i}),c}}async withProfileExtensions(s,i,n){return this.getResourceAccessQueue(s).queue(async()=>{let c=[],S;try{const R=await this.fileService.readFile(s);S=JSON.parse(R.value.toString().trim()||"[]")}catch(R){if((0,w.toFileOperationResult)(R)!==1)throw R;if(this.uriIdentityService.extUri.isEqual(s,this.userDataProfilesService.defaultProfile.extensionsResource)&&(S=await this.migrateFromOldDefaultProfileExtensionsLocation()),!S&&n?.bailOutWhenFileNotFound)throw new d((0,m.getErrorMessage)(R),"ERROR_PROFILE_NOT_FOUND")}if(S){Array.isArray(S)||this.reportAndThrowInvalidConentError(s);let R=!1;for(const k of S){a(k)||this.reportAndThrowInvalidConentError(s);let P;if((0,v.isString)(k.relativeLocation)&&k.relativeLocation)P=this.resolveExtensionLocation(k.relativeLocation);else if((0,v.isString)(k.location)){this.logService.warn(`Extensions profile: Ignoring extension with invalid location: ${k.location}`);continue}else{P=I.URI.revive(k.location);const D=this.toRelativePath(P);D&&(R=!0,k.relativeLocation=D)}(0,v.isUndefined)(k.metadata?.hasPreReleaseVersion)&&k.metadata?.preRelease&&(R=!0,k.metadata.hasPreReleaseVersion=!0),c.push({identifier:k.identifier,location:P,version:k.version,metadata:k.metadata})}R&&await this.fileService.writeFile(s,L.VSBuffer.fromString(JSON.stringify(S)))}if(i){c=i(c);const R=c.map(k=>({identifier:k.identifier,version:k.version,location:k.location.toJSON(),relativeLocation:this.toRelativePath(k.location),metadata:k.metadata}));await this.fileService.writeFile(s,L.VSBuffer.fromString(JSON.stringify(R)))}return c})}reportAndThrowInvalidConentError(s){const i=new d(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}toRelativePath(s){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(s),this.extensionsLocation)?this.uriIdentityService.extUri.basename(s):void 0}resolveExtensionLocation(s){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,s)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const s=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),i=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let n;try{n=(await this.fileService.readFile(s)).value.toString()}catch(S){if((0,w.toFileOperationResult)(S)===1)return;throw S}this.logService.info("Migrating extensions from old default profile location",s.toString());let c;try{const S=JSON.parse(n);Array.isArray(S)&&S.every(R=>a(R))?c=S:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",S)}catch(S){this.logService.error(S)}if(c)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,L.VSBuffer.fromString(JSON.stringify(c)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",s.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(S){if((0,w.toFileOperationResult)(S)===3)this.logService.info("Migration from old default profile location to new location is done by another window",s.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw S}try{await this.fileService.del(s)}catch(S){(0,w.toFileOperationResult)(S)!==1&&this.logService.error(S)}try{await this.fileService.del(i)}catch(S){(0,w.toFileOperationResult)(S)!==1&&this.logService.error(S)}return c})()),this._migrationPromise}getResourceAccessQueue(s){let i=this.resourcesAccessQueueMap.get(s);return i||(i=new C.Queue,this.resourcesAccessQueueMap.set(s,i)),i}};e.AbstractExtensionsProfileScannerService=p,e.AbstractExtensionsProfileScannerService=p=be([ne(1,w.IFileService),ne(2,u.IUserDataProfilesService),ne(3,y.IUriIdentityService),ne(4,g.ITelemetryService),ne(5,E.ILogService)],p);function a(o){return(0,v.isObject)(o)&&(0,f.isIExtensionIdentifier)(o.identifier)&&(t(o.location)||(0,v.isString)(o.location)&&o.location)&&((0,v.isUndefined)(o.relativeLocation)||(0,v.isString)(o.relativeLocation))&&o.version&&(0,v.isString)(o.version)}function t(o){return o?(0,v.isString)(o.path)&&(0,v.isString)(o.scheme):!1}}),define(oe[130],ae([0,1,22,8,35,17,14,42,152,2,13,9,4,19,205,74,12,7,172,38,124,121,204,16,6,5,27,3,77,81,41,40,203]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y,v,m,g,h,d,p,a,t,o,s,i,n,c,S,R,k,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var _;(function(ue){function X(Y,x){if(Y===x)return!0;const W=Object.keys(Y),F=new Set;for(const H of Object.keys(x))F.add(H);if(W.length!==F.size)return!1;for(const H of W){if(Y[H]!==x[H])return!1;F.delete(H)}return F.size===0}ue.equals=X})(_||(e.Translations=_={})),e.IExtensionsScannerService=(0,s.createDecorator)("IExtensionsScannerService");let N=class extends l.Disposable{constructor(X,Y,x,W,F,H,q,ee,de,G,A,T){super(),this.systemExtensionsLocation=X,this.userExtensionsLocation=Y,this.extensionsControlLocation=x,this.currentProfile=W,this.userDataProfilesService=F,this.extensionsProfileScannerService=H,this.fileService=q,this.logService=ee,this.environmentService=de,this.productService=G,this.uriIdentityService=A,this.instantiationService=T,this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,u.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(V,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(V,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(j,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,p.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(X,Y,x){const[W,F]=await Promise.all([this.scanSystemExtensions(X),this.scanUserExtensions(Y)]),H=x?await this.scanExtensionsUnderDevelopment(X,[...W,...F]):[];return this.dedupExtensions(W,F,H,await this.getTargetPlatform(),!0)}async scanSystemExtensions(X){const Y=[];Y.push(this.scanDefaultSystemExtensions(!!X.useCache,X.language)),Y.push(this.scanDevSystemExtensions(X.language,!!X.checkControlFile));const[x,W]=await Promise.all(Y);return this.applyScanOptions([...x,...W],0,X,!1)}async scanUserExtensions(X){const Y=X.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",Y);const x=this.uriIdentityService.extUri.isEqual(X.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.createExtensionScannerInput(Y,!!X.profileLocation,1,!X.includeUninstalled,X.language,!0,x),F=X.useCache&&!W.devMode&&W.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let H;try{H=await F.scanExtensions(W)}catch(q){if(q instanceof R.ExtensionsProfileScanningError&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),H=await F.scanExtensions(W);else throw q}return H=await this.applyScanOptions(H,1,X,!0),this.logService.trace("Scanned user extensions:",H.length),H}async scanExtensionsUnderDevelopment(X,Y){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const x=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(W=>W.scheme===w.Schemas.file).map(async W=>{const F=await this.createExtensionScannerInput(W,!1,1,!0,X.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(F)).map(q=>(q.type=Y.find(ee=>(0,p.areSameExtensions)(ee.identifier,q.identifier))?.type??q.type,this.extensionsScanner.validate(q,F)))}))).flat();return this.applyScanOptions(x,"development",X,!0)}return[]}async scanExistingExtension(X,Y,x){const W=await this.createExtensionScannerInput(X,!1,Y,!0,x.language,!0,void 0),F=await this.extensionsScanner.scanExtension(W);return!F||!x.includeInvalid&&!F.isValid?null:F}async scanOneOrMultipleExtensions(X,Y,x){const W=await this.createExtensionScannerInput(X,!1,Y,!0,x.language,!0,void 0),F=await this.extensionsScanner.scanOneOrMultipleExtensions(W);return this.applyScanOptions(F,Y,x,!0)}async scanMetadata(X){const Y=(0,u.joinPath)(X,"package.json"),x=(await this.fileService.readFile(Y)).value.toString();return JSON.parse(x).__metadata}async updateMetadata(X,Y){const x=(0,u.joinPath)(X,"package.json"),W=(await this.fileService.readFile(x)).value.toString(),F=JSON.parse(W);Y.isMachineScoped===!1&&delete Y.isMachineScoped,Y.isBuiltin===!1&&delete Y.isBuiltin,F.__metadata={...F.__metadata,...Y},await this.fileService.writeFile((0,u.joinPath)(X,"package.json"),O.VSBuffer.fromString(JSON.stringify(F,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(X){if(X instanceof R.ExtensionsProfileScanningError&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw X}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const X=await this.scanUserExtensions({includeInvalid:!0});if(X.length)await this.extensionsProfileScannerService.addExtensionsToProfile(X.map(Y=>[Y,Y.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify([])))}catch(Y){(0,o.toFileOperationResult)(Y)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,M.getErrorMessage)(Y))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(X){this.logService.error(X)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(X,Y,x,W){return x.includeAllVersions||(X=this.dedupExtensions(Y===0?X:void 0,Y===1?X:void 0,Y==="development"?X:void 0,await this.getTargetPlatform(),W)),x.includeInvalid||(X=X.filter(F=>F.isValid)),X.sort((F,H)=>{const q=b.basename(F.location.fsPath),ee=b.basename(H.location.fsPath);return q<ee?-1:q>ee?1:0})}dedupExtensions(X,Y,x,W,F){const H=(ee,de,G)=>{if(ee.isValid&&!de.isValid)return!1;if(ee.isValid===de.isValid){if(F&&y.gt(ee.manifest.version,de.manifest.version))return this.logService.debug(`Skipping extension ${de.location.path} with lower version ${de.manifest.version} in favour of ${ee.location.path} with version ${ee.manifest.version}`),!1;if(y.eq(ee.manifest.version,de.manifest.version)){if(ee.type===0)return this.logService.debug(`Skipping extension ${de.location.path} in favour of system extension ${ee.location.path} with same version`),!1;if(ee.targetPlatform===W)return this.logService.debug(`Skipping extension ${de.location.path} from different target platform ${de.targetPlatform}`),!1}}return G?this.logService.warn(`Overwriting user extension ${ee.location.path} with ${de.location.path}.`):this.logService.debug(`Overwriting user extension ${ee.location.path} with ${de.location.path}.`),!0},q=new a.ExtensionIdentifierMap;return X?.forEach(ee=>{const de=q.get(ee.identifier.id);(!de||H(de,ee,!1))&&q.set(ee.identifier.id,ee)}),Y?.forEach(ee=>{const de=q.get(ee.identifier.id);if(!de&&X&&ee.type===0){this.logService.debug(`Skipping obsolete system extension ${ee.location.path}.`);return}(!de||H(de,ee,!1))&&q.set(ee.identifier.id,ee)}),x?.forEach(ee=>{const de=q.get(ee.identifier.id);(!de||H(de,ee,!0))&&q.set(ee.identifier.id,ee),q.set(ee.identifier.id,ee)}),[...q.values()]}async scanDefaultSystemExtensions(X,Y){this.logService.trace("Started scanning system extensions");const x=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,Y,!0,void 0),F=await(X&&!x.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(x);return this.logService.trace("Scanned system extensions:",F.length),F}async scanDevSystemExtensions(X,Y){const x=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!x?.length)return[];this.logService.trace("Started scanning dev system extensions");const W=Y?await this.getBuiltInExtensionControl():{},F=[],H=g.URI.file(b.normalize(b.join(w.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ee of x){const de=W[ee.name]||"marketplace";switch(de){case"disabled":break;case"marketplace":F.push((0,u.joinPath)(H,ee.name));break;default:F.push(g.URI.file(de));break}}const q=await Promise.all(F.map(async ee=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(ee,!1,0,!0,X,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",q.length),(0,C.coalesce)(q)}async getBuiltInExtensionControl(){try{const X=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(X.value.toString())}catch{return{}}}async createExtensionScannerInput(X,Y,x,W,F,H,q){const ee=await this.getTranslations(F??E.language),de=await this.getMtime(X),G=Y&&!this.uriIdentityService.extUri.isEqual(X,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,A=G?await this.getMtime(G):void 0;return new U(X,de,G,A,Y,q,x,W,H,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,F,ee)}async getMtime(X){try{const Y=await this.fileService.stat(X);if(typeof Y.mtime=="number")return Y.mtime}catch{}}};e.AbstractExtensionsScannerService=N,e.AbstractExtensionsScannerService=N=be([ne(4,k.IUserDataProfilesService),ne(5,R.IExtensionsProfileScannerService),ne(6,o.IFileService),ne(7,i.ILogService),ne(8,d.IEnvironmentService),ne(9,n.IProductService),ne(10,P.IUriIdentityService),ne(11,s.IInstantiationService)],N);class U{constructor(X,Y,x,W,F,H,q,ee,de,G,A,T,Z,z,J){this.location=X,this.mtime=Y,this.applicationExtensionslocation=x,this.applicationExtensionslocationMtime=W,this.profile=F,this.profileScanOptions=H,this.type=q,this.excludeObsolete=ee,this.validate=de,this.productVersion=G,this.productDate=A,this.productCommit=T,this.devMode=Z,this.language=z,this.translations=J}static createNlsConfiguration(X){return{language:X.language,pseudo:X.language==="pseudo",devMode:X.devMode,translations:X.translations}}static equals(X,Y){return(0,u.isEqual)(X.location,Y.location)&&X.mtime===Y.mtime&&(0,u.isEqual)(X.applicationExtensionslocation,Y.applicationExtensionslocation)&&X.applicationExtensionslocationMtime===Y.applicationExtensionslocationMtime&&X.profile===Y.profile&&r.equals(X.profileScanOptions,Y.profileScanOptions)&&X.type===Y.type&&X.excludeObsolete===Y.excludeObsolete&&X.validate===Y.validate&&X.productVersion===Y.productVersion&&X.productDate===Y.productDate&&X.productCommit===Y.productCommit&&X.devMode===Y.devMode&&X.language===Y.language&&_.equals(X.translations,Y.translations)}}e.ExtensionScannerInput=U;let j=class extends l.Disposable{constructor(X,Y,x,W,F){super(),this.obsoleteFile=X,this.extensionsProfileScannerService=Y,this.uriIdentityService=x,this.fileService=W,this.logService=F}async scanExtensions(X){const Y=X.profile?await this.scanExtensionsFromProfile(X):await this.scanExtensionsFromLocation(X);let x={};if(X.excludeObsolete&&X.type===1)try{const W=(await this.fileService.readFile(this.obsoleteFile)).value.toString();x=JSON.parse(W)}catch{}return(0,m.isEmptyObject)(x)?Y:Y.filter(W=>!x[p.ExtensionKey.create(W).toString()])}async scanExtensionsFromLocation(X){const Y=await this.fileService.resolve(X.location);if(!Y.children?.length)return[];const x=await Promise.all(Y.children.map(async W=>{if(!W.isDirectory||X.type===1&&(0,u.basename)(W.resource).indexOf(".")===0)return null;const F=new U(W.resource,X.mtime,X.applicationExtensionslocation,X.applicationExtensionslocationMtime,X.profile,X.profileScanOptions,X.type,X.excludeObsolete,X.validate,X.productVersion,X.productDate,X.productCommit,X.devMode,X.language,X.translations);return this.scanExtension(F)}));return(0,C.coalesce)(x).sort((W,F)=>W.location.path<F.location.path?-1:1)}async scanExtensionsFromProfile(X){let Y=await this.scanExtensionsFromProfileResource(X.location,()=>!0,X);if(X.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(X.location,X.applicationExtensionslocation)){Y=Y.filter(W=>!W.metadata?.isApplicationScoped);const x=await this.scanExtensionsFromProfileResource(X.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,X);Y.push(...x)}return Y}async scanExtensionsFromProfileResource(X,Y,x){const W=await this.extensionsProfileScannerService.scanProfileExtensions(X,x.profileScanOptions);if(!W.length)return[];const F=await Promise.all(W.map(async H=>{if(Y(H)){const q=new U(H.location,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(q,H.metadata)}return null}));return(0,C.coalesce)(F)}async scanOneOrMultipleExtensions(X){try{if(await this.fileService.exists((0,u.joinPath)(X.location,"package.json"))){const Y=await this.scanExtension(X);return Y?[Y]:[]}else return await this.scanExtensions(X)}catch(Y){return this.logService.error(`Error scanning extensions at ${X.location.path}:`,(0,M.getErrorMessage)(Y)),[]}}async scanExtension(X,Y){try{let x=await this.scanExtensionManifest(X.location);if(x){x.publisher||(x.publisher=a.UNDEFINED_PUBLISHER),Y=Y??x.__metadata,delete x.__metadata;const W=(0,p.getGalleryExtensionId)(x.publisher,x.name),F=Y?.id?{id:W,uuid:Y.id}:{id:W},H=Y?.isSystem?0:X.type,q=H===0||!!Y?.isBuiltin;x=await this.translateManifest(X.location,x,U.createNlsConfiguration(X));const ee={type:H,identifier:F,manifest:x,location:X.location,isBuiltin:q,targetPlatform:Y?.targetPlatform??"undefined",metadata:Y,isValid:!0,validations:[]};return X.validate?this.validate(ee,X):ee}}catch(x){X.type!==0&&this.logService.error(x)}return null}validate(X,Y){let x=!0;const W=(0,t.validateExtensionManifest)(Y.productVersion,Y.productDate,Y.location,X.manifest,X.isBuiltin);for(const[F,H]of W)F===v.default.Error&&(x=!1,this.logService.error(this.formatMessage(Y.location,H)));return X.isValid=x,X.validations=W,X}async scanExtensionManifest(X){const Y=(0,u.joinPath)(X,"package.json");let x;try{x=(await this.fileService.readFile(Y)).value.toString()}catch(F){return(0,o.toFileOperationResult)(F)!==1&&this.logService.error(this.formatMessage(X,(0,h.localize)(0,null,Y.path,F.message))),null}let W;try{W=JSON.parse(x)}catch{const H=[];(0,I.parse)(x,H);for(const q of H)this.logService.error(this.formatMessage(X,(0,h.localize)(1,null,Y.path,q.offset,q.length,(0,f.getParseErrorMessage)(q.error))));return null}return(0,I.getNodeType)(W)!=="object"?(this.logService.error(this.formatMessage(X,(0,h.localize)(2,null,Y.path))),null):W}async translateManifest(X,Y,x){const W=await this.getLocalizedMessages(X,Y,x);if(W)try{const F=[],H=await this.resolveOriginalMessageBundle(W.default,F);if(F.length>0)return F.forEach(ee=>{this.logService.error(this.formatMessage(X,(0,h.localize)(3,null,W.default?.path,(0,f.getParseErrorMessage)(ee.error))))}),Y;if((0,I.getNodeType)(W)!=="object")return this.logService.error(this.formatMessage(X,(0,h.localize)(4,null,W.default?.path))),Y;const q=W.values||Object.create(null);return(0,D.localizeManifest)(this.logService,Y,q,H)}catch{}return Y}async getLocalizedMessages(X,Y,x){const W=(0,u.joinPath)(X,"package.nls.json"),F=(de,G)=>{G.forEach(A=>{this.logService.error(this.formatMessage(X,(0,h.localize)(5,null,de?.path,(0,f.getParseErrorMessage)(A.error))))})},H=de=>{this.logService.error(this.formatMessage(X,(0,h.localize)(6,null,de?.path)))},q=`${Y.publisher}.${Y.name}`,ee=x.translations[q];if(ee)try{const de=g.URI.file(ee),G=(await this.fileService.readFile(de)).value.toString(),A=[],T=(0,I.parse)(G,A);return A.length>0?(F(de,A),{values:void 0,default:W}):(0,I.getNodeType)(T)!=="object"?(H(de),{values:void 0,default:W}):{values:T.contents?T.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.fileService.exists(W))return;let G;try{G=await this.findMessageBundles(X,x)}catch{return}if(!G.localized)return{values:void 0,default:G.original};try{const A=(await this.fileService.readFile(G.localized)).value.toString(),T=[],Z=(0,I.parse)(A,T);return T.length>0?(F(G.localized,T),{values:void 0,default:G.original}):(0,I.getNodeType)(Z)!=="object"?(H(G.localized),{values:void 0,default:G.original}):{values:Z,default:G.original}}catch{return{values:void 0,default:G.original}}}}async resolveOriginalMessageBundle(X,Y){if(X)try{const x=(await this.fileService.readFile(X)).value.toString();return(0,I.parse)(x,Y)}catch{}}findMessageBundles(X,Y){return new Promise((x,W)=>{const F=H=>{const q=(0,u.joinPath)(X,`package.nls.${H}.json`);this.fileService.exists(q).then(ee=>{ee&&x({localized:q,original:(0,u.joinPath)(X,"package.nls.json")});const de=H.lastIndexOf("-");de===-1?x({localized:(0,u.joinPath)(X,"package.nls.json"),original:null}):(H=H.substring(0,de),F(H))})};if(Y.devMode||Y.pseudo||!Y.language)return x({localized:(0,u.joinPath)(X,"package.nls.json"),original:null});F(Y.language)})}formatMessage(X,Y){return`[${X.path}]: ${Y}`}};j=be([ne(1,R.IExtensionsProfileScannerService),ne(2,P.IUriIdentityService),ne(3,o.IFileService),ne(4,i.ILogService)],j);let V=class extends j{constructor(X,Y,x,W,F,H,q){super(Y,W,F,H,q),this.currentProfile=X,this.userDataProfilesService=x,this.cacheValidatorThrottler=this._register(new L.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(X){const Y=this.getCacheFile(X),x=await this.readExtensionCache(Y);if(this.input=X,x&&x.input&&U.equals(x.input,this.input))return this.logService.debug("Using cached extensions scan result",X.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),x.result.map(F=>(F.location=g.URI.revive(F.location),F));const W=await super.scanExtensions(X);return await this.writeExtensionCache(Y,{input:X,result:W}),W}async readExtensionCache(X){try{const Y=await this.fileService.readFile(X),x=JSON.parse(Y.value.toString());return{result:x.result,input:(0,S.revive)(x.input)}}catch(Y){this.logService.debug("Error while reading the extension cache file:",X.path,(0,M.getErrorMessage)(Y))}return null}async writeExtensionCache(X,Y){try{await this.fileService.writeFile(X,O.VSBuffer.fromString(JSON.stringify(Y)))}catch(x){this.logService.debug("Error while writing the extension cache file:",X.path,(0,M.getErrorMessage)(x))}}async validateCache(){if(!this.input)return;const X=this.getCacheFile(this.input),Y=await this.readExtensionCache(X);if(!Y)return;const x=Y.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!r.equals(W,x))try{this.logService.info("Invalidating Cache",x,W),await this.fileService.del(X),this._onDidChangeCache.fire()}catch(F){this.logService.error(F)}}getCacheFile(X){const Y=this.getProfile(X);return this.uriIdentityService.extUri.joinPath(Y.cacheHome,X.type===0?a.BUILTIN_MANIFEST_CACHE_FILE:a.USER_MANIFEST_CACHE_FILE)}getProfile(X){return X.type===0?this.userDataProfilesService.defaultProfile:X.profile?this.uriIdentityService.extUri.isEqual(X.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(Y=>this.uriIdentityService.extUri.isEqual(X.location,Y.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};V=be([ne(2,k.IUserDataProfilesService),ne(3,R.IExtensionsProfileScannerService),ne(4,P.IUriIdentityService),ne(5,o.IFileService),ne(6,i.ILogService)],V);function ce(ue,X){const Y=(0,p.getExtensionId)(ue.manifest.publisher,ue.manifest.name);return{id:Y,identifier:new a.ExtensionIdentifier(Y),isBuiltin:ue.type===0,isUserBuiltin:ue.type===1&&ue.isBuiltin,isUnderDevelopment:X,extensionLocation:ue.location,uuid:ue.identifier.uuid,targetPlatform:ue.targetPlatform,...ue.manifest}}e.toExtensionDescription=ce;class se extends N{constructor(X,Y,x,W,F,H,q,ee,de,G,A,T){super(X,Y,(0,u.joinPath)(x,".vscode-oss-dev","extensions","control.json"),W,F,H,q,ee,de,G,A,T),this.translationsPromise=(async()=>{if(E.translationsConfigFile)try{const Z=await this.fileService.readFile(g.URI.file(E.translationsConfigFile));return JSON.parse(Z.value.toString())}catch{}return Object.create(null)})()}getTranslations(X){return this.translationsPromise}}e.NativeExtensionsScannerService=se}),define(oe[276],ae([0,1,5,41,40,28,81,16,38,7]),function(Q,e,C,L,r,O,M,I,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let w=class extends M.AbstractExtensionsProfileScannerService{constructor(E,u,y,v,m,g){super(l.URI.file(E.extensionsPath),u,y,v,m,g)}};e.ExtensionsProfileScannerService=w,e.ExtensionsProfileScannerService=w=be([ne(0,f.INativeEnvironmentService),ne(1,I.IFileService),ne(2,L.IUserDataProfilesService),ne(3,r.IUriIdentityService),ne(4,O.ITelemetryService),ne(5,C.ILogService)],w)}),define(oe[277],ae([0,1,7,38,81,130,16,6,5,27,40,41]),function(Q,e,C,L,r,O,M,I,f,l,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let E=class extends O.NativeExtensionsScannerService{constructor(y,v,m,g,h,d,p,a){super(C.URI.file(h.builtinExtensionsPath),C.URI.file(h.extensionsPath),h.userHome,y.defaultProfile,y,v,m,g,h,d,p,a)}};e.ExtensionsScannerService=E,e.ExtensionsScannerService=E=be([ne(0,b.IUserDataProfilesService),ne(1,r.IExtensionsProfileScannerService),ne(2,M.IFileService),ne(3,f.ILogService),ne(4,L.INativeEnvironmentService),ne(5,l.IProductService),ne(6,w.IUriIdentityService),ne(7,I.IInstantiationService)],E)}),define(oe[278],ae([0,1,15,2,13,9,4,58,7,32,37,38,5,41]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let y=class extends L.Disposable{constructor(m,g,h){super(),this.environmentService=m,this.logService=h,this.validRoots=I.TernarySearchTree.forPaths(!M.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(m.appRoot),this.addValidFileRoot(m.extensionsPath),this.addValidFileRoot(g.defaultProfile.globalStorageHome.with({scheme:r.Schemas.file}).fsPath),this.addValidFileRoot(m.workspaceStorageHome.with({scheme:r.Schemas.file}).fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:m}=C.session;m.protocol.registerFileProtocol(r.Schemas.vscodeFileResource,(g,h)=>this.handleResourceRequest(g,h)),m.protocol.interceptFileProtocol(r.Schemas.file,(g,h)=>this.handleFileRequest(g,h)),this._register((0,L.toDisposable)(()=>{m.protocol.unregisterProtocol(r.Schemas.vscodeFileResource),m.protocol.uninterceptProtocol(r.Schemas.file)}))}addValidFileRoot(m){const g=(0,O.normalize)(m);return this.validRoots.get(g)?L.Disposable.None:(this.validRoots.set(g,!0),(0,L.toDisposable)(()=>this.validRoots.delete(g)))}handleFileRequest(m,g){const h=f.URI.parse(m.url);return this.logService.error(`Refused to load resource ${h.fsPath} from ${r.Schemas.file}: protocol (original URL: ${m.url})`),g({error:-3})}handleResourceRequest(m,g){const h=this.requestToNormalizedFilePath(m);let d;return this.environmentService.crossOriginIsolated&&((0,O.basename)(h)==="workbench.html"||(0,O.basename)(h)==="workbench-dev.html"?d=r.COI.CoopAndCoep:d=r.COI.getHeadersFromQuery(m.url)),this.validRoots.findSubstr(h)?g({path:h,headers:d}):this.validExtensions.has((0,O.extname)(h).toLowerCase())?g({path:h}):(this.logService.error(`${r.Schemas.vscodeFileResource}: Refused to load resource ${h} from ${r.Schemas.vscodeFileResource}: protocol (original URL: ${m.url})`),g({error:-3}))}requestToNormalizedFilePath(m){const g=f.URI.parse(m.url),h=r.FileAccess.uriToFileUri(g);return(0,O.normalize)(h.fsPath)}createIPCObjectUrl(){let m;const g=f.URI.from({scheme:"vscode",path:(0,l.generateUuid)()}),h=g.toString(),d=async()=>m;return w.validatedIpcMain.handle(h,d),this.logService.trace(`IPC Object URL: Registered new channel ${h}.`),{resource:g,update:p=>m=p,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${h}.`),w.validatedIpcMain.removeHandler(h)}}}};e.ProtocolMainService=y,e.ProtocolMainService=y=be([ne(0,b.INativeEnvironmentService),ne(1,u.IUserDataProfilesService),ne(2,E.ILogService)],y)}),define(oe[96],ae([0,1,8,3,2,68,12,112,6,41]),function(Q,e,C,L,r,O,M,I,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,f.createDecorator)("storageService");var w;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(w||(e.WillSaveStateReason=w={}));var b;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var E;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(E||(e.StorageTarget=E={}));function u(h){const d=h.get(e.TARGET_KEY);if(d)try{return JSON.parse(d)}catch{}return Object.create(null)}e.loadKeyTargets=u;class y extends r.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(d={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super(),this.options=d,this._onDidChangeValue=this._register(new L.PauseableEmitter),this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new C.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new r.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(d,p,a){return L.Event.filter(this._onDidChangeValue.event,t=>t.scope===d&&(p===void 0||t.key===p),a)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,C.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,r.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,O.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(d,p){const{key:a,external:t}=p;if(a===e.TARGET_KEY){switch(d){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:d})}else this._onDidChangeValue.fire({scope:d,key:a,target:this.getKeyTargets(d)[a],external:t})}emitWillSaveState(d){this._onWillSaveState.fire({reason:d})}get(d,p,a){return this.getStorage(p)?.get(d,a)}getBoolean(d,p,a){return this.getStorage(p)?.getBoolean(d,a)}getNumber(d,p,a){return this.getStorage(p)?.getNumber(d,a)}getObject(d,p,a){return this.getStorage(p)?.getObject(d,a)}storeAll(d,p){this.withPausedEmitters(()=>{for(const a of d)this.store(a.key,a.value,a.scope,a.target,p)})}store(d,p,a,t,o=!1){if((0,M.isUndefinedOrNull)(p)){this.remove(d,a,o);return}this.withPausedEmitters(()=>{this.updateKeyTarget(d,a,t),this.getStorage(a)?.set(d,p,o)})}remove(d,p,a=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(d,p,void 0),this.getStorage(p)?.delete(d,a)})}withPausedEmitters(d){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{d()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(d,p){const a=[],t=this.getKeyTargets(d);for(const o of Object.keys(t))t[o]===p&&a.push(o);return a}updateKeyTarget(d,p,a,t=!1){const o=this.getKeyTargets(p);typeof a=="number"?o[d]!==a&&(o[d]=a,this.getStorage(p)?.set(e.TARGET_KEY,JSON.stringify(o),t)):typeof o[d]=="number"&&(delete o[d],this.getStorage(p)?.set(e.TARGET_KEY,JSON.stringify(o),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(d){switch(d){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(d){const p=this.getStorage(d);return p?u(p):Object.create(null)}isNew(d){return this.getBoolean(e.IS_NEW_KEY,d)===!0}async flush(d=w.NONE){this._onWillSaveState.fire({reason:d});const p=this.getStorage(-1),a=this.getStorage(0),t=this.getStorage(1);switch(d){case w.NONE:await C.Promises.settled([p?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case w.SHUTDOWN:await C.Promises.settled([p?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.getStorage(-1)?.items??new Map,p=this.getStorage(0)?.items??new Map,a=this.getStorage(1)?.items??new Map;return g(d,p,a,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(d){return await this.flush(),this.getStorage(d)?.optimize()}async switch(d,p){return this.emitWillSaveState(w.NONE),(0,l.isUserDataProfile)(d)?this.switchToProfile(d,p):this.switchToWorkspace(d,p)}canSwitchProfile(d,p){return!(d.id===p.id||v(p)&&v(d))}switchData(d,p,a){this.withPausedEmitters(()=>{const t=new Set;for(const[o,s]of d)t.add(o),p.get(o)!==s&&this.emitDidChangeValue(a,{key:o,external:!0});for(const[o]of p.items)t.has(o)||this.emitDidChangeValue(a,{key:o,external:!0})})}}e.AbstractStorageService=y;function v(h){return h.isDefault||!!h.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=v;class m extends y{constructor(){super(),this.applicationStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(d=>this.emitDidChangeValue(1,d))),this._register(this.profileStorage.onDidChangeStorage(d=>this.emitDidChangeValue(0,d))),this._register(this.applicationStorage.onDidChangeStorage(d=>this.emitDidChangeValue(-1,d)))}getStorage(d){switch(d){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(d){switch(d){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(d){return!1}}e.InMemoryStorageService=m;async function g(h,d,p,a,t,o){const s=_=>{try{return JSON.parse(_)}catch{return _}},i=new Map,n=new Map;h.forEach((_,N)=>{i.set(N,_),n.set(N,s(_))});const c=new Map,S=new Map;d.forEach((_,N)=>{c.set(N,_),S.set(N,s(_))});const R=new Map,k=new Map;p.forEach((_,N)=>{R.set(N,_),k.set(N,s(_))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const P=[];if(i.forEach((_,N)=>{P.push({key:N,value:_})}),console.table(P),console.groupEnd(),console.log(n),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const _=[];c.forEach((N,U)=>{_.push({key:U,value:N})}),console.table(_),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${o})`);const D=[];R.forEach((_,N)=>{D.push({key:N,value:_})}),console.table(D),console.groupEnd(),console.log(k)}e.logStorage=g}),define(oe[279],ae([0,1,22,8,3,2,9,73,7,21,112,161,5,96,28,30,13]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class g extends O.Disposable{static{this.LOG_SLOW_CLOSE_THRESHOLD=2e3}get storage(){return this._storage}constructor(s,i){super(),this.logService=s,this.fileService=i,this._onDidChangeStorage=this._register(new r.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new r.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=this._register(new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.initializePromise=void 0,this.whenInitPromise=new L.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=w.StorageState.None}isInMemory(){return this._storage.isInMemory()}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===w.StorageState.None)try{const s=this._register(await this.doCreate());this._storage.dispose(),this._storage=s,this._register(s.onDidChangeStorage(n=>this._onDidChangeStorage.fire(n))),await this.doInit(s);const i=s.getBoolean(u.IS_NEW_KEY);i===void 0?s.set(u.IS_NEW_KEY,!0):i&&s.set(u.IS_NEW_KEY,!1)}catch(s){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${s}`)}finally{this.state=w.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===E.LogLevel.Trace?s=>this.logService.trace(s):void 0,logError:s=>this.logService.error(s)}}doInit(s){return s.init()}get items(){return this._storage.items}get(s,i){return this._storage.get(s,i)}set(s,i){return this._storage.set(s,i)}delete(s){return this._storage.delete(s)}optimize(){return this._storage.optimize()}async close(){const s=new I.StopWatch(!1);await this.doClose(),s.stop(),s.elapsed()>g.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(s),this._onDidCloseStorage.fire()}async logSlowClose(s){if(this.path)try{const i=(0,C.top)(Array.from(this._storage.items.entries()).map(([c,S])=>({key:c,length:S.length})),(c,S)=>S.length-c.length,5).map(c=>`${c.key}:${c.length}`).join(", "),n=(await this.fileService.stat(f.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${s.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=w.StorageState.Closed,await this._storage.close()}}class h extends g{static{this.STORAGE_NAME="state.vscdb"}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.profile.globalStorageHome.with({scheme:m.Schemas.file}).fsPath,h.STORAGE_NAME)}constructor(s,i,n,c){super(n,c),this.profile=s,this.options=i}async doCreate(){return new w.Storage(new b.SQLiteStorageDatabase(this.path??b.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}),this.path?void 0:{hint:w.StorageHint.STORAGE_IN_MEMORY})}}class d extends h{constructor(s,i,n,c){super(s,i,n,c)}}e.ProfileStorageMain=d;class p extends h{constructor(s,i,n,c){super(i.defaultProfile,s,n,c)}async doInit(s){await super.doInit(s),this.updateTelemetryState(s)}updateTelemetryState(s){s.get(y.firstSessionDateStorageKey,void 0)===void 0&&s.set(y.firstSessionDateStorageKey,new Date().toUTCString());const n=s.get(y.currentSessionDateStorageKey,void 0),c=new Date().toUTCString();s.set(y.lastSessionDateStorageKey,typeof n>"u"?null:n),s.set(y.currentSessionDateStorageKey,c)}}e.ApplicationStorageMain=p;class a extends g{static{this.WORKSPACE_STORAGE_NAME="state.vscdb"}static{this.WORKSPACE_META_NAME="workspace.json"}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.environmentService.workspaceStorageHome.with({scheme:m.Schemas.file}).fsPath,this.workspace.id,a.WORKSPACE_STORAGE_NAME)}constructor(s,i,n,c,S){super(n,S),this.workspace=s,this.options=i,this.environmentService=c}async doCreate(){const{storageFilePath:s,wasCreated:i}=await this.prepareWorkspaceStorageFolder();return new w.Storage(new b.SQLiteStorageDatabase(s,{logging:this.createLoggingOptions()}),{hint:this.options.useInMemoryStorage?w.StorageHint.STORAGE_IN_MEMORY:i?w.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:b.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const s=(0,M.join)(this.environmentService.workspaceStorageHome.with({scheme:m.Schemas.file}).fsPath,this.workspace.id),i=(0,M.join)(s,a.WORKSPACE_STORAGE_NAME);return await l.Promises.exists(s)?{storageFilePath:i,wasCreated:!1}:(await l.Promises.mkdir(s,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(s),{storageFilePath:i,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(s){let i;if((0,v.isSingleFolderWorkspaceIdentifier)(this.workspace)?i={folder:this.workspace.uri.toString()}:(0,v.isWorkspaceIdentifier)(this.workspace)&&(i={workspace:this.workspace.configPath.toString()}),i)try{const n=(0,M.join)(s,a.WORKSPACE_META_NAME);await l.Promises.exists(n)||await l.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.WorkspaceStorageMain=a;class t extends g{get path(){}async doCreate(){return new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=t}),define(oe[280],ae([0,1,3,2,96]),function(Q,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class O extends L.Disposable{constructor(I,f,l){super(),this.storageMainService=I,this.userDataProfilesService=f,this.logService=l;const w=this._register(new L.MutableDisposable);this._onDidChange=this._register(new C.Emitter({onWillAddFirstListener:()=>w.value=this.registerStorageChangeListeners(),onDidRemoveLastListener:()=>w.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const I=new L.DisposableStore;return I.add(C.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(f,l)=>(f?f.push(l.key):f=[l.key],f),100)(f=>this.onDidChangeApplicationStorage(f))),I.add(C.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(f,l)=>{f||(f=new Map);let w=f.get(l.profile.id);return w||f.set(l.profile.id,w={profile:l.profile,keys:[],storage:l.storage}),w.keys.push(l.key),f},100)(f=>this.onDidChangeProfileStorage(f))),I}onDidChangeApplicationStorage(I){const f=I.includes(r.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],l=[];if(I=I.filter(w=>w!==r.TARGET_KEY),I.length){const w=(0,r.loadKeyTargets)(this.storageMainService.applicationStorage.storage);l.push({profile:this.userDataProfilesService.defaultProfile,changes:I.map(b=>({key:b,scope:0,target:w[b]}))})}this.triggerEvents(f,l)}onDidChangeProfileStorage(I){const f=[],l=new Map;for(const[w,b]of I.entries()){b.keys.includes(r.TARGET_KEY)&&f.push(b.profile);const E=b.keys.filter(u=>u!==r.TARGET_KEY);if(E.length){const u=(0,r.loadKeyTargets)(b.storage.storage);l.set(w,{profile:b.profile,changes:E.map(y=>({key:y,scope:0,target:u[y]}))})}}this.triggerEvents(f,[...l.values()])}triggerEvents(I,f){(I.length||f.length)&&this._onDidChange.fire({valueChanges:f,targetChanges:I})}listen(I,f,l){switch(f){case"onDidChange":return this._onDidChange.event}throw new Error(`Event not found: ${f}`)}async call(I,f){throw new Error(`Call not found: ${f}`)}}e.ProfileStorageChangesListenerChannel=O}),define(oe[281],ae([0,1,7,38,16,5,34,40,41,12,122]),function(Q,e,C,L,r,O,M,I,f,l,w){"use strict";var b,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let u=class extends f.UserDataProfilesService{static{b=this}static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(g,h,d,p,a){super(d,p,h,a),this.stateReadonlyService=g,this.nativeEnvironmentService=d}getStoredProfiles(){return this.stateReadonlyService.getItem(b.PROFILES_KEY,[]).map(h=>({...h,location:(0,l.isString)(h.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,h.location):C.URI.revive(h.location)}))}getStoredProfileAssociations(){const g=this.stateReadonlyService.getItem(b.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(b.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?g:this.migrateStoredProfileAssociations(g)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(C.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.UserDataProfilesReadonlyService=u,e.UserDataProfilesReadonlyService=u=b=be([ne(0,M.IStateReadService),ne(1,I.IUriIdentityService),ne(2,L.INativeEnvironmentService),ne(3,r.IFileService),ne(4,O.ILogService)],u);let y=E=class extends u{constructor(g,h,d,p,a){super(g,h,d,p,a),this.stateService=g}saveStoredProfiles(g){g.length?this.stateService.setItem(E.PROFILES_KEY,g.map(h=>({...h,location:this.uriIdentityService.extUri.basename(h.location)}))):this.stateService.removeItem(E.PROFILES_KEY)}getStoredProfiles(){const g=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(g),this.stateService.setItem("userDataProfilesMigration",!0)),g}saveStoredProfileAssociations(g){g.emptyWindows||g.workspaces?this.stateService.setItem(E.PROFILE_ASSOCIATIONS_KEY,g):this.stateService.removeItem(E.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const g="workspaceAndProfileInfo",h=this.stateService.getItem(g,void 0);if(h){this.stateService.removeItem(g);const p=h.reduce((a,{workspace:t,profile:o})=>(a[C.URI.revive(t).toString()]=C.URI.revive(o).toString(),a),{});this.stateService.setItem(E.PROFILE_ASSOCIATIONS_KEY,{workspaces:p})}const d=super.getStoredProfileAssociations();return this.stateService.getItem(E.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(d),this.stateService.setItem(E.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),d}};e.UserDataProfilesService=y,e.UserDataProfilesService=y=E=be([ne(0,M.IStateService),ne(1,I.IUriIdentityService),ne(2,L.INativeEnvironmentService),ne(3,r.IFileService),ne(4,O.ILogService)],y);let v=class extends y{constructor(g,h,d,p){super(new w.StateService(0,h,p,d),g,h,d,p)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=v,e.ServerUserDataProfilesService=v=be([ne(0,I.IUriIdentityService),ne(1,L.INativeEnvironmentService),ne(2,r.IFileService),ne(3,O.ILogService)],v)}),define(oe[56],ae([0,1,38,16,6,5,40,41,281,34]),function(Q,e,C,L,r,O,M,I,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,r.refineServiceDecorator)(I.IUserDataProfilesService);let w=class extends f.UserDataProfilesService{constructor(E,u,y,v,m){super(E,u,y,v,m)}getAssociatedEmptyWindows(){const E=[];for(const u of this.profilesObject.emptyWindows.keys())E.push({id:u});return E}};e.UserDataProfilesMainService=w,e.UserDataProfilesMainService=w=be([ne(0,l.IStateService),ne(1,M.IUriIdentityService),ne(2,C.INativeEnvironmentService),ne(3,L.IFileService),ne(4,O.ILogService)],w)}),define(oe[131],ae([0,1,19,7,30]),function(Q,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function O(f,l,w){for(const E of f){const u=E.openedWorkspace;if((0,r.isWorkspaceIdentifier)(u)){const y=await w(u);if(y){if(y.folders.some(v=>C.extUriBiasedIgnorePathCase.isEqualOrParent(l,v.uri)))return E}else if(C.extUriBiasedIgnorePathCase.isEqualOrParent(l,u.configPath))return E}}const b=f.filter(E=>(0,r.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&C.extUriBiasedIgnorePathCase.isEqualOrParent(l,E.openedWorkspace.uri));if(b.length)return b.sort((E,u)=>-(E.openedWorkspace.uri.path.length-u.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=O;function M(f,l){for(const w of f)if((0,r.isWorkspaceIdentifier)(w.openedWorkspace)&&C.extUriBiasedIgnorePathCase.isEqual(w.openedWorkspace.configPath,l)||(0,r.isSingleFolderWorkspaceIdentifier)(w.openedWorkspace)&&C.extUriBiasedIgnorePathCase.isEqual(w.openedWorkspace.uri,l))return w}e.findWindowOnWorkspaceOrFolder=M;function I(f,l){const w=b=>l.some(E=>C.extUriBiasedIgnorePathCase.isEqual(L.URI.file(E),L.URI.file(b)));for(const b of f)if(b.config?.extensionDevelopmentPath?.some(E=>w(E)))return b}e.findWindowOnExtensionDevelopmentPath=I}),define(oe[97],ae([0,1,33,42,101,47,13,9,4,19,7,6,59,30]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,b.createDecorator)("workspacesService");function y(k){return k.hasOwnProperty("workspace")}e.isRecentWorkspace=y;function v(k){return k.hasOwnProperty("folderUri")}e.isRecentFolder=v;function m(k){return k.hasOwnProperty("fileUri")}e.isRecentFile=m;function g(k){return h(k)||d(k)}e.isStoredWorkspaceFolder=g;function h(k){const P=k;return typeof P?.path=="string"&&(!P.name||typeof P.name=="string")}function d(k){const P=k;return typeof P?.uri=="string"&&(!P.name||typeof P.name=="string")}function p(k,P,D,_,N){if(k.scheme!==_.scheme)return{name:D,uri:k.toString(!0)};let U=P?void 0:N.relativePath(_,k);if(U!==void 0)U.length===0?U=".":f.isWindows&&(U=a(U));else if(k.scheme===M.Schemas.file)U=k.fsPath,f.isWindows&&(U=a(U));else if(N.isEqualAuthority(k.authority,_.authority))U=k.path;else return{name:D,uri:k.toString(!0)};return{name:D,path:U}}e.getStoredWorkspaceFolder=p;function a(k){return k=(0,O.normalizeDriveLetter)(k),(0,C.isUNC)(k)||(k=(0,C.toSlashes)(k)),k}function t(k,P,D){const _=[],N=new Set,U=D.dirname(P);for(const j of k){let V;if(h(j))j.path&&(V=D.resolvePath(U,j.path));else if(d(j))try{V=w.URI.parse(j.uri),V.path[0]!==I.posix.sep&&(V=V.with({path:I.posix.sep+V.path}))}catch(ce){console.warn(ce)}if(V){const ce=D.getComparisonKey(V);if(!N.has(ce)){N.add(ce);const se=j.name||D.basenameOrAuthority(V);_.push(new u.WorkspaceFolder({uri:V,name:se,index:_.length},j))}}}return _}e.toWorkspaceFolders=t;function o(k,P,D,_,N){const U=s(P,k),j=N.dirname(P),V=N.dirname(_),ce=[];for(const Y of U.folders){const x=h(Y)?N.resolvePath(j,Y.path):w.URI.parse(Y.uri);let W;D?W=!1:W=!h(Y)||(0,I.isAbsolute)(Y.path),ce.push(p(x,W,Y.name,V,N))}const se={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},ue=r.setProperty(k,["folders"],ce,se);let X=r.applyEdits(k,ue);return(0,l.isEqualAuthority)(U.remoteAuthority,(0,E.getRemoteAuthority)(_))&&(X=r.applyEdits(X,r.removeProperty(X,["remoteAuthority"],se))),X}e.rewriteWorkspaceFileForNewLocation=o;function s(k,P){const D=L.parse(P);if(D&&Array.isArray(D.folders))D.folders=D.folders.filter(_=>g(_));else throw new Error(`${k} looks like an invalid workspace file.`);return D}function i(k){return k.workspace&&typeof k.workspace=="object"&&typeof k.workspace.id=="string"&&typeof k.workspace.configPath=="string"}function n(k){return typeof k.folderUri=="string"}function c(k){return typeof k.fileUri=="string"}function S(k,P){const D={workspaces:[],files:[]};if(k){const _=function(U,j){for(let V=0;V<U.length;V++)try{j(U[V],V)}catch(ce){P.warn(`Error restoring recent entry ${JSON.stringify(U[V])}: ${ce.toString()}. Skip entry.`)}},N=k;Array.isArray(N.entries)&&_(N.entries,U=>{const j=U.label,V=U.remoteAuthority;i(U)?D.workspaces.push({label:j,remoteAuthority:V,workspace:{id:U.workspace.id,configPath:w.URI.parse(U.workspace.configPath)}}):n(U)?D.workspaces.push({label:j,remoteAuthority:V,folderUri:w.URI.parse(U.folderUri)}):c(U)&&D.files.push({label:j,remoteAuthority:V,fileUri:w.URI.parse(U.fileUri)})})}return D}e.restoreRecentlyOpened=S;function R(k){const P={entries:[]};for(const D of k.workspaces)v(D)?P.entries.push({folderUri:D.folderUri.toString(),label:D.label,remoteAuthority:D.remoteAuthority}):P.entries.push({workspace:{id:D.workspace.id,configPath:D.workspace.configPath.toString()},label:D.label,remoteAuthority:D.remoteAuthority});for(const D of k.files)P.entries.push({fileUri:D.fileUri.toString(),label:D.label,remoteAuthority:D.remoteAuthority});return P}e.toStoreData=R}),define(oe[98],ae([0,1,86,13,4,19]),function(Q,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function M(l){function w(){let b=l.scheme===L.Schemas.file?(0,O.originalFSPath)(l):l.toString();return r.isLinux||(b=b.toLowerCase()),(0,C.createHash)("md5").update(b).digest("hex")}return{id:w(),configPath:l}}e.getWorkspaceIdentifier=M;function I(l,w){function b(){if(l.scheme!==L.Schemas.file)return(0,C.createHash)("md5").update(l.toString()).digest("hex");if(!w)return;let u;return r.isLinux?u=w.ino:r.isMacintosh?u=w.birthtime.getTime():r.isWindows&&(typeof w.birthtimeMs=="number"?u=Math.floor(w.birthtimeMs):u=w.birthtime.getTime()),(0,C.createHash)("md5").update(l.fsPath).update(u?String(u):"").digest("hex")}const E=b();if(typeof E=="string")return{id:E,uri:l}}e.getSingleFolderWorkspaceIdentifier=I;function f(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=f}),define(oe[99],ae([0,1,86,87,26,282,17,14,3,2,9,4,32,43,110]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{traceSocketEvent(P,D){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,P,D)}constructor(P,D=""){this._canWrite=!0,this.debugLabel=D,this.socket=P,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=_=>{if(this.traceSocketEvent("error",{code:_?.code,message:_?.message}),_){if(_.code==="EPIPE")return;(0,I.onUnexpectedError)(_)}},this.socket.on("error",this._errorListener),this._closeListener=_=>{this.traceSocketEvent("close",{hadError:_}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(P){const D=_=>{this.traceSocketEvent("read",_),P(M.VSBuffer.wrap(_))};return this.socket.on("data",D),{dispose:()=>this.socket.off("data",D)}}onClose(P){const D=_=>{P({type:0,hadError:_,error:void 0})};return this.socket.on("close",D),{dispose:()=>this.socket.off("close",D)}}onEnd(P){const D=()=>{P()};return this.socket.on("end",D),{dispose:()=>this.socket.off("end",D)}}write(P){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",P),this.socket.write(P.buffer,D=>{if(D){if(D.code==="EPIPE")return;(0,I.onUnexpectedError)(D)}})}catch(D){if(D.code==="EPIPE")return;(0,I.onUnexpectedError)(D)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((P,D)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),P();return}const _=()=>{this.socket.off("close",_),this.socket.off("end",_),this.socket.off("error",_),this.socket.off("timeout",_),this.socket.off("drain",_),this.traceSocketEvent("nodeDrainEnd"),P()};this.socket.on("close",_),this.socket.on("end",_),this.socket.on("error",_),this.socket.on("timeout",_),this.socket.on("drain",_)})}}e.NodeSocket=v;var m;(function(k){k[k.MinHeaderByteSize=2]="MinHeaderByteSize",k[k.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var g;(function(k){k[k.PeekHeader=1]="PeekHeader",k[k.ReadHeader=2]="ReadHeader",k[k.ReadBody=3]="ReadBody",k[k.Fin=4]="Fin"})(g||(g={}));class h extends l.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(P,D){this.socket.traceSocketEvent(P,D)}constructor(P,D,_,N){super(),this._onData=this._register(new f.Emitter),this._onClose=this._register(new f.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=P,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:D,inflateBytesLength:_?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new d(this,D,_,N,this._onData,(U,j)=>this._write(U,j))),this._register(this._flowManager.onError(U=>{console.error(U),(0,I.onUnexpectedError)(U),this._onClose.fire({type:0,hadError:!0,error:U})})),this._incomingData=new y.ChunkStream,this._register(this.socket.onData(U=>this._acceptChunk(U))),this._register(this.socket.onClose(async U=>{this._flowManager.isProcessingReadQueue()&&await f.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(U)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(P){return this._onData.event(P)}onClose(P){return this._onClose.event(P)}onEnd(P){return this.socket.onEnd(P)}write(P){let D=0;for(;D<P.byteLength;)this._flowManager.writeMessage(P.slice(D,Math.min(D+262144,P.byteLength)),{compressed:!0,opcode:2}),D+=262144}_write(P,{compressed:D,opcode:_}){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",P);let N=2;P.byteLength<126?N+=0:P.byteLength<2**16?N+=2:N+=8;const U=M.VSBuffer.alloc(N),j=D?64:0,V=_&15;if(U.writeUInt8(128|j|V,0),P.byteLength<126)U.writeUInt8(P.byteLength,1);else if(P.byteLength<2**16){U.writeUInt8(126,1);let ce=1;U.writeUInt8(P.byteLength>>>8&255,++ce),U.writeUInt8(P.byteLength>>>0&255,++ce)}else{U.writeUInt8(127,1);let ce=1;U.writeUInt8(0,++ce),U.writeUInt8(0,++ce),U.writeUInt8(0,++ce),U.writeUInt8(0,++ce),U.writeUInt8(P.byteLength>>>24&255,++ce),U.writeUInt8(P.byteLength>>>16&255,++ce),U.writeUInt8(P.byteLength>>>8&255,++ce),U.writeUInt8(P.byteLength>>>0&255,++ce)}this.socket.write(M.VSBuffer.concat([U,P]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(P){if(P.byteLength!==0){for(this._incomingData.acceptChunk(P);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const D=this._incomingData.peek(this._state.readLen),_=D.readUInt8(0),N=(_&128)>>>7,U=(_&64)>>>6,j=_&15,V=D.readUInt8(1),ce=(V&128)>>>7,se=V&127;this._state.state=2,this._state.readLen=2+(ce?4:0)+(se===126?2:0)+(se===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=!!U),this._state.firstFrameOfMessage=!!N,this._state.mask=0,this._state.opcode=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===2){const D=this._incomingData.read(this._state.readLen),_=D.readUInt8(1),N=(_&128)>>>7;let U=_&127,j=1;U===126?U=D.readUInt8(++j)*2**8+D.readUInt8(++j):U===127&&(U=D.readUInt8(++j)*0+D.readUInt8(++j)*0+D.readUInt8(++j)*0+D.readUInt8(++j)*0+D.readUInt8(++j)*2**24+D.readUInt8(++j)*2**16+D.readUInt8(++j)*2**8+D.readUInt8(++j));let V=0;N&&(V=D.readUInt8(++j)*2**24+D.readUInt8(++j)*2**16+D.readUInt8(++j)*2**8+D.readUInt8(++j)),this._state.state=3,this._state.readLen=U,this._state.mask=V,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===3){const D=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",D),t(D,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",D),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(D,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(D,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await f.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=h;class d extends l.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:M.VSBuffer.alloc(0)}constructor(P,D,_,N,U,j){super(),this._tracer=P,this._onData=U,this._writeFn=j,this._onError=this._register(new f.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new f.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new f.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,D?(this._zlibInflateStream=this._register(new p(this._tracer,N,_,{windowBits:15})),this._zlibDeflateStream=this._register(new a(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(V=>this._onError.fire(V))),this._register(this._zlibDeflateStream.onError(V=>this._onError.fire(V)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(P,D){this._writeQueue.push({data:P,options:D}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:P,options:D}=this._writeQueue.shift();if(this._zlibDeflateStream&&D.compressed){const _=await this._deflateMessage(this._zlibDeflateStream,P);this._writeFn(_,D)}else this._writeFn(P,{...D,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(P,D){return new Promise((_,N)=>{P.write(D),P.flush(U=>_(U))})}acceptFrame(P,D,_){this._readQueue.push({data:P,isCompressed:D,isLastFrameOfMessage:_}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const P=this._readQueue.shift();if(this._zlibInflateStream&&P.isCompressed){const D=await this._inflateFrame(this._zlibInflateStream,P.data,P.isLastFrameOfMessage);this._onData.fire(D)}else this._onData.fire(P.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(P,D,_){return new Promise((N,U)=>{P.write(D),_&&P.write(M.VSBuffer.fromByteArray([0,0,255,255])),P.flush(j=>N(j))})}}class p extends l.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?M.VSBuffer.concat(this._recordedInflateBytes):M.VSBuffer.alloc(0)}constructor(P,D,_,N){super(),this._tracer=P,this._recordInflateBytes=D,this._onError=this._register(new f.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,O.createInflateRaw)(N),this._zlibInflate.on("error",U=>{this._tracer.traceSocketEvent("zlibInflateError",{message:U?.message,code:U?.code}),this._onError.fire(U)}),this._zlibInflate.on("data",U=>{this._tracer.traceSocketEvent("zlibInflateData",U),this._pendingInflateData.push(M.VSBuffer.wrap(U))}),_&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",_.buffer),this._zlibInflate.write(_.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(P){this._recordInflateBytes&&this._recordedInflateBytes.push(P.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",P),this._zlibInflate.write(P.buffer)}flush(P){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const D=M.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,P(D)})}}class a extends l.Disposable{constructor(P,D){super(),this._tracer=P,this._onError=this._register(new f.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,O.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",_=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:_?.message,code:_?.code}),this._onError.fire(_)}),this._zlibDeflate.on("data",_=>{this._tracer.traceSocketEvent("zlibDeflateData",_),this._pendingDeflateData.push(M.VSBuffer.wrap(_))})}write(P){this._tracer.traceSocketEvent("zlibDeflateWrite",P.buffer),this._zlibDeflate.write(P.buffer)}flush(P){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let D=M.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,D=D.slice(0,D.byteLength-4),P(D)})}}function t(k,P){if(P===0)return;const D=k.byteLength>>>2;for(let ce=0;ce<D;ce++){const se=k.readUInt32BE(ce*4);k.writeUInt32BE(se^P,ce*4)}const _=D*4,N=k.byteLength-_,U=P>>>24&255,j=P>>>16&255,V=P>>>8&255;N>=1&&k.writeUInt8(k.readUInt8(_)^U,_),N>=2&&k.writeUInt8(k.readUInt8(_+1)^j,_+1),N>=3&&k.writeUInt8(k.readUInt8(_+2)^V,_+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function s(){const k=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${k}-sock`;const P=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,r.tmpdir)(),D=(0,w.join)(P,`vscode-ipc-${k}.sock`);return n(D),D}e.createRandomIPCHandle=s;function i(k,P,D){const N=(0,C.createHash)("sha256").update(k).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${D}-${P}-sock`;const U=D.substr(0,4),j=P.substr(0,6);let V;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?V=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-${N}-${U}-${j}.sock`):V=(0,w.join)(k,`${U}-${j}.sock`),n(V),V}e.createStaticIPCHandle=i;function n(k){const P=o[b.platform];typeof P=="number"&&k.length>=P&&console.warn(`WARNING: IPC handle "${k}" is longer than ${P} chars, try a shorter --user-data-dir`)}class c extends u.IPCServer{static toClientConnectionEvent(P){const D=f.Event.fromNodeEventEmitter(P,"connection");return f.Event.map(D,_=>({protocol:new y.Protocol(new v(_,"ipc-server-connection")),onDidClientDisconnect:f.Event.once(f.Event.fromNodeEventEmitter(_,"close"))}))}constructor(P){super(c.toClientConnectionEvent(P)),this.server=P}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=c;function S(k){return new Promise((P,D)=>{const _=(0,L.createServer)();_.on("error",D),_.listen(k,()=>{_.removeListener("error",D),P(new c(_))})})}e.serve=S;function R(k,P){return new Promise((D,_)=>{const N=(0,L.createConnection)(k,()=>{N.removeListener("error",_),D(y.Client.fromSocket(new v(N,`ipc-client${P}`),P))});N.once("error",_)})}e.connect=R}),define(oe[24],ae([0,1,50,9,4,99,38,90,6]),function(Q,e,C,L,r,O,M,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,f.refineServiceDecorator)(M.IEnvironmentService);class l extends I.NativeEnvironmentService{constructor(){super(...arguments),this._snapEnv={}}get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,O.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(r.isLinux){for(const b in process.env)if(b.endsWith("_VSCODE_SNAP_ORIG")){const E=b.slice(0,-17);if(this._snapEnv[E])continue;process.env[E]&&(this._snapEnv[E]=process.env[E]),process.env[b]?process.env[E]=process.env[b]:delete process.env[E]}}}restoreSnapExportedVariables(){if(r.isLinux)for(const b in this._snapEnv)process.env[b]=this._snapEnv[b],delete this._snapEnv[b]}}e.EnvironmentMainService=l,be([C.memoize],l.prototype,"cachedLanguagesPath",null),be([C.memoize],l.prototype,"backupHome",null),be([C.memoize],l.prototype,"mainIPCHandle",null),be([C.memoize],l.prototype,"mainLockfile",null),be([C.memoize],l.prototype,"disableUpdates",null),be([C.memoize],l.prototype,"crossOriginIsolated",null),be([C.memoize],l.prototype,"codeCachePath",null),be([C.memoize],l.prototype,"useCodeCache",null)}),define(oe[283],ae([0,1,86,33,13,9,4,19,21,196,18,24,34,16,5,195,30,98]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y,v,m,g){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let d=class{static{h=this}static{this.backupWorkspacesMetadataStorageKey="backupWorkspaces"}constructor(a,t,o,s){this.environmentMainService=a,this.configurationService=t,this.logService=o,this.stateService=s,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=I.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(i,n)=>(0,L.isEqual)(i,n,!M.isLinux)}}async initialize(){const a=this.stateService.getItem(h.backupWorkspacesMetadataStorageKey)??{workspaces:[],folders:[],emptyWindows:[]};this.emptyWindows=await this.validateEmptyWorkspaces(a.emptyWindows),this.workspaces=await this.validateWorkspaces((0,l.deserializeWorkspaceInfos)(a)),this.folders=await this.validateFolders((0,l.deserializeFolderInfos)(a)),this.storeWorkspacesMetadata()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==u.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===u.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||u.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(a,t){this.workspaces.some(s=>a.workspace.id===s.workspace.id)||(this.workspaces.push(a),this.storeWorkspacesMetadata());const o=(0,O.join)(this.backupHome,a.workspace.id);return t?this.moveBackupFolder(o,t).then(()=>o):o}async moveBackupFolder(a,t){if(await f.Promises.exists(a)&&await this.convertToEmptyWindowBackup(a),await f.Promises.exists(t))try{await f.Promises.rename(t,a,!1)}catch(o){this.logService.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}registerFolderBackup(a){return this.folders.some(t=>this.backupUriComparer.isEqual(a.folderUri,t.folderUri))||(this.folders.push(a),this.storeWorkspacesMetadata()),(0,O.join)(this.backupHome,this.getFolderHash(a))}registerEmptyWindowBackup(a){return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,a.backupFolder))||(this.emptyWindows.push(a),this.storeWorkspacesMetadata()),(0,O.join)(this.backupHome,a.backupFolder)}async validateWorkspaces(a){if(!Array.isArray(a))return[];const t=new Set,o=[];for(const s of a){const i=s.workspace;if(!(0,m.isWorkspaceIdentifier)(i))return[];if(!t.has(i.id)){t.add(i.id);const n=(0,O.join)(this.backupHome,i.id);await this.doHasBackups(n)?i.configPath.scheme!==r.Schemas.file||await f.Promises.exists(i.configPath.fsPath)?o.push(s):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return o}async validateFolders(a){if(!Array.isArray(a))return[];const t=[],o=new Set;for(const s of a){const i=s.folderUri,n=this.backupUriComparer.getComparisonKey(i);if(!o.has(n)){o.add(n);const c=(0,O.join)(this.backupHome,this.getFolderHash(s));await this.doHasBackups(c)?i.scheme!==r.Schemas.file||await f.Promises.exists(i.fsPath)?t.push(s):await this.convertToEmptyWindowBackup(c):await this.deleteStaleBackup(c)}}return t}async validateEmptyWorkspaces(a){if(!Array.isArray(a))return[];const t=[],o=new Set;for(const s of a){const i=s.backupFolder;if(typeof i!="string")return[];if(!o.has(i)){o.add(i);const n=(0,O.join)(this.backupHome,i);await this.doHasBackups(n)?t.push(s):await this.deleteStaleBackup(n)}}return t}async deleteStaleBackup(a){try{await f.Promises.rm(a,f.RimRafMode.MOVE)}catch(t){this.logService.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}prepareNewEmptyWindowBackup(){let a=(0,g.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,a.id));)a=(0,g.createEmptyWorkspaceIdentifier)();return{backupFolder:a.id}}async convertToEmptyWindowBackup(a){const t=this.prepareNewEmptyWindowBackup(),o=(0,O.join)(this.backupHome,t.backupFolder);try{await f.Promises.rename(a,o,!1)}catch(s){return this.logService.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.emptyWindows.push(t),!0}async getDirtyWorkspaces(){const a=[];for(const t of this.workspaces)await this.hasBackups(t)&&a.push(t);for(const t of this.folders)await this.hasBackups(t)&&a.push(t);return a}hasBackups(a){let t;return(0,l.isEmptyWindowBackupInfo)(a)?t=(0,O.join)(this.backupHome,a.backupFolder):(0,v.isFolderBackupInfo)(a)?t=(0,O.join)(this.backupHome,this.getFolderHash(a)):t=(0,O.join)(this.backupHome,a.workspace.id),this.doHasBackups(t)}async doHasBackups(a){try{const t=await f.Promises.readdir(a);for(const o of t)try{if((await f.Promises.readdir((0,O.join)(a,o))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const a={workspaces:this.workspaces.map(({workspace:t,remoteAuthority:o})=>{const s={id:t.id,configURIPath:t.configPath.toString()};return o&&(s.remoteAuthority=o),s}),folders:this.folders.map(({folderUri:t,remoteAuthority:o})=>{const s={folderUri:t.toString()};return o&&(s.remoteAuthority=o),s}),emptyWindows:this.emptyWindows.map(({backupFolder:t,remoteAuthority:o})=>{const s={backupFolder:t};return o&&(s.remoteAuthority=o),s})};this.stateService.setItem(h.backupWorkspacesMetadataStorageKey,a)}getFolderHash(a){const t=a.folderUri;let o;return t.scheme===r.Schemas.file?o=M.isLinux?t.fsPath:t.fsPath.toLowerCase():o=t.toString().toLowerCase(),(0,C.createHash)("md5").update(o).digest("hex")}};e.BackupMainService=d,e.BackupMainService=d=h=be([ne(0,b.IEnvironmentMainService),ne(1,w.IConfigurationService),ne(2,y.ILogService),ne(3,E.IStateService)],d)}),define(oe[20],ae([0,1,15,37,8,3,2,4,36,12,6,5,34,24]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,w.createDecorator)("lifecycleMainService");var v;(function(h){h[h.QUIT=1]="QUIT",h[h.KILL=2]="KILL"})(v||(e.ShutdownReason=v={}));var m;(function(h){h[h.Starting=1]="Starting",h[h.Ready=2]="Ready",h[h.AfterWindowOpen=3]="AfterWindowOpen",h[h.Eventually=4]="Eventually"})(m||(e.LifecycleMainPhase=m={}));let g=class extends M.Disposable{static{y=this}static{this.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart"}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(d,p,a){super(),this.logService=d,this.stateService=p,this.environmentMainService=a,this._onBeforeShutdown=this._register(new O.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new O.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new O.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new O.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.relaunchHandler=void 0,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateService.getItem(y.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateService.removeItem(y.QUIT_AND_RESTART_KEY)}registerListeners(){const d=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),I.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};C.app.addListener("before-quit",d);const p=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!I.isMacintosh)&&C.app.quit()};C.app.addListener("window-all-closed",p),C.app.once("will-quit",a=>{this.trace("Lifecycle#app.on(will-quit) - begin"),a.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.trace("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.resolvePendingQuitPromise(!1),C.app.removeListener("before-quit",d),C.app.removeListener("window-all-closed",p),this.trace("Lifecycle#app.on(will-quit) - calling app.quit()"),C.app.quit()})})}fireOnWillShutdown(d){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;const p=this.logService;this.trace("Lifecycle#onWillShutdown.fire()");const a=[];return this._onWillShutdown.fire({reason:d,join(t,o){p.trace(`Lifecycle#onWillShutdown - begin '${t}'`),a.push(o.finally(()=>{p.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.pendingWillShutdownPromise=(async()=>{try{await r.Promises.settled(a)}catch(t){this.logService.error(t)}try{await this.stateService.close()}catch(t){this.logService.error(t)}})(),this.pendingWillShutdownPromise}set phase(d){if(d<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===d)return;this.trace(`lifecycle (main): phase changed (value: ${d})`),this._phase=d;const p=this.phaseWhen.get(this._phase);p&&(p.open(),this.phaseWhen.delete(this._phase))}async when(d){if(d<=this._phase)return;let p=this.phaseWhen.get(d);p||(p=new r.Barrier,this.phaseWhen.set(d,p)),await p.wait()}registerWindow(d){const p=new M.DisposableStore;this.windowCounter++,p.add(d.onWillLoad(t=>this._onWillLoadWindow.fire({window:d,workspace:t.workspace,reason:t.reason})));const a=(0,l.assertIsDefined)(d.win);a.on("close",t=>{const o=d.id;if(this.windowToCloseRequest.has(o)){this.windowToCloseRequest.delete(o);return}this.trace(`Lifecycle#window.on('close') - window ID ${d.id}`),t.preventDefault(),this.unload(d,1).then(s=>{if(s){this.windowToCloseRequest.delete(o);return}this.windowToCloseRequest.add(o),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this._onBeforeCloseWindow.fire(d),d.close()})}),a.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${d.id}`),this.windowCounter--,p.dispose(),this.windowCounter===0&&(!I.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}registerAuxWindow(d){const p=(0,l.assertIsDefined)(d.win);p.on("close",a=>{this.trace(`Lifecycle#auxWindow.on('close') - window ID ${d.id}`),this._quitRequested&&(this.trace("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),a.preventDefault())}),p.on("closed",()=>{this.trace(`Lifecycle#auxWindow.on('closed') - window ID ${d.id}`)})}async reload(d,p){await this.unload(d,3)||d.reload(p)}unload(d,p){const a=this.mapWindowIdToPendingUnload.get(d.id);if(a)return a;const t=this.doUnload(d,p).finally(()=>{this.mapWindowIdToPendingUnload.delete(d.id)});return this.mapWindowIdToPendingUnload.set(d.id,t),t}async doUnload(d,p){if(!d.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${d.id}`);const a=this._quitRequested?2:p,t=await this.onBeforeUnloadWindowInRenderer(d,a);return t?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${d.id})`),this.handleWindowUnloadVeto(t)):(await this.onWillUnloadWindowInRenderer(d,a),!1)}handleWindowUnloadVeto(d){return d?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(d){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(d),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(d,p){return new Promise(a=>{const t=this.oneTimeListenerTokenGenerator++,o=`vscode:ok${t}`,s=`vscode:cancel${t}`;L.validatedIpcMain.once(o,()=>{a(!1)}),L.validatedIpcMain.once(s,()=>{a(!0)}),d.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:s,reason:p})})}onWillUnloadWindowInRenderer(d,p){return new Promise(a=>{const o=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;L.validatedIpcMain.once(o,()=>a()),d.send("vscode:onWillUnload",{replyChannel:o,reason:p})})}quit(d){return this.doQuit(d).then(p=>{if(!p&&d)try{if(I.isWindows){const a=(0,f.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.logService.error(a)}return p})}doQuit(d){return this.trace(`Lifecycle#quit() - begin (willRestart: ${d})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(d&&this.stateService.setItem(y.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(p=>{this.pendingQuitPromiseResolve=p,this.trace("Lifecycle#quit() - calling app.quit()"),C.app.quit()}),this.pendingQuitPromise)}trace(d){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(d):this.logService.trace(d)}setRelaunchHandler(d){this.relaunchHandler=d}async relaunch(d){this.trace("Lifecycle#relaunch()");const p=process.argv.slice(1);if(d?.addArgs&&p.push(...d.addArgs),d?.removeArgs)for(const o of d.removeArgs){const s=p.indexOf(o);s>=0&&p.splice(s,1)}const a=()=>{this.relaunchHandler?.handleRelaunch(d)||(this.trace("Lifecycle#relaunch() - calling app.relaunch()"),C.app.relaunch({args:p}))};C.app.once("quit",a),await this.quit(!0)&&C.app.removeListener("quit",a)}async kill(d){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,r.timeout)(1e3),(async()=>{for(const p of C.BrowserWindow.getAllWindows())if(p&&!p.isDestroyed()){let a;p.webContents&&!p.webContents.isDestroyed()?a=new Promise(t=>p.once("closed",t)):a=Promise.resolve(),p.destroy(),await a}})()]),C.app.exit(d)}};e.LifecycleMainService=g,e.LifecycleMainService=g=y=be([ne(0,b.ILogService),ne(1,E.IStateService),ne(2,u.IEnvironmentMainService)],g)}),define(oe[284],ae([0,1,4,3,2,6,20]),function(Q,e,C,L,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,O.createDecorator)("keyboardLayoutMainService");let I=class extends r.Disposable{constructor(w){super(),this._onDidChangeKeyboardLayout=this._register(new L.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,w.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const w=await new Promise((b,E)=>{Q(["native-keymap"],b,E)});this._keyboardLayoutData=f(w),C.isCI||w.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=f(w),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};e.KeyboardLayoutMainService=I,e.KeyboardLayoutMainService=I=be([ne(0,M.ILifecycleMainService)],I);function f(l){const w=l.getKeyMap(),b=l.getCurrentKeyboardLayout();return{keyboardMapping:w,keyboardLayoutInfo:b}}}),define(oe[285],ae([0,1,246,8,17,14,12,18,38,94,5,53,245,282]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let y=class extends b.AbstractRequestService{constructor(h,d,p,a){super(a),this.configurationService=h,this.environmentService=d,this.logService=p,this.configure(),this._register(h.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.configure()}))}configure(){const h=this.configurationService.getValue("http");this.proxyUrl=h?.proxy,this.strictSSL=!!h?.proxyStrictSSL,this.authorization=h?.proxyAuthorization}async request(h,d){const{proxyUrl:p,strictSSL:a}=this;let t;try{t=await(0,l.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(i){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,O.getErrorMessage)(i)))}const o={...process.env,...t},s=h.agent?h.agent:await(0,E.getProxyAgent)(h.url||"",o,{proxyUrl:p,strictSSL:a});return h.agent=s,h.strictSSL=a,this.authorization&&(h.headers={...h.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(h.isChromiumNetwork?"electron":"node",h,()=>m(h,d))}async resolveProxy(h){}async loadCertificates(){return(await new Promise((d,p)=>{Q(["@vscode/proxy-agent"],d,p)})).loadSystemCertificates({log:this.logService})}};e.RequestService=y,e.RequestService=y=be([ne(0,I.IConfigurationService),ne(1,f.INativeEnvironmentService),ne(2,w.ILogService),ne(3,w.ILoggerService)],y);async function v(g){return((0,C.parse)(g.url).protocol==="https:"?await new Promise((p,a)=>{Q(["https"],p,a)}):await new Promise((p,a)=>{Q(["http"],p,a)})).request}async function m(g,h){return L.Promises.withAsyncBody(async(d,p)=>{const a=(0,C.parse)(g.url),t=g.getRawRequest?g.getRawRequest(g):await v(g),o={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,M.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(o.auth=g.user+":"+g.password);const s=t(o,i=>{const n=(0,M.isNumber)(g.followRedirects)?g.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)m({...g,url:i.headers.location,followRedirects:n-1},h).then(d,p);else{let c=i;!g.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(c=i.pipe((0,u.createGunzip)())),d({res:i,stream:(0,r.streamToBufferReadableStream)(c)})}});s.on("error",p),g.timeout&&s.setTimeout(g.timeout),g.isChromiumNetwork&&s.removeHeader("Content-Length"),g.data&&typeof g.data=="string"&&s.write(g.data),s.end(),h.onCancellationRequested(()=>{s.abort(),p(new O.CancellationError)})})}e.nodeRequest=m}),define(oe[286],ae([0,1,15,285]),function(Q,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function r(M){return C.net.request}class O extends L.RequestService{request(I,f){return super.request({...I||{},getRawRequest:r,isChromiumNetwork:!0},f)}}e.RequestMainService=O}),define(oe[82],ae([0,1,7,3,2,38,16,6,20,5,96,279,41,56,40,13]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,I.createDecorator)("storageMainService");let m=class extends r.Disposable{constructor(d,p,a,t,o,s){super(),this.logService=d,this.environmentService=p,this.userDataProfilesService=a,this.lifecycleMainService=t,this.fileService=o,this.uriIdentityService=s,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new L.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this._register(this.createApplicationStorage()),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(d=>{d.window.profile&&this.profileStorage(d.window.profile).init(),d.workspace&&this.workspaceStorage(d.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(d=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=d.reason,d.join("applicationStorage",this.applicationStorage.close());for(const[,p]of this.mapProfileToStorage)d.join("profileStorage",p.close());for(const[,p]of this.mapWorkspaceToStorage)d.join("workspaceStorage",p.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(d=>{d.join((async()=>{await this.fileService.exists(d.profile.globalStorageHome)||await this.fileService.createFolder(d.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(d=>{const p=this.mapProfileToStorage.get(d.profile.id);p&&d.join(p.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const d=new b.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return this._register(L.Event.once(d.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")})),d}profileStorage(d){if((0,w.isProfileUsingDefaultStorage)(d))return this.applicationStorage;let p=this.mapProfileToStorage.get(d.id);if(!p){this.logService.trace(`StorageMainService: creating profile storage (${d.name})`),p=this._register(this.createProfileStorage(d)),this.mapProfileToStorage.set(d.id,p);const a=this._register(p.onDidChangeStorage(t=>this._onDidChangeProfileStorage.fire({...t,storage:p,profile:d})));this._register(L.Event.once(p.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${d.name})`),this.mapProfileToStorage.delete(d.id),a.dispose()}))}return p}createProfileStorage(d){return this.shutdownReason===2?new b.InMemoryStorageMain(this.logService,this.fileService):new b.ProfileStorageMain(d,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(d){let p=this.mapWorkspaceToStorage.get(d.id);return p||(this.logService.trace(`StorageMainService: creating workspace storage (${d.id})`),p=this._register(this.createWorkspaceStorage(d)),this.mapWorkspaceToStorage.set(d.id,p),this._register(L.Event.once(p.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${d.id})`),this.mapWorkspaceToStorage.delete(d.id)}))),p}createWorkspaceStorage(d){return this.shutdownReason===2?new b.InMemoryStorageMain(this.logService,this.fileService):new b.WorkspaceStorageMain(d,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(d){const p=C.URI.file(d);for(const a of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(a.path&&this.uriIdentityService.extUri.isEqualOrParent(C.URI.file(a.path),p))return!0;return!1}};e.StorageMainService=m,e.StorageMainService=m=be([ne(0,l.ILogService),ne(1,O.IEnvironmentService),ne(2,u.IUserDataProfilesMainService),ne(3,f.ILifecycleMainService),ne(4,M.IFileService),ne(5,y.IUriIdentityService)],m),e.IApplicationStorageMainService=(0,I.createDecorator)("applicationStorageMainService");let g=class extends w.AbstractStorageService{constructor(d,p){super(),this.userDataProfilesService=d,this.storageMainService=p,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(d){if(d===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(d){if(d===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.with({scheme:v.Schemas.file}).fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.ApplicationStorageMainService=g,e.ApplicationStorageMainService=g=be([ne(0,E.IUserDataProfilesService),ne(1,e.IStorageMainService)],g)}),define(oe[287],ae([0,1,87,26,104,99,8,2,4,18,5,27,241,242,95,127,17]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function g(t,o,s,i,n){let c;for(let S=3;S&&(c?.dispose(),c=await new h(t,o,s,i,n).waitForReady(),!(n&&r.BROWSER_RESTRICTED_PORTS[n]||!r.BROWSER_RESTRICTED_PORTS[c.tunnelLocalPort]));S--);return c}class h extends I.Disposable{constructor(o,s,i,n,c){super(),this.defaultTunnelHost=s,this.suggestedLocalPort=c,this.privacy=v.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=o,this._server=C.createServer(),this._barrier=new M.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=S=>this._onConnection(S),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(s=>{s()})}async waitForReady(){const o=this.suggestedLocalPort??this.tunnelRemotePort,s=(0,v.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let i=await(0,r.findFreePortFaster)(o,2,1e3,s),n=null;return this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address(),n||(i=0,this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async _onConnection(o){o.pause();const s=(0,v.isLocalhost)(this.tunnelRemoteHost)||(0,v.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,E.connectRemoteAgentTunnel)(this._options,s,this.tunnelRemotePort),n=i.getSocket(),c=i.readEntireBuffer();i.dispose(),c.byteLength>0&&o.write(c.buffer),o.on("end",()=>{o.localAddress&&this._socketsDispose.delete(o.localAddress),n.end()}),o.on("close",()=>n.end()),o.on("error",()=>{o.localAddress&&this._socketsDispose.delete(o.localAddress),n instanceof O.NodeSocket?n.socket.destroy():n.end()}),n instanceof O.NodeSocket?this._mirrorNodeSocket(o,n):this._mirrorGenericSocket(o,n),o.localAddress&&this._socketsDispose.set(o.localAddress,()=>{o.end(),n.end()})}_mirrorGenericSocket(o,s){s.onClose(()=>o.destroy()),s.onEnd(()=>o.end()),s.onData(i=>o.write(i.buffer)),o.on("data",i=>s.write(m.VSBuffer.wrap(i))),o.resume()}_mirrorNodeSocket(o,s){const i=s.socket;i.on("end",()=>o.end()),i.on("close",()=>o.end()),i.on("error",()=>{o.destroy()}),i.pipe(o),o.pipe(i)}}e.NodeRemoteTunnel=h;let d=class extends v.AbstractTunnelService{constructor(o,s,i,n,c){super(s,c),this.remoteSocketFactoryService=o,this.signService=i,this.productService=n}isPortPrivileged(o){return(0,v.isPortPrivileged)(o,this.defaultTunnelHost,f.OS,L.release())}retainOrCreateTunnel(o,s,i,n,c,S,R,k){const P=this.getTunnelFromMap(s,i);if(P)return++P.refcount,P.value;if((0,v.isTunnelProvider)(o))return this.createWithProvider(o,s,i,c,S,R,k);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${i} on local port ${c}.`);const D={commit:this.productService.commit,quality:this.productService.quality,addressProvider:o,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},_=g(D,n,s,i,c);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(s,i,_),_}}};e.BaseTunnelService=d,e.BaseTunnelService=d=be([ne(0,u.IRemoteSocketFactoryService),ne(1,w.ILogService),ne(2,y.ISignService),ne(3,b.IProductService),ne(4,l.IConfigurationService)],d);let p=class extends d{constructor(o,s,i,n,c){super(o,s,i,n,c)}};e.TunnelService=p,e.TunnelService=p=be([ne(0,u.IRemoteSocketFactoryService),ne(1,w.ILogService),ne(2,y.ISignService),ne(3,b.IProductService),ne(4,l.IConfigurationService)],p);let a=class extends I.Disposable{constructor(o,s,i,n,c){super(),this.remoteSocketFactoryService=o,this.logService=s,this.productService=i,this.signService=n,this.configurationService=c,this._tunnelServices=new Map}async openTunnel(o,s,i,n,c,S,R,k,P){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${S}.`),!this._tunnelServices.has(o)){const D=new p(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(D),this._tunnelServices.set(o,D),D.onTunnelClosed(async()=>{(await D.tunnels).length===0&&(D.dispose(),this._tunnelServices.delete(o))})}return this._tunnelServices.get(o).openTunnel(s,i,n,c,S,R,k,P)}};e.SharedTunnelsService=a,e.SharedTunnelsService=a=be([ne(0,u.IRemoteSocketFactoryService),ne(1,w.ILogService),ne(2,b.IProductService),ne(3,y.ISignService),ne(4,l.IConfigurationService)],a)}),define(oe[100],ae([0,1,8,23,3,18,24,20,5,27,53,49]),function(Q,e,C,L,r,O,M,I,f,l,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function E(y,v,m){return`${m.updateUrl}/api/update/${y}/${v}/${m.commit}`}e.createUpdateURL=E;let u=class{get state(){return this._state}setState(v){this.logService.info("update#setState",v.type),this._state=v,this._onStateChange.fire(v)}constructor(v,m,g,h,d,p){this.lifecycleMainService=v,this.configurationService=m,this.environmentMainService=g,this.requestService=h,this.logService=d,this.productService=p,this._state=b.State.Uninitialized,this._onStateChange=new r.Emitter,this.onStateChange=this._onStateChange.event,v.when(3).finally(()=>this.initialize())}async initialize(){if(!this.environmentMainService.isBuilt){this.setState(b.State.Disabled(0));return}if(this.environmentMainService.disableUpdates){this.setState(b.State.Disabled(1)),this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.setState(b.State.Disabled(3)),this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const v=this.configurationService.getValue("update.mode"),m=this.getProductQuality(v);if(!m){this.setState(b.State.Disabled(2)),this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(m),!this.url){this.setState(b.State.Disabled(4)),this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.configurationService.getValue("_update.prss")){const g=new URL(this.url);g.searchParams.set("prss","true"),this.url=g.toString()}if(this.setState(b.State.Idle(this.getUpdateType())),v==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}v==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,g=>this.logService.error(g))}getProductQuality(v){return v==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(v=60*60*1e3){return(0,C.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(v){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(v)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(v){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(v=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.url)return;if(this.configurationService.getValue("update.mode")==="none")return!1;try{return(await this.requestService.request({url:this.url},L.CancellationToken.None)).res.statusCode===204}catch(m){this.logService.error("update#isLatestVersion(): failed to check for updates"),this.logService.error(m);return}}async _applySpecificUpdate(v){}getUpdateType(){return 1}doQuitAndInstall(){}};e.AbstractUpdateService=u,e.AbstractUpdateService=u=be([ne(0,I.ILifecycleMainService),ne(1,O.IConfigurationService),ne(2,M.IEnvironmentMainService),ne(3,w.IRequestService),ne(4,f.ILogService),ne(5,l.IProductService)],u)}),define(oe[288],ae([0,1,15,50,3,45,2,18,24,20,5,27,53,28,49,100]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let m=class extends v.AbstractUpdateService{get onRawError(){return r.Event.fromNodeEventEmitter(C.autoUpdater,"error",(h,d)=>d)}get onRawUpdateNotAvailable(){return r.Event.fromNodeEventEmitter(C.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return r.Event.fromNodeEventEmitter(C.autoUpdater,"update-available",(h,d,p)=>({url:d,version:p,productVersion:p}))}get onRawUpdateDownloaded(){return r.Event.fromNodeEventEmitter(C.autoUpdater,"update-downloaded",(h,d,p,a)=>({releaseNotes:d,version:p,productVersion:p,date:a}))}constructor(h,d,p,a,t,o,s){super(h,d,a,t,o,s),this.telemetryService=p,this.disposables=new M.DisposableStore,h.setRelaunchHandler(this)}handleRelaunch(h){return h?.addArgs||h?.removeArgs||this.state.type!=="ready"?!1:(this.logService.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.doQuitAndInstall(),!0)}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(h){this.telemetryService.publicLog2("update:error",{messageHash:String((0,O.hash)(String(h)))}),this.logService.error("UpdateService error:",h);const d=this.state.type==="checking for updates"&&this.state.explicit?h:void 0;this.setState(y.State.Idle(1,d))}buildUpdateFeedUrl(h){let d;this.productService.darwinUniversalAssetId?d=this.productService.darwinUniversalAssetId:d=process.arch==="x64"?"darwin":"darwin-arm64";const p=(0,v.createUpdateURL)(d,h,this.productService);try{C.autoUpdater.setFeedURL({url:p})}catch(a){this.logService.error("Failed to set update feed URL",a);return}return p}doCheckForUpdates(h){this.setState(y.State.CheckingForUpdates(h)),C.autoUpdater.checkForUpdates()}onUpdateAvailable(h){this.state.type==="checking for updates"&&this.setState(y.State.Downloading(h))}onUpdateDownloaded(h){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:h.version}),this.setState(y.State.Ready(h)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(y.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),C.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};e.DarwinUpdateService=m,be([L.memoize],m.prototype,"onRawError",null),be([L.memoize],m.prototype,"onRawUpdateNotAvailable",null),be([L.memoize],m.prototype,"onRawUpdateAvailable",null),be([L.memoize],m.prototype,"onRawUpdateDownloaded",null),e.DarwinUpdateService=m=be([ne(0,l.ILifecycleMainService),ne(1,I.IConfigurationService),ne(2,u.ITelemetryService),ne(3,f.IEnvironmentMainService),ne(4,E.IRequestService),ne(5,w.ILogService),ne(6,b.IProductService)],m)}),define(oe[289],ae([0,1,48,46,8,3,9,24,20,5,28,49]),function(Q,e,C,L,r,O,M,I,f,l,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let E=class{get state(){return this._state}setState(v){this.logService.info("update#setState",v.type),this._state=v,this._onStateChange.fire(v)}constructor(v,m,g){if(this.lifecycleMainService=v,this.logService=g,this._state=b.State.Uninitialized,this._onStateChange=new O.Emitter,this.onStateChange=this._onStateChange.event,m.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(b.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,h=>this.logService.error(h))}scheduleCheckForUpdates(v=60*60*1e3){return(0,r.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(v){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(v)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(v){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(v=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(v){}};E=be([ne(0,f.ILifecycleMainService),ne(1,I.IEnvironmentMainService),ne(2,l.ILogService)],E);let u=class extends E{constructor(v,m,g,h,d,p){super(g,h,d),this.snap=v,this.snapRevision=m,this.telemetryService=p;const a=(0,L.watch)(M.dirname(this.snap)),t=O.Event.fromNodeEventEmitter(a,"change",(n,c)=>c),o=O.Event.filter(t,n=>n==="current"),i=O.Event.debounce(o,(n,c)=>c,2e3)(()=>this.checkForUpdates(!1));g.onWillShutdown(()=>{i.dispose(),a.close()})}doCheckForUpdates(){this.setState(b.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(v=>{v?this.setState(b.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2)))},v=>{this.logService.error(v),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2,v.message||v))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,C.spawn)("sleep 3 && "+M.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const v=await new Promise((g,h)=>(0,L.realpath)(`${M.dirname(this.snap)}/current`,(d,p)=>d?h(d):g(p))),m=M.basename(v);return this.snapRevision!==m}isLatestVersion(){return this.isUpdateAvailable().then(void 0,v=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.SnapUpdateService=u,e.SnapUpdateService=u=be([ne(2,f.ILifecycleMainService),ne(3,I.IEnvironmentMainService),ne(4,l.ILogService),ne(5,w.ITelemetryService)],u)}),define(oe[29],ae([0,1,4,6,60,70,27,18,24,9,65,137]),function(Q,e,C,L,r,O,M,I,f,l,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLastFocused=e.getFocusedOrLastActiveWindow=e.defaultBrowserWindowOptions=e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,L.createDecorator)("windowsMainService");var E;(function(m){m[m.CLI=0]="CLI",m[m.DOCK=1]="DOCK",m[m.MENU=2]="MENU",m[m.DIALOG=3]="DIALOG",m[m.DESKTOP=4]="DESKTOP",m[m.API=5]="API"})(E||(e.OpenContext=E={}));function u(m,g,h){const d=m.get(O.IThemeMainService),p=m.get(M.IProductService),a=m.get(I.IConfigurationService),t=m.get(f.IEnvironmentMainService),o=a.getValue("window"),s={backgroundColor:d.getBackgroundColor(),minWidth:r.WindowMinimumSize.WIDTH,minHeight:r.WindowMinimumSize.HEIGHT,title:p.nameLong,...h,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,r.zoomLevelToZoomFactor)(g?.zoomLevel??o?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...h?.webPreferences,sandbox:!0},experimentalDarkMode:!0};if(g&&(s.x=g.x,s.y=g.y,s.width=g.width,s.height=g.height),C.isLinux?s.icon=(0,l.join)(t.appRoot,"resources/linux/code.png"):C.isWindows&&!t.isBuilt&&(s.icon=(0,l.join)(t.appRoot,"resources/win32/code_150x150.png")),C.isMacintosh&&(s.acceptFirstMouse=!0,o?.clickThroughInactive===!1&&(s.acceptFirstMouse=!1)),C.isMacintosh&&!(0,r.useNativeFullScreen)(a)&&(s.fullscreenable=!1),C.isMacintosh&&o?.nativeTabs===!0&&(s.tabbingIdentifier=p.nameShort),!(0,r.hasNativeTitlebar)(a)&&(s.titleBarStyle="hidden",C.isMacintosh||(s.frame=!1),(0,r.useWindowControlsOverlay)(a))){const c=d.getWindowSplash()?.colorInfo.titleBarBackground??d.getBackgroundColor(),S=b.Color.fromHex(c).isDarker()?"#FFFFFF":"#000000";s.titleBarOverlay={height:29,color:c,symbolColor:S}}return s}e.defaultBrowserWindowOptions=u;function y(m){const g=m.get(e.IWindowsMainService),h=m.get(w.IAuxiliaryWindowsMainService),d=g.getFocusedWindow()??h.getFocusedWindow();if(d)return d;const p=g.getLastActiveWindow(),a=h.getLastActiveWindow();return p&&a?p.lastFocusTime<a.lastFocusTime?a:p:p??a}e.getFocusedOrLastActiveWindow=y;function v(m){let g,h=Number.MIN_VALUE;for(const d of m)d.lastFocusTime>h&&(h=d.lastFocusTime,g=d);return g}e.getLastFocused=v}),define(oe[290],ae([0,1,15,23,3,45,2,32,117,5,82,29]),function(Q,e,C,L,r,O,M,I,f,l,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var E;(function(y){y[y.Initial=1]="Initial",y[y.StoredCredentialsUsed=2]="StoredCredentialsUsed",y[y.LoginDialogShown=3]="LoginDialogShown"})(E||(E={}));let u=class extends M.Disposable{constructor(v,m,g,h){super(),this.logService=v,this.windowsMainService=m,this.encryptionMainService=g,this.applicationStorageMainService=h,this.PROXY_CREDENTIALS_SERVICE_KEY="proxy-credentials://",this.pendingProxyResolve=void 0,this.state=E.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const v=r.Event.fromNodeEventEmitter(C.app,"login",(m,g,h,d,p)=>({event:m,webContents:g,req:h,authInfo:d,callback:p}));this._register(v(this.onLogin,this))}async onLogin({event:v,authInfo:m,req:g,callback:h}){if(!m.isProxy)return;if(!this.pendingProxyResolve&&this.state===E.LoginDialogShown&&g.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}v.preventDefault();let d;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),d=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(m);try{d=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}h(d?.username,d?.password)}async resolveProxyCredentials(v){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const m=await this.doResolveProxyCredentials(v);if(m)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),m;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(v){this.logService.trace("auth#doResolveProxyCredentials - enter",v);const m=String((0,O.hash)({scheme:v.scheme,host:v.host,port:v.port}));let g,h;try{const t=this.applicationStorageMainService.get(this.PROXY_CREDENTIALS_SERVICE_KEY+m,-1);if(t){const o=JSON.parse(await this.encryptionMainService.decrypt(t));g=o.username,h=o.password}}catch(t){this.logService.error(t)}if(this.state!==E.StoredCredentialsUsed&&typeof g=="string"&&typeof h=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=E.StoredCredentialsUsed,{username:g,password:h};const d=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!d){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${d.id} to handle proxy login`);const p={authInfo:v,username:this.sessionCredentials?.username??g,password:this.sessionCredentials?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,I.generateUuid)()}`};d.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,p),this.state=E.LoginDialogShown;const a=await new Promise(t=>{const o=async(s,i,n)=>{if(i===p.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${d.id}`),d.win?.webContents.off("ipc-message",o),n){const c={username:n.username,password:n.password};try{if(n.remember){const S=await this.encryptionMainService.encrypt(JSON.stringify(c));this.applicationStorageMainService.store(this.PROXY_CREDENTIALS_SERVICE_KEY+m,S,-1,1)}else this.applicationStorageMainService.remove(this.PROXY_CREDENTIALS_SERVICE_KEY+m,-1)}catch(S){this.logService.error(S)}t({username:c.username,password:c.password})}else t(void 0)};d.win?.webContents.on("ipc-message",o)});return this.sessionCredentials=a,a}};e.ProxyAuthHandler=u,e.ProxyAuthHandler=u=be([ne(0,l.ILogService),ne(1,b.IWindowsMainService),ne(2,f.IEncryptionMainService),ne(3,w.IApplicationStorageMainService)],u)}),define(oe[291],ae([0,1,15,22,4,7,21,18,64,6,5,128,29]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,l.createDecorator)(e.ID);let u=class{constructor(v,m,g,h){this.logService=v,this.windowsMainService=m,this.urlService=g,this.configurationService=h}async start(v,m){this.logService.trace("Received data from other instance: ",v,m),r.isMacintosh&&C.app.focus({steal:!0});const g=this.parseOpenUrl(v);if(g.length){let h=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const d=(0,L.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:4}));d&&(h=d.ready())}h.then(()=>{for(const{uri:d,originalUrl:p}of g)this.urlService.open(d,{originalUrl:p})})}else return this.startOpenWindow(v,m)}parseOpenUrl(v){return v["open-url"]&&v._urls&&v._urls.length>0?(0,L.coalesce)(v._urls.map(m=>{try{return{uri:O.URI.parse(m),originalUrl:m}}catch{return null}})):[]}async startOpenWindow(v,m){const g=(0,f.isLaunchedFromCli)(m)?0:4;let h=[];const d=v.wait&&v.waitMarkerFilePath?O.URI.file(v.waitMarkerFilePath):void 0,p=v.remote||void 0,a={context:g,cli:v,userEnv:v["preserve-env"]||g===0?m:void 0,waitMarkerFileURI:d,remoteAuthority:p,forceProfile:v.profile,forceTempProfile:v["profile-temp"]};if(v.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(v.extensionDevelopmentPath,a);else if(!v._.length&&!v["folder-uri"]&&!v["file-uri"]){let t=!1;if(v["new-window"]||v["unity-launch"]||a.forceProfile||a.forceTempProfile)t=!0;else if(v["reuse-window"])t=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!r.isMacintosh}if(t)h=await this.windowsMainService.open({...a,forceNewWindow:!0,forceEmpty:!0});else{const o=this.windowsMainService.getLastActiveWindow();o?(this.windowsMainService.openExistingWindow(o,a),h=[o]):h=await this.windowsMainService.open({...a,forceEmpty:!0})}}else h=await this.windowsMainService.open({...a,forceNewWindow:v["new-window"],preferNewWindow:!v["reuse-window"]&&!v.wait,forceReuseWindow:v["reuse-window"],diffMode:v.diff,mergeMode:v.merge,addMode:v.add,noRecentEntry:!!v["skip-add-to-recently-opened"],gotoLineMode:v.goto});if(d&&h.length===1&&h[0])return Promise.race([h[0].whenClosedOrLoaded,(0,M.whenDeleted)(d.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};e.LaunchMainService=u,e.LaunchMainService=u=be([ne(0,w.ILogService),ne(1,E.IWindowsMainService),ne(2,b.IURLService),ne(3,I.IConfigurationService)],u)}),define(oe[292],ae([0,1,2,20,56,30,8,29]),function(Q,e,C,L,r,O,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let f=class extends C.Disposable{constructor(w,b,E){super(),this.userDataProfilesService=b,this.windowsMainService=E,this._register(w.onWillLoadWindow(u=>{u.reason===2&&this.unsetProfileForWorkspace(u.window)})),this._register(w.onBeforeCloseWindow(u=>this.unsetProfileForWorkspace(u))),this._register(new M.RunOnceScheduler(()=>this.cleanUpEmptyWindowAssociations(),30*1e3)).schedule()}async unsetProfileForWorkspace(w){const b=this.getWorkspace(w),E=this.userDataProfilesService.getProfileForWorkspace(b);E?.isTransient&&(this.userDataProfilesService.unsetWorkspace(b,E.isTransient),E.isTransient&&await this.userDataProfilesService.cleanUpTransientProfiles())}getWorkspace(w){return w.openedWorkspace??(0,O.toWorkspaceIdentifier)(w.backupPath,w.isExtensionDevelopmentHost)}cleanUpEmptyWindowAssociations(){const w=this.userDataProfilesService.getAssociatedEmptyWindows();if(w.length===0)return;const b=this.windowsMainService.getWindows().map(E=>this.getWorkspace(E));for(const E of w)b.some(u=>u.id===E.id)||this.userDataProfilesService.unsetWorkspace(E,!1)}};e.UserDataProfilesHandler=f,e.UserDataProfilesHandler=f=be([ne(0,L.ILifecycleMainService),ne(1,r.IUserDataProfilesMainService),ne(2,I.IWindowsMainService)],f)}),define(oe[61],ae([0,1,15,2,3,5,312,8,13,29,74,28,20,76,35,4,132]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y,v,m){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.WindowUtilityProcess=e.UtilityProcess=void 0;function h(a){return typeof a.responseWindowId=="number"}let d=class extends L.Disposable{static{g=this}static{this.ID_COUNTER=0}static{this.all=new Map}static getAll(){return Array.from(g.all.values())}constructor(t,o,s){super(),this.logService=t,this.telemetryService=o,this.lifecycleMainService=s,this.id=String(++g.ID_COUNTER),this._onStdout=this._register(new r.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new r.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new r.Emitter),this.onMessage=this._onMessage.event,this._onSpawn=this._register(new r.Emitter),this.onSpawn=this._onSpawn.event,this._onExit=this._register(new r.Emitter),this.onExit=this._onExit.event,this._onCrash=this._register(new r.Emitter),this.onCrash=this._onCrash.event,this.process=void 0,this.processPid=void 0,this.configuration=void 0}log(t,o){let s;switch(this.configuration?.correlationId?s=`[UtilityProcess id: ${this.configuration?.correlationId}, type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${t}`:s=`[UtilityProcess type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${t}`,o){case w.default.Error:this.logService.error(s);break;case w.default.Warning:this.logService.warn(s);break;case w.default.Info:this.logService.trace(s);break}}validateCanStart(){return this.process?(this.log("Cannot start utility process because it is already running...",w.default.Error),!1):!0}start(t){const o=this.doStart(t);return o&&t.payload&&this.postMessage(t.payload),o}doStart(t){if(!this.validateCanStart())return!1;this.configuration=t;const o=`${this.configuration.type}-${this.id}`,s=f.FileAccess.asFileUri("bootstrap-fork.js").fsPath,i=this.configuration.args??[],n=this.configuration.execArgv??[],c=this.configuration.allowLoadingUnsignedLibraries,S=this.configuration.forceAllocationsToV8Sandbox,R="pipe",k=this.createEnv(t);return this.log("creating new...",w.default.Info),this.process=C.utilityProcess.fork(s,i,{serviceName:o,env:k,execArgv:n,allowLoadingUnsignedLibraries:c,forceAllocationsToV8Sandbox:S,stdio:R}),this.registerListeners(this.process,this.configuration,o),!0}createEnv(t){const o=t.env?{...t.env}:{...(0,y.deepClone)(process.env)};o.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,v.isWindows&&((0,m.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,m.getUNCHostAllowlist)().join("\\")),(0,u.removeDangerousEnvVariables)(o);for(const s of Object.keys(o))o[s]=String(o[s]);return o}registerListeners(t,o,s){if(t.stdout){const i=new M.StringDecoder("utf-8");this._register(r.Event.fromNodeEventEmitter(t.stdout,"data")(n=>this._onStdout.fire(typeof n=="string"?n:i.write(n))))}if(t.stderr){const i=new M.StringDecoder("utf-8");this._register(r.Event.fromNodeEventEmitter(t.stderr,"data")(n=>this._onStderr.fire(typeof n=="string"?n:i.write(n))))}this._register(r.Event.fromNodeEventEmitter(t,"message")(i=>this._onMessage.fire(i))),this._register(r.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.processPid=t.pid,typeof t.pid=="number"&&g.all.set(t.pid,{pid:t.pid,name:h(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.log("successfully created",w.default.Info),this._onSpawn.fire(t.pid)})),this._register(r.Event.fromNodeEventEmitter(t,"exit")(i=>{this.log(`received exit event with code ${i}`,w.default.Info),this._onExit.fire({pid:this.processPid,code:i,signal:"unknown"}),this.onDidExitOrCrashOrKill()})),this._register(r.Event.fromNodeEventEmitter(C.app,"child-process-gone",(i,n)=>({event:i,details:n}))(({details:i})=>{i.type==="Utility"&&i.name===s&&(this.log(`crashed with code ${i.exitCode} and reason '${i.reason}'`,w.default.Error),this.telemetryService.publicLog2("utilityprocesscrash",{type:o.type,reason:i.reason,code:i.exitCode}),this._onCrash.fire({pid:this.processPid,code:i.exitCode,reason:i.reason}),this.onDidExitOrCrashOrKill())}))}once(t,o){const s=this._register(this._onMessage.event(i=>{i===t&&(s.dispose(),o())}))}postMessage(t,o){this.process&&this.process.postMessage(t,o)}connect(t){const{port1:o,port2:s}=new C.MessageChannelMain;return this.postMessage(t,[s]),o}enableInspectPort(){if(!this.process||typeof this.processPid!="number")return!1;this.log("enabling inspect port",w.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.processPid),!0):!1}kill(){if(!this.process)return;this.log("attempting to kill the process...",w.default.Info),this.process.kill()?(this.log("successfully killed the process",w.default.Info),this.onDidExitOrCrashOrKill()):this.log("unable to kill the process",w.default.Warning)}onDidExitOrCrashOrKill(){typeof this.processPid=="number"&&g.all.delete(this.processPid),this.process=void 0}async waitForExit(t){this.process&&(this.log("waiting to exit...",w.default.Info),await Promise.race([r.Event.toPromise(this.onExit),(0,I.timeout)(t)]),this.process&&(this.log(`did not exit within ${t}ms, will kill it now...`,w.default.Info),this.kill()))}};e.UtilityProcess=d,e.UtilityProcess=d=g=be([ne(0,O.ILogService),ne(1,b.ITelemetryService),ne(2,E.ILifecycleMainService)],d);let p=class extends d{constructor(t,o,s,i){super(t,s,i),this.windowsMainService=o}start(t){const o=this.windowsMainService.getWindowById(t.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.log("Refusing to start utility process because requesting window cannot be found or is destroyed...",w.default.Error),!0;if(!super.doStart(t))return!1;this.registerWindowListeners(o.win,t);const i=this.connect(t.payload);return o.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}registerWindowListeners(t,o){o.windowLifecycleBound&&(this._register(r.Event.filter(this.lifecycleMainService.onWillLoadWindow,s=>s.window.win===t)(()=>this.kill())),this._register(r.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.WindowUtilityProcess=p,e.WindowUtilityProcess=p=be([ne(0,O.ILogService),ne(1,l.IWindowsMainService),ne(2,b.ITelemetryService),ne(3,E.ILifecycleMainService)],p)}),define(oe[293],ae([0,1,14,3,5,20,8,61,29,28]),function(Q,e,C,L,r,O,M,I,f,l){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let b=class{static{w=this}static{this._lastId=0}constructor(u,y,v,m){this._logService=u,this._lifecycleMainService=y,this._windowsMainService=v,this._telemetryService=m,this._extHosts=new Map,this._shutdown=!1,this._lifecycleMainService.onWillShutdown(g=>{this._shutdown=!0,g.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}_getExtHost(u){const y=this._extHosts.get(u);if(!y)throw new Error("Unknown extension host!");return y}onDynamicStdout(u){return this._getExtHost(u).onStdout}onDynamicStderr(u){return this._getExtHost(u).onStderr}onDynamicMessage(u){return this._getExtHost(u).onMessage}onDynamicExit(u){return this._getExtHost(u).onExit}async createExtensionHost(){if(this._shutdown)throw(0,C.canceled)();const u=String(++w._lastId),y=new I.WindowUtilityProcess(this._logService,this._windowsMainService,this._telemetryService,this._lifecycleMainService);return this._extHosts.set(u,y),y.onExit(({pid:v,code:m,signal:g})=>{this._logService.info(`Extension host with pid ${v} exited with code: ${m}, signal: ${g}.`),setTimeout(()=>{y.dispose(),this._extHosts.delete(u)}),setTimeout(()=>{try{process.kill(v,0),this._logService.error(`Extension host with pid ${v} still exists, forcefully killing it...`),process.kill(v)}catch{}},1e3)}),{id:u}}async start(u,y){if(this._shutdown)throw(0,C.canceled)();const v=this._getExtHost(u);return v.start({...y,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:y.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:u}),{pid:await L.Event.toPromise(v.onSpawn)}}async enableInspectPort(u){if(this._shutdown)throw(0,C.canceled)();const y=this._extHosts.get(u);return y?y.enableInspectPort():!1}async kill(u){if(this._shutdown)throw(0,C.canceled)();const y=this._extHosts.get(u);y&&y.kill()}async _killAllNow(){for(const[,u]of this._extHosts)u.kill()}async _waitForAllExit(u){const y=[];for(const[,v]of this._extHosts)y.push(v.waitForExit(u));return M.Promises.settled(y).then(()=>{})}};e.ExtensionHostStarter=b,e.ExtensionHostStarter=b=w=be([ne(0,r.ILogService),ne(1,O.ILifecycleMainService),ne(2,f.IWindowsMainService),ne(3,l.ITelemetryService)],b)}),define(oe[294],ae([0,1,37,8,2,24,20,5,41,39,69,61,54,90,12,247]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let m=class extends r.Disposable{constructor(h,d,p,a,t,o,s,i){super(),this.machineId=h,this.sqmId=d,this.environmentMainService=p,this.userDataProfilesService=a,this.lifecycleMainService=t,this.logService=o,this.loggerMainService=s,this.policyService=i,this.firstWindowConnectionBarrier=new L.Barrier,this.utilityProcess=void 0,this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){C.validatedIpcMain.on(v.SharedProcessChannelConnection.request,(h,d)=>this.onWindowConnection(h,d,v.SharedProcessChannelConnection.response)),C.validatedIpcMain.on(v.SharedProcessRawConnection.request,(h,d)=>this.onWindowConnection(h,d,v.SharedProcessRawConnection.response)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(h,d,p){this.logService.trace(`[SharedProcess] onWindowConnection for: ${p}`),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const a=await this.connect(p);if(h.sender.isDestroyed())return a.close();h.sender.postMessage(p,d,[a])}onWillShutdown(){this.logService.trace("[SharedProcess] onWillShutdown"),this.utilityProcess?.postMessage(v.SharedProcessLifecycle.exit),this.utilityProcess=void 0}whenReady(){return this._whenReady||(this._whenReady=(async()=>{await this.whenIpcReady;const h=new L.DeferredPromise;this.utilityProcess?this.utilityProcess.once(v.SharedProcessLifecycle.initDone,()=>h.complete()):C.validatedIpcMain.once(v.SharedProcessLifecycle.initDone,()=>h.complete()),await h.p,this.logService.trace("[SharedProcess] Overall ready")})()),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createUtilityProcess();const h=new L.DeferredPromise;this.utilityProcess?this.utilityProcess.once(v.SharedProcessLifecycle.ipcReady,()=>h.complete()):C.validatedIpcMain.once(v.SharedProcessLifecycle.ipcReady,()=>h.complete()),await h.p,this.logService.trace("[SharedProcess] IPC ready")})()),this._whenIpcReady}createUtilityProcess(){this.utilityProcess=this._register(new b.UtilityProcess(this.logService,E.NullTelemetryService,this.lifecycleMainService));const h=(0,u.parseSharedProcessDebugPort)(this.environmentMainService.args,this.environmentMainService.isBuilt);let d;h.port&&(d=["--nolazy"],h.break?d.push(`--inspect-brk=${h.port}`):d.push(`--inspect=${h.port}`)),this.utilityProcess.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.createSharedProcessConfiguration(),execArgv:d})}createSharedProcessConfiguration(){return{machineId:this.machineId,sqmId:this.sqmId,codeCachePath:this.environmentMainService.codeCachePath,profiles:{home:this.userDataProfilesService.profilesHome,all:this.userDataProfilesService.profiles},args:this.environmentMainService.args,logLevel:this.loggerMainService.getLogLevel(),loggers:this.loggerMainService.getRegisteredLoggers(),policiesData:this.policyService.serialize()}}async connect(h){return await this.whenIpcReady,(0,y.assertIsDefined)(this.utilityProcess).connect(h)}};e.SharedProcess=m,e.SharedProcess=m=be([ne(2,O.IEnvironmentMainService),ne(3,f.IUserDataProfilesService),ne(4,M.ILifecycleMainService),ne(5,I.ILogService),ne(6,w.ILoggerMainService),ne(7,l.IPolicyService)],m)}),define(oe[295],ae([0,1,24,90,20,5,54,61,111,37,2,3,35,18,13]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronPtyHostStarter=void 0;let v=class extends w.Disposable{constructor(g,h,d,p,a){super(),this._reconnectConstants=g,this._configurationService=h,this._environmentMainService=d,this._lifecycleMainService=p,this._logService=a,this.utilityProcess=void 0,this._onRequestConnection=new b.Emitter,this.onRequestConnection=this._onRequestConnection.event,this._onWillShutdown=new b.Emitter,this.onWillShutdown=this._onWillShutdown.event,this._lifecycleMainService.onWillShutdown(()=>this._onWillShutdown.fire()),l.validatedIpcMain.on("vscode:createPtyHostMessageChannel",(t,o)=>this._onWindowConnection(t,o)),this._register((0,w.toDisposable)(()=>{l.validatedIpcMain.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.utilityProcess=new I.UtilityProcess(this._logService,M.NullTelemetryService,this._lifecycleMainService);const g=(0,L.parsePtyHostDebugPort)(this._environmentMainService.args,this._environmentMainService.isBuilt),h=g.port?["--nolazy",`--inspect${g.break?"-brk":""}=${g.port}`]:void 0;this.utilityProcess.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:h,args:["--logsPath",this._environmentMainService.logsHome.with({scheme:y.Schemas.file}).fsPath],env:this._createPtyHostConfiguration()});const d=this.utilityProcess.connect(),p=new f.Client(d,"ptyHost"),a=new w.DisposableStore;return a.add(p),a.add((0,w.toDisposable)(()=>{this.utilityProcess?.kill(),this.utilityProcess?.dispose(),this.utilityProcess=void 0})),{client:p,store:a,onDidProcessExit:this.utilityProcess.onExit}}_createPtyHostConfiguration(){this._environmentMainService.unsetSnapExportedVariables();const g={...(0,E.deepClone)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this._reconnectConstants.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this._reconnectConstants.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this._reconnectConstants.scrollback)},h=this._configurationService.getValue("terminal.integrated.developer.ptyHost.latency");h&&typeof h=="number"&&(g.VSCODE_LATENCY=String(h));const d=this._configurationService.getValue("terminal.integrated.developer.ptyHost.startupDelay");return d&&typeof d=="number"&&(g.VSCODE_STARTUP_DELAY=String(d)),this._environmentMainService.restoreSnapExportedVariables(),g}_onWindowConnection(g,h){this._onRequestConnection.fire();const d=this.utilityProcess.connect();if(g.sender.isDestroyed()){d.close();return}g.sender.postMessage("vscode:createPtyHostMessageChannelResult",h,[d])}};e.ElectronPtyHostStarter=v,e.ElectronPtyHostStarter=v=be([ne(1,u.IConfigurationService),ne(2,C.IEnvironmentMainService),ne(3,r.ILifecycleMainService),ne(4,O.ILogService)],v)}),define(oe[296],ae([0,1,2,6,5,29,61,28,45,3,8,20]),function(Q,e,C,L,r,O,M,I,f,l,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,L.createDecorator)("utilityProcessWorker");let E=class extends C.Disposable{constructor(v,m,g,h){super(),this.logService=v,this.windowsMainService=m,this.telemetryService=g,this.lifecycleMainService=h,this.workers=new Map}async createWorker(v){const m=`window: ${v.reply.windowId}, moduleId: ${v.process.moduleId}`;this.logService.trace(`[UtilityProcessWorker]: createWorker(${m})`);const g=this.hash(v);this.workers.has(g)&&(this.logService.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${m})`),this.disposeWorker(v));const h=new u(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService,v);if(!h.spawn())return{reason:{code:1,signal:"EINVALID"}};this.workers.set(g,h);const d=new w.DeferredPromise;return l.Event.once(h.onDidTerminate)(p=>{p.code===0?this.logService.trace(`[UtilityProcessWorker]: terminated normally with code ${p.code}, signal: ${p.signal}`):this.logService.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${p.code}, signal: ${p.signal}`),this.workers.delete(g),d.complete({reason:p})}),d.p}hash(v){return(0,f.hash)({moduleId:v.process.moduleId,windowId:v.reply.windowId})}async disposeWorker(v){const m=this.hash(v),g=this.workers.get(m);g&&(this.logService.trace(`[UtilityProcessWorker]: disposeWorker(window: ${v.reply.windowId}, moduleId: ${v.process.moduleId})`),g.kill(),this.workers.delete(m))}};e.UtilityProcessWorkerMainService=E,e.UtilityProcessWorkerMainService=E=be([ne(0,r.ILogService),ne(1,O.IWindowsMainService),ne(2,I.ITelemetryService),ne(3,b.ILifecycleMainService)],E);let u=class extends C.Disposable{constructor(v,m,g,h,d){super(),this.logService=v,this.windowsMainService=m,this.telemetryService=g,this.lifecycleMainService=h,this.configuration=d,this._onDidTerminate=this._register(new l.Emitter),this.onDidTerminate=this._onDidTerminate.event,this.utilityProcess=new M.WindowUtilityProcess(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService),this.registerListeners()}registerListeners(){this._register(this.utilityProcess.onExit(v=>this._onDidTerminate.fire({code:v.code,signal:v.signal}))),this._register(this.utilityProcess.onCrash(v=>this._onDidTerminate.fire({code:v.code,signal:"ECRASH"})))}spawn(){const m=this.windowsMainService.getWindowById(this.configuration.reply.windowId)?.win?.webContents.getOSProcessId();return this.utilityProcess.start({type:this.configuration.process.type,entryPoint:this.configuration.process.moduleId,parentLifecycleBound:m,windowLifecycleBound:!0,correlationId:`${this.configuration.reply.windowId}`,responseWindowId:this.configuration.reply.windowId,responseChannel:this.configuration.reply.channel,responseNonce:this.configuration.reply.nonce})}kill(){this.utilityProcess.kill()}};u=be([ne(0,r.ILogService),ne(1,O.IWindowsMainService),ne(2,I.ITelemetryService),ne(3,b.ILifecycleMainService)],u)}),define(oe[297],ae([0,1,15,3,2,273,29]),function(Q,e,C,L,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let I=class extends r.Disposable{constructor(l){super(),this.windowsMainService=l,this._onFoundInFrame=this._register(new L.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new O.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(l,w){let b;if(typeof l.windowId=="number"){const{windowId:E}=l,u=this.windowsMainService.getWindowById(E);if(!u?.win)throw new Error(`Invalid windowId: ${E}`);b=u.win.webContents}else{const{webContentsId:E}=l;if(b=C.webContents.fromId(E),!b)throw new Error(`Invalid webContentsId: ${E}`)}b.isDestroyed()||b.setIgnoreMenuShortcuts(w)}async findInFrame(l,w,b,E){const y=this.getFrameByName(l,w);if(typeof y.findInFrame=="function"){y.findInFrame(b,{findNext:E.findNext,forward:E.forward});const v=(m,g)=>{g.finalUpdate&&(this._onFoundInFrame.fire(g),y.removeListener("found-in-frame",v))};y.on("found-in-frame",v)}}async stopFindInFrame(l,w,b){const u=this.getFrameByName(l,w);typeof u.stopFindInFrame=="function"&&u.stopFindInFrame(b.keepSelection?"keepSelection":"clearSelection")}getFrameByName(l,w){const b=this.windowsMainService.getWindowById(l.windowId);if(!b?.win)throw new Error(`Invalid windowId: ${l}`);const E=b.win.webContents.mainFrame.framesInSubtree.find(u=>u.name===w);if(!E)throw new Error(`Unknown frame: ${w}`);return E}};e.WebviewMainService=I,e.WebviewMainService=I=be([ne(0,M.IWindowsMainService)],I)}),define(oe[298],ae([0,1,15,2,4,19,7,18,20,5,34,29,129,30]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let v=class extends L.Disposable{static{y=this}static{this.windowsStateStorageKey="windowsState"}get state(){return this._state}constructor(a,t,o,s,i){super(),this.windowsMainService=a,this.stateService=t,this.lifecycleMainService=o,this.logService=s,this.configurationService=i,this._state=m(this.stateService.getItem(y.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){C.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(a=>this.onBeforeCloseWindow(a)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(a=>{a.newCount-a.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(a=>this.onBeforeCloseWindow(a))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const a=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!t.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.toWindowState(i),t.lastActiveWindow.uiState.mode===3&&a.add(t.lastActiveWindow.uiState.display))}const o=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);o&&(t.lastPluginDevelopmentHostWindow=this.toWindowState(o),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(a.has(t.lastPluginDevelopmentHostWindow.uiState.display)?r.isMacintosh&&!o.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):a.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(t.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.toWindowState(i);return n.uiState.mode===3&&(a.has(n.uiState.display)?r.isMacintosh&&n.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):a.add(n.uiState.display)),n}));const s=h(t);this.stateService.setItem(y.windowsStateStorageKey,s),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",s)}onBeforeCloseWindow(a){if(this.lifecycleMainService.quitRequested)return;const t=this.toWindowState(a);a.isExtensionDevelopmentHost&&!a.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=t:!a.isExtensionDevelopmentHost&&a.openedWorkspace&&this._state.openedWindows.forEach(o=>{const s=(0,u.isWorkspaceIdentifier)(a.openedWorkspace)&&o.workspace?.id===a.openedWorkspace.id,i=(0,u.isSingleFolderWorkspaceIdentifier)(a.openedWorkspace)&&o.folderUri&&O.extUriBiasedIgnorePathCase.isEqual(o.folderUri,a.openedWorkspace.uri);(s||i)&&(o.uiState=t.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=t)}toWindowState(a){return{windowId:a.id,workspace:(0,u.isWorkspaceIdentifier)(a.openedWorkspace)?a.openedWorkspace:void 0,folderUri:(0,u.isSingleFolderWorkspaceIdentifier)(a.openedWorkspace)?a.openedWorkspace.uri:void 0,backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.serializeWindowState()}}getNewWindowState(a){const t=this.doGetNewWindowState(a),o=this.configurationService.getValue("window");if(t.mode===3){let s;t.hasDefaultState?s=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):s=!!(this.lifecycleMainService.wasRestarted||o?.restoreFullscreen),s||(t.mode=1)}return t}doGetNewWindowState(a){const t=this.windowsMainService.getLastActiveWindow();if(!a.extensionTestsPath){if(a.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const S=a.workspace;if((0,u.isWorkspaceIdentifier)(S)){const k=this.state.openedWindows.filter(P=>P.workspace&&P.workspace.id===S.id).map(P=>P.uiState);if(k.length)return k[0]}if((0,u.isSingleFolderWorkspaceIdentifier)(S)){const k=this.state.openedWindows.filter(P=>P.folderUri&&O.extUriBiasedIgnorePathCase.isEqual(P.folderUri,S.uri)).map(P=>P.uiState);if(k.length)return k[0]}else if(a.backupPath){const k=this.state.openedWindows.filter(P=>P.backupPath===a.backupPath).map(P=>P.uiState);if(k.length)return k[0]}const R=this.lastClosedState||this.state.lastActiveWindow;if(!t&&R)return R.uiState}let o;const s=C.screen.getAllDisplays();if(s.length===1)o=s[0];else{if(r.isMacintosh){const S=C.screen.getCursorScreenPoint();o=C.screen.getDisplayNearestPoint(S)}!o&&t&&(o=C.screen.getDisplayMatching(t.getBounds())),o||(o=C.screen.getPrimaryDisplay()||s[0])}let i=(0,E.defaultWindowState)();i.x=Math.round(o.bounds.x+o.bounds.width/2-i.width/2),i.y=Math.round(o.bounds.y+o.bounds.height/2-i.height/2);const n=this.configurationService.getValue("window");let c=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,c=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,c=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&t){const S=t.serializeWindowState();S.mode===3?i.mode=3:i={...S,zoomLevel:void 0},c=i.mode!==3&&n.newWindowDimensions==="offset"}}return c&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(a){if(this.windowsMainService.getWindows().length===0)return a;a.x=typeof a.x=="number"?a.x:0,a.y=typeof a.y=="number"?a.y:0;const t=this.windowsMainService.getWindows().map(o=>o.getBounds());for(;t.some(o=>o.x===a.x||o.y===a.y);)a.x+=30,a.y+=30;return a}};e.WindowsStateHandler=v,e.WindowsStateHandler=v=y=be([ne(0,b.IWindowsMainService),ne(1,w.IStateService),ne(2,f.ILifecycleMainService),ne(3,l.ILogService),ne(4,I.IConfigurationService)],v);function m(p){const a={openedWindows:[]},t=p||{openedWindows:[]};return t.lastActiveWindow&&(a.lastActiveWindow=g(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(a.lastPluginDevelopmentHostWindow=g(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(a.openedWindows=t.openedWindows.map(o=>g(o))),a}e.restoreWindowsState=m;function g(p){const a={uiState:p.uiState};return p.backupPath&&(a.backupPath=p.backupPath),p.remoteAuthority&&(a.remoteAuthority=p.remoteAuthority),p.folder&&(a.folderUri=M.URI.parse(p.folder)),p.workspaceIdentifier&&(a.workspace={id:p.workspaceIdentifier.id,configPath:M.URI.parse(p.workspaceIdentifier.configURIPath)}),a}function h(p){return{lastActiveWindow:p.lastActiveWindow&&d(p.lastActiveWindow),lastPluginDevelopmentHostWindow:p.lastPluginDevelopmentHostWindow&&d(p.lastPluginDevelopmentHostWindow),openedWindows:p.openedWindows.map(a=>d(a))}}e.getWindowsStateStoreData=h;function d(p){return{workspaceIdentifier:p.workspace&&{id:p.workspace.id,configURIPath:p.workspace.configPath.toString()},folder:p.folderUri&&p.folderUri.toString(),backupPath:p.backupPath,remoteAuthority:p.remoteAuthority,uiState:p.uiState}}}),define(oe[57],ae([0,1,15,3,42,2,13,9,19,21,194,66,55,24,6,5,56,131,30,97,98]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y,v,m,g,h,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,y.createDecorator)("workspacesManagementMainService");let a=class extends O.Disposable{constructor(o,s,i,n,c){super(),this.environmentMainService=o,this.logService=s,this.userDataProfilesMainService=i,this.backupMainService=n,this.dialogMainService=c,this._onDidDeleteUntitledWorkspace=this._register(new L.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new L.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const o=(await l.Promises.readdir(this.untitledWorkspacesHome.with({scheme:M.Schemas.file}).fsPath)).map(s=>(0,f.joinPath)(this.untitledWorkspacesHome,s,h.UNTITLED_WORKSPACE_NAME));for(const s of o){const i=(0,p.getWorkspaceIdentifier)(s),n=await this.resolveLocalWorkspace(s);n?this.untitledWorkspaces.push({workspace:i,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(o){o.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${o}).`)}}resolveLocalWorkspace(o){return this.doResolveLocalWorkspace(o,s=>l.Promises.readFile(s,"utf8"))}doResolveLocalWorkspace(o,s){if(this.isWorkspacePath(o)&&o.scheme===M.Schemas.file)try{const i=s(o.fsPath);return i instanceof Promise?i.then(n=>this.doResolveWorkspace(o,n),n=>{}):this.doResolveWorkspace(o,i)}catch{return}}isWorkspacePath(o){return(0,h.isUntitledWorkspace)(o,this.environmentMainService)||(0,h.hasWorkspaceFileExtension)(o)}doResolveWorkspace(o,s){try{const i=this.doParseStoredWorkspace(o,s),n=(0,p.getWorkspaceIdentifier)(o);return{id:n.id,configPath:n.configPath,folders:(0,d.toWorkspaceFolders)(i.folders,n.configPath,f.extUriBiasedIgnorePathCase),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.logService.warn(i.toString())}}doParseStoredWorkspace(o,s){const i=(0,r.parse)(s);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(n=>(0,d.isStoredWorkspaceFolder)(n));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(o,s){const{workspace:i,storedWorkspace:n}=this.newUntitledWorkspace(o,s),c=i.configPath.fsPath;return await l.Promises.mkdir((0,I.dirname)(c),{recursive:!0}),await l.Promises.writeFile(c,JSON.stringify(n,null,"	")),this.untitledWorkspaces.push({workspace:i,remoteAuthority:s}),i}newUntitledWorkspace(o=[],s){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,f.joinPath)(this.untitledWorkspacesHome,i),c=(0,f.joinPath)(n,h.UNTITLED_WORKSPACE_NAME),S=[];for(const R of o)S.push((0,d.getStoredWorkspaceFolder)(R.uri,!0,R.name,n,f.extUriBiasedIgnorePathCase));return{workspace:(0,p.getWorkspaceIdentifier)(c),storedWorkspace:{folders:S,remoteAuthority:s}}}async getWorkspaceIdentifier(o){return(0,p.getWorkspaceIdentifier)(o)}isUntitledWorkspace(o){return(0,h.isUntitledWorkspace)(o.configPath,this.environmentMainService)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.doDeleteUntitledWorkspace(o),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(o),this._onDidDeleteUntitledWorkspace.fire(o))}async doDeleteUntitledWorkspace(o){const s=(0,f.originalFSPath)(o.configPath);try{await l.Promises.rm((0,I.dirname)(s));const i=(0,I.join)(this.environmentMainService.workspaceStorageHome.with({scheme:M.Schemas.file}).fsPath,o.id);await l.Promises.exists(i)&&await l.Promises.writeFile((0,I.join)(i,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(n=>n.workspace.id!==o.id)}catch(i){this.logService.warn(`Unable to delete untitled workspace ${s} (${i}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(o,s,i){if(!o||!o.win||!o.isReady||!await this.isValidTargetWorkspacePath(o,s,i))return;const c=await this.doEnterWorkspace(o,(0,p.getWorkspaceIdentifier)(i));if(c)return this._onDidEnterWorkspace.fire({window:o,workspace:c.workspace}),c}async isValidTargetWorkspacePath(o,s,i){return i?(0,h.isWorkspaceIdentifier)(o.openedWorkspace)&&f.extUriBiasedIgnorePathCase.isEqual(o.openedWorkspace.configPath,i)?!1:(0,g.findWindowOnWorkspaceOrFolder)(s,i)?(await this.dialogMainService.showMessageBox({type:"info",buttons:[(0,w.localize)(0,null)],message:(0,w.localize)(1,null,(0,f.basename)(i)),detail:(0,w.localize)(2,null)},C.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async doEnterWorkspace(o,s){if(!o.config)return;o.focus();let i;return o.config.extensionDevelopmentPath||(o.config.backupPath?i=await this.backupMainService.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority},o.config.backupPath):i=this.backupMainService.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority})),(0,h.isWorkspaceIdentifier)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=s,o.config.backupPath=i,{workspace:s,backupPath:i}}};e.WorkspacesManagementMainService=a,e.WorkspacesManagementMainService=a=be([ne(0,u.IEnvironmentMainService),ne(1,v.ILogService),ne(2,m.IUserDataProfilesMainService),ne(3,b.IBackupMainService),ne(4,E.IDialogMainService)],a)}),define(oe[133],ae([0,1,15,37,23,6,29,30,57,12,5,61]),function(Q,e,C,L,r,O,M,I,f,l,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,O.createDecorator)(e.ID);let E=class{constructor(y,v,m){this.windowsMainService=y,this.workspacesManagementMainService=v,this.logService=m}async getRemoteDiagnostics(y){const v=this.windowsMainService.getWindows();return(await Promise.all(v.map(async g=>{const h=g.remoteAuthority;if(!h)return;const d=`vscode:getDiagnosticInfoResponse${g.id}`,p={includeProcesses:y.includeProcesses,folders:y.includeWorkspaceMetadata?await this.getFolderURIs(g):void 0};return new Promise(a=>{g.sendWhenReady("vscode:getDiagnosticInfo",r.CancellationToken.None,{replyChannel:d,args:p}),L.validatedIpcMain.once(d,(t,o)=>{o||a({hostName:h,errorMessage:`Unable to resolve connection to '${h}'.`}),a(o)}),setTimeout(()=>{a({hostName:h,errorMessage:`Connection to '${h}' could not be established`})},5e3)})}))).filter(g=>!!g)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const y=[];for(const m of C.BrowserWindow.getAllWindows()){const g=this.windowsMainService.getWindowById(m.id);g?y.push(await this.codeWindowToInfo(g)):y.push(this.browserWindowToInfo(m))}const v=[];for(const{pid:m,name:g}of b.UtilityProcess.getAll())v.push({pid:m,name:g});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:y,pidToNames:v,screenReader:!!C.app.accessibilitySupportEnabled,gpuFeatureStatus:C.app.getGPUFeatureStatus()}}async codeWindowToInfo(y){const v=await this.getFolderURIs(y),m=(0,l.assertIsDefined)(y.win);return this.browserWindowToInfo(m,v,y.remoteAuthority)}browserWindowToInfo(y,v=[],m){return{id:y.id,pid:y.webContents.getOSProcessId(),title:y.getTitle(),folderURIs:v,remoteAuthority:m}}async getFolderURIs(y){const v=[],m=y.openedWorkspace;if((0,I.isSingleFolderWorkspaceIdentifier)(m))v.push(m.uri);else if((0,I.isWorkspaceIdentifier)(m)){const g=await this.workspacesManagementMainService.resolveLocalWorkspace(m.configPath);g&&g.folders.forEach(d=>{v.push(d.uri)})}return v}};e.DiagnosticsMainService=E,e.DiagnosticsMainService=E=be([ne(0,M.IWindowsMainService),ne(1,f.IWorkspacesManagementMainService),ne(2,w.ILogService)],E)}),define(oe[71],ae([0,1,48,15,26,156,50,3,2,13,9,4,7,106,88,21,104,182,55,24,6,20,5,27,70,29,30,57,17,243,235,65,14]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y,v,m,g,h,d,p,a,t,o,s,i,n,c,S,R,k,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,p.createDecorator)("nativeHostMainService");let _=class extends f.Disposable{constructor(U,j,V,ce,se,ue,X,Y,x,W){super(),this.windowsMainService=U,this.auxiliaryWindowsMainService=j,this.dialogMainService=V,this.lifecycleMainService=ce,this.environmentMainService=se,this.logService=ue,this.productService=X,this.themeMainService=Y,this.workspacesManagementMainService=x,this.instantiationService=W,this.onDidOpenMainWindow=I.Event.map(this.windowsMainService.onDidOpenWindow,F=>F.id),this.onDidTriggerWindowSystemContextMenu=I.Event.any(I.Event.filter(I.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:F,x:H,y:q})=>({windowId:F.id,x:H,y:q})),({windowId:F})=>!!this.windowsMainService.getWindowById(F)),I.Event.filter(I.Event.map(this.auxiliaryWindowsMainService.onDidTriggerSystemContextMenu,({window:F,x:H,y:q})=>({windowId:F.id,x:H,y:q})),({windowId:F})=>!!this.auxiliaryWindowsMainService.getWindowById(F))),this.onDidMaximizeWindow=I.Event.any(I.Event.filter(I.Event.map(this.windowsMainService.onDidMaximizeWindow,F=>F.id),F=>!!this.windowsMainService.getWindowById(F)),I.Event.filter(I.Event.map(this.auxiliaryWindowsMainService.onDidMaximizeWindow,F=>F.id),F=>!!this.auxiliaryWindowsMainService.getWindowById(F))),this.onDidUnmaximizeWindow=I.Event.any(I.Event.filter(I.Event.map(this.windowsMainService.onDidUnmaximizeWindow,F=>F.id),F=>!!this.windowsMainService.getWindowById(F)),I.Event.filter(I.Event.map(this.auxiliaryWindowsMainService.onDidUnmaximizeWindow,F=>F.id),F=>!!this.auxiliaryWindowsMainService.getWindowById(F))),this.onDidChangeWindowFullScreen=I.Event.any(I.Event.map(this.windowsMainService.onDidChangeFullScreen,F=>({windowId:F.window.id,fullscreen:F.fullscreen})),I.Event.map(this.auxiliaryWindowsMainService.onDidChangeFullScreen,F=>({windowId:F.window.id,fullscreen:F.fullscreen}))),this.onDidBlurMainWindow=I.Event.filter(I.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(F,H)=>H.id),F=>!!this.windowsMainService.getWindowById(F)),this.onDidFocusMainWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),F=>!!F),F=>F.id),I.Event.filter(I.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(F,H)=>H.id),F=>!!this.windowsMainService.getWindowById(F))),this.onDidBlurMainOrAuxiliaryWindow=I.Event.any(this.onDidBlurMainWindow,I.Event.map(I.Event.filter(I.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(F,H)=>H),F=>(0,P.isAuxiliaryWindow)(F.webContents)),F=>F.id)),this.onDidFocusMainOrAuxiliaryWindow=I.Event.any(this.onDidFocusMainWindow,I.Event.map(I.Event.filter(I.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(F,H)=>H),F=>(0,P.isAuxiliaryWindow)(F.webContents)),F=>F.id)),this.onDidResumeOS=I.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new I.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(F,H,q)=>q),F=>!(Array.isArray(F)&&F.length===1&&F[0]==="workArea")),I.Event.fromNodeEventEmitter(L.screen,"display-added"),I.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(U,j){const V=this.windowsMainService.getWindows().map(se=>({id:se.id,workspace:se.openedWorkspace??(0,n.toWorkspaceIdentifier)(se.backupPath,se.isExtensionDevelopmentHost),title:se.win?.getTitle()??"",filename:se.getRepresentedFilename(),dirty:se.isDocumentEdited()})),ce=[];return j.includeAuxiliaryWindows&&ce.push(...this.auxiliaryWindowsMainService.getWindows().map(se=>({id:se.id,parentId:se.parentId,title:se.win?.getTitle()??"",filename:se.getRepresentedFilename()}))),[...V,...ce]}async getWindowCount(U){return this.windowsMainService.getWindowCount()}async getActiveWindowId(U){const j=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(j)return j.id}openWindow(U,j,V){return Array.isArray(j)?this.doOpenWindow(U,j,V):this.doOpenEmptyWindow(U,j)}async doOpenWindow(U,j,V=Object.create(null)){j.length>0&&await this.windowsMainService.open({context:5,contextWindowId:U,urisToOpen:j,cli:this.environmentMainService.args,forceNewWindow:V.forceNewWindow,forceReuseWindow:V.forceReuseWindow,preferNewWindow:V.preferNewWindow,diffMode:V.diffMode,mergeMode:V.mergeMode,addMode:V.addMode,gotoLineMode:V.gotoLineMode,noRecentEntry:V.noRecentEntry,waitMarkerFileURI:V.waitMarkerFileURI,remoteAuthority:V.remoteAuthority||void 0,forceProfile:V.forceProfile,forceTempProfile:V.forceTempProfile})}async doOpenEmptyWindow(U,j){await this.windowsMainService.openEmptyWindow({context:5,contextWindowId:U},j)}async toggleFullScreen(U,j){this.windowById(j?.targetWindowId,U)?.toggleFullScreen()}async handleTitleDoubleClick(U,j){this.windowById(j?.targetWindowId,U)?.handleTitleDoubleClick()}async getCursorScreenPoint(U){const j=L.screen.getCursorScreenPoint(),V=L.screen.getDisplayNearestPoint(j);return{point:j,display:V.bounds}}async isMaximized(U,j){return this.windowById(j?.targetWindowId,U)?.win?.isMaximized()??!1}async maximizeWindow(U,j){this.windowById(j?.targetWindowId,U)?.win?.maximize()}async unmaximizeWindow(U,j){this.windowById(j?.targetWindowId,U)?.win?.unmaximize()}async minimizeWindow(U,j){this.windowById(j?.targetWindowId,U)?.win?.minimize()}async moveWindowTop(U,j){this.windowById(j?.targetWindowId,U)?.win?.moveTop()}async positionWindow(U,j,V){const ce=this.windowById(V?.targetWindowId,U);if(ce?.win){if(ce.win.isFullScreen()){const se=I.Event.toPromise(I.Event.once(I.Event.fromNodeEventEmitter(ce.win,"leave-full-screen")));ce.win.setFullScreen(!1),await se}ce.win.setBounds(j)}}async updateWindowControls(U,j){this.windowById(j?.targetWindowId,U)?.updateWindowControls(j)}async focusWindow(U,j){this.windowById(j?.targetWindowId,U)?.focus({force:j?.force??!1})}async setMinimumSize(U,j,V){const ce=this.codeWindowById(U);if(ce?.win){const[se,ue]=ce.win.getSize(),[X,Y]=ce.win.getMinimumSize(),[x,W]=[j??X,V??Y],[F,H]=[Math.max(se,x),Math.max(ue,W)];(X!==x||Y!==W)&&ce.win.setMinimumSize(x,W),(se!==F||ue!==H)&&ce.win.setSize(F,H)}}async saveWindowSplash(U,j){this.themeMainService.saveWindowSplash(U,j)}async installShellCommand(U){const{source:j,target:V}=await this.getShellCommandLink();try{const{symbolicLink:ce}=await v.SymlinkSupport.stat(j);if(ce&&!ce.dangling){const se=await(0,u.realpath)(j);if(V===se)return}await v.Promises.unlink(j)}catch(ce){if(ce.code!=="ENOENT")throw ce}try{await v.Promises.symlink(V,j)}catch(ce){if(ce.code!=="EACCES"&&ce.code!=="ENOENT")throw ce;const{response:se}=await this.showMessageBox(U,{type:"info",message:(0,g.localize)(0,null,this.productService.nameShort),buttons:[(0,g.localize)(1,null),(0,g.localize)(2,null)]});if(se===1)throw new D.CancellationError;try{const ue=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${V}' '${j}'\\" with administrator privileges"`;await(0,O.promisify)(C.exec)(ue)}catch{throw new Error((0,g.localize)(3,null,j))}}}async uninstallShellCommand(U){const{source:j}=await this.getShellCommandLink();try{await v.Promises.unlink(j)}catch(V){switch(V.code){case"EACCES":{const{response:ce}=await this.showMessageBox(U,{type:"info",message:(0,g.localize)(4,null,this.productService.nameShort),buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null)]});if(ce===1)throw new D.CancellationError;try{const se=`osascript -e "do shell script \\"rm '${j}'\\" with administrator privileges"`;await(0,O.promisify)(C.exec)(se)}catch{throw new Error((0,g.localize)(7,null,j))}break}case"ENOENT":break;default:throw V}}}async getShellCommandLink(){const U=(0,w.resolve)(this.environmentMainService.appRoot,"bin",this.productService.applicationName),j=`/usr/local/bin/${this.productService.applicationName}`;if(!await v.Promises.exists(U))throw new Error((0,g.localize)(8,null,U));return{source:j,target:U}}async showMessageBox(U,j){const V=this.getTargetWindow(U);return this.dialogMainService.showMessageBox(j,V?.win??void 0)}async showSaveDialog(U,j){const V=this.getTargetWindow(U);return this.dialogMainService.showSaveDialog(j,V?.win??void 0)}async showOpenDialog(U,j){const V=this.getTargetWindow(U);return this.dialogMainService.showOpenDialog(j,V?.win??void 0)}async pickFileFolderAndOpen(U,j){const V=await this.dialogMainService.pickFileFolder(j);V&&await this.doOpenPicked(await Promise.all(V.map(async ce=>await v.SymlinkSupport.existsDirectory(ce)?{folderUri:E.URI.file(ce)}:{fileUri:E.URI.file(ce)})),j,U)}async pickFolderAndOpen(U,j){const V=await this.dialogMainService.pickFolder(j);V&&await this.doOpenPicked(V.map(ce=>({folderUri:E.URI.file(ce)})),j,U)}async pickFileAndOpen(U,j){const V=await this.dialogMainService.pickFile(j);V&&await this.doOpenPicked(V.map(ce=>({fileUri:E.URI.file(ce)})),j,U)}async pickWorkspaceAndOpen(U,j){const V=await this.dialogMainService.pickWorkspace(j);V&&await this.doOpenPicked(V.map(ce=>({workspaceUri:E.URI.file(ce)})),j,U)}async doOpenPicked(U,j,V){await this.windowsMainService.open({context:3,contextWindowId:V,cli:this.environmentMainService.args,urisToOpen:U,forceNewWindow:j.forceNewWindow})}async showItemInFolder(U,j){L.shell.showItemInFolder(j)}async setRepresentedFilename(U,j,V){this.windowById(V?.targetWindowId,U)?.setRepresentedFilename(j)}async setDocumentEdited(U,j,V){this.windowById(V?.targetWindowId,U)?.setDocumentEdited(j)}async openExternal(U,j){return this.environmentMainService.unsetSnapExportedVariables(),L.shell.openExternal(j),this.environmentMainService.restoreSnapExportedVariables(),!0}moveItemToTrash(U,j){return L.shell.trashItem(j)}async isAdmin(){let U;return b.isWindows?U=(await new Promise((j,V)=>{Q(["native-is-elevated"],j,V)}))():U=process.getuid?.()===0,U}async writeElevated(U,j,V,ce){const se=await new Promise((ue,X)=>{Q(["@vscode/sudo-prompt"],ue,X)});return new Promise((ue,X)=>{const Y=[`"${this.cliPath}"`];ce?.unlock&&Y.push("--file-chmod"),Y.push("--file-write",`"${j.fsPath}"`,`"${V.fsPath}"`);const x={name:this.productService.nameLong.replace("-",""),icns:b.isMacintosh&&this.environmentMainService.isBuilt?(0,w.join)((0,w.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};se.exec(Y.join(" "),x,(W,F,H)=>{F&&this.logService.trace(`[sudo-prompt] received stdout: ${F}`),H&&this.logService.trace(`[sudo-prompt] received stderr: ${H}`),W?X(W):ue(void 0)})})}async isRunningUnderARM64Translation(){return b.isLinux||b.isWindows?!1:L.app.runningUnderARM64Translation}get cliPath(){return b.isWindows?this.environmentMainService.isBuilt?(0,w.join)((0,w.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,w.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):b.isLinux?this.environmentMainService.isBuilt?(0,w.join)((0,w.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,w.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,w.join)(this.environmentMainService.appRoot,"bin",`${this.productService.applicationName}`):(0,w.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,r.totalmem)(),freemem:(0,r.freemem)(),loadavg:(0,r.loadavg)()}}async getOSProperties(){return{arch:(0,r.arch)(),platform:(0,r.platform)(),release:(0,r.release)(),type:(0,r.type)(),cpus:(0,r.cpus)()}}async getOSVirtualMachineHint(){return y.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return b.isWindows&&(0,R.hasWSLFeatureInstalled)()}async killProcess(U,j,V){process.kill(j,V)}async readClipboardText(U,j){return L.clipboard.readText(j)}async writeClipboardText(U,j,V){return L.clipboard.writeText(j,V)}async readClipboardFindText(U){return L.clipboard.readFindText()}async writeClipboardFindText(U,j){return L.clipboard.writeFindText(j)}async writeClipboardBuffer(U,j,V,ce){return L.clipboard.writeBuffer(j,Buffer.from(V.buffer),ce)}async readClipboardBuffer(U,j){return S.VSBuffer.wrap(L.clipboard.readBuffer(j))}async hasClipboard(U,j,V){return L.clipboard.has(j,V)}async newWindowTab(){await this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(U,j){this.codeWindowById(U)?.updateTouchBar(j)}async notifyReady(U){this.codeWindowById(U)?.setReady()}async relaunch(U,j){return this.lifecycleMainService.relaunch(j)}async reload(U,j){const V=this.codeWindowById(U);if(V){if((0,n.isWorkspaceIdentifier)(V.openedWorkspace)){const ce=V.openedWorkspace.configPath;if(ce.scheme===l.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(ce))?.transient)return this.openWindow(V.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(V,j?.disableExtensions!==void 0?{_:[],"disable-extensions":j.disableExtensions}:void 0)}}async closeWindow(U,j){return this.windowById(j?.targetWindowId,U)?.win?.close()}async quit(U){const j=this.windowsMainService.getLastActiveWindow();j?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&j.win?j.win.close():this.lifecycleMainService.quit()}async exit(U,j){await this.lifecycleMainService.kill(j)}async resolveProxy(U,j){return this.codeWindowById(U)?.win?.webContents?.session?.resolveProxy(j)}async loadCertificates(U){return(await new Promise((V,ce)=>{Q(["@vscode/proxy-agent"],V,ce)})).loadSystemCertificates({log:this.logService})}findFreePort(U,j,V,ce,se=1){return(0,m.findFreePort)(j,V,ce,se)}async openDevTools(U,j){this.getTargetWindow(U)?.win?.webContents.openDevTools(j)}async toggleDevTools(U){this.getTargetWindow(U)?.win?.webContents.toggleDevTools()}async profileRenderer(U,j,V){const ce=this.codeWindowById(U);if(!ce||!ce.win)throw new Error;return await new k.WindowProfiler(ce.win,j,this.logService).inspect(V)}async windowsGetStringRegKey(U,j,V,ce){if(!b.isWindows)return;const se=await new Promise((ue,X)=>{Q(["@vscode/windows-registry"],ue,X)});try{return se.GetStringRegKey(j,V,ce)}catch{return}}windowById(U,j){return this.codeWindowById(U)??this.auxiliaryWindowById(U)??this.codeWindowById(j)}codeWindowById(U){if(typeof U=="number")return this.windowsMainService.getWindowById(U)}auxiliaryWindowById(U){if(typeof U=="number")return this.auxiliaryWindowsMainService.getWindowById(U)}getTargetWindow(U){let j=this.instantiationService.invokeFunction(i.getFocusedOrLastActiveWindow);return j||(j=this.windowById(U)),j}};e.NativeHostMainService=_,be([M.memoize],_.prototype,"cliPath",null),e.NativeHostMainService=_=be([ne(0,i.IWindowsMainService),ne(1,P.IAuxiliaryWindowsMainService),ne(2,h.IDialogMainService),ne(3,a.ILifecycleMainService),ne(4,d.IEnvironmentMainService),ne(5,t.ILogService),ne(6,o.IProductService),ne(7,s.IThemeMainService),ne(8,c.IWorkspacesManagementMainService),ne(9,p.IInstantiationService)],_)}),define(oe[299],ae([0,1,15,26,8,23,33,2,13,4,7,108,37,180,91,133,55,24,5,71,79,27,80,34,61,60,29]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y,v,m,g,h,d,p,a,t,o,s,i,n){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=void 0;const S="issue.processExplorerWindowState";let R=class{static{c=this}static{this.DEFAULT_BACKGROUND_COLOR="#1E1E1E"}constructor(D,_,N,U,j,V,ce,se,ue,X,Y){this.userEnv=D,this.environmentMainService=_,this.logService=N,this.diagnosticsService=U,this.diagnosticsMainService=j,this.dialogMainService=V,this.nativeHostMainService=ce,this.protocolMainService=se,this.productService=ue,this.stateService=X,this.windowsMainService=Y,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){E.validatedIpcMain.on("vscode:listProcesses",async D=>{const _=[];try{_.push({name:(0,u.localize)(0,null),rootProcess:await(0,b.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(U=>{(0,y.isRemoteDiagnosticError)(U)?_.push({name:U.hostName,rootProcess:U}):U.processes&&_.push({name:U.hostName,rootProcess:U.processes})})}catch(N){this.logService.error(`Listing processes failed: ${N}`)}this.safeSend(D,"vscode:listProcessesResponse",_)}),E.validatedIpcMain.on("vscode:workbenchCommand",(D,_)=>{const{id:N,from:U,args:j}=_;let V;switch(U){case"processExplorer":V=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${U}`)}V?.webContents.send("vscode:runAction",{id:N,from:U,args:j})}),E.validatedIpcMain.on("vscode:closeProcessExplorer",D=>{this.processExplorerWindow?.close()}),E.validatedIpcMain.on("vscode:pidToNameRequest",async D=>{const _=await this.diagnosticsMainService.getMainDiagnostics(),N=[];for(const U of _.windows)N.push([U.pid,`window [${U.id}] (${U.title})`]);for(const{pid:U,name:j}of s.UtilityProcess.getAll())N.push([U,j]);this.safeSend(D,"vscode:pidToNameResponse",N)})}async openReporter(D){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=C.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const _=new I.DisposableStore,N=_.add(this.protocolMainService.createIPCObjectUrl()),U=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(U,N,{backgroundColor:D.styles.backgroundColor,title:(0,u.localize)(1,null),zoomLevel:D.zoomLevel,alwaysOnTop:!1},"issue-reporter"),N.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:D,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,L.type)(),arch:(0,L.arch)(),release:(0,L.release)()},product:p.default}),this.issueReporterWindow.loadURL(f.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,_.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,_.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(D){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=C.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const _=new I.DisposableStore,N=_.add(this.protocolMainService.createIPCObjectUrl()),U=this.stateService.getItem(S,void 0),j=k(U)?U:this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(j,N,{backgroundColor:D.styles.backgroundColor,title:(0,u.localize)(2,null),zoomLevel:D.zoomLevel,alwaysOnTop:!0},"process-explorer"),N.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:D,product:p.default}),this.processExplorerWindow.loadURL(f.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,_.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,_.dispose())});const V=()=>{if(!this.processExplorerWindow)return;const ce=this.processExplorerWindow.getSize(),se=this.processExplorerWindow.getPosition();if(!ce||!se)return;const ue={width:ce[0],height:ce[1],x:se[0],y:se[1]};this.stateService.setItem(S,ue)};this.processExplorerWindow.on("moved",V),this.processExplorerWindow.on("resized",V)}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}async stopTracing(){if(!this.environmentMainService.args.trace)return;const D=await C.contentTracing.stopRecording(`${(0,M.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({type:"info",message:(0,u.localize)(3,null),detail:(0,u.localize)(4,null,D),buttons:[(0,u.localize)(5,null)]},C.BrowserWindow.getFocusedWindow()??void 0),this.nativeHostMainService.showItemInFolder(void 0,D)}async getSystemStatus(){const[D,_]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(D,_)}async $getSystemInfo(){const[D,_]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.diagnosticsService.getSystemInfo(D,_)}async $getPerformanceInfo(){try{const[D,_]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(D,_)}catch(D){throw this.logService.warn("issueService#getPerformanceInfo ",D.message),D}}async $reloadWithExtensionsDisabled(){if(this.issueReporterParentWindow)try{await this.nativeHostMainService.reload(this.issueReporterParentWindow.id,{disableExtensions:!0})}catch(D){this.logService.error(D)}}async $showConfirmCloseDialog(){if(this.issueReporterWindow){const{response:D}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,u.localize)(6,null),buttons:[(0,u.localize)(7,null),(0,u.localize)(8,null)]},this.issueReporterWindow);D===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}}async $showClipboardDialog(){if(this.issueReporterWindow){const{response:D}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,u.localize)(9,null),buttons:[(0,u.localize)(10,null),(0,u.localize)(11,null)]},this.issueReporterWindow);return D===0}return!1}issueReporterWindowCheck(){if(!this.issueReporterParentWindow)throw new Error("Issue reporter window not available");const D=this.windowsMainService.getWindowById(this.issueReporterParentWindow.id);if(!D)throw new Error("Window not found");return D}async $getIssueReporterUri(D){const _=this.issueReporterWindowCheck(),N=`vscode:triggerIssueUriRequestHandlerResponse${_.id}`;return r.Promises.withAsyncBody(async(U,j)=>{const V=new O.CancellationTokenSource;_.sendWhenReady("vscode:triggerIssueUriRequestHandler",V.token,{replyChannel:N,extensionId:D}),E.validatedIpcMain.once(N,(ce,se)=>{U(w.URI.parse(se))});try{await(0,r.timeout)(5e3),V.cancel(),j(new Error("Timed out waiting for issue reporter URI"))}finally{E.validatedIpcMain.removeHandler(N)}})}async $getIssueReporterData(D){const _=this.issueReporterWindowCheck(),N=`vscode:triggerIssueDataProviderResponse${_.id}`;return r.Promises.withAsyncBody(async U=>{const j=new O.CancellationTokenSource;_.sendWhenReady("vscode:triggerIssueDataProvider",j.token,{replyChannel:N,extensionId:D}),E.validatedIpcMain.once(N,(V,ce)=>{U(ce)});try{await(0,r.timeout)(5e3),j.cancel(),U("Error: Extension timed out waiting for issue reporter data")}finally{E.validatedIpcMain.removeHandler(N)}})}async $getIssueReporterTemplate(D){const _=this.issueReporterWindowCheck(),N=`vscode:triggerIssueDataTemplateResponse${_.id}`;return r.Promises.withAsyncBody(async U=>{const j=new O.CancellationTokenSource;_.sendWhenReady("vscode:triggerIssueDataTemplate",j.token,{replyChannel:N,extensionId:D}),E.validatedIpcMain.once(N,(V,ce)=>{U(ce)});try{await(0,r.timeout)(5e3),j.cancel(),U("Error: Extension timed out waiting for issue reporter template")}finally{E.validatedIpcMain.removeHandler(N)}})}async $getReporterStatus(D,_){const N=[!1,!1],U=this.issueReporterWindowCheck(),j="vscode:triggerReporterStatus",V=new O.CancellationTokenSource;return U.sendWhenReady(j,V.token,{replyChannel:j,extensionId:D,extensionName:_}),await(0,r.raceTimeout)(new Promise(se=>E.validatedIpcMain.once("vscode:triggerReporterStatusResponse",(ue,X)=>se(X))),2e3,()=>{this.logService.error("Error: Extension timed out waiting for reporter status"),V.cancel()})??N}async $closeReporter(){this.issueReporterWindow?.close()}async closeProcessExplorer(){this.processExplorerWindow?.close()}focusWindow(D){D.isMinimized()&&D.restore(),D.focus()}safeSend(D,_,...N){D.sender.isDestroyed()||D.sender.send(_,...N)}createBrowserWindow(D,_,N,U){const j=new C.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:D.width,height:D.height,minWidth:300,minHeight:200,x:D.x,y:D.y,title:N.title,backgroundColor:N.backgroundColor||c.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${_.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,i.zoomLevelToZoomFactor)(N.zoomLevel),sandbox:!0},alwaysOnTop:N.alwaysOnTop,experimentalDarkMode:!0});return j.setMenuBarVisibility(!1),j}getWindowPosition(D,_,N){let U;const j=C.screen.getAllDisplays();if(j.length===1)U=j[0];else{if(l.isMacintosh){const se=C.screen.getCursorScreenPoint();U=C.screen.getDisplayNearestPoint(se)}!U&&D&&(U=C.screen.getDisplayMatching(D.getBounds())),U||(U=C.screen.getPrimaryDisplay()||j[0])}const V=U.bounds,ce={width:_,height:N,x:V.x+V.width/2-_/2,y:V.y+V.height/2-N/2};return V.width>0&&V.height>0&&(ce.x<V.x&&(ce.x=V.x),ce.y<V.y&&(ce.y=V.y),ce.x>V.x+V.width&&(ce.x=V.x),ce.y>V.y+V.height&&(ce.y=V.y),ce.width>V.width&&(ce.width=V.width),ce.height>V.height&&(ce.height=V.height)),ce}};e.IssueMainService=R,e.IssueMainService=R=c=be([ne(1,g.IEnvironmentMainService),ne(2,h.ILogService),ne(3,y.IDiagnosticsService),ne(4,v.IDiagnosticsMainService),ne(5,m.IDialogMainService),ne(6,d.INativeHostMainService),ne(7,t.IProtocolMainService),ne(8,a.IProductService),ne(9,o.IStateService),ne(10,n.IWindowsMainService)],R);function k(P){return typeof P!="object"||P===null?!1:"x"in P&&"y"in P&&"width"in P&&"height"in P}}),define(oe[300],ae([0,1,23,18,24,20,5,71,27,53,28,49,100]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let u=class extends E.AbstractUpdateService{constructor(v,m,g,h,d,p,a,t){super(v,m,h,d,p,t),this.telemetryService=g,this.nativeHostMainService=a}buildUpdateFeedUrl(v){return(0,E.createUpdateURL)(`linux-${process.arch}`,v,this.productService)}doCheckForUpdates(v){this.url&&(this.setState(b.State.CheckingForUpdates(v)),this.requestService.request({url:this.url},C.CancellationToken.None).then(l.asJson).then(m=>{!m||!m.url||!m.version||!m.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v}),this.setState(b.State.Idle(1))):this.setState(b.State.AvailableForDownload(m))}).then(void 0,m=>{this.logService.error(m);const g=v?m.message||m:void 0;this.setState(b.State.Idle(1,g))}))}async doDownloadUpdate(v){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):v.update.url&&this.nativeHostMainService.openExternal(void 0,v.update.url),this.setState(b.State.Idle(1))}};e.LinuxUpdateService=u,e.LinuxUpdateService=u=be([ne(0,O.ILifecycleMainService),ne(1,L.IConfigurationService),ne(2,w.ITelemetryService),ne(3,r.IEnvironmentMainService),ne(4,l.IRequestService),ne(5,M.ILogService),ne(6,I.INativeHostMainService),ne(7,f.IProductService)],u)}),define(oe[301],ae([0,1,48,46,26,8,23,50,45,9,7,144,21,18,24,16,20,5,71,27,53,28,49,100]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y,v,m,g,h,d,p,a,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function s(S,R=1e3){for(;!S();)await(0,O.timeout)(R)}let i;function n(){return typeof i>"u"&&(L.existsSync(l.join(l.dirname(process.execPath),"unins000.exe"))?i=0:l.basename(l.normalize(l.join(process.execPath,"..","..")))==="Program Files"?i=3:i=1),i}let c=class extends o.AbstractUpdateService{get cachePath(){const R=l.join((0,r.tmpdir)(),`${this.productService.applicationName}-${this.productService.quality}-${this.productService.target}-${process.arch}`);return E.Promises.mkdir(R,{recursive:!0}).then(()=>R)}constructor(R,k,P,D,_,N,U,j,V){super(R,k,D,_,N,V),this.telemetryService=P,this.fileService=U,this.nativeHostMainService=j,R.setRelaunchHandler(this)}handleRelaunch(R){return R?.addArgs||R?.removeArgs||this.state.type!=="ready"||!this.availableUpdate?!1:(this.logService.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.doQuitAndInstall(),!0)}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.setState(t.State.Disabled(5)),this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.initialize()}buildUpdateFeedUrl(R){let k=`win32-${process.arch}`;switch(n()){case 1:k+="-archive";break;case 3:k+="-msi";break;default:this.productService.target==="user"?k+="-user":k+="-system"}return(0,o.createUpdateURL)(k,R,this.productService)}doCheckForUpdates(R){this.url&&(this.setState(t.State.CheckingForUpdates(R)),this.requestService.request({url:this.url},M.CancellationToken.None).then(p.asJson).then(k=>{const P=n();return!k||!k.url||!k.version||!k.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!R}),this.setState(t.State.Idle(P)),Promise.resolve(null)):P===1?(this.setState(t.State.AvailableForDownload(k)),Promise.resolve(null)):(this.setState(t.State.Downloading(k)),this.cleanup(k.version).then(()=>this.getUpdatePackagePath(k.version).then(D=>E.Promises.exists(D).then(_=>{if(_)return Promise.resolve(D);const N=`${D}.tmp`;return this.requestService.request({url:k.url},M.CancellationToken.None).then(U=>this.fileService.writeFile(w.URI.file(N),U.stream)).then(k.sha256hash?()=>(0,b.checksum)(N,k.sha256hash):()=>{}).then(()=>E.Promises.rename(N,D,!1)).then(()=>D)})).then(D=>{const _=n()==0&&this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:D},_?this.productService.target==="user"?this.doApplyUpdate():this.setState(t.State.Downloaded(k)):this.setState(t.State.Ready(k))})))}).then(void 0,k=>{this.telemetryService.publicLog2("update:error",{messageHash:String((0,f.hash)(String(k)))}),this.logService.error(k);const P=R?k.message||k:void 0;this.setState(t.State.Idle(n(),P))}))}async doDownloadUpdate(R){R.update.url&&this.nativeHostMainService.openExternal(void 0,R.update.url),this.setState(t.State.Idle(n()))}async getUpdatePackagePath(R){const k=await this.cachePath;return l.join(k,`CodeSetup-${this.productService.quality}-${R}.exe`)}async cleanup(R=null){const k=R?N=>!new RegExp(`${this.productService.quality}-${R}\\.exe$`).test(N):()=>!0,P=await this.cachePath,_=(await E.Promises.readdir(P)).filter(k).map(async N=>{try{await E.Promises.unlink(l.join(P,N))}catch{}});await Promise.all(_)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const R=this.state.update;this.setState(t.State.Updating(R));const k=await this.cachePath;this.availableUpdate.updateFilePath=l.join(k,`CodeSetup-${this.productService.quality}-${R.version}.flag`),await E.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,C.spawn)(this.availableUpdate.packagePath,["/verysilent","/log",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(t.State.Idle(n()))});const D=`${this.productService.win32MutexName}-ready`,_=await new Promise((N,U)=>{Q(["@vscode/windows-mutex"],N,U)});s(()=>_.isActive(D)).then(()=>this.setState(t.State.Ready(R)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.availableUpdate.updateFilePath?L.unlinkSync(this.availableUpdate.updateFilePath):n()==3?(0,C.spawn)("msiexec.exe",["/i",this.availableUpdate.packagePath],{detached:!0,stdio:["ignore","ignore","ignore"]}):(0,C.spawn)(this.availableUpdate.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return n()}async _applySpecificUpdate(R){if(this.state.type!=="idle")return;const k=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),P={version:"unknown",productVersion:"unknown"};this.setState(t.State.Downloading(P)),this.availableUpdate={packagePath:R},k?this.productService.target==="user"?this.doApplyUpdate():this.setState(t.State.Downloaded(P)):this.setState(t.State.Ready(P))}};e.Win32UpdateService=c,be([I.memoize],c.prototype,"cachePath",null),e.Win32UpdateService=c=be([ne(0,m.ILifecycleMainService),ne(1,u.IConfigurationService),ne(2,a.ITelemetryService),ne(3,y.IEnvironmentMainService),ne(4,p.IRequestService),ne(5,g.ILogService),ne(6,v.IFileService),ne(7,h.INativeHostMainService),ne(8,d.IProductService)],c)}),define(oe[134],ae([0,1,15,8,23,51,3,2,13,68,4,7,190,26,66,18,55,24,64,16,20,5,27,80,252,82,28,103,70,60,29,30,57,129,39,34,56,69,22,6]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y,v,m,g,h,d,p,a,t,o,s,i,n,c,S,R,k,P,D,_,N,U,j,V,ce,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=e.BaseWindow=void 0;var ue;(function(x){x[x.NONE=0]="NONE",x[x.NAVIGATING=1]="NAVIGATING",x[x.READY=2]="READY"})(ue||(ue={}));class X extends I.Disposable{get lastFocusTime(){return this._lastFocusTime}get win(){return this._win}setWin(W){this._win=W,this._register(M.Event.fromNodeEventEmitter(W,"maximize")(()=>this._onDidMaximize.fire())),this._register(M.Event.fromNodeEventEmitter(W,"unmaximize")(()=>this._onDidUnmaximize.fire())),this._register(M.Event.fromNodeEventEmitter(W,"closed")(()=>{this._onDidClose.fire(),this.dispose()})),this._register(M.Event.fromNodeEventEmitter(W,"focus")(()=>{this._lastFocusTime=Date.now()})),this._register(M.Event.fromNodeEventEmitter(this._win,"enter-full-screen")(()=>this._onDidEnterFullScreen.fire())),this._register(M.Event.fromNodeEventEmitter(this._win,"leave-full-screen")(()=>this._onDidLeaveFullScreen.fire()));const F=!(0,R.hasNativeTitlebar)(this.configurationService);if(w.isMacintosh&&F&&W.setSheetOffset((0,w.isBigSurOrNewer)((0,u.release)())?28:22),F&&(w.isWindows&&(0,R.useWindowControlsOverlay)(this.configurationService)||w.isMacintosh)){const H=this.stateService.getItem(X.windowControlHeightStateStorageKey);H&&this.updateWindowControls({height:H})}w.isWindows&&F&&W.hookWindowMessage(278,()=>{const[q,ee]=W.getPosition(),de=C.screen.getCursorScreenPoint(),G=de.x-q,A=de.y-ee;return(()=>!(G>30&&A>=0&&A<=Math.max(W.getBounds().height*.15,35)))()||(W.setEnabled(!1),W.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:G,y:A})),0}),this.environmentMainService.args["open-devtools"]===!0&&W.webContents.openDevTools()}constructor(W,F,H){super(),this.configurationService=W,this.stateService=F,this.environmentMainService=H,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidMaximize=this._register(new M.Emitter),this.onDidMaximize=this._onDidMaximize.event,this._onDidUnmaximize=this._register(new M.Emitter),this.onDidUnmaximize=this._onDidUnmaximize.event,this._onDidTriggerSystemContextMenu=this._register(new M.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidEnterFullScreen=this._register(new M.Emitter),this.onDidEnterFullScreen=this._onDidEnterFullScreen.event,this._onDidLeaveFullScreen=this._register(new M.Emitter),this.onDidLeaveFullScreen=this._onDidLeaveFullScreen.event,this._lastFocusTime=Date.now(),this._win=null,this.hasWindowControlOverlay=(0,R.useWindowControlsOverlay)(this.configurationService),this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0}setRepresentedFilename(W){w.isMacintosh?this.win?.setRepresentedFilename(W):this.representedFilename=W}getRepresentedFilename(){return w.isMacintosh?this.win?.getRepresentedFilename():this.representedFilename}setDocumentEdited(W){w.isMacintosh&&this.win?.setDocumentEdited(W),this.documentEdited=W}isDocumentEdited(){return w.isMacintosh?!!this.win?.isDocumentEdited():!!this.documentEdited}focus(W){w.isMacintosh&&W?.force&&C.app.focus({steal:!0});const F=this.win;F&&(F.isMinimized()&&F.restore(),F.focus())}handleTitleDoubleClick(){const W=this.win;if(W)if(w.isMacintosh)switch(C.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":W.minimize();break;case"None":break;case"Maximize":default:W.isMaximized()?W.unmaximize():W.maximize()}else W.isMaximized()?W.unmaximize():W.maximize()}static{this.windowControlHeightStateStorageKey="windowControlHeight"}updateWindowControls(W){const F=this.win;if(F){if(W.height&&this.stateService.setItem(Y.windowControlHeightStateStorageKey,W.height),w.isWindows&&this.hasWindowControlOverlay)F.setTitleBarOverlay({color:W.backgroundColor?.trim()===""?void 0:W.backgroundColor,symbolColor:W.foregroundColor?.trim()===""?void 0:W.foregroundColor,height:W.height?W.height-1:void 0});else if(w.isMacintosh&&W.height!==void 0){const H=(W.height-15)/2;H?F.setWindowButtonPosition({x:H,y:H}):F.setWindowButtonPosition(null)}}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(W){(0,R.useNativeFullScreen)(this.configurationService)?this.setNativeFullScreen(W):this.setSimpleFullScreen(W)}get isFullScreen(){if(w.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean")return this.transientIsNativeFullScreen;const W=this.win,F=W?.isFullScreen(),H=W?.isSimpleFullScreen();return!!(F||H)}setNativeFullScreen(W){const F=this.win;F?.isSimpleFullScreen()&&F?.setSimpleFullScreen(!1),this.doSetNativeFullScreen(W)}doSetNativeFullScreen(W){w.isMacintosh&&(this.transientIsNativeFullScreen=W,this.joinNativeFullScreenTransition=new L.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,L.timeout)(1e4)]).finally(()=>{this.transientIsNativeFullScreen=void 0})),this.win?.setFullScreen(W)}setSimpleFullScreen(W){const F=this.win;F?.isFullScreen()&&this.doSetNativeFullScreen(!1),F?.setSimpleFullScreen(W),F?.webContents.focus()}dispose(){super.dispose(),this._win=null}}e.BaseWindow=X;let Y=class extends X{get id(){return this._id}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){if(!this.config)return;const W=this.userDataProfilesService.profiles.find(F=>F.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&W?W:this.userDataProfilesService.getProfileForWorkspace(this.config.workspace??(0,P.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.userDataProfilesService.defaultProfile}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(W,F,H,q,ee,de,G,A,T,Z,z,J,B,$,K,re,le,ge,we,Ie,De){super(Z,Ie,q),this.logService=F,this.loggerMainService=H,this.policyService=ee,this.userDataProfilesService=de,this.fileService=G,this.applicationStorageMainService=A,this.storageMainService=T,this.themeMainService=z,this.workspacesManagementMainService=J,this.backupMainService=B,this.telemetryService=$,this.dialogMainService=K,this.lifecycleMainService=re,this.productService=le,this.protocolMainService=ge,this.windowsMainService=we,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.customZoomLevel=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[We,Ee]=this.restoreWindowState(W.state);this.windowState=We,this.logService.trace("window#ctor: using window state",We);const Se=this.windowState.mode===0||this.windowState.mode===3,te=De.invokeFunction(k.defaultBrowserWindowOptions,this.windowState,{show:!Se,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none"}});(0,l.mark)("code/willCreateCodeBrowserWindow"),this._win=new C.BrowserWindow(te),(0,l.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.setWin(this._win);const he=this.configurationService.getValue("window"),me=w.isMacintosh&&he?.nativeTabs===!0;(w.isMacintosh||w.isWindows)&&Ee&&(!me||C.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(Ce=>typeof Ce=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),Se&&((0,l.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,l.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(W=>{if(this.isReady)return W(this);this.whenReadyCallbacks.push(W)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(W=>{function F(){H.dispose(),q.dispose(),W()}const H=this.onDidClose(()=>F()),q=this.onWillLoad(()=>F())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(F,H)=>this.onWindowError(2,{...H})),this._win.webContents.on("did-fail-load",(F,H,q)=>this.onWindowError(3,{reason:q,exitCode:H})),this._win.webContents.on("will-prevent-unload",F=>{F.preventDefault()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._register(this.onDidMaximize(()=>{this._config&&(this._config.maximized=!0)})),this._register(this.onDidUnmaximize(()=>{this._config&&(this._config.maximized=!1)})),this._register(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",r.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0})),this._register(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",r.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0})),this._register(this.configurationService.onDidChangeConfiguration(F=>this.onConfigurationUpdated(F))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(F=>this.onDidDeleteUntitledWorkspace(F)));const W=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:W},async(F,H)=>{const q=await this.getMarketplaceHeaders();H({cancel:!1,requestHeaders:Object.assign(F.requestHeaders,q)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,s.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(W,F){switch(W){case 2:this.logService.error(`CodeWindow: renderer process gone (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:W,reason:F?.reason,code:F?.exitCode}),W){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(W===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const{response:H,checkboxChecked:q}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,E.localize)(0,null),(0,E.localize)(1,null),(0,E.localize)(2,null)],message:(0,E.localize)(3,null),detail:(0,E.localize)(4,null),checkboxLabel:this._config?.workspace?(0,E.localize)(5,null):void 0},this._win);if(H!==2){const ee=H===0;await this.destroyWindow(ee,q)}}else if(W===2){let H;F?H=(0,E.localize)(7,null,F.reason,F.exitCode??"<unknown>"):H=(0,E.localize)(6,null);const{response:q,checkboxChecked:ee}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[this._config?.workspace?(0,E.localize)(8,null):(0,E.localize)(9,null),(0,E.localize)(10,null)],message:H,detail:this._config?.workspace?(0,E.localize)(11,null):(0,E.localize)(12,null),checkboxLabel:this._config?.workspace?(0,E.localize)(13,null):void 0},this._win),de=q===0;await this.destroyWindow(de,ee)}break}}async destroyWindow(W,F){const H=this._config?.workspace;if(F&&H)try{const q=this.storageMainService.workspaceStorage(H);await q.init(),q.delete("memento/workbench.parts.editor"),await q.close()}catch(q){this.logService.error(q)}this._onDidDestroy.fire();try{if(W&&this._config){let q,ee;(0,P.isSingleFolderWorkspaceIdentifier)(H)?q={folderUri:H.uri}:(0,P.isWorkspaceIdentifier)(H)?q={workspaceUri:H.configPath}:ee=!0,(0,ce.firstOrDefault)(await this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:q?[q]:void 0,forceEmpty:ee,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this._win?.destroy()}}onDidDeleteUntitledWorkspace(W){this._config?.workspace?.id===W.id&&(this._config.workspace=void 0)}onConfigurationUpdated(W){if(!W||W.affectsConfiguration("window.menuBarVisibility")){const F=this.getMenuBarVisibility();F!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=F,this.setMenuBarVisibility(F))}if(!W||W.affectsConfiguration("http.proxy")){let F=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;F?.endsWith("/")&&(F=F.substr(0,F.length-1));const H=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((F||"").indexOf("@")===-1&&(F!==this.currentHttpProxy||H!==this.currentNoProxy)){this.currentHttpProxy=F,this.currentNoProxy=H;const q=F||"",ee=H?`${H},<local>`:"<local>";this.logService.trace(`Setting proxy to '${q}', bypassing '${ee}'`),this._win.webContents.session.setProxy({proxyRules:q,proxyBypassRules:ee,pacScript:""})}}}addTabbedWindow(W){w.isMacintosh&&W.win&&this._win.addTabbedWindow(W.win)}load(W,F=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!F.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),F.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(W,F),this.readyState===0?this._config=W:this.pendingLoadConfig=W,this.readyState=1,this._win.loadURL(f.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0));const H=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new L.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:W.workspace,reason:F.isReload?3:H?2:1})}updateConfiguration(W,F){const H=(this._config??this.pendingLoadConfig)?.userEnv;if(H){const q=(0,h.isLaunchedFromCli)(H)&&!(0,h.isLaunchedFromCli)(W.userEnv),ee=this.isExtensionDevelopmentHost;(q||ee)&&(W.userEnv={...H,...W.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(W.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),F.disableExtensions!==void 0&&(W["disable-extensions"]=F.disableExtensions),W.fullscreen=this.isFullScreen,W.maximized=this._win.isMaximized(),W.partsSplash=this.themeMainService.getWindowSplash(),W.zoomLevel=this.getZoomLevel(),W.isCustomZoomLevel=typeof this.customZoomLevel=="number",W.isCustomZoomLevel&&W.partsSplash&&(W.partsSplash.zoomLevel=W.zoomLevel),(0,l.mark)("code/willOpenNewWindow"),W.perfMarks=(0,l.getMarks)(),this.configObjectUrl.update(W)}async reload(W){const F=Object.assign({},this._config);F.workspace=await this.validateWorkspaceBeforeReload(F),delete F.filesToOpenOrCreate,delete F.filesToDiff,delete F.filesToMerge,delete F.filesToWait,this.isExtensionDevelopmentHost&&W&&(F.verbose=W.verbose,F.debugId=W.debugId,F.extensionEnvironment=W.extensionEnvironment,F["inspect-extensions"]=W["inspect-extensions"],F["inspect-brk-extensions"]=W["inspect-brk-extensions"],F["extensions-dir"]=W["extensions-dir"]),F.accessibilitySupport=C.app.isAccessibilitySupportEnabled(),F.isInitialStartup=!1,F.policiesData=this.policyService.serialize(),F.continueOn=this.environmentMainService.continueOn,F.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile,home:this.userDataProfilesService.profilesHome},F.logLevel=this.loggerMainService.getLogLevel(),F.loggers={window:this.loggerMainService.getRegisteredLoggers(this.id),global:this.loggerMainService.getRegisteredLoggers()},this.load(F,{isReload:!0,disableExtensions:W?.["disable-extensions"]})}async validateWorkspaceBeforeReload(W){if((0,P.isWorkspaceIdentifier)(W.workspace)){const F=W.workspace.configPath;if(F.scheme===f.Schemas.file&&!await this.fileService.exists(F))return}else if((0,P.isSingleFolderWorkspaceIdentifier)(W.workspace)){const F=W.workspace.uri;if(F.scheme===f.Schemas.file&&!await this.fileService.exists(F))return}return W.workspace}serializeWindowState(){if(!this._win)return(0,_.defaultWindowState)();if(this.isFullScreen){let H;try{H=C.screen.getDisplayMatching(this.getBounds())}catch{}const q=(0,_.defaultWindowState)();return{mode:3,display:H?H.id:void 0,width:this.windowState.width||q.width,height:this.windowState.height||q.height,x:this.windowState.x||0,y:this.windowState.y||0,zoomLevel:this.customZoomLevel}}const W=Object.create(null);let F;if(!w.isMacintosh&&this._win.isMaximized()?F=0:F=1,F===0?W.mode=0:W.mode=1,F===1||F===0){let H;F===1?H=this.getBounds():H=this._win.getNormalBounds(),W.x=H.x,W.y=H.y,W.width=H.width,W.height=H.height}return W.zoomLevel=this.customZoomLevel,W}restoreWindowState(W){(0,l.mark)("code/willRestoreCodeWindowState");let F=!1;if(W){this.customZoomLevel=W.zoomLevel;try{const H=C.screen.getAllDisplays();F=H.length>1,W=this.validateWindowState(W,H)}catch(H){this.logService.warn(`Unexpected error validating window state: ${H}
${H.stack}`)}}return(0,l.mark)("code/didRestoreCodeWindowState"),[W||(0,_.defaultWindowState)(),F]}validateWindowState(W,F){if(this.logService.trace(`window#validateWindowState: validating window state on ${F.length} display(s)`,W),typeof W.x!="number"||typeof W.y!="number"||typeof W.width!="number"||typeof W.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(W.width<=0||W.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(F.length===1){const ee=this.getWorkingArea(F[0]);if(ee){let de=function(){!W||typeof W.x!="number"||typeof W.y!="number"||!ee||(W.x<ee.x&&(W.x=ee.x),W.y<ee.y&&(W.y=ee.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",ee),de(),W.width>ee.width&&(W.width=ee.width),W.height>ee.height&&(W.height=ee.height),W.x>ee.x+ee.width-128&&(W.x=ee.x+ee.width-W.width),W.y>ee.y+ee.height-128&&(W.y=ee.y+ee.height-W.height),de()}return W}if(W.display&&W.mode===3){const ee=F.find(de=>de.id===W.display);if(ee&&typeof ee.bounds?.x=="number"&&typeof ee.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const de=(0,_.defaultWindowState)(3);return de.x=ee.bounds.x,de.y=ee.bounds.y,de}}let H,q;try{H=C.screen.getDisplayMatching({x:W.x,y:W.y,width:W.width,height:W.height}),q=this.getWorkingArea(H)}catch{}if(H&&q&&W.x+W.width>q.x&&W.y+W.height>q.y&&W.x<q.x+q.width&&W.y<q.y+q.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",q),W}getWorkingArea(W){if(W.workArea.width>0&&W.workArea.height>0)return W.workArea;if(W.bounds.width>0&&W.bounds.height>0)return W.bounds}getBounds(){const[W,F]=this._win.getPosition(),[H,q]=this._win.getSize();return{x:W,y:F,width:H,height:q}}setFullScreen(W){super.setFullScreen(W),this.sendWhenReady(W?"vscode:enterFullScreen":"vscode:leaveFullScreen",r.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}getMenuBarVisibility(){let W=(0,R.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(W)<0&&(W="classic"),W}setMenuBarVisibility(W,F=!0){w.isMacintosh||(W==="toggle"&&F&&this.send("vscode:showInfoMessage",(0,E.localize)(14,null)),W==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(W)}):this.doSetMenuBarVisibility(W))}doSetMenuBarVisibility(W){const F=this.isFullScreen;switch(W){case"classic":this._win.setMenuBarVisibility(!F),this._win.autoHideMenuBar=F;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}notifyZoomLevel(W){this.customZoomLevel=W}getZoomLevel(){return typeof this.customZoomLevel=="number"?this.customZoomLevel:this.configurationService.getValue("window")?.zoomLevel}close(){this._win?.close()}sendWhenReady(W,F,...H){this.isReady?this.send(W,...H):this.ready().then(()=>{F.isCancellationRequested||this.send(W,...H)})}send(W,...F){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${W}' for window that is destroyed`);return}try{this._win.webContents.send(W,...F)}catch(H){this.logService.warn(`Error sending IPC message to channel '${W}' of window ${this._id}: ${(0,O.toErrorMessage)(H)}`)}}}updateTouchBar(W){w.isMacintosh&&this.touchBarGroups.forEach((F,H)=>{const q=W[H];F.segments=this.createTouchBarGroupSegments(q)})}createTouchBar(){if(w.isMacintosh){for(let W=0;W<10;W++){const F=this.createTouchBarGroup();this.touchBarGroups.push(F)}this._win.setTouchBar(new C.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(W=[]){const F=this.createTouchBarGroupSegments(W),H=new C.TouchBar.TouchBarSegmentedControl({segments:F,mode:"buttons",segmentStyle:"automatic",change:q=>{this.sendWhenReady("vscode:runAction",r.CancellationToken.None,{id:H.segments[q].id,from:"touchbar"})}});return H}createTouchBarGroupSegments(W=[]){return W.map(H=>{let q;H.icon&&!c.ThemeIcon.isThemeIcon(H.icon)&&H.icon?.dark?.scheme===f.Schemas.file&&(q=C.nativeImage.createFromPath(b.URI.revive(H.icon.dark).fsPath),q.isEmpty()&&(q=void 0));let ee;return typeof H.title=="string"?ee=H.title:ee=H.title.value,{id:H.id,label:q?void 0:ee,icon:q}})}dispose(){super.dispose(),this.loggerMainService.deregisterLoggers(this.id)}};e.CodeWindow=Y,e.CodeWindow=Y=be([ne(1,a.ILogService),ne(2,V.ILoggerMainService),ne(3,g.IEnvironmentMainService),ne(4,N.IPolicyService),ne(5,j.IUserDataProfilesMainService),ne(6,d.IFileService),ne(7,i.IApplicationStorageMainService),ne(8,i.IStorageMainService),ne(9,v.IConfigurationService),ne(10,S.IThemeMainService),ne(11,D.IWorkspacesManagementMainService),ne(12,y.IBackupMainService),ne(13,n.ITelemetryService),ne(14,m.IDialogMainService),ne(15,p.ILifecycleMainService),ne(16,t.IProductService),ne(17,o.IProtocolMainService),ne(18,k.IWindowsMainService),ne(19,U.IStateService),ne(20,se.IInstantiationService)],Y)}),define(oe[302],ae([0,1,15,18,24,20,5,34,134]),function(Q,e,C,L,r,O,M,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AuxiliaryWindow=void 0;let l=class extends f.BaseWindow{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(b,E,u,y,v,m){super(y,v,E),this.contents=b,this.logService=u,this.lifecycleMainService=m,this.id=this.contents.id,this.parentId=-1,this.tryClaimWindow()}tryClaimWindow(){if(this._win||this._store.isDisposed||this.contents.isDestroyed())return;const b=C.BrowserWindow.fromWebContents(this.contents);b&&(this.logService.trace("[aux window] Claimed browser window instance"),this.setWin(b),b.setMenu(null),this.lifecycleMainService.registerAuxWindow(this))}};e.AuxiliaryWindow=l,e.AuxiliaryWindow=l=be([ne(1,r.IEnvironmentMainService),ne(2,M.ILogService),ne(3,L.IConfigurationService),ne(4,I.IStateService),ne(5,O.ILifecycleMainService)],l)}),define(oe[303],ae([0,1,15,3,2,13,37,302,6,5,29]),function(Q,e,C,L,r,O,M,I,f,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AuxiliaryWindowsMainService=void 0;let b=class extends r.Disposable{constructor(u,y){super(),this.instantiationService=u,this.logService=y,this._onDidMaximizeWindow=this._register(new L.Emitter),this.onDidMaximizeWindow=this._onDidMaximizeWindow.event,this._onDidUnmaximizeWindow=this._register(new L.Emitter),this.onDidUnmaximizeWindow=this._onDidUnmaximizeWindow.event,this._onDidChangeFullScreen=this._register(new L.Emitter),this.onDidChangeFullScreen=this._onDidChangeFullScreen.event,this._onDidTriggerSystemContextMenu=this._register(new L.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windows=new Map,this.registerListeners()}registerListeners(){C.app.on("browser-window-created",(u,y)=>{const v=this.getWindowById(y.id);v&&(this.logService.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),v.tryClaimWindow())}),M.validatedIpcMain.handle("vscode:registerAuxiliaryWindow",async(u,y)=>{const v=this.getWindowById(u.sender.id);return v&&(this.logService.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),v.parentId=y),u.sender.id})}createWindow(){return this.instantiationService.invokeFunction(w.defaultBrowserWindowOptions,void 0,{webPreferences:{preload:O.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath}})}registerWindow(u){const y=new r.DisposableStore,v=this.instantiationService.createInstance(I.AuxiliaryWindow,u);this.windows.set(v.id,v),y.add((0,r.toDisposable)(()=>this.windows.delete(v.id))),y.add(v.onDidMaximize(()=>this._onDidMaximizeWindow.fire(v))),y.add(v.onDidUnmaximize(()=>this._onDidUnmaximizeWindow.fire(v))),y.add(v.onDidEnterFullScreen(()=>this._onDidChangeFullScreen.fire({window:v,fullscreen:!0}))),y.add(v.onDidLeaveFullScreen(()=>this._onDidChangeFullScreen.fire({window:v,fullscreen:!1}))),y.add(v.onDidTriggerSystemContextMenu(({x:m,y:g})=>this._onDidTriggerSystemContextMenu.fire({window:v,x:m,y:g}))),L.Event.once(v.onDidClose)(()=>y.dispose())}getWindowById(u){return this.windows.get(u)}getFocusedWindow(){const u=C.BrowserWindow.getFocusedWindow();if(u)return this.getWindowById(u.id)}getLastActiveWindow(){return(0,w.getLastFocused)(Array.from(this.windows.values()))}getWindows(){return Array.from(this.windows.values())}};e.AuxiliaryWindowsMainService=b,e.AuxiliaryWindowsMainService=b=be([ne(0,f.IInstantiationService),ne(1,l.ILogService)],b)}),define(oe[83],ae([0,1,15,22,8,3,47,2,13,4,19,7,21,193,6,20,5,82,97,30,57,31,55]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y,v,m,g,h,d,p,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,y.createDecorator)("workspacesHistoryMainService");let s=class extends I.Disposable{static{o=this}static{this.MAX_TOTAL_RECENT_ENTRIES=500}static{this.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList"}constructor(n,c,S,R,k){super(),this.logService=n,this.workspacesManagementMainService=c,this.lifecycleMainService=S,this.applicationStorageMainService=R,this.dialogMainService=k,this._onDidChangeRecentlyOpened=this._register(new O.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new r.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let c=[],S=[];for(const k of n)if((0,h.isRecentWorkspace)(k))!this.workspacesManagementMainService.isUntitledWorkspace(k.workspace)&&!this.containsWorkspace(c,k.workspace)&&c.push(k);else if((0,h.isRecentFolder)(k))this.containsFolder(c,k.folderUri)||c.push(k);else{const P=this.containsFile(S,k.fileUri),D=k.fileUri.scheme===f.Schemas.file&&o.COMMON_FILES_FILTER.indexOf((0,w.basename)(k.fileUri))>=0;!P&&!D&&(S.push(k),l.isWindows&&k.fileUri.scheme===f.Schemas.file&&C.app.addRecentDocument(k.fileUri.fsPath))}const R=await this.mergeEntriesFromStorage({workspaces:c,files:S});c=R.workspaces,S=R.files,c.length>o.MAX_TOTAL_RECENT_ENTRIES&&(c.length=o.MAX_TOTAL_RECENT_ENTRIES),S.length>o.MAX_TOTAL_RECENT_ENTRIES&&(S.length=o.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:c,files:S}),this._onDidChangeRecentlyOpened.fire(),l.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(n){const c=P=>{const D=this.location(P);for(const _ of n)if(w.extUriBiasedIgnorePathCase.isEqual(_,D))return!1;return!0},S=await this.getRecentlyOpened(),R=S.workspaces.filter(c),k=S.files.filter(c);(R.length!==S.workspaces.length||k.length!==S.files.length)&&(await this.saveRecentlyOpened({files:k,workspaces:R}),this._onDidChangeRecentlyOpened.fire(),l.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(n){if(n?.confirm){const{response:c}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,u.localize)(0,null),(0,u.localize)(1,null)],message:(0,u.localize)(2,null),detail:(0,u.localize)(3,null),cancelId:1});if(c!==0)return}await this.saveRecentlyOpened({workspaces:[],files:[]}),C.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(n){const c=new a.ResourceMap(k=>w.extUriBiasedIgnorePathCase.getComparisonKey(k));if(n?.workspaces)for(const k of n.workspaces)c.set(this.location(k),k);const S=new a.ResourceMap(k=>w.extUriBiasedIgnorePathCase.getComparisonKey(k));if(n?.files)for(const k of n.files)S.set(this.location(k),k);const R=await this.getRecentlyOpenedFromStorage();for(const k of R.workspaces){const P=c.get(this.location(k));P?P.label=P.label??k.label:c.set(this.location(k),k)}for(const k of R.files){const P=S.get(this.location(k));P?P.label=P.label??k.label:S.set(this.location(k),k)}return{workspaces:[...c.values()],files:[...S.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let n;const c=this.applicationStorageMainService.get(o.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof c=="string")try{n=JSON.parse(c)}catch(S){this.logService.error("Unexpected error parsing opened paths list",S)}return(0,h.restoreRecentlyOpened)(n,this.logService)}async saveRecentlyOpened(n){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(o.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,h.toStoreData)(n)),-1,1)}location(n){return(0,h.isRecentFolder)(n)?n.folderUri:(0,h.isRecentFile)(n)?n.fileUri:n.workspace.configPath}containsWorkspace(n,c){return!!n.find(S=>(0,h.isRecentWorkspace)(S)&&S.workspace.id===c.id)}containsFolder(n,c){return!!n.find(S=>(0,h.isRecentFolder)(S)&&w.extUriBiasedIgnorePathCase.isEqual(S.folderUri,c))}containsFile(n,c){return!!n.find(S=>w.extUriBiasedIgnorePathCase.isEqual(S.fileUri,c))}static{this.MAX_MACOS_DOCK_RECENT_WORKSPACES=7}static{this.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10}static{this.MAX_WINDOWS_JUMP_LIST_ENTRIES=7}static{this.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"]}async handleWindowsJumpList(){l.isWindows&&(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!l.isWindows)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,u.localize)(4,null),description:(0,u.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const c=[];for(const k of C.app.getJumpListSettings().removedItems){const P=k.args;if(P){const D=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(P);D&&c.push(b.URI.parse(D[2]))}}await this.removeRecentlyOpened(c);let S=!1;const R=(0,L.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,o.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(k=>{const P=(0,h.isRecentWorkspace)(k)?k.workspace:k.folderUri,{title:D,description:_}=this.getWindowsJumpListLabel(P,k.label);let N;return b.URI.isUri(P)?N=`--folder-uri "${P.toString()}"`:(S=!0,N=`--file-uri "${P.configPath.toString()}"`),{type:"task",title:D.substr(0,255),description:_.substr(0,255),program:process.execPath,args:N,iconPath:"explorer.exe",iconIndex:0}}));R.length>0&&n.push({type:"custom",name:S?(0,u.localize)(6,null):(0,u.localize)(7,null),items:R})}n.push({type:"recent"});try{const c=C.app.setJumpList(n);c&&c!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${c}`)}catch(c){this.logService.warn("updateWindowsJumpList#setJumpList",c)}}getWindowsJumpListLabel(n,c){if(c)return{title:(0,M.splitRecentLabel)(c).name,description:c};if(b.URI.isUri(n))return{title:(0,w.basename)(n),description:this.renderJumpListPathDescription(n)};if(this.workspacesManagementMainService.isUntitledWorkspace(n))return{title:(0,u.localize)(8,null),description:""};let S=(0,w.basename)(n.configPath);return S.endsWith(d.WORKSPACE_EXTENSION)&&(S=S.substr(0,S.length-d.WORKSPACE_EXTENSION.length-1)),{title:(0,u.localize)(9,null,S),description:this.renderJumpListPathDescription(n.configPath)}}renderJumpListPathDescription(n){return n.scheme==="file"?(0,M.normalizeDriveLetter)(n.fsPath):n.toString()}async updateMacOSRecentDocuments(){if(!l.isMacintosh)return;C.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),c=[];let S=0;for(let k=0;k<n.workspaces.length&&S<o.MAX_MACOS_DOCK_RECENT_WORKSPACES;k++){const P=this.location(n.workspaces[k]);if(P.scheme===f.Schemas.file){const D=(0,w.originalFSPath)(P);await E.Promises.exists(D)&&(c.push(D),S++)}}const R=[];for(let k=0;k<n.files.length&&S<o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;k++){const P=this.location(n.files[k]);if(P.scheme===f.Schemas.file){const D=(0,w.originalFSPath)(P);if(o.COMMON_FILES_FILTER.includes((0,w.basename)(P))||c.includes(D))continue;await E.Promises.exists(D)&&(R.push(D),S++)}}R.reverse().forEach(k=>C.app.addRecentDocument(k)),c.reverse().forEach(k=>C.app.addRecentDocument(k))}};e.WorkspacesHistoryMainService=s,e.WorkspacesHistoryMainService=s=o=be([ne(0,m.ILogService),ne(1,p.IWorkspacesManagementMainService),ne(2,v.ILifecycleMainService),ne(3,g.IApplicationStorageMainService),ne(4,t.IDialogMainService)],s)}),define(oe[304],ae([0,1,15,8,23,47,4,7,181,65,18,24,20,5,231,71,27,34,28,49,60,29,83]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y,v,m,g,h,d,p,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const s="menu";let i=class{static{o=this}static{this.lastKnownMenubarStorageKey="lastKnownMenubarData"}constructor(S,R,k,P,D,_,N,U,j,V,ce,se){this.updateService=S,this.configurationService=R,this.windowsMainService=k,this.environmentMainService=P,this.telemetryService=D,this.workspacesHistoryMainService=_,this.stateService=N,this.lifecycleMainService=U,this.logService=j,this.nativeHostMainService=V,this.productService=ce,this.auxiliaryWindowsMainService=se,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new L.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new L.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(M.isMacintosh||(0,p.hasNativeTitlebar)(R))&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveMainWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const S=this.stateService.getItem(o.lastKnownMenubarStorageKey);S&&(S.menus&&(this.menubarMenus=S.menus),S.keybindings&&(this.keybindings=S.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(_,N,U)=>{this.runActionInRenderer({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.windowsMainService.openEmptyWindow({context:2,contextWindowId:N?.id})},this.fallbackMenuHandlers["workbench.action.newWindow"]=(_,N,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:N?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(_,N,U)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(_,N,U)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(_,N,U)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened({confirm:!0});const S=this.productService.youTubeUrl;S&&(this.fallbackMenuHandlers["workbench.action.openYouTubeUrl"]=()=>this.openUrl(S,"openYouTubeUrl"));const R=this.productService.requestFeatureUrl;R&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(R,"openUserVoiceUrl"));const k=this.productService.reportIssueUrl;k&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(k,"openReportIssues"));const P=this.productService.licenseUrl;P&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(M.language){const _=P.indexOf("?")>0?"&":"?";this.openUrl(`${P}${_}lang=${M.language}`,"openLicenseUrl")}else this.openUrl(P,"openLicenseUrl")});const D=this.productService.privacyStatementUrl;D&&P&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(D,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(S=>this.onDidChangeWindowsCount(S)),this.nativeHostMainService.onDidBlurMainWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusMainWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const S=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof S!="boolean"?!0:S}get currentEnableNativeTabs(){if(!M.isMacintosh)return!1;const S=this.configurationService.getValue("window.nativeTabs");return typeof S!="boolean"?!1:S}updateMenu(S,R){this.menubarMenus=S.menus,this.keybindings=S.keybindings,this.stateService.setItem(o.lastKnownMenubarStorageKey,S),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(S){M.isMacintosh&&(S.oldCount===0&&S.newCount>0||S.oldCount>0&&S.newCount===0)&&(this.closedLastWindow=S.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){if(!M.isMacintosh)return;const S=C.BrowserWindow.getFocusedWindow();this.noActiveMainWindow=!S||!!this.auxiliaryWindowsMainService.getWindowById(S.id),this.scheduleUpdateMenu()}install(){const S=C.Menu.getApplicationMenu();if(S&&this.oldMenus.push(S),Object.keys(this.menubarMenus).length===0){this.doSetApplicationMenu(M.isMacintosh?new C.Menu:null);return}const R=new C.Menu;let k;if(M.isMacintosh){const D=new C.Menu;k=new C.MenuItem({label:this.productService.nameShort,submenu:D}),this.setMacApplicationMenu(D),R.append(k)}if(M.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const D=new C.Menu;D.append(new C.MenuItem({label:this.mnemonicLabel(f.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),C.app.dock.setMenu(D)}if(this.shouldDrawMenu("File")){const D=new C.Menu,_=new C.MenuItem({label:this.mnemonicLabel(f.localize(1,null)),submenu:D});this.setMenuById(D,"File"),R.append(_)}if(this.shouldDrawMenu("Edit")){const D=new C.Menu,_=new C.MenuItem({label:this.mnemonicLabel(f.localize(2,null)),submenu:D});this.setMenuById(D,"Edit"),R.append(_)}if(this.shouldDrawMenu("Selection")){const D=new C.Menu,_=new C.MenuItem({label:this.mnemonicLabel(f.localize(3,null)),submenu:D});this.setMenuById(D,"Selection"),R.append(_)}if(this.shouldDrawMenu("View")){const D=new C.Menu,_=new C.MenuItem({label:this.mnemonicLabel(f.localize(4,null)),submenu:D});this.setMenuById(D,"View"),R.append(_)}if(this.shouldDrawMenu("Go")){const D=new C.Menu,_=new C.MenuItem({label:this.mnemonicLabel(f.localize(5,null)),submenu:D});this.setMenuById(D,"Go"),R.append(_)}if(this.shouldDrawMenu("Run")){const D=new C.Menu,_=new C.MenuItem({label:this.mnemonicLabel(f.localize(6,null)),submenu:D});this.setMenuById(D,"Run"),R.append(_)}if(this.shouldDrawMenu("Terminal")){const D=new C.Menu,_=new C.MenuItem({label:this.mnemonicLabel(f.localize(7,null)),submenu:D});this.setMenuById(D,"Terminal"),R.append(_)}let P;if(this.shouldDrawMenu("Window")){const D=new C.Menu;P=new C.MenuItem({label:this.mnemonicLabel(f.localize(8,null)),submenu:D,role:"window"}),this.setMacWindowMenu(D)}if(P&&R.append(P),this.shouldDrawMenu("Help")){const D=new C.Menu,_=new C.MenuItem({label:this.mnemonicLabel(f.localize(9,null)),submenu:D,role:"help"});this.setMenuById(D,"Help"),R.append(_)}R.items&&R.items.length>0?this.doSetApplicationMenu(R):this.doSetApplicationMenu(null),this.menuGC.schedule()}doSetApplicationMenu(S){if(C.Menu.setApplicationMenu(S),S)for(const R of this.auxiliaryWindowsMainService.getWindows())R.win?.setMenu(null)}setMacApplicationMenu(S){const R=this.createMenuItem(f.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),k=this.getUpdateMenuItems();let P;if(this.shouldDrawMenu("Preferences")){const se=new C.Menu;this.setMenuById(se,"Preferences"),P=new C.MenuItem({label:this.mnemonicLabel(f.localize(11,null)),submenu:se})}const D=new C.Menu,_=new C.MenuItem({label:f.localize(12,null),role:"services",submenu:D}),N=new C.MenuItem({label:f.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),U=new C.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),j=new C.MenuItem({label:f.localize(15,null),role:"unhide"}),V=new C.MenuItem(this.likeAction("workbench.action.quit",{label:f.localize(16,null,this.productService.nameLong),click:async(se,ue,X)=>{const Y=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||C.BrowserWindow.getFocusedWindow()||Y?.win?.isMinimized())&&await this.confirmBeforeQuit(X)&&this.nativeHostMainService.quit(void 0)}})),ce=[R];ce.push(...k),P&&ce.push(n(),P),ce.push(n(),_,n(),N,U,j,n(),V),ce.forEach(se=>S.append(se))}async confirmBeforeQuit(S){if(this.windowsMainService.getWindowCount()===0)return!0;const R=this.configurationService.getValue("window.confirmBeforeClose");if(R==="always"||R==="keyboardOnly"&&this.isKeyboardEvent(S)){const{response:k}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,{type:"question",buttons:[f.localize(17,null),f.localize(18,null)],message:f.localize(19,null)});return k===0}return!0}shouldDrawMenu(S){if(!M.isMacintosh&&!(0,p.hasNativeTitlebar)(this.configurationService))return!1;switch(S){case"File":case"Help":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveMainWindow||!!this.menubarMenus&&!!this.menubarMenus[S];case"Window":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveMainWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[S]}}setMenu(S,R){R.forEach(k=>{if((0,y.isMenubarMenuItemSeparator)(k))S.append(n());else if((0,y.isMenubarMenuItemSubmenu)(k)){const P=new C.Menu,D=new C.MenuItem({label:this.mnemonicLabel(k.label),submenu:P});this.setMenu(P,k.submenu.items),S.append(D)}else(0,y.isMenubarMenuItemRecentAction)(k)?S.append(this.createOpenRecentMenuItem(k)):(0,y.isMenubarMenuItemAction)(k)&&(k.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(S),M.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveMainWindow?this.fallbackMenuHandlers[k.id]?S.append(new C.MenuItem(this.likeAction(k.id,{label:this.mnemonicLabel(k.label),click:this.fallbackMenuHandlers[k.id]}))):S.append(this.createMenuItem(k.label,k.id,!1,k.checked)):S.append(this.createMenuItem(k.label,k.id,k.enabled!==!1,!!k.checked)):S.append(this.createMenuItem(k.label,k.id,k.enabled!==!1,!!k.checked)))})}setMenuById(S,R){this.menubarMenus&&this.menubarMenus[R]&&this.setMenu(S,this.menubarMenus[R].items)}insertCheckForUpdatesItems(S){const R=this.getUpdateMenuItems();R.length&&(R.forEach(k=>S.append(k)),S.append(n()))}createOpenRecentMenuItem(S){const R=I.URI.revive(S.uri),k=S.id,P=k==="openRecentFile"?{fileUri:R}:k==="openRecentWorkspace"?{workspaceUri:R}:{folderUri:R};return new C.MenuItem(this.likeAction(k,{label:S.label,click:async(D,_,N)=>{const U=this.isOptionClick(N);(await this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[P],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:S.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([R])}},!1))}isOptionClick(S){return!!(S&&(!M.isMacintosh&&(S.ctrlKey||S.shiftKey)||M.isMacintosh&&(S.metaKey||S.altKey)))}isKeyboardEvent(S){return!!(S.triggeredByAccelerator||S.altKey||S.ctrlKey||S.metaKey||S.shiftKey)}createRoleMenuItem(S,R,k){const P={label:this.mnemonicLabel(S),role:k,enabled:!0};return new C.MenuItem(this.withKeybinding(R,P))}setMacWindowMenu(S){const R=new C.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),k=new C.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),P=new C.MenuItem({label:f.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),D=this.createMenuItem(f.localize(23,null),"workbench.action.switchWindow"),_=[];this.currentEnableNativeTabs&&(_.push(n()),_.push(this.createMenuItem(f.localize(24,null),"workbench.action.newWindowTab")),_.push(this.createRoleMenuItem(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),_.push(this.createRoleMenuItem(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),_.push(this.createRoleMenuItem(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),_.push(this.createRoleMenuItem(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[R,k,n(),D,..._,n(),P].forEach(N=>S.append(N))}getUpdateMenuItems(){switch(this.updateService.state.type){case"idle":return[new C.MenuItem({label:this.mnemonicLabel(f.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new C.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new C.MenuItem({label:this.mnemonicLabel(f.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new C.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new C.MenuItem({label:this.mnemonicLabel(f.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new C.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new C.MenuItem({label:this.mnemonicLabel(f.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})];default:return[]}}createMenuItem(S,R,k,P){const D=this.mnemonicLabel(S),_=typeof R=="function"?R:(ce,se,ue)=>{const X=ce?ce.userSettingsLabel:null;let Y=R;Array.isArray(R)&&(Y=this.isOptionClick(ue)?R[1]:R[0]),X&&ue.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:X}):this.runActionInRenderer({type:"commandId",commandId:Y})},N=typeof k=="boolean"?k:this.windowsMainService.getWindowCount()>0,U=typeof P=="boolean"?P:!1,j={label:D,click:_,enabled:N};U&&(j.type="checkbox",j.checked=U);let V;return typeof R=="string"?V=R:Array.isArray(R)&&(V=R[0]),M.isMacintosh&&(V==="editor.action.clipboardCutAction"?j.role="cut":V==="editor.action.clipboardCopyAction"?j.role="copy":V==="editor.action.clipboardPasteAction"&&(j.role="paste"),V==="undo"?j.click=this.makeContextAwareClickHandler(_,{inDevTools:ce=>ce.undo(),inNoWindow:()=>C.Menu.sendActionToFirstResponder("undo:")}):V==="redo"?j.click=this.makeContextAwareClickHandler(_,{inDevTools:ce=>ce.redo(),inNoWindow:()=>C.Menu.sendActionToFirstResponder("redo:")}):V==="editor.action.selectAll"&&(j.click=this.makeContextAwareClickHandler(_,{inDevTools:ce=>ce.selectAll(),inNoWindow:()=>C.Menu.sendActionToFirstResponder("selectAll:")}))),new C.MenuItem(this.withKeybinding(V,j))}makeContextAwareClickHandler(S,R){return(k,P,D)=>{const _=C.BrowserWindow.getFocusedWindow();if(!_)return R.inNoWindow();if(_.webContents.isDevToolsFocused()&&_.webContents.devToolsWebContents)return R.inDevTools(_.webContents.devToolsWebContents);S(k,P||_,D)}}runActionInRenderer(S){let R=C.BrowserWindow.getFocusedWindow();if(R){const P=this.auxiliaryWindowsMainService.getWindowById(R.id);P&&(R=this.windowsMainService.getWindowById(P.parentId)?.win??null)}if(!R){const P=this.windowsMainService.getLastActiveWindow();P?.win?.isMinimized()&&(R=P.win)}const k=R?this.windowsMainService.getWindowById(R.id):void 0;if(k){if(this.logService.trace("menubar#runActionInRenderer",S),M.isMacintosh&&!this.environmentMainService.isBuilt&&!k.isReady&&(S.type==="commandId"&&S.commandId==="workbench.action.toggleDevTools"||S.type!=="commandId"&&S.userSettingsLabel==="alt+cmd+i"))return!1;if(S.type==="commandId"){const P={id:S.commandId,from:"menu"};k.sendWhenReady("vscode:runAction",r.CancellationToken.None,P)}else{const P={userSettingsLabel:S.userSettingsLabel};k.sendWhenReady("vscode:runKeybinding",r.CancellationToken.None,P)}return!0}else return this.logService.trace("menubar#runActionInRenderer: no active window found",S),!1}withKeybinding(S,R){const k=typeof S=="string"?this.keybindings[S]:void 0;if(k?.label){if(k.isNative!==!1)R.accelerator=k.label,R.userSettingsLabel=k.userSettingsLabel;else if(typeof R.label=="string"){const P=R.label.indexOf("[");P>=0?R.label=`${R.label.substr(0,P)} [${k.label}]`:R.label=`${R.label} [${k.label}]`}}else R.accelerator=void 0;return R}likeAction(S,R,k=!R.accelerator){k&&(R=this.withKeybinding(S,R));const P=R.click;return R.click=(D,_,N)=>{this.reportMenuActionTelemetry(S),P?.(D,_,N)},R}openUrl(S,R){this.nativeHostMainService.openExternal(void 0,S),this.reportMenuActionTelemetry(R)}reportMenuActionTelemetry(S){this.telemetryService.publicLog2("workbenchActionExecuted",{id:S,from:s})}mnemonicLabel(S){return(0,O.mnemonicMenuLabel)(S,!this.currentEnableMenuBarMnemonics)}};e.Menubar=i,e.Menubar=i=o=be([ne(0,d.IUpdateService),ne(1,w.IConfigurationService),ne(2,a.IWindowsMainService),ne(3,b.IEnvironmentMainService),ne(4,h.ITelemetryService),ne(5,t.IWorkspacesHistoryMainService),ne(6,g.IStateService),ne(7,E.ILifecycleMainService),ne(8,u.ILogService),ne(9,v.INativeHostMainService),ne(10,m.IProductService),ne(11,l.IAuxiliaryWindowsMainService)],i);function n(){return new C.MenuItem({type:"separator"})}}),define(oe[305],ae([0,1,6,20,5,304]),function(Q,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,C.createDecorator)("menubarMainService");let M=class{constructor(f,l,w){this.instantiationService=f,this.lifecycleMainService=l,this.logService=w,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(O.Menubar)}async updateMenubar(f,l){this.logService.trace("menubarService#updateMenubar",f),(await this.menubar).updateMenu(l,f)}};e.MenubarMainService=M,e.MenubarMainService=M=be([ne(0,C.IInstantiationService),ne(1,L.ILifecycleMainService),ne(2,r.ILogService)],M)}),define(oe[306],ae([0,1,15,21,132,26,22,23,3,33,47,2,13,9,68,4,36,19,12,7,191,66,18,55,24,16,6,20,5,79,80,59,34,60,134,29,131,298,30,98,83,57,70,39,56,69,65]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y,v,m,g,h,d,p,a,t,o,s,i,n,c,S,R,k,P,D,_,N,U,j,V,ce,se,ue,X,Y,x,W,F,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function q(G){return(0,ce.isWorkspaceIdentifier)(G?.workspace)}function ee(G){return(0,ce.isSingleFolderWorkspaceIdentifier)(G?.workspace)}let de=class extends b.Disposable{constructor(A,T,Z,z,J,B,$,K,re,le,ge,we,Ie,De,We,Ee,Se,te,he,me){super(),this.machineId=A,this.sqmId=T,this.initialUserEnv=Z,this.logService=z,this.loggerService=J,this.stateService=B,this.policyService=$,this.environmentMainService=K,this.userDataProfilesMainService=re,this.lifecycleMainService=le,this.backupMainService=ge,this.configurationService=we,this.workspacesHistoryMainService=Ie,this.workspacesManagementMainService=De,this.instantiationService=We,this.dialogMainService=Ee,this.fileService=Se,this.protocolMainService=te,this.themeMainService=he,this.auxiliaryWindowsMainService=me,this._onDidOpenWindow=this._register(new f.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new f.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new f.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new f.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidMaximizeWindow=this._register(new f.Emitter),this.onDidMaximizeWindow=this._onDidMaximizeWindow.event,this._onDidUnmaximizeWindow=this._register(new f.Emitter),this.onDidUnmaximizeWindow=this._onDidUnmaximizeWindow.event,this._onDidChangeFullScreen=this._register(new f.Emitter),this.onDidChangeFullScreen=this._onDidChangeFullScreen.event,this._onDidTriggerSystemContextMenu=this._register(new f.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windows=new Map,this.windowsStateHandler=this._register(new V.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(A=>this._onDidSignalReadyWindow.fire(A.window))),this._register(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const T=new b.DisposableStore;if(T.add(f.Event.any(A.onDidClose,A.onDidDestroy)(()=>T.dispose())),A.config.extensionDevelopmentPath)for(const Z of A.config.extensionDevelopmentPath)T.add(this.protocolMainService.addValidFileRoot(Z));A.config.extensionTestsPath&&T.add(this.protocolMainService.addValidFileRoot(A.config.extensionTestsPath))}}))}openEmptyWindow(A,T){const Z=this.environmentMainService.args,z=T?.remoteAuthority||void 0,J=!0,B=T?.forceReuseWindow,$=!B;return this.open({...A,cli:Z,forceEmpty:J,forceNewWindow:$,forceReuseWindow:B,remoteAuthority:z})}openExistingWindow(A,T){A.focus(),this.handleWaitMarkerFile(T,[A])}async open(A){this.logService.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const T=[],Z=[],z=[],J=[],B=[];let $,K=0;const re=await this.getPathsToOpen(A);this.logService.trace("windowsManager#open pathsToOpen",re);for(const De of re)ee(De)?A.addMode?T.push(De):Z.push(De):q(De)?z.push(De):De.fileUri?($||($={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:De.remoteAuthority}),$.filesToOpenOrCreate.push(De)):De.backupPath?B.push({backupFolder:(0,u.basename)(De.backupPath),remoteAuthority:De.remoteAuthority}):K++;A.diffMode&&$&&$.filesToOpenOrCreate.length>=2&&($.filesToDiff=$.filesToOpenOrCreate.slice(0,2),$.filesToOpenOrCreate=[]),A.mergeMode&&$&&$.filesToOpenOrCreate.length===4&&($.filesToMerge=$.filesToOpenOrCreate.slice(0,4),$.filesToOpenOrCreate=[],$.filesToDiff=[]),$&&A.waitMarkerFileURI&&($.filesToWait={paths:(0,M.coalesce)([...$.filesToDiff,$.filesToMerge[3],...$.filesToOpenOrCreate]),waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(J.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),z.push(...J),B.push(...this.backupMainService.getEmptyWindowBackups())):B.length=0;const{windows:le,filesOpenedInWindow:ge}=await this.doOpen(A,z,Z,B,K,$,T);if(this.logService.trace(`windowsManager#open used window count ${le.length} (workspacesToOpen: ${z.length}, foldersToOpen: ${Z.length}, emptyToRestore: ${B.length}, emptyToOpen: ${K})`),le.length>1)if(ge)ge.focus();else{const De=this.windowsStateHandler.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let We=!0,Ee=!0;if(De){const Se=le.filter(te=>this.windowsStateHandler.state.lastActiveWindow&&te.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Se.length&&(Se[0].focus(),We=!1,Ee=!1)}if(We)for(let Se=le.length-1;Se>=0;Se--){const te=le[Se];if(!(te.openedWorkspace&&J.some(he=>te.openedWorkspace&&he.workspace.id===te.openedWorkspace.id)||te.backupPath&&B.some(he=>te.backupPath&&he.backupFolder===(0,u.basename)(te.backupPath)))){te.focus(),Ee=!1;break}}Ee&&le[le.length-1].focus()}const we=$&&$.filesToDiff.length>0,Ie=$&&$.filesToMerge.length>0;if(!le.some(De=>De.isExtensionDevelopmentHost)&&!we&&!Ie&&!A.noRecentEntry){const De=[];for(const We of re)q(We)&&!We.transient?De.push({label:We.label,workspace:We.workspace,remoteAuthority:We.remoteAuthority}):ee(We)?De.push({label:We.label,folderUri:We.workspace.uri,remoteAuthority:We.remoteAuthority}):We.fileUri&&De.push({label:We.label,fileUri:We.fileUri,remoteAuthority:We.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(De)}return this.handleWaitMarkerFile(A,le),le}handleWaitMarkerFile(A,T){const Z=A.waitMarkerFileURI;A.context===0&&Z&&T.length===1&&T[0]&&(async()=>{await T[0].whenClosedOrLoaded;try{await this.fileService.del(Z)}catch{}})()}async doOpen(A,T,Z,z,J,B,$){const K=[];let re;function le(Se,te){K.push(Se),te&&(re=Se,B=void 0)}let{openFolderInNewWindow:ge,openFilesInNewWindow:we}=this.shouldOpenNewWindow(A);if(!A.initialStartup&&$.length>0){const Se=$[0].remoteAuthority,te=this.getLastActiveWindowForAuthority(Se);te&&le(this.doAddFoldersToExistingWindow(te,$.map(he=>he.workspace.uri)))}const Ie=Z.length+T.length+z.length;if(B&&Ie===0){const Se=B.filesToOpenOrCreate[0]||B.filesToDiff[0]||B.filesToMerge[3],te=this.getWindows().filter(me=>B&&(0,g.isEqualAuthority)(me.remoteAuthority,B.remoteAuthority));let he;Se?.fileUri&&!we&&((A.context===4||A.context===0||A.context===1)&&(he=await(0,j.findWindowOnFile)(te,Se.fileUri,async me=>me.configPath.scheme===E.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(me.configPath):void 0)),he||(he=this.doGetLastActiveWindow(te))),he?(0,ce.isWorkspaceIdentifier)(he.openedWorkspace)?T.push({workspace:he.openedWorkspace,remoteAuthority:he.remoteAuthority}):(0,ce.isSingleFolderWorkspaceIdentifier)(he.openedWorkspace)?Z.push({workspace:he.openedWorkspace,remoteAuthority:he.remoteAuthority}):le(this.doOpenFilesInExistingWindow(A,he,B),!0):le(await this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:B,forceNewWindow:!0,remoteAuthority:B.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile}),!0)}const De=(0,M.distinct)(T,Se=>Se.workspace.id);if(De.length>0){const Se=(0,M.coalesce)(De.map(te=>(0,j.findWindowOnWorkspaceOrFolder)(this.getWindows(),te.workspace.configPath)));if(Se.length>0){const te=Se[0],he=(0,g.isEqualAuthority)(B?.remoteAuthority,te.remoteAuthority)?B:void 0;le(this.doOpenFilesInExistingWindow(A,te,he),!!he),ge=!0}for(const te of De){if(Se.some(Ce=>Ce.openedWorkspace&&Ce.openedWorkspace.id===te.workspace.id))continue;const he=te.remoteAuthority,me=(0,g.isEqualAuthority)(B?.remoteAuthority,he)?B:void 0;le(await this.doOpenFolderOrWorkspace(A,te,ge,me),!!me),ge=!0}}const We=(0,M.distinct)(Z,Se=>g.extUriBiasedIgnorePathCase.getComparisonKey(Se.workspace.uri));if(We.length>0){const Se=(0,M.coalesce)(We.map(te=>(0,j.findWindowOnWorkspaceOrFolder)(this.getWindows(),te.workspace.uri)));if(Se.length>0){const te=Se[0],he=(0,g.isEqualAuthority)(B?.remoteAuthority,te.remoteAuthority)?B:void 0;le(this.doOpenFilesInExistingWindow(A,te,he),!!he),ge=!0}for(const te of We){if(Se.some(Ce=>(0,ce.isSingleFolderWorkspaceIdentifier)(Ce.openedWorkspace)&&g.extUriBiasedIgnorePathCase.isEqual(Ce.openedWorkspace.uri,te.workspace.uri)))continue;const he=te.remoteAuthority,me=(0,g.isEqualAuthority)(B?.remoteAuthority,he)?B:void 0;le(await this.doOpenFolderOrWorkspace(A,te,ge,me),!!me),ge=!0}}const Ee=(0,M.distinct)(z,Se=>Se.backupFolder);if(Ee.length>0)for(const Se of Ee){const te=Se.remoteAuthority,he=(0,g.isEqualAuthority)(B?.remoteAuthority,te)?B:void 0;le(await this.doOpenEmpty(A,!0,te,he,Se),!!he),ge=!0}if(K.length===0||B){B&&!J&&J++;const Se=B?B.remoteAuthority:A.remoteAuthority;for(let te=0;te<J;te++)le(await this.doOpenEmpty(A,ge,Se,B),!!B),ge=!0}return{windows:(0,M.distinct)(K),filesOpenedInWindow:re}}doOpenFilesInExistingWindow(A,T,Z){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:Z}),this.focusMainOrChildWindow(T);const z={filesToOpenOrCreate:Z?.filesToOpenOrCreate,filesToDiff:Z?.filesToDiff,filesToMerge:Z?.filesToMerge,filesToWait:Z?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return T.sendWhenReady("vscode:openFiles",I.CancellationToken.None,z),T}focusMainOrChildWindow(A){let T=A;const Z=C.BrowserWindow.getFocusedWindow();if(Z&&Z.id!==A.id){const z=this.auxiliaryWindowsMainService.getWindowById(Z.id);z&&z.parentId===A.id&&(T=z)}T.focus()}doAddFoldersToExistingWindow(A,T){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:T}),A.focus();const Z={foldersToAdd:T};return A.sendWhenReady("vscode:addFolders",I.CancellationToken.None,Z),A}doOpenEmpty(A,T,Z,z,J){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!J,remoteAuthority:Z,filesToOpen:z,forceNewWindow:T});let B;return!T&&typeof A.contextWindowId=="number"&&(B=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:Z,forceNewWindow:T,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:z,windowToUse:B,emptyWindowBackupInfo:J,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}doOpenFolderOrWorkspace(A,T,Z,z,J){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:T,filesToOpen:z}),!Z&&!J&&typeof A.contextWindowId=="number"&&(J=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({workspace:T.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:T.remoteAuthority,forceNewWindow:Z,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:z,windowToUse:J,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}async getPathsToOpen(A){let T,Z=!1,z=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(T=await this.doExtractPathsFromAPI(A),Z=!0):A.forceEmpty?T=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(T=await this.doExtractPathsFromCLI(A.cli),T.length===0&&T.push(Object.create(null)),Z=!0):(T=await this.doGetPathsFromLastSession(),T.length===0&&T.push(Object.create(null)),z=!0),!A.addMode&&Z){const J=T.filter(B=>ee(B));if(J.length>1){const B=J[0].remoteAuthority;if(J.every($=>(0,g.isEqualAuthority)($.remoteAuthority,B))){const $=await this.workspacesManagementMainService.createUntitledWorkspace(J.map(K=>({uri:K.workspace.uri})));T.push({workspace:$,remoteAuthority:B}),T=T.filter(K=>!ee(K))}}}if(A.initialStartup&&!z&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const J=await this.doGetPathsFromLastSession();T.unshift(...J.filter(B=>q(B)||ee(B)||B.backupPath))}return T}async doExtractPathsFromAPI(A){const T={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority},Z=await Promise.all((0,M.coalesce)(A.urisToOpen||[]).map(async z=>{const J=await this.resolveOpenable(z,T);if(J)return J.label=z.label,J;const B=this.resourceFromOpenable(z);this.dialogMainService.showMessageBox({type:"info",buttons:[(0,p.localize)(0,null)],message:B.scheme===E.Schemas.file?(0,p.localize)(1,null):(0,p.localize)(2,null),detail:B.scheme===E.Schemas.file?(0,p.localize)(3,null,(0,w.getPathLabel)(B,{os:v.OS,tildify:this.environmentMainService})):(0,p.localize)(4,null,B.toString(!0))},C.BrowserWindow.getFocusedWindow()??void 0)}));return(0,M.coalesce)(Z)}async doExtractPathsFromCLI(A){const T=[],Z={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:A.diff&&A._.length===2||A.merge&&A._.length===4},z=A["folder-uri"];if(z){const $=await Promise.all(z.map(K=>{const re=this.cliArgToUri(K);if(re)return this.resolveOpenable({folderUri:re},Z)}));T.push(...(0,M.coalesce)($))}const J=A["file-uri"];if(J){const $=await Promise.all(J.map(K=>{const re=this.cliArgToUri(K);if(re)return this.resolveOpenable((0,ce.hasWorkspaceFileExtension)(K)?{workspaceUri:re}:{fileUri:re},Z)}));T.push(...(0,M.coalesce)($))}const B=await Promise.all(A._.map($=>Z.remoteAuthority?this.doResolveRemotePath($,Z):this.doResolveFilePath($,Z)));return T.push(...(0,M.coalesce)(B)),T}cliArgToUri(A){try{const T=d.URI.parse(A);if(!T.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${A}`);return}return T.path?T:T.with({path:"/"})}catch(T){this.logService.error(`Invalid URI input string: ${A}, ${T.message}`)}}async doGetPathsFromLastSession(){const A=this.getRestoreWindowsSetting();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":{const T=[];A!=="one"&&T.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&T.push(this.windowsStateHandler.state.lastActiveWindow);const Z=await Promise.all(T.map(async z=>{if(z.workspace){const J=await this.resolveOpenable({workspaceUri:z.workspace.configPath},{remoteAuthority:z.remoteAuthority,rejectTransientWorkspaces:!0});if(q(J))return J}else if(z.folderUri){const J=await this.resolveOpenable({folderUri:z.folderUri},{remoteAuthority:z.remoteAuthority});if(ee(J))return J}else if(A!=="folders"&&z.backupPath)return{backupPath:z.backupPath,remoteAuthority:z.remoteAuthority}}));return(0,M.coalesce)(Z)}}}getRestoreWindowsSetting(){let A;return this.lifecycleMainService.wasRestarted?A="all":(A=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}async resolveOpenable(A,T=Object.create(null)){const Z=this.resourceFromOpenable(A);return Z.scheme===E.Schemas.file?((0,_.isFileToOpen)(A)&&(T={...T,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(Z.fsPath,T)):this.doResolveRemoteOpenable(A,T)}doResolveRemoteOpenable(A,T){let Z=this.resourceFromOpenable(A);const z=(0,P.getRemoteAuthority)(Z)||T.remoteAuthority;if(Z=(0,g.removeTrailingPathSeparator)((0,g.normalizePath)(Z)),(0,_.isFileToOpen)(A)){if(T.gotoLineMode){const{path:J,line:B,column:$}=(0,l.parseLineAndColumnAware)(Z.path);return{fileUri:Z.with({path:J}),options:{selection:B?{startLineNumber:B,startColumn:$||1}:void 0},remoteAuthority:z}}return{fileUri:Z,remoteAuthority:z}}else if((0,_.isWorkspaceToOpen)(A))return{workspace:(0,se.getWorkspaceIdentifier)(Z),remoteAuthority:z};return{workspace:(0,se.getSingleFolderWorkspaceIdentifier)(Z),remoteAuthority:z}}resourceFromOpenable(A){return(0,_.isWorkspaceToOpen)(A)?A.workspaceUri:(0,_.isFolderToOpen)(A)?A.folderUri:A.fileUri}async doResolveFilePath(A,T,Z){let z,J;T.gotoLineMode&&({path:A,line:z,column:J}=(0,l.parseLineAndColumnAware)(A)),A=(0,l.sanitizeFilePath)((0,u.normalize)(A),(0,m.cwd)());try{const B=await L.Promises.stat(A);if(B.isFile()){if(!T.forceOpenWorkspaceAsFile){const $=await this.workspacesManagementMainService.resolveLocalWorkspace(d.URI.file(A));if($)return $.transient&&T.rejectTransientWorkspaces?void 0:{workspace:{id:$.id,configPath:$.configPath},type:i.FileType.File,exists:!0,remoteAuthority:$.remoteAuthority,transient:$.transient}}return{fileUri:d.URI.file(A),type:i.FileType.File,exists:!0,options:{selection:z?{startLineNumber:z,startColumn:J||1}:void 0}}}else{if(B.isDirectory())return{workspace:(0,se.getSingleFolderWorkspaceIdentifier)(d.URI.file(A),B),type:i.FileType.Directory,exists:!0};if(!v.isWindows&&A==="/dev/null")return{fileUri:d.URI.file(A),type:i.FileType.File,exists:!0}}}catch(B){if(B.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!Z)return this.onUNCHostNotAllowed(A,T);const $=d.URI.file(A);if(this.workspacesHistoryMainService.removeRecentlyOpened([$]),T.ignoreFileNotFound)return{fileUri:$,type:i.FileType.File,exists:!1}}}async onUNCHostNotAllowed(A,T){const Z=d.URI.file(A),{response:z,checkboxChecked:J}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,p.localize)(5,null),(0,p.localize)(6,null),(0,p.localize)(7,null)],message:(0,p.localize)(8,null,Z.authority),detail:(0,p.localize)(9,null,(0,w.getPathLabel)(Z,{os:v.OS,tildify:this.environmentMainService})),checkboxLabel:(0,p.localize)(10,null,Z.authority),cancelId:1});if(z===0){if((0,r.addUNCHostToAllowlist)(Z.authority),J){const B={channel:"vscode:configureAllowedUNCHost",args:Z.authority};this.sendToFocused(B.channel,B.args),this.sendToOpeningWindow(B.channel,B.args)}return this.doResolveFilePath(A,T,!0)}if(z===2)return C.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.onUNCHostNotAllowed(A,T)}doResolveRemotePath(A,T){const Z=A.charCodeAt(0),z=T.remoteAuthority;let J,B;T.gotoLineMode&&({path:A,line:J,column:B}=(0,l.parseLineAndColumnAware)(A)),Z!==47&&((0,l.isWindowsDriveLetter)(Z)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,l.toSlashes)(A)),A=`/${A}`);const $=d.URI.from({scheme:E.Schemas.vscodeRemote,authority:z,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,ce.hasWorkspaceFileExtension)(A))return T.forceOpenWorkspaceAsFile?{fileUri:$,options:{selection:J?{startLineNumber:J,startColumn:B||1}:void 0},remoteAuthority:T.remoteAuthority}:{workspace:(0,se.getWorkspaceIdentifier)($),remoteAuthority:z};if(T.gotoLineMode||u.posix.basename(A).indexOf(".")!==-1)return{fileUri:$,options:{selection:J?{startLineNumber:J,startColumn:B||1}:void 0},remoteAuthority:z}}return{workspace:(0,se.getSingleFolderWorkspaceIdentifier)($),remoteAuthority:z}}shouldOpenNewWindow(A){const T=this.configurationService.getValue("window"),Z=T?.openFoldersInNewWindow||"default",z=T?.openFilesInNewWindow||"off";let J=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(Z==="on"||Z==="off")&&(J=Z==="on");let B=!1;return A.forceNewWindow||A.forceReuseWindow?B=!!A.forceNewWindow&&!A.forceReuseWindow:(v.isMacintosh?A.context===1&&(B=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(B=!0),!A.cli.extensionDevelopmentPath&&(z==="on"||z==="off")&&(B=z==="on")),{openFolderInNewWindow:!!J,openFilesInNewWindow:B}}async openExtensionDevelopmentHostWindow(A,T){const Z=(0,j.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if(Z)return this.lifecycleMainService.reload(Z,T.cli),Z.focus(),[Z];let z=T.cli["folder-uri"]||[],J=T.cli["file-uri"]||[],B=T.cli._;if(!B.length&&!z.length&&!J.length&&!T.cli.extensionTestsPath){const re=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,le=re?.workspace??re?.folderUri;le&&(d.URI.isUri(le)?le.scheme===E.Schemas.file?B=[le.fsPath]:z=[le.toString()]:le.configPath.scheme===E.Schemas.file?B=[(0,g.originalFSPath)(le.configPath)]:J=[le.configPath.toString()])}let $=T.remoteAuthority;for(const re of A)if(re.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const le=d.URI.parse(re),ge=(0,P.getRemoteAuthority)(le);ge&&($?(0,g.isEqualAuthority)(ge,$)||this.logService.error("more than one extension development path authority"):$=ge)}B=B.filter(re=>{const le=d.URI.file(re);return(0,j.findWindowOnWorkspaceOrFolder)(this.getWindows(),le)?!1:(0,g.isEqualAuthority)((0,P.getRemoteAuthority)(le),$)}),z=z.filter(re=>{const le=this.cliArgToUri(re);return le&&(0,j.findWindowOnWorkspaceOrFolder)(this.getWindows(),le)?!1:le?(0,g.isEqualAuthority)((0,P.getRemoteAuthority)(le),$):!1}),J=J.filter(re=>{const le=this.cliArgToUri(re);return le&&(0,j.findWindowOnWorkspaceOrFolder)(this.getWindows(),le)?!1:le?(0,g.isEqualAuthority)((0,P.getRemoteAuthority)(le),$):!1}),T.cli._=B,T.cli["folder-uri"]=z,T.cli["file-uri"]=J;const K={context:T.context,cli:T.cli,forceNewWindow:!0,forceEmpty:!B.length&&!z.length&&!J.length,userEnv:T.userEnv,noRecentEntry:!0,waitMarkerFileURI:T.waitMarkerFileURI,remoteAuthority:$,forceProfile:T.forceProfile,forceTempProfile:T.forceTempProfile};return this.open(K)}async openInBrowserWindow(A){const T=this.configurationService.getValue("window"),Z=this.getLastActiveWindow(),z=Z?.profile??this.userDataProfilesMainService.defaultProfile;let J;!A.forceNewWindow&&!A.forceNewTabbedWindow&&(J=A.windowToUse||Z,J&&J.focus());const B={...this.environmentMainService.args,...A.cli,machineId:this.machineId,sqmId:this.sqmId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,u.join)(this.environmentMainService.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.userDataProfilesMainService.profilesHome,all:this.userDataProfilesMainService.profiles,profile:z},homeDir:this.environmentMainService.userHome.with({scheme:E.Schemas.file}).fsPath,tmpDir:this.environmentMainService.tmpDir.with({scheme:E.Schemas.file}).fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.initialUserEnv,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToMerge:A.filesToOpen?.filesToMerge,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.loggerService.getLogLevel(),loggers:{window:[],global:this.loggerService.getRegisteredLoggers()},logsPath:this.environmentMainService.logsHome.with({scheme:E.Schemas.file}).fsPath,product:R.default,isInitialStartup:A.initialStartup,perfMarks:(0,y.getMarks)(),os:{release:(0,O.release)(),hostname:(0,O.hostname)(),arch:(0,O.arch)()},autoDetectHighContrast:T?.autoDetectHighContrast??!0,autoDetectColorScheme:T?.autoDetectColorScheme??!1,accessibilitySupport:C.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn};if(J){const $=J.config;!B.extensionDevelopmentPath&&$?.extensionDevelopmentPath&&(B.extensionDevelopmentPath=$.extensionDevelopmentPath,B.extensionDevelopmentKind=$.extensionDevelopmentKind,B["enable-proposed-api"]=$["enable-proposed-api"],B.verbose=$.verbose,B["inspect-extensions"]=$["inspect-extensions"],B["inspect-brk-extensions"]=$["inspect-brk-extensions"],B.debugId=$.debugId,B.extensionEnvironment=$.extensionEnvironment,B["extensions-dir"]=$["extensions-dir"],B["disable-extensions"]=$["disable-extensions"]),B.loggers={global:B.loggers.global,window:$?.loggers.window??B.loggers.window}}else{const $=this.windowsStateHandler.getNewWindowState(B);(0,y.mark)("code/willCreateCodeWindow");const K=J=this.instantiationService.createInstance(N.CodeWindow,{state:$,extensionDevelopmentPath:B.extensionDevelopmentPath,isExtensionTestHost:!!B.extensionTestsPath});(0,y.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(K),this.windows.set(K.id,K),this._onDidOpenWindow.fire(K),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const re=new b.DisposableStore;re.add(K.onDidSignalReady(()=>this._onDidSignalReadyWindow.fire(K))),re.add(f.Event.once(K.onDidClose)(()=>this.onWindowClosed(K,re))),re.add(f.Event.once(K.onDidDestroy)(()=>this.onWindowDestroyed(K))),re.add(K.onDidMaximize(()=>this._onDidMaximizeWindow.fire(K))),re.add(K.onDidUnmaximize(()=>this._onDidUnmaximizeWindow.fire(K))),re.add(K.onDidEnterFullScreen(()=>this._onDidChangeFullScreen.fire({window:K,fullscreen:!0}))),re.add(K.onDidLeaveFullScreen(()=>this._onDidChangeFullScreen.fire({window:K,fullscreen:!1}))),re.add(K.onDidTriggerSystemContextMenu(({x:ge,y:we})=>this._onDidTriggerSystemContextMenu.fire({window:K,x:ge,y:we})));const le=(0,h.assertIsDefined)(K.win?.webContents);le.removeAllListeners("devtools-reload-page"),le.on("devtools-reload-page",()=>this.lifecycleMainService.reload(K)),this.lifecycleMainService.registerWindow(K)}return B.windowId=J.id,J.isReady?this.lifecycleMainService.unload(J,4).then(async $=>{$||await this.doOpenInBrowserWindow(J,B,A,z)}):await this.doOpenInBrowserWindow(J,B,A,z),J}async doOpenInBrowserWindow(A,T,Z,z){if(T.extensionDevelopmentPath||((0,ce.isWorkspaceIdentifier)(T.workspace)?T.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:T.workspace,remoteAuthority:T.remoteAuthority}):(0,ce.isSingleFolderWorkspaceIdentifier)(T.workspace)?T.backupPath=this.backupMainService.registerFolderBackup({folderUri:T.workspace.uri,remoteAuthority:T.remoteAuthority}):T.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:Z.emptyWindowBackupInfo?.backupFolder??(0,se.createEmptyWorkspaceIdentifier)().id,remoteAuthority:T.remoteAuthority})),this.userDataProfilesMainService.isEnabled()){const J=T.workspace??(0,ce.toWorkspaceIdentifier)(T.backupPath,!1),B=this.resolveProfileForBrowserWindow(Z,J,z),$=B instanceof Promise?await B:B;T.profiles.profile=$,T.extensionDevelopmentPath||await this.userDataProfilesMainService.setProfileForWorkspace(J,$)}A.load(T)}resolveProfileForBrowserWindow(A,T,Z){return A.forceProfile?this.userDataProfilesMainService.profiles.find(z=>z.name===A.forceProfile)??this.userDataProfilesMainService.createNamedProfile(A.forceProfile):A.forceTempProfile?this.userDataProfilesMainService.createTransientProfile():this.userDataProfilesMainService.getProfileForWorkspace(T)??Z}onWindowClosed(A,T){this.windows.delete(A.id),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),T.dispose()}onWindowDestroyed(A){this.windows.delete(A.id),this._onDidDestroyWindow.fire(A)}getFocusedWindow(){const A=C.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(A){return this.doGetLastActiveWindow(this.getWindows().filter(T=>(0,g.isEqualAuthority)(T.remoteAuthority,A)))}doGetLastActiveWindow(A){return(0,U.getLastFocused)(A)}sendToFocused(A,...T){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(A,I.CancellationToken.None,...T)}sendToOpeningWindow(A,...T){this._register(f.Event.once(this.onDidSignalReadyWindow)(Z=>{Z.sendWhenReady(A,I.CancellationToken.None,...T)}))}sendToAll(A,T,Z){for(const z of this.getWindows())Z&&Z.indexOf(z.id)>=0||z.sendWhenReady(A,I.CancellationToken.None,T)}getWindows(){return Array.from(this.windows.values())}getWindowCount(){return this.windows.size}getWindowById(A){return this.windows.get(A)}getWindowByWebContents(A){const T=C.BrowserWindow.fromWebContents(A);if(T)return this.getWindowById(T.id)}};e.WindowsMainService=de,e.WindowsMainService=de=be([ne(3,S.ILogService),ne(4,F.ILoggerMainService),ne(5,D.IStateService),ne(6,x.IPolicyService),ne(7,s.IEnvironmentMainService),ne(8,W.IUserDataProfilesMainService),ne(9,c.ILifecycleMainService),ne(10,a.IBackupMainService),ne(11,t.IConfigurationService),ne(12,ue.IWorkspacesHistoryMainService),ne(13,X.IWorkspacesManagementMainService),ne(14,n.IInstantiationService),ne(15,o.IDialogMainService),ne(16,i.IFileService),ne(17,k.IProtocolMainService),ne(18,Y.IThemeMainService),ne(19,H.IAuxiliaryWindowsMainService)],de)}),define(oe[307],ae([0,1,66,29,83,57]),function(Q,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(f,l,w,b){this.workspacesManagementMainService=f,this.windowsMainService=l,this.workspacesHistoryMainService=w,this.backupMainService=b,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(f,l){const w=this.windowsMainService.getWindowById(f);if(w)return this.workspacesManagementMainService.enterWorkspace(w,this.windowsMainService.getWindows(),l)}createUntitledWorkspace(f,l,w){return this.workspacesManagementMainService.createUntitledWorkspace(l,w)}deleteUntitledWorkspace(f,l){return this.workspacesManagementMainService.deleteUntitledWorkspace(l)}getWorkspaceIdentifier(f,l){return this.workspacesManagementMainService.getWorkspaceIdentifier(l)}getRecentlyOpened(f){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(f,l){return this.workspacesHistoryMainService.addRecentlyOpened(l)}removeRecentlyOpened(f,l){return this.workspacesHistoryMainService.removeRecentlyOpened(l)}clearRecentlyOpened(f){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};e.WorkspacesMainService=M,e.WorkspacesMainService=M=be([ne(0,O.IWorkspacesManagementMainService),ne(1,L.IWindowsMainService),ne(2,r.IWorkspacesHistoryMainService),ne(3,C.IBackupMainService)],M)}),define(oe[308],ae([0,1,15,132,37,26,17,51,14,33,3,42,47,2,13,9,4,12,7,32,158,43,159,111,290,162,66,283,18,200,91,133,55,117,220,24,64,94,209,293,211,212,213,16,224,93,78,6,92,219,299,284,291,20,5,305,71,27,59,294,95,34,275,82,123,28,251,253,54,49,265,288,300,289,301,128,267,268,269,272,297,60,29,306,274,30,97,83,307,57,39,233,56,244,53,81,130,277,292,280,8,255,276,228,69,296,271,22,126,295,263,239,62,65,303]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y,v,m,g,h,d,p,a,t,o,s,i,n,c,S,R,k,P,D,_,N,U,j,V,ce,se,ue,X,Y,x,W,F,H,q,ee,de,G,A,T,Z,z,J,B,$,K,re,le,ge,we,Ie,De,We,Ee,Se,te,he,me,Ce,Oe,Ne,_e,Ve,$e,xe,He,ie,fe,ve,Pe,ye,Le,Ue,qe,Ke,Je,Qe,Xe,nt,rt,ot,St,yt,bt,Et,Pt,It,at,gt,Ct,kt,Dt,ct,Mt,mt,lt,Rt,Lt,ut,At,dt,Ot){"use strict";var ht;Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let ft=class extends u.Disposable{static{ht=this}static{this.SECURITY_PROTOCOL_HANDLING_CONFIRMATION_SETTING_KEY={[y.Schemas.file]:"security.promptForLocalFileProtocolHandling",[y.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(ke,Me,Ae,pe,Re,Be,ze,Ge,Te,Fe,je,Ye){super(),this.mainProcessNodeIpcServer=ke,this.userEnv=Me,this.mainInstantiationService=Ae,this.logService=pe,this.loggerService=Re,this.environmentMainService=Be,this.lifecycleMainService=ze,this.configurationService=Ge,this.stateService=Te,this.fileService=Fe,this.productService=je,this.userDataProfilesMainService=Ye,this.configureSession(),this.registerListeners()}configureSession(){const ke=Te=>Te?.startsWith(`${y.Schemas.vscodeWebview}://`),Me=new Set(["clipboard-read","clipboard-sanitized-write"]);C.session.defaultSession.setPermissionRequestHandler((Te,Fe,je,Ye)=>ke(Ye.requestingUrl)?je(Me.has(Fe)):je(!1)),C.session.defaultSession.setPermissionCheckHandler((Te,Fe,je,Ye)=>ke(Ye.requestingUrl)?Me.has(Fe):!1);const Ae=new Set([y.Schemas.file,y.Schemas.vscodeFileResource,y.Schemas.vscodeRemoteResource,y.Schemas.vscodeManagedRemoteResource,"devtools"]),pe=Te=>{for(let Fe=Te;Fe;Fe=Fe.parent)if(Fe.url.startsWith(`${y.Schemas.vscodeWebview}://`))return!0;return!1},Re=Te=>Te.resourceType==="xhr"||pe(Te.frame),Be=Te=>{const Fe=Te.frame;if(!Fe||!this.windowsMainService)return!1;const je=C.BrowserWindow.getAllWindows();for(const Ye of je)if(Fe.processId===Ye.webContents.mainFrame.processId)return!0;return!1},ze=(Te,Fe)=>{if(Te.path!=="/index.html")return!0;const je=Fe.frame;if(!je||!this.windowsMainService)return!1;for(const Ye of this.windowsMainService.getWindows())if(Ye.win&&je.processId===Ye.win.webContents.mainFrame.processId)return!0;return!1};C.session.defaultSession.webRequest.onBeforeRequest((Te,Fe)=>{const je=h.URI.parse(Te.url);return je.scheme===y.Schemas.vscodeWebview&&!ze(je,Te)?(this.logService.error("Blocked vscode-webview request",Te.url),Fe({cancel:!0})):je.scheme===y.Schemas.vscodeFileResource&&!Be(Te)?(this.logService.error("Blocked vscode-file request",Te.url),Fe({cancel:!0})):je.path.endsWith(".svg")&&!Ae.has(je.scheme)?Fe({cancel:!Re(Te)}):Fe({cancel:!1})}),C.session.defaultSession.webRequest.onHeadersReceived((Te,Fe)=>{const je=Te.responseHeaders,Ye=je["content-type"]||je["Content-Type"];if(Ye&&Array.isArray(Ye)){const Ze=h.URI.parse(Te.url);if(Ze.path.endsWith(".svg")&&Ae.has(Ze.scheme))return je["Content-Type"]=["image/svg+xml"],Fe({cancel:!1,responseHeaders:je});if(!Ze.path.endsWith(y.Schemas.vscodeRemoteResource)&&Ye.some(tt=>tt.toLowerCase().includes("image/svg")))return Fe({cancel:!Re(Te)})}return Fe({cancel:!1})}),C.session.defaultSession.webRequest.onHeadersReceived((Te,Fe)=>{if(Te.url.startsWith("https://vscode.download.prss.microsoft.com/")){const je=Te.responseHeaders??Object.create(null);if(je["Access-Control-Allow-Origin"]===void 0)return je["Access-Control-Allow-Origin"]=["*"],Fe({cancel:!1,responseHeaders:je})}return Fe({cancel:!1})});const Ge=C.session.defaultSession;typeof Ge.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Ge.setCodeCachePath((0,v.join)(this.environmentMainService.codeCachePath,"chrome")),m.isWindows&&(this.configurationService.getValue("security.restrictUNCAccess")===!1?(0,L.disableUNCAccessRestrictions)():(0,L.addUNCHostToAllowlist)(this.configurationService.getValue("security.allowedUNCHosts")))}registerListeners(){(0,f.setUnexpectedErrorHandler)(Ae=>this.onUnexpectedError(Ae)),process.on("uncaughtException",Ae=>{(0,f.isSigPipeError)(Ae)||(0,f.onUnexpectedError)(Ae)}),process.on("unhandledRejection",Ae=>(0,f.onUnexpectedError)(Ae)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,p.registerContextMenuListener)(),C.app.on("accessibility-support-changed",(Ae,pe)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",pe)}),C.app.on("activate",async(Ae,pe)=>{this.logService.trace("app#activate"),pe||await this.windowsMainService?.openEmptyWindow({context:1})}),C.app.on("web-contents-created",(Ae,pe)=>{(0,dt.isAuxiliaryWindow)(pe)&&(this.logService.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.auxiliaryWindowsMainService?.registerWindow(pe)),pe.on("will-navigate",Re=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Re.preventDefault()}),pe.setWindowOpenHandler(Re=>Re.url==="about:blank"?(this.logService.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.auxiliaryWindowsMainService?.createWindow()}):(this.logService.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Re.url}}`),this.nativeHostMainService?.openExternal(void 0,Re.url),{action:"deny"}))});let ke=[],Me;C.app.on("open-file",(Ae,pe)=>{this.logService.trace("app#open-file: ",pe),Ae.preventDefault(),ke.push((0,Ue.hasWorkspaceFileExtension)(pe)?{workspaceUri:h.URI.file(pe)}:{fileUri:h.URI.file(pe)}),Me!==void 0&&(clearTimeout(Me),Me=void 0),Me=setTimeout(async()=>{await this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:ke,gotoLineMode:!1,preferNewWindow:!0}),ke=[],Me=void 0},100)}),C.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:4})}),r.validatedIpcMain.handle("vscode:fetchShellEnv",Ae=>{const pe=this.windowsMainService?.getWindowByWebContents(Ae.sender);let Re,Be;return pe?.config?(Re=pe.config,Be={...process.env,...pe.config.userEnv}):(Re=this.environmentMainService.args,Be=process.env),this.resolveShellEnvironment(Re,Be,!1)}),r.validatedIpcMain.handle("vscode:writeNlsFile",(Ae,pe,Re)=>{const Be=this.validateNlsPath([pe]);if(!Be||typeof Re!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Be,M.VSBuffer.fromString(Re))}),r.validatedIpcMain.handle("vscode:readNlsFile",async(Ae,...pe)=>{const Re=this.validateNlsPath(pe);if(!Re)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Re)).value.toString()}),r.validatedIpcMain.on("vscode:toggleDevTools",Ae=>Ae.sender.toggleDevTools()),r.validatedIpcMain.on("vscode:openDevTools",Ae=>Ae.sender.openDevTools()),r.validatedIpcMain.on("vscode:reloadWindow",Ae=>Ae.sender.reload()),r.validatedIpcMain.handle("vscode:notifyZoomLevel",async(Ae,pe)=>{const Re=this.windowsMainService?.getWindowById(Ae.sender.id);Re&&Re.notifyZoomLevel(pe)})}validateNlsPath(ke){let Me;for(const Ae of ke)typeof Ae=="string"&&(typeof Me!="string"?Me=Ae:Me=(0,v.join)(Me,Ae));if(!(typeof Me!="string"||!(0,v.isAbsolute)(Me)||!(0,l.isEqualOrParent)(Me,this.environmentMainService.cachedLanguagesPath,!m.isLinux)))return h.URI.file(Me)}onUnexpectedError(ke){if(ke){const Me={message:`[uncaught exception in main]: ${ke.message}`,stack:ke.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Me))}this.logService.error(`[uncaught exception in main]: ${ke}`),ke.stack&&this.logService.error(ke.stack)}async startup(){this.logService.debug("Starting VSCodium"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const ke=this.productService.win32AppUserModelId;m.isWindows&&ke&&C.app.setAppUserModelId(ke);try{m.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!C.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&C.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Fe){this.logService.error(Fe)}const Me=new t.Server;this.lifecycleMainService.onWillShutdown(Fe=>{Fe.reason===2&&Me.dispose()}),this.logService.trace("Resolving machine identifier...");const[Ae,pe]=await Promise.all([(0,gt.resolveMachineId)(this.stateService,this.logService),(0,gt.resolveSqmId)(this.stateService,this.logService)]);this.logService.trace(`Resolved machine identifier: ${Ae}`);const{sharedProcessReady:Re,sharedProcessClient:Be}=this.setupSharedProcess(Ae,pe),ze=await this.initServices(Ae,pe,Re);this._register(ze.createInstance(s.ProxyAuthHandler)),this._register(ze.createInstance(Pt.UserDataProfilesHandler)),ze.invokeFunction(Fe=>this.initChannels(Fe,Me,Be));const Ge=await ze.invokeFunction(Fe=>this.setupProtocolUrlHandlers(Fe,Me));this.setupManagedRemoteResourceUrlHandler(Me),this.lifecycleMainService.phase=2,await ze.invokeFunction(Fe=>this.openFirstWindow(Fe,Ge)),this.lifecycleMainService.phase=3,this.afterWindowOpen(),this._register(new at.RunOnceScheduler(()=>{this._register((0,at.runWhenGlobalIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}async setupProtocolUrlHandlers(ke,Me){const Ae=this.windowsMainService=ke.get(Pe.IWindowsMainService),pe=ke.get(Ve.IURLService),Re=this.nativeHostMainService=ke.get(B.INativeHostMainService),Be=ke.get(D.IDialogMainService),ze=this;pe.registerHandler({async handleURL(Ze,tt){return ze.handleProtocolUrl(Ae,Be,pe,Ze,tt)}});const Ge=this._register(new Le.ActiveWindowManager({onDidOpenMainWindow:Re.onDidOpenMainWindow,onDidFocusMainWindow:Re.onDidFocusMainWindow,getActiveWindowId:()=>Re.getActiveWindowId(-1)})),Te=new a.StaticRouter(Ze=>Ge.getActiveClientId().then(tt=>Ze===tt)),Fe=new $e.URLHandlerRouter(Te,this.logService),je=Me.getChannel("urlHandler",Fe);pe.registerHandler(new $e.URLHandlerChannelClient(je));const Ye=await this.resolveInitialProtocolUrls(Ae,Be);return this._register(new He.ElectronURLListener(Ye?.urls,pe,Ae,this.environmentMainService,this.productService,this.logService)),Ye}setupManagedRemoteResourceUrlHandler(ke){const Me=()=>({statusCode:404,data:"Not found"}),Ae=new At.Lazy(()=>ke.getChannel(ut.NODE_REMOTE_RESOURCE_CHANNEL_NAME,new ut.NodeRemoteResourceRouter));C.protocol.registerBufferProtocol(y.Schemas.vscodeManagedRemoteResource,(pe,Re)=>{const Be=h.URI.parse(pe.url);if(!Be.authority.startsWith("window:"))return Re(Me());Ae.value.call(ut.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME,[Be]).then(ze=>Re({...ze,data:Buffer.from(ze.body,"base64")}),ze=>{this.logService.warn("error dispatching remote resource call",ze),Re({statusCode:500,data:String(ze)})})})}async resolveInitialProtocolUrls(ke,Me){const Ae=this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[];Ae.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ae);const pe=global.getOpenUrls()||[];if(pe.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",pe),Ae.length+pe.length===0)return;const Re=[...Ae,...pe].map(Ge=>{try{return{uri:h.URI.parse(Ge),originalUrl:Ge}}catch{this.logService.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ge);return}}),Be=[],ze=[];for(const Ge of Re){if(!Ge)continue;const Te=this.getWindowOpenableFromProtocolUrl(Ge.uri);if(Te)if(await this.shouldBlockOpenable(Te,ke,Me)){this.logService.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ge.uri.toString(!0));continue}else this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ge.uri.toString(!0),Te),Be.push(Te);else this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ge.uri.toString(!0)),ze.push(Ge)}return{urls:ze,openables:Be}}async shouldBlockOpenable(ke,Me,Ae){let pe,Re;if((0,ve.isWorkspaceToOpen)(ke)?(pe=ke.workspaceUri,Re=(0,i.localize)(0,null,pe.scheme===y.Schemas.file?(0,E.getPathLabel)(pe,{os:m.OS,tildify:this.environmentMainService}):pe.toString(!0),this.productService.nameShort)):(0,ve.isFolderToOpen)(ke)?(pe=ke.folderUri,Re=(0,i.localize)(1,null,pe.scheme===y.Schemas.file?(0,E.getPathLabel)(pe,{os:m.OS,tildify:this.environmentMainService}):pe.toString(!0),this.productService.nameShort)):(pe=ke.fileUri,Re=(0,i.localize)(2,null,pe.scheme===y.Schemas.file?(0,E.getPathLabel)(pe,{os:m.OS,tildify:this.environmentMainService}):pe.toString(!0),this.productService.nameShort)),pe.scheme!==y.Schemas.file&&pe.scheme!==y.Schemas.vscodeRemote||this.configurationService.getValue(ht.SECURITY_PROTOCOL_HANDLING_CONFIRMATION_SETTING_KEY[pe.scheme])===!1)return!1;const{response:ze,checkboxChecked:Ge}=await Ae.showMessageBox({type:"warning",buttons:[(0,i.localize)(3,null),(0,i.localize)(4,null)],message:Re,detail:(0,i.localize)(5,null),checkboxLabel:pe.scheme===y.Schemas.file?(0,i.localize)(6,null):(0,i.localize)(7,null),cancelId:1});if(ze!==0)return!0;if(Ge){const Te={channel:"vscode:disablePromptForProtocolHandling",args:pe.scheme===y.Schemas.file?"local":"remote"};Me.sendToFocused(Te.channel,Te.args),Me.sendToOpeningWindow(Te.channel,Te.args)}return!1}getWindowOpenableFromProtocolUrl(ke){if(ke.path){if(ke.authority===y.Schemas.file){const Me=h.URI.file(ke.fsPath);return(0,Ue.hasWorkspaceFileExtension)(Me)?{workspaceUri:Me}:{fileUri:Me}}else if(ke.authority===y.Schemas.vscodeRemote){const Me=ke.path.indexOf(v.posix.sep,1);if(Me!==-1){const Ae=ke.path.substring(1,Me),pe=ke.path.substring(Me);let Re=ke.query;const Be=new URLSearchParams(ke.query);Be.get("windowId")==="_blank"&&(Be.delete("windowId"),Re=Be.toString());const ze=h.URI.from({scheme:y.Schemas.vscodeRemote,authority:Ae,path:pe,query:Re,fragment:ke.fragment});return(0,Ue.hasWorkspaceFileExtension)(pe)?{workspaceUri:ze}:/:[\d]+$/.test(pe)?{fileUri:ze}:{folderUri:ze}}}}}async handleProtocolUrl(ke,Me,Ae,pe,Re){this.logService.trace("app#handleProtocolUrl():",pe.toString(!0),Re),pe.scheme===this.productService.urlProtocol&&pe.path==="workspace"&&(pe=pe.with({authority:"file",path:h.URI.parse(pe.query).path,query:""}));let Be=!1;const ze=new URLSearchParams(pe.query);ze.get("windowId")==="_blank"?(this.logService.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",pe.toString(!0)),ze.delete("windowId"),pe=pe.with({query:ze.toString()}),Be=!0):m.isMacintosh&&ke.getWindowCount()===0&&(this.logService.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",pe.toString(!0)),Be=!0);const Ge=ze.get("continueOn");Ge!==null&&(this.logService.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",pe.toString(!0)),ze.delete("continueOn"),pe=pe.with({query:ze.toString()}),this.environmentMainService.continueOn=Ge??void 0);const Te=this.getWindowOpenableFromProtocolUrl(pe);return Te?await this.shouldBlockOpenable(Te,ke,Me)?(this.logService.trace("app#handleProtocolUrl() protocol url was blocked:",pe.toString(!0)),!0):(this.logService.trace("app#handleProtocolUrl() opening protocol url as window:",Te,pe.toString(!0)),(0,mt.firstOrDefault)(await ke.open({context:5,cli:{...this.environmentMainService.args},urisToOpen:[Te],forceNewWindow:Be,gotoLineMode:!0}))?.focus(),!0):Be?(this.logService.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",pe.toString(!0)),await(0,mt.firstOrDefault)(await ke.open({context:5,cli:{...this.environmentMainService.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,K.getRemoteAuthority)(pe)}))?.ready(),Ae.open(pe,Re)):(this.logService.trace("app#handleProtocolUrl(): not handled",pe.toString(!0),Re),!1)}setupSharedProcess(ke,Me){const Ae=this._register(this.mainInstantiationService.createInstance(re.SharedProcess,ke,Me)),pe=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Be=await Ae.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new o.Client(Be,"main")})();return{sharedProcessReady:(async()=>(await Ae.whenReady(),pe))(),sharedProcessClient:pe}}async initServices(ke,Me,Ae){const pe=new ee.ServiceCollection;switch(process.platform){case"win32":pe.set(he.IUpdateService,new H.SyncDescriptor(_e.Win32UpdateService));break;case"linux":m.isLinuxSnap?pe.set(he.IUpdateService,new H.SyncDescriptor(Ne.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):pe.set(he.IUpdateService,new H.SyncDescriptor(Oe.LinuxUpdateService));break;case"darwin":pe.set(he.IUpdateService,new H.SyncDescriptor(Ce.DarwinUpdateService));break}pe.set(Pe.IWindowsMainService,new H.SyncDescriptor(ye.WindowsMainService,[ke,Me,this.userEnv],!1)),pe.set(dt.IAuxiliaryWindowsMainService,new H.SyncDescriptor(Ot.AuxiliaryWindowsMainService,void 0,!1));const Re=new D.DialogMainService(this.logService,this.productService);pe.set(D.IDialogMainService,Re),pe.set(T.ILaunchMainService,new H.SyncDescriptor(T.LaunchMainService,void 0,!1)),pe.set(P.IDiagnosticsMainService,new H.SyncDescriptor(P.DiagnosticsMainService,void 0,!1)),pe.set(k.IDiagnosticsService,a.ProxyChannel.toService((0,a.getDelayedChannel)(Ae.then(Fe=>Fe.getChannel("diagnostics"))))),pe.set(de.IIssueMainService,new H.SyncDescriptor(G.IssueMainService,[this.userEnv])),pe.set(_.IEncryptionMainService,new H.SyncDescriptor(N.EncryptionMainService)),pe.set(A.IKeyboardLayoutMainService,new H.SyncDescriptor(A.KeyboardLayoutMainService)),pe.set(B.INativeHostMainService,new H.SyncDescriptor(B.NativeHostMainService,void 0,!1)),pe.set(ie.IWebviewManagerService,new H.SyncDescriptor(fe.WebviewMainService)),pe.set(J.IMenubarMainService,new H.SyncDescriptor(J.MenubarMainService)),pe.set(ce.IExtensionHostStarter,new H.SyncDescriptor(se.ExtensionHostStarter)),pe.set(Ie.IStorageMainService,new H.SyncDescriptor(Ie.StorageMainService)),pe.set(Ie.IApplicationStorageMainService,new H.SyncDescriptor(Ie.ApplicationStorageMainService));const Be=new Rt.ElectronPtyHostStarter({graceTime:6e4,shortGraceTime:6e3,scrollback:this.configurationService.getValue("terminal.integrated.persistentSessionScrollback")??100},this.configurationService,this.environmentMainService,this.lifecycleMainService,this.logService),ze=new Lt.PtyHostService(Be,this.configurationService,this.logService,this.loggerService);pe.set(lt.ILocalPtyService,ze),m.isWindows?pe.set(ue.IExternalTerminalMainService,new H.SyncDescriptor(X.WindowsExternalTerminalService)):m.isMacintosh?pe.set(ue.IExternalTerminalMainService,new H.SyncDescriptor(X.MacExternalTerminalService)):m.isLinux&&pe.set(ue.IExternalTerminalMainService,new H.SyncDescriptor(X.LinuxExternalTerminalService));const Ge=new c.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateService);pe.set(n.IBackupMainService,Ge);const Te=new Qe.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,Ge,Re);if(pe.set(Qe.IWorkspacesManagementMainService,Te),pe.set(qe.IWorkspacesService,new H.SyncDescriptor(Je.WorkspacesMainService,void 0,!1)),pe.set(Ke.IWorkspacesHistoryMainService,new H.SyncDescriptor(Ke.WorkspacesHistoryMainService,void 0,!1)),pe.set(Ve.IURLService,new H.SyncDescriptor(xe.NativeURLService,void 0,!1)),(0,te.supportsTelemetry)(this.productService,this.environmentMainService)){const Fe=(0,te.isInternalTelemetry)(this.productService,this.configurationService),je=(0,a.getDelayedChannel)(Ae.then(st=>st.getChannel("telemetryAppender"))),Ye=new Ee.TelemetryAppenderClient(je),Ze=(0,De.resolveCommonProperties)((0,O.release)(),(0,O.hostname)(),process.arch,this.productService.commit,this.productService.version,ke,Me,Fe),tt=(0,te.getPiiPathsFromEnvironment)(this.environmentMainService),it={appenders:[Ye],commonProperties:Ze,piiPaths:tt,sendErrorTelemetry:!0};pe.set(We.ITelemetryService,new H.SyncDescriptor(Se.TelemetryService,[it],!1))}else pe.set(We.ITelemetryService,te.NullTelemetryService);return pe.set(yt.IExtensionsProfileScannerService,new H.SyncDescriptor(Ct.ExtensionsProfileScannerService,void 0,!0)),pe.set(bt.IExtensionsScannerService,new H.SyncDescriptor(Et.ExtensionsScannerService,void 0,!0)),pe.set(ct.IUtilityProcessWorkerMainService,new H.SyncDescriptor(ct.UtilityProcessWorkerMainService,void 0,!0)),await at.Promises.settled([Ge.initialize(),Te.initialize()]),this.mainInstantiationService.createChild(pe)}initChannels(ke,Me,Ae){const pe=this._register(new u.DisposableStore),Re=a.ProxyChannel.fromService(ke.get(T.ILaunchMainService),pe,{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Re);const Be=a.ProxyChannel.fromService(ke.get(P.IDiagnosticsMainService),pe,{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Be);const ze=new nt.PolicyChannel(ke.get(Xe.IPolicyService));Me.registerChannel("policy",ze),Ae.then(et=>et.registerChannel("policy",ze));const Ge=this.fileService.getProvider(y.Schemas.file);(0,g.assertType)(Ge instanceof F.DiskFileSystemProvider);const Te=new W.DiskFileSystemProviderChannel(Ge,this.logService,this.environmentMainService);Me.registerChannel(Y.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Te),Ae.then(et=>et.registerChannel(Y.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Te));const Fe=a.ProxyChannel.fromService(ke.get(rt.IUserDataProfilesMainService),pe);Me.registerChannel("userDataProfiles",Fe),Ae.then(et=>et.registerChannel("userDataProfiles",Fe));const je=new ot.RequestChannel(ke.get(St.IRequestService));Ae.then(et=>et.registerChannel("request",je));const Ye=new me.UpdateChannel(ke.get(he.IUpdateService));Me.registerChannel("update",Ye);const Ze=a.ProxyChannel.fromService(ke.get(de.IIssueMainService),pe);Me.registerChannel("issue",Ze);const tt=a.ProxyChannel.fromService(ke.get(_.IEncryptionMainService),pe);Me.registerChannel("encryption",tt);const it=a.ProxyChannel.fromService(ke.get(le.ISignService),pe);Me.registerChannel("sign",it);const st=a.ProxyChannel.fromService(ke.get(A.IKeyboardLayoutMainService),pe);Me.registerChannel("keyboardLayout",st),this.nativeHostMainService=ke.get(B.INativeHostMainService);const pt=a.ProxyChannel.fromService(this.nativeHostMainService,pe);Me.registerChannel("nativeHost",pt),Ae.then(et=>et.registerChannel("nativeHost",pt));const _t=a.ProxyChannel.fromService(ke.get(qe.IWorkspacesService),pe);Me.registerChannel("workspaces",_t);const Wt=a.ProxyChannel.fromService(ke.get(J.IMenubarMainService),pe);Me.registerChannel("menubar",Wt);const Tt=a.ProxyChannel.fromService(ke.get(Ve.IURLService),pe);Me.registerChannel("url",Tt);const Ft=a.ProxyChannel.fromService(ke.get(ie.IWebviewManagerService),pe);Me.registerChannel("webview",Ft);const vt=this._register(new we.StorageDatabaseChannel(this.logService,ke.get(Ie.IStorageMainService)));Me.registerChannel("storage",vt),Ae.then(et=>et.registerChannel("storage",vt));const Ut=this._register(new It.ProfileStorageChangesListenerChannel(ke.get(Ie.IStorageMainService),ke.get(rt.IUserDataProfilesMainService),this.logService));Ae.then(et=>et.registerChannel("profileStorageListener",Ut));const Nt=a.ProxyChannel.fromService(ke.get(lt.ILocalPtyService),pe);Me.registerChannel(lt.TerminalIpcChannels.LocalPty,Nt);const Bt=a.ProxyChannel.fromService(ke.get(ue.IExternalTerminalMainService),pe);Me.registerChannel("externalTerminal",Bt);const wt=new kt.LoggerChannel(ke.get(Dt.ILoggerMainService));Me.registerChannel("logger",wt),Ae.then(et=>et.registerChannel("logger",wt));const zt=new R.ElectronExtensionHostDebugBroadcastChannel(ke.get(Pe.IWindowsMainService));Me.registerChannel("extensionhostdebugservice",zt);const $t=a.ProxyChannel.fromService(ke.get(ce.IExtensionHostStarter),pe);Me.registerChannel(ce.ipcExtensionHostStarterChannelName,$t);const qt=a.ProxyChannel.fromService(ke.get(ct.IUtilityProcessWorkerMainService),pe);Me.registerChannel(Mt.ipcUtilityProcessWorkerChannelName,qt)}async openFirstWindow(ke,Me){const Ae=this.windowsMainService=ke.get(Pe.IWindowsMainService);this.auxiliaryWindowsMainService=ke.get(dt.IAuxiliaryWindowsMainService);const pe=(0,j.isLaunchedFromCli)(process.env)?0:4,Re=this.environmentMainService.args;if(Me){if(Me.openables.length>0)return Ae.open({context:pe,cli:Re,urisToOpen:Me.openables,gotoLineMode:!0,initialStartup:!0});if(Me.urls.length>0)for(const it of Me.urls){const st=new URLSearchParams(it.uri.query);if(st.get("windowId")==="_blank")return st.delete("windowId"),it.originalUrl=it.uri.toString(!0),it.uri=it.uri.with({query:st.toString()}),Ae.open({context:pe,cli:Re,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Be=global.macOpenFiles,ze=Re._.length,Ge=!!Re["folder-uri"],Te=!!Re["file-uri"],Fe=Re["skip-add-to-recently-opened"]===!0,je=Re.wait&&Re.waitMarkerFilePath?h.URI.file(Re.waitMarkerFilePath):void 0,Ye=Re.remote||void 0,Ze=Re.profile,tt=Re["profile-temp"];if(!ze&&!Ge&&!Te){if(Re["new-window"]||Ze||tt)return Ae.open({context:pe,cli:Re,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Fe,waitMarkerFileURI:je,initialStartup:!0,remoteAuthority:Ye,forceProfile:Ze,forceTempProfile:tt});if(Be.length)return Ae.open({context:1,cli:Re,urisToOpen:Be.map(it=>(0,Ue.hasWorkspaceFileExtension)(it)?{workspaceUri:h.URI.file(it)}:{fileUri:h.URI.file(it)}),noRecentEntry:Fe,waitMarkerFileURI:je,initialStartup:!0})}return Ae.open({context:pe,cli:Re,forceNewWindow:Re["new-window"]||!ze&&Re["unity-launch"],diffMode:Re.diff,mergeMode:Re.merge,noRecentEntry:Fe,waitMarkerFileURI:je,gotoLineMode:Re.goto,initialStartup:!0,remoteAuthority:Ye,forceProfile:Ze,forceTempProfile:tt})}afterWindowOpen(){this.installMutex(),C.protocol.registerHttpProtocol(y.Schemas.vscodeRemoteResource,(ke,Me)=>{Me({url:ke.url.replace(/^vscode-remote-resource:/,"http:"),method:ke.method})}),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement(),m.isMacintosh&&C.app.runningUnderARM64Translation&&this.windowsMainService?.sendToFocused("vscode:showTranslatedBuildWarning")}async installMutex(){const ke=this.productService.win32MutexName;if(m.isWindows&&ke)try{const Me=await new Promise((pe,Re)=>{Q(["@vscode/windows-mutex"],pe,Re)}),Ae=new Me.Mutex(ke);w.Event.once(this.lifecycleMainService.onWillShutdown)(()=>Ae.release())}catch(Me){this.logService.error(Me)}}async resolveShellEnvironment(ke,Me,Ae){try{return await(0,V.getResolvedShellEnv)(this.configurationService,this.logService,ke,Me)}catch(pe){const Re=(0,I.toErrorMessage)(pe);Ae?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Re):this.logService.error(Re)}return{}}async updateCrashReporterEnablement(){try{const Me=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),Ae=JSON.parse((0,b.stripComments)(Me)),Re=(0,te.getTelemetryLevel)(this.configurationService)>=1;if(Ae["enable-crash-reporter"]===void 0){const Be=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Re},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,d.generateUuid)()}"`,"}"],ze=Me.substring(0,Me.length-2).concat(`,
`,Be.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(ze))}else{const Be=Me.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Re},`);Be!==Me&&await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(Be))}}catch(ke){this.logService.error(ke)}}};e.CodeApplication=ft,e.CodeApplication=ft=ht=be([ne(2,q.IInstantiationService),ne(3,z.ILogService),ne(4,z.ILoggerService),ne(5,U.IEnvironmentMainService),ne(6,Z.ILifecycleMainService),ne(7,S.IConfigurationService),ne(8,ge.IStateService),ne(9,x.IFileService),ne(10,$.IProductService),ne(11,rt.IUserDataProfilesMainService)],ft)}),define(oe[313],ae([0,1,15,46,7,22,8,51,14,33,3,47,13,9,68,4,36,25,21,43,99,308,10,18,238,250,24,64,202,16,222,93,78,218,92,20,225,5,79,27,80,278,127,287,53,286,95,249,34,54,70,56,39,234,232,2,40,266,69,227,116,122,270,264]),function(Q,e,C,L,r,O,M,I,f,l,w,b,E,u,y,v,m,g,h,d,p,a,t,o,s,i,n,c,S,R,k,P,D,_,N,U,j,V,ce,se,ue,X,Y,x,W,F,H,q,ee,de,G,A,T,Z,z,J,B,$,K,re,le,ge,we){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Ie{main(){try{this.startup()}catch(Ee){console.error(Ee.message),C.app.exit(1)}}async startup(){(0,f.setUnexpectedErrorHandler)(_e=>console.error(_e));const[Ee,Se,te,he,me,Ce,Oe,Ne]=this.createServices();try{try{await this.initServices(te,Ne,he,me,Oe)}catch(_e){throw this.handleStartupDataDirError(te,Oe,_e),_e}await Ee.invokeFunction(async _e=>{const Ve=_e.get(V.ILogService),$e=_e.get(U.ILifecycleMainService),xe=_e.get(R.IFileService),He=_e.get(V.ILoggerService),ie=await this.claimInstance(Ve,te,$e,Ee,Oe,!0);return h.Promises.writeFile(te.mainLockfile,String(process.pid)).catch(fe=>{Ve.warn(`app#startup(): Error writing main lockfile: ${fe.stack}`)}),Ce.logger=He.createLogger("main",{name:(0,t.localize)(0,null)}),w.Event.once($e.onWillShutdown)(fe=>{xe.dispose(),he.dispose(),fe.join("instanceLockfile",h.Promises.unlink(te.mainLockfile).catch(()=>{}))}),Ee.createInstance(a.CodeApplication,ie,Se).startup()})}catch(_e){Ee.invokeFunction(this.quit,_e)}}createServices(){const Ee=new N.ServiceCollection,Se=new J.DisposableStore;process.once("exit",()=>Se.dispose());const te={_serviceBrand:void 0,...ce.default};Ee.set(se.IProductService,te);const he=new n.EnvironmentMainService(this.resolveArgs(),te),me=this.patchEnvironment(he);Ee.set(n.IEnvironmentMainService,he);const Ce=new K.LoggerMainService((0,V.getLogLevel)(he),he.logsHome);Ee.set(K.ILoggerMainService,Ce);const Oe=new j.BufferLogger(Ce.getLogLevel()),Ne=Se.add(new re.LogService(Oe,[new V.ConsoleMainLogger(Ce.getLogLevel())]));Ee.set(V.ILogService,Ne);const _e=new k.FileService(Ne);Ee.set(R.IFileService,_e);const Ve=new P.DiskFileSystemProvider(Ne);_e.registerProvider(E.Schemas.file,Ve);const $e=new $.UriIdentityService(_e);Ee.set(B.IUriIdentityService,$e);const xe=new ge.StateService(1,he,Ne,_e);Ee.set(ee.IStateReadService,xe),Ee.set(ee.IStateService,xe);const He=new A.UserDataProfilesMainService(xe,$e,he,_e,Ne);Ee.set(A.IUserDataProfilesMainService,He),_e.registerProvider(E.Schemas.vscodeUserData,new we.FileUserDataProvider(E.Schemas.file,Ve,E.Schemas.vscodeUserData,He,$e,Ne));const ie=v.isWindows&&te.win32RegValueName?Se.add(new Z.NativePolicyService(Ne,te.win32RegValueName)):he.policyFile?Se.add(new z.FilePolicyService(he.policyFile,_e,Ne)):new T.NullPolicyService;Ee.set(T.IPolicyService,ie);const fe=new s.ConfigurationService(He.defaultProfile.settingsResource,_e,ie,Ne);return Ee.set(o.IConfigurationService,fe),Ee.set(U.ILifecycleMainService,new D.SyncDescriptor(U.LifecycleMainService,void 0,!1)),Ee.set(W.IRequestService,new D.SyncDescriptor(F.RequestMainService,void 0,!0)),Ee.set(G.IThemeMainService,new D.SyncDescriptor(G.ThemeMainService)),Ee.set(H.ISignService,new D.SyncDescriptor(q.SignService,void 0,!1)),Ee.set(Y.ITunnelService,new D.SyncDescriptor(x.TunnelService)),Ee.set(ue.IProtocolMainService,new X.ProtocolMainService(he,He,Ne)),[new _.InstantiationService(Ee,!0),me,he,fe,xe,Oe,te,He]}patchEnvironment(Ee){const Se={VSCODE_IPC_HOOK:Ee.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(te=>{const he=process.env[te];typeof he=="string"&&(Se[te]=he)}),Object.assign(process.env,Se),Se}async initServices(Ee,Se,te,he,me){await M.Promises.settled([Promise.all([Ee.extensionsPath,Ee.codeCachePath,Ee.logsHome.with({scheme:E.Schemas.file}).fsPath,Se.defaultProfile.globalStorageHome.with({scheme:E.Schemas.file}).fsPath,Ee.workspaceStorageHome.with({scheme:E.Schemas.file}).fsPath,Ee.localHistoryHome.with({scheme:E.Schemas.file}).fsPath,Ee.backupHome].map(Ce=>Ce?h.Promises.mkdir(Ce,{recursive:!0}):void 0)),he.init(),te.initialize()]),Se.init()}async claimInstance(Ee,Se,te,he,me,Ce){let Oe;try{(0,y.mark)("code/willStartMainServer"),Oe=await(0,p.serve)(Se.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),w.Event.once(te.onWillShutdown)(()=>Oe.dispose())}catch(Ne){if(Ne.code!=="EADDRINUSE")throw this.handleStartupDataDirError(Se,me,Ne),Ne;let _e;try{_e=await(0,p.connect)(Se.mainIPCHandle,"main")}catch(He){if(!Ce||v.isWindows||He.code!=="ECONNREFUSED")throw He.code==="EPERM"&&this.showStartupWarningDialog((0,t.localize)(1,null,me.nameShort),(0,t.localize)(2,null),me),He;try{(0,L.unlinkSync)(Se.mainIPCHandle)}catch(ie){throw Ee.warn("Could not delete obsolete instance handle",ie),ie}return this.claimInstance(Ee,Se,te,he,me,!1)}if(Se.extensionTestsLocationURI&&!Se.debugExtensionHost.break){const He=`Running extension tests from the command line is currently only supported if no other instance of ${me.nameShort} is running.`;throw Ee.error(He),_e.dispose(),new Error(He)}let Ve;!Se.args.wait&&!Se.args.status&&(Ve=setTimeout(()=>{this.showStartupWarningDialog((0,t.localize)(3,null,me.nameShort),(0,t.localize)(4,null),me)},1e4));const $e=d.ProxyChannel.toService(_e.getChannel("launch"),{disableMarshalling:!0}),xe=d.ProxyChannel.toService(_e.getChannel("diagnostics"),{disableMarshalling:!0});if(Se.args.status)return he.invokeFunction(async()=>{const He=new i.DiagnosticsService(de.NullTelemetryService,me),ie=await xe.getMainDiagnostics(),fe=await xe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),ve=await He.getDiagnostics(ie,fe);throw console.log(ve),new f.ExpectedError});throw v.isWindows&&await this.windowsAllowSetForegroundWindow($e,Ee),Ee.trace("Sending env to running instance..."),await $e.start(Se.args,process.env),_e.dispose(),Ve&&clearTimeout(Ve),new f.ExpectedError("Sent env to running instance. Terminating...")}if(Se.args.status)throw console.log((0,t.localize)(5,null,me.nameShort)),new f.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Oe}handleStartupDataDirError(Ee,Se,te){if(te.code==="EACCES"||te.code==="EPERM"){const he=(0,O.coalesce)([Ee.userDataPath,Ee.extensionsPath,p.XDG_RUNTIME_DIR]).map(me=>(0,b.getPathLabel)(r.URI.file(me),{os:v.OS,tildify:Ee}));this.showStartupWarningDialog((0,t.localize)(6,null),(0,t.localize)(7,null,(0,I.toErrorMessage)(te),he.join(`
`)),Se)}}showStartupWarningDialog(Ee,Se,te){C.dialog.showMessageBoxSync((0,le.massageMessageBoxOptions)({type:"warning",buttons:[(0,t.localize)(8,null)],message:Ee,detail:Se},te).options)}async windowsAllowSetForegroundWindow(Ee,Se){if(v.isWindows){const te=await Ee.getMainProcessId();Se.trace("Sending some foreground love to the running instance:",te);try{(await new Promise((he,me)=>{Q(["windows-foreground-love"],he,me)})).allowSetForegroundWindow(te)}catch(he){Se.error(he)}}}quit(Ee,Se){const te=Ee.get(V.ILogService),he=Ee.get(U.ILifecycleMainService);let me=0;Se&&(Se.isExpected?Se.message&&te.trace(Se.message):(me=1,Se.stack?te.error(Se.stack):te.error(`Startup error: ${Se.toString()}`))),he.kill(me)}resolveArgs(){const Ee=this.validatePaths((0,c.parseMainProcessArgv)(process.argv));if(Ee.wait&&!Ee.waitMarkerFilePath){const Se=(0,S.createWaitMarkerFileSync)(Ee.verbose);Se&&((0,c.addArg)(process.argv,"--waitMarkerFilePath",Se),Ee.waitMarkerFilePath=Se)}return Ee}validatePaths(Ee){if(Ee["open-url"]&&(Ee._urls=Ee._,Ee._=[]),!Ee.remote){const Se=this.doValidatePaths(Ee._,Ee.goto);Ee._=Se}return Ee}doValidatePaths(Ee,Se){const te=(0,m.cwd)(),he=Ee.map(Oe=>{let Ne=String(Oe),_e;Se&&(_e=(0,l.parseLineAndColumnAware)(Ne),Ne=_e.path),Ne&&(Ne=this.preparePath(te,Ne));const Ve=(0,l.sanitizeFilePath)(Ne,te),$e=(0,u.basename)(Ve);return $e&&!(0,l.isValidBasename)($e)?null:Se&&_e?(_e.path=Ve,this.toPath(_e)):Ve}),me=v.isWindows||v.isMacintosh,Ce=(0,O.distinct)(he,Oe=>Oe&&me?Oe.toLowerCase():Oe||"");return(0,O.coalesce)(Ce)}preparePath(Ee,Se){return v.isWindows&&(Se=(0,g.rtrim)(Se,'"')),Se=(0,g.trim)((0,g.trim)(Se," "),"	"),v.isWindows&&(Se=(0,u.resolve)(Ee,Se),Se=(0,g.rtrim)(Se,".")),Se}toPath(Ee){const Se=[Ee.path];return typeof Ee.line=="number"&&Se.push(String(Ee.line)),typeof Ee.column=="number"&&Se.push(String(Ee.column)),Se.join(":")}}new Ie().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/27d855b2b4105a2aca2445223c8f3dc4694fbd58/core/vs/code/electron-main/main.js.map
