/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/types","vs/nls","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/path","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ue=function(se){for(var e=[],k=0,O=se.length;k<O;k++)e[k]=le[se[k]];return e};define(le[124],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class k{static get(){const T=new Map,A=new Map,L=new Map,D=new Map;function I(l,g){l.has(g.detail)||l.set(g.detail,-g.timestamp)}function m(l,g){const p=l.get(g.detail);p&&(p>=0||l.set(g.detail,p+g.timestamp))}let P=[];typeof se=="function"&&typeof se.getStats=="function"&&(P=se.getStats().slice(0).sort((l,g)=>l.timestamp-g.timestamp));for(const l of P)switch(l.type){case 10:I(T,l);break;case 11:case 12:m(T,l);break;case 21:I(A,l);break;case 22:m(A,l);break;case 33:I(L,l);break;case 34:m(L,l);break;case 31:I(D,l);break;case 32:m(D,l);break}let b=0;L.forEach(l=>b+=l);function S(l){const g=[];return l.forEach((p,v)=>g.push([v,p])),g}return{amdLoad:S(T),amdInvoke:S(A),nodeRequire:S(L),nodeEval:S(D),nodeRequireTotal:b}}static toMarkdownTable(T,A){let L="";const D=[];return T.forEach((I,m)=>{D[m]=I.length}),A.forEach(I=>{I.forEach((m,P)=>{typeof m>"u"&&(m=I[P]="-");const b=m.toString().length;D[P]=Math.max(b,D[P])})}),T.forEach((I,m)=>{L+=`| ${I+" ".repeat(D[m]-I.toString().length)} `}),L+=`|
`,T.forEach((I,m)=>{L+=`| ${"-".repeat(D[m])} `}),L+=`|
`,A.forEach(I=>{I.forEach((m,P)=>{typeof m<"u"&&(L+=`| ${m+" ".repeat(D[P]-m.toString().length)} `)}),L+=`|
`}),L}}e.LoaderStats=k}),define(le[125],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFindFirst=e.findMaxIdxBy=e.findFirstMinBy=e.findLastMaxBy=e.findFirstMaxBy=e.MonotonousArray=e.findFirstIdxMonotonous=e.findFirstIdxMonotonousOrArrLen=e.findFirstMonotonous=e.findLastIdxMonotonous=e.findLastMonotonous=e.findLastIdx=e.findLast=void 0;function k(p,v,u){const d=O(p,v);if(d!==-1)return p[d]}e.findLast=k;function O(p,v,u=p.length-1){for(let d=u;d>=0;d--){const f=p[d];if(v(f))return d}return-1}e.findLastIdx=O;function T(p,v){const u=A(p,v);return u===-1?void 0:p[u]}e.findLastMonotonous=T;function A(p,v,u=0,d=p.length){let f=u,c=d;for(;f<c;){const w=Math.floor((f+c)/2);v(p[w])?f=w+1:c=w}return f-1}e.findLastIdxMonotonous=A;function L(p,v){const u=D(p,v);return u===p.length?void 0:p[u]}e.findFirstMonotonous=L;function D(p,v,u=0,d=p.length){let f=u,c=d;for(;f<c;){const w=Math.floor((f+c)/2);v(p[w])?c=w:f=w+1}return f}e.findFirstIdxMonotonousOrArrLen=D;function I(p,v,u=0,d=p.length){const f=D(p,v,u,d);return f===p.length?-1:f}e.findFirstIdxMonotonous=I;class m{static{this.assertInvariants=!1}constructor(v){this._array=v,this._findLastMonotonousLastIdx=0}findLastMonotonous(v){if(m.assertInvariants){if(this._prevFindLastPredicate){for(const d of this._array)if(this._prevFindLastPredicate(d)&&!v(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=v}const u=A(this._array,v,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=u+1,u===-1?void 0:this._array[u]}}e.MonotonousArray=m;function P(p,v){if(p.length===0)return;let u=p[0];for(let d=1;d<p.length;d++){const f=p[d];v(f,u)>0&&(u=f)}return u}e.findFirstMaxBy=P;function b(p,v){if(p.length===0)return;let u=p[0];for(let d=1;d<p.length;d++){const f=p[d];v(f,u)>=0&&(u=f)}return u}e.findLastMaxBy=b;function S(p,v){return P(p,(u,d)=>-v(u,d))}e.findFirstMinBy=S;function l(p,v){if(p.length===0)return-1;let u=0;for(let d=1;d<p.length;d++){const f=p[d];v(f,p[u])>0&&(u=d)}return u}e.findMaxIdxBy=l;function g(p,v){for(const u of p){const d=v(u);if(d!==void 0)return d}}e.mapFindFirst=g}),define(le[126],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.intersection=e.diffMaps=e.diffSets=e.groupBy=void 0;function k(L,D){const I=Object.create(null);for(const m of L){const P=D(m);let b=I[P];b||(b=I[P]=[]),b.push(m)}return I}e.groupBy=k;function O(L,D){const I=[],m=[];for(const P of L)D.has(P)||I.push(P);for(const P of D)L.has(P)||m.push(P);return{removed:I,added:m}}e.diffSets=O;function T(L,D){const I=[],m=[];for(const[P,b]of L)D.has(P)||I.push(b);for(const[P,b]of D)L.has(P)||m.push(b);return{removed:I,added:m}}e.diffMaps=T;function A(L,D){const I=new Set;for(const m of D)L.has(m)&&I.add(m);return I}e.intersection=A}),define(le[85],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function k(L){return(D,I,m)=>{let P=null,b=null;if(typeof m.value=="function"?(P="value",b=m.value):typeof m.get=="function"&&(P="get",b=m.get),!b)throw new Error("not supported");m[P]=L(b,I)}}function O(L,D,I){let m=null,P=null;if(typeof I.value=="function"?(m="value",P=I.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof I.get=="function"&&(m="get",P=I.get),!P)throw new Error("not supported");const b=`$memoize$${D}`;I[m]=function(...S){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,S)}),this[b]}}e.memoize=O;function T(L,D,I){return k((m,P)=>{const b=`$debounce$${P}`,S=`$debounce$result$${P}`;return function(...l){this[S]||(this[S]=I?I():void 0),clearTimeout(this[b]),D&&(this[S]=D(this[S],...l),l=[this[S]]),this[b]=setTimeout(()=>{m.apply(this,l),this[S]=I?I():void 0},L)}})}e.debounce=T;function A(L,D,I){return k((m,P)=>{const b=`$throttle$timer$${P}`,S=`$throttle$result$${P}`,l=`$throttle$lastRun$${P}`,g=`$throttle$pending$${P}`;return function(...p){if(this[S]||(this[S]=I?I():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),D&&(this[S]=D(this[S],...p)),this[g])return;const v=this[l]+L;v<=Date.now()?(this[l]=Date.now(),m.apply(this,[this[S]]),this[S]=I?I():void 0):(this[g]=!0,this[b]=setTimeout(()=>{this[g]=!1,this[l]=Date.now(),m.apply(this,[this[S]]),this[S]=I?I():void 0},v-Date.now()))}})}e.throttle=A}),define(le[7],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.ReadonlyError=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class k{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?f.isErrorNoTelemetry(i)?new f(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(o=>{o(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=k,e.errorHandler=new k;function O(w){e.errorHandler.setUnexpectedErrorHandler(w)}e.setUnexpectedErrorHandler=O;function T(w){if(!w||typeof w!="object")return!1;const i=w;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=T;function A(w){m(w)||e.errorHandler.onUnexpectedError(w)}e.onUnexpectedError=A;function L(w){m(w)||e.errorHandler.onUnexpectedExternalError(w)}e.onUnexpectedExternalError=L;function D(w){if(w instanceof Error){const{name:i,message:o}=w,n=w.stacktrace||w.stack;return{$isError:!0,name:i,message:o,stack:n,noTelemetry:f.isErrorNoTelemetry(w)}}return w}e.transformErrorForSerialization=D;const I="Canceled";function m(w){return w instanceof P?!0:w instanceof Error&&w.name===I&&w.message===I}e.isCancellationError=m;class P extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=P;function b(){const w=new Error(I);return w.name=w.message,w}e.canceled=b;function S(w){return w?new Error(`Illegal argument: ${w}`):new Error("Illegal argument")}e.illegalArgument=S;function l(w){return w?new Error(`Illegal state: ${w}`):new Error("Illegal state")}e.illegalState=l;class g extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=g;function p(w){return w?w.message?w.message:w.stack?w.stack.split(`
`)[0]:String(w):"Error"}e.getErrorMessage=p;class v extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=v;class u extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=u;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=d;class f extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof f)return i;const o=new f;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=f;class c extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}e.BugIndicatingError=c}),define(le[17],ue([0,1,7,125]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.reverseOrder=e.booleanComparator=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.forEachWithNeighbors=e.forEachAdjacent=e.groupAdjacentBy=e.groupBy=e.quickSelect=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function T($,Z=0){return $[$.length-(1+Z)]}e.tail=T;function A($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=A;function L($,Z,B=(H,te)=>H===te){if($===Z)return!0;if(!$||!Z||$.length!==Z.length)return!1;for(let H=0,te=$.length;H<te;H++)if(!B($[H],Z[H]))return!1;return!0}e.equals=L;function D($,Z){const B=$.length-1;Z<B&&($[Z]=$[B]),$.pop()}e.removeFastWithoutKeepingOrder=D;function I($,Z,B){return m($.length,H=>B($[H],Z))}e.binarySearch=I;function m($,Z){let B=0,H=$-1;for(;B<=H;){const te=(B+H)/2|0,ne=Z(te);if(ne<0)B=te+1;else if(ne>0)H=te-1;else return te}return-(B+1)}e.binarySearch2=m;function P($,Z,B){if($=$|0,$>=Z.length)throw new TypeError("invalid index");const H=Z[Math.floor(Z.length*Math.random())],te=[],ne=[],ce=[];for(const fe of Z){const ge=B(fe,H);ge<0?te.push(fe):ge>0?ne.push(fe):ce.push(fe)}return $<te.length?P($,te,B):$<te.length+ce.length?ce[0]:P($-(te.length+ce.length),ne,B)}e.quickSelect=P;function b($,Z){const B=[];let H;for(const te of $.slice(0).sort(Z))!H||Z(H[0],te)!==0?(H=[te],B.push(H)):H.push(te);return B}e.groupBy=b;function*S($,Z){let B,H;for(const te of $)H!==void 0&&Z(H,te)?B.push(te):(B&&(yield B),B=[te]),H=te;B&&(yield B)}e.groupAdjacentBy=S;function l($,Z){for(let B=0;B<=$.length;B++)Z(B===0?void 0:$[B-1],B===$.length?void 0:$[B])}e.forEachAdjacent=l;function g($,Z){for(let B=0;B<$.length;B++)Z(B===0?void 0:$[B-1],$[B],B+1===$.length?void 0:$[B+1])}e.forEachWithNeighbors=g;function p($,Z,B){const H=[];function te(fe,ge,Se){if(ge===0&&Se.length===0)return;const Ce=H[H.length-1];Ce&&Ce.start+Ce.deleteCount===fe?(Ce.deleteCount+=ge,Ce.toInsert.push(...Se)):H.push({start:fe,deleteCount:ge,toInsert:Se})}let ne=0,ce=0;for(;;){if(ne===$.length){te(ne,0,Z.slice(ce));break}if(ce===Z.length){te(ne,$.length-ne,[]);break}const fe=$[ne],ge=Z[ce],Se=B(fe,ge);Se===0?(ne+=1,ce+=1):Se<0?(te(ne,1,[]),ne+=1):Se>0&&(te(ne,0,[ge]),ce+=1)}return H}e.sortedDiff=p;function v($,Z,B){const H=p($,Z,B),te=[],ne=[];for(const ce of H)te.push(...$.slice(ce.start,ce.start+ce.deleteCount)),ne.push(...ce.toInsert);return{removed:te,added:ne}}e.delta=v;function u($,Z,B){if(B===0)return[];const H=$.slice(0,B).sort(Z);return f($,Z,H,B,$.length),H}e.top=u;function d($,Z,B,H,te){return B===0?Promise.resolve([]):new Promise((ne,ce)=>{(async()=>{const fe=$.length,ge=$.slice(0,B).sort(Z);for(let Se=B,Ce=Math.min(B+H,fe);Se<fe;Se=Ce,Ce=Math.min(Ce+H,fe)){if(Se>B&&await new Promise(Re=>setTimeout(Re)),te&&te.isCancellationRequested)throw new k.CancellationError;f($,Z,ge,Se,Ce)}return ge})().then(ne,ce)})}e.topAsync=d;function f($,Z,B,H,te){for(const ne=B.length;H<te;H++){const ce=$[H];if(Z(ce,B[ne-1])<0){B.pop();const fe=(0,O.findFirstIdxMonotonousOrArrLen)(B,ge=>Z(ce,ge)<0);B.splice(fe,0,ce)}}}function c($){return $.filter(Z=>!!Z)}e.coalesce=c;function w($){let Z=0;for(let B=0;B<$.length;B++)$[B]&&($[Z]=$[B],Z+=1);$.length=Z}e.coalesceInPlace=w;function i($,Z,B){$.splice(B,0,$.splice(Z,1)[0])}e.move=i;function o($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=o;function n($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=n;function s($,Z=B=>B){const B=new Set;return $.filter(H=>{const te=Z(H);return B.has(te)?!1:(B.add(te),!0)})}e.distinct=s;function t($){const Z=new Set;return B=>{const H=$(B);return Z.has(H)?!1:(Z.add(H),!0)}}e.uniqueFilter=t;function r($,Z){return $.length>0?$[0]:Z}e.firstOrDefault=r;function a($,Z){return $.length>0?$[$.length-1]:Z}e.lastOrDefault=a;function C($,Z,B=(H,te)=>H===te){let H=0;for(let te=0,ne=Math.min($.length,Z.length);te<ne&&B($[te],Z[te]);te++)H++;return H}e.commonPrefixLength=C;function E($){return[].concat(...$)}e.flatten=E;function h($,Z){let B=typeof Z=="number"?$:0;typeof Z=="number"?B=$:(B=0,Z=$);const H=[];if(B<=Z)for(let te=B;te<Z;te++)H.push(te);else for(let te=B;te>Z;te--)H.push(te);return H}e.range=h;function y($,Z,B){return $.reduce((H,te)=>(H[Z(te)]=B?B(te):te,H),Object.create(null))}e.index=y;function R($,Z){return $.push(Z),()=>U($,Z)}e.insert=R;function U($,Z){const B=$.indexOf(Z);if(B>-1)return $.splice(B,1),Z}e.remove=U;function F($,Z,B){const H=$.slice(0,Z),te=$.slice(Z);return H.concat(B,te)}e.arrayInsert=F;function M($,Z){let B;if(typeof Z=="number"){let H=Z;B=()=>{const te=Math.sin(H++)*179426549;return te-Math.floor(te)}}else B=Math.random;for(let H=$.length-1;H>0;H-=1){const te=Math.floor(B()*(H+1)),ne=$[H];$[H]=$[te],$[te]=ne}}e.shuffle=M;function j($,Z){const B=$.indexOf(Z);B>-1&&($.splice(B,1),$.unshift(Z))}e.pushToStart=j;function Q($,Z){const B=$.indexOf(Z);B>-1&&($.splice(B,1),$.push(Z))}e.pushToEnd=Q;function K($,Z){for(const B of Z)$.push(B)}e.pushMany=K;function X($,Z){return Array.isArray($)?$.map(Z):Z($)}e.mapArrayOrNot=X;function x($){return Array.isArray($)?$:[$]}e.asArray=x;function J($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=J;function V($,Z,B){const H=ie($,Z),te=$.length,ne=B.length;$.length=te+ne;for(let ce=te-1;ce>=H;ce--)$[ce+ne]=$[ce];for(let ce=0;ce<ne;ce++)$[ce+H]=B[ce]}e.insertInto=V;function q($,Z,B,H){const te=ie($,Z);let ne=$.splice(te,B);return ne===void 0&&(ne=[]),V($,te,H),ne}e.splice=q;function ie($,Z){return Z<0?Math.max(Z+$.length,0):Math.min(Z,$.length)}var re;(function($){function Z(ne){return ne<0}$.isLessThan=Z;function B(ne){return ne<=0}$.isLessThanOrEqual=B;function H(ne){return ne>0}$.isGreaterThan=H;function te(ne){return ne===0}$.isNeitherLessOrGreaterThan=te,$.greaterThan=1,$.lessThan=-1,$.neitherLessOrGreaterThan=0})(re||(e.CompareResult=re={}));function ee($,Z){return(B,H)=>Z($(B),$(H))}e.compareBy=ee;function ae(...$){return(Z,B)=>{for(const H of $){const te=H(Z,B);if(!re.isNeitherLessOrGreaterThan(te))return te}return re.neitherLessOrGreaterThan}}e.tieBreakComparators=ae;const G=($,Z)=>$-Z;e.numberComparator=G;const W=($,Z)=>(0,e.numberComparator)($?1:0,Z?1:0);e.booleanComparator=W;function _($){return(Z,B)=>-$(Z,B)}e.reverseOrder=_;class N{constructor(Z){this.items=Z,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Z){let B=this.firstIdx;for(;B<this.items.length&&Z(this.items[B]);)B++;const H=B===this.firstIdx?null:this.items.slice(this.firstIdx,B);return this.firstIdx=B,H}takeFromEndWhile(Z){let B=this.lastIdx;for(;B>=0&&Z(this.items[B]);)B--;const H=B===this.lastIdx?null:this.items.slice(B+1,this.lastIdx+1);return this.lastIdx=B,H}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const Z=this.items[this.firstIdx];return this.firstIdx++,Z}removeLast(){const Z=this.items[this.lastIdx];return this.lastIdx--,Z}takeCount(Z){const B=this.items.slice(this.firstIdx,this.firstIdx+Z);return this.firstIdx+=Z,B}}e.ArrayQueue=N;class z{static{this.empty=new z(Z=>{})}constructor(Z){this.iterate=Z}forEach(Z){this.iterate(B=>(Z(B),!0))}toArray(){const Z=[];return this.iterate(B=>(Z.push(B),!0)),Z}filter(Z){return new z(B=>this.iterate(H=>Z(H)?B(H):!0))}map(Z){return new z(B=>this.iterate(H=>B(Z(H))))}some(Z){let B=!1;return this.iterate(H=>(B=Z(H),!B)),B}findFirst(Z){let B;return this.iterate(H=>Z(H)?(B=H,!1):!0),B}findLast(Z){let B;return this.iterate(H=>(Z(H)&&(B=H),!0)),B}findLastMaxBy(Z){let B,H=!0;return this.iterate(te=>((H||re.isGreaterThan(Z(te,B)))&&(H=!1,B=te),!0)),B}}e.CallbackIterable=z}),define(le[127],ue([0,1,7]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.softAssert=e.assert=e.assertNever=e.ok=void 0;function O(m,P){if(!m)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}e.ok=O;function T(m,P="Unreachable"){throw new Error(P)}e.assertNever=T;function A(m){if(!m)throw new k.BugIndicatingError("Assertion Failed")}e.assert=A;function L(m){m||(0,k.onUnexpectedError)(new k.BugIndicatingError("Assertion Failed"))}e.softAssert=L;function D(m){if(!m()){debugger;m(),(0,k.onUnexpectedError)(new k.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function I(m,P){let b=0;for(;b<m.length-1;){const S=m[b],l=m[b+1];if(!P(S,l))return!1;b++}return!0}e.checkAdjacentItems=I}),define(le[86],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=void 0;function k(O,T){const A=this;let L=!1,D;return function(){if(L)return D;if(L=!0,T)try{D=O.apply(A,arguments)}finally{T()}else D=O.apply(A,arguments);return D}}e.createSingleCallFunction=k}),define(le[61],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(O){function T(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}O.is=T;const A=Object.freeze([]);function L(){return A}O.empty=L;function*D(i){yield i}O.single=D;function I(i){return T(i)?i:D(i)}O.wrap=I;function m(i){return i||A}O.from=m;function*P(i){for(let o=i.length-1;o>=0;o--)yield i[o]}O.reverse=P;function b(i){return!i||i[Symbol.iterator]().next().done===!0}O.isEmpty=b;function S(i){return i[Symbol.iterator]().next().value}O.first=S;function l(i,o){for(const n of i)if(o(n))return!0;return!1}O.some=l;function g(i,o){for(const n of i)if(o(n))return n}O.find=g;function*p(i,o){for(const n of i)o(n)&&(yield n)}O.filter=p;function*v(i,o){let n=0;for(const s of i)yield o(s,n++)}O.map=v;function*u(...i){for(const o of i)yield*o}O.concat=u;function d(i,o,n){let s=n;for(const t of i)s=o(s,t);return s}O.reduce=d;function*f(i,o,n=i.length){for(o<0&&(o+=i.length),n<0?n+=i.length:n>i.length&&(n=i.length);o<n;o++)yield i[o]}O.slice=f;function c(i,o=Number.POSITIVE_INFINITY){const n=[];if(o===0)return[n,i];const s=i[Symbol.iterator]();for(let t=0;t<o;t++){const r=s.next();if(r.done)return[n,O.empty()];n.push(r.value)}return[n,{[Symbol.iterator](){return s}}]}O.consume=c;async function w(i){const o=[];for await(const n of i)o.push(n);return Promise.resolve(o)}O.asyncToArray=w})(k||(e.Iterable=k={}))}),define(le[34],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(k||(e.ScanError=k={}));var O;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var T;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(T||(e.ParseErrorCode=T={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function L(i,o=!1){let n=0;const s=i.length;let t="",r=0,a=16,C=0;function E(j){let Q=0,K=0;for(;Q<j;){const X=i.charCodeAt(n);if(X>=48&&X<=57)K=K*16+X-48;else if(X>=65&&X<=70)K=K*16+X-65+10;else if(X>=97&&X<=102)K=K*16+X-97+10;else break;n++,Q++}return Q<j&&(K=-1),K}function h(j){n=j,t="",r=0,a=16,C=0}function y(){const j=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&m(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&m(i.charCodeAt(n)))for(n++;n<i.length&&m(i.charCodeAt(n));)n++;else return C=3,i.substring(j,n);let Q=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&m(i.charCodeAt(n))){for(n++;n<i.length&&m(i.charCodeAt(n));)n++;Q=n}else C=3;return i.substring(j,Q)}function R(){let j="",Q=n;for(;;){if(n>=s){j+=i.substring(Q,n),C=2;break}const K=i.charCodeAt(n);if(K===34){j+=i.substring(Q,n),n++;break}if(K===92){if(j+=i.substring(Q,n),n++,n>=s){C=2;break}switch(i.charCodeAt(n++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const x=E(4);x>=0?j+=String.fromCharCode(x):C=4;break}default:C=5}Q=n;continue}if(K>=0&&K<=31)if(I(K)){j+=i.substring(Q,n),C=2;break}else C=6;n++}return j}function U(){if(t="",C=0,r=n,n>=s)return r=s,a=17;let j=i.charCodeAt(n);if(D(j)){do n++,t+=String.fromCharCode(j),j=i.charCodeAt(n);while(D(j));return a=15}if(I(j))return n++,t+=String.fromCharCode(j),j===13&&i.charCodeAt(n)===10&&(n++,t+=`
`),a=14;switch(j){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,t=R(),a=10;case 47:{const Q=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<s&&!I(i.charCodeAt(n));)n++;return t=i.substring(Q,n),a=12}if(i.charCodeAt(n+1)===42){n+=2;const K=s-1;let X=!1;for(;n<K;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,X=!0;break}n++}return X||(n++,C=1),t=i.substring(Q,n),a=13}return t+=String.fromCharCode(j),n++,a=16}case 45:if(t+=String.fromCharCode(j),n++,n===s||!m(i.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=y(),a=11;default:for(;n<s&&F(j);)n++,j=i.charCodeAt(n);if(r!==n){switch(t=i.substring(r,n),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode(j),n++,a=16}}function F(j){if(D(j)||I(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let j;do j=U();while(j>=12&&j<=15);return j}return{setPosition:h,getPosition:()=>n,scan:o?M:U,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>C}}e.createScanner=L;function D(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function I(i){return i===10||i===13||i===8232||i===8233}function m(i){return i>=48&&i<=57}var P;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(P||(P={}));function b(i,o){const n=[],s=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function C(E,h,y,R){r.value=E,r.offset=h,r.length=y,r.type=R,r.colonOffset=void 0,t=r}try{f(i,{onObjectBegin:(E,h)=>{if(o<=E)throw s;t=void 0,a=o>E,n.push("")},onObjectProperty:(E,h,y)=>{if(o<h||(C(E,h,y,"property"),n[n.length-1]=E,o<=h+y))throw s},onObjectEnd:(E,h)=>{if(o<=E)throw s;t=void 0,n.pop()},onArrayBegin:(E,h)=>{if(o<=E)throw s;t=void 0,n.push(0)},onArrayEnd:(E,h)=>{if(o<=E)throw s;t=void 0,n.pop()},onLiteralValue:(E,h,y)=>{if(o<h||(C(E,h,y,w(E)),o<=h+y))throw s},onSeparator:(E,h,y)=>{if(o<=h)throw s;if(E===":"&&t&&t.type==="property")t.colonOffset=h,a=!1,t=void 0;else if(E===","){const R=n[n.length-1];typeof R=="number"?n[n.length-1]=R+1:(a=!0,n[n.length-1]=""),t=void 0}}})}catch(E){if(E!==s)throw E}return{path:n,previousNode:t,isAtPropertyKey:a,matches:E=>{let h=0;for(let y=0;h<E.length&&y<n.length;y++)if(E[h]===n[y]||E[h]==="*")h++;else if(E[h]!=="**")return!1;return h===E.length}}}e.getLocation=b;function S(i,o=[],n=A.DEFAULT){let s=null,t=[];const r=[];function a(E){Array.isArray(t)?t.push(E):s!==null&&(t[s]=E)}return f(i,{onObjectBegin:()=>{const E={};a(E),r.push(t),t=E,s=null},onObjectProperty:E=>{s=E},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const E=[];a(E),r.push(t),t=E,s=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:a,onError:(E,h,y)=>{o.push({error:E,offset:h,length:y})}},n),t[0]}e.parse=S;function l(i,o=[],n=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(E){s.type==="property"&&(s.length=E-s.offset,s=s.parent)}function r(E){return s.children.push(E),E}f(i,{onObjectBegin:E=>{s=r({type:"object",offset:E,length:-1,parent:s,children:[]})},onObjectProperty:(E,h,y)=>{s=r({type:"property",offset:h,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:E,offset:h,length:y,parent:s})},onObjectEnd:(E,h)=>{s.length=E+h-s.offset,s=s.parent,t(E+h)},onArrayBegin:(E,h)=>{s=r({type:"array",offset:E,length:-1,parent:s,children:[]})},onArrayEnd:(E,h)=>{s.length=E+h-s.offset,s=s.parent,t(E+h)},onLiteralValue:(E,h,y)=>{r({type:w(E),offset:h,length:y,parent:s,value:E}),t(h+y)},onSeparator:(E,h,y)=>{s.type==="property"&&(E===":"?s.colonOffset=h:E===","&&t(h))},onError:(E,h,y)=>{o.push({error:E,offset:h,length:y})}},n);const C=s.children[0];return C&&delete C.parent,C}e.parseTree=l;function g(i,o){if(!i)return;let n=i;for(const s of o)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===s){n=r.children[1],t=!0;break}if(!t)return}else{const t=s;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}e.findNodeAtLocation=g;function p(i){if(!i.parent||!i.parent.children)return[];const o=p(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;o.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&o.push(n)}return o}e.getNodePath=p;function v(i){switch(i.type){case"array":return i.children.map(v);case"object":{const o=Object.create(null);for(const n of i.children){const s=n.children[1];s&&(o[n.children[0].value]=v(s))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=v;function u(i,o,n=!1){return o>=i.offset&&o<i.offset+i.length||n&&o===i.offset+i.length}e.contains=u;function d(i,o,n=!1){if(u(i,o,n)){const s=i.children;if(Array.isArray(s))for(let t=0;t<s.length&&s[t].offset<=o;t++){const r=d(s[t],o,n);if(r)return r}return i}}e.findNodeAtOffset=d;function f(i,o,n=A.DEFAULT){const s=L(i,!1);function t(ee){return ee?()=>ee(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(ee){return ee?ae=>ee(ae,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=t(o.onObjectBegin),C=r(o.onObjectProperty),E=t(o.onObjectEnd),h=t(o.onArrayBegin),y=t(o.onArrayEnd),R=r(o.onLiteralValue),U=r(o.onSeparator),F=t(o.onComment),M=r(o.onError),j=n&&n.disallowComments,Q=n&&n.allowTrailingComma;function K(){for(;;){const ee=s.scan();switch(s.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:j||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(ee){case 12:case 13:j?X(10):F();break;case 16:X(1);break;case 15:case 14:break;default:return ee}}}function X(ee,ae=[],G=[]){if(M(ee),ae.length+G.length>0){let W=s.getToken();for(;W!==17;){if(ae.indexOf(W)!==-1){K();break}else if(G.indexOf(W)!==-1)break;W=K()}}}function x(ee){const ae=s.getTokenValue();return ee?R(ae):C(ae),K(),!0}function J(){switch(s.getToken()){case 11:{let ee=0;try{ee=JSON.parse(s.getTokenValue()),typeof ee!="number"&&(X(2),ee=0)}catch{X(2)}R(ee);break}case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return K(),!0}function V(){return s.getToken()!==10?(X(3,[],[2,5]),!1):(x(!1),s.getToken()===6?(U(":"),K(),re()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function q(){a(),K();let ee=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ee||X(4,[],[]),U(","),K(),s.getToken()===2&&Q)break}else ee&&X(6,[],[]);V()||X(4,[],[2,5]),ee=!0}return E(),s.getToken()!==2?X(7,[2],[]):K(),!0}function ie(){h(),K();let ee=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ee||X(4,[],[]),U(","),K(),s.getToken()===4&&Q)break}else ee&&X(6,[],[]);re()||X(4,[],[4,5]),ee=!0}return y(),s.getToken()!==4?X(8,[4],[]):K(),!0}function re(){switch(s.getToken()){case 3:return ie();case 1:return q();case 10:return x(!0);default:return J()}}return K(),s.getToken()===17?n.allowEmptyContent?!0:(X(4,[],[]),!1):re()?(s.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}e.visit=f;function c(i,o){const n=L(i),s=[];let t,r=0,a;do switch(a=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==a&&s.push(i.substring(r,a)),o!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,o)),r=n.getPosition();break}while(t!==17);return s.join("")}e.stripComments=c;function w(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),define(le[42],ue([0,1,34]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function O(m,P,b){let S,l,g,p,v;if(P){for(p=P.offset,v=p+P.length,g=p;g>0&&!I(m,g-1);)g--;let a=v;for(;a<m.length&&!I(m,a);)a++;l=m.substring(g,a),S=L(l,b)}else l=m,S=0,g=0,p=0,v=m.length;const u=D(b,m);let d=!1,f=0,c;b.insertSpaces?c=A(" ",b.tabSize||4):c="	";const w=(0,k.createScanner)(l,!1);let i=!1;function o(){return u+A(c,S+f)}function n(){let a=w.scan();for(d=!1;a===15||a===14;)d=d||a===14,a=w.scan();return i=a===16||w.getTokenError()!==0,a}const s=[];function t(a,C,E){!i&&C<v&&E>p&&m.substring(C,E)!==a&&s.push({offset:C,length:E-C,content:a})}let r=n();if(r!==17){const a=w.getTokenOffset()+g,C=A(c,S);t(C,g,a)}for(;r!==17;){let a=w.getTokenOffset()+w.getTokenLength()+g,C=n(),E="";for(;!d&&(C===12||C===13);){const y=w.getTokenOffset()+g;t(" ",a,y),a=w.getTokenOffset()+w.getTokenLength()+g,E=C===12?o():"",C=n()}if(C===2)r!==1&&(f--,E=o());else if(C===4)r!==3&&(f--,E=o());else{switch(r){case 3:case 1:f++,E=o();break;case 5:case 12:E=o();break;case 13:d?E=o():E=" ";break;case 6:E=" ";break;case 10:if(C===6){E="";break}case 7:case 8:case 9:case 11:case 2:case 4:C===12||C===13?E=" ":C!==5&&C!==17&&(i=!0);break;case 16:i=!0;break}d&&(C===12||C===13)&&(E=o())}const h=w.getTokenOffset()+g;t(E,a,h),r=C}return s}e.format=O;function T(m,P){const b=JSON.stringify(m,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?b.replace(/\r\n|\r|\n/g,P.eol):b}e.toFormattedString=T;function A(m,P){let b="";for(let S=0;S<P;S++)b+=m;return b}function L(m,P){let b=0,S=0;const l=P.tabSize||4;for(;b<m.length;){const g=m.charAt(b);if(g===" ")S++;else if(g==="	")S+=l;else break;b++}return Math.floor(S/l)}function D(m,P){for(let b=0;b<P.length;b++){const S=P.charAt(b);if(S==="\r")return b+1<P.length&&P.charAt(b+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=D;function I(m,P){return`\r
`.indexOf(m.charAt(P))!==-1}e.isEOL=I}),define(le[62],ue([0,1,34,42]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function T(m,P,b){return A(m,P,void 0,b)}e.removeProperty=T;function A(m,P,b,S,l){const g=P.slice(),p=[],v=(0,k.parseTree)(m,p);let u,d;for(;g.length>0&&(d=g.pop(),u=(0,k.findNodeAtLocation)(v,g),u===void 0&&b!==void 0);)typeof d=="string"?b={[d]:b}:b=[b];if(u)if(u.type==="object"&&typeof d=="string"&&Array.isArray(u.children)){const f=(0,k.findNodeAtLocation)(u,[d]);if(f!==void 0)if(b===void 0){if(!f.parent)throw new Error("Malformed AST");const c=u.children.indexOf(f.parent);let w,i=f.parent.offset+f.parent.length;if(c>0){const o=u.children[c-1];w=o.offset+o.length}else w=u.offset+1,u.children.length>1&&(i=u.children[1].offset);return L(m,{offset:w,length:i-w,content:""},S)}else return L(m,{offset:f.offset,length:f.length,content:JSON.stringify(b)},S);else{if(b===void 0)return[];const c=`${JSON.stringify(d)}: ${JSON.stringify(b)}`,w=l?l(u.children.map(o=>o.children[0].value)):u.children.length;let i;if(w>0){const o=u.children[w-1];i={offset:o.offset+o.length,length:0,content:","+c}}else u.children.length===0?i={offset:u.offset+1,length:0,content:c}:i={offset:u.offset+1,length:0,content:c+","};return L(m,i,S)}}else if(u.type==="array"&&typeof d=="number"&&Array.isArray(u.children))if(b!==void 0){const f=`${JSON.stringify(b)}`;let c;if(u.children.length===0||d===0)c={offset:u.offset+1,length:0,content:u.children.length===0?f:f+","};else{const w=d===-1||d>u.children.length?u.children.length:d,i=u.children[w-1];c={offset:i.offset+i.length,length:0,content:","+f}}return L(m,c,S)}else{const f=d,c=u.children[f];let w;if(u.children.length===1)w={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===f){const i=u.children[f-1],o=i.offset+i.length,n=u.offset+u.length;w={offset:o,length:n-2-o,content:""}}else w={offset:c.offset,length:u.children[f+1].offset-c.offset,content:""};return L(m,w,S)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${u.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return L(m,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(b)},S)}}e.setProperty=A;function L(m,P,b){let S=D(m,P),l=P.offset,g=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;l>0&&!(0,O.isEOL)(S,l-1);)l--;for(;g<S.length&&!(0,O.isEOL)(S,g);)g++}const p=(0,O.format)(S,{offset:l,length:g-l},b);for(let u=p.length-1;u>=0;u--){const d=p[u];S=D(S,d),l=Math.min(l,d.offset),g=Math.max(g,d.offset+d.length),g+=d.content.length-d.length}const v=m.length-(S.length-g)-l;return[{offset:l,length:v,content:S.substring(l,g)}]}e.withFormatting=L;function D(m,P){return m.substring(0,P.offset)+P.content+m.substring(P.offset+P.length)}e.applyEdit=D;function I(m,P){const b=P.slice(0).sort((l,g)=>{const p=l.offset-g.offset;return p===0?l.length-g.length:p});let S=m.length;for(let l=b.length-1;l>=0;l--){const g=b[l];if(g.offset+g.length<=S)m=D(m,g);else throw new Error("Overlapping edit");S=g.offset}return m}e.applyEdits=I}),define(le[52],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class k{constructor(T){this.executor=T,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(T){this._error=T}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=k}),define(le[87],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class k{static{this.Undefined=new k(void 0)}constructor(A){this.element=A,this.next=k.Undefined,this.prev=k.Undefined}}class O{constructor(){this._first=k.Undefined,this._last=k.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===k.Undefined}clear(){let A=this._first;for(;A!==k.Undefined;){const L=A.next;A.prev=k.Undefined,A.next=k.Undefined,A=L}this._first=k.Undefined,this._last=k.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,L){const D=new k(A);if(this._first===k.Undefined)this._first=D,this._last=D;else if(L){const m=this._last;this._last=D,D.prev=m,m.next=D}else{const m=this._first;this._first=D,D.next=m,m.prev=D}this._size+=1;let I=!1;return()=>{I||(I=!0,this._remove(D))}}shift(){if(this._first!==k.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==k.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==k.Undefined&&A.next!==k.Undefined){const L=A.prev;L.next=A.next,A.next.prev=L}else A.prev===k.Undefined&&A.next===k.Undefined?(this._first=k.Undefined,this._last=k.Undefined):A.next===k.Undefined?(this._last=this._last.prev,this._last.next=k.Undefined):A.prev===k.Undefined&&(this._first=this._first.next,this._first.prev=k.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==k.Undefined;)yield A.element,A=A.next}}e.LinkedList=O}),define(le[35],ue([0,1]),function(se,e){"use strict";var k,O,T;Object.defineProperty(e,"__esModule",{value:!0}),e.mapsStrictEqualIgnoreOrder=e.SetMap=e.BidirectionalMap=e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(f,c,w){let i=f.get(c);return i===void 0&&(i=w,f.set(c,i)),i}e.getOrSet=A;function L(f){const c=[];return f.forEach((w,i)=>{c.push(`${i} => ${w}`)}),`Map(${f.size}) {${c.join(", ")}}`}e.mapToString=L;function D(f){const c=[];return f.forEach(w=>{c.push(w)}),`Set(${f.size}) {${c.join(", ")}}`}e.setToString=D;class I{constructor(c,w){this.uri=c,this.value=w}}function m(f){return Array.isArray(f)}class P{static{this.defaultToKey=c=>c.toString()}constructor(c,w){if(this[k]="ResourceMap",c instanceof P)this.map=new Map(c.map),this.toKey=w??P.defaultToKey;else if(m(c)){this.map=new Map,this.toKey=w??P.defaultToKey;for(const[i,o]of c)this.set(i,o)}else this.map=new Map,this.toKey=c??P.defaultToKey}set(c,w){return this.map.set(this.toKey(c),new I(c,w)),this}get(c){return this.map.get(this.toKey(c))?.value}has(c){return this.map.has(this.toKey(c))}get size(){return this.map.size}clear(){this.map.clear()}delete(c){return this.map.delete(this.toKey(c))}forEach(c,w){typeof w<"u"&&(c=c.bind(w));for(const[i,o]of this.map)c(o.value,o.uri,this)}*values(){for(const c of this.map.values())yield c.value}*keys(){for(const c of this.map.values())yield c.uri}*entries(){for(const c of this.map.values())yield[c.uri,c.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.map)yield[c.uri,c.value]}}e.ResourceMap=P;class b{constructor(c,w){this[O]="ResourceSet",!c||typeof c=="function"?this._map=new P(c):(this._map=new P(w),c.forEach(this.add,this))}get size(){return this._map.size}add(c){return this._map.set(c,c),this}clear(){this._map.clear()}delete(c){return this._map.delete(c)}forEach(c,w){this._map.forEach((i,o)=>c.call(w,o,o,this))}has(c){return this._map.has(c)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=b;var S;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(S||(e.Touch=S={}));class l{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(c){return this._map.has(c)}get(c,w=0){const i=this._map.get(c);if(i)return w!==0&&this.touch(i,w),i.value}set(c,w,i=0){let o=this._map.get(c);if(o)o.value=w,i!==0&&this.touch(o,i);else{switch(o={key:c,value:w,next:void 0,previous:void 0},i){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(c,o),this._size++}return this}delete(c){return!!this.remove(c)}remove(c){const w=this._map.get(c);if(w)return this._map.delete(c),this.removeItem(w),this._size--,w.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const c=this._head;return this._map.delete(c.key),this.removeItem(c),this._size--,c.value}forEach(c,w){const i=this._state;let o=this._head;for(;o;){if(w?c.bind(w)(o.value,o.key,this):c(o.value,o.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const c=this,w=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(c._state!==w)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.key,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}values(){const c=this,w=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(c._state!==w)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.value,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}entries(){const c=this,w=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(c._state!==w)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:[i.key,i.value],done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(c){if(c>=this.size)return;if(c===0){this.clear();return}let w=this._head,i=this.size;for(;w&&i>c;)this._map.delete(w.key),w=w.next,i--;this._head=w,this._size=i,w&&(w.previous=void 0),this._state++}addItemFirst(c){if(!this._head&&!this._tail)this._tail=c;else if(this._head)c.next=this._head,this._head.previous=c;else throw new Error("Invalid list");this._head=c,this._state++}addItemLast(c){if(!this._head&&!this._tail)this._head=c;else if(this._tail)c.previous=this._tail,this._tail.next=c;else throw new Error("Invalid list");this._tail=c,this._state++}removeItem(c){if(c===this._head&&c===this._tail)this._head=void 0,this._tail=void 0;else if(c===this._head){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this._head=c.next}else if(c===this._tail){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this._tail=c.previous}else{const w=c.next,i=c.previous;if(!w||!i)throw new Error("Invalid list");w.previous=i,i.next=w}c.next=void 0,c.previous=void 0,this._state++}touch(c,w){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(w!==1&&w!==2)){if(w===1){if(c===this._head)return;const i=c.next,o=c.previous;c===this._tail?(o.next=void 0,this._tail=o):(i.previous=o,o.next=i),c.previous=void 0,c.next=this._head,this._head.previous=c,this._head=c,this._state++}else if(w===2){if(c===this._tail)return;const i=c.next,o=c.previous;c===this._head?(i.previous=void 0,this._head=i):(i.previous=o,o.next=i),c.next=void 0,c.previous=this._tail,this._tail.next=c,this._tail=c,this._state++}}}toJSON(){const c=[];return this.forEach((w,i)=>{c.push([i,w])}),c}fromJSON(c){this.clear();for(const[w,i]of c)this.set(w,i)}}e.LinkedMap=l;class g extends l{constructor(c,w=1){super(),this._limit=c,this._ratio=Math.min(Math.max(0,w),1)}get limit(){return this._limit}set limit(c){this._limit=c,this.checkTrim()}get ratio(){return this._ratio}set ratio(c){this._ratio=Math.min(Math.max(0,c),1),this.checkTrim()}get(c,w=2){return super.get(c,w)}peek(c){return super.get(c,0)}set(c,w){return super.set(c,w,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=g;class p{constructor(){this.map=new Map}add(c){return this.map.set(c,(this.map.get(c)||0)+1),this}delete(c){let w=this.map.get(c)||0;return w===0?!1:(w--,w===0?this.map.delete(c):this.map.set(c,w),!0)}has(c){return this.map.has(c)}}e.CounterSet=p;class v{constructor(c){if(this._m1=new Map,this._m2=new Map,c)for(const[w,i]of c)this.set(w,i)}clear(){this._m1.clear(),this._m2.clear()}set(c,w){this._m1.set(c,w),this._m2.set(w,c)}get(c){return this._m1.get(c)}getKey(c){return this._m2.get(c)}delete(c){const w=this._m1.get(c);return w===void 0?!1:(this._m1.delete(c),this._m2.delete(w),!0)}forEach(c,w){this._m1.forEach((i,o)=>{c.call(w,i,o,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=v;class u{constructor(){this.map=new Map}add(c,w){let i=this.map.get(c);i||(i=new Set,this.map.set(c,i)),i.add(w)}delete(c,w){const i=this.map.get(c);i&&(i.delete(w),i.size===0&&this.map.delete(c))}forEach(c,w){const i=this.map.get(c);i&&i.forEach(w)}get(c){const w=this.map.get(c);return w||new Set}}e.SetMap=u;function d(f,c){if(f===c)return!0;if(f.size!==c.size)return!1;for(const[w,i]of f)if(!c.has(w)||c.get(w)!==i)return!1;for(const[w]of c)if(!f.has(w))return!1;return!0}e.mapsStrictEqualIgnoreOrder=d}),define(le[2],ue([0,1,17,126,35,86,61]),function(se,e,k,O,T,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.markAsDisposed=e.trackDisposable=e.setDisposableTracker=e.DisposableTracker=void 0;const D=!1;let I=null;class m{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(R){let U=this.livingDisposables.get(R);return U||(U={parent:null,source:null,isSingleton:!1,value:R,idx:m.idx++},this.livingDisposables.set(R,U)),U}trackDisposable(R){const U=this.getDisposableData(R);U.source||(U.source=new Error().stack)}setParent(R,U){const F=this.getDisposableData(R);F.parent=U}markAsDisposed(R){this.livingDisposables.delete(R)}markAsSingleton(R){this.getDisposableData(R).isSingleton=!0}getRootParent(R,U){const F=U.get(R);if(F)return F;const M=R.parent?this.getRootParent(this.getDisposableData(R.parent),U):R;return U.set(R,M),M}getTrackedDisposables(){const R=new Map;return[...this.livingDisposables.entries()].filter(([,F])=>F.source!==null&&!this.getRootParent(F,R).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(R=10,U){let F;if(U)F=U;else{const X=new Map,x=[...this.livingDisposables.values()].filter(V=>V.source!==null&&!this.getRootParent(V,X).isSingleton);if(x.length===0)return;const J=new Set(x.map(V=>V.value));if(F=x.filter(V=>!(V.parent&&J.has(V.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function M(X){function x(V,q){for(;V.length>0&&q.some(ie=>typeof ie=="string"?ie===V[0]:V[0].match(ie));)V.shift()}const J=X.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return x(J,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),J.reverse()}const j=new T.SetMap;for(const X of F){const x=M(X);for(let J=0;J<=x.length;J++)j.add(x.slice(0,J).join(`
`),X)}F.sort((0,k.compareBy)(X=>X.idx,k.numberComparator));let Q="",K=0;for(const X of F.slice(0,R)){K++;const x=M(X),J=[];for(let V=0;V<x.length;V++){let q=x[V];q=`(shared with ${j.get(x.slice(0,V+1).join(`
`)).size}/${F.length} leaks) at ${q}`;const re=j.get(x.slice(0,V).join(`
`)),ee=(0,O.groupBy)([...re].map(ae=>M(ae)[V]),ae=>ae);delete ee[x[V]];for(const[ae,G]of Object.entries(ee))J.unshift(`    - stacktraces of ${G.length} other leaks continue with ${ae}`);J.unshift(q)}Q+=`


==================== Leaking disposable ${K}/${F.length}: ${X.value.constructor.name} ====================
${J.join(`
`)}
============================================================

`}return F.length>R&&(Q+=`


... and ${F.length-R} more leaking disposables

`),{leaks:F,details:Q}}}e.DisposableTracker=m;function P(y){I=y}if(e.setDisposableTracker=P,D){const y="__is_disposable_tracked__";P(new class{trackDisposable(R){const U=new Error("Potentially leaked disposable").stack;setTimeout(()=>{R[y]||console.log(U)},3e3)}setParent(R,U){if(R&&R!==i.None)try{R[y]=!0}catch{}}markAsDisposed(R){if(R&&R!==i.None)try{R[y]=!0}catch{}}markAsSingleton(R){}})}function b(y){return I?.trackDisposable(y),y}e.trackDisposable=b;function S(y){I?.markAsDisposed(y)}e.markAsDisposed=S;function l(y,R){I?.setParent(y,R)}function g(y,R){if(I)for(const U of y)I.setParent(U,R)}function p(y){return I?.markAsSingleton(y),y}e.markAsSingleton=p;function v(y){return typeof y.dispose=="function"&&y.dispose.length===0}e.isDisposable=v;function u(y){if(L.Iterable.is(y)){const R=[];for(const U of y)if(U)try{U.dispose()}catch(F){R.push(F)}if(R.length===1)throw R[0];if(R.length>1)throw new AggregateError(R,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}e.dispose=u;function d(y){for(const R of y)v(R)&&R.dispose();return[]}e.disposeIfDisposable=d;function f(...y){const R=c(()=>u(y));return g(y,R),R}e.combinedDisposable=f;function c(y){const R=b({dispose:(0,A.createSingleCallFunction)(()=>{S(R),y()})});return R}e.toDisposable=c;class w{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,b(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{u(this._toDispose)}finally{this._toDispose.clear()}}add(R){if(!R)return R;if(R===this)throw new Error("Cannot register a disposable on itself!");return l(R,this),this._isDisposed?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(R),R}delete(R){if(R){if(R===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(R),R.dispose()}}deleteAndLeak(R){R&&this._toDispose.has(R)&&(this._toDispose.delete(R),l(R,null))}}e.DisposableStore=w;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new w,b(this),l(this._store,this)}dispose(){S(this),this._store.dispose()}_register(R){if(R===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(R)}}e.Disposable=i;class o{constructor(){this._isDisposed=!1,b(this)}get value(){return this._isDisposed?void 0:this._value}set value(R){this._isDisposed||R===this._value||(this._value?.dispose(),R&&l(R,this),this._value=R)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const R=this._value;return this._value=void 0,R&&l(R,null),R}}e.MutableDisposable=o;class n{constructor(R){this._disposable=new o,this._isDisposed=!1,this._disposable.value=R}get value(){return this._disposable.value}set value(R){this._isDisposed||R===this._disposable.value||(this._disposable.value=R)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=n;class s{constructor(R){this._disposable=R,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=s;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(R){let U=R;return this.unset=()=>U=void 0,this.isset=()=>U!==void 0,this.dispose=()=>{U&&(U(),U=void 0,S(this))},this}}e.SafeDisposable=t;class r{constructor(){this.references=new Map}acquire(R,...U){let F=this.references.get(R);F||(F={counter:0,object:this.createReferencedObject(R,...U)},this.references.set(R,F));const{object:M}=F,j=(0,A.createSingleCallFunction)(()=>{--F.counter===0&&(this.destroyReferencedObject(R,F.object),this.references.delete(R))});return F.counter++,{object:M,dispose:j}}}e.ReferenceCollection=r;class a{constructor(R){this.referenceCollection=R}async acquire(R,...U){const F=this.referenceCollection.acquire(R,...U);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(M){throw F.dispose(),M}}}e.AsyncReferenceCollection=a;class C{constructor(R){this.object=R}dispose(){}}e.ImmortalReference=C;function E(y){const R=new w;try{y(R)}finally{R.dispose()}}e.disposeOnReturn=E;class h{constructor(){this._store=new Map,this._isDisposed=!1,b(this)}dispose(){S(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{u(this._store.values())}finally{this._store.clear()}}has(R){return this._store.has(R)}get size(){return this._store.size}get(R){return this._store.get(R)}set(R,U,F=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this._store.get(R)?.dispose(),this._store.set(R,U)}deleteAndDispose(R){this._store.get(R)?.dispose(),this._store.delete(R)}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=h}),define(le[88],ue([0,1,35]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const O=new k.LRUCache(1e4);function T(m){return I(m,"NFC",O)}e.normalizeNFC=T;const A=new k.LRUCache(1e4);function L(m){return I(m,"NFD",A)}e.normalizeNFD=L;const D=/[^\u0000-\u0080]/;function I(m,P,b){if(!m)return m;const S=b.get(m);if(S)return S;let l;return D.test(m)?l=m.normalize(P):l=m,b.set(m,l),l}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(P){return L(P).replace(m,"")}}()}),function(){function se(T){const A=[];typeof T=="number"&&A.push("code/timeOrigin",T);function L(I){A.push(I,Date.now())}function D(){const I=[];for(let m=0;m<A.length;m+=2)I.push({name:A[m],startTime:A[m+1]});return I}return{mark:L,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?se():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const L of performance.getEntriesByType("mark"))A.push({name:L.name,startTime:Math.round(T+L.startTime)});return A}};if(typeof process=="object"){const T=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return se(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),se()}function k(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=k(O))}(),function(se,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var O in k)(typeof exports=="object"?exports:se)[O]=k[O]}}(typeof self<"u"?self:this,function(){return function(se){var e={};function k(O){if(e[O])return e[O].exports;var T=e[O]={i:O,l:!1,exports:{}};return se[O].call(T.exports,T,T.exports,k),T.l=!0,T.exports}return k.m=se,k.c=e,k.d=function(O,T,A){k.o(O,T)||Object.defineProperty(O,T,{enumerable:!0,get:A})},k.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},k.t=function(O,T){if(1&T&&(O=k(O)),8&T||4&T&&typeof O=="object"&&O&&O.__esModule)return O;var A=Object.create(null);if(k.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:O}),2&T&&typeof O!="string")for(var L in O)k.d(A,L,function(D){return O[D]}.bind(null,L));return A},k.n=function(O){var T=O&&O.__esModule?function(){return O.default}:function(){return O};return k.d(T,"a",T),T},k.o=function(O,T){return Object.prototype.hasOwnProperty.call(O,T)},k.p="",k(k.s=0)}([function(se,e,k){(function(O){var T;e=se.exports=G,T=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var he=Array.prototype.slice.call(arguments,0);he.unshift("SEMVER"),console.log.apply(console,he)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,D=e.re=[],I=e.src=[],m=0,P=m++;I[P]="0|[1-9]\\d*";var b=m++;I[b]="[0-9]+";var S=m++;I[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var l=m++;I[l]="("+I[P]+")\\.("+I[P]+")\\.("+I[P]+")";var g=m++;I[g]="("+I[b]+")\\.("+I[b]+")\\.("+I[b]+")";var p=m++;I[p]="(?:"+I[P]+"|"+I[S]+")";var v=m++;I[v]="(?:"+I[b]+"|"+I[S]+")";var u=m++;I[u]="(?:-("+I[p]+"(?:\\."+I[p]+")*))";var d=m++;I[d]="(?:-?("+I[v]+"(?:\\."+I[v]+")*))";var f=m++;I[f]="[0-9A-Za-z-]+";var c=m++;I[c]="(?:\\+("+I[f]+"(?:\\."+I[f]+")*))";var w=m++,i="v?"+I[l]+I[u]+"?"+I[c]+"?";I[w]="^"+i+"$";var o="[v=\\s]*"+I[g]+I[d]+"?"+I[c]+"?",n=m++;I[n]="^"+o+"$";var s=m++;I[s]="((?:<|>)?=?)";var t=m++;I[t]=I[b]+"|x|X|\\*";var r=m++;I[r]=I[P]+"|x|X|\\*";var a=m++;I[a]="[v=\\s]*("+I[r]+")(?:\\.("+I[r]+")(?:\\.("+I[r]+")(?:"+I[u]+")?"+I[c]+"?)?)?";var C=m++;I[C]="[v=\\s]*("+I[t]+")(?:\\.("+I[t]+")(?:\\.("+I[t]+")(?:"+I[d]+")?"+I[c]+"?)?)?";var E=m++;I[E]="^"+I[s]+"\\s*"+I[a]+"$";var h=m++;I[h]="^"+I[s]+"\\s*"+I[C]+"$";var y=m++;I[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var R=m++;I[R]="(?:~>?)";var U=m++;I[U]="(\\s*)"+I[R]+"\\s+",D[U]=new RegExp(I[U],"g");var F=m++;I[F]="^"+I[R]+I[a]+"$";var M=m++;I[M]="^"+I[R]+I[C]+"$";var j=m++;I[j]="(?:\\^)";var Q=m++;I[Q]="(\\s*)"+I[j]+"\\s+",D[Q]=new RegExp(I[Q],"g");var K=m++;I[K]="^"+I[j]+I[a]+"$";var X=m++;I[X]="^"+I[j]+I[C]+"$";var x=m++;I[x]="^"+I[s]+"\\s*("+o+")$|^$";var J=m++;I[J]="^"+I[s]+"\\s*("+i+")$|^$";var V=m++;I[V]="(\\s*)"+I[s]+"\\s*("+o+"|"+I[a]+")",D[V]=new RegExp(I[V],"g");var q=m++;I[q]="^\\s*("+I[a]+")\\s+-\\s+("+I[a]+")\\s*$";var ie=m++;I[ie]="^\\s*("+I[C]+")\\s+-\\s+("+I[C]+")\\s*$";var re=m++;I[re]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)T(ee,I[ee]),D[ee]||(D[ee]=new RegExp(I[ee]));function ae(he,me){if(he instanceof G)return he;if(typeof he!="string"||he.length>A||!(me?D[n]:D[w]).test(he))return null;try{return new G(he,me)}catch{return null}}function G(he,me){if(he instanceof G){if(he.loose===me)return he;he=he.version}else if(typeof he!="string")throw new TypeError("Invalid Version: "+he);if(he.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof G))return new G(he,me);T("SemVer",he,me),this.loose=me;var ve=he.trim().match(me?D[n]:D[w]);if(!ve)throw new TypeError("Invalid Version: "+he);if(this.raw=he,this.major=+ve[1],this.minor=+ve[2],this.patch=+ve[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");ve[4]?this.prerelease=ve[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var De=+Pe;if(De>=0&&De<L)return De}return Pe}):this.prerelease=[],this.build=ve[5]?ve[5].split("."):[],this.format()}e.parse=ae,e.valid=function(he,me){var ve=ae(he,me);return ve?ve.version:null},e.clean=function(he,me){var ve=ae(he.trim().replace(/^[=v]+/,""),me);return ve?ve.version:null},e.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(he){return T("SemVer.compare",this.version,this.loose,he),he instanceof G||(he=new G(he,this.loose)),this.compareMain(he)||this.comparePre(he)},G.prototype.compareMain=function(he){return he instanceof G||(he=new G(he,this.loose)),_(this.major,he.major)||_(this.minor,he.minor)||_(this.patch,he.patch)},G.prototype.comparePre=function(he){if(he instanceof G||(he=new G(he,this.loose)),this.prerelease.length&&!he.prerelease.length)return-1;if(!this.prerelease.length&&he.prerelease.length)return 1;if(!this.prerelease.length&&!he.prerelease.length)return 0;var me=0;do{var ve=this.prerelease[me],Pe=he.prerelease[me];if(T("prerelease compare",me,ve,Pe),ve===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(ve===void 0)return-1;if(ve!==Pe)return _(ve,Pe)}while(++me)},G.prototype.inc=function(he,me){switch(he){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",me);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",me);break;case"prepatch":this.prerelease.length=0,this.inc("patch",me),this.inc("pre",me);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",me),this.inc("pre",me);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ve=this.prerelease.length;--ve>=0;)typeof this.prerelease[ve]=="number"&&(this.prerelease[ve]++,ve=-2);ve===-1&&this.prerelease.push(0)}me&&(this.prerelease[0]===me?isNaN(this.prerelease[1])&&(this.prerelease=[me,0]):this.prerelease=[me,0]);break;default:throw new Error("invalid increment argument: "+he)}return this.format(),this.raw=this.version,this},e.inc=function(he,me,ve,Pe){typeof ve=="string"&&(Pe=ve,ve=void 0);try{return new G(he,ve).inc(me,Pe).version}catch{return null}},e.diff=function(he,me){if(Z(he,me))return null;var ve=ae(he),Pe=ae(me);if(ve.prerelease.length||Pe.prerelease.length){for(var De in ve)if((De==="major"||De==="minor"||De==="patch")&&ve[De]!==Pe[De])return"pre"+De;return"prerelease"}for(var De in ve)if((De==="major"||De==="minor"||De==="patch")&&ve[De]!==Pe[De])return De},e.compareIdentifiers=_;var W=/^[0-9]+$/;function _(he,me){var ve=W.test(he),Pe=W.test(me);return ve&&Pe&&(he=+he,me=+me),ve&&!Pe?-1:Pe&&!ve?1:he<me?-1:he>me?1:0}function N(he,me,ve){return new G(he,ve).compare(new G(me,ve))}function z(he,me,ve){return N(he,me,ve)>0}function $(he,me,ve){return N(he,me,ve)<0}function Z(he,me,ve){return N(he,me,ve)===0}function B(he,me,ve){return N(he,me,ve)!==0}function H(he,me,ve){return N(he,me,ve)>=0}function te(he,me,ve){return N(he,me,ve)<=0}function ne(he,me,ve,Pe){var De;switch(me){case"===":typeof he=="object"&&(he=he.version),typeof ve=="object"&&(ve=ve.version),De=he===ve;break;case"!==":typeof he=="object"&&(he=he.version),typeof ve=="object"&&(ve=ve.version),De=he!==ve;break;case"":case"=":case"==":De=Z(he,ve,Pe);break;case"!=":De=B(he,ve,Pe);break;case">":De=z(he,ve,Pe);break;case">=":De=H(he,ve,Pe);break;case"<":De=$(he,ve,Pe);break;case"<=":De=te(he,ve,Pe);break;default:throw new TypeError("Invalid operator: "+me)}return De}function ce(he,me){if(he instanceof ce){if(he.loose===me)return he;he=he.value}if(!(this instanceof ce))return new ce(he,me);T("comparator",he,me),this.loose=me,this.parse(he),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,T("comp",this)}e.rcompareIdentifiers=function(he,me){return _(me,he)},e.major=function(he,me){return new G(he,me).major},e.minor=function(he,me){return new G(he,me).minor},e.patch=function(he,me){return new G(he,me).patch},e.compare=N,e.compareLoose=function(he,me){return N(he,me,!0)},e.rcompare=function(he,me,ve){return N(me,he,ve)},e.sort=function(he,me){return he.sort(function(ve,Pe){return e.compare(ve,Pe,me)})},e.rsort=function(he,me){return he.sort(function(ve,Pe){return e.rcompare(ve,Pe,me)})},e.gt=z,e.lt=$,e.eq=Z,e.neq=B,e.gte=H,e.lte=te,e.cmp=ne,e.Comparator=ce;var fe={};function ge(he,me){if(he instanceof ge)return he.loose===me?he:new ge(he.raw,me);if(he instanceof ce)return new ge(he.value,me);if(!(this instanceof ge))return new ge(he,me);if(this.loose=me,this.raw=he,this.set=he.split(/\s*\|\|\s*/).map(function(ve){return this.parseRange(ve.trim())},this).filter(function(ve){return ve.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+he);this.format()}function Se(he){return!he||he.toLowerCase()==="x"||he==="*"}function Ce(he,me,ve,Pe,De,Me,_e,We,Ne,Fe,je,oe,de){return((me=Se(ve)?"":Se(Pe)?">="+ve+".0.0":Se(De)?">="+ve+"."+Pe+".0":">="+me)+" "+(We=Se(Ne)?"":Se(Fe)?"<"+(+Ne+1)+".0.0":Se(je)?"<"+Ne+"."+(+Fe+1)+".0":oe?"<="+Ne+"."+Fe+"."+je+"-"+oe:"<="+We)).trim()}function Re(he,me){for(var ve=0;ve<he.length;ve++)if(!he[ve].test(me))return!1;if(me.prerelease.length){for(ve=0;ve<he.length;ve++)if(T(he[ve].semver),he[ve].semver!==fe&&he[ve].semver.prerelease.length>0){var Pe=he[ve].semver;if(Pe.major===me.major&&Pe.minor===me.minor&&Pe.patch===me.patch)return!0}return!1}return!0}function ke(he,me,ve){try{me=new ge(me,ve)}catch{return!1}return me.test(he)}function Ue(he,me,ve,Pe){var De,Me,_e,We,Ne;switch(he=new G(he,Pe),me=new ge(me,Pe),ve){case">":De=z,Me=te,_e=$,We=">",Ne=">=";break;case"<":De=$,Me=H,_e=z,We="<",Ne="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(he,me,Pe))return!1;for(var Fe=0;Fe<me.set.length;++Fe){var je=me.set[Fe],oe=null,de=null;if(je.forEach(function(pe){pe.semver===fe&&(pe=new ce(">=0.0.0")),oe=oe||pe,de=de||pe,De(pe.semver,oe.semver,Pe)?oe=pe:_e(pe.semver,de.semver,Pe)&&(de=pe)}),oe.operator===We||oe.operator===Ne||(!de.operator||de.operator===We)&&Me(he,de.semver)||de.operator===Ne&&_e(he,de.semver))return!1}return!0}ce.prototype.parse=function(he){var me=this.loose?D[x]:D[J],ve=he.match(me);if(!ve)throw new TypeError("Invalid comparator: "+he);this.operator=ve[1],this.operator==="="&&(this.operator=""),ve[2]?this.semver=new G(ve[2],this.loose):this.semver=fe},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(he){return T("Comparator.test",he,this.loose),this.semver===fe||(typeof he=="string"&&(he=new G(he,this.loose)),ne(he,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(he,me){if(!(he instanceof ce))throw new TypeError("a Comparator is required");var ve;if(this.operator==="")return ve=new ge(he.value,me),ke(this.value,ve,me);if(he.operator==="")return ve=new ge(this.value,me),ke(he.semver,ve,me);var Pe=!(this.operator!==">="&&this.operator!==">"||he.operator!==">="&&he.operator!==">"),De=!(this.operator!=="<="&&this.operator!=="<"||he.operator!=="<="&&he.operator!=="<"),Me=this.semver.version===he.semver.version,_e=!(this.operator!==">="&&this.operator!=="<="||he.operator!==">="&&he.operator!=="<="),We=ne(this.semver,"<",he.semver,me)&&(this.operator===">="||this.operator===">")&&(he.operator==="<="||he.operator==="<"),Ne=ne(this.semver,">",he.semver,me)&&(this.operator==="<="||this.operator==="<")&&(he.operator===">="||he.operator===">");return Pe||De||Me&&_e||We||Ne},e.Range=ge,ge.prototype.format=function(){return this.range=this.set.map(function(he){return he.join(" ").trim()}).join("||").trim(),this.range},ge.prototype.toString=function(){return this.range},ge.prototype.parseRange=function(he){var me=this.loose;he=he.trim(),T("range",he,me);var ve=me?D[ie]:D[q];he=he.replace(ve,Ce),T("hyphen replace",he),he=he.replace(D[V],"$1$2$3"),T("comparator trim",he,D[V]),he=(he=(he=he.replace(D[U],"$1~")).replace(D[Q],"$1^")).split(/\s+/).join(" ");var Pe=me?D[x]:D[J],De=he.split(" ").map(function(Me){return function(_e,We){return T("comp",_e),_e=function(Ne,Fe){return Ne.trim().split(/\s+/).map(function(je){return function(oe,de){T("caret",oe,de);var pe=de?D[X]:D[K];return oe.replace(pe,function(we,Ee,Ie,Le,Te){var Oe;return T("caret",oe,we,Ee,Ie,Le,Te),Se(Ee)?Oe="":Se(Ie)?Oe=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Se(Le)?Oe=Ee==="0"?">="+Ee+"."+Ie+".0 <"+Ee+"."+(+Ie+1)+".0":">="+Ee+"."+Ie+".0 <"+(+Ee+1)+".0.0":Te?(T("replaceCaret pr",Te),Te.charAt(0)!=="-"&&(Te="-"+Te),Oe=Ee==="0"?Ie==="0"?">="+Ee+"."+Ie+"."+Le+Te+" <"+Ee+"."+Ie+"."+(+Le+1):">="+Ee+"."+Ie+"."+Le+Te+" <"+Ee+"."+(+Ie+1)+".0":">="+Ee+"."+Ie+"."+Le+Te+" <"+(+Ee+1)+".0.0"):(T("no pr"),Oe=Ee==="0"?Ie==="0"?">="+Ee+"."+Ie+"."+Le+" <"+Ee+"."+Ie+"."+(+Le+1):">="+Ee+"."+Ie+"."+Le+" <"+Ee+"."+(+Ie+1)+".0":">="+Ee+"."+Ie+"."+Le+" <"+(+Ee+1)+".0.0"),T("caret return",Oe),Oe})}(je,Fe)}).join(" ")}(_e,We),T("caret",_e),_e=function(Ne,Fe){return Ne.trim().split(/\s+/).map(function(je){return function(oe,de){var pe=de?D[M]:D[F];return oe.replace(pe,function(we,Ee,Ie,Le,Te){var Oe;return T("tilde",oe,we,Ee,Ie,Le,Te),Se(Ee)?Oe="":Se(Ie)?Oe=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Se(Le)?Oe=">="+Ee+"."+Ie+".0 <"+Ee+"."+(+Ie+1)+".0":Te?(T("replaceTilde pr",Te),Te.charAt(0)!=="-"&&(Te="-"+Te),Oe=">="+Ee+"."+Ie+"."+Le+Te+" <"+Ee+"."+(+Ie+1)+".0"):Oe=">="+Ee+"."+Ie+"."+Le+" <"+Ee+"."+(+Ie+1)+".0",T("tilde return",Oe),Oe})}(je,Fe)}).join(" ")}(_e,We),T("tildes",_e),_e=function(Ne,Fe){return T("replaceXRanges",Ne,Fe),Ne.split(/\s+/).map(function(je){return function(oe,de){oe=oe.trim();var pe=de?D[h]:D[E];return oe.replace(pe,function(we,Ee,Ie,Le,Te,Oe){T("xRange",oe,we,Ee,Ie,Le,Te,Oe);var qe=Se(Ie),$e=qe||Se(Le),ze=$e||Se(Te);return Ee==="="&&ze&&(Ee=""),qe?we=Ee===">"||Ee==="<"?"<0.0.0":"*":Ee&&ze?($e&&(Le=0),ze&&(Te=0),Ee===">"?(Ee=">=",$e?(Ie=+Ie+1,Le=0,Te=0):ze&&(Le=+Le+1,Te=0)):Ee==="<="&&(Ee="<",$e?Ie=+Ie+1:Le=+Le+1),we=Ee+Ie+"."+Le+"."+Te):$e?we=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":ze&&(we=">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0"),T("xRange return",we),we})}(je,Fe)}).join(" ")}(_e,We),T("xrange",_e),_e=function(Ne,Fe){return T("replaceStars",Ne,Fe),Ne.trim().replace(D[re],"")}(_e,We),T("stars",_e),_e}(Me,me)}).join(" ").split(/\s+/);return this.loose&&(De=De.filter(function(Me){return!!Me.match(Pe)})),De=De.map(function(Me){return new ce(Me,me)})},ge.prototype.intersects=function(he,me){if(!(he instanceof ge))throw new TypeError("a Range is required");return this.set.some(function(ve){return ve.every(function(Pe){return he.set.some(function(De){return De.every(function(Me){return Pe.intersects(Me,me)})})})})},e.toComparators=function(he,me){return new ge(he,me).set.map(function(ve){return ve.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},ge.prototype.test=function(he){if(!he)return!1;typeof he=="string"&&(he=new G(he,this.loose));for(var me=0;me<this.set.length;me++)if(Re(this.set[me],he))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(he,me,ve){var Pe=null,De=null;try{var Me=new ge(me,ve)}catch{return null}return he.forEach(function(_e){Me.test(_e)&&(Pe&&De.compare(_e)!==-1||(De=new G(Pe=_e,ve)))}),Pe},e.minSatisfying=function(he,me,ve){var Pe=null,De=null;try{var Me=new ge(me,ve)}catch{return null}return he.forEach(function(_e){Me.test(_e)&&(Pe&&De.compare(_e)!==1||(De=new G(Pe=_e,ve)))}),Pe},e.validRange=function(he,me){try{return new ge(he,me).range||"*"}catch{return null}},e.ltr=function(he,me,ve){return Ue(he,me,"<",ve)},e.gtr=function(he,me,ve){return Ue(he,me,">",ve)},e.outside=Ue,e.prerelease=function(he,me){var ve=ae(he,me);return ve&&ve.prerelease.length?ve.prerelease:null},e.intersects=function(he,me,ve){return he=new ge(he,ve),me=new ge(me,ve),he.intersects(me)},e.coerce=function(he){if(he instanceof G)return he;if(typeof he!="string")return null;var me=he.match(D[y]);return me==null?null:ae((me[1]||"0")+"."+(me[2]||"0")+"."+(me[3]||"0"))}}).call(this,k(1))},function(se,e){var k,O,T=se.exports={};function A(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function D(v){if(k===setTimeout)return setTimeout(v,0);if((k===A||!k)&&setTimeout)return k=setTimeout,setTimeout(v,0);try{return k(v,0)}catch{try{return k.call(null,v,0)}catch{return k.call(this,v,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:A}catch{k=A}try{O=typeof clearTimeout=="function"?clearTimeout:L}catch{O=L}})();var I,m=[],P=!1,b=-1;function S(){P&&I&&(P=!1,I.length?m=I.concat(m):b=-1,m.length&&l())}function l(){if(!P){var v=D(S);P=!0;for(var u=m.length;u;){for(I=m,m=[];++b<u;)I&&I[b].run();b=-1,u=m.length}I=null,P=!1,function(d){if(O===clearTimeout)return clearTimeout(d);if((O===L||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(d);try{O(d)}catch{try{return O.call(null,d)}catch{return O.call(this,d)}}}(v)}}function g(v,u){this.fun=v,this.array=u}function p(){}T.nextTick=function(v){var u=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)u[d-1]=arguments[d];m.push(new g(v,u)),m.length!==1||P||D(l)},g.prototype.run=function(){this.fun.apply(null,this.array)},T.title="browser",T.browser=!0,T.env={},T.argv=[],T.version="",T.versions={},T.on=p,T.addListener=p,T.once=p,T.off=p,T.removeListener=p,T.removeAllListeners=p,T.emit=p,T.prependListener=p,T.prependOnceListener=p,T.listeners=function(v){return[]},T.binding=function(v){throw new Error("process.binding is not supported")},T.cwd=function(){return"/"},T.chdir=function(v){throw new Error("process.chdir is not supported")},T.umask=function(){return 0}}])}),define(le[128],ue([0,1]),function(se,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class O{constructor(D,I,m){this.level=D,this.key=I,this.value=m,this.forward=[]}}const T=void 0;class A{constructor(D,I=2**16){this.comparator=D,this[k]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(I)|0),this._header=new O(this._maxLevel,T,T)}get size(){return this._size}clear(){this._header=new O(this._maxLevel,T,T),this._size=0}has(D){return!!A._search(this,D,this.comparator)}get(D){return A._search(this,D,this.comparator)?.value}set(D,I){return A._insert(this,D,I,this.comparator)&&(this._size+=1),this}delete(D){const I=A._delete(this,D,this.comparator);return I&&(this._size-=1),I}forEach(D,I){let m=this._header.forward[0];for(;m;)D.call(I,m.value,m.key,this),m=m.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let D=this._header.forward[0];for(;D;)yield[D.key,D.value],D=D.forward[0]}*keys(){let D=this._header.forward[0];for(;D;)yield D.key,D=D.forward[0]}*values(){let D=this._header.forward[0];for(;D;)yield D.value,D=D.forward[0]}toString(){let D="[SkipList]:",I=this._header.forward[0];for(;I;)D+=`node(${I.key}, ${I.value}, lvl:${I.level})`,I=I.forward[0];return D}static _search(D,I,m){let P=D._header;for(let b=D._level-1;b>=0;b--)for(;P.forward[b]&&m(P.forward[b].key,I)<0;)P=P.forward[b];if(P=P.forward[0],P&&m(P.key,I)===0)return P}static _insert(D,I,m,P){const b=[];let S=D._header;for(let l=D._level-1;l>=0;l--){for(;S.forward[l]&&P(S.forward[l].key,I)<0;)S=S.forward[l];b[l]=S}if(S=S.forward[0],S&&P(S.key,I)===0)return S.value=m,!1;{const l=A._randomLevel(D);if(l>D._level){for(let g=D._level;g<l;g++)b[g]=D._header;D._level=l}S=new O(l,I,m);for(let g=0;g<l;g++)S.forward[g]=b[g].forward[g],b[g].forward[g]=S;return!0}}static _randomLevel(D,I=.5){let m=1;for(;Math.random()<I&&m<D._maxLevel;)m+=1;return m}static _delete(D,I,m){const P=[];let b=D._header;for(let S=D._level-1;S>=0;S--){for(;b.forward[S]&&m(b.forward[S].key,I)<0;)b=b.forward[S];P[S]=b}if(b=b.forward[0],!b||m(b.key,I)!==0)return!1;for(let S=0;S<D._level&&P[S].forward[S]===b;S++)P[S].forward[S]=b.forward[S];for(;D._level>0&&D._header.forward[D._level-1]===T;)D._level-=1;return!0}}e.SkipList=A}),define(le[63],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const k=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(A){return new O(A)}constructor(A){this._now=k&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=O}),define(le[3],ue([0,1,7,86,2,87,63]),function(se,e,k,O,T,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const D=!1,I=!1;var m;(function(E){E.None=()=>T.Disposable.None;function h(te){if(I){const{onDidAddListener:ne}=te,ce=g.create();let fe=0;te.onDidAddListener=()=>{++fe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ce.print()),ne?.()}}}function y(te,ne){return J(te,()=>{},0,void 0,!0,void 0,ne)}E.defer=y;function R(te){return(ne,ce=null,fe)=>{let ge=!1,Se;return Se=te(Ce=>{if(!ge)return Se?Se.dispose():ge=!0,ne.call(ce,Ce)},null,fe),ge&&Se.dispose(),Se}}E.once=R;function U(te,ne,ce){return X((fe,ge=null,Se)=>te(Ce=>fe.call(ge,ne(Ce)),null,Se),ce)}E.map=U;function F(te,ne,ce){return X((fe,ge=null,Se)=>te(Ce=>{ne(Ce),fe.call(ge,Ce)},null,Se),ce)}E.forEach=F;function M(te,ne,ce){return X((fe,ge=null,Se)=>te(Ce=>ne(Ce)&&fe.call(ge,Ce),null,Se),ce)}E.filter=M;function j(te){return te}E.signal=j;function Q(...te){return(ne,ce=null,fe)=>{const ge=(0,T.combinedDisposable)(...te.map(Se=>Se(Ce=>ne.call(ce,Ce))));return x(ge,fe)}}E.any=Q;function K(te,ne,ce,fe){let ge=ce;return U(te,Se=>(ge=ne(ge,Se),ge),fe)}E.reduce=K;function X(te,ne){let ce;const fe={onWillAddFirstListener(){ce=te(ge.fire,ge)},onDidRemoveLastListener(){ce?.dispose()}};ne||h(fe);const ge=new f(fe);return ne?.add(ge),ge.event}function x(te,ne){return ne instanceof Array?ne.push(te):ne&&ne.add(te),te}function J(te,ne,ce=100,fe=!1,ge=!1,Se,Ce){let Re,ke,Ue,he=0,me;const ve={leakWarningThreshold:Se,onWillAddFirstListener(){Re=te(De=>{he++,ke=ne(ke,De),fe&&!Ue&&(Pe.fire(ke),ke=void 0),me=()=>{const Me=ke;ke=void 0,Ue=void 0,(!fe||he>1)&&Pe.fire(Me),he=0},typeof ce=="number"?(clearTimeout(Ue),Ue=setTimeout(me,ce)):Ue===void 0&&(Ue=0,queueMicrotask(me))})},onWillRemoveListener(){ge&&he>0&&me?.()},onDidRemoveLastListener(){me=void 0,Re.dispose()}};Ce||h(ve);const Pe=new f(ve);return Ce?.add(Pe),Pe.event}E.debounce=J;function V(te,ne=0,ce){return E.debounce(te,(fe,ge)=>fe?(fe.push(ge),fe):[ge],ne,void 0,!0,void 0,ce)}E.accumulate=V;function q(te,ne=(fe,ge)=>fe===ge,ce){let fe=!0,ge;return M(te,Se=>{const Ce=fe||!ne(Se,ge);return fe=!1,ge=Se,Ce},ce)}E.latch=q;function ie(te,ne,ce){return[E.filter(te,ne,ce),E.filter(te,fe=>!ne(fe),ce)]}E.split=ie;function re(te,ne=!1,ce=[],fe){let ge=ce.slice(),Se=te(ke=>{ge?ge.push(ke):Re.fire(ke)});fe&&fe.add(Se);const Ce=()=>{ge?.forEach(ke=>Re.fire(ke)),ge=null},Re=new f({onWillAddFirstListener(){Se||(Se=te(ke=>Re.fire(ke)),fe&&fe.add(Se))},onDidAddFirstListener(){ge&&(ne?setTimeout(Ce):Ce())},onDidRemoveLastListener(){Se&&Se.dispose(),Se=null}});return fe&&fe.add(Re),Re.event}E.buffer=re;function ee(te,ne){return(fe,ge,Se)=>{const Ce=ne(new G);return te(function(Re){const ke=Ce.evaluate(Re);ke!==ae&&fe.call(ge,ke)},void 0,Se)}}E.chain=ee;const ae=Symbol("HaltChainable");class G{constructor(){this.steps=[]}map(ne){return this.steps.push(ne),this}forEach(ne){return this.steps.push(ce=>(ne(ce),ce)),this}filter(ne){return this.steps.push(ce=>ne(ce)?ce:ae),this}reduce(ne,ce){let fe=ce;return this.steps.push(ge=>(fe=ne(fe,ge),fe)),this}latch(ne=(ce,fe)=>ce===fe){let ce=!0,fe;return this.steps.push(ge=>{const Se=ce||!ne(ge,fe);return ce=!1,fe=ge,Se?ge:ae}),this}evaluate(ne){for(const ce of this.steps)if(ne=ce(ne),ne===ae)break;return ne}}function W(te,ne,ce=fe=>fe){const fe=(...Re)=>Ce.fire(ce(...Re)),ge=()=>te.on(ne,fe),Se=()=>te.removeListener(ne,fe),Ce=new f({onWillAddFirstListener:ge,onDidRemoveLastListener:Se});return Ce.event}E.fromNodeEventEmitter=W;function _(te,ne,ce=fe=>fe){const fe=(...Re)=>Ce.fire(ce(...Re)),ge=()=>te.addEventListener(ne,fe),Se=()=>te.removeEventListener(ne,fe),Ce=new f({onWillAddFirstListener:ge,onDidRemoveLastListener:Se});return Ce.event}E.fromDOMEventEmitter=_;function N(te){return new Promise(ne=>R(te)(ne))}E.toPromise=N;function z(te){const ne=new f;return te.then(ce=>{ne.fire(ce)},()=>{ne.fire(void 0)}).finally(()=>{ne.dispose()}),ne.event}E.fromPromise=z;function $(te,ne,ce){return ne(ce),te(fe=>ne(fe))}E.runAndSubscribe=$;class Z{constructor(ne,ce){this._observable=ne,this._counter=0,this._hasChanged=!1;const fe={onWillAddFirstListener:()=>{ne.addObserver(this)},onDidRemoveLastListener:()=>{ne.removeObserver(this)}};ce||h(fe),this.emitter=new f(fe),ce&&ce.add(this.emitter)}beginUpdate(ne){this._counter++}handlePossibleChange(ne){}handleChange(ne,ce){this._hasChanged=!0}endUpdate(ne){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function B(te,ne){return new Z(te,ne).emitter.event}E.fromObservable=B;function H(te){return(ne,ce,fe)=>{let ge=0,Se=!1;const Ce={beginUpdate(){ge++},endUpdate(){ge--,ge===0&&(te.reportChanges(),Se&&(Se=!1,ne.call(ce)))},handlePossibleChange(){},handleChange(){Se=!0}};te.addObserver(Ce),te.reportChanges();const Re={dispose(){te.removeObserver(Ce)}};return fe instanceof T.DisposableStore?fe.add(Re):Array.isArray(fe)&&fe.push(Re),Re}}E.fromObservableLight=H})(m||(e.Event=m={}));class P{static{this.all=new Set}static{this._idPool=0}constructor(h){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${h}_${P._idPool++}`,P.all.add(this)}start(h){this._stopWatch=new L.StopWatch,this.listenerCount=h}stop(){if(this._stopWatch){const h=this._stopWatch.elapsed();this.durations.push(h),this.elapsedOverall+=h,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=P;let b=-1;function S(E){const h=b;return b=E,{dispose(){b=h}}}e.setGlobalLeakWarningThreshold=S;class l{constructor(h,y=Math.random().toString(18).slice(2,5)){this.threshold=h,this.name=y,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(h,y){const R=this.threshold;if(R<=0||y<R)return;this._stacks||(this._stacks=new Map);const U=this._stacks.get(h.value)||0;if(this._stacks.set(h.value,U+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=R*.5;let F,M=0;for(const[j,Q]of this._stacks)(!F||M<Q)&&(F=j,M=Q);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${M}):`),console.warn(F)}return()=>{const F=this._stacks.get(h.value)||0;this._stacks.set(h.value,F-1)}}}class g{static create(){return new g(new Error().stack??"")}constructor(h){this.value=h}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class v{constructor(h){this.value=h,this.id=p++}}const u=2,d=(E,h)=>{if(E instanceof v)h(E);else for(let y=0;y<E.length;y++){const R=E[y];R&&h(R)}};class f{constructor(h){this._size=0,this._options=h,this._leakageMon=b>0||this._options?.leakWarningThreshold?new l(this._options?.leakWarningThreshold??b):void 0,this._perfMon=this._options?._profName?new P(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(D){const h=this._listeners;queueMicrotask(()=>{d(h,y=>y.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(h,y,R)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),T.Disposable.None;if(this._disposed)return T.Disposable.None;y&&(h=h.bind(y));const U=new v(h);let F,M;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(U.stack=g.create(),F=this._leakageMon.check(U.stack,this._size+1)),D&&(U.stack=M??g.create()),this._listeners?this._listeners instanceof v?(this._deliveryQueue??=new w,this._listeners=[this._listeners,U]):this._listeners.push(U):(this._options?.onWillAddFirstListener?.(this),this._listeners=U,this._options?.onDidAddFirstListener?.(this)),this._size++;const j=(0,T.toDisposable)(()=>{F?.(),this._removeListener(U)});return R instanceof T.DisposableStore?R.add(j):Array.isArray(R)&&R.push(j),j},this._event}_removeListener(h){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const y=this._listeners,R=y.indexOf(h);if(R===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,y[R]=void 0;const U=this._deliveryQueue.current===this;if(this._size*u<=y.length){let F=0;for(let M=0;M<y.length;M++)y[M]?y[F++]=y[M]:U&&(this._deliveryQueue.end--,F<this._deliveryQueue.i&&this._deliveryQueue.i--);y.length=F}}_deliver(h,y){if(!h)return;const R=this._options?.onListenerError||k.onUnexpectedError;if(!R){h.value(y);return}try{h.value(y)}catch(U){R(U)}}_deliverQueue(h){const y=h.current._listeners;for(;h.i<h.end;)this._deliver(y[h.i++],h.value);h.reset()}fire(h){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof v)this._deliver(this._listeners,h);else{const y=this._deliveryQueue;y.enqueue(this,h,this._listeners.length),this._deliverQueue(y)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=f;const c=()=>new w;e.createEventDeliveryQueue=c;class w{constructor(){this.i=-1,this.end=0}enqueue(h,y,R){this.i=0,this.end=R,this.current=h,this.value=y}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends f{async fireAsync(h,y,R){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList),d(this._listeners,U=>this._asyncDeliveryQueue.push([U.value,h]));this._asyncDeliveryQueue.size>0&&!y.isCancellationRequested;){const[U,F]=this._asyncDeliveryQueue.shift(),M=[],j={...F,token:y,waitUntil:Q=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");R&&(Q=R(Q,U)),M.push(Q)}};try{U(j)}catch(Q){(0,k.onUnexpectedError)(Q);continue}Object.freeze(M),await Promise.allSettled(M).then(Q=>{for(const K of Q)K.status==="rejected"&&(0,k.onUnexpectedError)(K.reason)})}}}e.AsyncEmitter=i;class o extends f{get isPaused(){return this._isPaused!==0}constructor(h){super(h),this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=h?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const h=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(h))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(h){this._size&&(this._isPaused!==0?this._eventQueue.push(h):super.fire(h))}}e.PauseableEmitter=o;class n extends o{constructor(h){super(h),this._delay=h.delay??100}fire(h){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(h)}}e.DebounceEmitter=n;class s extends f{constructor(h){super(h),this._queuedEvents=[],this._mergeFn=h?.merge}fire(h){this.hasListeners()&&(this._queuedEvents.push(h),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(y=>super.fire(y)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=s;class t{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(h){const y={event:h,listener:null};this.events.push(y),this.hasListeners&&this.hook(y);const R=()=>{this.hasListeners&&this.unhook(y);const U=this.events.indexOf(y);this.events.splice(U,1)};return(0,T.toDisposable)((0,O.createSingleCallFunction)(R))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(h=>this.hook(h))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(h=>this.unhook(h))}hook(h){h.listener=h.event(y=>this.emitter.fire(y))}unhook(h){h.listener&&h.listener.dispose(),h.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=t;class r{constructor(h,y,R,U){this._store=new T.DisposableStore;const F=this._store.add(new t),M=this._store.add(new T.DisposableMap);function j(Q){M.set(Q,F.add(U(Q)))}for(const Q of h)j(Q);this._store.add(y(Q=>{j(Q)})),this._store.add(R(Q=>{M.deleteAndDispose(Q)})),this.event=F.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=r;class a{constructor(){this.buffers=[]}wrapEvent(h){return(y,R,U)=>h(F=>{const M=this.buffers[this.buffers.length-1];M?M.push(()=>y.call(R,F)):y.call(R,F)},void 0,U)}bufferEvents(h){const y=[];this.buffers.push(y);const R=h();return this.buffers.pop(),y.forEach(U=>U()),R}}e.EventBufferer=a;class C{constructor(){this.listening=!1,this.inputEvent=m.None,this.inputEventListener=T.Disposable.None,this.emitter=new f({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(h){this.inputEvent=h,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=h(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=C}),define(le[26],ue([0,1,3]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const O=Object.freeze(function(D,I){const m=setTimeout(D.bind(I),0);return{dispose(){clearTimeout(m)}}});var T;(function(D){function I(m){return m===D.None||m===D.Cancelled||m instanceof A?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}D.isCancellationToken=I,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(T||(e.CancellationToken=T={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?O:(this._emitter||(this._emitter=new k.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class L{constructor(I){this._token=void 0,this._parentListener=void 0,this._parentListener=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=T.Cancelled}dispose(I=!1){I&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=T.None}}e.CancellationTokenSource=L}),define(le[129],ue([0,1,26]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class O{constructor(D){this.task=D,this.result=null}get(){if(this.result)return this.result;const D=new k.CancellationTokenSource,I=this.task(D.token);return this.result={promise:I,dispose:()=>{this.result=null,D.cancel(),D.dispose()}},this.result}}e.Cache=O;class T{constructor(D){this.fn=D,this.lastCache=void 0,this.lastArgKey=void 0}get(D){const I=JSON.stringify(D);return this.lastArgKey!==I&&(this.lastArgKey=I,this.lastCache=this.fn(D)),this.lastCache}}e.LRUCachedFunction=T;class A{get cachedValues(){return this._map}constructor(D){this.fn=D,this._map=new Map}get(D){if(this._map.has(D))return this._map.get(D);const I=this.fn(D);return this._map.set(D,I),I}}e.CachedFunction=A}),define(le[47],ue([0,1,7,2]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function T(c){const w=c;return w?typeof w.read=="function":!1}e.isReadable=T;function A(c){const w=c;return w?[w.on,w.pause,w.resume,w.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=A;function L(c){const w=c;return w?A(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=L;function D(c,w){return new I(c,w)}e.newWriteableStream=D;class I{constructor(w,i){this.reducer=w,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(w){if(!this.state.destroyed){if(this.state.flowing)this.emitData(w);else if(this.buffer.data.push(w),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(w){this.state.destroyed||(this.state.flowing?this.emitError(w):this.buffer.error.push(w))}end(w){this.state.destroyed||(typeof w<"u"&&this.write(w),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(w){this.listeners.data.slice(0).forEach(i=>i(w))}emitError(w){this.listeners.error.length===0?(0,k.onUnexpectedError)(w):this.listeners.error.slice(0).forEach(i=>i(w))}emitEnd(){this.listeners.end.slice(0).forEach(w=>w())}on(w,i){if(!this.state.destroyed)switch(w){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(w,i){if(this.state.destroyed)return;let o;switch(w){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const n=o.indexOf(i);n>=0&&o.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const w=this.reducer(this.buffer.data);this.emitData(w),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const w of this.buffer.error)this.emitError(w);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(c,w){const i=[];let o;for(;(o=c.read())!==null;)i.push(o);return w(i)}e.consumeReadable=m;function P(c,w,i){const o=[];let n;for(;(n=c.read())!==null&&o.length<i;)o.push(n);return n===null&&o.length>0?w(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return c.read()}}}e.peekReadable=P;function b(c,w){return new Promise((i,o)=>{const n=[];S(c,{onData:s=>{w&&n.push(s)},onError:s=>{w?o(s):i(void 0)},onEnd:()=>{i(w?w(n):void 0)}})})}e.consumeStream=b;function S(c,w,i){c.on("error",o=>{i?.isCancellationRequested||w.onError(o)}),c.on("end",()=>{i?.isCancellationRequested||w.onEnd()}),c.on("data",o=>{i?.isCancellationRequested||w.onData(o)})}e.listenStream=S;function l(c,w){return new Promise((i,o)=>{const n=new O.DisposableStore,s=[],t=C=>{if(s.push(C),s.length>w)return n.dispose(),c.pause(),i({stream:c,buffer:s,ended:!1})},r=C=>(n.dispose(),o(C)),a=()=>(n.dispose(),i({stream:c,buffer:s,ended:!0}));n.add((0,O.toDisposable)(()=>c.removeListener("error",r))),c.on("error",r),n.add((0,O.toDisposable)(()=>c.removeListener("end",a))),c.on("end",a),n.add((0,O.toDisposable)(()=>c.removeListener("data",t))),c.on("data",t)})}e.peekStream=l;function g(c,w){const i=D(w);return i.end(c),i}e.toStream=g;function p(){const c=D(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=p;function v(c){let w=!1;return{read:()=>w?null:(w=!0,c)}}e.toReadable=v;function u(c,w,i){const o=D(i);return S(c,{onData:n=>o.write(w.data(n)),onError:n=>o.error(w.error?w.error(n):n),onEnd:()=>o.end()}),o}e.transform=u;function d(c,w,i){let o=!1;return{read:()=>{const n=w.read();return o?n:(o=!0,n!==null?i([c,n]):c)}}}e.prefixedReadable=d;function f(c,w,i){let o=!1;const n=D(i);return S(w,{onData:s=>o?n.write(s):(o=!0,n.write(i([c,s]))),onError:s=>n.error(s),onEnd:()=>{o||(o=!0,n.write(c)),n.end()}}),n}e.prefixedStream=f}),define(le[14],ue([0,1,52,47]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const T=typeof Buffer<"u",A=new k.Lazy(()=>new Uint8Array(256));let L,D;class I{static alloc(y){return T?new I(Buffer.allocUnsafe(y)):new I(new Uint8Array(y))}static wrap(y){return T&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new I(y)}static fromString(y,R){return!(R?.dontUseNodeBuffer||!1)&&T?new I(Buffer.from(y)):(L||(L=new TextEncoder),new I(L.encode(y)))}static fromByteArray(y){const R=I.alloc(y.length);for(let U=0,F=y.length;U<F;U++)R.buffer[U]=y[U];return R}static concat(y,R){if(typeof R>"u"){R=0;for(let M=0,j=y.length;M<j;M++)R+=y[M].byteLength}const U=I.alloc(R);let F=0;for(let M=0,j=y.length;M<j;M++){const Q=y[M];U.set(Q,F),F+=Q.byteLength}return U}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=I.alloc(this.byteLength);return y.set(this),y}toString(){return T?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(y,R){return new I(this.buffer.subarray(y,R))}set(y,R){if(y instanceof I)this.buffer.set(y.buffer,R);else if(y instanceof Uint8Array)this.buffer.set(y,R);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),R);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return S(this.buffer,y)}writeUInt32BE(y,R){l(this.buffer,y,R)}readUInt32LE(y){return g(this.buffer,y)}writeUInt32LE(y,R){p(this.buffer,y,R)}readUInt8(y){return v(this.buffer,y)}writeUInt8(y,R){u(this.buffer,y,R)}indexOf(y,R=0){return m(this.buffer,y instanceof I?y.buffer:y,R)}}e.VSBuffer=I;function m(h,y,R=0){const U=y.byteLength,F=h.byteLength;if(U===0)return 0;if(U===1)return h.indexOf(y[0]);if(U>F-R)return-1;const M=A.value;M.fill(y.length);for(let X=0;X<y.length;X++)M[y[X]]=y.length-X-1;let j=R+y.length-1,Q=j,K=-1;for(;j<F;)if(h[j]===y[Q]){if(Q===0){K=j;break}j--,Q--}else j+=Math.max(y.length-Q,M[h[j]]),Q=y.length-1;return K}e.binaryIndexOf=m;function P(h,y){return h[y+0]<<0>>>0|h[y+1]<<8>>>0}e.readUInt16LE=P;function b(h,y,R){h[R+0]=y&255,y=y>>>8,h[R+1]=y&255}e.writeUInt16LE=b;function S(h,y){return h[y]*2**24+h[y+1]*2**16+h[y+2]*2**8+h[y+3]}e.readUInt32BE=S;function l(h,y,R){h[R+3]=y,y=y>>>8,h[R+2]=y,y=y>>>8,h[R+1]=y,y=y>>>8,h[R]=y}e.writeUInt32BE=l;function g(h,y){return h[y+0]<<0>>>0|h[y+1]<<8>>>0|h[y+2]<<16>>>0|h[y+3]<<24>>>0}e.readUInt32LE=g;function p(h,y,R){h[R+0]=y&255,y=y>>>8,h[R+1]=y&255,y=y>>>8,h[R+2]=y&255,y=y>>>8,h[R+3]=y&255}e.writeUInt32LE=p;function v(h,y){return h[y]}e.readUInt8=v;function u(h,y,R){h[R]=y}e.writeUInt8=u;function d(h){return O.consumeReadable(h,y=>I.concat(y))}e.readableToBuffer=d;function f(h){return O.toReadable(h)}e.bufferToReadable=f;function c(h){return O.consumeStream(h,y=>I.concat(y))}e.streamToBuffer=c;async function w(h){return h.ended?I.concat(h.buffer):I.concat([...h.buffer,await c(h.stream)])}e.bufferedStreamToBuffer=w;function i(h){return O.toStream(h,y=>I.concat(y))}e.bufferToStream=i;function o(h){return O.transform(h,{data:y=>typeof y=="string"?I.fromString(y):I.wrap(y)},y=>I.concat(y))}e.streamToBufferReadableStream=o;function n(h){return O.newWriteableStream(y=>I.concat(y),h)}e.newWriteableBufferStream=n;function s(h,y){return O.prefixedReadable(h,y,R=>I.concat(R))}e.prefixedBufferReadable=s;function t(h,y){return O.prefixedStream(h,y,R=>I.concat(R))}e.prefixedBufferStream=t;function r(h){let y=0,R=0,U=0;const F=new Uint8Array(Math.floor(h.length/4*3)),M=Q=>{switch(R){case 3:F[U++]=y|Q,R=0;break;case 2:F[U++]=y|Q>>>2,y=Q<<6,R=3;break;case 1:F[U++]=y|Q>>>4,y=Q<<4,R=2;break;default:y=Q<<2,R=1}};for(let Q=0;Q<h.length;Q++){const K=h.charCodeAt(Q);if(K>=65&&K<=90)M(K-65);else if(K>=97&&K<=122)M(K-97+26);else if(K>=48&&K<=57)M(K-48+52);else if(K===43||K===45)M(62);else if(K===47||K===95)M(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${h[Q]}`)}}const j=U;for(;R>0;)M(0);return I.wrap(F).slice(0,j)}e.decodeBase64=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function E({buffer:h},y=!0,R=!1){const U=R?C:a;let F="";const M=h.byteLength%3;let j=0;for(;j<h.byteLength-M;j+=3){const Q=h[j+0],K=h[j+1],X=h[j+2];F+=U[Q>>>2],F+=U[(Q<<4|K>>>4)&63],F+=U[(K<<2|X>>>6)&63],F+=U[X&63]}if(M===1){const Q=h[j+0];F+=U[Q>>>2],F+=U[Q<<4&63],y&&(F+="==")}else if(M===2){const Q=h[j+0],K=h[j+1];F+=U[Q>>>2],F+=U[(Q<<4|K>>>4)&63],F+=U[K<<2&63],y&&(F+="=")}return F}e.encodeBase64=E}),define(le[27],ue([0,1,129,52]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncateMiddle=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.htmlAttributeEncodeValue=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function T(oe){return!oe||typeof oe!="string"?!0:oe.trim().length===0}e.isFalsyOrWhitespace=T;const A=/{(\d+)}/g;function L(oe,...de){return de.length===0?oe:oe.replace(A,function(pe,we){const Ee=parseInt(we,10);return isNaN(Ee)||Ee<0||Ee>=de.length?pe:de[Ee]})}e.format=L;const D=/{([^}]+)}/g;function I(oe,de){return Object.keys(de).length===0?oe:oe.replace(D,(pe,we)=>de[we]??pe)}e.format2=I;function m(oe){return oe.replace(/[<>"'&]/g,de=>{switch(de){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return de})}e.htmlAttributeEncodeValue=m;function P(oe){return oe.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}e.escape=P;function b(oe){return oe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=b;function S(oe,de){let pe=0;const we=de.charCodeAt(0);for(let Ee=oe.length-1;Ee>=0;Ee--)oe.charCodeAt(Ee)===we&&pe++;return pe}e.count=S;function l(oe,de,pe="\u2026"){return oe.length<=de?oe:`${oe.substr(0,de)}${pe}`}e.truncate=l;function g(oe,de,pe="\u2026"){if(oe.length<=de)return oe;const we=Math.ceil(de/2)-pe.length/2,Ee=Math.floor(de/2)-pe.length/2;return`${oe.substr(0,we)}${pe}${oe.substr(oe.length-Ee)}`}e.truncateMiddle=g;function p(oe,de=" "){const pe=v(oe,de);return u(pe,de)}e.trim=p;function v(oe,de){if(!oe||!de)return oe;const pe=de.length;if(pe===0||oe.length===0)return oe;let we=0;for(;oe.indexOf(de,we)===we;)we=we+pe;return oe.substring(we)}e.ltrim=v;function u(oe,de){if(!oe||!de)return oe;const pe=de.length,we=oe.length;if(pe===0||we===0)return oe;let Ee=we,Ie=-1;for(;Ie=oe.lastIndexOf(de,Ee-1),!(Ie===-1||Ie+pe!==Ee);){if(Ie===0)return"";Ee=Ie}return oe.substring(0,Ee)}e.rtrim=u;function d(oe){return oe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function f(oe){return oe.replace(/\*/g,"")}e.stripWildcards=f;function c(oe,de,pe={}){if(!oe)throw new Error("Cannot create regex from empty string");de||(oe=b(oe)),pe.wholeWord&&(/\B/.test(oe.charAt(0))||(oe="\\b"+oe),/\B/.test(oe.charAt(oe.length-1))||(oe=oe+"\\b"));let we="";return pe.global&&(we+="g"),pe.matchCase||(we+="i"),pe.multiline&&(we+="m"),pe.unicode&&(we+="u"),new RegExp(oe,we)}e.createRegExp=c;function w(oe){return oe.source==="^"||oe.source==="^$"||oe.source==="$"||oe.source==="^\\s*$"?!1:!!(oe.exec("")&&oe.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function i(oe){return oe.split(/\r\n|\r|\n/)}e.splitLines=i;function o(oe){for(let de=0,pe=oe.length;de<pe;de++){const we=oe.charCodeAt(de);if(we!==32&&we!==9)return de}return-1}e.firstNonWhitespaceIndex=o;function n(oe,de=0,pe=oe.length){for(let we=de;we<pe;we++){const Ee=oe.charCodeAt(we);if(Ee!==32&&Ee!==9)return oe.substring(de,we)}return oe.substring(de,pe)}e.getLeadingWhitespace=n;function s(oe,de=oe.length-1){for(let pe=de;pe>=0;pe--){const we=oe.charCodeAt(pe);if(we!==32&&we!==9)return pe}return-1}e.lastNonWhitespaceIndex=s;function t(oe,de,pe){const we=[];let Ee=0;for(const Ie of oe.matchAll(de)){if(we.push(oe.slice(Ee,Ie.index)),Ie.index===void 0)throw new Error("match.index should be defined");Ee=Ie.index+Ie[0].length,we.push(pe(Ie[0],...Ie.slice(1),Ie.index,oe,Ie.groups))}return we.push(oe.slice(Ee)),Promise.all(we).then(Ie=>Ie.join(""))}e.replaceAsync=t;function r(oe,de){return oe<de?-1:oe>de?1:0}e.compare=r;function a(oe,de,pe=0,we=oe.length,Ee=0,Ie=de.length){for(;pe<we&&Ee<Ie;pe++,Ee++){const Oe=oe.charCodeAt(pe),qe=de.charCodeAt(Ee);if(Oe<qe)return-1;if(Oe>qe)return 1}const Le=we-pe,Te=Ie-Ee;return Le<Te?-1:Le>Te?1:0}e.compareSubstring=a;function C(oe,de){return E(oe,de,0,oe.length,0,de.length)}e.compareIgnoreCase=C;function E(oe,de,pe=0,we=oe.length,Ee=0,Ie=de.length){for(;pe<we&&Ee<Ie;pe++,Ee++){let Oe=oe.charCodeAt(pe),qe=de.charCodeAt(Ee);if(Oe===qe)continue;if(Oe>=128||qe>=128)return a(oe.toLowerCase(),de.toLowerCase(),pe,we,Ee,Ie);y(Oe)&&(Oe-=32),y(qe)&&(qe-=32);const $e=Oe-qe;if($e!==0)return $e}const Le=we-pe,Te=Ie-Ee;return Le<Te?-1:Le>Te?1:0}e.compareSubstringIgnoreCase=E;function h(oe){return oe>=48&&oe<=57}e.isAsciiDigit=h;function y(oe){return oe>=97&&oe<=122}e.isLowerAsciiLetter=y;function R(oe){return oe>=65&&oe<=90}e.isUpperAsciiLetter=R;function U(oe,de){return oe.length===de.length&&E(oe,de)===0}e.equalsIgnoreCase=U;function F(oe,de){const pe=de.length;return de.length>oe.length?!1:E(oe,de,0,pe)===0}e.startsWithIgnoreCase=F;function M(oe,de){const pe=Math.min(oe.length,de.length);let we;for(we=0;we<pe;we++)if(oe.charCodeAt(we)!==de.charCodeAt(we))return we;return pe}e.commonPrefixLength=M;function j(oe,de){const pe=Math.min(oe.length,de.length);let we;const Ee=oe.length-1,Ie=de.length-1;for(we=0;we<pe;we++)if(oe.charCodeAt(Ee-we)!==de.charCodeAt(Ie-we))return we;return pe}e.commonSuffixLength=j;function Q(oe){return 55296<=oe&&oe<=56319}e.isHighSurrogate=Q;function K(oe){return 56320<=oe&&oe<=57343}e.isLowSurrogate=K;function X(oe,de){return(oe-55296<<10)+(de-56320)+65536}e.computeCodePoint=X;function x(oe,de,pe){const we=oe.charCodeAt(pe);if(Q(we)&&pe+1<de){const Ee=oe.charCodeAt(pe+1);if(K(Ee))return X(we,Ee)}return we}e.getNextCodePoint=x;function J(oe,de){const pe=oe.charCodeAt(de-1);if(K(pe)&&de>1){const we=oe.charCodeAt(de-2);if(Q(we))return X(we,pe)}return pe}class V{get offset(){return this._offset}constructor(de,pe=0){this._str=de,this._len=de.length,this._offset=pe}setOffset(de){this._offset=de}prevCodePoint(){const de=J(this._str,this._offset);return this._offset-=de>=65536?2:1,de}nextCodePoint(){const de=x(this._str,this._len,this._offset);return this._offset+=de>=65536?2:1,de}eol(){return this._offset>=this._len}}e.CodePointIterator=V;class q{get offset(){return this._iterator.offset}constructor(de,pe=0){this._iterator=new V(de,pe)}nextGraphemeLength(){const de=Pe.getInstance(),pe=this._iterator,we=pe.offset;let Ee=de.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Ie=pe.offset,Le=de.getGraphemeBreakType(pe.nextCodePoint());if(me(Ee,Le)){pe.setOffset(Ie);break}Ee=Le}return pe.offset-we}prevGraphemeLength(){const de=Pe.getInstance(),pe=this._iterator,we=pe.offset;let Ee=de.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Ie=pe.offset,Le=de.getGraphemeBreakType(pe.prevCodePoint());if(me(Le,Ee)){pe.setOffset(Ie);break}Ee=Le}return we-pe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=q;function ie(oe,de){return new q(oe,de).nextGraphemeLength()}e.nextCharLength=ie;function re(oe,de){return new q(oe,de).prevGraphemeLength()}e.prevCharLength=re;function ee(oe,de){de>0&&K(oe.charCodeAt(de))&&de--;const pe=de+ie(oe,de);return[pe-re(oe,pe),pe]}e.getCharContainingOffset=ee;function ae(oe){const de=new q(oe);let pe=0;for(;!de.eol();)pe++,de.nextGraphemeLength();return pe}e.charCount=ae;let G;function W(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _(oe){return G||(G=W()),G.test(oe)}e.containsRTL=_;const N=/^[\t\n\r\x20-\x7E]*$/;function z(oe){return N.test(oe)}e.isBasicASCII=z,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function $(oe){return e.UNUSUAL_LINE_TERMINATORS.test(oe)}e.containsUnusualLineTerminators=$;function Z(oe){return oe>=11904&&oe<=55215||oe>=63744&&oe<=64255||oe>=65281&&oe<=65374}e.isFullWidthCharacter=Z;function B(oe){return oe>=127462&&oe<=127487||oe===8986||oe===8987||oe===9200||oe===9203||oe>=9728&&oe<=10175||oe===11088||oe===11093||oe>=127744&&oe<=128591||oe>=128640&&oe<=128764||oe>=128992&&oe<=129008||oe>=129280&&oe<=129535||oe>=129648&&oe<=129782}e.isEmojiImprecise=B;function H(oe,de,pe=""){const we=oe.trimStart();if(we.length<de)return we;const Ee=/\b/g;let Ie=0;for(;Ee.test(we)&&!(we.length-Ee.lastIndex<de);)Ie=Ee.lastIndex,Ee.lastIndex+=1;return Ie===0?we:pe+we.substring(Ie).trimStart()}e.lcut=H;const te=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ne=/\x1b\].*?\x07/g;function ce(oe){return oe&&(oe=oe.replace(te,"").replace(ne,"")),oe}e.removeAnsiEscapeCodes=ce,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function fe(oe){return!!(oe&&oe.length>0&&oe.charCodeAt(0)===65279)}e.startsWithUTF8BOM=fe;function ge(oe){return fe(oe)?oe.substr(1):oe}e.stripUTF8BOM=ge;function Se(oe,de){if(!oe||!de||oe.length<de.length)return!1;const pe=de.length,we=oe.toLowerCase();let Ee=0,Ie=-1;for(;Ee<pe;){const Le=we.indexOf(de[Ee],Ie+1);if(Le<0)return!1;Ie=Le,Ee++}return!0}e.fuzzyContains=Se;function Ce(oe,de=!1){return oe?(de&&(oe=oe.replace(/\\./g,"")),oe.toLowerCase()!==oe):!1}e.containsUppercaseCharacter=Ce;function Re(oe){return oe.charAt(0).toUpperCase()+oe.slice(1)}e.uppercaseFirstLetter=Re;function ke(oe,de=1){if(de===0)return"";let pe=-1;do pe=oe.indexOf(`
`,pe+1),de--;while(de>0&&pe>=0);return pe===-1?oe:(oe[pe-1]==="\r"&&pe--,oe.substr(0,pe))}e.getNLines=ke;function Ue(oe){return oe=oe%(2*26),oe<26?String.fromCharCode(97+oe):String.fromCharCode(65+oe-26)}e.singleLetterHash=Ue;function he(oe){return Pe.getInstance().getGraphemeBreakType(oe)}e.getGraphemeBreakType=he;function me(oe,de){return oe===0?de!==5&&de!==7:oe===2&&de===3?!1:oe===4||oe===2||oe===3||de===4||de===2||de===3?!0:!(oe===8&&(de===8||de===9||de===11||de===12)||(oe===11||oe===9)&&(de===9||de===10)||(oe===12||oe===10)&&de===10||de===5||de===13||de===7||oe===1||oe===13&&de===14||oe===6&&de===6)}var ve;(function(oe){oe[oe.Other=0]="Other",oe[oe.Prepend=1]="Prepend",oe[oe.CR=2]="CR",oe[oe.LF=3]="LF",oe[oe.Control=4]="Control",oe[oe.Extend=5]="Extend",oe[oe.Regional_Indicator=6]="Regional_Indicator",oe[oe.SpacingMark=7]="SpacingMark",oe[oe.L=8]="L",oe[oe.V=9]="V",oe[oe.T=10]="T",oe[oe.LV=11]="LV",oe[oe.LVT=12]="LVT",oe[oe.ZWJ=13]="ZWJ",oe[oe.Extended_Pictographic=14]="Extended_Pictographic"})(ve||(e.GraphemeBreakType=ve={}));class Pe{static{this._INSTANCE=null}static getInstance(){return Pe._INSTANCE||(Pe._INSTANCE=new Pe),Pe._INSTANCE}constructor(){this._data=De()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const pe=this._data,we=pe.length/3;let Ee=1;for(;Ee<=we;)if(de<pe[3*Ee])Ee=2*Ee;else if(de>pe[3*Ee+1])Ee=2*Ee+1;else return pe[3*Ee+2];return 0}}function De(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Me(oe,de){if(oe===0)return 0;const pe=_e(oe,de);if(pe!==void 0)return pe;const we=new V(de,oe);return we.prevCodePoint(),we.offset}e.getLeftDeleteOffset=Me;function _e(oe,de){const pe=new V(de,oe);let we=pe.prevCodePoint();for(;We(we)||we===65039||we===8419;){if(pe.offset===0)return;we=pe.prevCodePoint()}if(!B(we))return;let Ee=pe.offset;return Ee>0&&pe.prevCodePoint()===8205&&(Ee=pe.offset),Ee}function We(oe){return 127995<=oe&&oe<=127999}var Ne;(function(oe){oe[oe.zwj=8205]="zwj",oe[oe.emojiVariantSelector=65039]="emojiVariantSelector",oe[oe.enclosingKeyCap=8419]="enclosingKeyCap"})(Ne||(Ne={})),e.noBreakWhitespace="\xA0";class Fe{static{this.ambiguousCharacterData=new O.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new k.LRUCachedFunction(de=>{function pe($e){const ze=new Map;for(let Ve=0;Ve<$e.length;Ve+=2)ze.set($e[Ve],$e[Ve+1]);return ze}function we($e,ze){const Ve=new Map($e);for(const[Je,et]of ze)Ve.set(Je,et);return Ve}function Ee($e,ze){if(!$e)return ze;const Ve=new Map;for(const[Je,et]of $e)ze.has(Je)&&Ve.set(Je,et);return Ve}const Ie=this.ambiguousCharacterData.value;let Le=de.filter($e=>!$e.startsWith("_")&&$e in Ie);Le.length===0&&(Le=["_default"]);let Te;for(const $e of Le){const ze=pe(Ie[$e]);Te=Ee(Te,ze)}const Oe=pe(Ie._common),qe=we(Oe,Te);return new Fe(qe)})}static getInstance(de){return Fe.cache.get(Array.from(de))}static{this._locales=new O.Lazy(()=>Object.keys(Fe.ambiguousCharacterData.value).filter(de=>!de.startsWith("_")))}static getLocales(){return Fe._locales.value}constructor(de){this.confusableDictionary=de}isAmbiguous(de){return this.confusableDictionary.has(de)}getPrimaryConfusable(de){return this.confusableDictionary.get(de)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Fe;class je{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(je.getRawData())),this._data}static isInvisibleCharacter(de){return je.getData().has(de)}static get codePoints(){return je.getData()}}e.InvisibleCharacters=je}),define(le[53],ue([0,1,27]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function O(u){return T(u,0)}e.hash=O;function T(u,d){switch(typeof u){case"object":return u===null?A(349,d):Array.isArray(u)?I(u,d):m(u,d);case"string":return D(u,d);case"boolean":return L(u,d);case"number":return A(u,d);case"undefined":return A(937,d);default:return A(617,d)}}e.doHash=T;function A(u,d){return(d<<5)-d+u|0}e.numberHash=A;function L(u,d){return A(u?433:863,d)}function D(u,d){d=A(149417,d);for(let f=0,c=u.length;f<c;f++)d=A(u.charCodeAt(f),d);return d}e.stringHash=D;function I(u,d){return d=A(104579,d),u.reduce((f,c)=>T(c,f),d)}function m(u,d){return d=A(181387,d),Object.keys(u).sort().reduce((f,c)=>(f=D(c,f),T(u[c],f)),d)}class P{constructor(){this._value=0}get value(){return this._value}hash(d){return this._value=T(d,this._value),this._value}}e.Hasher=P;var b;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function S(u,d,f=32){const c=f-d,w=~((1<<c)-1);return(u<<d|(w&u)>>>c)>>>0}function l(u,d=0,f=u.byteLength,c=0){for(let w=0;w<f;w++)u[d+w]=c}function g(u,d,f="0"){for(;u.length<d;)u=f+u;return u}function p(u,d=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(f=>f.toString(16).padStart(2,"0")).join(""):g((u>>>0).toString(16),d/4)}e.toHexString=p;class v{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(d){const f=d.length;if(f===0)return;const c=this._buff;let w=this._buffLen,i=this._leftoverHighSurrogate,o,n;for(i!==0?(o=i,n=-1,i=0):(o=d.charCodeAt(0),n=0);;){let s=o;if(k.isHighSurrogate(o))if(n+1<f){const t=d.charCodeAt(n+1);k.isLowSurrogate(t)?(n++,s=k.computeCodePoint(o,t)):s=65533}else{i=o;break}else k.isLowSurrogate(o)&&(s=65533);if(w=this._push(c,w,s),n++,n<f)o=d.charCodeAt(n);else break}this._buffLen=w,this._leftoverHighSurrogate=i}_push(d,f,c){return c<128?d[f++]=c:c<2048?(d[f++]=192|(c&1984)>>>6,d[f++]=128|(c&63)>>>0):c<65536?(d[f++]=224|(c&61440)>>>12,d[f++]=128|(c&4032)>>>6,d[f++]=128|(c&63)>>>0):(d[f++]=240|(c&1835008)>>>18,d[f++]=128|(c&258048)>>>12,d[f++]=128|(c&4032)>>>6,d[f++]=128|(c&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,l(this._buff,this._buffLen),this._buffLen>56&&(this._step(),l(this._buff));const d=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(d/4294967296),!1),this._buffDV.setUint32(60,d%4294967296,!1),this._step()}_step(){const d=v._bigBlock32,f=this._buffDV;for(let a=0;a<64;a+=4)d.setUint32(a,f.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)d.setUint32(a,S(d.getUint32(a-12,!1)^d.getUint32(a-32,!1)^d.getUint32(a-56,!1)^d.getUint32(a-64,!1),1),!1);let c=this._h0,w=this._h1,i=this._h2,o=this._h3,n=this._h4,s,t,r;for(let a=0;a<80;a++)a<20?(s=w&i|~w&o,t=1518500249):a<40?(s=w^i^o,t=1859775393):a<60?(s=w&i|w&o|i&o,t=2400959708):(s=w^i^o,t=3395469782),r=S(c,5)+s+n+t+d.getUint32(a*4,!1)&4294967295,n=o,o=i,i=S(w,30),w=c,c=r;this._h0=this._h0+c&4294967295,this._h1=this._h1+w&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=v}),define(le[89],ue([0,1,27]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(O||(O={})),function(T){const A="error",L="warning",D="warn",I="info",m="ignore";function P(S){return S?k.equalsIgnoreCase(A,S)?T.Error:k.equalsIgnoreCase(L,S)||k.equalsIgnoreCase(D,S)?T.Warning:k.equalsIgnoreCase(I,S)?T.Info:T.Ignore:T.Ignore}T.fromValue=P;function b(S){switch(S){case T.Error:return A;case T.Warning:return L;case T.Info:return I;default:return m}}T.toString=b}(O||(O={})),e.default=O}),define(le[130],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(le[48],ue([0,1,17,27]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class T{constructor(){this._value="",this._pos=0}reset(l){return this._value=l,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(l){const g=l.charCodeAt(0),p=this._value.charCodeAt(this._pos);return g-p}value(){return this._value[this._pos]}}e.StringIterator=T;class A{constructor(l=!0){this._caseSensitive=l}reset(l){return this._value=l,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let l=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(l)this._from++;else break;else l=!1;return this}cmp(l){return this._caseSensitive?(0,O.compareSubstring)(l,this._value,0,l.length,this._from,this._to):(0,O.compareSubstringIgnoreCase)(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class L{constructor(l=!0,g=!0){this._splitOnBackslash=l,this._caseSensitive=g}reset(l){this._from=0,this._to=0,this._value=l,this._valueLen=l.length;for(let g=l.length-1;g>=0;g--,this._valueLen--){const p=this._value.charCodeAt(g);if(!(p===47||this._splitOnBackslash&&p===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let l=!0;for(;this._to<this._valueLen;this._to++){const g=this._value.charCodeAt(this._to);if(g===47||this._splitOnBackslash&&g===92)if(l)this._from++;else break;else l=!1}return this}cmp(l){return this._caseSensitive?(0,O.compareSubstring)(l,this._value,0,l.length,this._from,this._to):(0,O.compareSubstringIgnoreCase)(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=L;var D;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})(D||(D={}));class I{constructor(l,g){this._ignorePathCasing=l,this._ignoreQueryAndFragment=g,this._states=[],this._stateIdx=0}reset(l){return this._value=l,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new L(!1,!this._ignorePathCasing(l)),this._pathIterator.reset(l.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(l)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(l){if(this._states[this._stateIdx]===1)return(0,O.compareIgnoreCase)(l,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,O.compareIgnoreCase)(l,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(l);if(this._states[this._stateIdx]===4)return(0,O.compare)(l,this._value.query);if(this._states[this._stateIdx]===5)return(0,O.compare)(l,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=I;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(P||(P={}));class b{static forUris(l=()=>!1,g=()=>!1){return new b(new I(l,g))}static forPaths(l=!1){return new b(new L(void 0,!l))}static forStrings(){return new b(new T)}static forConfigKeys(){return new b(new A)}constructor(l){this._iter=l}clear(){this._root=void 0}fill(l,g){if(g){const p=g.slice(0);(0,k.shuffle)(p);for(const v of p)this.set(v,l)}else{const p=l.slice(0);(0,k.shuffle)(p);for(const v of p)this.set(v[0],v[1])}}set(l,g){const p=this._iter.reset(l);let v;this._root||(this._root=new m,this._root.segment=p.value());const u=[];for(v=this._root;;){const f=p.cmp(v.segment);if(f>0)v.left||(v.left=new m,v.left.segment=p.value()),u.push([-1,v]),v=v.left;else if(f<0)v.right||(v.right=new m,v.right.segment=p.value()),u.push([1,v]),v=v.right;else if(p.hasNext())p.next(),v.mid||(v.mid=new m,v.mid.segment=p.value()),u.push([0,v]),v=v.mid;else break}const d=v.value;v.value=g,v.key=l;for(let f=u.length-1;f>=0;f--){const c=u[f][1];c.updateHeight();const w=c.balanceFactor();if(w<-1||w>1){const i=u[f][0],o=u[f+1][0];if(i===1&&o===1)u[f][1]=c.rotateLeft();else if(i===-1&&o===-1)u[f][1]=c.rotateRight();else if(i===1&&o===-1)c.right=u[f+1][1]=u[f+1][1].rotateRight(),u[f][1]=c.rotateLeft();else if(i===-1&&o===1)c.left=u[f+1][1]=u[f+1][1].rotateLeft(),u[f][1]=c.rotateRight();else throw new Error;if(f>0)switch(u[f-1][0]){case-1:u[f-1][1].left=u[f][1];break;case 1:u[f-1][1].right=u[f][1];break;case 0:u[f-1][1].mid=u[f][1];break}else this._root=u[0][1]}}return d}get(l){return this._getNode(l)?.value}_getNode(l){const g=this._iter.reset(l);let p=this._root;for(;p;){const v=g.cmp(p.segment);if(v>0)p=p.left;else if(v<0)p=p.right;else if(g.hasNext())g.next(),p=p.mid;else break}return p}has(l){const g=this._getNode(l);return!(g?.value===void 0&&g?.mid===void 0)}delete(l){return this._delete(l,!1)}deleteSuperstr(l){return this._delete(l,!0)}_delete(l,g){const p=this._iter.reset(l),v=[];let u=this._root;for(;u;){const d=p.cmp(u.segment);if(d>0)v.push([-1,u]),u=u.left;else if(d<0)v.push([1,u]),u=u.right;else if(p.hasNext())p.next(),v.push([0,u]),u=u.mid;else break}if(u){if(g?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const d=this._min(u.right);if(d.key){const{key:f,value:c,segment:w}=d;this._delete(d.key,!1),u.key=f,u.value=c,u.segment=w}}else{const d=u.left??u.right;if(v.length>0){const[f,c]=v[v.length-1];switch(f){case-1:c.left=d;break;case 0:c.mid=d;break;case 1:c.right=d;break}}else this._root=d}for(let d=v.length-1;d>=0;d--){const f=v[d][1];f.updateHeight();const c=f.balanceFactor();if(c>1?(f.right.balanceFactor()>=0||(f.right=f.right.rotateRight()),v[d][1]=f.rotateLeft()):c<-1&&(f.left.balanceFactor()<=0||(f.left=f.left.rotateLeft()),v[d][1]=f.rotateRight()),d>0)switch(v[d-1][0]){case-1:v[d-1][1].left=v[d][1];break;case 1:v[d-1][1].right=v[d][1];break;case 0:v[d-1][1].mid=v[d][1];break}else this._root=v[0][1]}}}_min(l){for(;l.left;)l=l.left;return l}findSubstr(l){const g=this._iter.reset(l);let p=this._root,v;for(;p;){const u=g.cmp(p.segment);if(u>0)p=p.left;else if(u<0)p=p.right;else if(g.hasNext())g.next(),v=p.value||v,p=p.mid;else break}return p&&p.value||v}findSuperstr(l){return this._findSuperstrOrElement(l,!1)}_findSuperstrOrElement(l,g){const p=this._iter.reset(l);let v=this._root;for(;v;){const u=p.cmp(v.segment);if(u>0)v=v.left;else if(u<0)v=v.right;else if(p.hasNext())p.next(),v=v.mid;else return v.mid?this._entries(v.mid):g?v.value:void 0}}hasElementOrSubtree(l){return this._findSuperstrOrElement(l,!0)!==void 0}forEach(l){for(const[g,p]of this)l(p,g)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(l){const g=[];return this._dfsEntries(l,g),g[Symbol.iterator]()}_dfsEntries(l,g){l&&(l.left&&this._dfsEntries(l.left,g),l.value&&g.push([l.key,l.value]),l.mid&&this._dfsEntries(l.mid,g),l.right&&this._dfsEntries(l.right,g))}_isBalanced(){const l=g=>{if(!g)return!0;const p=g.balanceFactor();return p<-1||p>1?!1:l(g.left)&&l(g.right)};return l(this._root)}}e.TernarySearchTree=b}),define(le[12],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function k(w){return typeof w=="string"}e.isString=k;function O(w){return Array.isArray(w)&&w.every(i=>k(i))}e.isStringArray=O;function T(w){return typeof w=="object"&&w!==null&&!Array.isArray(w)&&!(w instanceof RegExp)&&!(w instanceof Date)}e.isObject=T;function A(w){const i=Object.getPrototypeOf(Uint8Array);return typeof w=="object"&&w instanceof i}e.isTypedArray=A;function L(w){return typeof w=="number"&&!isNaN(w)}e.isNumber=L;function D(w){return!!w&&typeof w[Symbol.iterator]=="function"}e.isIterable=D;function I(w){return w===!0||w===!1}e.isBoolean=I;function m(w){return typeof w>"u"}e.isUndefined=m;function P(w){return!b(w)}e.isDefined=P;function b(w){return m(w)||w===null}e.isUndefinedOrNull=b;function S(w,i){if(!w)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=S;function l(w){if(b(w))throw new Error("Assertion Failed: argument is undefined or null");return w}e.assertIsDefined=l;function g(...w){const i=[];for(let o=0;o<w.length;o++){const n=w[o];if(b(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(n)}return i}e.assertAllDefined=g;const p=Object.prototype.hasOwnProperty;function v(w){if(!T(w))return!1;for(const i in w)if(p.call(w,i))return!1;return!0}e.isEmptyObject=v;function u(w){return typeof w=="function"}e.isFunction=u;function d(...w){return w.length>0&&w.every(u)}e.areFunctions=d;function f(w,i){const o=Math.min(w.length,i.length);for(let n=0;n<o;n++)c(w[n],i[n])}e.validateConstraints=f;function c(w,i){if(k(i)){if(typeof w!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(u(i)){try{if(w instanceof i)return}catch{}if(!b(w)&&w.constructor===i||i.length===1&&i.call(void 0,w)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c}),define(le[30],ue([0,1,12]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function O(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const d=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([f,c])=>{d[f]=c&&typeof c=="object"?O(c):c}),d}e.deepClone=O;function T(u){if(!u||typeof u!="object")return u;const d=[u];for(;d.length>0;){const f=d.shift();Object.freeze(f);for(const c in f)if(A.call(f,c)){const w=f[c];typeof w=="object"&&!Object.isFrozen(w)&&!(0,k.isTypedArray)(w)&&d.push(w)}}return u}e.deepFreeze=T;const A=Object.prototype.hasOwnProperty;function L(u,d){return D(u,d,new Set)}e.cloneAndChange=L;function D(u,d,f){if((0,k.isUndefinedOrNull)(u))return u;const c=d(u);if(typeof c<"u")return c;if(Array.isArray(u)){const w=[];for(const i of u)w.push(D(i,d,f));return w}if((0,k.isObject)(u)){if(f.has(u))throw new Error("Cannot clone recursive data-structure");f.add(u);const w={};for(const i in u)A.call(u,i)&&(w[i]=D(u[i],d,f));return f.delete(u),w}return u}function I(u,d,f=!0){return(0,k.isObject)(u)?((0,k.isObject)(d)&&Object.keys(d).forEach(c=>{c in u?f&&((0,k.isObject)(u[c])&&(0,k.isObject)(d[c])?I(u[c],d[c],f):u[c]=d[c]):u[c]=d[c]}),u):d}e.mixin=I;function m(u,d){if(u===d)return!0;if(u==null||d===null||d===void 0||typeof u!=typeof d||typeof u!="object"||Array.isArray(u)!==Array.isArray(d))return!1;let f,c;if(Array.isArray(u)){if(u.length!==d.length)return!1;for(f=0;f<u.length;f++)if(!m(u[f],d[f]))return!1}else{const w=[];for(c in u)w.push(c);w.sort();const i=[];for(c in d)i.push(c);if(i.sort(),!m(w,i))return!1;for(f=0;f<w.length;f++)if(!m(u[w[f]],d[w[f]]))return!1}return!0}e.equals=m;function P(u){const d=new Set;return JSON.stringify(u,(f,c)=>{if((0,k.isObject)(c)||Array.isArray(c)){if(d.has(c))return"[Circular]";d.add(c)}return c})}e.safeStringify=P;function b(u,d){const f=Object.create(null);return!u||!d||Object.keys(d).forEach(w=>{const i=u[w],o=d[w];m(i,o)||(f[w]=o)}),f}e.distinct=b;function S(u,d){const f=d.toLowerCase(),c=Object.keys(u).find(w=>w.toLowerCase()===f);return c?u[c]:u[d]}e.getCaseInsensitive=S;function l(u,d){const f=Object.create(null);for(const[c,w]of Object.entries(u))d(c,w)&&(f[c]=w);return f}e.filter=l;function g(u){let d=[];for(;Object.prototype!==u;)d=d.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return d}e.getAllPropertyNames=g;function p(u){const d=[];for(const f of g(u))typeof u[f]=="function"&&d.push(f);return d}e.getAllMethodNames=p;function v(u,d){const f=w=>function(){const i=Array.prototype.slice.call(arguments,0);return d(w,i)},c={};for(const w of u)c[w]=f(w);return c}e.createProxyObject=v}),define(le[32],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(T){return k.test(T)}e.isUUID=O,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(D){for(let I=0;I<D.length;I++)D[I]=Math.floor(Math.random()*256);return D};const A=new Uint8Array(16),L=[];for(let D=0;D<256;D++)L.push(D.toString(16).padStart(2,"0"));return function(){T(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let I=0,m="";return m+=L[A[I++]],m+=L[A[I++]],m+=L[A[I++]],m+=L[A[I++]],m+="-",m+=L[A[I++]],m+=L[A[I++]],m+="-",m+=L[A[I++]],m+=L[A[I++]],m+="-",m+=L[A[I++]],m+=L[A[I++]],m+="-",m+=L[A[I++]],m+=L[A[I++]],m+=L[A[I++]],m+=L[A[I++]],m+=L[A[I++]],m+=L[A[I++]],m}}()}),define(le[131],ue([0,1,36]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function T(L){const D=L.replace(/\-/g,":").toLowerCase();return!O.has(D)}function A(){const L=(0,k.networkInterfaces)();for(const D in L){const I=L[D];if(I){for(const{mac:m}of I)if(T(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(le[132],ue([0,1,267,14]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StreamSplitter=void 0;class T extends k.Transform{constructor(L){if(super(),typeof L=="number")this.splitter=L,this.spitterLen=1;else{const D=Buffer.isBuffer(L)?L:Buffer.from(L);this.splitter=D.length===1?D[0]:D,this.spitterLen=D.length}}_transform(L,D,I){this.buffer?this.buffer=Buffer.concat([this.buffer,L]):this.buffer=L;let m=0;for(;m<this.buffer.length;){const P=typeof this.splitter=="number"?this.buffer.indexOf(this.splitter,m):(0,O.binaryIndexOf)(this.buffer,this.splitter,m);if(P===-1)break;this.push(this.buffer.slice(m,P+this.spitterLen)),m=P+this.spitterLen}this.buffer=m===this.buffer.length?void 0:this.buffer.slice(m),I()}_flush(L){this.buffer&&this.push(this.buffer),L()}}e.StreamSplitter=T}),define(le[133],ue([0,1,64]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function O(D,I,m,P=1){let b=!1;return new Promise(S=>{const l=setTimeout(()=>{if(!b)return b=!0,S(0)},m);T(D,I,P,g=>{if(!b)return b=!0,clearTimeout(l),S(g)})})}e.findFreePort=O;function T(D,I,m,P){if(I===0)return P(0);const b=new k.Socket;b.once("connect",()=>(L(b),T(D+m,I-1,m,P))),b.once("data",()=>{}),b.once("error",S=>(L(b),S.code!=="ECONNREFUSED"?T(D+m,I-1,m,P):P(D))),b.connect(D,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(D,I,m,P="127.0.0.1"){let b=!1,S,l=1;const g=k.createServer({pauseOnConnect:!0});function p(v,u){b||(b=!0,g.removeAllListeners(),g.close(),S&&clearTimeout(S),u(v))}return new Promise(v=>{S=setTimeout(()=>{p(0,v)},m),g.on("listening",()=>{p(D,v)}),g.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&l<I?(D++,l++,g.listen(D,P)):p(0,v)}),g.on("close",()=>{p(0,v)}),g.listen(D,P)})}e.findFreePortFaster=A;function L(D){try{D.removeAllListeners("connect"),D.removeAllListeners("error"),D.end(),D.destroy(),D.unref()}catch(I){console.error(I)}}}),define(le[134],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=void 0;function k(O){return!!O.parentPort}e.isUtilityProcess=k}),define(le[135],ue([13,9]),function(se,e){return se.create("vs/base/common/date",e)}),define(le[65],ue([0,1,135]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const O=60,T=O*60,A=T*24,L=A*7,D=A*30,I=A*365;function m(b,S,l,g){typeof b!="number"&&(b=b.getTime());const p=Math.round((new Date().getTime()-b)/1e3);if(p<-30)return(0,k.localize)(0,null,m(new Date().getTime()+p*1e3,!1));if(!g&&p<30)return(0,k.localize)(1,null);let v;return p<O?(v=p,S?v===1?l?(0,k.localize)(2,null,v):(0,k.localize)(3,null,v):l?(0,k.localize)(4,null,v):(0,k.localize)(5,null,v):v===1?l?(0,k.localize)(6,null,v):(0,k.localize)(7,null,v):l?(0,k.localize)(8,null,v):(0,k.localize)(9,null,v)):p<T?(v=Math.floor(p/O),S?v===1?l?(0,k.localize)(10,null,v):(0,k.localize)(11,null,v):l?(0,k.localize)(12,null,v):(0,k.localize)(13,null,v):v===1?l?(0,k.localize)(14,null,v):(0,k.localize)(15,null,v):l?(0,k.localize)(16,null,v):(0,k.localize)(17,null,v)):p<A?(v=Math.floor(p/T),S?v===1?l?(0,k.localize)(18,null,v):(0,k.localize)(19,null,v):l?(0,k.localize)(20,null,v):(0,k.localize)(21,null,v):v===1?l?(0,k.localize)(22,null,v):(0,k.localize)(23,null,v):l?(0,k.localize)(24,null,v):(0,k.localize)(25,null,v)):p<L?(v=Math.floor(p/A),S?v===1?(0,k.localize)(26,null,v):(0,k.localize)(27,null,v):v===1?(0,k.localize)(28,null,v):(0,k.localize)(29,null,v)):p<D?(v=Math.floor(p/L),S?v===1?l?(0,k.localize)(30,null,v):(0,k.localize)(31,null,v):l?(0,k.localize)(32,null,v):(0,k.localize)(33,null,v):v===1?l?(0,k.localize)(34,null,v):(0,k.localize)(35,null,v):l?(0,k.localize)(36,null,v):(0,k.localize)(37,null,v)):p<I?(v=Math.floor(p/D),S?v===1?l?(0,k.localize)(38,null,v):(0,k.localize)(39,null,v):l?(0,k.localize)(40,null,v):(0,k.localize)(41,null,v):v===1?l?(0,k.localize)(42,null,v):(0,k.localize)(43,null,v):l?(0,k.localize)(44,null,v):(0,k.localize)(45,null,v)):(v=Math.floor(p/I),S?v===1?l?(0,k.localize)(46,null,v):(0,k.localize)(47,null,v):l?(0,k.localize)(48,null,v):(0,k.localize)(49,null,v):v===1?l?(0,k.localize)(50,null,v):(0,k.localize)(51,null,v):l?(0,k.localize)(52,null,v):(0,k.localize)(53,null,v))}e.fromNow=m;function P(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(le[136],ue([13,9]),function(se,e){return se.create("vs/base/common/errorMessage",e)}),define(le[38],ue([0,1,17,12,136]),function(se,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(b,S){return S&&(b.stack||b.stacktrace)?T.localize(0,null,D(b),L(b.stack)||L(b.stacktrace)):D(b)}function L(b){return Array.isArray(b)?b.join(`
`):b}function D(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?T.localize(1,null,b.message):b.message||T.localize(2,null)}function I(b=null,S=!1){if(!b)return T.localize(3,null);if(Array.isArray(b)){const l=k.coalesce(b),g=I(l[0],S);return l.length>1?T.localize(4,null,g,l.length):g}if(O.isString(b))return b;if(b.detail){const l=b.detail;if(l.error)return A(l.error,S);if(l.exception)return A(l.exception,S)}return b.stack?A(b,S):b.message?b.message:T.localize(5,null)}e.toErrorMessage=I;function m(b){const S=b;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=m;function P(b,S){let l;return typeof b=="string"?l=new Error(b):l=b,l.actions=S,l}e.createErrorWithActions=P}),define(le[137],ue([13,9]),function(se,e){return se.create("vs/base/common/jsonErrorMessages",e)}),define(le[138],ue([0,1,137]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function O(T){switch(T){case 1:return(0,k.localize)(0,null);case 2:return(0,k.localize)(1,null);case 3:return(0,k.localize)(2,null);case 4:return(0,k.localize)(3,null);case 5:return(0,k.localize)(4,null);case 6:return(0,k.localize)(5,null);case 7:return(0,k.localize)(6,null);case 8:return(0,k.localize)(7,null);case 9:return(0,k.localize)(8,null);default:return""}}e.getParseErrorMessage=O}),define(le[139],ue([13,9]),function(se,e){return se.create("vs/base/common/platform",e)}),define(le[5],ue([0,1,139]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isBigSurOrNewer=e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let O=!1,T=!1,A=!1,L=!1,D=!1,I=!1,m=!1,P=!1,b=!1,S=!1,l,g=e.LANGUAGE_DEFAULT,p=e.LANGUAGE_DEFAULT,v,u;const d=globalThis;let f;typeof d.vscode<"u"&&typeof d.vscode.process<"u"?f=d.vscode.process:typeof process<"u"&&(f=process);const c=typeof f?.versions?.electron=="string",w=c&&f?.type==="renderer";if(typeof f=="object"){O=f.platform==="win32",T=f.platform==="darwin",A=f.platform==="linux",L=A&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,m=c,b=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=e.LANGUAGE_DEFAULT,g=e.LANGUAGE_DEFAULT;const h=f.env.VSCODE_NLS_CONFIG;if(h)try{const y=JSON.parse(h),R=y.availableLanguages["*"];l=y.locale,p=y.osLocale,g=R||e.LANGUAGE_DEFAULT,v=y._translationsConfigFile}catch{}D=!0}else typeof navigator=="object"&&!w?(u=navigator.userAgent,O=u.indexOf("Windows")>=0,T=u.indexOf("Macintosh")>=0,P=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=u.indexOf("Linux")>=0,S=u?.indexOf("Mobi")>=0,I=!0,l=k.getConfiguredDefaultLocale(k.localize(0,null))||e.LANGUAGE_DEFAULT,g=l,p=navigator.language):console.error("Unable to resolve platform.");var i;(function(h){h[h.Web=0]="Web",h[h.Mac=1]="Mac",h[h.Linux=2]="Linux",h[h.Windows=3]="Windows"})(i||(e.Platform=i={}));function o(h){switch(h){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=o;let n=0;T?n=1:O?n=3:A&&(n=2),e.isWindows=O,e.isMacintosh=T,e.isLinux=A,e.isLinuxSnap=L,e.isNative=D,e.isElectron=m,e.isWeb=I,e.isWebWorker=I&&typeof d.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?d.origin:void 0,e.isIOS=P,e.isMobile=S,e.isCI=b,e.platform=n,e.userAgent=u,e.language=g;var s;(function(h){function y(){return e.language}h.value=y;function R(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}h.isDefaultVariant=R;function U(){return e.language==="en"}h.isDefault=U})(s||(e.Language=s={})),e.locale=l,e.platformLocale=p,e.translationsConfigFile=v,e.setTimeout0IsFaster=typeof d.postMessage=="function"&&!d.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const h=[];d.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let U=0,F=h.length;U<F;U++){const M=h[U];if(M.id===R.data.vscodeScheduleAsyncWork){h.splice(U,1),M.callback();return}}});let y=0;return R=>{const U=++y;h.push({id:U,callback:R}),d.postMessage({vscodeScheduleAsyncWork:U},"*")}}return h=>setTimeout(h)})();var t;(function(h){h[h.Windows=1]="Windows",h[h.Macintosh=2]="Macintosh",h[h.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=T||P?2:O?1:3;let r=!0,a=!1;function C(){if(!a){a=!0;const h=new Uint8Array(2);h[0]=1,h[1]=2,r=new Uint16Array(h.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=C,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function E(h){return parseFloat(h)>=20}e.isBigSurOrNewer=E}),define(le[37],ue([0,1,5]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let O;const T=globalThis.vscode;if(typeof T<"u"&&typeof T.process<"u"){const A=T.process;O={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.platform=O.platform,e.arch=O.arch}),define(le[16],ue([0,1,37]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const O=65,T=97,A=90,L=122,D=46,I=47,m=92,P=58,b=63;class S extends Error{constructor(o,n,s){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${t} of type ${n}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function l(i,o){if(i===null||typeof i!="object")throw new S(o,"Object",i)}function g(i,o){if(typeof i!="string")throw new S(o,"string",i)}const p=k.platform==="win32";function v(i){return i===I||i===m}function u(i){return i===I}function d(i){return i>=O&&i<=A||i>=T&&i<=L}function f(i,o,n,s){let t="",r=0,a=-1,C=0,E=0;for(let h=0;h<=i.length;++h){if(h<i.length)E=i.charCodeAt(h);else{if(s(E))break;E=I}if(s(E)){if(!(a===h-1||C===1))if(C===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==D||t.charCodeAt(t.length-2)!==D){if(t.length>2){const y=t.lastIndexOf(n);y===-1?(t="",r=0):(t=t.slice(0,y),r=t.length-1-t.lastIndexOf(n)),a=h,C=0;continue}else if(t.length!==0){t="",r=0,a=h,C=0;continue}}o&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${i.slice(a+1,h)}`:t=i.slice(a+1,h),r=h-a-1;a=h,C=0}else E===D&&C!==-1?++C:C=-1}return t}function c(i,o){l(o,"pathObject");const n=o.dir||o.root,s=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${s}`:`${n}${i}${s}`:s}e.win32={resolve(...i){let o="",n="",s=!1;for(let t=i.length-1;t>=-1;t--){let r;if(t>=0){if(r=i[t],g(r,"path"),r.length===0)continue}else o.length===0?r=k.cwd():(r=k.env[`=${o}`]||k.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===m)&&(r=`${o}\\`));const a=r.length;let C=0,E="",h=!1;const y=r.charCodeAt(0);if(a===1)v(y)&&(C=1,h=!0);else if(v(y))if(h=!0,v(r.charCodeAt(1))){let R=2,U=R;for(;R<a&&!v(r.charCodeAt(R));)R++;if(R<a&&R!==U){const F=r.slice(U,R);for(U=R;R<a&&v(r.charCodeAt(R));)R++;if(R<a&&R!==U){for(U=R;R<a&&!v(r.charCodeAt(R));)R++;(R===a||R!==U)&&(E=`\\\\${F}\\${r.slice(U,R)}`,C=R)}}}else C=1;else d(y)&&r.charCodeAt(1)===P&&(E=r.slice(0,2),C=2,a>2&&v(r.charCodeAt(2))&&(h=!0,C=3));if(E.length>0)if(o.length>0){if(E.toLowerCase()!==o.toLowerCase())continue}else o=E;if(s){if(o.length>0)break}else if(n=`${r.slice(C)}\\${n}`,s=h,h&&o.length>0)break}return n=f(n,!s,"\\",v),s?`${o}\\${n}`:`${o}${n}`||"."},normalize(i){g(i,"path");const o=i.length;if(o===0)return".";let n=0,s,t=!1;const r=i.charCodeAt(0);if(o===1)return u(r)?"\\":i;if(v(r))if(t=!0,v(i.charCodeAt(1))){let C=2,E=C;for(;C<o&&!v(i.charCodeAt(C));)C++;if(C<o&&C!==E){const h=i.slice(E,C);for(E=C;C<o&&v(i.charCodeAt(C));)C++;if(C<o&&C!==E){for(E=C;C<o&&!v(i.charCodeAt(C));)C++;if(C===o)return`\\\\${h}\\${i.slice(E)}\\`;C!==E&&(s=`\\\\${h}\\${i.slice(E,C)}`,n=C)}}}else n=1;else d(r)&&i.charCodeAt(1)===P&&(s=i.slice(0,2),n=2,o>2&&v(i.charCodeAt(2))&&(t=!0,n=3));let a=n<o?f(i.slice(n),!t,"\\",v):"";return a.length===0&&!t&&(a="."),a.length>0&&v(i.charCodeAt(o-1))&&(a+="\\"),s===void 0?t?`\\${a}`:a:t?`${s}\\${a}`:`${s}${a}`},isAbsolute(i){g(i,"path");const o=i.length;if(o===0)return!1;const n=i.charCodeAt(0);return v(n)||o>2&&d(n)&&i.charCodeAt(1)===P&&v(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,n;for(let r=0;r<i.length;++r){const a=i[r];g(a,"path"),a.length>0&&(o===void 0?o=n=a:o+=`\\${a}`)}if(o===void 0)return".";let s=!0,t=0;if(typeof n=="string"&&v(n.charCodeAt(0))){++t;const r=n.length;r>1&&v(n.charCodeAt(1))&&(++t,r>2&&(v(n.charCodeAt(2))?++t:s=!1))}if(s){for(;t<o.length&&v(o.charCodeAt(t));)t++;t>=2&&(o=`\\${o.slice(t)}`)}return e.win32.normalize(o)},relative(i,o){if(g(i,"from"),g(o,"to"),i===o)return"";const n=e.win32.resolve(i),s=e.win32.resolve(o);if(n===s||(i=n.toLowerCase(),o=s.toLowerCase(),i===o))return"";let t=0;for(;t<i.length&&i.charCodeAt(t)===m;)t++;let r=i.length;for(;r-1>t&&i.charCodeAt(r-1)===m;)r--;const a=r-t;let C=0;for(;C<o.length&&o.charCodeAt(C)===m;)C++;let E=o.length;for(;E-1>C&&o.charCodeAt(E-1)===m;)E--;const h=E-C,y=a<h?a:h;let R=-1,U=0;for(;U<y;U++){const M=i.charCodeAt(t+U);if(M!==o.charCodeAt(C+U))break;M===m&&(R=U)}if(U!==y){if(R===-1)return s}else{if(h>y){if(o.charCodeAt(C+U)===m)return s.slice(C+U+1);if(U===2)return s.slice(C+U)}a>y&&(i.charCodeAt(t+U)===m?R=U:U===2&&(R=3)),R===-1&&(R=0)}let F="";for(U=t+R+1;U<=r;++U)(U===r||i.charCodeAt(U)===m)&&(F+=F.length===0?"..":"\\..");return C+=R,F.length>0?`${F}${s.slice(C,E)}`:(s.charCodeAt(C)===m&&++C,s.slice(C,E))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.win32.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===m){if(o.charCodeAt(1)===m){const n=o.charCodeAt(2);if(n!==b&&n!==D)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(d(o.charCodeAt(0))&&o.charCodeAt(1)===P&&o.charCodeAt(2)===m)return`\\\\?\\${o}`;return i},dirname(i){g(i,"path");const o=i.length;if(o===0)return".";let n=-1,s=0;const t=i.charCodeAt(0);if(o===1)return v(t)?i:".";if(v(t)){if(n=s=1,v(i.charCodeAt(1))){let C=2,E=C;for(;C<o&&!v(i.charCodeAt(C));)C++;if(C<o&&C!==E){for(E=C;C<o&&v(i.charCodeAt(C));)C++;if(C<o&&C!==E){for(E=C;C<o&&!v(i.charCodeAt(C));)C++;if(C===o)return i;C!==E&&(n=s=C+1)}}}}else d(t)&&i.charCodeAt(1)===P&&(n=o>2&&v(i.charCodeAt(2))?3:2,s=n);let r=-1,a=!0;for(let C=o-1;C>=s;--C)if(v(i.charCodeAt(C))){if(!a){r=C;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return i.slice(0,r)},basename(i,o){o!==void 0&&g(o,"ext"),g(i,"path");let n=0,s=-1,t=!0,r;if(i.length>=2&&d(i.charCodeAt(0))&&i.charCodeAt(1)===P&&(n=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,C=-1;for(r=i.length-1;r>=n;--r){const E=i.charCodeAt(r);if(v(E)){if(!t){n=r+1;break}}else C===-1&&(t=!1,C=r+1),a>=0&&(E===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=C))}return n===s?s=C:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=n;--r)if(v(i.charCodeAt(r))){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){g(i,"path");let o=0,n=-1,s=0,t=-1,r=!0,a=0;i.length>=2&&i.charCodeAt(1)===P&&d(i.charCodeAt(0))&&(o=s=2);for(let C=i.length-1;C>=o;--C){const E=i.charCodeAt(C);if(v(E)){if(!r){s=C+1;break}continue}t===-1&&(r=!1,t=C+1),E===D?n===-1?n=C:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||t===-1||a===0||a===1&&n===t-1&&n===s+1?"":i.slice(n,t)},format:c.bind(null,"\\"),parse(i){g(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.length;let s=0,t=i.charCodeAt(0);if(n===1)return v(t)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(v(t)){if(s=1,v(i.charCodeAt(1))){let R=2,U=R;for(;R<n&&!v(i.charCodeAt(R));)R++;if(R<n&&R!==U){for(U=R;R<n&&v(i.charCodeAt(R));)R++;if(R<n&&R!==U){for(U=R;R<n&&!v(i.charCodeAt(R));)R++;R===n?s=R:R!==U&&(s=R+1)}}}}else if(d(t)&&i.charCodeAt(1)===P){if(n<=2)return o.root=o.dir=i,o;if(s=2,v(i.charCodeAt(2))){if(n===3)return o.root=o.dir=i,o;s=3}}s>0&&(o.root=i.slice(0,s));let r=-1,a=s,C=-1,E=!0,h=i.length-1,y=0;for(;h>=s;--h){if(t=i.charCodeAt(h),v(t)){if(!E){a=h+1;break}continue}C===-1&&(E=!1,C=h+1),t===D?r===-1?r=h:y!==1&&(y=1):r!==-1&&(y=-1)}return C!==-1&&(r===-1||y===0||y===1&&r===C-1&&r===a+1?o.base=o.name=i.slice(a,C):(o.name=i.slice(a,r),o.base=i.slice(a,C),o.ext=i.slice(r,C))),a>0&&a!==s?o.dir=i.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const w=(()=>{if(p){const i=/\\/g;return()=>{const o=k.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>k.cwd()})();e.posix={resolve(...i){let o="",n=!1;for(let s=i.length-1;s>=-1&&!n;s--){const t=s>=0?i[s]:w();g(t,"path"),t.length!==0&&(o=`${t}/${o}`,n=t.charCodeAt(0)===I)}return o=f(o,!n,"/",u),n?`/${o}`:o.length>0?o:"."},normalize(i){if(g(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===I,n=i.charCodeAt(i.length-1)===I;return i=f(i,!o,"/",u),i.length===0?o?"/":n?"./":".":(n&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return g(i,"path"),i.length>0&&i.charCodeAt(0)===I},join(...i){if(i.length===0)return".";let o;for(let n=0;n<i.length;++n){const s=i[n];g(s,"path"),s.length>0&&(o===void 0?o=s:o+=`/${s}`)}return o===void 0?".":e.posix.normalize(o)},relative(i,o){if(g(i,"from"),g(o,"to"),i===o||(i=e.posix.resolve(i),o=e.posix.resolve(o),i===o))return"";const n=1,s=i.length,t=s-n,r=1,a=o.length-r,C=t<a?t:a;let E=-1,h=0;for(;h<C;h++){const R=i.charCodeAt(n+h);if(R!==o.charCodeAt(r+h))break;R===I&&(E=h)}if(h===C)if(a>C){if(o.charCodeAt(r+h)===I)return o.slice(r+h+1);if(h===0)return o.slice(r+h)}else t>C&&(i.charCodeAt(n+h)===I?E=h:h===0&&(E=0));let y="";for(h=n+E+1;h<=s;++h)(h===s||i.charCodeAt(h)===I)&&(y+=y.length===0?"..":"/..");return`${y}${o.slice(r+E)}`},toNamespacedPath(i){return i},dirname(i){if(g(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===I;let n=-1,s=!0;for(let t=i.length-1;t>=1;--t)if(i.charCodeAt(t)===I){if(!s){n=t;break}}else s=!1;return n===-1?o?"/":".":o&&n===1?"//":i.slice(0,n)},basename(i,o){o!==void 0&&g(o,"ext"),g(i,"path");let n=0,s=-1,t=!0,r;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,C=-1;for(r=i.length-1;r>=0;--r){const E=i.charCodeAt(r);if(E===I){if(!t){n=r+1;break}}else C===-1&&(t=!1,C=r+1),a>=0&&(E===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=C))}return n===s?s=C:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=0;--r)if(i.charCodeAt(r)===I){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){g(i,"path");let o=-1,n=0,s=-1,t=!0,r=0;for(let a=i.length-1;a>=0;--a){const C=i.charCodeAt(a);if(C===I){if(!t){n=a+1;break}continue}s===-1&&(t=!1,s=a+1),C===D?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||s===-1||r===0||r===1&&o===s-1&&o===n+1?"":i.slice(o,s)},format:c.bind(null,"/"),parse(i){g(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.charCodeAt(0)===I;let s;n?(o.root="/",s=1):s=0;let t=-1,r=0,a=-1,C=!0,E=i.length-1,h=0;for(;E>=s;--E){const y=i.charCodeAt(E);if(y===I){if(!C){r=E+1;break}continue}a===-1&&(C=!1,a=E+1),y===D?t===-1?t=E:h!==1&&(h=1):t!==-1&&(h=-1)}if(a!==-1){const y=r===0&&n?1:r;t===-1||h===0||h===1&&t===a-1&&t===r+1?o.base=o.name=i.slice(y,a):(o.name=i.slice(y,t),o.base=i.slice(y,a),o.ext=i.slice(t,a))}return r>0?o.dir=i.slice(0,r-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p?e.win32.normalize:e.posix.normalize,e.isAbsolute=p?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p?e.win32.join:e.posix.join,e.resolve=p?e.win32.resolve:e.posix.resolve,e.relative=p?e.win32.relative:e.posix.relative,e.dirname=p?e.win32.dirname:e.posix.dirname,e.basename=p?e.win32.basename:e.posix.basename,e.extname=p?e.win32.extname:e.posix.extname,e.format=p?e.win32.format:e.posix.format,e.parse=p?e.win32.parse:e.posix.parse,e.toNamespacedPath=p?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p?e.win32.sep:e.posix.sep,e.delimiter=p?e.win32.delimiter:e.posix.delimiter}),define(le[49],ue([0,1,16,5,27,12]),function(se,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function L(r){return r===47||r===92}e.isPathSeparator=L;function D(r){return r.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=D;function I(r){return r.indexOf("/")===-1&&(r=D(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=I;function m(r,a=k.posix.sep){if(!r)return"";const C=r.length,E=r.charCodeAt(0);if(L(E)){if(L(r.charCodeAt(1))&&!L(r.charCodeAt(2))){let y=3;const R=y;for(;y<C&&!L(r.charCodeAt(y));y++);if(R!==y&&!L(r.charCodeAt(y+1))){for(y+=1;y<C;y++)if(L(r.charCodeAt(y)))return r.slice(0,y+1).replace(/[\\/]/g,a)}}return a}else if(u(E)&&r.charCodeAt(1)===58)return L(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let h=r.indexOf("://");if(h!==-1){for(h+=3;h<C;h++)if(L(r.charCodeAt(h)))return r.slice(0,h+1)}return""}e.getRoot=m;function P(r){if(!O.isWindows||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let C=2;const E=C;for(;C<r.length&&(a=r.charCodeAt(C),a!==92);C++);return!(E===C||(a=r.charCodeAt(C+1),isNaN(a)||a===92))}e.isUNC=P;const b=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(r,a=O.isWindows){const C=a?b:S;return!(!r||r.length===0||/^\s+$/.test(r)||(C.lastIndex=0,C.test(r))||a&&l.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=g;function p(r,a,C){const E=r===a;return!C||E?E:!r||!a?!1:(0,T.equalsIgnoreCase)(r,a)}e.isEqual=p;function v(r,a,C,E=k.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(C){if(!(0,T.startsWithIgnoreCase)(r,a))return!1;if(a.length===r.length)return!0;let y=a.length;return a.charAt(a.length-1)===E&&y--,r.charAt(y)===E}return a.charAt(a.length-1)!==E&&(a+=E),r.indexOf(a)===0}e.isEqualOrParent=v;function u(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=u;function d(r,a){return O.isWindows&&r.endsWith(":")&&(r+=k.sep),(0,k.isAbsolute)(r)||(r=(0,k.join)(a,r)),r=(0,k.normalize)(r),O.isWindows?(r=(0,T.rtrim)(r,k.sep),r.endsWith(":")&&(r+=k.sep)):(r=(0,T.rtrim)(r,k.sep),r||(r=k.sep)),r}e.sanitizeFilePath=d;function f(r){const a=(0,k.normalize)(r);return O.isWindows?r.length>3?!1:c(a)&&(r.length===2||a.charCodeAt(2)===92):a===k.posix.sep}e.isRootOrDriveLetter=f;function c(r,a=O.isWindows){return a?u(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function w(r,a=O.isWindows){return c(r,a)?r[0]:void 0}e.getDriveLetter=w;function i(r,a,C){return a.length>r.length?-1:r===a?0:(C&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.indexOfPath=i;function o(r){const a=r.split(":");let C,E,h;for(const y of a){const R=Number(y);(0,A.isNumber)(R)?E===void 0?E=R:h===void 0&&(h=R):C=C?[C,y].join(":"):y}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:E!==void 0?E:void 0,column:h!==void 0?h:E!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,a,C=8){let E="";for(let y=0;y<C;y++){let R;y===0&&O.isWindows&&!a&&(C===3||C===4)?R=s:R=n,E+=R.charAt(Math.floor(Math.random()*R.length))}let h;return a?h=`${a}-${E}`:h=E,r?(0,k.join)(r,h):h}e.randomPath=t}),define(le[140],ue([0,1,16]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(P){const b=(0,k.extname)(P),S=O[b.toLowerCase()];return S!==void 0?S:L(P)}e.getMediaOrTextMime=A;function L(P){const b=(0,k.extname)(P);return T[b.toLowerCase()]}e.getMediaMime=L;function D(P){for(const b in T)if(T[b]===P)return b}e.getExtensionForMimeType=D;const I=/^(.+)\/(.+?)(;.+)?$/;function m(P,b){const S=I.exec(P);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:b?void 0:P}e.normalizeMimeType=m}),define(le[90],ue([0,1,5]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var O;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(O||(e.Source=O={}));var T;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(T||(e.TerminateResponseCode=T={}));function A(D,...I){const m=I.reduce((S,l)=>(S[l]=!0,S),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(S=>!m[S]).forEach(S=>{for(let l=0;l<P.length;l++)if(S.search(P[l])!==-1){delete D[S];break}})}e.sanitizeProcessEnvironment=A;function L(D){D&&(delete D.DEBUG,k.isMacintosh&&delete D.DYLD_LIBRARY_PATH,k.isLinux&&delete D.LD_PRELOAD)}e.removeDangerousEnvVariables=L}),define(le[10],ue([0,1,16,5]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,A=/^\//,L=/^\/\//;function D(s,t){if(!s.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!T.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!A.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(s,t){return!s&&!t?"file":s}function m(s,t){switch(s){case"https":case"http":case"file":t?t[0]!==b&&(t=b+t):t=b;break}return t}const P="",b="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(t){return t instanceof l?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,a,C,E,h=!1){typeof t=="object"?(this.scheme=t.scheme||P,this.authority=t.authority||P,this.path=t.path||P,this.query=t.query||P,this.fragment=t.fragment||P):(this.scheme=I(t,h),this.authority=r||P,this.path=m(this.scheme,a||P),this.query=C||P,this.fragment=E||P,D(this,h))}get fsPath(){return c(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:a,path:C,query:E,fragment:h}=t;return r===void 0?r=this.scheme:r===null&&(r=P),a===void 0?a=this.authority:a===null&&(a=P),C===void 0?C=this.path:C===null&&(C=P),E===void 0?E=this.query:E===null&&(E=P),h===void 0?h=this.fragment:h===null&&(h=P),r===this.scheme&&a===this.authority&&C===this.path&&E===this.query&&h===this.fragment?this:new v(r,a,C,E,h)}static parse(t,r=!1){const a=S.exec(t);return a?new v(a[2]||P,n(a[4]||P),n(a[5]||P),n(a[7]||P),n(a[9]||P),r):new v(P,P,P,P,P)}static file(t){let r=P;if(O.isWindows&&(t=t.replace(/\\/g,b)),t[0]===b&&t[1]===b){const a=t.indexOf(b,2);a===-1?(r=t.substring(2),t=b):(r=t.substring(2,a),t=t.substring(a)||b)}return new v("file",r,t,P,P)}static from(t,r){return new v(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return O.isWindows&&t.scheme==="file"?a=l.file(k.win32.join(c(t,!0),...r)).path:a=k.posix.join(t.path,...r),t.with({path:a})}toString(t=!1){return w(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof l)return t;{const r=new v(t);return r._formatted=t.external??null,r._fsPath=t._sep===p?t.fsPath??null:null,r}}else return t}}e.URI=l;function g(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}e.isUriComponents=g;const p=O.isWindows?1:void 0;class v extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(t=!1){return t?w(this,!0):(this._formatted||(this._formatted=w(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=p),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const u={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(s,t,r){let a,C=-1;for(let E=0;E<s.length;E++){const h=s.charCodeAt(E);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||t&&h===47||r&&h===91||r&&h===93||r&&h===58)C!==-1&&(a+=encodeURIComponent(s.substring(C,E)),C=-1),a!==void 0&&(a+=s.charAt(E));else{a===void 0&&(a=s.substr(0,E));const y=u[h];y!==void 0?(C!==-1&&(a+=encodeURIComponent(s.substring(C,E)),C=-1),a+=y):C===-1&&(C=E)}}return C!==-1&&(a+=encodeURIComponent(s.substring(C))),a!==void 0?a:s}function f(s){let t;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);a===35||a===63?(t===void 0&&(t=s.substr(0,r)),t+=u[a]):t!==void 0&&(t+=s[r])}return t!==void 0?t:s}function c(s,t){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?t?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,O.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=c;function w(s,t){const r=t?f:d;let a="",{scheme:C,authority:E,path:h,query:y,fragment:R}=s;if(C&&(a+=C,a+=":"),(E||C==="file")&&(a+=b,a+=b),E){let U=E.indexOf("@");if(U!==-1){const F=E.substr(0,U);E=E.substr(U+1),U=F.lastIndexOf(":"),U===-1?a+=r(F,!1,!1):(a+=r(F.substr(0,U),!1,!1),a+=":",a+=r(F.substr(U+1),!1,!0)),a+="@"}E=E.toLowerCase(),U=E.lastIndexOf(":"),U===-1?a+=r(E,!1,!0):(a+=r(E.substr(0,U),!1,!0),a+=E.substr(U))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const U=h.charCodeAt(1);U>=65&&U<=90&&(h=`/${String.fromCharCode(U+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const U=h.charCodeAt(0);U>=65&&U<=90&&(h=`${String.fromCharCode(U+32)}:${h.substr(2)}`)}a+=r(h,!0,!1)}return y&&(a+="?",a+=r(y,!1,!1)),R&&(a+="#",a+=t?R:d(R,!1,!1)),a}function i(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+i(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(o)?s.replace(o,t=>i(t)):s}}),define(le[141],ue([0,1,10]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function O(m){const P=m;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=O;function T(m){const P=[];let b;try{const S=JSON.parse(m.arguments),l=S[S.length-1];l&&l.__$stack&&(S.pop(),b=l.__$stack),P.push(...S)}catch{P.push("Unable to log remote console arguments",m.arguments)}return{args:P,stack:b}}e.parse=T;function A(m){if(typeof m!="string")return A(T(m).stack);const P=m;if(P){const b=L(P),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(S&&S.length===4)return{uri:k.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=A;function L(m){if(!m)return m;const P=m.indexOf(`
`);return P===-1?m:m.substring(0,P)}function D(m,P){const{args:b,stack:S}=T(m),l=typeof b[0]=="string"&&b.length===1;let g=L(S);g&&(g=`(${g.trim()})`);let p=[];if(typeof b[0]=="string"?g&&l?p=[`%c[${P}] %c${b[0]} %c${g}`,I("blue"),I(""),I("grey")]:p=[`%c[${P}] %c${b[0]}`,I("blue"),I(""),...b.slice(1)]:p=[`%c[${P}]%`,I("blue"),...b],g&&!l&&p.push(g),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,p)}e.log=D;function I(m){return`color: ${m}`}}),define(le[66],ue([0,1,14,10]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(I){return JSON.stringify(I,L)}e.stringify=T;function A(I){let m=JSON.parse(I);return m=D(m),m}e.parse=A;function L(I,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:m.flags}:m}function D(I,m=0){if(!I||m>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return O.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 17:return new Date(I.source)}if(I instanceof k.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let P=0;P<I.length;++P)I[P]=D(I[P],m+1);else for(const P in I)Object.hasOwnProperty.call(I,P)&&(I[P]=D(I[P],m+1))}return I}e.revive=D}),define(le[23],ue([0,1,7,5,27,10]),function(se,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.matchesSomeScheme=e.matchesScheme=e.Schemas=void 0;var L;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeManagedRemoteResource="vscode-managed-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.vscodeChatSesssion="vscode-chat-editor",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={}));function D(S,l){return A.URI.isUri(S)?(0,T.equalsIgnoreCase)(S.scheme,l):(0,T.startsWithIgnoreCase)(S,l+":")}e.matchesScheme=D;function I(S,...l){return l.some(g=>D(S,g))}e.matchesSomeScheme=I,e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class m{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(l){this._preferredWebSchema=l}setDelegate(l){this._delegate=l}setServerRootPath(l){this._remoteResourcesPath=`${l}/${L.vscodeRemoteResource}`}set(l,g,p){this._hosts[l]=g,this._ports[l]=p}setConnectionToken(l,g){this._connectionTokens[l]=g}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(l){if(this._delegate)try{return this._delegate(l)}catch(f){return k.onUnexpectedError(f),l}const g=l.authority;let p=this._hosts[g];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const v=this._ports[g],u=this._connectionTokens[g];let d=`path=${encodeURIComponent(l.path)}`;return typeof u=="string"&&(d+=`&${e.connectionTokenQueryName}=${encodeURIComponent(u)}`),A.URI.from({scheme:O.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${p}:${v}`,path:this._remoteResourcesPath,query:d})}}e.RemoteAuthorities=new m,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class P{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(l){const g=this.toUri(l,se);return this.uriToBrowserUri(g)}uriToBrowserUri(l){return l.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(l):l.scheme===L.file&&(O.isNative||O.webWorkerOrigin===`${L.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?l.with({scheme:L.vscodeFileResource,authority:l.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):l}asFileUri(l){const g=this.toUri(l,se);return this.uriToFileUri(g)}uriToFileUri(l){return l.scheme===L.vscodeFileResource?l.with({scheme:L.file,authority:l.authority!==P.FALLBACK_AUTHORITY?l.authority:null,query:null,fragment:null}):l}toUri(l,g){return A.URI.isUri(l)?l:A.URI.parse(g.toUrl(l))}}e.FileAccess=new P;var b;(function(S){const l=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(l.get("3"));const g="vscode-coi";function p(u){let d;typeof u=="string"?d=new URL(u).searchParams:u instanceof URL?d=u.searchParams:A.URI.isUri(u)&&(d=new URL(u.toString(!0)).searchParams);const f=d?.get(g);if(f)return l.get(f)}S.getHeadersFromQuery=p;function v(u,d,f){if(!globalThis.crossOriginIsolated)return;const c=d&&f?"3":f?"2":"1";u instanceof URLSearchParams?u.set(g,c):u[g]=c}S.addSearchParam=v})(b||(e.COI=b={}))}),define(le[142],ue([0,1,124,23,5,10]),function(se,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class L{constructor(S,l,g){this.id=S,this.dependencies=l,this.callback=g}}class D{static{this.INSTANCE=new D}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(S,l,g)=>{typeof S!="string"&&(g=l,l=S,S=null),(typeof l!="object"||!Array.isArray(l))&&(g=l,l=null),this._defineCalls.push(new L(S,l,g))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(S){if(S.startsWith(window.location.origin)||S.startsWith("vscode-file://vscode-app"))return S;throw new Error(`[trusted_script_src] Invalid script url: ${S}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(S){return S}})))}async load(S){this._initialize();const l=await(this._isWebWorker?this._workerLoadScript(S):this._isRenderer?this._rendererLoadScript(S):this._nodeJSLoadScript(S));if(!l)throw new Error(`Did not receive a define call from script ${S}`);if(Array.isArray(l.dependencies)&&l.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${S}. The dependencies are: ${l.dependencies.join(", ")}`);return typeof l.callback=="function"?l.callback([]):l.callback}_rendererLoadScript(S){return new Promise((l,g)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const v=()=>{p.removeEventListener("load",u),p.removeEventListener("error",d)},u=f=>{v(),l(this._defineCalls.pop())},d=f=>{v(),g(f)};p.addEventListener("load",u),p.addEventListener("error",d),this._amdPolicy&&(S=this._amdPolicy.createScriptURL(S)),p.setAttribute("src",S),window.document.getElementsByTagName("head")[0].appendChild(p)})}_workerLoadScript(S){return new Promise((l,g)=>{try{this._amdPolicy&&(S=this._amdPolicy.createScriptURL(S)),importScripts(S),l(this._defineCalls.pop())}catch(p){g(p)}})}async _nodeJSLoadScript(S){try{const l=globalThis._VSCODE_NODE_MODULES.fs,g=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,v=A.URI.parse(S).fsPath,u=l.readFileSync(v).toString(),d=p.wrap(u.replace(/^#!.*/,""));return new g.Script(d).runInThisContext().apply(),this._defineCalls.pop()}catch(l){throw l}}}const I=new Map;let m={};typeof globalThis.require=="object"&&(m=globalThis.require.paths??{});async function P(b,S,l){if(k.isESM){l===void 0&&(l=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),m[b]&&(b=m[b]);const g=`${b}/${S}`;if(I.has(g))return I.get(g);let p;if(/^\w[\w\d+.-]*:\/\//.test(g))p=g;else{const f=`${l&&!T.isWeb?O.nodeModulesAsarPath:O.nodeModulesPath}/${g}`;p=O.FileAccess.asBrowserUri(f).toString(!0)}const v=D.INSTANCE.load(p);return I.set(g,v),v}else return await new Promise((g,p)=>{se([b],g,p)})}e.importAMDNodeModule=P}),define(le[20],ue([0,1,49,23,16,5,27,10]),function(se,e,k,O,T,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(l){return(0,D.uriToFsPath)(l,!0)}e.originalFSPath=I;class m{constructor(g){this._ignorePathCasing=g}compare(g,p,v=!1){return g===p?0:(0,L.compare)(this.getComparisonKey(g,v),this.getComparisonKey(p,v))}isEqual(g,p,v=!1){return g===p?!0:!g||!p?!1:this.getComparisonKey(g,v)===this.getComparisonKey(p,v)}getComparisonKey(g,p=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,p,v=!1){if(g.scheme===p.scheme){if(g.scheme===O.Schemas.file)return k.isEqualOrParent(I(g),I(p),this._ignorePathCasing(g))&&g.query===p.query&&(v||g.fragment===p.fragment);if((0,e.isEqualAuthority)(g.authority,p.authority))return k.isEqualOrParent(g.path,p.path,this._ignorePathCasing(g),"/")&&g.query===p.query&&(v||g.fragment===p.fragment)}return!1}joinPath(g,...p){return D.URI.joinPath(g,...p)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return T.posix.basename(g.path)}extname(g){return T.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let p;return g.scheme===O.Schemas.file?p=D.URI.file(T.dirname(I(g))).path:(p=T.posix.dirname(g.path),g.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),p="/")),g.with({path:p})}normalizePath(g){if(!g.path.length)return g;let p;return g.scheme===O.Schemas.file?p=D.URI.file(T.normalize(I(g))).path:p=T.posix.normalize(g.path),g.with({path:p})}relativePath(g,p){if(g.scheme!==p.scheme||!(0,e.isEqualAuthority)(g.authority,p.authority))return;if(g.scheme===O.Schemas.file){const d=T.relative(I(g),I(p));return A.isWindows?k.toSlashes(d):d}let v=g.path||"/";const u=p.path||"/";if(this._ignorePathCasing(g)){let d=0;for(const f=Math.min(v.length,u.length);d<f&&!(v.charCodeAt(d)!==u.charCodeAt(d)&&v.charAt(d).toLowerCase()!==u.charAt(d).toLowerCase());d++);v=u.substr(0,d)+v.substr(d)}return T.posix.relative(v,u)}resolvePath(g,p){if(g.scheme===O.Schemas.file){const v=D.URI.file(T.resolve(I(g),p));return g.with({authority:v.authority,path:v.path})}return p=k.toPosixPath(p),g.with({path:T.posix.resolve(g.path,p)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,p){return g===p||g!==void 0&&p!==void 0&&(0,L.equalsIgnoreCase)(g,p)}hasTrailingPathSeparator(g,p=T.sep){if(g.scheme===O.Schemas.file){const v=I(g);return v.length>k.getRoot(v).length&&v[v.length-1]===p}else{const v=g.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,p=T.sep){return(0,e.hasTrailingPathSeparator)(g,p)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,p=T.sep){let v=!1;if(g.scheme===O.Schemas.file){const u=I(g);v=u!==void 0&&u.length===k.getRoot(u).length&&u[u.length-1]===p}else{p="/";const u=g.path;v=u.length===1&&u.charCodeAt(u.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(g,p)?g.with({path:g.path+"/"}):g}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(l=>l.scheme===O.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new m(l=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(l,g){const p=[];for(let v=0;v<l.length;v++){const u=g(l[v]);l.some((d,f)=>f===v?!1:(0,e.isEqualOrParent)(u,g(d)))||p.push(l[v])}return p}e.distinctParents=P;var b;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function g(p){const v=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(f=>{const[c,w]=f.split(":");c&&w&&v.set(c,w)});const d=p.path.substring(0,p.path.indexOf(";"));return d&&v.set(l.META_DATA_MIME,d),v}l.parseMetaData=g})(b||(e.DataUri=b={}));function S(l,g,p){if(g){let v=l.path;return v&&v[0]!==T.posix.sep&&(v=T.posix.sep+v),l.with({scheme:p,authority:g,path:v})}return l.with({scheme:p})}e.toLocalResource=S}),define(le[6],ue([0,1,26,7,3,2,20,5,130,52]),function(se,e,k,O,T,A,L,D,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(B){return!!B&&typeof B.then=="function"}e.isThenable=P;function b(B){const H=new k.CancellationTokenSource,te=B(H.token),ne=new Promise((ce,fe)=>{const ge=H.token.onCancellationRequested(()=>{ge.dispose(),fe(new O.CancellationError)});Promise.resolve(te).then(Se=>{ge.dispose(),H.dispose(),ce(Se)},Se=>{ge.dispose(),H.dispose(),fe(Se)})});return new class{cancel(){H.cancel(),H.dispose()}then(ce,fe){return ne.then(ce,fe)}catch(ce){return this.then(void 0,ce)}finally(ce){return ne.finally(ce)}}}e.createCancelablePromise=b;function S(B,H,te){return new Promise((ne,ce)=>{const fe=H.onCancellationRequested(()=>{fe.dispose(),ne(te)});B.then(ne,ce).finally(()=>fe.dispose())})}e.raceCancellation=S;function l(B,H){return new Promise((te,ne)=>{const ce=H.onCancellationRequested(()=>{ce.dispose(),ne(new O.CancellationError)});B.then(te,ne).finally(()=>ce.dispose())})}e.raceCancellationError=l;async function g(B){let H=-1;const te=B.map((ne,ce)=>ne.then(fe=>(H=ce,fe)));try{return await Promise.race(te)}finally{B.forEach((ne,ce)=>{ce!==H&&ne.cancel()})}}e.raceCancellablePromises=g;function p(B,H,te){let ne;const ce=setTimeout(()=>{ne?.(void 0),te?.()},H);return Promise.race([B.finally(()=>clearTimeout(ce)),new Promise(fe=>ne=fe)])}e.raceTimeout=p;function v(B){return new Promise((H,te)=>{const ne=B();P(ne)?ne.then(H,te):H(ne)})}e.asPromise=v;class u{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(H){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=H,!this.queuedPromise){const te=()=>{if(this.queuedPromise=null,this.isDisposed)return;const ne=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ne};this.queuedPromise=new Promise(ne=>{this.activePromise.then(te,te).then(ne)})}return new Promise((te,ne)=>{this.queuedPromise.then(te,ne)})}return this.activePromise=H(),new Promise((te,ne)=>{this.activePromise.then(ce=>{this.activePromise=null,te(ce)},ce=>{this.activePromise=null,ne(ce)})})}dispose(){this.isDisposed=!0}}e.Throttler=u;class d{constructor(){this.current=Promise.resolve(null)}queue(H){return this.current=this.current.then(()=>H(),()=>H())}}e.Sequencer=d;class f{constructor(){this.promiseMap=new Map}queue(H,te){const ce=(this.promiseMap.get(H)??Promise.resolve()).catch(()=>{}).then(te).finally(()=>{this.promiseMap.get(H)===ce&&this.promiseMap.delete(H)});return this.promiseMap.set(H,ce),ce}}e.SequencerByKey=f;const c=(B,H)=>{let te=!0;const ne=setTimeout(()=>{te=!1,H()},B);return{isTriggered:()=>te,dispose:()=>{clearTimeout(ne),te=!1}}},w=B=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,B())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};class i{constructor(H){this.defaultDelay=H,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(H,te=this.defaultDelay){this.task=H,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ce,fe)=>{this.doResolve=ce,this.doReject=fe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ce=this.task;return this.task=null,ce()}}));const ne=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=te===I.MicrotaskDelay?w(ne):c(te,ne),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new O.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=i;class o{constructor(H){this.delayer=new i(H),this.throttler=new u}trigger(H,te){return this.delayer.trigger(()=>this.throttler.queue(H),te)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=o;class n{constructor(){this._isOpen=!1,this._promise=new Promise((H,te)=>{this._completePromise=H})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class s extends n{constructor(H){super(),this._timeout=setTimeout(()=>this.open(),H)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function t(B,H){return H?new Promise((te,ne)=>{const ce=setTimeout(()=>{fe.dispose(),te()},B),fe=H.onCancellationRequested(()=>{clearTimeout(ce),fe.dispose(),ne(new O.CancellationError)})}):b(te=>t(B,te))}e.timeout=t;function r(B,H=0,te){const ne=setTimeout(()=>{B(),te&&ce.dispose()},H),ce=(0,A.toDisposable)(()=>{clearTimeout(ne),te?.deleteAndLeak(ce)});return te?.add(ce),ce}e.disposableTimeout=r;function a(B){const H=[];let te=0;const ne=B.length;function ce(){return te<ne?B[te++]():null}function fe(ge){ge!=null&&H.push(ge);const Se=ce();return Se?Se.then(fe):Promise.resolve(H)}return Promise.resolve(null).then(fe)}e.sequence=a;function C(B,H=ne=>!!ne,te=null){let ne=0;const ce=B.length,fe=()=>{if(ne>=ce)return Promise.resolve(te);const ge=B[ne++];return Promise.resolve(ge()).then(Ce=>H(Ce)?Promise.resolve(Ce):fe())};return fe()}e.first=C;function E(B,H=ne=>!!ne,te=null){if(B.length===0)return Promise.resolve(te);let ne=B.length;const ce=()=>{ne=-1;for(const fe of B)fe.cancel?.()};return new Promise((fe,ge)=>{for(const Se of B)Se.then(Ce=>{--ne>=0&&H(Ce)?(ce(),fe(Ce)):ne===0&&fe(te)}).catch(Ce=>{--ne>=0&&(ce(),ge(Ce))})})}e.firstParallel=E;class h{constructor(H){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=H,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new T.Emitter}whenIdle(){return this.size>0?T.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(H){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((te,ne)=>{this.outstandingPromises.push({factory:H,c:te,e:ne}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const H=this.outstandingPromises.shift();this.runningPromises++;const te=H.factory();te.then(H.c,H.e),te.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=h;class y extends h{constructor(){super(1)}}e.Queue=y;class R{constructor(){this.sequentializer=new q,this.tasks=0}queue(H){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,H())):this.sequentializer.run(this.tasks++,H())}}e.LimitedQueue=R;class U{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const H=new ee;return this.drainers.add(H),H.p}isDrained(){for(const[,H]of this.queues)if(H.size>0)return!1;return!0}queueSize(H,te=L.extUri){const ne=te.getComparisonKey(H);return this.queues.get(ne)?.size??0}queueFor(H,te,ne=L.extUri){const ce=ne.getComparisonKey(H);let fe=this.queues.get(ce);if(!fe){fe=new y;const ge=this.drainListenerCount++,Se=T.Event.once(fe.onDrained)(()=>{fe?.dispose(),this.queues.delete(ce),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(ge),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new A.DisposableMap),this.drainListeners.set(ge,Se),this.queues.set(ce,fe)}return fe.queue(te)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const H of this.drainers)H.complete();this.drainers.clear()}dispose(){for(const[,H]of this.queues)H.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=U;class F{constructor(H,te){this._token=-1,typeof H=="function"&&typeof te=="number"&&this.setIfNotSet(H,te)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(H,te){this.cancel(),this._token=setTimeout(()=>{this._token=-1,H()},te)}setIfNotSet(H,te){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,H()},te))}}e.TimeoutTimer=F;class M{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(H,te,ne=globalThis){this.cancel();const ce=ne.setInterval(()=>{H()},te);this.disposable=(0,A.toDisposable)(()=>{ne.clearInterval(ce),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=M;class j{constructor(H,te){this.timeoutToken=-1,this.runner=H,this.timeout=te,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(H=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,H)}get delay(){return this.timeout}set delay(H){this.timeout=H}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=j;class Q{constructor(H,te){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.runner=H,this.timeout=te,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(H=this.timeout){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(H/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=Q;class K extends j{constructor(H,te){super(H,te),this.units=[]}work(H){this.units.push(H),this.isScheduled()||this.schedule()}doRun(){const H=this.units;this.units=[],this.runner?.(H)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=K;class X extends A.Disposable{constructor(H,te){super(),this.options=H,this.handler=te,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(H){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+H.length>this.options.maxBufferedWork)return!1}else if(this.pending+H.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const te of H)this.pendingWork.push(te);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new j(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=X,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(B,H)=>{(0,D.setTimeout0)(()=>{if(te)return;const ne=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ne-Date.now())}}))});let te=!1;return{dispose(){te||(te=!0)}}}:e._runWhenIdle=(B,H,te)=>{const ne=B.requestIdleCallback(H,typeof te=="number"?{timeout:te}:void 0);let ce=!1;return{dispose(){ce||(ce=!0,B.cancelIdleCallback(ne))}}},e.runWhenGlobalIdle=B=>(0,e._runWhenIdle)(globalThis,B)}();class x{constructor(H,te){this._didRun=!1,this._executor=()=>{try{this._value=te()}catch(ne){this._error=ne}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(H,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=x;class J extends x{constructor(H){super(globalThis,H)}}e.GlobalIdleValue=J;async function V(B,H,te){let ne;for(let ce=0;ce<te;ce++)try{return await B()}catch(fe){ne=fe,await t(H)}throw ne}e.retry=V;class q{isRunning(H){return typeof H=="number"?this._running?.taskId===H:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(H,te,ne){return this._running={taskId:H,cancel:()=>ne?.(),promise:te},te.then(()=>this.doneRunning(H),()=>this.doneRunning(H)),te}doneRunning(H){this._running&&H===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const H=this._queued;this._queued=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}queue(H){if(this._queued)this._queued.run=H;else{let te,ne;const ce=new Promise((fe,ge)=>{te=fe,ne=ge});this._queued={run:H,promise:ce,promiseResolve:te,promiseReject:ne}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=q;class ie{constructor(H,te=()=>Date.now()){this.interval=H,this.nowFn=te,this.lastIncrementTime=0,this.value=0}increment(){const H=this.nowFn();return H-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=H,this.value=0),this.value++,this.value}}e.IntervalCounter=ie;var re;(function(B){B[B.Resolved=0]="Resolved",B[B.Rejected=1]="Rejected"})(re||(re={}));class ee{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((H,te)=>{this.completeCallback=H,this.errorCallback=te})}complete(H){return new Promise(te=>{this.completeCallback(H),this.outcome={outcome:0,value:H},te()})}error(H){return new Promise(te=>{this.errorCallback(H),this.outcome={outcome:1,value:H},te()})}cancel(){return this.error(new O.CancellationError)}}e.DeferredPromise=ee;var ae;(function(B){async function H(ne){let ce;const fe=await Promise.all(ne.map(ge=>ge.then(Se=>Se,Se=>{ce||(ce=Se)})));if(typeof ce<"u")throw ce;return fe}B.settled=H;function te(ne){return new Promise(async(ce,fe)=>{try{await ne(ce,fe)}catch(ge){fe(ge)}})}B.withAsyncBody=te})(ae||(e.Promises=ae={}));class G{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(H){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=H.then(te=>(this._value=te,this._isResolved=!0,te),te=>{throw this._error=te,this._isResolved=!0,te})}requireValue(){if(!this._isResolved)throw new O.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=G;class W{constructor(H){this._compute=H,this._promise=new m.Lazy(()=>new G(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=W;var _;(function(B){B[B.Initial=0]="Initial",B[B.DoneOK=1]="DoneOK",B[B.DoneError=2]="DoneError"})(_||(_={}));class N{static fromArray(H){return new N(te=>{te.emitMany(H)})}static fromPromise(H){return new N(async te=>{te.emitMany(await H)})}static fromPromises(H){return new N(async te=>{await Promise.all(H.map(async ne=>te.emitOne(await ne)))})}static merge(H){return new N(async te=>{await Promise.all(H.map(async ne=>{for await(const ce of ne)te.emitOne(ce)}))})}static{this.EMPTY=N.fromArray([])}constructor(H){this._state=0,this._results=[],this._error=null,this._onStateChanged=new T.Emitter,queueMicrotask(async()=>{const te={emitOne:ne=>this.emitOne(ne),emitMany:ne=>this.emitMany(ne),reject:ne=>this.reject(ne)};try{await Promise.resolve(H(te)),this.resolve()}catch(ne){this.reject(ne)}finally{te.emitOne=void 0,te.emitMany=void 0,te.reject=void 0}})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(H<this._results.length)return{done:!1,value:this._results[H++]};if(this._state===1)return{done:!0,value:void 0};await T.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(H,te){return new N(async ne=>{for await(const ce of H)ne.emitOne(te(ce))})}map(H){return N.map(this,H)}static filter(H,te){return new N(async ne=>{for await(const ce of H)te(ce)&&ne.emitOne(ce)})}filter(H){return N.filter(this,H)}static coalesce(H){return N.filter(H,te=>!!te)}coalesce(){return N.coalesce(this)}static async toPromise(H){const te=[];for await(const ne of H)te.push(ne);return te}toPromise(){return N.toPromise(this)}emitOne(H){this._state===0&&(this._results.push(H),this._onStateChanged.fire())}emitMany(H){this._state===0&&(this._results=this._results.concat(H),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(H){this._state===0&&(this._state=2,this._error=H,this._onStateChanged.fire())}}e.AsyncIterableObject=N;class z extends N{constructor(H,te){super(te),this._source=H}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=z;function $(B){const H=new k.CancellationTokenSource,te=B(H.token);return new z(H,async ne=>{const ce=H.token.onCancellationRequested(()=>{ce.dispose(),H.dispose(),ne.reject(new O.CancellationError)});try{for await(const fe of te){if(H.token.isCancellationRequested)return;ne.emitOne(fe)}ce.dispose(),H.dispose()}catch(fe){ce.dispose(),H.dispose(),ne.reject(fe)}})}e.createCancelableAsyncIterable=$;class Z{constructor(){this._deferred=new ee,this._asyncIterable=new N(ne=>{if(H){ne.reject(H);return}return te&&ne.emitMany(te),this._errorFn=ce=>ne.reject(ce),this._emitFn=ce=>ne.emitOne(ce),this._deferred.p});let H,te;this._emitFn=ne=>{te||(te=[]),te.push(ne)},this._errorFn=ne=>{H||(H=ne)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(H){this._errorFn(H),this._deferred.complete()}emitOne(H){this._emitFn(H)}}e.AsyncIterableSource=Z}),define(le[91],ue([0,1,17,6,49,35,16,5,27]),function(se,e,k,O,T,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const P="[/\\\\]",b="[^/\\\\]",S=/\//g;function l(J,V){switch(J){case 0:return"";case 1:return`${b}*?`;default:return`(?:${P}|${b}+${P}${V?`|${P}${b}+`:""})*?`}}function g(J,V){if(!J)return[];const q=[];let ie=!1,re=!1,ee="";for(const ae of J){switch(ae){case V:if(!ie&&!re){q.push(ee),ee="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":re=!0;break;case"]":re=!1;break}ee+=ae}return ee&&q.push(ee),q}e.splitGlobAware=g;function p(J){if(!J)return"";let V="";const q=g(J,e.GLOB_SPLIT);if(q.every(ie=>ie===e.GLOBSTAR))V=".*";else{let ie=!1;q.forEach((re,ee)=>{if(re===e.GLOBSTAR){if(ie)return;V+=l(2,ee===q.length-1)}else{let ae=!1,G="",W=!1,_="";for(const N of re){if(N!=="}"&&ae){G+=N;continue}if(W&&(N!=="]"||!_)){let z;N==="-"?z=N:(N==="^"||N==="!")&&!_?z="^":N===e.GLOB_SPLIT?z="":z=(0,I.escapeRegExpCharacters)(N),_+=z;continue}switch(N){case"{":ae=!0;continue;case"[":W=!0;continue;case"}":{const $=`(?:${g(G,",").map(Z=>p(Z)).join("|")})`;V+=$,ae=!1,G="";break}case"]":{V+="["+_+"]",W=!1,_="";break}case"?":V+=b;continue;case"*":V+=l(1);continue;default:V+=(0,I.escapeRegExpCharacters)(N)}}ee<q.length-1&&(q[ee+1]!==e.GLOBSTAR||ee+2<q.length)&&(V+=P)}ie=re===e.GLOBSTAR})}return V}const v=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new A.LRUCache(1e4),o=function(){return!1},n=function(){return null};function s(J,V){if(!J)return n;let q;typeof J!="string"?q=J.pattern:q=J,q=q.trim();const ie=`${q}_${!!V.trimForExclusions}`;let re=i.get(ie);if(re)return t(re,J);let ee;return v.test(q)?re=a(q.substr(4),q):(ee=u.exec(r(q,V)))?re=C(ee[1],q):(V.trimForExclusions?f:d).test(q)?re=E(q,V):(ee=c.exec(r(q,V)))?re=h(ee[1].substr(1),q,!0):(ee=w.exec(r(q,V)))?re=h(ee[1],q,!1):re=y(q),i.set(ie,re),t(re,J)}function t(J,V){if(typeof V=="string")return J;const q=function(ie,re){return(0,T.isEqualOrParent)(ie,V.base,!D.isLinux)?J((0,I.ltrim)(ie.substr(V.base.length),L.sep),re):null};return q.allBasenames=J.allBasenames,q.allPaths=J.allPaths,q.basenames=J.basenames,q.patterns=J.patterns,q}function r(J,V){return V.trimForExclusions&&J.endsWith("/**")?J.substr(0,J.length-2):J}function a(J,V){return function(q,ie){return typeof q=="string"&&q.endsWith(J)?V:null}}function C(J,V){const q=`/${J}`,ie=`\\${J}`,re=function(ae,G){return typeof ae!="string"?null:G?G===J?V:null:ae===J||ae.endsWith(q)||ae.endsWith(ie)?V:null},ee=[J];return re.basenames=ee,re.patterns=[V],re.allBasenames=ee,re}function E(J,V){const q=X(J.slice(1,-1).split(",").map(G=>s(G,V)).filter(G=>G!==n),J),ie=q.length;if(!ie)return n;if(ie===1)return q[0];const re=function(G,W){for(let _=0,N=q.length;_<N;_++)if(q[_](G,W))return J;return null},ee=q.find(G=>!!G.allBasenames);ee&&(re.allBasenames=ee.allBasenames);const ae=q.reduce((G,W)=>W.allPaths?G.concat(W.allPaths):G,[]);return ae.length&&(re.allPaths=ae),re}function h(J,V,q){const ie=L.sep===L.posix.sep,re=ie?J:J.replace(S,L.sep),ee=L.sep+re,ae=L.posix.sep+J;let G;return q?G=function(W,_){return typeof W=="string"&&(W===re||W.endsWith(ee)||!ie&&(W===J||W.endsWith(ae)))?V:null}:G=function(W,_){return typeof W=="string"&&(W===re||!ie&&W===J)?V:null},G.allPaths=[(q?"*/":"./")+J],G}function y(J){try{const V=new RegExp(`^${p(J)}$`);return function(q){return V.lastIndex=0,typeof q=="string"&&V.test(q)?J:null}}catch{return n}}function R(J,V,q){return!J||typeof V!="string"?!1:U(J)(V,void 0,q)}e.match=R;function U(J,V={}){if(!J)return o;if(typeof J=="string"||F(J)){const q=s(J,V);if(q===n)return o;const ie=function(re,ee){return!!q(re,ee)};return q.allBasenames&&(ie.allBasenames=q.allBasenames),q.allPaths&&(ie.allPaths=q.allPaths),ie}return Q(J,V)}e.parse=U;function F(J){const V=J;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.isRelativePattern=F;function M(J){return J.allBasenames||[]}e.getBasenameTerms=M;function j(J){return J.allPaths||[]}e.getPathTerms=j;function Q(J,V){const q=X(Object.getOwnPropertyNames(J).map(G=>K(G,J[G],V)).filter(G=>G!==n)),ie=q.length;if(!ie)return n;if(!q.some(G=>!!G.requiresSiblings)){if(ie===1)return q[0];const G=function(N,z){let $;for(let Z=0,B=q.length;Z<B;Z++){const H=q[Z](N,z);if(typeof H=="string")return H;(0,O.isThenable)(H)&&($||($=[]),$.push(H))}return $?(async()=>{for(const Z of $){const B=await Z;if(typeof B=="string")return B}return null})():null},W=q.find(N=>!!N.allBasenames);W&&(G.allBasenames=W.allBasenames);const _=q.reduce((N,z)=>z.allPaths?N.concat(z.allPaths):N,[]);return _.length&&(G.allPaths=_),G}const re=function(G,W,_){let N,z;for(let $=0,Z=q.length;$<Z;$++){const B=q[$];B.requiresSiblings&&_&&(W||(W=(0,L.basename)(G)),N||(N=W.substr(0,W.length-(0,L.extname)(G).length)));const H=B(G,W,N,_);if(typeof H=="string")return H;(0,O.isThenable)(H)&&(z||(z=[]),z.push(H))}return z?(async()=>{for(const $ of z){const Z=await $;if(typeof Z=="string")return Z}return null})():null},ee=q.find(G=>!!G.allBasenames);ee&&(re.allBasenames=ee.allBasenames);const ae=q.reduce((G,W)=>W.allPaths?G.concat(W.allPaths):G,[]);return ae.length&&(re.allPaths=ae),re}function K(J,V,q){if(V===!1)return n;const ie=s(J,q);if(ie===n)return n;if(typeof V=="boolean")return ie;if(V){const re=V.when;if(typeof re=="string"){const ee=(ae,G,W,_)=>{if(!_||!ie(ae,G))return null;const N=re.replace("$(basename)",()=>W),z=_(N);return(0,O.isThenable)(z)?z.then($=>$?J:null):z?J:null};return ee.requiresSiblings=!0,ee}}return ie}function X(J,V){const q=J.filter(G=>!!G.basenames);if(q.length<2)return J;const ie=q.reduce((G,W)=>{const _=W.basenames;return _?G.concat(_):G},[]);let re;if(V){re=[];for(let G=0,W=ie.length;G<W;G++)re.push(V)}else re=q.reduce((G,W)=>{const _=W.patterns;return _?G.concat(_):G},[]);const ee=function(G,W){if(typeof G!="string")return null;if(!W){let N;for(N=G.length;N>0;N--){const z=G.charCodeAt(N-1);if(z===47||z===92)break}W=G.substr(N)}const _=ie.indexOf(W);return _!==-1?re[_]:null};ee.basenames=ie,ee.patterns=re,ee.allBasenames=ie;const ae=J.filter(G=>!G.basenames);return ae.push(ee),ae}function x(J,V){return(0,k.equals)(J,V,(q,ie)=>typeof q=="string"&&typeof ie=="string"?q===ie:typeof q!="string"&&typeof ie!="string"?q.base===ie.base&&q.pattern===ie.pattern:!1)}e.patternsEquals=x}),define(le[92],ue([0,1,14,10]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(b){return b.toJSON()}class A{constructor(S){this._uriTransformer=S}transformIncoming(S){const l=this._uriTransformer.transformIncoming(S);return l===S?S:T(O.URI.from(l))}transformOutgoing(S){const l=this._uriTransformer.transformOutgoing(S);return l===S?S:T(O.URI.from(l))}transformOutgoingURI(S){const l=this._uriTransformer.transformOutgoing(S);return l===S?S:O.URI.from(l)}transformOutgoingScheme(S){return this._uriTransformer.transformOutgoingScheme(S)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function L(b,S,l){if(!b||l>200)return null;if(typeof b=="object"){if(b instanceof O.URI)return S.transformOutgoing(b);for(const g in b)if(Object.hasOwnProperty.call(b,g)){const p=L(b[g],S,l+1);p!==null&&(b[g]=p)}}return null}function D(b,S){const l=L(b,S,0);return l===null?b:l}e.transformOutgoingURIs=D;function I(b,S,l,g){if(!b||g>200)return null;if(typeof b=="object"){if(b.$mid===1)return l?O.URI.revive(S.transformIncoming(b)):S.transformIncoming(b);if(b instanceof k.VSBuffer)return null;for(const p in b)if(Object.hasOwnProperty.call(b,p)){const v=I(b[p],S,l,g+1);v!==null&&(b[p]=v)}}return null}function m(b,S){const l=I(b,S,!1,0);return l===null?b:l}e.transformIncomingURIs=m;function P(b,S){const l=I(b,S,!0,0);return l===null?b:l}e.transformAndReviveIncomingURIs=P}),define(le[143],ue([0,1,36,48,32,131,5]),function(se,e,k,O,T,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSqmMachineId=e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(S){return this._virtualMachineOUIs||(this._virtualMachineOUIs=O.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(S)}value(){if(this._value===void 0){let S=0,l=0;const g=(0,k.networkInterfaces)();for(const p in g){const v=g[p];if(v)for(const{mac:u,internal:d}of v)d||(l+=1,this._isVirtualMachineMacAddress(u.toUpperCase())&&(S+=1))}this._value=l>0?S/l:0}return this._value}};let D;async function I(S){return D||(D=(async()=>await m(S)||T.generateUuid())()),D}e.getMachineId=I;async function m(S){try{const l=await new Promise((p,v)=>{se(["crypto"],p,v)}),g=(0,A.getMac)();return l.createHash("sha256").update(g,"utf8").digest("hex")}catch(l){S(l);return}}const P="Software\\Microsoft\\SQMClient";async function b(S){if(L.isWindows){const l=await new Promise((g,p)=>{se(["@vscode/windows-registry"],g,p)});try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",P,"MachineId")||""}catch(g){return S(g),""}}return""}e.getSqmMachineId=b}),define(le[31],ue([0,1,54,36,268,6,49,88,16,5,20,10]),function(se,e,k,O,T,A,L,D,I,m,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(K){K[K.UNLINK=0]="UNLINK",K[K.MOVE=1]="MOVE"})(S||(e.RimRafMode=S={}));async function l(K,X=S.UNLINK,x){if((0,L.isRootOrDriveLetter)(K))throw new Error("rimraf - will refuse to recursively delete root");return X===S.UNLINK?p(K):g(K,x)}async function g(K,X=(0,L.randomPath)((0,O.tmpdir)())){try{try{await k.promises.rename(K,X)}catch(x){return x.code==="ENOENT"?void 0:p(K)}p(X).catch(x=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function p(K){return(0,T.promisify)(k.rm)(K,{recursive:!0,force:!0,maxRetries:3})}function v(K){if((0,L.isRootOrDriveLetter)(K))throw new Error("rimraf - will refuse to recursively delete root");k.rmSync(K,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=v;async function u(K,X){return c(await(X?d(K):(0,T.promisify)(k.readdir)(K)))}async function d(K){try{return await(0,T.promisify)(k.readdir)(K,{withFileTypes:!0})}catch(J){console.warn("[node.js fs] readdir with filetypes failed with error: ",J)}const X=[],x=await u(K);for(const J of x){let V=!1,q=!1,ie=!1;try{const re=await e.Promises.lstat((0,I.join)(K,J));V=re.isFile(),q=re.isDirectory(),ie=re.isSymbolicLink()}catch(re){console.warn("[node.js fs] unexpected error from lstat after readdir: ",re)}X.push({name:J,isFile:()=>V,isDirectory:()=>q,isSymbolicLink:()=>ie})}return X}function f(K){return c(k.readdirSync(K))}e.readdirSync=f;function c(K){return K.map(X=>typeof X=="string"?m.isMacintosh?(0,D.normalizeNFC)(X):X:(X.name=m.isMacintosh?(0,D.normalizeNFC)(X.name):X.name,X))}async function w(K){const X=await u(K),x=[];for(const J of X)await o.existsDirectory((0,I.join)(K,J))&&x.push(J);return x}function i(K,X=1e3){return new Promise(x=>{let J=!1;const V=setInterval(()=>{J||(J=!0,k.access(K,q=>{J=!1,q&&(clearInterval(V),x(void 0))}))},X)})}e.whenDeleted=i;var o;(function(K){async function X(V){let q;try{if(q=await e.Promises.lstat(V),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ie){if(ie.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(m.isWindows&&ie.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(re){if(re.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw re}throw ie}}K.stat=X;async function x(V){try{const{stat:q,symbolicLink:ie}=await K.stat(V);return q.isFile()&&ie?.dangling!==!0}catch{}return!1}K.existsFile=x;async function J(V){try{const{stat:q,symbolicLink:ie}=await K.stat(V);return q.isDirectory()&&ie?.dangling!==!0}catch{}return!1}K.existsDirectory=J})(o||(e.SymlinkSupport=o={}));const n=new A.ResourceQueue;function s(K,X,x){return n.queueFor(b.URI.file(K),()=>{const J=E(x);return new Promise((V,q)=>a(K,X,J,ie=>ie?q(ie):V()))},P.extUriBiasedIgnorePathCase)}let t=!0;function r(K){t=K}e.configureFlushOnWrite=r;function a(K,X,x,J){if(!t)return k.writeFile(K,X,{mode:x.mode,flag:x.flag},J);k.open(K,x.flag,x.mode,(V,q)=>{if(V)return J(V);k.writeFile(q,X,ie=>{if(ie)return k.close(q,()=>J(ie));k.fdatasync(q,re=>(re&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",re),r(!1)),k.close(q,ee=>J(ee))))})})}function C(K,X,x){const J=E(x);if(!t)return k.writeFileSync(K,X,{mode:J.mode,flag:J.flag});const V=k.openSync(K,J.flag,J.mode);try{k.writeFileSync(V,X);try{k.fdatasyncSync(V)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),r(!1)}}finally{k.closeSync(V)}}e.writeFileSync=C;function E(K){return K?{mode:typeof K.mode=="number"?K.mode:438,flag:typeof K.flag=="string"?K.flag:"w"}:{mode:438,flag:"w"}}async function h(K,X,x=6e4){if(K!==X)try{m.isWindows&&typeof x=="number"?await y(K,X,Date.now(),x):await(0,T.promisify)(k.rename)(K,X)}catch(J){if(K.toLowerCase()!==X.toLowerCase()&&J.code==="EXDEV"||K.endsWith("."))await R(K,X,{preserveSymlinks:!1}),await l(K,S.MOVE);else throw J}}async function y(K,X,x,J,V=0){try{return await(0,T.promisify)(k.rename)(K,X)}catch(q){if(q.code!=="EACCES"&&q.code!=="EPERM"&&q.code!=="EBUSY")throw q;if(Date.now()-x>=J)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${q}`),q;if(V===0){let ie=!1;try{const{stat:re}=await o.stat(X);re.isFile()||(ie=!0)}catch{}if(ie)throw q}return await(0,A.timeout)(Math.min(100,V*10)),y(K,X,x,J,V+1)}}async function R(K,X,x){return F(K,X,{root:{source:K,target:X},options:x,handledSourcePaths:new Set})}const U=511;async function F(K,X,x){if(x.handledSourcePaths.has(K))return;x.handledSourcePaths.add(K);const{stat:J,symbolicLink:V}=await o.stat(K);if(V){if(x.options.preserveSymlinks)try{return await Q(K,X,x)}catch{}if(V.dangling)return}return J.isDirectory()?M(K,X,J.mode&U,x):j(K,X,J.mode&U)}async function M(K,X,x,J){await e.Promises.mkdir(X,{recursive:!0,mode:x});const V=await u(K);for(const q of V)await F((0,I.join)(K,q),(0,I.join)(X,q),J)}async function j(K,X,x){await e.Promises.copyFile(K,X),await e.Promises.chmod(X,x)}async function Q(K,X,x){let J=await e.Promises.readlink(K);(0,L.isEqualOrParent)(J,x.root.source,!m.isLinux)&&(J=(0,I.join)(x.root.target,J.substr(x.root.source.length+1))),await e.Promises.symlink(J,X)}e.Promises=new class{get access(){return(0,T.promisify)(k.access)}get stat(){return(0,T.promisify)(k.stat)}get lstat(){return(0,T.promisify)(k.lstat)}get utimes(){return(0,T.promisify)(k.utimes)}get read(){return(K,X,x,J,V)=>new Promise((q,ie)=>{k.read(K,X,x,J,V,(re,ee,ae)=>re?ie(re):q({bytesRead:ee,buffer:ae}))})}get readFile(){return(0,T.promisify)(k.readFile)}get write(){return(K,X,x,J,V)=>new Promise((q,ie)=>{k.write(K,X,x,J,V,(re,ee,ae)=>re?ie(re):q({bytesWritten:ee,buffer:ae}))})}get appendFile(){return(0,T.promisify)(k.appendFile)}get fdatasync(){return(0,T.promisify)(k.fdatasync)}get truncate(){return(0,T.promisify)(k.truncate)}get copyFile(){return(0,T.promisify)(k.copyFile)}get open(){return(0,T.promisify)(k.open)}get close(){return(0,T.promisify)(k.close)}get symlink(){return(0,T.promisify)(k.symlink)}get readlink(){return(0,T.promisify)(k.readlink)}get chmod(){return(0,T.promisify)(k.chmod)}get mkdir(){return(0,T.promisify)(k.mkdir)}get unlink(){return(0,T.promisify)(k.unlink)}get rmdir(){return(0,T.promisify)(k.rmdir)}get realpath(){return(0,T.promisify)(k.realpath)}async exists(K){try{return await e.Promises.access(K),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return w}get writeFile(){return s}get rm(){return l}get rename(){return h}get copy(){return R}}}),define(le[144],ue([0,1,54,16,5,27,31]),function(se,e,k,O,T,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function D(S){if(T.isLinux)return S;const l=(0,O.dirname)(S);if(S===l)return S;const g=((0,O.basename)(S)||S).toLowerCase();try{const v=(0,L.readdirSync)(l).filter(u=>u.toLowerCase()===g);if(v.length===1){const u=D(l);if(u)return(0,O.join)(u,v[0])}else if(v.length>1){const u=v.indexOf(g);if(u>=0){const d=D(l);if(d)return(0,O.join)(d,v[u])}}}catch{}return null}e.realcaseSync=D;async function I(S){if(T.isLinux)return S;const l=(0,O.dirname)(S);if(S===l)return S;const g=((0,O.basename)(S)||S).toLowerCase();try{const v=(await L.Promises.readdir(l)).filter(u=>u.toLowerCase()===g);if(v.length===1){const u=await I(l);if(u)return(0,O.join)(u,v[0])}else if(v.length>1){const u=v.indexOf(g);if(u>=0){const d=await I(l);if(d)return(0,O.join)(d,v[u])}}}catch{}return null}e.realcase=I;async function m(S){try{return await L.Promises.realpath(S)}catch{const g=b(S);return await L.Promises.access(g,k.constants.R_OK),g}}e.realpath=m;function P(S){try{return k.realpathSync(S)}catch{const g=b(S);return k.accessSync(g,k.constants.R_OK),g}}e.realpathSync=P;function b(S){return(0,A.rtrim)((0,O.normalize)(S),O.sep)}}),define(le[145],ue([0,1,16,5,37,90,12,31]),function(se,e,k,O,T,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function I(b=T.env){return b.comspec||"cmd.exe"}e.getWindowsShell=I;function m(b){let S=[],l=!1;const g=function(p){if(l){S.push(p);return}(!b.send(p,u=>{if(u&&console.error(u),l=!1,S.length>0){const d=S.slice(0);S=[],d.forEach(f=>g(f))}})||O.isWindows)&&(l=!0)};return{send:g}}e.createQueuedSender=m;var P;(function(b){async function S(l,g,p){if(k.isAbsolute(l))return l;if(g===void 0&&(g=T.cwd()),k.dirname(l)!=="."||(p===void 0&&L.isString(T.env.PATH)&&(p=T.env.PATH.split(k.delimiter)),p===void 0||p.length===0))return k.join(g,l);async function u(d){if(await D.Promises.exists(d)){let f;try{f=await D.Promises.stat(d)}catch(c){c.message.startsWith("EACCES")&&(f=await D.Promises.lstat(d))}return f?!f.isDirectory():!1}return!1}for(const d of p){let f;if(k.isAbsolute(d)?f=k.join(d,l):f=k.join(g,d,l),await u(f))return f;let c=f+".com";if(await u(c)||(c=f+".exe",await u(c)))return c}return k.join(g,l)}b.findExecutable=S})(P||(e.win32=P={}))}),define(le[146],ue([0,1,67,23]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function T(L){return new Promise((D,I)=>{let m;const P=new Map;function b(l,g,p,v,u){const d=P.get(g);if(l===L||d){const f={name:S(p),cmd:p,pid:l,ppid:g,load:v,mem:u};P.set(l,f),l===L&&(m=f),d&&(d.children||(d.children=[]),d.children.push(f),d.children.length>1&&(d.children=d.children.sort((c,w)=>c.pid-w.pid)))}}function S(l){const g=/--utility-sub-type=network/i,p=/--crashes-directory/i,v=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,d=/--type=([a-zA-Z-]+)/;if(p.exec(l))return"electron-crash-reporter";if(v.exec(l))return"winpty-agent";if(u.exec(l))return"conpty-agent";let f=d.exec(l);if(f&&f.length===2)return f[1]==="renderer"?"window":f[1]==="utility"?g.exec(l)?"utility-network-service":"utility-process":f[1]==="extensionHost"?"extension-host":f[1];const c=/[a-zA-Z-]+\.js/g;let w="";do f=c.exec(l),f&&(w+=f+" ");while(f);return w&&l.indexOf("node ")<0&&l.indexOf("node.exe")<0?`electron-nodejs (${w})`:l}if(process.platform==="win32"){const l=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substring(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substring(5):g;new Promise((g,p)=>{se(["@vscode/windows-process-tree"],g,p)}).then(g=>{g.getProcessList(L,p=>{if(!p){I(new Error(`Root process ${L} not found`));return}g.getProcessCpuUsage(p,v=>{const u=new Map;v.forEach(d=>{const f=l(d.commandLine||"");u.set(d.pid,{name:S(f),cmd:f,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),m=u.get(L),m?(u.forEach(d=>{const f=u.get(d.ppid);f&&(f.children||(f.children=[]),f.children.push(d))}),u.forEach(d=>{d.children&&(d.children=d.children.sort((f,c)=>f.pid-c.pid))}),D(m)):I(new Error(`Root process ${L} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let l=function(){let g=[m];const p=[];for(;g.length;){const u=g.shift();u&&(p.push(u.pid),u.children&&(g=g.concat(u.children)))}let v=JSON.stringify(O.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);v+=" "+p.join(" "),(0,k.exec)(v,{},(u,d,f)=>{if(u||f)I(u||new Error(f.toString()));else{const c=d.toString().split(`
`);for(let w=0;w<p.length;w++){const i=P.get(p[w]);i.load=parseFloat(c[w])}if(!m){I(new Error(`Root process ${L} not found`));return}D(m)}})};(0,k.exec)("which ps",{},(g,p,v)=>{if(g||v)if(process.platform!=="linux")I(g||new Error(v.toString()));else{const u=JSON.stringify(O.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,k.exec)(u,{},(d,f,c)=>{d||c?I(d||new Error(c.toString())):(A(f,b),l())})}else{const u=p.toString().trim(),d="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${u} ${d}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,c,w)=>{f||w&&!w.includes("screen size is bogus")?I(f||new Error(w.toString())):(A(c,b),process.platform==="linux"?l():m?D(m):I(new Error(`Root process ${L} not found`)))})}})}})}e.listProcesses=T;function A(L,D){const I=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=L.toString().split(`
`);for(const P of m){const b=I.exec(P.trim());b&&b.length===6&&D(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}});var ye=this&&this.__decorate||function(se,e,k,O){var T=arguments.length,A=T<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,k):O,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(se,e,k,O);else for(var D=se.length-1;D>=0;D--)(L=se[D])&&(A=(T<3?L(A):T>3?L(e,k,A):L(e,k))||A);return T>3&&A&&Object.defineProperty(e,k,A),A};define(le[40],ue([0,1,17,6,14,26,85,7,3,2,66,27,12]),function(se,e,k,O,T,A,L,D,I,m,P,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var l;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(l||(l={}));function g(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(p||(p={}));function v(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(u||(u={}));function d(V){let q=0;for(let ie=0;;ie+=7){const re=V.read(1);if(q|=(re.buffer[0]&127)<<ie,!(re.buffer[0]&128))return q}}const f=n(0);function c(V,q){if(q===0){V.write(f);return}let ie=0;for(let ee=q;ee!==0;ee=ee>>>7)ie++;const re=T.VSBuffer.alloc(ie);for(let ee=0;q!==0;ee++)re.buffer[ee]=q&127,q=q>>>7,q>0&&(re.buffer[ee]|=128);V.write(re)}class w{constructor(q){this.buffer=q,this.pos=0}read(q){const ie=this.buffer.slice(this.pos,this.pos+q);return this.pos+=ie.byteLength,ie}}e.BufferReader=w;class i{constructor(){this.buffers=[]}get buffer(){return T.VSBuffer.concat(this.buffers)}write(q){this.buffers.push(q)}}e.BufferWriter=i;var o;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(o||(o={}));function n(V){const q=T.VSBuffer.alloc(1);return q.writeUInt8(V,0),q}const s={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},t=typeof Buffer<"u";function r(V,q){if(typeof q>"u")V.write(s.Undefined);else if(typeof q=="string"){const ie=T.VSBuffer.fromString(q);V.write(s.String),c(V,ie.byteLength),V.write(ie)}else if(t&&Buffer.isBuffer(q)){const ie=T.VSBuffer.wrap(q);V.write(s.Buffer),c(V,ie.byteLength),V.write(ie)}else if(q instanceof T.VSBuffer)V.write(s.VSBuffer),c(V,q.byteLength),V.write(q);else if(Array.isArray(q)){V.write(s.Array),c(V,q.length);for(const ie of q)r(V,ie)}else if(typeof q=="number"&&(q|0)===q)V.write(s.Uint),c(V,q);else{const ie=T.VSBuffer.fromString(JSON.stringify(q));V.write(s.Object),c(V,ie.byteLength),V.write(ie)}}e.serialize=r;function a(V){switch(V.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return V.read(d(V)).toString();case o.Buffer:return V.read(d(V)).buffer;case o.VSBuffer:return V.read(d(V));case o.Array:{const ie=d(V),re=[];for(let ee=0;ee<ie;ee++)re.push(a(V));return re}case o.Object:return JSON.parse(V.read(d(V)).toString());case o.Int:return d(V)}}e.deserialize=a;class C{constructor(q,ie,re=null,ee=1e3){this.protocol=q,this.ctx=ie,this.logger=re,this.timeoutDelay=ee,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ae=>this.onRawMessage(ae)),this.sendResponse({type:200})}registerChannel(q,ie){this.channels.set(q,ie),setTimeout(()=>this.flushPendingRequests(q),0)}sendResponse(q){switch(q.type){case 200:{const ie=this.send([q.type]);this.logger?.logOutgoing(ie,0,1,v(q.type));return}case 201:case 202:case 204:case 203:{const ie=this.send([q.type,q.id],q.data);this.logger?.logOutgoing(ie,q.id,1,v(q.type),q.data);return}}}send(q,ie=void 0){const re=new i;return r(re,q),r(re,ie),this.sendBuffer(re.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onRawMessage(q){const ie=new w(q),re=a(ie),ee=a(ie),ae=re[0];switch(ae){case 100:return this.logger?.logIncoming(q.byteLength,re[1],1,`${g(ae)}: ${re[2]}.${re[3]}`,ee),this.onPromise({type:ae,id:re[1],channelName:re[2],name:re[3],arg:ee});case 102:return this.logger?.logIncoming(q.byteLength,re[1],1,`${g(ae)}: ${re[2]}.${re[3]}`,ee),this.onEventListen({type:ae,id:re[1],channelName:re[2],name:re[3],arg:ee});case 101:return this.logger?.logIncoming(q.byteLength,re[1],1,`${g(ae)}`),this.disposeActiveRequest({type:ae,id:re[1]});case 103:return this.logger?.logIncoming(q.byteLength,re[1],1,`${g(ae)}`),this.disposeActiveRequest({type:ae,id:re[1]})}}onPromise(q){const ie=this.channels.get(q.channelName);if(!ie){this.collectPendingRequest(q);return}const re=new A.CancellationTokenSource;let ee;try{ee=ie.call(this.ctx,q.name,q.arg,re.token)}catch(W){ee=Promise.reject(W)}const ae=q.id;ee.then(W=>{this.sendResponse({id:ae,data:W,type:201})},W=>{W instanceof Error?this.sendResponse({id:ae,data:{message:W.message,name:W.name,stack:W.stack?W.stack.split?W.stack.split(`
`):W.stack:void 0},type:202}):this.sendResponse({id:ae,data:W,type:203})}).finally(()=>{G.dispose(),this.activeRequests.delete(q.id)});const G=(0,m.toDisposable)(()=>re.cancel());this.activeRequests.set(q.id,G)}onEventListen(q){const ie=this.channels.get(q.channelName);if(!ie){this.collectPendingRequest(q);return}const re=q.id,ae=ie.listen(this.ctx,q.name,q.arg)(G=>this.sendResponse({id:re,data:G,type:204}));this.activeRequests.set(q.id,ae)}disposeActiveRequest(q){const ie=this.activeRequests.get(q.id);ie&&(ie.dispose(),this.activeRequests.delete(q.id))}collectPendingRequest(q){let ie=this.pendingRequests.get(q.channelName);ie||(ie=[],this.pendingRequests.set(q.channelName,ie));const re=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.sendResponse({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);ie.push({request:q,timeoutTimer:re})}flushPendingRequests(q){const ie=this.pendingRequests.get(q);if(ie){for(const re of ie)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.onPromise(re.request);break;case 102:this.onEventListen(re.request);break}this.pendingRequests.delete(q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=C;var E;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(E||(e.RequestInitiator=E={}));class h{constructor(q,ie=null){this.protocol=q,this.isDisposed=!1,this.state=u.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new I.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(re=>this.onBuffer(re)),this.logger=ie}getChannel(q){const ie=this;return{call(re,ee,ae){return ie.isDisposed?Promise.reject(new D.CancellationError):ie.requestPromise(q,re,ee,ae)},listen(re,ee){return ie.isDisposed?I.Event.None:ie.requestEvent(q,re,ee)}}}requestPromise(q,ie,re,ee=A.CancellationToken.None){const ae=this.lastRequestId++,W={id:ae,type:100,channelName:q,name:ie,arg:re};if(ee.isCancellationRequested)return Promise.reject(new D.CancellationError);let _;return new Promise((z,$)=>{if(ee.isCancellationRequested)return $(new D.CancellationError);const Z=()=>{const ne=ce=>{switch(ce.type){case 201:this.handlers.delete(ae),z(ce.data);break;case 202:{this.handlers.delete(ae);const fe=new Error(ce.data.message);fe.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,fe.name=ce.data.name,$(fe);break}case 203:this.handlers.delete(ae),$(ce.data);break}};this.handlers.set(ae,ne),this.sendRequest(W)};let B=null;this.state===u.Idle?Z():(B=(0,O.createCancelablePromise)(ne=>this.whenInitialized()),B.then(()=>{B=null,Z()}));const H=()=>{B?(B.cancel(),B=null):this.sendRequest({id:ae,type:101}),$(new D.CancellationError)},te=ee.onCancellationRequested(H);_=(0,m.combinedDisposable)((0,m.toDisposable)(H),te),this.activeRequests.add(_)}).finally(()=>{_.dispose(),this.activeRequests.delete(_)})}requestEvent(q,ie,re){const ee=this.lastRequestId++,G={id:ee,type:102,channelName:q,name:ie,arg:re};let W=null;const _=new I.Emitter({onWillAddFirstListener:()=>{W=(0,O.createCancelablePromise)(z=>this.whenInitialized()),W.then(()=>{W=null,this.activeRequests.add(_),this.sendRequest(G)})},onDidRemoveLastListener:()=>{W?(W.cancel(),W=null):(this.activeRequests.delete(_),this.sendRequest({id:ee,type:103}))}}),N=z=>_.fire(z.data);return this.handlers.set(ee,N),_.event}sendRequest(q){switch(q.type){case 100:case 102:{const ie=this.send([q.type,q.id,q.channelName,q.name],q.arg);this.logger?.logOutgoing(ie,q.id,0,`${g(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const ie=this.send([q.type,q.id]);this.logger?.logOutgoing(ie,q.id,0,g(q.type));return}}}send(q,ie=void 0){const re=new i;return r(re,q),r(re,ie),this.sendBuffer(re.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onBuffer(q){const ie=new w(q),re=a(ie),ee=a(ie),ae=re[0];switch(ae){case 200:return this.logger?.logIncoming(q.byteLength,0,0,v(ae)),this.onResponse({type:re[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(q.byteLength,re[1],0,v(ae),ee),this.onResponse({type:re[0],id:re[1],data:ee})}}onResponse(q){if(q.type===200){this.state=u.Idle,this._onDidInitialize.fire();return}this.handlers.get(q.id)?.(q)}get onDidInitializePromise(){return I.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=h,ye([L.memoize],h.prototype,"onDidInitializePromise",null);class y{get connections(){const q=[];return this._connections.forEach(ie=>q.push(ie)),q}constructor(q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new I.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new I.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new m.DisposableStore,this.disposables.add(q(({protocol:ie,onDidClientDisconnect:re})=>{const ee=I.Event.once(ie.onMessage);this.disposables.add(ee(ae=>{const G=new w(ae),W=a(G),_=new C(ie,W),N=new h(ie);this.channels.forEach(($,Z)=>_.registerChannel(Z,$));const z={channelServer:_,channelClient:N,ctx:W};this._connections.add(z),this._onDidAddConnection.fire(z),this.disposables.add(re(()=>{_.dispose(),N.dispose(),this._connections.delete(z),this._onDidRemoveConnection.fire(z)}))}))}))}getChannel(q,ie){const re=this;return{call(ee,ae,G){let W;if((0,S.isFunction)(ie)){const N=(0,k.getRandomElement)(re.connections.filter(ie));W=N?Promise.resolve(N):I.Event.toPromise(I.Event.filter(re.onDidAddConnection,ie))}else W=ie.routeCall(re,ee,ae);const _=W.then(N=>N.channelClient.getChannel(q));return U(_).call(ee,ae,G)},listen(ee,ae){if((0,S.isFunction)(ie))return re.getMulticastEvent(q,ie,ee,ae);const G=ie.routeEvent(re,ee,ae).then(W=>W.channelClient.getChannel(q));return U(G).listen(ee,ae)}}}getMulticastEvent(q,ie,re,ee){const ae=this;let G;const W=new I.Emitter({onWillAddFirstListener:()=>{G=new m.DisposableStore;const _=new I.EventMultiplexer,N=new Map,z=Z=>{const H=Z.channelClient.getChannel(q).listen(re,ee),te=_.add(H);N.set(Z,te)},$=Z=>{const B=N.get(Z);B&&(B.dispose(),N.delete(Z))};ae.connections.filter(ie).forEach(z),I.Event.filter(ae.onDidAddConnection,ie)(z,void 0,G),ae.onDidRemoveConnection($,void 0,G),_.event(W.fire,W,G),G.add(_)},onDidRemoveLastListener:()=>{G?.dispose(),G=void 0}});return W.event}registerChannel(q,ie){this.channels.set(q,ie);for(const re of this._connections)re.channelServer.registerChannel(q,ie)}dispose(){this.disposables.dispose();for(const q of this._connections)q.channelClient.dispose(),q.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=y;class R{constructor(q,ie,re=null){const ee=new i;r(ee,ie),q.send(ee.buffer),this.channelClient=new h(q,re),this.channelServer=new C(q,ie,re)}getChannel(q){return this.channelClient.getChannel(q)}registerChannel(q,ie){this.channelServer.registerChannel(q,ie)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=R;function U(V){return{call(q,ie,re){return V.then(ee=>ee.call(q,ie,re))},listen(q,ie){const re=new I.Relay;return V.then(ee=>re.input=ee.listen(q,ie)),re.event}}}e.getDelayedChannel=U;function F(V){let q=!1;return{call(ie,re,ee){return q?V.call(ie,re,ee):(0,O.timeout)(0).then(()=>q=!0).then(()=>V.call(ie,re,ee))},listen(ie,re){if(q)return V.listen(ie,re);const ee=new I.Relay;return(0,O.timeout)(0).then(()=>q=!0).then(()=>ee.input=V.listen(ie,re)),ee.event}}}e.getNextTickChannel=F;class M{constructor(q){this.fn=q}routeCall(q){return this.route(q)}routeEvent(q){return this.route(q)}async route(q){for(const ie of q.connections)if(await Promise.resolve(this.fn(ie.ctx)))return Promise.resolve(ie);return await I.Event.toPromise(q.onDidAddConnection),await this.route(q)}}e.StaticRouter=M;var j;(function(V){function q(ae,G,W){const _=ae,N=W&&W.disableMarshalling,z=new Map;for(const $ in _)re($)&&z.set($,I.Event.buffer(_[$],!0,void 0,G));return new class{listen($,Z,B){const H=z.get(Z);if(H)return H;if(ee(Z)){const te=_[Z];if(typeof te=="function")return te.call(_,B)}throw new D.ErrorNoTelemetry(`Event not found: ${Z}`)}call($,Z,B){const H=_[Z];if(typeof H=="function"){if(!N&&Array.isArray(B))for(let ne=0;ne<B.length;ne++)B[ne]=(0,P.revive)(B[ne]);let te=H.apply(_,B);return te instanceof Promise||(te=Promise.resolve(te)),te}throw new D.ErrorNoTelemetry(`Method not found: ${Z}`)}}}V.fromService=q;function ie(ae,G){const W=G&&G.disableMarshalling;return new Proxy({},{get(_,N){if(typeof N=="string")return G?.properties?.has(N)?G.properties.get(N):ee(N)?function(z){return ae.listen(N,z)}:re(N)?ae.listen(N):async function(...z){let $;G&&!(0,S.isUndefinedOrNull)(G.context)?$=[G.context,...z]:$=z;const Z=await ae.call(N,$);return W?Z:(0,P.revive)(Z)};throw new D.ErrorNoTelemetry(`Property not found: ${String(N)}`)}})}V.toService=ie;function re(ae){return ae[0]==="o"&&ae[1]==="n"&&b.isUpperAsciiLetter(ae.charCodeAt(2))}function ee(ae){return/^onDynamic/.test(ae)&&b.isUpperAsciiLetter(ae.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function K(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const q=V.toString();if(q!=="[object Object]")return q}return V}function X(V){return Array.isArray(V)?V.map(K):K(V)}function x(V,q,ie,re,ee,ae,G){G=X(G);const W=Q[ee],_=W[re%W.length];let N=[`%c[${V}]%c[${String(q).padStart(7," ")}]%c[len: ${String(ie).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${_}`];/\($/.test(ae)?(N=N.concat(G),N.push(")")):N.push(G),console.log.apply(console,N)}class J{constructor(q,ie){this._outgoingPrefix=q,this._incomingPrefix=ie,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(q,ie,re,ee,ae){this._totalOutgoing+=q,x(this._outgoingPrefix,this._totalOutgoing,q,ie,re,ee,ae)}logIncoming(q,ie,re,ee,ae){this._totalIncoming+=q,x(this._incomingPrefix,this._totalIncoming,q,ie,re,ee,ae)}}e.IPCLogger=J}),define(le[68],ue([0,1,14,3,2,40]),function(se,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var D;(function(s){s.enableDiagnostics=!1,s.records=[];const t=new WeakMap;let r=0;function a(E,h){if(!t.has(E)){const y=String(++r);t.set(E,y)}return t.get(E)}function C(E,h,y,R){if(!s.enableDiagnostics)return;const U=a(E,h);if(R instanceof k.VSBuffer||R instanceof Uint8Array||R instanceof ArrayBuffer||ArrayBuffer.isView(R)){const F=k.VSBuffer.alloc(R.byteLength);F.set(R),s.records.push({timestamp:Date.now(),id:U,label:h,type:y,buff:F})}else s.records.push({timestamp:Date.now(),id:U,label:h,type:y,data:R})}s.traceSocketEvent=C})(D||(e.SocketDiagnostics=D={}));var I;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(I||(e.SocketCloseEventType=I={}));let m=null;function P(){return m||(m=k.VSBuffer.alloc(0)),m}class b{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(t){this._chunks.push(t),this._totalLength+=t.byteLength}read(t){return this._read(t,!0)}peek(t){return this._read(t,!1)}_read(t,r){if(t===0)return P();if(t>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===t){const h=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=t),h}if(this._chunks[0].byteLength>t){const h=this._chunks[0].slice(0,t);return r&&(this._chunks[0]=this._chunks[0].slice(t),this._totalLength-=t),h}const a=k.VSBuffer.alloc(t);let C=0,E=0;for(;t>0;){const h=this._chunks[E];if(h.byteLength>t){const y=h.slice(0,t);a.set(y,C),C+=t,r&&(this._chunks[E]=h.slice(t),this._totalLength-=t),t-=t}else a.set(h,C),C+=h.byteLength,r?(this._chunks.shift(),this._totalLength-=h.byteLength):E++,t-=h.byteLength}return a}}e.ChunkStream=b;var S;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(S||(S={}));function l(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var g;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(g||(e.ProtocolConstants=g={}));class p{constructor(t,r,a,C){this.type=t,this.id=r,this.ack=a,this.data=C,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends T.Disposable{constructor(t){super(),this._onMessage=this._register(new O.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=t,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(t);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:l(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,C=this._state.id,E=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",r),this._onMessage.fire(new p(a,C,E,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class u{constructor(t){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=t,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(t){if(this._isDisposed)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=k.VSBuffer.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:l(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",t.data),this._writeSoon(r,t.data)}_bufferAdd(t,r){const a=this._totalLength===0;return this._data.push(t,r),this._totalLength+=t.byteLength+r.byteLength,a}_bufferTake(){const t=k.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,t}_writeSoon(t,r){this._bufferAdd(t,r)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const t=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this._socket.write(t)}}class d extends T.Disposable{constructor(t){super(),this._onMessage=new O.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new O.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=t,this._socketWriter=this._register(new u(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(t){this._socketWriter.write(new p(1,0,0,t))}}e.Protocol=d;class f extends A.IPCClient{static fromSocket(t,r){return new f(new d(t),r)}get onDidDispose(){return this.protocol.onDidDispose}constructor(t,r,a=null){super(t,r,a),this.protocol=t}dispose(){super.dispose();const t=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),t.end()}}e.Client=f;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new O.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(t){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(t):this._emitter.fire(t):this._bufferedMessages.push(t)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class w{constructor(t){this.data=t,this.next=null}}class i{constructor(){this._first=null,this._last=null}length(){let t=0,r=this._first;for(;r;)r=r.next,t++;return t}peek(){return this._first?this._first.data:null}toArray(){const t=[];let r=0,a=this._first;for(;a;)t[r++]=a.data,a=a.next;return t}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(t){const r=new w(t);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class o{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}constructor(){this.lastRuns=[];const t=Date.now();for(let r=0;r<o._HISTORY_LENGTH;r++)this.lastRuns[r]=t-1e3*r;setInterval(()=>{for(let r=o._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}load(){const t=Date.now(),r=(1+o._HISTORY_LENGTH)*1e3;let a=0;for(let C=0;C<o._HISTORY_LENGTH;C++)t-this.lastRuns[C]<=r&&a++;return 1-a/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class n{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(t){this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=t.loadEstimator??o.getInstance(),this._shouldSendKeepAlive=t.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new T.DisposableStore,this._socket=t.socket,this._socketWriter=this._socketDisposables.add(new u(this._socket)),this._socketReader=this._socketDisposables.add(new v(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(r=>this._receiveMessage(r))),this._socketDisposables.add(this._socket.onClose(r=>this._onSocketClose.fire(r))),t.initialChunk&&this._socketReader.acceptChunk(t.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const t=new p(5,0,0,P());this._socketWriter.write(t),this._socketWriter.flush()}sendPause(){const t=new p(7,0,0,P());this._socketWriter.write(t)}sendResume(){const t=new p(8,0,0,P());this._socketWriter.write(t)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(t,r){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new T.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=t,this._socketWriter=this._socketDisposables.add(new u(this._socket)),this._socketReader=this._socketDisposables.add(new v(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.add(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const t=new p(3,0,this._incomingAckId,P());this._socketWriter.write(t);const r=this._outgoingUnackMsg.toArray();for(let a=0,C=r.length;a<C;a++)this._socketWriter.write(r[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(t){if(t.ack>this._outgoingAckId){this._outgoingAckId=t.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=t.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this._incomingMsgId)if(t.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new p(6,0,0,P())))}else this._incomingMsgId=t.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(t.data);break}case 2:{this._onControlMessage.fire(t.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const r=this._outgoingUnackMsg.toArray();for(let a=0,C=r.length;a<C;a++)this._socketWriter.write(r[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(t){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new p(1,r,this._incomingAckId,t);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(t){const r=new p(2,0,0,t);this._socketWriter.write(r)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const t=Date.now()-this._incomingMsgLastTime;if(t>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-t+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const t=this._outgoingUnackMsg.peek(),r=Date.now()-t.writtenTime,a=Date.now()-this._socketReader.lastReadTime,C=Date.now()-this._lastSocketTimeoutTime;if(r>=2e4&&a>=2e4&&C>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const E=Math.max(2e4-r,2e4-a,2e4-C,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},E)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const t=new p(3,0,this._incomingAckId,P());this._socketWriter.write(t)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const t=new p(9,0,this._incomingAckId,P());this._socketWriter.write(t)}}e.PersistentProtocol=n}),define(le[93],ue([0,1,67,6,14,26,141,7,3,2,30,145,90,40]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class g extends l.ChannelServer{constructor(u){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:I.Event.fromNodeEventEmitter(process,"message",d=>T.VSBuffer.wrap(Buffer.from(d,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=g;class p{constructor(u,d){this.modulePath=u,this.options=d,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new I.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=d&&d.timeout?d.timeout:6e4;this.disposeDelayer=new O.Delayer(f),this.child=null,this._client=null}getChannel(u){const d=this;return{call(f,c,w){return d.requestPromise(u,f,c,w)},listen(f,c){return d.requestEvent(u,f,c)}}}requestPromise(u,d,f,c=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(D.canceled());this.disposeDelayer.cancel();const w=this.getCachedChannel(u),i=(0,O.createCancelablePromise)(s=>w.call(d,f,s)),o=c.onCancellationRequested(()=>i.cancel()),n=(0,m.toDisposable)(()=>i.cancel());return this.activeRequests.add(n),i.finally(()=>{o.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(u,d,f){if(!this.disposeDelayer)return I.Event.None;this.disposeDelayer.cancel();let c;const w=new I.Emitter({onWillAddFirstListener:()=>{c=this.getCachedChannel(u).listen(d,f)(w.fire,w),this.activeRequests.add(c)},onDidRemoveLastListener:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return w.event}get client(){if(!this._client){const u=this.options&&this.options.args?this.options.args:[],d=Object.create(null);d.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(d.env={...d.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(d.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,S.removeDangerousEnvVariables)(d.env),this.child=(0,k.fork)(this.modulePath,u,d);const f=new I.Emitter;I.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,L.isRemoteConsoleLog)(t)){(0,L.log)(t,`IPC Library: ${this.options.serverName}`);return}f.fire(T.VSBuffer.wrap(Buffer.from(t,"base64")))});const w=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,i=t=>this.child&&this.child.connected&&w.send(t.buffer.toString("base64")),o=f.event,n={send:i,onMessage:o};this._client=new l.ChannelClient(n);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,r)=>{process.removeListener("exit",s),this.activeRequests.forEach(a=>(0,m.dispose)(a)),this.activeRequests.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+r),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:r})})}return this._client}getCachedChannel(u){let d=this.channels.get(u);return d||(d=this.client.getChannel(u),this.channels.set(u,d)),d}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=p}),define(le[147],ue([0,1,134,14,40,3,12,17]),function(se,e,k,O,T,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=e.Server=void 0;class I{constructor(S){this.port=S,this.onMessage=A.Event.fromNodeEventEmitter(this.port,"message",l=>l.data?O.VSBuffer.wrap(l.data):O.VSBuffer.alloc(0)),S.start()}send(S){this.port.postMessage(S.buffer)}disconnect(){this.port.close()}}class m extends T.IPCServer{static getOnDidClientConnect(S){(0,L.assertType)((0,k.isUtilityProcess)(process),"Electron Utility Process");const l=new A.Emitter;return process.parentPort.on("message",g=>{if(S?.handledClientConnection(g))return;const p=(0,D.firstOrDefault)(g.ports);p&&l.fire(p)}),A.Event.map(l.event,g=>({protocol:new I(g),onDidClientDisconnect:A.Event.fromNodeEventEmitter(g,"close")}))}constructor(S){super(m.getOnDidClientConnect(S))}}e.Server=m;function P(b,S,l){const g=p=>{p.data===S&&(b.removeListener("message",g),l())};b.on("message",g)}e.once=P}),define(le[69],ue([0,1,6,3,2,66,12]),function(se,e,k,O,T,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",S[S.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(D||(e.StorageHint=D={}));function I(S){const l=S;return l?.changed instanceof Map||l?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var m;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(m||(e.StorageState=m={}));class P extends T.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(l,g=Object.create(null)){super(),this.database=l,this.options=g,this._onDidChangeStorage=this._register(new O.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=m.None,this.cache=new Map,this.flushDelayer=this._register(new k.ThrottledDelayer(P.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(l=>this.onDidChangeItemsExternal(l)))}onDidChangeItemsExternal(l){this._onDidChangeStorage.pause();try{l.changed?.forEach((g,p)=>this.acceptExternal(p,g)),l.deleted?.forEach(g=>this.acceptExternal(g,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(l,g){if(this.state===m.Closed)return;let p=!1;(0,L.isUndefinedOrNull)(g)?p=this.cache.delete(l):this.cache.get(l)!==g&&(this.cache.set(l,g),p=!0),p&&this._onDidChangeStorage.fire({key:l,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===m.None&&(this.state=m.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(l,g){const p=this.cache.get(l);return(0,L.isUndefinedOrNull)(p)?g:p}getBoolean(l,g){const p=this.get(l);return(0,L.isUndefinedOrNull)(p)?g:p==="true"}getNumber(l,g){const p=this.get(l);return(0,L.isUndefinedOrNull)(p)?g:parseInt(p,10)}getObject(l,g){const p=this.get(l);return(0,L.isUndefinedOrNull)(p)?g:(0,A.parse)(p)}async set(l,g,p=!1){if(this.state===m.Closed)return;if((0,L.isUndefinedOrNull)(g))return this.delete(l,p);const v=(0,L.isObject)(g)||Array.isArray(g)?(0,A.stringify)(g):String(g);if(this.cache.get(l)!==v)return this.cache.set(l,v),this.pendingInserts.set(l,v),this.pendingDeletes.delete(l),this._onDidChangeStorage.fire({key:l,external:p}),this.doFlush()}async delete(l,g=!1){if(!(this.state===m.Closed||!this.cache.delete(l)))return this.pendingDeletes.has(l)||this.pendingDeletes.add(l),this.pendingInserts.delete(l),this._onDidChangeStorage.fire({key:l,external:g}),this.doFlush()}async optimize(){if(this.state!==m.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=m.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const l={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(l).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(l){if(this.hasPending)return this.doFlush(l)}async doFlush(l){return this.options.hint===D.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),l)}async whenFlushed(){if(this.hasPending)return new Promise(l=>this.whenFlushedCallbacks.push(l))}isInMemory(){return this.options.hint===D.STORAGE_IN_MEMORY}}e.Storage=P;class b{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(l){l.insert?.forEach((g,p)=>this.items.set(p,g)),l.delete?.forEach(g=>this.items.delete(g))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=b}),define(le[148],ue([13,9]),function(se,e){return se.create("vs/base/node/zip",e)}),define(le[70],ue([0,1,54,6,16,12,31,148]),function(se,e,k,O,T,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const I=new RegExp(e.CorruptZipMessage);class m extends Error{constructor(w,i){let o=i.message;switch(w){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=w,this.cause=i}}e.ExtractError=m;function P(c){const w=c.externalFileAttributes>>16||33188;return[448,56,7].map(i=>w&i).reduce((i,o)=>i+o,w&61440)}function b(c){if(c instanceof m)return c;let w;return I.test(c.message)&&(w="CorruptZip"),new m(w,c)}function S(c,w,i,o,n,s){const t=T.dirname(w),r=T.join(o,t);if(!r.startsWith(o))return Promise.reject(new Error(D.localize(0,null,w)));const a=T.join(o,w);let C;return s.onCancellationRequested(()=>{C?.destroy()}),Promise.resolve(L.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((E,h)=>{if(!s.isCancellationRequested)try{C=(0,k.createWriteStream)(a,{mode:i}),C.once("close",()=>E()),C.once("error",h),c.once("error",h),c.pipe(C)}catch(y){h(y)}}))}function l(c,w,i,o){let n=(0,O.createCancelablePromise)(()=>Promise.resolve()),s=0;const t=o.onCancellationRequested(()=>{n.cancel(),c.close()});return new Promise((r,a)=>{const C=new O.Sequencer,E=h=>{h.isCancellationRequested||(s++,c.readEntry())};c.once("error",a),c.once("close",()=>n.then(()=>{o.isCancellationRequested||c.entryCount===s?r():a(new m("Incomplete",new Error(D.localize(1,null,s,c.entryCount))))},a)),c.readEntry(),c.on("entry",h=>{if(o.isCancellationRequested)return;if(!i.sourcePathRegex.test(h.fileName)){E(o);return}const y=h.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(y)){const F=T.join(w,y);n=(0,O.createCancelablePromise)(M=>L.Promises.mkdir(F,{recursive:!0}).then(()=>E(M)).then(void 0,a));return}const R=p(c,h),U=P(h);n=(0,O.createCancelablePromise)(F=>C.queue(()=>R.then(M=>S(M,y,U,w,i,F).then(()=>E(F)))).then(null,a))})}).finally(()=>t.dispose())}async function g(c,w=!1){const{open:i}=await new Promise((o,n)=>{se(["yauzl"],o,n)});return new Promise((o,n)=>{i(c,w?{lazyEntries:!0}:void 0,(s,t)=>{s?n(b(s)):o((0,A.assertIsDefined)(t))})})}function p(c,w){return new Promise((i,o)=>{c.openReadStream(w,(n,s)=>{n?o(b(n)):i((0,A.assertIsDefined)(s))})})}async function v(c,w){const{ZipFile:i}=await new Promise((o,n)=>{se(["yazl"],o,n)});return new Promise((o,n)=>{const s=new i;w.forEach(r=>{r.contents?s.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&s.addFile(r.localPath,r.path)}),s.end();const t=(0,k.createWriteStream)(c);s.outputStream.pipe(t),s.outputStream.once("error",n),t.once("error",n),t.once("finish",()=>o(c))})}e.zip=v;function u(c,w,i={},o){const n=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let s=g(c,!0);return i.overwrite&&(s=s.then(t=>L.Promises.rm(w).then(()=>t))),s.then(t=>l(t,w,{sourcePathRegex:n},o))}e.extract=u;function d(c,w){return g(c).then(i=>new Promise((o,n)=>{i.on("entry",s=>{s.fileName===w&&p(i,s).then(t=>o(t),t=>n(t))}),i.once("close",()=>n(new Error(D.localize(2,null,w))))}))}function f(c,w){return d(c,w).then(i=>new Promise((o,n)=>{const s=[];i.once("error",n),i.on("data",t=>s.push(t)),i.on("end",()=>o(Buffer.concat(s)))}))}e.buffer=f}),define(le[149],ue([13,9]),function(se,e){return se.create("vs/platform/configuration/common/configurationRegistry",e)}),define(le[150],ue([13,9]),function(se,e){return se.create("vs/platform/contextkey/common/contextkey",e)}),define(le[151],ue([13,9]),function(se,e){return se.create("vs/platform/contextkey/common/scanner",e)}),define(le[152],ue([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(le[153],ue([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(le[154],ue([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(le[155],ue([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(le[156],ue([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(le[157],ue([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(le[158],ue([13,9]),function(se,e){return se.create("vs/platform/extensions/common/extensionValidator",e)}),define(le[159],ue([13,9]),function(se,e){return se.create("vs/platform/files/common/fileService",e)}),define(le[160],ue([13,9]),function(se,e){return se.create("vs/platform/files/common/files",e)}),define(le[161],ue([13,9]),function(se,e){return se.create("vs/platform/files/common/io",e)}),define(le[162],ue([13,9]),function(se,e){return se.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(le[163],ue([13,9]),function(se,e){return se.create("vs/platform/languagePacks/common/languagePacks",e)}),define(le[164],ue([13,9]),function(se,e){return se.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(le[165],ue([13,9]),function(se,e){return se.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(le[166],ue([13,9]),function(se,e){return se.create("vs/platform/request/common/request",e)}),define(le[167],ue([13,9]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(le[168],ue([13,9]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryService",e)}),define(le[169],ue([13,9]),function(se,e){return se.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(le[170],ue([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(le[171],ue([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(le[172],ue([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/settingsSync",e)}),define(le[173],ue([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(le[174],ue([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSync",e)}),define(le[175],ue([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(le[176],ue([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(le[177],ue([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(le[178],ue([13,9]),function(se,e){return se.create("vs/platform/workspace/common/workspace",e)}),define(le[179],ue([0,1,7,151]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var T;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(T||(e.TokenType=T={}));function A(...m){switch(m.length){case 1:return(0,O.localize)(0,null,m[0]);case 2:return(0,O.localize)(1,null,m[0],m[1]);case 3:return(0,O.localize)(2,null,m[0],m[1],m[2]);default:return}}const L=(0,O.localize)(3,null),D=(0,O.localize)(4,null);class I{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,k.illegalState)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(P){return this._input=P,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const b=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:b})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const b=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:b})}else this._match(126)?this._addToken(9):this._error(A("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(A("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(P){return this._isAtEnd()||this._input.charCodeAt(this._current)!==P?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(P){this._tokens.push({type:P,offset:this._start})}_error(P){const b=this._start,S=this._input.substring(this._start,this._current),l={type:19,offset:this._start,lexeme:S};this._errors.push({offset:b,lexeme:S,additionalInfo:P}),this._tokens.push(l)}_string(){this.stringRe.lastIndex=this._start;const P=this.stringRe.exec(this._input);if(P){this._current=this._start+P[0].length;const b=this._input.substring(this._start,this._current),S=I._keywords.get(b);S?this._addToken(S):this._tokens.push({type:17,lexeme:b,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(L);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let P=this._current,b=!1,S=!1;for(;;){if(P>=this._input.length){this._current=P,this._error(D);return}const g=this._input.charCodeAt(P);if(b)b=!1;else if(g===47&&!S){P++;break}else g===91?S=!0:g===92?b=!0:g===93&&(S=!1);P++}for(;P<this._input.length&&I._regexFlags.has(this._input.charCodeAt(P));)P++;this._current=P;const l=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:l,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=I}),define(le[180],ue([0,1,65,85,23,16,37,20,10]),function(se,e,k,O,T,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class m{get appRoot(){return(0,A.dirname)(T.FileAccess.asFileUri("").fsPath)}get userHome(){return I.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return I.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return I.URI.file(this.paths.tmpDir)}get cacheHome(){return I.URI.file(this.userDataPath)}get stateResource(){return(0,D.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:T.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,D.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const l=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",l)}return I.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,D.joinPath)(I.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,D.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,D.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,D.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=L.env.VSCODE_PORTABLE;return l?I.URI.file((0,A.join)(l,"argv.json")):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,A.resolve)(l):(0,A.normalize)((0,A.join)(T.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const l=this.args["extensions-download-dir"];return l?I.URI.file((0,A.resolve)(l)):I.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,A.resolve)(l);const g=L.env.VSCODE_EXTENSIONS;if(g)return g;const p=L.env.VSCODE_PORTABLE;return p?(0,A.join)(p,"extensions"):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(g=>/^[^:/?#]+?:\/\//.test(g)?I.URI.parse(g):I.URI.file((0,A.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?I.URI.parse(l):I.URI.file((0,A.normalize)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(l=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(l))}get extensionLogLevel(){const l=[];for(const g of this.args.log||[]){const p=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(g);p&&p[1]&&p[2]&&l.push([p[1],p[2]])}return l.length?l:void 0}get serviceMachineIdResource(){return(0,D.joinPath)(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const l=L.env.VSCODE_PORTABLE;return l?I.URI.file((0,A.join)(l,"policy.json")):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(l){this.args.continueOn=l}get args(){return this._args}constructor(l,g,p){this._args=l,this.paths=g,this.productService=p,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=m,ye([O.memoize],m.prototype,"appRoot",null),ye([O.memoize],m.prototype,"userHome",null),ye([O.memoize],m.prototype,"userDataPath",null),ye([O.memoize],m.prototype,"appSettingsHome",null),ye([O.memoize],m.prototype,"tmpDir",null),ye([O.memoize],m.prototype,"cacheHome",null),ye([O.memoize],m.prototype,"stateResource",null),ye([O.memoize],m.prototype,"userRoamingDataHome",null),ye([O.memoize],m.prototype,"userDataSyncHome",null),ye([O.memoize],m.prototype,"sync",null),ye([O.memoize],m.prototype,"machineSettingsResource",null),ye([O.memoize],m.prototype,"workspaceStorageHome",null),ye([O.memoize],m.prototype,"localHistoryHome",null),ye([O.memoize],m.prototype,"keyboardLayoutResource",null),ye([O.memoize],m.prototype,"argvResource",null),ye([O.memoize],m.prototype,"isExtensionDevelopment",null),ye([O.memoize],m.prototype,"untitledWorkspacesHome",null),ye([O.memoize],m.prototype,"builtinExtensionsPath",null),ye([O.memoize],m.prototype,"extensionsPath",null),ye([O.memoize],m.prototype,"extensionDevelopmentLocationURI",null),ye([O.memoize],m.prototype,"extensionDevelopmentKind",null),ye([O.memoize],m.prototype,"extensionTestsLocationURI",null),ye([O.memoize],m.prototype,"debugExtensionHost",null),ye([O.memoize],m.prototype,"logLevel",null),ye([O.memoize],m.prototype,"extensionLogLevel",null),ye([O.memoize],m.prototype,"serviceMachineIdResource",null),ye([O.memoize],m.prototype,"disableTelemetry",null),ye([O.memoize],m.prototype,"disableWorkspaceTrust",null),ye([O.memoize],m.prototype,"useInMemorySecretStorage",null),ye([O.memoize],m.prototype,"policyFile",null);function P(S,l){return b(S["inspect-extensions"],S["inspect-brk-extensions"],5870,l,S.debugId,S.extensionEnvironment)}e.parseExtensionHostDebugPort=P;function b(S,l,g,p,v,u){const f=Number(l||S)||(p?null:g),c=f?!!l:!1;let w;if(u)try{w=JSON.parse(u)}catch{}return{port:f,break:c,debugId:v,env:w}}e.parseDebugParams=b}),function(){"use strict";function se(e,k,O){function T(L,D){const I=A(L,D),m=[I];return e.isAbsolute(I)||m.unshift(O),e.resolve(...m)}function A(L,D){process.env.VSCODE_DEV&&(D="code-oss-dev");const I=process.env.VSCODE_PORTABLE;if(I)return e.join(I,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,D);const P=L["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(b,"AppData","Roaming")}break;case"darwin":m=e.join(k.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,D)}return{getUserDataPath:T}}if(typeof define=="function")define(le[181],ue([269,36,37]),function(e,k,O){return se(e,k,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),k=require("os");module.exports=se(e,k,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[182],ue([0,1,36,180,181]),function(se,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class A extends O.AbstractNativeEnvironmentService{constructor(m,P){super(m,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,T.getUserDataPath)(m,P.nameShort)},P)}}e.NativeEnvironmentService=A;function L(I,m){return(0,O.parseDebugParams)(I["inspect-ptyhost"],I["inspect-brk-ptyhost"],5877,m,I.extensionEnvironment)}e.parsePtyHostDebugPort=L;function D(I,m){return(0,O.parseDebugParams)(I["inspect-sharedprocess"],I["inspect-brk-sharedprocess"],5879,m,I.extensionEnvironment)}e.parseSharedProcessDebugPort=D}),define(le[183],ue([0,1,12,154]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function T(L,D,I,m){try{A(L,D,I,m)}catch(P){L.error(P?.message??P)}return D}e.localizeManifest=T;function A(L,D,I,m){const P=(b,S,l)=>{const g=b[S];if((0,k.isString)(g)){const p=g,v=p.length;if(v>1&&p[0]==="%"&&p[v-1]==="%"){const u=p.substr(1,v-2);let d=I[u];d===void 0&&m&&(d=m[u]);const f=typeof d=="string"?d:d?.message,c=m?.[u],w=typeof c=="string"?c:c?.message;if(!f){w||L.warn(`[${D.name}]: ${(0,O.localize)(0,null,u)}`);return}if(l&&(S==="title"||S==="category")&&w&&w!==f){const i={value:f,original:w};b[S]=i}else b[S]=f}}else if((0,k.isObject)(g))for(const p in g)g.hasOwnProperty(p)&&(p==="commands"?P(g,p,!0):P(g,p,l));else if(Array.isArray(g))for(let p=0;p<g.length;p++)P(g,p,l)};for(const b in D)D.hasOwnProperty(b)&&P(D,b)}}),define(le[184],ue([0,1,70,157]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function T(A){return(0,k.buffer)(A,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}e.getManifest=T}),define(le[185],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class k{constructor(A){this.channel=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A){return this.channel.call("promptImportantExtensionsInstallNotification",[A])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=k;class O{constructor(A){this.service=A}listen(A,L){throw new Error(`Event not found: ${L}`)}call(A,L,D){switch(L){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(D[0])}throw new Error(`Call not found: ${L}`)}}e.ExtensionRecommendationNotificationServiceChannel=O}),define(le[71],ue([0,1,20,89,158,55]),function(se,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function I(u){return u=u.trim(),u==="*"||L.test(u)}e.isValidVersionStr=I;function m(u){if(!I(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=u.match(L);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=m;function P(u){if(!u)return null;const d=u.majorBase,f=u.majorMustEqual,c=u.minorBase;let w=u.minorMustEqual;const i=u.patchBase;let o=u.patchMustEqual;u.hasCaret&&(d===0||(w=!1),o=!1);let n=0;if(u.preRelease){const s=D.exec(u.preRelease);if(s){const[,t,r,a]=s;n=Date.UTC(Number(t),Number(r)-1,Number(a))}}return{majorBase:d,majorMustEqual:f,minorBase:c,minorMustEqual:w,patchBase:i,patchMustEqual:o,isMinimum:u.hasGreaterEquals,notBefore:n}}e.normalizeVersion=P;function b(u,d,f){let c;typeof u=="string"?c=P(m(u)):c=u;let w;d instanceof Date?w=d.getTime():typeof d=="string"&&(w=new Date(d).getTime());let i;if(typeof f=="string"?i=P(m(f)):i=f,!c||!i)return!1;const o=c.majorBase,n=c.minorBase,s=c.patchBase;let t=i.majorBase,r=i.minorBase,a=i.patchBase;const C=i.notBefore;let E=i.majorMustEqual,h=i.minorMustEqual,y=i.patchMustEqual;return i.isMinimum?o>t?!0:o<t?!1:n>r?!0:n<r||w&&w<C?!1:s>=a:(o===1&&t===0&&(!E||!h||!y)&&(t=1,r=0,a=0,E=!0,h=!1,y=!1),o<t?!1:o>t?!E:n<r?!1:n>r?!h:s<a?!1:s>a?!y:!(w&&w<C))}e.isValidVersion=b;function S(u,d,f,c,w){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([O.default.Error,T.localize(0,null)]),i;if(typeof c.name!="string")return i.push([O.default.Error,T.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([O.default.Error,T.localize(2,null,"version")]),i;if(!c.engines)return i.push([O.default.Error,T.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([O.default.Error,T.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!v(c.extensionDependencies))return i.push([O.default.Error,T.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!v(c.activationEvents))return i.push([O.default.Error,T.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([O.default.Error,T.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([O.default.Warning,T.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([O.default.Error,T.localize(9,null,"main")]),i;{const s=(0,k.joinPath)(f,c.main);(0,k.isEqualOrParent)(s,f)||i.push([O.default.Warning,T.localize(10,null,s.path,f.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([O.default.Error,T.localize(11,null,"browser")]),i;{const s=(0,k.joinPath)(f,c.browser);(0,k.isEqualOrParent)(s,f)||i.push([O.default.Warning,T.localize(12,null,s.path,f.path)])}}if(!A.valid(c.version))return i.push([O.default.Error,T.localize(13,null)]),i;const o=[];if(!l(u,d,c,w,o))for(const s of o)i.push([O.default.Error,s]);return i}e.validateExtensionManifest=S;function l(u,d,f,c,w){return c||typeof f.main>"u"&&typeof f.browser>"u"?!0:p(u,d,f.engines.vscode,w)}e.isValidExtensionVersion=l;function g(u,d,f){return u==="*"||p(d,f,u)}e.isEngineValid=g;function p(u,d,f,c=[]){const w=P(m(f));if(!w)return c.push(T.localize(14,null,f)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return c.push(T.localize(15,null,f)),!1}else if(!w.majorMustEqual)return c.push(T.localize(16,null,f)),!1;return b(u,d,w)?!0:(c.push(T.localize(17,null,u,f)),!1)}function v(u){if(!Array.isArray(u))return!1;for(let d=0,f=u.length;d<f;d++)if(typeof u[d]!="string")return!1;return!0}}),define(le[43],ue([0,1,14,32]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function T(A,L,D){let I=D&&D.get("storage.serviceMachineId",-1)||null;if(I)return I;try{const P=(await L.readFile(A.serviceMachineIdResource)).value.toString();I=(0,O.isUUID)(P)?P:null}catch{I=null}if(!I){I=(0,O.generateUuid)();try{await L.writeFile(A.serviceMachineIdResource,k.VSBuffer.fromString(I))}catch{}}return D?.store("storage.serviceMachineId",I,-1,1),I}e.getServiceMachineId=T}),define(le[72],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(T,A=[],L=!1){this.ctor=T,this.staticArguments=A,this.supportsDelayedInstantiation=L}}e.SyncDescriptor=k}),define(le[186],ue([0,1,72]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const O=[];var T;(function(D){D[D.Eager=0]="Eager",D[D.Delayed=1]="Delayed"})(T||(e.InstantiationType=T={}));function A(D,I,m){I instanceof k.SyncDescriptor||(I=new k.SyncDescriptor(I,[],!!m)),O.push([D,I])}e.registerSingleton=A;function L(){return O}e.getSingletonServiceDescriptors=L}),define(le[187],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(A,L){this.key=A,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.Node=k;class O{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const L of this._nodes.values())L.outgoing.size===0&&A.push(L);return A}insertEdge(A,L){const D=this.lookupOrInsertNode(A),I=this.lookupOrInsertNode(L);D.outgoing.set(I.key,I),I.incoming.set(D.key,D)}removeNode(A){const L=this._hashFn(A);this._nodes.delete(L);for(const D of this._nodes.values())D.outgoing.delete(L),D.incoming.delete(L)}lookupOrInsertNode(A){const L=this._hashFn(A);let D=this._nodes.get(L);return D||(D=new k(L,A),this._nodes.set(L,D)),D}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[L,D]of this._nodes)A.push(`${L}
	(-> incoming)[${[...D.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...D.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,L]of this._nodes){const D=new Set([A]),I=this._findCycle(L,D);if(I)return I}}_findCycle(A,L){for(const[D,I]of A.outgoing){if(L.has(D))return[...L,D].join(" -> ");L.add(D);const m=this._findCycle(I,L);if(m)return m;L.delete(D)}}}e.Graph=O}),define(le[4],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var k;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function D(I){return I[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=D})(k||(e._util=k={})),e.IInstantiationService=T("instantiationService");function O(L,D,I){D[k.DI_TARGET]===D?D[k.DI_DEPENDENCIES].push({id:L,index:I}):(D[k.DI_DEPENDENCIES]=[{id:L,index:I}],D[k.DI_TARGET]=D)}function T(L){if(k.serviceIds.has(L))return k.serviceIds.get(L);const D=function(I,m,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(D,I,P)};return D.toString=()=>L,k.serviceIds.set(L,D),D}e.createDecorator=T;function A(L){return L}e.refineServiceDecorator=A}),define(le[188],ue([0,1,4]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,k.createDecorator)("checksumService")}),define(le[21],ue([0,1,12,10,4]),function(se,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function A(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof O.URI)}e.isConfigurationOverrides=A;function L(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof O.URI)}e.isConfigurationUpdateOverrides=L;var D;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(D||(e.ConfigurationTarget=D={}));function I(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=I;function m(u){return u.applicationValue!==void 0||u.userValue!==void 0||u.userLocalValue!==void 0||u.userRemoteValue!==void 0||u.workspaceValue!==void 0||u.workspaceFolderValue!==void 0}e.isConfigured=m;function P(u,d){const f=Object.create(null);for(const c in u)b(f,c,u[c],d);return f}e.toValuesTree=P;function b(u,d,f,c){const w=d.split("."),i=w.pop();let o=u;for(let n=0;n<w.length;n++){const s=w[n];let t=o[s];switch(typeof t){case"undefined":t=o[s]=Object.create(null);break;case"object":break;default:c(`Ignoring ${d} as ${w.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}o=t}if(typeof o=="object"&&o!==null)try{o[i]=f}catch{c(`Ignoring ${d} as ${w.join(".")} is ${JSON.stringify(o)}`)}else c(`Ignoring ${d} as ${w.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=b;function S(u,d){const f=d.split(".");l(u,f)}e.removeFromValueTree=S;function l(u,d){const f=d.shift();if(d.length===0){delete u[f];return}if(Object.keys(u).indexOf(f)!==-1){const c=u[f];typeof c=="object"&&!Array.isArray(c)&&(l(c,d),Object.keys(c).length===0&&delete u[f])}}function g(u,d,f){function c(o,n){let s=o;for(const t of n){if(typeof s!="object"||s===null)return;s=s[t]}return s}const w=d.split("."),i=c(u,w);return typeof i>"u"?f:i}e.getConfigurationValue=g;function p(u,d,f){Object.keys(d).forEach(c=>{c!=="__proto__"&&(c in u?k.isObject(u[c])&&k.isObject(d[c])?p(u[c],d[c],f):f&&(u[c]=d[c]):u[c]=d[c])})}e.merge=p;function v(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=v}),define(le[94],ue([0,1,5,27,179,4,150,7]),function(se,e,k,O,T,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const I=new Map;I.set("false",!1),I.set("true",!0),I.set("isMac",k.isMacintosh),I.set("isLinux",k.isLinux),I.set("isWindows",k.isWindows),I.set("isWeb",k.isWeb),I.set("isMacNative",k.isMacintosh&&!k.isWeb),I.set("isEdge",k.isEdge),I.set("isFirefox",k.isFirefox),I.set("isChrome",k.isChrome),I.set("isSafari",k.isSafari);function m(W,_){if(I.get(W)!==void 0)throw(0,D.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");I.set(W,_)}e.setConstant=m;const P=Object.prototype.hasOwnProperty;var b;(function(W){W[W.False=0]="False",W[W.True=1]="True",W[W.Defined=2]="Defined",W[W.Not=3]="Not",W[W.Equals=4]="Equals",W[W.NotEquals=5]="NotEquals",W[W.And=6]="And",W[W.Regex=7]="Regex",W[W.NotRegex=8]="NotRegex",W[W.Or=9]="Or",W[W.In=10]="In",W[W.NotIn=11]="NotIn",W[W.Greater=12]="Greater",W[W.GreaterEquals=13]="GreaterEquals",W[W.Smaller=14]="Smaller",W[W.SmallerEquals=15]="SmallerEquals"})(b||(e.ContextKeyExprType=b={}));const S={regexParsingWithErrorRecovery:!0},l=(0,L.localize)(0,null),g=(0,L.localize)(1,null),p=(0,L.localize)(2,null),v=(0,L.localize)(3,null),u=(0,L.localize)(4,null),d=(0,L.localize)(5,null),f=(0,L.localize)(6,null),c=(0,L.localize)(7,null);class w{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(_=S){this._config=_,this._scanner=new T.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(_){if(_===""){this._parsingErrors.push({message:l,offset:0,lexeme:"",additionalInfo:g});return}this._tokens=this._scanner.reset(_).scan(),this._current=0,this._parsingErrors=[];try{const N=this._expr();if(!this._isAtEnd()){const z=this._peek(),$=z.type===17?d:void 0;throw this._parsingErrors.push({message:u,offset:z.offset,lexeme:T.Scanner.getLexeme(z),additionalInfo:$}),w._parseError}return N}catch(N){if(N!==w._parseError)throw N;return}}_expr(){return this._or()}_or(){const _=[this._and()];for(;this._matchOne(16);){const N=this._and();_.push(N)}return _.length===1?_[0]:i.or(..._)}_and(){const _=[this._term()];for(;this._matchOne(15);){const N=this._term();_.push(N)}return _.length===1?_[0]:i.and(..._)}_term(){if(this._matchOne(2)){const _=this._peek();switch(_.type){case 11:return this._advance(),t.INSTANCE;case 12:return this._advance(),r.INSTANCE;case 0:{this._advance();const N=this._expr();return this._consume(1,v),N?.negate()}case 17:return this._advance(),R.create(_.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",_)}}return this._primary()}_primary(){const _=this._peek();switch(_.type){case 11:return this._advance(),i.true();case 12:return this._advance(),i.false();case 0:{this._advance();const N=this._expr();return this._consume(1,v),N}case 17:{const N=_.lexeme;if(this._advance(),this._matchOne(9)){const $=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),$.type!==10)throw this._errExpectedButGot("REGEX",$);const Z=$.lexeme,B=Z.lastIndexOf("/"),H=B===Z.length-1?void 0:this._removeFlagsGY(Z.substring(B+1));let te;try{te=new RegExp(Z.substring(1,B),H)}catch{throw this._errExpectedButGot("REGEX",$)}return K.create(N,te)}switch($.type){case 10:case 19:{const Z=[$.lexeme];this._advance();let B=this._peek(),H=0;for(let ge=0;ge<$.lexeme.length;ge++)$.lexeme.charCodeAt(ge)===40?H++:$.lexeme.charCodeAt(ge)===41&&H--;for(;!this._isAtEnd()&&B.type!==15&&B.type!==16;){switch(B.type){case 0:H++;break;case 1:H--;break;case 10:case 18:for(let ge=0;ge<B.lexeme.length;ge++)B.lexeme.charCodeAt(ge)===40?H++:$.lexeme.charCodeAt(ge)===41&&H--}if(H<0)break;Z.push(T.Scanner.getLexeme(B)),this._advance(),B=this._peek()}const te=Z.join(""),ne=te.lastIndexOf("/"),ce=ne===te.length-1?void 0:this._removeFlagsGY(te.substring(ne+1));let fe;try{fe=new RegExp(te.substring(1,ne),ce)}catch{throw this._errExpectedButGot("REGEX",$)}return i.regex(N,fe)}case 18:{const Z=$.lexeme;this._advance();let B=null;if(!(0,O.isFalsyOrWhitespace)(Z)){const H=Z.indexOf("/"),te=Z.lastIndexOf("/");if(H!==te&&H>=0){const ne=Z.slice(H+1,te),ce=Z[te+1]==="i"?"i":"";try{B=new RegExp(ne,ce)}catch{throw this._errExpectedButGot("REGEX",$)}}}if(B===null)throw this._errExpectedButGot("REGEX",$);return K.create(N,B)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,p);const $=this._value();return i.notIn(N,$)}switch(this._peek().type){case 3:{this._advance();const $=this._value();if(this._previous().type===18)return i.equals(N,$);switch($){case"true":return i.has(N);case"false":return i.not(N);default:return i.equals(N,$)}}case 4:{this._advance();const $=this._value();if(this._previous().type===18)return i.notEquals(N,$);switch($){case"true":return i.not(N);case"false":return i.has(N);default:return i.notEquals(N,$)}}case 5:return this._advance(),j.create(N,this._value());case 6:return this._advance(),Q.create(N,this._value());case 7:return this._advance(),F.create(N,this._value());case 8:return this._advance(),M.create(N,this._value());case 13:return this._advance(),i.in(N,this._value());default:return i.has(N)}}case 20:throw this._parsingErrors.push({message:f,offset:_.offset,lexeme:"",additionalInfo:c}),w._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const _=this._peek();switch(_.type){case 17:case 18:return this._advance(),_.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(_){return _.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(_){return this._check(_)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(_,N){if(this._check(_))return this._advance();throw this._errExpectedButGot(N,this._peek())}_errExpectedButGot(_,N,z){const $=(0,L.localize)(8,null,_,T.Scanner.getLexeme(N)),Z=N.offset,B=T.Scanner.getLexeme(N);return this._parsingErrors.push({message:$,offset:Z,lexeme:B,additionalInfo:z}),w._parseError}_check(_){return this._peek().type===_}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=w;class i{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(_){return a.create(_)}static equals(_,N){return C.create(_,N)}static notEquals(_,N){return y.create(_,N)}static regex(_,N){return K.create(_,N)}static in(_,N){return E.create(_,N)}static notIn(_,N){return h.create(_,N)}static not(_){return R.create(_)}static and(..._){return J.create(_,null,!0)}static or(..._){return V.create(_,null,!0)}static greater(_,N){return F.create(_,N)}static greaterEquals(_,N){return M.create(_,N)}static smaller(_,N){return j.create(_,N)}static smallerEquals(_,N){return Q.create(_,N)}static{this._parser=new w({regexParsingWithErrorRecovery:!1})}static deserialize(_){return _==null?void 0:this._parser.parse(_)}}e.ContextKeyExpr=i;function o(W){const _=new w({regexParsingWithErrorRecovery:!1});return W.map(N=>(_.parse(N),_.lexingErrors.length>0?_.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,L.localize)(9,null,z.additionalInfo):(0,L.localize)(10,null),offset:z.offset,length:z.lexeme.length})):_.parsingErrors.length>0?_.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.validateWhenClauses=o;function n(W,_){const N=W?W.substituteConstants():void 0,z=_?_.substituteConstants():void 0;return!N&&!z?!0:!N||!z?!1:N.equals(z)}e.expressionsAreEqualWithConstantSubstitution=n;function s(W,_){return W.cmp(_)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!1}serialize(){return"false"}keys(){return[]}map(_){return this}negate(){return r.INSTANCE}}e.ContextKeyFalseExpr=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!0}serialize(){return"true"}keys(){return[]}map(_){return this}negate(){return t.INSTANCE}}e.ContextKeyTrueExpr=r;class a{static create(_,N=null){const z=I.get(_);return typeof z=="boolean"?z?r.INSTANCE:t.INSTANCE:new a(_,N)}constructor(_,N){this.key=_,this.negated=N,this.type=2}cmp(_){return _.type!==this.type?this.type-_.type:ie(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=I.get(this.key);return typeof _=="boolean"?_?r.INSTANCE:t.INSTANCE:this}evaluate(_){return!!_.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(_){return _.mapDefined(this.key)}negate(){return this.negated||(this.negated=R.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=a;class C{static create(_,N,z=null){if(typeof N=="boolean")return N?a.create(_,z):R.create(_,z);const $=I.get(_);return typeof $=="boolean"?N===($?"true":"false")?r.INSTANCE:t.INSTANCE:new C(_,N,z)}constructor(_,N,z){this.key=_,this.value=N,this.negated=z,this.type=4}cmp(_){return _.type!==this.type?this.type-_.type:re(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=I.get(this.key);if(typeof _=="boolean"){const N=_?"true":"false";return this.value===N?r.INSTANCE:t.INSTANCE}return this}evaluate(_){return _.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(_){return _.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=C;class E{static create(_,N){return new E(_,N)}constructor(_,N){this.key=_,this.valueKey=N,this.type=10,this.negated=null}cmp(_){return _.type!==this.type?this.type-_.type:re(this.key,this.valueKey,_.key,_.valueKey)}equals(_){return _.type===this.type?this.key===_.key&&this.valueKey===_.valueKey:!1}substituteConstants(){return this}evaluate(_){const N=_.getValue(this.valueKey),z=_.getValue(this.key);return Array.isArray(N)?N.includes(z):typeof z=="string"&&typeof N=="object"&&N!==null?P.call(N,z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(_){return _.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=h.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=E;class h{static create(_,N){return new h(_,N)}constructor(_,N){this.key=_,this.valueKey=N,this.type=11,this._negated=E.create(_,N)}cmp(_){return _.type!==this.type?this.type-_.type:this._negated.cmp(_._negated)}equals(_){return _.type===this.type?this._negated.equals(_._negated):!1}substituteConstants(){return this}evaluate(_){return!this._negated.evaluate(_)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(_){return _.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=h;class y{static create(_,N,z=null){if(typeof N=="boolean")return N?R.create(_,z):a.create(_,z);const $=I.get(_);return typeof $=="boolean"?N===($?"true":"false")?t.INSTANCE:r.INSTANCE:new y(_,N,z)}constructor(_,N,z){this.key=_,this.value=N,this.negated=z,this.type=5}cmp(_){return _.type!==this.type?this.type-_.type:re(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=I.get(this.key);if(typeof _=="boolean"){const N=_?"true":"false";return this.value===N?t.INSTANCE:r.INSTANCE}return this}evaluate(_){return _.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(_){return _.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=y;class R{static create(_,N=null){const z=I.get(_);return typeof z=="boolean"?z?t.INSTANCE:r.INSTANCE:new R(_,N)}constructor(_,N){this.key=_,this.negated=N,this.type=3}cmp(_){return _.type!==this.type?this.type-_.type:ie(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=I.get(this.key);return typeof _=="boolean"?_?t.INSTANCE:r.INSTANCE:this}evaluate(_){return!_.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(_){return _.mapNot(this.key)}negate(){return this.negated||(this.negated=a.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=R;function U(W,_){if(typeof W=="string"){const N=parseFloat(W);isNaN(N)||(W=N)}return typeof W=="string"||typeof W=="number"?_(W):t.INSTANCE}class F{static create(_,N,z=null){return U(N,$=>new F(_,$,z))}constructor(_,N,z){this.key=_,this.value=N,this.negated=z,this.type=12}cmp(_){return _.type!==this.type?this.type-_.type:re(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=Q.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=F;class M{static create(_,N,z=null){return U(N,$=>new M(_,$,z))}constructor(_,N,z){this.key=_,this.value=N,this.negated=z,this.type=13}cmp(_){return _.type!==this.type?this.type-_.type:re(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=j.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=M;class j{static create(_,N,z=null){return U(N,$=>new j(_,$,z))}constructor(_,N,z){this.key=_,this.value=N,this.negated=z,this.type=14}cmp(_){return _.type!==this.type?this.type-_.type:re(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=j;class Q{static create(_,N,z=null){return U(N,$=>new Q(_,$,z))}constructor(_,N,z){this.key=_,this.value=N,this.negated=z,this.type=15}cmp(_){return _.type!==this.type?this.type-_.type:re(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=Q;class K{static create(_,N){return new K(_,N)}constructor(_,N){this.key=_,this.regexp=N,this.type=7,this.negated=null}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.key<_.key)return-1;if(this.key>_.key)return 1;const N=this.regexp?this.regexp.source:"",z=_.regexp?_.regexp.source:"";return N<z?-1:N>z?1:0}equals(_){if(_.type===this.type){const N=this.regexp?this.regexp.source:"",z=_.regexp?_.regexp.source:"";return this.key===_.key&&N===z}return!1}substituteConstants(){return this}evaluate(_){const N=_.getValue(this.key);return this.regexp?this.regexp.test(N):!1}serialize(){const _=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${_}`}keys(){return[this.key]}map(_){return _.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=X.create(this)),this.negated}}e.ContextKeyRegexExpr=K;class X{static create(_){return new X(_)}constructor(_){this._actual=_,this.type=8}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}substituteConstants(){return this}evaluate(_){return!this._actual.evaluate(_)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(_){return new X(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=X;function x(W){let _=null;for(let N=0,z=W.length;N<z;N++){const $=W[N].substituteConstants();if(W[N]!==$&&_===null){_=[];for(let Z=0;Z<N;Z++)_[Z]=W[Z]}_!==null&&(_[N]=$)}return _===null?W:_}class J{static create(_,N,z){return J._normalizeArr(_,N,z)}constructor(_,N){this.expr=_,this.negated=N,this.type=6}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let N=0,z=this.expr.length;N<z;N++){const $=s(this.expr[N],_.expr[N]);if($!==0)return $}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let N=0,z=this.expr.length;N<z;N++)if(!this.expr[N].equals(_.expr[N]))return!1;return!0}return!1}substituteConstants(){const _=x(this.expr);return _===this.expr?this:J.create(_,this.negated,!1)}evaluate(_){for(let N=0,z=this.expr.length;N<z;N++)if(!this.expr[N].evaluate(_))return!1;return!0}static _normalizeArr(_,N,z){const $=[];let Z=!1;for(const B of _)if(B){if(B.type===1){Z=!0;continue}if(B.type===0)return t.INSTANCE;if(B.type===6){$.push(...B.expr);continue}$.push(B)}if($.length===0&&Z)return r.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(s);for(let B=1;B<$.length;B++)$[B-1].equals($[B])&&($.splice(B,1),B--);if($.length===1)return $[0];for(;$.length>1;){const B=$[$.length-1];if(B.type!==9)break;$.pop();const H=$.pop(),te=$.length===0,ne=V.create(B.expr.map(ce=>J.create([ce,H],null,z)),null,te);ne&&($.push(ne),$.sort(s))}if($.length===1)return $[0];if(z){for(let B=0;B<$.length;B++)for(let H=B+1;H<$.length;H++)if($[B].negate().equals($[H]))return t.INSTANCE;if($.length===1)return $[0]}return new J($,N)}}serialize(){return this.expr.map(_=>_.serialize()).join(" && ")}keys(){const _=[];for(const N of this.expr)_.push(...N.keys());return _}map(_){return new J(this.expr.map(N=>N.map(_)),null)}negate(){if(!this.negated){const _=[];for(const N of this.expr)_.push(N.negate());this.negated=V.create(_,this,!0)}return this.negated}}e.ContextKeyAndExpr=J;class V{static create(_,N,z){return V._normalizeArr(_,N,z)}constructor(_,N){this.expr=_,this.negated=N,this.type=9}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let N=0,z=this.expr.length;N<z;N++){const $=s(this.expr[N],_.expr[N]);if($!==0)return $}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let N=0,z=this.expr.length;N<z;N++)if(!this.expr[N].equals(_.expr[N]))return!1;return!0}return!1}substituteConstants(){const _=x(this.expr);return _===this.expr?this:V.create(_,this.negated,!1)}evaluate(_){for(let N=0,z=this.expr.length;N<z;N++)if(this.expr[N].evaluate(_))return!0;return!1}static _normalizeArr(_,N,z){let $=[],Z=!1;if(_){for(let B=0,H=_.length;B<H;B++){const te=_[B];if(te){if(te.type===0){Z=!0;continue}if(te.type===1)return r.INSTANCE;if(te.type===9){$=$.concat(te.expr);continue}$.push(te)}}if($.length===0&&Z)return t.INSTANCE;$.sort(s)}if($.length!==0){if($.length===1)return $[0];for(let B=1;B<$.length;B++)$[B-1].equals($[B])&&($.splice(B,1),B--);if($.length===1)return $[0];if(z){for(let B=0;B<$.length;B++)for(let H=B+1;H<$.length;H++)if($[B].negate().equals($[H]))return r.INSTANCE;if($.length===1)return $[0]}return new V($,N)}}serialize(){return this.expr.map(_=>_.serialize()).join(" || ")}keys(){const _=[];for(const N of this.expr)_.push(...N.keys());return _}map(_){return new V(this.expr.map(N=>N.map(_)),null)}negate(){if(!this.negated){const _=[];for(const N of this.expr)_.push(N.negate());for(;_.length>1;){const N=_.shift(),z=_.shift(),$=[];for(const Z of G(N))for(const B of G(z))$.push(J.create([Z,B],null,!1));_.unshift(V.create($,null,!1))}this.negated=V.create(_,this,!0)}return this.negated}}e.ContextKeyOrExpr=V;class q extends a{static{this._info=[]}static all(){return q._info.values()}constructor(_,N,z){super(_,null),this._defaultValue=N,typeof z=="object"?q._info.push({...z,key:_}):z!==!0&&q._info.push({key:_,description:z,type:N!=null?typeof N:void 0})}bindTo(_){return _.createKey(this.key,this._defaultValue)}getValue(_){return _.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(_){return C.create(this.key,_)}notEqualsTo(_){return y.create(this.key,_)}}e.RawContextKey=q,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function ie(W,_){return W<_?-1:W>_?1:0}function re(W,_,N,z){return W<N?-1:W>N?1:_<z?-1:_>z?1:0}function ee(W,_){if(W.type===0||_.type===1)return!0;if(W.type===9)return _.type===9?ae(W.expr,_.expr):!1;if(_.type===9){for(const N of _.expr)if(ee(W,N))return!0;return!1}if(W.type===6){if(_.type===6)return ae(_.expr,W.expr);for(const N of W.expr)if(ee(N,_))return!0;return!1}return W.equals(_)}e.implies=ee;function ae(W,_){let N=0,z=0;for(;N<W.length&&z<_.length;){const $=W[N].cmp(_[z]);if($<0)return!1;$===0&&N++,z++}return N===W.length}function G(W){return W.type===9?W.expr:[W]}}),define(le[95],ue([0,1,4]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,k.createDecorator)(e.ID);function O(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=O;class T{async getPerformanceInfo(L,D){return{}}async getSystemInfo(L,D){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(L,D){return""}async getWorkspaceFileExtensions(L){return{extensions:[]}}async reportWorkspaceStats(L){}}e.NullDiagnosticsService=T}),define(le[96],ue([0,1,4]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(le[15],ue([0,1,4]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(le[29],ue([0,1,153,4]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function T(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=T;function A(f){switch(f){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function L(f,c){switch(f){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":c==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=L;function D(f,c){return c==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=D;function I(f,c,w){return D(c,w)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===w}e.isTargetPlatformCompatible=I;function m(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=m;var P;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var b;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var S;(function(f){f.Install="install",f.Uninstall="uninstall"})(S||(e.StatisticType=S={}));var l;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(l||(e.InstallOperation=l={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var g;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.DownloadSignature="DownloadSignature",f.UpdateMetadata="UpdateMetadata",f.Extract="Extract",f.Scanning="Scanning",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Signature="Signature",f.NotAllowed="NotAllowed",f.Gallery="Gallery",f.Unknown="Unknown",f.Internal="Internal"})(g||(e.ExtensionManagementErrorCode=g={}));var p;(function(f){f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(p||(e.ExtensionSignaturetErrorCode=p={}));class v extends Error{constructor(c,w){super(c),this.code=w,this.name=w}}e.ExtensionManagementError=v;var u;(function(f){f.Timeout="Timeout",f.Cancelled="Cancelled",f.Failed="Failed"})(u||(e.ExtensionGalleryErrorCode=u={}));class d extends Error{constructor(c,w){super(c),this.code=w,this.name=w}}e.ExtensionGalleryError=d,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel=(0,k.localize2)(1,"Preferences")}),define(le[189],ue([0,1,3,2,30,10,92,29]),function(se,e,k,O,T,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function I(v,u){return v?A.URI.revive(u?u.transformIncoming(v):v):void 0}function m(v,u){return u?u.transformOutgoingURI(v):v}function P(v,u){u=u||L.DefaultURITransformer;const d=v.manifest;return{...(0,L.transformAndReviveIncomingURIs)({...v,manifest:void 0},u),manifest:d}}function b(v,u){return v?.profileLocation?(0,L.transformAndReviveIncomingURIs)(v,u??L.DefaultURITransformer):v}function S(v,u){return u?(0,T.cloneAndChange)(v,d=>d instanceof A.URI?u.transformOutgoingURI(d):void 0):v}class l{constructor(u,d){this.service=u,this.getUriTransformer=d,this.onInstallExtension=k.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(u.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=k.Event.buffer(u.onDidUpdateExtensionMetadata,!0)}listen(u,d){const f=this.getUriTransformer(u);switch(d){case"onInstallExtension":return k.Event.map(this.onInstallExtension,c=>({...c,profileLocation:c.profileLocation?m(c.profileLocation,f):c.profileLocation}));case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,c=>c.map(w=>({...w,local:w.local?S(w.local,f):w.local,profileLocation:w.profileLocation?m(w.profileLocation,f):w.profileLocation})));case"onUninstallExtension":return k.Event.map(this.onUninstallExtension,c=>({...c,profileLocation:c.profileLocation?m(c.profileLocation,f):c.profileLocation}));case"onDidUninstallExtension":return k.Event.map(this.onDidUninstallExtension,c=>({...c,profileLocation:c.profileLocation?m(c.profileLocation,f):c.profileLocation}));case"onDidUpdateExtensionMetadata":return k.Event.map(this.onDidUpdateExtensionMetadata,c=>S(c,f))}throw new Error("Invalid listen")}async call(u,d,f){const c=this.getUriTransformer(u);switch(d){case"zip":{const w=P(f[0],c),i=await this.service.zip(w);return m(i,c)}case"unzip":return this.service.unzip(I(f[0],c));case"install":return this.service.install(I(f[0],c),b(f[1],c));case"installFromLocation":return this.service.installFromLocation(I(f[0],c),I(f[1],c));case"installExtensionsFromProfile":return this.service.installExtensionsFromProfile(f[0],I(f[1],c),I(f[2],c));case"getManifest":return this.service.getManifest(I(f[0],c));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(f[0]);case"installFromGallery":return this.service.installFromGallery(f[0],b(f[1],c));case"installGalleryExtensions":{const w=f[0];return this.service.installGalleryExtensions(w.map(({extension:i,options:o})=>({extension:i,options:b(o,c)??{}})))}case"uninstall":return this.service.uninstall(P(f[0],c),b(f[1],c));case"reinstallFromGallery":return this.service.reinstallFromGallery(P(f[0],c));case"getInstalled":return(await this.service.getInstalled(f[0],I(f[1],c))).map(i=>S(i,c));case"toggleAppliationScope":{const w=await this.service.toggleAppliationScope(P(f[0],c),I(f[1],c));return S(w,c)}case"copyExtensions":return this.service.copyExtensions(I(f[0],c),I(f[1],c));case"updateMetadata":{const w=await this.service.updateMetadata(P(f[0],c),f[1],I(f[2],c));return S(w,c)}case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest();case"download":return this.service.download(f[0],f[1],f[2]);case"cleanUp":return this.service.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=l;class g extends O.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(u){super(),this.channel=u,this._onInstallExtension=this._register(new k.Emitter),this._onDidInstallExtensions=this._register(new k.Emitter),this._onUninstallExtension=this._register(new k.Emitter),this._onDidUninstallExtension=this._register(new k.Emitter),this._onDidUpdateExtensionMetadata=this._register(new k.Emitter),this._register(this.channel.listen("onInstallExtension")(d=>this.fireEvent(this._onInstallExtension,{...d,source:this.isUriComponents(d.source)?A.URI.revive(d.source):d.source,profileLocation:A.URI.revive(d.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(d=>this.fireEvent(this._onDidInstallExtensions,d.map(f=>({...f,local:f.local?P(f.local,null):f.local,source:this.isUriComponents(f.source)?A.URI.revive(f.source):f.source,profileLocation:A.URI.revive(f.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(d=>this.fireEvent(this._onUninstallExtension,{...d,profileLocation:A.URI.revive(d.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(d=>this.fireEvent(this._onDidUninstallExtension,{...d,profileLocation:A.URI.revive(d.profileLocation)}))),this._register(this.channel.listen("onDidUpdateExtensionMetadata")(d=>this._onDidUpdateExtensionMetadata.fire(P(d,null))))}fireEvent(u,d){u.fire(d)}isUriComponents(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(u){const d=await this.getTargetPlatform();return u.allTargetPlatforms.some(f=>(0,D.isTargetPlatformCompatible)(f,u.allTargetPlatforms,d))}zip(u){return Promise.resolve(this.channel.call("zip",[u]).then(d=>A.URI.revive(d)))}unzip(u){return Promise.resolve(this.channel.call("unzip",[u]))}install(u,d){return Promise.resolve(this.channel.call("install",[u,d])).then(f=>P(f,null))}installFromLocation(u,d){return Promise.resolve(this.channel.call("installFromLocation",[u,d])).then(f=>P(f,null))}async installExtensionsFromProfile(u,d,f){return(await this.channel.call("installExtensionsFromProfile",[u,d,f])).map(w=>P(w,null))}getManifest(u){return Promise.resolve(this.channel.call("getManifest",[u]))}installFromGallery(u,d){return Promise.resolve(this.channel.call("installFromGallery",[u,d])).then(f=>P(f,null))}async installGalleryExtensions(u){return(await this.channel.call("installGalleryExtensions",[u])).map(f=>({...f,local:f.local?P(f.local,null):f.local,source:this.isUriComponents(f.source)?A.URI.revive(f.source):f.source,profileLocation:A.URI.revive(f.profileLocation)}))}uninstall(u,d){return Promise.resolve(this.channel.call("uninstall",[u,d]))}reinstallFromGallery(u){return Promise.resolve(this.channel.call("reinstallFromGallery",[u])).then(d=>P(d,null))}getInstalled(u=null,d){return Promise.resolve(this.channel.call("getInstalled",[u,d])).then(f=>f.map(c=>P(c,null)))}updateMetadata(u,d,f){return Promise.resolve(this.channel.call("updateMetadata",[u,d,f])).then(c=>P(c,null))}toggleAppliationScope(u,d){return this.channel.call("toggleAppliationScope",[u,d]).then(f=>P(f,null))}copyExtensions(u,d){return this.channel.call("copyExtensions",[u,d])}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}async download(u,d,f){const c=await this.channel.call("download",[u,d,f]);return A.URI.revive(c)}async cleanUp(){return this.channel.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=g;class p{constructor(u){this.service=u}listen(u,d){throw new Error("Invalid listen")}call(u,d,f){switch(d){case"getConfigBasedTips":return this.service.getConfigBasedTips(A.URI.revive(f[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=p}),define(le[97],ue([0,1,4]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var O;(function(L){L[L.FILE=1]="FILE",L[L.WORKSPACE=2]="WORKSPACE",L[L.EXE=3]="EXE"})(O||(e.RecommendationSource=O={}));function T(L){switch(L){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=T;var A;(function(L){L.Ignored="ignored",L.Cancelled="cancelled",L.TooMany="toomany",L.IncompatibleWindow="incompatibleWindow",L.Accepted="reacted"})(A||(e.RecommendationsNotificationResult=A={})),e.IExtensionRecommendationNotificationService=(0,k.createDecorator)("IExtensionRecommendationNotificationService")}),define(le[11],ue([0,1,48,16,27,12,10,160,4,5,23,52]),function(se,e,k,O,T,A,L,D,I,m,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.isFileSystemWatcher=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function S(ee){return ee.create===!0}e.isFileOpenForWriteOptions=S;var l;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(l||(e.FileType=l={}));var g;(function(ee){ee[ee.Readonly=1]="Readonly",ee[ee.Locked=2]="Locked"})(g||(e.FilePermission=g={}));function p(ee){const ae=ee;return!!ae&&typeof ae.onDidChange=="function"}e.isFileSystemWatcher=p;var v;(function(ee){ee[ee.None=0]="None",ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileAtomicWrite=32768]="FileAtomicWrite",ee[ee.FileAtomicDelete=65536]="FileAtomicDelete",ee[ee.FileClone=131072]="FileClone"})(v||(e.FileSystemProviderCapabilities=v={}));function u(ee){return!!(ee.capabilities&2)}e.hasReadWriteCapability=u;function d(ee){return!!(ee.capabilities&8)}e.hasFileFolderCopyCapability=d;function f(ee){return!!(ee.capabilities&131072)}e.hasFileCloneCapability=f;function c(ee){return!!(ee.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function w(ee){return!!(ee.capabilities&16)}e.hasFileReadStreamCapability=w;function i(ee){return u(ee)?!!(ee.capabilities&16384):!1}e.hasFileAtomicReadCapability=i;function o(ee){return u(ee)?!!(ee.capabilities&32768):!1}e.hasFileAtomicWriteCapability=o;function n(ee){return!!(ee.capabilities&65536)}e.hasFileAtomicDeleteCapability=n;function s(ee){return!!(ee.capabilities&2048)}e.hasReadonlyCapability=s;var t;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsStorageQuota="EntryExceedsStorageQuota",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(ae,G){const W=new r(ae.toString(),G);return E(W,G),W}constructor(ae,G){super(ae),this.code=G}}e.FileSystemProviderError=r;function a(ee,ae){return r.create(ee,ae)}e.createFileSystemProviderError=a;function C(ee){return ee||a((0,D.localize)(0,null),t.Unknown)}e.ensureFileSystemProviderError=C;function E(ee,ae){return ee.name=ae?`${ae} (FileSystemError)`:"FileSystemError",ee}e.markAsFileSystemProviderError=E;function h(ee){if(!ee)return t.Unknown;if(ee instanceof r)return ee.code;const ae=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!ae)return t.Unknown;switch(ae[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}e.toFileSystemProviderErrorCode=h;function y(ee){if(ee instanceof Q)return ee.fileOperationResult;switch(h(ee)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=y;var R;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(R||(e.FileOperation=R={}));class U{constructor(ae,G,W){this.resource=ae,this.operation=G,this.target=W}isOperation(ae){return this.operation===ae}}e.FileOperationEvent=U;var F;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class M{static{this.MIXED_CORRELATION=null}constructor(ae,G){this.ignorePathCasing=G,this.correlationId=void 0,this.added=new b.Lazy(()=>{const W=k.TernarySearchTree.forUris(()=>this.ignorePathCasing);return W.fill(this.rawAdded.map(_=>[_,!0])),W}),this.updated=new b.Lazy(()=>{const W=k.TernarySearchTree.forUris(()=>this.ignorePathCasing);return W.fill(this.rawUpdated.map(_=>[_,!0])),W}),this.deleted=new b.Lazy(()=>{const W=k.TernarySearchTree.forUris(()=>this.ignorePathCasing);return W.fill(this.rawDeleted.map(_=>[_,!0])),W}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const W of ae){switch(W.type){case 1:this.rawAdded.push(W.resource);break;case 0:this.rawUpdated.push(W.resource);break;case 2:this.rawDeleted.push(W.resource);break}this.correlationId!==M.MIXED_CORRELATION&&(typeof W.cId=="number"?this.correlationId===void 0?this.correlationId=W.cId:this.correlationId!==W.cId&&(this.correlationId=M.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=M.MIXED_CORRELATION))}}contains(ae,...G){return this.doContains(ae,{includeChildren:!1},...G)}affects(ae,...G){return this.doContains(ae,{includeChildren:!0},...G)}doContains(ae,G,...W){if(!ae)return!1;const _=W.length>0;return!!((!_||W.includes(1))&&(this.added.value.get(ae)||G.includeChildren&&this.added.value.findSuperstr(ae))||(!_||W.includes(0))&&(this.updated.value.get(ae)||G.includeChildren&&this.updated.value.findSuperstr(ae))||(!_||W.includes(2))&&(this.deleted.value.findSubstr(ae)||G.includeChildren&&this.deleted.value.findSuperstr(ae)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ae){return this.correlationId===ae}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=M;function j(ee,ae,G){return!ee||!ae||ee===ae||ae.length>ee.length?!1:(ae.charAt(ae.length-1)!==O.sep&&(ae+=O.sep),G?(0,T.startsWithIgnoreCase)(ee,ae):ee.indexOf(ae)===0)}e.isParent=j;class Q extends Error{constructor(ae,G,W){super(ae),this.fileOperationResult=G,this.options=W}}e.FileOperationError=Q;class K extends Q{constructor(ae,G,W,_){super(ae,G,_),this.fileOperationResult=G,this.size=W}}e.TooLargeFileOperationError=K;class X extends Q{constructor(ae,G,W){super(ae,2,W),this.stat=G}}e.NotModifiedSinceFileOperationError=X;var x;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(x||(e.FileOperationResult=x={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var J;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})(J||(e.FileKind=J={})),e.ETAG_DISABLED="";function V(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}e.etag=V;async function q(ee,ae){if(!ae.hasProvider(L.URI.from({scheme:ee.scheme})))return new Promise(G=>{const W=ae.onDidChangeFileSystemProviderRegistrations(_=>{_.scheme===ee.scheme&&_.added&&(W.dispose(),G())})})}e.whenProviderRegistered=q;class ie{static{this.KB=1024}static{this.MB=ie.KB*ie.KB}static{this.GB=ie.MB*ie.KB}static{this.TB=ie.GB*ie.KB}static formatSize(ae){return(0,A.isNumber)(ae)||(ae=0),ae<ie.KB?(0,D.localize)(1,null,ae.toFixed(0)):ae<ie.MB?(0,D.localize)(2,null,(ae/ie.KB).toFixed(2)):ae<ie.GB?(0,D.localize)(3,null,(ae/ie.MB).toFixed(2)):ae<ie.TB?(0,D.localize)(4,null,(ae/ie.GB).toFixed(2)):(0,D.localize)(5,null,(ae/ie.TB).toFixed(2))}}e.ByteSize=ie;function re(ee){const ae=typeof ee=="string"||ee?.scheme===P.Schemas.vscodeRemote;return typeof ee!="string"&&ee?.scheme===P.Schemas.file?1024*ie.MB:ae?10*ie.MB:m.isWeb?50*ie.MB:1024*ie.MB}e.getLargeFileConfirmationLimit=re});var Y=this&&this.__param||function(se,e){return function(k,O){e(k,O,se)}};define(le[190],ue([0,1,73,47,11]),function(se,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let A=class{constructor(D){this.fileService=D}async checksum(D){const I=(await this.fileService.readFileStream(D)).value;return new Promise((m,P)=>{const b=(0,k.createHash)("sha256");(0,O.listenStream)(I,{onData:S=>b.update(S.buffer),onError:S=>P(S),onEnd:()=>m(b.digest("base64").replace(/=+$/,""))})})}};e.ChecksumService=A,e.ChecksumService=A=ye([Y(0,T.IFileService)],A)}),define(le[98],ue([0,1,14,7,161,11]),function(se,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function L(P,b,S,l,g,p){let v;try{await D(P,b,S,l,g,p)}catch(u){v=u}finally{v&&g.errorTransformer&&(v=g.errorTransformer(v)),typeof v<"u"&&S.error(v),S.end()}}e.readFileIntoStream=L;async function D(P,b,S,l,g,p){I(p);const v=await P.open(b,{create:!1});try{I(p);let u=0,d=0,f=g&&typeof g.length=="number"?g.length:void 0,c=k.VSBuffer.alloc(Math.min(g.bufferSize,typeof f=="number"?f:g.bufferSize)),w=g&&typeof g.position=="number"?g.position:0,i=0;do d=await P.read(v,w,c.buffer,i,c.byteLength-i),w+=d,i+=d,u+=d,typeof f=="number"&&(f-=d),i===c.byteLength&&(await S.write(l(c)),c=k.VSBuffer.alloc(Math.min(g.bufferSize,typeof f=="number"?f:g.bufferSize)),i=0);while(d>0&&(typeof f!="number"||f>0)&&I(p)&&m(u,g));if(i>0){let o=i;typeof f=="number"&&(o=Math.min(i,f)),S.write(l(c.slice(0,o)))}}catch(u){throw(0,A.ensureFileSystemProviderError)(u)}finally{await P.close(v)}}function I(P){if(P.isCancellationRequested)throw(0,O.canceled)();return!0}function m(P,b){if(typeof b?.limits?.size=="number"&&P>b.limits.size)throw(0,A.createFileSystemProviderError)((0,T.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[50],ue([0,1,91,2,16,5,10,11]),function(se,e,k,O,T,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.reviveFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function I(u){return u.recursive===!0}e.isRecursiveWatchRequest=I;class m extends O.Disposable{static{this.MAX_RESTARTS=5}constructor(d,f,c,w){super(),this.onFileChanges=d,this.onLogMessage=f,this.verboseLogging=c,this.options=w,this.watcherDisposables=this._register(new O.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const d=new O.DisposableStore;this.watcherDisposables.value=d,this.watcher=this.createWatcher(d),this.watcher.setVerboseLogging(this.verboseLogging),d.add(this.watcher.onDidChangeFile(f=>this.onFileChanges(f))),d.add(this.watcher.onDidLogMessage(f=>this.onLogMessage(f))),d.add(this.watcher.onDidError(f=>this.onError(f)))}onError(d){this.options.restartOnError?this.restartCounter<m.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${d}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${d}`):this.error(d)}restart(d){this.restartCounter++,this.init(),this.watch(d)}async watch(d){this.requests=d,await this.watcher?.watch(d)}async setVerboseLogging(d){this.verboseLogging=d,await this.watcher?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${d}`})}trace(d){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${d}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=m;class P extends m{constructor(d,f,c){super(d,f,c,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=P;class b extends m{constructor(d,f,c){super(d,f,c,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=b;function S(u){return u.map(d=>({type:d.type,resource:L.URI.revive(d.resource),cId:d.cId}))}e.reviveFileChanges=S;function l(u){const d=new v;for(const f of u)d.processEvent(f);return d.coalesce()}e.coalesceEvents=l;function g(u,d){return typeof d=="string"&&!d.startsWith(k.GLOBSTAR)&&!(0,T.isAbsolute)(d)?{base:u,pattern:d}:d}e.normalizeWatcherPattern=g;function p(u,d){const f=[];for(const c of d)f.push((0,k.parse)(g(u,c)));return f}e.parseWatcherPatterns=p;class v{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(d){return A.isLinux?d.resource.fsPath:d.resource.fsPath.toLowerCase()}processEvent(d){const f=this.mapPathToChange.get(this.toKey(d));let c=!1;if(f){const w=f.type,i=d.type;f.resource.fsPath!==d.resource.fsPath&&(d.type===2||d.type===1)?c=!0:w===1&&i===2?(this.mapPathToChange.delete(this.toKey(d)),this.coalesced.delete(f)):w===2&&i===1?f.type=0:w===1&&i===0||(f.type=i)}else c=!0;c&&(this.coalesced.add(d),this.mapPathToChange.set(this.toKey(d),d))}coalesce(){const d=[],f=[];return Array.from(this.coalesced).filter(c=>c.type!==2?(d.push(c),!1):!0).sort((c,w)=>c.resource.fsPath.length-w.resource.fsPath.length).filter(c=>f.some(w=>(0,D.isParent)(c.resource.fsPath,w,!A.isLinux))?!1:(f.push(c.resource.fsPath),!0)).concat(d)}}}),define(le[191],ue([0,1,14,38,7,3,2,47,32,11,50]),function(se,e,k,O,T,A,L,D,I,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class b extends L.Disposable{constructor(l,g){super(),this.channel=l,this.extraCapabilities=g,this.onDidChangeCapabilities=A.Event.None,this._onDidChange=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,I.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=253982,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(l){return this.channel.call("stat",[l])}readdir(l){return this.channel.call("readdir",[l])}async readFile(l,g){const{buffer:p}=await this.channel.call("readFile",[l,g]);return p}readFileStream(l,g,p){const v=(0,D.newWriteableStream)(d=>k.VSBuffer.concat(d.map(f=>k.VSBuffer.wrap(f))).buffer),u=new L.DisposableStore;return u.add(this.channel.listen("readFileStream",[l,g])(d=>{if(d instanceof k.VSBuffer)v.write(d.buffer);else{if(d==="end")v.end();else{let f;if(d instanceof Error)f=d;else{const c=d;f=(0,m.createFileSystemProviderError)(c.message??(0,O.toErrorMessage)(c),c.code??m.FileSystemProviderErrorCode.Unknown)}v.error(f),v.end()}u.dispose()}})),u.add(p.onCancellationRequested(()=>{v.error((0,T.canceled)()),v.end(),u.dispose()})),v}writeFile(l,g,p){return this.channel.call("writeFile",[l,k.VSBuffer.wrap(g),p])}open(l,g){return this.channel.call("open",[l,g])}close(l){return this.channel.call("close",[l])}async read(l,g,p,v,u){const[d,f]=await this.channel.call("read",[l,g,u]);return p.set(d.buffer.slice(0,f),v),f}write(l,g,p,v,u){return this.channel.call("write",[l,g,k.VSBuffer.wrap(p),v,u])}mkdir(l){return this.channel.call("mkdir",[l])}delete(l,g){return this.channel.call("delete",[l,g])}rename(l,g,p){return this.channel.call("rename",[l,g,p])}copy(l,g,p){return this.channel.call("copy",[l,g,p])}cloneFile(l,g){return this.channel.call("cloneFile",[l,g])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(l=>{if(Array.isArray(l)){const g=l;this._onDidChange.fire((0,P.reviveFileChanges)(g))}else{const g=l;this._onDidWatchError.fire(g)}}))}watch(l,g){const p=(0,I.generateUuid)();return this.channel.call("watch",[this.sessionId,p,l,g]),(0,L.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,p]))}}e.DiskFileSystemProviderClient=b}),define(le[192],ue([0,1,54,6,26,49,2,88,16,5,20,10,144,31,50]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class p extends L.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(d,f,c,w){super(),this.request=d,this.onDidFilesChange=f,this.onLogMessage=c,this.verboseLogging=w,this.throttledFileChangesEmitter=this._register(new O.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.onDidFilesChange(i))),this.fileChangesAggregator=this._register(new O.RunOnceWorker(i=>this.handleFileChanges(i),p.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,g.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,g.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new T.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const d=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const f=await l.Promises.stat(d);this._register(await this.doWatch(d,f.isDirectory()))}catch(d){d.code!=="ENOENT"?this.error(d):this.trace(d)}}async normalizePath(d){let f=d.path;try{f=await l.Promises.realpath(d.path),d.path===f&&(f=await(0,S.realcase)(d.path)??d.path),d.path!==f&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${f})`)}catch{}return f}async doWatch(d,f){if(m.isMacintosh&&(0,A.isEqualOrParent)(d,"/Volumes/",!0))return this.error(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.Disposable.None;const c=new T.CancellationTokenSource(this.cts.token),w=new L.DisposableStore;try{const i=b.URI.file(this.request.path),o=(0,I.basename)(d),n=(0,k.watch)(d);w.add((0,L.toDisposable)(()=>{n.removeAllListeners(),n.close()})),this.trace(`Started watching: '${d}'`);const s=new Set;if(f)try{for(const r of await l.Promises.readdir(d))s.add(r)}catch(r){this.error(r)}const t=new Map;w.add((0,L.toDisposable)(()=>{for(const[,r]of t)r.dispose();t.clear()})),n.on("error",(r,a)=>{this.error(`Failed to watch ${d} for changes using fs.watch() (${r}, ${a})`),this.dispose()}),n.on("change",(r,a)=>{if(c.token.isCancellationRequested)return;this.trace(`[raw] ["${r}"] ${a}`);let C="";if(a&&(C=a.toString(),m.isMacintosh&&(C=(0,D.normalizeNFC)(C))),!(!C||r!=="change"&&r!=="rename"))if(f)if(r==="rename"){t.get(C)?.dispose();const E=setTimeout(async()=>{if(t.delete(C),C===o&&!await l.Promises.exists(d)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const h=await this.existsChildStrictCase((0,I.join)(d,C));if(c.token.isCancellationRequested)return;let y;h?s.has(C)?y=0:(y=1,s.add(C)):(s.delete(C),y=2),this.onFileChange({resource:(0,P.joinPath)(i,C),type:y,cId:this.request.correlationId})},p.FILE_DELETE_HANDLER_DELAY);t.set(C,(0,L.toDisposable)(()=>clearTimeout(E)))}else{let E;s.has(C)?E=0:(E=1,s.add(C)),this.onFileChange({resource:(0,P.joinPath)(i,C),type:E,cId:this.request.correlationId})}else if(r==="rename"||C!==o){const E=setTimeout(async()=>{const h=await l.Promises.exists(d);c.token.isCancellationRequested||(h?(this.onFileChange({resource:i,type:0,cId:this.request.correlationId},!0),w.add(await this.doWatch(d,!1))):(this.onFileChange({resource:i,type:2,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.dispose()))},p.FILE_DELETE_HANDLER_DELAY);w.clear(),w.add((0,L.toDisposable)(()=>clearTimeout(E)))}else this.onFileChange({resource:i,type:0,cId:this.request.correlationId},!0)})}catch(i){await l.Promises.exists(d)&&!c.token.isCancellationRequested&&this.error(`Failed to watch ${d} for changes using fs.watch() (${i.toString()})`)}return(0,L.toDisposable)(()=>{c.dispose(!0),w.dispose()})}onFileChange(d,f=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`),!f&&this.excludes.some(c=>c(d.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${d.resource.fsPath}`):!f&&this.includes&&this.includes.length>0&&!this.includes.some(c=>c(d.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (not included) ${d.resource.fsPath}`):this.fileChangesAggregator.work(d))}handleFileChanges(d){const f=(0,g.coalesceEvents)(d);if(f.length>0){if(this.verboseLogging)for(const w of f)this.trace(` >> normalized ${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.resource.fsPath}`);this.throttledFileChangesEmitter.work(f)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${f[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(d){if(m.isLinux)return l.Promises.exists(d);try{const f=(0,I.basename)(d);return(await l.Promises.readdir((0,I.dirname)(d))).some(w=>w===f)}catch(f){return this.trace(f),!1}}setVerboseLogging(d){this.verboseLogging=d}error(d){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}warn(d){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}trace(d){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=p;async function v(u,d,f,c,w=512){const i=await l.Promises.open(u,"r"),o=Buffer.allocUnsafe(w),n=new T.CancellationTokenSource(c);let s,t=!1;const r={path:u,excludes:[],recursive:!1},a=new p(r,C=>{(async()=>{for(const{type:E}of C)if(E===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:h}=await l.Promises.read(i,o,0,w,null);if(!h||n.token.isCancellationRequested)break;d(o.slice(0,h))}}catch(h){s=new Error(h),n.dispose(!0)}finally{t=!1}}})()});return await a.ready,f(),new Promise((C,E)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await l.Promises.close(i)}catch(h){s=new Error(h)}s?E(s):C()})})}e.watchFileContents=v}),define(le[193],ue([0,1,3,91,2,5,192]),function(se,e,k,O,T,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class D extends T.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new k.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=k.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(m){const P=this.normalizeRequests(m),b=P.filter(l=>{const g=this.watchers.get(l.path);return g?!(0,O.patternsEquals)(g.request.excludes,l.excludes)||!(0,O.patternsEquals)(g.request.includes,l.includes):!0}),S=Array.from(this.watchers.values()).filter(({request:l})=>!P.find(g=>g.path===l.path&&(0,O.patternsEquals)(g.excludes,l.excludes)&&(0,O.patternsEquals)(g.includes,l.includes))).map(({request:l})=>l.path);b.length&&this.trace(`Request to start watching: ${b.map(l=>`${l.path} (excludes: ${l.excludes.length>0?l.excludes:"<none>"}, includes: ${l.includes&&l.includes.length>0?JSON.stringify(l.includes):"<all>"}, correlationId: ${typeof l.correlationId=="number"?l.correlationId:"<none>"})`).join(",")}`),S.length&&this.trace(`Request to stop watching: ${S.join(",")}`);for(const l of S)this.stopWatching(l);for(const l of b)this.startWatching(l)}startWatching(m){const P=new L.NodeJSFileWatcherLibrary(m,S=>this._onDidChangeFile.fire(S),S=>this._onDidLogMessage.fire(S),this.verboseLogging),b={request:m,instance:P};this.watchers.set(m.path,b)}async stop(){for(const[m]of this.watchers)this.stopWatching(m);this.watchers.clear()}stopWatching(m){const P=this.watchers.get(m);P&&(this.watchers.delete(m),P.instance.dispose())}normalizeRequests(m){const P=new Map;for(const b of m){const S=A.isLinux?b.path:b.path.toLowerCase();let l=P.get(b.correlationId);l||(l=new Map,P.set(b.correlationId,l)),l.set(S,b)}return Array.from(P.values()).map(b=>Array.from(b.values())).flat()}async setVerboseLogging(m){this.verboseLogging=m;for(const[,P]of this.watchers)P.instance.setVerboseLogging(m)}trace(m){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(m)})}toMessage(m,P){return P?`[File Watcher (node.js)] ${m} (path: ${P.request.path})`:`[File Watcher (node.js)] ${m}`}}e.NodeJSWatcher=D}),define(le[194],ue([0,1,50,193]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class T extends k.AbstractNonRecursiveWatcherClient{constructor(L,D,I){super(L,D,I),this.init()}createWatcher(L){return L.add(new O.NodeJSWatcher)}}e.NodeJSWatcherClient=T}),define(le[195],ue([0,1,23,40,93,50]),function(se,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class L extends A.AbstractUniversalWatcherClient{constructor(I,m,P){super(I,m,P),this.init()}createWatcher(I){const m=I.add(new T.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return I.add(m.onDidProcessExit(({code:P,signal:b})=>this.onError(`terminated by itself with code ${P}, signal: ${b}`))),O.ProxyChannel.toService((0,O.getNextTickChannel)(m.getChannel("watcher")))}}e.UniversalWatcherClient=L}),define(le[74],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...T){this._entries=new Map;for(const[A,L]of T)this.set(A,L)}set(T,A){const L=this._entries.get(T);return this._entries.set(T,A),L}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=k}),define(le[196],ue([0,1,6,7,2,72,187,4,74,87]),function(se,e,k,O,T,A,L,D,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class b extends Error{constructor(v){super("cyclic dependency between services"),this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class S{constructor(v=new I.ServiceCollection,u=!1,d,f=P){this._services=v,this._strict=u,this._parent=d,this._enableTracing=f,this._activeInstantiations=new Set,this._services.set(D.IInstantiationService,this),this._globalGraph=f?d?._globalGraph??new L.Graph(c=>c):void 0}createChild(v){return new S(v,this._strict,this,this._enableTracing)}invokeFunction(v,...u){const d=g.traceInvocation(this._enableTracing,v);let f=!1;try{return v({get:w=>{if(f)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(w,d);if(!i)throw new Error(`[invokeFunction] unknown service '${w}'`);return i}},...u)}finally{f=!0,d.stop()}}createInstance(v,...u){let d,f;return v instanceof A.SyncDescriptor?(d=g.traceCreation(this._enableTracing,v.ctor),f=this._createInstance(v.ctor,v.staticArguments.concat(u),d)):(d=g.traceCreation(this._enableTracing,v),f=this._createInstance(v,u,d)),d.stop(),f}_createInstance(v,u=[],d){const f=D._util.getServiceDependencies(v).sort((i,o)=>i.index-o.index),c=[];for(const i of f){const o=this._getOrCreateServiceInstance(i.id,d);o||this._throwIfStrict(`[createInstance] ${v.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(o)}const w=f.length>0?f[0].index:u.length;if(u.length!==w){console.trace(`[createInstance] First service dependency of ${v.name} at position ${w+1} conflicts with ${u.length} static arguments`);const i=w-u.length;i>0?u=u.concat(new Array(i)):u=u.slice(0,w)}return Reflect.construct(v,u.concat(c))}_setServiceInstance(v,u){if(this._services.get(v)instanceof A.SyncDescriptor)this._services.set(v,u);else if(this._parent)this._parent._setServiceInstance(v,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(v){const u=this._services.get(v);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(v):u}_getOrCreateServiceInstance(v,u){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(v));const d=this._getServiceInstanceOrDescriptor(v);return d instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(v,d,u.branch(v,!0)):(u.branch(v,!1),d)}_safeCreateAndCacheServiceInstance(v,u,d){if(this._activeInstantiations.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this._activeInstantiations.add(v);try{return this._createAndCacheServiceInstance(v,u,d)}finally{this._activeInstantiations.delete(v)}}_createAndCacheServiceInstance(v,u,d){const f=new L.Graph(i=>i.id.toString());let c=0;const w=[{id:v,desc:u,_trace:d}];for(;w.length;){const i=w.pop();if(f.lookupOrInsertNode(i),c++>1e3)throw new b(f);for(const o of D._util.getServiceDependencies(i.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(o.id);if(n||this._throwIfStrict(`[createInstance] ${v} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),n instanceof A.SyncDescriptor){const s={id:o.id,desc:n,_trace:i._trace.branch(o.id,!0)};f.insertEdge(i,s),w.push(s)}}}for(;;){const i=f.roots();if(i.length===0){if(!f.isEmpty())throw new b(f);break}for(const{data:o}of i){if(this._getServiceInstanceOrDescriptor(o.id)instanceof A.SyncDescriptor){const s=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,s)}f.removeNode(o)}}return this._getServiceInstanceOrDescriptor(v)}_createServiceInstanceWithOwner(v,u,d=[],f,c){if(this._services.get(v)instanceof A.SyncDescriptor)return this._createServiceInstance(v,u,d,f,c);if(this._parent)return this._parent._createServiceInstanceWithOwner(v,u,d,f,c);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(v,u,d=[],f,c){if(f){const w=new S(void 0,this._strict,this,this._enableTracing);w._globalGraphImplicitDependency=String(v);const i=new Map,o=new k.GlobalIdleValue(()=>{const n=w._createInstance(u,d,c);for(const[s,t]of i){const r=n[s];if(typeof r=="function")for(const a of t)a.disposable=r.apply(n,a.listener)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!o.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let a=i.get(s);return a||(a=new m.LinkedList,i.set(s,a)),(E,h,y)=>{if(o.isInitialized)return o.value[s](E,h,y);{const R={listener:[E,h,y],disposable:void 0},U=a.push(R);return(0,T.toDisposable)(()=>{U(),R.disposable?.dispose()})}}}if(s in n)return n[s];const t=o.value;let r=t[s];return typeof r!="function"||(r=r.bind(t),n[s]=r),r},set(n,s,t){return o.value[s]=t,!0},getPrototypeOf(n){return u.prototype}})}else return this._createInstance(u,d,c)}_throwIfStrict(v,u){if(u&&console.warn(v),this._strict)throw new Error(v)}}e.InstantiationService=S;var l;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(l||(l={}));class g{static{this.all=new Set}static{this._None=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(v,u){return v?new g(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g._None}static traceCreation(v,u){return v?new g(1,u.name):g._None}static{this._totals=0}constructor(v,u){this.type=v,this.name=u,this._start=Date.now(),this._dep=[]}branch(v,u){const d=new g(3,v.toString());return this._dep.push([v,u,d]),d}stop(){const v=Date.now()-this._start;g._totals+=v;let u=!1;function d(c,w){const i=[],o=new Array(c+1).join("	");for(const[n,s,t]of w._dep)if(s&&t){u=!0,i.push(`${o}CREATES -> ${n}`);const r=d(c+1,t);r&&i.push(r)}else i.push(`${o}uses -> ${n}`);return i.join(`
`)}const f=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(v>2||u)&&g.all.add(f.join(`
`))}}e.Trace=g}),define(le[56],ue([0,1,4]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MainProcessService=e.IMainProcessService=void 0,e.IMainProcessService=(0,k.createDecorator)("mainProcessService");class O{constructor(A,L){this.server=A,this.router=L}getChannel(A){return this.server.getChannel(A,this.router)}registerChannel(A,L){this.server.registerChannel(A,L)}}e.MainProcessService=O}),define(le[75],ue([0,1,26,2,5,163,29,4]),function(se,e,k,O,T,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function I(P){return P.tags.find(b=>b.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=I,e.ILanguagePackService=(0,D.createDecorator)("languagePackService");let m=class extends O.Disposable{constructor(b){super(),this.extensionGalleryService=b}async getAvailableLanguages(){const b=new k.CancellationTokenSource;setTimeout(()=>b.cancel(),1e3);let S;try{S=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},b.token)}catch{return[]}const g=S.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(v=>v.startsWith("lp-"))).map(p=>{const v=p.properties.localizedLanguages?.[0],u=I(p);return{...this.createQuickPickItem(u,v,p),extensionId:p.identifier.id,galleryExtension:p}});return g.push(this.createQuickPickItem("en","English")),g}createQuickPickItem(b,S,l){const g=S??b;let p;if(g!==b&&(p=`(${b})`),b.toLowerCase()===T.language.toLowerCase()&&(p??="",p+=(0,A.localize)(0,null)),l?.installCount){p??="";const v=l.installCount;let u;v>1e6?u=`${Math.floor(v/1e5)/10}M`:v>1e3?u=`${Math.floor(v/1e3)}K`:u=String(v),p+=` $(cloud-download) ${u}`}return{id:b,label:g,description:p}}};e.LanguagePackBaseService=m,e.LanguagePackBaseService=m=ye([Y(0,L.IExtensionGalleryService)],m)}),define(le[197],ue([0,1,2,75]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let T=class extends k.Disposable{constructor(L){super(),this.localizationsService=L,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};e.LocalizationsUpdater=T,e.LocalizationsUpdater=T=ye([Y(0,O.ILanguagePackService)],T)}),define(le[8],ue([0,1,38,3,53,2,35,5,20,12,10,94,4]),function(se,e,k,O,T,A,L,D,I,m,P,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function l(){return new Date().toISOString()}function g(E){return(0,m.isNumber)(E)}e.isLogLevel=g;var p;(function(E){E[E.Off=0]="Off",E[E.Trace=1]="Trace",E[E.Debug=2]="Debug",E[E.Info=3]="Info",E[E.Warning=4]="Warning",E[E.Error=5]="Error"})(p||(e.LogLevel=p={})),e.DEFAULT_LOG_LEVEL=p.Info;function v(E,h,y){switch(h){case p.Trace:E.trace(y);break;case p.Debug:E.debug(y);break;case p.Info:E.info(y);break;case p.Warning:E.warn(y);break;case p.Error:E.error(y);break;case p.Off:break;default:throw new Error(`Invalid log level ${h}`)}}e.log=v;function u(E,h=!1){let y="";for(let R=0;R<E.length;R++){let U=E[R];if(U instanceof Error&&(U=(0,k.toErrorMessage)(U,h)),typeof U=="object")try{U=JSON.stringify(U)}catch{}y+=(R>0?" ":"")+U}return y}class d extends A.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(h){this.level!==h&&(this.level=h,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(h){return this.level!==p.Off&&this.level<=h}}e.AbstractLogger=d;class f extends d{constructor(h){super(),this.logAlways=h}checkLogLevel(h){return this.logAlways||super.checkLogLevel(h)}trace(h,...y){this.checkLogLevel(p.Trace)&&this.log(p.Trace,u([h,...y],!0))}debug(h,...y){this.checkLogLevel(p.Debug)&&this.log(p.Debug,u([h,...y]))}info(h,...y){this.checkLogLevel(p.Info)&&this.log(p.Info,u([h,...y]))}warn(h,...y){this.checkLogLevel(p.Warning)&&this.log(p.Warning,u([h,...y]))}error(h,...y){if(this.checkLogLevel(p.Error))if(h instanceof Error){const R=Array.prototype.slice.call(arguments);R[0]=h.stack,this.log(p.Error,u(R))}else this.log(p.Error,u([h,...y]))}flush(){}}e.AbstractMessageLogger=f;class c extends d{constructor(h=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(h),this.useColors=!D.isWindows}trace(h,...y){this.checkLogLevel(p.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,h,...y):console.log(`[main ${l()}]`,h,...y))}debug(h,...y){this.checkLogLevel(p.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,h,...y):console.log(`[main ${l()}]`,h,...y))}info(h,...y){this.checkLogLevel(p.Info)&&(this.useColors?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,h,...y):console.log(`[main ${l()}]`,h,...y))}warn(h,...y){this.checkLogLevel(p.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,h,...y):console.warn(`[main ${l()}]`,h,...y))}error(h,...y){this.checkLogLevel(p.Error)&&(this.useColors?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,h,...y):console.error(`[main ${l()}]`,h,...y))}flush(){}}e.ConsoleMainLogger=c;class w extends d{constructor(h=e.DEFAULT_LOG_LEVEL,y=!0){super(),this.useColors=y,this.setLevel(h)}trace(h,...y){this.checkLogLevel(p.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",h,...y):console.log(h,...y))}debug(h,...y){this.checkLogLevel(p.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",h,...y):console.log(h,...y))}info(h,...y){this.checkLogLevel(p.Info)&&(this.useColors?console.log("%c INFO","color: #33f",h,...y):console.log(h,...y))}warn(h,...y){this.checkLogLevel(p.Warning)&&(this.useColors?console.log("%c WARN","color: #993",h,...y):console.log(h,...y))}error(h,...y){this.checkLogLevel(p.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",h,...y):console.error(h,...y))}flush(){}}e.ConsoleLogger=w;class i extends d{constructor(h,y=e.DEFAULT_LOG_LEVEL){super(),this.adapter=h,this.setLevel(y)}trace(h,...y){this.checkLogLevel(p.Trace)&&this.adapter.log(p.Trace,[this.extractMessage(h),...y])}debug(h,...y){this.checkLogLevel(p.Debug)&&this.adapter.log(p.Debug,[this.extractMessage(h),...y])}info(h,...y){this.checkLogLevel(p.Info)&&this.adapter.log(p.Info,[this.extractMessage(h),...y])}warn(h,...y){this.checkLogLevel(p.Warning)&&this.adapter.log(p.Warning,[this.extractMessage(h),...y])}error(h,...y){this.checkLogLevel(p.Error)&&this.adapter.log(p.Error,[this.extractMessage(h),...y])}extractMessage(h){return typeof h=="string"?h:(0,k.toErrorMessage)(h,this.checkLogLevel(p.Trace))}flush(){}}e.AdapterLogger=i;class o extends d{constructor(h){super(),this.loggers=h,h.length&&this.setLevel(h[0].getLevel())}setLevel(h){for(const y of this.loggers)y.setLevel(h);super.setLevel(h)}trace(h,...y){for(const R of this.loggers)R.trace(h,...y)}debug(h,...y){for(const R of this.loggers)R.debug(h,...y)}info(h,...y){for(const R of this.loggers)R.info(h,...y)}warn(h,...y){for(const R of this.loggers)R.warn(h,...y)}error(h,...y){for(const R of this.loggers)R.error(h,...y)}flush(){for(const h of this.loggers)h.flush()}dispose(){for(const h of this.loggers)h.dispose();super.dispose()}}e.MultiplexLogger=o;class n extends A.Disposable{constructor(h,y,R){if(super(),this.logLevel=h,this.logsHome=y,this._loggers=new L.ResourceMap,this._onDidChangeLoggers=this._register(new O.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new O.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,R)for(const U of R)this._loggers.set(U.resource,{logger:void 0,info:U})}getLoggerEntry(h){return(0,m.isString)(h)?[...this._loggers.values()].find(y=>y.info.id===h):this._loggers.get(h)}getLogger(h){return this.getLoggerEntry(h)?.logger}createLogger(h,y){const R=this.toResource(h),U=(0,m.isString)(h)?h:y?.id??(0,T.hash)(R.toString()).toString(16);let F=this._loggers.get(R)?.logger;const M=y?.logLevel==="always"?p.Trace:y?.logLevel;F||(F=this.doCreateLogger(R,M??this.getLogLevel(R)??this.logLevel,{...y,id:U}));const j={logger:F,info:{resource:R,id:U,logLevel:M,name:y?.name,hidden:y?.hidden,extensionId:y?.extensionId,when:y?.when}};return this.registerLogger(j.info),this._loggers.set(R,j),F}toResource(h){return(0,m.isString)(h)?(0,I.joinPath)(this.logsHome,`${h}.log`):h}setLogLevel(h,y){if(P.URI.isUri(h)){const R=h,U=y,F=this._loggers.get(R);F&&U!==F.info.logLevel&&(F.info.logLevel=U===this.logLevel?void 0:U,F.logger?.setLevel(U),this._loggers.set(F.info.resource,F),this._onDidChangeLogLevel.fire([R,U]))}else{this.logLevel=h;for(const[R,U]of this._loggers.entries())this._loggers.get(R)?.info.logLevel===void 0&&U.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(h,y){const R=this.getLoggerEntry(h);R&&y!==!R.info.hidden&&(R.info.hidden=!y,this._loggers.set(R.info.resource,R),this._onDidChangeVisibility.fire([R.info.resource,y]))}getLogLevel(h){let y;return h&&(y=this._loggers.get(h)?.info.logLevel),y??this.logLevel}registerLogger(h){const y=this._loggers.get(h.resource);y?y.info.hidden!==h.hidden&&this.setVisibility(h.resource,!h.hidden):(this._loggers.set(h.resource,{info:h,logger:void 0}),this._onDidChangeLoggers.fire({added:[h],removed:[]}))}deregisterLogger(h){const y=this._loggers.get(h);y&&(y.logger&&y.logger.dispose(),this._loggers.delete(h),this._onDidChangeLoggers.fire({added:[],removed:[y.info]}))}*getRegisteredLoggers(){for(const h of this._loggers.values())yield h.info}getRegisteredLogger(h){return this._loggers.get(h)?.info}dispose(){this._loggers.forEach(h=>h.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=n;class s{constructor(){this.onDidChangeLogLevel=new O.Emitter().event}setLevel(h){}getLevel(){return p.Info}trace(h,...y){}debug(h,...y){}info(h,...y){}warn(h,...y){}error(h,...y){}critical(h,...y){}dispose(){}flush(){}}e.NullLogger=s;class t extends s{}e.NullLogService=t;function r(E){if(E.verbose)return p.Trace;if(typeof E.logLevel=="string"){const h=C(E.logLevel.toLowerCase());if(h!==void 0)return h}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function a(E){switch(E){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.LogLevelToString=a;function C(E){switch(E){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.parseLogLevel=C,e.CONTEXT_LOG_LEVEL=new b.RawContextKey("logLevel",a(p.Info))}),define(le[198],ue([0,1,6,7,2,23,16,20,31,15,8]),function(se,e,k,O,T,A,L,D,I,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let b=class extends T.Disposable{constructor(l,g){super(),this.environmentService=l,this.logService=g,this._register(new k.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const l=(0,D.basename)(this.environmentService.logsHome),g=(0,D.dirname)(this.environmentService.logsHome.with({scheme:A.Schemas.file})).fsPath,u=(await I.Promises.readdir(g)).filter(f=>/^\d{8}T\d{6}$/.test(f)).sort().filter(f=>f!==l),d=u.slice(0,Math.max(0,u.length-9));d.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${d.join(", ")}'`),await Promise.all(d.map(f=>I.Promises.rm((0,L.join)(g,f)))))}catch(l){(0,O.onUnexpectedError)(l)}}};e.LogsDataCleaner=b,e.LogsDataCleaner=b=ye([Y(0,m.IEnvironmentService),Y(1,P.ILogService)],b)}),define(le[99],ue([0,1,7,4,8]),function(se,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,O.createDecorator)("IExtensionSignatureVerificationService");let A=class{constructor(D){this.logService=D}vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((D,I)=>se(["node-vsce-sign"],async m=>D(m),I))),this.moduleLoadingPromise}async verify(D,I,m){let P;try{P=await this.vsceSign()}catch(b){return this.logService.error("Could not load vsce-sign module",(0,k.getErrorMessage)(b)),!1}return P.verify(D,I,m)}};e.ExtensionSignatureVerificationService=A,e.ExtensionSignatureVerificationService=A=ye([Y(0,T.ILogService)],A)}),define(le[199],ue([0,1,17,6,7,3,2,16,50,8]),function(se,e,k,O,T,A,L,D,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends L.Disposable{constructor(S,l){super(),this.logService=S,this.options=l,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new O.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new O.ThrottledDelayer(0))}watch(S,l){return l.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,l):this.watchNonRecursive(S,l)}watchUniversal(S,l){const g={path:this.toFilePath(S),excludes:l.excludes,includes:l.includes,recursive:l.recursive,correlationId:l.correlationId},p=(0,k.insert)(this.universalPathsToWatch,g);return this.refreshUniversalWatchers(),(0,L.toDisposable)(()=>{p(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,T.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(l=>this._onDidChangeFile.fire((0,I.reviveFileChanges)(l)),l=>this.onWatcherLogMessage(l),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const l of this.universalPathsToWatch)(0,I.isRecursiveWatchRequest)(l)&&(l.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const l of this.universalPathsToWatch)(0,I.isRecursiveWatchRequest)(l)&&S.includes(l.path)&&(l.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(S,l){const g={path:this.toFilePath(S),excludes:l.excludes,includes:l.includes,recursive:!1,correlationId:l.correlationId},p=(0,k.insert)(this.nonRecursivePathsToWatch,g);return this.refreshNonRecursiveWatchers(),(0,L.toDisposable)(()=>{p(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,T.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,I.reviveFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,D.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(le[200],ue([0,1,17,6,14,26,3,53,61,2,48,23,100,20,47,159,11,98,8,7]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g,p,v,u,d,f){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class extends m.Disposable{static{c=this}constructor(o){super(),this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new L.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new L.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new L.Emitter),this._onDidUncorrelatedFilesChange=this._register(new L.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new O.ResourceQueue)}registerProvider(o,n){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${o}`);const s=new m.DisposableStore;return this.provider.set(o,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:n}),s.add(n.onDidChangeFile(t=>{const r=new v.FileChangesEvent(t,!this.isPathCaseSensitive(n));this.internalOnDidFilesChange.fire(r),r.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(r)})),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),s.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:o}))),(0,m.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:n}),this.provider.delete(o),(0,m.dispose)(s)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(s){n.push(s)}}),!this.provider.has(o)&&await O.Promises.settled(n)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,n){const s=this.provider.get(o.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return I.Iterable.map(this.provider,([o,n])=>({scheme:o,capabilities:n.capabilities}))}async withProvider(o){if(!(0,l.isAbsolutePath)(o))throw new v.FileOperationError((0,p.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const n=this.provider.get(o.scheme);if(!n){const s=new f.ErrorNoTelemetry;throw s.message=(0,p.localize)(1,null,o.toString()),s}return n}async withReadProvider(o){const n=await this.withProvider(o);if((0,v.hasOpenReadWriteCloseCapability)(n)||(0,v.hasReadWriteCapability)(n)||(0,v.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const n=await this.withProvider(o);if((0,v.hasOpenReadWriteCloseCapability)(n)||(0,v.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,n){try{return await this.doResolveFile(o,n)}catch(s){throw(0,v.toFileSystemProviderErrorCode)(s)===v.FileSystemProviderErrorCode.FileNotFound?new v.FileOperationError((0,p.localize)(2,null,this.resourceForError(o)),1):(0,v.ensureFileSystemProviderError)(s)}}async doResolveFile(o,n){const s=await this.withProvider(o),t=this.isPathCaseSensitive(s),r=n?.resolveTo,a=n?.resolveSingleChildDescendants,C=n?.resolveMetadata,E=await s.stat(o);let h;return this.toFileStat(s,o,E,void 0,!!C,(y,R)=>(h||(h=P.TernarySearchTree.forUris(()=>!t),h.set(o,!0),r&&h.fill(!0,r)),h.get(y.resource)||h.findSuperstr(y.resource.with({query:null,fragment:null}))?!0:y.isDirectory&&a?R===1:!1))}async toFileStat(o,n,s,t,r,a){const{providerExtUri:C}=this.getExtUri(o),E={resource:n,name:C.basename(n),isFile:(s.type&v.FileType.File)!==0,isDirectory:(s.type&v.FileType.Directory)!==0,isSymbolicLink:(s.type&v.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&v.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((s.permissions??0)&v.FilePermission.Locked),etag:(0,v.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(E.isDirectory&&a(E,t)){try{const h=await o.readdir(n),y=await O.Promises.settled(h.map(async([R,U])=>{try{const F=C.joinPath(n,R),M=r?await o.stat(F):{type:U};return await this.toFileStat(o,F,M,h.length,r,a)}catch(F){return this.logService.trace(F),null}}));E.children=(0,k.coalesce)(y)}catch(h){this.logService.trace(h),E.children=[]}return E}return E}async resolveAll(o){return O.Promises.settled(o.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async stat(o){const n=await this.withProvider(o),s=await n.stat(o);return this.toFileStat(n,o,s,void 0,!0,()=>!1)}async exists(o){const n=await this.withProvider(o);try{return!!await n.stat(o)}catch{return!1}}async canCreateFile(o,n){try{await this.doValidateCreateFile(o,n)}catch(s){return s}return!0}async doValidateCreateFile(o,n){if(!n?.overwrite&&await this.exists(o))throw new v.FileOperationError((0,p.localize)(3,null,this.resourceForError(o)),3,n)}async createFile(o,n=T.VSBuffer.fromString(""),s){await this.doValidateCreateFile(o,s);const t=await this.writeFile(o,n);return this._onDidRunOperation.fire(new v.FileOperationEvent(o,0,t)),t}async writeFile(o,n,s){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:r}=this.getExtUri(t);let a=s;if((0,v.hasFileAtomicWriteCapability)(t)&&!a?.atomic){const C=t.enforceAtomicWriteFile?.(o);C&&(a={...s,atomic:C})}try{await this.validateWriteFile(t,o,a)||await this.mkdirp(t,r.dirname(o));let E;if((0,v.hasReadWriteCapability)(t)&&!(n instanceof T.VSBuffer))if((0,g.isReadableStream)(n)){const h=await(0,g.peekStream)(n,3);h.ended?E=T.VSBuffer.concat(h.buffer):E=h}else E=(0,g.peekReadable)(n,h=>T.VSBuffer.concat(h),3);else E=n;!(0,v.hasOpenReadWriteCloseCapability)(t)||(0,v.hasReadWriteCapability)(t)&&E instanceof T.VSBuffer||(0,v.hasReadWriteCapability)(t)&&(0,v.hasFileAtomicWriteCapability)(t)&&a?.atomic?await this.doWriteUnbuffered(t,o,a,E):await this.doWriteBuffered(t,o,a,E instanceof T.VSBuffer?(0,T.bufferToReadable)(E):E),this._onDidRunOperation.fire(new v.FileOperationEvent(o,4))}catch(C){throw new v.FileOperationError((0,p.localize)(4,null,this.resourceForError(o),(0,v.ensureFileSystemProviderError)(C).toString()),(0,v.toFileOperationResult)(C),a)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,n,s){const t=!!s?.unlock;if(t&&!(o.capabilities&8192))throw new Error((0,p.localize)(5,null,this.resourceForError(n)));if(!!s?.atomic){if(!(o.capabilities&32768))throw new Error((0,p.localize)(6,null,this.resourceForError(n)));if(!(o.capabilities&2))throw new Error((0,p.localize)(7,null,this.resourceForError(n)));if(t)throw new Error((0,p.localize)(8,null,this.resourceForError(n)))}let a;try{a=await o.stat(n)}catch{return}if(a.type&v.FileType.Directory)throw new v.FileOperationError((0,p.localize)(9,null,this.resourceForError(n)),0,s);if(this.throwIfFileIsReadonly(n,a),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==v.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&s.mtime<a.mtime&&s.etag!==(0,v.etag)({mtime:s.mtime,size:a.size}))throw new v.FileOperationError((0,p.localize)(10,null),3,s);return a}async readFile(o,n,s){const t=await this.withReadProvider(o);return n?.atomic?this.doReadFileAtomic(t,o,n,s):this.doReadFile(t,o,n,s)}async doReadFileAtomic(o,n,s,t){return new Promise((r,a)=>{this.writeQueue.queueFor(n,async()=>{try{const C=await this.doReadFile(o,n,s,t);r(C)}catch(C){a(C)}},this.getExtUri(o).providerExtUri)})}async doReadFile(o,n,s,t){const r=await this.doReadFileStream(o,n,{...s,preferUnbuffered:!0},t);return{...r,value:await(0,T.streamToBuffer)(r.value)}}async readFileStream(o,n,s){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,n,s)}async doReadFileStream(o,n,s,t){const r=new A.CancellationTokenSource(t);let a=s;(0,v.hasFileAtomicReadCapability)(o)&&o.enforceAtomicReadFile?.(n)&&(a={...s,atomic:!0});const C=this.validateReadFile(n,a).then(h=>h,h=>{throw r.dispose(!0),h});let E;try{return typeof a?.etag=="string"&&a.etag!==v.ETAG_DISABLED&&await C,a?.atomic&&(0,v.hasFileAtomicReadCapability)(o)||!((0,v.hasOpenReadWriteCloseCapability)(o)||(0,v.hasFileReadStreamCapability)(o))||(0,v.hasReadWriteCapability)(o)&&a?.preferUnbuffered?E=this.readFileUnbuffered(o,n,a):(0,v.hasFileReadStreamCapability)(o)?E=this.readFileStreamed(o,n,r.token,a):E=this.readFileBuffered(o,n,r.token,a),E.on("end",()=>r.dispose()),E.on("error",()=>r.dispose()),{...await C,value:E}}catch(h){throw E&&await(0,g.consumeStream)(E),this.restoreReadError(h,n,a)}}restoreReadError(o,n,s){const t=(0,p.localize)(11,null,this.resourceForError(n),(0,v.ensureFileSystemProviderError)(o).toString());return o instanceof v.NotModifiedSinceFileOperationError?new v.NotModifiedSinceFileOperationError(t,o.stat,s):o instanceof v.TooLargeFileOperationError?new v.TooLargeFileOperationError(t,o.fileOperationResult,o.size,o.options):new v.FileOperationError(t,(0,v.toFileOperationResult)(o),s)}readFileStreamed(o,n,s,t=Object.create(null)){const r=o.readFileStream(n,t,s);return(0,g.transform)(r,{data:a=>a instanceof T.VSBuffer?a:T.VSBuffer.wrap(a),error:a=>this.restoreReadError(a,n,t)},a=>T.VSBuffer.concat(a))}readFileBuffered(o,n,s,t=Object.create(null)){const r=(0,T.newWriteableBufferStream)();return(0,u.readFileIntoStream)(o,n,r,a=>a,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:a=>this.restoreReadError(a,n,t)},s),r}readFileUnbuffered(o,n,s){const t=(0,g.newWriteableStream)(r=>T.VSBuffer.concat(r));return(async()=>{try{let r;s?.atomic&&(0,v.hasFileAtomicReadCapability)(o)?r=await o.readFile(n,{atomic:!0}):r=await o.readFile(n),typeof s?.position=="number"&&(r=r.slice(s.position)),typeof s?.length=="number"&&(r=r.slice(0,s.length)),this.validateReadFileLimits(n,r.byteLength,s),t.end(T.VSBuffer.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async validateReadFile(o,n){const s=await this.resolve(o,{resolveMetadata:!0});if(s.isDirectory)throw new v.FileOperationError((0,p.localize)(12,null,this.resourceForError(o)),0,n);if(typeof n?.etag=="string"&&n.etag!==v.ETAG_DISABLED&&n.etag===s.etag)throw new v.NotModifiedSinceFileOperationError((0,p.localize)(13,null),s,n);return this.validateReadFileLimits(o,s.size,n),s}validateReadFileLimits(o,n,s){if(typeof s?.limits?.size=="number"&&n>s.limits.size)throw new v.TooLargeFileOperationError((0,p.localize)(14,null,this.resourceForError(o)),7,n,s)}async canMove(o,n,s){return this.doCanMoveCopy(o,n,"move",s)}async canCopy(o,n,s){return this.doCanMoveCopy(o,n,"copy",s)}async doCanMoveCopy(o,n,s,t){if(o.toString()!==n.toString())try{const r=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(r,o,a,n,s,t)}catch(r){return r}return!0}async move(o,n,s){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),a=await this.doMoveCopy(t,o,r,n,"move",!!s),C=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(o,a==="move"?2:3,C)),C}async copy(o,n,s){const t=await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),a=await this.doMoveCopy(t,o,r,n,"copy",!!s),C=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(o,a==="copy"?3:2,C)),C}async doMoveCopy(o,n,s,t,r,a){if(n.toString()===t.toString())return r;const{exists:C,isSameResourceWithDifferentPathCase:E}=await this.doValidateMoveCopy(o,n,s,t,r,a);if(C&&!E&&a&&await this.del(t,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(t)),r==="copy"){if(o===s&&(0,v.hasFileFolderCopyCapability)(o))await o.copy(n,t,{overwrite:a});else{const h=await this.resolve(n);h.isDirectory?await this.doCopyFolder(o,h,s,t):await this.doCopyFile(o,n,s,t)}return r}else return o===s?(await o.rename(n,t,{overwrite:a}),r):(await this.doMoveCopy(o,n,s,t,"copy",a),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(o,n,s,t){if((0,v.hasOpenReadWriteCloseCapability)(o)&&(0,v.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(o,n,s,t);if((0,v.hasOpenReadWriteCloseCapability)(o)&&(0,v.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(o,n,s,t);if((0,v.hasReadWriteCapability)(o)&&(0,v.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(o,n,s,t);if((0,v.hasReadWriteCapability)(o)&&(0,v.hasReadWriteCapability)(s))return this.doPipeUnbuffered(o,n,s,t)}async doCopyFolder(o,n,s,t){await s.mkdir(t),Array.isArray(n.children)&&await O.Promises.settled(n.children.map(async r=>{const a=this.getExtUri(s).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.doCopyFolder(o,await this.resolve(r.resource),s,a):this.doCopyFile(o,r.resource,s,a)}))}async doValidateMoveCopy(o,n,s,t,r,a){let C=!1;if(o===s){const{providerExtUri:h,isPathCaseSensitive:y}=this.getExtUri(o);if(y||(C=h.isEqual(n,t)),C&&r==="copy")throw new Error((0,p.localize)(15,null,this.resourceForError(n),this.resourceForError(t)));if(!C&&h.isEqualOrParent(t,n))throw new Error((0,p.localize)(16,null,this.resourceForError(n),this.resourceForError(t)))}const E=await this.exists(t);if(E&&!C){if(!a)throw new v.FileOperationError((0,p.localize)(17,null,this.resourceForError(n),this.resourceForError(t)),4);if(o===s){const{providerExtUri:h}=this.getExtUri(o);if(h.isEqualOrParent(n,t))throw new Error((0,p.localize)(18,null,this.resourceForError(n),this.resourceForError(t)))}}return{exists:E,isSameResourceWithDifferentPathCase:C}}getExtUri(o){const n=this.isPathCaseSensitive(o);return{providerExtUri:n?l.extUri:l.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(n,o);const s=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(o,0,s)),s}async mkdirp(o,n){const s=[],{providerExtUri:t}=this.getExtUri(o);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&v.FileType.Directory))throw new Error((0,p.localize)(19,null,this.resourceForError(n)));break}catch(r){if((0,v.toFileSystemProviderErrorCode)(r)!==v.FileSystemProviderErrorCode.FileNotFound)throw r;s.push(t.basename(n)),n=t.dirname(n)}for(let r=s.length-1;r>=0;r--){n=t.joinPath(n,s[r]);try{await o.mkdir(n)}catch(a){if((0,v.toFileSystemProviderErrorCode)(a)!==v.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,n){try{await this.doValidateDelete(o,n)}catch(s){return s}return!0}async doValidateDelete(o,n){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o),t=!!n?.useTrash;if(t&&!(s.capabilities&4096))throw new Error((0,p.localize)(20,null,this.resourceForError(o)));const r=n?.atomic;if(r&&!(s.capabilities&65536))throw new Error((0,p.localize)(21,null,this.resourceForError(o)));if(t&&r)throw new Error((0,p.localize)(22,null,this.resourceForError(o)));let a;try{a=await s.stat(o)}catch{}if(a)this.throwIfFileIsReadonly(o,a);else throw new v.FileOperationError((0,p.localize)(23,null,this.resourceForError(o)),1);if(!!!n?.recursive){const E=await this.resolve(o);if(E.isDirectory&&Array.isArray(E.children)&&E.children.length>0)throw new Error((0,p.localize)(24,null,this.resourceForError(o)))}return s}async del(o,n){const s=await this.doValidateDelete(o,n);let t=n;if((0,v.hasFileAtomicDeleteCapability)(s)&&!t?.atomic){const E=s.enforceAtomicDelete?.(o);E&&(t={...n,atomic:E})}const r=!!t?.useTrash,a=!!t?.recursive,C=t?.atomic??!1;await s.delete(o,{recursive:a,useTrash:r,atomic:C}),this._onDidRunOperation.fire(new v.FileOperationEvent(o,1))}async cloneFile(o,n){const s=await this.withProvider(o),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(!(s===t&&this.getExtUri(s).providerExtUri.isEqual(o,n)))return s===t&&(0,v.hasFileCloneCapability)(s)?s.cloneFile(o,n):(await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(n)),s===t&&(0,v.hasFileFolderCopyCapability)(s)?this.writeQueue.queueFor(o,()=>s.copy(o,n,{overwrite:!0}),this.getExtUri(s).providerExtUri):this.writeQueue.queueFor(o,()=>this.doCopyFile(s,o,t,n),this.getExtUri(s).providerExtUri))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(o,n){return this.watch(o,{...n,correlationId:c.WATCHER_CORRELATION_IDS++})}watch(o,n={recursive:!1,excludes:[]}){const s=new m.DisposableStore;let t=!1,r=()=>{t=!0};s.add((0,m.toDisposable)(()=>r())),(async()=>{try{const C=await this.doWatch(o,n);t?(0,m.dispose)(C):r=()=>(0,m.dispose)(C)}catch(C){this.logService.error(C)}})();const a=n.correlationId;if(typeof a=="number"){const C=s.add(new L.Emitter);return s.add(this.internalOnDidFilesChange.event(h=>{h.correlates(a)&&C.fire(h)})),{onDidChange:C.event,dispose:()=>s.dispose()}}return s}async doWatch(o,n){const s=await this.withProvider(o),t=(0,D.hash)([this.getExtUri(s).providerExtUri.getComparisonKey(o),n]);let r=this.activeWatchers.get(t);return r||(r={count:0,disposable:s.watch(o,n)},this.activeWatchers.set(t,r)),r.count+=1,(0,m.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,m.dispose)(r.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,m.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,n,s,t){return this.writeQueue.queueFor(n,async()=>{const r=await o.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,g.isReadableStream)(t)||(0,g.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(o,r,t):await this.doWriteReadableBufferedQueued(o,r,t)}catch(a){throw(0,v.ensureFileSystemProviderError)(a)}finally{await o.close(r)}},this.getExtUri(o).providerExtUri)}async doWriteStreamBufferedQueued(o,n,s){let t=0,r;if((0,g.isReadableBufferedStream)(s)){if(s.buffer.length>0){const a=T.VSBuffer.concat(s.buffer);await this.doWriteBuffer(o,n,a,a.byteLength,t,0),t+=a.byteLength}if(s.ended)return;r=s.stream}else r=s;return new Promise((a,C)=>{(0,g.listenStream)(r,{onData:async E=>{r.pause();try{await this.doWriteBuffer(o,n,E,E.byteLength,t,0)}catch(h){return C(h)}t+=E.byteLength,setTimeout(()=>r.resume())},onError:E=>C(E),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(o,n,s){let t=0,r;for(;(r=s.read())!==null;)await this.doWriteBuffer(o,n,r,r.byteLength,t,0),t+=r.byteLength}async doWriteBuffer(o,n,s,t,r,a){let C=0;for(;C<t;){const E=await o.write(n,r+C,s.buffer,a+C,t-C);C+=E}}async doWriteUnbuffered(o,n,s,t){return this.writeQueue.queueFor(n,()=>this.doWriteUnbufferedQueued(o,n,s,t),this.getExtUri(o).providerExtUri)}async doWriteUnbufferedQueued(o,n,s,t){let r;t instanceof T.VSBuffer?r=t:(0,g.isReadableStream)(t)?r=await(0,T.streamToBuffer)(t):(0,g.isReadableBufferedStream)(t)?r=await(0,T.bufferedStreamToBuffer)(t):r=(0,T.readableToBuffer)(t),await o.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async doPipeBuffered(o,n,s,t){return this.writeQueue.queueFor(t,()=>this.doPipeBufferedQueued(o,n,s,t),this.getExtUri(s).providerExtUri)}async doPipeBufferedQueued(o,n,s,t){let r,a;try{r=await o.open(n,{create:!1}),a=await s.open(t,{create:!0,unlock:!1});const C=T.VSBuffer.alloc(this.BUFFER_SIZE);let E=0,h=0,y=0;do y=await o.read(r,E,C.buffer,h,C.byteLength-h),await this.doWriteBuffer(s,a,C,y,E,h),E+=y,h+=y,h===C.byteLength&&(h=0);while(y>0)}catch(C){throw(0,v.ensureFileSystemProviderError)(C)}finally{await O.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?s.close(a):Promise.resolve()])}}async doPipeUnbuffered(o,n,s,t){return this.writeQueue.queueFor(t,()=>this.doPipeUnbufferedQueued(o,n,s,t),this.getExtUri(s).providerExtUri)}async doPipeUnbufferedQueued(o,n,s,t){return s.writeFile(t,await o.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(o,n,s,t){return this.writeQueue.queueFor(t,()=>this.doPipeUnbufferedToBufferedQueued(o,n,s,t),this.getExtUri(s).providerExtUri)}async doPipeUnbufferedToBufferedQueued(o,n,s,t){const r=await s.open(t,{create:!0,unlock:!1});try{const a=await o.readFile(n);await this.doWriteBuffer(s,r,T.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,v.ensureFileSystemProviderError)(a)}finally{await s.close(r)}}async doPipeBufferedToUnbuffered(o,n,s,t){const r=await(0,T.streamToBuffer)(this.readFileBuffered(o,n,A.CancellationToken.None));await this.doWriteUnbuffered(s,t,void 0,r)}throwIfFileSystemIsReadonly(o,n){if(o.capabilities&2048)throw new v.FileOperationError((0,p.localize)(25,null,this.resourceForError(n)),6);return o}throwIfFileIsReadonly(o,n){if((n.permissions??0)&v.FilePermission.Readonly)throw new v.FileOperationError((0,p.localize)(26,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===b.Schemas.file?o.fsPath:o.toString(!0)}};e.FileService=w,e.FileService=w=c=ye([Y(0,d.ILogService)],w)}),define(le[201],ue([0,1,54,270,6,35,14,3,49,2,16,5,20,47,31,162,11,98,199,38,195,194]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g,p,v,u,d,f,c,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,O.gracefulify)(k)}catch(o){console.error(`Error enabling graceful-fs: ${(0,f.toErrorMessage)(o)}`)}})();class i extends d.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=D.Event.None,this.resourceLocks=new A.ResourceMap(t=>S.extUriBiasedIgnorePathCase.getComparisonKey(t)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:s,symbolicLink:t}=await g.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(s,t),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:v.FilePermission.Locked}}catch(s){throw this.toFileSystemProviderError(s)}}async statIgnoreError(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await g.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),t=[];return await Promise.all(s.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,S.joinPath)(n,r.name))).type:a=this.toType(r),t.push([r.name,a])}catch(a){this.logService.trace(a)}})),t}catch(s){throw this.toFileSystemProviderError(s)}}toType(n,s){let t;return s?.dangling?t=v.FileType.Unknown:n.isFile()?t=v.FileType.File:n.isDirectory()?t=v.FileType.Directory:t=v.FileType.Unknown,s&&(t|=v.FileType.SymbolicLink),t}async createResourceLock(n){const s=this.toFilePath(n);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let t;for(;t=this.resourceLocks.get(n);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await t.wait();const r=new T.Barrier;return this.resourceLocks.set(n,r),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,m.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.resourceLocks.get(n)===r&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.resourceLocks.delete(n)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),r.open()})}async readFile(n,s){let t;try{s?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),t=await this.createResourceLock(n));const r=this.toFilePath(n);return await g.Promises.readFile(r)}catch(r){throw this.toFileSystemProviderError(r)}finally{t?.dispose()}}traceLock(n){i.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(n)}readFileStream(n,s,t){const r=(0,l.newWriteableStream)(a=>L.VSBuffer.concat(a.map(C=>L.VSBuffer.wrap(C))).buffer);return(0,u.readFileIntoStream)(this,n,r,a=>a.buffer,{...s,bufferSize:256*1024},t),r}async writeFile(n,s,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.canWriteFileAtomic(n)?this.doWriteFileAtomic(n,(0,S.joinPath)((0,S.dirname)(n),`${(0,S.basename)(n)}${t.atomic.postfix}`),s,t):this.doWriteFile(n,s,t)}async canWriteFileAtomic(n){try{const s=this.toFilePath(n),{symbolicLink:t}=await g.SymlinkSupport.stat(s);if(t)return!1}catch{}return!0}async doWriteFileAtomic(n,s,t,r){const a=new m.DisposableStore;try{a.add(await this.createResourceLock(n)),a.add(await this.createResourceLock(s)),await this.doWriteFile(s,t,r,!0);try{await this.rename(s,n,{overwrite:!0})}catch(C){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw C}}finally{a.dispose()}}async doWriteFile(n,s,t,r){let a;try{const C=this.toFilePath(n);if(!t.create||!t.overwrite){if(await g.Promises.exists(C)){if(!t.overwrite)throw(0,v.createFileSystemProviderError)((0,p.localize)(0,null),v.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,v.createFileSystemProviderError)((0,p.localize)(1,null),v.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(a,0,s,0,s.byteLength)}catch(C){throw await this.toFileSystemProviderWriteError(n,C)}finally{typeof a=="number"&&await this.close(a)}}static{this.canFlush=!0}static configureFlushOnWrite(n){i.canFlush=n}async open(n,s,t){const r=this.toFilePath(n);let a;(0,v.isFileOpenForWriteOptions)(s)&&!t&&(a=await this.createResourceLock(n));let C;try{if((0,v.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:h}=await g.SymlinkSupport.stat(r);h.mode&128||await g.Promises.chmod(r,h.mode|128)}catch(h){h.code!=="ENOENT"&&this.logService.trace(h)}let E;if((0,v.isFileOpenForWriteOptions)(s)){if(b.isWindows)try{await g.Promises.truncate(r,0),E="r+"}catch(h){h.code!=="ENOENT"&&this.logService.trace(h)}E||(E="w")}else E="r";C=await g.Promises.open(r,E)}catch(E){throw a?.dispose(),(0,v.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(n,E):this.toFileSystemProviderError(E)}if(this.mapHandleToPos.set(C,0),(0,v.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(C,n),a){const E=this.mapHandleToLock.get(C);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${C} (${r})`),this.mapHandleToLock.set(C,a),E&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${C} (${r})`),E.dispose())}return C}async close(n){const s=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&i.canFlush)try{await g.Promises.fdatasync(n)}catch(t){i.configureFlushOnWrite(!1),this.logService.error(t)}return await g.Promises.close(n)}catch(t){throw this.toFileSystemProviderError(t)}finally{s&&(this.mapHandleToLock.get(n)===s&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,t,r,a){const C=this.normalizePos(n,s);let E=null;try{E=(await g.Promises.read(n,t,r,a,C)).bytesRead}catch(h){throw this.toFileSystemProviderError(h)}finally{this.updatePos(n,C,E)}return E}normalizePos(n,s){return s===this.mapHandleToPos.get(n)?null:s}updatePos(n,s,t){const r=this.mapHandleToPos.get(n);typeof r=="number"&&(typeof s=="number"||(typeof t=="number"?this.mapHandleToPos.set(n,r+t):this.mapHandleToPos.delete(n)))}async write(n,s,t,r,a){return(0,T.retry)(()=>this.doWrite(n,s,t,r,a),100,3)}async doWrite(n,s,t,r,a){const C=this.normalizePos(n,s);let E=null;try{E=(await g.Promises.write(n,t,r,a,C)).bytesWritten}catch(h){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),h)}finally{this.updatePos(n,C,E)}return E}async mkdir(n){try{await g.Promises.mkdir(this.toFilePath(n))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(n,s){try{const t=this.toFilePath(n);if(s.recursive){let r;s?.atomic!==!1&&s.atomic.postfix&&(r=(0,P.join)((0,P.dirname)(t),`${(0,P.basename)(t)}${s.atomic.postfix}`)),await g.Promises.rm(t,g.RimRafMode.MOVE,r)}else try{await g.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:C,symbolicLink:E}=await g.SymlinkSupport.stat(t);a=C.isDirectory()&&!E}catch{}if(a)await g.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.toFileSystemProviderError(t)}}async rename(n,s,t){const r=this.toFilePath(n),a=this.toFilePath(s);if(r!==a)try{await this.validateMoveCopy(n,s,"move",t.overwrite),await g.Promises.rename(r,a)}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,p.localize)(2,null,(0,P.basename)(r),(0,P.basename)((0,P.dirname)(a)),C.toString()))),this.toFileSystemProviderError(C)}}async copy(n,s,t){const r=this.toFilePath(n),a=this.toFilePath(s);if(r!==a)try{await this.validateMoveCopy(n,s,"copy",t.overwrite),await g.Promises.copy(r,a,{preserveSymlinks:!0})}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,p.localize)(3,null,(0,P.basename)(r),(0,P.basename)((0,P.dirname)(a)),C.toString()))),this.toFileSystemProviderError(C)}}async validateMoveCopy(n,s,t,r){const a=this.toFilePath(n),C=this.toFilePath(s);let E=!1;if(!!(this.capabilities&1024)||(E=(0,I.isEqual)(a,C,!0)),E){if(t==="copy")throw(0,v.createFileSystemProviderError)((0,p.localize)(4,null),v.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const y=await this.statIgnoreError(n);if(!y)throw(0,v.createFileSystemProviderError)((0,p.localize)(5,null),v.FileSystemProviderErrorCode.FileNotFound);const R=await this.statIgnoreError(s);if(R){if(!r)throw(0,v.createFileSystemProviderError)((0,p.localize)(6,null),v.FileSystemProviderErrorCode.FileExists);y.type&v.FileType.File&&R.type&v.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.doCloneFile(n,s,!1)}async doCloneFile(n,s,t){const r=this.toFilePath(n),a=this.toFilePath(s),C=!!(this.capabilities&1024);if((0,I.isEqual)(r,a,!C))return;const E=new m.DisposableStore;try{E.add(await this.createResourceLock(n)),E.add(await this.createResourceLock(s)),t&&await g.Promises.mkdir((0,P.dirname)(a),{recursive:!0}),await g.Promises.copyFile(r,a)}catch(h){if(h.code==="ENOENT"&&!t)return this.doCloneFile(n,s,!0);throw this.toFileSystemProviderError(h)}finally{E.dispose()}}createUniversalWatcher(n,s,t){return new c.UniversalWatcherClient(r=>n(r),r=>s(r),t)}createNonRecursiveWatcher(n,s,t){return new w.NodeJSWatcherClient(r=>n(r),r=>s(r),t)}toFileSystemProviderError(n){if(n instanceof v.FileSystemProviderError)return n;let s=n,t;switch(n.code){case"ENOENT":t=v.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=v.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=v.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=v.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=v.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=v.FileSystemProviderErrorCode.Unknown;break;default:t=v.FileSystemProviderErrorCode.Unknown}return(0,v.createFileSystemProviderError)(s,t)}async toFileSystemProviderWriteError(n,s){let t=this.toFileSystemProviderError(s);if(n&&t.code===v.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await g.SymlinkSupport.stat(this.toFilePath(n));r.mode&128||(t=(0,v.createFileSystemProviderError)(s,v.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.logService.trace(r)}return t}}e.DiskFileSystemProvider=i}),define(le[101],ue([0,1,3,2,4,8]),function(se,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,T.createDecorator)("sharedProcessLifecycleService");let L=class extends O.Disposable{constructor(I){super(),this.logService=I,this._onWillShutdown=this._register(new k.Emitter),this.onWillShutdown=this._onWillShutdown.event}fireOnWillShutdown(){this.logService.trace("Lifecycle#onWillShutdown.fire()"),this._onWillShutdown.fire()}};e.SharedProcessLifecycleService=L,e.SharedProcessLifecycleService=L=ye([Y(0,A.ILogService)],L)}),define(le[202],ue([0,1,10,3,8,2]),function(se,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class L extends T.AbstractLoggerService{constructor(b,S,l,g,p){super(S,l,g),this.windowId=b,this.channel=p,this._register(p.listen("onDidChangeLogLevel",b)(v=>{(0,T.isLogLevel)(v)?super.setLogLevel(v):super.setLogLevel(k.URI.revive(v[0]),v[1])})),this._register(p.listen("onDidChangeVisibility",b)(([v,u])=>super.setVisibility(k.URI.revive(v),u))),this._register(p.listen("onDidChangeLoggers",b)(({added:v,removed:u})=>{for(const d of v)super.registerLogger({...d,resource:k.URI.revive(d.resource)});for(const d of u)super.deregisterLogger(d.resource)}))}createConsoleMainLogger(){return new T.AdapterLogger({log:(b,S)=>{this.channel.call("consoleLog",[b,S])}})}registerLogger(b){super.registerLogger(b),this.channel.call("registerLogger",[b,this.windowId])}deregisterLogger(b){super.deregisterLogger(b),this.channel.call("deregisterLogger",[b,this.windowId])}setLogLevel(b,S){super.setLogLevel(b,S),this.channel.call("setLogLevel",[b,S])}setVisibility(b,S){super.setVisibility(b,S),this.channel.call("setVisibility",[this.toResource(b),S])}doCreateLogger(b,S,l){return new D(this.channel,b,S,l,this.windowId)}static setLogLevel(b,S,l){return b.call("setLogLevel",[S,l])}}e.LoggerChannelClient=L;class D extends T.AbstractMessageLogger{constructor(b,S,l,g,p){super(g?.logLevel==="always"),this.channel=b,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(l),this.channel.call("createLogger",[S,g,p]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(b,S){const l=[[b,S]];this.isLoggerCreated?this.doLog(l):this.buffer.push(...l)}doLog(b){this.channel.call("log",[this.file,b])}}class I{constructor(b,S){this.loggerService=b,this.getUriTransformer=S}listen(b,S){const l=this.getUriTransformer(b);switch(S){case"onDidChangeLoggers":return O.Event.map(this.loggerService.onDidChangeLoggers,g=>({added:[...g.added].map(p=>this.transformLogger(p,l)),removed:[...g.removed].map(p=>this.transformLogger(p,l))}));case"onDidChangeVisibility":return O.Event.map(this.loggerService.onDidChangeVisibility,g=>[l.transformOutgoingURI(g[0]),g[1]]);case"onDidChangeLogLevel":return O.Event.map(this.loggerService.onDidChangeLogLevel,g=>(0,T.isLogLevel)(g)?g:[l.transformOutgoingURI(g[0]),g[1]])}throw new Error(`Event not found: ${S}`)}async call(b,S,l){const g=this.getUriTransformer(b);switch(S){case"setLogLevel":return(0,T.isLogLevel)(l[0])?this.loggerService.setLogLevel(l[0]):this.loggerService.setLogLevel(k.URI.revive(g.transformIncoming(l[0][0])),l[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(p=>this.transformLogger(p,g)))}throw new Error(`Call not found: ${S}`)}transformLogger(b,S){return{...b,resource:S.transformOutgoingURI(b.resource)}}}e.LoggerChannel=I;class m extends A.Disposable{constructor(b,S){super(),S.call("setLogLevel",[b.getLogLevel()]),this._register(b.onDidChangeLogLevel(l=>S.call("setLogLevel",[l]))),S.call("getRegisteredLoggers").then(l=>{for(const g of l)b.registerLogger({...g,resource:k.URI.revive(g.resource)})}),this._register(S.listen("onDidChangeVisibility")(([l,g])=>b.setVisibility(k.URI.revive(l),g))),this._register(S.listen("onDidChangeLoggers")(({added:l,removed:g})=>{for(const p of l)b.registerLogger({...p,resource:k.URI.revive(p.resource)});for(const p of g)b.deregisterLogger(p.resource)}))}}e.RemoteLoggerChannelClient=m}),define(le[203],ue([0,1,2,8]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class T extends k.Disposable{constructor(L,D=[]){super(),this.logger=new O.MultiplexLogger([L,...D]),this._register(L.onDidChangeLogLevel(I=>this.setLevel(I)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(L){this.logger.setLevel(L)}getLevel(){return this.logger.getLevel()}trace(L,...D){this.logger.trace(L,...D)}debug(L,...D){this.logger.debug(L,...D)}info(L,...D){this.logger.info(L,...D)}warn(L,...D){this.logger.warn(L,...D)}error(L,...D){this.logger.error(L,...D)}flush(){this.logger.flush()}}e.LogService=T}),define(le[57],ue([0,1,4]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,k.createDecorator)("nativeHostService")}),define(le[204],ue([0,1,40,56]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostService=void 0;let T=class{constructor(L,D){return this.windowId=L,k.ProxyChannel.toService(D.getChannel("nativeHost"),{context:L,properties:(()=>{const I=new Map;return I.set("windowId",L),I})()})}};e.NativeHostService=T,e.NativeHostService=T=ye([Y(1,O.IMainProcessService)],T)}),define(le[58],ue([0,1,3,61,2,4]),function(se,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class L extends T.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(m){const P=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...m,...this.policyDefinitions},P!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(m),O.Iterable.reduce(this.policies.entries(),(b,[S,l])=>({...b,[S]:l}),{})}getPolicyValue(m){return this.policies.get(m)}serialize(){return O.Iterable.reduce(Object.entries(this.policyDefinitions),(m,[P,b])=>({...m,[P]:{definition:b,value:this.policies.get(P)}}),{})}}e.AbstractPolicyService=L;class D{constructor(){this.onDidChange=k.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=D}),define(le[205],ue([0,1,3,2,58]),function(se,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class A{constructor(I){this.service=I,this.disposables=new O.DisposableStore}listen(I,m){switch(m){case"onDidChange":return k.Event.map(this.service.onDidChange,P=>P.reduce((b,S)=>({...b,[S]:this.service.getPolicyValue(S)??null}),{}),this.disposables)}throw new Error(`Event not found: ${m}`)}call(I,m,P){switch(m){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${m}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=A;class L extends T.AbstractPolicyService{constructor(I,m){super(),this.channel=m;for(const P in I){const{definition:b,value:S}=I[P];this.policyDefinitions[P]=b,S!==void 0&&this.policies.set(P,S)}this.channel.listen("onDidChange")(P=>{for(const b in P){const S=P[b];S===null?this.policies.delete(b):this.policies.set(b,S)}this._onDidChange.fire(Object.keys(P))})}async _updatePolicyDefinitions(I){const m=await this.channel.call("updatePolicyDefinitions",I);for(const P in m)this.policies.set(P,m[P])}}e.PolicyChannelClient=L}),define(le[102],ue([0,1,37]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let O;const T=globalThis.vscode;if(typeof T<"u"&&typeof T.context<"u"){const A=T.context.configuration();if(A)O=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){O=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:A,searchUrl:L,itemUrl:D,controlUrl:I}=O.extensionsGallery||{};Object.assign(O,{extensionsGallery:{serviceUrl:k.env.VSCODE_GALLERY_SERVICE_URL||A,searchUrl:k.env.VSCODE_GALLERY_SEARCH_URL||L,itemUrl:k.env.VSCODE_GALLERY_ITEM_URL||D,controlUrl:k.env.VSCODE_GALLERY_CONTROL_URL||I}});try{const m=(...b)=>b.reduce((S,l)=>(Object.keys(l).forEach(g=>{Array.isArray(S[g])&&Array.isArray(l[g])?S[g]=l[g]:typeof S[g]=="object"&&typeof l[g]=="object"?S[g]=m(S[g],l[g]):S[g]=l[g]}),S),{}),P=globalThis._VSCODE_USER_PRODUCT_JSON||{};O=m(O,P)}catch{}if(k.env.VSCODE_DEV&&Object.assign(O,{nameShort:`${O.nameShort} Dev`,nameLong:`${O.nameLong} Dev`,dataFolderName:`${O.dataFolderName}-dev`,serverDataFolderName:O.serverDataFolderName?`${O.serverDataFolderName}-dev`:void 0}),!O.version){const m=globalThis._VSCODE_PACKAGE_JSON;Object.assign(O,{version:m.version,release:m.release})}}else O={},Object.keys(O).length===0&&Object.assign(O,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=O}),define(le[24],ue([0,1,4]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(le[206],ue([0,1,6,7,2,16,31,8,24]),function(se,e,k,O,T,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let m=class extends T.Disposable{constructor(b,S,l){super(),this.productService=S,this.logService=l,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,b&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpCodeCaches(b)},3e4)).schedule()}async cleanUpCodeCaches(b){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const S=Date.now(),l=(0,A.dirname)(b),g=(0,A.basename)(b),p=await L.Promises.readdir(l);await Promise.all(p.map(async v=>{if(v===g)return;const u=(0,A.join)(l,v),d=await L.Promises.stat(u);if(d.isDirectory()&&S-d.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${v}.`),L.Promises.rm(u)}))}catch(S){(0,O.onUnexpectedError)(S)}}};e.CodeCacheCleaner=m,e.CodeCacheCleaner=m=ye([Y(1,I.IProductService),Y(2,D.ILogService)],m)}),define(le[207],ue([0,1,6,7,2,16,31,15,8,24]),function(se,e,k,O,T,A,L,D,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=class extends T.Disposable{constructor(S,l,g){super(),this.environmentService=S,this.logService=l,this.productService=g,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const S=Object.create(null),l=JSON.parse(await L.Promises.readFile((0,A.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const d of Object.keys(l)){const f=l[d];S[`${f.hash}.${d}`]=!0}const g=(0,A.join)(this.environmentService.userDataPath,"clp");if(!await L.Promises.exists(g))return;const v=await L.Promises.readdir(g);for(const d of v){if(S[d]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${d}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${d}`),await L.Promises.rm((0,A.join)(g,d))}const u=Date.now();for(const d of Object.keys(S)){const f=(0,A.join)(g,d),c=await L.Promises.readdir(f);for(const w of c){if(w==="tcf.json")continue;const i=(0,A.join)(f,w),o=await L.Promises.stat(i);o.isDirectory()&&u-o.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.join)(d,w)}`),await L.Promises.rm(i))}}}catch(S){(0,O.onUnexpectedError)(S)}}};e.LanguagePackCachedDataCleaner=P,e.LanguagePackCachedDataCleaner=P=ye([Y(0,D.INativeEnvironmentService),Y(1,I.ILogService),Y(2,m.IProductService)],P)}),define(le[208],ue([0,1,16,4]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,O.createDecorator)("IV8InspectProfilingService");var T;(function(A){function L(I){return!!(I.samples&&I.timeDeltas)}A.isValidProfile=L;function D(I,m="noAbsolutePaths"){for(const P of I.nodes)P.callFrame&&P.callFrame.url&&((0,k.isAbsolute)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,k.join)(m,(0,k.basename)(P.callFrame.url)));return I}A.rewriteAbsolutePaths=D})(T||(e.Utils=T={}))}),define(le[209],ue([0,1,32]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class O{constructor(){this._sessions=new Map}async startProfiling(A){const D=await(await new Promise((m,P)=>{se(["v8-inspect-profiler"],m,P)})).startProfiling({port:A.port,checkForPaused:!0}),I=(0,k.generateUuid)();return this._sessions.set(I,D),I}async stopProfiling(A){const L=this._sessions.get(A);if(!L)throw new Error(`UNKNOWN session '${A}'`);const D=await L.stop();return this._sessions.delete(A),D.profile}}e.InspectProfilingService=O}),define(le[41],ue([0,1,127,12]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.data=new Map}add(L,D){k.ok(O.isString(L)),k.ok(O.isObject(D)),k.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,D)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}e.Registry=new T}),define(le[103],ue([0,1,3,41]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class A{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(I,m){this.schemasById[T(I)]=m,this._onDidChangeSchema.fire(I)}notifySchemaChanged(I){this._onDidChangeSchema.fire(I)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new A;O.Registry.add(e.Extensions.JSONContribution,L)}),define(le[44],ue([0,1,17,3,12,149,21,103,41]),function(se,e,k,O,T,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(m||(e.EditPresentationTypes=m={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=I.Registry.as(D.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new O.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new O.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const n=new Set;this.doRegisterConfigurations(i,o,n),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(i){const o=new Set;this.doDeregisterConfigurations(i,o),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:i,remove:o}){const n=new Set;this.doDeregisterConfigurations(o,n),this.doRegisterConfigurations(i,!1,n),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}registerDefaultConfigurations(i){const o=new Set;this.doRegisterDefaultConfigurations(i,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doRegisterDefaultConfigurations(i,o){const n=[];for(const{overrides:s,source:t}of i)for(const r in s)if(o.add(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const a=this.configurationDefaultsOverrides.get(r),C=a?.valuesSources??new Map;if(t)for(const R of Object.keys(s[r]))C.set(R,t);const E={...a?.value||{},...s[r]};this.configurationDefaultsOverrides.set(r,{source:t,value:E,valuesSources:C});const h=(0,L.getLanguageTagSettingPlainKey)(r),y={type:"object",default:E,description:A.localize(1,null,h),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:E,source:T.isString(t)?void 0:t,defaultValueSource:t};n.push(...p(r)),this.configurationProperties[r]=y,this.defaultLanguageConfigurationOverridesNode.properties[r]=y}else{this.configurationDefaultsOverrides.set(r,{value:s[r],source:t});const a=this.configurationProperties[r];a&&(this.updatePropertyDefaultValue(r,a),this.updateSchema(r,a))}this.doRegisterOverrideIdentifiers(n)}deregisterDefaultConfigurations(i){const o=new Set;this.doDeregisterDefaultConfigurations(i,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(i,o){for(const{overrides:n,source:s}of i)for(const t in n){const r=this.configurationDefaultsOverrides.get(t),a=T.isString(s)?s:s?.id,C=T.isString(r?.source)?r?.source:r?.source?.id;if(a===C)if(o.add(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const E=this.configurationProperties[t];E&&(this.updatePropertyDefaultValue(t,E),this.updateSchema(t,E))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(i){let o=!1;const n=new Set;i.removedDefaults&&(this.doDeregisterDefaultConfigurations(i.removedDefaults,n),o=!0),i.addedDefaults&&(this.doRegisterDefaultConfigurations(i.addedDefaults,n),o=!0),i.removedConfigurations&&this.doDeregisterConfigurations(i.removedConfigurations,n),i.addedConfigurations&&this.doRegisterConfigurations(i.addedConfigurations,!1,n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){this.doRegisterOverrideIdentifiers(i),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(i){for(const o of i)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,o,n){i.forEach(s=>{this.validateAndRegisterProperties(s,o,s.extensionInfo,s.restrictedProperties,void 0,n),this.configurationContributors.push(s),this.registerJSONConfiguration(s)})}doDeregisterConfigurations(i,o){const n=s=>{if(s.properties)for(const t in s.properties){o.add(t);const r=this.configurationProperties[t];r?.policy?.name&&this.policyConfigurations.delete(r.policy.name),delete this.configurationProperties[t],this.removeFromSchema(t,s.properties[t])}s.allOf?.forEach(t=>n(t))};for(const s of i){n(s);const t=this.configurationContributors.indexOf(s);t!==-1&&this.configurationContributors.splice(t,1)}}validateAndRegisterProperties(i,o=!0,n,s,t=3,r){t=T.isUndefinedOrNull(i.scope)?t:i.scope;const a=i.properties;if(a)for(const E in a){const h=a[E];if(o&&f(E,h)){delete a[E];continue}if(h.source=n,h.defaultDefaultValue=a[E].default,this.updatePropertyDefaultValue(E,h),e.OVERRIDE_PROPERTY_REGEX.test(E)?h.scope=void 0:(h.scope=T.isUndefinedOrNull(h.scope)?t:h.scope,h.restricted=T.isUndefinedOrNull(h.restricted)?!!s?.includes(E):h.restricted),a[E].hasOwnProperty("included")&&!a[E].included){this.excludedConfigurationProperties[E]=a[E],delete a[E];continue}else this.configurationProperties[E]=a[E],a[E].policy?.name&&this.policyConfigurations.set(a[E].policy.name,E);!a[E].deprecationMessage&&a[E].markdownDeprecationMessage&&(a[E].deprecationMessage=a[E].markdownDeprecationMessage),r.add(E)}const C=i.allOf;if(C)for(const E of C)this.validateAndRegisterProperties(E,o,n,s,t,r)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const o=n=>{const s=n.properties;if(s)for(const r in s)this.updateSchema(r,s[r]);n.allOf?.forEach(o)};o(i)}updateSchema(i,o){switch(e.allSettings.properties[i]=o,o.scope){case 1:e.applicationSettings.properties[i]=o;break;case 2:e.machineSettings.properties[i]=o;break;case 6:e.machineOverridableSettings.properties[i]=o;break;case 3:e.windowSettings.properties[i]=o;break;case 4:e.resourceSettings.properties[i]=o;break;case 5:e.resourceSettings.properties[i]=o,this.resourceLanguageSettingsSchema.properties[i]=o;break}}removeFromSchema(i,o){switch(delete e.allSettings.properties[i],o.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const o=`[${i}]`,n={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,n),e.allSettings.properties[o]=n,e.applicationSettings.properties[o]=n,e.machineSettings.properties[o]=n,e.machineOverridableSettings.properties[o]=n,e.windowSettings.properties[o]=n,e.resourceSettings.properties[o]=n}}registerOverridePropertyPatternKey(){const i={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,o){const n=this.configurationDefaultsOverrides.get(i);let s=n?.value,t=n?.source;T.isUndefined(s)&&(s=o.defaultDefaultValue,t=void 0),T.isUndefined(s)&&(s=u(o.type)),o.default=s,o.defaultValueSource=t}}const l="\\[([^\\]]+)\\]",g=new RegExp(l,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${l})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(w){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(w)){let o=g.exec(w);for(;o?.length;){const n=o[1].trim();n&&i.push(n),o=g.exec(w)}}return(0,k.distinct)(i)}e.overrideIdentifiersFromKey=p;function v(w){return w.reduce((i,o)=>`${i}[${o}]`,"")}e.keyFromOverrideIdentifiers=v;function u(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const d=new S;I.Registry.add(e.Extensions.Configuration,d);function f(w,i){return w.trim()?e.OVERRIDE_PROPERTY_REGEX.test(w)?A.localize(7,null,w):d.getConfigurationProperties()[w]!==void 0?A.localize(8,null,w):i.policy?.name&&d.getPolicyConfigurations().get(i.policy?.name)!==void 0?A.localize(9,null,w,i.policy?.name,d.getPolicyConfigurations().get(i.policy?.name)):null:A.localize(6,null)}e.validateProperty=f;function c(){const w=[],i=d.getConfigurationProperties();for(const o of Object.keys(i))w.push([o,i[o].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=c}),define(le[76],ue([0,1,17,3,34,2,35,30,12,10,21,44,41]),function(se,e,k,O,T,A,L,D,I,m,P,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function l(o){return Object.isFrozen(o)?o:D.deepFreeze(o)}class g{constructor(n={},s=[],t=[],r){this._contents=n,this._keys=s,this._overrides=t,this.raw=r,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof g)return s;const t=new p("");return t.parseRaw(s),t.configurationModel});this._rawConfiguration=n.reduce((s,t)=>t===s?t:s.merge(t),n[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,P.getConfigurationValue)(this.contents,n):this.contents}inspect(n,s){const t=this.rawConfiguration.getValue(n),r=s?this.rawConfiguration.getOverrideValue(n,s):void 0,a=s?this.rawConfiguration.override(s).getValue(n):t;return{value:t,override:r,merged:a}}getOverrideValue(n,s){const t=this.getContentsForOverrideIdentifer(s);return t?n?(0,P.getConfigurationValue)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const t of this.overrides)t.identifiers.includes(n)&&s.push(...t.keys);return k.distinct(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return k.distinct(n)}override(n){let s=this.overrideConfigurations.get(n);return s||(s=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,s)),s}merge(...n){const s=D.deepClone(this.contents),t=D.deepClone(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const C of n)if(a.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.mergeContents(s,C.contents);for(const E of C.overrides){const[h]=t.filter(y=>k.equals(y.identifiers,E.identifiers));h?(this.mergeContents(h.contents,E.contents),h.keys.push(...E.keys),h.keys=k.distinct(h.keys)):t.push(D.deepClone(E))}for(const E of C.keys)r.indexOf(E)===-1&&r.push(E)}return new g(s,r,t,a.every(C=>C instanceof g)?void 0:a)}createOverrideConfigurationModel(n){const s=this.getContentsForOverrideIdentifer(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const t={};for(const r of k.distinct([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[r];const C=s[r];C&&(typeof a=="object"&&typeof C=="object"?(a=D.deepClone(a),this.mergeContents(a,C)):a=C),t[r]=a}return new g(t,this.keys,this.overrides)}mergeContents(n,s){for(const t of Object.keys(s)){if(t in n&&I.isObject(n[t])&&I.isObject(s[t])){this.mergeContents(n[t],s[t]);continue}n[t]=D.deepClone(s[t])}}getContentsForOverrideIdentifer(n){let s=null,t=null;const r=a=>{a&&(t?this.mergeContents(t,a):t=D.deepClone(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?s=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(s),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.updateValue(n,s,!0)}setValue(n,s){this.updateValue(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,P.removeFromValueTree)(this.contents,n),b.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>k.equals(t.identifiers,(0,b.overrideIdentifiersFromKey)(n))),1))}updateValue(n,s,t){(0,P.addToValueTree)(this.contents,n,s,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),b.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,b.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,P.toValuesTree)(this.contents[n],r=>console.error(r))})}}e.ConfigurationModel=g;class p{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,s){if(!I.isUndefinedOrNull(n)){const t=this.doParseContent(n);this.parseRaw(t,s)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,s){this._raw=n;const{contents:t,keys:r,overrides:a,restricted:C,hasExcludedProperties:E}=this.doParseRaw(n,s);this._configurationModel=new g(t,r,a,E?[n]:void 0),this._restrictedConfigurations=C||[]}doParseContent(n){let s={},t=null,r=[];const a=[],C=[];function E(y){Array.isArray(r)?r.push(y):t!==null&&(r[t]=y)}const h={onObjectBegin:()=>{const y={};E(y),a.push(r),r=y,t=null},onObjectProperty:y=>{t=y},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const y=[];E(y),a.push(r),r=y,t=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:E,onError:(y,R,U)=>{C.push({error:y,offset:R,length:U})}};if(n)try{T.visit(n,h),s=r[0]||{}}catch(y){console.error(`Error while parsing settings file ${this._name}: ${y}`),this._parseErrors=[y]}return s}doParseRaw(n,s){const t=S.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),r=this.filter(n,t,!0,s);n=r.raw;const a=(0,P.toValuesTree)(n,h=>console.error(`Conflict in settings file ${this._name}: ${h}`)),C=Object.keys(n),E=this.toOverrides(n,h=>console.error(`Conflict in settings file ${this._name}: ${h}`));return{contents:a,keys:C,overrides:E,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}filter(n,s,t,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const C={},E=[];for(const h in n)if(b.OVERRIDE_PROPERTY_REGEX.test(h)&&t){const y=this.filter(n[h],s,!1,r);C[h]=y.raw,a=a||y.hasExcludedProperties,E.push(...y.restricted)}else{const y=s[h],R=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&E.push(h),!r.exclude?.includes(h)&&(r.include?.includes(h)||(R===void 0||r.scopes===void 0||r.scopes.includes(R))&&!(r.skipRestricted&&y?.restricted))?C[h]=n[h]:a=!0}return{raw:C,restricted:E,hasExcludedProperties:a}}toOverrides(n,s){const t=[];for(const r of Object.keys(n))if(b.OVERRIDE_PROPERTY_REGEX.test(r)){const a={};for(const C in n[r])a[C]=n[r][C];t.push({identifiers:(0,b.overrideIdentifiersFromKey)(r),keys:Object.keys(a),contents:(0,P.toValuesTree)(a,s)})}return t}}e.ConfigurationModelParser=p;class v extends A.Disposable{constructor(n,s,t,r){super(),this.userSettingsResource=n,this.parseOptions=s,this.fileService=r,this._onDidChange=this._register(new O.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this._register(this.fileService.watch(t.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(O.Event.any(O.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),O.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&t.isEqual(a.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new g}}reparse(n){return n&&(this.parseOptions=n),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class u{constructor(n,s,t,r,a,C,E,h,y,R,U,F,M){this.key=n,this.overrides=s,this._value=t,this.overrideIdentifiers=r,this.defaultConfiguration=a,this.policyConfiguration=C,this.applicationConfiguration=E,this.userConfiguration=h,this.localUserConfiguration=y,this.remoteUserConfiguration=R,this.workspaceConfiguration=U,this.folderConfigurationModel=F,this.memoryConfigurationModel=M}get value(){return l(this._value)}inspect(n,s,t){const r=n.inspect(s,t);return{get value(){return l(r.value)},get override(){return l(r.override)},get merged(){return l(r.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class d{constructor(n,s,t,r,a=new g,C=new g,E=new L.ResourceMap,h=new g,y=new L.ResourceMap){this._defaultConfiguration=n,this._policyConfiguration=s,this._applicationConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=a,this._workspaceConfiguration=C,this._folderConfigurations=E,this._memoryConfiguration=h,this._memoryConfigurationByResource=y,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(n,s,t){return this.getConsolidatedConfigurationModel(n,s,t).getValue(n)}updateValue(n,s,t={}){let r;t.resource?(r=this._memoryConfigurationByResource.get(t.resource),r||(r=new g,this._memoryConfigurationByResource.set(t.resource,r))):r=this._memoryConfiguration,s===void 0?r.removeValue(n):r.setValue(n,s),t.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,s,t){const r=this.getConsolidatedConfigurationModel(n,s,t),a=this.getFolderConfigurationModelForResource(s.resource,t),C=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,E=new Set;for(const h of r.overrides)for(const y of h.identifiers)r.getOverrideValue(n,y)!==void 0&&E.add(y);return new u(n,s,r.getValue(n),E.size?[...E]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this._workspaceConfiguration:void 0,a||void 0,C)}keys(n){const s=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,s){this._folderConfigurations.set(n,s),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const t=[];if(!s){const{added:r,updated:a,removed:C}=w(this._defaultConfiguration,n);s=[...r,...a,...C]}for(const r of s)for(const a of(0,b.overrideIdentifiersFromKey)(r)){const C=this._defaultConfiguration.getKeysForOverrideIdentifier(a),E=n.getKeysForOverrideIdentifier(a),h=[...E.filter(y=>C.indexOf(y)===-1),...C.filter(y=>E.indexOf(y)===-1),...C.filter(y=>!D.equals(this._defaultConfiguration.override(a).getValue(y),n.override(a).getValue(y)))];t.push([a,h])}return this.updateDefaultConfiguration(n),{keys:s,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:t,removed:r}=w(this._policyConfiguration,n),a=[...s,...t,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=w(this.applicationConfiguration,n),C=[...s,...t,...r];return C.length&&this.updateApplicationConfiguration(n),{keys:C,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=w(this.localUserConfiguration,n),C=[...s,...t,...r];return C.length&&this.updateLocalUserConfiguration(n),{keys:C,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=w(this.remoteUserConfiguration,n),C=[...s,...t,...r];return C.length&&this.updateRemoteUserConfiguration(n),{keys:C,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=w(this.workspaceConfiguration,n),C=[...s,...t,...r];return C.length&&this.updateWorkspaceConfiguration(n),{keys:C,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const t=this.folderConfigurations.get(n),{added:r,updated:a,removed:C,overrides:E}=w(t,s),h=[...r,...a,...C];return(h.length||!t)&&this.updateFolderConfiguration(n,s),{keys:h,overrides:E}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:a,overrides:C}=w(s,void 0);return{keys:[...t,...r,...a],overrides:C}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,s,t){let r=this.getConsolidatedConfigurationModelForResource(s,t);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:n},s){let t=this.getWorkspaceConsolidatedConfiguration();if(s&&n){const r=s.getFolder(n);r&&(t=this.getFolderConsolidatedConfiguration(r.uri)||t);const a=this._memoryConfigurationByResource.get(n);a&&(t=t.merge(a))}return t}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let s=this._foldersConsolidatedConfigurations.get(n);if(!s){const t=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(n);r?(s=t.merge(r),this._foldersConsolidatedConfigurations.set(n,s)):s=t}return s}getFolderConfigurationModelForResource(n,s){if(s&&n){const t=s.getFolder(n);if(t)return this._folderConfigurations.get(t.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,s)=>{const{contents:t,overrides:r,keys:a}=this._folderConfigurations.get(s);return n.push([s,{contents:t,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this._workspaceConfiguration.keys.forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.keys.forEach(t=>n.add(t))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this._folderConfigurations.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r))),[...s.values()]}static parse(n){const s=this.parseConfigurationModel(n.defaults),t=this.parseConfigurationModel(n.policy),r=this.parseConfigurationModel(n.application),a=this.parseConfigurationModel(n.user),C=this.parseConfigurationModel(n.workspace),E=n.folders.reduce((h,y)=>(h.set(m.URI.revive(y[0]),this.parseConfigurationModel(y[1])),h),new L.ResourceMap);return new d(s,t,r,a,new g,C,E,new g,new L.ResourceMap)}static parseConfigurationModel(n){return new g(n.contents,n.keys,n.overrides)}}e.Configuration=d;function f(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,s=new Map;for(const r of o)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,C])=>{const E=(0,L.getOrSet)(s,a,new Set);C.forEach(h=>E.add(h))});const t=[];return s.forEach((r,a)=>t.push([a,[...r.values()]])),{keys:[...n.values()],overrides:t}}e.mergeChanges=f;class c{constructor(n,s,t,r){this.change=n,this.previous=s,this.currentConfiguraiton=t,this.currentWorkspace=r,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const C of a)this.affectedKeys.add(C);this._affectsConfigStr=this._marker;for(const a of this.affectedKeys)this._affectsConfigStr+=a+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,s){const t=this._marker+n,r=this._affectsConfigStr.indexOf(t);if(r<0)return!1;const a=r+t.length;if(a>=this._affectsConfigStr.length)return!1;const C=this._affectsConfigStr.charCodeAt(a);if(C!==this._markerCode1&&C!==this._markerCode2)return!1;if(s){const E=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.previous?.workspace):void 0,h=this.currentConfiguraiton.getValue(n,s,this.currentWorkspace);return!D.equals(E,h)}return!0}}e.ConfigurationChangeEvent=c;function w(o,n){const{added:s,removed:t,updated:r}=i(n?.rawConfiguration,o?.rawConfiguration),a=[],C=o?.getAllOverrideIdentifiers()||[],E=n?.getAllOverrideIdentifiers()||[];if(n){const h=E.filter(y=>!C.includes(y));for(const y of h)a.push([y,n.getKeysForOverrideIdentifier(y)])}if(o){const h=C.filter(y=>!E.includes(y));for(const y of h)a.push([y,o.getKeysForOverrideIdentifier(y)])}if(n&&o){for(const h of C)if(E.includes(h)){const y=i({contents:o.getOverrideValue(void 0,h)||{},keys:o.getKeysForOverrideIdentifier(h)},{contents:n.getOverrideValue(void 0,h)||{},keys:n.getKeysForOverrideIdentifier(h)});a.push([h,[...y.added,...y.removed,...y.updated]])}}return{added:s,removed:t,updated:r,overrides:a}}function i(o,n){const s=o?n?o.keys.filter(a=>n.keys.indexOf(a)===-1):[...o.keys]:[],t=n?o?n.keys.filter(a=>o.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(o&&n){for(const a of n.keys)if(o.keys.indexOf(a)!==-1){const C=(0,P.getConfigurationValue)(n.contents,a),E=(0,P.getConfigurationValue)(o.contents,a);D.equals(C,E)||r.push(a)}}return{added:s,removed:t,updated:r}}}),define(le[210],ue([0,1,17,3,2,30,12,76,44,8,58,41]),function(se,e,k,O,T,A,L,D,I,m,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class S extends T.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new D.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(b.Registry.as(I.Extensions.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:u})=>this.onDidUpdateConfiguration(Array.from(v),u))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(v,u){this.updateConfigurationModel(v,b.Registry.as(I.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:v})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new D.ConfigurationModel;const v=b.Registry.as(I.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(v),v)}updateConfigurationModel(v,u){const d=this.getConfigurationDefaultOverrides();for(const f of v){const c=d[f],w=u[f];c!==void 0?this._configurationModel.addValue(f,c):w?this._configurationModel.addValue(f,w.default):this._configurationModel.removeValue(f)}}}e.DefaultConfiguration=S;class l{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new D.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=l;let g=class extends T.Disposable{get configurationModel(){return this._configurationModel}constructor(v,u,d){super(),this.defaultConfiguration=v,this.policyService=u,this.logService=d,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new D.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(v=>this.onDidChangePolicies(v))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:v})=>this.update(await this.updatePolicyDefinitions(v),!0))),this._configurationModel}async updatePolicyDefinitions(v){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",v);const u={},d=[],f=b.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(const c of v){const w=f[c];if(!w){d.push(c);continue}if(w.policy){if(w.type!=="string"&&w.type!=="number"){this.logService.warn(`Policy ${w.policy.name} has unsupported type ${w.type}`);continue}d.push(c),u[w.policy.name]={type:w.type}}}return(0,L.isEmptyObject)(u)||await this.policyService.updatePolicyDefinitions(u),d}onDidChangePolicies(v){this.logService.trace("PolicyConfiguration#onDidChangePolicies",v);const u=b.Registry.as(I.Extensions.Configuration).getPolicyConfigurations(),d=(0,k.coalesce)(v.map(f=>u.get(f)));this.update(d,!0)}update(v,u){this.logService.trace("PolicyConfiguration#update",v);const d=b.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),f=[],c=this._configurationModel.isEmpty();for(const w of v){const i=d[w]?.policy?.name;if(i){const o=this.policyService.getPolicyValue(i);(c?o!==void 0:!(0,A.equals)(this._configurationModel.getValue(w),o))&&f.push([w,o])}else this._configurationModel.getValue(w)!==void 0&&f.push([w,void 0])}if(f.length){this.logService.trace("PolicyConfiguration#changed",f);const w=this._configurationModel;this._configurationModel=new D.ConfigurationModel;for(const i of w.keys)this._configurationModel.setValue(i,w.getValue(i));for(const[i,o]of f)o===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,o);u&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=g,e.PolicyConfiguration=g=ye([Y(1,P.IPolicyService),Y(2,m.ILogService)],g)}),define(le[211],ue([0,1,17,6,14,3,34,62,2,30,5,20,21,76,44,210,58]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class u extends I.Disposable{constructor(c,w,i,o){super(),this.settingsResource=c,this._onDidChangeConfiguration=this._register(new A.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new p.DefaultConfiguration),this.policyConfiguration=i instanceof v.NullPolicyService?new p.NullPolicyConfiguration:this._register(new p.PolicyConfiguration(this.defaultConfiguration,i,o)),this.userConfiguration=this._register(new l.UserSettings(this.settingsResource,{},b.extUriBiasedIgnorePathCase,w)),this.configuration=new l.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new l.ConfigurationModel,new l.ConfigurationModel),this.configurationEditing=new d(c,w,this),this.reloadConfigurationScheduler=this._register(new O.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:n,properties:s})=>this.onDidDefaultConfigurationChange(n,s))),this._register(this.policyConfiguration.onDidChangeConfiguration(n=>this.onDidPolicyConfigurationChange(n))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[c,w,i]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new l.Configuration(c,w,new l.ConfigurationModel,i)}getConfigurationData(){return this.configuration.toData()}getValue(c,w){const i=typeof c=="string"?c:void 0,o=(0,S.isConfigurationOverrides)(c)?c:(0,S.isConfigurationOverrides)(w)?w:{};return this.configuration.getValue(i,o,void 0)}async updateValue(c,w,i,o,n){const s=(0,S.isConfigurationUpdateOverrides)(i)?i:(0,S.isConfigurationOverrides)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,t=s?o:i;if(t!==void 0&&t!==3&&t!==2)throw new Error(`Unable to write ${c} to target ${t}.`);s?.overrideIdentifiers&&(s.overrideIdentifiers=(0,k.distinct)(s.overrideIdentifiers),s.overrideIdentifiers=s.overrideIdentifiers.length?s.overrideIdentifiers:void 0);const r=this.inspect(c,{resource:s?.resource,overrideIdentifier:s?.overrideIdentifiers?s.overrideIdentifiers[0]:void 0});if(r.policyValue!==void 0)throw new Error(`Unable to write ${c} because it is configured in system policy.`);if((0,m.equals)(w,r.defaultValue)&&(w=void 0),s?.overrideIdentifiers?.length&&s.overrideIdentifiers.length>1){const C=s.overrideIdentifiers.sort(),E=this.configuration.localUserConfiguration.overrides.find(h=>(0,k.equals)([...h.identifiers].sort(),C));E&&(s.overrideIdentifiers=E.identifiers)}const a=s?.overrideIdentifiers?.length?[(0,g.keyFromOverrideIdentifiers)(s.overrideIdentifiers),c]:[c];await this.configurationEditing.write(a,w),await this.reloadConfiguration()}inspect(c,w={}){return this.configuration.inspect(c,w,void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const c=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(c)}onDidChangeUserConfiguration(c){const w=this.configuration.toData(),i=this.configuration.compareAndUpdateLocalUserConfiguration(c);this.trigger(i,w,2)}onDidDefaultConfigurationChange(c,w){const i=this.configuration.toData(),o=this.configuration.compareAndUpdateDefaultConfiguration(c,w);this.trigger(o,i,7)}onDidPolicyConfigurationChange(c){const w=this.configuration.toData(),i=this.configuration.compareAndUpdatePolicyConfiguration(c);this.trigger(i,w,7)}trigger(c,w,i){const o=new l.ConfigurationChangeEvent(c,{data:w},this.configuration);o.source=i,this._onDidChangeConfiguration.fire(o)}}e.ConfigurationService=u;class d{constructor(c,w,i){this.settingsResource=c,this.fileService=w,this.configurationService=i,this.queue=new O.Queue}write(c,w){return this.queue.queue(()=>this.doWriteConfiguration(c,w))}async doWriteConfiguration(c,w){let i;try{i=(await this.fileService.readFile(this.settingsResource)).value.toString()}catch(s){if(s.fileOperationResult===1)i="{}";else throw s}const o=[];if((0,L.parse)(i,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.getEdits(i,c,w);i=(0,D.applyEdits)(i,n),await this.fileService.writeFile(this.settingsResource,T.VSBuffer.fromString(i))}getEdits(c,w,i){const{tabSize:o,insertSpaces:n,eol:s}=this.formattingOptions;if(!w.length){const t=JSON.stringify(i,null,n?" ".repeat(o):"	");return[{content:t,length:t.length,offset:0}]}return(0,D.setProperty)(c,w,i,{tabSize:o,insertSpaces:n,eol:s})}get formattingOptions(){if(!this._formattingOptions){let c=P.OS===3||P.OS===2?`
`:`\r
`;const w=this.configurationService.getValue("files.eol",{overrideIdentifier:"jsonc"});w&&typeof w=="string"&&w!=="auto"&&(c=w),this._formattingOptions={eol:c,insertSpaces:!!this.configurationService.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.configurationService.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this._formattingOptions}}}),define(le[212],ue([0,1,14,3,2,68]),function(se,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagedSocket=e.connectManagedSocket=e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0;const L=(m,P,b)=>{const S=new Uint8Array(16);for(let p=0;p<16;p++)S[p]=Math.round(Math.random()*256);const l=(0,k.encodeBase64)(k.VSBuffer.wrap(S));return[`GET ws://localhost${m}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${l}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=L,e.socketRawEndHeaderSequence=k.VSBuffer.fromString(`\r
\r
`);async function D(m,P,b,S,l){m.write(k.VSBuffer.fromString((0,e.makeRawSocketHeaders)(P,b,S)));const g=new T.DisposableStore;try{return await new Promise((p,v)=>{let u;g.add(m.onData(d=>{u?u=k.VSBuffer.concat([u,d],u.byteLength+d.byteLength):u=d;const f=u.indexOf(e.socketRawEndHeaderSequence);if(f===-1)return;p(m),m.pauseData();const c=u.slice(f+e.socketRawEndHeaderSequence.byteLength);c.byteLength&&l.onData.fire(c)})),g.add(m.onClose(d=>v(d??new Error("socket closed")))),g.add(m.onEnd(()=>v(new Error("socket ended"))))})}catch(p){throw m.dispose(),p}finally{g.dispose()}}e.connectManagedSocket=D;class I extends T.Disposable{constructor(P,b){super(),this.debugLabel=P,this.pausableDataEmitter=this._register(new O.PauseableEmitter),this.onData=(...S)=>(this.pausableDataEmitter.isPaused&&queueMicrotask(()=>this.pausableDataEmitter.resume()),this.pausableDataEmitter.event(...S)),this.didDisposeEmitter=this._register(new O.Emitter),this.onDidDispose=this.didDisposeEmitter.event,this.ended=!1,this._register(b.onData),this._register(b.onData.event(S=>this.pausableDataEmitter.fire(S))),this.onClose=this._register(b.onClose).event,this.onEnd=this._register(b.onEnd).event}pauseData(){this.pausableDataEmitter.pause()}drain(){return Promise.resolve()}end(){this.ended=!0,this.closeRemote()}traceSocketEvent(P,b){A.SocketDiagnostics.traceSocketEvent(this,this.debugLabel,P,b)}dispose(){this.ended||this.closeRemote(),this.didDisposeEmitter.fire(),super.dispose()}}e.ManagedSocket=I}),define(le[213],ue([0,1,7,4]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,O.createDecorator)("remoteAuthorityResolverService");var T;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(T||(e.RemoteConnectionType=T={}));class A{constructor(b){this.id=b,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=A;class L{constructor(b,S){this.host=b,this.port=S,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=L;var D;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(D||(e.RemoteAuthorityResolverErrorCode=D={}));class I extends k.ErrorNoTelemetry{static isNotAvailable(b){return b instanceof I&&b._code===D.NotAvailable}static isTemporarilyNotAvailable(b){return b instanceof I&&b._code===D.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof I&&b._code===D.NoResolverFound}static isInvalidAuthority(b){return b instanceof I&&b._code===D.InvalidAuthority}static isHandled(b){return b instanceof I&&b.isHandled}constructor(b,S=D.Unknown,l){super(b),this._message=b,this._code=S,this._detail=l,this.isHandled=S===D.NotAvailable&&l===!0,Object.setPrototypeOf(this,I.prototype)}}e.RemoteAuthorityResolverError=I;function m(P){const b=P.indexOf("+");return b===-1?P:P.substring(0,b)}e.getRemoteAuthorityPrefix=m}),define(le[77],ue([0,1,23]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function O(m){return m.scheme===k.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=O;function T(m){if(!m)return;const P=m.indexOf("+");return P<0?m:m.substr(0,P)}e.getRemoteName=T;function A(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=A;function L(m){const{host:P,port:b}=I(m);if(typeof b>"u")throw new Error(`Invalid remote authority: ${m}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:P,port:b}}e.parseAuthorityWithPort=L;function D(m,P){let{host:b,port:S}=I(m);return typeof S>"u"&&(S=P),{host:b,port:S}}e.parseAuthorityWithOptionalPort=D;function I(m){const P=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const b=m.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const S=m.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:m,port:void 0}}}),define(le[45],ue([0,1,27,4,77]),function(se,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(L||(e.ExtensionType=L={}));var D;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.LINUX_PPC64LE="linux-ppc64le",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(D||(e.TargetPlatform=D={}));class I{constructor(v){this.value=v,this._lower=v.toLowerCase()}static equals(v,u){if(typeof v>"u"||v===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof v=="string"||typeof u=="string"){const d=typeof v=="string"?v:v.value,f=typeof u=="string"?u:u.value;return k.equalsIgnoreCase(d,f)}return v._lower===u._lower}static toKey(v){return typeof v=="string"?v.toLowerCase():v._lower}}e.ExtensionIdentifier=I;class m{get size(){return this._set.size}constructor(v){if(this._set=new Set,v)for(const u of v)this.add(u)}add(v){this._set.add(I.toKey(v))}delete(v){return this._set.delete(I.toKey(v))}has(v){return this._set.has(I.toKey(v))}}e.ExtensionIdentifierSet=m;class P{constructor(){this._map=new Map}clear(){this._map.clear()}delete(v){this._map.delete(I.toKey(v))}get(v){return this._map.get(I.toKey(v))}has(v){return this._map.has(I.toKey(v))}set(v,u){this._map.set(I.toKey(v),u)}values(){return this._map.values()}forEach(v){this._map.forEach(v)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=P;function b(p){return S(p)}e.isApplicationScopedExtension=b;function S(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function l(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=l;function g(p,v){if(v){const u=`onResolveRemoteAuthority:${(0,T.getRemoteName)(v)}`;return!!p.activationEvents?.includes(u)}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(le[214],ue([0,1,2,45,11]),function(se,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends k.Disposable{constructor(D,I,m,P,b){super(),this.userDataProfilesService=D,this.fileService=I,this.uriIdentityService=m,this.logService=b,this._register(P.onDidInstallExtensions(S=>this.onDidInstallExtensions(S))),this._register(P.onDidUninstallExtension(S=>this.onDidUnInstallExtension(S)))}onDidInstallExtensions(D){for(const I of D)I.local&&this.invalidate(I.profileLocation)}onDidUnInstallExtension(D){D.error||this.invalidate(D.profileLocation)}async invalidate(D){if(D)for(const I of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(I.extensionsResource,D)&&await this.deleteUserCacheFile(I);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(D){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(D.cacheHome,O.USER_MANIFEST_CACHE_FILE))}catch(I){(0,T.toFileOperationResult)(I)!==1&&this.logService.error(I)}}}e.ExtensionsManifestCache=A}),define(le[215],ue([0,1,6,14,26,7,3,2,100,63,32,68,213,77]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const g=30*1e3;var p;(function(W){W[W.Management=1]="Management",W[W.ExtensionHost=2]="ExtensionHost",W[W.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function v(W){switch(W){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(W){const _=new T.CancellationTokenSource;return setTimeout(()=>_.cancel(),W),_.token}function d(W,_){if(W.isCancellationRequested||_.isCancellationRequested)return T.CancellationToken.Cancelled;const N=new T.CancellationTokenSource;return W.onCancellationRequested(()=>N.cancel()),_.onCancellationRequested(()=>N.cancel()),N.token}class f{get didTimeout(){return this._state==="timedout"}constructor(_){this._state="pending",this._disposables=new D.DisposableStore,this.promise=new Promise((N,z)=>{this._resolvePromise=N,this._rejectPromise=z}),_.isCancellationRequested?this._timeout():this._disposables.add(_.onCancellationRequested(()=>this._timeout()))}registerDisposable(_){this._state==="pending"?this._disposables.add(_):_.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const _=new Error("Time limit reached");return _.code="ETIMEDOUT",_.syscall="connect",_}resolve(_){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(_))}reject(_){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(_))}}function c(W,_){const N=new f(_);return N.registerDisposable(W.onControlMessage(z=>{const $=JSON.parse(z.toString()),Z=q($);Z?N.reject(Z):N.resolve($)})),N.promise}function w(W,_,N,z,$,Z,B,H){const te=new f(H),ne=m.StopWatch.create(!1);return W.info(`Creating a socket (${B})...`),I.mark(`code/willCreateSocket/${Z}`),_.connect(N,z,$,B).then(ce=>{te.didTimeout?(I.mark(`code/didCreateSocketError/${Z}`),W.info(`Creating a socket (${B}) finished after ${ne.elapsed()} ms, but this is too late and has timed out already.`),ce?.dispose()):(I.mark(`code/didCreateSocketOK/${Z}`),W.info(`Creating a socket (${B}) was successful after ${ne.elapsed()} ms.`),te.resolve(ce))},ce=>{I.mark(`code/didCreateSocketError/${Z}`),W.info(`Creating a socket (${B}) returned an error after ${ne.elapsed()} ms.`),W.error(ce),te.reject(ce)}),te.promise}function i(W,_){const N=new f(_);return W.then(z=>{N.didTimeout||N.resolve(z)},z=>{N.didTimeout||N.reject(z)}),N.promise}async function o(W,_,N,z){const $=ae(W,_);W.logService.trace(`${$} 1/6. invoking socketFactory.connect().`);let Z;try{Z=await w(W.logService,W.remoteSocketFactoryService,W.connectTo,(0,l.getRemoteServerRootPath)(W),`reconnectionToken=${W.reconnectionToken}&reconnection=${W.reconnectionProtocol?"true":"false"}`,v(_),`renderer-${v(_)}-${W.reconnectionToken}`,z)}catch(ce){throw W.logService.error(`${$} socketFactory.connect() failed or timed out. Error:`),W.logService.error(ce),ce}W.logService.trace(`${$} 2/6. socketFactory.connect() was successful.`);let B,H;W.reconnectionProtocol?(W.reconnectionProtocol.beginAcceptReconnection(Z,null),B=W.reconnectionProtocol,H=!1):(B=new b.PersistentProtocol({socket:Z}),H=!0),W.logService.trace(`${$} 3/6. sending AuthRequest control message.`);const te=await i(W.signService.createNewMessage((0,P.generateUuid)()),z),ne={type:"auth",auth:W.connectionToken||"00000000000000000000",data:te.data};B.sendControl(O.VSBuffer.fromString(JSON.stringify(ne)));try{const ce=await c(B,d(z,u(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if(W.logService.trace(`${$} 4/6. received SignRequest control message.`),!await i(W.signService.validate(te,ce.signedData),z)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const ge=await i(W.signService.sign(ce.data),z),Se={type:"connectionType",commit:W.commit,signedData:ge,desiredConnectionType:_};return N&&(Se.args=N),W.logService.trace(`${$} 5/6. sending ConnectionTypeRequest control message.`),B.sendControl(O.VSBuffer.fromString(JSON.stringify(Se))),{protocol:B,ownsProtocol:H}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(W.logService.error(`${$} the handshake timed out. Error:`),W.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(W.logService.error(`${$} received error control message when negotiating connection. Error:`),W.logService.error(ce)),H&&V(B),ce}}async function n(W,_,N,z){const $=Date.now(),Z=ae(W,_),{protocol:B,ownsProtocol:H}=await o(W,_,N,z),te=new f(z);return te.registerDisposable(B.onControlMessage(ne=>{const ce=JSON.parse(ne.toString()),fe=q(ce);fe?(W.logService.error(`${Z} received error control message when negotiating connection. Error:`),W.logService.error(fe),H&&V(B),te.reject(fe)):(W.reconnectionProtocol?.endAcceptReconnection(),W.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${G($)}!`),te.resolve({protocol:B,firstMessage:ce}))})),te.promise}async function s(W,_){const{protocol:N}=await n(W,1,void 0,_);return{protocol:N}}async function t(W,_,N){const{protocol:z,firstMessage:$}=await n(W,2,_,N),Z=$&&$.debugPort;return{protocol:z,debugPort:Z}}async function r(W,_,N){const z=Date.now(),$=ae(W,3),{protocol:Z}=await o(W,3,_,N);return W.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${G(z)}!`),Z}async function a(W,_,N){const{connectTo:z,connectionToken:$}=await W.addressProvider.getAddress();return{commit:W.commit,quality:W.quality,connectTo:z,connectionToken:$,reconnectionToken:_,reconnectionProtocol:N,remoteSocketFactoryService:W.remoteSocketFactoryService,signService:W.signService,logService:W.logService}}async function C(W,_,N){return h(W,async z=>{const{protocol:$}=await s(z,T.CancellationToken.None);return new x(W,_,N,z.reconnectionToken,$)})}e.connectRemoteAgentManagement=C;async function E(W,_){return h(W,async N=>{const{protocol:z,debugPort:$}=await t(N,_,T.CancellationToken.None);return new J(W,_,N.reconnectionToken,z,$)})}e.connectRemoteAgentExtensionHost=E;async function h(W,_){for(let z=1;;z++)try{const $=(0,P.generateUuid)(),Z=await a(W,$,null);return await _(Z)}catch($){if(z<5)W.logService.error(`[remote-connection][attempt ${z}] An error occurred in initial connection! Will retry... Error:`),W.logService.error($);else throw W.logService.error(`[remote-connection][attempt ${z}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),W.logService.error($),X.triggerPermanentFailure(0,0,S.RemoteAuthorityResolverError.isHandled($)),$}}async function y(W,_,N){const z=await a(W,(0,P.generateUuid)(),null);return await r(z,{host:_,port:N},T.CancellationToken.None)}e.connectRemoteAgentTunnel=y;function R(W){return(0,k.createCancelablePromise)(_=>new Promise((N,z)=>{const $=setTimeout(N,W*1e3);_.onCancellationRequested(()=>{clearTimeout($),N()})}))}var U;(function(W){W[W.ConnectionLost=0]="ConnectionLost",W[W.ReconnectionWait=1]="ReconnectionWait",W[W.ReconnectionRunning=2]="ReconnectionRunning",W[W.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",W[W.ConnectionGain=4]="ConnectionGain"})(U||(e.PersistentConnectionEventType=U={}));class F{constructor(_,N){this.reconnectionToken=_,this.millisSinceLastIncomingData=N,this.type=0}}e.ConnectionLostEvent=F;class M{constructor(_,N,z,$){this.reconnectionToken=_,this.millisSinceLastIncomingData=N,this.durationSeconds=z,this.cancellableTimer=$,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=M;class j{constructor(_,N,z){this.reconnectionToken=_,this.millisSinceLastIncomingData=N,this.attempt=z,this.type=2}}e.ReconnectionRunningEvent=j;class Q{constructor(_,N,z){this.reconnectionToken=_,this.millisSinceLastIncomingData=N,this.attempt=z,this.type=4}}e.ConnectionGainEvent=Q;class K{constructor(_,N,z,$){this.reconnectionToken=_,this.millisSinceLastIncomingData=N,this.attempt=z,this.handled=$,this.type=3}}e.ReconnectionPermanentFailureEvent=K;class X extends D.Disposable{static triggerPermanentFailure(_,N,z){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=_,this._permanentFailureAttempt=N,this._permanentFailureHandled=z,this._instances.forEach($=>$._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(_=>_._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(_=>_._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||X._permanentFailure}constructor(_,N,z,$,Z){super(),this._connectionType=_,this._options=N,this.reconnectionToken=z,this.protocol=$,this._reconnectionFailureIsFatal=Z,this._onDidStateChange=this._register(new L.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new Q(this.reconnectionToken,0,0)),this._register($.onSocketClose(B=>{const H=ee(this._connectionType,this.reconnectionToken,!0);B?B.type===0?(this._options.logService.info(`${H} received socket close event (hadError: ${B.hadError}).`),B.error&&this._options.logService.error(B.error)):(this._options.logService.info(`${H} received socket close event (wasClean: ${B.wasClean}, code: ${B.code}, reason: ${B.reason}).`),B.event&&this._options.logService.error(B.event)):this._options.logService.info(`${H} received socket close event.`),this._beginReconnecting()})),this._register($.onSocketTimeout(B=>{const H=ee(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${H} received socket timeout event (unacknowledgedMsgCount: ${B.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${B.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${B.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),X._instances.push(this),this._register((0,D.toDisposable)(()=>{const B=X._instances.indexOf(this);B>=0&&X._instances.splice(B,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(X._permanentFailureMillisSinceLastIncomingData,X._permanentFailureAttempt,X._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const _=ee(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${_} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const N=[0,5,5,10,10,10,10,10,30];let z=-1;do{z++;const $=z<N.length?N[z]:N[N.length-1];try{if($>0){const B=R($);this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$,B)),this._options.logService.info(`${_} waiting for ${$} seconds before reconnecting...`);try{await B}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${_} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1)),this._options.logService.info(`${_} resolving connection...`);const Z=await a(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${_} connecting to ${Z.connectTo}...`),await this._reconnect(Z,u(g)),this._options.logService.info(`${_} reconnected!`),this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${_} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(Z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(z>360){this._options.logService.error(`${_} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(Z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(S.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Z)){this._options.logService.info(`${_} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this._options.logService.info(`${_} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if((0,A.isCancellationError)(Z)){this._options.logService.info(`${_} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if(Z instanceof S.RemoteAuthorityResolverError){this._options.logService.error(`${_} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(Z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),z+1,S.RemoteAuthorityResolverError.isHandled(Z));break}this._options.logService.error(`${_} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(Z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(_,N,z){this._reconnectionFailureIsFatal?X.triggerPermanentFailure(_,N,z):this._gotoPermanentFailure(_,N,z)}_gotoPermanentFailure(_,N,z){this._onDidStateChange.fire(new K(this.reconnectionToken,_,N,z)),V(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=X;class x extends X{constructor(_,N,z,$,Z){super(1,_,$,Z,!0),this.client=this._register(new b.Client(Z,{remoteAuthority:N,clientId:z},_.ipcLogger))}async _reconnect(_,N){await s(_,N)}}e.ManagementPersistentConnection=x;class J extends X{constructor(_,N,z,$,Z){super(2,_,z,$,!1),this._startArguments=N,this.debugPort=Z}async _reconnect(_,N){await t(_,this._startArguments,N)}}e.ExtensionHostPersistentConnection=J;function V(W){try{W.acceptDisconnect();const _=W.getSocket();W.dispose(),_.dispose()}catch(_){(0,A.onUnexpectedError)(_)}}function q(W){if(W&&W.type==="error"){const _=new Error(`Connection error: ${W.reason}`);return _.code="VSCODE_CONNECTION_ERROR",_}return null}function ie(W,_){for(;W.length<_;)W+=" ";return W}function re(W,_){return`[remote-connection][${ie(v(W),13)}][${_.substr(0,5)}\u2026]`}function ee(W,_,N){return`${re(W,_)}[${N?"reconnect":"initial"}]`}function ae(W,_){return`${ee(_,W.reconnectionToken,!!W.reconnectionProtocol)}[${W.connectTo}]`}function G(W){return`${Date.now()-W} ms`}}),define(le[104],ue([0,1,2,4]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,O.createDecorator)("remoteSocketFactoryService");class T{constructor(){this.factories={}}register(L,D){return this.factories[L]??=[],this.factories[L].push(D),(0,k.toDisposable)(()=>{const I=this.factories[L]?.indexOf(D);typeof I=="number"&&I>=0&&this.factories[L]?.splice(I,1)})}getSocketFactory(L){return(this.factories[L.type]||[]).find(I=>I.supports(L))}connect(L,D,I,m){const P=this.getSocketFactory(L);if(!P)throw new Error(`No socket factory found for ${L}`);return P.connect(L,D,I,m)}}e.RemoteSocketFactoryService=T}),define(le[216],ue([0,1,4]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,k.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(le[105],ue([0,1,4,164]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOGGER_NAME=e.LOG_ID=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.INACTIVE_TUNNEL_MODE=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,k.createDecorator)("IRemoteTunnelService"),e.INACTIVE_TUNNEL_MODE={active:!1};var T;(function(A){A.disconnected=L=>({type:"disconnected",onTokenFailed:L}),A.connected=(L,D)=>({type:"connected",info:L,serviceInstallFailed:D}),A.connecting=L=>({type:"connecting",progress:L}),A.uninitialized={type:"uninitialized"}})(T||(e.TunnelStates=T={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_ID="remoteTunnelService",e.LOGGER_NAME=(0,O.localize)(0,null)}),define(le[59],ue([0,1,14,7,2,166,44,4,8,41]),function(se,e,k,O,T,A,L,D,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.hasNoContent=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,D.createDecorator)("requestService");class P{constructor(w){this.original=w}toJSON(){if(!this.headers){const w=Object.create(null);for(const i in this.original)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?w[i]="*****":w[i]=this.original[i];this.headers=w}return this.headers}}class b extends T.Disposable{constructor(w){super(),this.counter=0,this.logger=w.createLogger("network",{name:(0,A.localize)(0,null),when:I.CONTEXT_LOG_LEVEL.isEqualTo((0,I.LogLevelToString)(I.LogLevel.Trace)).serialize()})}async logAndRequest(w,i,o){const n=`${w} #${++this.counter}: ${i.url}`;this.logger.trace(`${n} - begin`,i.type,new P(i.headers??{}));try{const s=await o();return this.logger.trace(`${n} - end`,i.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.logger.error(`${n} - error`,i.type,(0,O.getErrorMessage)(s)),s}}}e.AbstractRequestService=b;function S(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}e.isSuccess=S;function l(c){return c.res.statusCode===204}e.hasNoContent=l;async function g(c){return l(c)?null:(await(0,k.streamToBuffer)(c.stream)).toString()}e.asText=g;async function p(c){if(!S(c))throw new Error("Server returned "+c.res.statusCode);return g(c)}e.asTextOrError=p;async function v(c){if(!S(c))throw new Error("Server returned "+c.res.statusCode);if(l(c))return null;const i=(await(0,k.streamToBuffer)(c.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}e.asJson=v;function u(c){f(c)}e.updateProxyConfigurationsScope=u;let d;function f(c){const w=m.Registry.as(L.Extensions.Configuration),i=d;d={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},w.updateConfigurations({add:[d],remove:i?[i]:[]})}f(1)}),define(le[217],ue([0,1,26,23,11,59]),function(se,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let L=class{constructor(I,m){this.requestService=I,this.fileService=m}async download(I,m,P=k.CancellationToken.None){if(I.scheme===O.Schemas.file||I.scheme===O.Schemas.vscodeRemote){await this.fileService.copy(I,m);return}const b={type:"GET",url:I.toString(!0)},S=await this.requestService.request(b,P);if(S.res.statusCode===200)await this.fileService.writeFile(m,S.stream);else{const l=await(0,A.asTextOrError)(S);throw new Error(`Expected 200, got back ${S.res.statusCode} instead.

${l}`)}}};e.DownloadService=L,e.DownloadService=L=ye([Y(0,A.IRequestService),Y(1,T.IFileService)],L)}),define(le[218],ue([0,1,14,26]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class T{constructor(D){this.service=D}listen(D,I){throw new Error("Invalid listen")}call(D,I,m,P=O.CancellationToken.None){switch(I){case"request":return this.service.request(m[0],P).then(async({res:b,stream:S})=>{const l=await(0,k.streamToBuffer)(S);return[{statusCode:b.statusCode,headers:b.headers},l]});case"resolveProxy":return this.service.resolveProxy(m[0]);case"loadCertificates":return this.service.loadCertificates()}throw new Error("Invalid call")}}e.RequestChannel=T;class A{constructor(D){this.channel=D}async request(D,I){const[m,P]=await this.channel.call("request",[D],I);return{res:m,stream:(0,k.bufferToStream)(P)}}async resolveProxy(D){return this.channel.call("resolveProxy",[D])}async loadCertificates(){return this.channel.call("loadCertificates")}}e.RequestChannelClient=A}),define(le[219],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRawConnection=e.SharedProcessChannelConnection=e.SharedProcessLifecycle=void 0,e.SharedProcessLifecycle={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.SharedProcessChannelConnection={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.SharedProcessRawConnection={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[220],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class k{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(T){try{const A=await this.getValidator();if(A){const L=String(k._nextId++);return this.validators.set(L,A),{id:L,data:A.createNewMessage(T)}}}catch{}return{id:"",data:T}}async validate(T,A){if(!T.id)return!0;const L=this.validators.get(T.id);if(!L)return!1;this.validators.delete(T.id);try{return L.validate(A)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(T){try{return await this.signValue(T)}catch{}return T}}e.AbstractSignService=k}),define(le[106],ue([0,1,4]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,k.createDecorator)(e.SIGN_SERVICE_ID)}),define(le[221],ue([0,1,220]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class O extends k.AbstractSignService{getValidator(){return this.vsda().then(A=>new A.validator)}signValue(A){return this.vsda().then(L=>new L.signer().sign(A))}vsda(){return new Promise((A,L)=>se(["vsda"],A,L))}}e.SignService=O}),define(le[78],ue([0,1,3,2]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class T extends O.Disposable{constructor(b,S,l){super(),this.channel=b,this.profile=S,this.workspace=l}async getItems(){const b={profile:this.profile,workspace:this.workspace},S=await this.channel.call("getItems",b);return new Map(S)}updateItems(b){const S={profile:this.profile,workspace:this.workspace};return b.insert&&(S.insert=Array.from(b.insert.entries())),b.delete&&(S.delete=Array.from(b.delete.values())),this.channel.call("updateItems",S)}optimize(){const b={profile:this.profile,workspace:this.workspace};return this.channel.call("optimize",b)}}class A extends T{constructor(b,S){super(b,S,void 0),this._onDidChangeItemsExternal=this._register(new k.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(b=>this.onDidChangeStorage(b)))}onDidChangeStorage(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this._onDidChangeItemsExternal.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}}class L extends A{constructor(b){super(b,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=L;class D extends A{constructor(b,S){super(b,S)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=D;class I extends T{constructor(b,S){super(b,void 0,S),this.onDidChangeItemsExternal=k.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=I;class m{constructor(b){this.channel=b}isUsed(b){const S={payload:b,profile:void 0,workspace:void 0};return this.channel.call("isUsed",S)}}e.StorageClient=m}),define(le[107],ue([0,1,5,37,32]),function(se,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(I){if(k.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}function L(I,m,P,b,S,l,g,p,v){const u=Object.create(null);u["common.machineId"]=l,u["common.sqmId"]=g,u.sessionID=(0,T.generateUuid)()+Date.now(),u.commitHash=b,u.version=S,u["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,k.PlatformToString)(k.platform),u["common.nodePlatform"]=O.platform,u["common.nodeArch"]=P,u["common.product"]=v||"desktop",p&&(u["common.msftInternal"]=p);let d=0;const f=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),k.isLinuxSnap&&(u["common.snap"]="true");const c=A(m);return c&&(u["common.platformDetail"]=c),u}e.resolveCommonProperties=L;function D(I){const m=O.env.USERDNSDOMAIN;if(!m)return!1;const P=m.toLowerCase();return I.some(b=>P===b)}e.verifyMicrosoftInternalDomain=D}),define(le[22],ue([0,1,4]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var T;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(T||(e.TelemetryConfiguration=T={}))}),define(le[222],ue([0,1,36,6,34,23,16,5,10,143,31,146,95,11,24,22]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const v=new Map;async function u(i,o){const n=`${i}::${o.join(":")}`,s=v.get(n);if(s)return s;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,C=2e4;function E(y,R,U,F){const M=R.substring(y.length+1);return O.Promises.withAsyncBody(async j=>{let Q;try{Q=await P.Promises.readdir(R,{withFileTypes:!0})}catch{j();return}if(F.count>=C){F.count+=Q.length,F.maxReached=!0,j();return}let K=Q.length;if(K===0){j();return}let X=Q;F.count+Q.length>C&&(F.maxReached=!0,K=C-F.count,X=Q.slice(0,K)),F.count+=Q.length;for(const x of X)if(x.isDirectory()){if(U.includes(x.name)||await E(y,(0,L.join)(R,x.name),U,F),--K===0){j();return}}else{const J=x.name.lastIndexOf(".");if(J>=0){const V=x.name.substring(J+1);V&&r.set(V,(r.get(V)??0)+1)}for(const V of t)V.relativePathPattern?.test(M)!==!1&&V.filePattern.test(x.name)&&a.set(V.tag,(a.get(V.tag)??0)+1);if(--K===0){j();return}}})}const h=O.Promises.withAsyncBody(async y=>{const R={count:0,maxReached:!1};await E(i,i,o,R);const U=await c(i);y({configFiles:d(a),fileTypes:d(r),fileCount:R.count,maxFilesReached:R.maxReached,launchConfigFiles:U})});return v.set(n,h),h}e.collectWorkspaceStats=u;function d(i){return Array.from(i.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function f(){const i={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/l.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/l.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(m.virtualMachineHint.value()*100)}%`},o=k.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}e.getMachineInfo=f;async function c(i){try{const o=new Map,n=(0,L.join)(i,".vscode","launch.json"),s=await P.Promises.readFile(n),t=[],r=(0,T.parse)(s.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,T.getNodeType)(r)==="object"&&r.configurations)for(const a of r.configurations){const C=a.type;C&&(o.has(C)?o.set(C,o.get(C)+1):o.set(C,1))}return d(o)}catch{return[]}}e.collectLaunchConfigs=c;let w=class{constructor(o,n){this.telemetryService=o,this.productService=n}formatMachineInfo(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}formatEnvironment(o){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const s=k.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(k.totalmem()/l.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/l.ByteSize.GB).toFixed(2)}GB free)`),D.isWindows||n.push(`Load (avg):       ${k.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(m.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,b.listProcesses)(o.mainPID),this.formatWorkspaceMetadata(o)]).then(async s=>{let[t,r]=s,a=this.formatProcessList(o,t);return n.forEach(C=>{if((0,S.isRemoteDiagnosticError)(C))a+=`
${C.errorMessage}`,r+=`
${C.errorMessage}`;else if(a+=`

Remote: ${C.hostName}`,C.processes&&(a+=`
${this.formatProcessList(o,C.processes)}`),C.workspaceMetadata){r+=`
|  Remote: ${C.hostName}`;for(const E of Object.keys(C.workspaceMetadata)){const h=C.workspaceMetadata[E];let y=`${h.fileCount} files`;h.maxFilesReached&&(y=`more than ${y}`),r+=`|    Folder (${E}): ${y}`,r+=this.formatWorkspaceStats(h)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,n){const{memory:s,vmHint:t,os:r,cpus:a}=f(),C={os:r,memory:s,cpus:a,vmHint:t,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return D.isWindows||(C.load=`${k.loadavg().map(E=>Math.round(E)).join(", ")}`),D.isLinux&&(C.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(C)}async getDiagnostics(o,n){const s=[];return(0,b.listProcesses)(o.mainPID).then(async t=>(s.push(""),s.push(this.formatEnvironment(o)),s.push(""),s.push(this.formatProcessList(o,t)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(o))),n.forEach(r=>{if((0,S.isRemoteDiagnosticError)(r))s.push(`
${r.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${r.hostName}`),s.push(this.formatMachineInfo(r.machineInfo)),r.processes&&s.push(this.formatProcessList(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const C=r.workspaceMetadata[a];let E=`${C.fileCount} files`;C.maxFilesReached&&(E=`more than ${E}`),s.push(`Folder (${a}): ${E}`),s.push(this.formatWorkspaceStats(C))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(o){const n=[];let t=0;const r=(h,y)=>{const R=` ${h}(${y})`;t+R.length>60?(n.push(a),a="|                 ",t=a.length):t+=R.length,a+=R};let a="|      File types:";const C=10,E=o.fileTypes.length>C?C:o.fileTypes.length;for(let h=0;h<E;h++){const y=o.fileTypes[h];r(y.name,y.count)}if(n.push(a),o.configFiles.length>=0&&(a="|      Conf files:",t=0,o.configFiles.forEach(h=>{r(h.name,h.count)}),n.push(a)),o.launchConfigFiles.length>0){let h="|      Launch Configs:";o.launchConfigFiles.forEach(y=>{const R=y.count>1?` ${y.name}(${y.count})`:` ${y.name}`;h+=R}),n.push(h)}return n.join(`
`)}expandGPUFeatures(o){const n=Math.max(...Object.keys(o).map(s=>s.length));return Object.keys(o).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${o[s]}`).join(`
                  `)}formatWorkspaceMetadata(o){const n=[],s=[];return o.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const a=I.URI.revive(r);if(a.scheme===A.Schemas.file){const C=a.fsPath;s.push(u(C,["node_modules",".git"]).then(E=>{let h=`${E.fileCount} files`;E.maxFilesReached&&(h=`more than ${h}`),n.push(`|    Folder (${(0,L.basename)(C)}): ${h}`),n.push(this.formatWorkspaceStats(E))}).catch(E=>{n.push(`|      Error: Unable to collect workspace stats for folder ${C} (${E.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}formatProcessList(o,n){const s=new Map;o.windows.forEach(r=>s.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>s.set(r,a));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(o.mainPID,s,t,n,0),t.join(`
`)}formatProcessItem(o,n,s,t,r){const a=r===0;let C;a?C=t.pid===o?`${this.productService.applicationName} main`:"remote agent":n.has(t.pid)?C=n.get(t.pid):C=`${"  ".repeat(r)} ${t.name}`;const E=process.platform==="win32"?t.mem:k.totalmem()*(t.mem/100);s.push(`${t.load.toFixed(0).padStart(5," ")}	${(E/l.ByteSize.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${C}`),Array.isArray(t.children)&&t.children.forEach(h=>this.formatProcessItem(o,n,s,h,r+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:s}of o.folders){const t=I.URI.revive(s);if(t.scheme!==A.Schemas.file)continue;const r=t.fsPath;try{(await u(r,["node_modules",".git"])).fileTypes.forEach(C=>n.add(C.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const s=I.URI.revive(n);if(s.scheme!==A.Schemas.file)continue;const t=s.fsPath;try{const r=await u(t,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.DiagnosticsService=w,e.DiagnosticsService=w=ye([Y(0,p.ITelemetryService),Y(1,g.IProductService)],w)}),define(le[108],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class k{constructor(A){this.appenders=A}listen(A,L){throw new Error(`Event not found: ${L}`)}call(A,L,{eventName:D,data:I}){return this.appenders.forEach(m=>m.log(D,I)),Promise.resolve(null)}}e.TelemetryAppenderChannel=k;class O{constructor(A){this.channel=A}log(A,L){return this.channel.call("log",{eventName:A,data:L}).then(void 0,D=>`Failed to log telemetry: ${console.warn(D)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=O}),define(le[46],ue([0,1,30,12,77,107,22]),function(se,e,k,O,T,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class D{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=D;class I{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=I,e.NullTelemetryService=new I;class m{async publicLog(o,n,s){}async publicLogError(o,n,s){}}e.NullEndpointTelemetryService=m,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function P(i,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!i.enableTelemetry)}e.supportsTelemetry=P;function b(i,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=b;function S(i){const o=i.getValue(L.TELEMETRY_SETTING_ID),n=i.getValue(L.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(L.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=S;function l(i){const o={},n={},s={};v(i,s);for(let t in s){t=t.length>150?t.substr(t.length-149):t;const r=s[t];typeof r=="number"?n[t]=r:typeof r=="boolean"?n[t]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${t} has been trimmed to 8192, the original length is ${r.length}`),o[t]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(o[t]=r)}return{properties:o,measurements:n}}e.validateTelemetryData=l;const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(i){if(!i)return"none";const o=(0,T.getRemoteName)(i);return g.has(o)?o:"other"}e.cleanRemoteAuthority=p;function v(i,o,n=0,s){if(i)for(const t of Object.getOwnPropertyNames(i)){const r=i[t],a=s?s+t:t;Array.isArray(r)?o[a]=(0,k.safeStringify)(r):r instanceof Date?o[a]=r.toISOString():(0,O.isObject)(r)?n<2?v(r,o,n+1,a+"."):o[a]=(0,k.safeStringify)(r):o[a]=r}}function u(i,o){const n=i.msftInternalDomains||[],s=o.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(n)||s}e.isInternalTelemetry=u;function d(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=d;function f(i,o){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let n=i;const s=[];for(const C of o)for(;;){const E=C.exec(i);if(!E)break;s.push([E.index,C.lastIndex])}const t=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(n="";;){const C=r.exec(i);if(!C)break;const E=s.some(([h,y])=>C.index<y&&h<r.lastIndex);!t.test(C[0])&&!E&&(n+=i.substring(a,C.index)+"<REDACTED: user-file-path>",a=r.lastIndex)}return a<i.length&&(n+=i.substr(a)),n}function c(i){if(!i)return i;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of o)if(n.regex.test(i))return`<REDACTED: ${n.label}>`;return i}function w(i,o){return(0,k.cloneAndChange)(i,n=>{if(n instanceof D||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let s=n.replaceAll("%20"," ");s=f(s,o);for(const t of o)s=s.replace(t,"");return s=c(s),s}})}e.cleanData=w}),define(le[33],ue([0,1,27,29,45,5,10,7,37,46]),function(se,e,k,O,T,A,L,D,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,k.compareIgnoreCase)(n.id,s.id)===0}e.areSameExtensions=P;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class S{static create(s){const t=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new S(s.identifier,t,r)}static parse(s){const t=b.exec(s);return t&&t[1]&&t[2]?new S({id:t[1]},t[2],t[4]||void 0):null}constructor(s,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof S?P(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=S;const l=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(n){const s=l.exec(n);return s&&s[1]?[v(s[1]),s[2]]:[v(n),void 0]}e.getIdAndVersion=g;function p(n,s){return`${n}.${s}`}e.getExtensionId=p;function v(n){return n.toLowerCase()}e.adoptToGalleryExtensionId=v;function u(n,s){return v(p(n??T.UNDEFINED_PUBLISHER,s))}e.getGalleryExtensionId=u;function d(n,s){const t=[],r=a=>{for(const C of t)if(C.some(E=>P(s(E),s(a))))return C;return null};for(const a of n){const C=r(a);C?C.push(a):t.push([a])}return t}e.groupByExtension=d;function f(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=f;function c(n){return{id:new m.TelemetryTrustedValue(n.identifier.id),name:new m.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=c,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function w(n,s){const t=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&t.every(C=>!P(C.identifier,{id:a}))){const C=n.filter(E=>P(E.identifier,{id:a}));C.length===1&&(t.push(C[0]),r.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.getExtensionDependencies=w;async function i(n,s){if(!A.isLinux)return!1;let t;try{t=(await n.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,D.getErrorMessage)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,s){const t=await i(n,s),r=(0,O.getTargetPlatform)(t?"alpine":A.platform,I.arch);return s.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=o}),define(le[223],ue([0,1,17,2,20,10,11,24,6,3,16,5,37,33]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeExtensionTipsService=e.ExtensionTipsService=void 0;let g=class extends O.Disposable{constructor(f,c){super(),this.fileService=f,this.productService=c,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,w])=>this.allConfigBasedTips.set(w.configPath,w))}getConfigBasedTips(f){return this.getValidConfigBasedTips(f)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(f){const c=[];for(const[w,i]of this.allConfigBasedTips)if(!(i.configScheme&&i.configScheme!==f.scheme))try{const o=(await this.fileService.readFile((0,T.joinPath)(f,w))).value.toString();for(const[n,s]of Object.entries(i.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(o))&&c.push({extensionId:n,extensionName:s.name,configName:i.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return c}};e.ExtensionTipsService=g,e.ExtensionTipsService=g=ye([Y(0,L.IFileService),Y(1,D.IProductService)],g);const p="extensionTips/promptedExecutableTips",v="extensionTips/lastPromptedMediumImpExeTime";class u extends g{constructor(f,c,w,i,o,n,s,t){super(s,t),this.userHome=f,this.windowEvents=c,this.telemetryService=w,this.extensionManagementService=i,this.storageService=o,this.extensionRecommendationNotificationService=n,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,a])=>{const C=[],E=[],h=[];Object.entries(a.recommendations).forEach(([y,R])=>{R.important?a.important?C.push({extensionId:y,extensionName:R.name,isExtensionPack:!!R.isExtensionPack}):E.push({extensionId:y,extensionName:R.name,isExtensionPack:!!R.isExtensionPack}):h.push({extensionId:y,extensionName:R.name,isExtensionPack:!!R.isExtensionPack})}),C.length&&this.highImportanceExecutableTips.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:C}),E.length&&this.mediumImportanceExecutableTips.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:E}),h.length&&this.allOtherExecutableTips.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:h})}),(0,I.disposableTimeout)(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()},3e3,this._store)}async getImportantExecutableBasedTips(){const f=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...f,...c]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const f=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),w=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(f,w),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(c,w)}groupImportantTipsByExe(f,c){const w=new Map;f.forEach(t=>w.set(t.extensionId.toLowerCase(),t));const{installed:i,uninstalled:o}=this.groupByInstalled([...w.keys()],c);for(const t of i){const r=w.get(t);r&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of o){const r=w.get(t);r&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.getPromptedExecutableTips(),s=new Map;for(const t of o){const r=w.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=s.get(r.exeName);a||(a=[],s.set(r.exeName,a)),a.push(r)}}return s}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[f,c]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(c).then(w=>{switch(w){case"reacted":this.addToRecommendedExecutables(c[0].exeName,c);break;case"ignored":this.highImportanceTipsByExe.delete(f);break;case"incompatibleWindow":{const i=m.Event.once(m.Event.latch(m.Event.any(this.windowEvents.onDidOpenMainWindow,this.windowEvents.onDidFocusMainWindow)));this._register(i(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const i=this._register(new O.MutableDisposable);i.value=(0,I.disposableTimeout)(()=>{i.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3);break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const f=this.getLastPromptedMediumExeTime(),c=Date.now()-f,w=7*24*60*60*1e3;if(c<w){const n=this._register(new O.MutableDisposable);n.value=(0,I.disposableTimeout)(()=>{n.dispose(),this.promptMediumImportanceExeBasedTip()},w-c);return}const[i,o]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(n=>{switch(n){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(i),this.addToRecommendedExecutables(o[0].exeName,o);const s=this._register(new O.MutableDisposable);s.value=(0,I.disposableTimeout)(()=>{s.dispose(),this.promptMediumImportanceExeBasedTip()},w);break}case"ignored":this.mediumImportanceTipsByExe.delete(i),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const s=m.Event.once(m.Event.latch(m.Event.any(this.windowEvents.onDidOpenMainWindow,this.windowEvents.onDidFocusMainWindow)));this._register(s(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const s=this._register(new O.MutableDisposable);s.value=(0,I.disposableTimeout)(()=>{s.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3);break}}})}async promptExeRecommendations(f){const c=await this.extensionManagementService.getInstalled(1),w=f.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(o=>c.every(n=>!(0,l.areSameExtensions)(n.identifier,{id:o})))).map(({extensionId:i})=>i.toLowerCase());return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification({extensions:w,source:3,name:f[0].exeFriendlyName,searchValue:`@exe:"${f[0].exeName}"`})}getLastPromptedMediumExeTime(){let f=this.storageService.getNumber(v,-1);return f||(f=Date.now(),this.updateLastPromptedMediumExeTime(f)),f}updateLastPromptedMediumExeTime(f){this.storageService.store(v,f,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(p,-1,"{}"))}addToRecommendedExecutables(f,c){const w=this.getPromptedExecutableTips();w[f]=c.map(({extensionId:i})=>i.toLowerCase()),this.storageService.store(p,JSON.stringify(w),-1,0)}groupByInstalled(f,c){const w=[],i=[],o=c.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return f.forEach(n=>{o.has(n.toLowerCase())?w.push(n):i.push(n)}),{installed:w,uninstalled:i}}async getValidExecutableBasedExtensionTips(f){const c=[],w=new Map;for(const i of f.keys()){const o=f.get(i);if(!o||!(0,k.isNonEmptyArray)(o.recommendations))continue;const n=[];b.isWindows?o.windowsPath&&n.push(o.windowsPath.replace("%USERPROFILE%",()=>S.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>S.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>S.env.ProgramFiles).replace("%APPDATA%",()=>S.env.APPDATA).replace("%WINDIR%",()=>S.env.WINDIR)):(n.push((0,P.join)("/usr/local/bin",i)),n.push((0,P.join)("/usr/bin",i)),n.push((0,P.join)(this.userHome.fsPath,i)));for(const s of n){let t=w.get(s);if(t===void 0&&(t=await this.fileService.exists(A.URI.file(s)),w.set(s,t)),t)for(const{extensionId:r,extensionName:a,isExtensionPack:C,whenNotInstalled:E}of o.recommendations)c.push({extensionId:r,extensionName:a,isExtensionPack:C,exeName:i,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:E})}}return c}}e.AbstractNativeExtensionTipsService=u}),define(le[224],ue([0,1,26,33]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function T(A,L,D,I,m){try{const P=await A.getExtensionsControlManifest();if(!P.deprecated)return;const b=await A.getInstalled(1);for(const[S,l]of Object.entries(P.deprecated)){if(!l?.extension)continue;const{id:g,autoMigrate:p,preRelease:v}=l.extension;if(!p)continue;const u=b.find(f=>(0,O.areSameExtensions)(f.identifier,{id:S}));if(!u)continue;const d=(await L.getExtensions([{id:g,preRelease:v}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},k.CancellationToken.None))[0];if(!d){m.info(`Skipping migrating '${u.identifier.id}' extension because, the comaptible target '${g}' extension is not found`);continue}try{m.info(`Migrating '${u.identifier.id}' extension to '${g}' extension...`);const f=!I.getDisabledExtensions().some(w=>(0,O.areSameExtensions)(w,u.identifier));await A.uninstall(u),m.info(`Uninstalled the unsupported extension '${u.identifier.id}'`);let c=b.find(w=>(0,O.areSameExtensions)(w.identifier,{id:g}));(!c||!c.isPreReleaseVersion&&f)&&(c=await A.installFromGallery(d,{installPreReleaseVersion:!0,isMachineScoped:u.isMachineScoped,operation:4}),m.info(`Installed the pre-release extension '${c.identifier.id}'`),f||(await I.disableExtension(c.identifier),m.info(`Disabled the pre-release extension '${c.identifier.id}' because the unsupported extension '${u.identifier.id}' is disabled`)),p.storage&&(D.addToMigrationList((0,O.getExtensionId)(u.manifest.publisher,u.manifest.name),(0,O.getExtensionId)(c.manifest.publisher,c.manifest.name)),m.info("Added pre-release extension to the storage migration list"))),m.info(`Migrated '${u.identifier.id}' extension to '${g}' extension.`)}catch(f){m.error(f)}}}catch(P){m.error(P)}}e.migrateUnsupportedExtensions=T}),define(le[225],ue([0,1,6,7,2,23,20,55,12,32,31,70,21,15,29,33,99,11,8]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g,p,v,u,d){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let c=class extends T.Disposable{static{f=this}static{this.SignatureArchiveExtension=".sigzip"}constructor(i,o,n,s,t,r){super(),this.fileService=o,this.extensionGalleryService=n,this.configurationService=s,this.extensionSignatureVerificationService=t,this.logService=r,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(i,o,n){await this.cleanUpPromise;const s=(0,L.joinPath)(this.extensionsDownloadDir,this.getName(i));try{await this.downloadFile(i,s,r=>this.extensionGalleryService.download(i,r,o))}catch(r){throw new g.ExtensionManagementError(r.message,g.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.shouldVerifySignature(i)){const r=await this.downloadSignatureArchive(i);try{t=await this.extensionSignatureVerificationService.verify(s.fsPath,r.fsPath,this.logService.getLevel()===d.LogLevel.Trace)}catch(a){const C=a;if(t=C.code,C.output&&this.logService.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${C.output}`),t===g.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===g.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(s)}catch(E){this.logService.error(E)}throw new g.ExtensionManagementError(b.CorruptZipMessage,g.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(r)}catch(a){this.logService.error(a)}}}return t===!0?this.logService.info(`Extension signature is verified: ${i.identifier.id}`):t===!1?this.logService.info(`Extension signature verification is not done: ${i.identifier.id}`):this.logService.warn(`Extension signature verification failed with error '${t}': ${i.identifier.id}`),{location:s,verificationStatus:t}}shouldVerifySignature(i){if(!i.isSigned)return this.logService.info(`Extension is not signed: ${i.identifier.id}`),!1;const o=this.configurationService.getValue("extensions.verifySignature");return(0,I.isBoolean)(o)?o:!0}async downloadSignatureArchive(i){await this.cleanUpPromise;const o=(0,L.joinPath)(this.extensionsDownloadDir,`${this.getName(i)}${f.SignatureArchiveExtension}`);try{await this.downloadFile(i,o,n=>this.extensionGalleryService.downloadSignatureArchive(i,n))}catch(n){throw new g.ExtensionManagementError(n.message,g.ExtensionManagementErrorCode.DownloadSignature)}return o}async downloadFile(i,o,n){if(await this.fileService.exists(o))return;if(o.scheme!==A.Schemas.file){await n(o);return}const s=(0,L.joinPath)(this.extensionsDownloadDir,`.${(0,m.generateUuid)()}`);await this.fileService.exists(s)||await n(s);try{await P.Promises.rename(s.fsPath,o.fsPath,2*60*1e3)}catch(t){try{await this.fileService.del(s)}catch{}if(t.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,o.path);else throw this.logService.info(`Rename failed because of ${(0,O.getErrorMessage)(t)}. Deleted the file from downloaded location`,s.path),t}}async delete(i){await this.cleanUpPromise,await this.fileService.del(i)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const o=[],n=[],s=[];for(const a of i.children)if(a.name.endsWith(f.SignatureArchiveExtension))s.push(a.resource);else{const C=p.ExtensionKey.parse(a.name);C&&n.push([C,a])}const t=(0,p.groupByExtension)(n,([a])=>a),r=[];for(const a of t)a.sort((C,E)=>D.rcompare(C[0].version,E[0].version)),o.push(...a.slice(1).map(C=>C[1].resource)),r.push(a[0][1]);r.sort((a,C)=>a.mtime-C.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(a=>a.resource)),o.push(...s),await k.Promises.settled(o.map(a=>(this.logService.trace("Deleting from cache",a.path),this.fileService.del(a))))}}catch(i){this.logService.error(i)}}getName(i){return this.cache?p.ExtensionKey.create(i).toString().toLowerCase():(0,m.generateUuid)()}};e.ExtensionsDownloader=c,e.ExtensionsDownloader=c=f=ye([Y(0,l.INativeEnvironmentService),Y(1,u.IFileService),Y(2,g.IExtensionGalleryService),Y(3,S.IConfigurationService),Y(4,v.IExtensionSignatureVerificationService),Y(5,d.ILogService)],c)}),define(le[226],ue([0,1,3,2,35,33,45]),function(se,e,k,O,T,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class D extends O.Disposable{constructor(m,P,b,S,l,g,p){super(),this.extensionManagementService=m,this.extensionsScannerService=P,this.userDataProfilesService=b,this.extensionsProfileScannerService=S,this.uriIdentityService=l,this.fileService=g,this.logService=p,this._onDidChangeExtensionsByAnotherSource=this._register(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new O.DisposableMap),this.initialize().then(null,v=>p.error(v))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(m=>this.onDidChangeProfiles(m.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(m=>this.onAddExtensions(m))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(m=>this.onDidAddExtensions(m))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(m=>this.onRemoveExtensions(m))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(m=>this.onDidRemoveExtensions(m))),this._register(this.fileService.onDidFilesChange(m=>this.onDidFilesChange(m)))}async onDidChangeProfiles(m){try{m.length&&await Promise.all(m.map(P=>(this.extensionsProfileWatchDisposables.set(P.id,(0,O.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(P.extensionsResource)),this.fileService.watch(P.extensionsResource))),this.populateExtensionsFromProfile(P.extensionsResource))))}catch(P){throw this.logService.error(P),P}}async onAddExtensions(m){for(const P of m.extensions)this.addExtensionWithKey(this.getKey(P.identifier,P.version),m.profileLocation)}async onDidAddExtensions(m){for(const P of m.extensions){const b=this.getKey(P.identifier,P.version);m.error?this.removeExtensionWithKey(b,m.profileLocation):this.addExtensionWithKey(b,m.profileLocation)}}async onRemoveExtensions(m){for(const P of m.extensions)this.removeExtensionWithKey(this.getKey(P.identifier,P.version),m.profileLocation)}async onDidRemoveExtensions(m){const P=[],b=[];for(const S of m.extensions){const l=this.getKey(S.identifier,S.version);m.error?this.addExtensionWithKey(l,m.profileLocation):(this.removeExtensionWithKey(l,m.profileLocation),this.allExtensions.has(l)||(this.logService.debug("Extension is removed from all profiles",S.identifier.id,S.version),b.push(this.extensionManagementService.scanInstalledExtensionAtLocation(S.location).then(g=>{g?P.push(g):this.logService.info("Extension not found at the location",S.location.toString())},g=>this.logService.error(g)))))}try{await Promise.all(b),P.length&&await this.uninstallExtensionsNotInProfiles(P)}catch(S){this.logService.error(S)}}onDidFilesChange(m){for(const P of this.userDataProfilesService.profiles)m.contains(P.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(P.extensionsResource)}async onDidExtensionsProfileChange(m){const P=[],b=[],S=await this.extensionsProfileScannerService.scanProfileExtensions(m),l=new Set,g=new Set;for(const[p,v]of this.allExtensions)v.has(m)&&g.add(p);for(const p of S){const v=this.getKey(p.identifier,p.version);l.add(v),g.has(v)||(P.push(p.identifier),this.addExtensionWithKey(v,m))}for(const p of g)if(!l.has(p)){const v=this.fromKey(p);v&&(b.push(v.identifier),this.removeExtensionWithKey(p,m))}(P.length||b.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:P.length?{extensions:P,profileLocation:m}:void 0,removed:b.length?{extensions:b,profileLocation:m}:void 0})}async populateExtensionsFromProfile(m){const P=await this.extensionsProfileScannerService.scanProfileExtensions(m);for(const b of P)this.addExtensionWithKey(this.getKey(b.identifier,b.version),m)}async uninstallExtensionsNotInProfiles(m){m||(m=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(b=>!this.allExtensions.has(this.getKey(b.identifier,b.manifest.version)))),m.length&&await this.extensionManagementService.markAsUninstalled(...m)}addExtensionWithKey(m,P){let b=this.allExtensions.get(m);b||this.allExtensions.set(m,b=new T.ResourceSet(S=>this.uriIdentityService.extUri.getComparisonKey(S))),b.add(P)}removeExtensionWithKey(m,P){const b=this.allExtensions.get(m);b&&b.delete(P),b?.size||this.allExtensions.delete(m)}getKey(m,P){return`${L.ExtensionIdentifier.toKey(m.id)}@${P}`}fromKey(m){const[P,b]=(0,A.getIdAndVersion)(m);return b?{identifier:{id:P},version:b}:void 0}}e.ExtensionsWatcher=D}),define(le[227],ue([0,1,43,46]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function T(A,L,D,I,m,P,b){const S={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${L.nameShort})`};if((0,O.supportsTelemetry)(L,D)&&(0,O.getTelemetryLevel)(I)===3){const l=await(0,k.getServiceMachineId)(D,m,P);S["X-Market-User-Id"]=l,S["VSCode-SessionId"]=b.machineId||l}return S}e.resolveMarketplaceHeaders=T}),define(le[228],ue([0,1,73,17,6,2,23,16,31,15,29,33,8,75,10]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let p=class extends l.LanguagePackBaseService{constructor(f,c,w,i){super(w),this.extensionManagementService=f,this.logService=i,this.cache=this._register(new v(c,i)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getBuiltInExtensionTranslationsUri(f,c){const i=(await this.cache.getLanguagePacks())[c];if(!i){this.logService.warn(`No language pack found for ${c}`);return}const o=i.translations[f];return o?g.URI.file(o):void 0}async getInstalledLanguages(){const f=await this.cache.getLanguagePacks(),c=Object.keys(f).map(w=>{const i=f[w];return{...this.createQuickPickItem(w,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return c.push(this.createQuickPickItem("en","English")),c.sort((w,i)=>w.label.localeCompare(i.label)),c}async postInstallExtension(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",f.identifier.id),await this.update())}async postUninstallExtension(f){const c=await this.cache.getLanguagePacks();Object.keys(c).some(w=>c[w]&&c[w].extensions.some(i=>(0,b.areSameExtensions)(i.extensionIdentifier,f.identifier)))&&(this.logService.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,c]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),w=await this.cache.update(c);return!(0,O.equals)(Object.keys(f),Object.keys(w))}};e.NativeLanguagePackService=p,e.NativeLanguagePackService=p=ye([Y(0,P.IExtensionManagementService),Y(1,m.INativeEnvironmentService),Y(2,P.IExtensionGalleryService),Y(3,S.ILogService)],p);let v=class extends A.Disposable{constructor(f,c){super(),this.logService=c,this.languagePacks={},this.languagePacksFilePath=(0,D.join)(f.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new T.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(f){return this.withLanguagePacks(c=>{Object.keys(c).forEach(w=>delete c[w]),this.createLanguagePacksFromExtensions(c,...f)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(f,...c){for(const w of c)w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(f,w);Object.keys(f).forEach(w=>this.updateHash(f[w]))}createLanguagePacksFromExtension(f,c){const w=c.identifier,i=c.manifest.contributes&&c.manifest.contributes.localizations?c.manifest.contributes.localizations:[];for(const o of i)if(c.location.scheme===L.Schemas.file&&u(o)){let n=f[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},f[o.languageId]=n);const s=n.extensions.filter(t=>(0,b.areSameExtensions)(t.extensionIdentifier,w))[0];s?s.version=c.manifest.version:n.extensions.push({extensionIdentifier:w,version:c.manifest.version});for(const t of o.translations)n.translations[t.id]=(0,D.join)(c.location.fsPath,t.path)}}updateHash(f){if(f){const c=(0,k.createHash)("md5");for(const w of f.extensions)c.update(w.extensionIdentifier.uuid||w.extensionIdentifier.id).update(w.version);f.hash=c.digest("hex")}}withLanguagePacks(f=()=>null){return this.languagePacksFileLimiter.queue(()=>{let c=null;return I.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,w=>w.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(w)).then(w=>{try{return JSON.parse(w)}catch{return{}}}).then(w=>(c=f(w),w)).then(w=>{for(const o of Object.keys(w))w[o]||delete w[o];this.languagePacks=w,this.initializedCache=!0;const i=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",i),I.Promises.writeFile(this.languagePacksFilePath,i)}).then(()=>c,w=>this.logService.error(w))})}};v=ye([Y(0,m.INativeEnvironmentService),Y(1,S.ILogService)],v);function u(d){if(typeof d.languageId!="string"||!Array.isArray(d.translations)||d.translations.length===0)return!1;for(const f of d.translations)if(typeof f.id!="string"||typeof f.path!="string")return!1;return!(d.languageName&&typeof d.languageName!="string"||d.localizedLanguageName&&typeof d.localizedLanguageName!="string")}}),define(le[229],ue([0,1,142,7,30,46]),function(se,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const L="https://0.0.0.0/OneCollector/1.0",D="https://0.0.0.0/ping";async function I(P,b,S){const l=await(0,k.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),g=await(0,k.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),p=new l.AppInsightsCore,v=new g.PostChannel,u={instrumentationKey:P,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[v]]};if(S){u.extensionConfig={};const d={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:S};u.extensionConfig[v.identifier]=d}return p.initialize(u,[]),p.addTelemetryInitializer(d=>{d.ext=d.ext??{},d.ext.web=d.ext.web??{},d.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',b&&(d.ext.utc=d.ext.utc??{},d.ext.utc.flags=8462029)}),p}class m{constructor(b,S,l,g,p){this._isInternalTelemetry=b,this._eventPrefix=S,this._defaultData=l,this._xhrOverride=p,this.endPointUrl=L,this.endPointHealthUrl=D,this._defaultData||(this._defaultData={}),typeof g=="function"?this._aiCoreOrKey=g():this._aiCoreOrKey=g,this._asyncAiCore=null}_withAIClient(b){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){b(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=I(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(S=>{b(S)},S=>{(0,O.onUnexpectedError)(S),console.error(S)})}}log(b,S){if(!this._aiCoreOrKey)return;S=(0,T.mixin)(S,this._defaultData),S=(0,A.validateTelemetryData)(S);const l=this._eventPrefix+"/"+b;try{this._withAIClient(g=>{g.pluginVersionString=S?.properties.version??"Unknown",g.track({name:l,baseData:{name:l,properties:S?.properties,measurements:S?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(b=>{this._withAIClient(S=>{S.unload(!0,()=>{this._aiCoreOrKey=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=m}),define(le[109],ue([0,1,2,167,15,8,24,46]),function(se,e,k,O,T,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let I=class extends k.Disposable{constructor(P,b,S,l,g=""){super(),this.prefix=g;const p=b.getLogger(D.telemetryLogId);if(p)this.logger=this._register(p);else{const u=(0,D.isLoggingOnly)(l,S)?" (Not Sent)":"",d=()=>(0,D.supportsTelemetry)(l,S)&&P.getLevel()===A.LogLevel.Trace;this.logger=this._register(b.createLogger(D.telemetryLogId,{name:(0,O.localize)(0,null,u),hidden:!d()})),this._register(P.onDidChangeLogLevel(()=>b.setVisibility(D.telemetryLogId,d()))),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,b){this.logger.trace(`${this.prefix}telemetry/${P}`,(0,D.validateTelemetryData)(b))}};e.TelemetryLogAppender=I,e.TelemetryLogAppender=I=ye([Y(0,A.ILogService),Y(1,A.ILoggerService),Y(2,T.IEnvironmentService),Y(3,L.IProductService)],I)}),define(le[110],ue([0,1,2,30,5,27,168,21,44,102,24,41,22,46]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let g=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(u,d,f){this._configurationService=d,this._productService=f,this._experimentProperties={},this._disposables=new k.DisposableStore,this._cleanupPatterns=[],this._appenders=u.appenders,this._commonProperties=u.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=u.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(c),"gi")),c.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(c.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(c=>{(c.affectsConfiguration(S.TELEMETRY_SETTING_ID)||c.affectsConfiguration(S.TELEMETRY_OLD_SETTING_ID)||c.affectsConfiguration(S.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(u,d){this._experimentProperties[u]=d}_updateTelemetryLevel(){let u=(0,l.getTelemetryLevel)(this._configurationService);const d=this._productService.enabledTelemetryLevels;if(d){this._sendErrorTelemetry=this.sendErrorTelemetry?d.error:!1;const f=d.usage?3:d.error?2:0;u=Math.min(u,f)}this._telemetryLevel=u}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(u,d,f){this._telemetryLevel<d||(f=(0,O.mixin)(f,this._experimentProperties),f=(0,l.cleanData)(f,this._cleanupPatterns),f=(0,O.mixin)(f,this._commonProperties),this._appenders.forEach(c=>c.log(u,f)))}publicLog(u,d){this._log(u,3,d)}publicLog2(u,d){this.publicLog(u,d)}publicLogError(u,d){this._sendErrorTelemetry&&this._log(u,2,d)}publicLogError2(u,d){this.publicLogError(u,d)}};e.TelemetryService=g,e.TelemetryService=g=ye([Y(1,D.IConfigurationService),Y(2,P.IProductService)],g);function p(){const v=(0,L.localize)(0,null,m.default.nameLong),u=m.default.privacyStatementUrl?(0,L.localize)(2,null,"https://aka.ms/vscode-telemetry",m.default.privacyStatementUrl):(0,L.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=T.isWeb?"":(0,L.localize)(3,null),f=(0,L.localize)(4,null),c=(0,L.localize)(5,null),w=(0,L.localize)(6,null),i=(0,L.localize)(7,null),o=`
|       | ${f} | ${c} | ${w} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,L.localize)(8,null);return`
${v} ${u} ${d}

&nbsp;

${i}
${o}

&nbsp;

${n}
`}b.Registry.as(I.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,L.localize)(9,null),properties:{[S.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,L.localize)(10,null),(0,L.localize)(11,null),(0,L.localize)(12,null),(0,L.localize)(13,null)],markdownDescription:p(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(I.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(14,null),properties:{[S.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,L.localize)(16,null,m.default.nameLong,m.default.privacyStatementUrl):(0,L.localize)(15,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(17,null,`\`#${S.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(le[230],ue([0,1,14,26,271,229]),function(se,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;async function L(P,b){const S=await b.request(P,O.CancellationToken.None),l=(await(0,k.streamToBuffer)(S.stream)).toString(),g=S.res.statusCode??200;return{headers:S.res.headers,statusCode:g,responseData:l}}async function D(P){const b={method:P.type,headers:P.headers};return new Promise((l,g)=>{const p=T.request(P.url??"",b,v=>{v.on("data",function(u){l({headers:v.headers,statusCode:v.statusCode??200,responseData:u.toString()})}),v.on("error",function(u){g(u)})});p.write(P.data,v=>{v&&g(v)}),p.end()})}async function I(P,b,S){const l=typeof b.data=="string"?b.data:new TextDecoder().decode(b.data),g={type:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data).toString()},url:b.urlString,data:l};try{const p=P?await L(g,P):await D(g);S(p.statusCode,p.headers,p.responseData)}catch{S(0,{})}}class m extends A.AbstractOneDataSystemAppender{constructor(b,S,l,g,p){const v={sendPOST:(u,d)=>{I(b,u,d)}};super(S,l,g,p,v)}}e.OneDataSystemAppender=m}),define(le[231],ue([0,1,23,93,21,15,8,24,22,108,109,110]),function(se,e,k,O,T,A,L,D,I,m,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let S=class{constructor(g,p,v,u,d,f){this.configurationService=g,this.telemetryService=p,this.logService=v,this.loggerService=u,this.environmentService=d,this.productService=f,this.customTelemetryServices=new Map}getCustomTelemetryService(g){if(!this.customTelemetryServices.has(g.id)){const p=Object.create(null);p["common.vscodemachineid"]=this.telemetryService.machineId,p["common.vscodesessionid"]=this.telemetryService.sessionId;const v=[g.id,JSON.stringify(p),g.aiKey],d=new O.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:v,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),f=[new m.TelemetryAppenderClient(d),new P.TelemetryLogAppender(this.logService,this.loggerService,this.environmentService,this.productService,`[${g.id}] `)];this.customTelemetryServices.set(g.id,new b.TelemetryService({appenders:f,sendErrorTelemetry:g.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(g.id)}publicLog(g,p,v){this.getCustomTelemetryService(g).publicLog(p,v)}publicLogError(g,p,v){this.getCustomTelemetryService(g).publicLogError(p,v)}};e.CustomEndpointTelemetryService=S,e.CustomEndpointTelemetryService=S=ye([Y(0,T.IConfigurationService),Y(1,I.ITelemetryService),Y(2,L.ILogService),Y(3,L.ILoggerService),Y(4,A.IEnvironmentService),Y(5,D.IProductService)],S)}),define(le[79],ue([0,1,3,21,4,8]),function(se,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,T.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,T.createDecorator)("sharedTunnelsService");var L;(function(v){v.Http="http",v.Https="https"})(L||(e.TunnelProtocol=L={}));var D;(function(v){v.ConstantPrivate="constantPrivate",v.Private="private",v.Public="public"})(D||(e.TunnelPrivacyId=D={}));function I(v){return!!v.forwardPort}e.isTunnelProvider=I;var m;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(m||(e.ProvidedOnAutoForward=m={}));function P(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(v){return e.LOCALHOST_ADDRESSES.indexOf(v)>=0}e.isLocalhost=b,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(v){return e.ALL_INTERFACES_ADDRESSES.indexOf(v)>=0}e.isAllInterfaces=S;function l(v,u,d,f){if(d===1)return!1;if(d===2&&S(u)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(f);if(c?.length===4&&parseInt(c[1])>=18)return!1}return v<1024}e.isPortPrivileged=l;class g{constructor(u,d,f){this.remoteAddress=u,this.localAddress=d,this._dispose=f,this._onDispose=new k.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=g;let p=class{constructor(u,d){this.logService=u,this.configurationService=d,this._onTunnelOpened=new k.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new k.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new k.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const u=this.configurationService.getValue("remote.localPortHost");return!u||u==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(u){return this._tunnelProvider=u,u?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this._canElevate=u.elevation,this._privacyOptions=u.privacyOptions,this._canChangeProtocol=u.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const u=[],d=Array.from(this._tunnels.values());for(const f of d){const c=Array.from(f.values());for(const w of c){const i=await w.value;i&&typeof i!="string"&&u.push(i)}}return u}async dispose(){for(const u of this._tunnels.values()){for(const{value:d}of u.values())await d.then(f=>typeof f!="string"?f?.dispose():void 0);u.clear()}this._tunnels.clear()}setEnvironmentTunnel(u,d,f,c,w){this.addTunnelToMap(u,d,Promise.resolve({tunnelRemoteHost:u,tunnelRemotePort:d,localAddress:f,privacy:c,protocol:w,dispose:()=>Promise.resolve()}))}async getExistingTunnel(u,d){(S(u)||b(u))&&(u=e.LOCALHOST_ADDRESSES[0]);const f=this.getTunnelFromMap(u,d);if(f)return++f.refcount,f.value}openTunnel(u,d,f,c,w,i=!1,o,n){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${f} on local port ${w}.`);const s=this._tunnelProvider??u;if(!s)return;if(d||(d="localhost"),c||(c=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(f)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.retainOrCreateTunnel(s,d,f,c,w,i,o,n);return t?t.then(r=>{if(r){if(typeof r=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(d,f),r}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(d,f);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(r);return(r.tunnelRemoteHost!==d||r.tunnelRemotePort!==f)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&r.privacy!==o&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}makeTunnel(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const d=this._tunnels.get(u.tunnelRemoteHost);if(d){const f=d.get(u.tunnelRemotePort);f&&(f.refcount--,await this.tryDisposeTunnel(u.tunnelRemoteHost,u.tunnelRemotePort,f))}}}}async tryDisposeTunnel(u,d,f){if(f.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${d}.`);const c=f.value.then(async w=>{w&&typeof w!="string"&&(await w.dispose(!0),this._onTunnelClosed.fire({host:w.tunnelRemoteHost,port:w.tunnelRemotePort}))});return this._tunnels.has(u)&&this._tunnels.get(u).delete(d),c}}async closeTunnel(u,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${d} `);const f=this._tunnels.get(u);if(f&&f.has(d)){const c=f.get(d);c.refcount=0,await this.tryDisposeTunnel(u,d,c)}}addTunnelToMap(u,d,f){this._tunnels.has(u)||this._tunnels.set(u,new Map),this._tunnels.get(u).set(d,{refcount:1,value:f})}async removeEmptyOrErrorTunnelFromMap(u,d){const f=this._tunnels.get(u);if(f){const c=f.get(d),w=c?await c.value:void 0;(!w||typeof w=="string")&&f.delete(d),f.size===0&&this._tunnels.delete(u)}}getTunnelFromMap(u,d){const f=[u];b(u)?(f.push(...e.LOCALHOST_ADDRESSES),f.push(...e.ALL_INTERFACES_ADDRESSES)):S(u)&&f.push(...e.ALL_INTERFACES_ADDRESSES);const c=f.map(w=>this._tunnels.get(w));for(const w of c){const i=w?.get(d);if(i)return i}}canTunnel(u){return!!P(u)}createWithProvider(u,d,f,c,w,i,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${f} on local port ${c}.`);const n=f;this._factoryInProgress.add(n);const s=c===void 0?f:c,t={elevationRequired:w?this.isPortPrivileged(s):!1},r={remoteAddress:{host:d,port:f},localAddressPort:c,privacy:i,public:i?i!==D.Private:void 0,protocol:o},a=u.forwardPort(r,t);return a?(this.addTunnelToMap(d,f,a),a.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(n)})):this._factoryInProgress.delete(n),a}};e.AbstractTunnelService=p,e.AbstractTunnelService=p=ye([Y(0,A.ILogService),Y(1,O.IConfigurationService)],p)}),define(le[232],ue([0,1,8,79,2,7,6]),function(se,e,k,O,T,A,L){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class I extends T.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new L.DeferredPromise),this._addressPromise.p)}setAddress(b){this._address=b,this._addressPromise&&(this._addressPromise.complete(b),this._addressPromise=null)}setTunnel(b){this._register(b)}}let m=class extends T.Disposable{static{D=this}static{this._lastId=0}constructor(b,S){super(),this._tunnelService=b,this._logService=S,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(b=>b.dispose())}async createTunnel(){return{id:String(++D._lastId)}}async startTunnel(b,S,l,g,p,v,u){const d=new I,f=await Promise.resolve(this._tunnelService.openTunnel(b,d,l,g,p,v,u));if(!f||typeof f=="string")throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${l}:${g} (remote).`),d.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(S))throw this._disposedTunnels.delete(S),d.dispose(),await f.dispose(),(0,A.canceled)();return d.setTunnel(f),this._tunnels.set(S,d),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${S}: ${f.localAddress} (local) to ${l}:${g} (remote).`),{tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress}}async setAddress(b,S){const l=this._tunnels.get(b);l&&l.setAddress(S)}async destroyTunnel(b){const S=this._tunnels.get(b);if(S){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${b}.`),this._tunnels.delete(b),await S.dispose();return}this._disposedTunnels.add(b)}};e.SharedProcessTunnelService=m,e.SharedProcessTunnelService=m=D=ye([Y(0,O.ISharedTunnelsService),Y(1,k.ILogService)],m)}),define(le[28],ue([0,1,4]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(le[233],ue([0,1,28,186,11,20,128,3,2]),function(se,e,k,O,T,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class m{static{this._clock=0}constructor(S){this.uri=S,this.time=m._clock++}touch(){return this.time=m._clock++,this}}let P=class{constructor(S){this._fileService=S,this._dispooables=new I.DisposableStore,this._limit=2**16;const l=new Map,g=p=>{let v=l.get(p.scheme);return v===void 0&&(v=S.hasProvider(p)&&!this._fileService.hasCapability(p,1024),l.set(p.scheme,v)),v};this._dispooables.add(D.Event.any(S.onDidChangeFileSystemProviderRegistrations,S.onDidChangeFileSystemProviderCapabilities)(p=>{l.delete(p.scheme)})),this.extUri=new A.ExtUri(g),this._canonicalUris=new L.SkipList((p,v)=>this.extUri.compare(p,v,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(S){this._fileService.hasProvider(S)&&(S=(0,A.normalizePath)(S));const l=this._canonicalUris.get(S);return l?l.touch().uri.with({fragment:S.fragment}):(this._canonicalUris.set(S,new m(S)),this._checkTrim(),S)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const S=[...this._canonicalUris.entries()].sort((g,p)=>g[1].time<p[1].time?1:g[1].time>p[1].time?-1:0);m._clock=0,this._canonicalUris.clear();const l=this._limit*.5;for(let g=0;g<l;g++)this._canonicalUris.set(S[g][0],S[g][1].touch())}};e.UriIdentityService=P,e.UriIdentityService=P=ye([Y(0,T.IFileService)],P),(0,O.registerSingleton)(k.IUriIdentityService,P,1)}),define(le[234],ue([0,1,3,2,11,48,35]),function(se,e,k,O,T,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class D extends O.Disposable{constructor(m,P,b,S,l,g){super(),this.fileSystemScheme=m,this.fileSystemProvider=P,this.userDataScheme=b,this.userDataProfilesService=S,this.uriIdentityService=l,this.logService=g,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=A.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.atomicReadWriteResources=new L.ResourceSet(p=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(p))),this.updateAtomicReadWritesResources(),this._register(S.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(p=>this.handleFileChanges(p)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const m of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(m.settingsResource),this.atomicReadWriteResources.add(m.keybindingsResource),this.atomicReadWriteResources.add(m.tasksResource),this.atomicReadWriteResources.add(m.extensionsResource)}open(m,P){return this.fileSystemProvider.open(this.toFileSystemResource(m),P)}close(m){return this.fileSystemProvider.close(m)}read(m,P,b,S,l){return this.fileSystemProvider.read(m,P,b,S,l)}write(m,P,b,S,l){return this.fileSystemProvider.write(m,P,b,S,l)}watch(m,P){this.watchResources.set(m,m);const b=this.fileSystemProvider.watch(this.toFileSystemResource(m),P);return(0,O.toDisposable)(()=>{this.watchResources.delete(m),b.dispose()})}stat(m){return this.fileSystemProvider.stat(this.toFileSystemResource(m))}mkdir(m){return this.fileSystemProvider.mkdir(this.toFileSystemResource(m))}rename(m,P,b){return this.fileSystemProvider.rename(this.toFileSystemResource(m),this.toFileSystemResource(P),b)}readFile(m,P){return this.fileSystemProvider.readFile(this.toFileSystemResource(m),P)}readFileStream(m,P,b){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(m),P,b)}readdir(m){return this.fileSystemProvider.readdir(this.toFileSystemResource(m))}enforceAtomicReadFile(m){return this.atomicReadWriteResources.has(m)}writeFile(m,P,b){return this.fileSystemProvider.writeFile(this.toFileSystemResource(m),P,b)}enforceAtomicWriteFile(m){return this.atomicReadWriteResources.has(m)?{postfix:".vsctmp"}:!1}delete(m,P){return this.fileSystemProvider.delete(this.toFileSystemResource(m),P)}copy(m,P,b){if((0,T.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(m),this.toFileSystemResource(P),b);throw new Error("copy not supported")}cloneFile(m,P){if((0,T.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(m),this.toFileSystemResource(P));throw new Error("clone not supported")}handleFileChanges(m){const P=[];for(const b of m){if(b.resource.scheme!==this.fileSystemScheme)continue;const S=this.toUserDataResource(b.resource);this.watchResources.findSubstr(S)&&P.push({resource:S,type:b.type,cId:b.cId})}P.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(P))}toFileSystemResource(m){return m.with({scheme:this.fileSystemScheme})}toUserDataResource(m){return m.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=D}),define(le[80],ue([0,1,62]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function O(L,D,I,m){const P=(0,k.setProperty)(L,D,I,m)[0];return P&&(L=L.substring(0,P.offset)+P.content+L.substring(P.offset+P.length)),L}e.edit=O;function T(L,D,I){let m=I;for(;m>=0;){if(L.charAt(m)===D.charAt(D.length-1)&&D.length===1)return m+1;if(m--,D.length===2&&m>=0&&L.charAt(m)===D.charAt(0))return m+2}return 0}e.getLineStartOffset=T;function A(L,D,I){let m=I;for(;m>=0;)if(L.charAt(m)===D.charAt(D.length-1)&&D.length===1||(m++,D.length===2&&m>=0&&L.charAt(m)===D.charAt(1)))return m;return L.length-1}e.getLineEndOffset=A}),define(le[235],ue([0,1,30,55,12]),function(se,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(l,g,p,v,u,d){const f=[],c=[],w=[];if(!g){const j=l.filter(({identifier:Q})=>u.every(K=>K.toLowerCase()!==Q.id.toLowerCase()));return{local:{added:f,removed:c,updated:w},remote:j.length>0?{added:j,updated:[],removed:[],all:j}:null}}l=l.map(b),g=g.map(b),p=p?p.map(b):null;const i=new Map,o=j=>{j.uuid&&i.set(j.id.toLowerCase(),j.uuid)};l.forEach(({identifier:j})=>o(j)),g.forEach(({identifier:j})=>o(j)),p?.forEach(({identifier:j})=>o(j)),v?.forEach(({identifier:j})=>o(j)),d?.forEach(j=>o(j));const n=j=>{const Q=j.identifier.uuid||i.get(j.identifier.id.toLowerCase());return Q?`uuid:${Q}`:`id:${j.identifier.id.toLowerCase()}`},s=(j,Q)=>(j.set(n(Q),Q),j),t=l.reduce(s,new Map),r=g.reduce(s,new Map),a=g.reduce((j,Q)=>s(j,(0,k.deepClone)(Q)),new Map),C=p?p.reduce(s,new Map):null,E=v.reduce(s,new Map),h=u.reduce((j,Q)=>{const K=i.get(Q.toLowerCase());return j.add(K?`uuid:${K}`:`id:${Q.toLowerCase()}`)},new Set),y=d?d.reduce((j,{id:Q,uuid:K})=>(K=K??i.get(Q.toLowerCase()),j.add(K?`uuid:${K}`:`id:${Q.toLowerCase()}`)),new Set):null,R=L(t,r,h,!1);if(R.added.size>0||R.removed.size>0||R.updated.size>0){const j=L(C,t,h,!1),Q=L(C,r,h,!0),K=(X,x,J,V)=>{let q,ie,re;return x.installed?(q=V.pinned,re=V.preRelease,q&&(ie=V.version)):(q=J.pinned,re=J.preRelease,q&&(ie=J.version)),q===void 0&&(q=x.pinned,q&&(ie=x.version)),re===void 0&&(re=x.preRelease),{...V,installed:x.installed||J.installed,pinned:q,preRelease:re,version:ie??(J.version&&(!x.installed||O.gt(J.version,x.version))?J.version:x.version),state:I(x,J,C?.get(X))}};for(const X of Q.removed.values()){const x=t.get(X);if(!x)continue;const J=(0,T.assertIsDefined)(C?.get(X)),V=y&&!y.has(X)&&J.installed;x.installed&&V?c.push(x.identifier):a.set(X,x)}for(const X of Q.added.values()){const x=(0,T.assertIsDefined)(r.get(X)),J=t.get(X);if(J){if(R.updated.has(X)){const V=K(X,J,x,x);D(J,x,!1,!1)||w.push(S(V,X)),a.set(X,V)}}else x.installed&&f.push(S(x,X))}for(const X of Q.updated.values()){const x=(0,T.assertIsDefined)(r.get(X)),J=(0,T.assertIsDefined)(C?.get(X)),V=t.get(X);if(V)if(y&&!y.has(X)&&J.installed&&V.installed&&!x.installed)c.push(V.identifier);else{const ie=K(X,V,x,x);w.push(S(ie,X)),a.set(X,ie)}else x.installed&&f.push(S(x,X))}for(const X of j.added.values())Q.added.has(X)||a.set(X,(0,T.assertIsDefined)(t.get(X)));for(const X of j.updated.values()){if(Q.removed.has(X)||Q.updated.has(X))continue;const x=(0,T.assertIsDefined)(t.get(X)),J=(0,T.assertIsDefined)(r.get(X));a.set(X,K(X,x,J,x))}for(const X of j.removed.values())Q.updated.has(X)||Q.removed.has(X)||E.has(X)||(0,T.assertIsDefined)(r.get(X)).installed&&y&&(y.has(X)||!(0,T.assertIsDefined)(C?.get(X)).installed||a.delete(X))}const U=[],F=L(r,a,new Set,!0),M=F.added.size>0||F.updated.size>0||F.removed.size>0;return M&&a.forEach((j,Q)=>U.push(S(j,Q))),{local:{added:f,removed:c,updated:w},remote:M?{added:[...F.added].map(j=>a.get(j)),updated:[...F.updated].map(j=>a.get(j)),removed:[...F.removed].map(j=>r.get(j)),all:U}:null}}e.merge=A;function L(l,g,p,v){const u=l?[...l.keys()].filter(i=>!p.has(i)):[],d=[...g.keys()].filter(i=>!p.has(i)),f=d.filter(i=>!u.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),c=u.filter(i=>!d.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),w=new Set;for(const i of u){if(c.has(i))continue;const o=l.get(i),n=g.get(i);(!n||!D(o,n,v,!0))&&w.add(i)}return{added:f,removed:c,updated:w}}function D(l,g,p,v){return!(l.disabled!==g.disabled||!!l.isApplicationScoped!=!!g.isApplicationScoped||v&&l.installed!==g.installed||l.installed&&g.installed&&(l.preRelease!==g.preRelease||l.pinned!==g.pinned||g.pinned&&l.version!==g.version)||!P(l.state,g.state)||p&&l.version!==g.version)}function I(l,g,p){const v=l.state,u=g.state,d=p?.state;if(!g.version||v&&O.gt(l.version,g.version))return v;if(u&&O.gt(g.version,l.version)||!v)return u;if(!u)return v;const f=(0,k.deepClone)(v),c=d?m(d,u):{added:Object.keys(u).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set},w=d?m(d,v):{added:Object.keys(v).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set};for(const i of[...c.added.values(),...c.updated.values()])f[i]=u[i];for(const i of c.removed.values())w.updated.has(i)||delete f[i];return f}function m(l,g){const p=Object.keys(l),v=Object.keys(g),u=v.filter(c=>!p.includes(c)).reduce((c,w)=>(c.add(w),c),new Set),d=p.filter(c=>!v.includes(c)).reduce((c,w)=>(c.add(w),c),new Set),f=new Set;for(const c of p){if(d.has(c))continue;const w=l[c],i=g[c];(0,k.equals)(w,i)||f.add(c)}return{added:u,removed:d,updated:f}}function P(l={},g={}){const{added:p,removed:v,updated:u}=m(l,g);return p.size===0&&v.size===0&&u.size===0}function b(l){return{...l,disabled:!!l.disabled,installed:!!l.installed}}function S(l,g){const p={...l,identifier:{id:l.identifier.id,uuid:g.startsWith("uuid:")?g.substring(5):void 0},preRelease:!!l.preRelease,pinned:!!l.pinned};return l.disabled||delete p.disabled,l.installed||delete p.installed,l.state||delete p.state,l.isApplicationScoped||delete p.isApplicationScoped,p}}),define(le[111],ue([0,1,17,21,4]),function(se,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,T.createDecorator)("IIgnoredExtensionsManagementService");let A=class{constructor(D){this.configurationService=D}hasToNeverSyncExtension(D){return this.getConfiguredIgnoredExtensions().includes(D.toLowerCase())}hasToAlwaysSyncExtension(D){return this.getConfiguredIgnoredExtensions().includes(`-${D.toLowerCase()}`)}updateIgnoredExtensions(D,I){let m=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return m=m.filter(P=>P!==D&&P!==`-${D}`),I&&m.push(D.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",m.length?m:void 0,2)}updateSynchronizedExtensions(D,I){let m=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return m=m.filter(P=>P!==D&&P!==`-${D}`),I&&m.push(`-${D.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",m.length?m:void 0,2)}getIgnoredExtensions(D){const I=D.filter(S=>S.isMachineScoped).map(S=>S.identifier.id.toLowerCase()),m=this.getConfiguredIgnoredExtensions().map(S=>S.toLowerCase()),P=[],b=[];if(Array.isArray(m))for(const S of m)S.startsWith("-")?b.push(S.substring(1)):P.push(S);return(0,k.distinct)([...I,...P].filter(S=>!b.includes(S)))}getConfiguredIgnoredExtensions(){let D=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return D!==void 0||(D=this.configurationService.inspect("sync.ignoredExtensions").userValue,D!==void 0)?D:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(I=>I.toLowerCase())}};e.IgnoredExtensionsManagementService=A,e.IgnoredExtensionsManagementService=A=ye([Y(0,O.IConfigurationService)],A)}),define(le[236],ue([0,1,17,34,30,94,80]),function(se,e,k,O,T,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(c){return(0,O.parse)(c)||[]}async function I(c,w,i,o,n){const s=D(c),t=D(w),r=i?D(i):null,a=[...s,...t,...r||[]].map(K=>K.key),C=await n.resolveUserBindings(a),E=P(s,t,r,C);if(!E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!E.hasLocalForwarded&&E.hasRemoteForwarded)return{mergeContent:w,hasChanges:!0,hasConflicts:!1};if(E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const h=S(s),y=S(t),R=r?S(r):null,U=g(h,y,C),F=R?g(R,h,C):{added:[...h.keys()].reduce((K,X)=>(K.add(X),K),new Set),removed:new Set,updated:new Set},M=R?g(R,y,C):{added:[...y.keys()].reduce((K,X)=>(K.add(X),K),new Set),removed:new Set,updated:new Set},j=m(U,F,M);let Q=c;for(const K of j.removed.values())j.conflicts.has(K)||(Q=d(Q,K,o));for(const K of j.added.values()){if(j.conflicts.has(K))continue;const X=y.get(K);if(X.some(x=>x.command!==`-${K}`&&E.conflicts.has(C[x.key]))){j.conflicts.add(K);continue}Q=u(Q,X,o)}for(const K of j.updated.values()){if(j.conflicts.has(K))continue;const X=y.get(K);if(X.some(x=>x.command!==`-${K}`&&E.conflicts.has(C[x.key]))){j.conflicts.add(K);continue}Q=f(Q,K,X,o)}return{mergeContent:Q,hasChanges:!0,hasConflicts:j.conflicts.size>0}}e.merge=I;function m(c,w,i){const o=new Set,n=new Set,s=new Set,t=new Set;for(const r of w.removed.values())i.updated.has(r)&&t.add(r);for(const r of i.removed.values())t.has(r)||(w.updated.has(r)?t.add(r):n.add(r));for(const r of w.added.values())t.has(r)||i.added.has(r)&&c.updated.has(r)&&t.add(r);for(const r of i.added.values())t.has(r)||(w.added.has(r)?c.updated.has(r)&&t.add(r):o.add(r));for(const r of w.updated.values())t.has(r)||i.updated.has(r)&&c.updated.has(r)&&t.add(r);for(const r of i.updated.values())t.has(r)||(w.updated.has(r)?c.updated.has(r)&&t.add(r):s.add(r));return{added:o,removed:n,updated:s,conflicts:t}}function P(c,w,i,o){const n=new Set,s=b(c,o),t=b(w,o),r=i?b(i,o):null,a=l(s,t);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const C=r?l(r,s):{added:[...s.keys()].reduce((F,M)=>(F.add(M),F),new Set),removed:new Set,updated:new Set};if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const E=r?l(r,t):{added:[...t.keys()].reduce((F,M)=>(F.add(M),F),new Set),removed:new Set,updated:new Set};if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:h,removed:y,updated:R,conflicts:U}=m(a,C,E);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:h,removed:y,updated:R,conflicts:U}}function b(c,w){const i=new Map;for(const o of c){const n=w[o.key];let s=i.get(n);s||(s=[],i.set(n,s)),s.push(o)}return i}function S(c){const w=new Map;for(const i of c){const o=i.command[0]==="-"?i.command.substring(1):i.command;let n=w.get(o);n||(n=[],w.set(o,n)),n.push(i)}return w}function l(c,w){const i=[...c.keys()],o=[...w.keys()],n=o.filter(r=>!i.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),s=i.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=new Set;for(const r of i){if(s.has(r))continue;const a=c.get(r).map(E=>({...E,key:r})),C=w.get(r).map(E=>({...E,key:r}));(0,k.equals)(a,C,(E,h)=>v(E,h))||t.add(r)}return{added:n,removed:s,updated:t}}function g(c,w,i){const o=[...c.keys()],n=[...w.keys()],s=n.filter(a=>!o.includes(a)).reduce((a,C)=>(a.add(C),a),new Set),t=o.filter(a=>!n.includes(a)).reduce((a,C)=>(a.add(C),a),new Set),r=new Set;for(const a of o){if(t.has(a))continue;const C=c.get(a).map(h=>({...h,key:i[h.key]})),E=w.get(a).map(h=>({...h,key:i[h.key]}));p(C,E)||r.add(a)}return{added:s,removed:t,updated:r}}function p(c,w){return!(!(0,k.equals)(c.filter(({command:i})=>i[0]!=="-"),w.filter(({command:i})=>i[0]!=="-"),(i,o)=>v(i,o))||!(0,k.equals)(c.filter(({command:i})=>i[0]==="-"),w.filter(({command:i})=>i[0]==="-"),(i,o)=>v(i,o)))}function v(c,w){if(c.command!==w.command||c.key!==w.key)return!1;const i=A.ContextKeyExpr.deserialize(c.when),o=A.ContextKeyExpr.deserialize(w.when);return!(i&&!o||!i&&o||i&&o&&!i.equals(o)||!T.equals(c.args,w.args))}function u(c,w,i){for(const o of w)c=L.edit(c,[-1],o,i);return c}function d(c,w,i){const o=D(c);for(let n=o.length-1;n>=0;n--)(o[n].command===w||o[n].command===`-${w}`)&&(c=L.edit(c,[n],void 0,i));return c}function f(c,w,i,o){const n=D(c),s=n.findIndex(t=>t.command===w||t.command===`-${w}`);for(let t=n.length-1;t>=0;t--)(n[t].command===w||n[t].command===`-${w}`)&&(c=L.edit(c,[t],void 0,o));for(let t=i.length-1;t>=0;t--)c=L.edit(c,[s],i[t],o);return c}}),define(le[237],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function k(A,L,D){const I={},m={},P=new Set;if(!L)return{local:{added:I,updated:m,removed:[...P.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const b=O(A,L);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{local:{added:I,updated:m,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const S=O(D,A),l=O(D,L),g={},p={},v=new Set,u=new Set;for(const d of S.removed.values())l.updated.has(d)?I[d]=L[d]:v.add(d);for(const d of l.removed.values())u.has(d)||(S.updated.has(d)?u.add(d):P.add(d));for(const d of S.updated.values())u.has(d)||(l.updated.has(d)?b.updated.has(d)&&u.add(d):p[d]=A[d]);for(const d of l.updated.values())u.has(d)||(S.updated.has(d)?b.updated.has(d)&&u.add(d):A[d]!==void 0&&(m[d]=L[d]));for(const d of S.added.values())u.has(d)||(l.added.has(d)?b.updated.has(d)&&u.add(d):g[d]=A[d]);for(const d of l.added.values())u.has(d)||(S.added.has(d)?b.updated.has(d)&&u.add(d):I[d]=L[d]);return{local:{added:I,removed:[...P.values()],updated:m},remote:{added:g,removed:[...v.values()],updated:p},conflicts:[...u.values()]}}e.merge=k;function O(A,L){const D=A?Object.keys(A):[],I=L?Object.keys(L):[],m=I.filter(S=>!D.includes(S)).reduce((S,l)=>(S.add(l),S),new Set),P=D.filter(S=>!I.includes(S)).reduce((S,l)=>(S.add(l),S),new Set),b=new Set;for(const S of D){if(P.has(S))continue;const l=A[S],g=L[S];l!==g&&b.add(S)}return{added:m,removed:P,updated:b}}function T(A,L){const{added:D,removed:I,updated:m}=O(A,L);return D.size===0&&I.size===0&&m.size===0}e.areSame=T}),define(le[238],ue([0,1,30]),function(se,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function O(A,L,D,I){const m={added:[],removed:[],updated:[]};let P={added:[],removed:[],updated:[]};if(!L){const S=A.filter(({id:l})=>!I.includes(l));return S.length?P.added=S:P=null,{local:m,remote:P}}const b=T(A,L,I);if(b.added.length>0||b.removed.length>0||b.updated.length>0){const S=T(D,A,I),l=T(D,L,I);for(const g of l.removed){const p=A.find(v=>v.id===g);p&&m.removed.push(p)}for(const g of l.added){const p=L.find(v=>v.id===g);S.added.includes(g)?b.updated.includes(g)&&m.updated.push(p):m.added.push(p)}for(const g of l.updated)m.updated.push(L.find(p=>p.id===g));for(const g of S.added)l.added.includes(g)||P.added.push(A.find(p=>p.id===g));for(const g of S.updated)l.removed.includes(g)||l.updated.includes(g)||P.updated.push(A.find(p=>p.id===g));for(const g of S.removed){const p=L.find(v=>v.id===g);p&&P.removed.push(p)}}return P.added.length===0&&P.removed.length===0&&P.updated.length===0&&(P=null),{local:m,remote:P}}e.merge=O;function T(A,L,D){A=A?A.filter(({id:l})=>!D.includes(l)):[],L=L.filter(({id:l})=>!D.includes(l));const I=A.map(({id:l})=>l),m=L.map(({id:l})=>l),P=m.filter(l=>!I.includes(l)),b=I.filter(l=>!m.includes(l)),S=[];for(const{id:l,name:g,shortName:p,icon:v,useDefaultFlags:u}of A){if(b.includes(l))continue;const d=L.find(f=>f.id===l);(!d||d.name!==g||d.shortName!==p||d.icon!==v||!(0,k.equals)(d.useDefaultFlags,u))&&S.push(l)}return{added:P,removed:b,updated:S}}}),define(le[25],ue([0,1,17,12,174,44,29,4,103,41]),function(se,e,k,O,T,A,L,D,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncLocalStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=void 0;function P(){const t=m.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=P;function b(){const t=m.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(E=>!!t[E].ignoreSync),a=Object.keys(t).filter(E=>t[E].scope===2||t[E].scope===6),C=P();return(0,k.distinct)([...r,...a,...C])}e.getDefaultIgnoredSettings=b,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function S(){const t="vscode://schemas/ignoredSettings",r=m.Registry.as(A.Extensions.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=m.Registry.as(I.Extensions.JSONContribution),C=()=>{const E=P(),h=b(),y=Object.keys(A.allSettings.properties).filter(F=>!h.includes(F)),R=h.filter(F=>!E.includes(F)),U={items:{type:"string",enum:[...y,...R.map(F=>`-${F}`)]}};a.registerSchema(t,U)};return r.onDidUpdateConfiguration(()=>C())}e.registerConfiguration=S;function l(t){return t&&(0,O.isObject)(t)&&(0,O.isString)(t.id)&&Array.isArray(t.scopes)}e.isAuthenticationProvider=l;var g;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})(g||(e.SyncResource=g={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function p(t,...r){return t?[t,...r]:r}e.getPathSegments=p;function v(t,r,a,C){return C.joinPath(a.userDataSyncHome,...p(t,r,`lastSync${r}.json`))}e.getLastSyncResourceUri=v,e.IUserDataSyncStoreManagementService=(0,D.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,D.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncLocalStoreService=(0,D.createDecorator)("IUserDataSyncLocalStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function u(t){const r={};return r[e.HEADER_EXECUTION_ID]=t,r}e.createSyncHeaders=u;var d;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(d||(e.UserDataSyncErrorCode=d={}));class f extends Error{constructor(r,a,C,E){super(r),this.code=a,this.resource=C,this.operationId=E,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=f;class c extends f{constructor(r,a,C,E,h){super(r,C,void 0,h),this.url=a,this.serverCode=E}}e.UserDataSyncStoreError=c;class w extends f{constructor(r,a){super(r,a)}}e.UserDataAutoSyncError=w,function(t){function r(a){if(a instanceof t)return a;const C=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(C&&C[1]){const E=C[2]==="unknown"?void 0:C[2],h=C[3]==="unknown"?void 0:C[3];return new t(a.message,C[1],E,h)}return new t(a.message,"Unknown")}t.toUserDataSyncError=r}(f||(e.UserDataSyncError=f={}));var i;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(i||(e.SyncStatus=i={}));var o;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(o||(e.Change=o={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function s(t){return`sync.enable.${t}`}e.getEnablementKey=s,e.IUserDataSyncEnablementService=(0,D.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,D.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,D.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,D.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,D.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,D.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSync",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(le[239],ue([0,1,30,25]),function(se,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(L,D,I,m,P){if(!D)return{remote:{added:Object.keys(L),removed:[],updated:[],all:Object.keys(L).length>0?L:null},local:{added:{},removed:[],updated:{}}};const b=A(L,D);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const S=I?A(I,D):{added:Object.keys(D).reduce((d,f)=>(d.add(f),d),new Set),removed:new Set,updated:new Set},l=I?A(I,L):{added:Object.keys(L).reduce((d,f)=>(d.add(f),d),new Set),removed:new Set,updated:new Set},g={added:{},removed:[],updated:{}},p=k.deepClone(D),v=!I;for(const d of l.added.values())d!==O.SYNC_SERVICE_URL_TYPE&&v&&S.added.has(d)||(p[d]=L[d]);for(const d of l.updated.values())p[d]=L[d];for(const d of l.removed.values())m.unregistered.includes(d)||delete p[d];for(const d of S.added.values()){const f=D[d];if(m.machine.includes(d)){P.info(`GlobalState: Skipped adding ${d} in local storage because it is declared as machine scoped.`);continue}if(I&&l.added.has(d))continue;const c=L[d];c&&c.value===f.value||d===O.SYNC_SERVICE_URL_TYPE&&v&&l.added.has(d)||(c?g.updated[d]=f:g.added[d]=f)}for(const d of S.updated.values()){const f=D[d];if(m.machine.includes(d)){P.info(`GlobalState: Skipped updating ${d} in local storage because it is declared as machine scoped.`);continue}if(l.updated.has(d)||l.removed.has(d))continue;const c=L[d];c&&c.value===f.value||(g.updated[d]=f)}for(const d of S.removed.values()){if(m.machine.includes(d)){P.trace(`GlobalState: Skipped removing ${d} in local storage because it is declared as machine scoped.`);continue}l.updated.has(d)||l.removed.has(d)||g.removed.push(d)}const u=A(D,p);return{local:g,remote:{added:[...u.added],updated:[...u.updated],removed:[...u.removed],all:u.added.size===0&&u.removed.size===0&&u.updated.size===0?null:p}}}e.merge=T;function A(L,D){const I=Object.keys(L),m=Object.keys(D),P=m.filter(l=>!I.includes(l)).reduce((l,g)=>(l.add(g),l),new Set),b=I.filter(l=>!m.includes(l)).reduce((l,g)=>(l.add(g),l),new Set),S=new Set;for(const l of I){if(b.has(l))continue;const g=L[l],p=D[l];k.equals(g,p)||S.add(l)}return{added:P,removed:b,updated:S}}}),define(le[240],ue([0,1,17,34,62,42,30,80,25]),function(se,e,k,O,T,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function m(a,C,E){let h=[];E?h=b(E):h=P(C);const y=[],R=[...(0,I.getDisallowedIgnoredSettings)()];if(Array.isArray(h))for(const U of h)U.startsWith("-")?R.push(U.substring(1)):y.push(U);return(0,k.distinct)([...a,...y].filter(U=>!R.includes(U)))}e.getIgnoredSettings=m;function P(a){let C=a.inspect("settingsSync.ignoredSettings").userValue;return C!==void 0||(C=a.inspect("sync.ignoredSettings").userValue,C!==void 0)?C:a.getValue("settingsSync.ignoredSettings")||[]}function b(a){const C=(0,O.parse)(a);return C?C["settingsSync.ignoredSettings"]||C["sync.ignoredSettings"]||[]:[]}function S(a,C){const E=(0,O.parse)(a)||{};let h="{}";for(const y of Object.keys(E)){const R=(0,T.setProperty)(h,[y],E[y],C);h=(0,T.applyEdits)(h,R)}return h}e.removeComments=S;function l(a,C,E,h){if(E.length){const y=r(C),R=(0,O.parse)(C)||{},U=(0,O.parse)(a);if(!U)return a;const F=[];for(const M of E){const j=R[M],Q=U[M];j===void 0?a=D.edit(a,[M],void 0,h):Q!==void 0?a=D.edit(a,[M],j,h):F.push(i(M,y))}F.sort((M,j)=>M.startOffset-j.startOffset),F.forEach(M=>a=d(M.setting.key,C,a,h))}return a}e.updateIgnoredSettings=l;function g(a,C,E,h,y,R){const U=l(a,C,h,R),F=E!==U,M=E!==C;if(!F&&!M)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!M)return{conflictsSettings:[],localContent:null,remoteContent:U,hasConflicts:!1};if(M&&!F)return{conflictsSettings:[],localContent:l(C,a,h,R),remoteContent:null,hasConflicts:!1};if(E===null&&v(a)){const N=p(a,C,h)?null:l(C,a,h,R);return{conflictsSettings:[],localContent:N,remoteContent:null,hasConflicts:!1}}let j=a,Q=C;const K=(0,O.parse)(a),X=(0,O.parse)(C),x=E?(0,O.parse)(E):null,J=h.reduce((N,z)=>(N.add(z),N),new Set),V=u(K,X,J),q=u(x,K,J),ie=u(x,X,J),re=new Map,ee=new Set,ae=N=>{ee.add(N);const z=y.filter(({key:$})=>$===N)[0];z?(j=D.edit(j,[N],z.value,R),Q=D.edit(Q,[N],z.value,R)):re.set(N,{key:N,localValue:K[N],remoteValue:X[N]})};for(const N of q.removed.values())ie.updated.has(N)?ae(N):Q=D.edit(Q,[N],void 0,R);for(const N of ie.removed.values())ee.has(N)||(q.updated.has(N)?ae(N):j=D.edit(j,[N],void 0,R));for(const N of q.updated.values())ee.has(N)||(ie.updated.has(N)?V.updated.has(N)&&ae(N):Q=D.edit(Q,[N],K[N],R));for(const N of ie.updated.values())ee.has(N)||(q.updated.has(N)?V.updated.has(N)&&ae(N):j=D.edit(j,[N],X[N],R));for(const N of q.added.values())ee.has(N)||(ie.added.has(N)?V.updated.has(N)&&ae(N):Q=d(N,j,Q,R));for(const N of ie.added.values())ee.has(N)||(q.added.has(N)?V.updated.has(N)&&ae(N):j=d(N,Q,j,R));const G=re.size>0||!p(j,Q,h),W=G||!p(j,a,[]),_=G||!p(Q,C,[]);return{localContent:W?j:null,remoteContent:_?Q:null,conflictsSettings:[...re.values()],hasConflicts:G}}e.merge=g;function p(a,C,E){if(a===C)return!0;const h=(0,O.parse)(a),y=(0,O.parse)(C),R=E.reduce((M,j)=>(M.add(j),M),new Set),U=r(a).filter(M=>!(M.setting&&R.has(M.setting.key))),F=r(C).filter(M=>!(M.setting&&R.has(M.setting.key)));if(U.length!==F.length)return!1;for(let M=0;M<U.length;M++){const j=U[M],Q=F[M];if(j.setting&&Q.setting){if(j.setting.key!==Q.setting.key||!L.equals(h[j.setting.key],y[j.setting.key]))return!1}else if(!j.setting&&!Q.setting){if(j.value!==Q.value)return!1}else return!1}return!0}function v(a){return a?r(a).length===0:!0}e.isEmpty=v;function u(a,C,E){const h=a?Object.keys(a).filter(M=>!E.has(M)):[],y=Object.keys(C).filter(M=>!E.has(M)),R=y.filter(M=>!h.includes(M)).reduce((M,j)=>(M.add(j),M),new Set),U=h.filter(M=>!y.includes(M)).reduce((M,j)=>(M.add(j),M),new Set),F=new Set;if(a)for(const M of h){if(U.has(M))continue;const j=a[M],Q=C[M];L.equals(j,Q)||F.add(M)}return{added:R,removed:U,updated:F}}function d(a,C,E,h){const y=(0,O.parse)(C),R=r(C),U=r(E),F=f(a,R,U);return c(E,a,y[a],F,U,h)}e.addSetting=d;function f(a,C,E){const h=C.findIndex(R=>R.setting?.key===a),y=C[h-1];if(y){if(y.setting){const U=i(y.setting.key,E);if(U)return{index:E.indexOf(U),insertAfter:!0}}else{const U=o(h,C);if(U){const F=i(U.setting.key,E);if(F){const M=n(E.indexOf(F),E),j=s(C,U,C[h]);if(M){const Q=s(E,F,M),K=t(j,Q);return K?{index:E.indexOf(K),insertAfter:!0}:{index:E.indexOf(M),insertAfter:!1}}else{const Q=s(E,F,E[E.length-1]),K=t(j,Q);return K?{index:E.indexOf(K),insertAfter:!0}:{index:E.length-1,insertAfter:!0}}}}}const R=C[h+1];if(R)if(R.setting){const U=i(R.setting.key,E);if(U)return{index:E.indexOf(U),insertAfter:!1}}else{const U=n(h,C);if(U){const F=i(U.setting.key,E);if(F){const M=o(E.indexOf(F),E),j=s(C,C[h],U);if(M){const Q=s(E,M,F),K=t(j.reverse(),Q.reverse());return K?{index:E.indexOf(K),insertAfter:!1}:{index:E.indexOf(M),insertAfter:!0}}else{const Q=s(E,E[0],F),K=t(j.reverse(),Q.reverse());return K?{index:E.indexOf(K),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:E.length-1,insertAfter:!0}}function c(a,C,E,h,y,R){let U;return h.index===-1?U=(0,T.setProperty)(a,[C],E,R):U=w(a,C,E,h,y,R).map(F=>(0,T.withFormatting)(a,F,R)[0]),(0,T.applyEdits)(a,U)}function w(a,C,E,h,y,R){const U=`${JSON.stringify(C)}: ${JSON.stringify(E)}`,F=(0,A.getEOL)(R,a),M=y[h.index];if(h.insertAfter){const j=[];if(M.setting)j.push({offset:M.endOffset,length:0,content:","+U});else{const Q=n(h.index,y),K=o(h.index,y),X=K?.setting?.commaOffset;K&&X===void 0&&j.push({offset:K.endOffset,length:0,content:","});const x=X!==void 0&&X>M.endOffset;j.push({offset:x?X+1:M.endOffset,length:0,content:Q?F+U+",":F+U})}return j}else{if(M.setting)return[{offset:M.startOffset,length:0,content:U+","}];const j=(y[h.index-1]&&!y[h.index-1].setting?F:"")+U+(n(h.index,y)?",":"")+F;return[{offset:M.startOffset,length:0,content:j}]}}function i(a,C){return C.filter(E=>E.setting?.key===a)[0]}function o(a,C){for(let E=a-1;E>=0;E--)if(C[E].setting)return C[E]}function n(a,C){for(let E=a+1;E<C.length;E++)if(C[E].setting)return C[E]}function s(a,C,E){const h=a.indexOf(C),y=a.indexOf(E);return a.filter((R,U)=>h<U&&U<y)}function t(a,C){if(a.length&&C.length){let E=0;for(;E<C.length&&E<a.length;E++)if(a[E].value!==C[E].value)return C[E-1];return C[E-1]}}function r(a){const C=[];let E=-1,h,y;const R={onObjectBegin:U=>{E++},onObjectProperty:(U,F,M)=>{E===0&&(h=F,y=U)},onObjectEnd:(U,F)=>{E--,E===0&&C.push({startOffset:h,endOffset:U+F,value:a.substring(h,U+F),setting:{key:y,commaOffset:void 0}})},onArrayBegin:(U,F)=>{E++},onArrayEnd:(U,F)=>{E--,E===0&&C.push({startOffset:h,endOffset:U+F,value:a.substring(h,U+F),setting:{key:y,commaOffset:void 0}})},onLiteralValue:(U,F,M)=>{E===0&&C.push({startOffset:h,endOffset:F+M,value:a.substring(h,F+M),setting:{key:y,commaOffset:void 0}})},onSeparator:(U,F,M)=>{if(E===0&&U===","){let j=C.length-1;for(;j>=0&&!C[j].setting;j--);const Q=C[j];Q&&C.splice(j,1,{startOffset:Q.startOffset,endOffset:Q.endOffset,value:Q.value,setting:{key:Q.setting.key,commaOffset:F}})}},onComment:(U,F)=>{E===0&&C.push({startOffset:U,endOffset:U+F,value:a.substring(U,U+F)})}};return(0,O.visit)(a,R),C}}),define(le[81],ue([0,1,3,2,4,25]),function(se,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,T.createDecorator)("IUserDataSyncAccountService");let L=class extends O.Disposable{get account(){return this._account}constructor(I,m){super(),this.userDataSyncStoreService=I,this.logService=m,this._onDidChangeAccount=this._register(new k.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(I.onTokenFailed(P=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed,P),this.updateAccount(void 0),P==="Forbidden"?this._onTokenFailed.fire(!0):this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(I.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(I){(I&&this._account?I.token!==this._account.token||I.authenticationProviderId!==this._account.authenticationProviderId:I!==this._account)&&(this._account=I,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(I))}};e.UserDataSyncAccountService=L,e.UserDataSyncAccountService=L=ye([Y(0,A.IUserDataSyncStoreService),Y(1,A.IUserDataSyncLogService)],L)}),define(le[241],ue([0,1,20,175,15,8,25]),function(se,e,k,O,T,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends A.AbstractLogger{constructor(m,P){super(),this.logger=this._register(m.createLogger((0,k.joinPath)(P.logsHome,`${L.USER_DATA_SYNC_LOG_ID}.log`),{id:L.USER_DATA_SYNC_LOG_ID,name:(0,O.localize)(0,null)}))}trace(m,...P){this.logger.trace(m,...P)}debug(m,...P){this.logger.debug(m,...P)}info(m,...P){this.logger.info(m,...P)}warn(m,...P){this.logger.warn(m,...P)}error(m,...P){this.logger.error(m,...P)}flush(){this.logger.flush()}};e.UserDataSyncLogService=D,e.UserDataSyncLogService=D=ye([Y(0,A.ILoggerService),Y(1,T.IEnvironmentService)],D)}),define(le[242],ue([0,1,6,3,2]),function(se,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends T.Disposable{constructor({onDidOpenMainWindow:D,onDidFocusMainWindow:I,getActiveWindowId:m}){super(),this.disposables=this._register(new T.DisposableStore),O.Event.latch(O.Event.any(D,I))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,k.createCancelablePromise)(()=>m()),(async()=>{try{const b=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:b}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(D){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=D}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=A}),define(le[112],ue([0,1,178,16,48,20,10,4,23]),function(se,e,k,O,T,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");function m(s){const t=s;return typeof t?.id=="string"&&L.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=m;function P(s){return typeof s?.id=="string"&&!m(s)&&!S(s)}e.isEmptyWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function b(s,t){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,O.basename)(s)}:t?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=b;function S(s){const t=s;return typeof t?.id=="string"&&L.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=S;function l(s){const t=s;if(t?.uri)return{id:t.id,uri:L.URI.revive(t.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:L.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=l;var g;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function p(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=p;function v(s){const t=s;return!!(t&&typeof t=="object"&&L.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=v;class u{constructor(t,r,a,C,E){this._id=t,this._transient=a,this._configuration=C,this._ignorePathCasing=E,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(t){this._id=t.id,this._configuration=t.configuration,this._transient=t.transient,this._ignorePathCasing=t._ignorePathCasing,this.folders=t.folders}get folders(){return this._folders}set folders(t){this._folders=t,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(t){this._configuration=t}getFolder(t){return t&&this._foldersMap.findSubstr(t)||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const t of this.folders)this._foldersMap.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class d{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,A.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function f(s){return new d({uri:s,index:0,name:(0,A.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=f,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function c(s,t){return A.extUriBiasedIgnorePathCase.isEqualOrParent(s,t.untitledWorkspacesHome)}e.isUntitledWorkspace=c;function w(s){let t;return L.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===I.Schemas.tmp}e.isTemporaryWorkspace=w,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(s){return s.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=i;function o(s,t){return!c(s,t)&&!w(s)}e.isSavedWorkspace=o;function n(s){return(typeof s=="string"?(0,O.extname)(s):(0,A.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(le[18],ue([0,1,53,3,2,20,10,169,15,11,4,8,112,35,28,6,32,27,12]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g,p,v,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var f;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(f||(e.ProfileResourceType=f={}));function c(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&L.URI.isUri(t.location)&&L.URI.isUri(t.globalStorageHome)&&L.URI.isUri(t.settingsResource)&&L.URI.isUri(t.keybindingsResource)&&L.URI.isUri(t.tasksResource)&&L.URI.isUri(t.snippetsHome)&&L.URI.isUri(t.extensionsResource))}e.isUserDataProfile=c,e.IUserDataProfilesService=(0,P.createDecorator)("IUserDataProfilesService");function w(s,t){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:L.URI.revive(s.location).with({scheme:t}),globalStorageHome:L.URI.revive(s.globalStorageHome).with({scheme:t}),settingsResource:L.URI.revive(s.settingsResource).with({scheme:t}),keybindingsResource:L.URI.revive(s.keybindingsResource).with({scheme:t}),tasksResource:L.URI.revive(s.tasksResource).with({scheme:t}),snippetsHome:L.URI.revive(s.snippetsHome).with({scheme:t}),extensionsResource:L.URI.revive(s.extensionsResource).with({scheme:t}),cacheHome:L.URI.revive(s.cacheHome).with({scheme:t}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.reviveProfile=w;function i(s,t,r,a,C,E){return{id:s,name:t,location:r,isDefault:!1,shortName:C?.shortName,icon:C?.icon,globalStorageHome:E&&C?.useDefaultFlags?.globalState?E.globalStorageHome:(0,A.joinPath)(r,"globalStorage"),settingsResource:E&&C?.useDefaultFlags?.settings?E.settingsResource:(0,A.joinPath)(r,"settings.json"),keybindingsResource:E&&C?.useDefaultFlags?.keybindings?E.keybindingsResource:(0,A.joinPath)(r,"keybindings.json"),tasksResource:E&&C?.useDefaultFlags?.tasks?E.tasksResource:(0,A.joinPath)(r,"tasks.json"),snippetsHome:E&&C?.useDefaultFlags?.snippets?E.snippetsHome:(0,A.joinPath)(r,"snippets"),extensionsResource:E&&C?.useDefaultFlags?.extensions?E.extensionsResource:(0,A.joinPath)(r,"extensions.json"),cacheHome:(0,A.joinPath)(a,s),useDefaultFlags:C?.useDefaultFlags,isTransient:C?.transient}}e.toUserDataProfile=i;let o=class extends T.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(t,r,a,C){super(),this.environmentService=t,this.fileService=r,this.uriIdentityService=a,this.logService=C,this.enabled=!0,this._onDidChangeProfiles=this._register(new O.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new O.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new O.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new O.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new l.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,A.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(t){this.enabled!==t&&(this._profilesObject=void 0,this.enabled=t)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const t=this.createDefaultProfile(),r=[t];if(this.enabled)try{for(const E of this.getStoredProfiles()){if(!E.name||!(0,d.isString)(E.name)||!E.location){this.logService.warn("Skipping the invalid stored profile",E.location||E.name);continue}r.push(i((0,A.basename)(E.location),E.name,E.location,this.profilesCacheHome,{shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags},t))}}catch(E){this.logService.error(E)}const a=new l.ResourceMap,C=new Map;if(r.length)try{const E=this.getStoredProfileAssociations();if(E.workspaces)for(const[h,y]of Object.entries(E.workspaces)){const R=L.URI.parse(h),U=r.find(F=>F.id===y);U&&a.set(R,U)}if(E.emptyWindows)for(const[h,y]of Object.entries(E.emptyWindows)){const R=r.find(U=>U.id===y);R&&C.set(h,R)}}catch(E){this.logService.error(E)}this._profilesObject={profiles:r,workspaces:a,emptyWindows:C}}return this._profilesObject}createDefaultProfile(){const t=i("__default__profile__",(0,D.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...t,extensionsResource:this.getDefaultProfileExtensionsLocation()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",a=new RegExp(`${(0,u.escapeRegExpCharacters)(r)}\\s(\\d+)`);let C=0;for(const h of this.profiles){const y=a.exec(h.name),R=y?parseInt(y[1]):0;C=R>C?R:C}const E=`${r} ${C+1}`;return this.createProfile((0,k.hash)((0,v.generateUuid)()).toString(16),E,{transient:!0},t)}async createNamedProfile(t,r,a){return this.createProfile((0,k.hash)((0,v.generateUuid)()).toString(16),t,r,a)}async createProfile(t,r,a,C){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const E=await this.doCreateProfile(t,r,a);return C&&await this.setProfileForWorkspace(C,E),E}async doCreateProfile(t,r,a){if(!(0,d.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let C=this.profileCreationPromises.get(r);return C||(C=(async()=>{try{const E=this.profiles.find(R=>R.name===r||R.id===t);if(E)return E;const h=i(t,r,(0,A.joinPath)(this.profilesHome,t),this.profilesCacheHome,a,this.defaultProfile);await this.fileService.createFolder(h.location);const y=[];return this._onWillCreateProfile.fire({profile:h,join(R){y.push(R)}}),await p.Promises.settled(y),this.updateProfiles([h],[],[]),h}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,C)),C}async updateProfile(t,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(C=>C.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);return a=i(a.id,r.name??a.name,a.location,this.profilesCacheHome,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[a]),a}async removeProfile(t){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(C=>C.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const a=[];this._onWillRemoveProfile.fire({profile:r,join(C){a.push(C)}});try{await Promise.allSettled(a)}catch(C){this.logService.error(C)}for(const C of[...this.profilesObject.emptyWindows.keys()])r.id===this.profilesObject.emptyWindows.get(C)?.id&&this.profilesObject.emptyWindows.delete(C);for(const C of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(C)?.id&&this.profilesObject.workspaces.delete(C);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{await this.fileService.del(r.cacheHome,{recursive:!0})}catch(C){(0,m.toFileOperationResult)(C)!==1&&this.logService.error(C)}}async setProfileForWorkspace(t,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(C=>C.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(t,a)}unsetWorkspace(t,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(t,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const t=await this.fileService.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.uriIdentityService.extUri.isEqual(a.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const t=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.getWorkspace(t);return L.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindows.get(r)??this.profilesObject.emptyWindows.get(r)}getWorkspace(t){return(0,S.isSingleFolderWorkspaceIdentifier)(t)?t.uri:(0,S.isWorkspaceIdentifier)(t)?t.configPath:t.id}isProfileAssociatedToWorkspace(t){return!!([...this.transientProfilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location))||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location))||[...this.profilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location))||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location)))}updateProfiles(t,r,a){const C=[...this.profiles,...t],E=[];this.transientProfilesObject.profiles=[];for(let h of C)h.isDefault||r.some(y=>h.id===y.id)||(h=a.find(y=>h.id===y.id)??h,h.isTransient?this.transientProfilesObject.profiles.push(h):E.push({location:h.location,name:h.name,shortName:h.shortName,icon:h.icon,useDefaultFlags:h.useDefaultFlags}));this.saveStoredProfiles(E),this._profilesObject=void 0,this.triggerProfilesChanges(t,r,a)}triggerProfilesChanges(t,r,a){this._onDidChangeProfiles.fire({added:t,removed:r,updated:a,all:this.profiles})}updateWorkspaceAssociation(t,r,a){a=r?.isTransient?!0:a,a||this.updateWorkspaceAssociation(t,void 0,!0);const C=this.getWorkspace(t),E=a?this.transientProfilesObject:this.profilesObject;L.URI.isUri(C)?(E.workspaces.delete(C),r&&E.workspaces.set(C,r)):(E.emptyWindows.delete(C),r&&E.emptyWindows.set(C,r)),a||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const t={};for(const[a,C]of this.profilesObject.workspaces.entries())t[a.toString()]=C.id;const r={};for(const[a,C]of this.profilesObject.emptyWindows.entries())r[a.toString()]=C.id;this.saveStoredProfileAssociations({workspaces:t,emptyWindows:r}),this._profilesObject=void 0}migrateStoredProfileAssociations(t){const r={},a=this.createDefaultProfile();if(t.workspaces)for(const[E,h]of Object.entries(t.workspaces)){const y=L.URI.parse(h);r[E]=this.uriIdentityService.extUri.isEqual(y,a.location)?a.id:this.uriIdentityService.extUri.basename(y)}const C={};if(t.emptyWindows)for(const[E,h]of Object.entries(t.emptyWindows)){const y=L.URI.parse(h);C[E]=this.uriIdentityService.extUri.isEqual(y,a.location)?a.id:this.uriIdentityService.extUri.basename(y)}return{workspaces:r,emptyWindows:C}}getStoredProfiles(){return[]}saveStoredProfiles(t){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(t){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=o,e.UserDataProfilesService=o=ye([Y(0,I.IEnvironmentService),Y(1,m.IFileService),Y(2,g.IUriIdentityService),Y(3,b.ILogService)],o);class n extends o{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(t){this.storedProfiles=t}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(t){this.storedProfileAssociations=t}}e.InMemoryUserDataProfilesService=n}),define(le[243],ue([0,1,6,2,18]),function(se,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let A=class extends O.Disposable{constructor(D){super(),this._register(new k.RunOnceScheduler(()=>{D.cleanUp()},10*1e3)).schedule()}};e.UserDataProfilesCleaner=A,e.UserDataProfilesCleaner=A=ye([Y(0,T.IUserDataProfilesService)],A)}),define(le[244],ue([0,1,17,6,26,7,3,2,5,12,10,152,29,33,45,8,24,22,28,18]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g,p,v,u,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.toExtensionManagementError=e.joinErrors=e.AbstractExtensionManagementService=void 0;let c=class extends D.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(t,r,a,C,E,h){super(),this.galleryService=t,this.telemetryService=r,this.uriIdentityService=a,this.logService=C,this.productService=E,this.userDataProfilesService=h,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new L.Emitter),this._onDidInstallExtensions=this._register(new L.Emitter),this._onUninstallExtension=this._register(new L.Emitter),this._onDidUninstallExtension=this._register(new L.Emitter),this._onDidUpdateExtensionMetadata=this._register(new L.Emitter),this.participants=[],this._register((0,D.toDisposable)(()=>{this.installingExtensions.forEach(({task:y})=>y.cancel()),this.uninstallingExtensions.forEach(y=>y.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,S.isTargetPlatformCompatible)(a,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const C=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:E})=>(0,l.areSameExtensions)(E,t.identifier));if(C?.local)return C?.local;throw C?.error?C.error:new S.ExtensionManagementError(`Unknown error while installing extension ${t.identifier.id}`,S.ExtensionManagementErrorCode.Unknown)}catch(a){throw i(a)}}async installGalleryExtensions(t){if(!this.galleryService.isEnabled())throw new S.ExtensionManagementError(b.localize(0,null),S.ExtensionManagementErrorCode.NotAllowed);const r=[],a=[];await Promise.allSettled(t.map(async({extension:C,options:E})=>{try{const h=await this.checkAndGetCompatibleVersion(C,!!E?.installGivenVersion,!!E?.installPreReleaseVersion);a.push({...h,options:E})}catch(h){r.push({identifier:C.identifier,operation:2,source:C,error:h})}})),a.length&&r.push(...await this.installExtensions(a));for(const C of r)C.error&&(this.logService.error("Failed to install extension.",C.identifier.id),this.logService.error(C.error),C.source&&!P.URI.isUri(C.source)&&o(this.telemetryService,"extensionGallery:install",{extensionData:(0,l.getGalleryExtensionTelemetryData)(C.source),error:C.error}));return r}async uninstall(t,r={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,r)}async toggleAppliationScope(t,r){if((0,g.isApplicationScopedExtension)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let a=await this.updateMetadata(t,{isApplicationScoped:!1},this.userDataProfilesService.defaultProfile.extensionsResource);this.uriIdentityService.extUri.isEqual(r,this.userDataProfilesService.defaultProfile.extensionsResource)||(a=await this.copyExtension(t,this.userDataProfilesService.defaultProfile.extensionsResource,r));for(const C of this.userDataProfilesService.profiles){const E=(await this.getInstalled(1,C.extensionsResource)).find(h=>(0,l.areSameExtensions)(h.identifier,t.identifier));E?this._onDidUpdateExtensionMetadata.fire(E):this._onDidUninstallExtension.fire({identifier:t.identifier,profileLocation:C.extensionsResource})}return a}else{const a=this.uriIdentityService.extUri.isEqual(r,this.userDataProfilesService.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.userDataProfilesService.defaultProfile.extensionsResource):await this.copyExtension(t,r,this.userDataProfilesService.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this._onDidInstallExtensions.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtensions(t){const r=[];return await Promise.allSettled(t.map(async a=>{try{const C=await this.installExtension(a,(E,h)=>t.some(y=>(0,l.adoptToGalleryExtensionId)(h.identifier.id)===(0,l.getGalleryExtensionId)(y.manifest.publisher,y.manifest.name))?!1:this.canWaitForTask(E,h));r.push(...C)}catch(C){r.push({identifier:{id:(0,l.getGalleryExtensionId)(a.manifest.publisher,a.manifest.name)},operation:2,source:a.extension,error:C})}})),this._onDidInstallExtensions.fire(r),r}async installExtension({manifest:t,extension:r,options:a},C){const E=a.isApplicationScoped||a.isBuiltin||(0,g.isApplicationScopedExtension)(t),h={...a,installOnlyNewlyAddedFromExtensionPack:P.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:E,profileLocation:E?this.userDataProfilesService.defaultProfile.extensionsResource:a.profileLocation??this.getCurrentExtensionsManifestLocation()},y=Q=>`${l.ExtensionKey.create(Q).toString()}${h.profileLocation?`-${h.profileLocation.toString()}`:""}`;if(!P.URI.isUri(r)){const Q=this.installingExtensions.get(y(r));if(Q)return this.logService.info("Extensions is already requested to install",r.identifier.id),await Q.task.waitUntilTaskIsFinished(),[]}const R=[],U=[],F=[],M=this.createInstallExtensionTask(t,r,h);P.URI.isUri(r)||this.installingExtensions.set(y(r),{task:M,waitingTasks:[]}),this._onInstallExtension.fire({identifier:M.identifier,source:r,profileLocation:h.profileLocation}),this.logService.info("Installing extension:",M.identifier.id),R.push({task:M,manifest:t});let j=!1;try{if(h.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",M.identifier.id);else try{const K=await this.getAllDepsAndPackExtensions(M.identifier,t,!!h.installOnlyNewlyAddedFromExtensionPack,!!h.installPreReleaseVersion,h.profileLocation),X=await this.getInstalled(void 0,h.profileLocation),x={...h,donotIncludePackAndDependencies:!0,context:{...h.context,[S.EXTENSION_INSTALL_DEP_PACK_CONTEXT]:!0}};for(const{gallery:J,manifest:V}of(0,k.distinct)(K,({gallery:q})=>q.identifier.id)){j=j||!!V.extensionDependencies?.some(re=>(0,l.areSameExtensions)({id:re},M.identifier));const q=y(J),ie=this.installingExtensions.get(q);if(ie){if(C(M,ie.task)){const re=ie.task.identifier;this.logService.info("Waiting for already requested installing extension",re.id,M.identifier.id),ie.waitingTasks.push(M),U.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,ee=>ee.some(ae=>(0,l.areSameExtensions)(ae.identifier,re)))).then(ee=>{if(this.logService.info("Finished waiting for already requested installing extension",re.id,M.identifier.id),!ee.find(G=>(0,l.areSameExtensions)(G.identifier,re))?.local)throw new Error(`Extension ${re.id} is not installed`)}))}}else if(!X.some(({identifier:re})=>(0,l.areSameExtensions)(re,J.identifier))){const re=this.createInstallExtensionTask(V,J,x);this.installingExtensions.set(q,{task:re,waitingTasks:[M]}),this._onInstallExtension.fire({identifier:re.identifier,source:J,profileLocation:h.profileLocation}),this.logService.info("Installing extension:",re.identifier.id,M.identifier.id),R.push({task:re,manifest:V})}}}catch(K){if(P.URI.isUri(M.source))(0,k.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",M.identifier.id,K.message),(0,k.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",M.identifier.id,K.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",M.identifier.id),K}const Q=R.reduce((K,{task:X,manifest:x})=>(K.set(X.identifier.id.toLowerCase(),{task:X,manifest:x}),K),new Map);for(;Q.size;){let K;const X=[...Q.values()].filter(({manifest:x})=>!x.extensionDependencies?.some(J=>Q.has(J.toLowerCase())));X.length?K=Q.size===1?X:X.filter(({task:x})=>!(x===M&&!j)):(this.logService.info("Found extensions with circular dependencies",X.map(({task:x})=>x.identifier.id)),K=[...Q.values()]),await this.joinAllSettled(K.map(async({task:x})=>{const J=new Date().getTime();try{const V=await x.run();if(await this.joinAllSettled(this.participants.map(q=>q.postInstall(V,x.source,h,T.CancellationToken.None))),!P.URI.isUri(x.source)){const q=x.operation===3,ie=q?void 0:(new Date().getTime()-x.source.lastUpdated)/1e3;if(o(this.telemetryService,q?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.getGalleryExtensionTelemetryData)(x.source),verificationStatus:x.verificationStatus,duration:new Date().getTime()-J,durationSinceUpdate:ie}),I.isWeb&&x.operation!==3)try{await this.galleryService.reportStatistic(V.manifest.publisher,V.manifest.name,V.manifest.version,"install")}catch{}}F.push({local:V,identifier:x.identifier,operation:x.operation,source:x.source,context:x.options.context,profileLocation:x.profileLocation,applicationScoped:V.isApplicationScoped})}catch(V){throw this.logService.error("Error while installing the extension",x.identifier.id,(0,A.getErrorMessage)(V)),V}finally{Q.delete(x.identifier.id.toLowerCase())}}))}return U.length&&await this.joinAllSettled(U),F.forEach(({identifier:K})=>this.logService.info("Extension installed successfully:",K.id)),F}catch(Q){if(R.forEach(({task:K})=>K.cancel()),F.length)try{const K=await Promise.allSettled(F.map(({local:X})=>this.createUninstallExtensionTask(X,{versionOnly:!0,profileLocation:h.profileLocation}).run()));for(let X=0;X<K.length;X++){const x=K[X],{identifier:J}=F[X];x.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",J.id):this.logService.warn("Rollback: Error while uninstalling extension",J.id,(0,A.getErrorMessage)(x.reason))}}catch(K){this.logService.warn("Error while rolling back extensions",(0,A.getErrorMessage)(K),F.map(({identifier:X})=>X.id))}return R.map(({task:K})=>({identifier:K.identifier,operation:2,source:K.source,context:h.context,profileLocation:h.profileLocation,error:Q}))}finally{for(const{task:Q}of R)Q.source&&!P.URI.isUri(Q.source)&&this.installingExtensions.delete(y(Q.source))}}canWaitForTask(t,r){for(const[,{task:a,waitingTasks:C}]of this.installingExtensions.entries())if(a===t&&(C.includes(r)||C.some(E=>this.canWaitForTask(E,r)))||a===r&&C[0]&&!this.canWaitForTask(t,C[0]))return!1;return!0}async joinAllSettled(t){const r=[],a=[],C=await Promise.allSettled(t);for(const E of C)E.status==="fulfilled"?r.push(E.value):a.push(E.reason);if(a.length)throw w(a);return r}async getAllDepsAndPackExtensions(t,r,a,C,E){if(!this.galleryService.isEnabled())return[];const h=await this.getInstalled(void 0,E),y=[],R=[],U=async(F,M)=>{y.push(F);const j=M.extensionDependencies||[],Q=[...j];if(M.extensionPack){const K=a?h.find(X=>(0,l.areSameExtensions)(X.identifier,F)):void 0;for(const X of M.extensionPack)K&&K.manifest.extensionPack&&K.manifest.extensionPack.some(x=>(0,l.areSameExtensions)({id:x},{id:X}))||Q.every(x=>!(0,l.areSameExtensions)({id:x},{id:X}))&&Q.push(X)}if(Q.length){const K=Q.filter(X=>y.every(x=>!(0,l.areSameExtensions)(x,{id:X})));if(K.length){const X=await this.galleryService.getExtensions(K.map(x=>({id:x,preRelease:C})),T.CancellationToken.None);for(const x of X){if(y.find(q=>(0,l.areSameExtensions)(q,x.identifier)))continue;const J=j.some(q=>(0,l.areSameExtensions)({id:q},x.identifier));let V;try{V=await this.checkAndGetCompatibleVersion(x,!1,C)}catch(q){if(J)throw q;this.logService.info("Skipping the packed extension as it cannot be installed",x.identifier.id,(0,A.getErrorMessage)(q));continue}R.push({gallery:V.extension,manifest:V.manifest}),await U(V.extension.identifier,V.manifest)}}}};return await U(t,r),R}async checkAndGetCompatibleVersion(t,r,a){let C;const E=await this.getExtensionsControlManifest();if(E.malicious.some(R=>(0,l.areSameExtensions)(t.identifier,R)))throw new S.ExtensionManagementError(b.localize(1,null,t.identifier.id),S.ExtensionManagementErrorCode.Malicious);const h=E.deprecated[t.identifier.id.toLowerCase()];if(h?.extension?.autoMigrate){if(this.logService.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${h.extension.id}' extension instead.`),C=(await this.galleryService.getExtensions([{id:h.extension.id,preRelease:h.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},T.CancellationToken.None))[0],!C)throw new S.ExtensionManagementError(b.localize(2,null,t.identifier.id,h.extension.id),S.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const R=await this.getTargetPlatform();throw new S.ExtensionManagementError(b.localize(3,null,t.identifier.id,this.productService.nameLong,(0,S.TargetPlatformToString)(R)),S.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(C=await this.getCompatibleVersion(t,r,a),!C)throw!a&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],T.CancellationToken.None))[0]?new S.ExtensionManagementError(b.localize(4,null,t.displayName??t.identifier.id),S.ExtensionManagementErrorCode.ReleaseVersionNotFound):new S.ExtensionManagementError(b.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),S.ExtensionManagementErrorCode.Incompatible)}this.logService.info("Getting Manifest...",C.identifier.id);const y=await this.galleryService.getManifest(C,T.CancellationToken.None);if(y===null)throw new S.ExtensionManagementError(`Missing manifest for extension ${C.identifier.id}`,S.ExtensionManagementErrorCode.Invalid);if(y.version!==C.version)throw new S.ExtensionManagementError(`Cannot install '${C.identifier.id}' extension because of version mismatch in Marketplace`,S.ExtensionManagementErrorCode.Invalid);return{extension:C,manifest:y}}async getCompatibleVersion(t,r,a){const C=await this.getTargetPlatform();let E=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(E=(await this.galleryService.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:C,compatible:!0},T.CancellationToken.None))[0]||null),!E&&await this.galleryService.isExtensionCompatible(t,a,C)&&(E=t),E||(r?E=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:C,compatible:!0},T.CancellationToken.None))[0]||null:E=await this.galleryService.getCompatibleExtension(t,a,C)),E}async uninstallExtension(t,r){const a={...r,profileLocation:t.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:r.profileLocation??this.getCurrentExtensionsManifestLocation()},C=F=>`${F.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,E=this.uninstallingExtensions.get(C(t.identifier));if(E)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),E.waitUntilTaskIsFinished();const h=F=>{const M=this.createUninstallExtensionTask(F,a);return this.uninstallingExtensions.set(C(M.extension.identifier),M),a.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${F.identifier.id}@${F.manifest.version}`),this._onUninstallExtension.fire({identifier:F.identifier,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped}),M},y=(F,M)=>{M?a.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString(),M.message):this.logService.error("Failed to uninstall extension:",`${F.identifier.id}@${F.manifest.version}`,M.message):a.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${F.identifier.id}@${F.manifest.version}`),o(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,l.getLocalExtensionTelemetryData)(F),error:M}),this._onDidUninstallExtension.fire({identifier:F.identifier,error:M?.code,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped})},R=[],U=[];try{R.push(h(t));const F=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const M=this.getAllPackExtensionsToUninstall(t,F);for(const j of M)this.uninstallingExtensions.has(C(j.identifier))?this.logService.info("Extensions is already requested to uninstall",j.identifier.id):R.push(h(j))}a.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(R.map(M=>M.extension),F,t),await this.joinAllSettled(R.map(async M=>{try{if(await M.run(),await this.joinAllSettled(this.participants.map(j=>j.postUninstall(M.extension,a,T.CancellationToken.None))),M.extension.identifier.uuid)try{await this.galleryService.reportStatistic(M.extension.manifest.publisher,M.extension.manifest.name,M.extension.manifest.version,"uninstall")}catch{}y(M.extension)}catch(j){const Q=j instanceof S.ExtensionManagementError?j:new S.ExtensionManagementError((0,A.getErrorMessage)(j),S.ExtensionManagementErrorCode.Internal);throw y(M.extension,Q),Q}finally{U.push(M)}}))}catch(F){const M=F instanceof S.ExtensionManagementError?F:new S.ExtensionManagementError((0,A.getErrorMessage)(F),S.ExtensionManagementErrorCode.Internal);for(const j of R){try{j.cancel()}catch{}U.includes(j)||y(j.extension,M)}throw M}finally{for(const F of R)this.uninstallingExtensions.delete(C(F.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}checkForDependents(t,r,a){for(const C of t){const E=this.getDependents(C,r);if(E.length){const h=E.filter(y=>!t.some(R=>(0,l.areSameExtensions)(R.identifier,y.identifier)));if(h.length)throw new Error(this.getDependentsErrorMessage(C,h,a))}}}getDependentsErrorMessage(t,r,a){return a===t?r.length===1?b.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?b.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(t,r,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const C=t.manifest.extensionPack?t.manifest.extensionPack:[];if(C.length){const E=r.filter(y=>!y.isBuiltin&&C.some(R=>(0,l.areSameExtensions)({id:R},y.identifier))),h=[];for(const y of E)h.push(...this.getAllPackExtensionsToUninstall(y,r,a));return[...E,...h]}return[]}getDependents(t,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(C=>(0,l.areSameExtensions)({id:C},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.AbstractExtensionManagementService=c,e.AbstractExtensionManagementService=c=ye([Y(0,S.IExtensionGalleryService),Y(1,u.ITelemetryService),Y(2,d.IUriIdentityService),Y(3,p.ILogService),Y(4,v.IProductService),Y(5,f.IUserDataProfilesService)],c);function w(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=w;function i(s){if(s instanceof S.ExtensionManagementError)return s;if(s instanceof S.ExtensionGalleryError){const r=new S.ExtensionManagementError(s.message,S.ExtensionManagementErrorCode.Gallery);return r.stack=s.stack,r}const t=new S.ExtensionManagementError(s.message,S.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}e.toExtensionManagementError=i;function o(s,t,{extensionData:r,verificationStatus:a,duration:C,error:E,durationSinceUpdate:h}){let y,R;(0,m.isDefined)(a)&&(a===!0?a="Verified":(a===!1||(y=S.ExtensionManagementErrorCode.Signature,R=a),a="Unverified")),E&&(E instanceof S.ExtensionManagementError||E instanceof S.ExtensionGalleryError?(y=E.code,E.code===S.ExtensionManagementErrorCode.Signature&&(R=E.message)):y=S.ExtensionManagementErrorCode.Internal),s.publicLog(t,{...r,verificationStatus:a,success:!E,duration:C,errorcode:y,errorcodeDetail:R,durationSinceUpdate:h})}class n{constructor(){this.barrier=new O.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(t=>new Promise((r,a)=>{const C=t.onCancellationRequested(()=>{C.dispose(),a(new A.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=n}),define(le[51],ue([0,1,6,14,2,3,35,10,29,33,11,4,8,18,28,12,7,22]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g,p,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d||(e.ExtensionsProfileScanningErrorCode=d={}));class f extends Error{constructor(n,s){super(n),this.code=s}}e.ExtensionsProfileScanningError=f,e.IExtensionsProfileScannerService=(0,b.createDecorator)("IExtensionsProfileScannerService");let c=class extends T.Disposable{constructor(n,s,t,r,a,C){super(),this.extensionsLocation=n,this.fileService=s,this.userDataProfilesService=t,this.uriIdentityService=r,this.telemetryService=a,this.logService=C,this._onAddExtensions=this._register(new A.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new A.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new A.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new A.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new L.ResourceMap}scanProfileExtensions(n,s){return this.withProfileExtensions(n,void 0,s)}async addExtensionsToProfile(n,s){const t=[],r=[];try{return await this.withProfileExtensions(s,a=>{const C=[];for(const E of a)n.some(([h])=>(0,m.areSameExtensions)(h.identifier,E.identifier)&&h.manifest.version!==E.version)?t.push(E):C.push(E);for(const[E,h]of n){const y=C.findIndex(U=>(0,m.areSameExtensions)(U.identifier,E.identifier)&&U.version===E.manifest.version),R={identifier:E.identifier,version:E.manifest.version,location:E.location,metadata:h};y===-1?(r.push(R),C.push(R)):C.splice(y,1,R)}return r.length&&this._onAddExtensions.fire({extensions:r,profileLocation:s}),t.length&&this._onRemoveExtensions.fire({extensions:t,profileLocation:s}),C}),r.length&&this._onDidAddExtensions.fire({extensions:r,profileLocation:s}),t.length&&this._onDidRemoveExtensions.fire({extensions:t,profileLocation:s}),r}catch(a){throw r.length&&this._onDidAddExtensions.fire({extensions:r,error:a,profileLocation:s}),t.length&&this._onDidRemoveExtensions.fire({extensions:t,error:a,profileLocation:s}),a}}async updateMetadata(n,s){const t=[];return await this.withProfileExtensions(s,r=>{const a=[];for(const C of r){const E=n.find(([h])=>(0,m.areSameExtensions)(h.identifier,C.identifier)&&h.manifest.version===C.version);E&&(C.metadata={...C.metadata,...E[1]},t.push(C)),a.push(C)}return a}),t}async removeExtensionFromProfile(n,s){const t=[];try{await this.withProfileExtensions(s,r=>{const a=[];for(const C of r)(0,m.areSameExtensions)(C.identifier,n.identifier)?t.push(C):a.push(C);return t.length&&this._onRemoveExtensions.fire({extensions:t,profileLocation:s}),a}),t.length&&this._onDidRemoveExtensions.fire({extensions:t,profileLocation:s})}catch(r){throw t.length&&this._onDidRemoveExtensions.fire({extensions:t,error:r,profileLocation:s}),r}}async withProfileExtensions(n,s,t){return this.getResourceAccessQueue(n).queue(async()=>{let r=[],a;try{const C=await this.fileService.readFile(n);a=JSON.parse(C.value.toString().trim()||"[]")}catch(C){if((0,P.toFileOperationResult)(C)!==1)throw C;if(this.uriIdentityService.extUri.isEqual(n,this.userDataProfilesService.defaultProfile.extensionsResource)&&(a=await this.migrateFromOldDefaultProfileExtensionsLocation()),!a&&t?.bailOutWhenFileNotFound)throw new f((0,v.getErrorMessage)(C),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.reportAndThrowInvalidConentError(n);let C=!1;for(const E of a){w(E)||this.reportAndThrowInvalidConentError(n);let h;if((0,p.isString)(E.relativeLocation)&&E.relativeLocation)h=this.resolveExtensionLocation(E.relativeLocation);else if((0,p.isString)(E.location)){this.logService.warn(`Extensions profile: Ignoring extension with invalid location: ${E.location}`);continue}else{h=D.URI.revive(E.location);const y=this.toRelativePath(h);y&&(C=!0,E.relativeLocation=y)}(0,p.isUndefined)(E.metadata?.hasPreReleaseVersion)&&E.metadata?.preRelease&&(C=!0,E.metadata.hasPreReleaseVersion=!0),r.push({identifier:E.identifier,location:h,version:E.version,metadata:E.metadata})}C&&await this.fileService.writeFile(n,O.VSBuffer.fromString(JSON.stringify(a)))}if(s){r=s(r);const C=r.map(E=>({identifier:E.identifier,version:E.version,location:E.location.toJSON(),relativeLocation:this.toRelativePath(E.location),metadata:E.metadata}));await this.fileService.writeFile(n,O.VSBuffer.fromString(JSON.stringify(C)))}return r})}reportAndThrowInvalidConentError(n){const s=new f(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}toRelativePath(n){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(n),this.extensionsLocation)?this.uriIdentityService.extUri.basename(n):void 0}resolveExtensionLocation(n){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,n)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const n=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),s=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let t;try{t=(await this.fileService.readFile(n)).value.toString()}catch(a){if((0,P.toFileOperationResult)(a)===1)return;throw a}this.logService.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(t);Array.isArray(a)&&a.every(C=>w(C))?r=a:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.logService.error(a)}if(r)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify(r)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(a){if((0,P.toFileOperationResult)(a)===3)this.logService.info("Migration from old default profile location to new location is done by another window",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw a}try{await this.fileService.del(n)}catch(a){(0,P.toFileOperationResult)(a)!==1&&this.logService.error(a)}try{await this.fileService.del(s)}catch(a){(0,P.toFileOperationResult)(a)!==1&&this.logService.error(a)}return r})()),this._migrationPromise}getResourceAccessQueue(n){let s=this.resourcesAccessQueueMap.get(n);return s||(s=new k.Queue,this.resourcesAccessQueueMap.set(n,s)),s}};e.AbstractExtensionsProfileScannerService=c,e.AbstractExtensionsProfileScannerService=c=ye([Y(1,P.IFileService),Y(2,l.IUserDataProfilesService),Y(3,g.IUriIdentityService),Y(4,u.ITelemetryService),Y(5,S.ILogService)],c);function w(o){return(0,p.isObject)(o)&&(0,I.isIExtensionIdentifier)(o.identifier)&&(i(o.location)||(0,p.isString)(o.location)&&o.location)&&((0,p.isUndefined)(o.relativeLocation)||(0,p.isString)(o.relativeLocation))&&o.version&&(0,p.isString)(o.version)}function i(o){return o?(0,p.isString)(o.path)&&(0,p.isString)(o.scheme):!1}}),define(le[82],ue([0,1,17,6,30,14,7,34,138,2,23,16,5,20,55,89,12,10,155,15,33,45,71,11,4,8,24,3,66,51,18,28,183]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g,p,v,u,d,f,c,w,i,o,n,s,t,r,a,C,E,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var R;(function(X){function x(J,V){if(J===V)return!0;const q=Object.keys(J),ie=new Set;for(const re of Object.keys(V))ie.add(re);if(q.length!==ie.size)return!1;for(const re of q){if(J[re]!==V[re])return!1;ie.delete(re)}return ie.size===0}X.equals=x})(R||(e.Translations=R={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let U=class extends m.Disposable{constructor(x,J,V,q,ie,re,ee,ae,G,W,_,N){super(),this.systemExtensionsLocation=x,this.userExtensionsLocation=J,this.extensionsControlLocation=V,this.currentProfile=q,this.userDataProfilesService=ie,this.extensionsProfileScannerService=re,this.fileService=ee,this.logService=ae,this.environmentService=G,this.productService=W,this.uriIdentityService=_,this.instantiationService=N,this._onDidChangeCache=this._register(new r.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,l.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(j,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(j,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(M,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,c.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(x,J,V){const[q,ie]=await Promise.all([this.scanSystemExtensions(x),this.scanUserExtensions(J)]),re=V?await this.scanExtensionsUnderDevelopment(x,[...q,...ie]):[];return this.dedupExtensions(q,ie,re,await this.getTargetPlatform(),!0)}async scanSystemExtensions(x){const J=[];J.push(this.scanDefaultSystemExtensions(!!x.useCache,x.language)),J.push(this.scanDevSystemExtensions(x.language,!!x.checkControlFile));const[V,q]=await Promise.all(J);return this.applyScanOptions([...V,...q],0,x,!1)}async scanUserExtensions(x){const J=x.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",J);const V=this.uriIdentityService.extUri.isEqual(x.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,q=await this.createExtensionScannerInput(J,!!x.profileLocation,1,!x.includeUninstalled,x.language,!0,V),ie=x.useCache&&!q.devMode&&q.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let re;try{re=await ie.scanExtensions(q)}catch(ee){if(ee instanceof C.ExtensionsProfileScanningError&&ee.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),re=await ie.scanExtensions(q);else throw ee}return re=await this.applyScanOptions(re,1,x,!0),this.logService.trace("Scanned user extensions:",re.length),re}async scanExtensionsUnderDevelopment(x,J){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const V=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(q=>q.scheme===P.Schemas.file).map(async q=>{const ie=await this.createExtensionScannerInput(q,!1,1,!0,x.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(ie)).map(ee=>(ee.type=J.find(ae=>(0,c.areSameExtensions)(ae.identifier,ee.identifier))?.type??ee.type,this.extensionsScanner.validate(ee,ie)))}))).flat();return this.applyScanOptions(V,"development",x,!0)}return[]}async scanExistingExtension(x,J,V){const q=await this.createExtensionScannerInput(x,!1,J,!0,V.language,!0,void 0),ie=await this.extensionsScanner.scanExtension(q);return!ie||!V.includeInvalid&&!ie.isValid?null:ie}async scanOneOrMultipleExtensions(x,J,V){const q=await this.createExtensionScannerInput(x,!1,J,!0,V.language,!0,void 0),ie=await this.extensionsScanner.scanOneOrMultipleExtensions(q);return this.applyScanOptions(ie,J,V,!0)}async scanMetadata(x){const J=(0,l.joinPath)(x,"package.json"),V=(await this.fileService.readFile(J)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(x,J){const V=(0,l.joinPath)(x,"package.json"),q=(await this.fileService.readFile(V)).value.toString(),ie=JSON.parse(q);J.isMachineScoped===!1&&delete J.isMachineScoped,J.isBuiltin===!1&&delete J.isBuiltin,ie.__metadata={...ie.__metadata,...J},await this.fileService.writeFile((0,l.joinPath)(x,"package.json"),A.VSBuffer.fromString(JSON.stringify(ie,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(x){if(x instanceof C.ExtensionsProfileScanningError&&x.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw x}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const x=await this.scanUserExtensions({includeInvalid:!0});if(x.length)await this.extensionsProfileScannerService.addExtensionsToProfile(x.map(J=>[J,J.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(J){(0,o.toFileOperationResult)(J)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,L.getErrorMessage)(J))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(x){this.logService.error(x)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(x,J,V,q){return V.includeAllVersions||(x=this.dedupExtensions(J===0?x:void 0,J===1?x:void 0,J==="development"?x:void 0,await this.getTargetPlatform(),q)),V.includeInvalid||(x=x.filter(ie=>ie.isValid)),x.sort((ie,re)=>{const ee=b.basename(ie.location.fsPath),ae=b.basename(re.location.fsPath);return ee<ae?-1:ee>ae?1:0})}dedupExtensions(x,J,V,q,ie){const re=(ae,G,W)=>{if(ae.isValid&&!G.isValid)return!1;if(ae.isValid===G.isValid){if(ie&&g.gt(ae.manifest.version,G.manifest.version))return this.logService.debug(`Skipping extension ${G.location.path} with lower version ${G.manifest.version} in favour of ${ae.location.path} with version ${ae.manifest.version}`),!1;if(g.eq(ae.manifest.version,G.manifest.version)){if(ae.type===0)return this.logService.debug(`Skipping extension ${G.location.path} in favour of system extension ${ae.location.path} with same version`),!1;if(ae.targetPlatform===q)return this.logService.debug(`Skipping extension ${G.location.path} from different target platform ${G.targetPlatform}`),!1}}return W?this.logService.warn(`Overwriting user extension ${ae.location.path} with ${G.location.path}.`):this.logService.debug(`Overwriting user extension ${ae.location.path} with ${G.location.path}.`),!0},ee=new w.ExtensionIdentifierMap;return x?.forEach(ae=>{const G=ee.get(ae.identifier.id);(!G||re(G,ae,!1))&&ee.set(ae.identifier.id,ae)}),J?.forEach(ae=>{const G=ee.get(ae.identifier.id);if(!G&&x&&ae.type===0){this.logService.debug(`Skipping obsolete system extension ${ae.location.path}.`);return}(!G||re(G,ae,!1))&&ee.set(ae.identifier.id,ae)}),V?.forEach(ae=>{const G=ee.get(ae.identifier.id);(!G||re(G,ae,!0))&&ee.set(ae.identifier.id,ae),ee.set(ae.identifier.id,ae)}),[...ee.values()]}async scanDefaultSystemExtensions(x,J){this.logService.trace("Started scanning system extensions");const V=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,J,!0,void 0),ie=await(x&&!V.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(V);return this.logService.trace("Scanned system extensions:",ie.length),ie}async scanDevSystemExtensions(x,J){const V=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!V?.length)return[];this.logService.trace("Started scanning dev system extensions");const q=J?await this.getBuiltInExtensionControl():{},ie=[],re=u.URI.file(b.normalize(b.join(P.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ae of V){const G=q[ae.name]||"marketplace";switch(G){case"disabled":break;case"marketplace":ie.push((0,l.joinPath)(re,ae.name));break;default:ie.push(u.URI.file(G));break}}const ee=await Promise.all(ie.map(async ae=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(ae,!1,0,!0,x,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",ee.length),(0,k.coalesce)(ee)}async getBuiltInExtensionControl(){try{const x=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(x.value.toString())}catch{return{}}}async createExtensionScannerInput(x,J,V,q,ie,re,ee){const ae=await this.getTranslations(ie??S.language),G=await this.getMtime(x),W=J&&!this.uriIdentityService.extUri.isEqual(x,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,_=W?await this.getMtime(W):void 0;return new F(x,G,W,_,J,ee,V,q,re,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,ie,ae)}async getMtime(x){try{const J=await this.fileService.stat(x);if(typeof J.mtime=="number")return J.mtime}catch{}}};e.AbstractExtensionsScannerService=U,e.AbstractExtensionsScannerService=U=ye([Y(4,E.IUserDataProfilesService),Y(5,C.IExtensionsProfileScannerService),Y(6,o.IFileService),Y(7,s.ILogService),Y(8,f.IEnvironmentService),Y(9,t.IProductService),Y(10,h.IUriIdentityService),Y(11,n.IInstantiationService)],U);class F{constructor(x,J,V,q,ie,re,ee,ae,G,W,_,N,z,$,Z){this.location=x,this.mtime=J,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=q,this.profile=ie,this.profileScanOptions=re,this.type=ee,this.excludeObsolete=ae,this.validate=G,this.productVersion=W,this.productDate=_,this.productCommit=N,this.devMode=z,this.language=$,this.translations=Z}static createNlsConfiguration(x){return{language:x.language,pseudo:x.language==="pseudo",devMode:x.devMode,translations:x.translations}}static equals(x,J){return(0,l.isEqual)(x.location,J.location)&&x.mtime===J.mtime&&(0,l.isEqual)(x.applicationExtensionslocation,J.applicationExtensionslocation)&&x.applicationExtensionslocationMtime===J.applicationExtensionslocationMtime&&x.profile===J.profile&&T.equals(x.profileScanOptions,J.profileScanOptions)&&x.type===J.type&&x.excludeObsolete===J.excludeObsolete&&x.validate===J.validate&&x.productVersion===J.productVersion&&x.productDate===J.productDate&&x.productCommit===J.productCommit&&x.devMode===J.devMode&&x.language===J.language&&R.equals(x.translations,J.translations)}}e.ExtensionScannerInput=F;let M=class extends m.Disposable{constructor(x,J,V,q,ie){super(),this.obsoleteFile=x,this.extensionsProfileScannerService=J,this.uriIdentityService=V,this.fileService=q,this.logService=ie}async scanExtensions(x){const J=x.profile?await this.scanExtensionsFromProfile(x):await this.scanExtensionsFromLocation(x);let V={};if(x.excludeObsolete&&x.type===1)try{const q=(await this.fileService.readFile(this.obsoleteFile)).value.toString();V=JSON.parse(q)}catch{}return(0,v.isEmptyObject)(V)?J:J.filter(q=>!V[c.ExtensionKey.create(q).toString()])}async scanExtensionsFromLocation(x){const J=await this.fileService.resolve(x.location);if(!J.children?.length)return[];const V=await Promise.all(J.children.map(async q=>{if(!q.isDirectory||x.type===1&&(0,l.basename)(q.resource).indexOf(".")===0)return null;const ie=new F(q.resource,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(ie)}));return(0,k.coalesce)(V).sort((q,ie)=>q.location.path<ie.location.path?-1:1)}async scanExtensionsFromProfile(x){let J=await this.scanExtensionsFromProfileResource(x.location,()=>!0,x);if(x.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(x.location,x.applicationExtensionslocation)){J=J.filter(q=>!q.metadata?.isApplicationScoped);const V=await this.scanExtensionsFromProfileResource(x.applicationExtensionslocation,q=>!!q.metadata?.isBuiltin||!!q.metadata?.isApplicationScoped,x);J.push(...V)}return J}async scanExtensionsFromProfileResource(x,J,V){const q=await this.extensionsProfileScannerService.scanProfileExtensions(x,V.profileScanOptions);if(!q.length)return[];const ie=await Promise.all(q.map(async re=>{if(J(re)){const ee=new F(re.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(ee,re.metadata)}return null}));return(0,k.coalesce)(ie)}async scanOneOrMultipleExtensions(x){try{if(await this.fileService.exists((0,l.joinPath)(x.location,"package.json"))){const J=await this.scanExtension(x);return J?[J]:[]}else return await this.scanExtensions(x)}catch(J){return this.logService.error(`Error scanning extensions at ${x.location.path}:`,(0,L.getErrorMessage)(J)),[]}}async scanExtension(x,J){try{let V=await this.scanExtensionManifest(x.location);if(V){V.publisher||(V.publisher=w.UNDEFINED_PUBLISHER),J=J??V.__metadata,delete V.__metadata;const q=(0,c.getGalleryExtensionId)(V.publisher,V.name),ie=J?.id?{id:q,uuid:J.id}:{id:q},re=J?.isSystem?0:x.type,ee=re===0||!!J?.isBuiltin;V=await this.translateManifest(x.location,V,F.createNlsConfiguration(x));const ae={type:re,identifier:ie,manifest:V,location:x.location,isBuiltin:ee,targetPlatform:J?.targetPlatform??"undefined",metadata:J,isValid:!0,validations:[]};return x.validate?this.validate(ae,x):ae}}catch(V){x.type!==0&&this.logService.error(V)}return null}validate(x,J){let V=!0;const q=(0,i.validateExtensionManifest)(J.productVersion,J.productDate,J.location,x.manifest,x.isBuiltin);for(const[ie,re]of q)ie===p.default.Error&&(V=!1,this.logService.error(this.formatMessage(J.location,re)));return x.isValid=V,x.validations=q,x}async scanExtensionManifest(x){const J=(0,l.joinPath)(x,"package.json");let V;try{V=(await this.fileService.readFile(J)).value.toString()}catch(ie){return(0,o.toFileOperationResult)(ie)!==1&&this.logService.error(this.formatMessage(x,(0,d.localize)(0,null,J.path,ie.message))),null}let q;try{q=JSON.parse(V)}catch{const re=[];(0,D.parse)(V,re);for(const ee of re)this.logService.error(this.formatMessage(x,(0,d.localize)(1,null,J.path,ee.offset,ee.length,(0,I.getParseErrorMessage)(ee.error))));return null}return(0,D.getNodeType)(q)!=="object"?(this.logService.error(this.formatMessage(x,(0,d.localize)(2,null,J.path))),null):q}async translateManifest(x,J,V){const q=await this.getLocalizedMessages(x,J,V);if(q)try{const ie=[],re=await this.resolveOriginalMessageBundle(q.default,ie);if(ie.length>0)return ie.forEach(ae=>{this.logService.error(this.formatMessage(x,(0,d.localize)(3,null,q.default?.path,(0,I.getParseErrorMessage)(ae.error))))}),J;if((0,D.getNodeType)(q)!=="object")return this.logService.error(this.formatMessage(x,(0,d.localize)(4,null,q.default?.path))),J;const ee=q.values||Object.create(null);return(0,y.localizeManifest)(this.logService,J,ee,re)}catch{}return J}async getLocalizedMessages(x,J,V){const q=(0,l.joinPath)(x,"package.nls.json"),ie=(G,W)=>{W.forEach(_=>{this.logService.error(this.formatMessage(x,(0,d.localize)(5,null,G?.path,(0,I.getParseErrorMessage)(_.error))))})},re=G=>{this.logService.error(this.formatMessage(x,(0,d.localize)(6,null,G?.path)))},ee=`${J.publisher}.${J.name}`,ae=V.translations[ee];if(ae)try{const G=u.URI.file(ae),W=(await this.fileService.readFile(G)).value.toString(),_=[],N=(0,D.parse)(W,_);return _.length>0?(ie(G,_),{values:void 0,default:q}):(0,D.getNodeType)(N)!=="object"?(re(G),{values:void 0,default:q}):{values:N.contents?N.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.fileService.exists(q))return;let W;try{W=await this.findMessageBundles(x,V)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const _=(await this.fileService.readFile(W.localized)).value.toString(),N=[],z=(0,D.parse)(_,N);return N.length>0?(ie(W.localized,N),{values:void 0,default:W.original}):(0,D.getNodeType)(z)!=="object"?(re(W.localized),{values:void 0,default:W.original}):{values:z,default:W.original}}catch{return{values:void 0,default:W.original}}}}async resolveOriginalMessageBundle(x,J){if(x)try{const V=(await this.fileService.readFile(x)).value.toString();return(0,D.parse)(V,J)}catch{}}findMessageBundles(x,J){return new Promise((V,q)=>{const ie=re=>{const ee=(0,l.joinPath)(x,`package.nls.${re}.json`);this.fileService.exists(ee).then(ae=>{ae&&V({localized:ee,original:(0,l.joinPath)(x,"package.nls.json")});const G=re.lastIndexOf("-");G===-1?V({localized:(0,l.joinPath)(x,"package.nls.json"),original:null}):(re=re.substring(0,G),ie(re))})};if(J.devMode||J.pseudo||!J.language)return V({localized:(0,l.joinPath)(x,"package.nls.json"),original:null});ie(J.language)})}formatMessage(x,J){return`[${x.path}]: ${J}`}};M=ye([Y(1,C.IExtensionsProfileScannerService),Y(2,h.IUriIdentityService),Y(3,o.IFileService),Y(4,s.ILogService)],M);let j=class extends M{constructor(x,J,V,q,ie,re,ee){super(J,q,ie,re,ee),this.currentProfile=x,this.userDataProfilesService=V,this.cacheValidatorThrottler=this._register(new O.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new r.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(x){const J=this.getCacheFile(x),V=await this.readExtensionCache(J);if(this.input=x,V&&V.input&&F.equals(V.input,this.input))return this.logService.debug("Using cached extensions scan result",x.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),V.result.map(ie=>(ie.location=u.URI.revive(ie.location),ie));const q=await super.scanExtensions(x);return await this.writeExtensionCache(J,{input:x,result:q}),q}async readExtensionCache(x){try{const J=await this.fileService.readFile(x),V=JSON.parse(J.value.toString());return{result:V.result,input:(0,a.revive)(V.input)}}catch(J){this.logService.debug("Error while reading the extension cache file:",x.path,(0,L.getErrorMessage)(J))}return null}async writeExtensionCache(x,J){try{await this.fileService.writeFile(x,A.VSBuffer.fromString(JSON.stringify(J)))}catch(V){this.logService.debug("Error while writing the extension cache file:",x.path,(0,L.getErrorMessage)(V))}}async validateCache(){if(!this.input)return;const x=this.getCacheFile(this.input),J=await this.readExtensionCache(x);if(!J)return;const V=J.result,q=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!T.equals(q,V))try{this.logService.info("Invalidating Cache",V,q),await this.fileService.del(x),this._onDidChangeCache.fire()}catch(ie){this.logService.error(ie)}}getCacheFile(x){const J=this.getProfile(x);return this.uriIdentityService.extUri.joinPath(J.cacheHome,x.type===0?w.BUILTIN_MANIFEST_CACHE_FILE:w.USER_MANIFEST_CACHE_FILE)}getProfile(x){return x.type===0?this.userDataProfilesService.defaultProfile:x.profile?this.uriIdentityService.extUri.isEqual(x.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(J=>this.uriIdentityService.extUri.isEqual(x.location,J.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};j=ye([Y(2,E.IUserDataProfilesService),Y(3,C.IExtensionsProfileScannerService),Y(4,h.IUriIdentityService),Y(5,o.IFileService),Y(6,s.ILogService)],j);function Q(X,x){const J=(0,c.getExtensionId)(X.manifest.publisher,X.manifest.name);return{id:J,identifier:new w.ExtensionIdentifier(J),isBuiltin:X.type===0,isUserBuiltin:X.type===1&&X.isBuiltin,isUnderDevelopment:x,extensionLocation:X.location,uuid:X.identifier.uuid,targetPlatform:X.targetPlatform,...X.manifest}}e.toExtensionDescription=Q;class K extends U{constructor(x,J,V,q,ie,re,ee,ae,G,W,_,N){super(x,J,(0,l.joinPath)(V,".vscode-oss-dev","extensions","control.json"),q,ie,re,ee,ae,G,W,_,N),this.translationsPromise=(async()=>{if(S.translationsConfigFile)try{const z=await this.fileService.readFile(u.URI.file(S.translationsConfigFile));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}getTranslations(x){return this.translationsPromise}}e.NativeExtensionsScannerService=K}),define(le[245],ue([0,1,67,6,38,3,2,23,16,31,8,18]),function(se,e,k,O,T,A,L,D,I,m,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let S=class extends L.Disposable{constructor(g,p){super(),this.userDataProfilesService=g,this.logService=p,this.processesLimiter=new O.Limiter(5)}async postUninstall(g){const p=this.parseScript(g,"uninstall");p&&(this.logService.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(p.script,"uninstall",p.args,!0,g),this.logService.info("Finished running post uninstall script",g.identifier.id,g.manifest.version)}catch(v){this.logService.error("Failed to run post uninstall script",g.identifier.id,g.manifest.version),this.logService.error(v)}}));try{await m.Promises.rm(this.getExtensionStoragePath(g))}catch(v){this.logService.error("Error while removing extension storage path",g.identifier.id),this.logService.error(v)}}parseScript(g,p){const v=`vscode:${p}`;if(g.location.scheme===D.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[v]=="string"){const u=g.manifest.scripts[v].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.logService.warn(g.identifier.id,g.manifest.version,`${v} should be a node script`),null):{script:(0,I.join)(g.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}runLifecycleHook(g,p,v,u,d){return new Promise((f,c)=>{const w=this.start(g,p,v,d);let i;const o=n=>{i&&(clearTimeout(i),i=null),n?c(n):f(void 0)};w.on("error",n=>{o((0,T.toErrorMessage)(n)||"Unknown")}),w.on("exit",(n,s)=>{o(n?`post-${p} process exited with code ${n}`:void 0)}),u&&(i=setTimeout(()=>{i=null,w.kill(),c("timed out")},5e3))})}start(g,p,v,u){const d={silent:!0,execArgv:void 0},f=(0,k.fork)(g,[`--type=extension-post-${p}`,...v],d);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const c=A.Event.fromNodeEventEmitter(f.stdout,"data"),w=A.Event.fromNodeEventEmitter(f.stderr,"data");c(n=>this.logService.info(u.identifier.id,u.manifest.version,`post-${p}`,n)),w(n=>this.logService.error(u.identifier.id,u.manifest.version,`post-${p}`,n));const i=A.Event.any(A.Event.map(c,n=>({data:`%c${n}`,format:[""]})),A.Event.map(w,n=>({data:`%c${n}`,format:["color: red"]})));return A.Event.debounce(i,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(u.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),f}getExtensionStoragePath(g){return(0,I.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=S,e.ExtensionsLifecycle=S=ye([Y(0,b.IUserDataProfilesService),Y(1,P.ILogService)],S)}),define(le[113],ue([0,1,6,14,26,38,7,3,53,2,35,23,16,20,55,12,10,32,31,70,156,96,15,244,29,33,51,82,225,245,184,214,226,71,11,4,8,24,22,28,18]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g,p,v,u,d,f,c,w,i,o,n,s,t,r,a,C,E,h,y,R,U,F,M,j,Q,K,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,F.refineServiceDecorator)(n.IExtensionManagementService);const x=".vsctmp";let J=class extends o.AbstractExtensionManagementService{constructor(G,W,_,N,z,$,Z,B,H,te,ne,ce){super(G,W,ne,_,te,ce),this.extensionsScannerService=z,this.extensionsProfileScannerService=$,this.downloadService=Z,this.fileService=H,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new P.ResourceSet;const fe=this._register(B.createInstance(C.ExtensionsLifecycle));this.extensionsScanner=this._register(B.createInstance(V,Se=>fe.postUninstall(Se))),this.manifestCache=this._register(new h.ExtensionsManifestCache(ce,H,ne,this,this.logService)),this.extensionsDownloader=this._register(B.createInstance(a.ExtensionsDownloader));const ge=this._register(new y.ExtensionsWatcher(this,this.extensionsScannerService,ce,$,ne,H,_));this._register(ge.onDidChangeExtensionsByAnotherSource(Se=>this.onDidChangeExtensionsFromAnotherSource(Se))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(G){this.logService.trace("ExtensionManagementService#zip",G.identifier.id);const W=await this.collectFiles(G),_=await(0,f.zip)((0,l.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,u.generateUuid)()).fsPath,W);return v.URI.file(_)}async unzip(G){return this.logService.trace("ExtensionManagementService#unzip",G.toString()),(await this.install(G)).identifier}async getManifest(G){const{location:W,cleanup:_}=await this.downloadVsix(G),N=S.resolve(W.fsPath);try{return await(0,E.getManifest)(N)}finally{await _()}}getInstalled(G,W=this.userDataProfilesService.defaultProfile.extensionsResource){return this.extensionsScanner.scanExtensions(G??null,W)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(G){return this.extensionsScanner.scanUserExtensionAtLocation(G)}async install(G,W={}){this.logService.trace("ExtensionManagementService#install",G.toString());const{location:_,cleanup:N}=await this.downloadVsix(G);try{const z=await(0,E.getManifest)(S.resolve(_.fsPath)),$=(0,s.getGalleryExtensionId)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,R.isEngineValid)(z.engines.vscode,this.productService.version,this.productService.date))throw new Error(c.localize(0,null,$,this.productService.version));const B=(await this.installExtensions([{manifest:z,extension:_,options:W}])).find(({identifier:H})=>(0,s.areSameExtensions)(H,{id:$}));if(B?.local)return B.local;throw B?.error?B.error:(0,o.toExtensionManagementError)(new Error(`Unknown error while installing extension ${$}`))}finally{await N()}}async installFromLocation(G,W){this.logService.trace("ExtensionManagementService#installFromLocation",G.toString());const _=await this.extensionsScanner.scanUserExtensionAtLocation(G);if(!_)throw new Error(`Cannot find a valid extension from the location ${G.toString()}`);return await this.addExtensionsToProfile([[_,void 0]],W),this.logService.info("Successfully installed extension",_.identifier.id,W.toString()),_}async installExtensionsFromProfile(G,W,_){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",G,W.toString(),_.toString());const N=(await this.extensionsScanner.scanExtensions(1,W)).filter(z=>G.some($=>(0,s.areSameExtensions)($,z.identifier)));if(N.length){const z=await Promise.all(N.map($=>this.extensionsScanner.scanMetadata($,W)));await this.addExtensionsToProfile(N.map(($,Z)=>[$,z[Z]]),_),this.logService.info("Successfully installed extensions",N.map($=>$.identifier.id),_.toString())}return N}async updateMetadata(G,W,_=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",G.identifier.id),W.isPreReleaseVersion&&(W.preRelease=!0,W.hasPreReleaseVersion=!0),W.isMachineScoped===!1&&(W.isMachineScoped=void 0),W.isBuiltin===!1&&(W.isBuiltin=void 0),W.pinned===!1&&(W.pinned=void 0),G=await this.extensionsScanner.updateMetadata(G,W,_),this.manifestCache.invalidate(_),this._onDidUpdateExtensionMetadata.fire(G),G}async reinstallFromGallery(G){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",G.identifier.id),!this.galleryService.isEnabled())throw new Error(c.localize(1,null));const W=await this.getTargetPlatform(),[_]=await this.galleryService.getExtensions([{...G.identifier,preRelease:G.preRelease}],{targetPlatform:W,compatible:!0},T.CancellationToken.None);if(!_)throw new Error(c.localize(2,null));await this.extensionsScanner.setUninstalled(G);try{await this.extensionsScanner.removeUninstalledExtension(G)}catch(N){throw new Error(c.localize(3,null,(0,A.toErrorMessage)(N)))}return this.installFromGallery(_)}copyExtension(G,W,_,N){return this.extensionsScanner.copyExtension(G,W,_,N)}copyExtensions(G,W){return this.extensionsScanner.copyExtensions(G,W)}markAsUninstalled(...G){return this.extensionsScanner.setUninstalled(...G)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(G){this.logService.error(G)}}async download(G,W,_){const{location:N}=await this.extensionsDownloader.download(G,W,!_);return N}async downloadVsix(G){if(G.scheme===b.Schemas.file)return{location:G,async cleanup(){}};this.logService.trace("Downloading extension from",G.toString());const W=(0,l.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,u.generateUuid)());return await this.downloadService.download(G,W),this.logService.info("Downloaded extension to",W.toString()),{location:W,cleanup:async()=>{try{await this.fileService.del(W)}catch(N){this.logService.error(N)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(G,W,_){if(v.URI.isUri(W))return new re(G,W,_,this.galleryService,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService);const N=s.ExtensionKey.create(W).toString();let z=this.installGalleryExtensionsTasks.get(N);return z||(this.installGalleryExtensionsTasks.set(N,z=new ie(G,W,_,this.extensionsDownloader,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService)),z.waitUntilTaskIsFinished().finally(()=>this.installGalleryExtensionsTasks.delete(N))),z}createUninstallExtensionTask(G,W){return new ee(G,W.profileLocation,this.extensionsProfileScannerService)}async collectFiles(G){const W=async N=>{let z=await d.Promises.readdir(N);z=z.map(B=>S.join(N,B));const $=await Promise.all(z.map(B=>d.Promises.stat(B)));let Z=Promise.resolve([]);return $.forEach((B,H)=>{const te=z[H];B.isFile()&&(Z=Z.then(ne=>[...ne,te])),B.isDirectory()&&(Z=Z.then(ne=>W(te).then(ce=>[...ne,...ce])))}),Z};return(await W(G.location.fsPath)).map(N=>({path:`extension/${S.relative(G.location.fsPath,N)}`,localPath:N}))}async onDidChangeExtensionsFromAnotherSource({added:G,removed:W}){if(W){const _=G&&this.uriIdentityService.extUri.isEqual(W.profileLocation,G.profileLocation)?W.extensions.filter(N=>G.extensions.every(z=>!(0,s.areSameExtensions)(z,N))):W.extensions;for(const N of _)this.logService.info("Extensions removed from another source",N.id,W.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:N,profileLocation:W.profileLocation})}if(G){const N=(await this.extensionsScanner.scanExtensions(1,G.profileLocation)).filter(z=>G.extensions.some($=>(0,s.areSameExtensions)($,z.identifier)));this._onDidInstallExtensions.fire(N.map(z=>(this.logService.info("Extensions added from another source",z.identifier.id,G.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:G.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(W=>this.knownDirectories.add(W)));const G=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const W of G.children??[])W.isDirectory&&this.knownDirectories.add(W.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(W=>this.onDidFilesChange(W)))}async onDidFilesChange(G){if(!G.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const W=[];for(const _ of G.rawAdded){if(this.knownDirectories.has(_)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(_),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(_,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(_).startsWith(".")||!(await this.fileService.stat(_)).isDirectory)continue;const N=await this.extensionsScanner.scanUserExtensionAtLocation(_);N&&N.installedTimestamp===void 0&&(this.knownDirectories.add(_),W.push(N))}W.length&&(await this.addExtensionsToProfile(W.map(_=>[_,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",W.map(_=>_.identifier.id)))}async addExtensionsToProfile(G,W){const _=G.map(N=>N[0]);await this.setInstalled(_),await this.extensionsProfileScannerService.addExtensionsToProfile(G,W),this._onDidInstallExtensions.fire(_.map(N=>({local:N,identifier:N.identifier,operation:1,profileLocation:W})))}async setInstalled(G){const W=await this.extensionsScanner.getUninstalledExtensions();for(const _ of G){const N=s.ExtensionKey.create(_);W[N.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",N.id),await this.extensionsScanner.setInstalled(N),this.logService.info("Removed the extension from uninstalled list:",N.id))}}};e.ExtensionManagementService=J,e.ExtensionManagementService=J=ye([Y(0,n.IExtensionGalleryService),Y(1,Q.ITelemetryService),Y(2,M.ILogService),Y(3,i.INativeEnvironmentService),Y(4,r.IExtensionsScannerService),Y(5,t.IExtensionsProfileScannerService),Y(6,w.IDownloadService),Y(7,F.IInstantiationService),Y(8,U.IFileService),Y(9,j.IProductService),Y(10,K.IUriIdentityService),Y(11,X.IUserDataProfilesService)],J);let V=class extends m.Disposable{constructor(G,W,_,N,z,$){super(),this.beforeRemovingExtension=G,this.fileService=W,this.extensionsScannerService=_,this.extensionsProfileScannerService=N,this.uriIdentityService=z,this.logService=$,this._onExtract=this._register(new D.Emitter),this.onExtract=this._onExtract.event,this.uninstalledResource=(0,l.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new k.Queue}async cleanUp(){await this.removeTemporarilyDeletedFolders(),await this.removeUninstalledExtensions()}async scanExtensions(G,W){const _={includeInvalid:!0,profileLocation:W};let N=[];return G===null||G===0?N.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},_,!1)):G===1&&N.push(...await this.extensionsScannerService.scanUserExtensions(_)),N=G!==null?N.filter(z=>z.type===G):N,Promise.all(N.map(z=>this.toLocalExtension(z)))}async scanAllUserExtensions(G){const W=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!G,includeInvalid:!0});return Promise.all(W.map(_=>this.toLocalExtension(_)))}async scanUserExtensionAtLocation(G){try{const W=await this.extensionsScannerService.scanExistingExtension(G,1,{includeInvalid:!0});if(W)return await this.toLocalExtension(W)}catch(W){this.logService.error(W)}return null}async extractUserExtension(G,W,_,N,z){const $=G.toString(),Z=v.URI.file(S.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,u.generateUuid)()}`)),B=v.URI.file(S.join(this.extensionsScannerService.userExtensionsLocation.fsPath,$));let H=await this.fileService.exists(B);if(H&&N){try{await this.deleteExtensionFromLocation(G.id,B,"removeExisting")}catch{throw new n.ExtensionManagementError(c.localize(4,null,B.fsPath,G.id),n.ExtensionManagementErrorCode.Delete)}H=!1}if(H)await this.extensionsScannerService.updateMetadata(B,_);else try{try{this.logService.trace(`Started extracting the extension from ${W} to ${B.fsPath}`),await(0,f.extract)(W,Z.fsPath,{sourcePath:"extension",overwrite:!0},z),this.logService.info(`Extracted extension to ${B}:`,G.id)}catch(te){let ne=n.ExtensionManagementErrorCode.Extract;throw te instanceof f.ExtractError&&(te.type==="CorruptZip"?ne=n.ExtensionManagementErrorCode.CorruptZip:te.type==="Incomplete"&&(ne=n.ExtensionManagementErrorCode.IncompleteZip)),new n.ExtensionManagementError(te.message,ne)}await this.extensionsScannerService.updateMetadata(Z,_);try{this.logService.trace(`Started renaming the extension from ${Z.fsPath} to ${B.fsPath}`),await this.rename(Z.fsPath,B.fsPath),this.logService.info("Renamed to",B.fsPath)}catch(te){if(te.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",G.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(te)}. Deleted from extracted location`,Z),te}this._onExtract.fire(B)}catch(te){try{await this.fileService.del(Z,{recursive:!0})}catch{}throw te}return this.scanLocalExtension(B,1)}async scanMetadata(G,W){return W?(await this.getScannedExtension(G,W))?.metadata:this.extensionsScannerService.scanMetadata(G.location)}async getScannedExtension(G,W){return(await this.extensionsProfileScannerService.scanProfileExtensions(W)).find(N=>(0,s.areSameExtensions)(N.identifier,G.identifier))}async updateMetadata(G,W,_){return _?await this.extensionsProfileScannerService.updateMetadata([[G,W]],_):await this.extensionsScannerService.updateMetadata(G.location,W),this.scanLocalExtension(G.location,G.type,_)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...G){const W=G.map(_=>s.ExtensionKey.create(_));await this.withUninstalledExtensions(_=>W.forEach(N=>{_[N.toString()]=!0,this.logService.info("Marked extension as uninstalled",N.toString())}))}async setInstalled(G){await this.withUninstalledExtensions(W=>delete W[G.toString()])}async removeExtension(G,W){if(this.uriIdentityService.extUri.isEqualOrParent(G.location,this.extensionsScannerService.userExtensionsLocation))return this.deleteExtensionFromLocation(G.identifier.id,G.location,W)}async removeUninstalledExtension(G){await this.removeExtension(G,"uninstalled"),await this.withUninstalledExtensions(W=>delete W[s.ExtensionKey.create(G).toString()])}async copyExtension(G,W,_,N){const z=await this.getScannedExtension(G,W),$=await this.getScannedExtension(G,_);return N={...z?.metadata,...N},$?await this.extensionsProfileScannerService.updateMetadata([[G,{...$.metadata,...N}]],_):await this.extensionsProfileScannerService.addExtensionsToProfile([[G,N]],_),this.scanLocalExtension(G.location,G.type,_)}async copyExtensions(G,W){const _=await this.scanExtensions(1,G),N=await Promise.all(_.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,G)]));await this.extensionsProfileScannerService.addExtensionsToProfile(N,W)}async deleteExtensionFromLocation(G,W,_){this.logService.trace(`Deleting ${_} extension from disk`,G,W.fsPath);const N=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(W),`${this.uriIdentityService.extUri.basename(W)}.${(0,I.hash)((0,u.generateUuid)()).toString(16)}${x}`);await this.rename(W.fsPath,N.fsPath),await this.fileService.del(N,{recursive:!0}),this.logService.info(`Deleted ${_} extension from disk`,G,W.fsPath)}async withUninstalledExtensions(G){return this.uninstalledFileLimiter.queue(async()=>{let W;try{W=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(N){if((0,U.toFileOperationResult)(N)!==1)throw N}let _={};if(W)try{_=JSON.parse(W)}catch{}return G&&(G(_),Object.keys(_).length?await this.fileService.writeFile(this.uninstalledResource,O.VSBuffer.fromString(JSON.stringify(_))):await this.fileService.del(this.uninstalledResource)),_})}async rename(G,W){try{await d.Promises.rename(G,W,2*60*1e3)}catch(_){throw new n.ExtensionManagementError(_.message||c.localize(5,null,G,W),_.code||n.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(G,W,_){if(_){const z=(await this.extensionsScannerService.scanUserExtensions({profileLocation:_})).find($=>this.uriIdentityService.extUri.isEqual($.location,G));if(z)return this.toLocalExtension(z)}else{const N=await this.extensionsScannerService.scanExistingExtension(G,W,{includeInvalid:!0});if(N)return this.toLocalExtension(N)}throw new Error(c.localize(6,null,G.path))}async toLocalExtension(G){const W=await this.fileService.resolve(G.location);let _,N;return W.children&&(_=W.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,N=W.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:G.identifier,type:G.type,isBuiltin:G.isBuiltin||!!G.metadata?.isBuiltin,location:G.location,manifest:G.manifest,targetPlatform:G.targetPlatform,validations:G.validations,isValid:G.isValid,readmeUrl:_,changelogUrl:N,publisherDisplayName:G.metadata?.publisherDisplayName||null,publisherId:G.metadata?.publisherId||null,isApplicationScoped:!!G.metadata?.isApplicationScoped,isMachineScoped:!!G.metadata?.isMachineScoped,isPreReleaseVersion:!!G.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!G.metadata?.hasPreReleaseVersion,preRelease:!!G.metadata?.preRelease,installedTimestamp:G.metadata?.installedTimestamp,updated:!!G.metadata?.updated,pinned:!!G.metadata?.pinned}}async removeUninstalledExtensions(){const G=await this.getUninstalledExtensions();if(Object.keys(G).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(G));const W=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),_=new Set;for(const z of W)G[s.ExtensionKey.create(z).toString()]||_.add(z.identifier.id.toLowerCase());try{const z=(0,s.groupByExtension)(W,$=>$.identifier);await k.Promises.settled(z.map(async $=>{const Z=$.sort((B,H)=>g.rcompare(B.manifest.version,H.manifest.version))[0];_.has(Z.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(Z))}))}catch(z){this.logService.error(z)}const N=W.filter(z=>z.metadata&&G[s.ExtensionKey.create(z).toString()]);await Promise.allSettled(N.map(z=>this.removeUninstalledExtension(z)))}async removeTemporarilyDeletedFolders(){this.logService.trace("ExtensionManagementService#removeTempDeleteFolders");let G;try{G=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(W){(0,U.toFileOperationResult)(W)!==1&&this.logService.error(W);return}if(G?.children)try{await Promise.allSettled(G.children.map(async W=>{if(!(!W.isDirectory||!W.name.endsWith(x))){this.logService.trace("Deleting the temporarily deleted folder",W.resource.toString());try{await this.fileService.del(W.resource,{recursive:!0}),this.logService.trace("Deleted the temporarily deleted folder",W.resource.toString())}catch(_){(0,U.toFileOperationResult)(_)!==1&&this.logService.error(_)}}}))}catch{}}};e.ExtensionsScanner=V,e.ExtensionsScanner=V=ye([Y(1,U.IFileService),Y(2,r.IExtensionsScannerService),Y(3,t.IExtensionsProfileScannerService),Y(4,K.IUriIdentityService),Y(5,M.ILogService)],V);class q extends o.AbstractExtensionTask{get profileLocation(){return this._profileLocation}get verificationStatus(){return this._verificationStatus}get operation(){return(0,p.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(G,W,_,N,z,$,Z,B,H){super(),this.identifier=G,this.source=W,this.options=_,this.extensionsScanner=N,this.uriIdentityService=z,this.userDataProfilesService=$,this.extensionsScannerService=Z,this.extensionsProfileScannerService=B,this.logService=H,this._profileLocation=this.options.profileLocation,this._verificationStatus=!1,this._operation=2}async doRun(G){const[W,_]=await this.install(G);return this._profileLocation=W.isBuiltin||W.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:this.options.profileLocation,this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this._profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[W,_]],this._profileLocation),W}async extractExtension({zipPath:G,key:W,metadata:_},N,z){let $=await this.unsetIfUninstalled(W);return $?$=await this.extensionsScanner.updateMetadata($,_):(this.logService.trace("Extracting extension...",W.id),$=await this.extensionsScanner.extractUserExtension(W,G,_,N,z),this.logService.info("Extracting extension completed.",W.id)),$}async unsetIfUninstalled(G){return await this.isUninstalled(G)?(this.logService.trace("Removing the extension from uninstalled list:",G.id),await this.extensionsScanner.setInstalled(G),this.logService.info("Removed the extension from uninstalled list:",G.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(N=>s.ExtensionKey.create(N).equals(G))):void 0}async isUninstalled(G){return!!(await this.extensionsScanner.getUninstalledExtensions())[G.toString()]}}class ie extends q{constructor(G,W,_,N,z,$,Z,B,H,te){super(W.identifier,W,_,z,$,Z,B,H,te),this.gallery=W,this.extensionsDownloader=N}async install(G){let W;try{W=await this.extensionsScanner.scanExtensions(null,this.options.profileLocation)}catch(Z){throw new n.ExtensionManagementError(Z,n.ExtensionManagementErrorCode.Scanning)}const _=W.find(Z=>(0,s.areSameExtensions)(Z.identifier,this.gallery.identifier));_&&(this._operation=3);const N={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||_?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||_?.isMachineScoped,isBuiltin:this.options.isBuiltin||_?.isBuiltin,isSystem:_?.type===0?!0:void 0,updated:!!_,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,hasPreReleaseVersion:_?.hasPreReleaseVersion||this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??_?.pinned,preRelease:(0,p.isBoolean)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.gallery.properties.isPreReleaseVersion||_?.preRelease};if(_?.manifest.version===this.gallery.version)try{return[await this.extensionsScanner.updateMetadata(_,N),N]}catch(Z){throw new n.ExtensionManagementError((0,L.getErrorMessage)(Z),n.ExtensionManagementErrorCode.UpdateMetadata)}const{location:z,verificationStatus:$}=await this.extensionsDownloader.download(this.gallery,this._operation,!this.options.donotVerifySignature);try{return this._verificationStatus=$,this.validateManifest(z.fsPath),[await this.extractExtension({zipPath:z.fsPath,key:s.ExtensionKey.create(this.gallery),metadata:N},!1,G),N]}catch(Z){try{await this.extensionsDownloader.delete(z)}catch(B){this.logService.warn("Error while deleting the downloaded file",z.toString(),(0,L.getErrorMessage)(B))}throw Z}}async validateManifest(G){try{await(0,E.getManifest)(G)}catch(W){throw new n.ExtensionManagementError((0,o.joinErrors)(W).message,n.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=ie;class re extends q{constructor(G,W,_,N,z,$,Z,B,H,te){super({id:(0,s.getGalleryExtensionId)(G.publisher,G.name)},W,_,z,$,Z,B,H,te),this.manifest=G,this.location=W,this.galleryService=N}async doRun(G){const W=await super.doRun(G);return this.updateMetadata(W,G),W}async install(G){const W=new s.ExtensionKey(this.identifier,this.manifest.version),N=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation)).find(Z=>(0,s.areSameExtensions)(this.identifier,Z.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||N?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||N?.isMachineScoped,isBuiltin:this.options.isBuiltin||N?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??N?.pinned};if(N)if(this._operation=3,W.equals(new s.ExtensionKey(N.identifier,N.manifest.version)))try{await this.extensionsScanner.removeExtension(N,"existing")}catch{throw new Error(c.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&g.gt(N.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(N);else{const Z=await this.unsetIfUninstalled(W);if(Z)try{await this.extensionsScanner.removeExtension(Z,"existing")}catch{throw new Error(c.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.extractExtension({zipPath:S.resolve(this.location.fsPath),key:W,metadata:z},!0,G),z]}async updateMetadata(G,W){try{let[_]=await this.galleryService.getExtensions([{id:G.identifier.id,version:G.manifest.version}],W);if(_||([_]=await this.galleryService.getExtensions([{id:G.identifier.id}],W)),_){const N={id:_.identifier.uuid,publisherDisplayName:_.publisherDisplayName,publisherId:_.publisherId,isPreReleaseVersion:_.properties.isPreReleaseVersion,hasPreReleaseVersion:G.hasPreReleaseVersion||_.properties.isPreReleaseVersion,preRelease:_.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(G,N,this.options.profileLocation)}}catch{}}}class ee extends o.AbstractExtensionTask{constructor(G,W,_){super(),this.extension=G,this.profileLocation=W,this.extensionsProfileScannerService=_}async doRun(G){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(le[246],ue([0,1,8,18,28,22,51,11,15,10]),function(se,e,k,O,T,A,L,D,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let P=class extends L.AbstractExtensionsProfileScannerService{constructor(S,l,g,p,v,u){super(m.URI.file(S.extensionsPath),l,g,p,v,u)}};e.ExtensionsProfileScannerService=P,e.ExtensionsProfileScannerService=P=ye([Y(0,I.INativeEnvironmentService),Y(1,D.IFileService),Y(2,O.IUserDataProfilesService),Y(3,T.IUriIdentityService),Y(4,A.ITelemetryService),Y(5,k.ILogService)],P)}),define(le[247],ue([0,1,10,15,51,82,11,4,8,24,28,18]),function(se,e,k,O,T,A,L,D,I,m,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let S=class extends A.NativeExtensionsScannerService{constructor(g,p,v,u,d,f,c,w){super(k.URI.file(d.builtinExtensionsPath),k.URI.file(d.extensionsPath),d.userHome,g.defaultProfile,g,p,v,u,d,f,c,w)}};e.ExtensionsScannerService=S,e.ExtensionsScannerService=S=ye([Y(0,b.IUserDataProfilesService),Y(1,T.IExtensionsProfileScannerService),Y(2,L.IFileService),Y(3,I.ILogService),Y(4,O.INativeEnvironmentService),Y(5,m.IProductService),Y(6,P.IUriIdentityService),Y(7,D.IInstantiationService)],S)}),define(le[19],ue([0,1,6,3,2,100,12,69,4,18]),function(se,e,k,O,T,A,L,D,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,I.createDecorator)("storageService");var P;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var b;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var S;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(S||(e.StorageTarget=S={}));function l(d){const f=d.get(e.TARGET_KEY);if(f)try{return JSON.parse(f)}catch{}return Object.create(null)}e.loadKeyTargets=l;class g extends T.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(f={flushInterval:g.DEFAULT_FLUSH_INTERVAL}){super(),this.options=f,this._onDidChangeValue=this._register(new O.PauseableEmitter),this._onDidChangeTarget=this._register(new O.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new O.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new k.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new T.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(f,c,w){return O.Event.filter(this._onDidChangeValue.event,i=>i.scope===f&&(c===void 0||i.key===c),w)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,k.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,T.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,A.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(f,c){const{key:w,external:i}=c;if(w===e.TARGET_KEY){switch(f){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:f})}else this._onDidChangeValue.fire({scope:f,key:w,target:this.getKeyTargets(f)[w],external:i})}emitWillSaveState(f){this._onWillSaveState.fire({reason:f})}get(f,c,w){return this.getStorage(c)?.get(f,w)}getBoolean(f,c,w){return this.getStorage(c)?.getBoolean(f,w)}getNumber(f,c,w){return this.getStorage(c)?.getNumber(f,w)}getObject(f,c,w){return this.getStorage(c)?.getObject(f,w)}storeAll(f,c){this.withPausedEmitters(()=>{for(const w of f)this.store(w.key,w.value,w.scope,w.target,c)})}store(f,c,w,i,o=!1){if((0,L.isUndefinedOrNull)(c)){this.remove(f,w,o);return}this.withPausedEmitters(()=>{this.updateKeyTarget(f,w,i),this.getStorage(w)?.set(f,c,o)})}remove(f,c,w=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(f,c,void 0),this.getStorage(c)?.delete(f,w)})}withPausedEmitters(f){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{f()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(f,c){const w=[],i=this.getKeyTargets(f);for(const o of Object.keys(i))i[o]===c&&w.push(o);return w}updateKeyTarget(f,c,w,i=!1){const o=this.getKeyTargets(c);typeof w=="number"?o[f]!==w&&(o[f]=w,this.getStorage(c)?.set(e.TARGET_KEY,JSON.stringify(o),i)):typeof o[f]=="number"&&(delete o[f],this.getStorage(c)?.set(e.TARGET_KEY,JSON.stringify(o),i))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(f){switch(f){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(f){const c=this.getStorage(f);return c?l(c):Object.create(null)}isNew(f){return this.getBoolean(e.IS_NEW_KEY,f)===!0}async flush(f=P.NONE){this._onWillSaveState.fire({reason:f});const c=this.getStorage(-1),w=this.getStorage(0),i=this.getStorage(1);switch(f){case P.NONE:await k.Promises.settled([c?.whenFlushed()??Promise.resolve(),w?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await k.Promises.settled([c?.flush(0)??Promise.resolve(),w?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const f=this.getStorage(-1)?.items??new Map,c=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return u(f,c,w,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(f){return await this.flush(),this.getStorage(f)?.optimize()}async switch(f,c){return this.emitWillSaveState(P.NONE),(0,m.isUserDataProfile)(f)?this.switchToProfile(f,c):this.switchToWorkspace(f,c)}canSwitchProfile(f,c){return!(f.id===c.id||p(c)&&p(f))}switchData(f,c,w){this.withPausedEmitters(()=>{const i=new Set;for(const[o,n]of f)i.add(o),c.get(o)!==n&&this.emitDidChangeValue(w,{key:o,external:!0});for(const[o]of c.items)i.has(o)||this.emitDidChangeValue(w,{key:o,external:!0})})}}e.AbstractStorageService=g;function p(d){return d.isDefault||!!d.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=p;class v extends g{constructor(){super(),this.applicationStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(f=>this.emitDidChangeValue(1,f))),this._register(this.profileStorage.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),this._register(this.applicationStorage.onDidChangeStorage(f=>this.emitDidChangeValue(-1,f)))}getStorage(f){switch(f){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(f){switch(f){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(f){return!1}}e.InMemoryStorageService=v;async function u(d,f,c,w,i,o){const n=R=>{try{return JSON.parse(R)}catch{return R}},s=new Map,t=new Map;d.forEach((R,U)=>{s.set(U,R),t.set(U,n(R))});const r=new Map,a=new Map;f.forEach((R,U)=>{r.set(U,R),a.set(U,n(R))});const C=new Map,E=new Map;c.forEach((R,U)=>{C.set(U,R),E.set(U,n(R))}),console.group(w!==i?`Storage: Application (path: ${w})`:`Storage: Application & Profile (path: ${w}, default profile)`);const h=[];if(s.forEach((R,U)=>{h.push({key:U,value:R})}),console.table(h),console.groupEnd(),console.log(t),w!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const R=[];r.forEach((U,F)=>{R.push({key:F,value:U})}),console.table(R),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const y=[];C.forEach((R,U)=>{y.push({key:U,value:R})}),console.table(y),console.groupEnd(),console.log(E)}e.logStorage=u}),define(le[114],ue([0,1,3,2,12,29,33,19]),function(se,e,k,O,T,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let I=class extends O.Disposable{constructor(b,S){super(),this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new m(b)),this._register(this.storageManger.onDidChange(l=>this._onDidChangeEnablement.fire({extensions:l,source:"storage"}))),this._register(S.onDidInstallExtensions(l=>l.forEach(({local:g,operation:p})=>{g&&p===4&&this._removeFromDisabledExtensions(g.identifier)})))}async enableExtension(b,S){return this._removeFromDisabledExtensions(b)?(this._onDidChangeEnablement.fire({extensions:[b],source:S}),!0):!1}async disableExtension(b,S){return this._addToDisabledExtensions(b)?(this._onDidChangeEnablement.fire({extensions:[b],source:S}),!0):!1}getDisabledExtensions(){return this._getExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(b){const S=this.getDisabledExtensions();return S.every(l=>!(0,L.areSameExtensions)(l,b))?(S.push(b),this._setDisabledExtensions(S),!0):!1}_removeFromDisabledExtensions(b){const S=this.getDisabledExtensions();for(let l=0;l<S.length;l++){const g=S[l];if((0,L.areSameExtensions)(g,b))return S.splice(l,1),this._setDisabledExtensions(S),!0}return!1}_setDisabledExtensions(b){this._setExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH,b)}_getExtensions(b){return this.storageManger.get(b,0)}_setExtensions(b,S){this.storageManger.set(b,S,0)}};e.GlobalExtensionEnablementService=I,e.GlobalExtensionEnablementService=I=ye([Y(0,D.IStorageService),Y(1,A.IExtensionManagementService)],I);class m extends O.Disposable{constructor(b){super(),this.storageService=b,this.storage=Object.create(null),this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this._register(b.onDidChangeValue(0,void 0,this._register(new O.DisposableStore))(S=>this.onDidStorageChange(S)))}get(b,S){let l;return S===0?((0,T.isUndefinedOrNull)(this.storage[b])&&(this.storage[b]=this._get(b,S)),l=this.storage[b]):l=this._get(b,S),JSON.parse(l)}set(b,S,l){const g=JSON.stringify(S.map(({id:v,uuid:u})=>({id:v,uuid:u})));this._get(b,l)!==g&&(l===0&&(S.length?this.storage[b]=g:delete this.storage[b]),this._set(b,S.length?g:void 0,l))}onDidStorageChange(b){if(!(0,T.isUndefinedOrNull)(this.storage[b.key])&&this._get(b.key,b.scope)!==this.storage[b.key]){const l=this.get(b.key,b.scope);delete this.storage[b.key];const g=this.get(b.key,b.scope),p=l.filter(u=>!g.some(d=>(0,L.areSameExtensions)(u,d))),v=g.filter(u=>!l.some(d=>(0,L.areSameExtensions)(d,u)));(p.length||v.length)&&this._onDidChange.fire([...p,...v])}}_get(b,S){return this.storageService.get(b,S,"[]")}_set(b,S,l){S?this.storageService.store(b,S,l,1):this.storageService.remove(b,l)}}e.StorageManager=m}),define(le[248],ue([0,1,17,26,7,5,37,12,10,21,15,29,33,71,11,8,24,59,227,19,22,63]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g,p,v,u,d,f,c,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const i=A.isWeb?"web":(0,b.getTargetPlatform)(A.platform,L.arch),o="X-Market-Search-Activity-Id";var n;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished",N[N.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...N){return String(N.reduce((z,$)=>z|$,0))}var t;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},E={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class h{constructor(z=E){this.state=z}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(z,$=this.state.pageSize){return new h({...this.state,pageNumber:z,pageSize:$})}withFilter(z,...$){const Z=[...this.state.criteria,...$.length?$.map(B=>({filterType:z,value:B})):[{filterType:z}]];return new h({...this.state,criteria:Z})}withSortBy(z){return new h({...this.state,sortBy:z})}withSortOrder(z){return new h({...this.state,sortOrder:z})}withFlags(...z){return new h({...this.state,flags:z.reduce(($,Z)=>$|Z,0)})}withAssetTypes(...z){return new h({...this.state,assetTypes:z})}withSource(z){return new h({...this.state,source:z})}get raw(){const{criteria:z,pageNumber:$,pageSize:Z,sortBy:B,sortOrder:H,flags:te,assetTypes:ne}=this.state;return{filters:[{criteria:z,pageNumber:$,pageSize:Z,sortBy:B,sortOrder:H}],assetTypes:ne,flags:te}}get searchText(){const z=this.state.criteria.filter($=>$.filterType===t.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(z=>String(z.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function y(N,z){const $=(N||[]).filter(Z=>Z.statisticName===z)[0];return $?$.value:0}function R(N){const z="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(Z=>Z.assetType.indexOf(z)===0).reduce((Z,B)=>{const H=M(N,B.assetType);return H&&Z.push([B.assetType.substring(z.length),H]),Z},[])}function U(N){if(N.properties){const z=N.properties.filter(B=>B.key===r.Repository),$=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Z=z.filter(B=>$.test(B.value))[0];return Z?{uri:Z.value,fallbackUri:Z.value}:null}return M(N,r.Repository)}function F(N){return{uri:`${N.fallbackAssetUri}/${r.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${r.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function M(N,z){return N.files.filter(Z=>Z.assetType===z)[0]?{uri:`${N.assetUri}/${z}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${z}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}:null}function j(N,z){const $=N.properties?N.properties.filter(B=>B.key===z):[],Z=$.length>0&&$[0].value;return Z?Z.split(",").map(B=>(0,S.adoptToGalleryExtensionId)(B)):[]}function Q(N){const z=N.properties?N.properties.filter($=>$.key===a.Engine):[];return z.length>0&&z[0].value||""}function K(N){const z=N.properties?N.properties.filter($=>$.key===a.PreRelease):[];return z.length>0&&z[0].value==="true"}function X(N){const z=N.properties?N.properties.filter(Z=>Z.key===a.LocalizedLanguages):[],$=z.length>0&&z[0].value||"";return $?$.split(","):[]}function x(N){return N.properties?.find(z=>z.key===a.SponsorLink)?.value}function J(N){return N.properties?.find(z=>z.key===a.SupportLink)?.value}function V(N){return N.indexOf("preview")!==-1}function q(N){return N.targetPlatform?(0,b.toTargetPlatform)(N.targetPlatform):"undefined"}function ie(N){const z=(0,k.distinct)(N.versions.map(q)),$=!!N.tags?.includes(b.WEB_EXTENSION_TAG),Z=z.indexOf("web");return $?Z===-1&&z.push("web"):Z!==-1&&z.splice(Z,1),z}function re(N,z){for(let $=0;$<N.length;$++){const Z=N[$];if(Z.version===N[$-1]?.version){let B=$;if(q(Z)===z)for(;B>0&&N[B-1].version===Z.version;)B--;B!==$&&(N.splice($,1),N.splice(B,0,Z))}}return N}e.sortExtensionVersions=re;function ee(N,z,$){N.telemetryData={index:z,querySource:$,queryActivityId:N.queryContext?.[o]}}function ae(N,z,$,Z){const B=N.versions[0],H={manifest:M(z,r.Manifest),readme:M(z,r.Details),changelog:M(z,r.Changelog),license:M(z,r.License),repository:U(z),download:F(z),icon:M(z,r.Icon),signature:M(z,r.Signature),coreTranslations:R(z)};return{identifier:{id:(0,S.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:z.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,publisherDomain:N.publisher.domain?{link:N.publisher.domain,verified:!!N.publisher.isDomainVerified}:void 0,publisherSponsorLink:x(B),description:N.shortDescription||"",installCount:y(N.statistics,"install"),rating:y(N.statistics,"averagerating"),ratingCount:y(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:$,assets:H,properties:{dependencies:j(z,a.Dependency),extensionPack:j(z,a.ExtensionPack),engine:Q(z),localizedLanguages:X(z),targetPlatform:q(z),isPreReleaseVersion:K(z)},hasPreReleaseVersion:K(B),hasReleaseVersion:!0,preview:V(N.flags),isSigned:!!H.signature,queryContext:Z,supportLink:J(B)}}let G=class{constructor(z,$,Z,B,H,te,ne,ce){this.requestService=$,this.logService=Z,this.environmentService=B,this.telemetryService=H,this.fileService=te,this.productService=ne,this.configurationService=ce;const fe=ne.extensionsGallery,ge=fe?.servicePPEUrl&&ce.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=ge?fe.servicePPEUrl:fe?.serviceUrl,this.extensionsGallerySearchUrl=ge?void 0:fe?.searchUrl,this.extensionsControlUrl=fe?.controlUrl,this.commonHeadersPromise=(0,d.resolveMarketplaceHeaders)(ne.version,ne,this.environmentService,this.configurationService,this.fileService,z,this.telemetryService)}api(z=""){return`${this.extensionsGalleryUrl}${z}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(z,$,Z){const B=O.CancellationToken.isCancellationToken($)?{}:$,H=O.CancellationToken.isCancellationToken($)?$:Z,te=[],ne=[],ce=[],fe=[];let ge=!0;for(const Re of z){Re.uuid?ne.push(Re.uuid):te.push(Re.id);const ke=!!(Re.version||Re.preRelease);ce.push({id:Re.id,uuid:Re.uuid,includePreRelease:ke}),Re.version&&fe.push({id:Re.id,uuid:Re.uuid,version:Re.version}),ge=ge&&!!Re.hasPreRelease&&!ke}if(!ne.length&&!te.length)return[];let Se=new h().withPage(1,z.length);ne.length&&(Se=Se.withFilter(t.ExtensionId,...ne)),te.length&&(Se=Se.withFilter(t.ExtensionName,...te)),(B.queryAllVersions||ge)&&(Se=Se.withFlags(Se.flags,n.IncludeVersions)),B.source&&(Se=Se.withSource(B.source));const{extensions:Ce}=await this.queryGalleryExtensions(Se,{targetPlatform:B.targetPlatform??i,includePreRelease:ce,versions:fe,compatible:!!B.compatible},H);return B.source&&Ce.forEach((Re,ke)=>ee(Re,ke,B.source)),Ce}async getCompatibleExtension(z,$,Z){if((0,b.isNotWebExtensionInWebTargetPlatform)(z.allTargetPlatforms,Z))return null;if(await this.isExtensionCompatible(z,$,Z))return z;const B=new h().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,z.identifier.uuid),{extensions:H}=await this.queryGalleryExtensions(B,{targetPlatform:Z,compatible:!0,includePreRelease:$},O.CancellationToken.None);return H[0]||null}async isExtensionCompatible(z,$,Z){if(!(0,b.isTargetPlatformCompatible)(z.properties.targetPlatform,z.allTargetPlatforms,Z)||!$&&z.properties.isPreReleaseVersion)return!1;let B=z.properties.engine;if(!B){const H=await this.getManifest(z,O.CancellationToken.None);if(!H)throw new Error("Manifest was not found");B=H.engines.vscode}return(0,l.isEngineValid)(B,this.productService.version,this.productService.date)}async isValidVersion(z,$,Z,B,H){if(!(0,b.isTargetPlatformCompatible)(q(z),B,H)||$!=="any"&&K(z)!==($==="prerelease"))return!1;if(Z)try{const te=await this.getEngine(z);if(!(0,l.isEngineValid)(te,this.productService.version,this.productService.date))return!1}catch(te){return this.logService.error(`Error while getting the engine for the version ${z.version}.`,(0,T.getErrorMessage)(te)),!1}return!0}async query(z,$){let Z=z.text||"";const B=z.pageSize??50;let H=new h().withPage(1,B);Z?(Z=Z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,Se,Ce)=>(H=H.withFilter(t.Category,Ce||Se),"")),Z=Z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,Se,Ce)=>(H=H.withFilter(t.Tag,Ce||Se),"")),Z=Z.replace(/\bfeatured(\s+|\b|$)/g,()=>(H=H.withFilter(t.Featured),"")),Z=Z.trim(),Z&&(Z=Z.length<200?Z:Z.substring(0,200),H=H.withFilter(t.SearchText,Z)),H=H.withSortBy(0)):z.ids?H=H.withFilter(t.ExtensionId,...z.ids):z.names?H=H.withFilter(t.ExtensionName,...z.names):H=H.withSortBy(4),typeof z.sortBy=="number"&&(H=H.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(H=H.withSortOrder(z.sortOrder)),z.source&&(H=H.withSource(z.source));const te=async(ge,Se)=>{const{extensions:Ce,total:Re}=await this.queryGalleryExtensions(ge,{targetPlatform:i,compatible:!1,includePreRelease:!!z.includePreRelease},Se);return Ce.forEach((ke,Ue)=>ee(ke,(ge.pageNumber-1)*ge.pageSize+Ue,z.source)),{extensions:Ce,total:Re}},{extensions:ne,total:ce}=await te(H,$),fe=async(ge,Se)=>{if(Se.isCancellationRequested)throw new T.CancellationError;const{extensions:Ce}=await te(H.withPage(ge+1),Se);return Ce};return{firstPage:ne,total:ce,pageSize:H.pageSize,getPage:fe}}async queryGalleryExtensions(z,$,Z){const B=z.flags;z.flags&n.IncludeLatestVersionOnly&&z.flags&n.IncludeVersions&&(z=z.withFlags(z.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(z.flags&n.IncludeLatestVersionOnly)&&!(z.flags&n.IncludeVersions)&&(z=z.withFlags(z.flags,n.IncludeLatestVersionOnly)),$.versions?.length&&(z=z.withFlags(z.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),z=z.withFlags(z.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:H,total:te,context:ne}=await this.queryRawGalleryExtensions(z,Z);if(!(z.flags&n.IncludeLatestVersionOnly)){const Se=[];for(const Ce of H){const Re=await this.toGalleryExtensionWithCriteria(Ce,$,ne);Re&&Se.push(Re)}return{extensions:Se,total:te}}const fe=[],ge=new Map;for(let Se=0;Se<H.length;Se++){const Ce=H[Se],Re={id:(0,S.getGalleryExtensionId)(Ce.publisher.publisherName,Ce.extensionName),uuid:Ce.extensionId},ke=(0,D.isBoolean)($.includePreRelease)?$.includePreRelease:!!$.includePreRelease.find(he=>(0,S.areSameExtensions)(he,Re))?.includePreRelease;if($.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(ie(Ce),$.targetPlatform))continue;const Ue=await this.toGalleryExtensionWithCriteria(Ce,$,ne);!Ue||Ue.properties.isPreReleaseVersion&&(!ke||!Ue.hasReleaseVersion)||!Ue.properties.isPreReleaseVersion&&Ue.properties.targetPlatform!==$.targetPlatform&&Ue.hasPreReleaseVersion?ge.set(Ce.extensionId,Se):fe.push([Se,Ue])}if(ge.size){const Se=new w.StopWatch,Ce=new h().withFlags(B&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,ge.size).withFilter(t.ExtensionId,...ge.keys()),{extensions:Re}=await this.queryGalleryExtensions(Ce,$,Z);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:Se.elapsed(),count:ge.size});for(const ke of Re){const Ue=ge.get(ke.identifier.uuid);fe.push([Ue,ke])}}return{extensions:fe.sort((Se,Ce)=>Se[0]-Ce[0]).map(([,Se])=>Se),total:te}}async toGalleryExtensionWithCriteria(z,$,Z){const B={id:(0,S.getGalleryExtensionId)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},H=$.versions?.find(fe=>(0,S.areSameExtensions)(fe,B))?.version,te=(0,D.isBoolean)($.includePreRelease)?$.includePreRelease:!!$.includePreRelease.find(fe=>(0,S.areSameExtensions)(fe,B))?.includePreRelease,ne=ie(z),ce=re(z.versions,$.targetPlatform);if($.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(ne,$.targetPlatform))return null;for(let fe=0;fe<ce.length;fe++){const ge=ce[fe];if(!(H&&ge.version!==H)){if(await this.isValidVersion(ge,te?"any":"release",$.compatible,ne,$.targetPlatform))return ae(z,ge,ne,Z);if(H&&ge.version===H)return null}}return H||$.compatible?null:ae(z,z.versions[0],ne)}async queryRawGalleryExtensions(z,$){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,s(n.Unpublished));const Z=await this.commonHeadersPromise,B=JSON.stringify(z.raw),H={...Z,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(B.length)},te=new w.StopWatch;let ne,ce,fe=0;try{if(ne=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&z.criteria.some(Se=>Se.filterType===t.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:B,headers:H},$),ne.res.statusCode&&ne.res.statusCode>=400&&ne.res.statusCode<500)return{galleryExtensions:[],total:fe};const ge=await(0,u.asJson)(ne);if(ge){const Se=ge.results[0],Ce=Se.extensions,Re=Se.resultMetadata&&Se.resultMetadata.filter(ke=>ke.metadataType==="ResultCount")[0];return fe=Re&&Re.metadataItems.filter(ke=>ke.name==="TotalCount")[0].count||0,{galleryExtensions:Ce,total:fe,context:{[o]:ne.res.headers.activityid}}}return{galleryExtensions:[],total:fe}}catch(ge){const Se=(0,T.isCancellationError)(ge)?b.ExtensionGalleryErrorCode.Cancelled:(0,T.getErrorMessage)(ge).startsWith("XHR timeout")?b.ExtensionGalleryErrorCode.Timeout:b.ExtensionGalleryErrorCode.Failed;throw ce=new b.ExtensionGalleryError((0,T.getErrorMessage)(ge),Se),ce}finally{this.telemetryService.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(B.length),duration:te.elapsed(),success:!!ne&&(0,u.isSuccess)(ne),responseBodySize:ne?.res.headers["Content-Length"],statusCode:ne?String(ne.res.statusCode):void 0,errorCode:ce?.code,count:String(fe)})}}async reportStatistic(z,$,Z,B){if(!this.isEnabled())return;const H=A.isWeb?this.api(`/itemName/${z}.${$}/version/${Z}/statType/${B==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${z}/extensions/${$}/${Z}/stats?statType=${B}`),te=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ce={...await this.commonHeadersPromise,Accept:te};try{await this.requestService.request({type:"POST",url:H,headers:ce},O.CancellationToken.None)}catch{}}async download(z,$,Z){this.logService.trace("ExtensionGalleryService#download",z.identifier.id);const B=(0,S.getGalleryExtensionTelemetryData)(z),H=new Date().getTime(),te=Se=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...B,duration:Se}),ne=Z===2?"install":Z===3?"update":"",ce=ne?{uri:`${z.assets.download.uri}${I.URI.parse(z.assets.download.uri).query?"&":"?"}${ne}=true`,fallbackUri:`${z.assets.download.fallbackUri}${I.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${ne}=true`}:z.assets.download,fe=z.queryContext?.[o]?{[o]:z.queryContext[o]}:void 0,ge=await this.getAsset(ce,fe?{headers:fe}:void 0);await this.fileService.writeFile($,ge.stream),te(new Date().getTime()-H)}async downloadSignatureArchive(z,$){if(!z.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",z.identifier.id);const Z=await this.getAsset(z.assets.signature);await this.fileService.writeFile($,Z.stream)}async getReadme(z,$){if(z.assets.readme){const Z=await this.getAsset(z.assets.readme,{},$);return await(0,u.asTextOrError)(Z)||""}return""}async getManifest(z,$){if(z.assets.manifest){const Z=await this.getAsset(z.assets.manifest,{},$),B=await(0,u.asTextOrError)(Z);return B?JSON.parse(B):null}return null}async getManifestFromRawExtensionVersion(z,$){const Z=M(z,r.Manifest);if(!Z)throw new Error("Manifest was not found");const B={"Accept-Encoding":"gzip"},H=await this.getAsset(Z,{headers:B});return await(0,u.asJson)(H)}async getCoreTranslation(z,$){const Z=z.assets.coreTranslations.filter(B=>B[0]===$.toUpperCase())[0];if(Z){const B=await this.getAsset(Z[1]),H=await(0,u.asTextOrError)(B);return H?JSON.parse(H):null}return null}async getChangelog(z,$){if(z.assets.changelog){const Z=await this.getAsset(z.assets.changelog,{},$);return await(0,u.asTextOrError)(Z)||""}return""}async getAllCompatibleVersions(z,$,Z){let B=new h().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);z.identifier.uuid?B=B.withFilter(t.ExtensionId,z.identifier.uuid):B=B.withFilter(t.ExtensionName,z.identifier.id);const{galleryExtensions:H}=await this.queryRawGalleryExtensions(B,O.CancellationToken.None);if(!H.length)return[];const te=ie(H[0]);if((0,b.isNotWebExtensionInWebTargetPlatform)(te,Z))return[];const ne=[];await Promise.all(H[0].versions.map(async ge=>{try{await this.isValidVersion(ge,$?"any":"release",!0,te,Z)&&ne.push(ge)}catch{}}));const ce=[],fe=new Set;for(const ge of re(ne,Z))fe.has(ge.version)||(fe.add(ge.version),ce.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:K(ge)}));return ce}async getAsset(z,$={},Z=O.CancellationToken.None){const B=await this.commonHeadersPromise,H={type:"GET"},te={...B,...$.headers||{}};$={...$,...H,headers:te};const ne=z.uri,ce=z.fallbackUri,fe={...$,url:ne};try{const ge=await this.requestService.request(fe,Z);if(ge.res.statusCode===200)return ge;const Se=await(0,u.asTextOrError)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${Se}`)}catch(ge){if((0,T.isCancellationError)(ge))throw ge;const Se=(0,T.getErrorMessage)(ge);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ne,message:Se});const Ce={...$,url:ce};return this.requestService.request(Ce,Z)}}async getEngine(z){let $=Q(z);if(!$){const Z=await this.getManifestFromRawExtensionVersion(z,O.CancellationToken.None);if(!Z)throw new Error("Manifest was not found");$=Z.engines.vscode}return $}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const z=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},O.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const $=await(0,u.asJson)(z),Z=[],B={},H=[];if($){for(const te of $.malicious)Z.push({id:te});if($.migrateToPreRelease)for(const[te,ne]of Object.entries($.migrateToPreRelease))(!ne.engine||(0,l.isEngineValid)(ne.engine,this.productService.version,this.productService.date))&&(B[te.toLowerCase()]={disallowInstall:!0,extension:{id:ne.id,displayName:ne.displayName,autoMigrate:{storage:!!ne.migrateStorage},preRelease:!0}});if($.deprecated)for(const[te,ne]of Object.entries($.deprecated))ne&&(B[te.toLowerCase()]=(0,D.isBoolean)(ne)?{}:ne);if($.search)for(const te of $.search)H.push(te)}return{malicious:Z,deprecated:B,search:H}}};G=ye([Y(1,u.IRequestService),Y(2,p.ILogService),Y(3,P.IEnvironmentService),Y(4,c.ITelemetryService),Y(5,g.IFileService),Y(6,v.IProductService),Y(7,m.IConfigurationService)],G);let W=class extends G{constructor(z,$,Z,B,H,te,ne,ce){super(z,$,Z,B,H,te,ne,ce)}};e.ExtensionGalleryService=W,e.ExtensionGalleryService=W=ye([Y(0,f.IStorageService),Y(1,u.IRequestService),Y(2,p.ILogService),Y(3,P.IEnvironmentService),Y(4,c.ITelemetryService),Y(5,g.IFileService),Y(6,v.IProductService),Y(7,m.IConfigurationService)],W);let _=class extends G{constructor(z,$,Z,B,H,te,ne){super(void 0,z,$,Z,B,H,te,ne)}};e.ExtensionGalleryServiceWithNoStorageService=_,e.ExtensionGalleryServiceWithNoStorageService=_=ye([Y(0,u.IRequestService),Y(1,p.ILogService),Y(2,P.IEnvironmentService),Y(3,c.ITelemetryService),Y(4,g.IFileService),Y(5,v.IProductService),Y(6,m.IConfigurationService)],_)}),define(le[83],ue([0,1,4,3,2,19,33,24,17,8,12]),function(se,e,k,O,T,A,L,D,I,m,P){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,k.createDecorator)("IExtensionStorageService");const S=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let l=class extends T.Disposable{static{b=this}static{this.LARGE_STATE_WARNING_THRESHOLD=512*1024}static toKey(p){return`extensionKeys/${(0,L.adoptToGalleryExtensionId)(p.id)}@${p.version}`}static fromKey(p){const v=S.exec(p);if(v&&v[1])return{id:v[1],version:v[2]}}static async removeOutdatedExtensionVersions(p,v){const u=await p.getInstalled(),d=[];for(const[f,c]of b.readAllExtensionsWithKeysForSync(v)){const w=u.find(i=>(0,L.areSameExtensions)(i.identifier,{id:f}))?.manifest.version;for(const i of c)w!==i&&d.push(b.toKey({id:f,version:i}))}for(const f of d)v.remove(f,0)}static readAllExtensionsWithKeysForSync(p){const v=new Map,u=p.keys(0,1);for(const d of u){const f=b.fromKey(d);if(f){let c=v.get(f.id.toLowerCase());c||v.set(f.id.toLowerCase(),c=[]),c.push(f.version)}}return v}constructor(p,v,u){super(),this.storageService=p,this.productService=v,this.logService=u,this._onDidChangeExtensionStorageToSync=this._register(new O.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=b.readAllExtensionsWithKeysForSync(p),this._register(this.storageService.onDidChangeValue(0,void 0,this._register(new T.DisposableStore))(d=>this.onDidChangeStorageValue(d)))}onDidChangeStorageValue(p){if(this.extensionsWithKeysForSync.has(p.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const v=b.fromKey(p.key);if(v){if(this.storageService.get(p.key,0)===void 0)this.extensionsWithKeysForSync.delete(v.id.toLowerCase());else{let u=this.extensionsWithKeysForSync.get(v.id.toLowerCase());u||this.extensionsWithKeysForSync.set(v.id.toLowerCase(),u=[]),u.push(v.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(p){if((0,P.isString)(p))return p;const v=p.manifest?p.manifest.publisher:p.publisher,u=p.manifest?p.manifest.name:p.name;return(0,L.getExtensionId)(v,u)}getExtensionState(p,v){const u=this.getExtensionId(p),d=this.getExtensionStateRaw(p,v);if(d)try{return JSON.parse(d)}catch(f){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${u}, global: ${v}): ${f}`)}}getExtensionStateRaw(p,v){const u=this.getExtensionId(p),d=this.storageService.get(u,v?0:1);return d&&d?.length>b.LARGE_STATE_WARNING_THRESHOLD&&this.logService.warn(`[mainThreadStorage] large extension state detected (extensionId: ${u}, global: ${v}): ${d.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),d}setExtensionState(p,v,u){const d=this.getExtensionId(p);v===void 0?this.storageService.remove(d,u?0:1):this.storageService.store(d,JSON.stringify(v),u?0:1,1)}setKeysForSync(p,v){this.storageService.store(b.toKey(p),JSON.stringify(v),0,1)}getKeysForSync(p){const v=this.productService.extensionSyncedKeys?.[p.id.toLowerCase()],u=this.storageService.get(b.toKey(p),0),d=u?JSON.parse(u):void 0;return d&&v?(0,I.distinct)([...d,...v]):d||v}addToMigrationList(p,v){if(p!==v){const u=this.migrationList.filter(d=>!d.includes(p)&&!d.includes(v));u.push([p,v]),this.migrationList=u}}getSourceExtensionToMigrate(p){const v=this.migrationList.find(([,u])=>p===u);return v?v[0]:void 0}get migrationList(){const p=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const v=JSON.parse(p);if(Array.isArray(v))return v}catch{}return[]}set migrationList(p){p.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(p),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};e.ExtensionStorageService=l,e.ExtensionStorageService=l=b=ye([Y(0,A.IStorageService),Y(1,D.IProductService),Y(2,m.ILogService)],l)}),define(le[249],ue([0,1,2,29,83,224,113,8,19]),function(se,e,k,O,T,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let m=class extends k.Disposable{constructor(b,S,l,g,p,v){super(),b.cleanUp(),(0,A.migrateUnsupportedExtensions)(b,S,l,g,v),T.ExtensionStorageService.removeOutdatedExtensionVersions(b,p)}};e.ExtensionsContributions=m,e.ExtensionsContributions=m=ye([Y(0,L.INativeServerExtensionManagementService),Y(1,O.IExtensionGalleryService),Y(2,T.IExtensionStorageService),Y(3,O.IGlobalExtensionEnablementService),Y(4,I.IStorageService),Y(5,D.ILogService)],m)}),define(le[250],ue([0,1,29,11,24,15,97,57,19,22,223]),function(se,e,k,O,T,A,L,D,I,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let b=class extends P.AbstractNativeExtensionTipsService{constructor(l,g,p,v,u,d,f,c){super(l.userHome,u,g,p,v,d,f,c)}};e.ExtensionTipsService=b,e.ExtensionTipsService=b=ye([Y(0,A.INativeEnvironmentService),Y(1,m.ITelemetryService),Y(2,k.IExtensionManagementService),Y(3,I.IStorageService),Y(4,D.INativeHostService),Y(5,L.IExtensionRecommendationNotificationService),Y(6,O.IFileService),Y(7,T.IProductService)],b)}),define(le[251],ue([0,1,105,3,22,15,2,8,16,67,24,5,6,101,21,165,36,19,12,132,20]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g,p,v,u,d,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const w=[k.CONFIGURATION_KEY_HOST_NAME,k.CONFIGURATION_KEY_PREVENT_SLEEP],i="remoteTunnelSession",o="remoteTunnelIsService";let n=class extends L.Disposable{constructor(a,C,E,h,y,R,U){super(),this.telemetryService=a,this.productService=C,this.environmentService=E,this.configurationService=R,this.storageService=U,this._onDidTokenFailedEmitter=new O.Emitter,this.onDidTokenFailed=this._onDidTokenFailedEmitter.event,this._onDidChangeTunnelStatusEmitter=new O.Emitter,this.onDidChangeTunnelStatus=this._onDidChangeTunnelStatusEmitter.event,this._onDidChangeModeEmitter=new O.Emitter,this.onDidChangeMode=this._onDidChangeModeEmitter.event,this._mode=k.INACTIVE_TUNNEL_MODE,this._initialized=!1,this.defaultOnOutput=(F,M)=>{M?this._logger.error(F):this._logger.info(F)},this._logger=this._register(h.createLogger((0,c.joinPath)(E.logsHome,`${k.LOG_ID}.log`),{id:k.LOG_ID,name:k.LOGGER_NAME})),this._startTunnelProcessDelayer=new S.Delayer(100),this._register(this._logger.onDidChangeLogLevel(F=>this._logger.info("Log level changed to "+(0,D.LogLevelToString)(F)))),this._register(y.onWillShutdown(()=>{this._tunnelProcess?.cancel(),this._tunnelProcess=void 0,this.dispose()})),this._register(R.onDidChangeConfiguration(F=>{w.some(M=>F.affectsConfiguration(M))&&this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())})),this._mode=this._restoreMode(),this._tunnelStatus=k.TunnelStates.uninitialized}async getTunnelStatus(){return this._tunnelStatus}setTunnelStatus(a){this._tunnelStatus=a,this._onDidChangeTunnelStatusEmitter.fire(a)}setMode(a){t(this._mode,a)||(this._mode=a,this._storeMode(a),this._onDidChangeModeEmitter.fire(this._mode),a.active?(this._logger.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this._logger.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this._logger.info("Session reset"))}getMode(){return Promise.resolve(this._mode)}async initialize(a){if(this._initialized)return this._tunnelStatus;this._initialized=!0,this.setMode(a);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(C){this._logger.error(C)}return this._tunnelStatus}getTunnelCommandLocation(){if(!this._tunnelCommand){let a;b.isMacintosh?a=this.environmentService.appRoot:a=(0,I.dirname)((0,I.dirname)(this.environmentService.appRoot)),this._tunnelCommand=(0,I.join)(a,"bin",`${this.productService.tunnelApplicationName}${b.isWindows?".exe":""}`)}return this._tunnelCommand}async startTunnel(a){if(t(this._mode,a)&&this._tunnelStatus.type!=="disconnected")return this._tunnelStatus;this.setMode(a);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(C){this._logger.error(C)}return this._tunnelStatus}async stopTunnel(){if(this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),this._mode.active){const a=this._mode.asService;this.setMode(k.INACTIVE_TUNNEL_MODE);try{a&&this.runCodeTunnelCommand("uninstallService",["service","uninstall"])}catch(C){this._logger.error(C)}}try{await this.runCodeTunnelCommand("stop",["kill"])}catch(a){this._logger.error(a)}this.setTunnelStatus(k.TunnelStates.disconnected())}async updateTunnelProcess(){this.telemetryService.publicLog2("remoteTunnel.enablement",{enabled:this._mode.active,service:this._mode.active&&this._mode.asService}),this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0);let a="",C=!1;const E=(M,j)=>{j?this._logger.error(M):a+=M,!this.environmentService.isBuilt&&M.startsWith("   Compiling")&&this.setTunnelStatus(k.TunnelStates.connecting((0,p.localize)(0,null)))},h=this.runCodeTunnelCommand("status",["status"],E);this._tunnelProcess=h;try{if(await h,this._tunnelProcess!==h)return;let M;try{M=JSON.parse(a.trim().split(`
`).find(j=>j.startsWith("{")))}catch{this._logger.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.setTunnelStatus(k.TunnelStates.disconnected());return}if(C=M.service_installed,this._logger.info(M.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!M.tunnel&&!this._mode.active){this.setTunnelStatus(k.TunnelStates.disconnected());return}}catch(M){this._logger.error(M),this.setTunnelStatus(k.TunnelStates.disconnected());return}finally{this._tunnelProcess===h&&(this._tunnelProcess=void 0)}const y=this._mode.active?this._mode.session:void 0;if(y&&y.token){const M=y.token;this.setTunnelStatus(k.TunnelStates.connecting((0,p.localize)(1,null,y.accountLabel,y.providerId)));const j=(K,X)=>{K=K.replaceAll(M,"*".repeat(4)),E(K,X)},Q=this.runCodeTunnelCommand("login",["user","login","--provider",y.providerId,"--access-token",M,"--log",(0,D.LogLevelToString)(this._logger.getLevel())],j);this._tunnelProcess=Q;try{if(await Q,this._tunnelProcess!==Q)return}catch(K){this._logger.error(K),this._tunnelProcess=void 0,this._onDidTokenFailedEmitter.fire(y),this.setTunnelStatus(k.TunnelStates.disconnected(y));return}}const R=this._getTunnelName();R?this.setTunnelStatus(k.TunnelStates.connecting((0,p.localize)(2,null,R))):this.setTunnelStatus(k.TunnelStates.connecting((0,p.localize)(3,null)));const U=["--accept-server-license-terms","--log",(0,D.LogLevelToString)(this._logger.getLevel())];R?U.push("--name",R):U.push("--random-name");let F=!1;return this._mode.active&&this._mode.asService&&!C&&(F=await this.installTunnelService(U)===!1),this.serverOrAttachTunnel(y,U,F)}async installTunnelService(a){let C;try{C=await this.runCodeTunnelCommand("serviceInstall",["service","install",...a])}catch(E){this._logger.error(E),C=1}if(C!==0){const E=(0,p.localize)(4,null);return this._logger.warn(E),this.setTunnelStatus(k.TunnelStates.connecting(E)),!1}return!0}async serverOrAttachTunnel(a,C,E){C.push("--parent-process-id",String(process.pid)),this._preventSleep()&&C.push("--no-sleep");let h=!1;const y=this.runCodeTunnelCommand("tunnel",C,(R,U)=>{U?this._logger.error(R):this._logger.info(R),R.includes("Connected to an existing tunnel process")&&(h=!0);const F=R.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(F){const M={link:F[1],domain:F[2],tunnelName:F[4],isAttached:h};this.setTunnelStatus(k.TunnelStates.connected(M,E))}else R.match(/error refreshing token/)&&(y.cancel(),this._onDidTokenFailedEmitter.fire(a),this.setTunnelStatus(k.TunnelStates.disconnected(a)))});this._tunnelProcess=y,y.finally(()=>{y===this._tunnelProcess&&(this._logger.info("tunnel process terminated"),this._tunnelProcess=void 0,this._mode=k.INACTIVE_TUNNEL_MODE,this.setTunnelStatus(k.TunnelStates.disconnected()))})}runCodeTunnelCommand(a,C,E=this.defaultOnOutput){return(0,S.createCancelablePromise)(h=>new Promise((y,R)=>{h.isCancellationRequested&&y(-1);let U;const F=["ignore","pipe","pipe"];if(h.onCancellationRequested(()=>{U&&(this._logger.info(`${a} terminating(${U.pid})`),U.kill())}),!this.environmentService.isBuilt)E(`Building tunnel CLI from sources and run
`,!1),E(`${a} Spawning: cargo run -- tunnel ${C.join(" ")}
`,!1),U=(0,m.spawn)("cargo",["run","--","tunnel",...C],{cwd:(0,I.join)(this.environmentService.appRoot,"cli"),stdio:F});else{E(`Running tunnel CLI
`,!1);const M=this.getTunnelCommandLocation();E(`${a} Spawning: ${M} tunnel ${C.join(" ")}
`,!1),U=(0,m.spawn)(M,["tunnel",...C],{cwd:(0,v.homedir)(),stdio:F})}U.stdout.pipe(new f.StreamSplitter(`
`)).on("data",M=>{if(U){const j=M.toString();E(j,!1)}}),U.stderr.pipe(new f.StreamSplitter(`
`)).on("data",M=>{if(U){const j=M.toString();E(j,!0)}}),U.on("exit",M=>{U&&(E(`${a} exit(${U.pid}): + ${M} `,!1),U=void 0,y(M||0))}),U.on("error",M=>{U&&(E(`${a} error(${U.pid}): + ${M} `,!0),U=void 0,R())})}))}async getTunnelName(){return this._getTunnelName()}_preventSleep(){return!!this.configurationService.getValue(k.CONFIGURATION_KEY_PREVENT_SLEEP)}_getTunnelName(){let a=this.configurationService.getValue(k.CONFIGURATION_KEY_HOST_NAME)||(0,v.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}_restoreMode(){try{const a=this.storageService.get(i,-1),C=this.storageService.getBoolean(o,-1,!1);if(a){const E=JSON.parse(a);if(E&&(0,d.isString)(E.accountLabel)&&(0,d.isString)(E.sessionId)&&(0,d.isString)(E.providerId))return{active:!0,session:E,asService:C};this._logger.error("Problems restoring session from storage, invalid format",E)}}catch(a){this._logger.error("Problems restoring session from storage",a)}return k.INACTIVE_TUNNEL_MODE}_storeMode(a){if(a.active){const C={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.storageService.store(i,JSON.stringify(C),-1,1),this.storageService.store(o,a.asService,-1,1)}else this.storageService.remove(i,-1),this.storageService.remove(o,-1)}};e.RemoteTunnelService=n,e.RemoteTunnelService=n=ye([Y(0,T.ITelemetryService),Y(1,P.IProductService),Y(2,A.INativeEnvironmentService),Y(3,D.ILoggerService),Y(4,l.ISharedProcessLifecycleService),Y(5,g.IConfigurationService),Y(6,u.IStorageService)],n);function s(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const t=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&s(r.session,a.session):!0}),define(le[252],ue([0,1,6,2,23,20,69,19,78,18]),function(se,e,k,O,T,A,L,D,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteStorageService=void 0;class P extends D.AbstractStorageService{constructor(S,l,g,p){super(),this.initialWorkspace=S,this.initialProfiles=l,this.remoteService=g,this.environmentService=p,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new O.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new O.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const S=this._register(new I.ApplicationStorageDatabaseClient(this.remoteService.getChannel("storage"))),l=this._register(new L.Storage(S));return this._register(l.onDidChangeStorage(g=>this.emitDidChangeValue(-1,g))),l}createProfileStorage(S){this.profileStorageDisposables.clear(),this.profileStorageProfile=S;let l;if((0,D.isProfileUsingDefaultStorage)(S))l=this.applicationStorage;else{const g=this.profileStorageDisposables.add(new I.ProfileStorageDatabaseClient(this.remoteService.getChannel("storage"),S));l=this.profileStorageDisposables.add(new L.Storage(g))}return this.profileStorageDisposables.add(l.onDidChangeStorage(g=>this.emitDidChangeValue(0,g))),l}createWorkspaceStorage(S){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=S?.id;let l;if(S){const g=this.workspaceStorageDisposables.add(new I.WorkspaceStorageDatabaseClient(this.remoteService.getChannel("storage"),S));l=this.workspaceStorageDisposables.add(new L.Storage(g)),this.workspaceStorageDisposables.add(l.onDidChangeStorage(p=>this.emitDidChangeValue(1,p)))}return l}async doInitialize(){await k.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(S){switch(S){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(S){switch(S){case-1:return this.applicationStorageProfile.globalStorageHome.with({scheme:T.Schemas.file}).fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.with({scheme:T.Schemas.file}).fsPath;default:return this.workspaceStorageId?`${(0,A.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").with({scheme:T.Schemas.file}).fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(D.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(S){if(!this.canSwitchProfile(this.profileStorageProfile,S))return;const l=this.profileStorage,g=l.items;l!==this.applicationStorage&&await l.close(),this.profileStorage=this.createProfileStorage(S),await this.profileStorage.init(),this.switchData(g,this.profileStorage,0)}async switchToWorkspace(S,l){const g=this.workspaceStorage,p=g?.items??new Map;await g?.close(),this.workspaceStorage=this.createWorkspaceStorage(S),await this.workspaceStorage.init(),this.switchData(p,this.workspaceStorage,1)}hasScope(S){return(0,m.isUserDataProfile)(S)?this.profileStorageProfile.id===S.id:this.workspaceStorageId===S.id}}e.RemoteStorageService=P}),define(le[253],ue([0,1,3,2,18,92]),function(se,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class L{constructor(m,P){this.service=m,this.getUriTransformer=P}listen(m,P){const b=this.getUriTransformer(m);switch(P){case"onDidChangeProfiles":return k.Event.map(this.service.onDidChangeProfiles,S=>({all:S.all.map(l=>(0,A.transformOutgoingURIs)({...l},b)),added:S.added.map(l=>(0,A.transformOutgoingURIs)({...l},b)),removed:S.removed.map(l=>(0,A.transformOutgoingURIs)({...l},b)),updated:S.updated.map(l=>(0,A.transformOutgoingURIs)({...l},b))}))}throw new Error(`Invalid listen ${P}`)}async call(m,P,b){const S=this.getUriTransformer(m);switch(P){case"createProfile":{const l=await this.service.createProfile(b[0],b[1],b[2]);return(0,A.transformOutgoingURIs)({...l},S)}case"updateProfile":{let l=(0,T.reviveProfile)((0,A.transformIncomingURIs)(b[0],S),this.service.profilesHome.scheme);return l=await this.service.updateProfile(l,b[1]),(0,A.transformOutgoingURIs)({...l},S)}case"removeProfile":{const l=(0,T.reviveProfile)((0,A.transformIncomingURIs)(b[0],S),this.service.profilesHome.scheme);return this.service.removeProfile(l)}}throw new Error(`Invalid call ${P}`)}}e.RemoteUserDataProfilesServiceChannel=L;class D extends O.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(m,P,b){super(),this.profilesHome=P,this.channel=b,this._profiles=[],this._onDidChangeProfiles=this._register(new k.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.enabled=!0,this._profiles=m.map(S=>(0,T.reviveProfile)(S,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(S=>{const l=S.added.map(v=>(0,T.reviveProfile)(v,this.profilesHome.scheme)),g=S.removed.map(v=>(0,T.reviveProfile)(v,this.profilesHome.scheme)),p=S.updated.map(v=>(0,T.reviveProfile)(v,this.profilesHome.scheme));this._profiles=S.all.map(v=>(0,T.reviveProfile)(v,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:l,removed:g,updated:p,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}setEnablement(m){this.enabled=m}isEnabled(){return this.enabled}async createNamedProfile(m,P,b){const S=await this.channel.call("createNamedProfile",[m,P,b]);return(0,T.reviveProfile)(S,this.profilesHome.scheme)}async createProfile(m,P,b,S){const l=await this.channel.call("createProfile",[m,P,b,S]);return(0,T.reviveProfile)(l,this.profilesHome.scheme)}async createTransientProfile(m){const P=await this.channel.call("createTransientProfile",[m]);return(0,T.reviveProfile)(P,this.profilesHome.scheme)}async setProfileForWorkspace(m,P){await this.channel.call("setProfileForWorkspace",[m,P])}removeProfile(m){return this.channel.call("removeProfile",[m])}async updateProfile(m,P){const b=await this.channel.call("updateProfile",[m,P]);return(0,T.reviveProfile)(b,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=D}),define(le[60],ue([0,1,2,69,4,19,3,78,18]),function(se,e,k,O,T,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteUserDataProfileStorageService=e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,T.createDecorator)("IUserDataProfileStorageService");let m=class extends k.Disposable{constructor(l){super(),this.storageService=l}async readStorageData(l){return this.withProfileScopedStorageService(l,async g=>this.getItems(g))}async updateStorageData(l,g,p){return this.withProfileScopedStorageService(l,async v=>this.writeItems(v,g,p))}async withProfileScopedStorageService(l,g){if(this.storageService.hasScope(l))return g(this.storageService);const p=await this.createStorageDatabase(l),v=new b(p);try{await v.initialize();const u=await g(v);return await v.flush(),u}finally{v.dispose(),await this.closeAndDispose(p)}}getItems(l){const g=new Map,p=v=>{for(const u of l.keys(0,v))g.set(u,{value:l.get(u,0),target:v})};return p(0),p(1),g}writeItems(l,g,p){l.storeAll(Array.from(g.entries()).map(([v,u])=>({key:v,value:u,scope:0,target:p})),!0)}async closeAndDispose(l){try{await l.close()}finally{(0,k.isDisposable)(l)&&l.dispose()}}};e.AbstractUserDataProfileStorageService=m,e.AbstractUserDataProfileStorageService=m=ye([Y(0,A.IStorageService)],m);class P extends m{constructor(l,g,p,v){super(p),this.remoteService=l;const u=l.getChannel("profileStorageListener"),d=this._register(new k.MutableDisposable);this._onDidChange=this._register(new L.Emitter({onWillAddFirstListener:()=>{d.value=u.listen("onDidChange")(f=>{v.trace("profile storage changes",f),this._onDidChange.fire({targetChanges:f.targetChanges.map(c=>(0,I.reviveProfile)(c,g.profilesHome.scheme)),valueChanges:f.valueChanges.map(c=>({...c,profile:(0,I.reviveProfile)(c.profile,g.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>d.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(l){const g=this.remoteService.getChannel("storage");return(0,A.isProfileUsingDefaultStorage)(l)?new D.ApplicationStorageDatabaseClient(g):new D.ProfileStorageDatabaseClient(g,l)}}e.RemoteUserDataProfileStorageService=P;class b extends A.AbstractStorageService{constructor(l){super({flushInterval:100}),this.profileStorage=this._register(new O.Storage(l))}doInitialize(){return this.profileStorage.init()}getStorage(l){return l===0?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(le[254],ue([0,1,19,8,18,56,60]),function(se,e,k,O,T,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeUserDataProfileStorageService=void 0;let D=class extends L.RemoteUserDataProfileStorageService{constructor(m,P,b,S){super(m,P,b,S)}};e.NativeUserDataProfileStorageService=D,e.NativeUserDataProfileStorageService=D=ye([Y(0,A.IMainProcessService),Y(1,T.IUserDataProfilesService),Y(2,k.IStorageService),Y(3,O.ILogService)],D)}),define(le[39],ue([0,1,17,6,14,26,3,34,2,27,12,170,21,15,11,8,43,19,22,28,25,18]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g,p,v,u,d,f,c,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function i(C){return!!(C&&C.ref!==void 0&&typeof C.ref=="string"&&C.ref!==""&&C.syncData!==void 0&&(C.syncData===null||o(C.syncData)))}e.isRemoteUserData=i;function o(C){return!!(C&&C.version!==void 0&&typeof C.version=="number"&&C.content!==void 0&&typeof C.content=="string"&&(Object.keys(C).length===2||Object.keys(C).length===3&&C.machineId!==void 0&&typeof C.machineId=="string"))}e.isSyncData=o;function n(C,E){return`${(0,m.uppercaseFirstLetter)(C)}${E.isDefault?"":` (${E.name})`}`}e.getSyncResourceLogLabel=n;let s=class extends I.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(E,h,y,R,U,F,M,j,Q,K,X,x){super(),this.syncResource=E,this.collection=h,this.fileService=y,this.environmentService=R,this.storageService=U,this.userDataSyncStoreService=F,this.userDataSyncLocalStoreService=M,this.userDataSyncEnablementService=j,this.telemetryService=Q,this.logService=K,this.configurationService=X,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=this._register(new O.ThrottledDelayer(50)),this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.lastSyncUserDataStateKey=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=n(E.syncResource,E.profile),this.extUri=x.extUri,this.syncFolder=this.extUri.joinPath(R.userDataSyncHome,...(0,c.getPathSegments)(E.profile.isDefault?void 0:E.profile.id,E.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,c.PREVIEW_DIR_NAME),this.lastSyncResource=(0,c.getLastSyncResourceUri)(E.profile.isDefault?void 0:E.profile.id,E.syncResource,R,this.extUri),this.currentMachineIdPromise=(0,v.getServiceMachineId)(R,y,U)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const E=await this.syncPreviewPromise;this.syncPreviewPromise=null;const h=await this.performSync(E.remoteUserData,E.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(h)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const E=await this.getLastSyncUserData();(E?await this.hasRemoteChanged(E):!0)&&this._onDidChangeLocal.fire()}}setStatus(E){this._status!==E&&(this._status=E,this._onDidChangStatus.fire(E))}async sync(E,h={}){await this._sync(E,!0,this.getUserDataSyncConfiguration(),h)}async preview(E,h,y={}){return this._sync(E,!1,h,y)}async apply(E,h={}){try{this.syncHeaders={...h};const y=await this.doApply(E);return this.setStatus(y),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(E,h,y,R){try{if(this.syncHeaders={...R},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let U="idle";try{const F=await this.getLastSyncUserData(),M=await this.getLatestRemoteUserData(E,F);return U=await this.performSync(M,F,h,y),U==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):U==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(U)}}finally{this.syncHeaders={}}}async replace(E){const h=this.parseSyncData(E);if(!h)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const y=await this.getLastSyncUserData(),R=await this.getLatestRemoteUserData(null,y),U=await this.isRemoteDataFromCurrentMachine(R),F=await this.generateSyncPreview({ref:R.ref,syncData:h},y,U,this.getUserDataSyncConfiguration(),A.CancellationToken.None),M=[];for(const j of F){const Q=await this.getAcceptResult(j,j.remoteResource,void 0,A.CancellationToken.None),{remoteChange:K}=await this.getAcceptResult(j,j.previewResource,j.remoteContent,A.CancellationToken.None);M.push([j,{...Q,remoteChange:K!==0?K:2}])}await this.applyResult(R,y,M,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(E){const h=await this.currentMachineIdPromise;return!!E.syncData?.machineId&&E.syncData.machineId===h}async getLatestRemoteUserData(E,h){if(h){const y=E?E[this.resource]:void 0;if(h.ref===y||y===void 0&&h.syncData===null)return h}return this.getRemoteUserData(h)}async performSync(E,h,y,R){if(E.syncData&&E.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new c.UserDataSyncError((0,b.localize)(0,null,this.resource,this.version,E.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(E,h,y,R)}catch(U){if(U instanceof c.UserDataSyncError)switch(U.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(E,h,y,R);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),E=await this.getRemoteUserData(null),h=await this.getLastSyncUserData(),this.performSync(E,h,y,R)}throw U}}async doSync(E,h,y,R){try{const U=await this.isRemoteDataFromCurrentMachine(E),F=!U&&h===null&&this.getStoredLastSyncUserDataStateContent()!==void 0,M=y&&!F;this.syncPreviewPromise||(this.syncPreviewPromise=(0,O.createCancelablePromise)(Q=>this.doGenerateSyncResourcePreview(E,h,U,M,R,Q)));let j=await this.syncPreviewPromise;if(y&&F){this.logService.info(`${this.syncResourceLogLabel}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Q of j.resourcePreviews)j=await this.accept(Q.remoteResource)||j}return this.updateConflicts(j.resourcePreviews),j.resourcePreviews.some(({mergeState:Q})=>Q==="conflict")?"hasConflicts":y?await this.doApply(!1):"syncing"}catch(U){throw this.syncPreviewPromise=null,U}}async merge(E){return await this.updateSyncResourcePreview(E,async h=>{const y=await this.getMergeResult(h,A.CancellationToken.None);await this.fileService.writeFile(h.previewResource,T.VSBuffer.fromString(y?.content||""));const R=y&&!y.hasConflicts?await this.getAcceptResult(h,h.previewResource,void 0,A.CancellationToken.None):void 0;return h.acceptResult=R,h.mergeState=y.hasConflicts?"conflict":R?"accepted":"preview",h.localChange=R?R.localChange:y.localChange,h.remoteChange=R?R.remoteChange:y.remoteChange,h}),this.syncPreviewPromise}async accept(E,h){return await this.updateSyncResourcePreview(E,async y=>{const R=await this.getAcceptResult(y,E,h,A.CancellationToken.None);return y.acceptResult=R,y.mergeState="accepted",y.localChange=R.localChange,y.remoteChange=R.remoteChange,y}),this.syncPreviewPromise}async discard(E){return await this.updateSyncResourcePreview(E,async h=>{const y=await this.getMergeResult(h,A.CancellationToken.None);return await this.fileService.writeFile(h.previewResource,T.VSBuffer.fromString(y.content||"")),h.acceptResult=void 0,h.mergeState="preview",h.localChange=y.localChange,h.remoteChange=y.remoteChange,h}),this.syncPreviewPromise}async updateSyncResourcePreview(E,h){if(!this.syncPreviewPromise)return;let y=await this.syncPreviewPromise;const R=y.resourcePreviews.findIndex(({localResource:U,remoteResource:F,previewResource:M})=>this.extUri.isEqual(U,E)||this.extUri.isEqual(F,E)||this.extUri.isEqual(M,E));R!==-1&&(this.syncPreviewPromise=(0,O.createCancelablePromise)(async U=>{const F=[...y.resourcePreviews];return F[R]=await h(F[R]),{...y,resourcePreviews:F}}),y=await this.syncPreviewPromise,this.updateConflicts(y.resourcePreviews),y.resourcePreviews.some(({mergeState:U})=>U==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(E){if(!this.syncPreviewPromise)return"idle";const h=await this.syncPreviewPromise;return h.resourcePreviews.some(({mergeState:y})=>y==="conflict")?"hasConflicts":h.resourcePreviews.some(({mergeState:y})=>y!=="accepted")?"syncing":(await this.applyResult(h.remoteUserData,h.lastSyncUserData,h.resourcePreviews.map(y=>[y,y.acceptResult]),E),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(E){const h=E.filter(({mergeState:y})=>y==="conflict");(0,k.equals)(this._conflicts,h,(y,R)=>this.extUri.isEqual(y.previewResource,R.previewResource))||(this._conflicts=h,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const E=await this.getLastSyncUserData();return!!E&&E.syncData!==null}async resolvePreviewContent(E){const h=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(h)for(const y of h.resourcePreviews){if(this.extUri.isEqual(y.acceptedResource,E))return y.acceptResult?y.acceptResult.content:null;if(this.extUri.isEqual(y.remoteResource,E))return y.remoteContent;if(this.extUri.isEqual(y.localResource,E))return y.localContent;if(this.extUri.isEqual(y.baseResource,E))return y.baseContent}return null}async resetLocal(){this.storageService.remove(this.lastSyncUserDataStateKey,-1);try{await this.fileService.del(this.lastSyncResource)}catch(E){(0,g.toFileOperationResult)(E)!==1&&this.logService.error(E)}}async doGenerateSyncResourcePreview(E,h,y,R,U,F){const M=await this.generateSyncPreview(E,h,y,U,F),j=[];for(const Q of M){const K=Q.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(Q.localChange===0&&Q.remoteChange===0)j.push({...Q,acceptedResource:K,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const X=R?await this.getMergeResult(Q,F):void 0;if(F.isCancellationRequested)break;await this.fileService.writeFile(Q.previewResource,T.VSBuffer.fromString(X?.content||""));const x=X&&!X.hasConflicts?await this.getAcceptResult(Q,Q.previewResource,void 0,F):void 0;j.push({...Q,acceptResult:x,mergeState:X?.hasConflicts?"conflict":x?"accepted":"preview",localChange:x?x.localChange:X?X.localChange:Q.localChange,remoteChange:x?x.remoteChange:X?X.remoteChange:Q.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:E,lastSyncUserData:h,resourcePreviews:j,isLastSyncFromCurrentMachine:y}}async getLastSyncUserData(){let E=this.getStoredLastSyncUserDataStateContent();if(E||(E=await this.migrateLastSyncUserData()),!E)return this.logService.info(`${this.syncResourceLogLabel}: Last sync data state does not exist.`),null;const h=JSON.parse(E),y=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=!!h.version&&!!y&&h.version!==y,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${h.version} is not compatible with current sync state version ${y}.`),await this.resetLocal(),null;let R,U=1;for(;R===void 0&&U++<6;)try{const F=await this.readLastSyncStoredRemoteUserData();F&&(F.ref===h.ref?R=F.syncData:this.logService.info(`${this.syncResourceLogLabel}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof g.FileOperationError&&F.fileOperationResult===1){this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist locally.`);break}else{if(F instanceof c.UserDataSyncError)throw F;this.logService.error(F,U)}}if(R===void 0)try{const F=await this.userDataSyncStoreService.resolveResourceContent(this.resource,h.ref,this.collection,this.syncHeaders);R=F===null?null:this.parseSyncData(F),await this.writeLastSyncStoredRemoteUserData({ref:h.ref,syncData:R})}catch(F){if(F instanceof c.UserDataSyncError&&F.code==="NotFound")this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist remotely.`);else throw F}return R===void 0?null:{...h,syncData:R}}async updateLastSyncUserData(E,h={}){if(h.ref||h.version)throw new Error("Cannot have core properties as additional");const y=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),R={ref:E.ref,version:y,...h};this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify(R),-1,1),await this.writeLastSyncStoredRemoteUserData(E)}getStoredLastSyncUserDataStateContent(){return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async readLastSyncStoredRemoteUserData(){const E=(await this.fileService.readFile(this.lastSyncResource)).value.toString();try{const h=E?JSON.parse(E):void 0;if(i(h))return h}catch(h){this.logService.error(h)}}async writeLastSyncStoredRemoteUserData(E){await this.fileService.writeFile(this.lastSyncResource,T.VSBuffer.fromString(JSON.stringify(E)))}async migrateLastSyncUserData(){try{const E=await this.fileService.readFile(this.lastSyncResource),h=JSON.parse(E.value.toString());await this.fileService.del(this.lastSyncResource),h.ref&&h.content!==void 0?(this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify({...h,content:void 0}),-1,1),await this.writeLastSyncStoredRemoteUserData({ref:h.ref,syncData:h.content===null?null:JSON.parse(h.content)})):this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Invalid data.`,h)}catch(E){E instanceof g.FileOperationError&&E.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Resource does not exist.`):this.logService.error(E)}return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async getRemoteUserData(E){const{ref:h,content:y}=await this.getUserData(E);let R=null;return y!==null&&(R=this.parseSyncData(y)),{ref:h,syncData:R}}parseSyncData(E){try{const h=JSON.parse(E);if(o(h))return h}catch(h){this.logService.error(h)}throw new c.UserDataSyncError((0,b.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(E){const h=E?{ref:E.ref,content:E.syncData?JSON.stringify(E.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,h,this.collection,this.syncHeaders)}async updateRemoteUserData(E,h){const y=await this.currentMachineIdPromise,R={version:this.version,machineId:y,content:E};try{return h=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(R),h,this.collection,this.syncHeaders),{ref:h,syncData:R}}catch(U){throw U instanceof c.UserDataSyncError&&U.code==="TooLarge"&&(U=new c.UserDataSyncError(U.message,U.code,this.resource)),U}}async backupLocal(E){const h={version:this.version,content:E};return this.userDataSyncLocalStoreService.writeResource(this.resource,JSON.stringify(h),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(c.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};e.AbstractSynchroniser=s,e.AbstractSynchroniser=s=ye([Y(2,g.IFileService),Y(3,l.IEnvironmentService),Y(4,u.IStorageService),Y(5,c.IUserDataSyncStoreService),Y(6,c.IUserDataSyncLocalStoreService),Y(7,c.IUserDataSyncEnablementService),Y(8,d.ITelemetryService),Y(9,c.IUserDataSyncLogService),Y(10,S.IConfigurationService),Y(11,f.IUriIdentityService)],s);let t=class extends s{constructor(E,h,y,R,U,F,M,j,Q,K,X,x,J){super(h,y,R,U,F,M,j,Q,K,X,x,J),this.file=E,this._register(this.fileService.watch(this.extUri.dirname(E))),this._register(this.fileService.onDidFilesChange(V=>this.onFileChanges(V)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(E,h,y){try{h?await this.fileService.writeFile(this.file,T.VSBuffer.fromString(E),y?void 0:h):await this.fileService.createFile(this.file,T.VSBuffer.fromString(E),{overwrite:y})}catch(R){throw R instanceof g.FileOperationError&&R.fileOperationResult===1||R instanceof g.FileOperationError&&R.fileOperationResult===3?new c.UserDataSyncError(R.message,"LocalPreconditionFailed"):R}}async deleteLocalFile(){try{await this.fileService.del(this.file)}catch(E){if(!(E instanceof g.FileOperationError&&E.fileOperationResult===1))throw E}}onFileChanges(E){E.contains(this.file)&&this.triggerLocalChange()}};e.AbstractFileSynchroniser=t,e.AbstractFileSynchroniser=t=ye([Y(3,g.IFileService),Y(4,l.IEnvironmentService),Y(5,u.IStorageService),Y(6,c.IUserDataSyncStoreService),Y(7,c.IUserDataSyncLocalStoreService),Y(8,c.IUserDataSyncEnablementService),Y(9,d.ITelemetryService),Y(10,c.IUserDataSyncLogService),Y(11,S.IConfigurationService),Y(12,f.IUriIdentityService)],t);let r=class extends t{constructor(E,h,y,R,U,F,M,j,Q,K,X,x,J,V){super(E,h,y,R,U,F,M,j,Q,K,X,J,V),this.userDataSyncUtilService=x,this._formattingOptions=void 0}hasErrors(E,h){const y=[],R=(0,D.parse)(E,y,{allowEmptyContent:!0,allowTrailingComma:!0});return y.length>0||!(0,P.isUndefined)(R)&&h!==Array.isArray(R)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};e.AbstractJsonFileSynchroniser=r,e.AbstractJsonFileSynchroniser=r=ye([Y(3,g.IFileService),Y(4,l.IEnvironmentService),Y(5,u.IStorageService),Y(6,c.IUserDataSyncStoreService),Y(7,c.IUserDataSyncLocalStoreService),Y(8,c.IUserDataSyncEnablementService),Y(9,d.ITelemetryService),Y(10,c.IUserDataSyncLogService),Y(11,c.IUserDataSyncUtilService),Y(12,S.IConfigurationService),Y(13,f.IUriIdentityService)],r);let a=class{constructor(E,h,y,R,U,F,M){this.resource=E,this.userDataProfilesService=h,this.environmentService=y,this.logService=R,this.fileService=U,this.storageService=F,this.extUri=M.extUri,this.lastSyncResource=(0,c.getLastSyncResourceUri)(void 0,this.resource,y,this.extUri)}async initialize({ref:E,content:h}){if(!h){this.logService.info("Remote content does not exist.",this.resource);return}const y=this.parseSyncData(h);if(y)try{await this.doInitialize({ref:E,syncData:y})}catch(R){this.logService.error(R)}}parseSyncData(E){try{const h=JSON.parse(E);if(o(h))return h}catch(h){this.logService.error(h)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(E,h={}){if(h.ref||h.version)throw new Error("Cannot have core properties as additional");const y={ref:E.ref,version:void 0,...h};this.storageService.store(`${this.resource}.lastSyncUserData`,JSON.stringify(y),-1,1),await this.fileService.writeFile(this.lastSyncResource,T.VSBuffer.fromString(JSON.stringify(E)))}};e.AbstractInitializer=a,e.AbstractInitializer=a=ye([Y(1,w.IUserDataProfilesService),Y(2,l.IEnvironmentService),Y(3,p.ILogService),Y(4,g.IFileService),Y(5,u.IStorageService),Y(6,f.IUriIdentityService)],a)}),define(le[115],ue([0,1,6,26,7,3,42,2,27,21,15,114,29,33,83,45,11,4,74,8,19,22,28,18,39,235,111,25,60]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g,p,v,u,d,f,c,w,i,o,n,s,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function C(F,M){const j=JSON.parse(F.content);if(F.version===1||F.version===2){const Q=(await M.getInstalled(0)).filter(K=>K.isBuiltin);for(const K of j)F.version===1&&(K.enabled===!1&&(K.disabled=!0),delete K.enabled),F.version===2&&Q.every(X=>!(0,l.areSameExtensions)(X.identifier,K.identifier))&&(K.installed=!0)}return j}function E(F){return JSON.parse(F.content)}e.parseExtensions=E;function h(F,M){return F.sort((j,Q)=>!j.identifier.uuid&&Q.identifier.uuid?-1:j.identifier.uuid&&!Q.identifier.uuid?1:(0,I.compare)(j.identifier.id,Q.identifier.id)),M?(0,L.toFormattedString)(F,{}):JSON.stringify(F)}e.stringify=h;let y=class extends n.AbstractSynchroniser{constructor(M,j,Q,K,X,x,J,V,q,ie,re,ee,ae,G,W,_,N){super({syncResource:"extensions",profile:M},j,K,Q,X,x,J,ee,ae,ie,re,W),this.extensionManagementService=V,this.ignoredExtensionsManagementService=q,this.instantiationService=N,this.version=6,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localExtensionsProvider=this.instantiationService.createInstance(R),this._register(A.Event.any(A.Event.filter(this.extensionManagementService.onDidInstallExtensions,z=>z.some(({local:$})=>!!$)),A.Event.filter(this.extensionManagementService.onDidUninstallExtension,z=>!z.error),A.Event.filter(_.onDidChange,z=>z.valueChanges.some(({profile:$,changes:Z})=>this.syncResource.profile.id===$.id&&Z.some(B=>B.key===S.DISABLED_EXTENSIONS_STORAGE_PATH))),G.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(M,j){const Q=M.syncData?await C(M.syncData,this.extensionManagementService):null,K=j?.skippedExtensions??[],X=j?.builtinExtensions??null,x=j?.syncData?await C(j.syncData,this.extensionManagementService):null,{localExtensions:J,ignoredExtensions:V}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);Q?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:q,remote:ie}=(0,s.merge)(J,Q,x,K,V,X),re={local:q,remote:ie,content:this.getPreviewContent(J,q.added,q.updated,q.removed),localChange:q.added.length>0||q.removed.length>0||q.updated.length>0?2:0,remoteChange:ie!==null?2:0},ee=this.stringify(J,!1);return[{skippedExtensions:K,builtinExtensions:X,baseResource:this.baseResource,baseContent:x?this.stringify(x,!1):ee,localResource:this.localResource,localContent:ee,localExtensions:J,remoteResource:this.remoteResource,remoteExtensions:Q,remoteContent:Q?this.stringify(Q,!1):null,previewResource:this.previewResource,previewResult:re,localChange:re.localChange,remoteChange:re.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(M){const j=M.syncData?await C(M.syncData,this.extensionManagementService):null,{localExtensions:Q,ignoredExtensions:K}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile),{remote:X}=(0,s.merge)(Q,j,j,M.skippedExtensions||[],K,M.builtinExtensions||[]);return X!==null}getPreviewContent(M,j,Q,K){const X=[...j,...Q],x=new Set,J=V=>{x.add(V.id.toLowerCase()),V.uuid&&x.add(V.uuid)};X.forEach(({identifier:V})=>J(V)),K.forEach(J);for(const V of M)x.has(V.identifier.id.toLowerCase())||V.identifier.uuid&&x.has(V.identifier.uuid)||X.push(V);return this.stringify(X,!1)}async getMergeResult(M,j){return{...M.previewResult,hasConflicts:!1}}async getAcceptResult(M,j,Q,K){if(this.extUri.isEqual(j,this.localResource))return this.acceptLocal(M);if(this.extUri.isEqual(j,this.remoteResource))return this.acceptRemote(M);if(this.extUri.isEqual(j,this.previewResource))return M.previewResult;throw new Error(`Invalid Resource: ${j.toString()}`)}async acceptLocal(M){const j=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),Q=this.ignoredExtensionsManagementService.getIgnoredExtensions(j),K=(0,s.merge)(M.localExtensions,null,null,M.skippedExtensions,Q,M.builtinExtensions),{local:X,remote:x}=K;return{content:M.localContent,local:X,remote:x,localChange:X.added.length>0||X.removed.length>0||X.updated.length>0?2:0,remoteChange:x!==null?2:0}}async acceptRemote(M){const j=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),Q=this.ignoredExtensionsManagementService.getIgnoredExtensions(j),K=M.remoteContent?JSON.parse(M.remoteContent):null;if(K!==null){const X=(0,s.merge)(M.localExtensions,K,M.localExtensions,[],Q,M.builtinExtensions),{local:x,remote:J}=X;return{content:M.remoteContent,local:x,remote:J,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:J!==null?2:0}}else return{content:M.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(M,j,Q,K){let{skippedExtensions:X,builtinExtensions:x,localExtensions:J}=Q[0][0];const{local:V,remote:q,localChange:ie,remoteChange:re}=Q[0][1];if(ie===0&&re===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),ie!==0&&(await this.backupLocal(JSON.stringify(J)),X=await this.localExtensionsProvider.updateLocalExtensions(V.added,V.removed,V.updated,X,this.syncResource.profile)),q){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const ee=JSON.stringify(q.all);M=await this.updateRemoteUserData(ee,K?null:M.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${q.added.length?` Added: ${JSON.stringify(q.added.map(ae=>ae.identifier.id))}.`:""}${q.updated.length?` Updated: ${JSON.stringify(q.updated.map(ae=>ae.identifier.id))}.`:""}${q.removed.length?` Removed: ${JSON.stringify(q.removed.map(ae=>ae.identifier.id))}.`:""}`)}j?.ref!==M.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),x=this.computeBuiltinExtensions(J,x),await this.updateLastSyncUserData(M,{skippedExtensions:X,builtinExtensions:x}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${X.length?` Skipped: ${JSON.stringify(X.map(ee=>ee.identifier.id))}.`:""}`))}computeBuiltinExtensions(M,j){const Q=new Set,K=[];for(const X of M)Q.add(X.identifier.id.toLowerCase()),X.installed||K.push(X.identifier);if(j)for(const X of j)Q.has(X.id.toLowerCase())||K.push(X);return K}async resolveContent(M){if(this.extUri.isEqual(this.remoteResource,M)||this.extUri.isEqual(this.baseResource,M)||this.extUri.isEqual(this.localResource,M)||this.extUri.isEqual(this.acceptedResource,M)){const j=await this.resolvePreviewContent(M);return j&&this.stringify(JSON.parse(j),!0)}return null}stringify(M,j){return h(M,j)}async hasLocalData(){try{const{localExtensions:M}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);if(M.some(j=>j.installed||j.disabled))return!0}catch{}return!1}};e.ExtensionsSynchroniser=y,e.ExtensionsSynchroniser=y=ye([Y(2,P.IEnvironmentService),Y(3,v.IFileService),Y(4,c.IStorageService),Y(5,r.IUserDataSyncStoreService),Y(6,r.IUserDataSyncLocalStoreService),Y(7,S.IExtensionManagementService),Y(8,t.IIgnoredExtensionsManagementService),Y(9,r.IUserDataSyncLogService),Y(10,m.IConfigurationService),Y(11,r.IUserDataSyncEnablementService),Y(12,w.ITelemetryService),Y(13,g.IExtensionStorageService),Y(14,i.IUriIdentityService),Y(15,a.IUserDataProfileStorageService),Y(16,u.IInstantiationService)],y);let R=class{constructor(M,j,Q,K,X,x){this.extensionManagementService=M,this.userDataProfileStorageService=j,this.extensionGalleryService=Q,this.ignoredExtensionsManagementService=K,this.instantiationService=X,this.logService=x}async getLocalExtensions(M){const j=await this.extensionManagementService.getInstalled(void 0,M.extensionsResource),Q=this.ignoredExtensionsManagementService.getIgnoredExtensions(j);return{localExtensions:await this.withProfileScopedServices(M,async(X,x)=>{const J=X.getDisabledExtensions();return j.map(V=>{const{identifier:q,isBuiltin:ie,manifest:re,preRelease:ee,pinned:ae,isApplicationScoped:G}=V,W={identifier:q,preRelease:ee,version:re.version,pinned:!!ae};G&&!(0,p.isApplicationScopedExtension)(re)&&(W.isApplicationScoped=G),J.some(_=>(0,l.areSameExtensions)(_,q))&&(W.disabled=!0),ie||(W.installed=!0);try{const _=x.getKeysForSync({id:q.id,version:re.version});if(_){const N=x.getExtensionState(V,!0)||{};W.state=Object.keys(N).reduce((z,$)=>(_.includes($)&&(z[$]=N[$]),z),{})}}catch(_){this.logService.info(`${(0,n.getSyncResourceLogLabel)("extensions",M)}: Error while parsing extension state`,(0,T.getErrorMessage)(_))}return W})}),ignoredExtensions:Q}}async updateLocalExtensions(M,j,Q,K,X){const x=(0,n.getSyncResourceLogLabel)("extensions",X),J=[],V=new Map,q=[],ie=[],re=await this.extensionManagementService.getInstalled(void 0,X.extensionsResource);if((M.length||Q.length)&&await this.withProfileScopedServices(X,async(G,W)=>{await k.Promises.settled([...M,...Q].map(async _=>{const N=re.find(Z=>(0,l.areSameExtensions)(Z.identifier,_.identifier));if(N&&N.isBuiltin){_.state&&N.manifest.version===_.version&&this.updateExtensionState(_.state,N,N.manifest.version,W),G.getDisabledExtensions().some(B=>(0,l.areSameExtensions)(B,_.identifier))!==!!_.disabled&&(_.disabled?(this.logService.trace(`${x}: Disabling extension...`,_.identifier.id),await G.disableExtension(_.identifier),this.logService.info(`${x}: Disabled extension`,_.identifier.id)):(this.logService.trace(`${x}: Enabling extension...`,_.identifier.id),await G.enableExtension(_.identifier),this.logService.info(`${x}: Enabled extension`,_.identifier.id))),q.push(_.identifier);return}const z=_.pinned?_.version:void 0,$=(await this.extensionGalleryService.getExtensions([{..._.identifier,version:z,preRelease:z?void 0:_.preRelease}],O.CancellationToken.None))[0];if(_.state&&(N?N.manifest.version===_.version:$)&&this.updateExtensionState(_.state,N||$,N?.manifest.version,W),$)try{G.getDisabledExtensions().some(B=>(0,l.areSameExtensions)(B,_.identifier))!==!!_.disabled&&(_.disabled?(this.logService.trace(`${x}: Disabling extension...`,_.identifier.id,$.version),await G.disableExtension($.identifier),this.logService.info(`${x}: Disabled extension`,_.identifier.id,$.version)):(this.logService.trace(`${x}: Enabling extension...`,_.identifier.id,$.version),await G.enableExtension($.identifier),this.logService.info(`${x}: Enabled extension`,_.identifier.id,$.version))),(!N||N.preRelease!==_.preRelease||N.pinned!==_.pinned||z&&N.manifest.version!==z)&&(await this.extensionManagementService.canInstall($)?(J.push({extension:$,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:_.pinned&&!!_.version,installPreReleaseVersion:_.preRelease,profileLocation:X.extensionsResource,isApplicationScoped:_.isApplicationScoped,context:{[S.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[S.EXTENSION_INSTALL_SYNC_CONTEXT]:!0}}}),V.set($.identifier.id.toLowerCase(),_)):(this.logService.info(`${x}: Skipped synchronizing extension because it cannot be installed.`,$.displayName||$.identifier.id),ie.push(_)))}catch(Z){ie.push(_),this.logService.error(Z),this.logService.info(`${x}: Skipped synchronizing extension`,$.displayName||$.identifier.id)}else ie.push(_),this.logService.info(`${x}: Skipped synchronizing extension because the extension is not found.`,_.identifier.id)}))}),j.length){const G=re.filter(({identifier:W,isBuiltin:_})=>!_&&j.some(N=>(0,l.areSameExtensions)(W,N)));await k.Promises.settled(G.map(async W=>{this.logService.trace(`${x}: Uninstalling local extension...`,W.identifier.id),await this.extensionManagementService.uninstall(W,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:X.extensionsResource}),this.logService.info(`${x}: Uninstalled local extension.`,W.identifier.id),q.push(W.identifier)}))}const ee=await this.extensionManagementService.installGalleryExtensions(J);for(const{identifier:G,local:W,error:_,source:N}of ee){const z=N;if(W)this.logService.info(`${x}: Installed extension.`,G.id,z.version),q.push(G);else{const $=V.get(G.id.toLowerCase());$&&(ie.push($),this.logService.info(`${x}: Skipped synchronizing extension`,z.displayName||z.identifier.id)),_ instanceof S.ExtensionManagementError&&[S.ExtensionManagementErrorCode.Incompatible,S.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(_.code)?this.logService.info(`${x}: Skipped synchronizing extension because the compatible extension is not found.`,z.displayName||z.identifier.id):_&&this.logService.error(_)}}const ae=[];for(const G of K)q.some(W=>(0,l.areSameExtensions)(W,G.identifier))||ae.push(G);for(const G of ie)ae.some(W=>(0,l.areSameExtensions)(W.identifier,G.identifier))||ae.push(G);return ae}updateExtensionState(M,j,Q,K){const X=K.getExtensionState(j,!0)||{},x=Q?K.getKeysForSync({id:j.identifier.id,version:Q}):void 0;x?x.forEach(J=>{X[J]=M[J]}):Object.keys(M).forEach(J=>X[J]=M[J]),K.setExtensionState(j,X,!0)}async withProfileScopedServices(M,j){return this.userDataProfileStorageService.withProfileScopedStorageService(M,async Q=>{const K=new D.DisposableStore,X=this.instantiationService.createChild(new d.ServiceCollection([c.IStorageService,Q])),x=K.add(X.createInstance(b.GlobalExtensionEnablementService)),J=K.add(X.createInstance(g.ExtensionStorageService));try{return await j(x,J)}finally{K.dispose()}})}};e.LocalExtensionsProvider=R,e.LocalExtensionsProvider=R=ye([Y(0,S.IExtensionManagementService),Y(1,a.IUserDataProfileStorageService),Y(2,S.IExtensionGalleryService),Y(3,t.IIgnoredExtensionsManagementService),Y(4,u.IInstantiationService),Y(5,r.IUserDataSyncLogService)],R);let U=class extends n.AbstractInitializer{constructor(M,j,Q,K,X,x,J,V){super("extensions",K,X,x,Q,J,V),this.extensionManagementService=M,this.ignoredExtensionsManagementService=j}async parseExtensions(M){return M.syncData?await C(M.syncData,this.extensionManagementService):null}generatePreview(M,j){const Q=[],K=[],X=[];for(const x of M){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(x.identifier.id))continue;const J=j.find(V=>(0,l.areSameExtensions)(V.identifier,x.identifier));J?(Q.push(J),x.disabled&&X.push(x.identifier)):x.installed&&(K.push({...x.identifier,preRelease:!!x.preRelease}),x.disabled&&X.push(x.identifier))}return{installedExtensions:Q,newExtensions:K,disabledExtensions:X,remoteExtensions:M}}};e.AbstractExtensionsInitializer=U,e.AbstractExtensionsInitializer=U=ye([Y(0,S.IExtensionManagementService),Y(1,t.IIgnoredExtensionsManagementService),Y(2,v.IFileService),Y(3,o.IUserDataProfilesService),Y(4,P.IEnvironmentService),Y(5,f.ILogService),Y(6,c.IStorageService),Y(7,i.IUriIdentityService)],U)}),define(le[116],ue([0,1,14,7,3,34,42,5,32,21,15,11,8,43,19,22,28,39,80,239,25,18,60,4]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g,p,v,u,d,f,c,w,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const n="globalState.argv.",s=["locale"];function t(y,R){const U=y.storage?Object.keys(y.storage).sort():[],F={};return U.forEach(M=>F[M]=y.storage[M]),y.storage=F,R?(0,L.toFormattedString)(y,{}):JSON.stringify(y)}e.stringify=t;const r=1;let a=class extends u.AbstractSynchroniser{constructor(R,U,F,M,j,Q,K,X,x,J,V,q,ie,re){super({syncResource:"globalState",profile:R},U,M,X,q,j,Q,x,J,K,V,ie),this.userDataProfileStorageService=F,this.version=r,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localGlobalStateProvider=re.createInstance(C),this._register(M.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(T.Event.any(T.Event.filter(M.onDidFilesChange,ee=>ee.contains(this.environmentService.argvResource)),T.Event.filter(F.onDidChange,ee=>!!(ee.targetChanges.some(ae=>this.syncResource.profile.id===ae.id)||ee.valueChanges.some(({profile:ae,changes:G})=>this.syncResource.profile.id===ae.id&&G.some(W=>W.target===0)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(R,U,F){const M=R.syncData?JSON.parse(R.syncData.content):null;U=U===null&&F?R:U;const j=U&&U.syncData?JSON.parse(U.syncData.content):null,Q=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);M?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const K=await this.getStorageKeys(j),{local:X,remote:x}=(0,f.merge)(Q.storage,M?M.storage:null,j?j.storage:null,K,this.logService),J={content:null,local:X,remote:x,localChange:Object.keys(X.added).length>0||Object.keys(X.updated).length>0||X.removed.length>0?2:0,remoteChange:x.all!==null?2:0},V=t(Q,!1);return[{baseResource:this.baseResource,baseContent:j?t(j,!1):V,localResource:this.localResource,localContent:V,localUserData:Q,remoteResource:this.remoteResource,remoteContent:M?t(M,!1):null,previewResource:this.previewResource,previewResult:J,localChange:J.localChange,remoteChange:J.remoteChange,acceptedResource:this.acceptedResource,storageKeys:K}]}async hasRemoteChanged(R){const U=R.syncData?JSON.parse(R.syncData.content):null;if(U===null)return!0;const F=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile),M=await this.getStorageKeys(U),{remote:j}=(0,f.merge)(F.storage,U.storage,U.storage,M,this.logService);return j.all!==null}async getMergeResult(R,U){return{...R.previewResult,hasConflicts:!1}}async getAcceptResult(R,U,F,M){if(this.extUri.isEqual(U,this.localResource))return this.acceptLocal(R);if(this.extUri.isEqual(U,this.remoteResource))return this.acceptRemote(R);if(this.extUri.isEqual(U,this.previewResource))return R.previewResult;throw new Error(`Invalid Resource: ${U.toString()}`)}async acceptLocal(R){return{content:R.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(R.localUserData.storage),removed:[],updated:[],all:R.localUserData.storage},localChange:0,remoteChange:2}}async acceptRemote(R){if(R.remoteContent!==null){const U=JSON.parse(R.remoteContent),{local:F,remote:M}=(0,f.merge)(R.localUserData.storage,U.storage,null,R.storageKeys,this.logService);return{content:R.remoteContent,local:F,remote:M,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:M!==null?2:0}}else return{content:R.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async applyResult(R,U,F,M){const{localUserData:j}=F[0][0],{local:Q,remote:K,localChange:X,remoteChange:x}=F[0][1];if(X===0&&x===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),X!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(j)),await this.localGlobalStateProvider.writeLocalGlobalState(Q,this.syncResource.profile),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),x!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const J=JSON.stringify({storage:K.all});R=await this.updateRemoteUserData(J,M?null:R.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state.${K.added.length?` Added: ${K.added}.`:""}${K.updated.length?` Updated: ${K.updated}.`:""}${K.removed.length?` Removed: ${K.removed}.`:""}`)}U?.ref!==R.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(R),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async resolveContent(R){if(this.extUri.isEqual(this.remoteResource,R)||this.extUri.isEqual(this.baseResource,R)||this.extUri.isEqual(this.localResource,R)||this.extUri.isEqual(this.acceptedResource,R)){const U=await this.resolvePreviewContent(R);return U&&t(JSON.parse(U),!0)}return null}async hasLocalData(){try{const{storage:R}=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);if(Object.keys(R).length>1||R[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async getStorageKeys(R){const U=await this.userDataProfileStorageService.readStorageData(this.syncResource.profile),F=[],M=[];for(const[K,X]of U)X.target===0?F.push(K):X.target===1&&M.push(K);const j=[...F,...M],Q=R?.storage?Object.keys(R.storage).filter(K=>!K.startsWith(n)&&!j.includes(K)&&U.get(K)!==void 0):[];if(!D.isWeb){const K=[...c.ALL_SYNC_RESOURCES.map(X=>(0,c.getEnablementKey)(X)),c.SYNC_SERVICE_URL_TYPE];Q.push(...K),M.push(...K)}return{user:F,machine:M,unregistered:Q}}};e.GlobalStateSynchroniser=a,e.GlobalStateSynchroniser=a=ye([Y(2,i.IUserDataProfileStorageService),Y(3,b.IFileService),Y(4,c.IUserDataSyncStoreService),Y(5,c.IUserDataSyncLocalStoreService),Y(6,c.IUserDataSyncLogService),Y(7,P.IEnvironmentService),Y(8,c.IUserDataSyncEnablementService),Y(9,p.ITelemetryService),Y(10,m.IConfigurationService),Y(11,g.IStorageService),Y(12,v.IUriIdentityService),Y(13,o.IInstantiationService)],a);let C=class{constructor(R,U,F,M){this.fileService=R,this.environmentService=U,this.userDataProfileStorageService=F,this.logService=M}async getLocalGlobalState(R){const U={};if(R.isDefault){const M=await this.getLocalArgvContent(),j=(0,A.parse)(M);for(const Q of s)j[Q]!==void 0&&(U[`${n}${Q}`]={version:1,value:j[Q]})}const F=await this.userDataProfileStorageService.readStorageData(R);for(const[M,j]of F)j.value&&j.target===0&&(U[M]={version:1,value:j.value});return{storage:U}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const R=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),R.value.toString()}catch(R){this.logService.debug((0,O.getErrorMessage)(R))}return"{}"}async writeLocalGlobalState({added:R,removed:U,updated:F},M){const j=(0,u.getSyncResourceLogLabel)("globalState",M),Q={},K=new Map,X=await this.userDataProfileStorageService.readStorageData(M),x=(J,V)=>{for(const q of J){if(q.startsWith(n)){Q[q.substring(n.length)]=V?V[q].value:void 0;continue}if(V){const ie=V[q];ie.value!==X.get(q)?.value&&K.set(q,ie.value)}else X.get(q)!==void 0&&K.set(q,void 0)}};if(x(Object.keys(R),R),x(Object.keys(F),F),x(U),Object.keys(Q).length){this.logService.trace(`${j}: Updating locale...`);const J=await this.getLocalArgvContent();let V=J;for(const q of Object.keys(Q))V=(0,d.edit)(V,[q],Q[q],{});J!==V&&(this.logService.trace(`${j}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(V)),this.logService.info(`${j}: Updated locale.`)),this.logService.info(`${j}: Updated locale`)}K.size&&(this.logService.trace(`${j}: Updating global state...`),await this.userDataProfileStorageService.updateStorageData(M,K,0),this.logService.info(`${j}: Updated global state`,[...K.keys()]))}};e.LocalGlobalStateProvider=C,e.LocalGlobalStateProvider=C=ye([Y(0,b.IFileService),Y(1,P.IEnvironmentService),Y(2,i.IUserDataProfileStorageService),Y(3,c.IUserDataSyncLogService)],C);let E=class extends u.AbstractInitializer{constructor(R,U,F,M,j,Q){super("globalState",F,M,j,U,R,Q)}async doInitialize(R){const U=R.syncData?JSON.parse(R.syncData.content):null;if(!U){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const F={},M={};for(const j of Object.keys(U.storage))j.startsWith(n)?F[j.substring(n.length)]=U.storage[j].value:this.storageService.get(j,0)===void 0&&(M[j]=U.storage[j].value);if(Object.keys(F).length){let j="{}";try{j=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const Q of Object.keys(F))j=(0,d.edit)(j,[Q],F[Q],{});await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(j))}if(Object.keys(M).length){const j=[];for(const Q of Object.keys(M))j.push({key:Q,value:M[Q],scope:0,target:0});this.storageService.storeAll(j,!0)}}};e.GlobalStateInitializer=E,e.GlobalStateInitializer=E=ye([Y(0,g.IStorageService),Y(1,b.IFileService),Y(2,w.IUserDataProfilesService),Y(3,P.IEnvironmentService),Y(4,c.IUserDataSyncLogService),Y(5,v.IUriIdentityService)],E);let h=class{constructor(R,U,F,M,j){this.userDataSyncStoreClient=R,this.storageService=U,this.environmentService=F,this.fileService=M,this.logService=j}getSyncStoreType(R){return this.parseGlobalState(R)?.storage[c.SYNC_SERVICE_URL_TYPE]?.value}async sync(R){const U=(0,c.createSyncHeaders)((0,I.generateUuid)());try{return await this.doSync(R,U)}catch(F){if(F instanceof c.UserDataSyncError)switch(F.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(R,U)}throw F}}async doSync(R,U){const F=await this.userDataSyncStoreClient.readResource("globalState",null,void 0,U),M=this.parseGlobalState(F)||{storage:{}};M.storage[c.SYNC_SERVICE_URL_TYPE]={value:R,version:r};const j=await(0,l.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),Q={version:r,machineId:j,content:t(M,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify(Q),F.ref,void 0,U)}parseGlobalState({content:R}){if(!R)return null;const U=JSON.parse(R);if((0,u.isSyncData)(U))return U?JSON.parse(U.content):null;throw new Error("Invalid remote data")}};e.UserDataSyncStoreTypeSynchronizer=h,e.UserDataSyncStoreTypeSynchronizer=h=ye([Y(1,g.IStorageService),Y(2,P.IEnvironmentService),Y(3,b.IFileService),Y(4,S.ILogService)],h)}),define(le[117],ue([0,1,17,14,3,34,5,12,171,21,15,11,19,22,28,18,39,236,25]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g,p,v,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function f(i,o,n){try{const s=JSON.parse(i);if(!o)return(0,D.isUndefined)(s.all)?null:s.all;switch(L.OS){case 2:return(0,D.isUndefined)(s.mac)?null:s.mac;case 3:return(0,D.isUndefined)(s.linux)?null:s.linux;case 1:return(0,D.isUndefined)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}e.getKeybindingsContentFromSyncContent=f;let c=class extends v.AbstractJsonFileSynchroniser{constructor(o,n,s,t,r,a,C,E,h,y,R,U,F){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},n,E,h,y,s,t,C,U,r,R,a,F),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.filter(a.onDidChangeConfiguration,M=>M.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(o,n,s,t){const r=o.syncData?f(o.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;n=n===null&&s?o:n;const a=n?this.getKeybindingsContentFromLastSyncUserData(n):null,C=await this.getLocalFileContent(),E=await this.getFormattingOptions();let h=null,y=!1,R=!1,U=!1;if(r){let j=C?C.value.toString():"[]";if(j=j||"[]",this.hasErrors(j,!0))throw new d.UserDataSyncError((0,I.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==j||a!==r){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const Q=await(0,u.merge)(j,r,a,E,this.userDataSyncUtilService);Q.hasChanges&&(h=Q.mergeContent,U=Q.hasConflicts,y=U||Q.mergeContent!==j,R=U||Q.mergeContent!==r)}}else C&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),h=C.value.toString(),R=!0);const F={content:U?a:h,localChange:y?C?2:1:0,remoteChange:R?2:0,hasConflicts:U},M=C?C.value.toString():null;return[{fileContent:C,baseResource:this.baseResource,baseContent:a,localResource:this.localResource,localContent:M,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:r,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const n=this.getKeybindingsContentFromLastSyncUserData(o);if(n===null)return!0;const s=await this.getLocalFileContent(),t=s?s.value.toString():"",r=await this.getFormattingOptions(),a=await(0,u.merge)(t||"[]",n,n,r,this.userDataSyncUtilService);return a.hasConflicts||a.mergeContent!==n}async getMergeResult(o,n){return o.previewResult}async getAcceptResult(o,n,s,t){if(this.extUri.isEqual(n,this.localResource))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(n,this.remoteResource))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(n,this.previewResource))return s===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async applyResult(o,n,s,t){const{fileContent:r}=s[0][0];let{content:a,localChange:C,remoteChange:E}=s[0][1];if(C===0&&E===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a,!0)))throw new d.UserDataSyncError((0,I.localize)(1,null),"LocalInvalidContent",this.resource);if(C!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),r&&await this.backupLocal(this.toSyncContent(r.value.toString())),await this.updateLocalFileContent(a||"[]",r,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),E!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const h=this.toSyncContent(a||"[]",o.syncData?.content);o=await this.updateRemoteUserData(h,t?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}n?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(o,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const n=(0,A.parse)(o.value.toString());if((0,k.isNonEmptyArray)(n))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.baseResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o)?this.resolvePreviewContent(o):null}getKeybindingsContentFromLastSyncUserData(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.syncKeybindingsPerPlatform()?null:f(o.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(o,n){let s={};try{s=JSON.parse(n||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete s.all:s.all=o,L.OS){case 2:s.mac=o;break;case 3:s.linux=o;break;case 1:s.windows=o;break}return JSON.stringify(s)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue(d.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};e.KeybindingsSynchroniser=c,e.KeybindingsSynchroniser=c=ye([Y(2,d.IUserDataSyncStoreService),Y(3,d.IUserDataSyncLocalStoreService),Y(4,d.IUserDataSyncLogService),Y(5,m.IConfigurationService),Y(6,d.IUserDataSyncEnablementService),Y(7,b.IFileService),Y(8,P.IEnvironmentService),Y(9,S.IStorageService),Y(10,d.IUserDataSyncUtilService),Y(11,l.ITelemetryService),Y(12,g.IUriIdentityService)],c);let w=class extends v.AbstractInitializer{constructor(o,n,s,t,r,a){super("keybindings",n,s,t,o,r,a)}async doInitialize(o){const n=o.syncData?this.getKeybindingsContentFromSyncContent(o.syncData.content):null;if(!n){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,O.VSBuffer.fromString(n)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),n=(0,A.parse)(o.value.toString());return!(0,k.isNonEmptyArray)(n)}catch(o){return o.fileOperationResult===1}}getKeybindingsContentFromSyncContent(o){try{return f(o,!0,this.logService)}catch(n){return this.logService.error(n),null}}};e.KeybindingsInitializer=w,e.KeybindingsInitializer=w=ye([Y(0,b.IFileService),Y(1,p.IUserDataProfilesService),Y(2,P.IEnvironmentService),Y(3,d.IUserDataSyncLogService),Y(4,S.IStorageService),Y(5,g.IUriIdentityService)],w)}),define(le[118],ue([0,1,14,3,172,21,76,15,29,11,19,22,28,18,39,240,25]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function u(w){return w&&w.settings&&typeof w.settings=="string"&&Object.keys(w).length===1}function d(w){const i=JSON.parse(w);return u(i)?i:{settings:w}}e.parseSettingsSyncContent=d;let f=class extends g.AbstractJsonFileSynchroniser{constructor(i,o,n,s,t,r,a,C,E,h,y,R,U,F){super(i.settingsResource,{syncResource:"settings",profile:i},o,n,s,t,r,a,y,R,C,E,h,F),this.extensionManagementService=U,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(i){const o=await this.getLastSyncUserData(),n=await this.getLatestRemoteUserData(i,o),s=this.getSettingsSyncContent(n),t=new L.ConfigurationModelParser(v.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&t.parse(s.settings),t.configurationModel.getValue(v.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(i,o,n){const s=await this.getLocalFileContent(),t=await this.getFormattingOptions(),r=this.getSettingsSyncContent(i);o=o===null&&n?i:o;const a=o?this.getSettingsSyncContent(o):null,C=await this.getIgnoredSettings();let E=null,h=!1,y=!1,R=!1;if(r){let j=s?s.value.toString().trim():"{}";j=j||"{}",this.validateContent(j),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const Q=(0,p.merge)(j,r.settings,a?a.settings:null,C,[],t);E=Q.localContent||Q.remoteContent,h=Q.localContent!==null,y=Q.remoteContent!==null,R=Q.hasConflicts}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),E=s.value.toString().trim()||"{}",this.validateContent(E),y=!0);const U=s?s.value.toString():null,F=a?.settings??null,M={content:R?F:E,localChange:h?2:0,remoteChange:y?2:0,hasConflicts:R};return[{fileContent:s,baseResource:this.baseResource,baseContent:F,localResource:this.localResource,localContent:U,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(i){const o=this.getSettingsSyncContent(i);if(o===null)return!0;const n=await this.getLocalFileContent(),s=n?n.value.toString().trim():"",t=await this.getIgnoredSettings(),r=await this.getFormattingOptions();return(0,p.merge)(s||"{}",o.settings,o.settings,t,[],r).remoteContent!==null}async getMergeResult(i,o){const n=await this.getFormattingOptions(),s=await this.getIgnoredSettings();return{...i.previewResult,content:i.previewResult.content?(0,p.updateIgnoredSettings)(i.previewResult.content,"{}",s,n):null}}async getAcceptResult(i,o,n,s){const t=await this.getFormattingOptions(),r=await this.getIgnoredSettings();if(this.extUri.isEqual(o,this.localResource))return{content:i.fileContent?(0,p.updateIgnoredSettings)(i.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(o,this.remoteResource))return{content:i.remoteContent!==null?(0,p.updateIgnoredSettings)(i.remoteContent,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(o,this.previewResource))return n===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:n!==null?(0,p.updateIgnoredSettings)(n,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async applyResult(i,o,n,s){const{fileContent:t}=n[0][0];let{content:r,localChange:a,remoteChange:C}=n[0][1];if(a===0&&C===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.validateContent(r),a!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),t&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(t.value.toString()))),await this.updateLocalFileContent(r,t,s),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),C!==0){const E=await this.getFormattingOptions(),h=this.getSettingsSyncContent(i),y=await this.getIgnoredSettings(r);r=(0,p.updateIgnoredSettings)(r,h?h.settings:"{}",y,E),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),i=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(r)),s?null:i.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}o?.ref!==i.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(i),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const i=await this.getLocalFileContent();if(i)return!(0,p.isEmpty)(i.value.toString())}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async resolveContent(i){return this.extUri.isEqual(this.remoteResource,i)||this.extUri.isEqual(this.localResource,i)||this.extUri.isEqual(this.acceptedResource,i)||this.extUri.isEqual(this.baseResource,i)?this.resolvePreviewContent(i):null}async resolvePreviewContent(i){let o=await super.resolvePreviewContent(i);if(o){const n=await this.getFormattingOptions(),s=await this.getIgnoredSettings();o=(0,p.updateIgnoredSettings)(o,"{}",s,n)}return o}getSettingsSyncContent(i){return i.syncData?this.parseSettingsSyncContent(i.syncData.content):null}parseSettingsSyncContent(i){try{return d(i)}catch(o){this.logService.error(o)}return null}toSettingsSyncContent(i){return{settings:i}}async getIgnoredSettings(i){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=this._register(O.Event.any(O.Event.filter(this.extensionManagementService.onDidInstallExtensions,s=>s.some(({local:t})=>!!t)),O.Event.filter(this.extensionManagementService.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0}))}const o=await this._defaultIgnoredSettings;return(0,p.getIgnoredSettings)(o,this.configurationService,i)}validateContent(i){if(this.hasErrors(i,!1))throw new v.UserDataSyncError((0,T.localize)(0,null),"LocalInvalidContent",this.resource)}};e.SettingsSynchroniser=f,e.SettingsSynchroniser=f=ye([Y(2,m.IFileService),Y(3,D.IEnvironmentService),Y(4,P.IStorageService),Y(5,v.IUserDataSyncStoreService),Y(6,v.IUserDataSyncLocalStoreService),Y(7,v.IUserDataSyncLogService),Y(8,v.IUserDataSyncUtilService),Y(9,A.IConfigurationService),Y(10,v.IUserDataSyncEnablementService),Y(11,b.ITelemetryService),Y(12,I.IExtensionManagementService),Y(13,S.IUriIdentityService)],f);let c=class extends g.AbstractInitializer{constructor(i,o,n,s,t,r){super("settings",o,n,s,i,t,r)}async doInitialize(i){const o=i.syncData?this.parseSettingsSyncContent(i.syncData.content):null;if(!o){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,k.VSBuffer.fromString(o.settings)),await this.updateLastSyncUserData(i)}async isEmpty(){try{const i=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,p.isEmpty)(i.value.toString().trim())}catch(i){return i.fileOperationResult===1}}parseSettingsSyncContent(i){try{return d(i)}catch(o){this.logService.error(o)}return null}};e.SettingsInitializer=c,e.SettingsInitializer=c=ye([Y(0,m.IFileService),Y(1,l.IUserDataProfilesService),Y(2,D.IEnvironmentService),Y(3,v.IUserDataSyncLogService),Y(4,P.IStorageService),Y(5,S.IUriIdentityService)],c)}),define(le[119],ue([0,1,14,3,30,21,15,11,19,22,28,18,39,237,25]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function p(d){return JSON.parse(d.content)}e.parseSnippets=p;let v=class extends S.AbstractSynchroniser{constructor(f,c,w,i,o,n,s,t,r,a,C,E){super({syncResource:"snippets",profile:f},c,i,w,o,n,s,a,C,t,r,E),this.version=1,this.snippetsFolder=f.snippetsHome,this._register(this.fileService.watch(w.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(O.Event.filter(this.fileService.onDidFilesChange,h=>h.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(f,c,w){const i=await this.getSnippetsFileContents(),o=this.toSnippetsContents(i),n=f.syncData?this.parseSnippets(f.syncData):null;c=c===null&&w?f:c;const s=c&&c.syncData?this.parseSnippets(c.syncData):null;n?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,l.merge)(o,n,s);return this.getResourcePreviews(t,i,n||{},s||{})}async hasRemoteChanged(f){const c=f.syncData?this.parseSnippets(f.syncData):null;if(c===null)return!0;const w=await this.getSnippetsFileContents(),i=this.toSnippetsContents(w),o=(0,l.merge)(i,c,c);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async getMergeResult(f,c){return f.previewResult}async getAcceptResult(f,c,w,i){if(this.extUri.isEqualOrParent(c,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:0,remoteChange:f.fileContent?f.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(c,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:f.remoteContent,localChange:f.remoteContent!==null?f.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(c,this.syncPreviewFolder))return w===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:w,localChange:w===null?f.fileContent!==null?3:0:2,remoteChange:w===null?f.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async applyResult(f,c,w,i){const o=w.map(([n,s])=>({...n,acceptResult:s}));o.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:n})=>n!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,i)),o.some(({remoteChange:n})=>n!==0)&&(f=await this.updateRemoteSnippets(o,f,i)),c?.ref!==f.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(f),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:n}of o)try{await this.fileService.del(n)}catch{}}getResourcePreviews(f,c,w,i){const o=new Map;for(const n of Object.keys(f.local.added)){const s={content:f.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(f.local.updated)){const s={content:f.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of f.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(f.remote.added)){const s={content:f.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(f.remote.updated)){const s={content:f.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of f.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of f.conflicts){const s={content:i[n]??null,hasConflicts:!0,localChange:c[n]?2:1,remoteChange:w[n]?2:1},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[n]||null,localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(c))if(!o.has(n)){const s={content:c[n]?c[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[n]||null,localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...o.values()]}async resolveContent(f){return this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.resolvePreviewContent(f):null}async hasLocalData(){try{const f=await this.getSnippetsFileContents();if(Object.keys(f).length)return!0}catch{}return!1}async updateLocalBackup(f){const c={};for(const w of f)w.fileContent&&(c[this.extUri.basename(w.localResource)]=w.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(c)))}async updateLocalSnippets(f,c){for(const{fileContent:w,acceptResult:i,localResource:o,remoteResource:n,localChange:s}of f)if(s!==0){const t=n?this.extUri.basename(n):this.extUri.basename(o),r=this.extUri.joinPath(this.snippetsFolder,t);s===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(r)),await this.fileService.del(r),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(r))):s===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(r)),await this.fileService.createFile(r,k.VSBuffer.fromString(i.content),{overwrite:c}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(r))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(r)),await this.fileService.writeFile(r,k.VSBuffer.fromString(i.content),c?void 0:w),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(r)))}}async updateRemoteSnippets(f,c,w){const i=c.syncData?this.parseSnippets(c.syncData):{},o=(0,T.deepClone)(i);for(const{acceptResult:n,localResource:s,remoteResource:t,remoteChange:r}of f)if(r!==0){const a=s?this.extUri.basename(s):this.extUri.basename(t);r===3?delete o[a]:o[a]=n.content}return(0,l.areSame)(i,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),c=await this.updateRemoteUserData(JSON.stringify(o),w?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),c}parseSnippets(f){return p(f)}toSnippetsContents(f){const c={};for(const w of Object.keys(f))c[w]=f[w].value.toString();return c}async getSnippetsFileContents(){const f={};let c;try{c=await this.fileService.resolve(this.snippetsFolder)}catch(w){if(w instanceof D.FileOperationError&&w.fileOperationResult===1)return f;throw w}for(const w of c.children||[]){const i=w.resource,o=this.extUri.extname(i);if(o===".json"||o===".code-snippets"){const n=this.extUri.relativePath(this.snippetsFolder,i),s=await this.fileService.readFile(i);f[n]=s}}return f}};e.SnippetsSynchroniser=v,e.SnippetsSynchroniser=v=ye([Y(2,L.IEnvironmentService),Y(3,D.IFileService),Y(4,I.IStorageService),Y(5,g.IUserDataSyncStoreService),Y(6,g.IUserDataSyncLocalStoreService),Y(7,g.IUserDataSyncLogService),Y(8,A.IConfigurationService),Y(9,g.IUserDataSyncEnablementService),Y(10,m.ITelemetryService),Y(11,P.IUriIdentityService)],v);let u=class extends S.AbstractInitializer{constructor(f,c,w,i,o,n){super("snippets",c,w,i,f,o,n)}async doInitialize(f){const c=f.syncData?JSON.parse(f.syncData.content):null;if(!c){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const i of Object.keys(c)){const o=c[i];if(o){const n=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,i);await this.fileService.createFile(n,k.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(n))}}await this.updateLastSyncUserData(f)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(f){return f.fileOperationResult===1}}};e.SnippetsInitializer=u,e.SnippetsInitializer=u=ye([Y(0,D.IFileService),Y(1,b.IUserDataProfilesService),Y(2,L.IEnvironmentService),Y(3,g.IUserDataSyncLogService),Y(4,I.IStorageService),Y(5,P.IUriIdentityService)],u)}),define(le[120],ue([0,1,14,21,15,11,19,22,28,18,39,25]),function(se,e,k,O,T,A,L,D,I,m,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function S(v,u){try{return JSON.parse(v).tasks??null}catch(d){return u.error(d),null}}e.getTasksContentFromSyncContent=S;let l=class extends P.AbstractFileSynchroniser{constructor(u,d,f,c,w,i,o,n,s,t,r,a){super(u.tasksResource,{syncResource:"tasks",profile:u},d,n,s,t,f,c,o,r,w,i,a),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(u,d,f,c){const w=u.syncData?S(u.syncData.content,this.logService):null;d=d===null&&f?u:d;const i=d?.syncData?S(d.syncData.content,this.logService):null,o=await this.getLocalFileContent();let n=null,s=!1,t=!1,r=!1;if(u.syncData){const E=o?o.value.toString():null;if(!i||i!==E||i!==w){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const h=p(E,w,i);n=h.content,r=h.hasConflicts,s=h.hasLocalChanged,t=h.hasRemoteChanged}}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=o.value.toString(),t=!0);const a={content:r?i:n,localChange:s?o?2:1:0,remoteChange:t?2:0,hasConflicts:r},C=o?o.value.toString():null;return[{fileContent:o,baseResource:this.baseResource,baseContent:i,localResource:this.localResource,localContent:C,localChange:a.localChange,remoteResource:this.remoteResource,remoteContent:w,remoteChange:a.remoteChange,previewResource:this.previewResource,previewResult:a,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(u){const d=u?.syncData?S(u.syncData.content,this.logService):null;if(d===null)return!0;const f=await this.getLocalFileContent(),c=f?f.value.toString():null,w=p(c,d,d);return w.hasLocalChanged||w.hasRemoteChanged}async getMergeResult(u,d){return u.previewResult}async getAcceptResult(u,d,f,c){if(this.extUri.isEqual(d,this.localResource))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(d,this.remoteResource))return{content:u.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(d,this.previewResource))return f===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:f,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async applyResult(u,d,f,c){const{fileContent:w}=f[0][0],{content:i,localChange:o,remoteChange:n}=f[0][1];if(o===0&&n===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),o!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),w&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(w.value.toString()))),i?await this.updateLocalFileContent(i,w,c):await this.deleteLocalFile(),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),n!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const s=JSON.stringify(this.toTasksSyncContent(i));u=await this.updateRemoteUserData(s,c?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}d?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(u),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async resolveContent(u){return this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.baseResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u)?this.resolvePreviewContent(u):null}toTasksSyncContent(u){return u?{tasks:u}:{}}};e.TasksSynchroniser=l,e.TasksSynchroniser=l=ye([Y(2,b.IUserDataSyncStoreService),Y(3,b.IUserDataSyncLocalStoreService),Y(4,b.IUserDataSyncLogService),Y(5,O.IConfigurationService),Y(6,b.IUserDataSyncEnablementService),Y(7,A.IFileService),Y(8,T.IEnvironmentService),Y(9,L.IStorageService),Y(10,D.ITelemetryService),Y(11,I.IUriIdentityService)],l);let g=class extends P.AbstractInitializer{constructor(u,d,f,c,w,i){super("tasks",d,f,c,u,w,i),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(u){const d=u.syncData?S(u.syncData.content,this.logService):null;if(!d){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,k.VSBuffer.fromString(d)),await this.updateLastSyncUserData(u)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};e.TasksInitializer=g,e.TasksInitializer=g=ye([Y(0,A.IFileService),Y(1,m.IUserDataProfilesService),Y(2,T.IEnvironmentService),Y(3,b.IUserDataSyncLogService),Y(4,L.IStorageService),Y(5,I.IUriIdentityService)],g);function p(v,u,d){if(v===null&&u===null&&d===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(v===u)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const f=d!==v,c=d!==u;return!f&&!c?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:f&&!c?{content:v,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:c&&!f?{content:u,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:v,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(le[121],ue([0,1,42,21,15,11,19,22,28,18,39,238,25]),function(se,e,k,O,T,A,L,D,I,m,P,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let l=class extends P.AbstractSynchroniser{constructor(u,d,f,c,w,i,o,n,s,t,r,a,C){super({syncResource:"profiles",profile:u},d,c,w,i,o,n,r,a,s,t,C),this.userDataProfilesService=f,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(f.onDidChangeProfiles(()=>this.triggerLocalChange()))}async getLastSyncedProfiles(){const u=await this.getLastSyncUserData();return u?.syncData?p(u.syncData):null}async getRemoteSyncedProfiles(u){const d=await this.getLastSyncUserData(),f=await this.getLatestRemoteUserData(u,d);return f?.syncData?p(f.syncData):null}async generateSyncPreview(u,d,f){if(!this.userDataProfilesService.isEnabled())throw new S.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const c=u.syncData?p(u.syncData):null,w=d?.syncData?p(d.syncData):null,i=this.getLocalUserDataProfiles(),{local:o,remote:n}=(0,b.merge)(i,c,w,[]),s={local:o,remote:n,content:w?this.stringifyRemoteProfiles(w):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:n!==null?2:0},t=g(i,!1);return[{baseResource:this.baseResource,baseContent:w?this.stringifyRemoteProfiles(w):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:c?this.stringifyRemoteProfiles(c):null,remoteProfiles:c,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(u){const d=u?.syncData?p(u.syncData):null,f=this.getLocalUserDataProfiles(),{remote:c}=(0,b.merge)(f,d,d,[]);return!!c?.added.length||!!c?.removed.length||!!c?.updated.length}async getMergeResult(u,d){return{...u.previewResult,hasConflicts:!1}}async getAcceptResult(u,d,f,c){if(this.extUri.isEqual(d,this.localResource))return this.acceptLocal(u);if(this.extUri.isEqual(d,this.remoteResource))return this.acceptRemote(u);if(this.extUri.isEqual(d,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async acceptLocal(u){const d=this.getLocalUserDataProfiles(),f=(0,b.merge)(d,null,null,[]),{local:c,remote:w}=f;return{content:u.localContent,local:c,remote:w,localChange:c.added.length>0||c.removed.length>0||c.updated.length>0?2:0,remoteChange:w!==null?2:0}}async acceptRemote(u){const d=u.remoteContent?JSON.parse(u.remoteContent):null,f=[],c=[];for(const w of this.getLocalUserDataProfiles()){const i=d?.find(o=>o.id===w.id);i&&(f.push({id:w.id,name:w.name,collection:i.collection}),c.push(w))}if(d!==null){const w=(0,b.merge)(c,d,f,[]),{local:i,remote:o}=w;return{content:u.remoteContent,local:i,remote:o,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(u,d,f,c){const{local:w,remote:i,localChange:o,remoteChange:n}=f[0][1];o===0&&n===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`);const s=f[0][0].remoteProfiles||[];if(s.length+(i?.added.length??0)-(i?.removed.length??0)>20)throw new S.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.backupLocal(g(this.getLocalUserDataProfiles(),!1));const t=[];for(const r of w.added)t.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Creating '${r.name}' profile...`),await this.userDataProfilesService.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.logService.info(`${this.syncResourceLogLabel}: Created profile '${r.name}'.`)})());for(const r of w.removed)t.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Removing '${r.name}' profile...`),await this.userDataProfilesService.removeProfile(r),this.logService.info(`${this.syncResourceLogLabel}: Removed profile '${r.name}'.`)})());for(const r of w.updated){const a=this.userDataProfilesService.profiles.find(C=>C.id===r.id);a?t.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Updating '${r.name}' profile...`),await this.userDataProfilesService.updateProfile(a,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.logService.info(`${this.syncResourceLogLabel}: Updated profile '${r.name}'.`)})()):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);const t=[],r=s.length+(i?.added.length??0)<=20;if(r)for(const a of i?.added||[]){const C=await this.userDataSyncStoreService.createCollection(this.syncHeaders);t.push(C),s.push({id:a.id,name:a.name,collection:C,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.logService.info(`${this.syncResourceLogLabel}: Could not create remote profiles as there are too many profiles.`);for(const a of i?.removed||[])s.splice(s.findIndex(({id:C})=>a.id===C),1);for(const a of i?.updated||[]){const C=s.find(({id:E})=>a.id===E);C&&s.splice(s.indexOf(C),1,{...C,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{u=await this.updateRemoteProfiles(s,c?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${r&&i?.added.length?` Added: ${JSON.stringify(i.added.map(a=>a.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(a=>a.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(a=>a.name))}.`:""}`)}catch(a){if(t.length){this.logService.info(`${this.syncResourceLogLabel}: Failed to update remote profiles. Cleaning up added collections...`);for(const C of t)await this.userDataSyncStoreService.deleteCollection(C,this.syncHeaders)}throw a}for(const a of i?.removed||[])await this.userDataSyncStoreService.deleteCollection(a.collection,this.syncHeaders)}d?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(u),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async updateRemoteProfiles(u,d){return this.updateRemoteUserData(this.stringifyRemoteProfiles(u),d)}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async resolveContent(u){if(this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.baseResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u)){const d=await this.resolvePreviewContent(u);return d&&(0,k.toFormattedString)(JSON.parse(d),{})}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(u=>!u.isDefault&&!u.isTransient)}stringifyRemoteProfiles(u){return JSON.stringify([...u].sort((d,f)=>d.name.localeCompare(f.name)))}};e.UserDataProfilesManifestSynchroniser=l,e.UserDataProfilesManifestSynchroniser=l=ye([Y(2,m.IUserDataProfilesService),Y(3,A.IFileService),Y(4,T.IEnvironmentService),Y(5,L.IStorageService),Y(6,S.IUserDataSyncStoreService),Y(7,S.IUserDataSyncLocalStoreService),Y(8,S.IUserDataSyncLogService),Y(9,O.IConfigurationService),Y(10,S.IUserDataSyncEnablementService),Y(11,D.ITelemetryService),Y(12,I.IUriIdentityService)],l);function g(v,u){const d=[...v].sort((f,c)=>f.name.localeCompare(c.name)).map(f=>({id:f.id,name:f.name}));return u?(0,k.toFormattedString)(d,{}):JSON.stringify(d)}e.stringifyLocalProfiles=g;function p(v){return JSON.parse(v.content)}e.parseUserDataProfilesManifest=p}),define(le[255],ue([0,1,3,2,5,15,19,22,25]),function(se,e,k,O,T,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const m="sync.enable";let P=class extends O.Disposable{constructor(S,l,g,p){super(),this.storageService=S,this.telemetryService=l,this.environmentService=g,this.userDataSyncStoreManagementService=p,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new k.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(S.onDidChangeValue(-1,void 0,this._register(new O.DisposableStore))(v=>this.onDidStorageChange(v)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(m,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(S){S&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(m,{enabled:S}),this.storageService.store(m,S,-1,1))}isResourceEnabled(S){return this.storageService.getBoolean((0,I.getEnablementKey)(S),-1,!0)}setResourceEnablement(S,l){if(this.isResourceEnabled(S)!==l){const g=(0,I.getEnablementKey)(S);this.storeResourceEnablement(g,l)}}getResourceSyncStateVersion(S){}storeResourceEnablement(S,l){this.storageService.store(S,l,-1,T.isWeb?0:1)}onDidStorageChange(S){if(m===S.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const l=I.ALL_SYNC_RESOURCES.filter(g=>(0,I.getEnablementKey)(g)===S.key)[0];if(l){this._onDidChangeResourceEnablement.fire([l,this.isResourceEnabled(l)]);return}}};e.UserDataSyncEnablementService=P,e.UserDataSyncEnablementService=P=ye([Y(0,L.IStorageService),Y(1,D.ITelemetryService),Y(2,A.IEnvironmentService),Y(3,I.IUserDataSyncStoreManagementService)],P)}),define(le[256],ue([0,1,6,14,65,2,20,21,15,11,18,25]),function(se,e,k,O,T,A,L,D,I,m,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLocalStoreService=void 0;let S=class extends A.Disposable{constructor(g,p,v,u,d){super(),this.environmentService=g,this.fileService=p,this.configurationService=v,this.logService=u,this.userDataProfilesService=d,this.cleanUp()}async cleanUp(){for(const p of this.userDataProfilesService.profiles)for(const v of b.ALL_SYNC_RESOURCES)try{await this.cleanUpBackup(this.getResourceBackupHome(v,p.isDefault?void 0:p.id))}catch(u){this.logService.error(u)}let g;try{g=await this.fileService.resolve(this.environmentService.userDataSyncHome)}catch(p){(0,m.toFileOperationResult)(p)!==1&&this.logService.error(p);return}if(g.children){for(const p of g.children)if(p.isDirectory&&!this.userDataProfilesService.profiles.some(v=>v.id===p.name))try{this.logService.info("Deleting non existing profile from backup",p.resource.path),await this.fileService.del(p.resource,{recursive:!0})}catch(v){this.logService.error(v)}}}async getAllResourceRefs(g,p,v){const u=this.getResourceBackupHome(g,p,v);try{const d=await this.fileService.resolve(u);if(d.children)return d.children.filter(c=>c.isFile&&!c.name.startsWith("lastSync")).sort().reverse().map(c=>({ref:c.name,created:this.getCreationTime(c)}))}catch(d){if((0,m.toFileOperationResult)(d)!==1)throw d}return[]}async resolveResourceContent(g,p,v,u){const d=this.getResourceBackupHome(g,v,u),f=(0,L.joinPath)(d,p);try{return(await this.fileService.readFile(f)).value.toString()}catch(c){return this.logService.error(c),null}}async writeResource(g,p,v,u,d){const f=this.getResourceBackupHome(g,u,d),c=(0,L.joinPath)(f,`${(0,T.toLocalISOString)(v).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(c,O.VSBuffer.fromString(p))}catch(w){this.logService.error(w)}}getResourceBackupHome(g,p,v=this.environmentService.userDataSyncHome){return(0,L.joinPath)(v,...p?[p,g]:[g])}async cleanUpBackup(g){try{try{if(!await this.fileService.exists(g))return}catch{return}const p=await this.fileService.resolve(g);if(p.children){const v=p.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),u=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let d=v.filter(c=>Date.now()-this.getCreationTime(c)>u);const f=v.length-d.length;f<10&&(d=d.slice(10-f)),await k.Promises.settled(d.map(async c=>{this.logService.info("Deleting from backup",c.resource.path),await this.fileService.del(c.resource)}))}}catch(p){this.logService.error(p)}}getCreationTime(g){return new Date(parseInt(g.name.substring(0,4)),parseInt(g.name.substring(4,6))-1,parseInt(g.name.substring(6,8)),parseInt(g.name.substring(9,11)),parseInt(g.name.substring(11,13)),parseInt(g.name.substring(13,15))).getTime()}};e.UserDataSyncLocalStoreService=S,e.UserDataSyncLocalStoreService=S=ye([Y(0,I.IEnvironmentService),Y(1,m.IFileService),Y(2,D.IConfigurationService),Y(3,b.IUserDataSyncLogService),Y(4,P.IUserDataProfilesService)],S)}),define(le[84],ue([0,1,3,2,5,27,176,15,11,4,24,43,19,25]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,m.createDecorator)("IUserDataSyncMachinesService");const p="sync.currentMachineName",v="Safari",u="Chrome",d="Edge",f="Firefox",c="Android";function w(n){switch(n){case v:case u:case d:case f:case c:case(0,T.PlatformToString)(0):return!0}return!1}e.isWebPlatform=w;function i(){return T.isSafari?v:T.isChrome?u:T.isEdge?d:T.isFirefox?f:T.isAndroid?c:(0,T.PlatformToString)(T.isWeb?0:T.platform)}let o=class extends O.Disposable{static{g=this}static{this.VERSION=1}static{this.RESOURCE="machines"}constructor(s,t,r,a,C,E){super(),this.storageService=r,this.userDataSyncStoreService=a,this.logService=C,this.productService=E,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,b.getServiceMachineId)(s,t,r)}async getMachines(s){const t=await this.currentMachineIdPromise;return(await this.readMachinesData(s)).machines.map(a=>({...a,isCurrent:a.id===t}))}async addCurrentMachine(s){const t=await this.currentMachineIdPromise,r=await this.readMachinesData(s);r.machines.some(({id:a})=>a===t)||(r.machines.push({id:t,name:this.computeCurrentMachineName(r.machines),platform:i()}),await this.writeMachinesData(r))}async removeCurrentMachine(s){const t=await this.currentMachineIdPromise,r=await this.readMachinesData(s),a=r.machines.filter(({id:C})=>C!==t);a.length!==r.machines.length&&(r.machines=a,await this.writeMachinesData(r))}async renameMachine(s,t,r){const a=await this.readMachinesData(r),C=a.machines.find(({id:E})=>E===s);if(C){C.name=t,await this.writeMachinesData(a);const E=await this.currentMachineIdPromise;s===E&&this.storageService.store(p,t,-1,1)}}async setEnablements(s){const t=await this.readMachinesData();for(const[r,a]of s){const C=t.machines.find(E=>E.id===r);C&&(C.disabled=a?void 0:!0)}await this.writeMachinesData(t)}computeCurrentMachineName(s){const t=this.storageService.get(p,-1);if(t)return t;const r=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${i()} (${this.productService.nameShort})`,a=new RegExp(`${(0,A.escapeRegExpCharacters)(r)}\\s#(\\d+)`);let C=0;for(const E of s){const h=a.exec(E.name),y=h?parseInt(h[1]):0;C=y>C?y:C}return`${r} #${C+1}`}async readMachinesData(s){this.userData=await this.readUserData(s);const t=this.parse(this.userData);if(t.version!==g.VERSION)throw new Error((0,L.localize)(0,null,this.productService.nameLong));return t}async writeMachinesData(s){const t=JSON.stringify(s),r=await this.userDataSyncStoreService.writeResource(g.RESOURCE,t,this.userData?.ref||null);this.userData={ref:r,content:t},this._onDidChange.fire()}async readUserData(s){if(this.userData){const t=s&&s.latest?s.latest[g.RESOURCE]:void 0;if(this.userData.ref===t)return this.userData;if(t===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(g.RESOURCE,this.userData)}parse(s){if(s.content!==null)try{return JSON.parse(s.content)}catch(t){this.logService.error(t)}return{version:g.VERSION,machines:[]}}};e.UserDataSyncMachinesService=o,e.UserDataSyncMachinesService=o=g=ye([Y(0,D.IEnvironmentService),Y(1,I.IFileService),Y(2,S.IStorageService),Y(3,l.IUserDataSyncStoreService),Y(4,l.IUserDataSyncLogService),Y(5,P.IProductService)],o)}),define(le[257],ue([0,1,6,65,38,7,3,2,5,20,10,173,24,19,22,25,81,84]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g,p,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const d="sync.disableMachineEventually",f="sync.sessionId",c="sync.storeUrl",w="sync.productQuality";let i=class extends D.Disposable{get syncUrl(){const s=this.storageService.get(c,-1);return s?P.URI.parse(s):void 0}set syncUrl(s){s?this.storageService.store(c,s.toString(),-1,1):this.storageService.remove(c,-1)}get productQuality(){return this.storageService.get(w,-1)}set productQuality(s){s?this.storageService.store(w,s,-1,1):this.storageService.remove(w,-1)}constructor(s,t,r,a,C,E,h,y,R,U){super(),this.userDataSyncStoreManagementService=t,this.userDataSyncStoreService=r,this.userDataSyncEnablementService=a,this.userDataSyncService=C,this.logService=E,this.userDataSyncAccountService=h,this.telemetryService=y,this.userDataSyncMachinesService=R,this.storageService=U,this.autoSync=this._register(new D.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new L.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new k.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=t.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=s.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(t.onDidChangeUserDataSyncStore(()=>{(0,m.isEqual)(this.syncUrl,t.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=t.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(h.onDidChangeAccount(()=>this.updateAutoSync())),this._register(r.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(C.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this._register(L.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:s,message:t}=this.isAutoSyncEnabled();s?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.telemetryService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(r=>this.onDidFinishSync(r))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(t&&this.logService.info(t),this.autoSync.clear()):t&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(t))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,O.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(s,t,r){try{this.userDataSyncAccountService.account&&!r&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(f,-1),s?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(this.logService.error(a),t)this.updateEnablement(!1);else throw a}}updateEnablement(s){this.userDataSyncEnablementService.isEnabled()!==s&&(this.userDataSyncEnablementService.setEnablement(s),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(s){if(!s){this.successiveFailures=0;return}const t=p.UserDataSyncError.toUserDataSyncError(s);t instanceof p.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:t.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?I.isWeb&&t.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(t),this.successiveFailures++),this._onError.fire(t)}async disableMachineEventually(){this.storageService.store(d,!0,-1,1),await(0,k.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(d,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(d,-1)}async triggerSync(s,t,r){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(t&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...s),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources);const a=this.userDataSyncAccountService.account?.authenticationProviderId||"";this.telemetryService.publicLog2("sync/triggered",{sources:this.sources,providerId:a}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",r)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};e.UserDataAutoSyncService=i,e.UserDataAutoSyncService=i=ye([Y(0,S.IProductService),Y(1,p.IUserDataSyncStoreManagementService),Y(2,p.IUserDataSyncStoreService),Y(3,p.IUserDataSyncEnablementService),Y(4,p.IUserDataSyncService),Y(5,p.IUserDataSyncLogService),Y(6,v.IUserDataSyncAccountService),Y(7,g.ITelemetryService),Y(8,u.IUserDataSyncMachinesService),Y(9,l.IStorageService)],i);class o extends D.Disposable{static{this.INTERVAL_SYNCING="Interval"}constructor(s,t,r,a,C,E,h,y,R){super(),this.lastSyncUrl=s,this.interval=t,this.userDataSyncStoreManagementService=r,this.userDataSyncStoreService=a,this.userDataSyncService=C,this.userDataSyncMachinesService=E,this.logService=h,this.telemetryService=y,this.storageService=R,this.intervalHandler=this._register(new D.MutableDisposable),this._onDidStartSync=this._register(new L.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new L.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,D.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,k.disposableTimeout)(()=>{this.sync(o.INTERVAL_SYNCING,!1),this.intervalHandler.value=void 0},this.interval)}sync(s,t){const r=(0,k.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(C){if((0,A.isCancellationError)(C))return}return this.doSync(s,t,a)});return this.syncPromise=r,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,m.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const s=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),t=this.userDataSyncStoreManagementService.userDataSyncStore;return!!t&&!!s&&(!(0,m.isEqual)(t.defaultUrl,s.defaultUrl)||!(0,m.isEqual)(t.insidersUrl,s.insidersUrl)||!(0,m.isEqual)(t.stableUrl,s.stableUrl))}async doSync(s,t,r){this.logService.info(`Auto Sync: Triggered by ${s}`),this._onDidStartSync.fire();let a;try{await this.createAndRunSyncTask(t,r)}catch(C){if(this.logService.error(C),a=C,p.UserDataSyncError.toUserDataSyncError(C).code==="MethodNotFound")try{this.logService.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.userDataSyncService.cleanUpRemoteData(),this.logService.info("Auto Sync: Retrying sync..."),await this.createAndRunSyncTask(t,r),a=void 0}catch(E){this.logService.error(E),a=E}}this._onDidFinishSync.fire(a)}async createAndRunSyncTask(s,t){if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,s),t.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new p.UserDataAutoSyncError((0,b.localize)(0,null),"DefaultServiceChanged"):new p.UserDataAutoSyncError((0,b.localize)(1,null),"ServiceChanged"):new p.UserDataAutoSyncError((0,b.localize)(2,null),"TurnedOff");const r=this.storageService.get(f,-1);if(r&&this.manifest&&r!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new p.UserDataAutoSyncError((0,b.localize)(3,null),"DefaultServiceChanged"):new p.UserDataAutoSyncError((0,b.localize)(4,null),"ServiceChanged"):new p.UserDataAutoSyncError((0,b.localize)(5,null),"SessionExpired");const a=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(t.isCancellationRequested)return;const C=a.find(h=>h.isCurrent);if(C?.disabled)throw new p.UserDataAutoSyncError((0,b.localize)(6,null),"TurnedOff");const E=new Date().getTime();if(await this.syncTask.run(),this.telemetryService.publicLog2("settingsSync:sync",{duration:new Date().getTime()-E}),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(h){throw new p.UserDataAutoSyncError((0,T.toErrorMessage)(h),h instanceof p.UserDataSyncError?h.code:"Unknown")}this.manifest&&this.manifest.session!==r&&this.storageService.store(f,this.manifest.session,-1,1),!t.isCancellationRequested&&(C||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0))}register(s){return super._register(s)}}}),define(le[258],ue([0,1,10,177,15,11,43,19,28,25,18,39,119,118,117,21,120,115,116,4,121,42,27]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g,p,v,u,d,f,c,w,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=class{static{o=this}static{this.NOT_EXISTING_RESOURCE="not-existing-resource"}static{this.REMOTE_BACKUP_AUTHORITY="remote-backup"}static{this.LOCAL_BACKUP_AUTHORITY="local-backup"}constructor(t,r,a,C,E,h,y,R,U,F){this.userDataSyncStoreService=t,this.userDataSyncLocalStoreService=r,this.logService=a,this.environmentService=E,this.storageService=h,this.fileService=y,this.userDataProfilesService=R,this.configurationService=U,this.instantiationService=F,this.extUri=C.extUri}async getRemoteSyncedProfiles(){const t=await this.userDataSyncStoreService.readResource("profiles",null,void 0);if(t.content){const r=this.parseSyncData(t.content,"profiles");return(0,c.parseUserDataProfilesManifest)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.userDataSyncLocalStoreService.getAllResourceRefs("profiles",void 0,t);if(r.length){const a=await this.userDataSyncLocalStoreService.resolveResourceContent("profiles",r[0].ref,void 0,t);if(a){const C=this.parseSyncData(a,"profiles");return(0,c.parseUserDataProfilesManifest)(C)}}return[]}async getLocalSyncedMachines(t){const r=await this.userDataSyncLocalStoreService.getAllResourceRefs("machines",void 0,t);if(r.length){const a=await this.userDataSyncLocalStoreService.resolveResourceContent("machines",r[0].ref,void 0,t);if(a)return JSON.parse(a).machines.map(E=>({...E,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.userDataSyncStoreService.getAllResourceRefs(t,r?.collection)).map(({created:C,ref:E})=>({created:C,uri:this.toUri({remote:!0,syncResource:t,profile:r?.id??this.userDataProfilesService.defaultProfile.id,location:void 0,collection:r?.collection,ref:E,node:void 0})}))}async getLocalSyncResourceHandles(t,r,a){return(await this.userDataSyncLocalStoreService.getAllResourceRefs(t,r?.collection,a)).map(({created:E,ref:h})=>({created:E,uri:this.toUri({remote:!1,syncResource:t,profile:r?.id??this.userDataProfilesService.defaultProfile.id,collection:r?.collection,ref:h,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:t}){const r=this.resolveUri(t),a=r?this.userDataProfilesService.profiles.find(C=>C.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.resolveUri(t);if(!r)return[];const a=this.userDataProfilesService.profiles.find(C=>C.id===r.profile);switch(r.syncResource){case"settings":return this.getSettingsAssociatedResources(t,a);case"keybindings":return this.getKeybindingsAssociatedResources(t,a);case"tasks":return this.getTasksAssociatedResources(t,a);case"snippets":return this.getSnippetsAssociatedResources(t,a);case"globalState":return this.getGlobalStateAssociatedResources(t,a);case"extensions":return this.getExtensionsAssociatedResources(t,a);case"profiles":return this.getProfilesAssociatedResources(t,a);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.resolveUri(t);if(r){if(r.remote){if(r.ref){const{content:a}=await this.getUserData(r.syncResource,r.ref,r.collection);if(a)return this.parseSyncData(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.userDataSyncLocalStoreService.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.parseSyncData(a,r.syncResource)?.machineId}return}return(0,L.getServiceMachineId)(this.environmentService,this.fileService,this.storageService)}}async resolveContent(t){const r=this.resolveUri(t);if(!r||r.node===o.NOT_EXISTING_RESOURCE)return null;if(r.ref){const a=await this.getContentFromStore(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.resolveNodeContent(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.resolveLatestContent(r.syncResource,r.profile):null}async getContentFromStore(t,r,a,C,E){if(t){const{content:h}=await this.getUserData(r,C,a);return h}return this.userDataSyncLocalStoreService.resolveResourceContent(r,C,a,E)}resolveNodeContent(t,r,a){const C=this.parseSyncData(r,t);switch(t){case"settings":return this.resolveSettingsNodeContent(C,a);case"keybindings":return this.resolveKeybindingsNodeContent(C,a);case"tasks":return this.resolveTasksNodeContent(C,a);case"snippets":return this.resolveSnippetsNodeContent(C,a);case"globalState":return this.resolveGlobalStateNodeContent(C,a);case"extensions":return this.resolveExtensionsNodeContent(C,a);case"profiles":return this.resolveProfileNodeContent(C,a);case"workspaceState":return null}}async resolveLatestContent(t,r){const a=this.userDataProfilesService.profiles.find(C=>C.id===r);if(!a)return null;switch(t){case"globalState":return this.resolveLatestGlobalStateContent(a);case"extensions":return this.resolveLatestExtensionsContent(a);case"profiles":return this.resolveLatestProfilesContent(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}getSettingsAssociatedResources(t,r){const a=this.extUri.joinPath(t,"settings.json"),C=r?r.settingsResource:this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:C}]}resolveSettingsNodeContent(t,r){switch(r){case"settings.json":return(0,l.parseSettingsSyncContent)(t.content).settings}return null}getKeybindingsAssociatedResources(t,r){const a=this.extUri.joinPath(t,"keybindings.json"),C=r?r.keybindingsResource:this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:C}]}resolveKeybindingsNodeContent(t,r){switch(r){case"keybindings.json":return(0,g.getKeybindingsContentFromSyncContent)(t.content,!!this.configurationService.getValue(m.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.logService)}return null}getTasksAssociatedResources(t,r){const a=this.extUri.joinPath(t,"tasks.json"),C=r?r.tasksResource:this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:C}]}resolveTasksNodeContent(t,r){switch(r){case"tasks.json":return(0,v.getTasksContentFromSyncContent)(t.content,this.logService)}return null}async getSnippetsAssociatedResources(t,r){const a=await this.resolveContent(t);if(a){const C=this.parseSyncData(a,"snippets");if(C){const E=(0,S.parseSnippets)(C),h=[];for(const y of Object.keys(E)){const R=this.extUri.joinPath(t,y),U=r?this.extUri.joinPath(r.snippetsHome,y):this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);h.push({resource:R,comparableResource:U})}return h}}return[]}resolveSnippetsNodeContent(t,r){return(0,S.parseSnippets)(t)[r]||null}getExtensionsAssociatedResources(t,r){const a=this.extUri.joinPath(t,"extensions.json"),C=r?this.toUri({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:C}]}resolveExtensionsNodeContent(t,r){switch(r){case"extensions.json":return(0,u.stringify)((0,u.parseExtensions)(t),!0)}return null}async resolveLatestExtensionsContent(t){const{localExtensions:r}=await this.instantiationService.createInstance(u.LocalExtensionsProvider).getLocalExtensions(t);return(0,u.stringify)(r,!0)}getGlobalStateAssociatedResources(t,r){const a=this.extUri.joinPath(t,"globalState.json"),C=r?this.toUri({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:C}]}resolveGlobalStateNodeContent(t,r){switch(r){case"globalState.json":return(0,d.stringify)(JSON.parse(t.content),!0)}return null}async resolveLatestGlobalStateContent(t){const r=await this.instantiationService.createInstance(d.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,d.stringify)(r,!0)}getProfilesAssociatedResources(t,r){const a=this.extUri.joinPath(t,"profiles.json"),C=this.toUri({remote:!1,syncResource:"profiles",profile:this.userDataProfilesService.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:C}]}resolveProfileNodeContent(t,r){switch(r){case"profiles.json":return(0,w.toFormattedString)(JSON.parse(t.content),{})}return null}async resolveLatestProfilesContent(t){return(0,c.stringifyLocalProfiles)(this.userDataProfilesService.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}toUri(t){const r=t.remote?o.REMOTE_BACKUP_AUTHORITY:o.LOCAL_BACKUP_AUTHORITY,a=[];return t.location&&(a.push(`scheme:${t.location.scheme}`),a.push(`authority:${t.location.authority}`),a.push((0,i.trim)(t.location.path,"/"))),a.push(`syncResource:${t.syncResource}`),a.push(`profile:${t.profile}`),t.collection&&a.push(`collection:${t.collection}`),t.ref&&a.push(`ref:${t.ref}`),t.node&&a.push(t.node),this.extUri.joinPath(k.URI.from({scheme:m.USER_DATA_SYNC_SCHEME,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...a)}resolveUri(t){if(t.scheme!==m.USER_DATA_SYNC_SCHEME)return;const r=[];for(;t.path!=="/";)r.unshift(this.extUri.basename(t)),t=this.extUri.dirname(t);if(r.length<2)return;const a=t.authority===o.REMOTE_BACKUP_AUTHORITY;let C,E;const h=[];let y,R,U,F,M;for(;r.length;){const j=r.shift();j.startsWith("scheme:")?C=j.substring(7):j.startsWith("authority:")?E=j.substring(10):j.startsWith("syncResource:")?y=j.substring(13):j.startsWith("profile:")?R=j.substring(8):j.startsWith("collection:")?U=j.substring(11):j.startsWith("ref:")?F=j.substring(4):y?M=j:h.push(j)}return{remote:a,syncResource:y,profile:R,collection:U,ref:F,node:M,location:C&&E!==void 0?this.extUri.joinPath(k.URI.from({scheme:C,authority:E,query:t.query,fragment:t.fragment,path:"/"}),...h):void 0}}parseSyncData(t,r){try{const a=JSON.parse(t);if((0,b.isSyncData)(a))return a}catch(a){this.logService.error(a)}throw new m.UserDataSyncError((0,O.localize)(0,null),"IncompatibleRemoteContent",r)}async getUserData(t,r,a){const C=await this.userDataSyncStoreService.resolveResourceContent(t,r,a);return{ref:r,content:C}}};e.UserDataSyncResourceProviderService=n,e.UserDataSyncResourceProviderService=n=o=ye([Y(0,m.IUserDataSyncStoreService),Y(1,m.IUserDataSyncLocalStoreService),Y(2,m.IUserDataSyncLogService),Y(3,I.IUriIdentityService),Y(4,T.IEnvironmentService),Y(5,D.IStorageService),Y(6,A.IFileService),Y(7,P.IUserDataProfilesService),Y(8,p.IConfigurationService),Y(9,f.IInstantiationService)],n)}),define(le[259],ue([0,1,17,6,26,38,3,2,20,12,32,21,29,11,4,19,22,18,115,116,117,118,119,120,121,25]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g,p,v,u,d,f,c,w,i,o,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const t="sync.lastSyncTime";let r=class extends D.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(y,R,U,F,M,j,Q,K,X,x,J){super(),this.fileService=y,this.userDataSyncStoreService=R,this.userDataSyncStoreManagementService=U,this.instantiationService=F,this.logService=M,this.telemetryService=j,this.storageService=Q,this.userDataSyncEnablementService=K,this.userDataProfilesService=X,this.userDataSyncResourceProviderService=x,this.userDataSyncLocalStoreService=J,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new L.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new L.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=U.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(t,-1,void 0),this._register((0,D.toDisposable)(()=>this.clearActiveProfileSynchronizers()))}async createSyncTask(y,R){this.checkEnablement(),this.logService.info("Sync started.");const U=new Date().getTime(),F=(0,P.generateUuid)();try{const K=(0,s.createSyncHeaders)(F);R&&(K["Cache-Control"]="no-cache"),y=await this.userDataSyncStoreService.manifest(y,K)}catch(K){const X=s.UserDataSyncError.toUserDataSyncError(K);throw E(X,F,this.userDataSyncStoreManagementService,this.telemetryService),X}const M=!1,j=this;let Q;return{manifest:y,async run(){if(M)throw new Error("Can run a task only once");Q=(0,O.createCancelablePromise)(K=>j.sync(y,!1,F,K)),await Q.finally(()=>Q=void 0),j.logService.info(`Sync done. Took ${new Date().getTime()-U}ms`),j.updateLastSyncTime()},stop(){return Q?.cancel(),j.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new s.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.logService.info("Sync started.");const y=new Date().getTime(),R=(0,P.generateUuid)(),U=(0,s.createSyncHeaders)(R);let F;try{F=await this.userDataSyncStoreService.manifest(null,U)}catch(Q){const K=s.UserDataSyncError.toUserDataSyncError(Q);throw E(K,R,this.userDataSyncStoreManagementService,this.telemetryService),K}await this.resetLocal();const M=this,j=new T.CancellationTokenSource;return{id:R,async merge(){return M.sync(F,!0,R,j.token)},async apply(){try{try{await M.applyManualSync(F,R,j.token)}catch(Q){if(s.UserDataSyncError.toUserDataSyncError(Q).code==="MethodNotFound")M.logService.info("Client is making invalid requests. Cleaning up data..."),await M.cleanUpRemoteData(),M.logService.info("Applying manual sync again..."),await M.applyManualSync(F,R,j.token);else throw Q}}catch(Q){throw M.logService.error(Q),Q}M.logService.info(`Sync done. Took ${new Date().getTime()-y}ms`),M.updateLastSyncTime()},async stop(){j.cancel(),await M.stop(),await M.resetLocal()}}}async sync(y,R,U,F){this._syncErrors=[];try{this.status!=="hasConflicts"&&this.setStatus("syncing");const M=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile(M,y,R,U,F));const j=M.enabled.find(Q=>Q.resource==="profiles");if(j){const Q=await j.getLastSyncedProfiles()||[];if(F.isCancellationRequested)return;await this.syncRemoteProfiles(Q,y,R,U,F)}}finally{this.status!=="hasConflicts"&&this.setStatus("idle"),this._onSyncErrors.fire(this._syncErrors)}}async syncRemoteProfiles(y,R,U,F,M){for(const j of y){if(M.isCancellationRequested)return;const Q=this.userDataProfilesService.profiles.find(X=>X.id===j.id);if(!Q){this.logService.error(`Profile with id:${j.id} and name: ${j.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",j.name);const K=this.getOrCreateActiveProfileSynchronizer(Q,j);this._syncErrors.push(...await this.syncProfile(K,R,U,F,M))}for(const[j,Q]of this.activeProfileSynchronizers.entries())this.userDataProfilesService.profiles.some(K=>K.id===Q[0].profile.id)||(Q[1].dispose(),this.activeProfileSynchronizers.delete(j))}async applyManualSync(y,R,U){const F=this.getActiveProfileSynchronizers();for(const X of F){if(U.isCancellationRequested)return;await X.apply(R,U)}const M=F.find(X=>X.profile.isDefault);if(!M)return;const j=M.enabled.find(X=>X.resource==="profiles");if(!j)return;const K=(await j.getRemoteSyncedProfiles(y?.latest??null)||[]).filter(X=>F.every(x=>x.profile.id!==X.id));K.length&&await this.syncRemoteProfiles(K,y,!1,R,U)}async syncProfile(y,R,U,F,M){return(await y.sync(R,U,F,M)).map(([Q,K])=>({profile:y.profile,syncResource:Q,error:K}))}async stop(){this.status!=="idle"&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(y=>y.stop()))}async resolveContent(y){const R=await this.userDataSyncResourceProviderService.resolveContent(y);if(R)return R;for(const U of this.getActiveProfileSynchronizers())for(const F of U.enabled){const M=await F.resolveContent(y);if(M)return M}return null}async replace(y){this.checkEnablement();const R=this.userDataSyncResourceProviderService.resolveUserDataSyncResource(y);if(!R)return;const U=await this.resolveContent(y.uri);U&&await this.performAction(R.profile,async F=>{if(R.syncResource===F.resource)return await F.replace(U),!0})}async accept(y,R,U,F){this.checkEnablement(),await this.performAction(y.profile,async M=>{if(y.syncResource===M.resource)return await M.accept(R,U),F&&await M.apply((0,m.isBoolean)(F)?!1:F.force,(0,s.createSyncHeaders)((0,P.generateUuid)())),!0})}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async R=>{if(R.resource!=="globalState"&&await R.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async R=>{if(await R.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(y){this.logService.error(y)}this._onDidResetRemote.fire()}async resetLocal(){this.checkEnablement(),this._lastSyncTime=void 0,this.storageService.remove(t,-1);for(const[y]of this.activeProfileSynchronizers.values())try{await y.resetLocal()}catch(R){this.logService.error(R)}this.clearActiveProfileSynchronizers(),this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async cleanUpRemoteData(){const y=await this.userDataSyncResourceProviderService.getRemoteSyncedProfiles(),R=y.map(j=>j.collection),U=await this.userDataSyncStoreService.getAllCollections(),F=U.filter(j=>!R.includes(j));F.length&&(this.logService.info(`Deleting ${F.length} redundant collections on server`),await Promise.allSettled(F.map(j=>this.userDataSyncStoreService.deleteCollection(j))),this.logService.info("Deleted redundant collections on server"));const M=y.filter(j=>U.includes(j.collection));if(M.length!==y.length){const j=this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,this.userDataProfilesService.defaultProfile,void 0);try{this.logService.info("Resetting the last synced state of profiles"),await j.resetLocal(),this.logService.info("Did reset the last synced state of profiles"),this.logService.info("Updating remote profiles with invalid collections on server"),await j.updateRemoteProfiles(M,null),this.logService.info("Updated remote profiles on server")}finally{j.dispose()}}}async saveRemoteActivityData(y){this.checkEnablement();const R=await this.userDataSyncStoreService.getActivityData();await this.fileService.writeFile(y,R)}async extractActivityData(y,R){const U=(await this.fileService.readFile(y)).value.toString(),F=JSON.parse(U);if(F.resources)for(const M in F.resources)for(const j of F.resources[M])await this.userDataSyncLocalStoreService.writeResource(M,j.content,new Date(j.created*1e3),void 0,R);if(F.collections)for(const M in F.collections)for(const j in F.collections[M].resources)for(const Q of F.collections[M].resources?.[j]??[])await this.userDataSyncLocalStoreService.writeResource(j,Q.content,new Date(Q.created*1e3),M,R)}async performAction(y,R){const U=new D.DisposableStore;try{const F=this.activeProfileSynchronizers.get(y.id);if(F){const X=await this.performActionWithProfileSynchronizer(F[0],R,U);return(0,m.isUndefined)(X)?null:X}if(y.isDefault){const X=U.add(this.instantiationService.createInstance(a,y,void 0)),x=await this.performActionWithProfileSynchronizer(X,R,U);return(0,m.isUndefined)(x)?null:x}if(this.userDataProfilesService.isEnabled())return null;const M=U.add(this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,y,void 0)),j=await this.userDataSyncStoreService.manifest(null),K=(await M.getRemoteSyncedProfiles(j?.latest??null)||[]).find(X=>X.id===y.id);if(K){const X=U.add(this.instantiationService.createInstance(a,y,K.collection)),x=await this.performActionWithProfileSynchronizer(X,R,U);return(0,m.isUndefined)(x)?null:x}return null}finally{U.dispose()}}async performActionWithProfileSynchronizer(y,R,U){const F=[...y.enabled,...y.disabled.reduce((M,j)=>(j!=="workspaceState"&&M.push(U.add(y.createSynchronizer(j))),M),[])];for(const M of F){const j=await R(M);if(!(0,m.isUndefined)(j))return j}}setStatus(y){const R=this._status;this._status!==y&&(this._status=y,this._onDidChangeStatus.fire(y),R==="hasConflicts"&&this.updateLastSyncTime())}updateConflicts(){const y=this.getActiveProfileSynchronizers().map(R=>R.conflicts).flat();(0,k.equals)(this._conflicts,y,(R,U)=>R.profile.id===U.profile.id&&R.syncResource===U.syncResource&&(0,k.equals)(R.conflicts,U.conflicts,(F,M)=>(0,I.isEqual)(F.previewResource,M.previewResource)))||(this._conflicts=y,this._onDidChangeConflicts.fire(y))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(t,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(y,R){let U=this.activeProfileSynchronizers.get(y.id);if(U&&U[0].collection!==R?.collection&&(this.logService.error("Profile synchronizer collection does not match with the remote sync profile collection"),U[1].dispose(),U=void 0,this.activeProfileSynchronizers.delete(y.id)),!U){const F=new D.DisposableStore,M=F.add(this.instantiationService.createInstance(a,y,R?.collection));F.add(M.onDidChangeStatus(j=>this.setStatus(j))),F.add(M.onDidChangeConflicts(j=>this.updateConflicts())),F.add(M.onDidChangeLocal(j=>this._onDidChangeLocal.fire(j))),this.activeProfileSynchronizers.set(y.id,U=[M,F])}return U[0]}getActiveProfileSynchronizers(){const y=[];for(const[R]of this.activeProfileSynchronizers.values())y.push(R);return y}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,y])=>y.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};e.UserDataSyncService=r,e.UserDataSyncService=r=ye([Y(0,l.IFileService),Y(1,s.IUserDataSyncStoreService),Y(2,s.IUserDataSyncStoreManagementService),Y(3,g.IInstantiationService),Y(4,s.IUserDataSyncLogService),Y(5,v.ITelemetryService),Y(6,p.IStorageService),Y(7,s.IUserDataSyncEnablementService),Y(8,u.IUserDataProfilesService),Y(9,s.IUserDataSyncResourceProviderService),Y(10,s.IUserDataSyncLocalStoreService)],r);let a=class extends D.Disposable{get enabled(){return this._enabled.sort((y,R)=>y[1]-R[1]).map(([y])=>y)}get disabled(){return s.ALL_SYNC_RESOURCES.filter(y=>!this.userDataSyncEnablementService.isResourceEnabled(y))}get status(){return this._status}get conflicts(){return this._conflicts}constructor(y,R,U,F,M,j,Q,K,X,x){super(),this.profile=y,this.collection=R,this.userDataSyncEnablementService=U,this.instantiationService=F,this.extensionGalleryService=M,this.userDataSyncStoreManagementService=j,this.telemetryService=Q,this.logService=K,this.userDataProfilesService=X,this.configurationService=x,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._register(U.onDidChangeResourceEnablement(([J,V])=>this.onDidChangeResourceEnablement(J,V))),this._register((0,D.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,J])=>J.dispose())));for(const J of s.ALL_SYNC_RESOURCES)U.isResourceEnabled(J)&&this.registerSynchronizer(J)}onDidChangeResourceEnablement(y,R){R?this.registerSynchronizer(y):this.deRegisterSynchronizer(y)}registerSynchronizer(y){if(this._enabled.some(([M])=>M.resource===y))return;if(y==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(y==="profiles"&&(!this.profile.isDefault||!this.userDataProfilesService.isEnabled())||y==="workspaceState")return;if(y!=="profiles"&&this.profile.useDefaultFlags?.[y]){this.logService.debug(`Skipping syncing ${y} in ${this.profile.name} because it is already synced by default profile`);return}const R=new D.DisposableStore,U=R.add(this.createSynchronizer(y));R.add(U.onDidChangeStatus(()=>this.updateStatus())),R.add(U.onDidChangeConflicts(()=>this.updateConflicts())),R.add(U.onDidChangeLocal(()=>this._onDidChangeLocal.fire(y)));const F=this.getOrder(y);this._enabled.push([U,F,R])}deRegisterSynchronizer(y){const R=this._enabled.findIndex(([U])=>U.resource===y);if(R!==-1){const[[U,,F]]=this._enabled.splice(R,1);F.dispose(),this.updateStatus(),Promise.allSettled([U.stop(),U.resetLocal()]).then(null,M=>this.logService.error(M))}}createSynchronizer(y){switch(y){case"settings":return this.instantiationService.createInstance(w.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.instantiationService.createInstance(c.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.instantiationService.createInstance(i.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.instantiationService.createInstance(o.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.instantiationService.createInstance(f.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.instantiationService.createInstance(d.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(y,R,U,F){if(F.isCancellationRequested)return[];const M=this.enabled;if(!M.length)return[];try{const j=[],Q=(0,s.createSyncHeaders)(U),K=(this.collection?y?.collections?.[this.collection]?.latest:y?.latest)??null,X=R?await this.getUserDataSyncConfiguration(K):{};for(const x of M){if(F.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(x.resource))return[];try{if(R){const J=await x.preview(K,X,Q);if(J)for(const V of J.resourcePreviews)(V.localChange!==0||V.remoteChange!==0)&&V.mergeState==="preview"&&await x.merge(V.previewResource)}else await x.sync(K,Q)}catch(J){const V=s.UserDataSyncError.toUserDataSyncError(J);if(E(V,U,this.userDataSyncStoreManagementService,this.telemetryService),C(J))throw V;this.logService.error(J),this.logService.error(`${x.resource}: ${(0,A.toErrorMessage)(J)}`),j.push([x.resource,V])}}return j}finally{this.updateStatus()}}async apply(y,R){const U=(0,s.createSyncHeaders)(y);for(const F of this.enabled){if(R.isCancellationRequested)return;try{await F.apply(!1,U)}catch(M){const j=s.UserDataSyncError.toUserDataSyncError(M);if(E(j,y,this.userDataSyncStoreManagementService,this.telemetryService),C(M))throw j;this.logService.error(M),this.logService.error(`${F.resource}: ${(0,A.toErrorMessage)(M)}`)}}}async stop(){for(const y of this.enabled)try{y.status!=="idle"&&await y.stop()}catch(R){this.logService.error(R)}}async resetLocal(){for(const y of this.enabled)try{await y.resetLocal()}catch(R){this.logService.error(`${y.resource}: ${(0,A.toErrorMessage)(R)}`),this.logService.error(R)}}async getUserDataSyncConfiguration(y){if(!this.profile.isDefault)return{};const R=this.configurationService.getValue(s.USER_DATA_SYNC_CONFIGURATION_SCOPE),U=this.enabled.find(F=>F instanceof w.SettingsSynchroniser);if(U){const F=await U.getRemoteUserDataSyncConfiguration(y);return{...R,...F}}return R}setStatus(y){this._status!==y&&(this._status=y,this._onDidChangeStatus.fire(y))}updateStatus(){return this.updateConflicts(),this.enabled.some(y=>y.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(y=>y.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const y=this.enabled.filter(R=>R.status==="hasConflicts").filter(R=>R.conflicts.conflicts.length>0).map(R=>R.conflicts);(0,k.equals)(this._conflicts,y,(R,U)=>R.syncResource===U.syncResource&&(0,k.equals)(R.conflicts,U.conflicts,(F,M)=>(0,I.isEqual)(F.previewResource,M.previewResource)))||(this._conflicts=y,this._onDidChangeConflicts.fire(y))}getOrder(y){switch(y){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=ye([Y(2,s.IUserDataSyncEnablementService),Y(3,g.IInstantiationService),Y(4,S.IExtensionGalleryService),Y(5,s.IUserDataSyncStoreManagementService),Y(6,v.ITelemetryService),Y(7,s.IUserDataSyncLogService),Y(8,u.IUserDataProfilesService),Y(9,b.IConfigurationService)],a);function C(h){if(h instanceof s.UserDataSyncError)switch(h.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function E(h,y,R,U){U.publicLog2("sync/error",{code:h.code,serverCode:h instanceof s.UserDataSyncStoreError?String(h.serverCode):void 0,url:h instanceof s.UserDataSyncStoreError?h.url:void 0,resource:h.resource,executionId:y,service:R.userDataSyncStore.url.toString()})}}),define(le[260],ue([0,1,3,2,10,18,25]),function(se,e,k,O,T,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncServiceChannelClient=e.UserDataSyncServiceChannel=void 0;function D(S,l){return{...S,profile:(0,A.reviveProfile)(S.profile,l.profilesHome.scheme)}}function I(S){return{created:S.created,uri:T.URI.revive(S.uri)}}class m{constructor(l,g,p){this.service=l,this.userDataProfilesService=g,this.logService=p,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new k.Emitter}listen(l,g){switch(g){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${g}`)}async call(l,g,p){try{return await this._call(l,g,p)}catch(v){throw this.logService.error(v),v}}async _call(l,g,p){switch(g){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(T.URI.revive(p[0]));case"accept":return this.service.accept(D(p[0],this.userDataProfilesService),T.URI.revive(p[1]),p[2],p[3]);case"replace":return this.service.replace(I(p[0]));case"cleanUpRemoteData":return this.service.cleanUpRemoteData();case"getRemoteActivityData":return this.service.saveRemoteActivityData(T.URI.revive(p[0]));case"extractActivityData":return this.service.extractActivityData(T.URI.revive(p[0]),T.URI.revive(p[1]));case"createManualSyncTask":return this.createManualSyncTask()}if(g.startsWith("manualSync/")){const v=g.substring(11),u=p[0],d=this.getManualSyncTask(u);switch(p=p.slice(1),v){case"merge":return d.merge();case"apply":return d.apply().then(()=>this.manualSyncTasks.delete(this.createKey(d.id)));case"stop":return d.stop().finally(()=>this.manualSyncTasks.delete(this.createKey(d.id)))}}throw new Error("Invalid call")}getManualSyncTask(l){const g=this.manualSyncTasks.get(this.createKey(l));if(!g)throw new Error(`Manual sync taks not found: ${l}`);return g}async createManualSyncTask(){const l=await this.service.createManualSyncTask();return this.manualSyncTasks.set(this.createKey(l.id),l),l.id}createKey(l){return`manualSyncTask-${l}`}}e.UserDataSyncServiceChannel=m;let P=class extends O.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(l,g){super(),this.userDataProfilesService=g,this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(p,v,u){return l.call(p,v,u).then(null,d=>{throw L.UserDataSyncError.toUserDataSyncError(d)})},listen(p,v){return l.listen(p,v)}},this.channel.call("_getInitialData").then(([p,v,u])=>{this.updateStatus(p),this.updateConflicts(v),u&&this.updateLastSyncTime(u),this._register(this.channel.listen("onDidChangeStatus")(d=>this.updateStatus(d))),this._register(this.channel.listen("onDidChangeLastSyncTime")(d=>this.updateLastSyncTime(d)))}),this._register(this.channel.listen("onDidChangeConflicts")(p=>this.updateConflicts(p))),this._register(this.channel.listen("onSyncErrors")(p=>this._onSyncErrors.fire(p.map(v=>({...v,error:L.UserDataSyncError.toUserDataSyncError(v.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const l=await this.channel.call("createManualSyncTask"),g=this;return new b(l,{async call(v,u,d){return g.channel.call(`manualSync/${v}`,[l,...Array.isArray(u)?u:[u]],d)},listen(){throw new Error("not supported")}})}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(l,g,p,v){return this.channel.call("accept",[l,g,p,v])}resolveContent(l){return this.channel.call("resolveContent",[l])}cleanUpRemoteData(){return this.channel.call("cleanUpRemoteData")}replace(l){return this.channel.call("replace",[l])}saveRemoteActivityData(l){return this.channel.call("getRemoteActivityData",[l])}extractActivityData(l,g){return this.channel.call("extractActivityData",[l,g])}async updateStatus(l){this._status=l,this._onDidChangeStatus.fire(l)}async updateConflicts(l){this._conflicts=l.map(g=>({syncResource:g.syncResource,profile:(0,A.reviveProfile)(g.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:g.conflicts.map(p=>({...p,baseResource:T.URI.revive(p.baseResource),localResource:T.URI.revive(p.localResource),remoteResource:T.URI.revive(p.remoteResource),previewResource:T.URI.revive(p.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(l){this._lastSyncTime!==l&&(this._lastSyncTime=l,this._onDidChangeLastSyncTime.fire(l))}};e.UserDataSyncServiceChannelClient=P,e.UserDataSyncServiceChannelClient=P=ye([Y(1,A.IUserDataProfilesService)],P);class b extends O.Disposable{constructor(l,g){super(),this.id=l,this.channel=g}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose"),super.dispose()}}}),define(le[122],ue([0,1,6,26,7,3,2,140,5,20,12,10,32,21,15,11,24,59,43,19,25]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g,p,v,u,d,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const w="configurationSync.store",i="sync.previous.store",o="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",t=100,r=1e3*60*5;let a=class extends L.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(c.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(U){this.storageService.store(c.SYNC_SERVICE_URL_TYPE,U,-1,I.isWeb?0:1)}constructor(U,F,M){super(),this.productService=U,this.configurationService=F,this.storageService=M,this._onDidChangeUserDataSyncStore=this._register(new A.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore();const j=this._register(new L.DisposableStore);this._register(A.Event.filter(M.onDidChangeValue(-1,c.SYNC_SERVICE_URL_TYPE,j),()=>this.userDataSyncStoreType!==this.userDataSyncStore?.type,j)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[w]),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(U){if(U&&(U=I.isWeb&&U.web?{...U,...U.web}:U,(0,P.isString)(U.url)&&(0,P.isObject)(U.authenticationProviders)&&Object.keys(U.authenticationProviders).every(F=>Array.isArray(U.authenticationProviders[F].scopes)))){const F=U,M=!!F.canSwitch,j=F.url===F.insidersUrl?"insiders":"stable",Q=(M?this.userDataSyncStoreType:void 0)||j,K=Q==="insiders"?F.insidersUrl:Q==="stable"?F.stableUrl:F.url;return{url:b.URI.parse(K),type:Q,defaultType:j,defaultUrl:b.URI.parse(F.url),stableUrl:b.URI.parse(F.stableUrl),insidersUrl:b.URI.parse(F.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(F.authenticationProviders).reduce((X,x)=>(X.push({id:x,scopes:F.authenticationProviders[x].scopes}),X),[])}}}};e.AbstractUserDataSyncStoreManagementService=a,e.AbstractUserDataSyncStoreManagementService=a=ye([Y(0,v.IProductService),Y(1,l.IConfigurationService),Y(2,f.IStorageService)],a);let C=class extends a{constructor(U,F,M){super(U,F,M);const j=this.storageService.get(i,-1);j&&(this.previousConfigurationSyncStore=JSON.parse(j));const Q=this.productService[w];Q?this.storageService.store(i,JSON.stringify(Q),-1,1):this.storageService.remove(i,-1)}async switch(U){U!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=U,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};e.UserDataSyncStoreManagementService=C,e.UserDataSyncStoreManagementService=C=ye([Y(0,v.IProductService),Y(1,l.IConfigurationService),Y(2,f.IStorageService)],C);let E=class extends L.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(U,F,M,j,Q,K,X){super(),this.requestService=M,this.logService=j,this.storageService=X,this._onTokenFailed=this._register(new A.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new A.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new A.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(U),this.commonHeadersPromise=(0,d.getServiceMachineId)(Q,K,X).then(x=>{const J={"X-Client-Name":`${F.applicationName}${I.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(J["X-Client-Commit"]=F.commit),J}),this.session=new y(t,r,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,L.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(U,F){this.authToken={token:U,type:F}}updateUserDataSyncStoreUrl(U){this.userDataSyncStoreUrl=U?(0,m.joinPath)(U,"v1"):void 0}initDonotMakeRequestsUntil(){const U=this.storageService.getNumber(o,-1);U&&Date.now()<U&&this.setDonotMakeRequestsUntil(new Date(U))}setDonotMakeRequestsUntil(U){this._donotMakeRequestsUntil?.getTime()!==U?.getTime()&&(this._donotMakeRequestsUntil=U,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(o,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,k.createCancelablePromise)(F=>(0,k.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),F).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,F=>null)):this.storageService.remove(o,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,m.joinPath)(this.userDataSyncStoreUrl,"collection").toString();U={...U},U["Content-Type"]="application/json";const M=await this.request(F,{type:"GET",headers:U},[],O.CancellationToken.None);return(await(0,u.asJson)(M))?.map(({id:j})=>j)||[]}async createCollection(U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,m.joinPath)(this.userDataSyncStoreUrl,"collection").toString();U={...U},U["Content-Type"]=D.Mimes.text;const M=await this.request(F,{type:"POST",headers:U},[],O.CancellationToken.None),j=await(0,u.asTextOrError)(M);if(!j)throw new c.UserDataSyncStoreError("Server did not return the collection id",F,"NoCollection",M.res.statusCode,M.res.headers[c.HEADER_OPERATION_ID]);return j}async deleteCollection(U,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=U?(0,m.joinPath)(this.userDataSyncStoreUrl,"collection",U).toString():(0,m.joinPath)(this.userDataSyncStoreUrl,"collection").toString();F={...F},await this.request(M,{type:"DELETE",headers:F},[],O.CancellationToken.None)}async getAllResourceRefs(U,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=this.getResourceUrl(this.userDataSyncStoreUrl,F,U),j={},Q=await this.request(M.toString(),{type:"GET",headers:j},[],O.CancellationToken.None);return(await(0,u.asJson)(Q)||[]).map(({url:X,created:x})=>({ref:(0,m.relativePath)(M,M.with({path:X})),created:x*1e3}))}async resolveResourceContent(U,F,M,j={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const Q=(0,m.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,M,U),F).toString();j={...j},j["Cache-Control"]="no-cache";const K=await this.request(Q,{type:"GET",headers:j},[],O.CancellationToken.None);return await(0,u.asTextOrError)(K)}async deleteResource(U,F,M){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const j=F!==null?(0,m.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,M,U),F).toString():this.getResourceUrl(this.userDataSyncStoreUrl,M,U).toString(),Q={};await this.request(j,{type:"DELETE",headers:Q},[],O.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,m.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),F={"Content-Type":D.Mimes.text};await this.request(U,{type:"DELETE",headers:F},[],O.CancellationToken.None)}async readResource(U,F,M,j={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const Q=(0,m.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,M,U),"latest").toString();j={...j},j["Cache-Control"]="no-cache",F&&(j["If-None-Match"]=F.ref);const K=await this.request(Q,{type:"GET",headers:j},[304],O.CancellationToken.None);let X=null;if(K.res.statusCode===304&&(X=F),X===null){const x=K.res.headers.etag;if(!x)throw new c.UserDataSyncStoreError("Server did not return the ref",Q,"NoRef",K.res.statusCode,K.res.headers[c.HEADER_OPERATION_ID]);const J=await(0,u.asTextOrError)(K);if(!J&&K.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",Q,"EmptyResponse",K.res.statusCode,K.res.headers[c.HEADER_OPERATION_ID]);X={ref:x,content:J}}return X}async writeResource(U,F,M,j,Q={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const K=this.getResourceUrl(this.userDataSyncStoreUrl,j,U).toString();Q={...Q},Q["Content-Type"]=D.Mimes.text,M&&(Q["If-Match"]=M);const X=await this.request(K,{type:"POST",data:F,headers:Q},[],O.CancellationToken.None),x=X.res.headers.etag;if(!x)throw new c.UserDataSyncStoreError("Server did not return the ref",K,"NoRef",X.res.statusCode,X.res.headers[c.HEADER_OPERATION_ID]);return x}async manifest(U,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,m.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();F={...F},F["Content-Type"]="application/json",U&&(F["If-None-Match"]=U.ref);const j=await this.request(M,{type:"GET",headers:F},[304],O.CancellationToken.None);let Q=null;if(j.res.statusCode===304&&(Q=U),!Q){const X=j.res.headers.etag;if(!X)throw new c.UserDataSyncStoreError("Server did not return the ref",M,"NoRef",j.res.statusCode,j.res.headers[c.HEADER_OPERATION_ID]);const x=await(0,u.asTextOrError)(j);if(!x&&j.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",M,"EmptyResponse",j.res.statusCode,j.res.headers[c.HEADER_OPERATION_ID]);x&&(Q={...JSON.parse(x),ref:X})}const K=this.storageService.get(n,-1);return K&&Q&&K!==Q.session&&this.clearSession(),Q===null&&K&&this.clearSession(),Q&&this.storageService.store(n,Q.session,-1,1),Q}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.clearSession()}async getActivityData(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,m.joinPath)(this.userDataSyncStoreUrl,"download").toString(),F={},M=await this.request(U,{type:"GET",headers:F},[],O.CancellationToken.None);if(!(0,u.isSuccess)(M))throw new c.UserDataSyncStoreError("Server returned "+M.res.statusCode,U,"EmptyResponse",M.res.statusCode,M.res.headers[c.HEADER_OPERATION_ID]);if((0,u.hasNoContent)(M))throw new c.UserDataSyncStoreError("Empty response",U,"EmptyResponse",M.res.statusCode,M.res.headers[c.HEADER_OPERATION_ID]);return M.stream}getResourceUrl(U,F,M){return F?(0,m.joinPath)(U,"collection",F,"resource",M):(0,m.joinPath)(U,"resource",M)}clearSession(){this.storageService.remove(n,-1),this.storageService.remove(s,-1)}async request(U,F,M,j){if(!this.authToken)throw new c.UserDataSyncStoreError("No Auth Token Available",U,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new c.UserDataSyncStoreError(`${F.type} request '${U}' failed because of too many requests (429).`,U,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const Q=await this.commonHeadersPromise;F.headers={...F.headers||{},...Q,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(F.headers),this.logService.trace("Sending request to server",{url:U,type:F.type,headers:{...F.headers,authorization:void 0}});let K;try{K=await this.session.request(U,F,j)}catch(q){if(!(q instanceof c.UserDataSyncStoreError)){let ie="RequestFailed";const re=(0,T.getErrorMessage)(q).toLowerCase();re.includes("xhr timeout")?ie="RequestTimeout":re.includes("protocol")&&re.includes("not supported")?ie="RequestProtocolNotSupported":re.includes("request path contains unescaped characters")?ie="RequestPathNotEscaped":re.includes("headers must be an object")?ie="RequestHeadersNotObject":(0,T.isCancellationError)(q)&&(ie="RequestCanceled"),q=new c.UserDataSyncStoreError(`Connection refused for the request '${U}'.`,U,ie,void 0,void 0)}throw this.logService.info("Request failed",U),q}const X=K.res.headers[c.HEADER_OPERATION_ID],x={url:U,status:K.res.statusCode,"execution-id":F.headers[c.HEADER_EXECUTION_ID],"operation-id":X},J=(0,u.isSuccess)(K)||K.res.statusCode&&M.includes(K.res.statusCode);let V="";if(J?this.logService.trace("Request succeeded",x):(V=await(0,u.asText)(K)||"",this.logService.info("Request failed",x,V)),K.res.statusCode===401||K.res.statusCode===403){if(this.authToken=void 0,K.res.statusCode===401)throw this._onTokenFailed.fire("Unauthorized"),new c.UserDataSyncStoreError(`${F.type} request '${U}' failed because of Unauthorized (401).`,U,"Unauthorized",K.res.statusCode,X);if(K.res.statusCode===403)throw this._onTokenFailed.fire("Forbidden"),new c.UserDataSyncStoreError(`${F.type} request '${U}' failed because the access is forbidden (403).`,U,"Forbidden",K.res.statusCode,X)}if(this._onTokenSucceed.fire(),K.res.statusCode===404)throw new c.UserDataSyncStoreError(`${F.type} request '${U}' failed because the requested resource is not found (404).`,U,"NotFound",K.res.statusCode,X);if(K.res.statusCode===405)throw new c.UserDataSyncStoreError(`${F.type} request '${U}' failed because the requested endpoint is not found (405). ${V}`,U,"MethodNotFound",K.res.statusCode,X);if(K.res.statusCode===409)throw new c.UserDataSyncStoreError(`${F.type} request '${U}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,U,"Conflict",K.res.statusCode,X);if(K.res.statusCode===410)throw new c.UserDataSyncStoreError(`${F.type} request '${U}' failed because the requested resource is not longer available (410).`,U,"Gone",K.res.statusCode,X);if(K.res.statusCode===412)throw new c.UserDataSyncStoreError(`${F.type} request '${U}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,U,"PreconditionFailed",K.res.statusCode,X);if(K.res.statusCode===413)throw new c.UserDataSyncStoreError(`${F.type} request '${U}' failed because of too large payload (413).`,U,"TooLarge",K.res.statusCode,X);if(K.res.statusCode===426)throw new c.UserDataSyncStoreError(`${F.type} request '${U}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,U,"UpgradeRequired",K.res.statusCode,X);if(K.res.statusCode===429){const q=K.res.headers["retry-after"];throw q?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(q)*1e3)),new c.UserDataSyncStoreError(`${F.type} request '${U}' failed because of too many requests (429).`,U,"TooManyRequestsAndRetryAfter",K.res.statusCode,X)):new c.UserDataSyncStoreError(`${F.type} request '${U}' failed because of too many requests (429).`,U,"RemoteTooManyRequests",K.res.statusCode,X)}if(!J)throw new c.UserDataSyncStoreError("Server returned "+K.res.statusCode,U,"Unknown",K.res.statusCode,X);return K}addSessionHeaders(U){let F=this.storageService.get(s,-1);F===void 0&&(F=(0,S.generateUuid)(),this.storageService.store(s,F,-1,1)),U["X-Machine-Session-Id"]=F;const M=this.storageService.get(n,-1);M!==void 0&&(U["X-User-Session-Id"]=M)}};e.UserDataSyncStoreClient=E,e.UserDataSyncStoreClient=E=ye([Y(1,v.IProductService),Y(2,u.IRequestService),Y(3,c.IUserDataSyncLogService),Y(4,g.IEnvironmentService),Y(5,p.IFileService),Y(6,f.IStorageService)],E);let h=class extends E{constructor(U,F,M,j,Q,K,X){super(U.userDataSyncStore?.url,F,M,j,Q,K,X),this._register(U.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(U.userDataSyncStore?.url)))}};e.UserDataSyncStoreService=h,e.UserDataSyncStoreService=h=ye([Y(0,c.IUserDataSyncStoreManagementService),Y(1,v.IProductService),Y(2,u.IRequestService),Y(3,c.IUserDataSyncLogService),Y(4,g.IEnvironmentService),Y(5,p.IFileService),Y(6,f.IStorageService)],h);class y{constructor(U,F,M,j){this.limit=U,this.interval=F,this.requestService=M,this.logService=j,this.requests=[],this.startTime=void 0}request(U,F,M){if(this.isExpired()&&this.reset(),F.url=U,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new c.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,U,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(U),this.requestService.request(F,M)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=y}),define(le[261],ue([0,1,3,2,10,21,24,19,122]),function(se,e,k,O,T,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannelClient=e.UserDataSyncAccountServiceChannel=void 0;class m{constructor(g){this.service=g}listen(g,p){switch(p){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${p}`)}call(g,p,v){switch(p){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(v)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=m;class P extends O.Disposable{get account(){return this._account}get onTokenFailed(){return this.channel.listen("onTokenFailed")}constructor(g){super(),this.channel=g,this._onDidChangeAccount=this._register(new k.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this.channel.call("_getInitialData").then(p=>{this._account=p,this._register(this.channel.listen("onDidChangeAccount")(v=>{this._account=v,this._onDidChangeAccount.fire(v)}))})}updateAccount(g){return this.channel.call("updateAccount",g)}}e.UserDataSyncAccountServiceChannelClient=P;class b{constructor(g){this.service=g}listen(g,p){switch(p){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${p}`)}call(g,p,v){switch(p){case"switch":return this.service.switch(v[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=b;let S=class extends I.AbstractUserDataSyncStoreManagementService{constructor(g,p,v,u){super(p,v,u),this.channel=g,this._register(this.channel.listen("onDidChangeUserDataSyncStore")(()=>this.updateUserDataSyncStore()))}async switch(g){return this.channel.call("switch",[g])}async getPreviousUserDataSyncStore(){const g=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(g)}revive(g){return{url:T.URI.revive(g.url),type:g.type,defaultUrl:T.URI.revive(g.defaultUrl),insidersUrl:T.URI.revive(g.insidersUrl),stableUrl:T.URI.revive(g.stableUrl),canSwitch:g.canSwitch,authenticationProviders:g.authenticationProviders}}};e.UserDataSyncStoreManagementServiceChannelClient=S,e.UserDataSyncStoreManagementServiceChannelClient=S=ye([Y(1,L.IProductService),Y(2,A.IConfigurationService),Y(3,D.IStorageService)],S)}),define(le[262],ue([0,1,3,57,24,19,22,257,25,81,84]),function(se,e,k,O,T,A,L,D,I,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let b=class extends D.UserDataAutoSyncService{constructor(l,g,p,v,u,d,f,c,w,i,o){super(l,g,p,v,u,f,c,w,i,o),this._register(k.Event.debounce(k.Event.any(k.Event.map(d.onDidFocusMainWindow,()=>"windowFocus"),k.Event.map(d.onDidOpenMainWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.UserDataAutoSyncService=b,e.UserDataAutoSyncService=b=ye([Y(0,T.IProductService),Y(1,I.IUserDataSyncStoreManagementService),Y(2,I.IUserDataSyncStoreService),Y(3,I.IUserDataSyncEnablementService),Y(4,I.IUserDataSyncService),Y(5,O.INativeHostService),Y(6,I.IUserDataSyncLogService),Y(7,m.IUserDataSyncAccountService),Y(8,L.ITelemetryService),Y(9,P.IUserDataSyncMachinesService),Y(10,A.IStorageService)],b)}),define(le[263],ue([0,1,73,23,5,20]),function(se,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function L(m){function P(){let b=m.scheme===O.Schemas.file?(0,A.originalFSPath)(m):m.toString();return T.isLinux||(b=b.toLowerCase()),(0,k.createHash)("md5").update(b).digest("hex")}return{id:P(),configPath:m}}e.getWorkspaceIdentifier=L;function D(m,P){function b(){if(m.scheme!==O.Schemas.file)return(0,k.createHash)("md5").update(m.toString()).digest("hex");if(!P)return;let l;return T.isLinux?l=P.ino:T.isMacintosh?l=P.birthtime.getTime():T.isWindows&&(typeof P.birthtimeMs=="number"?l=Math.floor(P.birthtimeMs):l=P.birthtime.getTime()),(0,k.createHash)("md5").update(m.fsPath).update(l?String(l):"").digest("hex")}const S=b();if(typeof S=="string")return{id:S,uri:m}}e.getSingleFolderWorkspaceIdentifier=D;function I(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=I}),define(le[264],ue([0,1,6,7,2,16,31,15,8,78,112,263,57,56,23]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let p=class extends T.Disposable{constructor(u,d,f,c){super(),this.environmentService=u,this.logService=d,this.nativeHostService=f,this.mainProcessService=c,this._register(new k.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const u=this.environmentService.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,d=await L.Promises.readdir(u),f=new m.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(d.map(async c=>{const w=(0,A.join)(u,c);c.length===b.NON_EMPTY_WORKSPACE_ID_LENGTH||c===P.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===c)||await f.isUsed(w)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${c} as it seems to be an unused empty workspace.`),await L.Promises.rm(w))}))}catch(u){(0,O.onUnexpectedError)(u)}}};e.UnusedWorkspaceStorageDataCleaner=p,e.UnusedWorkspaceStorageDataCleaner=p=ye([Y(0,D.INativeEnvironmentService),Y(1,I.ILogService),Y(2,S.INativeHostService),Y(3,l.IMainProcessService)],p)}),define(le[123],ue([0,1,73,64,36,272,14,7,3,2,16,5,32,40,68]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class p{traceSocketEvent(h,y){g.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,h,y)}constructor(h,y=""){this._canWrite=!0,this.debugLabel=y,this.socket=h,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=R=>{if(this.traceSocketEvent("error",{code:R?.code,message:R?.message}),R){if(R.code==="EPIPE")return;(0,D.onUnexpectedError)(R)}},this.socket.on("error",this._errorListener),this._closeListener=R=>{this.traceSocketEvent("close",{hadError:R}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(h){const y=R=>{this.traceSocketEvent("read",R),h(L.VSBuffer.wrap(R))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(h){const y=R=>{h({type:0,hadError:R,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(h){const y=()=>{h()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(h){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",h),this.socket.write(h.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,D.onUnexpectedError)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,D.onUnexpectedError)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((h,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),h();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),this.traceSocketEvent("nodeDrainEnd"),h()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.NodeSocket=p;var v;(function(E){E[E.MinHeaderByteSize=2]="MinHeaderByteSize",E[E.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(v||(v={}));var u;(function(E){E[E.PeekHeader=1]="PeekHeader",E[E.ReadHeader=2]="ReadHeader",E[E.ReadBody=3]="ReadBody",E[E.Fin=4]="Fin"})(u||(u={}));class d extends m.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(h,y){this.socket.traceSocketEvent(h,y)}constructor(h,y,R,U){super(),this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=h,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:R?.byteLength||0,recordInflateBytes:U}),this._flowManager=this._register(new f(this,y,R,U,this._onData,(F,M)=>this._write(F,M))),this._register(this._flowManager.onError(F=>{console.error(F),(0,D.onUnexpectedError)(F),this._onClose.fire({type:0,hadError:!0,error:F})})),this._incomingData=new g.ChunkStream,this._register(this.socket.onData(F=>this._acceptChunk(F))),this._register(this.socket.onClose(async F=>{this._flowManager.isProcessingReadQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(F)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(h){return this._onData.event(h)}onClose(h){return this._onClose.event(h)}onEnd(h){return this.socket.onEnd(h)}write(h){let y=0;for(;y<h.byteLength;)this._flowManager.writeMessage(h.slice(y,Math.min(y+262144,h.byteLength)),{compressed:!0,opcode:2}),y+=262144}_write(h,{compressed:y,opcode:R}){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",h);let U=2;h.byteLength<126?U+=0:h.byteLength<2**16?U+=2:U+=8;const F=L.VSBuffer.alloc(U),M=y?64:0,j=R&15;if(F.writeUInt8(128|M|j,0),h.byteLength<126)F.writeUInt8(h.byteLength,1);else if(h.byteLength<2**16){F.writeUInt8(126,1);let Q=1;F.writeUInt8(h.byteLength>>>8&255,++Q),F.writeUInt8(h.byteLength>>>0&255,++Q)}else{F.writeUInt8(127,1);let Q=1;F.writeUInt8(0,++Q),F.writeUInt8(0,++Q),F.writeUInt8(0,++Q),F.writeUInt8(0,++Q),F.writeUInt8(h.byteLength>>>24&255,++Q),F.writeUInt8(h.byteLength>>>16&255,++Q),F.writeUInt8(h.byteLength>>>8&255,++Q),F.writeUInt8(h.byteLength>>>0&255,++Q)}this.socket.write(L.VSBuffer.concat([F,h]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(h){if(h.byteLength!==0){for(this._incomingData.acceptChunk(h);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const y=this._incomingData.peek(this._state.readLen),R=y.readUInt8(0),U=(R&128)>>>7,F=(R&64)>>>6,M=R&15,j=y.readUInt8(1),Q=(j&128)>>>7,K=j&127;this._state.state=2,this._state.readLen=2+(Q?4:0)+(K===126?2:0)+(K===127?8:0),this._state.fin=U,this._state.firstFrameOfMessage&&(this._state.compressed=!!F),this._state.firstFrameOfMessage=!!U,this._state.mask=0,this._state.opcode=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===2){const y=this._incomingData.read(this._state.readLen),R=y.readUInt8(1),U=(R&128)>>>7;let F=R&127,M=1;F===126?F=y.readUInt8(++M)*2**8+y.readUInt8(++M):F===127&&(F=y.readUInt8(++M)*0+y.readUInt8(++M)*0+y.readUInt8(++M)*0+y.readUInt8(++M)*0+y.readUInt8(++M)*2**24+y.readUInt8(++M)*2**16+y.readUInt8(++M)*2**8+y.readUInt8(++M));let j=0;U&&(j=y.readUInt8(++M)*2**24+y.readUInt8(++M)*2**16+y.readUInt8(++M)*2**8+y.readUInt8(++M)),this._state.state=3,this._state.readLen=F,this._state.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===3){const y=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),i(y,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(y,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(y,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=d;class f extends m.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:L.VSBuffer.alloc(0)}constructor(h,y,R,U,F,M){super(),this._tracer=h,this._onData=F,this._writeFn=M,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new I.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new I.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,y?(this._zlibInflateStream=this._register(new c(this._tracer,U,R,{windowBits:15})),this._zlibDeflateStream=this._register(new w(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(j=>this._onError.fire(j))),this._register(this._zlibDeflateStream.onError(j=>this._onError.fire(j)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(h,y){this._writeQueue.push({data:h,options:y}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:h,options:y}=this._writeQueue.shift();if(this._zlibDeflateStream&&y.compressed){const R=await this._deflateMessage(this._zlibDeflateStream,h);this._writeFn(R,y)}else this._writeFn(h,{...y,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(h,y){return new Promise((R,U)=>{h.write(y),h.flush(F=>R(F))})}acceptFrame(h,y,R){this._readQueue.push({data:h,isCompressed:y,isLastFrameOfMessage:R}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const h=this._readQueue.shift();if(this._zlibInflateStream&&h.isCompressed){const y=await this._inflateFrame(this._zlibInflateStream,h.data,h.isLastFrameOfMessage);this._onData.fire(y)}else this._onData.fire(h.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(h,y,R){return new Promise((U,F)=>{h.write(y),R&&h.write(L.VSBuffer.fromByteArray([0,0,255,255])),h.flush(M=>U(M))})}}class c extends m.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?L.VSBuffer.concat(this._recordedInflateBytes):L.VSBuffer.alloc(0)}constructor(h,y,R,U){super(),this._tracer=h,this._recordInflateBytes=y,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,A.createInflateRaw)(U),this._zlibInflate.on("error",F=>{this._tracer.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this._onError.fire(F)}),this._zlibInflate.on("data",F=>{this._tracer.traceSocketEvent("zlibInflateData",F),this._pendingInflateData.push(L.VSBuffer.wrap(F))}),R&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",R.buffer),this._zlibInflate.write(R.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(h){this._recordInflateBytes&&this._recordedInflateBytes.push(h.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",h),this._zlibInflate.write(h.buffer)}flush(h){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const y=L.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,h(y)})}}class w extends m.Disposable{constructor(h,y){super(),this._tracer=h,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,A.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",R=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:R?.message,code:R?.code}),this._onError.fire(R)}),this._zlibDeflate.on("data",R=>{this._tracer.traceSocketEvent("zlibDeflateData",R),this._pendingDeflateData.push(L.VSBuffer.wrap(R))})}write(h){this._tracer.traceSocketEvent("zlibDeflateWrite",h.buffer),this._zlibDeflate.write(h.buffer)}flush(h){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let y=L.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,y=y.slice(0,y.byteLength-4),h(y)})}}function i(E,h){if(h===0)return;const y=E.byteLength>>>2;for(let Q=0;Q<y;Q++){const K=E.readUInt32BE(Q*4);E.writeUInt32BE(K^h,Q*4)}const R=y*4,U=E.byteLength-R,F=h>>>24&255,M=h>>>16&255,j=h>>>8&255;U>=1&&E.writeUInt8(E.readUInt8(R)^F,R),U>=2&&E.writeUInt8(E.readUInt8(R+1)^M,R+1),U>=3&&E.writeUInt8(E.readUInt8(R+2)^j,R+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function n(){const E=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${E}-sock`;const h=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,T.tmpdir)(),y=(0,P.join)(h,`vscode-ipc-${E}.sock`);return t(y),y}e.createRandomIPCHandle=n;function s(E,h,y){const U=(0,k.createHash)("sha256").update(E).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${y}-${h}-sock`;const F=y.substr(0,4),M=h.substr(0,6);let j;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?j=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${U}-${F}-${M}.sock`):j=(0,P.join)(E,`${F}-${M}.sock`),t(j),j}e.createStaticIPCHandle=s;function t(E){const h=o[b.platform];typeof h=="number"&&E.length>=h&&console.warn(`WARNING: IPC handle "${E}" is longer than ${h} chars, try a shorter --user-data-dir`)}class r extends l.IPCServer{static toClientConnectionEvent(h){const y=I.Event.fromNodeEventEmitter(h,"connection");return I.Event.map(y,R=>({protocol:new g.Protocol(new p(R,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(R,"close"))}))}constructor(h){super(r.toClientConnectionEvent(h)),this.server=h}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function a(E){return new Promise((h,y)=>{const R=(0,O.createServer)();R.on("error",y),R.listen(E,()=>{R.removeListener("error",y),h(new r(R))})})}e.serve=a;function C(E,h){return new Promise((y,R)=>{const U=(0,O.createConnection)(E,()=>{U.removeListener("error",R),y(g.Client.fromSocket(new p(U,`ipc-client${h}`),h))});U.once("error",R)})}e.connect=C}),define(le[265],ue([0,1,64,123,212]),function(se,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{supports(A){return!0}connect({host:A,port:L},D,I,m){return new Promise((P,b)=>{const S=k.createConnection({host:A,port:L},()=>{S.removeListener("error",b),S.write((0,T.makeRawSocketHeaders)(D,I,m));const l=g=>{g.toString().indexOf(`\r
\r
`)>=0&&(S.off("data",l),P(new O.NodeSocket(S,m)))};S.on("data",l)});S.setNoDelay(!0),S.once("error",b)})}}}),define(le[266],ue([0,1,64,36,133,123,6,2,5,21,8,24,215,104,106,79,14]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function u(i,o,n,s,t){let r;for(let a=3;a&&(r?.dispose(),r=await new d(i,o,n,s,t).waitForReady(),!(t&&T.BROWSER_RESTRICTED_PORTS[t]||!T.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));a--);return r}class d extends D.Disposable{constructor(o,n,s,t,r){super(),this.defaultTunnelHost=n,this.suggestedLocalPort=r,this.privacy=p.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=o,this._server=k.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=a=>this._onConnection(a),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=t,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(n=>{n()})}async waitForReady(){const o=this.suggestedLocalPort??this.tunnelRemotePort,n=(0,p.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let s=await(0,T.findFreePortFaster)(o,2,1e3,n),t=null;return this._server.listen(s,this.defaultTunnelHost),await this._barrier.wait(),t=this._server.address(),t||(s=0,this._server.listen(s,this.defaultTunnelHost),await this._barrier.wait(),t=this._server.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async _onConnection(o){o.pause();const n=(0,p.isLocalhost)(this.tunnelRemoteHost)||(0,p.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,S.connectRemoteAgentTunnel)(this._options,n,this.tunnelRemotePort),t=s.getSocket(),r=s.readEntireBuffer();s.dispose(),r.byteLength>0&&o.write(r.buffer),o.on("end",()=>{o.localAddress&&this._socketsDispose.delete(o.localAddress),t.end()}),o.on("close",()=>t.end()),o.on("error",()=>{o.localAddress&&this._socketsDispose.delete(o.localAddress),t instanceof A.NodeSocket?t.socket.destroy():t.end()}),t instanceof A.NodeSocket?this._mirrorNodeSocket(o,t):this._mirrorGenericSocket(o,t),o.localAddress&&this._socketsDispose.set(o.localAddress,()=>{o.end(),t.end()})}_mirrorGenericSocket(o,n){n.onClose(()=>o.destroy()),n.onEnd(()=>o.end()),n.onData(s=>o.write(s.buffer)),o.on("data",s=>n.write(v.VSBuffer.wrap(s))),o.resume()}_mirrorNodeSocket(o,n){const s=n.socket;s.on("end",()=>o.end()),s.on("close",()=>o.end()),s.on("error",()=>{o.destroy()}),s.pipe(o),o.pipe(s)}}e.NodeRemoteTunnel=d;let f=class extends p.AbstractTunnelService{constructor(o,n,s,t,r){super(n,r),this.remoteSocketFactoryService=o,this.signService=s,this.productService=t}isPortPrivileged(o){return(0,p.isPortPrivileged)(o,this.defaultTunnelHost,I.OS,O.release())}retainOrCreateTunnel(o,n,s,t,r,a,C,E){const h=this.getTunnelFromMap(n,s);if(h)return++h.refcount,h.value;if((0,p.isTunnelProvider)(o))return this.createWithProvider(o,n,s,r,a,C,E);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${r}.`);const y={commit:this.productService.commit,quality:this.productService.quality,addressProvider:o,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},R=u(y,t,n,s,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(n,s,R),R}}};e.BaseTunnelService=f,e.BaseTunnelService=f=ye([Y(0,l.IRemoteSocketFactoryService),Y(1,P.ILogService),Y(2,g.ISignService),Y(3,b.IProductService),Y(4,m.IConfigurationService)],f);let c=class extends f{constructor(o,n,s,t,r){super(o,n,s,t,r)}};e.TunnelService=c,e.TunnelService=c=ye([Y(0,l.IRemoteSocketFactoryService),Y(1,P.ILogService),Y(2,g.ISignService),Y(3,b.IProductService),Y(4,m.IConfigurationService)],c);let w=class extends D.Disposable{constructor(o,n,s,t,r){super(),this.remoteSocketFactoryService=o,this.logService=n,this.productService=s,this.signService=t,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(o,n,s,t,r,a,C,E,h){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${t} on local port ${a}.`),!this._tunnelServices.has(o)){const y=new c(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(y),this._tunnelServices.set(o,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this._tunnelServices.delete(o))})}return this._tunnelServices.get(o).openTunnel(n,s,t,r,a,C,E,h)}};e.SharedTunnelsService=w,e.SharedTunnelsService=w=ye([Y(0,l.IRemoteSocketFactoryService),Y(1,P.ILogService),Y(2,b.IProductService),Y(3,g.ISignService),Y(4,m.IConfigurationService)],w)}),define(le[273],ue([0,1,36,38,7,2,23,10,17,3,40,147,206,207,197,198,264,188,190,21,211,95,222,96,217,15,114,248,29,99,189,113,97,11,200,201,72,4,196,74,75,228,8,202,102,24,59,19,107,22,108,109,110,46,231,83,111,25,81,256,261,241,84,255,259,260,122,60,254,242,106,221,79,266,216,232,28,233,5,234,191,209,208,82,247,18,51,205,58,253,230,243,105,258,249,9,203,101,251,246,218,185,57,204,262,250,56,252,104,265,182,219]),function(se,e,k,O,T,A,L,D,I,m,P,b,S,l,g,p,v,u,d,f,c,w,i,o,n,s,t,r,a,C,E,h,y,R,U,F,M,j,Q,K,X,x,J,V,q,ie,re,ee,ae,G,W,_,N,z,$,Z,B,H,te,ne,ce,fe,ge,Se,Ce,Re,ke,Ue,he,me,ve,Pe,De,Me,_e,We,Ne,Fe,je,oe,de,pe,we,Ee,Ie,Le,Te,Oe,qe,$e,ze,Ve,Je,et,wt,Ct,bt,ft,It,Pt,Dt,Rt,Lt,kt,_t,Tt,gt,At,mt,Ot,Ut,nt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Nt extends A.Disposable{constructor(be){super(),this.configuration=be,this.server=this._register(new b.Server(this)),this.lifecycleService=void 0,this.onDidWindowConnectRaw=this._register(new m.Emitter),this.registerListeners()}registerListeners(){let be=!1;const Ae=()=>{be||(be=!0,this.lifecycleService?.fireOnWillShutdown(),this.dispose())};process.once("exit",Ae),(0,b.once)(process.parentPort,nt.SharedProcessLifecycle.exit,Ae)}async init(){const be=await this.initServices();(0,H.registerConfiguration)(),be.invokeFunction(Ae=>{const Ke=Ae.get(J.ILogService),xe=Ae.get(G.ITelemetryService),Ye=Ae.get(Le.IUserDataProfilesService);Ke.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ae),this.registerErrorHandler(Ke),this.reportProfilesInfo(xe,Ye),this._register(Ye.onDidChangeProfiles(()=>this.reportProfilesInfo(xe,Ye)))}),this._register((0,A.combinedDisposable)(be.createInstance(S.CodeCacheCleaner,this.configuration.codeCachePath),be.createInstance(l.LanguagePackCachedDataCleaner),be.createInstance(v.UnusedWorkspaceStorageDataCleaner),be.createInstance(p.LogsDataCleaner),be.createInstance(g.LocalizationsUpdater),be.createInstance(wt.ExtensionsContributions),be.createInstance(Ve.UserDataProfilesCleaner)))}async initServices(){const be=new K.ServiceCollection,Ae={_serviceBrand:void 0,...q.default};be.set(ie.IProductService,Ae);const Ke=new P.StaticRouter(Be=>Be==="main"),xe=new gt.MainProcessService(this.server,Ke);be.set(gt.IMainProcessService,xe);const Ye=this.configuration.policiesData?new Oe.PolicyChannelClient(this.configuration.policiesData,xe.getChannel("policy")):new qe.NullPolicyService;be.set(qe.IPolicyService,Ye);const He=new Ut.NativeEnvironmentService(this.configuration.args,Ae);be.set(s.INativeEnvironmentService,He);const Ze=new V.LoggerChannelClient(void 0,this.configuration.logLevel,He.logsHome,this.configuration.loggers.map(Be=>({...Be,resource:D.URI.revive(Be.resource)})),xe.getChannel("logger"));be.set(J.ILoggerService,Ze);const rt=this._register(Ze.createLogger("sharedprocess",{name:(0,Ct.localize)(0,null)})),lt=this._register(new J.ConsoleLogger(rt.getLevel())),Ge=this._register(new bt.LogService(rt,[lt]));be.set(J.ILogService,Ge),this.lifecycleService=this._register(new ft.SharedProcessLifecycleService(Ge)),be.set(ft.ISharedProcessLifecycleService,this.lifecycleService);const Qe=this._register(new U.FileService(Ge));be.set(R.IFileService,Qe);const ut=this._register(new F.DiskFileSystemProvider(Ge));Qe.registerProvider(L.Schemas.file,ut);const ot=new Fe.UriIdentityService(Qe);be.set(Ne.IUriIdentityService,ot);const Xe=this._register(new $e.UserDataProfilesService(this.configuration.profiles.all,D.URI.revive(this.configuration.profiles.home).with({scheme:He.userRoamingDataHome.scheme}),xe.getChannel("userDataProfiles")));be.set(Le.IUserDataProfilesService,Xe);const ht=this._register(new oe.FileUserDataProvider(L.Schemas.file,this._register(new de.DiskFileSystemProviderClient(xe.getChannel(de.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:je.isLinux})),L.Schemas.vscodeUserData,Xe,ot,Ge));Qe.registerProvider(L.Schemas.vscodeUserData,ht);const tt=this._register(new c.ConfigurationService(Xe.defaultProfile.settingsResource,Qe,Ye,Ge));be.set(f.IConfigurationService,tt);const dt=new At.RemoteStorageService(void 0,{defaultProfile:Xe.defaultProfile,currentProfile:Xe.defaultProfile},xe,He);be.set(ee.IStorageService,dt),this._register((0,A.toDisposable)(()=>dt.flush())),await Promise.all([tt.initialize(),dt.initialize()]);const vt=new Dt.RequestChannelClient(xe.getChannel("request"));be.set(re.IRequestService,vt),be.set(u.IChecksumService,new M.SyncDescriptor(d.ChecksumService,void 0,!1)),be.set(we.IV8InspectProfilingService,new M.SyncDescriptor(pe.InspectProfilingService,void 0,!1));const pt=new kt.NativeHostService(-1,xe);be.set(Lt.INativeHostService,pt),be.set(o.IDownloadService,new M.SyncDescriptor(n.DownloadService,void 0,!0));const Ft=this._register(new me.ActiveWindowManager(pt)),Mt=new P.StaticRouter(Be=>Ft.getActiveClientId().then(ct=>Be===ct));be.set(y.IExtensionRecommendationNotificationService,new Rt.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Mt)));let at;const it=[],yt=(0,z.isInternalTelemetry)(Ae,tt);if((0,z.supportsTelemetry)(Ae,He)){const Be=new _.TelemetryLogAppender(Ge,Ze,He,Ae);if(it.push(Be),!(0,z.isLoggingOnly)(Ae,He)&&Ae.aiConfig?.ariaKey){const ct=new ze.OneDataSystemAppender(vt,yt,"monacoworkbench",null,Ae.aiConfig.ariaKey);this._register((0,A.toDisposable)(()=>ct.flush())),it.push(ct)}at=new N.TelemetryService({appenders:it,commonProperties:(0,ae.resolveCommonProperties)((0,k.release)(),(0,k.hostname)(),process.arch,Ae.commit,Ae.version,this.configuration.machineId,this.configuration.sqmId,yt),sendErrorTelemetry:!0,piiPaths:(0,z.getPiiPathsFromEnvironment)(He)},tt,Ae)}else{at=z.NullTelemetryService;const Be=z.NullAppender;it.push(Be)}this.server.registerChannel("telemetryAppender",new W.TelemetryAppenderChannel(it)),be.set(G.ITelemetryService,at);const $t=new $.CustomEndpointTelemetryService(tt,at,Ge,Ze,He,Ae);be.set(G.ICustomEndpointTelemetryService,$t),be.set(Te.IExtensionsProfileScannerService,new M.SyncDescriptor(Pt.ExtensionsProfileScannerService,void 0,!0)),be.set(Ee.IExtensionsScannerService,new M.SyncDescriptor(Ie.ExtensionsScannerService,void 0,!0)),be.set(C.IExtensionSignatureVerificationService,new M.SyncDescriptor(C.ExtensionSignatureVerificationService,void 0,!0)),be.set(h.INativeServerExtensionManagementService,new M.SyncDescriptor(h.ExtensionManagementService,void 0,!0)),be.set(a.IExtensionGalleryService,new M.SyncDescriptor(r.ExtensionGalleryService,void 0,!0)),be.set(a.IExtensionTipsService,new M.SyncDescriptor(Tt.ExtensionTipsService,void 0,!1)),be.set(X.ILanguagePackService,new M.SyncDescriptor(x.NativeLanguagePackService,void 0,!1)),be.set(w.IDiagnosticsService,new M.SyncDescriptor(i.DiagnosticsService,void 0,!1)),be.set(te.IUserDataSyncAccountService,new M.SyncDescriptor(te.UserDataSyncAccountService,void 0,!0)),be.set(H.IUserDataSyncLogService,new M.SyncDescriptor(fe.UserDataSyncLogService,void 0,!0)),be.set(H.IUserDataSyncUtilService,P.ProxyChannel.toService(this.server.getChannel("userDataSyncUtil",Be=>Be.ctx!=="main"))),be.set(a.IGlobalExtensionEnablementService,new M.SyncDescriptor(t.GlobalExtensionEnablementService,void 0,!1)),be.set(B.IIgnoredExtensionsManagementService,new M.SyncDescriptor(B.IgnoredExtensionsManagementService,void 0,!0)),be.set(Z.IExtensionStorageService,new M.SyncDescriptor(Z.ExtensionStorageService)),be.set(H.IUserDataSyncStoreManagementService,new M.SyncDescriptor(ke.UserDataSyncStoreManagementService,void 0,!0)),be.set(H.IUserDataSyncStoreService,new M.SyncDescriptor(ke.UserDataSyncStoreService,void 0,!0)),be.set(ge.IUserDataSyncMachinesService,new M.SyncDescriptor(ge.UserDataSyncMachinesService,void 0,!0)),be.set(H.IUserDataSyncLocalStoreService,new M.SyncDescriptor(ne.UserDataSyncLocalStoreService,void 0,!1)),be.set(H.IUserDataSyncEnablementService,new M.SyncDescriptor(Se.UserDataSyncEnablementService,void 0,!0)),be.set(H.IUserDataSyncService,new M.SyncDescriptor(Ce.UserDataSyncService,void 0,!1)),be.set(Ue.IUserDataProfileStorageService,new M.SyncDescriptor(he.NativeUserDataProfileStorageService,void 0,!0)),be.set(H.IUserDataSyncResourceProviderService,new M.SyncDescriptor(et.UserDataSyncResourceProviderService,void 0,!0)),be.set(ve.ISignService,new M.SyncDescriptor(Pe.SignService,void 0,!1));const Et=new mt.RemoteSocketFactoryService;return be.set(mt.IRemoteSocketFactoryService,Et),Et.register(0,Ot.nodeSocketFactory),be.set(De.ISharedTunnelsService,new M.SyncDescriptor(Me.SharedTunnelsService)),be.set(_e.ISharedProcessTunnelService,new M.SyncDescriptor(We.SharedProcessTunnelService)),be.set(Je.IRemoteTunnelService,new M.SyncDescriptor(It.RemoteTunnelService)),new Q.InstantiationService(be)}initChannels(be){const Ae=new E.ExtensionManagementChannel(be.get(a.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ae);const Ke=P.ProxyChannel.fromService(be.get(X.ILanguagePackService),this._store);this.server.registerChannel("languagePacks",Ke);const xe=P.ProxyChannel.fromService(be.get(w.IDiagnosticsService),this._store);this.server.registerChannel("diagnostics",xe);const Ye=new E.ExtensionTipsChannel(be.get(a.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Ye);const He=P.ProxyChannel.fromService(be.get(u.IChecksumService),this._store);this.server.registerChannel("checksum",He);const Ze=P.ProxyChannel.fromService(be.get(we.IV8InspectProfilingService),this._store);this.server.registerChannel("v8InspectProfiling",Ze);const rt=P.ProxyChannel.fromService(be.get(ge.IUserDataSyncMachinesService),this._store);this.server.registerChannel("userDataSyncMachines",rt);const lt=P.ProxyChannel.fromService(be.get(G.ICustomEndpointTelemetryService),this._store);this.server.registerChannel("customEndpointTelemetry",lt);const Ge=new ce.UserDataSyncAccountServiceChannel(be.get(te.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ge);const Qe=new ce.UserDataSyncStoreManagementServiceChannel(be.get(H.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Qe);const ut=new Re.UserDataSyncServiceChannel(be.get(H.IUserDataSyncService),be.get(Le.IUserDataProfilesService),be.get(J.ILogService));this.server.registerChannel("userDataSync",ut);const ot=this._register(be.get(j.IInstantiationService).createInstance(_t.UserDataAutoSyncService));this.server.registerChannel("userDataAutoSync",P.ProxyChannel.fromService(ot,this._store)),this.server.registerChannel("IUserDataSyncResourceProviderService",P.ProxyChannel.fromService(be.get(H.IUserDataSyncResourceProviderService),this._store));const Xe=P.ProxyChannel.fromService(be.get(_e.ISharedProcessTunnelService),this._store);this.server.registerChannel(_e.ipcSharedProcessTunnelChannelName,Xe);const ht=P.ProxyChannel.fromService(be.get(Je.IRemoteTunnelService),this._store);this.server.registerChannel("remoteTunnel",ht)}registerErrorHandler(be){process.on("uncaughtException",Ae=>(0,T.onUnexpectedError)(Ae)),process.on("unhandledRejection",Ae=>(0,T.onUnexpectedError)(Ae)),(0,T.setUnexpectedErrorHandler)(Ae=>{const Ke=(0,O.toErrorMessage)(Ae,!0);Ke&&be.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}reportProfilesInfo(be,Ae){be.publicLog2("profilesInfo",{count:Ae.profiles.length})}handledClientConnection(be){if(be.data!==nt.SharedProcessRawConnection.response)return!1;const Ae=(0,I.firstOrDefault)(be.ports);return Ae?(this.onDidWindowConnectRaw.fire(Ae),!0):!1}}async function St(st){const be=new Nt(st);process.parentPort.postMessage(nt.SharedProcessLifecycle.ipcReady),await be.init(),process.parentPort.postMessage(nt.SharedProcessLifecycle.initDone)}e.main=St,process.parentPort.once("message",st=>{St(st.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/27d855b2b4105a2aca2445223c8f3dc4694fbd58/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
