/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ue=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/base/common/uri","vs/base/common/errors","vs/base/common/path","vs/base/common/types","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/nls!vs/platform/terminal/node/ptyHostMain","vs/nls","vs/base/common/decorators","vs/base/common/process","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/network","os","vs/platform/instantiation/common/instantiation","vs/base/common/lazy","vs/base/common/resources","vs/base/node/pfs","vs/base/common/map","child_process","vs/base/parts/ipc/common/ipc","vs/platform/terminal/common/terminal","vs/base/common/functional","vs/base/common/objects","vs/base/parts/sandbox/node/electronTypes","vs/base/common/extpath","vs/base/common/processes","vs/base/node/processes","vs/platform/contextkey/common/contextkey","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/node/childProcessMonitor","vs/platform/terminal/node/terminalEnvironment","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/hash","vs/base/common/symbols","vs/base/common/ternarySearchTree","vs/base/common/uuid","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/terminal/node/ptyService","vs/nls!vs/platform/terminal/node/terminalProcess","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/files/common/files","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/registry/common/platform","vs/platform/terminal/common/capabilities/bufferMarkCapability","vs/platform/terminal/common/capabilities/commandDetection/terminalCommand","vs/platform/terminal/common/capabilities/commandDetectionCapability","vs/platform/terminal/common/capabilities/cwdDetectionCapability","vs/platform/terminal/common/capabilities/partialCommandDetectionCapability","vs/platform/terminal/common/capabilities/terminalCapabilityStore","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalAutoResponder","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/common/terminalProcess","vs/platform/terminal/common/terminalStrings","vs/platform/terminal/common/xterm/shellIntegrationAddon","vs/platform/terminal/node/heartbeatService","vs/platform/terminal/node/windowsShellHelper","vs/platform/terminal/node/terminalProcess","vs/platform/terminal/node/ptyService","fs","util","minimist","node-pty","@xterm/headless","vs/base/common/performance","vs/platform/terminal/node/ptyHostMain"],he=function(oe){for(var e=[],v=0,L=oe.length;v<L;v++)e[v]=ue[oe[v]];return e};define(ue[40],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFindFirst=e.findMaxIdxBy=e.findFirstMinBy=e.findLastMaxBy=e.findFirstMaxBy=e.MonotonousArray=e.findFirstIdxMonotonous=e.findFirstIdxMonotonousOrArrLen=e.findFirstMonotonous=e.findLastIdxMonotonous=e.findLastMonotonous=e.findLastIdx=e.findLast=void 0;function v(u,a,s){const o=L(u,a);if(o!==-1)return u[o]}e.findLast=v;function L(u,a,s=u.length-1){for(let o=s;o>=0;o--){const f=u[o];if(a(f))return o}return-1}e.findLastIdx=L;function S(u,a){const s=A(u,a);return s===-1?void 0:u[s]}e.findLastMonotonous=S;function A(u,a,s=0,o=u.length){let f=s,n=o;for(;f<n;){const t=Math.floor((f+n)/2);a(u[t])?f=t+1:n=t}return f-1}e.findLastIdxMonotonous=A;function M(u,a){const s=E(u,a);return s===u.length?void 0:u[s]}e.findFirstMonotonous=M;function E(u,a,s=0,o=u.length){let f=s,n=o;for(;f<n;){const t=Math.floor((f+n)/2);a(u[t])?n=t:f=t+1}return f}e.findFirstIdxMonotonousOrArrLen=E;function d(u,a,s=0,o=u.length){const f=E(u,a,s,o);return f===u.length?-1:f}e.findFirstIdxMonotonous=d;class l{static{this.assertInvariants=!1}constructor(a){this._array=a,this._findLastMonotonousLastIdx=0}findLastMonotonous(a){if(l.assertInvariants){if(this._prevFindLastPredicate){for(const o of this._array)if(this._prevFindLastPredicate(o)&&!a(o))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=a}const s=A(this._array,a,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=s+1,s===-1?void 0:this._array[s]}}e.MonotonousArray=l;function P(u,a){if(u.length===0)return;let s=u[0];for(let o=1;o<u.length;o++){const f=u[o];a(f,s)>0&&(s=f)}return s}e.findFirstMaxBy=P;function p(u,a){if(u.length===0)return;let s=u[0];for(let o=1;o<u.length;o++){const f=u[o];a(f,s)>=0&&(s=f)}return s}e.findLastMaxBy=p;function w(u,a){return P(u,(s,o)=>-a(s,o))}e.findFirstMinBy=w;function r(u,a){if(u.length===0)return-1;let s=0;for(let o=1;o<u.length;o++){const f=u[o];a(f,u[s])>0&&(s=o)}return s}e.findMaxIdxBy=r;function m(u,a){for(const s of u){const o=a(s);if(o!==void 0)return o}}e.mapFindFirst=m}),define(ue[41],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.intersection=e.diffMaps=e.diffSets=e.groupBy=void 0;function v(M,E){const d=Object.create(null);for(const l of M){const P=E(l);let p=d[P];p||(p=d[P]=[]),p.push(l)}return d}e.groupBy=v;function L(M,E){const d=[],l=[];for(const P of M)E.has(P)||d.push(P);for(const P of E)M.has(P)||l.push(P);return{removed:d,added:l}}e.diffSets=L;function S(M,E){const d=[],l=[];for(const[P,p]of M)E.has(P)||d.push(p);for(const[P,p]of E)M.has(P)||l.push(p);return{removed:d,added:l}}e.diffMaps=S;function A(M,E){const d=new Set;for(const l of E)M.has(l)&&d.add(l);return d}e.intersection=A}),define(ue[14],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function v(M){return(E,d,l)=>{let P=null,p=null;if(typeof l.value=="function"?(P="value",p=l.value):typeof l.get=="function"&&(P="get",p=l.get),!p)throw new Error("not supported");l[P]=M(p,d)}}function L(M,E,d){let l=null,P=null;if(typeof d.value=="function"?(l="value",P=d.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(l="get",P=d.get),!P)throw new Error("not supported");const p=`$memoize$${E}`;d[l]=function(...w){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,w)}),this[p]}}e.memoize=L;function S(M,E,d){return v((l,P)=>{const p=`$debounce$${P}`,w=`$debounce$result$${P}`;return function(...r){this[w]||(this[w]=d?d():void 0),clearTimeout(this[p]),E&&(this[w]=E(this[w],...r),r=[this[w]]),this[p]=setTimeout(()=>{l.apply(this,r),this[w]=d?d():void 0},M)}})}e.debounce=S;function A(M,E,d){return v((l,P)=>{const p=`$throttle$timer$${P}`,w=`$throttle$result$${P}`,r=`$throttle$lastRun$${P}`,m=`$throttle$pending$${P}`;return function(...u){if(this[w]||(this[w]=d?d():void 0),(this[r]===null||this[r]===void 0)&&(this[r]=-Number.MAX_VALUE),E&&(this[w]=E(this[w],...u)),this[m])return;const a=this[r]+M;a<=Date.now()?(this[r]=Date.now(),l.apply(this,[this[w]]),this[w]=d?d():void 0):(this[m]=!0,this[p]=setTimeout(()=>{this[m]=!1,this[r]=Date.now(),l.apply(this,[this[w]]),this[w]=d?d():void 0},a-Date.now()))}})}e.throttle=A}),define(ue[6],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.ReadonlyError=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?f.isErrorNoTelemetry(i)?new f(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(y=>{y(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=v,e.errorHandler=new v;function L(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=L;function S(t){if(!t||typeof t!="object")return!1;const i=t;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=S;function A(t){l(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=A;function M(t){l(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=M;function E(t){if(t instanceof Error){const{name:i,message:y}=t,F=t.stacktrace||t.stack;return{$isError:!0,name:i,message:y,stack:F,noTelemetry:f.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=E;const d="Canceled";function l(t){return t instanceof P?!0:t instanceof Error&&t.name===d&&t.message===d}e.isCancellationError=l;class P extends Error{constructor(){super(d),this.name=this.message}}e.CancellationError=P;function p(){const t=new Error(d);return t.name=t.message,t}e.canceled=p;function w(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=w;function r(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=r;class m extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=m;function u(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=u;class a extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=a;class s extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=s;class o extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=o;class f extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof f)return i;const y=new f;return y.message=i.message,y.stack=i.stack,y}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=f;class n extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,n.prototype)}}e.BugIndicatingError=n}),define(ue[16],he([0,1,6,40]),function(oe,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.reverseOrder=e.booleanComparator=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.forEachWithNeighbors=e.forEachAdjacent=e.groupAdjacentBy=e.groupBy=e.quickSelect=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function S(N,K=0){return N[N.length-(1+K)]}e.tail=S;function A(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.tail2=A;function M(N,K,O=(R,T)=>R===T){if(N===K)return!0;if(!N||!K||N.length!==K.length)return!1;for(let R=0,T=N.length;R<T;R++)if(!O(N[R],K[R]))return!1;return!0}e.equals=M;function E(N,K){const O=N.length-1;K<O&&(N[K]=N[O]),N.pop()}e.removeFastWithoutKeepingOrder=E;function d(N,K,O){return l(N.length,R=>O(N[R],K))}e.binarySearch=d;function l(N,K){let O=0,R=N-1;for(;O<=R;){const T=(O+R)/2|0,V=K(T);if(V<0)O=T+1;else if(V>0)R=T-1;else return T}return-(O+1)}e.binarySearch2=l;function P(N,K,O){if(N=N|0,N>=K.length)throw new TypeError("invalid index");const R=K[Math.floor(K.length*Math.random())],T=[],V=[],Y=[];for(const ie of K){const ce=O(ie,R);ce<0?T.push(ie):ce>0?V.push(ie):Y.push(ie)}return N<T.length?P(N,T,O):N<T.length+Y.length?Y[0]:P(N-(T.length+Y.length),V,O)}e.quickSelect=P;function p(N,K){const O=[];let R;for(const T of N.slice(0).sort(K))!R||K(R[0],T)!==0?(R=[T],O.push(R)):R.push(T);return O}e.groupBy=p;function*w(N,K){let O,R;for(const T of N)R!==void 0&&K(R,T)?O.push(T):(O&&(yield O),O=[T]),R=T;O&&(yield O)}e.groupAdjacentBy=w;function r(N,K){for(let O=0;O<=N.length;O++)K(O===0?void 0:N[O-1],O===N.length?void 0:N[O])}e.forEachAdjacent=r;function m(N,K){for(let O=0;O<N.length;O++)K(O===0?void 0:N[O-1],N[O],O+1===N.length?void 0:N[O+1])}e.forEachWithNeighbors=m;function u(N,K,O){const R=[];function T(ie,ce,pe){if(ce===0&&pe.length===0)return;const ye=R[R.length-1];ye&&ye.start+ye.deleteCount===ie?(ye.deleteCount+=ce,ye.toInsert.push(...pe)):R.push({start:ie,deleteCount:ce,toInsert:pe})}let V=0,Y=0;for(;;){if(V===N.length){T(V,0,K.slice(Y));break}if(Y===K.length){T(V,N.length-V,[]);break}const ie=N[V],ce=K[Y],pe=O(ie,ce);pe===0?(V+=1,Y+=1):pe<0?(T(V,1,[]),V+=1):pe>0&&(T(V,0,[ce]),Y+=1)}return R}e.sortedDiff=u;function a(N,K,O){const R=u(N,K,O),T=[],V=[];for(const Y of R)T.push(...N.slice(Y.start,Y.start+Y.deleteCount)),V.push(...Y.toInsert);return{removed:T,added:V}}e.delta=a;function s(N,K,O){if(O===0)return[];const R=N.slice(0,O).sort(K);return f(N,K,R,O,N.length),R}e.top=s;function o(N,K,O,R,T){return O===0?Promise.resolve([]):new Promise((V,Y)=>{(async()=>{const ie=N.length,ce=N.slice(0,O).sort(K);for(let pe=O,ye=Math.min(O+R,ie);pe<ie;pe=ye,ye=Math.min(ye+R,ie)){if(pe>O&&await new Promise(we=>setTimeout(we)),T&&T.isCancellationRequested)throw new v.CancellationError;f(N,K,ce,pe,ye)}return ce})().then(V,Y)})}e.topAsync=o;function f(N,K,O,R,T){for(const V=O.length;R<T;R++){const Y=N[R];if(K(Y,O[V-1])<0){O.pop();const ie=(0,L.findFirstIdxMonotonousOrArrLen)(O,ce=>K(Y,ce)<0);O.splice(ie,0,Y)}}}function n(N){return N.filter(K=>!!K)}e.coalesce=n;function t(N){let K=0;for(let O=0;O<N.length;O++)N[O]&&(N[K]=N[O],K+=1);N.length=K}e.coalesceInPlace=t;function i(N,K,O){N.splice(O,0,N.splice(K,1)[0])}e.move=i;function y(N){return!Array.isArray(N)||N.length===0}e.isFalsyOrEmpty=y;function F(N){return Array.isArray(N)&&N.length>0}e.isNonEmptyArray=F;function g(N,K=O=>O){const O=new Set;return N.filter(R=>{const T=K(R);return O.has(T)?!1:(O.add(T),!0)})}e.distinct=g;function b(N){const K=new Set;return O=>{const R=N(O);return K.has(R)?!1:(K.add(R),!0)}}e.uniqueFilter=b;function C(N,K){return N.length>0?N[0]:K}e.firstOrDefault=C;function k(N,K){return N.length>0?N[N.length-1]:K}e.lastOrDefault=k;function j(N,K,O=(R,T)=>R===T){let R=0;for(let T=0,V=Math.min(N.length,K.length);T<V&&O(N[T],K[T]);T++)R++;return R}e.commonPrefixLength=j;function B(N){return[].concat(...N)}e.flatten=B;function c(N,K){let O=typeof K=="number"?N:0;typeof K=="number"?O=N:(O=0,K=N);const R=[];if(O<=K)for(let T=O;T<K;T++)R.push(T);else for(let T=O;T>K;T--)R.push(T);return R}e.range=c;function _(N,K,O){return N.reduce((R,T)=>(R[K(T)]=O?O(T):T,R),Object.create(null))}e.index=_;function D(N,K){return N.push(K),()=>W(N,K)}e.insert=D;function W(N,K){const O=N.indexOf(K);if(O>-1)return N.splice(O,1),K}e.remove=W;function I(N,K,O){const R=N.slice(0,K),T=N.slice(K);return R.concat(O,T)}e.arrayInsert=I;function q(N,K){let O;if(typeof K=="number"){let R=K;O=()=>{const T=Math.sin(R++)*179426549;return T-Math.floor(T)}}else O=Math.random;for(let R=N.length-1;R>0;R-=1){const T=Math.floor(O()*(R+1)),V=N[R];N[R]=N[T],N[T]=V}}e.shuffle=q;function ee(N,K){const O=N.indexOf(K);O>-1&&(N.splice(O,1),N.unshift(K))}e.pushToStart=ee;function ne(N,K){const O=N.indexOf(K);O>-1&&(N.splice(O,1),N.push(K))}e.pushToEnd=ne;function Q(N,K){for(const O of K)N.push(O)}e.pushMany=Q;function re(N,K){return Array.isArray(N)?N.map(K):K(N)}e.mapArrayOrNot=re;function le(N){return Array.isArray(N)?N:[N]}e.asArray=le;function de(N){return N[Math.floor(Math.random()*N.length)]}e.getRandomElement=de;function G(N,K,O){const R=X(N,K),T=N.length,V=O.length;N.length=T+V;for(let Y=T-1;Y>=R;Y--)N[Y+V]=N[Y];for(let Y=0;Y<V;Y++)N[Y+R]=O[Y]}e.insertInto=G;function $(N,K,O,R){const T=X(N,K);let V=N.splice(T,O);return V===void 0&&(V=[]),G(N,T,R),V}e.splice=$;function X(N,K){return K<0?Math.max(K+N.length,0):Math.min(K,N.length)}var te;(function(N){function K(V){return V<0}N.isLessThan=K;function O(V){return V<=0}N.isLessThanOrEqual=O;function R(V){return V>0}N.isGreaterThan=R;function T(V){return V===0}N.isNeitherLessOrGreaterThan=T,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(te||(e.CompareResult=te={}));function H(N,K){return(O,R)=>K(N(O),N(R))}e.compareBy=H;function x(...N){return(K,O)=>{for(const R of N){const T=R(K,O);if(!te.isNeitherLessOrGreaterThan(T))return T}return te.neitherLessOrGreaterThan}}e.tieBreakComparators=x;const me=(N,K)=>N-K;e.numberComparator=me;const Z=(N,K)=>(0,e.numberComparator)(N?1:0,K?1:0);e.booleanComparator=Z;function h(N){return(K,O)=>-N(K,O)}e.reverseOrder=h;class U{constructor(K){this.items=K,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(K){let O=this.firstIdx;for(;O<this.items.length&&K(this.items[O]);)O++;const R=O===this.firstIdx?null:this.items.slice(this.firstIdx,O);return this.firstIdx=O,R}takeFromEndWhile(K){let O=this.lastIdx;for(;O>=0&&K(this.items[O]);)O--;const R=O===this.lastIdx?null:this.items.slice(O+1,this.lastIdx+1);return this.lastIdx=O,R}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const K=this.items[this.firstIdx];return this.firstIdx++,K}removeLast(){const K=this.items[this.lastIdx];return this.lastIdx--,K}takeCount(K){const O=this.items.slice(this.firstIdx,this.firstIdx+K);return this.firstIdx+=K,O}}e.ArrayQueue=U;class se{static{this.empty=new se(K=>{})}constructor(K){this.iterate=K}forEach(K){this.iterate(O=>(K(O),!0))}toArray(){const K=[];return this.iterate(O=>(K.push(O),!0)),K}filter(K){return new se(O=>this.iterate(R=>K(R)?O(R):!0))}map(K){return new se(O=>this.iterate(R=>O(K(R))))}some(K){let O=!1;return this.iterate(R=>(O=K(R),!O)),O}findFirst(K){let O;return this.iterate(R=>K(R)?(O=R,!1):!0),O}findLast(K){let O;return this.iterate(R=>(K(R)&&(O=R),!0)),O}findLastMaxBy(K){let O,R=!0;return this.iterate(T=>((R||te.isGreaterThan(K(T,O)))&&(R=!1,O=T),!0)),O}}e.CallbackIterable=se}),define(ue[42],he([0,1,6]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.softAssert=e.assert=e.assertNever=e.ok=void 0;function L(l,P){if(!l)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}e.ok=L;function S(l,P="Unreachable"){throw new Error(P)}e.assertNever=S;function A(l){if(!l)throw new v.BugIndicatingError("Assertion Failed")}e.assert=A;function M(l){l||(0,v.onUnexpectedError)(new v.BugIndicatingError("Assertion Failed"))}e.softAssert=M;function E(l){if(!l()){debugger;l(),(0,v.onUnexpectedError)(new v.BugIndicatingError("Assertion Failed"))}}e.assertFn=E;function d(l,P){let p=0;for(;p<l.length-1;){const w=l[p],r=l[p+1];if(!P(w,r))return!1;p++}return!0}e.checkAdjacentItems=d}),define(ue[29],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=void 0;function v(L,S){const A=this;let M=!1,E;return function(){if(M)return E;if(M=!0,S)try{E=L.apply(A,arguments)}finally{S()}else E=L.apply(A,arguments);return E}}e.createSingleCallFunction=v}),define(ue[43],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(L){function S(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}L.is=S;const A=Object.freeze([]);function M(){return A}L.empty=M;function*E(i){yield i}L.single=E;function d(i){return S(i)?i:E(i)}L.wrap=d;function l(i){return i||A}L.from=l;function*P(i){for(let y=i.length-1;y>=0;y--)yield i[y]}L.reverse=P;function p(i){return!i||i[Symbol.iterator]().next().done===!0}L.isEmpty=p;function w(i){return i[Symbol.iterator]().next().value}L.first=w;function r(i,y){for(const F of i)if(y(F))return!0;return!1}L.some=r;function m(i,y){for(const F of i)if(y(F))return F}L.find=m;function*u(i,y){for(const F of i)y(F)&&(yield F)}L.filter=u;function*a(i,y){let F=0;for(const g of i)yield y(g,F++)}L.map=a;function*s(...i){for(const y of i)yield*y}L.concat=s;function o(i,y,F){let g=F;for(const b of i)g=y(g,b);return g}L.reduce=o;function*f(i,y,F=i.length){for(y<0&&(y+=i.length),F<0?F+=i.length:F>i.length&&(F=i.length);y<F;y++)yield i[y]}L.slice=f;function n(i,y=Number.POSITIVE_INFINITY){const F=[];if(y===0)return[F,i];const g=i[Symbol.iterator]();for(let b=0;b<y;b++){const C=g.next();if(C.done)return[F,L.empty()];F.push(C.value)}return[F,{[Symbol.iterator](){return g}}]}L.consume=n;async function t(i){const y=[];for await(const F of i)y.push(F);return Promise.resolve(y)}L.asyncToArray=t})(v||(e.Iterable=v={}))}),define(ue[22],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(S){this.executor=S,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(S){this._error=S}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=v}),define(ue[44],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{static{this.Undefined=new v(void 0)}constructor(A){this.element=A,this.next=v.Undefined,this.prev=v.Undefined}}class L{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let A=this._first;for(;A!==v.Undefined;){const M=A.next;A.prev=v.Undefined,A.next=v.Undefined,A=M}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,M){const E=new v(A);if(this._first===v.Undefined)this._first=E,this._last=E;else if(M){const l=this._last;this._last=E,E.prev=l,l.next=E}else{const l=this._first;this._first=E,E.next=l,l.prev=E}this._size+=1;let d=!1;return()=>{d||(d=!0,this._remove(E))}}shift(){if(this._first!==v.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==v.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==v.Undefined&&A.next!==v.Undefined){const M=A.prev;M.next=A.next,A.next.prev=M}else A.prev===v.Undefined&&A.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):A.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):A.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==v.Undefined;)yield A.element,A=A.next}}e.LinkedList=L}),define(ue[25],he([0,1]),function(oe,e){"use strict";var v,L,S;Object.defineProperty(e,"__esModule",{value:!0}),e.mapsStrictEqualIgnoreOrder=e.SetMap=e.BidirectionalMap=e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(f,n,t){let i=f.get(n);return i===void 0&&(i=t,f.set(n,i)),i}e.getOrSet=A;function M(f){const n=[];return f.forEach((t,i)=>{n.push(`${i} => ${t}`)}),`Map(${f.size}) {${n.join(", ")}}`}e.mapToString=M;function E(f){const n=[];return f.forEach(t=>{n.push(t)}),`Set(${f.size}) {${n.join(", ")}}`}e.setToString=E;class d{constructor(n,t){this.uri=n,this.value=t}}function l(f){return Array.isArray(f)}class P{static{this.defaultToKey=n=>n.toString()}constructor(n,t){if(this[v]="ResourceMap",n instanceof P)this.map=new Map(n.map),this.toKey=t??P.defaultToKey;else if(l(n)){this.map=new Map,this.toKey=t??P.defaultToKey;for(const[i,y]of n)this.set(i,y)}else this.map=new Map,this.toKey=n??P.defaultToKey}set(n,t){return this.map.set(this.toKey(n),new d(n,t)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,t){typeof t<"u"&&(n=n.bind(t));for(const[i,y]of this.map)n(y.value,y.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(v=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=P;class p{constructor(n,t){this[L]="ResourceSet",!n||typeof n=="function"?this._map=new P(n):(this._map=new P(t),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,t){this._map.forEach((i,y)=>n.call(t,y,y,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=p;var w;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class r{constructor(){this[S]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,t=0){const i=this._map.get(n);if(i)return t!==0&&this.touch(i,t),i.value}set(n,t,i=0){let y=this._map.get(n);if(y)y.value=t,i!==0&&this.touch(y,i);else{switch(y={key:n,value:t,next:void 0,previous:void 0},i){case 0:this.addItemLast(y);break;case 1:this.addItemFirst(y);break;case 2:this.addItemLast(y);break;default:this.addItemLast(y);break}this._map.set(n,y),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const t=this._map.get(n);if(t)return this._map.delete(n),this.removeItem(t),this._size--,t.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,t){const i=this._state;let y=this._head;for(;y;){if(t?n.bind(t)(y.value,y.key,this):n(y.value,y.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");y=y.next}}keys(){const n=this,t=this._state;let i=this._head;const y={[Symbol.iterator](){return y},next(){if(n._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const F={value:i.key,done:!1};return i=i.next,F}else return{value:void 0,done:!0}}};return y}values(){const n=this,t=this._state;let i=this._head;const y={[Symbol.iterator](){return y},next(){if(n._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const F={value:i.value,done:!1};return i=i.next,F}else return{value:void 0,done:!0}}};return y}entries(){const n=this,t=this._state;let i=this._head;const y={[Symbol.iterator](){return y},next(){if(n._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const F={value:[i.key,i.value],done:!1};return i=i.next,F}else return{value:void 0,done:!0}}};return y}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let t=this._head,i=this.size;for(;t&&i>n;)this._map.delete(t.key),t=t.next,i--;this._head=t,this._size=i,t&&(t.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const t=n.next,i=n.previous;if(!t||!i)throw new Error("Invalid list");t.previous=i,i.next=t}n.next=void 0,n.previous=void 0,this._state++}touch(n,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(n===this._head)return;const i=n.next,y=n.previous;n===this._tail?(y.next=void 0,this._tail=y):(i.previous=y,y.next=i),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(t===2){if(n===this._tail)return;const i=n.next,y=n.previous;n===this._head?(i.previous=void 0,this._head=i):(i.previous=y,y.next=i),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((t,i)=>{n.push([i,t])}),n}fromJSON(n){this.clear();for(const[t,i]of n)this.set(t,i)}}e.LinkedMap=r;class m extends r{constructor(n,t=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,t=2){return super.get(n,t)}peek(n){return super.get(n,0)}set(n,t){return super.set(n,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=m;class u{constructor(){this.map=new Map}add(n){return this.map.set(n,(this.map.get(n)||0)+1),this}delete(n){let t=this.map.get(n)||0;return t===0?!1:(t--,t===0?this.map.delete(n):this.map.set(n,t),!0)}has(n){return this.map.has(n)}}e.CounterSet=u;class a{constructor(n){if(this._m1=new Map,this._m2=new Map,n)for(const[t,i]of n)this.set(t,i)}clear(){this._m1.clear(),this._m2.clear()}set(n,t){this._m1.set(n,t),this._m2.set(t,n)}get(n){return this._m1.get(n)}getKey(n){return this._m2.get(n)}delete(n){const t=this._m1.get(n);return t===void 0?!1:(this._m1.delete(n),this._m2.delete(t),!0)}forEach(n,t){this._m1.forEach((i,y)=>{n.call(t,i,y,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=a;class s{constructor(){this.map=new Map}add(n,t){let i=this.map.get(n);i||(i=new Set,this.map.set(n,i)),i.add(t)}delete(n,t){const i=this.map.get(n);i&&(i.delete(t),i.size===0&&this.map.delete(n))}forEach(n,t){const i=this.map.get(n);i&&i.forEach(t)}get(n){const t=this.map.get(n);return t||new Set}}e.SetMap=s;function o(f,n){if(f===n)return!0;if(f.size!==n.size)return!1;for(const[t,i]of f)if(!n.has(t)||n.get(t)!==i)return!1;for(const[t]of n)if(!f.has(t))return!1;return!0}e.mapsStrictEqualIgnoreOrder=o}),define(ue[2],he([0,1,16,41,25,29,43]),function(oe,e,v,L,S,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.markAsDisposed=e.trackDisposable=e.setDisposableTracker=e.DisposableTracker=void 0;const E=!1;let d=null;class l{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(D){let W=this.livingDisposables.get(D);return W||(W={parent:null,source:null,isSingleton:!1,value:D,idx:l.idx++},this.livingDisposables.set(D,W)),W}trackDisposable(D){const W=this.getDisposableData(D);W.source||(W.source=new Error().stack)}setParent(D,W){const I=this.getDisposableData(D);I.parent=W}markAsDisposed(D){this.livingDisposables.delete(D)}markAsSingleton(D){this.getDisposableData(D).isSingleton=!0}getRootParent(D,W){const I=W.get(D);if(I)return I;const q=D.parent?this.getRootParent(this.getDisposableData(D.parent),W):D;return W.set(D,q),q}getTrackedDisposables(){const D=new Map;return[...this.livingDisposables.entries()].filter(([,I])=>I.source!==null&&!this.getRootParent(I,D).isSingleton).flatMap(([I])=>I)}computeLeakingDisposables(D=10,W){let I;if(W)I=W;else{const re=new Map,le=[...this.livingDisposables.values()].filter(G=>G.source!==null&&!this.getRootParent(G,re).isSingleton);if(le.length===0)return;const de=new Set(le.map(G=>G.value));if(I=le.filter(G=>!(G.parent&&de.has(G.parent))),I.length===0)throw new Error("There are cyclic diposable chains!")}if(!I)return;function q(re){function le(G,$){for(;G.length>0&&$.some(X=>typeof X=="string"?X===G[0]:G[0].match(X));)G.shift()}const de=re.source.split(`
`).map(G=>G.trim().replace("at ","")).filter(G=>G!=="");return le(de,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),de.reverse()}const ee=new S.SetMap;for(const re of I){const le=q(re);for(let de=0;de<=le.length;de++)ee.add(le.slice(0,de).join(`
`),re)}I.sort((0,v.compareBy)(re=>re.idx,v.numberComparator));let ne="",Q=0;for(const re of I.slice(0,D)){Q++;const le=q(re),de=[];for(let G=0;G<le.length;G++){let $=le[G];$=`(shared with ${ee.get(le.slice(0,G+1).join(`
`)).size}/${I.length} leaks) at ${$}`;const te=ee.get(le.slice(0,G).join(`
`)),H=(0,L.groupBy)([...te].map(x=>q(x)[G]),x=>x);delete H[le[G]];for(const[x,me]of Object.entries(H))de.unshift(`    - stacktraces of ${me.length} other leaks continue with ${x}`);de.unshift($)}ne+=`


==================== Leaking disposable ${Q}/${I.length}: ${re.value.constructor.name} ====================
${de.join(`
`)}
============================================================

`}return I.length>D&&(ne+=`


... and ${I.length-D} more leaking disposables

`),{leaks:I,details:ne}}}e.DisposableTracker=l;function P(_){d=_}if(e.setDisposableTracker=P,E){const _="__is_disposable_tracked__";P(new class{trackDisposable(D){const W=new Error("Potentially leaked disposable").stack;setTimeout(()=>{D[_]||console.log(W)},3e3)}setParent(D,W){if(D&&D!==i.None)try{D[_]=!0}catch{}}markAsDisposed(D){if(D&&D!==i.None)try{D[_]=!0}catch{}}markAsSingleton(D){}})}function p(_){return d?.trackDisposable(_),_}e.trackDisposable=p;function w(_){d?.markAsDisposed(_)}e.markAsDisposed=w;function r(_,D){d?.setParent(_,D)}function m(_,D){if(d)for(const W of _)d.setParent(W,D)}function u(_){return d?.markAsSingleton(_),_}e.markAsSingleton=u;function a(_){return typeof _.dispose=="function"&&_.dispose.length===0}e.isDisposable=a;function s(_){if(M.Iterable.is(_)){const D=[];for(const W of _)if(W)try{W.dispose()}catch(I){D.push(I)}if(D.length===1)throw D[0];if(D.length>1)throw new AggregateError(D,"Encountered errors while disposing of store");return Array.isArray(_)?[]:_}else if(_)return _.dispose(),_}e.dispose=s;function o(_){for(const D of _)a(D)&&D.dispose();return[]}e.disposeIfDisposable=o;function f(..._){const D=n(()=>s(_));return m(_,D),D}e.combinedDisposable=f;function n(_){const D=p({dispose:(0,A.createSingleCallFunction)(()=>{w(D),_()})});return D}e.toDisposable=n;class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,p(this)}dispose(){this._isDisposed||(w(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{s(this._toDispose)}finally{this._toDispose.clear()}}add(D){if(!D)return D;if(D===this)throw new Error("Cannot register a disposable on itself!");return r(D,this),this._isDisposed?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(D),D}delete(D){if(D){if(D===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(D),D.dispose()}}deleteAndLeak(D){D&&this._toDispose.has(D)&&(this._toDispose.delete(D),r(D,null))}}e.DisposableStore=t;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new t,p(this),r(this._store,this)}dispose(){w(this),this._store.dispose()}_register(D){if(D===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(D)}}e.Disposable=i;class y{constructor(){this._isDisposed=!1,p(this)}get value(){return this._isDisposed?void 0:this._value}set value(D){this._isDisposed||D===this._value||(this._value?.dispose(),D&&r(D,this),this._value=D)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,w(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const D=this._value;return this._value=void 0,D&&r(D,null),D}}e.MutableDisposable=y;class F{constructor(D){this._disposable=new y,this._isDisposed=!1,this._disposable.value=D}get value(){return this._disposable.value}set value(D){this._isDisposed||D===this._disposable.value||(this._disposable.value=D)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=F;class g{constructor(D){this._disposable=D,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=g;class b{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,p(this)}set(D){let W=D;return this.unset=()=>W=void 0,this.isset=()=>W!==void 0,this.dispose=()=>{W&&(W(),W=void 0,w(this))},this}}e.SafeDisposable=b;class C{constructor(){this.references=new Map}acquire(D,...W){let I=this.references.get(D);I||(I={counter:0,object:this.createReferencedObject(D,...W)},this.references.set(D,I));const{object:q}=I,ee=(0,A.createSingleCallFunction)(()=>{--I.counter===0&&(this.destroyReferencedObject(D,I.object),this.references.delete(D))});return I.counter++,{object:q,dispose:ee}}}e.ReferenceCollection=C;class k{constructor(D){this.referenceCollection=D}async acquire(D,...W){const I=this.referenceCollection.acquire(D,...W);try{return{object:await I.object,dispose:()=>I.dispose()}}catch(q){throw I.dispose(),q}}}e.AsyncReferenceCollection=k;class j{constructor(D){this.object=D}dispose(){}}e.ImmortalReference=j;function B(_){const D=new t;try{_(D)}finally{D.dispose()}}e.disposeOnReturn=B;class c{constructor(){this._store=new Map,this._isDisposed=!1,p(this)}dispose(){w(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{s(this._store.values())}finally{this._store.clear()}}has(D){return this._store.has(D)}get size(){return this._store.size}get(D){return this._store.get(D)}set(D,W,I=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),I||this._store.get(D)?.dispose(),this._store.set(D,W)}deleteAndDispose(D){this._store.get(D)?.dispose(),this._store.delete(D)}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=c}),define(ue[45],he([0,1,25]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new v.LRUCache(1e4);function S(l){return d(l,"NFC",L)}e.normalizeNFC=S;const A=new v.LRUCache(1e4);function M(l){return d(l,"NFD",A)}e.normalizeNFD=M;const E=/[^\u0000-\u0080]/;function d(l,P,p){if(!l)return l;const w=p.get(l);if(w)return w;let r;return E.test(l)?r=l.normalize(P):r=l,p.set(l,r),r}e.removeAccents=function(){const l=/[\u0300-\u036f]/g;return function(P){return M(P).replace(l,"")}}()}),function(){function oe(S){const A=[];typeof S=="number"&&A.push("code/timeOrigin",S);function M(d){A.push(d,Date.now())}function E(){const d=[];for(let l=0;l<A.length;l+=2)d.push({name:A[l],startTime:A[l+1]});return d}return{mark:M,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const M of performance.getEntriesByType("mark"))A.push({name:M.name,startTime:Math.round(S+M.startTime)});return A}};if(typeof process=="object"){const S=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function v(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=v(L))}(),define(ue[46],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const v=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(A){return new L(A)}constructor(A){this._now=v&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=L}),define(ue[4],he([0,1,6,29,2,44,46]),function(oe,e,v,L,S,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const E=!1,d=!1;var l;(function(B){B.None=()=>S.Disposable.None;function c(T){if(d){const{onDidAddListener:V}=T,Y=m.create();let ie=0;T.onDidAddListener=()=>{++ie===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),V?.()}}}function _(T,V){return de(T,()=>{},0,void 0,!0,void 0,V)}B.defer=_;function D(T){return(V,Y=null,ie)=>{let ce=!1,pe;return pe=T(ye=>{if(!ce)return pe?pe.dispose():ce=!0,V.call(Y,ye)},null,ie),ce&&pe.dispose(),pe}}B.once=D;function W(T,V,Y){return re((ie,ce=null,pe)=>T(ye=>ie.call(ce,V(ye)),null,pe),Y)}B.map=W;function I(T,V,Y){return re((ie,ce=null,pe)=>T(ye=>{V(ye),ie.call(ce,ye)},null,pe),Y)}B.forEach=I;function q(T,V,Y){return re((ie,ce=null,pe)=>T(ye=>V(ye)&&ie.call(ce,ye),null,pe),Y)}B.filter=q;function ee(T){return T}B.signal=ee;function ne(...T){return(V,Y=null,ie)=>{const ce=(0,S.combinedDisposable)(...T.map(pe=>pe(ye=>V.call(Y,ye))));return le(ce,ie)}}B.any=ne;function Q(T,V,Y,ie){let ce=Y;return W(T,pe=>(ce=V(ce,pe),ce),ie)}B.reduce=Q;function re(T,V){let Y;const ie={onWillAddFirstListener(){Y=T(ce.fire,ce)},onDidRemoveLastListener(){Y?.dispose()}};V||c(ie);const ce=new f(ie);return V?.add(ce),ce.event}function le(T,V){return V instanceof Array?V.push(T):V&&V.add(T),T}function de(T,V,Y=100,ie=!1,ce=!1,pe,ye){let we,Ce,Ie,Me=0,Re;const Fe={leakWarningThreshold:pe,onWillAddFirstListener(){we=T(ze=>{Me++,Ce=V(Ce,ze),ie&&!Ie&&(Se.fire(Ce),Ce=void 0),Re=()=>{const qe=Ce;Ce=void 0,Ie=void 0,(!ie||Me>1)&&Se.fire(qe),Me=0},typeof Y=="number"?(clearTimeout(Ie),Ie=setTimeout(Re,Y)):Ie===void 0&&(Ie=0,queueMicrotask(Re))})},onWillRemoveListener(){ce&&Me>0&&Re?.()},onDidRemoveLastListener(){Re=void 0,we.dispose()}};ye||c(Fe);const Se=new f(Fe);return ye?.add(Se),Se.event}B.debounce=de;function G(T,V=0,Y){return B.debounce(T,(ie,ce)=>ie?(ie.push(ce),ie):[ce],V,void 0,!0,void 0,Y)}B.accumulate=G;function $(T,V=(ie,ce)=>ie===ce,Y){let ie=!0,ce;return q(T,pe=>{const ye=ie||!V(pe,ce);return ie=!1,ce=pe,ye},Y)}B.latch=$;function X(T,V,Y){return[B.filter(T,V,Y),B.filter(T,ie=>!V(ie),Y)]}B.split=X;function te(T,V=!1,Y=[],ie){let ce=Y.slice(),pe=T(Ce=>{ce?ce.push(Ce):we.fire(Ce)});ie&&ie.add(pe);const ye=()=>{ce?.forEach(Ce=>we.fire(Ce)),ce=null},we=new f({onWillAddFirstListener(){pe||(pe=T(Ce=>we.fire(Ce)),ie&&ie.add(pe))},onDidAddFirstListener(){ce&&(V?setTimeout(ye):ye())},onDidRemoveLastListener(){pe&&pe.dispose(),pe=null}});return ie&&ie.add(we),we.event}B.buffer=te;function H(T,V){return(ie,ce,pe)=>{const ye=V(new me);return T(function(we){const Ce=ye.evaluate(we);Ce!==x&&ie.call(ce,Ce)},void 0,pe)}}B.chain=H;const x=Symbol("HaltChainable");class me{constructor(){this.steps=[]}map(V){return this.steps.push(V),this}forEach(V){return this.steps.push(Y=>(V(Y),Y)),this}filter(V){return this.steps.push(Y=>V(Y)?Y:x),this}reduce(V,Y){let ie=Y;return this.steps.push(ce=>(ie=V(ie,ce),ie)),this}latch(V=(Y,ie)=>Y===ie){let Y=!0,ie;return this.steps.push(ce=>{const pe=Y||!V(ce,ie);return Y=!1,ie=ce,pe?ce:x}),this}evaluate(V){for(const Y of this.steps)if(V=Y(V),V===x)break;return V}}function Z(T,V,Y=ie=>ie){const ie=(...we)=>ye.fire(Y(...we)),ce=()=>T.on(V,ie),pe=()=>T.removeListener(V,ie),ye=new f({onWillAddFirstListener:ce,onDidRemoveLastListener:pe});return ye.event}B.fromNodeEventEmitter=Z;function h(T,V,Y=ie=>ie){const ie=(...we)=>ye.fire(Y(...we)),ce=()=>T.addEventListener(V,ie),pe=()=>T.removeEventListener(V,ie),ye=new f({onWillAddFirstListener:ce,onDidRemoveLastListener:pe});return ye.event}B.fromDOMEventEmitter=h;function U(T){return new Promise(V=>D(T)(V))}B.toPromise=U;function se(T){const V=new f;return T.then(Y=>{V.fire(Y)},()=>{V.fire(void 0)}).finally(()=>{V.dispose()}),V.event}B.fromPromise=se;function N(T,V,Y){return V(Y),T(ie=>V(ie))}B.runAndSubscribe=N;class K{constructor(V,Y){this._observable=V,this._counter=0,this._hasChanged=!1;const ie={onWillAddFirstListener:()=>{V.addObserver(this)},onDidRemoveLastListener:()=>{V.removeObserver(this)}};Y||c(ie),this.emitter=new f(ie),Y&&Y.add(this.emitter)}beginUpdate(V){this._counter++}handlePossibleChange(V){}handleChange(V,Y){this._hasChanged=!0}endUpdate(V){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function O(T,V){return new K(T,V).emitter.event}B.fromObservable=O;function R(T){return(V,Y,ie)=>{let ce=0,pe=!1;const ye={beginUpdate(){ce++},endUpdate(){ce--,ce===0&&(T.reportChanges(),pe&&(pe=!1,V.call(Y)))},handlePossibleChange(){},handleChange(){pe=!0}};T.addObserver(ye),T.reportChanges();const we={dispose(){T.removeObserver(ye)}};return ie instanceof S.DisposableStore?ie.add(we):Array.isArray(ie)&&ie.push(we),we}}B.fromObservableLight=R})(l||(e.Event=l={}));class P{static{this.all=new Set}static{this._idPool=0}constructor(c){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${c}_${P._idPool++}`,P.all.add(this)}start(c){this._stopWatch=new M.StopWatch,this.listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this.durations.push(c),this.elapsedOverall+=c,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=P;let p=-1;function w(B){const c=p;return p=B,{dispose(){p=c}}}e.setGlobalLeakWarningThreshold=w;class r{constructor(c,_=Math.random().toString(18).slice(2,5)){this.threshold=c,this.name=_,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(c,_){const D=this.threshold;if(D<=0||_<D)return;this._stacks||(this._stacks=new Map);const W=this._stacks.get(c.value)||0;if(this._stacks.set(c.value,W+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=D*.5;let I,q=0;for(const[ee,ne]of this._stacks)(!I||q<ne)&&(I=ee,q=ne);console.warn(`[${this.name}] potential listener LEAK detected, having ${_} listeners already. MOST frequent listener (${q}):`),console.warn(I)}return()=>{const I=this._stacks.get(c.value)||0;this._stacks.set(c.value,I-1)}}}class m{static create(){return new m(new Error().stack??"")}constructor(c){this.value=c}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let u=0;class a{constructor(c){this.value=c,this.id=u++}}const s=2,o=(B,c)=>{if(B instanceof a)c(B);else for(let _=0;_<B.length;_++){const D=B[_];D&&c(D)}};class f{constructor(c){this._size=0,this._options=c,this._leakageMon=p>0||this._options?.leakWarningThreshold?new r(this._options?.leakWarningThreshold??p):void 0,this._perfMon=this._options?._profName?new P(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(E){const c=this._listeners;queueMicrotask(()=>{o(c,_=>_.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(c,_,D)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),S.Disposable.None;if(this._disposed)return S.Disposable.None;_&&(c=c.bind(_));const W=new a(c);let I,q;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(W.stack=m.create(),I=this._leakageMon.check(W.stack,this._size+1)),E&&(W.stack=q??m.create()),this._listeners?this._listeners instanceof a?(this._deliveryQueue??=new t,this._listeners=[this._listeners,W]):this._listeners.push(W):(this._options?.onWillAddFirstListener?.(this),this._listeners=W,this._options?.onDidAddFirstListener?.(this)),this._size++;const ee=(0,S.toDisposable)(()=>{I?.(),this._removeListener(W)});return D instanceof S.DisposableStore?D.add(ee):Array.isArray(D)&&D.push(ee),ee},this._event}_removeListener(c){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const _=this._listeners,D=_.indexOf(c);if(D===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,_[D]=void 0;const W=this._deliveryQueue.current===this;if(this._size*s<=_.length){let I=0;for(let q=0;q<_.length;q++)_[q]?_[I++]=_[q]:W&&(this._deliveryQueue.end--,I<this._deliveryQueue.i&&this._deliveryQueue.i--);_.length=I}}_deliver(c,_){if(!c)return;const D=this._options?.onListenerError||v.onUnexpectedError;if(!D){c.value(_);return}try{c.value(_)}catch(W){D(W)}}_deliverQueue(c){const _=c.current._listeners;for(;c.i<c.end;)this._deliver(_[c.i++],c.value);c.reset()}fire(c){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof a)this._deliver(this._listeners,c);else{const _=this._deliveryQueue;_.enqueue(this,c,this._listeners.length),this._deliverQueue(_)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=f;const n=()=>new t;e.createEventDeliveryQueue=n;class t{constructor(){this.i=-1,this.end=0}enqueue(c,_,D){this.i=0,this.end=D,this.current=c,this.value=_}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends f{async fireAsync(c,_,D){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList),o(this._listeners,W=>this._asyncDeliveryQueue.push([W.value,c]));this._asyncDeliveryQueue.size>0&&!_.isCancellationRequested;){const[W,I]=this._asyncDeliveryQueue.shift(),q=[],ee={...I,token:_,waitUntil:ne=>{if(Object.isFrozen(q))throw new Error("waitUntil can NOT be called asynchronous");D&&(ne=D(ne,W)),q.push(ne)}};try{W(ee)}catch(ne){(0,v.onUnexpectedError)(ne);continue}Object.freeze(q),await Promise.allSettled(q).then(ne=>{for(const Q of ne)Q.status==="rejected"&&(0,v.onUnexpectedError)(Q.reason)})}}}e.AsyncEmitter=i;class y extends f{get isPaused(){return this._isPaused!==0}constructor(c){super(c),this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._size&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=y;class F extends y{constructor(c){super(c),this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=F;class g extends f{constructor(c){super(c),this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){this.hasListeners()&&(this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(_=>super.fire(_)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=g;class b{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const _={event:c,listener:null};this.events.push(_),this.hasListeners&&this.hook(_);const D=()=>{this.hasListeners&&this.unhook(_);const W=this.events.indexOf(_);this.events.splice(W,1)};return(0,S.toDisposable)((0,L.createSingleCallFunction)(D))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(_=>this.emitter.fire(_))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=b;class C{constructor(c,_,D,W){this._store=new S.DisposableStore;const I=this._store.add(new b),q=this._store.add(new S.DisposableMap);function ee(ne){q.set(ne,I.add(W(ne)))}for(const ne of c)ee(ne);this._store.add(_(ne=>{ee(ne)})),this._store.add(D(ne=>{q.deleteAndDispose(ne)})),this.event=I.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=C;class k{constructor(){this.buffers=[]}wrapEvent(c){return(_,D,W)=>c(I=>{const q=this.buffers[this.buffers.length-1];q?q.push(()=>_.call(D,I)):_.call(D,I)},void 0,W)}bufferEvents(c){const _=[];this.buffers.push(_);const D=c();return this.buffers.pop(),_.forEach(W=>W()),D}}e.EventBufferer=k;class j{constructor(){this.listening=!1,this.inputEvent=l.None,this.inputEventListener=S.Disposable.None,this.emitter=new f({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=j}),define(ue[17],he([0,1,4]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(E,d){const l=setTimeout(E.bind(d),0);return{dispose(){clearTimeout(l)}}});var S;(function(E){function d(l){return l===E.None||l===E.Cancelled||l instanceof A?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}E.isCancellationToken=d,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(S||(e.CancellationToken=S={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(d){this._token=void 0,this._parentListener=void 0,this._parentListener=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=S.Cancelled}dispose(d=!1){d&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=S.None}}e.CancellationTokenSource=M}),define(ue[47],he([0,1,17]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class L{constructor(E){this.task=E,this.result=null}get(){if(this.result)return this.result;const E=new v.CancellationTokenSource,d=this.task(E.token);return this.result={promise:d,dispose:()=>{this.result=null,E.cancel(),E.dispose()}},this.result}}e.Cache=L;class S{constructor(E){this.fn=E,this.lastCache=void 0,this.lastArgKey=void 0}get(E){const d=JSON.stringify(E);return this.lastArgKey!==d&&(this.lastArgKey=d,this.lastCache=this.fn(E)),this.lastCache}}e.LRUCachedFunction=S;class A{get cachedValues(){return this._map}constructor(E){this.fn=E,this._map=new Map}get(E){if(this._map.has(E))return this._map.get(E);const d=this.fn(E);return this._map.set(E,d),d}}e.CachedFunction=A}),define(ue[48],he([0,1,6,2]),function(oe,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function S(n){const t=n;return t?typeof t.read=="function":!1}e.isReadable=S;function A(n){const t=n;return t?[t.on,t.pause,t.resume,t.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=A;function M(n){const t=n;return t?A(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}e.isReadableBufferedStream=M;function E(n,t){return new d(n,t)}e.newWriteableStream=E;class d{constructor(t,i){this.reducer=t,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(t){if(!this.state.destroyed){if(this.state.flowing)this.emitData(t);else if(this.buffer.data.push(t),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(t){this.state.destroyed||(this.state.flowing?this.emitError(t):this.buffer.error.push(t))}end(t){this.state.destroyed||(typeof t<"u"&&this.write(t),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(t){this.listeners.data.slice(0).forEach(i=>i(t))}emitError(t){this.listeners.error.length===0?(0,v.onUnexpectedError)(t):this.listeners.error.slice(0).forEach(i=>i(t))}emitEnd(){this.listeners.end.slice(0).forEach(t=>t())}on(t,i){if(!this.state.destroyed)switch(t){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(t,i){if(this.state.destroyed)return;let y;switch(t){case"data":y=this.listeners.data;break;case"end":y=this.listeners.end;break;case"error":y=this.listeners.error;break}if(y){const F=y.indexOf(i);F>=0&&y.splice(F,1)}}flowData(){if(this.buffer.data.length>0){const t=this.reducer(this.buffer.data);this.emitData(t),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(y=>y())}}flowErrors(){if(this.listeners.error.length>0){for(const t of this.buffer.error)this.emitError(t);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(n,t){const i=[];let y;for(;(y=n.read())!==null;)i.push(y);return t(i)}e.consumeReadable=l;function P(n,t,i){const y=[];let F;for(;(F=n.read())!==null&&y.length<i;)y.push(F);return F===null&&y.length>0?t(y):{read:()=>{if(y.length>0)return y.shift();if(typeof F<"u"){const g=F;return F=void 0,g}return n.read()}}}e.peekReadable=P;function p(n,t){return new Promise((i,y)=>{const F=[];w(n,{onData:g=>{t&&F.push(g)},onError:g=>{t?y(g):i(void 0)},onEnd:()=>{i(t?t(F):void 0)}})})}e.consumeStream=p;function w(n,t,i){n.on("error",y=>{i?.isCancellationRequested||t.onError(y)}),n.on("end",()=>{i?.isCancellationRequested||t.onEnd()}),n.on("data",y=>{i?.isCancellationRequested||t.onData(y)})}e.listenStream=w;function r(n,t){return new Promise((i,y)=>{const F=new L.DisposableStore,g=[],b=j=>{if(g.push(j),g.length>t)return F.dispose(),n.pause(),i({stream:n,buffer:g,ended:!1})},C=j=>(F.dispose(),y(j)),k=()=>(F.dispose(),i({stream:n,buffer:g,ended:!0}));F.add((0,L.toDisposable)(()=>n.removeListener("error",C))),n.on("error",C),F.add((0,L.toDisposable)(()=>n.removeListener("end",k))),n.on("end",k),F.add((0,L.toDisposable)(()=>n.removeListener("data",b))),n.on("data",b)})}e.peekStream=r;function m(n,t){const i=E(t);return i.end(n),i}e.toStream=m;function u(){const n=E(()=>{throw new Error("not supported")});return n.end(),n}e.emptyStream=u;function a(n){let t=!1;return{read:()=>t?null:(t=!0,n)}}e.toReadable=a;function s(n,t,i){const y=E(i);return w(n,{onData:F=>y.write(t.data(F)),onError:F=>y.error(t.error?t.error(F):F),onEnd:()=>y.end()}),y}e.transform=s;function o(n,t,i){let y=!1;return{read:()=>{const F=t.read();return y?F:(y=!0,F!==null?i([n,F]):n)}}}e.prefixedReadable=o;function f(n,t,i){let y=!1;const F=E(i);return w(t,{onData:g=>y?F.write(g):(y=!0,F.write(i([n,g]))),onError:g=>F.error(g),onEnd:()=>{y||(y=!0,F.write(n)),F.end()}}),F}e.prefixedStream=f}),define(ue[18],he([0,1,22,48]),function(oe,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const S=typeof Buffer<"u",A=new v.Lazy(()=>new Uint8Array(256));let M,E;class d{static alloc(_){return S?new d(Buffer.allocUnsafe(_)):new d(new Uint8Array(_))}static wrap(_){return S&&!Buffer.isBuffer(_)&&(_=Buffer.from(_.buffer,_.byteOffset,_.byteLength)),new d(_)}static fromString(_,D){return!(D?.dontUseNodeBuffer||!1)&&S?new d(Buffer.from(_)):(M||(M=new TextEncoder),new d(M.encode(_)))}static fromByteArray(_){const D=d.alloc(_.length);for(let W=0,I=_.length;W<I;W++)D.buffer[W]=_[W];return D}static concat(_,D){if(typeof D>"u"){D=0;for(let q=0,ee=_.length;q<ee;q++)D+=_[q].byteLength}const W=d.alloc(D);let I=0;for(let q=0,ee=_.length;q<ee;q++){const ne=_[q];W.set(ne,I),I+=ne.byteLength}return W}constructor(_){this.buffer=_,this.byteLength=this.buffer.byteLength}clone(){const _=d.alloc(this.byteLength);return _.set(this),_}toString(){return S?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(_,D){return new d(this.buffer.subarray(_,D))}set(_,D){if(_ instanceof d)this.buffer.set(_.buffer,D);else if(_ instanceof Uint8Array)this.buffer.set(_,D);else if(_ instanceof ArrayBuffer)this.buffer.set(new Uint8Array(_),D);else if(ArrayBuffer.isView(_))this.buffer.set(new Uint8Array(_.buffer,_.byteOffset,_.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(_){return w(this.buffer,_)}writeUInt32BE(_,D){r(this.buffer,_,D)}readUInt32LE(_){return m(this.buffer,_)}writeUInt32LE(_,D){u(this.buffer,_,D)}readUInt8(_){return a(this.buffer,_)}writeUInt8(_,D){s(this.buffer,_,D)}indexOf(_,D=0){return l(this.buffer,_ instanceof d?_.buffer:_,D)}}e.VSBuffer=d;function l(c,_,D=0){const W=_.byteLength,I=c.byteLength;if(W===0)return 0;if(W===1)return c.indexOf(_[0]);if(W>I-D)return-1;const q=A.value;q.fill(_.length);for(let re=0;re<_.length;re++)q[_[re]]=_.length-re-1;let ee=D+_.length-1,ne=ee,Q=-1;for(;ee<I;)if(c[ee]===_[ne]){if(ne===0){Q=ee;break}ee--,ne--}else ee+=Math.max(_.length-ne,q[c[ee]]),ne=_.length-1;return Q}e.binaryIndexOf=l;function P(c,_){return c[_+0]<<0>>>0|c[_+1]<<8>>>0}e.readUInt16LE=P;function p(c,_,D){c[D+0]=_&255,_=_>>>8,c[D+1]=_&255}e.writeUInt16LE=p;function w(c,_){return c[_]*2**24+c[_+1]*2**16+c[_+2]*2**8+c[_+3]}e.readUInt32BE=w;function r(c,_,D){c[D+3]=_,_=_>>>8,c[D+2]=_,_=_>>>8,c[D+1]=_,_=_>>>8,c[D]=_}e.writeUInt32BE=r;function m(c,_){return c[_+0]<<0>>>0|c[_+1]<<8>>>0|c[_+2]<<16>>>0|c[_+3]<<24>>>0}e.readUInt32LE=m;function u(c,_,D){c[D+0]=_&255,_=_>>>8,c[D+1]=_&255,_=_>>>8,c[D+2]=_&255,_=_>>>8,c[D+3]=_&255}e.writeUInt32LE=u;function a(c,_){return c[_]}e.readUInt8=a;function s(c,_,D){c[D]=_}e.writeUInt8=s;function o(c){return L.consumeReadable(c,_=>d.concat(_))}e.readableToBuffer=o;function f(c){return L.toReadable(c)}e.bufferToReadable=f;function n(c){return L.consumeStream(c,_=>d.concat(_))}e.streamToBuffer=n;async function t(c){return c.ended?d.concat(c.buffer):d.concat([...c.buffer,await n(c.stream)])}e.bufferedStreamToBuffer=t;function i(c){return L.toStream(c,_=>d.concat(_))}e.bufferToStream=i;function y(c){return L.transform(c,{data:_=>typeof _=="string"?d.fromString(_):d.wrap(_)},_=>d.concat(_))}e.streamToBufferReadableStream=y;function F(c){return L.newWriteableStream(_=>d.concat(_),c)}e.newWriteableBufferStream=F;function g(c,_){return L.prefixedReadable(c,_,D=>d.concat(D))}e.prefixedBufferReadable=g;function b(c,_){return L.prefixedStream(c,_,D=>d.concat(D))}e.prefixedBufferStream=b;function C(c){let _=0,D=0,W=0;const I=new Uint8Array(Math.floor(c.length/4*3)),q=ne=>{switch(D){case 3:I[W++]=_|ne,D=0;break;case 2:I[W++]=_|ne>>>2,_=ne<<6,D=3;break;case 1:I[W++]=_|ne>>>4,_=ne<<4,D=2;break;default:_=ne<<2,D=1}};for(let ne=0;ne<c.length;ne++){const Q=c.charCodeAt(ne);if(Q>=65&&Q<=90)q(Q-65);else if(Q>=97&&Q<=122)q(Q-97+26);else if(Q>=48&&Q<=57)q(Q-48+52);else if(Q===43||Q===45)q(62);else if(Q===47||Q===95)q(63);else{if(Q===61)break;throw new SyntaxError(`Unexpected base64 character ${c[ne]}`)}}const ee=W;for(;D>0;)q(0);return d.wrap(I).slice(0,ee)}e.decodeBase64=C;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",j="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function B({buffer:c},_=!0,D=!1){const W=D?j:k;let I="";const q=c.byteLength%3;let ee=0;for(;ee<c.byteLength-q;ee+=3){const ne=c[ee+0],Q=c[ee+1],re=c[ee+2];I+=W[ne>>>2],I+=W[(ne<<4|Q>>>4)&63],I+=W[(Q<<2|re>>>6)&63],I+=W[re&63]}if(q===1){const ne=c[ee+0];I+=W[ne>>>2],I+=W[ne<<4&63],_&&(I+="==")}else if(q===2){const ne=c[ee+0],Q=c[ee+1];I+=W[ne>>>2],I+=W[(ne<<4|Q>>>4)&63],I+=W[Q<<2&63],_&&(I+="=")}return I}e.encodeBase64=B}),define(ue[11],he([0,1,47,22]),function(oe,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncateMiddle=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.htmlAttributeEncodeValue=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function S(z){return!z||typeof z!="string"?!0:z.trim().length===0}e.isFalsyOrWhitespace=S;const A=/{(\d+)}/g;function M(z,...J){return J.length===0?z:z.replace(A,function(ae,fe){const _e=parseInt(fe,10);return isNaN(_e)||_e<0||_e>=J.length?ae:J[_e]})}e.format=M;const E=/{([^}]+)}/g;function d(z,J){return Object.keys(J).length===0?z:z.replace(E,(ae,fe)=>J[fe]??ae)}e.format2=d;function l(z){return z.replace(/[<>"'&]/g,J=>{switch(J){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return J})}e.htmlAttributeEncodeValue=l;function P(z){return z.replace(/[<>&]/g,function(J){switch(J){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return J}})}e.escape=P;function p(z){return z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=p;function w(z,J){let ae=0;const fe=J.charCodeAt(0);for(let _e=z.length-1;_e>=0;_e--)z.charCodeAt(_e)===fe&&ae++;return ae}e.count=w;function r(z,J,ae="\u2026"){return z.length<=J?z:`${z.substr(0,J)}${ae}`}e.truncate=r;function m(z,J,ae="\u2026"){if(z.length<=J)return z;const fe=Math.ceil(J/2)-ae.length/2,_e=Math.floor(J/2)-ae.length/2;return`${z.substr(0,fe)}${ae}${z.substr(z.length-_e)}`}e.truncateMiddle=m;function u(z,J=" "){const ae=a(z,J);return s(ae,J)}e.trim=u;function a(z,J){if(!z||!J)return z;const ae=J.length;if(ae===0||z.length===0)return z;let fe=0;for(;z.indexOf(J,fe)===fe;)fe=fe+ae;return z.substring(fe)}e.ltrim=a;function s(z,J){if(!z||!J)return z;const ae=J.length,fe=z.length;if(ae===0||fe===0)return z;let _e=fe,ve=-1;for(;ve=z.lastIndexOf(J,_e-1),!(ve===-1||ve+ae!==_e);){if(ve===0)return"";_e=ve}return z.substring(0,_e)}e.rtrim=s;function o(z){return z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=o;function f(z){return z.replace(/\*/g,"")}e.stripWildcards=f;function n(z,J,ae={}){if(!z)throw new Error("Cannot create regex from empty string");J||(z=p(z)),ae.wholeWord&&(/\B/.test(z.charAt(0))||(z="\\b"+z),/\B/.test(z.charAt(z.length-1))||(z=z+"\\b"));let fe="";return ae.global&&(fe+="g"),ae.matchCase||(fe+="i"),ae.multiline&&(fe+="m"),ae.unicode&&(fe+="u"),new RegExp(z,fe)}e.createRegExp=n;function t(z){return z.source==="^"||z.source==="^$"||z.source==="$"||z.source==="^\\s*$"?!1:!!(z.exec("")&&z.lastIndex===0)}e.regExpLeadsToEndlessLoop=t;function i(z){return z.split(/\r\n|\r|\n/)}e.splitLines=i;function y(z){for(let J=0,ae=z.length;J<ae;J++){const fe=z.charCodeAt(J);if(fe!==32&&fe!==9)return J}return-1}e.firstNonWhitespaceIndex=y;function F(z,J=0,ae=z.length){for(let fe=J;fe<ae;fe++){const _e=z.charCodeAt(fe);if(_e!==32&&_e!==9)return z.substring(J,fe)}return z.substring(J,ae)}e.getLeadingWhitespace=F;function g(z,J=z.length-1){for(let ae=J;ae>=0;ae--){const fe=z.charCodeAt(ae);if(fe!==32&&fe!==9)return ae}return-1}e.lastNonWhitespaceIndex=g;function b(z,J,ae){const fe=[];let _e=0;for(const ve of z.matchAll(J)){if(fe.push(z.slice(_e,ve.index)),ve.index===void 0)throw new Error("match.index should be defined");_e=ve.index+ve[0].length,fe.push(ae(ve[0],...ve.slice(1),ve.index,z,ve.groups))}return fe.push(z.slice(_e)),Promise.all(fe).then(ve=>ve.join(""))}e.replaceAsync=b;function C(z,J){return z<J?-1:z>J?1:0}e.compare=C;function k(z,J,ae=0,fe=z.length,_e=0,ve=J.length){for(;ae<fe&&_e<ve;ae++,_e++){const Pe=z.charCodeAt(ae),Le=J.charCodeAt(_e);if(Pe<Le)return-1;if(Pe>Le)return 1}const be=fe-ae,ke=ve-_e;return be<ke?-1:be>ke?1:0}e.compareSubstring=k;function j(z,J){return B(z,J,0,z.length,0,J.length)}e.compareIgnoreCase=j;function B(z,J,ae=0,fe=z.length,_e=0,ve=J.length){for(;ae<fe&&_e<ve;ae++,_e++){let Pe=z.charCodeAt(ae),Le=J.charCodeAt(_e);if(Pe===Le)continue;if(Pe>=128||Le>=128)return k(z.toLowerCase(),J.toLowerCase(),ae,fe,_e,ve);_(Pe)&&(Pe-=32),_(Le)&&(Le-=32);const Ee=Pe-Le;if(Ee!==0)return Ee}const be=fe-ae,ke=ve-_e;return be<ke?-1:be>ke?1:0}e.compareSubstringIgnoreCase=B;function c(z){return z>=48&&z<=57}e.isAsciiDigit=c;function _(z){return z>=97&&z<=122}e.isLowerAsciiLetter=_;function D(z){return z>=65&&z<=90}e.isUpperAsciiLetter=D;function W(z,J){return z.length===J.length&&B(z,J)===0}e.equalsIgnoreCase=W;function I(z,J){const ae=J.length;return J.length>z.length?!1:B(z,J,0,ae)===0}e.startsWithIgnoreCase=I;function q(z,J){const ae=Math.min(z.length,J.length);let fe;for(fe=0;fe<ae;fe++)if(z.charCodeAt(fe)!==J.charCodeAt(fe))return fe;return ae}e.commonPrefixLength=q;function ee(z,J){const ae=Math.min(z.length,J.length);let fe;const _e=z.length-1,ve=J.length-1;for(fe=0;fe<ae;fe++)if(z.charCodeAt(_e-fe)!==J.charCodeAt(ve-fe))return fe;return ae}e.commonSuffixLength=ee;function ne(z){return 55296<=z&&z<=56319}e.isHighSurrogate=ne;function Q(z){return 56320<=z&&z<=57343}e.isLowSurrogate=Q;function re(z,J){return(z-55296<<10)+(J-56320)+65536}e.computeCodePoint=re;function le(z,J,ae){const fe=z.charCodeAt(ae);if(ne(fe)&&ae+1<J){const _e=z.charCodeAt(ae+1);if(Q(_e))return re(fe,_e)}return fe}e.getNextCodePoint=le;function de(z,J){const ae=z.charCodeAt(J-1);if(Q(ae)&&J>1){const fe=z.charCodeAt(J-2);if(ne(fe))return re(fe,ae)}return ae}class G{get offset(){return this._offset}constructor(J,ae=0){this._str=J,this._len=J.length,this._offset=ae}setOffset(J){this._offset=J}prevCodePoint(){const J=de(this._str,this._offset);return this._offset-=J>=65536?2:1,J}nextCodePoint(){const J=le(this._str,this._len,this._offset);return this._offset+=J>=65536?2:1,J}eol(){return this._offset>=this._len}}e.CodePointIterator=G;class ${get offset(){return this._iterator.offset}constructor(J,ae=0){this._iterator=new G(J,ae)}nextGraphemeLength(){const J=Se.getInstance(),ae=this._iterator,fe=ae.offset;let _e=J.getGraphemeBreakType(ae.nextCodePoint());for(;!ae.eol();){const ve=ae.offset,be=J.getGraphemeBreakType(ae.nextCodePoint());if(Re(_e,be)){ae.setOffset(ve);break}_e=be}return ae.offset-fe}prevGraphemeLength(){const J=Se.getInstance(),ae=this._iterator,fe=ae.offset;let _e=J.getGraphemeBreakType(ae.prevCodePoint());for(;ae.offset>0;){const ve=ae.offset,be=J.getGraphemeBreakType(ae.prevCodePoint());if(Re(be,_e)){ae.setOffset(ve);break}_e=be}return fe-ae.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=$;function X(z,J){return new $(z,J).nextGraphemeLength()}e.nextCharLength=X;function te(z,J){return new $(z,J).prevGraphemeLength()}e.prevCharLength=te;function H(z,J){J>0&&Q(z.charCodeAt(J))&&J--;const ae=J+X(z,J);return[ae-te(z,ae),ae]}e.getCharContainingOffset=H;function x(z){const J=new $(z);let ae=0;for(;!J.eol();)ae++,J.nextGraphemeLength();return ae}e.charCount=x;let me;function Z(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function h(z){return me||(me=Z()),me.test(z)}e.containsRTL=h;const U=/^[\t\n\r\x20-\x7E]*$/;function se(z){return U.test(z)}e.isBasicASCII=se,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function N(z){return e.UNUSUAL_LINE_TERMINATORS.test(z)}e.containsUnusualLineTerminators=N;function K(z){return z>=11904&&z<=55215||z>=63744&&z<=64255||z>=65281&&z<=65374}e.isFullWidthCharacter=K;function O(z){return z>=127462&&z<=127487||z===8986||z===8987||z===9200||z===9203||z>=9728&&z<=10175||z===11088||z===11093||z>=127744&&z<=128591||z>=128640&&z<=128764||z>=128992&&z<=129008||z>=129280&&z<=129535||z>=129648&&z<=129782}e.isEmojiImprecise=O;function R(z,J,ae=""){const fe=z.trimStart();if(fe.length<J)return fe;const _e=/\b/g;let ve=0;for(;_e.test(fe)&&!(fe.length-_e.lastIndex<J);)ve=_e.lastIndex,_e.lastIndex+=1;return ve===0?fe:ae+fe.substring(ve).trimStart()}e.lcut=R;const T=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,V=/\x1b\].*?\x07/g;function Y(z){return z&&(z=z.replace(T,"").replace(V,"")),z}e.removeAnsiEscapeCodes=Y,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ie(z){return!!(z&&z.length>0&&z.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ie;function ce(z){return ie(z)?z.substr(1):z}e.stripUTF8BOM=ce;function pe(z,J){if(!z||!J||z.length<J.length)return!1;const ae=J.length,fe=z.toLowerCase();let _e=0,ve=-1;for(;_e<ae;){const be=fe.indexOf(J[_e],ve+1);if(be<0)return!1;ve=be,_e++}return!0}e.fuzzyContains=pe;function ye(z,J=!1){return z?(J&&(z=z.replace(/\\./g,"")),z.toLowerCase()!==z):!1}e.containsUppercaseCharacter=ye;function we(z){return z.charAt(0).toUpperCase()+z.slice(1)}e.uppercaseFirstLetter=we;function Ce(z,J=1){if(J===0)return"";let ae=-1;do ae=z.indexOf(`
`,ae+1),J--;while(J>0&&ae>=0);return ae===-1?z:(z[ae-1]==="\r"&&ae--,z.substr(0,ae))}e.getNLines=Ce;function Ie(z){return z=z%(2*26),z<26?String.fromCharCode(97+z):String.fromCharCode(65+z-26)}e.singleLetterHash=Ie;function Me(z){return Se.getInstance().getGraphemeBreakType(z)}e.getGraphemeBreakType=Me;function Re(z,J){return z===0?J!==5&&J!==7:z===2&&J===3?!1:z===4||z===2||z===3||J===4||J===2||J===3?!0:!(z===8&&(J===8||J===9||J===11||J===12)||(z===11||z===9)&&(J===9||J===10)||(z===12||z===10)&&J===10||J===5||J===13||J===7||z===1||z===13&&J===14||z===6&&J===6)}var Fe;(function(z){z[z.Other=0]="Other",z[z.Prepend=1]="Prepend",z[z.CR=2]="CR",z[z.LF=3]="LF",z[z.Control=4]="Control",z[z.Extend=5]="Extend",z[z.Regional_Indicator=6]="Regional_Indicator",z[z.SpacingMark=7]="SpacingMark",z[z.L=8]="L",z[z.V=9]="V",z[z.T=10]="T",z[z.LV=11]="LV",z[z.LVT=12]="LVT",z[z.ZWJ=13]="ZWJ",z[z.Extended_Pictographic=14]="Extended_Pictographic"})(Fe||(e.GraphemeBreakType=Fe={}));class Se{static{this._INSTANCE=null}static getInstance(){return Se._INSTANCE||(Se._INSTANCE=new Se),Se._INSTANCE}constructor(){this._data=ze()}getGraphemeBreakType(J){if(J<32)return J===10?3:J===13?2:4;if(J<127)return 0;const ae=this._data,fe=ae.length/3;let _e=1;for(;_e<=fe;)if(J<ae[3*_e])_e=2*_e;else if(J>ae[3*_e+1])_e=2*_e+1;else return ae[3*_e+2];return 0}}function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function qe(z,J){if(z===0)return 0;const ae=$e(z,J);if(ae!==void 0)return ae;const fe=new G(J,z);return fe.prevCodePoint(),fe.offset}e.getLeftDeleteOffset=qe;function $e(z,J){const ae=new G(J,z);let fe=ae.prevCodePoint();for(;je(fe)||fe===65039||fe===8419;){if(ae.offset===0)return;fe=ae.prevCodePoint()}if(!O(fe))return;let _e=ae.offset;return _e>0&&ae.prevCodePoint()===8205&&(_e=ae.offset),_e}function je(z){return 127995<=z&&z<=127999}var Be;(function(z){z[z.zwj=8205]="zwj",z[z.emojiVariantSelector=65039]="emojiVariantSelector",z[z.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),e.noBreakWhitespace="\xA0";class Oe{static{this.ambiguousCharacterData=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new v.LRUCachedFunction(J=>{function ae(Ee){const Ae=new Map;for(let De=0;De<Ee.length;De+=2)Ae.set(Ee[De],Ee[De+1]);return Ae}function fe(Ee,Ae){const De=new Map(Ee);for(const[Ue,We]of Ae)De.set(Ue,We);return De}function _e(Ee,Ae){if(!Ee)return Ae;const De=new Map;for(const[Ue,We]of Ee)Ae.has(Ue)&&De.set(Ue,We);return De}const ve=this.ambiguousCharacterData.value;let be=J.filter(Ee=>!Ee.startsWith("_")&&Ee in ve);be.length===0&&(be=["_default"]);let ke;for(const Ee of be){const Ae=ae(ve[Ee]);ke=_e(ke,Ae)}const Pe=ae(ve._common),Le=fe(Pe,ke);return new Oe(Le)})}static getInstance(J){return Oe.cache.get(Array.from(J))}static{this._locales=new L.Lazy(()=>Object.keys(Oe.ambiguousCharacterData.value).filter(J=>!J.startsWith("_")))}static getLocales(){return Oe._locales.value}constructor(J){this.confusableDictionary=J}isAmbiguous(J){return this.confusableDictionary.has(J)}getPrimaryConfusable(J){return this.confusableDictionary.get(J)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Oe;class Ne{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Ne.getRawData())),this._data}static isInvisibleCharacter(J){return Ne.getData().has(J)}static get codePoints(){return Ne.getData()}}e.InvisibleCharacters=Ne}),define(ue[49],he([0,1,11]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(s){return S(s,0)}e.hash=L;function S(s,o){switch(typeof s){case"object":return s===null?A(349,o):Array.isArray(s)?d(s,o):l(s,o);case"string":return E(s,o);case"boolean":return M(s,o);case"number":return A(s,o);case"undefined":return A(937,o);default:return A(617,o)}}e.doHash=S;function A(s,o){return(o<<5)-o+s|0}e.numberHash=A;function M(s,o){return A(s?433:863,o)}function E(s,o){o=A(149417,o);for(let f=0,n=s.length;f<n;f++)o=A(s.charCodeAt(f),o);return o}e.stringHash=E;function d(s,o){return o=A(104579,o),s.reduce((f,n)=>S(n,f),o)}function l(s,o){return o=A(181387,o),Object.keys(s).sort().reduce((f,n)=>(f=E(n,f),S(s[n],f)),o)}class P{constructor(){this._value=0}get value(){return this._value}hash(o){return this._value=S(o,this._value),this._value}}e.Hasher=P;var p;(function(s){s[s.BLOCK_SIZE=64]="BLOCK_SIZE",s[s.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function w(s,o,f=32){const n=f-o,t=~((1<<n)-1);return(s<<o|(t&s)>>>n)>>>0}function r(s,o=0,f=s.byteLength,n=0){for(let t=0;t<f;t++)s[o+t]=n}function m(s,o,f="0"){for(;s.length<o;)s=f+s;return s}function u(s,o=32){return s instanceof ArrayBuffer?Array.from(new Uint8Array(s)).map(f=>f.toString(16).padStart(2,"0")).join(""):m((s>>>0).toString(16),o/4)}e.toHexString=u;class a{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(o){const f=o.length;if(f===0)return;const n=this._buff;let t=this._buffLen,i=this._leftoverHighSurrogate,y,F;for(i!==0?(y=i,F=-1,i=0):(y=o.charCodeAt(0),F=0);;){let g=y;if(v.isHighSurrogate(y))if(F+1<f){const b=o.charCodeAt(F+1);v.isLowSurrogate(b)?(F++,g=v.computeCodePoint(y,b)):g=65533}else{i=y;break}else v.isLowSurrogate(y)&&(g=65533);if(t=this._push(n,t,g),F++,F<f)y=o.charCodeAt(F);else break}this._buffLen=t,this._leftoverHighSurrogate=i}_push(o,f,n){return n<128?o[f++]=n:n<2048?(o[f++]=192|(n&1984)>>>6,o[f++]=128|(n&63)>>>0):n<65536?(o[f++]=224|(n&61440)>>>12,o[f++]=128|(n&4032)>>>6,o[f++]=128|(n&63)>>>0):(o[f++]=240|(n&1835008)>>>18,o[f++]=128|(n&258048)>>>12,o[f++]=128|(n&4032)>>>6,o[f++]=128|(n&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,o[0]=o[64+0],o[1]=o[64+1],o[2]=o[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),u(this._h0)+u(this._h1)+u(this._h2)+u(this._h3)+u(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,r(this._buff,this._buffLen),this._buffLen>56&&(this._step(),r(this._buff));const o=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(o/4294967296),!1),this._buffDV.setUint32(60,o%4294967296,!1),this._step()}_step(){const o=a._bigBlock32,f=this._buffDV;for(let k=0;k<64;k+=4)o.setUint32(k,f.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)o.setUint32(k,w(o.getUint32(k-12,!1)^o.getUint32(k-32,!1)^o.getUint32(k-56,!1)^o.getUint32(k-64,!1),1),!1);let n=this._h0,t=this._h1,i=this._h2,y=this._h3,F=this._h4,g,b,C;for(let k=0;k<80;k++)k<20?(g=t&i|~t&y,b=1518500249):k<40?(g=t^i^y,b=1859775393):k<60?(g=t&i|t&y|i&y,b=2400959708):(g=t^i^y,b=3395469782),C=w(n,5)+g+F+b+o.getUint32(k*4,!1)&4294967295,F=y,y=i,i=w(t,30),t=n,n=C;this._h0=this._h0+n&4294967295,this._h1=this._h1+t&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+y&4294967295,this._h4=this._h4+F&4294967295}}e.StringSHA1=a}),define(ue[50],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ue[51],he([0,1,16,11]),function(oe,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class S{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const m=r.charCodeAt(0),u=this._value.charCodeAt(this._pos);return m-u}value(){return this._value[this._pos]}}e.StringIterator=S;class A{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class M{constructor(r=!0,m=!0){this._splitOnBackslash=r,this._caseSensitive=m}reset(r){this._from=0,this._to=0,this._value=r,this._valueLen=r.length;for(let m=r.length-1;m>=0;m--,this._valueLen--){const u=this._value.charCodeAt(m);if(!(u===47||this._splitOnBackslash&&u===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let r=!0;for(;this._to<this._valueLen;this._to++){const m=this._value.charCodeAt(this._to);if(m===47||this._splitOnBackslash&&m===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=M;var E;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(E||(E={}));class d{constructor(r,m){this._ignorePathCasing=r,this._ignoreQueryAndFragment=m,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new M(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(r)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,L.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(P||(P={}));class p{static forUris(r=()=>!1,m=()=>!1){return new p(new d(r,m))}static forPaths(r=!1){return new p(new M(void 0,!r))}static forStrings(){return new p(new S)}static forConfigKeys(){return new p(new A)}constructor(r){this._iter=r}clear(){this._root=void 0}fill(r,m){if(m){const u=m.slice(0);(0,v.shuffle)(u);for(const a of u)this.set(a,r)}else{const u=r.slice(0);(0,v.shuffle)(u);for(const a of u)this.set(a[0],a[1])}}set(r,m){const u=this._iter.reset(r);let a;this._root||(this._root=new l,this._root.segment=u.value());const s=[];for(a=this._root;;){const f=u.cmp(a.segment);if(f>0)a.left||(a.left=new l,a.left.segment=u.value()),s.push([-1,a]),a=a.left;else if(f<0)a.right||(a.right=new l,a.right.segment=u.value()),s.push([1,a]),a=a.right;else if(u.hasNext())u.next(),a.mid||(a.mid=new l,a.mid.segment=u.value()),s.push([0,a]),a=a.mid;else break}const o=a.value;a.value=m,a.key=r;for(let f=s.length-1;f>=0;f--){const n=s[f][1];n.updateHeight();const t=n.balanceFactor();if(t<-1||t>1){const i=s[f][0],y=s[f+1][0];if(i===1&&y===1)s[f][1]=n.rotateLeft();else if(i===-1&&y===-1)s[f][1]=n.rotateRight();else if(i===1&&y===-1)n.right=s[f+1][1]=s[f+1][1].rotateRight(),s[f][1]=n.rotateLeft();else if(i===-1&&y===1)n.left=s[f+1][1]=s[f+1][1].rotateLeft(),s[f][1]=n.rotateRight();else throw new Error;if(f>0)switch(s[f-1][0]){case-1:s[f-1][1].left=s[f][1];break;case 1:s[f-1][1].right=s[f][1];break;case 0:s[f-1][1].mid=s[f][1];break}else this._root=s[0][1]}}return o}get(r){return this._getNode(r)?.value}_getNode(r){const m=this._iter.reset(r);let u=this._root;for(;u;){const a=m.cmp(u.segment);if(a>0)u=u.left;else if(a<0)u=u.right;else if(m.hasNext())m.next(),u=u.mid;else break}return u}has(r){const m=this._getNode(r);return!(m?.value===void 0&&m?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,m){const u=this._iter.reset(r),a=[];let s=this._root;for(;s;){const o=u.cmp(s.segment);if(o>0)a.push([-1,s]),s=s.left;else if(o<0)a.push([1,s]),s=s.right;else if(u.hasNext())u.next(),a.push([0,s]),s=s.mid;else break}if(s){if(m?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const o=this._min(s.right);if(o.key){const{key:f,value:n,segment:t}=o;this._delete(o.key,!1),s.key=f,s.value=n,s.segment=t}}else{const o=s.left??s.right;if(a.length>0){const[f,n]=a[a.length-1];switch(f){case-1:n.left=o;break;case 0:n.mid=o;break;case 1:n.right=o;break}}else this._root=o}for(let o=a.length-1;o>=0;o--){const f=a[o][1];f.updateHeight();const n=f.balanceFactor();if(n>1?(f.right.balanceFactor()>=0||(f.right=f.right.rotateRight()),a[o][1]=f.rotateLeft()):n<-1&&(f.left.balanceFactor()<=0||(f.left=f.left.rotateLeft()),a[o][1]=f.rotateRight()),o>0)switch(a[o-1][0]){case-1:a[o-1][1].left=a[o][1];break;case 1:a[o-1][1].right=a[o][1];break;case 0:a[o-1][1].mid=a[o][1];break}else this._root=a[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const m=this._iter.reset(r);let u=this._root,a;for(;u;){const s=m.cmp(u.segment);if(s>0)u=u.left;else if(s<0)u=u.right;else if(m.hasNext())m.next(),a=u.value||a,u=u.mid;else break}return u&&u.value||a}findSuperstr(r){return this._findSuperstrOrElement(r,!1)}_findSuperstrOrElement(r,m){const u=this._iter.reset(r);let a=this._root;for(;a;){const s=u.cmp(a.segment);if(s>0)a=a.left;else if(s<0)a=a.right;else if(u.hasNext())u.next(),a=a.mid;else return a.mid?this._entries(a.mid):m?a.value:void 0}}hasElementOrSubtree(r){return this._findSuperstrOrElement(r,!0)!==void 0}forEach(r){for(const[m,u]of this)r(u,m)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(r){const m=[];return this._dfsEntries(r,m),m[Symbol.iterator]()}_dfsEntries(r,m){r&&(r.left&&this._dfsEntries(r.left,m),r.value&&m.push([r.key,r.value]),r.mid&&this._dfsEntries(r.mid,m),r.right&&this._dfsEntries(r.right,m))}_isBalanced(){const r=m=>{if(!m)return!0;const u=m.balanceFactor();return u<-1||u>1?!1:r(m.left)&&r(m.right)};return r(this._root)}}e.TernarySearchTree=p}),define(ue[8],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function v(t){return typeof t=="string"}e.isString=v;function L(t){return Array.isArray(t)&&t.every(i=>v(i))}e.isStringArray=L;function S(t){return typeof t=="object"&&t!==null&&!Array.isArray(t)&&!(t instanceof RegExp)&&!(t instanceof Date)}e.isObject=S;function A(t){const i=Object.getPrototypeOf(Uint8Array);return typeof t=="object"&&t instanceof i}e.isTypedArray=A;function M(t){return typeof t=="number"&&!isNaN(t)}e.isNumber=M;function E(t){return!!t&&typeof t[Symbol.iterator]=="function"}e.isIterable=E;function d(t){return t===!0||t===!1}e.isBoolean=d;function l(t){return typeof t>"u"}e.isUndefined=l;function P(t){return!p(t)}e.isDefined=P;function p(t){return l(t)||t===null}e.isUndefinedOrNull=p;function w(t,i){if(!t)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=w;function r(t){if(p(t))throw new Error("Assertion Failed: argument is undefined or null");return t}e.assertIsDefined=r;function m(...t){const i=[];for(let y=0;y<t.length;y++){const F=t[y];if(p(F))throw new Error(`Assertion Failed: argument at index ${y} is undefined or null`);i.push(F)}return i}e.assertAllDefined=m;const u=Object.prototype.hasOwnProperty;function a(t){if(!S(t))return!1;for(const i in t)if(u.call(t,i))return!1;return!0}e.isEmptyObject=a;function s(t){return typeof t=="function"}e.isFunction=s;function o(...t){return t.length>0&&t.every(s)}e.areFunctions=o;function f(t,i){const y=Math.min(t.length,i.length);for(let F=0;F<y;F++)n(t[F],i[F])}e.validateConstraints=f;function n(t,i){if(v(i)){if(typeof t!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(s(i)){try{if(t instanceof i)return}catch{}if(!p(t)&&t.constructor===i||i.length===1&&i.call(void 0,t)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=n}),define(ue[30],he([0,1,8]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const o=Array.isArray(s)?[]:{};return Object.entries(s).forEach(([f,n])=>{o[f]=n&&typeof n=="object"?L(n):n}),o}e.deepClone=L;function S(s){if(!s||typeof s!="object")return s;const o=[s];for(;o.length>0;){const f=o.shift();Object.freeze(f);for(const n in f)if(A.call(f,n)){const t=f[n];typeof t=="object"&&!Object.isFrozen(t)&&!(0,v.isTypedArray)(t)&&o.push(t)}}return s}e.deepFreeze=S;const A=Object.prototype.hasOwnProperty;function M(s,o){return E(s,o,new Set)}e.cloneAndChange=M;function E(s,o,f){if((0,v.isUndefinedOrNull)(s))return s;const n=o(s);if(typeof n<"u")return n;if(Array.isArray(s)){const t=[];for(const i of s)t.push(E(i,o,f));return t}if((0,v.isObject)(s)){if(f.has(s))throw new Error("Cannot clone recursive data-structure");f.add(s);const t={};for(const i in s)A.call(s,i)&&(t[i]=E(s[i],o,f));return f.delete(s),t}return s}function d(s,o,f=!0){return(0,v.isObject)(s)?((0,v.isObject)(o)&&Object.keys(o).forEach(n=>{n in s?f&&((0,v.isObject)(s[n])&&(0,v.isObject)(o[n])?d(s[n],o[n],f):s[n]=o[n]):s[n]=o[n]}),s):o}e.mixin=d;function l(s,o){if(s===o)return!0;if(s==null||o===null||o===void 0||typeof s!=typeof o||typeof s!="object"||Array.isArray(s)!==Array.isArray(o))return!1;let f,n;if(Array.isArray(s)){if(s.length!==o.length)return!1;for(f=0;f<s.length;f++)if(!l(s[f],o[f]))return!1}else{const t=[];for(n in s)t.push(n);t.sort();const i=[];for(n in o)i.push(n);if(i.sort(),!l(t,i))return!1;for(f=0;f<t.length;f++)if(!l(s[t[f]],o[t[f]]))return!1}return!0}e.equals=l;function P(s){const o=new Set;return JSON.stringify(s,(f,n)=>{if((0,v.isObject)(n)||Array.isArray(n)){if(o.has(n))return"[Circular]";o.add(n)}return n})}e.safeStringify=P;function p(s,o){const f=Object.create(null);return!s||!o||Object.keys(o).forEach(t=>{const i=s[t],y=o[t];l(i,y)||(f[t]=y)}),f}e.distinct=p;function w(s,o){const f=o.toLowerCase(),n=Object.keys(s).find(t=>t.toLowerCase()===f);return n?s[n]:s[o]}e.getCaseInsensitive=w;function r(s,o){const f=Object.create(null);for(const[n,t]of Object.entries(s))o(n,t)&&(f[n]=t);return f}e.filter=r;function m(s){let o=[];for(;Object.prototype!==s;)o=o.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return o}e.getAllPropertyNames=m;function u(s){const o=[];for(const f of m(s))typeof s[f]=="function"&&o.push(f);return o}e.getAllMethodNames=u;function a(s,o){const f=t=>function(){const i=Array.prototype.slice.call(arguments,0);return o(t,i)},n={};for(const t of s)n[t]=f(t);return n}e.createProxyObject=a}),define(ue[52],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(S){return v.test(S)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(E){for(let d=0;d<E.length;d++)E[d]=Math.floor(Math.random()*256);return E};const A=new Uint8Array(16),M=[];for(let E=0;E<256;E++)M.push(E.toString(16).padStart(2,"0"));return function(){S(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let d=0,l="";return l+=M[A[d++]],l+=M[A[d++]],l+=M[A[d++]],l+=M[A[d++]],l+="-",l+=M[A[d++]],l+=M[A[d++]],l+="-",l+=M[A[d++]],l+=M[A[d++]],l+="-",l+=M[A[d++]],l+=M[A[d++]],l+="-",l+=M[A[d++]],l+=M[A[d++]],l+=M[A[d++]],l+=M[A[d++]],l+=M[A[d++]],l+=M[A[d++]],l}}()}),define(ue[31],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=void 0;function v(L){return!!L.parentPort}e.isUtilityProcess=v}),define(ue[53],he([13,12]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(ue[54],he([0,1,53]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,S=L*60,A=S*24,M=A*7,E=A*30,d=A*365;function l(p,w,r,m){typeof p!="number"&&(p=p.getTime());const u=Math.round((new Date().getTime()-p)/1e3);if(u<-30)return(0,v.localize)(0,null,l(new Date().getTime()+u*1e3,!1));if(!m&&u<30)return(0,v.localize)(1,null);let a;return u<L?(a=u,w?a===1?r?(0,v.localize)(2,null,a):(0,v.localize)(3,null,a):r?(0,v.localize)(4,null,a):(0,v.localize)(5,null,a):a===1?r?(0,v.localize)(6,null,a):(0,v.localize)(7,null,a):r?(0,v.localize)(8,null,a):(0,v.localize)(9,null,a)):u<S?(a=Math.floor(u/L),w?a===1?r?(0,v.localize)(10,null,a):(0,v.localize)(11,null,a):r?(0,v.localize)(12,null,a):(0,v.localize)(13,null,a):a===1?r?(0,v.localize)(14,null,a):(0,v.localize)(15,null,a):r?(0,v.localize)(16,null,a):(0,v.localize)(17,null,a)):u<A?(a=Math.floor(u/S),w?a===1?r?(0,v.localize)(18,null,a):(0,v.localize)(19,null,a):r?(0,v.localize)(20,null,a):(0,v.localize)(21,null,a):a===1?r?(0,v.localize)(22,null,a):(0,v.localize)(23,null,a):r?(0,v.localize)(24,null,a):(0,v.localize)(25,null,a)):u<M?(a=Math.floor(u/A),w?a===1?(0,v.localize)(26,null,a):(0,v.localize)(27,null,a):a===1?(0,v.localize)(28,null,a):(0,v.localize)(29,null,a)):u<E?(a=Math.floor(u/M),w?a===1?r?(0,v.localize)(30,null,a):(0,v.localize)(31,null,a):r?(0,v.localize)(32,null,a):(0,v.localize)(33,null,a):a===1?r?(0,v.localize)(34,null,a):(0,v.localize)(35,null,a):r?(0,v.localize)(36,null,a):(0,v.localize)(37,null,a)):u<d?(a=Math.floor(u/E),w?a===1?r?(0,v.localize)(38,null,a):(0,v.localize)(39,null,a):r?(0,v.localize)(40,null,a):(0,v.localize)(41,null,a):a===1?r?(0,v.localize)(42,null,a):(0,v.localize)(43,null,a):r?(0,v.localize)(44,null,a):(0,v.localize)(45,null,a)):(a=Math.floor(u/d),w?a===1?r?(0,v.localize)(46,null,a):(0,v.localize)(47,null,a):r?(0,v.localize)(48,null,a):(0,v.localize)(49,null,a):a===1?r?(0,v.localize)(50,null,a):(0,v.localize)(51,null,a):r?(0,v.localize)(52,null,a):(0,v.localize)(53,null,a))}e.fromNow=l;function P(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(ue[55],he([13,12]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(ue[56],he([0,1,16,8,55]),function(oe,e,v,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(p,w){return w&&(p.stack||p.stacktrace)?S.localize(0,null,E(p),M(p.stack)||M(p.stacktrace)):E(p)}function M(p){return Array.isArray(p)?p.join(`
`):p}function E(p){return p.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${p.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?S.localize(1,null,p.message):p.message||S.localize(2,null)}function d(p=null,w=!1){if(!p)return S.localize(3,null);if(Array.isArray(p)){const r=v.coalesce(p),m=d(r[0],w);return r.length>1?S.localize(4,null,m,r.length):m}if(L.isString(p))return p;if(p.detail){const r=p.detail;if(r.error)return A(r.error,w);if(r.exception)return A(r.exception,w)}return p.stack?A(p,w):p.message?p.message:S.localize(5,null)}e.toErrorMessage=d;function l(p){const w=p;return w instanceof Error&&Array.isArray(w.actions)}e.isErrorWithActions=l;function P(p,w){let r;return typeof p=="string"?r=new Error(p):r=p,r.actions=w,r}e.createErrorWithActions=P}),define(ue[57],he([13,12]),function(oe,e){return oe.create("vs/base/common/platform",e)}),define(ue[3],he([0,1,57]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isBigSurOrNewer=e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let L=!1,S=!1,A=!1,M=!1,E=!1,d=!1,l=!1,P=!1,p=!1,w=!1,r,m=e.LANGUAGE_DEFAULT,u=e.LANGUAGE_DEFAULT,a,s;const o=globalThis;let f;typeof o.vscode<"u"&&typeof o.vscode.process<"u"?f=o.vscode.process:typeof process<"u"&&(f=process);const n=typeof f?.versions?.electron=="string",t=n&&f?.type==="renderer";if(typeof f=="object"){L=f.platform==="win32",S=f.platform==="darwin",A=f.platform==="linux",M=A&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,l=n,p=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,r=e.LANGUAGE_DEFAULT,m=e.LANGUAGE_DEFAULT;const c=f.env.VSCODE_NLS_CONFIG;if(c)try{const _=JSON.parse(c),D=_.availableLanguages["*"];r=_.locale,u=_.osLocale,m=D||e.LANGUAGE_DEFAULT,a=_._translationsConfigFile}catch{}E=!0}else typeof navigator=="object"&&!t?(s=navigator.userAgent,L=s.indexOf("Windows")>=0,S=s.indexOf("Macintosh")>=0,P=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=s.indexOf("Linux")>=0,w=s?.indexOf("Mobi")>=0,d=!0,r=v.getConfiguredDefaultLocale(v.localize(0,null))||e.LANGUAGE_DEFAULT,m=r,u=navigator.language):console.error("Unable to resolve platform.");var i;(function(c){c[c.Web=0]="Web",c[c.Mac=1]="Mac",c[c.Linux=2]="Linux",c[c.Windows=3]="Windows"})(i||(e.Platform=i={}));function y(c){switch(c){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=y;let F=0;S?F=1:L?F=3:A&&(F=2),e.isWindows=L,e.isMacintosh=S,e.isLinux=A,e.isLinuxSnap=M,e.isNative=E,e.isElectron=l,e.isWeb=d,e.isWebWorker=d&&typeof o.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?o.origin:void 0,e.isIOS=P,e.isMobile=w,e.isCI=p,e.platform=F,e.userAgent=s,e.language=m;var g;(function(c){function _(){return e.language}c.value=_;function D(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}c.isDefaultVariant=D;function W(){return e.language==="en"}c.isDefault=W})(g||(e.Language=g={})),e.locale=r,e.platformLocale=u,e.translationsConfigFile=a,e.setTimeout0IsFaster=typeof o.postMessage=="function"&&!o.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const c=[];o.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let W=0,I=c.length;W<I;W++){const q=c[W];if(q.id===D.data.vscodeScheduleAsyncWork){c.splice(W,1),q.callback();return}}});let _=0;return D=>{const W=++_;c.push({id:W,callback:D}),o.postMessage({vscodeScheduleAsyncWork:W},"*")}}return c=>setTimeout(c)})();var b;(function(c){c[c.Windows=1]="Windows",c[c.Macintosh=2]="Macintosh",c[c.Linux=3]="Linux"})(b||(e.OperatingSystem=b={})),e.OS=S||P?2:L?1:3;let C=!0,k=!1;function j(){if(!k){k=!0;const c=new Uint8Array(2);c[0]=1,c[1]=2,C=new Uint16Array(c.buffer)[0]===(2<<8)+1}return C}e.isLittleEndian=j,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function B(c){return parseFloat(c)>=20}e.isBigSurOrNewer=B}),define(ue[15],he([0,1,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.process<"u"){const A=S.process;L={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(ue[7],he([0,1,15]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,S=97,A=90,M=122,E=46,d=47,l=92,P=58,p=63;class w extends Error{constructor(y,F,g){let b;typeof F=="string"&&F.indexOf("not ")===0?(b="must not be",F=F.replace(/^not /,"")):b="must be";const C=y.indexOf(".")!==-1?"property":"argument";let k=`The "${y}" ${C} ${b} of type ${F}`;k+=`. Received type ${typeof g}`,super(k),this.code="ERR_INVALID_ARG_TYPE"}}function r(i,y){if(i===null||typeof i!="object")throw new w(y,"Object",i)}function m(i,y){if(typeof i!="string")throw new w(y,"string",i)}const u=v.platform==="win32";function a(i){return i===d||i===l}function s(i){return i===d}function o(i){return i>=L&&i<=A||i>=S&&i<=M}function f(i,y,F,g){let b="",C=0,k=-1,j=0,B=0;for(let c=0;c<=i.length;++c){if(c<i.length)B=i.charCodeAt(c);else{if(g(B))break;B=d}if(g(B)){if(!(k===c-1||j===1))if(j===2){if(b.length<2||C!==2||b.charCodeAt(b.length-1)!==E||b.charCodeAt(b.length-2)!==E){if(b.length>2){const _=b.lastIndexOf(F);_===-1?(b="",C=0):(b=b.slice(0,_),C=b.length-1-b.lastIndexOf(F)),k=c,j=0;continue}else if(b.length!==0){b="",C=0,k=c,j=0;continue}}y&&(b+=b.length>0?`${F}..`:"..",C=2)}else b.length>0?b+=`${F}${i.slice(k+1,c)}`:b=i.slice(k+1,c),C=c-k-1;k=c,j=0}else B===E&&j!==-1?++j:j=-1}return b}function n(i,y){r(y,"pathObject");const F=y.dir||y.root,g=y.base||`${y.name||""}${y.ext||""}`;return F?F===y.root?`${F}${g}`:`${F}${i}${g}`:g}e.win32={resolve(...i){let y="",F="",g=!1;for(let b=i.length-1;b>=-1;b--){let C;if(b>=0){if(C=i[b],m(C,"path"),C.length===0)continue}else y.length===0?C=v.cwd():(C=v.env[`=${y}`]||v.cwd(),(C===void 0||C.slice(0,2).toLowerCase()!==y.toLowerCase()&&C.charCodeAt(2)===l)&&(C=`${y}\\`));const k=C.length;let j=0,B="",c=!1;const _=C.charCodeAt(0);if(k===1)a(_)&&(j=1,c=!0);else if(a(_))if(c=!0,a(C.charCodeAt(1))){let D=2,W=D;for(;D<k&&!a(C.charCodeAt(D));)D++;if(D<k&&D!==W){const I=C.slice(W,D);for(W=D;D<k&&a(C.charCodeAt(D));)D++;if(D<k&&D!==W){for(W=D;D<k&&!a(C.charCodeAt(D));)D++;(D===k||D!==W)&&(B=`\\\\${I}\\${C.slice(W,D)}`,j=D)}}}else j=1;else o(_)&&C.charCodeAt(1)===P&&(B=C.slice(0,2),j=2,k>2&&a(C.charCodeAt(2))&&(c=!0,j=3));if(B.length>0)if(y.length>0){if(B.toLowerCase()!==y.toLowerCase())continue}else y=B;if(g){if(y.length>0)break}else if(F=`${C.slice(j)}\\${F}`,g=c,c&&y.length>0)break}return F=f(F,!g,"\\",a),g?`${y}\\${F}`:`${y}${F}`||"."},normalize(i){m(i,"path");const y=i.length;if(y===0)return".";let F=0,g,b=!1;const C=i.charCodeAt(0);if(y===1)return s(C)?"\\":i;if(a(C))if(b=!0,a(i.charCodeAt(1))){let j=2,B=j;for(;j<y&&!a(i.charCodeAt(j));)j++;if(j<y&&j!==B){const c=i.slice(B,j);for(B=j;j<y&&a(i.charCodeAt(j));)j++;if(j<y&&j!==B){for(B=j;j<y&&!a(i.charCodeAt(j));)j++;if(j===y)return`\\\\${c}\\${i.slice(B)}\\`;j!==B&&(g=`\\\\${c}\\${i.slice(B,j)}`,F=j)}}}else F=1;else o(C)&&i.charCodeAt(1)===P&&(g=i.slice(0,2),F=2,y>2&&a(i.charCodeAt(2))&&(b=!0,F=3));let k=F<y?f(i.slice(F),!b,"\\",a):"";return k.length===0&&!b&&(k="."),k.length>0&&a(i.charCodeAt(y-1))&&(k+="\\"),g===void 0?b?`\\${k}`:k:b?`${g}\\${k}`:`${g}${k}`},isAbsolute(i){m(i,"path");const y=i.length;if(y===0)return!1;const F=i.charCodeAt(0);return a(F)||y>2&&o(F)&&i.charCodeAt(1)===P&&a(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let y,F;for(let C=0;C<i.length;++C){const k=i[C];m(k,"path"),k.length>0&&(y===void 0?y=F=k:y+=`\\${k}`)}if(y===void 0)return".";let g=!0,b=0;if(typeof F=="string"&&a(F.charCodeAt(0))){++b;const C=F.length;C>1&&a(F.charCodeAt(1))&&(++b,C>2&&(a(F.charCodeAt(2))?++b:g=!1))}if(g){for(;b<y.length&&a(y.charCodeAt(b));)b++;b>=2&&(y=`\\${y.slice(b)}`)}return e.win32.normalize(y)},relative(i,y){if(m(i,"from"),m(y,"to"),i===y)return"";const F=e.win32.resolve(i),g=e.win32.resolve(y);if(F===g||(i=F.toLowerCase(),y=g.toLowerCase(),i===y))return"";let b=0;for(;b<i.length&&i.charCodeAt(b)===l;)b++;let C=i.length;for(;C-1>b&&i.charCodeAt(C-1)===l;)C--;const k=C-b;let j=0;for(;j<y.length&&y.charCodeAt(j)===l;)j++;let B=y.length;for(;B-1>j&&y.charCodeAt(B-1)===l;)B--;const c=B-j,_=k<c?k:c;let D=-1,W=0;for(;W<_;W++){const q=i.charCodeAt(b+W);if(q!==y.charCodeAt(j+W))break;q===l&&(D=W)}if(W!==_){if(D===-1)return g}else{if(c>_){if(y.charCodeAt(j+W)===l)return g.slice(j+W+1);if(W===2)return g.slice(j+W)}k>_&&(i.charCodeAt(b+W)===l?D=W:W===2&&(D=3)),D===-1&&(D=0)}let I="";for(W=b+D+1;W<=C;++W)(W===C||i.charCodeAt(W)===l)&&(I+=I.length===0?"..":"\\..");return j+=D,I.length>0?`${I}${g.slice(j,B)}`:(g.charCodeAt(j)===l&&++j,g.slice(j,B))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const y=e.win32.resolve(i);if(y.length<=2)return i;if(y.charCodeAt(0)===l){if(y.charCodeAt(1)===l){const F=y.charCodeAt(2);if(F!==p&&F!==E)return`\\\\?\\UNC\\${y.slice(2)}`}}else if(o(y.charCodeAt(0))&&y.charCodeAt(1)===P&&y.charCodeAt(2)===l)return`\\\\?\\${y}`;return i},dirname(i){m(i,"path");const y=i.length;if(y===0)return".";let F=-1,g=0;const b=i.charCodeAt(0);if(y===1)return a(b)?i:".";if(a(b)){if(F=g=1,a(i.charCodeAt(1))){let j=2,B=j;for(;j<y&&!a(i.charCodeAt(j));)j++;if(j<y&&j!==B){for(B=j;j<y&&a(i.charCodeAt(j));)j++;if(j<y&&j!==B){for(B=j;j<y&&!a(i.charCodeAt(j));)j++;if(j===y)return i;j!==B&&(F=g=j+1)}}}}else o(b)&&i.charCodeAt(1)===P&&(F=y>2&&a(i.charCodeAt(2))?3:2,g=F);let C=-1,k=!0;for(let j=y-1;j>=g;--j)if(a(i.charCodeAt(j))){if(!k){C=j;break}}else k=!1;if(C===-1){if(F===-1)return".";C=F}return i.slice(0,C)},basename(i,y){y!==void 0&&m(y,"ext"),m(i,"path");let F=0,g=-1,b=!0,C;if(i.length>=2&&o(i.charCodeAt(0))&&i.charCodeAt(1)===P&&(F=2),y!==void 0&&y.length>0&&y.length<=i.length){if(y===i)return"";let k=y.length-1,j=-1;for(C=i.length-1;C>=F;--C){const B=i.charCodeAt(C);if(a(B)){if(!b){F=C+1;break}}else j===-1&&(b=!1,j=C+1),k>=0&&(B===y.charCodeAt(k)?--k===-1&&(g=C):(k=-1,g=j))}return F===g?g=j:g===-1&&(g=i.length),i.slice(F,g)}for(C=i.length-1;C>=F;--C)if(a(i.charCodeAt(C))){if(!b){F=C+1;break}}else g===-1&&(b=!1,g=C+1);return g===-1?"":i.slice(F,g)},extname(i){m(i,"path");let y=0,F=-1,g=0,b=-1,C=!0,k=0;i.length>=2&&i.charCodeAt(1)===P&&o(i.charCodeAt(0))&&(y=g=2);for(let j=i.length-1;j>=y;--j){const B=i.charCodeAt(j);if(a(B)){if(!C){g=j+1;break}continue}b===-1&&(C=!1,b=j+1),B===E?F===-1?F=j:k!==1&&(k=1):F!==-1&&(k=-1)}return F===-1||b===-1||k===0||k===1&&F===b-1&&F===g+1?"":i.slice(F,b)},format:n.bind(null,"\\"),parse(i){m(i,"path");const y={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return y;const F=i.length;let g=0,b=i.charCodeAt(0);if(F===1)return a(b)?(y.root=y.dir=i,y):(y.base=y.name=i,y);if(a(b)){if(g=1,a(i.charCodeAt(1))){let D=2,W=D;for(;D<F&&!a(i.charCodeAt(D));)D++;if(D<F&&D!==W){for(W=D;D<F&&a(i.charCodeAt(D));)D++;if(D<F&&D!==W){for(W=D;D<F&&!a(i.charCodeAt(D));)D++;D===F?g=D:D!==W&&(g=D+1)}}}}else if(o(b)&&i.charCodeAt(1)===P){if(F<=2)return y.root=y.dir=i,y;if(g=2,a(i.charCodeAt(2))){if(F===3)return y.root=y.dir=i,y;g=3}}g>0&&(y.root=i.slice(0,g));let C=-1,k=g,j=-1,B=!0,c=i.length-1,_=0;for(;c>=g;--c){if(b=i.charCodeAt(c),a(b)){if(!B){k=c+1;break}continue}j===-1&&(B=!1,j=c+1),b===E?C===-1?C=c:_!==1&&(_=1):C!==-1&&(_=-1)}return j!==-1&&(C===-1||_===0||_===1&&C===j-1&&C===k+1?y.base=y.name=i.slice(k,j):(y.name=i.slice(k,C),y.base=i.slice(k,j),y.ext=i.slice(C,j))),k>0&&k!==g?y.dir=i.slice(0,k-1):y.dir=y.root,y},sep:"\\",delimiter:";",win32:null,posix:null};const t=(()=>{if(u){const i=/\\/g;return()=>{const y=v.cwd().replace(i,"/");return y.slice(y.indexOf("/"))}}return()=>v.cwd()})();e.posix={resolve(...i){let y="",F=!1;for(let g=i.length-1;g>=-1&&!F;g--){const b=g>=0?i[g]:t();m(b,"path"),b.length!==0&&(y=`${b}/${y}`,F=b.charCodeAt(0)===d)}return y=f(y,!F,"/",s),F?`/${y}`:y.length>0?y:"."},normalize(i){if(m(i,"path"),i.length===0)return".";const y=i.charCodeAt(0)===d,F=i.charCodeAt(i.length-1)===d;return i=f(i,!y,"/",s),i.length===0?y?"/":F?"./":".":(F&&(i+="/"),y?`/${i}`:i)},isAbsolute(i){return m(i,"path"),i.length>0&&i.charCodeAt(0)===d},join(...i){if(i.length===0)return".";let y;for(let F=0;F<i.length;++F){const g=i[F];m(g,"path"),g.length>0&&(y===void 0?y=g:y+=`/${g}`)}return y===void 0?".":e.posix.normalize(y)},relative(i,y){if(m(i,"from"),m(y,"to"),i===y||(i=e.posix.resolve(i),y=e.posix.resolve(y),i===y))return"";const F=1,g=i.length,b=g-F,C=1,k=y.length-C,j=b<k?b:k;let B=-1,c=0;for(;c<j;c++){const D=i.charCodeAt(F+c);if(D!==y.charCodeAt(C+c))break;D===d&&(B=c)}if(c===j)if(k>j){if(y.charCodeAt(C+c)===d)return y.slice(C+c+1);if(c===0)return y.slice(C+c)}else b>j&&(i.charCodeAt(F+c)===d?B=c:c===0&&(B=0));let _="";for(c=F+B+1;c<=g;++c)(c===g||i.charCodeAt(c)===d)&&(_+=_.length===0?"..":"/..");return`${_}${y.slice(C+B)}`},toNamespacedPath(i){return i},dirname(i){if(m(i,"path"),i.length===0)return".";const y=i.charCodeAt(0)===d;let F=-1,g=!0;for(let b=i.length-1;b>=1;--b)if(i.charCodeAt(b)===d){if(!g){F=b;break}}else g=!1;return F===-1?y?"/":".":y&&F===1?"//":i.slice(0,F)},basename(i,y){y!==void 0&&m(y,"ext"),m(i,"path");let F=0,g=-1,b=!0,C;if(y!==void 0&&y.length>0&&y.length<=i.length){if(y===i)return"";let k=y.length-1,j=-1;for(C=i.length-1;C>=0;--C){const B=i.charCodeAt(C);if(B===d){if(!b){F=C+1;break}}else j===-1&&(b=!1,j=C+1),k>=0&&(B===y.charCodeAt(k)?--k===-1&&(g=C):(k=-1,g=j))}return F===g?g=j:g===-1&&(g=i.length),i.slice(F,g)}for(C=i.length-1;C>=0;--C)if(i.charCodeAt(C)===d){if(!b){F=C+1;break}}else g===-1&&(b=!1,g=C+1);return g===-1?"":i.slice(F,g)},extname(i){m(i,"path");let y=-1,F=0,g=-1,b=!0,C=0;for(let k=i.length-1;k>=0;--k){const j=i.charCodeAt(k);if(j===d){if(!b){F=k+1;break}continue}g===-1&&(b=!1,g=k+1),j===E?y===-1?y=k:C!==1&&(C=1):y!==-1&&(C=-1)}return y===-1||g===-1||C===0||C===1&&y===g-1&&y===F+1?"":i.slice(y,g)},format:n.bind(null,"/"),parse(i){m(i,"path");const y={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return y;const F=i.charCodeAt(0)===d;let g;F?(y.root="/",g=1):g=0;let b=-1,C=0,k=-1,j=!0,B=i.length-1,c=0;for(;B>=g;--B){const _=i.charCodeAt(B);if(_===d){if(!j){C=B+1;break}continue}k===-1&&(j=!1,k=B+1),_===E?b===-1?b=B:c!==1&&(c=1):b!==-1&&(c=-1)}if(k!==-1){const _=C===0&&F?1:C;b===-1||c===0||c===1&&b===k-1&&b===C+1?y.base=y.name=i.slice(_,k):(y.name=i.slice(_,b),y.base=i.slice(_,k),y.ext=i.slice(b,k))}return C>0?y.dir=i.slice(0,C-1):F&&(y.dir="/"),y},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=u?e.win32.normalize:e.posix.normalize,e.isAbsolute=u?e.win32.isAbsolute:e.posix.isAbsolute,e.join=u?e.win32.join:e.posix.join,e.resolve=u?e.win32.resolve:e.posix.resolve,e.relative=u?e.win32.relative:e.posix.relative,e.dirname=u?e.win32.dirname:e.posix.dirname,e.basename=u?e.win32.basename:e.posix.basename,e.extname=u?e.win32.extname:e.posix.extname,e.format=u?e.win32.format:e.posix.format,e.parse=u?e.win32.parse:e.posix.parse,e.toNamespacedPath=u?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=u?e.win32.sep:e.posix.sep,e.delimiter=u?e.win32.delimiter:e.posix.delimiter}),define(ue[32],he([0,1,7,3,11,8]),function(oe,e,v,L,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(C){return C===47||C===92}e.isPathSeparator=M;function E(C){return C.replace(/[\\/]/g,v.posix.sep)}e.toSlashes=E;function d(C){return C.indexOf("/")===-1&&(C=E(C)),/^[a-zA-Z]:(\/|$)/.test(C)&&(C="/"+C),C}e.toPosixPath=d;function l(C,k=v.posix.sep){if(!C)return"";const j=C.length,B=C.charCodeAt(0);if(M(B)){if(M(C.charCodeAt(1))&&!M(C.charCodeAt(2))){let _=3;const D=_;for(;_<j&&!M(C.charCodeAt(_));_++);if(D!==_&&!M(C.charCodeAt(_+1))){for(_+=1;_<j;_++)if(M(C.charCodeAt(_)))return C.slice(0,_+1).replace(/[\\/]/g,k)}}return k}else if(s(B)&&C.charCodeAt(1)===58)return M(C.charCodeAt(2))?C.slice(0,2)+k:C.slice(0,2);let c=C.indexOf("://");if(c!==-1){for(c+=3;c<j;c++)if(M(C.charCodeAt(c)))return C.slice(0,c+1)}return""}e.getRoot=l;function P(C){if(!L.isWindows||!C||C.length<5)return!1;let k=C.charCodeAt(0);if(k!==92||(k=C.charCodeAt(1),k!==92))return!1;let j=2;const B=j;for(;j<C.length&&(k=C.charCodeAt(j),k!==92);j++);return!(B===j||(k=C.charCodeAt(j+1),isNaN(k)||k===92))}e.isUNC=P;const p=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,r=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(C,k=L.isWindows){const j=k?p:w;return!(!C||C.length===0||/^\s+$/.test(C)||(j.lastIndex=0,j.test(C))||k&&r.test(C)||C==="."||C===".."||k&&C[C.length-1]==="."||k&&C.length!==C.trim().length||C.length>255)}e.isValidBasename=m;function u(C,k,j){const B=C===k;return!j||B?B:!C||!k?!1:(0,S.equalsIgnoreCase)(C,k)}e.isEqual=u;function a(C,k,j,B=v.sep){if(C===k)return!0;if(!C||!k||k.length>C.length)return!1;if(j){if(!(0,S.startsWithIgnoreCase)(C,k))return!1;if(k.length===C.length)return!0;let _=k.length;return k.charAt(k.length-1)===B&&_--,C.charAt(_)===B}return k.charAt(k.length-1)!==B&&(k+=B),C.indexOf(k)===0}e.isEqualOrParent=a;function s(C){return C>=65&&C<=90||C>=97&&C<=122}e.isWindowsDriveLetter=s;function o(C,k){return L.isWindows&&C.endsWith(":")&&(C+=v.sep),(0,v.isAbsolute)(C)||(C=(0,v.join)(k,C)),C=(0,v.normalize)(C),L.isWindows?(C=(0,S.rtrim)(C,v.sep),C.endsWith(":")&&(C+=v.sep)):(C=(0,S.rtrim)(C,v.sep),C||(C=v.sep)),C}e.sanitizeFilePath=o;function f(C){const k=(0,v.normalize)(C);return L.isWindows?C.length>3?!1:n(k)&&(C.length===2||k.charCodeAt(2)===92):k===v.posix.sep}e.isRootOrDriveLetter=f;function n(C,k=L.isWindows){return k?s(C.charCodeAt(0))&&C.charCodeAt(1)===58:!1}e.hasDriveLetter=n;function t(C,k=L.isWindows){return n(C,k)?C[0]:void 0}e.getDriveLetter=t;function i(C,k,j){return k.length>C.length?-1:C===k?0:(j&&(C=C.toLowerCase(),k=k.toLowerCase()),C.indexOf(k))}e.indexOfPath=i;function y(C){const k=C.split(":");let j,B,c;for(const _ of k){const D=Number(_);(0,A.isNumber)(D)?B===void 0?B=D:c===void 0&&(c=D):j=j?[j,_].join(":"):_}if(!j)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:j,line:B!==void 0?B:void 0,column:c!==void 0?c:B!==void 0?1:void 0}}e.parseLineAndColumnAware=y;const F="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",g="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function b(C,k,j=8){let B="";for(let _=0;_<j;_++){let D;_===0&&L.isWindows&&!k&&(j===3||j===4)?D=g:D=F,B+=D.charAt(Math.floor(Math.random()*D.length))}let c;return k?c=`${k}-${B}`:c=B,C?(0,v.join)(C,c):c}e.randomPath=b}),define(ue[33],he([0,1,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(L||(e.Source=L={}));var S;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(S||(e.TerminateResponseCode=S={}));function A(E,...d){const l=d.reduce((w,r)=>(w[r]=!0,w),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(w=>!l[w]).forEach(w=>{for(let r=0;r<P.length;r++)if(w.search(P[r])!==-1){delete E[w];break}})}e.sanitizeProcessEnvironment=A;function M(E){E&&(delete E.DEBUG,v.isMacintosh&&delete E.DYLD_LIBRARY_PATH,v.isLinux&&delete E.LD_PRELOAD)}e.removeDangerousEnvVariables=M}),define(ue[5],he([0,1,7,3]),function(oe,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const S=/^\w[\w\d+.-]*$/,A=/^\//,M=/^\/\//;function E(g,b){if(!g.scheme&&b)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${g.authority}", path: "${g.path}", query: "${g.query}", fragment: "${g.fragment}"}`);if(g.scheme&&!S.test(g.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(g.path){if(g.authority){if(!A.test(g.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(g.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(g,b){return!g&&!b?"file":g}function l(g,b){switch(g){case"https":case"http":case"file":b?b[0]!==p&&(b=p+b):b=p;break}return b}const P="",p="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class r{static isUri(b){return b instanceof r?!0:b?typeof b.authority=="string"&&typeof b.fragment=="string"&&typeof b.path=="string"&&typeof b.query=="string"&&typeof b.scheme=="string"&&typeof b.fsPath=="string"&&typeof b.with=="function"&&typeof b.toString=="function":!1}constructor(b,C,k,j,B,c=!1){typeof b=="object"?(this.scheme=b.scheme||P,this.authority=b.authority||P,this.path=b.path||P,this.query=b.query||P,this.fragment=b.fragment||P):(this.scheme=d(b,c),this.authority=C||P,this.path=l(this.scheme,k||P),this.query=j||P,this.fragment=B||P,E(this,c))}get fsPath(){return n(this,!1)}with(b){if(!b)return this;let{scheme:C,authority:k,path:j,query:B,fragment:c}=b;return C===void 0?C=this.scheme:C===null&&(C=P),k===void 0?k=this.authority:k===null&&(k=P),j===void 0?j=this.path:j===null&&(j=P),B===void 0?B=this.query:B===null&&(B=P),c===void 0?c=this.fragment:c===null&&(c=P),C===this.scheme&&k===this.authority&&j===this.path&&B===this.query&&c===this.fragment?this:new a(C,k,j,B,c)}static parse(b,C=!1){const k=w.exec(b);return k?new a(k[2]||P,F(k[4]||P),F(k[5]||P),F(k[7]||P),F(k[9]||P),C):new a(P,P,P,P,P)}static file(b){let C=P;if(L.isWindows&&(b=b.replace(/\\/g,p)),b[0]===p&&b[1]===p){const k=b.indexOf(p,2);k===-1?(C=b.substring(2),b=p):(C=b.substring(2,k),b=b.substring(k)||p)}return new a("file",C,b,P,P)}static from(b,C){return new a(b.scheme,b.authority,b.path,b.query,b.fragment,C)}static joinPath(b,...C){if(!b.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let k;return L.isWindows&&b.scheme==="file"?k=r.file(v.win32.join(n(b,!0),...C)).path:k=v.posix.join(b.path,...C),b.with({path:k})}toString(b=!1){return t(this,b)}toJSON(){return this}static revive(b){if(b){if(b instanceof r)return b;{const C=new a(b);return C._formatted=b.external??null,C._fsPath=b._sep===u?b.fsPath??null:null,C}}else return b}}e.URI=r;function m(g){return!g||typeof g!="object"?!1:typeof g.scheme=="string"&&(typeof g.authority=="string"||typeof g.authority>"u")&&(typeof g.path=="string"||typeof g.path>"u")&&(typeof g.query=="string"||typeof g.query>"u")&&(typeof g.fragment=="string"||typeof g.fragment>"u")}e.isUriComponents=m;const u=L.isWindows?1:void 0;class a extends r{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(b=!1){return b?t(this,!0):(this._formatted||(this._formatted=t(this,!1)),this._formatted)}toJSON(){const b={$mid:1};return this._fsPath&&(b.fsPath=this._fsPath,b._sep=u),this._formatted&&(b.external=this._formatted),this.path&&(b.path=this.path),this.scheme&&(b.scheme=this.scheme),this.authority&&(b.authority=this.authority),this.query&&(b.query=this.query),this.fragment&&(b.fragment=this.fragment),b}}const s={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function o(g,b,C){let k,j=-1;for(let B=0;B<g.length;B++){const c=g.charCodeAt(B);if(c>=97&&c<=122||c>=65&&c<=90||c>=48&&c<=57||c===45||c===46||c===95||c===126||b&&c===47||C&&c===91||C&&c===93||C&&c===58)j!==-1&&(k+=encodeURIComponent(g.substring(j,B)),j=-1),k!==void 0&&(k+=g.charAt(B));else{k===void 0&&(k=g.substr(0,B));const _=s[c];_!==void 0?(j!==-1&&(k+=encodeURIComponent(g.substring(j,B)),j=-1),k+=_):j===-1&&(j=B)}}return j!==-1&&(k+=encodeURIComponent(g.substring(j))),k!==void 0?k:g}function f(g){let b;for(let C=0;C<g.length;C++){const k=g.charCodeAt(C);k===35||k===63?(b===void 0&&(b=g.substr(0,C)),b+=s[k]):b!==void 0&&(b+=g[C])}return b!==void 0?b:g}function n(g,b){let C;return g.authority&&g.path.length>1&&g.scheme==="file"?C=`//${g.authority}${g.path}`:g.path.charCodeAt(0)===47&&(g.path.charCodeAt(1)>=65&&g.path.charCodeAt(1)<=90||g.path.charCodeAt(1)>=97&&g.path.charCodeAt(1)<=122)&&g.path.charCodeAt(2)===58?b?C=g.path.substr(1):C=g.path[1].toLowerCase()+g.path.substr(2):C=g.path,L.isWindows&&(C=C.replace(/\//g,"\\")),C}e.uriToFsPath=n;function t(g,b){const C=b?f:o;let k="",{scheme:j,authority:B,path:c,query:_,fragment:D}=g;if(j&&(k+=j,k+=":"),(B||j==="file")&&(k+=p,k+=p),B){let W=B.indexOf("@");if(W!==-1){const I=B.substr(0,W);B=B.substr(W+1),W=I.lastIndexOf(":"),W===-1?k+=C(I,!1,!1):(k+=C(I.substr(0,W),!1,!1),k+=":",k+=C(I.substr(W+1),!1,!0)),k+="@"}B=B.toLowerCase(),W=B.lastIndexOf(":"),W===-1?k+=C(B,!1,!0):(k+=C(B.substr(0,W),!1,!0),k+=B.substr(W))}if(c){if(c.length>=3&&c.charCodeAt(0)===47&&c.charCodeAt(2)===58){const W=c.charCodeAt(1);W>=65&&W<=90&&(c=`/${String.fromCharCode(W+32)}:${c.substr(3)}`)}else if(c.length>=2&&c.charCodeAt(1)===58){const W=c.charCodeAt(0);W>=65&&W<=90&&(c=`${String.fromCharCode(W+32)}:${c.substr(2)}`)}k+=C(c,!0,!1)}return _&&(k+="?",k+=C(_,!1,!1)),D&&(k+="#",k+=b?D:o(D,!1,!1)),k}function i(g){try{return decodeURIComponent(g)}catch{return g.length>3?g.substr(0,3)+i(g.substr(3)):g}}const y=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function F(g){return g.match(y)?g.replace(y,b=>i(b)):g}}),define(ue[58],he([0,1,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(l){const P=l;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=L;function S(l){const P=[];let p;try{const w=JSON.parse(l.arguments),r=w[w.length-1];r&&r.__$stack&&(w.pop(),p=r.__$stack),P.push(...w)}catch{P.push("Unable to log remote console arguments",l.arguments)}return{args:P,stack:p}}e.parse=S;function A(l){if(typeof l!="string")return A(S(l).stack);const P=l;if(P){const p=M(P),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(w&&w.length===4)return{uri:v.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.getFirstFrame=A;function M(l){if(!l)return l;const P=l.indexOf(`
`);return P===-1?l:l.substring(0,P)}function E(l,P){const{args:p,stack:w}=S(l),r=typeof p[0]=="string"&&p.length===1;let m=M(w);m&&(m=`(${m.trim()})`);let u=[];if(typeof p[0]=="string"?m&&r?u=[`%c[${P}] %c${p[0]} %c${m}`,d("blue"),d(""),d("grey")]:u=[`%c[${P}] %c${p[0]}`,d("blue"),d(""),...p.slice(1)]:u=[`%c[${P}]%`,d("blue"),...p],m&&!r&&u.push(m),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,u)}e.log=E;function d(l){return`color: ${l}`}}),define(ue[59],he([0,1,18,5]),function(oe,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function S(d){return JSON.stringify(d,M)}e.stringify=S;function A(d){let l=JSON.parse(d);return l=E(l),l}e.parse=A;function M(d,l){return l instanceof RegExp?{$mid:2,source:l.source,flags:l.flags}:l}function E(d,l=0){if(!d||l>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return L.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 17:return new Date(d.source)}if(d instanceof v.VSBuffer||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let P=0;P<d.length;++P)d[P]=E(d[P],l+1);else for(const P in d)Object.hasOwnProperty.call(d,P)&&(d[P]=E(d[P],l+1))}return d}e.revive=E}),define(ue[19],he([0,1,6,3,11,5]),function(oe,e,v,L,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.matchesSomeScheme=e.matchesScheme=e.Schemas=void 0;var M;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeManagedRemoteResource="vscode-managed-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.vscodeChatSesssion="vscode-chat-editor",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={}));function E(w,r){return A.URI.isUri(w)?(0,S.equalsIgnoreCase)(w.scheme,r):(0,S.startsWithIgnoreCase)(w,r+":")}e.matchesScheme=E;function d(w,...r){return r.some(m=>E(w,m))}e.matchesSomeScheme=d,e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class l{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(r){this._preferredWebSchema=r}setDelegate(r){this._delegate=r}setServerRootPath(r){this._remoteResourcesPath=`${r}/${M.vscodeRemoteResource}`}set(r,m,u){this._hosts[r]=m,this._ports[r]=u}setConnectionToken(r,m){this._connectionTokens[r]=m}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(r){if(this._delegate)try{return this._delegate(r)}catch(f){return v.onUnexpectedError(f),r}const m=r.authority;let u=this._hosts[m];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const a=this._ports[m],s=this._connectionTokens[m];let o=`path=${encodeURIComponent(r.path)}`;return typeof s=="string"&&(o+=`&${e.connectionTokenQueryName}=${encodeURIComponent(s)}`),A.URI.from({scheme:L.isWeb?this._preferredWebSchema:M.vscodeRemoteResource,authority:`${u}:${a}`,path:this._remoteResourcesPath,query:o})}}e.RemoteAuthorities=new l,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class P{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(r){const m=this.toUri(r,oe);return this.uriToBrowserUri(m)}uriToBrowserUri(r){return r.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(r):r.scheme===M.file&&(L.isNative||L.webWorkerOrigin===`${M.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?r.with({scheme:M.vscodeFileResource,authority:r.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):r}asFileUri(r){const m=this.toUri(r,oe);return this.uriToFileUri(m)}uriToFileUri(r){return r.scheme===M.vscodeFileResource?r.with({scheme:M.file,authority:r.authority!==P.FALLBACK_AUTHORITY?r.authority:null,query:null,fragment:null}):r}toUri(r,m){return A.URI.isUri(r)?r:A.URI.parse(m.toUrl(r))}}e.FileAccess=new P;var p;(function(w){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(r.get("3"));const m="vscode-coi";function u(s){let o;typeof s=="string"?o=new URL(s).searchParams:s instanceof URL?o=s.searchParams:A.URI.isUri(s)&&(o=new URL(s.toString(!0)).searchParams);const f=o?.get(m);if(f)return r.get(f)}w.getHeadersFromQuery=u;function a(s,o,f){if(!globalThis.crossOriginIsolated)return;const n=o&&f?"3":f?"2":"1";s instanceof URLSearchParams?s.set(m,n):s[m]=n}w.addSearchParam=a})(p||(e.COI=p={}))}),define(ue[23],he([0,1,32,19,7,3,11,5]),function(oe,e,v,L,S,A,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function d(r){return(0,E.uriToFsPath)(r,!0)}e.originalFSPath=d;class l{constructor(m){this._ignorePathCasing=m}compare(m,u,a=!1){return m===u?0:(0,M.compare)(this.getComparisonKey(m,a),this.getComparisonKey(u,a))}isEqual(m,u,a=!1){return m===u?!0:!m||!u?!1:this.getComparisonKey(m,a)===this.getComparisonKey(u,a)}getComparisonKey(m,u=!1){return m.with({path:this._ignorePathCasing(m)?m.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(m){return this._ignorePathCasing(m)}isEqualOrParent(m,u,a=!1){if(m.scheme===u.scheme){if(m.scheme===L.Schemas.file)return v.isEqualOrParent(d(m),d(u),this._ignorePathCasing(m))&&m.query===u.query&&(a||m.fragment===u.fragment);if((0,e.isEqualAuthority)(m.authority,u.authority))return v.isEqualOrParent(m.path,u.path,this._ignorePathCasing(m),"/")&&m.query===u.query&&(a||m.fragment===u.fragment)}return!1}joinPath(m,...u){return E.URI.joinPath(m,...u)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return S.posix.basename(m.path)}extname(m){return S.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let u;return m.scheme===L.Schemas.file?u=E.URI.file(S.dirname(d(m))).path:(u=S.posix.dirname(m.path),m.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),u="/")),m.with({path:u})}normalizePath(m){if(!m.path.length)return m;let u;return m.scheme===L.Schemas.file?u=E.URI.file(S.normalize(d(m))).path:u=S.posix.normalize(m.path),m.with({path:u})}relativePath(m,u){if(m.scheme!==u.scheme||!(0,e.isEqualAuthority)(m.authority,u.authority))return;if(m.scheme===L.Schemas.file){const o=S.relative(d(m),d(u));return A.isWindows?v.toSlashes(o):o}let a=m.path||"/";const s=u.path||"/";if(this._ignorePathCasing(m)){let o=0;for(const f=Math.min(a.length,s.length);o<f&&!(a.charCodeAt(o)!==s.charCodeAt(o)&&a.charAt(o).toLowerCase()!==s.charAt(o).toLowerCase());o++);a=s.substr(0,o)+a.substr(o)}return S.posix.relative(a,s)}resolvePath(m,u){if(m.scheme===L.Schemas.file){const a=E.URI.file(S.resolve(d(m),u));return m.with({authority:a.authority,path:a.path})}return u=v.toPosixPath(u),m.with({path:S.posix.resolve(m.path,u)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,u){return m===u||m!==void 0&&u!==void 0&&(0,M.equalsIgnoreCase)(m,u)}hasTrailingPathSeparator(m,u=S.sep){if(m.scheme===L.Schemas.file){const a=d(m);return a.length>v.getRoot(a).length&&a[a.length-1]===u}else{const a=m.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,u=S.sep){return(0,e.hasTrailingPathSeparator)(m,u)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,u=S.sep){let a=!1;if(m.scheme===L.Schemas.file){const s=d(m);a=s!==void 0&&s.length===v.getRoot(s).length&&s[s.length-1]===u}else{u="/";const s=m.path;a=s.length===1&&s.charCodeAt(s.length-1)===47}return!a&&!(0,e.hasTrailingPathSeparator)(m,u)?m.with({path:m.path+"/"}):m}}e.ExtUri=l,e.extUri=new l(()=>!1),e.extUriBiasedIgnorePathCase=new l(r=>r.scheme===L.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new l(r=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(r,m){const u=[];for(let a=0;a<r.length;a++){const s=m(r[a]);r.some((o,f)=>f===a?!1:(0,e.isEqualOrParent)(s,m(o)))||u.push(r[a])}return u}e.distinctParents=P;var p;(function(r){r.META_DATA_LABEL="label",r.META_DATA_DESCRIPTION="description",r.META_DATA_SIZE="size",r.META_DATA_MIME="mime";function m(u){const a=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(f=>{const[n,t]=f.split(":");n&&t&&a.set(n,t)});const o=u.path.substring(0,u.path.indexOf(";"));return o&&a.set(r.META_DATA_MIME,o),a}r.parseMetaData=m})(p||(e.DataUri=p={}));function w(r,m,u){if(m){let a=r.path;return a&&a[0]!==S.posix.sep&&(a=S.posix.sep+a),r.with({scheme:u,authority:m,path:a})}return r.with({scheme:u})}e.toLocalResource=w}),define(ue[9],he([0,1,17,6,4,2,23,3,50,22]),function(oe,e,v,L,S,A,M,E,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(O){return!!O&&typeof O.then=="function"}e.isThenable=P;function p(O){const R=new v.CancellationTokenSource,T=O(R.token),V=new Promise((Y,ie)=>{const ce=R.token.onCancellationRequested(()=>{ce.dispose(),ie(new L.CancellationError)});Promise.resolve(T).then(pe=>{ce.dispose(),R.dispose(),Y(pe)},pe=>{ce.dispose(),R.dispose(),ie(pe)})});return new class{cancel(){R.cancel(),R.dispose()}then(Y,ie){return V.then(Y,ie)}catch(Y){return this.then(void 0,Y)}finally(Y){return V.finally(Y)}}}e.createCancelablePromise=p;function w(O,R,T){return new Promise((V,Y)=>{const ie=R.onCancellationRequested(()=>{ie.dispose(),V(T)});O.then(V,Y).finally(()=>ie.dispose())})}e.raceCancellation=w;function r(O,R){return new Promise((T,V)=>{const Y=R.onCancellationRequested(()=>{Y.dispose(),V(new L.CancellationError)});O.then(T,V).finally(()=>Y.dispose())})}e.raceCancellationError=r;async function m(O){let R=-1;const T=O.map((V,Y)=>V.then(ie=>(R=Y,ie)));try{return await Promise.race(T)}finally{O.forEach((V,Y)=>{Y!==R&&V.cancel()})}}e.raceCancellablePromises=m;function u(O,R,T){let V;const Y=setTimeout(()=>{V?.(void 0),T?.()},R);return Promise.race([O.finally(()=>clearTimeout(Y)),new Promise(ie=>V=ie)])}e.raceTimeout=u;function a(O){return new Promise((R,T)=>{const V=O();P(V)?V.then(R,T):R(V)})}e.asPromise=a;class s{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(R){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=R,!this.queuedPromise){const T=()=>{if(this.queuedPromise=null,this.isDisposed)return;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(T,T).then(V)})}return new Promise((T,V)=>{this.queuedPromise.then(T,V)})}return this.activePromise=R(),new Promise((T,V)=>{this.activePromise.then(Y=>{this.activePromise=null,T(Y)},Y=>{this.activePromise=null,V(Y)})})}dispose(){this.isDisposed=!0}}e.Throttler=s;class o{constructor(){this.current=Promise.resolve(null)}queue(R){return this.current=this.current.then(()=>R(),()=>R())}}e.Sequencer=o;class f{constructor(){this.promiseMap=new Map}queue(R,T){const Y=(this.promiseMap.get(R)??Promise.resolve()).catch(()=>{}).then(T).finally(()=>{this.promiseMap.get(R)===Y&&this.promiseMap.delete(R)});return this.promiseMap.set(R,Y),Y}}e.SequencerByKey=f;const n=(O,R)=>{let T=!0;const V=setTimeout(()=>{T=!1,R()},O);return{isTriggered:()=>T,dispose:()=>{clearTimeout(V),T=!1}}},t=O=>{let R=!0;return queueMicrotask(()=>{R&&(R=!1,O())}),{isTriggered:()=>R,dispose:()=>{R=!1}}};class i{constructor(R){this.defaultDelay=R,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(R,T=this.defaultDelay){this.task=R,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Y,ie)=>{this.doResolve=Y,this.doReject=ie}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Y=this.task;return this.task=null,Y()}}));const V=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=T===d.MicrotaskDelay?t(V):n(T,V),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new L.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=i;class y{constructor(R){this.delayer=new i(R),this.throttler=new s}trigger(R,T){return this.delayer.trigger(()=>this.throttler.queue(R),T)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=y;class F{constructor(){this._isOpen=!1,this._promise=new Promise((R,T)=>{this._completePromise=R})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=F;class g extends F{constructor(R){super(),this._timeout=setTimeout(()=>this.open(),R)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=g;function b(O,R){return R?new Promise((T,V)=>{const Y=setTimeout(()=>{ie.dispose(),T()},O),ie=R.onCancellationRequested(()=>{clearTimeout(Y),ie.dispose(),V(new L.CancellationError)})}):p(T=>b(O,T))}e.timeout=b;function C(O,R=0,T){const V=setTimeout(()=>{O(),T&&Y.dispose()},R),Y=(0,A.toDisposable)(()=>{clearTimeout(V),T?.deleteAndLeak(Y)});return T?.add(Y),Y}e.disposableTimeout=C;function k(O){const R=[];let T=0;const V=O.length;function Y(){return T<V?O[T++]():null}function ie(ce){ce!=null&&R.push(ce);const pe=Y();return pe?pe.then(ie):Promise.resolve(R)}return Promise.resolve(null).then(ie)}e.sequence=k;function j(O,R=V=>!!V,T=null){let V=0;const Y=O.length,ie=()=>{if(V>=Y)return Promise.resolve(T);const ce=O[V++];return Promise.resolve(ce()).then(ye=>R(ye)?Promise.resolve(ye):ie())};return ie()}e.first=j;function B(O,R=V=>!!V,T=null){if(O.length===0)return Promise.resolve(T);let V=O.length;const Y=()=>{V=-1;for(const ie of O)ie.cancel?.()};return new Promise((ie,ce)=>{for(const pe of O)pe.then(ye=>{--V>=0&&R(ye)?(Y(),ie(ye)):V===0&&ie(T)}).catch(ye=>{--V>=0&&(Y(),ce(ye))})})}e.firstParallel=B;class c{constructor(R){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=R,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new S.Emitter}whenIdle(){return this.size>0?S.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(R){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((T,V)=>{this.outstandingPromises.push({factory:R,c:T,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const R=this.outstandingPromises.shift();this.runningPromises++;const T=R.factory();T.then(R.c,R.e),T.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=c;class _ extends c{constructor(){super(1)}}e.Queue=_;class D{constructor(){this.sequentializer=new $,this.tasks=0}queue(R){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,R())):this.sequentializer.run(this.tasks++,R())}}e.LimitedQueue=D;class W{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const R=new H;return this.drainers.add(R),R.p}isDrained(){for(const[,R]of this.queues)if(R.size>0)return!1;return!0}queueSize(R,T=M.extUri){const V=T.getComparisonKey(R);return this.queues.get(V)?.size??0}queueFor(R,T,V=M.extUri){const Y=V.getComparisonKey(R);let ie=this.queues.get(Y);if(!ie){ie=new _;const ce=this.drainListenerCount++,pe=S.Event.once(ie.onDrained)(()=>{ie?.dispose(),this.queues.delete(Y),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(ce),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new A.DisposableMap),this.drainListeners.set(ce,pe),this.queues.set(Y,ie)}return ie.queue(T)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const R of this.drainers)R.complete();this.drainers.clear()}dispose(){for(const[,R]of this.queues)R.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=W;class I{constructor(R,T){this._token=-1,typeof R=="function"&&typeof T=="number"&&this.setIfNotSet(R,T)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(R,T){this.cancel(),this._token=setTimeout(()=>{this._token=-1,R()},T)}setIfNotSet(R,T){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,R()},T))}}e.TimeoutTimer=I;class q{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(R,T,V=globalThis){this.cancel();const Y=V.setInterval(()=>{R()},T);this.disposable=(0,A.toDisposable)(()=>{V.clearInterval(Y),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=q;class ee{constructor(R,T){this.timeoutToken=-1,this.runner=R,this.timeout=T,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(R=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,R)}get delay(){return this.timeout}set delay(R){this.timeout=R}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=ee;class ne{constructor(R,T){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.runner=R,this.timeout=T,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(R=this.timeout){R%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${R}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(R/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=ne;class Q extends ee{constructor(R,T){super(R,T),this.units=[]}work(R){this.units.push(R),this.isScheduled()||this.schedule()}doRun(){const R=this.units;this.units=[],this.runner?.(R)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=Q;class re extends A.Disposable{constructor(R,T){super(),this.options=R,this.handler=T,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(R){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+R.length>this.options.maxBufferedWork)return!1}else if(this.pending+R.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const T of R)this.pendingWork.push(T);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new ee(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=re,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(O,R)=>{(0,E.setTimeout0)(()=>{if(T)return;const V=Date.now()+15;R(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,V-Date.now())}}))});let T=!1;return{dispose(){T||(T=!0)}}}:e._runWhenIdle=(O,R,T)=>{const V=O.requestIdleCallback(R,typeof T=="number"?{timeout:T}:void 0);let Y=!1;return{dispose(){Y||(Y=!0,O.cancelIdleCallback(V))}}},e.runWhenGlobalIdle=O=>(0,e._runWhenIdle)(globalThis,O)}();class le{constructor(R,T){this._didRun=!1,this._executor=()=>{try{this._value=T()}catch(V){this._error=V}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(R,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=le;class de extends le{constructor(R){super(globalThis,R)}}e.GlobalIdleValue=de;async function G(O,R,T){let V;for(let Y=0;Y<T;Y++)try{return await O()}catch(ie){V=ie,await b(R)}throw V}e.retry=G;class ${isRunning(R){return typeof R=="number"?this._running?.taskId===R:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(R,T,V){return this._running={taskId:R,cancel:()=>V?.(),promise:T},T.then(()=>this.doneRunning(R),()=>this.doneRunning(R)),T}doneRunning(R){this._running&&R===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const R=this._queued;this._queued=void 0,R.run().then(R.promiseResolve,R.promiseReject)}}queue(R){if(this._queued)this._queued.run=R;else{let T,V;const Y=new Promise((ie,ce)=>{T=ie,V=ce});this._queued={run:R,promise:Y,promiseResolve:T,promiseReject:V}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=$;class X{constructor(R,T=()=>Date.now()){this.interval=R,this.nowFn=T,this.lastIncrementTime=0,this.value=0}increment(){const R=this.nowFn();return R-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=R,this.value=0),this.value++,this.value}}e.IntervalCounter=X;var te;(function(O){O[O.Resolved=0]="Resolved",O[O.Rejected=1]="Rejected"})(te||(te={}));class H{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((R,T)=>{this.completeCallback=R,this.errorCallback=T})}complete(R){return new Promise(T=>{this.completeCallback(R),this.outcome={outcome:0,value:R},T()})}error(R){return new Promise(T=>{this.errorCallback(R),this.outcome={outcome:1,value:R},T()})}cancel(){return this.error(new L.CancellationError)}}e.DeferredPromise=H;var x;(function(O){async function R(V){let Y;const ie=await Promise.all(V.map(ce=>ce.then(pe=>pe,pe=>{Y||(Y=pe)})));if(typeof Y<"u")throw Y;return ie}O.settled=R;function T(V){return new Promise(async(Y,ie)=>{try{await V(Y,ie)}catch(ce){ie(ce)}})}O.withAsyncBody=T})(x||(e.Promises=x={}));class me{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(R){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=R.then(T=>(this._value=T,this._isResolved=!0,T),T=>{throw this._error=T,this._isResolved=!0,T})}requireValue(){if(!this._isResolved)throw new L.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=me;class Z{constructor(R){this._compute=R,this._promise=new l.Lazy(()=>new me(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=Z;var h;(function(O){O[O.Initial=0]="Initial",O[O.DoneOK=1]="DoneOK",O[O.DoneError=2]="DoneError"})(h||(h={}));class U{static fromArray(R){return new U(T=>{T.emitMany(R)})}static fromPromise(R){return new U(async T=>{T.emitMany(await R)})}static fromPromises(R){return new U(async T=>{await Promise.all(R.map(async V=>T.emitOne(await V)))})}static merge(R){return new U(async T=>{await Promise.all(R.map(async V=>{for await(const Y of V)T.emitOne(Y)}))})}static{this.EMPTY=U.fromArray([])}constructor(R){this._state=0,this._results=[],this._error=null,this._onStateChanged=new S.Emitter,queueMicrotask(async()=>{const T={emitOne:V=>this.emitOne(V),emitMany:V=>this.emitMany(V),reject:V=>this.reject(V)};try{await Promise.resolve(R(T)),this.resolve()}catch(V){this.reject(V)}finally{T.emitOne=void 0,T.emitMany=void 0,T.reject=void 0}})}[Symbol.asyncIterator](){let R=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(R<this._results.length)return{done:!1,value:this._results[R++]};if(this._state===1)return{done:!0,value:void 0};await S.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(R,T){return new U(async V=>{for await(const Y of R)V.emitOne(T(Y))})}map(R){return U.map(this,R)}static filter(R,T){return new U(async V=>{for await(const Y of R)T(Y)&&V.emitOne(Y)})}filter(R){return U.filter(this,R)}static coalesce(R){return U.filter(R,T=>!!T)}coalesce(){return U.coalesce(this)}static async toPromise(R){const T=[];for await(const V of R)T.push(V);return T}toPromise(){return U.toPromise(this)}emitOne(R){this._state===0&&(this._results.push(R),this._onStateChanged.fire())}emitMany(R){this._state===0&&(this._results=this._results.concat(R),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(R){this._state===0&&(this._state=2,this._error=R,this._onStateChanged.fire())}}e.AsyncIterableObject=U;class se extends U{constructor(R,T){super(T),this._source=R}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=se;function N(O){const R=new v.CancellationTokenSource,T=O(R.token);return new se(R,async V=>{const Y=R.token.onCancellationRequested(()=>{Y.dispose(),R.dispose(),V.reject(new L.CancellationError)});try{for await(const ie of T){if(R.token.isCancellationRequested)return;V.emitOne(ie)}Y.dispose(),R.dispose()}catch(ie){Y.dispose(),R.dispose(),V.reject(ie)}})}e.createCancelableAsyncIterable=N;class K{constructor(){this._deferred=new H,this._asyncIterable=new U(V=>{if(R){V.reject(R);return}return T&&V.emitMany(T),this._errorFn=Y=>V.reject(Y),this._emitFn=Y=>V.emitOne(Y),this._deferred.p});let R,T;this._emitFn=V=>{T||(T=[]),T.push(V)},this._errorFn=V=>{R||(R=V)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(R){this._errorFn(R),this._deferred.complete()}emitOne(R){this._emitFn(R)}}e.AsyncIterableSource=K}),define(ue[60],he([0,1,18,5]),function(oe,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function S(p){return p.toJSON()}class A{constructor(w){this._uriTransformer=w}transformIncoming(w){const r=this._uriTransformer.transformIncoming(w);return r===w?w:S(L.URI.from(r))}transformOutgoing(w){const r=this._uriTransformer.transformOutgoing(w);return r===w?w:S(L.URI.from(r))}transformOutgoingURI(w){const r=this._uriTransformer.transformOutgoing(w);return r===w?w:L.URI.from(r)}transformOutgoingScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(p){return p}transformOutgoing(p){return p}transformOutgoingURI(p){return p}transformOutgoingScheme(p){return p}};function M(p,w,r){if(!p||r>200)return null;if(typeof p=="object"){if(p instanceof L.URI)return w.transformOutgoing(p);for(const m in p)if(Object.hasOwnProperty.call(p,m)){const u=M(p[m],w,r+1);u!==null&&(p[m]=u)}}return null}function E(p,w){const r=M(p,w,0);return r===null?p:r}e.transformOutgoingURIs=E;function d(p,w,r,m){if(!p||m>200)return null;if(typeof p=="object"){if(p.$mid===1)return r?L.URI.revive(w.transformIncoming(p)):w.transformIncoming(p);if(p instanceof v.VSBuffer)return null;for(const u in p)if(Object.hasOwnProperty.call(p,u)){const a=d(p[u],w,r,m+1);a!==null&&(p[u]=a)}}return null}function l(p,w){const r=d(p,w,!1,0);return r===null?p:r}e.transformIncomingURIs=l;function P(p,w){const r=d(p,w,!0,0);return r===null?p:r}e.transformAndReviveIncomingURIs=P}),define(ue[24],he([0,1,104,20,105,9,32,45,7,3,23,5]),function(oe,e,v,L,S,A,M,E,d,l,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(Q){Q[Q.UNLINK=0]="UNLINK",Q[Q.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function r(Q,re=w.UNLINK,le){if((0,M.isRootOrDriveLetter)(Q))throw new Error("rimraf - will refuse to recursively delete root");return re===w.UNLINK?u(Q):m(Q,le)}async function m(Q,re=(0,M.randomPath)((0,L.tmpdir)())){try{try{await v.promises.rename(Q,re)}catch(le){return le.code==="ENOENT"?void 0:u(Q)}u(re).catch(le=>{})}catch(le){if(le.code!=="ENOENT")throw le}}async function u(Q){return(0,S.promisify)(v.rm)(Q,{recursive:!0,force:!0,maxRetries:3})}function a(Q){if((0,M.isRootOrDriveLetter)(Q))throw new Error("rimraf - will refuse to recursively delete root");v.rmSync(Q,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=a;async function s(Q,re){return n(await(re?o(Q):(0,S.promisify)(v.readdir)(Q)))}async function o(Q){try{return await(0,S.promisify)(v.readdir)(Q,{withFileTypes:!0})}catch(de){console.warn("[node.js fs] readdir with filetypes failed with error: ",de)}const re=[],le=await s(Q);for(const de of le){let G=!1,$=!1,X=!1;try{const te=await e.Promises.lstat((0,d.join)(Q,de));G=te.isFile(),$=te.isDirectory(),X=te.isSymbolicLink()}catch(te){console.warn("[node.js fs] unexpected error from lstat after readdir: ",te)}re.push({name:de,isFile:()=>G,isDirectory:()=>$,isSymbolicLink:()=>X})}return re}function f(Q){return n(v.readdirSync(Q))}e.readdirSync=f;function n(Q){return Q.map(re=>typeof re=="string"?l.isMacintosh?(0,E.normalizeNFC)(re):re:(re.name=l.isMacintosh?(0,E.normalizeNFC)(re.name):re.name,re))}async function t(Q){const re=await s(Q),le=[];for(const de of re)await y.existsDirectory((0,d.join)(Q,de))&&le.push(de);return le}function i(Q,re=1e3){return new Promise(le=>{let de=!1;const G=setInterval(()=>{de||(de=!0,v.access(Q,$=>{de=!1,$&&(clearInterval(G),le(void 0))}))},re)})}e.whenDeleted=i;var y;(function(Q){async function re(G){let $;try{if($=await e.Promises.lstat(G),!$.isSymbolicLink())return{stat:$}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:$?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};if(l.isWindows&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(te){if(te.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};throw te}throw X}}Q.stat=re;async function le(G){try{const{stat:$,symbolicLink:X}=await Q.stat(G);return $.isFile()&&X?.dangling!==!0}catch{}return!1}Q.existsFile=le;async function de(G){try{const{stat:$,symbolicLink:X}=await Q.stat(G);return $.isDirectory()&&X?.dangling!==!0}catch{}return!1}Q.existsDirectory=de})(y||(e.SymlinkSupport=y={}));const F=new A.ResourceQueue;function g(Q,re,le){return F.queueFor(p.URI.file(Q),()=>{const de=B(le);return new Promise((G,$)=>k(Q,re,de,X=>X?$(X):G()))},P.extUriBiasedIgnorePathCase)}let b=!0;function C(Q){b=Q}e.configureFlushOnWrite=C;function k(Q,re,le,de){if(!b)return v.writeFile(Q,re,{mode:le.mode,flag:le.flag},de);v.open(Q,le.flag,le.mode,(G,$)=>{if(G)return de(G);v.writeFile($,re,X=>{if(X)return v.close($,()=>de(X));v.fdatasync($,te=>(te&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",te),C(!1)),v.close($,H=>de(H))))})})}function j(Q,re,le){const de=B(le);if(!b)return v.writeFileSync(Q,re,{mode:de.mode,flag:de.flag});const G=v.openSync(Q,de.flag,de.mode);try{v.writeFileSync(G,re);try{v.fdatasyncSync(G)}catch($){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",$),C(!1)}}finally{v.closeSync(G)}}e.writeFileSync=j;function B(Q){return Q?{mode:typeof Q.mode=="number"?Q.mode:438,flag:typeof Q.flag=="string"?Q.flag:"w"}:{mode:438,flag:"w"}}async function c(Q,re,le=6e4){if(Q!==re)try{l.isWindows&&typeof le=="number"?await _(Q,re,Date.now(),le):await(0,S.promisify)(v.rename)(Q,re)}catch(de){if(Q.toLowerCase()!==re.toLowerCase()&&de.code==="EXDEV"||Q.endsWith("."))await D(Q,re,{preserveSymlinks:!1}),await r(Q,w.MOVE);else throw de}}async function _(Q,re,le,de,G=0){try{return await(0,S.promisify)(v.rename)(Q,re)}catch($){if($.code!=="EACCES"&&$.code!=="EPERM"&&$.code!=="EBUSY")throw $;if(Date.now()-le>=de)throw console.error(`[node.js fs] rename failed after ${G} retries with error: ${$}`),$;if(G===0){let X=!1;try{const{stat:te}=await y.stat(re);te.isFile()||(X=!0)}catch{}if(X)throw $}return await(0,A.timeout)(Math.min(100,G*10)),_(Q,re,le,de,G+1)}}async function D(Q,re,le){return I(Q,re,{root:{source:Q,target:re},options:le,handledSourcePaths:new Set})}const W=511;async function I(Q,re,le){if(le.handledSourcePaths.has(Q))return;le.handledSourcePaths.add(Q);const{stat:de,symbolicLink:G}=await y.stat(Q);if(G){if(le.options.preserveSymlinks)try{return await ne(Q,re,le)}catch{}if(G.dangling)return}return de.isDirectory()?q(Q,re,de.mode&W,le):ee(Q,re,de.mode&W)}async function q(Q,re,le,de){await e.Promises.mkdir(re,{recursive:!0,mode:le});const G=await s(Q);for(const $ of G)await I((0,d.join)(Q,$),(0,d.join)(re,$),de)}async function ee(Q,re,le){await e.Promises.copyFile(Q,re),await e.Promises.chmod(re,le)}async function ne(Q,re,le){let de=await e.Promises.readlink(Q);(0,M.isEqualOrParent)(de,le.root.source,!l.isLinux)&&(de=(0,d.join)(le.root.target,de.substr(le.root.source.length+1))),await e.Promises.symlink(de,re)}e.Promises=new class{get access(){return(0,S.promisify)(v.access)}get stat(){return(0,S.promisify)(v.stat)}get lstat(){return(0,S.promisify)(v.lstat)}get utimes(){return(0,S.promisify)(v.utimes)}get read(){return(Q,re,le,de,G)=>new Promise(($,X)=>{v.read(Q,re,le,de,G,(te,H,x)=>te?X(te):$({bytesRead:H,buffer:x}))})}get readFile(){return(0,S.promisify)(v.readFile)}get write(){return(Q,re,le,de,G)=>new Promise(($,X)=>{v.write(Q,re,le,de,G,(te,H,x)=>te?X(te):$({bytesWritten:H,buffer:x}))})}get appendFile(){return(0,S.promisify)(v.appendFile)}get fdatasync(){return(0,S.promisify)(v.fdatasync)}get truncate(){return(0,S.promisify)(v.truncate)}get copyFile(){return(0,S.promisify)(v.copyFile)}get open(){return(0,S.promisify)(v.open)}get close(){return(0,S.promisify)(v.close)}get symlink(){return(0,S.promisify)(v.symlink)}get readlink(){return(0,S.promisify)(v.readlink)}get chmod(){return(0,S.promisify)(v.chmod)}get mkdir(){return(0,S.promisify)(v.mkdir)}get unlink(){return(0,S.promisify)(v.unlink)}get rmdir(){return(0,S.promisify)(v.rmdir)}get realpath(){return(0,S.promisify)(v.realpath)}async exists(Q){try{return await e.Promises.access(Q),!0}catch{return!1}}get readdir(){return s}get readDirsInDir(){return t}get writeFile(){return g}get rm(){return r}get rename(){return c}get copy(){return D}}}),define(ue[61],he([0,1,20,7,24]),function(oe,e,v,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,M=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var d;(function(n){n[n.x64=0]="x64",n[n.x86=1]="x86",n[n.ARM=2]="ARM"})(d||(d={}));let l;switch(process.arch){case"ia32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class p{constructor(t,i,y){this.exePath=t,this.displayName=i,this.knownToExist=y}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await S.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function w({useAlternateBitness:n=!1}={}){return n?l===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function r({useAlternateBitness:n=!1,findPreview:t=!1}={}){const i=w({useAlternateBitness:n});if(!i)return null;const y=L.join(i,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(y))return null;let F=-1,g=null;for(const k of await S.Promises.readdir(y)){let j=-1;if(t){const c=k.indexOf("-");if(c<0)continue;const _=k.substring(0,c);if(!A.test(_)||k.substring(c+1)!=="preview")continue;j=parseInt(_,10)}else{if(!A.test(k))continue;j=parseInt(k,10)}if(j<=F)continue;const B=L.join(y,k,"pwsh.exe");await S.SymlinkSupport.existsFile(B)&&(g=B,F=j)}if(!g)return null;const b=i.includes("x86")?" (x86)":"",C=t?" Preview":"";return new p(g,`PowerShell${C}${b}`,!0)}async function m({findPreview:n}={}){if(!process.env.LOCALAPPDATA)return null;const t=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(t))return null;const{pwshMsixDirRegex:i,pwshMsixName:y}=n?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const F of await S.Promises.readdir(t))if(i.test(F)){const g=L.join(t,F,"pwsh.exe");return new p(g,y)}return null}function u(){const n=L.join(v.homedir(),".dotnet","tools","pwsh.exe");return new p(n,".NET Core PowerShell Global Tool")}function a(){const n=L.join(process.env.windir,l===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new p(n,"Windows PowerShell",!0)}async function*s(){let n=await r();n&&(yield n),n=await r({useAlternateBitness:!0}),n&&(yield n),n=await m(),n&&(yield n),n=u(),n&&(yield n),n=await r({findPreview:!0}),n&&(yield n),n=await m({findPreview:!0}),n&&(yield n),n=await r({useAlternateBitness:!0,findPreview:!0}),n&&(yield n),n=a(),n&&(yield n)}async function*o(){for await(const n of s())await n.exists()&&(yield n)}e.enumeratePowerShellInstallations=o;async function f(){for await(const n of o())return n;return null}e.getFirstAvailablePowerShellInstallation=f}),define(ue[34],he([0,1,7,3,15,33,8,24]),function(oe,e,v,L,S,A,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function d(p=S.env){return p.comspec||"cmd.exe"}e.getWindowsShell=d;function l(p){let w=[],r=!1;const m=function(u){if(r){w.push(u);return}(!p.send(u,s=>{if(s&&console.error(s),r=!1,w.length>0){const o=w.slice(0);w=[],o.forEach(f=>m(f))}})||L.isWindows)&&(r=!0)};return{send:m}}e.createQueuedSender=l;var P;(function(p){async function w(r,m,u){if(v.isAbsolute(r))return r;if(m===void 0&&(m=S.cwd()),v.dirname(r)!=="."||(u===void 0&&M.isString(S.env.PATH)&&(u=S.env.PATH.split(v.delimiter)),u===void 0||u.length===0))return v.join(m,r);async function s(o){if(await E.Promises.exists(o)){let f;try{f=await E.Promises.stat(o)}catch(n){n.message.startsWith("EACCES")&&(f=await E.Promises.lstat(o))}return f?!f.isDirectory():!1}return!1}for(const o of u){let f;if(v.isAbsolute(o)?f=v.join(o,r):f=v.join(m,o,r),await s(f))return f;let n=f+".com";if(await s(n)||(n=f+".exe",await s(n)))return n}return v.join(m,r)}p.findExecutable=w})(P||(e.win32=P={}))}),define(ue[62],he([0,1,26,19]),function(oe,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function S(M){return new Promise((E,d)=>{let l;const P=new Map;function p(r,m,u,a,s){const o=P.get(m);if(r===M||o){const f={name:w(u),cmd:u,pid:r,ppid:m,load:a,mem:s};P.set(r,f),r===M&&(l=f),o&&(o.children||(o.children=[]),o.children.push(f),o.children.length>1&&(o.children=o.children.sort((n,t)=>n.pid-t.pid)))}}function w(r){const m=/--utility-sub-type=network/i,u=/--crashes-directory/i,a=/\\pipe\\winpty-control/i,s=/conhost\.exe.+--headless/i,o=/--type=([a-zA-Z-]+)/;if(u.exec(r))return"electron-crash-reporter";if(a.exec(r))return"winpty-agent";if(s.exec(r))return"conpty-agent";let f=o.exec(r);if(f&&f.length===2)return f[1]==="renderer"?"window":f[1]==="utility"?m.exec(r)?"utility-network-service":"utility-process":f[1]==="extensionHost"?"extension-host":f[1];const n=/[a-zA-Z-]+\.js/g;let t="";do f=n.exec(r),f&&(t+=f+" ");while(f);return t&&r.indexOf("node ")<0&&r.indexOf("node.exe")<0?`electron-nodejs (${t})`:r}if(process.platform==="win32"){const r=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substring(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substring(5):m;new Promise((m,u)=>{oe(["@vscode/windows-process-tree"],m,u)}).then(m=>{m.getProcessList(M,u=>{if(!u){d(new Error(`Root process ${M} not found`));return}m.getProcessCpuUsage(u,a=>{const s=new Map;a.forEach(o=>{const f=r(o.commandLine||"");s.set(o.pid,{name:w(f),cmd:f,pid:o.pid,ppid:o.ppid,load:o.cpu||0,mem:o.memory||0})}),l=s.get(M),l?(s.forEach(o=>{const f=s.get(o.ppid);f&&(f.children||(f.children=[]),f.children.push(o))}),s.forEach(o=>{o.children&&(o.children=o.children.sort((f,n)=>f.pid-n.pid))}),E(l)):d(new Error(`Root process ${M} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let r=function(){let m=[l];const u=[];for(;m.length;){const s=m.shift();s&&(u.push(s.pid),s.children&&(m=m.concat(s.children)))}let a=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);a+=" "+u.join(" "),(0,v.exec)(a,{},(s,o,f)=>{if(s||f)d(s||new Error(f.toString()));else{const n=o.toString().split(`
`);for(let t=0;t<u.length;t++){const i=P.get(u[t]);i.load=parseFloat(n[t])}if(!l){d(new Error(`Root process ${M} not found`));return}E(l)}})};(0,v.exec)("which ps",{},(m,u,a)=>{if(m||a)if(process.platform!=="linux")d(m||new Error(a.toString()));else{const s=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,v.exec)(s,{},(o,f,n)=>{o||n?d(o||new Error(n.toString())):(A(f,p),r())})}else{const s=u.toString().trim(),o="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${s} ${o}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,n,t)=>{f||t&&!t.includes("screen size is bogus")?d(f||new Error(t.toString())):(A(n,p),process.platform==="linux"?r():l?E(l):d(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=S;function A(M,E){const d=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,l=M.toString().split(`
`);for(const P of l){const p=d.exec(P.trim());p&&p.length===6&&E(parseInt(p[1]),parseInt(p[2]),p[5],parseFloat(p[3]),parseFloat(p[4]))}}}),define(ue[63],he([0,1,20,3,61,34]),function(oe,e,v,L,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function M(p,w){return p===1?L.isWindows?P():A.getWindowsShell(w):d(p,w)}e.getSystemShell=M;let E=null;function d(p,w){if(L.isLinux&&p===2||L.isMacintosh&&p===3)return"/bin/bash";if(!E){let r;if(L.isWindows)r="/bin/bash";else{if(r=w.SHELL,!r)try{r=(0,v.userInfo)().shell}catch{}r||(r="sh"),r==="/bin/false"&&(r="/bin/bash")}E=r}return E}let l=null;async function P(){return l||(l=(await(0,S.getFirstAvailablePowerShellInstallation)()).exePath),l}});var ge=this&&this.__decorate||function(oe,e,v,L){var S=arguments.length,A=S<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,v):L,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(oe,e,v,L);else for(var E=oe.length-1;E>=0;E--)(M=oe[E])&&(A=(S<3?M(A):S>3?M(e,v,A):M(e,v))||A);return S>3&&A&&Object.defineProperty(e,v,A),A};define(ue[27],he([0,1,16,9,18,17,14,6,4,2,59,11,8]),function(oe,e,v,L,S,A,M,E,d,l,P,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var r;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(r||(r={}));function m(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(u||(u={}));function a(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var s;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})(s||(s={}));function o(G){let $=0;for(let X=0;;X+=7){const te=G.read(1);if($|=(te.buffer[0]&127)<<X,!(te.buffer[0]&128))return $}}const f=F(0);function n(G,$){if($===0){G.write(f);return}let X=0;for(let H=$;H!==0;H=H>>>7)X++;const te=S.VSBuffer.alloc(X);for(let H=0;$!==0;H++)te.buffer[H]=$&127,$=$>>>7,$>0&&(te.buffer[H]|=128);G.write(te)}class t{constructor($){this.buffer=$,this.pos=0}read($){const X=this.buffer.slice(this.pos,this.pos+$);return this.pos+=X.byteLength,X}}e.BufferReader=t;class i{constructor(){this.buffers=[]}get buffer(){return S.VSBuffer.concat(this.buffers)}write($){this.buffers.push($)}}e.BufferWriter=i;var y;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object",G[G.Int=6]="Int"})(y||(y={}));function F(G){const $=S.VSBuffer.alloc(1);return $.writeUInt8(G,0),$}const g={Undefined:F(y.Undefined),String:F(y.String),Buffer:F(y.Buffer),VSBuffer:F(y.VSBuffer),Array:F(y.Array),Object:F(y.Object),Uint:F(y.Int)},b=typeof Buffer<"u";function C(G,$){if(typeof $>"u")G.write(g.Undefined);else if(typeof $=="string"){const X=S.VSBuffer.fromString($);G.write(g.String),n(G,X.byteLength),G.write(X)}else if(b&&Buffer.isBuffer($)){const X=S.VSBuffer.wrap($);G.write(g.Buffer),n(G,X.byteLength),G.write(X)}else if($ instanceof S.VSBuffer)G.write(g.VSBuffer),n(G,$.byteLength),G.write($);else if(Array.isArray($)){G.write(g.Array),n(G,$.length);for(const X of $)C(G,X)}else if(typeof $=="number"&&($|0)===$)G.write(g.Uint),n(G,$);else{const X=S.VSBuffer.fromString(JSON.stringify($));G.write(g.Object),n(G,X.byteLength),G.write(X)}}e.serialize=C;function k(G){switch(G.read(1).readUInt8(0)){case y.Undefined:return;case y.String:return G.read(o(G)).toString();case y.Buffer:return G.read(o(G)).buffer;case y.VSBuffer:return G.read(o(G));case y.Array:{const X=o(G),te=[];for(let H=0;H<X;H++)te.push(k(G));return te}case y.Object:return JSON.parse(G.read(o(G)).toString());case y.Int:return o(G)}}e.deserialize=k;class j{constructor($,X,te=null,H=1e3){this.protocol=$,this.ctx=X,this.logger=te,this.timeoutDelay=H,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(x=>this.onRawMessage(x)),this.sendResponse({type:200})}registerChannel($,X){this.channels.set($,X),setTimeout(()=>this.flushPendingRequests($),0)}sendResponse($){switch($.type){case 200:{const X=this.send([$.type]);this.logger?.logOutgoing(X,0,1,a($.type));return}case 201:case 202:case 204:case 203:{const X=this.send([$.type,$.id],$.data);this.logger?.logOutgoing(X,$.id,1,a($.type),$.data);return}}}send($,X=void 0){const te=new i;return C(te,$),C(te,X),this.sendBuffer(te.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch{return 0}}onRawMessage($){const X=new t($),te=k(X),H=k(X),x=te[0];switch(x){case 100:return this.logger?.logIncoming($.byteLength,te[1],1,`${m(x)}: ${te[2]}.${te[3]}`,H),this.onPromise({type:x,id:te[1],channelName:te[2],name:te[3],arg:H});case 102:return this.logger?.logIncoming($.byteLength,te[1],1,`${m(x)}: ${te[2]}.${te[3]}`,H),this.onEventListen({type:x,id:te[1],channelName:te[2],name:te[3],arg:H});case 101:return this.logger?.logIncoming($.byteLength,te[1],1,`${m(x)}`),this.disposeActiveRequest({type:x,id:te[1]});case 103:return this.logger?.logIncoming($.byteLength,te[1],1,`${m(x)}`),this.disposeActiveRequest({type:x,id:te[1]})}}onPromise($){const X=this.channels.get($.channelName);if(!X){this.collectPendingRequest($);return}const te=new A.CancellationTokenSource;let H;try{H=X.call(this.ctx,$.name,$.arg,te.token)}catch(Z){H=Promise.reject(Z)}const x=$.id;H.then(Z=>{this.sendResponse({id:x,data:Z,type:201})},Z=>{Z instanceof Error?this.sendResponse({id:x,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:202}):this.sendResponse({id:x,data:Z,type:203})}).finally(()=>{me.dispose(),this.activeRequests.delete($.id)});const me=(0,l.toDisposable)(()=>te.cancel());this.activeRequests.set($.id,me)}onEventListen($){const X=this.channels.get($.channelName);if(!X){this.collectPendingRequest($);return}const te=$.id,x=X.listen(this.ctx,$.name,$.arg)(me=>this.sendResponse({id:te,data:me,type:204}));this.activeRequests.set($.id,x)}disposeActiveRequest($){const X=this.activeRequests.get($.id);X&&(X.dispose(),this.activeRequests.delete($.id))}collectPendingRequest($){let X=this.pendingRequests.get($.channelName);X||(X=[],this.pendingRequests.set($.channelName,X));const te=setTimeout(()=>{console.error(`Unknown channel: ${$.channelName}`),$.type===100&&this.sendResponse({id:$.id,data:{name:"Unknown channel",message:`Channel name '${$.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);X.push({request:$,timeoutTimer:te})}flushPendingRequests($){const X=this.pendingRequests.get($);if(X){for(const te of X)switch(clearTimeout(te.timeoutTimer),te.request.type){case 100:this.onPromise(te.request);break;case 102:this.onEventListen(te.request);break}this.pendingRequests.delete($)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=j;var B;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(B||(e.RequestInitiator=B={}));class c{constructor($,X=null){this.protocol=$,this.isDisposed=!1,this.state=s.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new d.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(te=>this.onBuffer(te)),this.logger=X}getChannel($){const X=this;return{call(te,H,x){return X.isDisposed?Promise.reject(new E.CancellationError):X.requestPromise($,te,H,x)},listen(te,H){return X.isDisposed?d.Event.None:X.requestEvent($,te,H)}}}requestPromise($,X,te,H=A.CancellationToken.None){const x=this.lastRequestId++,Z={id:x,type:100,channelName:$,name:X,arg:te};if(H.isCancellationRequested)return Promise.reject(new E.CancellationError);let h;return new Promise((se,N)=>{if(H.isCancellationRequested)return N(new E.CancellationError);const K=()=>{const V=Y=>{switch(Y.type){case 201:this.handlers.delete(x),se(Y.data);break;case 202:{this.handlers.delete(x);const ie=new Error(Y.data.message);ie.stack=Array.isArray(Y.data.stack)?Y.data.stack.join(`
`):Y.data.stack,ie.name=Y.data.name,N(ie);break}case 203:this.handlers.delete(x),N(Y.data);break}};this.handlers.set(x,V),this.sendRequest(Z)};let O=null;this.state===s.Idle?K():(O=(0,L.createCancelablePromise)(V=>this.whenInitialized()),O.then(()=>{O=null,K()}));const R=()=>{O?(O.cancel(),O=null):this.sendRequest({id:x,type:101}),N(new E.CancellationError)},T=H.onCancellationRequested(R);h=(0,l.combinedDisposable)((0,l.toDisposable)(R),T),this.activeRequests.add(h)}).finally(()=>{h.dispose(),this.activeRequests.delete(h)})}requestEvent($,X,te){const H=this.lastRequestId++,me={id:H,type:102,channelName:$,name:X,arg:te};let Z=null;const h=new d.Emitter({onWillAddFirstListener:()=>{Z=(0,L.createCancelablePromise)(se=>this.whenInitialized()),Z.then(()=>{Z=null,this.activeRequests.add(h),this.sendRequest(me)})},onDidRemoveLastListener:()=>{Z?(Z.cancel(),Z=null):(this.activeRequests.delete(h),this.sendRequest({id:H,type:103}))}}),U=se=>h.fire(se.data);return this.handlers.set(H,U),h.event}sendRequest($){switch($.type){case 100:case 102:{const X=this.send([$.type,$.id,$.channelName,$.name],$.arg);this.logger?.logOutgoing(X,$.id,0,`${m($.type)}: ${$.channelName}.${$.name}`,$.arg);return}case 101:case 103:{const X=this.send([$.type,$.id]);this.logger?.logOutgoing(X,$.id,0,m($.type));return}}}send($,X=void 0){const te=new i;return C(te,$),C(te,X),this.sendBuffer(te.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch{return 0}}onBuffer($){const X=new t($),te=k(X),H=k(X),x=te[0];switch(x){case 200:return this.logger?.logIncoming($.byteLength,0,0,a(x)),this.onResponse({type:te[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming($.byteLength,te[1],0,a(x),H),this.onResponse({type:te[0],id:te[1],data:H})}}onResponse($){if($.type===200){this.state=s.Idle,this._onDidInitialize.fire();return}this.handlers.get($.id)?.($)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===s.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=c,ge([M.memoize],c.prototype,"onDidInitializePromise",null);class _{get connections(){const $=[];return this._connections.forEach(X=>$.push(X)),$}constructor($){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new d.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new d.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new l.DisposableStore,this.disposables.add($(({protocol:X,onDidClientDisconnect:te})=>{const H=d.Event.once(X.onMessage);this.disposables.add(H(x=>{const me=new t(x),Z=k(me),h=new j(X,Z),U=new c(X);this.channels.forEach((N,K)=>h.registerChannel(K,N));const se={channelServer:h,channelClient:U,ctx:Z};this._connections.add(se),this._onDidAddConnection.fire(se),this.disposables.add(te(()=>{h.dispose(),U.dispose(),this._connections.delete(se),this._onDidRemoveConnection.fire(se)}))}))}))}getChannel($,X){const te=this;return{call(H,x,me){let Z;if((0,w.isFunction)(X)){const U=(0,v.getRandomElement)(te.connections.filter(X));Z=U?Promise.resolve(U):d.Event.toPromise(d.Event.filter(te.onDidAddConnection,X))}else Z=X.routeCall(te,H,x);const h=Z.then(U=>U.channelClient.getChannel($));return W(h).call(H,x,me)},listen(H,x){if((0,w.isFunction)(X))return te.getMulticastEvent($,X,H,x);const me=X.routeEvent(te,H,x).then(Z=>Z.channelClient.getChannel($));return W(me).listen(H,x)}}}getMulticastEvent($,X,te,H){const x=this;let me;const Z=new d.Emitter({onWillAddFirstListener:()=>{me=new l.DisposableStore;const h=new d.EventMultiplexer,U=new Map,se=K=>{const R=K.channelClient.getChannel($).listen(te,H),T=h.add(R);U.set(K,T)},N=K=>{const O=U.get(K);O&&(O.dispose(),U.delete(K))};x.connections.filter(X).forEach(se),d.Event.filter(x.onDidAddConnection,X)(se,void 0,me),x.onDidRemoveConnection(N,void 0,me),h.event(Z.fire,Z,me),me.add(h)},onDidRemoveLastListener:()=>{me?.dispose(),me=void 0}});return Z.event}registerChannel($,X){this.channels.set($,X);for(const te of this._connections)te.channelServer.registerChannel($,X)}dispose(){this.disposables.dispose();for(const $ of this._connections)$.channelClient.dispose(),$.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=_;class D{constructor($,X,te=null){const H=new i;C(H,X),$.send(H.buffer),this.channelClient=new c($,te),this.channelServer=new j($,X,te)}getChannel($){return this.channelClient.getChannel($)}registerChannel($,X){this.channelServer.registerChannel($,X)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=D;function W(G){return{call($,X,te){return G.then(H=>H.call($,X,te))},listen($,X){const te=new d.Relay;return G.then(H=>te.input=H.listen($,X)),te.event}}}e.getDelayedChannel=W;function I(G){let $=!1;return{call(X,te,H){return $?G.call(X,te,H):(0,L.timeout)(0).then(()=>$=!0).then(()=>G.call(X,te,H))},listen(X,te){if($)return G.listen(X,te);const H=new d.Relay;return(0,L.timeout)(0).then(()=>$=!0).then(()=>H.input=G.listen(X,te)),H.event}}}e.getNextTickChannel=I;class q{constructor($){this.fn=$}routeCall($){return this.route($)}routeEvent($){return this.route($)}async route($){for(const X of $.connections)if(await Promise.resolve(this.fn(X.ctx)))return Promise.resolve(X);return await d.Event.toPromise($.onDidAddConnection),await this.route($)}}e.StaticRouter=q;var ee;(function(G){function $(x,me,Z){const h=x,U=Z&&Z.disableMarshalling,se=new Map;for(const N in h)te(N)&&se.set(N,d.Event.buffer(h[N],!0,void 0,me));return new class{listen(N,K,O){const R=se.get(K);if(R)return R;if(H(K)){const T=h[K];if(typeof T=="function")return T.call(h,O)}throw new E.ErrorNoTelemetry(`Event not found: ${K}`)}call(N,K,O){const R=h[K];if(typeof R=="function"){if(!U&&Array.isArray(O))for(let V=0;V<O.length;V++)O[V]=(0,P.revive)(O[V]);let T=R.apply(h,O);return T instanceof Promise||(T=Promise.resolve(T)),T}throw new E.ErrorNoTelemetry(`Method not found: ${K}`)}}}G.fromService=$;function X(x,me){const Z=me&&me.disableMarshalling;return new Proxy({},{get(h,U){if(typeof U=="string")return me?.properties?.has(U)?me.properties.get(U):H(U)?function(se){return x.listen(U,se)}:te(U)?x.listen(U):async function(...se){let N;me&&!(0,w.isUndefinedOrNull)(me.context)?N=[me.context,...se]:N=se;const K=await x.call(U,N);return Z?K:(0,P.revive)(K)};throw new E.ErrorNoTelemetry(`Property not found: ${String(U)}`)}})}G.toService=X;function te(x){return x[0]==="o"&&x[1]==="n"&&p.isUpperAsciiLetter(x.charCodeAt(2))}function H(x){return/^onDynamic/.test(x)&&p.isUpperAsciiLetter(x.charCodeAt(9))}})(ee||(e.ProxyChannel=ee={}));const ne=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Q(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){const $=G.toString();if($!=="[object Object]")return $}return G}function re(G){return Array.isArray(G)?G.map(Q):Q(G)}function le(G,$,X,te,H,x,me){me=re(me);const Z=ne[H],h=Z[te%Z.length];let U=[`%c[${G}]%c[${String($).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(te).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${h}`];/\($/.test(x)?(U=U.concat(me),U.push(")")):U.push(me),console.log.apply(console,U)}class de{constructor($,X){this._outgoingPrefix=$,this._incomingPrefix=X,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing($,X,te,H,x){this._totalOutgoing+=$,le(this._outgoingPrefix,this._totalOutgoing,$,X,te,H,x)}logIncoming($,X,te,H,x){this._totalIncoming+=$,le(this._incomingPrefix,this._totalIncoming,$,X,te,H,x)}}e.IPCLogger=de}),define(ue[64],he([0,1,26,9,18,17,58,6,4,2,30,34,33,27]),function(oe,e,v,L,S,A,M,E,d,l,P,p,w,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class m extends r.ChannelServer{constructor(s){super({send:o=>{try{process.send?.(o.buffer.toString("base64"))}catch{}},onMessage:d.Event.fromNodeEventEmitter(process,"message",o=>S.VSBuffer.wrap(Buffer.from(o,"base64")))},s),process.once("disconnect",()=>this.dispose())}}e.Server=m;class u{constructor(s,o){this.modulePath=s,this.options=o,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new d.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=o&&o.timeout?o.timeout:6e4;this.disposeDelayer=new L.Delayer(f),this.child=null,this._client=null}getChannel(s){const o=this;return{call(f,n,t){return o.requestPromise(s,f,n,t)},listen(f,n){return o.requestEvent(s,f,n)}}}requestPromise(s,o,f,n=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(n.isCancellationRequested)return Promise.reject(E.canceled());this.disposeDelayer.cancel();const t=this.getCachedChannel(s),i=(0,L.createCancelablePromise)(g=>t.call(o,f,g)),y=n.onCancellationRequested(()=>i.cancel()),F=(0,l.toDisposable)(()=>i.cancel());return this.activeRequests.add(F),i.finally(()=>{y.dispose(),this.activeRequests.delete(F),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(s,o,f){if(!this.disposeDelayer)return d.Event.None;this.disposeDelayer.cancel();let n;const t=new d.Emitter({onWillAddFirstListener:()=>{n=this.getCachedChannel(s).listen(o,f)(t.fire,t),this.activeRequests.add(n)},onDidRemoveLastListener:()=>{this.activeRequests.delete(n),n.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return t.event}get client(){if(!this._client){const s=this.options&&this.options.args?this.options.args:[],o=Object.create(null);o.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(o.env={...o.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(o.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(o.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(o.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),o.execArgv===void 0&&(o.execArgv=process.execArgv.filter(b=>!/^--inspect(-brk)?=/.test(b)).filter(b=>!b.startsWith("--vscode-"))),(0,w.removeDangerousEnvVariables)(o.env),this.child=(0,v.fork)(this.modulePath,s,o);const f=new d.Emitter;d.Event.fromNodeEventEmitter(this.child,"message",b=>b)(b=>{if((0,M.isRemoteConsoleLog)(b)){(0,M.log)(b,`IPC Library: ${this.options.serverName}`);return}f.fire(S.VSBuffer.wrap(Buffer.from(b,"base64")))});const t=this.options.useQueue?(0,p.createQueuedSender)(this.child):this.child,i=b=>this.child&&this.child.connected&&t.send(b.buffer.toString("base64")),y=f.event,F={send:i,onMessage:y};this._client=new r.ChannelClient(F);const g=()=>this.disposeClient();process.once("exit",g),this.child.on("error",b=>console.warn('IPC "'+this.options.serverName+'" errored with '+b)),this.child.on("exit",(b,C)=>{process.removeListener("exit",g),this.activeRequests.forEach(k=>(0,l.dispose)(k)),this.activeRequests.clear(),b!==0&&C!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+b+" and signal "+C),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:b,signal:C})})}return this._client}getCachedChannel(s){let o=this.channels.get(s);return o||(o=this.client.getChannel(s),this.channels.set(s,o)),o}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=u}),define(ue[65],he([0,1,31,18,27,4,8,16]),function(oe,e,v,L,S,A,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=e.Server=void 0;class d{constructor(w){this.port=w,this.onMessage=A.Event.fromNodeEventEmitter(this.port,"message",r=>r.data?L.VSBuffer.wrap(r.data):L.VSBuffer.alloc(0)),w.start()}send(w){this.port.postMessage(w.buffer)}disconnect(){this.port.close()}}class l extends S.IPCServer{static getOnDidClientConnect(w){(0,M.assertType)((0,v.isUtilityProcess)(process),"Electron Utility Process");const r=new A.Emitter;return process.parentPort.on("message",m=>{if(w?.handledClientConnection(m))return;const u=(0,E.firstOrDefault)(m.ports);u&&r.fire(u)}),A.Event.map(r.event,m=>({protocol:new d(m),onDidClientDisconnect:A.Event.fromNodeEventEmitter(m,"close")}))}constructor(w){super(l.getOnDidClientConnect(w))}}e.Server=l;function P(p,w,r){const m=u=>{u.data===w&&(p.removeListener("message",m),r())};p.on("message",m)}e.once=P}),define(ue[66],he([13,12]),function(oe,e){return oe.create("vs/platform/contextkey/common/contextkey",e)}),define(ue[67],he([13,12]),function(oe,e){return oe.create("vs/platform/contextkey/common/scanner",e)}),define(ue[68],he([13,12]),function(oe,e){return oe.create("vs/platform/environment/node/argv",e)}),define(ue[69],he([13,12]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(ue[70],he([13,12]),function(oe,e){return oe.create("vs/platform/terminal/node/ptyService",e)}),define(ue[71],he([13,12]),function(oe,e){return oe.create("vs/platform/terminal/node/terminalProcess",e)}),define(ue[72],he([0,1,6,67]),function(oe,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var S;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(S||(e.TokenType=S={}));function A(...l){switch(l.length){case 1:return(0,L.localize)(0,null,l[0]);case 2:return(0,L.localize)(1,null,l[0],l[1]);case 3:return(0,L.localize)(2,null,l[0],l[1],l[2]);default:return}}const M=(0,L.localize)(3,null),E=(0,L.localize)(4,null);class d{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,v.illegalState)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(P){return this._input=P,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const p=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:p})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const p=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:p})}else this._match(126)?this._addToken(9):this._error(A("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(A("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(P){return this._isAtEnd()||this._input.charCodeAt(this._current)!==P?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(P){this._tokens.push({type:P,offset:this._start})}_error(P){const p=this._start,w=this._input.substring(this._start,this._current),r={type:19,offset:this._start,lexeme:w};this._errors.push({offset:p,lexeme:w,additionalInfo:P}),this._tokens.push(r)}_string(){this.stringRe.lastIndex=this._start;const P=this.stringRe.exec(this._input);if(P){this._current=this._start+P[0].length;const p=this._input.substring(this._start,this._current),w=d._keywords.get(p);w?this._addToken(w):this._tokens.push({type:17,lexeme:p,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(M);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let P=this._current,p=!1,w=!1;for(;;){if(P>=this._input.length){this._current=P,this._error(E);return}const m=this._input.charCodeAt(P);if(p)p=!1;else if(m===47&&!w){P++;break}else m===91?w=!0:m===92?p=!0:m===93&&(w=!1);P++}for(;P<this._input.length&&d._regexFlags.has(this._input.charCodeAt(P));)P++;this._current=P;const r=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:r,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=d}),define(ue[73],he([0,1,54,14,19,7,15,23,5]),function(oe,e,v,L,S,A,M,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class l{get appRoot(){return(0,A.dirname)(S.FileAccess.asFileUri("").fsPath)}get userHome(){return d.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return d.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.paths.tmpDir)}get cacheHome(){return d.URI.file(this.userDataPath)}get stateResource(){return(0,E.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:S.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const r=(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",r)}return d.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.joinPath)(d.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const r=M.env.VSCODE_PORTABLE;return r?d.URI.file((0,A.join)(r,"argv.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const r=this.args["builtin-extensions-dir"];return r?(0,A.resolve)(r):(0,A.normalize)((0,A.join)(S.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const r=this.args["extensions-download-dir"];return r?d.URI.file((0,A.resolve)(r)):d.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const r=this.args["extensions-dir"];if(r)return(0,A.resolve)(r);const m=M.env.VSCODE_EXTENSIONS;if(m)return m;const u=M.env.VSCODE_PORTABLE;return u?(0,A.join)(u,"extensions"):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const r=this.args.extensionDevelopmentPath;if(Array.isArray(r))return r.map(m=>/^[^:/?#]+?:\/\//.test(m)?d.URI.parse(m):d.URI.file((0,A.normalize)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(r=>r==="ui"||r==="workspace"||r==="web"?r:"workspace")}get extensionTestsLocationURI(){const r=this.args.extensionTestsPath;if(r)return/^[^:/?#]+?:\/\//.test(r)?d.URI.parse(r):d.URI.file((0,A.normalize)(r))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const r=this.args["disable-extension"];if(r){if(typeof r=="string")return[r];if(Array.isArray(r)&&r.length>0)return r}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(r=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(r))}get extensionLogLevel(){const r=[];for(const m of this.args.log||[]){const u=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(m);u&&u[1]&&u[2]&&r.push([u[1],u[2]])}return r.length?r:void 0}get serviceMachineIdResource(){return(0,E.joinPath)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const r=M.env.VSCODE_PORTABLE;return r?d.URI.file((0,A.join)(r,"policy.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(r){this.args.continueOn=r}get args(){return this._args}constructor(r,m,u){this._args=r,this.paths=m,this.productService=u,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=l,ge([L.memoize],l.prototype,"appRoot",null),ge([L.memoize],l.prototype,"userHome",null),ge([L.memoize],l.prototype,"userDataPath",null),ge([L.memoize],l.prototype,"appSettingsHome",null),ge([L.memoize],l.prototype,"tmpDir",null),ge([L.memoize],l.prototype,"cacheHome",null),ge([L.memoize],l.prototype,"stateResource",null),ge([L.memoize],l.prototype,"userRoamingDataHome",null),ge([L.memoize],l.prototype,"userDataSyncHome",null),ge([L.memoize],l.prototype,"sync",null),ge([L.memoize],l.prototype,"machineSettingsResource",null),ge([L.memoize],l.prototype,"workspaceStorageHome",null),ge([L.memoize],l.prototype,"localHistoryHome",null),ge([L.memoize],l.prototype,"keyboardLayoutResource",null),ge([L.memoize],l.prototype,"argvResource",null),ge([L.memoize],l.prototype,"isExtensionDevelopment",null),ge([L.memoize],l.prototype,"untitledWorkspacesHome",null),ge([L.memoize],l.prototype,"builtinExtensionsPath",null),ge([L.memoize],l.prototype,"extensionsPath",null),ge([L.memoize],l.prototype,"extensionDevelopmentLocationURI",null),ge([L.memoize],l.prototype,"extensionDevelopmentKind",null),ge([L.memoize],l.prototype,"extensionTestsLocationURI",null),ge([L.memoize],l.prototype,"debugExtensionHost",null),ge([L.memoize],l.prototype,"logLevel",null),ge([L.memoize],l.prototype,"extensionLogLevel",null),ge([L.memoize],l.prototype,"serviceMachineIdResource",null),ge([L.memoize],l.prototype,"disableTelemetry",null),ge([L.memoize],l.prototype,"disableWorkspaceTrust",null),ge([L.memoize],l.prototype,"useInMemorySecretStorage",null),ge([L.memoize],l.prototype,"policyFile",null);function P(w,r){return p(w["inspect-extensions"],w["inspect-brk-extensions"],5870,r,w.debugId,w.extensionEnvironment)}e.parseExtensionHostDebugPort=P;function p(w,r,m,u,a,s){const f=Number(r||w)||(u?null:m),n=f?!!r:!1;let t;if(s)try{t=JSON.parse(s)}catch{}return{port:f,break:n,debugId:a,env:t}}e.parseDebugParams=p}),define(ue[74],he([0,1,106,3,68]),function(oe,e,v,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=e.NATIVE_CLI_COMMANDS=void 0;const A={o:(0,S.localize)(0,null),e:(0,S.localize)(1,null),t:(0,S.localize)(2,null)};e.NATIVE_CLI_COMMANDS=["tunnel","serve-web"],e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,S.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,S.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,S.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,S.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,S.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,S.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,S.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,S.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,S.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,S.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,S.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,S.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,S.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,S.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,S.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,S.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,S.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,S.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,S.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,S.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,S.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,S.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,S.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,S.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,S.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,S.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,S.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,S.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,S.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,S.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,S.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function E(u,a,s=M){const o=u.find(C=>C.length>0&&C[0]!=="-"),f={},n=["_"],t=[],i={};let y;for(const C in a){const k=a[C];k.type==="subcommand"?C===o&&(y=k):(k.alias&&(f[C]=k.alias),k.type==="string"||k.type==="string[]"?(n.push(C),k.deprecates&&n.push(...k.deprecates)):k.type==="boolean"&&(t.push(C),k.deprecates&&t.push(...k.deprecates)),k.global&&(i[C]=k))}if(y&&o){const C=i;for(const c in y.options)C[c]=y.options[c];const k=u.filter(c=>c!==o),j=s.getSubcommandReporter?s.getSubcommandReporter(o):void 0,B=E(k,C,j);return{[o]:B,_:[]}}const F=v(u,{string:n,boolean:t,alias:f}),g={},b=F;g._=F._.map(C=>String(C)).filter(C=>C.length>0),delete b._;for(const C in a){const k=a[C];if(k.type==="subcommand")continue;k.alias&&delete b[k.alias];let j=b[C];if(k.deprecates)for(const B of k.deprecates)b.hasOwnProperty(B)&&(j||(j=b[B],j&&s.onDeprecatedOption(B,k.deprecationMessage||(0,S.localize)(38,null,C))),delete b[B]);if(typeof j<"u"){if(k.type==="string[]"){if(Array.isArray(j)||(j=[j]),!k.allowEmptyValue){const B=j.filter(c=>c.length>0);B.length!==j.length&&(s.onEmptyValue(C),j=B.length>0?B:void 0)}}else k.type==="string"&&(Array.isArray(j)?(j=j.pop(),s.onMultipleValues(C,j)):!j&&!k.allowEmptyValue&&(s.onEmptyValue(C),j=void 0));g[C]=j,k.deprecationMessage&&s.onDeprecatedOption(C,k.deprecationMessage)}delete b[C]}for(const C in b)s.onUnknownOption(C);return g}e.parseArgs=E;function d(u,a){let s="";return a.args&&(Array.isArray(a.args)?s=` <${a.args.join("> <")}>`:s=` <${a.args}>`),a.alias?`-${a.alias} --${u}${s}`:`--${u}${s}`}function l(u,a){const s=[];for(const o in u){const f=u[o],n=d(o,f);s.push([n,f.description])}return P(s,a)}e.formatOptions=l;function P(u,a){const o=u.reduce((t,i)=>Math.max(t,i[0].length),12)+2+1;if(a-o<25)return u.reduce((t,i)=>t.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const f=a-o-1,n=[];for(const t of u){const i=t[0],y=w(t[1],f),F=p(o-i.length-2);n.push("  "+i+F+y[0]);for(let g=1;g<y.length;g++)n.push(p(o)+y[g])}return n}function p(u){return" ".repeat(u)}function w(u,a){const s=[];for(;u.length;){const o=u.length<a?u.length:u.lastIndexOf(" ",a),f=u.slice(0,o).trim();u=u.slice(o),s.push(f)}return s}function r(u,a,s,o,f){const n=process.stdout.isTTY&&process.stdout.columns||80,t=f?.noInputFiles!==!0?`[${(0,S.localize)(39,null)}...]`:"",i=[`${u} ${s}`];i.push(""),i.push(`${(0,S.localize)(40,null)}: ${a} [${(0,S.localize)(41,null)}]${t}`),i.push(""),f?.noPipe!==!0&&(L.isWindows?i.push((0,S.localize)(42,null,a)):i.push((0,S.localize)(43,null,a)),i.push(""));const y={},F=[];for(const g in o){const b=o[g];if(b.type==="subcommand")b.description&&F.push({command:g,description:b.description});else if(b.description&&b.cat){let C=y[b.cat];C||(y[b.cat]=C={}),C[g]=b}}for(const g in y){const b=g,C=y[b];C&&(i.push(A[b]),i.push(...l(C,n)),i.push(""))}return F.length&&(i.push((0,S.localize)(44,null)),i.push(...P(F.map(g=>[g.command,g.description]),n)),i.push("")),i.join(`
`)}e.buildHelpMessage=r;function m(u,a){return`${u||(0,S.localize)(45,null)}
${a||(0,S.localize)(46,null)}
${process.arch}`}e.buildVersionMessage=m}),function(){"use strict";function oe(e,v,L){function S(M,E){const d=A(M,E),l=[d];return e.isAbsolute(d)||l.unshift(L),e.resolve(...l)}function A(M,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,E);const P=M["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(p,"AppData","Roaming")}break;case"darwin":l=e.join(v.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,E)}return{getUserDataPath:S}}if(typeof define=="function")define(ue[75],he([76,20,15]),function(e,v,L){return oe(e,v,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),v=require("os");module.exports=oe(e,v,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ue[77],he([0,1,20,73,75]),function(oe,e,v,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class A extends L.AbstractNativeEnvironmentService{constructor(l,P){super(l,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,S.getUserDataPath)(l,P.nameShort)},P)}}e.NativeEnvironmentService=A;function M(d,l){return(0,L.parseDebugParams)(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,l,d.extensionEnvironment)}e.parsePtyHostDebugPort=M;function E(d,l){return(0,L.parseDebugParams)(d["inspect-sharedprocess"],d["inspect-brk-sharedprocess"],5879,l,d.extensionEnvironment)}e.parseSharedProcessDebugPort=E}),define(ue[21],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function E(d){return d[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=E})(v||(e._util=v={})),e.IInstantiationService=S("instantiationService");function L(M,E,d){E[v.DI_TARGET]===E?E[v.DI_DEPENDENCIES].push({id:M,index:d}):(E[v.DI_DEPENDENCIES]=[{id:M,index:d}],E[v.DI_TARGET]=E)}function S(M){if(v.serviceIds.has(M))return v.serviceIds.get(M);const E=function(d,l,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(E,d,P)};return E.toString=()=>M,v.serviceIds.set(M,E),E}e.createDecorator=S;function A(M){return M}e.refineServiceDecorator=A}),define(ue[35],he([0,1,3,11,72,21,66,6]),function(oe,e,v,L,S,A,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const d=new Map;d.set("false",!1),d.set("true",!0),d.set("isMac",v.isMacintosh),d.set("isLinux",v.isLinux),d.set("isWindows",v.isWindows),d.set("isWeb",v.isWeb),d.set("isMacNative",v.isMacintosh&&!v.isWeb),d.set("isEdge",v.isEdge),d.set("isFirefox",v.isFirefox),d.set("isChrome",v.isChrome),d.set("isSafari",v.isSafari);function l(Z,h){if(d.get(Z)!==void 0)throw(0,E.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");d.set(Z,h)}e.setConstant=l;const P=Object.prototype.hasOwnProperty;var p;(function(Z){Z[Z.False=0]="False",Z[Z.True=1]="True",Z[Z.Defined=2]="Defined",Z[Z.Not=3]="Not",Z[Z.Equals=4]="Equals",Z[Z.NotEquals=5]="NotEquals",Z[Z.And=6]="And",Z[Z.Regex=7]="Regex",Z[Z.NotRegex=8]="NotRegex",Z[Z.Or=9]="Or",Z[Z.In=10]="In",Z[Z.NotIn=11]="NotIn",Z[Z.Greater=12]="Greater",Z[Z.GreaterEquals=13]="GreaterEquals",Z[Z.Smaller=14]="Smaller",Z[Z.SmallerEquals=15]="SmallerEquals"})(p||(e.ContextKeyExprType=p={}));const w={regexParsingWithErrorRecovery:!0},r=(0,M.localize)(0,null),m=(0,M.localize)(1,null),u=(0,M.localize)(2,null),a=(0,M.localize)(3,null),s=(0,M.localize)(4,null),o=(0,M.localize)(5,null),f=(0,M.localize)(6,null),n=(0,M.localize)(7,null);class t{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(h=w){this._config=h,this._scanner=new S.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(h){if(h===""){this._parsingErrors.push({message:r,offset:0,lexeme:"",additionalInfo:m});return}this._tokens=this._scanner.reset(h).scan(),this._current=0,this._parsingErrors=[];try{const U=this._expr();if(!this._isAtEnd()){const se=this._peek(),N=se.type===17?o:void 0;throw this._parsingErrors.push({message:s,offset:se.offset,lexeme:S.Scanner.getLexeme(se),additionalInfo:N}),t._parseError}return U}catch(U){if(U!==t._parseError)throw U;return}}_expr(){return this._or()}_or(){const h=[this._and()];for(;this._matchOne(16);){const U=this._and();h.push(U)}return h.length===1?h[0]:i.or(...h)}_and(){const h=[this._term()];for(;this._matchOne(15);){const U=this._term();h.push(U)}return h.length===1?h[0]:i.and(...h)}_term(){if(this._matchOne(2)){const h=this._peek();switch(h.type){case 11:return this._advance(),b.INSTANCE;case 12:return this._advance(),C.INSTANCE;case 0:{this._advance();const U=this._expr();return this._consume(1,a),U?.negate()}case 17:return this._advance(),D.create(h.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",h)}}return this._primary()}_primary(){const h=this._peek();switch(h.type){case 11:return this._advance(),i.true();case 12:return this._advance(),i.false();case 0:{this._advance();const U=this._expr();return this._consume(1,a),U}case 17:{const U=h.lexeme;if(this._advance(),this._matchOne(9)){const N=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),N.type!==10)throw this._errExpectedButGot("REGEX",N);const K=N.lexeme,O=K.lastIndexOf("/"),R=O===K.length-1?void 0:this._removeFlagsGY(K.substring(O+1));let T;try{T=new RegExp(K.substring(1,O),R)}catch{throw this._errExpectedButGot("REGEX",N)}return Q.create(U,T)}switch(N.type){case 10:case 19:{const K=[N.lexeme];this._advance();let O=this._peek(),R=0;for(let ce=0;ce<N.lexeme.length;ce++)N.lexeme.charCodeAt(ce)===40?R++:N.lexeme.charCodeAt(ce)===41&&R--;for(;!this._isAtEnd()&&O.type!==15&&O.type!==16;){switch(O.type){case 0:R++;break;case 1:R--;break;case 10:case 18:for(let ce=0;ce<O.lexeme.length;ce++)O.lexeme.charCodeAt(ce)===40?R++:N.lexeme.charCodeAt(ce)===41&&R--}if(R<0)break;K.push(S.Scanner.getLexeme(O)),this._advance(),O=this._peek()}const T=K.join(""),V=T.lastIndexOf("/"),Y=V===T.length-1?void 0:this._removeFlagsGY(T.substring(V+1));let ie;try{ie=new RegExp(T.substring(1,V),Y)}catch{throw this._errExpectedButGot("REGEX",N)}return i.regex(U,ie)}case 18:{const K=N.lexeme;this._advance();let O=null;if(!(0,L.isFalsyOrWhitespace)(K)){const R=K.indexOf("/"),T=K.lastIndexOf("/");if(R!==T&&R>=0){const V=K.slice(R+1,T),Y=K[T+1]==="i"?"i":"";try{O=new RegExp(V,Y)}catch{throw this._errExpectedButGot("REGEX",N)}}}if(O===null)throw this._errExpectedButGot("REGEX",N);return Q.create(U,O)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,u);const N=this._value();return i.notIn(U,N)}switch(this._peek().type){case 3:{this._advance();const N=this._value();if(this._previous().type===18)return i.equals(U,N);switch(N){case"true":return i.has(U);case"false":return i.not(U);default:return i.equals(U,N)}}case 4:{this._advance();const N=this._value();if(this._previous().type===18)return i.notEquals(U,N);switch(N){case"true":return i.not(U);case"false":return i.has(U);default:return i.notEquals(U,N)}}case 5:return this._advance(),ee.create(U,this._value());case 6:return this._advance(),ne.create(U,this._value());case 7:return this._advance(),I.create(U,this._value());case 8:return this._advance(),q.create(U,this._value());case 13:return this._advance(),i.in(U,this._value());default:return i.has(U)}}case 20:throw this._parsingErrors.push({message:f,offset:h.offset,lexeme:"",additionalInfo:n}),t._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const h=this._peek();switch(h.type){case 17:case 18:return this._advance(),h.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(h){return h.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(h){return this._check(h)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(h,U){if(this._check(h))return this._advance();throw this._errExpectedButGot(U,this._peek())}_errExpectedButGot(h,U,se){const N=(0,M.localize)(8,null,h,S.Scanner.getLexeme(U)),K=U.offset,O=S.Scanner.getLexeme(U);return this._parsingErrors.push({message:N,offset:K,lexeme:O,additionalInfo:se}),t._parseError}_check(h){return this._peek().type===h}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=t;class i{static false(){return b.INSTANCE}static true(){return C.INSTANCE}static has(h){return k.create(h)}static equals(h,U){return j.create(h,U)}static notEquals(h,U){return _.create(h,U)}static regex(h,U){return Q.create(h,U)}static in(h,U){return B.create(h,U)}static notIn(h,U){return c.create(h,U)}static not(h){return D.create(h)}static and(...h){return de.create(h,null,!0)}static or(...h){return G.create(h,null,!0)}static greater(h,U){return I.create(h,U)}static greaterEquals(h,U){return q.create(h,U)}static smaller(h,U){return ee.create(h,U)}static smallerEquals(h,U){return ne.create(h,U)}static{this._parser=new t({regexParsingWithErrorRecovery:!1})}static deserialize(h){return h==null?void 0:this._parser.parse(h)}}e.ContextKeyExpr=i;function y(Z){const h=new t({regexParsingWithErrorRecovery:!1});return Z.map(U=>(h.parse(U),h.lexingErrors.length>0?h.lexingErrors.map(se=>({errorMessage:se.additionalInfo?(0,M.localize)(9,null,se.additionalInfo):(0,M.localize)(10,null),offset:se.offset,length:se.lexeme.length})):h.parsingErrors.length>0?h.parsingErrors.map(se=>({errorMessage:se.additionalInfo?`${se.message}. ${se.additionalInfo}`:se.message,offset:se.offset,length:se.lexeme.length})):[]))}e.validateWhenClauses=y;function F(Z,h){const U=Z?Z.substituteConstants():void 0,se=h?h.substituteConstants():void 0;return!U&&!se?!0:!U||!se?!1:U.equals(se)}e.expressionsAreEqualWithConstantSubstitution=F;function g(Z,h){return Z.cmp(h)}class b{static{this.INSTANCE=new b}constructor(){this.type=0}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}substituteConstants(){return this}evaluate(h){return!1}serialize(){return"false"}keys(){return[]}map(h){return this}negate(){return C.INSTANCE}}e.ContextKeyFalseExpr=b;class C{static{this.INSTANCE=new C}constructor(){this.type=1}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}substituteConstants(){return this}evaluate(h){return!0}serialize(){return"true"}keys(){return[]}map(h){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=C;class k{static create(h,U=null){const se=d.get(h);return typeof se=="boolean"?se?C.INSTANCE:b.INSTANCE:new k(h,U)}constructor(h,U){this.key=h,this.negated=U,this.type=2}cmp(h){return h.type!==this.type?this.type-h.type:X(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}substituteConstants(){const h=d.get(this.key);return typeof h=="boolean"?h?C.INSTANCE:b.INSTANCE:this}evaluate(h){return!!h.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(h){return h.mapDefined(this.key)}negate(){return this.negated||(this.negated=D.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=k;class j{static create(h,U,se=null){if(typeof U=="boolean")return U?k.create(h,se):D.create(h,se);const N=d.get(h);return typeof N=="boolean"?U===(N?"true":"false")?C.INSTANCE:b.INSTANCE:new j(h,U,se)}constructor(h,U,se){this.key=h,this.value=U,this.negated=se,this.type=4}cmp(h){return h.type!==this.type?this.type-h.type:te(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}substituteConstants(){const h=d.get(this.key);if(typeof h=="boolean"){const U=h?"true":"false";return this.value===U?C.INSTANCE:b.INSTANCE}return this}evaluate(h){return h.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(h){return h.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=j;class B{static create(h,U){return new B(h,U)}constructor(h,U){this.key=h,this.valueKey=U,this.type=10,this.negated=null}cmp(h){return h.type!==this.type?this.type-h.type:te(this.key,this.valueKey,h.key,h.valueKey)}equals(h){return h.type===this.type?this.key===h.key&&this.valueKey===h.valueKey:!1}substituteConstants(){return this}evaluate(h){const U=h.getValue(this.valueKey),se=h.getValue(this.key);return Array.isArray(U)?U.includes(se):typeof se=="string"&&typeof U=="object"&&U!==null?P.call(U,se):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(h){return h.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=c.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=B;class c{static create(h,U){return new c(h,U)}constructor(h,U){this.key=h,this.valueKey=U,this.type=11,this._negated=B.create(h,U)}cmp(h){return h.type!==this.type?this.type-h.type:this._negated.cmp(h._negated)}equals(h){return h.type===this.type?this._negated.equals(h._negated):!1}substituteConstants(){return this}evaluate(h){return!this._negated.evaluate(h)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(h){return h.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=c;class _{static create(h,U,se=null){if(typeof U=="boolean")return U?D.create(h,se):k.create(h,se);const N=d.get(h);return typeof N=="boolean"?U===(N?"true":"false")?b.INSTANCE:C.INSTANCE:new _(h,U,se)}constructor(h,U,se){this.key=h,this.value=U,this.negated=se,this.type=5}cmp(h){return h.type!==this.type?this.type-h.type:te(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}substituteConstants(){const h=d.get(this.key);if(typeof h=="boolean"){const U=h?"true":"false";return this.value===U?b.INSTANCE:C.INSTANCE}return this}evaluate(h){return h.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(h){return h.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=j.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=_;class D{static create(h,U=null){const se=d.get(h);return typeof se=="boolean"?se?b.INSTANCE:C.INSTANCE:new D(h,U)}constructor(h,U){this.key=h,this.negated=U,this.type=3}cmp(h){return h.type!==this.type?this.type-h.type:X(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}substituteConstants(){const h=d.get(this.key);return typeof h=="boolean"?h?b.INSTANCE:C.INSTANCE:this}evaluate(h){return!h.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(h){return h.mapNot(this.key)}negate(){return this.negated||(this.negated=k.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=D;function W(Z,h){if(typeof Z=="string"){const U=parseFloat(Z);isNaN(U)||(Z=U)}return typeof Z=="string"||typeof Z=="number"?h(Z):b.INSTANCE}class I{static create(h,U,se=null){return W(U,N=>new I(h,N,se))}constructor(h,U,se){this.key=h,this.value=U,this.negated=se,this.type=12}cmp(h){return h.type!==this.type?this.type-h.type:te(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}substituteConstants(){return this}evaluate(h){return typeof this.value=="string"?!1:parseFloat(h.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=ne.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=I;class q{static create(h,U,se=null){return W(U,N=>new q(h,N,se))}constructor(h,U,se){this.key=h,this.value=U,this.negated=se,this.type=13}cmp(h){return h.type!==this.type?this.type-h.type:te(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}substituteConstants(){return this}evaluate(h){return typeof this.value=="string"?!1:parseFloat(h.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=ee.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=q;class ee{static create(h,U,se=null){return W(U,N=>new ee(h,N,se))}constructor(h,U,se){this.key=h,this.value=U,this.negated=se,this.type=14}cmp(h){return h.type!==this.type?this.type-h.type:te(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}substituteConstants(){return this}evaluate(h){return typeof this.value=="string"?!1:parseFloat(h.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=q.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=ee;class ne{static create(h,U,se=null){return W(U,N=>new ne(h,N,se))}constructor(h,U,se){this.key=h,this.value=U,this.negated=se,this.type=15}cmp(h){return h.type!==this.type?this.type-h.type:te(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}substituteConstants(){return this}evaluate(h){return typeof this.value=="string"?!1:parseFloat(h.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=I.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=ne;class Q{static create(h,U){return new Q(h,U)}constructor(h,U){this.key=h,this.regexp=U,this.type=7,this.negated=null}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.key<h.key)return-1;if(this.key>h.key)return 1;const U=this.regexp?this.regexp.source:"",se=h.regexp?h.regexp.source:"";return U<se?-1:U>se?1:0}equals(h){if(h.type===this.type){const U=this.regexp?this.regexp.source:"",se=h.regexp?h.regexp.source:"";return this.key===h.key&&U===se}return!1}substituteConstants(){return this}evaluate(h){const U=h.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const h=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${h}`}keys(){return[this.key]}map(h){return h.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=re.create(this)),this.negated}}e.ContextKeyRegexExpr=Q;class re{static create(h){return new re(h)}constructor(h){this._actual=h,this.type=8}cmp(h){return h.type!==this.type?this.type-h.type:this._actual.cmp(h._actual)}equals(h){return h.type===this.type?this._actual.equals(h._actual):!1}substituteConstants(){return this}evaluate(h){return!this._actual.evaluate(h)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(h){return new re(this._actual.map(h))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=re;function le(Z){let h=null;for(let U=0,se=Z.length;U<se;U++){const N=Z[U].substituteConstants();if(Z[U]!==N&&h===null){h=[];for(let K=0;K<U;K++)h[K]=Z[K]}h!==null&&(h[U]=N)}return h===null?Z:h}class de{static create(h,U,se){return de._normalizeArr(h,U,se)}constructor(h,U){this.expr=h,this.negated=U,this.type=6}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let U=0,se=this.expr.length;U<se;U++){const N=g(this.expr[U],h.expr[U]);if(N!==0)return N}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let U=0,se=this.expr.length;U<se;U++)if(!this.expr[U].equals(h.expr[U]))return!1;return!0}return!1}substituteConstants(){const h=le(this.expr);return h===this.expr?this:de.create(h,this.negated,!1)}evaluate(h){for(let U=0,se=this.expr.length;U<se;U++)if(!this.expr[U].evaluate(h))return!1;return!0}static _normalizeArr(h,U,se){const N=[];let K=!1;for(const O of h)if(O){if(O.type===1){K=!0;continue}if(O.type===0)return b.INSTANCE;if(O.type===6){N.push(...O.expr);continue}N.push(O)}if(N.length===0&&K)return C.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(g);for(let O=1;O<N.length;O++)N[O-1].equals(N[O])&&(N.splice(O,1),O--);if(N.length===1)return N[0];for(;N.length>1;){const O=N[N.length-1];if(O.type!==9)break;N.pop();const R=N.pop(),T=N.length===0,V=G.create(O.expr.map(Y=>de.create([Y,R],null,se)),null,T);V&&(N.push(V),N.sort(g))}if(N.length===1)return N[0];if(se){for(let O=0;O<N.length;O++)for(let R=O+1;R<N.length;R++)if(N[O].negate().equals(N[R]))return b.INSTANCE;if(N.length===1)return N[0]}return new de(N,U)}}serialize(){return this.expr.map(h=>h.serialize()).join(" && ")}keys(){const h=[];for(const U of this.expr)h.push(...U.keys());return h}map(h){return new de(this.expr.map(U=>U.map(h)),null)}negate(){if(!this.negated){const h=[];for(const U of this.expr)h.push(U.negate());this.negated=G.create(h,this,!0)}return this.negated}}e.ContextKeyAndExpr=de;class G{static create(h,U,se){return G._normalizeArr(h,U,se)}constructor(h,U){this.expr=h,this.negated=U,this.type=9}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let U=0,se=this.expr.length;U<se;U++){const N=g(this.expr[U],h.expr[U]);if(N!==0)return N}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let U=0,se=this.expr.length;U<se;U++)if(!this.expr[U].equals(h.expr[U]))return!1;return!0}return!1}substituteConstants(){const h=le(this.expr);return h===this.expr?this:G.create(h,this.negated,!1)}evaluate(h){for(let U=0,se=this.expr.length;U<se;U++)if(this.expr[U].evaluate(h))return!0;return!1}static _normalizeArr(h,U,se){let N=[],K=!1;if(h){for(let O=0,R=h.length;O<R;O++){const T=h[O];if(T){if(T.type===0){K=!0;continue}if(T.type===1)return C.INSTANCE;if(T.type===9){N=N.concat(T.expr);continue}N.push(T)}}if(N.length===0&&K)return b.INSTANCE;N.sort(g)}if(N.length!==0){if(N.length===1)return N[0];for(let O=1;O<N.length;O++)N[O-1].equals(N[O])&&(N.splice(O,1),O--);if(N.length===1)return N[0];if(se){for(let O=0;O<N.length;O++)for(let R=O+1;R<N.length;R++)if(N[O].negate().equals(N[R]))return C.INSTANCE;if(N.length===1)return N[0]}return new G(N,U)}}serialize(){return this.expr.map(h=>h.serialize()).join(" || ")}keys(){const h=[];for(const U of this.expr)h.push(...U.keys());return h}map(h){return new G(this.expr.map(U=>U.map(h)),null)}negate(){if(!this.negated){const h=[];for(const U of this.expr)h.push(U.negate());for(;h.length>1;){const U=h.shift(),se=h.shift(),N=[];for(const K of me(U))for(const O of me(se))N.push(de.create([K,O],null,!1));h.unshift(G.create(N,null,!1))}this.negated=G.create(h,this,!0)}return this.negated}}e.ContextKeyOrExpr=G;class $ extends k{static{this._info=[]}static all(){return $._info.values()}constructor(h,U,se){super(h,null),this._defaultValue=U,typeof se=="object"?$._info.push({...se,key:h}):se!==!0&&$._info.push({key:h,description:se,type:U!=null?typeof U:void 0})}bindTo(h){return h.createKey(this.key,this._defaultValue)}getValue(h){return h.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(h){return j.create(this.key,h)}notEqualsTo(h){return _.create(this.key,h)}}e.RawContextKey=$,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function X(Z,h){return Z<h?-1:Z>h?1:0}function te(Z,h,U,se){return Z<U?-1:Z>U?1:h<se?-1:h>se?1:0}function H(Z,h){if(Z.type===0||h.type===1)return!0;if(Z.type===9)return h.type===9?x(Z.expr,h.expr):!1;if(h.type===9){for(const U of h.expr)if(H(Z,U))return!0;return!1}if(Z.type===6){if(h.type===6)return x(h.expr,Z.expr);for(const U of Z.expr)if(H(U,h))return!0;return!1}return Z.equals(h)}e.implies=H;function x(Z,h){let U=0,se=0;for(;U<Z.length&&se<h.length;){const N=Z[U].cmp(h[se]);if(N<0)return!1;N===0&&U++,se++}return U===Z.length}function me(Z){return Z.type===9?Z.expr:[Z]}}),define(ue[78],he([0,1,51,7,11,8,5,69,21,3,19,22]),function(oe,e,v,L,S,A,M,E,d,l,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.isFileSystemWatcher=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,d.createDecorator)("fileService");function w(H){return H.create===!0}e.isFileOpenForWriteOptions=w;var r;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(r||(e.FileType=r={}));var m;(function(H){H[H.Readonly=1]="Readonly",H[H.Locked=2]="Locked"})(m||(e.FilePermission=m={}));function u(H){const x=H;return!!x&&typeof x.onDidChange=="function"}e.isFileSystemWatcher=u;var a;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileAtomicWrite=32768]="FileAtomicWrite",H[H.FileAtomicDelete=65536]="FileAtomicDelete",H[H.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function s(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=s;function o(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=o;function f(H){return!!(H.capabilities&131072)}e.hasFileCloneCapability=f;function n(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=n;function t(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=t;function i(H){return s(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=i;function y(H){return s(H)?!!(H.capabilities&32768):!1}e.hasFileAtomicWriteCapability=y;function F(H){return!!(H.capabilities&65536)}e.hasFileAtomicDeleteCapability=F;function g(H){return!!(H.capabilities&2048)}e.hasReadonlyCapability=g;var b;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsStorageQuota="EntryExceedsStorageQuota",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(b||(e.FileSystemProviderErrorCode=b={}));class C extends Error{static create(x,me){const Z=new C(x.toString(),me);return B(Z,me),Z}constructor(x,me){super(x),this.code=me}}e.FileSystemProviderError=C;function k(H,x){return C.create(H,x)}e.createFileSystemProviderError=k;function j(H){return H||k((0,E.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=j;function B(H,x){return H.name=x?`${x} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=B;function c(H){if(!H)return b.Unknown;if(H instanceof C)return H.code;const x=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!x)return b.Unknown;switch(x[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=c;function _(H){if(H instanceof ne)return H.fileOperationResult;switch(c(H)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 9;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=_;var D;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(D||(e.FileOperation=D={}));class W{constructor(x,me,Z){this.resource=x,this.operation=me,this.target=Z}isOperation(x){return this.operation===x}}e.FileOperationEvent=W;var I;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(I||(e.FileChangeType=I={}));class q{static{this.MIXED_CORRELATION=null}constructor(x,me){this.ignorePathCasing=me,this.correlationId=void 0,this.added=new p.Lazy(()=>{const Z=v.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Z.fill(this.rawAdded.map(h=>[h,!0])),Z}),this.updated=new p.Lazy(()=>{const Z=v.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Z.fill(this.rawUpdated.map(h=>[h,!0])),Z}),this.deleted=new p.Lazy(()=>{const Z=v.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Z.fill(this.rawDeleted.map(h=>[h,!0])),Z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Z of x){switch(Z.type){case 1:this.rawAdded.push(Z.resource);break;case 0:this.rawUpdated.push(Z.resource);break;case 2:this.rawDeleted.push(Z.resource);break}this.correlationId!==q.MIXED_CORRELATION&&(typeof Z.cId=="number"?this.correlationId===void 0?this.correlationId=Z.cId:this.correlationId!==Z.cId&&(this.correlationId=q.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=q.MIXED_CORRELATION))}}contains(x,...me){return this.doContains(x,{includeChildren:!1},...me)}affects(x,...me){return this.doContains(x,{includeChildren:!0},...me)}doContains(x,me,...Z){if(!x)return!1;const h=Z.length>0;return!!((!h||Z.includes(1))&&(this.added.value.get(x)||me.includeChildren&&this.added.value.findSuperstr(x))||(!h||Z.includes(0))&&(this.updated.value.get(x)||me.includeChildren&&this.updated.value.findSuperstr(x))||(!h||Z.includes(2))&&(this.deleted.value.findSubstr(x)||me.includeChildren&&this.deleted.value.findSuperstr(x)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(x){return this.correlationId===x}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=q;function ee(H,x,me){return!H||!x||H===x||x.length>H.length?!1:(x.charAt(x.length-1)!==L.sep&&(x+=L.sep),me?(0,S.startsWithIgnoreCase)(H,x):H.indexOf(x)===0)}e.isParent=ee;class ne extends Error{constructor(x,me,Z){super(x),this.fileOperationResult=me,this.options=Z}}e.FileOperationError=ne;class Q extends ne{constructor(x,me,Z,h){super(x,me,h),this.fileOperationResult=me,this.size=Z}}e.TooLargeFileOperationError=Q;class re extends ne{constructor(x,me,Z){super(x,2,Z),this.stat=me}}e.NotModifiedSinceFileOperationError=re;var le;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(le||(e.FileOperationResult=le={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var de;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(de||(e.FileKind=de={})),e.ETAG_DISABLED="";function G(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=G;async function $(H,x){if(!x.hasProvider(M.URI.from({scheme:H.scheme})))return new Promise(me=>{const Z=x.onDidChangeFileSystemProviderRegistrations(h=>{h.scheme===H.scheme&&h.added&&(Z.dispose(),me())})})}e.whenProviderRegistered=$;class X{static{this.KB=1024}static{this.MB=X.KB*X.KB}static{this.GB=X.MB*X.KB}static{this.TB=X.GB*X.KB}static formatSize(x){return(0,A.isNumber)(x)||(x=0),x<X.KB?(0,E.localize)(1,null,x.toFixed(0)):x<X.MB?(0,E.localize)(2,null,(x/X.KB).toFixed(2)):x<X.GB?(0,E.localize)(3,null,(x/X.MB).toFixed(2)):x<X.TB?(0,E.localize)(4,null,(x/X.GB).toFixed(2)):(0,E.localize)(5,null,(x/X.TB).toFixed(2))}}e.ByteSize=X;function te(H){const x=typeof H=="string"||H?.scheme===P.Schemas.vscodeRemote;return typeof H!="string"&&H?.scheme===P.Schemas.file?1024*X.MB:x?10*X.MB:l.isWeb?50*X.MB:1024*X.MB}e.getLargeFileConfirmationLimit=te}),define(ue[10],he([0,1,56,4,49,2,25,3,23,8,5,35,21]),function(oe,e,v,L,S,A,M,E,d,l,P,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function r(){return new Date().toISOString()}function m(B){return(0,l.isNumber)(B)}e.isLogLevel=m;var u;(function(B){B[B.Off=0]="Off",B[B.Trace=1]="Trace",B[B.Debug=2]="Debug",B[B.Info=3]="Info",B[B.Warning=4]="Warning",B[B.Error=5]="Error"})(u||(e.LogLevel=u={})),e.DEFAULT_LOG_LEVEL=u.Info;function a(B,c,_){switch(c){case u.Trace:B.trace(_);break;case u.Debug:B.debug(_);break;case u.Info:B.info(_);break;case u.Warning:B.warn(_);break;case u.Error:B.error(_);break;case u.Off:break;default:throw new Error(`Invalid log level ${c}`)}}e.log=a;function s(B,c=!1){let _="";for(let D=0;D<B.length;D++){let W=B[D];if(W instanceof Error&&(W=(0,v.toErrorMessage)(W,c)),typeof W=="object")try{W=JSON.stringify(W)}catch{}_+=(D>0?" ":"")+W}return _}class o extends A.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(c){this.level!==c&&(this.level=c,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(c){return this.level!==u.Off&&this.level<=c}}e.AbstractLogger=o;class f extends o{constructor(c){super(),this.logAlways=c}checkLogLevel(c){return this.logAlways||super.checkLogLevel(c)}trace(c,..._){this.checkLogLevel(u.Trace)&&this.log(u.Trace,s([c,..._],!0))}debug(c,..._){this.checkLogLevel(u.Debug)&&this.log(u.Debug,s([c,..._]))}info(c,..._){this.checkLogLevel(u.Info)&&this.log(u.Info,s([c,..._]))}warn(c,..._){this.checkLogLevel(u.Warning)&&this.log(u.Warning,s([c,..._]))}error(c,..._){if(this.checkLogLevel(u.Error))if(c instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=c.stack,this.log(u.Error,s(D))}else this.log(u.Error,s([c,..._]))}flush(){}}e.AbstractMessageLogger=f;class n extends o{constructor(c=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(c),this.useColors=!E.isWindows}trace(c,..._){this.checkLogLevel(u.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${r()}]\x1B[0m`,c,..._):console.log(`[main ${r()}]`,c,..._))}debug(c,..._){this.checkLogLevel(u.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${r()}]\x1B[0m`,c,..._):console.log(`[main ${r()}]`,c,..._))}info(c,..._){this.checkLogLevel(u.Info)&&(this.useColors?console.log(`\x1B[90m[main ${r()}]\x1B[0m`,c,..._):console.log(`[main ${r()}]`,c,..._))}warn(c,..._){this.checkLogLevel(u.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${r()}]\x1B[0m`,c,..._):console.warn(`[main ${r()}]`,c,..._))}error(c,..._){this.checkLogLevel(u.Error)&&(this.useColors?console.error(`\x1B[91m[main ${r()}]\x1B[0m`,c,..._):console.error(`[main ${r()}]`,c,..._))}flush(){}}e.ConsoleMainLogger=n;class t extends o{constructor(c=e.DEFAULT_LOG_LEVEL,_=!0){super(),this.useColors=_,this.setLevel(c)}trace(c,..._){this.checkLogLevel(u.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",c,..._):console.log(c,..._))}debug(c,..._){this.checkLogLevel(u.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",c,..._):console.log(c,..._))}info(c,..._){this.checkLogLevel(u.Info)&&(this.useColors?console.log("%c INFO","color: #33f",c,..._):console.log(c,..._))}warn(c,..._){this.checkLogLevel(u.Warning)&&(this.useColors?console.log("%c WARN","color: #993",c,..._):console.log(c,..._))}error(c,..._){this.checkLogLevel(u.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",c,..._):console.error(c,..._))}flush(){}}e.ConsoleLogger=t;class i extends o{constructor(c,_=e.DEFAULT_LOG_LEVEL){super(),this.adapter=c,this.setLevel(_)}trace(c,..._){this.checkLogLevel(u.Trace)&&this.adapter.log(u.Trace,[this.extractMessage(c),..._])}debug(c,..._){this.checkLogLevel(u.Debug)&&this.adapter.log(u.Debug,[this.extractMessage(c),..._])}info(c,..._){this.checkLogLevel(u.Info)&&this.adapter.log(u.Info,[this.extractMessage(c),..._])}warn(c,..._){this.checkLogLevel(u.Warning)&&this.adapter.log(u.Warning,[this.extractMessage(c),..._])}error(c,..._){this.checkLogLevel(u.Error)&&this.adapter.log(u.Error,[this.extractMessage(c),..._])}extractMessage(c){return typeof c=="string"?c:(0,v.toErrorMessage)(c,this.checkLogLevel(u.Trace))}flush(){}}e.AdapterLogger=i;class y extends o{constructor(c){super(),this.loggers=c,c.length&&this.setLevel(c[0].getLevel())}setLevel(c){for(const _ of this.loggers)_.setLevel(c);super.setLevel(c)}trace(c,..._){for(const D of this.loggers)D.trace(c,..._)}debug(c,..._){for(const D of this.loggers)D.debug(c,..._)}info(c,..._){for(const D of this.loggers)D.info(c,..._)}warn(c,..._){for(const D of this.loggers)D.warn(c,..._)}error(c,..._){for(const D of this.loggers)D.error(c,..._)}flush(){for(const c of this.loggers)c.flush()}dispose(){for(const c of this.loggers)c.dispose();super.dispose()}}e.MultiplexLogger=y;class F extends A.Disposable{constructor(c,_,D){if(super(),this.logLevel=c,this.logsHome=_,this._loggers=new M.ResourceMap,this._onDidChangeLoggers=this._register(new L.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new L.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,D)for(const W of D)this._loggers.set(W.resource,{logger:void 0,info:W})}getLoggerEntry(c){return(0,l.isString)(c)?[...this._loggers.values()].find(_=>_.info.id===c):this._loggers.get(c)}getLogger(c){return this.getLoggerEntry(c)?.logger}createLogger(c,_){const D=this.toResource(c),W=(0,l.isString)(c)?c:_?.id??(0,S.hash)(D.toString()).toString(16);let I=this._loggers.get(D)?.logger;const q=_?.logLevel==="always"?u.Trace:_?.logLevel;I||(I=this.doCreateLogger(D,q??this.getLogLevel(D)??this.logLevel,{..._,id:W}));const ee={logger:I,info:{resource:D,id:W,logLevel:q,name:_?.name,hidden:_?.hidden,extensionId:_?.extensionId,when:_?.when}};return this.registerLogger(ee.info),this._loggers.set(D,ee),I}toResource(c){return(0,l.isString)(c)?(0,d.joinPath)(this.logsHome,`${c}.log`):c}setLogLevel(c,_){if(P.URI.isUri(c)){const D=c,W=_,I=this._loggers.get(D);I&&W!==I.info.logLevel&&(I.info.logLevel=W===this.logLevel?void 0:W,I.logger?.setLevel(W),this._loggers.set(I.info.resource,I),this._onDidChangeLogLevel.fire([D,W]))}else{this.logLevel=c;for(const[D,W]of this._loggers.entries())this._loggers.get(D)?.info.logLevel===void 0&&W.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(c,_){const D=this.getLoggerEntry(c);D&&_!==!D.info.hidden&&(D.info.hidden=!_,this._loggers.set(D.info.resource,D),this._onDidChangeVisibility.fire([D.info.resource,_]))}getLogLevel(c){let _;return c&&(_=this._loggers.get(c)?.info.logLevel),_??this.logLevel}registerLogger(c){const _=this._loggers.get(c.resource);_?_.info.hidden!==c.hidden&&this.setVisibility(c.resource,!c.hidden):(this._loggers.set(c.resource,{info:c,logger:void 0}),this._onDidChangeLoggers.fire({added:[c],removed:[]}))}deregisterLogger(c){const _=this._loggers.get(c);_&&(_.logger&&_.logger.dispose(),this._loggers.delete(c),this._onDidChangeLoggers.fire({added:[],removed:[_.info]}))}*getRegisteredLoggers(){for(const c of this._loggers.values())yield c.info}getRegisteredLogger(c){return this._loggers.get(c)?.info}dispose(){this._loggers.forEach(c=>c.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=F;class g{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(c){}getLevel(){return u.Info}trace(c,..._){}debug(c,..._){}info(c,..._){}warn(c,..._){}error(c,..._){}critical(c,..._){}dispose(){}flush(){}}e.NullLogger=g;class b extends g{}e.NullLogService=b;function C(B){if(B.verbose)return u.Trace;if(typeof B.logLevel=="string"){const c=j(B.logLevel.toLowerCase());if(c!==void 0)return c}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=C;function k(B){switch(B){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Off:return"off"}}e.LogLevelToString=k;function j(B){switch(B){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Error;case"off":return u.Off}}e.parseLogLevel=j,e.CONTEXT_LOG_LEVEL=new p.RawContextKey("logLevel",k(u.Info))}),define(ue[79],he([0,1,5,4,10,2]),function(oe,e,v,L,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class M extends S.AbstractLoggerService{constructor(p,w,r,m,u){super(w,r,m),this.windowId=p,this.channel=u,this._register(u.listen("onDidChangeLogLevel",p)(a=>{(0,S.isLogLevel)(a)?super.setLogLevel(a):super.setLogLevel(v.URI.revive(a[0]),a[1])})),this._register(u.listen("onDidChangeVisibility",p)(([a,s])=>super.setVisibility(v.URI.revive(a),s))),this._register(u.listen("onDidChangeLoggers",p)(({added:a,removed:s})=>{for(const o of a)super.registerLogger({...o,resource:v.URI.revive(o.resource)});for(const o of s)super.deregisterLogger(o.resource)}))}createConsoleMainLogger(){return new S.AdapterLogger({log:(p,w)=>{this.channel.call("consoleLog",[p,w])}})}registerLogger(p){super.registerLogger(p),this.channel.call("registerLogger",[p,this.windowId])}deregisterLogger(p){super.deregisterLogger(p),this.channel.call("deregisterLogger",[p,this.windowId])}setLogLevel(p,w){super.setLogLevel(p,w),this.channel.call("setLogLevel",[p,w])}setVisibility(p,w){super.setVisibility(p,w),this.channel.call("setVisibility",[this.toResource(p),w])}doCreateLogger(p,w,r){return new E(this.channel,p,w,r,this.windowId)}static setLogLevel(p,w,r){return p.call("setLogLevel",[w,r])}}e.LoggerChannelClient=M;class E extends S.AbstractMessageLogger{constructor(p,w,r,m,u){super(m?.logLevel==="always"),this.channel=p,this.file=w,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(r),this.channel.call("createLogger",[w,m,u]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(p,w){const r=[[p,w]];this.isLoggerCreated?this.doLog(r):this.buffer.push(...r)}doLog(p){this.channel.call("log",[this.file,p])}}class d{constructor(p,w){this.loggerService=p,this.getUriTransformer=w}listen(p,w){const r=this.getUriTransformer(p);switch(w){case"onDidChangeLoggers":return L.Event.map(this.loggerService.onDidChangeLoggers,m=>({added:[...m.added].map(u=>this.transformLogger(u,r)),removed:[...m.removed].map(u=>this.transformLogger(u,r))}));case"onDidChangeVisibility":return L.Event.map(this.loggerService.onDidChangeVisibility,m=>[r.transformOutgoingURI(m[0]),m[1]]);case"onDidChangeLogLevel":return L.Event.map(this.loggerService.onDidChangeLogLevel,m=>(0,S.isLogLevel)(m)?m:[r.transformOutgoingURI(m[0]),m[1]])}throw new Error(`Event not found: ${w}`)}async call(p,w,r){const m=this.getUriTransformer(p);switch(w){case"setLogLevel":return(0,S.isLogLevel)(r[0])?this.loggerService.setLogLevel(r[0]):this.loggerService.setLogLevel(v.URI.revive(m.transformIncoming(r[0][0])),r[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(u=>this.transformLogger(u,m)))}throw new Error(`Call not found: ${w}`)}transformLogger(p,w){return{...p,resource:w.transformOutgoingURI(p.resource)}}}e.LoggerChannel=d;class l extends A.Disposable{constructor(p,w){super(),w.call("setLogLevel",[p.getLogLevel()]),this._register(p.onDidChangeLogLevel(r=>w.call("setLogLevel",[r]))),w.call("getRegisteredLoggers").then(r=>{for(const m of r)p.registerLogger({...m,resource:v.URI.revive(m.resource)})}),this._register(w.listen("onDidChangeVisibility")(([r,m])=>p.setVisibility(v.URI.revive(r),m))),this._register(w.listen("onDidChangeLoggers")(({added:r,removed:m})=>{for(const u of r)p.registerLogger({...u,resource:v.URI.revive(u.resource)});for(const u of m)p.deregisterLogger(u.resource)}))}}e.RemoteLoggerChannelClient=l}),define(ue[80],he([0,1,2,10]),function(oe,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class S extends v.Disposable{constructor(M,E=[]){super(),this.logger=new L.MultiplexLogger([M,...E]),this._register(M.onDidChangeLogLevel(d=>this.setLevel(d)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(M){this.logger.setLevel(M)}getLevel(){return this.logger.getLevel()}trace(M,...E){this.logger.trace(M,...E)}debug(M,...E){this.logger.debug(M,...E)}info(M,...E){this.logger.info(M,...E)}warn(M,...E){this.logger.warn(M,...E)}error(M,...E){this.logger.error(M,...E)}flush(){this.logger.flush()}}e.LogService=S}),define(ue[81],he([0,1,78,10]),function(oe,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var S;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(S||(S={}));async function A(l,P,p,w,r){try{const m=await new Promise((a,s)=>{oe(["@vscode/spdlog"],a,s)});m.setFlushOn(S.Trace);const u=await m.createAsyncRotatingLogger(l,P,p,w);return r?u.clearFormatters():u.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),u}catch(m){console.error(m)}return null}function M(l,P,p){switch(P){case L.LogLevel.Trace:l.trace(p);break;case L.LogLevel.Debug:l.debug(p);break;case L.LogLevel.Info:l.info(p);break;case L.LogLevel.Warning:l.warn(p);break;case L.LogLevel.Error:l.error(p);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function E(l,P){switch(P){case L.LogLevel.Trace:l.setLevel(S.Trace);break;case L.LogLevel.Debug:l.setLevel(S.Debug);break;case L.LogLevel.Info:l.setLevel(S.Info);break;case L.LogLevel.Warning:l.setLevel(S.Warning);break;case L.LogLevel.Error:l.setLevel(S.Error);break;case L.LogLevel.Off:l.setLevel(S.Off);break;default:throw new Error(`Invalid log level ${P}`)}}class d extends L.AbstractMessageLogger{constructor(P,p,w,r,m){super(),this.buffer=[],this.setLevel(m),this._loggerCreationPromise=this._createSpdLogLogger(P,p,w,r),this._register(this.onDidChangeLogLevel(u=>{this._logger&&E(this._logger,u)}))}async _createSpdLogLogger(P,p,w,r){const m=w?6:1,u=30/m*v.ByteSize.MB,a=await A(P,p,u,m,r);if(a){this._logger=a,E(this._logger,this.getLevel());for(const{level:s,message:o}of this.buffer)M(this._logger,s,o);this.buffer=[]}}log(P,p){this._logger?M(this._logger,P,p):this.getLevel()<=P&&this.buffer.push({level:P,message:p})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=d}),define(ue[82],he([0,1,52,10,81]),function(oe,e,v,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class A extends L.AbstractLoggerService{doCreateLogger(E,d,l){return new S.SpdLogLogger((0,v.generateUuid)(),E.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,d)}}e.LoggerService=A}),define(ue[83],he([0,1,15]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.context<"u"){const A=S.context.configuration();if(A)L=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){L=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:A,searchUrl:M,itemUrl:E,controlUrl:d}=L.extensionsGallery||{};Object.assign(L,{extensionsGallery:{serviceUrl:v.env.VSCODE_GALLERY_SERVICE_URL||A,searchUrl:v.env.VSCODE_GALLERY_SEARCH_URL||M,itemUrl:v.env.VSCODE_GALLERY_ITEM_URL||E,controlUrl:v.env.VSCODE_GALLERY_CONTROL_URL||d}});try{const l=(...p)=>p.reduce((w,r)=>(Object.keys(r).forEach(m=>{Array.isArray(w[m])&&Array.isArray(r[m])?w[m]=r[m]:typeof w[m]=="object"&&typeof r[m]=="object"?w[m]=l(w[m],r[m]):w[m]=r[m]}),w),{}),P=globalThis._VSCODE_USER_PRODUCT_JSON||{};L=l(L,P)}catch{}if(v.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`,serverDataFolderName:L.serverDataFolderName?`${L.serverDataFolderName}-dev`:void 0}),!L.version){const l=globalThis._VSCODE_PACKAGE_JSON;Object.assign(L,{version:l.version,release:l.release})}}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=L}),define(ue[84],he([0,1,21]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ue[85],he([0,1,42,8]),function(oe,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class S{constructor(){this.data=new Map}add(M,E){v.ok(L.isString(M)),v.ok(L.isObject(E)),v.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,E)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new S}),define(ue[86],he([0,1,4,2]),function(oe,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferMarkCapability=void 0;class S extends L.Disposable{constructor(M){super(),this._terminal=M,this.type=4,this._idToMarkerMap=new Map,this._anonymousMarkers=new Map,this._onMarkAdded=this._register(new v.Emitter),this.onMarkAdded=this._onMarkAdded.event}*markers(){for(const M of this._idToMarkerMap.values())yield M;for(const M of this._anonymousMarkers.values())yield M}addMark(M){const E=M?.marker||this._terminal.registerMarker(),d=M?.id;E&&(d?(this._idToMarkerMap.set(d,E),E.onDispose(()=>this._idToMarkerMap.delete(d))):(this._anonymousMarkers.set(E.id,E),E.onDispose(()=>this._anonymousMarkers.delete(E.id))),this._onMarkAdded.fire({marker:E,id:d,hidden:M?.hidden,hoverMessage:M?.hoverMessage}))}getMark(M){return this._idToMarkerMap.get(M)}}e.BufferMarkCapability=S}),define(ue[87],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PartialTerminalCommand=e.TerminalCommand=void 0;class v{get command(){return this._properties.command}get isTrusted(){return this._properties.isTrusted}get timestamp(){return this._properties.timestamp}get promptStartMarker(){return this._properties.promptStartMarker}get marker(){return this._properties.marker}get endMarker(){return this._properties.endMarker}set endMarker(l){this._properties.endMarker=l}get executedMarker(){return this._properties.executedMarker}get aliases(){return this._properties.aliases}get wasReplayed(){return this._properties.wasReplayed}get cwd(){return this._properties.cwd}get exitCode(){return this._properties.exitCode}get commandStartLineContent(){return this._properties.commandStartLineContent}get markProperties(){return this._properties.markProperties}get executedX(){return this._properties.executedX}get startX(){return this._properties.startX}constructor(l,P){this._xterm=l,this._properties=P}static deserialize(l,P,p){const w=l.buffer.normal,r=P.startLine!==void 0?l.registerMarker(P.startLine-(w.baseY+w.cursorY)):void 0;if(!r)return;const m=P.promptStartLine!==void 0?l.registerMarker(P.promptStartLine-(w.baseY+w.cursorY)):void 0,u=P.endLine!==void 0?l.registerMarker(P.endLine-(w.baseY+w.cursorY)):void 0,a=P.executedLine!==void 0?l.registerMarker(P.executedLine-(w.baseY+w.cursorY)):void 0;return new v(l,{command:p?"":P.command,isTrusted:P.isTrusted,promptStartMarker:m,marker:r,startX:P.startX,endMarker:u,executedMarker:a,executedX:P.executedX,timestamp:P.timestamp,cwd:P.cwd,commandStartLineContent:P.commandStartLineContent,exitCode:P.exitCode,markProperties:P.markProperties,aliases:void 0,wasReplayed:!0})}serialize(l){return{promptStartLine:this.promptStartMarker?.line,startLine:this.marker?.line,startX:void 0,endLine:this.endMarker?.line,executedLine:this.executedMarker?.line,executedX:this.executedX,command:l?"":this.command,isTrusted:this.isTrusted,cwd:this.cwd,exitCode:this.exitCode,commandStartLineContent:this.commandStartLineContent,timestamp:this.timestamp,markProperties:this.markProperties}}getOutput(){if(!this.executedMarker||!this.endMarker)return;const l=this.executedMarker.line,P=this.endMarker.line;if(l===P)return;let p="",w;for(let r=l;r<P;r++)w=this._xterm.buffer.active.getLine(r),w&&(p+=w.translateToString(!w.isWrapped)+(w.isWrapped?"":`
`));return p===""?void 0:p}getOutputMatch(l){if(!this.executedMarker||!this.endMarker)return;const P=this.endMarker.line;if(P===-1)return;const p=this._xterm.buffer.active,w=Math.max(this.executedMarker.line,0),r=l.lineMatcher,m=typeof r=="string"?1:l.length||A(r),u=[];let a;if(l.anchor==="bottom")for(let s=P-(l.offset||0);s>=w;s--){let o=s;const f=s;for(;o>=w&&p.getLine(o)?.isWrapped;)o--;if(s=o,u.unshift(S(p,o,f,this._xterm.cols)),a||(a=u[0].match(r)),u.length>=m)break}else for(let s=w+(l.offset||0);s<P;s++){const o=s;let f=s;for(;f+1<P&&p.getLine(f+1)?.isWrapped;)f++;if(s=f,u.push(S(p,o,f,this._xterm.cols)),a||(a=u[u.length-1].match(r)),u.length>=m)break}return a?{regexMatch:a,outputLines:u}:void 0}hasOutput(){return!this.executedMarker?.isDisposed&&!this.endMarker?.isDisposed&&!!(this.executedMarker&&this.endMarker&&this.executedMarker.line<this.endMarker.line)}getPromptRowCount(){return M(this,this._xterm.buffer.active)}getCommandRowCount(){return E(this)}}e.TerminalCommand=v;class L{constructor(l){this._xterm=l}serialize(l){if(this.commandStartMarker)return{promptStartLine:this.promptStartMarker?.line,startLine:this.commandStartMarker.line,startX:this.commandStartX,endLine:void 0,executedLine:void 0,executedX:void 0,command:"",isTrusted:!0,cwd:l,exitCode:void 0,commandStartLineContent:void 0,timestamp:0,markProperties:void 0}}promoteToFullCommand(l,P,p,w){if(P===void 0&&this.command===void 0&&(this.command=""),this.command!==void 0&&!this.command.startsWith("\\")||p)return new v(this._xterm,{command:p?"":this.command||"",isTrusted:!!this.isTrusted,promptStartMarker:this.promptStartMarker,marker:this.commandStartMarker,startX:this.commandStartX,endMarker:this.commandFinishedMarker,executedMarker:this.commandExecutedMarker,executedX:this.commandExecutedX,timestamp:Date.now(),cwd:l,exitCode:P,commandStartLineContent:this.commandStartLineContent,markProperties:w})}getPromptRowCount(){return M(this,this._xterm.buffer.active)}getCommandRowCount(){return E(this)}}e.PartialTerminalCommand=L;function S(d,l,P,p){const w=Math.max(2048/p*2);P=Math.min(P,l+w);let r="";for(let m=l;m<=P;m++){const u=d.getLine(m);u&&(r+=u.translateToString(!0,0,p))}return r}function A(d){if(!d.multiline)return 1;const l=d.source;let P=1,p=l.indexOf("\\n");for(;p!==-1;)P++,p=l.indexOf("\\n",p+1);return P}function M(d,l){const P="hasOutput"in d?d.marker:d.commandStartMarker;if(!P||!d.promptStartMarker)return 1;let p=1,w=d.promptStartMarker.line;for(;w<P.line&&(l.getLine(w)?.translateToString(!0)??"").length===0;)w++;return p=P.line-w+1,p}function E(d){const l="hasOutput"in d?d.marker:d.commandStartMarker,P="hasOutput"in d?d.executedMarker:d.commandExecutedMarker;if(!l||!P)return 1;let w=Math.max(P.line,l.line)-l.line+1;return("hasOutput"in d?d.executedX:d.commandExecutedX)===0&&w--,w}});var Te=this&&this.__param||function(oe,e){return function(v,L){e(v,L,oe)}};define(ue[88],he([0,1,9,14,4,2,10,87]),function(oe,e,v,L,S,A,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLinesForCommand=e.CommandDetectionCapability=void 0;class d extends A.Disposable{get commands(){return this._commands}get executingCommand(){return this._currentCommand.command}get executingCommandObject(){if(this._currentCommand.commandStartMarker)return{marker:this._currentCommand.commandStartMarker}}get currentCommand(){return this._currentCommand}get cwd(){return this._cwd}get _isInputting(){return!!(this._currentCommand.commandStartMarker&&!this._currentCommand.commandExecutedMarker)}get hasInput(){if(!(!this._isInputting||!this._currentCommand?.commandStartMarker)){if(this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY===this._currentCommand.commandStartMarker?.line){const a=this._terminal.buffer.active.getLine(this._terminal.buffer.active.cursorY)?.translateToString(!0,this._currentCommand.commandStartX);return a===void 0?void 0:a.length>0}return!0}}constructor(a,s){super(),this._terminal=a,this._logService=s,this.type=2,this._commands=[],this._currentCommand=new E.PartialTerminalCommand(this._terminal),this._commandMarkers=[],this.__isCommandStorageDisabled=!1,this._onCommandStarted=this._register(new S.Emitter),this.onCommandStarted=this._onCommandStarted.event,this._onBeforeCommandFinished=this._register(new S.Emitter),this.onBeforeCommandFinished=this._onBeforeCommandFinished.event,this._onCommandFinished=this._register(new S.Emitter),this.onCommandFinished=this._onCommandFinished.event,this._onCommandExecuted=this._register(new S.Emitter),this.onCommandExecuted=this._onCommandExecuted.event,this._onCommandInvalidated=this._register(new S.Emitter),this.onCommandInvalidated=this._onCommandInvalidated.event,this._onCurrentCommandInvalidated=this._register(new S.Emitter),this.onCurrentCommandInvalidated=this._onCurrentCommandInvalidated.event;const o=this;this._ptyHeuristicsHooks=new class{get onCurrentCommandInvalidatedEmitter(){return o._onCurrentCommandInvalidated}get onCommandStartedEmitter(){return o._onCommandStarted}get onCommandExecutedEmitter(){return o._onCommandExecuted}get dimensions(){return o._dimensions}get isCommandStorageDisabled(){return o.__isCommandStorageDisabled}get commandMarkers(){return o._commandMarkers}set commandMarkers(f){o._commandMarkers=f}get clearCommandsInViewport(){return o._clearCommandsInViewport.bind(o)}commitCommandFinished(){o._commitCommandFinished?.flush(),o._commitCommandFinished=void 0}},this._ptyHeuristics=this._register(new A.MandatoryMutableDisposable(new l(this._terminal,this,this._ptyHeuristicsHooks,this._logService))),this._dimensions={cols:this._terminal.cols,rows:this._terminal.rows},this._register(this._terminal.onResize(f=>this._handleResize(f))),this._register(this._terminal.onCursorMove(()=>this._handleCursorMove()))}_handleResize(a){this._ptyHeuristics.value.preHandleResize?.(a),this._dimensions.cols=a.cols,this._dimensions.rows=a.rows}_handleCursorMove(){this._terminal.buffer.active===this._terminal.buffer.normal&&this._currentCommand.commandStartMarker&&this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY<this._currentCommand.commandStartMarker.line&&(this._clearCommandsInViewport(),this._currentCommand.isInvalid=!0,this._onCurrentCommandInvalidated.fire({reason:"windows"}))}_clearCommandsInViewport(){let a=0;for(let s=this._commands.length-1;s>=0;s--){const o=this._commands[s].marker?.line;if(o&&o<this._terminal.buffer.active.baseY)break;a++}a>0&&this._onCommandInvalidated.fire(this._commands.splice(this._commands.length-a,a))}setCwd(a){this._cwd=a}setIsWindowsPty(a){if(a&&!(this._ptyHeuristics.value instanceof p)){const s=this;this._ptyHeuristics.value=new p(this._terminal,this,new class{get onCurrentCommandInvalidatedEmitter(){return s._onCurrentCommandInvalidated}get onCommandStartedEmitter(){return s._onCommandStarted}get onCommandExecutedEmitter(){return s._onCommandExecuted}get dimensions(){return s._dimensions}get isCommandStorageDisabled(){return s.__isCommandStorageDisabled}get commandMarkers(){return s._commandMarkers}set commandMarkers(o){s._commandMarkers=o}get clearCommandsInViewport(){return s._clearCommandsInViewport.bind(s)}commitCommandFinished(){s._commitCommandFinished?.flush(),s._commitCommandFinished=void 0}},this._logService)}else!a&&!(this._ptyHeuristics.value instanceof l)&&(this._ptyHeuristics.value=new l(this._terminal,this,this._ptyHeuristicsHooks,this._logService))}setIsCommandStorageDisabled(){this.__isCommandStorageDisabled=!0}getCommandForLine(a){if(this._currentCommand.promptStartMarker&&a>=this._currentCommand.promptStartMarker?.line)return this._currentCommand;if(this._commands.length!==0&&!((this._commands[0].promptStartMarker??this._commands[0].marker).line>a)){for(let s=this.commands.length-1;s>=0;s--)if((this.commands[s].promptStartMarker??this.commands[s].marker).line<=a)return this.commands[s]}}getCwdForLine(a){if(this._currentCommand.promptStartMarker&&a>=this._currentCommand.promptStartMarker?.line)return this._cwd;const s=this.getCommandForLine(a);if(s&&"cwd"in s)return s.cwd}handlePromptStart(a){const s=this.commands.at(-1);s?.endMarker&&s?.executedMarker&&s.endMarker.line===s.executedMarker.line&&(this._logService.debug("CommandDetectionCapability#handlePromptStart adjusted commandFinished",`${s.endMarker.line} -> ${s.executedMarker.line+1}`),s.endMarker=m(this._terminal,s.executedMarker,1)),this._currentCommand.promptStartMarker=a?.marker||(s?.endMarker?m(this._terminal,s.endMarker):this._terminal.registerMarker(0)),this._logService.debug("CommandDetectionCapability#handlePromptStart",this._terminal.buffer.active.cursorX,this._currentCommand.promptStartMarker?.line)}handleContinuationStart(){this._currentCommand.currentContinuationMarker=this._terminal.registerMarker(0),this._logService.debug("CommandDetectionCapability#handleContinuationStart",this._currentCommand.currentContinuationMarker)}handleContinuationEnd(){if(!this._currentCommand.currentContinuationMarker){this._logService.warn("CommandDetectionCapability#handleContinuationEnd Received continuation end without start");return}this._currentCommand.continuations||(this._currentCommand.continuations=[]),this._currentCommand.continuations.push({marker:this._currentCommand.currentContinuationMarker,end:this._terminal.buffer.active.cursorX}),this._currentCommand.currentContinuationMarker=void 0,this._logService.debug("CommandDetectionCapability#handleContinuationEnd",this._currentCommand.continuations[this._currentCommand.continuations.length-1])}handleRightPromptStart(){this._currentCommand.commandRightPromptStartX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleRightPromptStart",this._currentCommand.commandRightPromptStartX)}handleRightPromptEnd(){this._currentCommand.commandRightPromptEndX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleRightPromptEnd",this._currentCommand.commandRightPromptEndX)}handleCommandStart(a){if(this._handleCommandStartOptions=a,this._currentCommand.commandStartMarker=a?.marker||this._currentCommand.commandStartMarker,this._currentCommand.commandStartMarker?.line===this._terminal.buffer.active.cursorY){this._currentCommand.commandStartX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleCommandStart",this._currentCommand.commandStartX,this._currentCommand.commandStartMarker?.line);return}this._ptyHeuristics.value.handleCommandStart(a)}handleGenericCommand(a){a?.markProperties?.disableCommandStorage&&this.setIsCommandStorageDisabled(),this.handlePromptStart(a),this.handleCommandStart(a),this.handleCommandExecuted(a),this.handleCommandFinished(void 0,a)}handleCommandExecuted(a){this._ptyHeuristics.value.handleCommandExecuted(a)}handleCommandFinished(a,s){if(this._ptyHeuristics.value.preHandleCommandFinished?.(),this._logService.debug("CommandDetectionCapability#handleCommandFinished",this._terminal.buffer.active.cursorX,s?.marker?.line,this._currentCommand.command,this._currentCommand),a===void 0){const f=this.commands.length>0?this.commands[this.commands.length-1]:void 0;this._currentCommand.command&&this._currentCommand.command.length>0&&f?.command===this._currentCommand.command&&(a=f.exitCode)}if(this._currentCommand.commandStartMarker===void 0||!this._terminal.buffer.active)return;this._currentCommand.commandFinishedMarker=s?.marker||this._terminal.registerMarker(0),this._ptyHeuristics.value.postHandleCommandFinished?.();const o=this._currentCommand.promoteToFullCommand(this._cwd,a,this._handleCommandStartOptions?.ignoreCommandLine??!1,s?.markProperties);o&&(this._commands.push(o),this._commitCommandFinished=new v.RunOnceScheduler(()=>{this._onBeforeCommandFinished.fire(o),this._currentCommand.isInvalid||(this._logService.debug("CommandDetectionCapability#onCommandFinished",o),this._onCommandFinished.fire(o))},50),this._commitCommandFinished.schedule()),this._currentCommand=new E.PartialTerminalCommand(this._terminal),this._handleCommandStartOptions=void 0}setCommandLine(a,s){this._logService.debug("CommandDetectionCapability#setCommandLine",a,s),this._currentCommand.command=a,this._currentCommand.isTrusted=s}serialize(){const a=this.commands.map(o=>o.serialize(this.__isCommandStorageDisabled)),s=this._currentCommand.serialize(this._cwd);return s&&a.push(s),{isWindowsPty:this._ptyHeuristics.value instanceof p,commands:a}}deserialize(a){a.isWindowsPty&&this.setIsWindowsPty(a.isWindowsPty);const s=this._terminal.buffer.normal;for(const o of a.commands){if(!o.endLine){const n=o.startLine!==void 0?this._terminal.registerMarker(o.startLine-(s.baseY+s.cursorY)):void 0;if(!n)continue;this._currentCommand.commandStartMarker=o.startLine!==void 0?this._terminal.registerMarker(o.startLine-(s.baseY+s.cursorY)):void 0,this._currentCommand.commandStartX=o.startX,this._currentCommand.promptStartMarker=o.promptStartLine!==void 0?this._terminal.registerMarker(o.promptStartLine-(s.baseY+s.cursorY)):void 0,this._cwd=o.cwd,this._onCommandStarted.fire({marker:n});continue}const f=E.TerminalCommand.deserialize(this._terminal,o,this.__isCommandStorageDisabled);f&&(this._commands.push(f),this._logService.debug("CommandDetectionCapability#onCommandFinished",f),this._onCommandFinished.fire(f))}}}e.CommandDetectionCapability=d,ge([(0,L.debounce)(500)],d.prototype,"_handleCursorMove",null);class l extends A.Disposable{constructor(a,s,o,f){super(),this._terminal=a,this._capability=s,this._hooks=o,this._logService=f,this._register(a.parser.registerCsiHandler({final:"J"},n=>(n.length>=1&&(n[0]===2||n[0]===3)&&o.clearCommandsInViewport(),!1)))}async handleCommandStart(a){this._hooks.commitCommandFinished();const s=this._capability.currentCommand;s.commandStartX=this._terminal.buffer.active.cursorX,s.commandStartMarker=a?.marker||this._terminal.registerMarker(0),s.commandExecutedMarker?.dispose(),s.commandExecutedMarker=void 0,s.commandExecutedX=void 0;for(const o of this._hooks.commandMarkers)o.dispose();this._hooks.commandMarkers.length=0,this._hooks.onCommandStartedEmitter.fire({marker:a?.marker||s.commandStartMarker,markProperties:a?.markProperties}),this._logService.debug("CommandDetectionCapability#handleCommandStart",s.commandStartX,s.commandStartMarker?.line)}handleCommandExecuted(a){const s=this._capability.currentCommand;if(s.commandExecutedMarker=a?.marker||this._terminal.registerMarker(0),s.commandExecutedX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleCommandExecuted",s.commandExecutedX,s.commandExecutedMarker?.line),!s.commandStartMarker||!s.commandExecutedMarker||s.commandStartX===void 0)return;s.command=this._hooks.isCommandStorageDisabled?"":this._terminal.buffer.active.getLine(s.commandStartMarker.line)?.translateToString(!0,s.commandStartX,s.commandRightPromptStartX).trim();let o=s.commandStartMarker.line+1;const f=s.commandExecutedMarker.line;for(;o<f;o++){const n=this._terminal.buffer.active.getLine(o);if(n){const t=s.continuations?.find(y=>y.marker.line===o);t&&(s.command+=`
`);const i=t?.end??0;s.command+=n.translateToString(!0,i)}}o===f&&(s.command+=this._terminal.buffer.active.getLine(f)?.translateToString(!0,void 0,s.commandExecutedX)||""),this._hooks.onCommandExecutedEmitter.fire()}}var P;(function(u){u[u.MaxCheckLineCount=5]="MaxCheckLineCount",u[u.Interval=20]="Interval",u[u.MaximumPollCount=50]="MaximumPollCount"})(P||(P={}));let p=class extends A.Disposable{constructor(a,s,o,f){super(),this._terminal=a,this._capability=s,this._hooks=o,this._logService=f,this._onCursorMoveListener=this._register(new A.MutableDisposable),this._recentlyPerformedCsiJ=!1,this._tryAdjustCommandStartMarkerScannedLineCount=0,this._tryAdjustCommandStartMarkerPollCount=0,this._register(a.parser.registerCsiHandler({final:"J"},n=>(n.length>=1&&(n[0]===2||n[0]===3)&&(this._recentlyPerformedCsiJ=!0,this._hooks.clearCommandsInViewport()),!1))),this._register(this._capability.onBeforeCommandFinished(n=>{if(this._recentlyPerformedCsiJ){this._recentlyPerformedCsiJ=!1;return}(n.command.trim().toLowerCase()==="clear"||n.command.trim().toLowerCase()==="cls")&&(this._tryAdjustCommandStartMarkerScheduler?.cancel(),this._tryAdjustCommandStartMarkerScheduler=void 0,this._hooks.clearCommandsInViewport(),this._capability.currentCommand.isInvalid=!0,this._hooks.onCurrentCommandInvalidatedEmitter.fire({reason:"windows"}))}))}preHandleResize(a){const s=this._terminal.buffer.active.baseY,o=a.rows-this._hooks.dimensions.rows;o>0&&this._waitForCursorMove().then(()=>{const f=Math.min(o,s);for(let n=this._capability.commands.length-1;n>=0;n--){const t=this._capability.commands[n];if(!t.marker||t.marker.line<s||t.commandStartLineContent===void 0)break;const i=this._terminal.buffer.active.getLine(t.marker.line);if(!i||i.translateToString(!0)===t.commandStartLineContent)continue;const y=t.marker.line-f;this._terminal.buffer.active.getLine(y)?.translateToString(!0)===t.commandStartLineContent&&this._terminal._core._bufferService.buffer.lines.onDeleteEmitter.fire({index:this._terminal.buffer.active.baseY,amount:f})}})}async handleCommandStart(){this._capability.currentCommand.commandStartX=this._terminal.buffer.active.cursorX,this._hooks.commandMarkers.length=0;const a=this._capability.currentCommand.commandStartMarker=this._capability.currentCommand.promptStartMarker?m(this._terminal,this._capability.currentCommand.promptStartMarker):this._terminal.registerMarker(0);this._capability.currentCommand.commandStartX=0,this._tryAdjustCommandStartMarkerScannedLineCount=0,this._tryAdjustCommandStartMarkerPollCount=0,this._tryAdjustCommandStartMarkerScheduler=new v.RunOnceScheduler(()=>this._tryAdjustCommandStartMarker(a),20),this._tryAdjustCommandStartMarkerScheduler.schedule()}_tryAdjustCommandStartMarker(a){if(this._store.isDisposed)return;const s=this._terminal.buffer.active;let o=this._tryAdjustCommandStartMarkerScannedLineCount;for(;o<5&&a.line+o<s.baseY+this._terminal.rows;){if(this._cursorOnNextLine()){const f=this._getWindowsPrompt(a.line+o);if(f){const n=typeof f=="string"?f:f.prompt;if(this._capability.currentCommand.commandStartMarker=this._terminal.registerMarker(0),typeof f=="object"&&f.likelySingleLine){this._logService.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted promptStart",`${this._capability.currentCommand.promptStartMarker?.line} -> ${this._capability.currentCommand.commandStartMarker.line}`),this._capability.currentCommand.promptStartMarker?.dispose(),this._capability.currentCommand.promptStartMarker=m(this._terminal,this._capability.currentCommand.commandStartMarker);const t=this._capability.commands.at(-1);t&&this._capability.currentCommand.commandStartMarker.line!==t.endMarker?.line&&(t.endMarker?.dispose(),t.endMarker=m(this._terminal,this._capability.currentCommand.commandStartMarker))}this._capability.currentCommand.commandStartX=n.length,this._logService.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted commandStart",`${a.line} -> ${this._capability.currentCommand.commandStartMarker.line}:${this._capability.currentCommand.commandStartX}`),this._flushPendingHandleCommandStartTask();return}}o++}o<5?(this._tryAdjustCommandStartMarkerScannedLineCount=o,this._tryAdjustCommandStartMarkerPollCount<50?this._tryAdjustCommandStartMarkerScheduler?.schedule():this._flushPendingHandleCommandStartTask()):this._flushPendingHandleCommandStartTask()}_flushPendingHandleCommandStartTask(){if(this._tryAdjustCommandStartMarkerScheduler&&(this._tryAdjustCommandStartMarkerPollCount=50,this._tryAdjustCommandStartMarkerScheduler.flush(),this._tryAdjustCommandStartMarkerScheduler=void 0),this._hooks.commitCommandFinished(),this._capability.currentCommand.commandExecutedMarker||(this._onCursorMoveListener.value=this._terminal.onCursorMove(()=>{if(this._hooks.commandMarkers.length===0||this._hooks.commandMarkers[this._hooks.commandMarkers.length-1].line!==this._terminal.buffer.active.cursorY){const a=this._terminal.registerMarker(0);a&&this._hooks.commandMarkers.push(a)}})),this._capability.currentCommand.commandStartMarker){const a=this._terminal.buffer.active.getLine(this._capability.currentCommand.commandStartMarker.line);a&&(this._capability.currentCommand.commandStartLineContent=a.translateToString(!0))}this._hooks.onCommandStartedEmitter.fire({marker:this._capability.currentCommand.commandStartMarker}),this._logService.debug("CommandDetectionCapability#_handleCommandStartWindows",this._capability.currentCommand.commandStartX,this._capability.currentCommand.commandStartMarker?.line)}handleCommandExecuted(a){this._tryAdjustCommandStartMarkerScheduler&&this._flushPendingHandleCommandStartTask(),this._onCursorMoveListener.clear(),this._evaluateCommandMarkers(),this._capability.currentCommand.commandExecutedX=this._terminal.buffer.active.cursorX,this._hooks.onCommandExecutedEmitter.fire(),this._logService.debug("CommandDetectionCapability#handleCommandExecuted",this._capability.currentCommand.commandExecutedX,this._capability.currentCommand.commandExecutedMarker?.line)}preHandleCommandFinished(){this._capability.currentCommand.commandExecutedMarker||(this._hooks.commandMarkers.length===0&&(this._capability.currentCommand.commandStartMarker||(this._capability.currentCommand.commandStartMarker=this._terminal.registerMarker(0)),this._capability.currentCommand.commandStartMarker&&this._hooks.commandMarkers.push(this._capability.currentCommand.commandStartMarker)),this._evaluateCommandMarkers())}postHandleCommandFinished(){const a=this._capability.currentCommand,s=a.command,o=a.commandStartMarker?.line,f=a.commandExecutedMarker?.line;if(!s||s.length===0||o===void 0||o===-1||f===void 0||f===-1)return;let n=0,t=!1;for(let i=o;i<=f;i++){const y=this._terminal.buffer.active.getLine(i);if(!y)break;const F=y.translateToString(!0);for(let g=0;g<F.length;g++){for(;s.length<n&&s[n]===" ";)n++;if(F[g]===s[n]&&n++,n===s.length){const b=g>=this._terminal.cols-1;a.commandExecutedMarker=this._terminal.registerMarker(i-(this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY)+(b?1:0)),a.commandExecutedX=b?0:g+1,t=!0;break}}if(t)break}}_evaluateCommandMarkers(){if(this._hooks.commandMarkers.length!==0){if(this._hooks.commandMarkers=this._hooks.commandMarkers.sort((a,s)=>a.line-s.line),this._capability.currentCommand.commandStartMarker=this._hooks.commandMarkers[0],this._capability.currentCommand.commandStartMarker){const a=this._terminal.buffer.active.getLine(this._capability.currentCommand.commandStartMarker.line);a&&(this._capability.currentCommand.commandStartLineContent=a.translateToString(!0))}this._capability.currentCommand.commandExecutedMarker=this._hooks.commandMarkers[this._hooks.commandMarkers.length-1],this._hooks.onCommandExecutedEmitter.fire()}}_cursorOnNextLine(){const a=this._capability.commands.at(-1);if(!a)return!0;const s=this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY,o=(a.endMarker?a.endMarker.line:a.marker?.line)??-1;return s>o}_waitForCursorMove(){const a=this._terminal.buffer.active.cursorX,s=this._terminal.buffer.active.cursorY;let o=0;return new Promise((f,n)=>{const t=setInterval(()=>{if(a!==this._terminal.buffer.active.cursorX||s!==this._terminal.buffer.active.cursorY){f(),clearInterval(t);return}o+=10,o>1e3&&(clearInterval(t),f())},10)})}_getWindowsPrompt(a=this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY){const s=this._terminal.buffer.active.getLine(a);if(!s)return;const o=s.translateToString(!0);if(!o)return;const f=o.match(/(?<prompt>(\(.+\)\s)?(?:PS.+>\s?))/)?.groups?.prompt;if(f){const i=this._adjustPrompt(f,o,">");if(i)return{prompt:i,likelySingleLine:!0}}const n=o.match(/.*\u276f(?=[^\u276f]*$)/g)?.[0];if(n){const i=this._adjustPrompt(n,o,"\u276F");if(i)return i}const t=o.match(/^(?<prompt>(\(.+\)\s)?(?:[A-Z]:\\.*>))/);return t?.groups?.prompt?{prompt:t.groups.prompt,likelySingleLine:!0}:void 0}_adjustPrompt(a,s,o){if(a)return s===a&&a.endsWith(o)&&(a+=" "),a}};p=ge([Te(3,M.ILogService)],p);function w(u,a,s,o){if(!o)return;const f=a.executedMarker,n=a.endMarker;if(!f||!n)return;const t=f.line,i=n.line,y=o.length,F=[];if(o.anchor==="bottom")for(let g=i-(o.offset||0);g>=t;g--){let b=g;const C=g;for(;b>=t&&u.getLine(b)?.isWrapped;)b--;g=b,F.unshift(r(u,b,C,s)),F.length>y&&F.pop()}else for(let g=t+(o.offset||0);g<i;g++){const b=g;let C=g;for(;C+1<i&&u.getLine(C+1)?.isWrapped;)C++;g=C,F.push(r(u,b,C,s)),F.length===y&&F.shift()}return F}e.getLinesForCommand=w;function r(u,a,s,o){const f=Math.max(2048/o*2);s=Math.min(s,a+f);let n="";for(let t=a;t<=s;t++){const i=u.getLine(t);i&&(n+=i.translateToString(!0,0,o))}return n}function m(u,a,s=0){return u.registerMarker(a.line-(u.buffer.active.baseY+u.buffer.active.cursorY)+s)}}),define(ue[89],he([0,1,4,2]),function(oe,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CwdDetectionCapability=void 0;class S extends L.Disposable{constructor(){super(...arguments),this.type=0,this._cwd="",this._cwds=new Map,this._onDidChangeCwd=this._register(new v.Emitter),this.onDidChangeCwd=this._onDidChangeCwd.event}get cwds(){return Array.from(this._cwds.keys())}getCwd(){return this._cwd}updateCwd(M){const E=this._cwd!==M;this._cwd=M;const d=this._cwds.get(this._cwd)||0;this._cwds.delete(this._cwd),this._cwds.set(this._cwd,d+1),E&&this._onDidChangeCwd.fire(M)}}e.CwdDetectionCapability=S}),define(ue[90],he([0,1,4,2]),function(oe,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PartialCommandDetectionCapability=void 0;var S;(function(M){M[M.MinimumPromptLength=2]="MinimumPromptLength"})(S||(S={}));class A extends L.DisposableStore{get commands(){return this._commands}constructor(E){super(),this._terminal=E,this.type=3,this._commands=[],this._onCommandFinished=this.add(new v.Emitter),this.onCommandFinished=this._onCommandFinished.event,this.add(this._terminal.onData(d=>this._onData(d))),this.add(this._terminal.parser.registerCsiHandler({final:"J"},d=>(d.length>=1&&(d[0]===2||d[0]===3)&&this._clearCommandsInViewport(),!1)))}_onData(E){E==="\r"&&this._onEnter()}_onEnter(){if(this._terminal&&this._terminal.buffer.active.cursorX>=2){const E=this._terminal.registerMarker(0);E&&(this._commands.push(E),this._onCommandFinished.fire(E))}}_clearCommandsInViewport(){let E=0;for(let d=this._commands.length-1;d>=0&&!(this._commands[d].line<this._terminal.buffer.active.baseY);d--)E++;this._commands.splice(this._commands.length-E,E)}}e.PartialCommandDetectionCapability=A}),define(ue[91],he([0,1,4,2]),function(oe,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalCapabilityStoreMultiplexer=e.TerminalCapabilityStore=void 0;class S extends L.Disposable{constructor(){super(...arguments),this._map=new Map,this._onDidRemoveCapabilityType=this._register(new v.Emitter),this.onDidRemoveCapabilityType=this._onDidRemoveCapabilityType.event,this._onDidAddCapabilityType=this._register(new v.Emitter),this.onDidAddCapabilityType=this._onDidAddCapabilityType.event,this._onDidRemoveCapability=this._register(new v.Emitter),this.onDidRemoveCapability=this._onDidRemoveCapability.event,this._onDidAddCapability=this._register(new v.Emitter),this.onDidAddCapability=this._onDidAddCapability.event}get items(){return this._map.keys()}add(E,d){this._map.set(E,d),this._onDidAddCapabilityType.fire(E),this._onDidAddCapability.fire({id:E,capability:d})}get(E){return this._map.get(E)}remove(E){const d=this._map.get(E);d&&(this._map.delete(E),this._onDidRemoveCapabilityType.fire(E),this._onDidAddCapability.fire({id:E,capability:d}))}has(E){return this._map.has(E)}}e.TerminalCapabilityStore=S;class A extends L.Disposable{constructor(){super(...arguments),this._stores=[],this._onDidRemoveCapabilityType=this._register(new v.Emitter),this.onDidRemoveCapabilityType=this._onDidRemoveCapabilityType.event,this._onDidAddCapabilityType=this._register(new v.Emitter),this.onDidAddCapabilityType=this._onDidAddCapabilityType.event,this._onDidRemoveCapability=this._register(new v.Emitter),this.onDidRemoveCapability=this._onDidRemoveCapability.event,this._onDidAddCapability=this._register(new v.Emitter),this.onDidAddCapability=this._onDidAddCapability.event}get items(){return this._items()}*_items(){for(const E of this._stores)for(const d of E.items)yield d}has(E){for(const d of this._stores)for(const l of d.items)if(l===E)return!0;return!1}get(E){for(const d of this._stores){const l=d.get(E);if(l)return l}}add(E){this._stores.push(E);for(const d of E.items)this._onDidAddCapabilityType.fire(d),this._onDidAddCapability.fire({id:d,capability:E.get(d)});this._register(E.onDidAddCapabilityType(d=>this._onDidAddCapabilityType.fire(d))),this._register(E.onDidAddCapability(d=>this._onDidAddCapability.fire(d))),this._register(E.onDidRemoveCapabilityType(d=>this._onDidRemoveCapabilityType.fire(d))),this._register(E.onDidRemoveCapability(d=>this._onDidRemoveCapability.fire(d)))}}e.TerminalCapabilityStoreMultiplexer=A}),define(ue[36],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var v;(function(L){L[L.Replace=1]="Replace",L[L.Append=2]="Append",L[L.Prepend=3]="Prepend"})(v||(e.EnvironmentVariableMutatorType=v={}))}),define(ue[92],he([0,1,3,36]),function(oe,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;const S=new Map([[L.EnvironmentVariableMutatorType.Append,"APPEND"],[L.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[L.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class A{constructor(P){this.collections=P,this.map=new Map,this.descriptionMap=new Map,P.forEach((p,w)=>{this.populateDescriptionMap(p,w);const r=p.map.entries();let m=r.next();for(;!m.done;){const u=m.value[1],a=m.value[0];let s=this.map.get(a);if(s||(s=[],this.map.set(a,s)),s.length>0&&s[0].type===L.EnvironmentVariableMutatorType.Replace){m=r.next();continue}const o={extensionIdentifier:w,value:u.value,type:u.type,scope:u.scope,variable:u.variable,options:u.options};o.scope||delete o.scope,s.unshift(o),m=r.next()}})}async applyToProcessEnvironment(P,p,w){let r;v.isWindows&&(r={},Object.keys(P).forEach(m=>r[m.toLowerCase()]=m));for(const[m,u]of this.getVariableMap(p)){const a=v.isWindows&&r[m.toLowerCase()]||m;for(const s of u){const o=w?await w(s.value):s.value;if(s.options?.applyAtProcessCreation??!0)switch(s.type){case L.EnvironmentVariableMutatorType.Append:P[a]=(P[a]||"")+o;break;case L.EnvironmentVariableMutatorType.Prepend:P[a]=o+(P[a]||"");break;case L.EnvironmentVariableMutatorType.Replace:P[a]=o;break}if(s.options?.applyAtShellIntegration??!1){const f=`VSCODE_ENV_${S.get(s.type)}`;P[f]=(P[f]?P[f]+":":"")+m+"="+this._encodeColons(o)}}}}_encodeColons(P){return P.replaceAll(":","\\x3a")}diff(P,p){const w=new Map,r=new Map,m=new Map;if(P.getVariableMap(p).forEach((u,a)=>{const s=this.getVariableMap(p).get(a),o=E(u,s);o&&w.set(a,o)}),this.getVariableMap(p).forEach((u,a)=>{const s=P.getVariableMap(p).get(a),o=E(u,s);o&&m.set(a,o)}),this.getVariableMap(p).forEach((u,a)=>{const s=P.getVariableMap(p).get(a),o=d(u,s);o&&r.set(a,o)}),!(w.size===0&&r.size===0&&m.size===0))return{added:w,changed:r,removed:m}}getVariableMap(P){const p=new Map;for(const w of this.map.values()){const r=w.filter(m=>M(m,P));r.length>0&&p.set(r[0].variable,r)}return p}getDescriptionMap(P){const p=new Map;for(const w of this.descriptionMap.values()){const r=w.filter(m=>M(m,P,!0));for(const m of r)p.set(m.extensionIdentifier,m.description)}return p}populateDescriptionMap(P,p){if(!P.descriptionMap)return;const w=P.descriptionMap.entries();let r=w.next();for(;!r.done;){const m=r.value[1],u=r.value[0];let a=this.descriptionMap.get(u);a||(a=[],this.descriptionMap.set(u,a));const s={extensionIdentifier:p,scope:m.scope,description:m.description};s.scope||delete s.scope,a.push(s),r=w.next()}}}e.MergedEnvironmentVariableCollection=A;function M(l,P,p=!1){return l.scope?!!(l.scope.workspaceFolder&&P?.workspaceFolder&&l.scope.workspaceFolder.index===P.workspaceFolder.index):p?P===l.scope:!0}function E(l,P){if(!P)return l;const p=new Set;P.forEach(r=>p.add(r.extensionIdentifier));const w=[];return l.forEach(r=>{p.has(r.extensionIdentifier)||w.push(r)}),w.length===0?void 0:w}function d(l,P){if(!P)return;const p=new Map;P.forEach(r=>p.set(r.extensionIdentifier,r));const w=[];return l.forEach(r=>{const m=p.get(r.extensionIdentifier);m&&(r.type!==m.type||r.value!==m.value||r.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index)&&w.push(m)}),w.length===0?void 0:w}}),define(ue[93],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function v(d){return[...d.entries()]}e.serializeEnvironmentVariableCollection=v;function L(d){return d?[...d.entries()]:[]}e.serializeEnvironmentDescriptionMap=L;function S(d){return new Map(d)}e.deserializeEnvironmentVariableCollection=S;function A(d){return new Map(d??[])}e.deserializeEnvironmentDescriptionMap=A;function M(d){return Array.from(d.entries()).map(l=>[l[0],v(l[1].map),L(l[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=M;function E(d){return new Map(d.map(l=>[l[0],{map:S(l[1]),descriptionMap:A(l[2])}]))}e.deserializeEnvironmentVariableCollections=E}),define(ue[94],he([0,1,9,17,4,2,10]),function(oe,e,v,L,S,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let E=class extends A.Disposable{constructor(l,P){super(),this._logService=P,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new S.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=l===void 0?15e3:l,this._register((0,A.toDisposable)(()=>{for(const p of this._pendingRequestDisposables.values())(0,A.dispose)(p)}))}createRequest(l){return new Promise((P,p)=>{const w=++this._lastRequestId;this._pendingRequests.set(w,P),this._onCreateRequest.fire({requestId:w,...l});const r=new L.CancellationTokenSource;(0,v.timeout)(this._timeout,r.token).then(()=>p(`Request ${w} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(w,[(0,A.toDisposable)(()=>r.cancel())])})}acceptReply(l,P){const p=this._pendingRequests.get(l);p?(this._pendingRequests.delete(l),(0,A.dispose)(this._pendingRequestDisposables.get(l)||[]),this._pendingRequestDisposables.delete(l),p(P)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${l}`)}};e.RequestStore=E,e.RequestStore=E=ge([Te(1,M.ILogService)],E)}),define(ue[28],he([0,1,21,35,85]),function(oe,e,v,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new L.RawContextKey("terminalTabFocusMode",!1,!0);var A;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(A||(e.TerminalSettingPrefix=A={}));var M;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",t.LocalEchoEnabled="terminal.integrated.localEchoEnabled",t.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",t.LocalEchoStyle="terminal.integrated.localEchoStyle",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",t.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",t.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",t.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",t.MouseWheelZoom="terminal.integrated.mouseWheelZoom",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(M||(e.TerminalSettingId=M={}));var E;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh"})(E||(e.PosixShellType=E={}));var d;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash"})(d||(e.WindowsShellType=d={}));var l;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(l||(e.TitleEventSource=l={}));var P;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(P||(e.TerminalIpcChannels=P={}));var p;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(p||(e.ProcessPropertyType=p={})),e.IPtyService=(0,v.createDecorator)("ptyService");var w;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(w||(e.HeartbeatConstants=w={}));var r;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(r||(e.TerminalLocation=r={}));var m;(function(t){t.TerminalView="view",t.Editor="editor"})(m||(e.TerminalLocationString=m={}));var u;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(u||(e.LocalReconnectConstants=u={}));var a;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(a||(e.FlowControlConstants=a={}));var s;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(s||(e.ProfileSource=s={}));var o;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(o||(e.ShellIntegrationStatus=o={}));var f;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(f||(e.TerminalExitReason=f={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class n{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(i){const y=this._sanitizeRemoteAuthority(i.remoteAuthority);if(this._backends.has(y))throw new Error(`A terminal backend with remote authority '${y}' was already registered.`);this._backends.set(y,i)}getTerminalBackend(i){return this._backends.get(this._sanitizeRemoteAuthority(i))}_sanitizeRemoteAuthority(i){return i?.toLowerCase()??""}}S.Registry.add(e.TerminalExtensions.Backend,new n),e.ILocalPtyService=(0,v.createDecorator)("localPtyService"),e.ITerminalLogService=(0,v.createDecorator)("terminalLogService")}),define(ue[95],he([0,1,9,2,3]),function(oe,e,v,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalAutoResponder=void 0;class A extends L.Disposable{constructor(E,d,l,P){super(),this._pointer=0,this._paused=!1,this._throttled=!1,this._register(E.onProcessData(p=>{if(this._paused||this._throttled)return;const w=typeof p=="string"?p:p.data;for(let r=0;r<w.length;r++)w[r]===d[this._pointer]?this._pointer++:this._reset(),this._pointer===d.length&&(P.debug(`Auto reply match: "${d}", response: "${l}"`),E.input(l),this._throttled=!0,(0,v.timeout)(1e3).then(()=>this._throttled=!1),this._reset())}))}_reset(){this._pointer=0}handleResize(){S.isWindows&&(this._paused=!0)}handleInput(){this._paused=!1}}e.TerminalAutoResponder=A}),define(ue[96],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class v{constructor(S){this._callback=S,this._terminalBufferMap=new Map}dispose(){for(const S of this._terminalBufferMap.values())S.dispose()}startBuffering(S,A,M=5){const E=A(d=>{const l=typeof d=="string"?d:d.data;let P=this._terminalBufferMap.get(S);if(P){P.data.push(l);return}const p=setTimeout(()=>this.flushBuffer(S),M);P={data:[l],timeoutId:p,dispose:()=>{clearTimeout(p),this.flushBuffer(S),E.dispose()}},this._terminalBufferMap.set(S,P)});return E}stopBuffering(S){this._terminalBufferMap.get(S)?.dispose()}flushBuffer(S){const A=this._terminalBufferMap.get(S);A&&(this._terminalBufferMap.delete(S),this._callback(S,A.data.join("")))}}e.TerminalDataBufferer=v}),define(ue[37],he([0,1,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeCwd=e.collapseTildePath=e.escapeNonWindowsPath=void 0;function L(M){let E=M;E.includes("\\")&&(E=E.replace(/\\/g,"\\\\"));const d=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return E=E.replace(d,""),`'${E}'`}e.escapeNonWindowsPath=L;function S(M,E,d){if(!M)return"";if(!E)return M;E.match(/[\/\\]$/)&&(E=E.slice(0,E.length-1));const l=M.replace(/\\/g,"/").toLowerCase(),P=E.replace(/\\/g,"/").toLowerCase();return l.includes(P)?`~${d}${M.slice(E.length+1)}`:M}e.collapseTildePath=S;function A(M){return M.match(/^['"].*['"]$/)&&(M=M.substring(1,M.length-1)),v.OS===1&&M&&M[1]===":"?M[0].toUpperCase()+M.substring(1):M}e.sanitizeCwd=A}),define(ue[97],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.chunkInput=void 0;var v;(function(S){S[S.WriteMaxChunkSize=50]="WriteMaxChunkSize"})(v||(v={}));function L(S){const A=[];let M=0;for(let E=0;E<S.length-1;E++)(E-M+1>=50||S[E+1]==="\x1B")&&(A.push(S.substring(M,E+1)),M=E+1,E++);return M!==S.length&&A.push(S.substring(M)),A}e.chunkInput=L}),define(ue[98],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.formatMessageForTerminal=void 0;function v(L,S={}){let A="";return S.excludeLeadingNewLine||(A+=`\r
`),A+="\x1B[0m\x1B[7m * ",S.loudFormatting?A+="\x1B[0;104m":A+="\x1B[0m",A+=` ${L} \x1B[0m
\r`,A}e.formatMessageForTerminal=v}),define(ue[99],he([0,1,2,91,88,89,90,4,86,5,37]),function(oe,e,v,L,S,A,M,E,d,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseMarkSequence=e.parseKeyValueAssignment=e.deserializeMessage=e.ShellIntegrationAddon=void 0;var p;(function(o){o[o.FinalTerm=133]="FinalTerm",o[o.VSCode=633]="VSCode",o[o.ITerm=1337]="ITerm",o[o.SetCwd=7]="SetCwd",o[o.SetWindowsFriendlyCwd=9]="SetWindowsFriendlyCwd"})(p||(p={}));var w;(function(o){o.PromptStart="A",o.CommandStart="B",o.CommandExecuted="C",o.CommandFinished="D",o.CommandLine="E",o.ContinuationStart="F",o.ContinuationEnd="G",o.RightPromptStart="H",o.RightPromptEnd="I",o.Property="P",o.SetMark="SetMark"})(w||(w={}));var r;(function(o){o.SetMark="SetMark",o.CurrentDir="CurrentDir"})(r||(r={}));class m extends v.Disposable{get status(){return this._status}constructor(f,n,t,i){super(),this._nonce=f,this._disableTelemetry=n,this._telemetryService=t,this._logService=i,this.capabilities=this._register(new L.TerminalCapabilityStore),this._hasUpdatedTelemetry=!1,this._commonProtocolDisposables=[],this._status=0,this._onDidChangeStatus=new E.Emitter,this.onDidChangeStatus=this._onDidChangeStatus.event,this._register((0,v.toDisposable)(()=>{this._clearActivationTimeout(),this._disposeCommonProtocol()}))}_disposeCommonProtocol(){(0,v.dispose)(this._commonProtocolDisposables),this._commonProtocolDisposables.length=0}activate(f){this._terminal=f,this.capabilities.add(3,this._register(new M.PartialCommandDetectionCapability(this._terminal))),this._register(f.parser.registerOscHandler(633,n=>this._handleVSCodeSequence(n))),this._register(f.parser.registerOscHandler(1337,n=>this._doHandleITermSequence(n))),this._commonProtocolDisposables.push(f.parser.registerOscHandler(133,n=>this._handleFinalTermSequence(n))),this._register(f.parser.registerOscHandler(7,n=>this._doHandleSetCwd(n))),this._register(f.parser.registerOscHandler(9,n=>this._doHandleSetWindowsFriendlyCwd(n))),this._ensureCapabilitiesOrAddFailureTelemetry()}getMarkerId(f,n){this._createOrGetBufferMarkDetection(f).getMark(n)}_handleFinalTermSequence(f){const n=this._doHandleFinalTermSequence(f);return this._status===0&&(this._status=1,this._onDidChangeStatus.fire(this._status)),n}_doHandleFinalTermSequence(f){if(!this._terminal)return!1;const[n,...t]=f.split(";");switch(n){case"A":return this._createOrGetCommandDetection(this._terminal).handlePromptStart(),!0;case"B":return this._createOrGetCommandDetection(this._terminal).handleCommandStart({ignoreCommandLine:!0}),!0;case"C":return this._createOrGetCommandDetection(this._terminal).handleCommandExecuted(),!0;case"D":{const i=t.length===1?parseInt(t[0]):void 0;return this._createOrGetCommandDetection(this._terminal).handleCommandFinished(i),!0}}return!1}_handleVSCodeSequence(f){const n=this._doHandleVSCodeSequence(f);return!this._hasUpdatedTelemetry&&n&&(this._telemetryService?.publicLog2("terminal/shellIntegrationActivationSucceeded"),this._hasUpdatedTelemetry=!0,this._clearActivationTimeout()),this._status!==2&&(this._status=2,this._onDidChangeStatus.fire(this._status)),n}async _ensureCapabilitiesOrAddFailureTelemetry(){!this._telemetryService||this._disableTelemetry||(this._activationTimeout=setTimeout(()=>{!this.capabilities.get(2)&&!this.capabilities.get(0)&&(this._telemetryService?.publicLog2("terminal/shellIntegrationActivationTimeout"),this._logService.warn("Shell integration failed to add capabilities within 10 seconds")),this._hasUpdatedTelemetry=!0},1e4))}_clearActivationTimeout(){this._activationTimeout!==void 0&&(clearTimeout(this._activationTimeout),this._activationTimeout=void 0)}_doHandleVSCodeSequence(f){if(!this._terminal)return!1;const n=f.indexOf(";"),t=n===-1?f:f.substring(0,n),i=n===-1?[]:f.substring(n+1).split(";");switch(t){case"A":return this._createOrGetCommandDetection(this._terminal).handlePromptStart(),!0;case"B":return this._createOrGetCommandDetection(this._terminal).handleCommandStart(),!0;case"C":return this._createOrGetCommandDetection(this._terminal).handleCommandExecuted(),!0;case"D":{const y=i[0],F=y!==void 0?parseInt(y):void 0;return this._createOrGetCommandDetection(this._terminal).handleCommandFinished(F),!0}case"E":{const y=i[0],F=i[1];let g;return y!==void 0?g=u(y):g="",this._createOrGetCommandDetection(this._terminal).setCommandLine(g,F===this._nonce),!0}case"F":return this._createOrGetCommandDetection(this._terminal).handleContinuationStart(),!0;case"G":return this._createOrGetCommandDetection(this._terminal).handleContinuationEnd(),!0;case"H":return this._createOrGetCommandDetection(this._terminal).handleRightPromptStart(),!0;case"I":return this._createOrGetCommandDetection(this._terminal).handleRightPromptEnd(),!0;case"P":{const y=i[0],F=y!==void 0?u(y):"",{key:g,value:b}=a(F);if(b===void 0)return!0;switch(g){case"Cwd":return this._updateCwd(b),!0;case"IsWindows":return this._createOrGetCommandDetection(this._terminal).setIsWindowsPty(b==="True"),!0;case"Task":return this._createOrGetBufferMarkDetection(this._terminal),this.capabilities.get(2)?.setIsCommandStorageDisabled(),!0}}case"SetMark":return this._createOrGetBufferMarkDetection(this._terminal).addMark(s(i)),!0}return!1}_updateCwd(f){f=(0,P.sanitizeCwd)(f),this._createOrGetCwdDetection().updateCwd(f),this.capabilities.get(2)?.setCwd(f)}_doHandleITermSequence(f){if(!this._terminal)return!1;const[n]=f.split(";");switch(n){case"SetMark":this._createOrGetBufferMarkDetection(this._terminal).addMark();default:{const{key:t,value:i}=a(n);if(i===void 0)return!0;switch(t){case"CurrentDir":return this._updateCwd(i),!0}}}return!1}_doHandleSetWindowsFriendlyCwd(f){if(!this._terminal)return!1;const[n,...t]=f.split(";");switch(n){case"9":return t.length&&this._updateCwd(t[0]),!0}return!1}_doHandleSetCwd(f){if(!this._terminal)return!1;const[n]=f.split(";");if(n.match(/^file:\/\/.*\//)){const t=l.URI.parse(n);if(t.path&&t.path.length>0)return this._updateCwd(t.path),!0}return!1}serialize(){return!this._terminal||!this.capabilities.has(2)?{isWindowsPty:!1,commands:[]}:this._createOrGetCommandDetection(this._terminal).serialize()}deserialize(f){if(!this._terminal)throw new Error("Cannot restore commands before addon is activated");this._createOrGetCommandDetection(this._terminal).deserialize(f)}_createOrGetCwdDetection(){let f=this.capabilities.get(0);return f||(f=this._register(new A.CwdDetectionCapability),this.capabilities.add(0,f)),f}_createOrGetCommandDetection(f){let n=this.capabilities.get(2);return n||(n=this._register(new S.CommandDetectionCapability(f,this._logService)),this.capabilities.add(2,n)),n}_createOrGetBufferMarkDetection(f){let n=this.capabilities.get(4);return n||(n=this._register(new d.BufferMarkCapability(f)),this.capabilities.add(4,n)),n}}e.ShellIntegrationAddon=m;function u(o){return o.replaceAll(/\\(\\|x([0-9a-f]{2}))/gi,(f,n,t)=>t?String.fromCharCode(parseInt(t,16)):n)}e.deserializeMessage=u;function a(o){const f=o.indexOf("=");return f===-1?{key:o,value:void 0}:{key:o.substring(0,f),value:o.substring(1+f)}}e.parseKeyValueAssignment=a;function s(o){let f,n=!1;for(const t of o)t!==void 0&&(t==="Hidden"&&(n=!0),t.startsWith("Id=")&&(f=t.substring(3)));return{id:f,hidden:n}}e.parseMarkSequence=s}),define(ue[38],he([0,1,7,14,4,2,62,10]),function(oe,e,v,L,S,A,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChildProcessMonitor=e.ignoreProcessNames=void 0;var d;(function(P){P[P.InactiveThrottleDuration=5e3]="InactiveThrottleDuration",P[P.ActiveDebounceDuration=1e3]="ActiveDebounceDuration"})(d||(d={})),e.ignoreProcessNames=[];let l=class extends A.Disposable{set hasChildProcesses(p){this._hasChildProcesses!==p&&(this._hasChildProcesses=p,this._logService.debug("ChildProcessMonitor: Has child processes changed",p),this._onDidChangeHasChildProcesses.fire(p))}get hasChildProcesses(){return this._hasChildProcesses}constructor(p,w){super(),this._pid=p,this._logService=w,this._hasChildProcesses=!1,this._onDidChangeHasChildProcesses=this._register(new S.Emitter),this.onDidChangeHasChildProcesses=this._onDidChangeHasChildProcesses.event}handleInput(){this._refreshActive()}handleOutput(){this._refreshInactive()}async _refreshActive(){if(!this._store.isDisposed)try{const p=await(0,M.listProcesses)(this._pid);this.hasChildProcesses=this._processContainsChildren(p)}catch(p){this._logService.debug("ChildProcessMonitor: Fetching process tree failed",p)}}_refreshInactive(){this._refreshActive()}_processContainsChildren(p){if(!p.children)return!1;if(p.children.length===1){const w=p.children[0];let r;if(w.cmd.startsWith('"'))r=w.cmd.substring(1,w.cmd.indexOf('"',1));else{const m=w.cmd.indexOf(" ");m===-1?r=w.cmd:r=w.cmd.substring(0,m)}return e.ignoreProcessNames.indexOf((0,v.parse)(r).name)===-1}return p.children.length>0}};e.ChildProcessMonitor=l,ge([(0,L.debounce)(1e3)],l.prototype,"_refreshActive",null),ge([(0,L.throttle)(5e3)],l.prototype,"_refreshInactive",null),e.ChildProcessMonitor=l=ge([Te(1,E.ILogService)],l)}),define(ue[100],he([0,1,4,2,28]),function(oe,e,v,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.HeartbeatService=void 0;class A extends L.Disposable{constructor(){super(),this._onBeat=this._register(new v.Emitter),this.onBeat=this._onBeat.event;const E=setInterval(()=>{this._onBeat.fire()},S.HeartbeatConstants.BeatInterval);this._register((0,L.toDisposable)(()=>clearInterval(E)))}}e.HeartbeatService=A}),define(ue[39],he([0,1,20,19,30,7,3,15,11,8,24,36,93,92]),function(oe,e,v,L,S,A,M,E,d,l,P,p,w,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function m(){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(v.release());let b=0;return g&&g.length===4&&(b=parseInt(g[3])),b}e.getWindowsBuildNumber=m;async function u(g,b,C,k=E.env,j=P.Promises.exists){if(A.isAbsolute(g))return await j(g)?g:void 0;if(b===void 0&&(b=E.cwd()),A.dirname(g)!=="."){const D=A.join(b,g);return await j(D)?D:void 0}const c=(0,S.getCaseInsensitive)(k,"PATH");if(C===void 0&&(0,l.isString)(c)&&(C=c.split(A.delimiter)),C===void 0||C.length===0){const D=A.join(b,g);return await j(D)?D:void 0}for(const D of C){let W;if(A.isAbsolute(D)?W=A.join(D,g):W=A.join(b,D,g),await j(W))return W;if(M.isWindows){let I=W+".com";if(await j(I)||(I=W+".exe",await j(I)))return I}}const _=A.join(b,g);return await j(_)?_:void 0}e.findExecutable=u;function a(g,b,C,k,j){const B=M.isWindows&&(!b.windowsEnableConpty||m()<18309);if(!b.shellIntegration.enabled||!g.executable||g.isFeatureTerminal||g.hideFromUser||g.ignoreShellIntegration||B)return;const c=g.args,_=E.platform==="win32"?A.basename(g.executable).toLowerCase():A.basename(g.executable),D=A.dirname(L.FileAccess.asFileUri("").fsPath);let W;const I={VSCODE_INJECTION:"1"};if(b.shellIntegration.nonce&&(I.VSCODE_NONCE=b.shellIntegration.nonce),M.isWindows){if(_==="pwsh.exe"||_==="powershell.exe")return!c||y(c)?W=f.get(o.WindowsPwsh):i(c)&&(W=f.get(o.WindowsPwshLogin)),W?(W=[...W],W[W.length-1]=(0,d.format)(W[W.length-1],D,""),b.shellIntegration.suggestEnabled&&(I.VSCODE_SUGGEST="1"),{newArgs:W,envMixin:I}):void 0;k.warn(`Shell integration cannot be enabled for executable "${g.executable}" and args`,g.args);return}switch(_){case"bash":return!c||c.length===0?W=f.get(o.Bash):F(c)&&(I.VSCODE_SHELL_LOGIN="1",s(b,I),W=f.get(o.Bash)),W?(W=[...W],W[W.length-1]=(0,d.format)(W[W.length-1],D),{newArgs:W,envMixin:I}):void 0;case"fish":{const q=C?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ee=A.join(D,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return I.XDG_DATA_DIRS=`${q}:${ee}`,s(b,I),{newArgs:void 0,envMixin:I}}case"pwsh":return!c||y(c)?W=f.get(o.Pwsh):i(c)&&(W=f.get(o.PwshLogin)),W?(b.shellIntegration.suggestEnabled&&(I.VSCODE_SUGGEST="1"),W=[...W],W[W.length-1]=(0,d.format)(W[W.length-1],D,""),{newArgs:W,envMixin:I}):void 0;case"zsh":{if(!c||c.length===0?W=f.get(o.Zsh):F(c)?(W=f.get(o.ZshLogin),s(b,I)):(c===f.get(o.Zsh)||c===f.get(o.ZshLogin))&&(W=c),!W)return;W=[...W],W[W.length-1]=(0,d.format)(W[W.length-1],D);let q;try{q=v.userInfo().username}catch{q="unknown"}const ee=A.join(v.tmpdir(),`${q}-${j.applicationName}-zsh`);I.ZDOTDIR=ee;const ne=C?.ZDOTDIR??v.homedir()??"~";I.USER_ZDOTDIR=ne;const Q=[];return Q.push({source:A.join(D,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:A.join(ee,".zshrc")}),Q.push({source:A.join(D,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:A.join(ee,".zprofile")}),Q.push({source:A.join(D,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:A.join(ee,".zshenv")}),Q.push({source:A.join(D,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:A.join(ee,".zlogin")}),{newArgs:W,envMixin:I,filesToCopy:Q}}}k.warn(`Shell integration cannot be enabled for executable "${g.executable}" and args`,g.args)}e.getShellIntegrationInjection=a;function s(g,b){if(M.isMacintosh&&g.environmentVariableCollections){const C=(0,w.deserializeEnvironmentVariableCollections)(g.environmentVariableCollections),j=new r.MergedEnvironmentVariableCollection(C).getVariableMap({workspaceFolder:g.workspaceFolder}).get("PATH"),B=[];if(j)for(const c of j)c.type===p.EnvironmentVariableMutatorType.Prepend&&B.push(c.value);B.length>0&&(b.VSCODE_PATH_PREFIX=B.join(""))}}var o;(function(g){g.WindowsPwsh="windows-pwsh",g.WindowsPwshLogin="windows-pwsh-login",g.Pwsh="pwsh",g.PwshLogin="pwsh-login",g.Zsh="zsh",g.ZshLogin="zsh-login",g.Bash="bash"})(o||(o={}));const f=new Map;f.set(o.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(o.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(o.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),f.set(o.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),f.set(o.Zsh,["-i"]),f.set(o.ZshLogin,["-il"]),f.set(o.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const n=["-login","-l"],t=["-nol","-nologo"];function i(g){return typeof g=="string"?n.includes(g.toLowerCase()):g.length===1&&n.includes(g[0].toLowerCase())||g.length===2&&(n.includes(g[0].toLowerCase())||n.includes(g[1].toLowerCase()))&&(t.includes(g[0].toLowerCase())||t.includes(g[1].toLowerCase()))}function y(g){return typeof g=="string"?t.includes(g.toLowerCase()):g.length===0||g?.length===1&&t.includes(g[0].toLowerCase())}function F(g){return g==="string"&&n.includes(g.toLowerCase())||typeof g!="string"&&g.length===1&&n.includes(g[0].toLowerCase())}}),define(ue[101],he([0,1,9,14,4,2,3]),function(oe,e,v,L,S,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsShellHelper=void 0;const E=["cmd.exe","powershell.exe","pwsh.exe","bash.exe","wsl.exe","ubuntu.exe","ubuntu1804.exe","kali.exe","debian.exe","opensuse-42.exe","sles-12.exe"];let d;class l extends A.Disposable{get shellType(){return this._shellType}get shellTitle(){return this._shellTitle}get onShellNameChanged(){return this._onShellNameChanged.event}get onShellTypeChanged(){return this._onShellTypeChanged.event}constructor(p){if(super(),this._rootProcessId=p,this._shellTitle="",this._onShellNameChanged=new S.Emitter,this._onShellTypeChanged=new S.Emitter,!M.isWindows)throw new Error(`WindowsShellHelper cannot be instantiated on ${M.platform}`);this._startMonitoringShell()}async _startMonitoringShell(){this._store.isDisposed||this.checkShell()}async checkShell(){M.isWindows&&(await(0,v.timeout)(300),this.getShellName().then(p=>{const w=this.getShellType(p);w!==this._shellType&&(this._onShellTypeChanged.fire(w),this._onShellNameChanged.fire(p),this._shellType=w,this._shellTitle=p)}))}traverseTree(p){if(!p)return"";if(E.indexOf(p.name)===-1||!p.children||p.children.length===0)return p.name;let w=0;for(;w<p.children.length;w++){const r=p.children[w];if(!r.children||r.children.length===0||r.children[0].name!=="conhost.exe")break}return w>=p.children.length?p.name:this.traverseTree(p.children[w])}async getShellName(){return this._store.isDisposed?Promise.resolve(""):this._currentRequest?this._currentRequest:(d||(d=await new Promise((p,w)=>{oe(["@vscode/windows-process-tree"],p,w)})),this._currentRequest=new Promise(p=>{d.getProcessTree(this._rootProcessId,w=>{const r=this.traverseTree(w);this._currentRequest=void 0,p(r)})}),this._currentRequest)}getShellType(p){switch(p.toLowerCase()){case"cmd.exe":return"cmd";case"powershell.exe":case"pwsh.exe":return"pwsh";case"bash.exe":case"git-cmd.exe":return"gitbash";case"wsl.exe":case"ubuntu.exe":case"ubuntu1804.exe":case"kali.exe":case"debian.exe":case"opensuse-42.exe":case"sles-12.exe":return"wsl";default:return}}}e.WindowsShellHelper=l,ge([(0,L.debounce)(500)],l.prototype,"checkShell",null)}),define(ue[102],he([0,1,26,9,4,2,7,3,5,24,71,10,84,38,39,101,107,97]),function(oe,e,v,L,S,A,M,E,d,l,P,p,w,r,m,u,a,s){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalProcess=void 0;var f;(function(F){F[F.DataFlushTimeout=250]="DataFlushTimeout",F[F.MaximumShutdownTime=5e3]="MaximumShutdownTime"})(f||(f={}));var n;(function(F){F[F.KillSpawnThrottleInterval=250]="KillSpawnThrottleInterval",F[F.KillSpawnSpacingDuration=50]="KillSpawnSpacingDuration",F[F.WriteInterval=5]="WriteInterval"})(n||(n={}));const t=new Map([["bash","bash"],["csh","csh"],["fish","fish"],["ksh","ksh"],["sh","sh"],["pwsh","pwsh"],["zsh","zsh"]]);let i=class extends A.Disposable{static{o=this}static{this._lastKillOrStart=0}get exitMessage(){return this._exitMessage}get currentTitle(){return this._windowsShellHelper?.shellTitle||this._currentTitle}get shellType(){return E.isWindows?this._windowsShellHelper?.shellType:t.get(this._currentTitle)}get hasChildProcesses(){return this._childProcessMonitor?.hasChildProcesses||!1}constructor(g,b,C,k,j,B,c,_,D){super(),this.shellLaunchConfig=g,this._executableEnv=B,this._options=c,this._logService=_,this._productService=D,this.id=0,this.shouldPersist=!1,this._properties={cwd:"",initialCwd:"",fixedDimensions:{cols:void 0,rows:void 0},title:"",shellType:void 0,hasChildProcesses:!0,resolvedShellLaunchConfig:{},overrideDimensions:void 0,failedShellIntegrationActivation:!1,usedShellIntegrationInjection:void 0},this._currentTitle="",this._titleInterval=null,this._writeQueue=[],this._isPtyPaused=!1,this._unacknowledgedCharCount=0,this._onProcessData=this._register(new S.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new S.Emitter),this.onProcessReady=this._onProcessReady.event,this._onDidChangeProperty=this._register(new S.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new S.Emitter),this.onProcessExit=this._onProcessExit.event;let W;E.isWindows?W=M.basename(this.shellLaunchConfig.executable||""):W="xterm-256color",this._initialCwd=b,this._properties.initialCwd=this._initialCwd,this._properties.cwd=this._initialCwd;const I=this._options.windowsEnableConpty&&process.platform==="win32"&&(0,m.getWindowsBuildNumber)()>=18309;this._ptyOptions={name:W,cwd:b,env:j,cols:C,rows:k,useConpty:I,conptyInheritCursor:I&&!!g.initialText},E.isWindows&&(I&&C===0&&k===0&&this.shellLaunchConfig.executable?.endsWith("Git\\bin\\bash.exe")&&(this._delayedResizer=new y,this._register(this._delayedResizer.onTrigger(q=>{this._delayedResizer?.dispose(),this._delayedResizer=void 0,q.cols&&q.rows&&this.resize(q.cols,q.rows)}))),this.onProcessReady(q=>{this._windowsShellHelper=this._register(new u.WindowsShellHelper(q.pid)),this._register(this._windowsShellHelper.onShellTypeChanged(ee=>this._onDidChangeProperty.fire({type:"shellType",value:ee}))),this._register(this._windowsShellHelper.onShellNameChanged(ee=>this._onDidChangeProperty.fire({type:"title",value:ee})))})),this._register((0,A.toDisposable)(()=>{this._titleInterval&&(clearInterval(this._titleInterval),this._titleInterval=null)}))}async start(){const b=(await Promise.all([this._validateCwd(),this._validateExecutable()])).find(k=>k!==void 0);if(b)return b;let C;if(this._options.shellIntegration.enabled)if(C=(0,m.getShellIntegrationInjection)(this.shellLaunchConfig,this._options,this._ptyOptions.env,this._logService,this._productService),C){if(this._onDidChangeProperty.fire({type:"usedShellIntegrationInjection",value:!0}),C.envMixin)for(const[k,j]of Object.entries(C.envMixin))this._ptyOptions.env||={},this._ptyOptions.env[k]=j;if(C.filesToCopy)for(const k of C.filesToCopy){await l.Promises.mkdir(M.dirname(k.dest),{recursive:!0});try{await l.Promises.copyFile(k.source,k.dest)}catch{}}}else this._onDidChangeProperty.fire({type:"failedShellIntegrationActivation",value:!0});try{return await this.setupPtyProcess(this.shellLaunchConfig,this._ptyOptions,C),C?.newArgs?{injectedArgs:C.newArgs}:void 0}catch(k){return this._logService.trace("node-pty.node-pty.IPty#spawn native exception",k),{message:`A native exception occurred during launch (${k.message})`}}}async _validateCwd(){try{if(!(await l.Promises.stat(this._initialCwd)).isDirectory())return{message:(0,P.localize)(0,null,this._initialCwd.toString())}}catch(g){if(g?.code==="ENOENT")return{message:(0,P.localize)(1,null,this._initialCwd.toString())}}this._onDidChangeProperty.fire({type:"initialCwd",value:this._initialCwd})}async _validateExecutable(){const g=this.shellLaunchConfig;if(!g.executable)throw new Error("IShellLaunchConfig.executable not set");const b=g.cwd instanceof d.URI?g.cwd.path:g.cwd,C=g.env&&g.env.PATH?g.env.PATH.split(M.delimiter):void 0,k=await(0,m.findExecutable)(g.executable,b,C,this._executableEnv);if(!k)return{message:(0,P.localize)(2,null,g.executable)};try{const j=await l.Promises.stat(k);if(!j.isFile()&&!j.isSymbolicLink())return{message:(0,P.localize)(3,null,g.executable)};g.executable=k}catch(j){if(j?.code!=="EACCES")throw j}}async setupPtyProcess(g,b,C){const k=C?.newArgs||g.args||[];await this._throttleKillSpawn(),this._logService.trace("node-pty.IPty#spawn",g.executable,k,b);const j=(0,a.spawn)(g.executable,k,b);this._ptyProcess=j,this._childProcessMonitor=this._register(new r.ChildProcessMonitor(j.pid,this._logService)),this._childProcessMonitor.onDidChangeHasChildProcesses(B=>this._onDidChangeProperty.fire({type:"hasChildProcesses",value:B})),this._processStartupComplete=new Promise(B=>{this.onProcessReady(()=>B())}),j.onData(B=>{this._unacknowledgedCharCount+=B.length,!this._isPtyPaused&&this._unacknowledgedCharCount>1e5&&(this._logService.trace(`Flow control: Pause (${this._unacknowledgedCharCount} > 100000)`),this._isPtyPaused=!0,j.pause()),this._logService.trace("node-pty.IPty#onData",B),this._onProcessData.fire(B),this._closeTimeout&&this._queueProcessExit(),this._windowsShellHelper?.checkShell(),this._childProcessMonitor?.handleOutput()}),j.onExit(B=>{this._exitCode=B.exitCode,this._queueProcessExit()}),this._sendProcessId(j.pid),this._setupTitlePolling(j)}_setupTitlePolling(g){setTimeout(()=>this._sendProcessTitle(g)),E.isWindows||(this._titleInterval=setInterval(()=>{this._currentTitle!==g.process&&this._sendProcessTitle(g)},200))}_queueProcessExit(){this._logService.getLevel()===p.LogLevel.Trace&&this._logService.trace("TerminalProcess#_queueProcessExit",new Error().stack?.replace(/^Error/,"")),this._closeTimeout&&clearTimeout(this._closeTimeout),this._closeTimeout=setTimeout(()=>{this._closeTimeout=void 0,this._kill()},250)}async _kill(){if(await this._processStartupComplete,!this._store.isDisposed){try{this._ptyProcess&&(await this._throttleKillSpawn(),this._logService.trace("node-pty.IPty#kill"),this._ptyProcess.kill())}catch{}this._onProcessExit.fire(this._exitCode||0),this.dispose()}}async _throttleKillSpawn(){if(!(!E.isWindows||!("useConpty"in this._ptyOptions)||!this._ptyOptions.useConpty)){for(;Date.now()-o._lastKillOrStart<250;)this._logService.trace("Throttling kill/spawn call"),await(0,L.timeout)(250-(Date.now()-o._lastKillOrStart)+50);o._lastKillOrStart=Date.now()}}_sendProcessId(g){this._onProcessReady.fire({pid:g,cwd:this._initialCwd,windowsPty:this.getWindowsPty()})}_sendProcessTitle(g){if(this._store.isDisposed)return;this._currentTitle=g.process,this._onDidChangeProperty.fire({type:"title",value:this._currentTitle});const b=this.currentTitle.replace(/ \(figterm\)$/g,"");this._onDidChangeProperty.fire({type:"shellType",value:t.get(b)})}shutdown(g){this._logService.getLevel()===p.LogLevel.Trace&&this._logService.trace("TerminalProcess#shutdown",new Error().stack?.replace(/^Error/,"")),g&&!E.isWindows?this._kill():!this._closeTimeout&&!this._store.isDisposed&&(this._queueProcessExit(),setTimeout(()=>{this._closeTimeout&&!this._store.isDisposed&&(this._closeTimeout=void 0,this._kill())},5e3))}input(g,b=!1){this._store.isDisposed||!this._ptyProcess||(this._writeQueue.push(...(0,s.chunkInput)(g).map(C=>({isBinary:b,data:C}))),this._startWrite())}async processBinary(g){this.input(g,!0)}async refreshProperty(g){switch(g){case"cwd":{const b=await this.getCwd();return b!==this._properties.cwd&&(this._properties.cwd=b,this._onDidChangeProperty.fire({type:"cwd",value:this._properties.cwd})),b}case"initialCwd":{const b=await this.getInitialCwd();return b!==this._properties.initialCwd&&(this._properties.initialCwd=b,this._onDidChangeProperty.fire({type:"initialCwd",value:this._properties.initialCwd})),b}case"title":return this.currentTitle;default:return this.shellType}}async updateProperty(g,b){g==="fixedDimensions"&&(this._properties.fixedDimensions=b)}_startWrite(){if(!(this._writeTimeout!==void 0||this._writeQueue.length===0)){if(this._doWrite(),this._writeQueue.length===0){this._writeTimeout=void 0;return}this._writeTimeout=setTimeout(()=>{this._writeTimeout=void 0,this._startWrite()},5)}}_doWrite(){const g=this._writeQueue.shift();this._logService.trace("node-pty.IPty#write",g.data),g.isBinary?this._ptyProcess.write(Buffer.from(g.data,"binary")):this._ptyProcess.write(g.data),this._childProcessMonitor?.handleInput()}resize(g,b){if(!this._store.isDisposed&&!(typeof g!="number"||typeof b!="number"||isNaN(g)||isNaN(b))&&this._ptyProcess){if(g=Math.max(g,1),b=Math.max(b,1),this._delayedResizer){this._delayedResizer.cols=g,this._delayedResizer.rows=b;return}this._logService.trace("node-pty.IPty#resize",g,b);try{this._ptyProcess.resize(g,b)}catch(C){if(this._logService.trace("node-pty.IPty#resize exception "+C.message),this._exitCode!==void 0&&C.message!=="ioctl(2) failed, EBADF"&&C.message!=="Cannot resize a pty that has already exited")throw C}}}clearBuffer(){this._ptyProcess?.clear()}acknowledgeDataEvent(g){this._unacknowledgedCharCount=Math.max(this._unacknowledgedCharCount-g,0),this._logService.trace(`Flow control: Ack ${g} chars (unacknowledged: ${this._unacknowledgedCharCount})`),this._isPtyPaused&&this._unacknowledgedCharCount<5e3&&(this._logService.trace(`Flow control: Resume (${this._unacknowledgedCharCount} < 5000)`),this._ptyProcess?.resume(),this._isPtyPaused=!1)}clearUnacknowledgedChars(){this._unacknowledgedCharCount=0,this._logService.trace("Flow control: Cleared all unacknowledged chars, forcing resume"),this._isPtyPaused&&(this._ptyProcess?.resume(),this._isPtyPaused=!1)}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve(this._initialCwd)}async getCwd(){if(E.isMacintosh)return new Promise(g=>{if(!this._ptyProcess){g(this._initialCwd);return}this._logService.trace("node-pty.IPty#pid"),(0,v.exec)("lsof -OPln -p "+this._ptyProcess.pid+" | grep cwd",{env:{...process.env,LANG:"en_US.UTF-8"}},(b,C,k)=>{!b&&C!==""?g(C.substring(C.indexOf("/"),C.length-1)):(this._logService.error("lsof did not run successfully, it may not be on the $PATH?",b,C,k),g(this._initialCwd))})});if(E.isLinux){if(!this._ptyProcess)return this._initialCwd;this._logService.trace("node-pty.IPty#pid");try{return await l.Promises.readlink(`/proc/${this._ptyProcess.pid}/cwd`)}catch{return this._initialCwd}}return this._initialCwd}getWindowsPty(){return E.isWindows?{backend:"useConpty"in this._ptyOptions&&this._ptyOptions.useConpty?"conpty":"winpty",buildNumber:(0,m.getWindowsBuildNumber)()}:void 0}};e.TerminalProcess=i,e.TerminalProcess=i=o=ge([Te(7,p.ILogService),Te(8,w.IProductService)],i);class y extends A.Disposable{get onTrigger(){return this._onTrigger.event}constructor(){super(),this._onTrigger=this._register(new S.Emitter),this._timeout=setTimeout(()=>{this._onTrigger.fire({rows:this.rows,cols:this.cols})},1e3),this._register((0,A.toDisposable)(()=>clearTimeout(this._timeout)))}}}),define(ue[103],he([0,1,26,9,4,2,3,63,10,94,28,96,37,108,39,102,70,38,95,6,99,98,76,14,109]),function(oe,e,v,L,S,A,M,E,d,l,P,p,w,r,m,u,a,s,o,f,n,t,i,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyService=e.traceRpc=void 0;function g(W,I,q){if(typeof q.value!="function")throw new Error("not supported");const ee="value",ne=q.value;q[ee]=async function(...Q){this.traceRpcArgs.logService.getLevel()===d.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Request] PtyService#${ne.name}(${Q.map(le=>JSON.stringify(le)).join(", ")})`),this.traceRpcArgs.simulatedLatency&&await(0,L.timeout)(this.traceRpcArgs.simulatedLatency);let re;try{re=await ne.apply(this,Q)}catch(le){throw this.traceRpcArgs.logService.error(`[RPC Response] PtyService#${ne.name}`,le),le}return this.traceRpcArgs.logService.getLevel()===d.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Response] PtyService#${ne.name}`,re),re}}e.traceRpc=g;let b,C;class k extends A.Disposable{_traceEvent(I,q){return q(ee=>{this._logService.getLevel()===d.LogLevel.Trace&&this._logService.trace(`[RPC Event] PtyService#${I}.fire(${JSON.stringify(ee)})`)}),q}get traceRpcArgs(){return{logService:this._logService,simulatedLatency:this._simulatedLatency}}constructor(I,q,ee,ne){super(),this._logService=I,this._productService=q,this._reconnectConstants=ee,this._simulatedLatency=ne,this._ptys=new Map,this._workspaceLayoutInfos=new Map,this._revivedPtyIdMap=new Map,this._autoReplies=new Map,this._lastPtyId=0,this._onHeartbeat=this._register(new S.Emitter),this.onHeartbeat=this._traceEvent("_onHeartbeat",this._onHeartbeat.event),this._onProcessData=this._register(new S.Emitter),this.onProcessData=this._traceEvent("_onProcessData",this._onProcessData.event),this._onProcessReplay=this._register(new S.Emitter),this.onProcessReplay=this._traceEvent("_onProcessReplay",this._onProcessReplay.event),this._onProcessReady=this._register(new S.Emitter),this.onProcessReady=this._traceEvent("_onProcessReady",this._onProcessReady.event),this._onProcessExit=this._register(new S.Emitter),this.onProcessExit=this._traceEvent("_onProcessExit",this._onProcessExit.event),this._onProcessOrphanQuestion=this._register(new S.Emitter),this.onProcessOrphanQuestion=this._traceEvent("_onProcessOrphanQuestion",this._onProcessOrphanQuestion.event),this._onDidRequestDetach=this._register(new S.Emitter),this.onDidRequestDetach=this._traceEvent("_onDidRequestDetach",this._onDidRequestDetach.event),this._onDidChangeProperty=this._register(new S.Emitter),this.onDidChangeProperty=this._traceEvent("_onDidChangeProperty",this._onDidChangeProperty.event),this._register((0,A.toDisposable)(()=>{for(const Q of this._ptys.values())Q.shutdown(!0);this._ptys.clear()})),this._detachInstanceRequestStore=this._register(new l.RequestStore(void 0,this._logService)),this._detachInstanceRequestStore.onCreateRequest(this._onDidRequestDetach.fire,this._onDidRequestDetach)}async refreshIgnoreProcessNames(I){s.ignoreProcessNames.length=0,s.ignoreProcessNames.push(...I)}async requestDetachInstance(I,q){return this._detachInstanceRequestStore.createRequest({workspaceId:I,instanceId:q})}async acceptDetachInstanceReply(I,q){let ee;const ne=this._ptys.get(q);ne&&(ee=await this._buildProcessDetails(q,ne)),this._detachInstanceRequestStore.acceptReply(I,ee)}async freePortKillProcess(I){const ee=(await new Promise((ne,Q)=>{(0,v.exec)(M.isWindows?`netstat -ano | findstr "${I}"`:`lsof -nP -iTCP -sTCP:LISTEN | grep ${I}`,{},(re,le)=>{if(re)return Q("Problem occurred when listing active processes");ne(le)})})).split(/\r?\n/).filter(ne=>!!ne.trim());if(ee.length>=1){const ne=/\s+(\d+)(?:\s+|$)/,Q=ee[0].match(ne)?.[1];if(Q)try{process.kill(Number.parseInt(Q))}catch{}else throw new Error(`Processes for port ${I} were not found`);return{port:I,processId:Q}}throw new Error(`Could not kill process with port ${I}`)}async serializeTerminalState(I){const q=[];for(const[ne,Q]of this._ptys.entries())Q.hasWrittenData&&I.indexOf(ne)!==-1&&q.push(L.Promises.withAsyncBody(async re=>{re({id:ne,shellLaunchConfig:Q.shellLaunchConfig,processDetails:await this._buildProcessDetails(ne,Q),processLaunchConfig:Q.processLaunchOptions,unicodeVersion:Q.unicodeVersion,replayEvent:await Q.serializeNormalBuffer(),timestamp:Date.now()})}));const ee={version:1,state:await Promise.all(q)};return JSON.stringify(ee)}async reviveTerminalProcesses(I,q,ee){const ne=[];for(const Q of q)ne.push(this._reviveTerminalProcess(I,Q));await Promise.all(ne)}async _reviveTerminalProcess(I,q){const ee=(0,a.localize)(0,null),ne=await this.createProcess({...q.shellLaunchConfig,cwd:q.processDetails.cwd,color:q.processDetails.color,icon:q.processDetails.icon,name:q.processDetails.titleSource===P.TitleEventSource.Api?q.processDetails.title:void 0,initialText:q.replayEvent.events[0].data+(0,t.formatMessageForTerminal)(ee,{loudFormatting:!0})},q.processDetails.cwd,q.replayEvent.events[0].cols,q.replayEvent.events[0].rows,q.unicodeVersion,q.processLaunchConfig.env,q.processLaunchConfig.executableEnv,q.processLaunchConfig.options,!0,q.processDetails.workspaceId,q.processDetails.workspaceName,!0,q.replayEvent.events[0].data),Q=this._getRevivingProcessId(I,q.id);this._revivedPtyIdMap.set(Q,{newId:ne,state:q}),this._logService.info(`Revived process, old id ${Q} -> new id ${ne}`)}async shutdownAll(){this.dispose()}async createProcess(I,q,ee,ne,Q,re,le,de,G,$,X,te,H){if(I.attachPersistentProcess)throw new Error("Attempt to create a process when attach object was provided");const x=++this._lastPtyId,me=new u.TerminalProcess(I,q,ee,ne,re,le,de,this._logService,this._productService),Z={env:re,executableEnv:le,options:de},h=new B(x,me,$,X,G,ee,ne,Z,Q,this._reconnectConstants,this._logService,te&&typeof I.initialText=="string"?I.initialText:void 0,H,I.icon,I.color,I.name,I.fixedDimensions);return me.onProcessExit(U=>{h.dispose(),this._ptys.delete(x),this._onProcessExit.fire({id:x,event:U})}),h.onProcessData(U=>this._onProcessData.fire({id:x,event:U})),h.onProcessReplay(U=>this._onProcessReplay.fire({id:x,event:U})),h.onProcessReady(U=>this._onProcessReady.fire({id:x,event:U})),h.onProcessOrphanQuestion(()=>this._onProcessOrphanQuestion.fire({id:x})),h.onDidChangeProperty(U=>this._onDidChangeProperty.fire({id:x,property:U})),h.onPersistentProcessReady(()=>{for(const U of this._autoReplies.entries())h.installAutoReply(U[0],U[1])}),this._ptys.set(x,h),x}async attachToProcess(I){try{await this._throwIfNoPty(I).attach(),this._logService.info(`Persistent process reconnection "${I}"`)}catch(q){throw this._logService.warn(`Persistent process reconnection "${I}" failed`,q.message),q}}async updateTitle(I,q,ee){this._throwIfNoPty(I).setTitle(q,ee)}async updateIcon(I,q,ee,ne){this._throwIfNoPty(I).setIcon(q,ee,ne)}async clearBuffer(I){this._throwIfNoPty(I).clearBuffer()}async refreshProperty(I,q){return this._throwIfNoPty(I).refreshProperty(q)}async updateProperty(I,q,ee){return this._throwIfNoPty(I).updateProperty(q,ee)}async detachFromProcess(I,q){return this._throwIfNoPty(I).detach(q)}async reduceConnectionGraceTime(){for(const I of this._ptys.values())I.reduceGraceTime()}async listProcesses(){const I=Array.from(this._ptys.entries()).filter(([ne,Q])=>Q.shouldPersistTerminal);this._logService.info(`Listing ${I.length} persistent terminals, ${this._ptys.size} total terminals`);const q=I.map(async([ne,Q])=>this._buildProcessDetails(ne,Q));return(await Promise.all(q)).filter(ne=>ne.isOrphan)}async getPerformanceMarks(){return F.getMarks()}async start(I){const q=this._ptys.get(I);return q?q.start():{message:`Could not find pty with id "${I}"`}}async shutdown(I,q){return this._ptys.get(I)?.shutdown(q)}async input(I,q){return this._throwIfNoPty(I).input(q)}async processBinary(I,q){return this._throwIfNoPty(I).writeBinary(q)}async resize(I,q,ee){return this._throwIfNoPty(I).resize(q,ee)}async getInitialCwd(I){return this._throwIfNoPty(I).getInitialCwd()}async getCwd(I){return this._throwIfNoPty(I).getCwd()}async acknowledgeDataEvent(I,q){return this._throwIfNoPty(I).acknowledgeDataEvent(q)}async setUnicodeVersion(I,q){return this._throwIfNoPty(I).setUnicodeVersion(q)}async getLatency(){return[]}async orphanQuestionReply(I){return this._throwIfNoPty(I).orphanQuestionReply()}async installAutoReply(I,q){this._autoReplies.set(I,q);for(const ee of this._ptys.values())ee.installAutoReply(I,q)}async uninstallAllAutoReplies(){for(const I of this._autoReplies.keys())for(const q of this._ptys.values())q.uninstallAutoReply(I)}async uninstallAutoReply(I){for(const q of this._ptys.values())q.uninstallAutoReply(I)}async getDefaultSystemShell(I=M.OS){return(0,E.getSystemShell)(I,process.env)}async getEnvironment(){return{...process.env}}async getWslPath(I,q){if(q==="win-to-unix"){if(!M.isWindows)return I;if((0,m.getWindowsBuildNumber)()<17063)return I.replace(/\\/g,"/");const ee=this._getWSLExecutablePath();return ee?new Promise(ne=>{(0,v.execFile)(ee,["-e","wslpath",I],{},(re,le,de)=>{ne(re?I:(0,w.escapeNonWindowsPath)(le.trim()))}).stdin.end()}):I}if(q==="unix-to-win"&&M.isWindows){if((0,m.getWindowsBuildNumber)()<17063)return I;const ee=this._getWSLExecutablePath();return ee?new Promise(ne=>{(0,v.execFile)(ee,["-e","wslpath","-w",I],{},(re,le,de)=>{ne(re?I:le.trim())}).stdin.end()}):I}return I}_getWSLExecutablePath(){const I=(0,m.getWindowsBuildNumber)()>=16299,q=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),ee=process.env.SystemRoot;if(ee)return(0,i.join)(ee,q?"Sysnative":"System32",I?"wsl.exe":"bash.exe")}async getRevivedPtyNewId(I,q){try{return this._revivedPtyIdMap.get(this._getRevivingProcessId(I,q))?.newId}catch(ee){this._logService.warn(`Couldn't find terminal ID ${I}-${q}`,ee.message)}}async setTerminalLayoutInfo(I){this._workspaceLayoutInfos.set(I.workspaceId,I)}async getTerminalLayoutInfo(I){F.mark("code/willGetTerminalLayoutInfo");const q=this._workspaceLayoutInfos.get(I.workspaceId);if(q){const ee=new Set,Q=(await Promise.all(q.tabs.map(async re=>this._expandTerminalTab(I.workspaceId,re,ee)))).filter(re=>re.terminals.length>0);return F.mark("code/didGetTerminalLayoutInfo"),{tabs:Q}}F.mark("code/didGetTerminalLayoutInfo")}async _expandTerminalTab(I,q,ee){const Q=(await Promise.all(q.terminals.map(re=>this._expandTerminalInstance(I,re,ee)))).filter(re=>re.terminal!==null);return{isActive:q.isActive,activePersistentProcessId:q.activePersistentProcessId,terminals:Q}}async _expandTerminalInstance(I,q,ee){try{const ne=this._getRevivingProcessId(I,q.terminal),Q=this._revivedPtyIdMap.get(ne)?.newId;this._logService.info(`Expanding terminal instance, old id ${ne} -> new id ${Q}`),this._revivedPtyIdMap.delete(ne);const re=Q??q.terminal;if(ee.has(re))throw new Error(`Terminal ${re} has already been expanded`);ee.add(re);const le=this._throwIfNoPty(re);return{terminal:{...le&&await this._buildProcessDetails(q.terminal,le,Q!==void 0),id:re},relativeSize:q.relativeSize}}catch(ne){return this._logService.warn("Couldn't get layout info, a terminal was probably disconnected",ne.message),this._logService.debug("Reattach to wrong terminal debug info - layout info by id",q),this._logService.debug("Reattach to wrong terminal debug info - _revivePtyIdMap",Array.from(this._revivedPtyIdMap.values())),this._logService.debug("Reattach to wrong terminal debug info - _ptys ids",Array.from(this._ptys.keys())),{terminal:null,relativeSize:q.relativeSize}}}_getRevivingProcessId(I,q){return`${I}-${q}`}async _buildProcessDetails(I,q,ee=!1){F.mark(`code/willBuildProcessDetails/${I}`);const[ne,Q]=await Promise.all([q.getCwd(),ee?!0:q.isOrphaned()]),re={id:I,title:q.title,titleSource:q.titleSource,pid:q.pid,workspaceId:q.workspaceId,workspaceName:q.workspaceName,cwd:ne,isOrphan:Q,icon:q.icon,color:q.color,fixedDimensions:q.fixedDimensions,environmentVariableCollections:q.processLaunchOptions.options.environmentVariableCollections,reconnectionProperties:q.shellLaunchConfig.reconnectionProperties,waitOnExit:q.shellLaunchConfig.waitOnExit,hideFromUser:q.shellLaunchConfig.hideFromUser,isFeatureTerminal:q.shellLaunchConfig.isFeatureTerminal,type:q.shellLaunchConfig.type,hasChildProcesses:q.hasChildProcesses,shellIntegrationNonce:q.processLaunchOptions.options.shellIntegration.nonce};return F.mark(`code/didBuildProcessDetails/${I}`),re}_throwIfNoPty(I){const q=this._ptys.get(I);if(!q)throw new f.ErrorNoTelemetry("Could not find pty on pty host");return q}}e.PtyService=k,ge([y.memoize],k.prototype,"traceRpcArgs",null),ge([g],k.prototype,"refreshIgnoreProcessNames",null),ge([g],k.prototype,"requestDetachInstance",null),ge([g],k.prototype,"acceptDetachInstanceReply",null),ge([g],k.prototype,"freePortKillProcess",null),ge([g],k.prototype,"serializeTerminalState",null),ge([g],k.prototype,"reviveTerminalProcesses",null),ge([g],k.prototype,"shutdownAll",null),ge([g],k.prototype,"createProcess",null),ge([g],k.prototype,"attachToProcess",null),ge([g],k.prototype,"updateTitle",null),ge([g],k.prototype,"updateIcon",null),ge([g],k.prototype,"clearBuffer",null),ge([g],k.prototype,"refreshProperty",null),ge([g],k.prototype,"updateProperty",null),ge([g],k.prototype,"detachFromProcess",null),ge([g],k.prototype,"reduceConnectionGraceTime",null),ge([g],k.prototype,"listProcesses",null),ge([g],k.prototype,"getPerformanceMarks",null),ge([g],k.prototype,"start",null),ge([g],k.prototype,"shutdown",null),ge([g],k.prototype,"input",null),ge([g],k.prototype,"processBinary",null),ge([g],k.prototype,"resize",null),ge([g],k.prototype,"getInitialCwd",null),ge([g],k.prototype,"getCwd",null),ge([g],k.prototype,"acknowledgeDataEvent",null),ge([g],k.prototype,"setUnicodeVersion",null),ge([g],k.prototype,"getLatency",null),ge([g],k.prototype,"orphanQuestionReply",null),ge([g],k.prototype,"installAutoReply",null),ge([g],k.prototype,"uninstallAllAutoReplies",null),ge([g],k.prototype,"uninstallAutoReply",null),ge([g],k.prototype,"getDefaultSystemShell",null),ge([g],k.prototype,"getEnvironment",null),ge([g],k.prototype,"getWslPath",null),ge([g],k.prototype,"getRevivedPtyNewId",null),ge([g],k.prototype,"setTerminalLayoutInfo",null),ge([g],k.prototype,"getTerminalLayoutInfo",null);var j;(function(W){W.None="None",W.ReplayOnly="ReplayOnly",W.Session="Session"})(j||(j={}));class B extends A.Disposable{get pid(){return this._pid}get shellLaunchConfig(){return this._terminalProcess.shellLaunchConfig}get hasWrittenData(){return this._interactionState.value!=="None"}get title(){return this._title||this._terminalProcess.currentTitle}get titleSource(){return this._titleSource}get icon(){return this._icon}get color(){return this._color}get fixedDimensions(){return this._fixedDimensions}get hasChildProcesses(){return this._terminalProcess.hasChildProcesses}setTitle(I,q){q===P.TitleEventSource.Api&&(this._interactionState.setValue("Session","setTitle"),this._serializer.freeRawReviveBuffer()),this._title=I,this._titleSource=q}setIcon(I,q,ee){(!this._icon||"id"in q&&"id"in this._icon&&q.id!==this._icon.id||!this.color||ee!==this._color)&&(this._serializer.freeRawReviveBuffer(),I&&this._interactionState.setValue("Session","setIcon")),this._icon=q,this._color=ee}_setFixedDimensions(I){this._fixedDimensions=I}constructor(I,q,ee,ne,Q,re,le,de,G,$,X,te,H,x,me,Z,h){super(),this._persistentProcessId=I,this._terminalProcess=q,this.workspaceId=ee,this.workspaceName=ne,this.shouldPersistTerminal=Q,this.processLaunchOptions=de,this.unicodeVersion=G,this._logService=X,this._icon=x,this._color=me,this._autoReplies=new Map,this._pendingCommands=new Map,this._isStarted=!1,this._orphanRequestQueue=new L.Queue,this._onProcessReplay=this._register(new S.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessReady=this._register(new S.Emitter),this.onProcessReady=this._onProcessReady.event,this._onPersistentProcessReady=this._register(new S.Emitter),this.onPersistentProcessReady=this._onPersistentProcessReady.event,this._onProcessData=this._register(new S.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessOrphanQuestion=this._register(new S.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidChangeProperty=this._register(new S.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._inReplay=!1,this._pid=-1,this._cwd="",this._titleSource=P.TitleEventSource.Process,this._interactionState=new c(`Persistent process "${this._persistentProcessId}" interaction state`,"None",this._logService),this._wasRevived=te!==void 0,this._serializer=new _(re,le,$.scrollback,G,te,de.options.shellIntegration.nonce,Q?H:void 0,this._logService),Z&&this.setTitle(Z,P.TitleEventSource.Api),this._fixedDimensions=h,this._orphanQuestionBarrier=null,this._orphanQuestionReplyTime=0,this._disconnectRunner1=this._register(new L.ProcessTimeRunOnceScheduler(()=>{this._logService.info(`Persistent process "${this._persistentProcessId}": The reconnection grace time of ${D($.graceTime)} has expired, shutting down pid "${this._pid}"`),this.shutdown(!0)},$.graceTime)),this._disconnectRunner2=this._register(new L.ProcessTimeRunOnceScheduler(()=>{this._logService.info(`Persistent process "${this._persistentProcessId}": The short reconnection grace time of ${D($.shortGraceTime)} has expired, shutting down pid ${this._pid}`),this.shutdown(!0)},$.shortGraceTime)),this._register(this._terminalProcess.onProcessExit(()=>this._bufferer.stopBuffering(this._persistentProcessId))),this._register(this._terminalProcess.onProcessReady(U=>{this._pid=U.pid,this._cwd=U.cwd,this._onProcessReady.fire(U)})),this._register(this._terminalProcess.onDidChangeProperty(U=>{this._onDidChangeProperty.fire(U)})),this._bufferer=new p.TerminalDataBufferer((U,se)=>this._onProcessData.fire(se)),this._register(this._bufferer.startBuffering(this._persistentProcessId,this._terminalProcess.onProcessData)),this._register(this.onProcessData(U=>this._serializer.handleData(U))),this._register((0,A.toDisposable)(()=>{for(const U of this._autoReplies.values())U.dispose();this._autoReplies.clear()}))}async attach(){!this._disconnectRunner1.isScheduled()&&!this._disconnectRunner2.isScheduled()&&this._logService.warn(`Persistent process "${this._persistentProcessId}": Process had no disconnect runners but was an orphan`),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel()}async detach(I){this.shouldPersistTerminal&&(this._interactionState.value!=="None"||I)?this._disconnectRunner1.schedule():this.shutdown(!0)}serializeNormalBuffer(){return this._serializer.generateReplayEvent(!0,this._interactionState.value!=="Session")}async refreshProperty(I){return this._terminalProcess.refreshProperty(I)}async updateProperty(I,q){if(I==="fixedDimensions")return this._setFixedDimensions(q)}async start(){if(!this._isStarted){const I=await this._terminalProcess.start();return I&&"message"in I||(this._isStarted=!0,this._wasRevived?this.triggerReplay():this._onPersistentProcessReady.fire()),I}this._onProcessReady.fire({pid:this._pid,cwd:this._cwd,windowsPty:this._terminalProcess.getWindowsPty()}),this._onDidChangeProperty.fire({type:"title",value:this._terminalProcess.currentTitle}),this._onDidChangeProperty.fire({type:"shellType",value:this._terminalProcess.shellType}),this.triggerReplay()}shutdown(I){return this._terminalProcess.shutdown(I)}input(I){if(this._interactionState.setValue("Session","input"),this._serializer.freeRawReviveBuffer(),!this._inReplay){for(const q of this._autoReplies.values())q.handleInput();return this._terminalProcess.input(I)}}writeBinary(I){return this._terminalProcess.processBinary(I)}resize(I,q){if(!this._inReplay){this._serializer.handleResize(I,q),this._bufferer.flushBuffer(this._persistentProcessId);for(const ee of this._autoReplies.values())ee.handleResize();return this._terminalProcess.resize(I,q)}}async clearBuffer(){this._serializer.clearBuffer(),this._terminalProcess.clearBuffer()}setUnicodeVersion(I){this.unicodeVersion=I,this._serializer.setUnicodeVersion?.(I)}acknowledgeDataEvent(I){if(!this._inReplay)return this._terminalProcess.acknowledgeDataEvent(I)}getInitialCwd(){return this._terminalProcess.getInitialCwd()}getCwd(){return this._terminalProcess.getCwd()}async triggerReplay(){this._interactionState.value==="None"&&this._interactionState.setValue("ReplayOnly","triggerReplay");const I=await this._serializer.generateReplayEvent();let q=0;for(const ee of I.events)q+=ee.data.length;this._logService.info(`Persistent process "${this._persistentProcessId}": Replaying ${q} chars and ${I.events.length} size events`),this._onProcessReplay.fire(I),this._terminalProcess.clearUnacknowledgedChars(),this._onPersistentProcessReady.fire()}installAutoReply(I,q){this._autoReplies.get(I)?.dispose(),this._autoReplies.set(I,new o.TerminalAutoResponder(this._terminalProcess,I,q,this._logService))}uninstallAutoReply(I){this._autoReplies.get(I)?.dispose(),this._autoReplies.delete(I)}sendCommandResult(I,q,ee){this._pendingCommands.get(I)&&this._pendingCommands.delete(I)}orphanQuestionReply(){if(this._orphanQuestionReplyTime=Date.now(),this._orphanQuestionBarrier){const I=this._orphanQuestionBarrier;this._orphanQuestionBarrier=null,I.open()}}reduceGraceTime(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&this._disconnectRunner2.schedule()}async isOrphaned(){return await this._orphanRequestQueue.queue(async()=>this._isOrphaned())}async _isOrphaned(){return this._disconnectRunner1.isScheduled()||this._disconnectRunner2.isScheduled()?!0:(this._orphanQuestionBarrier||(this._orphanQuestionBarrier=new L.AutoOpenBarrier(4e3),this._orphanQuestionReplyTime=0,this._onProcessOrphanQuestion.fire()),await this._orphanQuestionBarrier.wait(),Date.now()-this._orphanQuestionReplyTime>500)}}class c{get value(){return this._value}setValue(I,q){this._value!==I&&(this._value=I,this._log(q))}constructor(I,q,ee){this._name=I,this._value=q,this._logService=ee,this._log("initialized")}_log(I){this._logService.debug(`MutationLogger "${this._name}" set to "${this._value}", reason: ${I}`)}}class _{constructor(I,q,ee,ne,Q,re,le,de){this._rawReviveBuffer=le,this._xterm=new r.Terminal({cols:I,rows:q,scrollback:ee,allowProposedApi:!0}),Q&&this._xterm.writeln(Q),this.setUnicodeVersion(ne),this._shellIntegrationAddon=new n.ShellIntegrationAddon(re,!0,void 0,de),this._xterm.loadAddon(this._shellIntegrationAddon)}freeRawReviveBuffer(){this._rawReviveBuffer=void 0}handleData(I){this._xterm.write(I)}handleResize(I,q){this._xterm.resize(I,q)}clearBuffer(){this._xterm.clear()}async generateReplayEvent(I,q){const ee=new(await this._getSerializeConstructor());this._xterm.loadAddon(ee);const ne={scrollback:this._xterm.options.scrollback};I&&(ne.excludeAltBuffer=!0,ne.excludeModes=!0);let Q;return q&&this._rawReviveBuffer?Q=this._rawReviveBuffer:Q=ee.serialize(ne),{events:[{cols:this._xterm.cols,rows:this._xterm.rows,data:Q}],commands:this._shellIntegrationAddon.serialize()}}async setUnicodeVersion(I){this._xterm.unicode.activeVersion!==I&&(I==="11"?(this._unicodeAddon=new(await this._getUnicode11Constructor()),this._xterm.loadAddon(this._unicodeAddon)):(this._unicodeAddon?.dispose(),this._unicodeAddon=void 0),this._xterm.unicode.activeVersion=I)}async _getUnicode11Constructor(){return C||(C=(await new Promise((I,q)=>{oe(["@xterm/addon-unicode11"],I,q)})).Unicode11Addon),C}async _getSerializeConstructor(){return b||(b=(await new Promise((I,q)=>{oe(["@xterm/addon-serialize"],I,q)})).SerializeAddon),b}}function D(W){let I=0,q=0,ee=0;W>=1e3&&(ee=Math.floor(W/1e3),W-=ee*1e3),ee>=60&&(q=Math.floor(ee/60),ee-=q*60),q>=60&&(I=Math.floor(q/60),q-=I*60);const ne=I?`${I}h`:"",Q=q?`${q}m`:"",re=ee?`${ee}s`:"",le=W?`${W}ms`:"";return`${ne}${Q}${re}${le}`}}),define(ue[110],he([0,1,60,27,64,65,12,74,77,10,79,80,82,83,28,100,103,31,9,2]),function(oe,e,v,L,S,A,M,E,d,l,P,p,w,r,m,u,a,s,o,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),n();async function n(){const t=parseInt(process.env.VSCODE_STARTUP_DELAY??"0"),i=parseInt(process.env.VSCODE_LATENCY??"0"),y={graceTime:parseInt(process.env.VSCODE_RECONNECT_GRACE_TIME||"0"),shortGraceTime:parseInt(process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME||"0"),scrollback:parseInt(process.env.VSCODE_RECONNECT_SCROLLBACK||"100")};delete process.env.VSCODE_RECONNECT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SCROLLBACK,delete process.env.VSCODE_LATENCY,delete process.env.VSCODE_STARTUP_DELAY,t&&await(0,o.timeout)(t);const F=(0,s.isUtilityProcess)(process);let g;F?g=new A.Server:g=new S.Server(m.TerminalIpcChannels.PtyHost);const b={_serviceBrand:void 0,...r.default},C=new d.NativeEnvironmentService((0,E.parseArgs)(process.argv,E.OPTIONS),b),k=new w.LoggerService((0,l.getLogLevel)(C),C.logsHome);g.registerChannel(m.TerminalIpcChannels.Logger,new P.LoggerChannel(k,()=>v.DefaultURITransformer));const j=k.createLogger("ptyhost",{name:(0,M.localize)(0,null)}),B=new p.LogService(j);t&&B.warn(`Pty Host startup is delayed ${t}ms`),i&&B.warn(`Pty host is simulating ${i}ms latency`);const c=new f.DisposableStore,_=new u.HeartbeatService;g.registerChannel(m.TerminalIpcChannels.Heartbeat,L.ProxyChannel.fromService(_,c));const D=new a.PtyService(B,b,y,i),W=L.ProxyChannel.fromService(D,c);g.registerChannel(m.TerminalIpcChannels.PtyHost,W),F&&g.registerChannel(m.TerminalIpcChannels.PtyHostWindow,W),process.once("exit",()=>{B.trace("Pty host exiting"),B.dispose(),_.dispose(),D.dispose()})}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/27d855b2b4105a2aca2445223c8f3dc4694fbd58/core/vs/platform/terminal/node/ptyHostMain.js.map
