/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/network","vs/base/common/strings","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Te=function(me){for(var e=[],I=0,L=me.length;I<L;I++)e[I]=Pe[me[I]];return e};define(Pe[67],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function I(T){return(g,h,S)=>{let R=null,D=null;if(typeof S.value=="function"?(R="value",D=S.value):typeof S.get=="function"&&(R="get",D=S.get),!D)throw new Error("not supported");S[R]=T(D,h)}}function L(T,g,h){let S=null,R=null;if(typeof h.value=="function"?(S="value",R=h.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(S="get",R=h.get),!R)throw new Error("not supported");const D=`$memoize$${g}`;h[S]=function(...u){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,u)}),this[D]}}e.memoize=L;function C(T,g,h){return I((S,R)=>{const D=`$debounce$${R}`,u=`$debounce$result$${R}`;return function(...p){this[u]||(this[u]=h?h():void 0),clearTimeout(this[D]),g&&(this[u]=g(this[u],...p),p=[this[u]]),this[D]=setTimeout(()=>{S.apply(this,p),this[u]=h?h():void 0},T)}})}e.debounce=C;function A(T,g,h){return I((S,R)=>{const D=`$throttle$timer$${R}`,u=`$throttle$result$${R}`,p=`$throttle$lastRun$${R}`,E=`$throttle$pending$${R}`;return function(...i){if(this[u]||(this[u]=h?h():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),g&&(this[u]=g(this[u],...i)),this[E])return;const a=this[p]+T;a<=Date.now()?(this[p]=Date.now(),S.apply(this,[this[u]]),this[u]=h?h():void 0):(this[E]=!0,this[D]=setTimeout(()=>{this[E]=!1,this[p]=Date.now(),S.apply(this,[this[u]]),this[u]=h?h():void 0},a-Date.now()))}})}e.throttle=A}),define(Pe[89],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class I{constructor(C){this._prefix=C,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=I,e.defaultGenerator=new I("id#")}),define(Pe[119],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function T(t,d=!1){let s=0;const b=t.length;let _="",f=0,w=16,P=0;function m(x){let k=0,M=0;for(;k<x;){const $=t.charCodeAt(s);if($>=48&&$<=57)M=M*16+$-48;else if($>=65&&$<=70)M=M*16+$-65+10;else if($>=97&&$<=102)M=M*16+$-97+10;else break;s++,k++}return k<x&&(M=-1),M}function v(x){s=x,_="",f=0,w=16,P=0}function y(){const x=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&S(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&S(t.charCodeAt(s)))for(s++;s<t.length&&S(t.charCodeAt(s));)s++;else return P=3,t.substring(x,s);let k=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&S(t.charCodeAt(s))){for(s++;s<t.length&&S(t.charCodeAt(s));)s++;k=s}else P=3;return t.substring(x,k)}function O(){let x="",k=s;for(;;){if(s>=b){x+=t.substring(k,s),P=2;break}const M=t.charCodeAt(s);if(M===34){x+=t.substring(k,s),s++;break}if(M===92){if(x+=t.substring(k,s),s++,s>=b){P=2;break}switch(t.charCodeAt(s++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:{const oe=m(4);oe>=0?x+=String.fromCharCode(oe):P=4;break}default:P=5}k=s;continue}if(M>=0&&M<=31)if(h(M)){x+=t.substring(k,s),P=2;break}else P=6;s++}return x}function N(){if(_="",P=0,f=s,s>=b)return f=b,w=17;let x=t.charCodeAt(s);if(g(x)){do s++,_+=String.fromCharCode(x),x=t.charCodeAt(s);while(g(x));return w=15}if(h(x))return s++,_+=String.fromCharCode(x),x===13&&t.charCodeAt(s)===10&&(s++,_+=`
`),w=14;switch(x){case 123:return s++,w=1;case 125:return s++,w=2;case 91:return s++,w=3;case 93:return s++,w=4;case 58:return s++,w=6;case 44:return s++,w=5;case 34:return s++,_=O(),w=10;case 47:{const k=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<b&&!h(t.charCodeAt(s));)s++;return _=t.substring(k,s),w=12}if(t.charCodeAt(s+1)===42){s+=2;const M=b-1;let $=!1;for(;s<M;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,$=!0;break}s++}return $||(s++,P=1),_=t.substring(k,s),w=13}return _+=String.fromCharCode(x),s++,w=16}case 45:if(_+=String.fromCharCode(x),s++,s===b||!S(t.charCodeAt(s)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return _+=y(),w=11;default:for(;s<b&&q(x);)s++,x=t.charCodeAt(s);if(f!==s){switch(_=t.substring(f,s),_){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return _+=String.fromCharCode(x),s++,w=16}}function q(x){if(g(x)||h(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let x;do x=N();while(x>=12&&x<=15);return x}return{setPosition:v,getPosition:()=>s,scan:d?W:N,getToken:()=>w,getTokenValue:()=>_,getTokenOffset:()=>f,getTokenLength:()=>s-f,getTokenError:()=>P}}e.createScanner=T;function g(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function S(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function D(t,d){const s=[],b=new Object;let _;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function P(m,v,y,O){f.value=m,f.offset=v,f.length=y,f.type=O,f.colonOffset=void 0,_=f}try{o(t,{onObjectBegin:(m,v)=>{if(d<=m)throw b;_=void 0,w=d>m,s.push("")},onObjectProperty:(m,v,y)=>{if(d<v||(P(m,v,y,"property"),s[s.length-1]=m,d<=v+y))throw b},onObjectEnd:(m,v)=>{if(d<=m)throw b;_=void 0,s.pop()},onArrayBegin:(m,v)=>{if(d<=m)throw b;_=void 0,s.push(0)},onArrayEnd:(m,v)=>{if(d<=m)throw b;_=void 0,s.pop()},onLiteralValue:(m,v,y)=>{if(d<v||(P(m,v,y,l(m)),d<=v+y))throw b},onSeparator:(m,v,y)=>{if(d<=v)throw b;if(m===":"&&_&&_.type==="property")_.colonOffset=v,w=!1,_=void 0;else if(m===","){const O=s[s.length-1];typeof O=="number"?s[s.length-1]=O+1:(w=!0,s[s.length-1]=""),_=void 0}}})}catch(m){if(m!==b)throw m}return{path:s,previousNode:_,isAtPropertyKey:w,matches:m=>{let v=0;for(let y=0;v<m.length&&y<s.length;y++)if(m[v]===s[y]||m[v]==="*")v++;else if(m[v]!=="**")return!1;return v===m.length}}}e.getLocation=D;function u(t,d=[],s=A.DEFAULT){let b=null,_=[];const f=[];function w(m){Array.isArray(_)?_.push(m):b!==null&&(_[b]=m)}return o(t,{onObjectBegin:()=>{const m={};w(m),f.push(_),_=m,b=null},onObjectProperty:m=>{b=m},onObjectEnd:()=>{_=f.pop()},onArrayBegin:()=>{const m=[];w(m),f.push(_),_=m,b=null},onArrayEnd:()=>{_=f.pop()},onLiteralValue:w,onError:(m,v,y)=>{d.push({error:m,offset:v,length:y})}},s),_[0]}e.parse=u;function p(t,d=[],s=A.DEFAULT){let b={type:"array",offset:-1,length:-1,children:[],parent:void 0};function _(m){b.type==="property"&&(b.length=m-b.offset,b=b.parent)}function f(m){return b.children.push(m),m}o(t,{onObjectBegin:m=>{b=f({type:"object",offset:m,length:-1,parent:b,children:[]})},onObjectProperty:(m,v,y)=>{b=f({type:"property",offset:v,length:-1,parent:b,children:[]}),b.children.push({type:"string",value:m,offset:v,length:y,parent:b})},onObjectEnd:(m,v)=>{b.length=m+v-b.offset,b=b.parent,_(m+v)},onArrayBegin:(m,v)=>{b=f({type:"array",offset:m,length:-1,parent:b,children:[]})},onArrayEnd:(m,v)=>{b.length=m+v-b.offset,b=b.parent,_(m+v)},onLiteralValue:(m,v,y)=>{f({type:l(m),offset:v,length:y,parent:b,value:m}),_(v+y)},onSeparator:(m,v,y)=>{b.type==="property"&&(m===":"?b.colonOffset=v:m===","&&_(v))},onError:(m,v,y)=>{d.push({error:m,offset:v,length:y})}},s);const P=b.children[0];return P&&delete P.parent,P}e.parseTree=p;function E(t,d){if(!t)return;let s=t;for(const b of d)if(typeof b=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let _=!1;for(const f of s.children)if(Array.isArray(f.children)&&f.children[0].value===b){s=f.children[1],_=!0;break}if(!_)return}else{const _=b;if(s.type!=="array"||_<0||!Array.isArray(s.children)||_>=s.children.length)return;s=s.children[_]}return s}e.findNodeAtLocation=E;function i(t){if(!t.parent||!t.parent.children)return[];const d=i(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;d.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&d.push(s)}return d}e.getNodePath=i;function a(t){switch(t.type){case"array":return t.children.map(a);case"object":{const d=Object.create(null);for(const s of t.children){const b=s.children[1];b&&(d[s.children[0].value]=a(b))}return d}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=a;function r(t,d,s=!1){return d>=t.offset&&d<t.offset+t.length||s&&d===t.offset+t.length}e.contains=r;function n(t,d,s=!1){if(r(t,d,s)){const b=t.children;if(Array.isArray(b))for(let _=0;_<b.length&&b[_].offset<=d;_++){const f=n(b[_],d,s);if(f)return f}return t}}e.findNodeAtOffset=n;function o(t,d,s=A.DEFAULT){const b=T(t,!1);function _(ae){return ae?()=>ae(b.getTokenOffset(),b.getTokenLength()):()=>!0}function f(ae){return ae?pe=>ae(pe,b.getTokenOffset(),b.getTokenLength()):()=>!0}const w=_(d.onObjectBegin),P=f(d.onObjectProperty),m=_(d.onObjectEnd),v=_(d.onArrayBegin),y=_(d.onArrayEnd),O=f(d.onLiteralValue),N=f(d.onSeparator),q=_(d.onComment),W=f(d.onError),x=s&&s.disallowComments,k=s&&s.allowTrailingComma;function M(){for(;;){const ae=b.scan();switch(b.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:x||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(ae){case 12:case 13:x?$(10):q();break;case 16:$(1);break;case 15:case 14:break;default:return ae}}}function $(ae,pe=[],re=[]){if(W(ae),pe.length+re.length>0){let J=b.getToken();for(;J!==17;){if(pe.indexOf(J)!==-1){M();break}else if(re.indexOf(J)!==-1)break;J=M()}}}function oe(ae){const pe=b.getTokenValue();return ae?O(pe):P(pe),M(),!0}function de(){switch(b.getToken()){case 11:{let ae=0;try{ae=JSON.parse(b.getTokenValue()),typeof ae!="number"&&($(2),ae=0)}catch{$(2)}O(ae);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return M(),!0}function we(){return b.getToken()!==10?($(3,[],[2,5]),!1):(oe(!1),b.getToken()===6?(N(":"),M(),ve()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function ye(){w(),M();let ae=!1;for(;b.getToken()!==2&&b.getToken()!==17;){if(b.getToken()===5){if(ae||$(4,[],[]),N(","),M(),b.getToken()===2&&k)break}else ae&&$(6,[],[]);we()||$(4,[],[2,5]),ae=!0}return m(),b.getToken()!==2?$(7,[2],[]):M(),!0}function le(){v(),M();let ae=!1;for(;b.getToken()!==4&&b.getToken()!==17;){if(b.getToken()===5){if(ae||$(4,[],[]),N(","),M(),b.getToken()===4&&k)break}else ae&&$(6,[],[]);ve()||$(4,[],[4,5]),ae=!0}return y(),b.getToken()!==4?$(8,[4],[]):M(),!0}function ve(){switch(b.getToken()){case 3:return le();case 1:return ye();case 10:return oe(!0);default:return de()}}return M(),b.getToken()===17?s.allowEmptyContent?!0:($(4,[],[]),!1):ve()?(b.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=o;function c(t,d){const s=T(t),b=[];let _,f=0,w;do switch(w=s.getPosition(),_=s.scan(),_){case 12:case 13:case 17:f!==w&&b.push(t.substring(f,w)),d!==void 0&&b.push(s.getTokenValue().replace(/[^\r\n]/g,d)),f=s.getPosition();break}while(_!==17);return b.join("")}e.stripComments=c;function l(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),function(me,e){typeof define=="function"&&define.amd?define(Pe[120],Te([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(ke,ce){for(var te=0;te<ce.length;te++){var K=ce[te];K.enumerable=K.enumerable||!1,K.configurable=!0,"value"in K&&(K.writable=!0),Object.defineProperty(ke,K.key,K)}}function I(ke,ce,te){return ce&&e(ke.prototype,ce),te&&e(ke,te),Object.defineProperty(ke,"prototype",{writable:!1}),ke}function L(ke,ce){if(ke){if(typeof ke=="string")return C(ke,ce);var te=Object.prototype.toString.call(ke).slice(8,-1);if(te==="Object"&&ke.constructor&&(te=ke.constructor.name),te==="Map"||te==="Set")return Array.from(ke);if(te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(te))return C(ke,ce)}}function C(ke,ce){(ce==null||ce>ke.length)&&(ce=ke.length);for(var te=0,K=new Array(ce);te<ce;te++)K[te]=ke[te];return K}function A(ke,ce){var te=typeof Symbol<"u"&&ke[Symbol.iterator]||ke["@@iterator"];if(te)return(te=te.call(ke)).next.bind(te);if(Array.isArray(ke)||(te=L(ke))||ce&&ke&&typeof ke.length=="number"){te&&(ke=te);var K=0;return function(){return K>=ke.length?{done:!0}:{done:!1,value:ke[K++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function T(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=T();function g(ke){me.defaults=ke}var h=/[&<>"']/,S=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(ce){return u[ce]};function E(ke,ce){if(ce){if(h.test(ke))return ke.replace(S,p)}else if(R.test(ke))return ke.replace(D,p);return ke}var i=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(ke){return ke.replace(i,function(ce,te){return te=te.toLowerCase(),te==="colon"?":":te.charAt(0)==="#"?te.charAt(1)==="x"?String.fromCharCode(parseInt(te.substring(2),16)):String.fromCharCode(+te.substring(1)):""})}var r=/(^|[^\[])\^/g;function n(ke,ce){ke=typeof ke=="string"?ke:ke.source,ce=ce||"";var te={replace:function(ee,ge){return ge=ge.source||ge,ge=ge.replace(r,"$1"),ke=ke.replace(ee,ge),te},getRegex:function(){return new RegExp(ke,ce)}};return te}var o=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(ke,ce,te){if(ke){var K;try{K=decodeURIComponent(a(te)).replace(o,"").toLowerCase()}catch{return null}if(K.indexOf("javascript:")===0||K.indexOf("vbscript:")===0||K.indexOf("data:")===0)return null}ce&&!c.test(te)&&(te=_(ce,te));try{te=encodeURI(te).replace(/%25/g,"%")}catch{return null}return te}var t={},d=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,b=/^([^:]+:\/*[^/]*)[\s\S]*$/;function _(ke,ce){t[" "+ke]||(d.test(ke)?t[" "+ke]=ke+"/":t[" "+ke]=m(ke,"/",!0)),ke=t[" "+ke];var te=ke.indexOf(":")===-1;return ce.substring(0,2)==="//"?te?ce:ke.replace(s,"$1")+ce:ce.charAt(0)==="/"?te?ce:ke.replace(b,"$1")+ce:ke+ce}var f={exec:function(){}};function w(ke){for(var ce=1,te,K;ce<arguments.length;ce++){te=arguments[ce];for(K in te)Object.prototype.hasOwnProperty.call(te,K)&&(ke[K]=te[K])}return ke}function P(ke,ce){var te=ke.replace(/\|/g,function(ge,be,Le){for(var fe=!1,_e=be;--_e>=0&&Le[_e]==="\\";)fe=!fe;return fe?"|":" |"}),K=te.split(/ \|/),ee=0;if(K[0].trim()||K.shift(),K.length>0&&!K[K.length-1].trim()&&K.pop(),K.length>ce)K.splice(ce);else for(;K.length<ce;)K.push("");for(;ee<K.length;ee++)K[ee]=K[ee].trim().replace(/\\\|/g,"|");return K}function m(ke,ce,te){var K=ke.length;if(K===0)return"";for(var ee=0;ee<K;){var ge=ke.charAt(K-ee-1);if(ge===ce&&!te)ee++;else if(ge!==ce&&te)ee++;else break}return ke.slice(0,K-ee)}function v(ke,ce){if(ke.indexOf(ce[1])===-1)return-1;for(var te=ke.length,K=0,ee=0;ee<te;ee++)if(ke[ee]==="\\")ee++;else if(ke[ee]===ce[0])K++;else if(ke[ee]===ce[1]&&(K--,K<0))return ee;return-1}function y(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function O(ke,ce){if(ce<1)return"";for(var te="";ce>1;)ce&1&&(te+=ke),ce>>=1,ke+=ke;return te+ke}function N(ke,ce,te,K){var ee=ce.href,ge=ce.title?E(ce.title):null,be=ke[1].replace(/\\([\[\]])/g,"$1");if(ke[0].charAt(0)!=="!"){K.state.inLink=!0;var Le={type:"link",raw:te,href:ee,title:ge,text:be,tokens:K.inlineTokens(be)};return K.state.inLink=!1,Le}return{type:"image",raw:te,href:ee,title:ge,text:E(be)}}function q(ke,ce){var te=ke.match(/^(\s+)(?:```)/);if(te===null)return ce;var K=te[1];return ce.split(`
`).map(function(ee){var ge=ee.match(/^\s+/);if(ge===null)return ee;var be=ge[0];return be.length>=K.length?ee.slice(K.length):ee}).join(`
`)}var W=function(){function ke(te){this.options=te||me.defaults}var ce=ke.prototype;return ce.space=function(K){var ee=this.rules.block.newline.exec(K);if(ee&&ee[0].length>0)return{type:"space",raw:ee[0]}},ce.code=function(K){var ee=this.rules.block.code.exec(K);if(ee){var ge=ee[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ee[0],codeBlockStyle:"indented",text:this.options.pedantic?ge:m(ge,`
`)}}},ce.fences=function(K){var ee=this.rules.block.fences.exec(K);if(ee){var ge=ee[0],be=q(ge,ee[3]||"");return{type:"code",raw:ge,lang:ee[2]?ee[2].trim():ee[2],text:be}}},ce.heading=function(K){var ee=this.rules.block.heading.exec(K);if(ee){var ge=ee[2].trim();if(/#$/.test(ge)){var be=m(ge,"#");(this.options.pedantic||!be||/ $/.test(be))&&(ge=be.trim())}return{type:"heading",raw:ee[0],depth:ee[1].length,text:ge,tokens:this.lexer.inline(ge)}}},ce.hr=function(K){var ee=this.rules.block.hr.exec(K);if(ee)return{type:"hr",raw:ee[0]}},ce.blockquote=function(K){var ee=this.rules.block.blockquote.exec(K);if(ee){var ge=ee[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ee[0],tokens:this.lexer.blockTokens(ge,[]),text:ge}}},ce.list=function(K){var ee=this.rules.block.list.exec(K);if(ee){var ge,be,Le,fe,_e,F,V,j,B,X,Z,Se,Ne=ee[1].trim(),$e=Ne.length>1,qe={type:"list",raw:"",ordered:$e,start:$e?+Ne.slice(0,-1):"",loose:!1,items:[]};Ne=$e?"\\d{1,9}\\"+Ne.slice(-1):"\\"+Ne,this.options.pedantic&&(Ne=$e?Ne:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+Ne+")((?:[	 ][^\\n]*)?(?:\\n|$))");K&&(Se=!1,!(!(ee=Qe.exec(K))||this.rules.block.hr.test(K)));){if(ge=ee[0],K=K.substring(ge.length),j=ee[2].split(`
`,1)[0],B=K.split(`
`,1)[0],this.options.pedantic?(fe=2,Z=j.trimLeft()):(fe=ee[2].search(/[^ ]/),fe=fe>4?1:fe,Z=j.slice(fe),fe+=ee[1].length),F=!1,!j&&/^ *$/.test(B)&&(ge+=B+`
`,K=K.substring(B.length+1),Se=!0),!Se)for(var nt=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,fe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,fe-1)+"}#");K&&(X=K.split(`
`,1)[0],j=X,this.options.pedantic&&(j=j.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(j)||rt.test(j)||nt.test(j)||it.test(K)));){if(j.search(/[^ ]/)>=fe||!j.trim())Z+=`
`+j.slice(fe);else if(!F)Z+=`
`+j;else break;!F&&!j.trim()&&(F=!0),ge+=X+`
`,K=K.substring(X.length+1)}qe.loose||(V?qe.loose=!0:/\n *\n *$/.test(ge)&&(V=!0)),this.options.gfm&&(be=/^\[[ xX]\] /.exec(Z),be&&(Le=be[0]!=="[ ] ",Z=Z.replace(/^\[[ xX]\] +/,""))),qe.items.push({type:"list_item",raw:ge,task:!!be,checked:Le,loose:!1,text:Z}),qe.raw+=ge}qe.items[qe.items.length-1].raw=ge.trimRight(),qe.items[qe.items.length-1].text=Z.trimRight(),qe.raw=qe.raw.trimRight();var ct=qe.items.length;for(_e=0;_e<ct;_e++){this.lexer.state.top=!1,qe.items[_e].tokens=this.lexer.blockTokens(qe.items[_e].text,[]);var Be=qe.items[_e].tokens.filter(function(Q){return Q.type==="space"}),gt=Be.every(function(Q){for(var Y=Q.raw.split(""),Ee=0,ze=A(Y),Ge;!(Ge=ze()).done;){var tt=Ge.value;if(tt===`
`&&(Ee+=1),Ee>1)return!0}return!1});!qe.loose&&Be.length&&gt&&(qe.loose=!0,qe.items[_e].loose=!0)}return qe}},ce.html=function(K){var ee=this.rules.block.html.exec(K);if(ee){var ge={type:"html",raw:ee[0],pre:!this.options.sanitizer&&(ee[1]==="pre"||ee[1]==="script"||ee[1]==="style"),text:ee[0]};if(this.options.sanitize){var be=this.options.sanitizer?this.options.sanitizer(ee[0]):E(ee[0]);ge.type="paragraph",ge.text=be,ge.tokens=this.lexer.inline(be)}return ge}},ce.def=function(K){var ee=this.rules.block.def.exec(K);if(ee){ee[3]&&(ee[3]=ee[3].substring(1,ee[3].length-1));var ge=ee[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ge,raw:ee[0],href:ee[2],title:ee[3]}}},ce.table=function(K){var ee=this.rules.block.table.exec(K);if(ee){var ge={type:"table",header:P(ee[1]).map(function(V){return{text:V}}),align:ee[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ee[3]&&ee[3].trim()?ee[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ge.header.length===ge.align.length){ge.raw=ee[0];var be=ge.align.length,Le,fe,_e,F;for(Le=0;Le<be;Le++)/^ *-+: *$/.test(ge.align[Le])?ge.align[Le]="right":/^ *:-+: *$/.test(ge.align[Le])?ge.align[Le]="center":/^ *:-+ *$/.test(ge.align[Le])?ge.align[Le]="left":ge.align[Le]=null;for(be=ge.rows.length,Le=0;Le<be;Le++)ge.rows[Le]=P(ge.rows[Le],ge.header.length).map(function(V){return{text:V}});for(be=ge.header.length,fe=0;fe<be;fe++)ge.header[fe].tokens=this.lexer.inline(ge.header[fe].text);for(be=ge.rows.length,fe=0;fe<be;fe++)for(F=ge.rows[fe],_e=0;_e<F.length;_e++)F[_e].tokens=this.lexer.inline(F[_e].text);return ge}}},ce.lheading=function(K){var ee=this.rules.block.lheading.exec(K);if(ee)return{type:"heading",raw:ee[0],depth:ee[2].charAt(0)==="="?1:2,text:ee[1],tokens:this.lexer.inline(ee[1])}},ce.paragraph=function(K){var ee=this.rules.block.paragraph.exec(K);if(ee){var ge=ee[1].charAt(ee[1].length-1)===`
`?ee[1].slice(0,-1):ee[1];return{type:"paragraph",raw:ee[0],text:ge,tokens:this.lexer.inline(ge)}}},ce.text=function(K){var ee=this.rules.block.text.exec(K);if(ee)return{type:"text",raw:ee[0],text:ee[0],tokens:this.lexer.inline(ee[0])}},ce.escape=function(K){var ee=this.rules.inline.escape.exec(K);if(ee)return{type:"escape",raw:ee[0],text:E(ee[1])}},ce.tag=function(K){var ee=this.rules.inline.tag.exec(K);if(ee)return!this.lexer.state.inLink&&/^<a /i.test(ee[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ee[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ee[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ee[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ee[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):E(ee[0]):ee[0]}},ce.link=function(K){var ee=this.rules.inline.link.exec(K);if(ee){var ge=ee[2].trim();if(!this.options.pedantic&&/^</.test(ge)){if(!/>$/.test(ge))return;var be=m(ge.slice(0,-1),"\\");if((ge.length-be.length)%2===0)return}else{var Le=v(ee[2],"()");if(Le>-1){var fe=ee[0].indexOf("!")===0?5:4,_e=fe+ee[1].length+Le;ee[2]=ee[2].substring(0,Le),ee[0]=ee[0].substring(0,_e).trim(),ee[3]=""}}var F=ee[2],V="";if(this.options.pedantic){var j=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(F);j&&(F=j[1],V=j[3])}else V=ee[3]?ee[3].slice(1,-1):"";return F=F.trim(),/^</.test(F)&&(this.options.pedantic&&!/>$/.test(ge)?F=F.slice(1):F=F.slice(1,-1)),N(ee,{href:F&&F.replace(this.rules.inline._escapes,"$1"),title:V&&V.replace(this.rules.inline._escapes,"$1")},ee[0],this.lexer)}},ce.reflink=function(K,ee){var ge;if((ge=this.rules.inline.reflink.exec(K))||(ge=this.rules.inline.nolink.exec(K))){var be=(ge[2]||ge[1]).replace(/\s+/g," ");if(be=ee[be.toLowerCase()],!be||!be.href){var Le=ge[0].charAt(0);return{type:"text",raw:Le,text:Le}}return N(ge,be,ge[0],this.lexer)}},ce.emStrong=function(K,ee,ge){ge===void 0&&(ge="");var be=this.rules.inline.emStrong.lDelim.exec(K);if(be&&!(be[3]&&ge.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Le=be[1]||be[2]||"";if(!Le||Le&&(ge===""||this.rules.inline.punctuation.exec(ge))){var fe=be[0].length-1,_e,F,V=fe,j=0,B=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(B.lastIndex=0,ee=ee.slice(-1*K.length+fe);(be=B.exec(ee))!=null;)if(_e=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!_e){if(F=_e.length,be[3]||be[4]){V+=F;continue}else if((be[5]||be[6])&&fe%3&&!((fe+F)%3)){j+=F;continue}if(V-=F,!(V>0)){if(F=Math.min(F,F+V+j),Math.min(fe,F)%2){var X=K.slice(1,fe+be.index+F);return{type:"em",raw:K.slice(0,fe+be.index+F+1),text:X,tokens:this.lexer.inlineTokens(X)}}var Z=K.slice(2,fe+be.index+F-1);return{type:"strong",raw:K.slice(0,fe+be.index+F+1),text:Z,tokens:this.lexer.inlineTokens(Z)}}}}}},ce.codespan=function(K){var ee=this.rules.inline.code.exec(K);if(ee){var ge=ee[2].replace(/\n/g," "),be=/[^ ]/.test(ge),Le=/^ /.test(ge)&&/ $/.test(ge);return be&&Le&&(ge=ge.substring(1,ge.length-1)),ge=E(ge,!0),{type:"codespan",raw:ee[0],text:ge}}},ce.br=function(K){var ee=this.rules.inline.br.exec(K);if(ee)return{type:"br",raw:ee[0]}},ce.del=function(K){var ee=this.rules.inline.del.exec(K);if(ee)return{type:"del",raw:ee[0],text:ee[2],tokens:this.lexer.inlineTokens(ee[2])}},ce.autolink=function(K,ee){var ge=this.rules.inline.autolink.exec(K);if(ge){var be,Le;return ge[2]==="@"?(be=E(this.options.mangle?ee(ge[1]):ge[1]),Le="mailto:"+be):(be=E(ge[1]),Le=be),{type:"link",raw:ge[0],text:be,href:Le,tokens:[{type:"text",raw:be,text:be}]}}},ce.url=function(K,ee){var ge;if(ge=this.rules.inline.url.exec(K)){var be,Le;if(ge[2]==="@")be=E(this.options.mangle?ee(ge[0]):ge[0]),Le="mailto:"+be;else{var fe;do fe=ge[0],ge[0]=this.rules.inline._backpedal.exec(ge[0])[0];while(fe!==ge[0]);be=E(ge[0]),ge[1]==="www."?Le="http://"+be:Le=be}return{type:"link",raw:ge[0],text:be,href:Le,tokens:[{type:"text",raw:be,text:be}]}}},ce.inlineText=function(K,ee){var ge=this.rules.inline.text.exec(K);if(ge){var be;return this.lexer.state.inRawBlock?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):E(ge[0]):ge[0]:be=E(this.options.smartypants?ee(ge[0]):ge[0]),{type:"text",raw:ge[0],text:be}}},ke}(),x={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:f,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};x._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,x._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,x.def=n(x.def).replace("label",x._label).replace("title",x._title).getRegex(),x.bullet=/(?:[*+-]|\d{1,9}[.)])/,x.listItemStart=n(/^( *)(bull) */).replace("bull",x.bullet).getRegex(),x.list=n(x.list).replace(/bull/g,x.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+x.def.source+")").getRegex(),x._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",x._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,x.html=n(x.html,"i").replace("comment",x._comment).replace("tag",x._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),x.paragraph=n(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.blockquote=n(x.blockquote).replace("paragraph",x.paragraph).getRegex(),x.normal=w({},x),x.gfm=w({},x.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),x.gfm.table=n(x.gfm.table).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.gfm.paragraph=n(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",x.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.pedantic=w({},x.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",x._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:f,paragraph:n(x.normal._paragraph).replace("hr",x.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",x.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var k={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:f,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:f,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};k._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",k.punctuation=n(k.punctuation).replace(/punctuation/g,k._punctuation).getRegex(),k.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,k.escapedEmSt=/\\\*|\\_/g,k._comment=n(x._comment).replace("(?:-->|$)","-->").getRegex(),k.emStrong.lDelim=n(k.emStrong.lDelim).replace(/punct/g,k._punctuation).getRegex(),k.emStrong.rDelimAst=n(k.emStrong.rDelimAst,"g").replace(/punct/g,k._punctuation).getRegex(),k.emStrong.rDelimUnd=n(k.emStrong.rDelimUnd,"g").replace(/punct/g,k._punctuation).getRegex(),k._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,k._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,k._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,k.autolink=n(k.autolink).replace("scheme",k._scheme).replace("email",k._email).getRegex(),k._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,k.tag=n(k.tag).replace("comment",k._comment).replace("attribute",k._attribute).getRegex(),k._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,k._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,k._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,k.link=n(k.link).replace("label",k._label).replace("href",k._href).replace("title",k._title).getRegex(),k.reflink=n(k.reflink).replace("label",k._label).replace("ref",x._label).getRegex(),k.nolink=n(k.nolink).replace("ref",x._label).getRegex(),k.reflinkSearch=n(k.reflinkSearch,"g").replace("reflink",k.reflink).replace("nolink",k.nolink).getRegex(),k.normal=w({},k),k.pedantic=w({},k.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",k._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",k._label).getRegex()}),k.gfm=w({},k.normal,{escape:n(k.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),k.gfm.url=n(k.gfm.url,"i").replace("email",k.gfm._extended_email).getRegex(),k.breaks=w({},k.gfm,{br:n(k.br).replace("{2,}","*").getRegex(),text:n(k.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function M(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function $(ke){var ce="",te,K,ee=ke.length;for(te=0;te<ee;te++)K=ke.charCodeAt(te),Math.random()>.5&&(K="x"+K.toString(16)),ce+="&#"+K+";";return ce}var oe=function(){function ke(te){this.tokens=[],this.tokens.links=Object.create(null),this.options=te||me.defaults,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var K={block:x.normal,inline:k.normal};this.options.pedantic?(K.block=x.pedantic,K.inline=k.pedantic):this.options.gfm&&(K.block=x.gfm,this.options.breaks?K.inline=k.breaks:K.inline=k.gfm),this.tokenizer.rules=K}ke.lex=function(K,ee){var ge=new ke(ee);return ge.lex(K)},ke.lexInline=function(K,ee){var ge=new ke(ee);return ge.inlineTokens(K)};var ce=ke.prototype;return ce.lex=function(K){K=K.replace(/\r\n|\r/g,`
`),this.blockTokens(K,this.tokens);for(var ee;ee=this.inlineQueue.shift();)this.inlineTokens(ee.src,ee.tokens);return this.tokens},ce.blockTokens=function(K,ee){var ge=this;ee===void 0&&(ee=[]),this.options.pedantic?K=K.replace(/\t/g,"    ").replace(/^ +$/gm,""):K=K.replace(/^( *)(\t+)/gm,function(V,j,B){return j+"    ".repeat(B.length)});for(var be,Le,fe,_e;K;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(V){return(be=V.call({lexer:ge},K,ee))?(K=K.substring(be.raw.length),ee.push(be),!0):!1}))){if(be=this.tokenizer.space(K)){K=K.substring(be.raw.length),be.raw.length===1&&ee.length>0?ee[ee.length-1].raw+=`
`:ee.push(be);continue}if(be=this.tokenizer.code(K)){K=K.substring(be.raw.length),Le=ee[ee.length-1],Le&&(Le.type==="paragraph"||Le.type==="text")?(Le.raw+=`
`+be.raw,Le.text+=`
`+be.text,this.inlineQueue[this.inlineQueue.length-1].src=Le.text):ee.push(be);continue}if(be=this.tokenizer.fences(K)){K=K.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.heading(K)){K=K.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.hr(K)){K=K.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.blockquote(K)){K=K.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.list(K)){K=K.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.html(K)){K=K.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.def(K)){K=K.substring(be.raw.length),Le=ee[ee.length-1],Le&&(Le.type==="paragraph"||Le.type==="text")?(Le.raw+=`
`+be.raw,Le.text+=`
`+be.raw,this.inlineQueue[this.inlineQueue.length-1].src=Le.text):this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(K)){K=K.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.lheading(K)){K=K.substring(be.raw.length),ee.push(be);continue}if(fe=K,this.options.extensions&&this.options.extensions.startBlock&&function(){var V=1/0,j=K.slice(1),B=void 0;ge.options.extensions.startBlock.forEach(function(X){B=X.call({lexer:this},j),typeof B=="number"&&B>=0&&(V=Math.min(V,B))}),V<1/0&&V>=0&&(fe=K.substring(0,V+1))}(),this.state.top&&(be=this.tokenizer.paragraph(fe))){Le=ee[ee.length-1],_e&&Le.type==="paragraph"?(Le.raw+=`
`+be.raw,Le.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Le.text):ee.push(be),_e=fe.length!==K.length,K=K.substring(be.raw.length);continue}if(be=this.tokenizer.text(K)){K=K.substring(be.raw.length),Le=ee[ee.length-1],Le&&Le.type==="text"?(Le.raw+=`
`+be.raw,Le.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Le.text):ee.push(be);continue}if(K){var F="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(F);break}else throw new Error(F)}}return this.state.top=!0,ee},ce.inline=function(K,ee){return ee===void 0&&(ee=[]),this.inlineQueue.push({src:K,tokens:ee}),ee},ce.inlineTokens=function(K,ee){var ge=this;ee===void 0&&(ee=[]);var be,Le,fe,_e=K,F,V,j;if(this.tokens.links){var B=Object.keys(this.tokens.links);if(B.length>0)for(;(F=this.tokenizer.rules.inline.reflinkSearch.exec(_e))!=null;)B.includes(F[0].slice(F[0].lastIndexOf("[")+1,-1))&&(_e=_e.slice(0,F.index)+"["+O("a",F[0].length-2)+"]"+_e.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(F=this.tokenizer.rules.inline.blockSkip.exec(_e))!=null;)_e=_e.slice(0,F.index)+"["+O("a",F[0].length-2)+"]"+_e.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(F=this.tokenizer.rules.inline.escapedEmSt.exec(_e))!=null;)_e=_e.slice(0,F.index)+"++"+_e.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;K;)if(V||(j=""),V=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Z){return(be=Z.call({lexer:ge},K,ee))?(K=K.substring(be.raw.length),ee.push(be),!0):!1}))){if(be=this.tokenizer.escape(K)){K=K.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.tag(K)){K=K.substring(be.raw.length),Le=ee[ee.length-1],Le&&be.type==="text"&&Le.type==="text"?(Le.raw+=be.raw,Le.text+=be.text):ee.push(be);continue}if(be=this.tokenizer.link(K)){K=K.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.reflink(K,this.tokens.links)){K=K.substring(be.raw.length),Le=ee[ee.length-1],Le&&be.type==="text"&&Le.type==="text"?(Le.raw+=be.raw,Le.text+=be.text):ee.push(be);continue}if(be=this.tokenizer.emStrong(K,_e,j)){K=K.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.codespan(K)){K=K.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.br(K)){K=K.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.del(K)){K=K.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.autolink(K,$)){K=K.substring(be.raw.length),ee.push(be);continue}if(!this.state.inLink&&(be=this.tokenizer.url(K,$))){K=K.substring(be.raw.length),ee.push(be);continue}if(fe=K,this.options.extensions&&this.options.extensions.startInline&&function(){var Z=1/0,Se=K.slice(1),Ne=void 0;ge.options.extensions.startInline.forEach(function($e){Ne=$e.call({lexer:this},Se),typeof Ne=="number"&&Ne>=0&&(Z=Math.min(Z,Ne))}),Z<1/0&&Z>=0&&(fe=K.substring(0,Z+1))}(),be=this.tokenizer.inlineText(fe,M)){K=K.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(j=be.raw.slice(-1)),V=!0,Le=ee[ee.length-1],Le&&Le.type==="text"?(Le.raw+=be.raw,Le.text+=be.text):ee.push(be);continue}if(K){var X="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return ee},I(ke,null,[{key:"rules",get:function(){return{block:x,inline:k}}}]),ke}(),de=function(){function ke(te){this.options=te||me.defaults}var ce=ke.prototype;return ce.code=function(K,ee,ge){var be=(ee||"").match(/\S*/)[0];if(this.options.highlight){var Le=this.options.highlight(K,be);Le!=null&&Le!==K&&(ge=!0,K=Le)}return K=K.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+E(be,!0)+'">'+(ge?K:E(K,!0))+`</code></pre>
`:"<pre><code>"+(ge?K:E(K,!0))+`</code></pre>
`},ce.blockquote=function(K){return`<blockquote>
`+K+`</blockquote>
`},ce.html=function(K){return K},ce.heading=function(K,ee,ge,be){if(this.options.headerIds){var Le=this.options.headerPrefix+be.slug(ge);return"<h"+ee+' id="'+Le+'">'+K+"</h"+ee+`>
`}return"<h"+ee+">"+K+"</h"+ee+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(K,ee,ge){var be=ee?"ol":"ul",Le=ee&&ge!==1?' start="'+ge+'"':"";return"<"+be+Le+`>
`+K+"</"+be+`>
`},ce.listitem=function(K){return"<li>"+K+`</li>
`},ce.checkbox=function(K){return"<input "+(K?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(K){return"<p>"+K+`</p>
`},ce.table=function(K,ee){return ee&&(ee="<tbody>"+ee+"</tbody>"),`<table>
<thead>
`+K+`</thead>
`+ee+`</table>
`},ce.tablerow=function(K){return`<tr>
`+K+`</tr>
`},ce.tablecell=function(K,ee){var ge=ee.header?"th":"td",be=ee.align?"<"+ge+' align="'+ee.align+'">':"<"+ge+">";return be+K+("</"+ge+`>
`)},ce.strong=function(K){return"<strong>"+K+"</strong>"},ce.em=function(K){return"<em>"+K+"</em>"},ce.codespan=function(K){return"<code>"+K+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(K){return"<del>"+K+"</del>"},ce.link=function(K,ee,ge){if(K=l(this.options.sanitize,this.options.baseUrl,K),K===null)return ge;var be='<a href="'+E(K)+'"';return ee&&(be+=' title="'+ee+'"'),be+=">"+ge+"</a>",be},ce.image=function(K,ee,ge){if(K=l(this.options.sanitize,this.options.baseUrl,K),K===null)return ge;var be='<img src="'+K+'" alt="'+ge+'"';return ee&&(be+=' title="'+ee+'"'),be+=this.options.xhtml?"/>":">",be},ce.text=function(K){return K},ke}(),we=function(){function ke(){}var ce=ke.prototype;return ce.strong=function(K){return K},ce.em=function(K){return K},ce.codespan=function(K){return K},ce.del=function(K){return K},ce.html=function(K){return K},ce.text=function(K){return K},ce.link=function(K,ee,ge){return""+ge},ce.image=function(K,ee,ge){return""+ge},ce.br=function(){return""},ke}(),ye=function(){function ke(){this.seen={}}var ce=ke.prototype;return ce.serialize=function(K){return K.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(K,ee){var ge=K,be=0;if(this.seen.hasOwnProperty(ge)){be=this.seen[K];do be++,ge=K+"-"+be;while(this.seen.hasOwnProperty(ge))}return ee||(this.seen[K]=be,this.seen[ge]=0),ge},ce.slug=function(K,ee){ee===void 0&&(ee={});var ge=this.serialize(K);return this.getNextSafeSlug(ge,ee.dryrun)},ke}(),le=function(){function ke(te){this.options=te||me.defaults,this.options.renderer=this.options.renderer||new de,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new we,this.slugger=new ye}ke.parse=function(K,ee){var ge=new ke(ee);return ge.parse(K)},ke.parseInline=function(K,ee){var ge=new ke(ee);return ge.parseInline(K)};var ce=ke.prototype;return ce.parse=function(K,ee){ee===void 0&&(ee=!0);var ge="",be,Le,fe,_e,F,V,j,B,X,Z,Se,Ne,$e,qe,Qe,nt,it,et,rt,ct=K.length;for(be=0;be<ct;be++){if(Z=K[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Z.type]&&(rt=this.options.extensions.renderers[Z.type].call({parser:this},Z),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Z.type))){ge+=rt||"";continue}switch(Z.type){case"space":continue;case"hr":{ge+=this.renderer.hr();continue}case"heading":{ge+=this.renderer.heading(this.parseInline(Z.tokens),Z.depth,a(this.parseInline(Z.tokens,this.textRenderer)),this.slugger);continue}case"code":{ge+=this.renderer.code(Z.text,Z.lang,Z.escaped);continue}case"table":{for(B="",j="",_e=Z.header.length,Le=0;Le<_e;Le++)j+=this.renderer.tablecell(this.parseInline(Z.header[Le].tokens),{header:!0,align:Z.align[Le]});for(B+=this.renderer.tablerow(j),X="",_e=Z.rows.length,Le=0;Le<_e;Le++){for(V=Z.rows[Le],j="",F=V.length,fe=0;fe<F;fe++)j+=this.renderer.tablecell(this.parseInline(V[fe].tokens),{header:!1,align:Z.align[fe]});X+=this.renderer.tablerow(j)}ge+=this.renderer.table(B,X);continue}case"blockquote":{X=this.parse(Z.tokens),ge+=this.renderer.blockquote(X);continue}case"list":{for(Se=Z.ordered,Ne=Z.start,$e=Z.loose,_e=Z.items.length,X="",Le=0;Le<_e;Le++)Qe=Z.items[Le],nt=Qe.checked,it=Qe.task,qe="",Qe.task&&(et=this.renderer.checkbox(nt),$e?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=et+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=et+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:et}):qe+=et),qe+=this.parse(Qe.tokens,$e),X+=this.renderer.listitem(qe,it,nt);ge+=this.renderer.list(X,Se,Ne);continue}case"html":{ge+=this.renderer.html(Z.text);continue}case"paragraph":{ge+=this.renderer.paragraph(this.parseInline(Z.tokens));continue}case"text":{for(X=Z.tokens?this.parseInline(Z.tokens):Z.text;be+1<ct&&K[be+1].type==="text";)Z=K[++be],X+=`
`+(Z.tokens?this.parseInline(Z.tokens):Z.text);ge+=ee?this.renderer.paragraph(X):X;continue}default:{var Be='Token with "'+Z.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}}return ge},ce.parseInline=function(K,ee){ee=ee||this.renderer;var ge="",be,Le,fe,_e=K.length;for(be=0;be<_e;be++){if(Le=K[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Le.type]&&(fe=this.options.extensions.renderers[Le.type].call({parser:this},Le),fe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Le.type))){ge+=fe||"";continue}switch(Le.type){case"escape":{ge+=ee.text(Le.text);break}case"html":{ge+=ee.html(Le.text);break}case"link":{ge+=ee.link(Le.href,Le.title,this.parseInline(Le.tokens,ee));break}case"image":{ge+=ee.image(Le.href,Le.title,Le.text);break}case"strong":{ge+=ee.strong(this.parseInline(Le.tokens,ee));break}case"em":{ge+=ee.em(this.parseInline(Le.tokens,ee));break}case"codespan":{ge+=ee.codespan(Le.text);break}case"br":{ge+=ee.br();break}case"del":{ge+=ee.del(this.parseInline(Le.tokens,ee));break}case"text":{ge+=ee.text(Le.text);break}default:{var F='Token with "'+Le.type+'" type was not found.';if(this.options.silent){console.error(F);return}else throw new Error(F)}}}return ge},ke}();function ve(ke,ce,te){if(typeof ke>"u"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof ce=="function"&&(te=ce,ce=null),ce=w({},ve.defaults,ce||{}),y(ce),te){var K=ce.highlight,ee;try{ee=oe.lex(ke,ce)}catch(_e){return te(_e)}var ge=function(F){var V;if(!F)try{ce.walkTokens&&ve.walkTokens(ee,ce.walkTokens),V=le.parse(ee,ce)}catch(j){F=j}return ce.highlight=K,F?te(F):te(null,V)};if(!K||K.length<3||(delete ce.highlight,!ee.length))return ge();var be=0;ve.walkTokens(ee,function(_e){_e.type==="code"&&(be++,setTimeout(function(){K(_e.text,_e.lang,function(F,V){if(F)return ge(F);V!=null&&V!==_e.text&&(_e.text=V,_e.escaped=!0),be--,be===0&&ge()})},0))}),be===0&&ge();return}function Le(_e){if(_e.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+E(_e.message+"",!0)+"</pre>";throw _e}try{var fe=oe.lex(ke,ce);if(ce.walkTokens){if(ce.async)return Promise.all(ve.walkTokens(fe,ce.walkTokens)).then(function(){return le.parse(fe,ce)}).catch(Le);ve.walkTokens(fe,ce.walkTokens)}return le.parse(fe,ce)}catch(_e){Le(_e)}}ve.options=ve.setOptions=function(ke){return w(ve.defaults,ke),g(ve.defaults),ve},ve.getDefaults=T,ve.defaults=me.defaults,ve.use=function(){for(var ke=arguments.length,ce=new Array(ke),te=0;te<ke;te++)ce[te]=arguments[te];var K=w.apply(void 0,[{}].concat(ce)),ee=ve.defaults.extensions||{renderers:{},childTokens:{}},ge;ce.forEach(function(be){if(be.extensions&&(ge=!0,be.extensions.forEach(function(fe){if(!fe.name)throw new Error("extension name required");if(fe.renderer){var _e=ee.renderers?ee.renderers[fe.name]:null;_e?ee.renderers[fe.name]=function(){for(var F=arguments.length,V=new Array(F),j=0;j<F;j++)V[j]=arguments[j];var B=fe.renderer.apply(this,V);return B===!1&&(B=_e.apply(this,V)),B}:ee.renderers[fe.name]=fe.renderer}if(fe.tokenizer){if(!fe.level||fe.level!=="block"&&fe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ee[fe.level]?ee[fe.level].unshift(fe.tokenizer):ee[fe.level]=[fe.tokenizer],fe.start&&(fe.level==="block"?ee.startBlock?ee.startBlock.push(fe.start):ee.startBlock=[fe.start]:fe.level==="inline"&&(ee.startInline?ee.startInline.push(fe.start):ee.startInline=[fe.start]))}fe.childTokens&&(ee.childTokens[fe.name]=fe.childTokens)})),be.renderer&&function(){var fe=ve.defaults.renderer||new de,_e=function(j){var B=fe[j];fe[j]=function(){for(var X=arguments.length,Z=new Array(X),Se=0;Se<X;Se++)Z[Se]=arguments[Se];var Ne=be.renderer[j].apply(fe,Z);return Ne===!1&&(Ne=B.apply(fe,Z)),Ne}};for(var F in be.renderer)_e(F);K.renderer=fe}(),be.tokenizer&&function(){var fe=ve.defaults.tokenizer||new W,_e=function(j){var B=fe[j];fe[j]=function(){for(var X=arguments.length,Z=new Array(X),Se=0;Se<X;Se++)Z[Se]=arguments[Se];var Ne=be.tokenizer[j].apply(fe,Z);return Ne===!1&&(Ne=B.apply(fe,Z)),Ne}};for(var F in be.tokenizer)_e(F);K.tokenizer=fe}(),be.walkTokens){var Le=ve.defaults.walkTokens;K.walkTokens=function(fe){var _e=[];return _e.push(be.walkTokens.call(this,fe)),Le&&(_e=_e.concat(Le.call(this,fe))),_e}}ge&&(K.extensions=ee),ve.setOptions(K)})},ve.walkTokens=function(ke,ce){for(var te=[],K=function(){var Le=ge.value;switch(te=te.concat(ce.call(ve,Le)),Le.type){case"table":{for(var fe=A(Le.header),_e;!(_e=fe()).done;){var F=_e.value;te=te.concat(ve.walkTokens(F.tokens,ce))}for(var V=A(Le.rows),j;!(j=V()).done;)for(var B=j.value,X=A(B),Z;!(Z=X()).done;){var Se=Z.value;te=te.concat(ve.walkTokens(Se.tokens,ce))}break}case"list":{te=te.concat(ve.walkTokens(Le.items,ce));break}default:ve.defaults.extensions&&ve.defaults.extensions.childTokens&&ve.defaults.extensions.childTokens[Le.type]?ve.defaults.extensions.childTokens[Le.type].forEach(function(Ne){te=te.concat(ve.walkTokens(Le[Ne],ce))}):Le.tokens&&(te=te.concat(ve.walkTokens(Le.tokens,ce)))}},ee=A(ke),ge;!(ge=ee()).done;)K();return te},ve.parseInline=function(ke,ce){if(typeof ke>"u"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");ce=w({},ve.defaults,ce||{}),y(ce);try{var te=oe.lexInline(ke,ce);return ce.walkTokens&&ve.walkTokens(te,ce.walkTokens),le.parseInline(te,ce)}catch(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+E(K.message+"",!0)+"</pre>";throw K}},ve.Parser=le,ve.parser=le.parse,ve.Renderer=de,ve.TextRenderer=we,ve.Lexer=oe,ve.lexer=oe.lex,ve.Tokenizer=W,ve.Slugger=ye,ve.parse=ve;var ae=ve.options,pe=ve.setOptions,re=ve.use,J=ve.walkTokens,H=ve.parseInline,ne=ve,Ae=le.parse,Re=oe.lex;me.Lexer=oe,me.Parser=le,me.Renderer=de,me.Slugger=ye,me.TextRenderer=we,me.Tokenizer=W,me.getDefaults=T,me.lexer=Re,me.marked=ve,me.options=ae,me.parse=ne,me.parseInline=H,me.parser=Ae,me.setOptions=pe,me.use=re,me.walkTokens=J,Object.defineProperty(me,"__esModule",{value:!0})}),define(Pe[121],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getKoreanAltChars=void 0;function I(i){const a=A(i);if(a&&a.length>0)return new Uint32Array(a)}e.getKoreanAltChars=I;let L=0;const C=new Uint32Array(10);function A(i){if(L=0,T(i,D,4352),L>0||(T(i,u,4449),L>0)||(T(i,p,4520),L>0)||(T(i,E,12593),L))return C.subarray(0,L);if(i>=44032&&i<=55203){const a=i-44032,r=a%588,n=Math.floor(a/588),o=Math.floor(r/28),c=r%28-1;if(n<D.length?T(n,D,0):4352+n-12593<E.length&&T(4352+n,E,12593),o<u.length?T(o,u,0):4449+o-12593<E.length&&T(4449+o-12593,E,12593),c>=0&&(c<p.length?T(c,p,0):4520+c-12593<E.length&&T(4520+c-12593,E,12593)),L>0)return C.subarray(0,L)}}function T(i,a,r){i>=r&&i<r+a.length&&g(a[i-r])}function g(i){i!==0&&(C[L++]=i&255,i>>8&&(C[L++]=i>>8&255),i>>16&&(C[L++]=i>>16&255))}var h;(function(i){i[i.InitialConsonant=4352]="InitialConsonant",i[i.Vowel=4449]="Vowel",i[i.FinalConsonant=4520]="FinalConsonant",i[i.CompatibilityJamo=12593]="CompatibilityJamo"})(h||(h={}));var S;(function(i){i[i.NUL=0]="NUL",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z"})(S||(S={}));var R;(function(i){i[i.fa=24934]="fa",i[i.fg=26470]="fg",i[i.fq=29030]="fq",i[i.fr=29286]="fr",i[i.ft=29798]="ft",i[i.fv=30310]="fv",i[i.fx=30822]="fx",i[i.hk=27496]="hk",i[i.hl=27752]="hl",i[i.ho=28520]="ho",i[i.ml=27757]="ml",i[i.nj=27246]="nj",i[i.nl=27758]="nl",i[i.np=28782]="np",i[i.qt=29809]="qt",i[i.rt=29810]="rt",i[i.sg=26483]="sg",i[i.sw=30579]="sw"})(R||(R={}));const D=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),u=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),p=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),E=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Pe[122],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function I(g,h,S){return Math.min(Math.max(g,h),S)}e.clamp=I;function L(g,h){return(h+g%h)%h}e.rot=L;class C{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=C;class A{constructor(){this._n=1,this._val=0}update(h){return this._val=this._val+(h-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class T{constructor(h){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(h),this._values.fill(0,0,h)}update(h){const S=this._values[this._index];return this._values[this._index]=h,this._index=(this._index+1)%this._values.length,this._sum-=S,this._sum+=h,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=T}),function(){function me(C){const A=[];typeof C=="number"&&A.push("code/timeOrigin",C);function T(h){A.push(h,Date.now())}function g(){const h=[];for(let S=0;S<A.length;S+=2)h.push({name:A[S],startTime:A[S+1]});return h}return{mark:T,getMarks:g}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const T of performance.getEntriesByType("mark"))A.push({name:T.name,startTime:Math.round(C+T.startTime)});return A}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function I(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=I(L))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var L in I)(typeof exports=="object"?exports:me)[L]=I[L]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function I(L){if(e[L])return e[L].exports;var C=e[L]={i:L,l:!1,exports:{}};return me[L].call(C.exports,C,C.exports,I),C.l=!0,C.exports}return I.m=me,I.c=e,I.d=function(L,C,A){I.o(L,C)||Object.defineProperty(L,C,{enumerable:!0,get:A})},I.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},I.t=function(L,C){if(1&C&&(L=I(L)),8&C||4&C&&typeof L=="object"&&L&&L.__esModule)return L;var A=Object.create(null);if(I.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:L}),2&C&&typeof L!="string")for(var T in L)I.d(A,T,function(g){return L[g]}.bind(null,T));return A},I.n=function(L){var C=L&&L.__esModule?function(){return L.default}:function(){return L};return I.d(C,"a",C),C},I.o=function(L,C){return Object.prototype.hasOwnProperty.call(L,C)},I.p="",I(I.s=0)}([function(me,e,I){(function(L){var C;e=me.exports=re,C=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,g=e.re=[],h=e.src=[],S=0,R=S++;h[R]="0|[1-9]\\d*";var D=S++;h[D]="[0-9]+";var u=S++;h[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=S++;h[p]="("+h[R]+")\\.("+h[R]+")\\.("+h[R]+")";var E=S++;h[E]="("+h[D]+")\\.("+h[D]+")\\.("+h[D]+")";var i=S++;h[i]="(?:"+h[R]+"|"+h[u]+")";var a=S++;h[a]="(?:"+h[D]+"|"+h[u]+")";var r=S++;h[r]="(?:-("+h[i]+"(?:\\."+h[i]+")*))";var n=S++;h[n]="(?:-?("+h[a]+"(?:\\."+h[a]+")*))";var o=S++;h[o]="[0-9A-Za-z-]+";var c=S++;h[c]="(?:\\+("+h[o]+"(?:\\."+h[o]+")*))";var l=S++,t="v?"+h[p]+h[r]+"?"+h[c]+"?";h[l]="^"+t+"$";var d="[v=\\s]*"+h[E]+h[n]+"?"+h[c]+"?",s=S++;h[s]="^"+d+"$";var b=S++;h[b]="((?:<|>)?=?)";var _=S++;h[_]=h[D]+"|x|X|\\*";var f=S++;h[f]=h[R]+"|x|X|\\*";var w=S++;h[w]="[v=\\s]*("+h[f]+")(?:\\.("+h[f]+")(?:\\.("+h[f]+")(?:"+h[r]+")?"+h[c]+"?)?)?";var P=S++;h[P]="[v=\\s]*("+h[_]+")(?:\\.("+h[_]+")(?:\\.("+h[_]+")(?:"+h[n]+")?"+h[c]+"?)?)?";var m=S++;h[m]="^"+h[b]+"\\s*"+h[w]+"$";var v=S++;h[v]="^"+h[b]+"\\s*"+h[P]+"$";var y=S++;h[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=S++;h[O]="(?:~>?)";var N=S++;h[N]="(\\s*)"+h[O]+"\\s+",g[N]=new RegExp(h[N],"g");var q=S++;h[q]="^"+h[O]+h[w]+"$";var W=S++;h[W]="^"+h[O]+h[P]+"$";var x=S++;h[x]="(?:\\^)";var k=S++;h[k]="(\\s*)"+h[x]+"\\s+",g[k]=new RegExp(h[k],"g");var M=S++;h[M]="^"+h[x]+h[w]+"$";var $=S++;h[$]="^"+h[x]+h[P]+"$";var oe=S++;h[oe]="^"+h[b]+"\\s*("+d+")$|^$";var de=S++;h[de]="^"+h[b]+"\\s*("+t+")$|^$";var we=S++;h[we]="(\\s*)"+h[b]+"\\s*("+d+"|"+h[w]+")",g[we]=new RegExp(h[we],"g");var ye=S++;h[ye]="^\\s*("+h[w]+")\\s+-\\s+("+h[w]+")\\s*$";var le=S++;h[le]="^\\s*("+h[P]+")\\s+-\\s+("+h[P]+")\\s*$";var ve=S++;h[ve]="(<|>)?=?\\s*\\*";for(var ae=0;ae<35;ae++)C(ae,h[ae]),g[ae]||(g[ae]=new RegExp(h[ae]));function pe(B,X){if(B instanceof re)return B;if(typeof B!="string"||B.length>A||!(X?g[s]:g[l]).test(B))return null;try{return new re(B,X)}catch{return null}}function re(B,X){if(B instanceof re){if(B.loose===X)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof re))return new re(B,X);C("SemVer",B,X),this.loose=X;var Z=B.trim().match(X?g[s]:g[l]);if(!Z)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+Z[1],this.minor=+Z[2],this.patch=+Z[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");Z[4]?this.prerelease=Z[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Ne=+Se;if(Ne>=0&&Ne<T)return Ne}return Se}):this.prerelease=[],this.build=Z[5]?Z[5].split("."):[],this.format()}e.parse=pe,e.valid=function(B,X){var Z=pe(B,X);return Z?Z.version:null},e.clean=function(B,X){var Z=pe(B.trim().replace(/^[=v]+/,""),X);return Z?Z.version:null},e.SemVer=re,re.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},re.prototype.toString=function(){return this.version},re.prototype.compare=function(B){return C("SemVer.compare",this.version,this.loose,B),B instanceof re||(B=new re(B,this.loose)),this.compareMain(B)||this.comparePre(B)},re.prototype.compareMain=function(B){return B instanceof re||(B=new re(B,this.loose)),H(this.major,B.major)||H(this.minor,B.minor)||H(this.patch,B.patch)},re.prototype.comparePre=function(B){if(B instanceof re||(B=new re(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var X=0;do{var Z=this.prerelease[X],Se=B.prerelease[X];if(C("prerelease compare",X,Z,Se),Z===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(Z===void 0)return-1;if(Z!==Se)return H(Z,Se)}while(++X)},re.prototype.inc=function(B,X){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",X);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",X);break;case"prepatch":this.prerelease.length=0,this.inc("patch",X),this.inc("pre",X);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",X),this.inc("pre",X);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Z=this.prerelease.length;--Z>=0;)typeof this.prerelease[Z]=="number"&&(this.prerelease[Z]++,Z=-2);Z===-1&&this.prerelease.push(0)}X&&(this.prerelease[0]===X?isNaN(this.prerelease[1])&&(this.prerelease=[X,0]):this.prerelease=[X,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,X,Z,Se){typeof Z=="string"&&(Se=Z,Z=void 0);try{return new re(B,Z).inc(X,Se).version}catch{return null}},e.diff=function(B,X){if(ke(B,X))return null;var Z=pe(B),Se=pe(X);if(Z.prerelease.length||Se.prerelease.length){for(var Ne in Z)if((Ne==="major"||Ne==="minor"||Ne==="patch")&&Z[Ne]!==Se[Ne])return"pre"+Ne;return"prerelease"}for(var Ne in Z)if((Ne==="major"||Ne==="minor"||Ne==="patch")&&Z[Ne]!==Se[Ne])return Ne},e.compareIdentifiers=H;var J=/^[0-9]+$/;function H(B,X){var Z=J.test(B),Se=J.test(X);return Z&&Se&&(B=+B,X=+X),Z&&!Se?-1:Se&&!Z?1:B<X?-1:B>X?1:0}function ne(B,X,Z){return new re(B,Z).compare(new re(X,Z))}function Ae(B,X,Z){return ne(B,X,Z)>0}function Re(B,X,Z){return ne(B,X,Z)<0}function ke(B,X,Z){return ne(B,X,Z)===0}function ce(B,X,Z){return ne(B,X,Z)!==0}function te(B,X,Z){return ne(B,X,Z)>=0}function K(B,X,Z){return ne(B,X,Z)<=0}function ee(B,X,Z,Se){var Ne;switch(X){case"===":typeof B=="object"&&(B=B.version),typeof Z=="object"&&(Z=Z.version),Ne=B===Z;break;case"!==":typeof B=="object"&&(B=B.version),typeof Z=="object"&&(Z=Z.version),Ne=B!==Z;break;case"":case"=":case"==":Ne=ke(B,Z,Se);break;case"!=":Ne=ce(B,Z,Se);break;case">":Ne=Ae(B,Z,Se);break;case">=":Ne=te(B,Z,Se);break;case"<":Ne=Re(B,Z,Se);break;case"<=":Ne=K(B,Z,Se);break;default:throw new TypeError("Invalid operator: "+X)}return Ne}function ge(B,X){if(B instanceof ge){if(B.loose===X)return B;B=B.value}if(!(this instanceof ge))return new ge(B,X);C("comparator",B,X),this.loose=X,this.parse(B),this.semver===be?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(B,X){return H(X,B)},e.major=function(B,X){return new re(B,X).major},e.minor=function(B,X){return new re(B,X).minor},e.patch=function(B,X){return new re(B,X).patch},e.compare=ne,e.compareLoose=function(B,X){return ne(B,X,!0)},e.rcompare=function(B,X,Z){return ne(X,B,Z)},e.sort=function(B,X){return B.sort(function(Z,Se){return e.compare(Z,Se,X)})},e.rsort=function(B,X){return B.sort(function(Z,Se){return e.rcompare(Z,Se,X)})},e.gt=Ae,e.lt=Re,e.eq=ke,e.neq=ce,e.gte=te,e.lte=K,e.cmp=ee,e.Comparator=ge;var be={};function Le(B,X){if(B instanceof Le)return B.loose===X?B:new Le(B.raw,X);if(B instanceof ge)return new Le(B.value,X);if(!(this instanceof Le))return new Le(B,X);if(this.loose=X,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(Z){return this.parseRange(Z.trim())},this).filter(function(Z){return Z.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function fe(B){return!B||B.toLowerCase()==="x"||B==="*"}function _e(B,X,Z,Se,Ne,$e,qe,Qe,nt,it,et,rt,ct){return((X=fe(Z)?"":fe(Se)?">="+Z+".0.0":fe(Ne)?">="+Z+"."+Se+".0":">="+X)+" "+(Qe=fe(nt)?"":fe(it)?"<"+(+nt+1)+".0.0":fe(et)?"<"+nt+"."+(+it+1)+".0":rt?"<="+nt+"."+it+"."+et+"-"+rt:"<="+Qe)).trim()}function F(B,X){for(var Z=0;Z<B.length;Z++)if(!B[Z].test(X))return!1;if(X.prerelease.length){for(Z=0;Z<B.length;Z++)if(C(B[Z].semver),B[Z].semver!==be&&B[Z].semver.prerelease.length>0){var Se=B[Z].semver;if(Se.major===X.major&&Se.minor===X.minor&&Se.patch===X.patch)return!0}return!1}return!0}function V(B,X,Z){try{X=new Le(X,Z)}catch{return!1}return X.test(B)}function j(B,X,Z,Se){var Ne,$e,qe,Qe,nt;switch(B=new re(B,Se),X=new Le(X,Se),Z){case">":Ne=Ae,$e=K,qe=Re,Qe=">",nt=">=";break;case"<":Ne=Re,$e=te,qe=Ae,Qe="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(V(B,X,Se))return!1;for(var it=0;it<X.set.length;++it){var et=X.set[it],rt=null,ct=null;if(et.forEach(function(Be){Be.semver===be&&(Be=new ge(">=0.0.0")),rt=rt||Be,ct=ct||Be,Ne(Be.semver,rt.semver,Se)?rt=Be:qe(Be.semver,ct.semver,Se)&&(ct=Be)}),rt.operator===Qe||rt.operator===nt||(!ct.operator||ct.operator===Qe)&&$e(B,ct.semver)||ct.operator===nt&&qe(B,ct.semver))return!1}return!0}ge.prototype.parse=function(B){var X=this.loose?g[oe]:g[de],Z=B.match(X);if(!Z)throw new TypeError("Invalid comparator: "+B);this.operator=Z[1],this.operator==="="&&(this.operator=""),Z[2]?this.semver=new re(Z[2],this.loose):this.semver=be},ge.prototype.toString=function(){return this.value},ge.prototype.test=function(B){return C("Comparator.test",B,this.loose),this.semver===be||(typeof B=="string"&&(B=new re(B,this.loose)),ee(B,this.operator,this.semver,this.loose))},ge.prototype.intersects=function(B,X){if(!(B instanceof ge))throw new TypeError("a Comparator is required");var Z;if(this.operator==="")return Z=new Le(B.value,X),V(this.value,Z,X);if(B.operator==="")return Z=new Le(this.value,X),V(B.semver,Z,X);var Se=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),Ne=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),$e=this.semver.version===B.semver.version,qe=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),Qe=ee(this.semver,"<",B.semver,X)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),nt=ee(this.semver,">",B.semver,X)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return Se||Ne||$e&&qe||Qe||nt},e.Range=Le,Le.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},Le.prototype.toString=function(){return this.range},Le.prototype.parseRange=function(B){var X=this.loose;B=B.trim(),C("range",B,X);var Z=X?g[le]:g[ye];B=B.replace(Z,_e),C("hyphen replace",B),B=B.replace(g[we],"$1$2$3"),C("comparator trim",B,g[we]),B=(B=(B=B.replace(g[N],"$1~")).replace(g[k],"$1^")).split(/\s+/).join(" ");var Se=X?g[oe]:g[de],Ne=B.split(" ").map(function($e){return function(qe,Qe){return C("comp",qe),qe=function(nt,it){return nt.trim().split(/\s+/).map(function(et){return function(rt,ct){C("caret",rt,ct);var Be=ct?g[$]:g[M];return rt.replace(Be,function(gt,Q,Y,Ee,ze){var Ge;return C("caret",rt,gt,Q,Y,Ee,ze),fe(Q)?Ge="":fe(Y)?Ge=">="+Q+".0.0 <"+(+Q+1)+".0.0":fe(Ee)?Ge=Q==="0"?">="+Q+"."+Y+".0 <"+Q+"."+(+Y+1)+".0":">="+Q+"."+Y+".0 <"+(+Q+1)+".0.0":ze?(C("replaceCaret pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ge=Q==="0"?Y==="0"?">="+Q+"."+Y+"."+Ee+ze+" <"+Q+"."+Y+"."+(+Ee+1):">="+Q+"."+Y+"."+Ee+ze+" <"+Q+"."+(+Y+1)+".0":">="+Q+"."+Y+"."+Ee+ze+" <"+(+Q+1)+".0.0"):(C("no pr"),Ge=Q==="0"?Y==="0"?">="+Q+"."+Y+"."+Ee+" <"+Q+"."+Y+"."+(+Ee+1):">="+Q+"."+Y+"."+Ee+" <"+Q+"."+(+Y+1)+".0":">="+Q+"."+Y+"."+Ee+" <"+(+Q+1)+".0.0"),C("caret return",Ge),Ge})}(et,it)}).join(" ")}(qe,Qe),C("caret",qe),qe=function(nt,it){return nt.trim().split(/\s+/).map(function(et){return function(rt,ct){var Be=ct?g[W]:g[q];return rt.replace(Be,function(gt,Q,Y,Ee,ze){var Ge;return C("tilde",rt,gt,Q,Y,Ee,ze),fe(Q)?Ge="":fe(Y)?Ge=">="+Q+".0.0 <"+(+Q+1)+".0.0":fe(Ee)?Ge=">="+Q+"."+Y+".0 <"+Q+"."+(+Y+1)+".0":ze?(C("replaceTilde pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ge=">="+Q+"."+Y+"."+Ee+ze+" <"+Q+"."+(+Y+1)+".0"):Ge=">="+Q+"."+Y+"."+Ee+" <"+Q+"."+(+Y+1)+".0",C("tilde return",Ge),Ge})}(et,it)}).join(" ")}(qe,Qe),C("tildes",qe),qe=function(nt,it){return C("replaceXRanges",nt,it),nt.split(/\s+/).map(function(et){return function(rt,ct){rt=rt.trim();var Be=ct?g[v]:g[m];return rt.replace(Be,function(gt,Q,Y,Ee,ze,Ge){C("xRange",rt,gt,Q,Y,Ee,ze,Ge);var tt=fe(Y),st=tt||fe(Ee),Fe=st||fe(ze);return Q==="="&&Fe&&(Q=""),tt?gt=Q===">"||Q==="<"?"<0.0.0":"*":Q&&Fe?(st&&(Ee=0),Fe&&(ze=0),Q===">"?(Q=">=",st?(Y=+Y+1,Ee=0,ze=0):Fe&&(Ee=+Ee+1,ze=0)):Q==="<="&&(Q="<",st?Y=+Y+1:Ee=+Ee+1),gt=Q+Y+"."+Ee+"."+ze):st?gt=">="+Y+".0.0 <"+(+Y+1)+".0.0":Fe&&(gt=">="+Y+"."+Ee+".0 <"+Y+"."+(+Ee+1)+".0"),C("xRange return",gt),gt})}(et,it)}).join(" ")}(qe,Qe),C("xrange",qe),qe=function(nt,it){return C("replaceStars",nt,it),nt.trim().replace(g[ve],"")}(qe,Qe),C("stars",qe),qe}($e,X)}).join(" ").split(/\s+/);return this.loose&&(Ne=Ne.filter(function($e){return!!$e.match(Se)})),Ne=Ne.map(function($e){return new ge($e,X)})},Le.prototype.intersects=function(B,X){if(!(B instanceof Le))throw new TypeError("a Range is required");return this.set.some(function(Z){return Z.every(function(Se){return B.set.some(function(Ne){return Ne.every(function($e){return Se.intersects($e,X)})})})})},e.toComparators=function(B,X){return new Le(B,X).set.map(function(Z){return Z.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},Le.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new re(B,this.loose));for(var X=0;X<this.set.length;X++)if(F(this.set[X],B))return!0;return!1},e.satisfies=V,e.maxSatisfying=function(B,X,Z){var Se=null,Ne=null;try{var $e=new Le(X,Z)}catch{return null}return B.forEach(function(qe){$e.test(qe)&&(Se&&Ne.compare(qe)!==-1||(Ne=new re(Se=qe,Z)))}),Se},e.minSatisfying=function(B,X,Z){var Se=null,Ne=null;try{var $e=new Le(X,Z)}catch{return null}return B.forEach(function(qe){$e.test(qe)&&(Se&&Ne.compare(qe)!==1||(Ne=new re(Se=qe,Z)))}),Se},e.validRange=function(B,X){try{return new Le(B,X).range||"*"}catch{return null}},e.ltr=function(B,X,Z){return j(B,X,"<",Z)},e.gtr=function(B,X,Z){return j(B,X,">",Z)},e.outside=j,e.prerelease=function(B,X){var Z=pe(B,X);return Z&&Z.prerelease.length?Z.prerelease:null},e.intersects=function(B,X,Z){return B=new Le(B,Z),X=new Le(X,Z),B.intersects(X)},e.coerce=function(B){if(B instanceof re)return B;if(typeof B!="string")return null;var X=B.match(g[y]);return X==null?null:pe((X[1]||"0")+"."+(X[2]||"0")+"."+(X[3]||"0"))}}).call(this,I(1))},function(me,e){var I,L,C=me.exports={};function A(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function g(a){if(I===setTimeout)return setTimeout(a,0);if((I===A||!I)&&setTimeout)return I=setTimeout,setTimeout(a,0);try{return I(a,0)}catch{try{return I.call(null,a,0)}catch{return I.call(this,a,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:A}catch{I=A}try{L=typeof clearTimeout=="function"?clearTimeout:T}catch{L=T}})();var h,S=[],R=!1,D=-1;function u(){R&&h&&(R=!1,h.length?S=h.concat(S):D=-1,S.length&&p())}function p(){if(!R){var a=g(u);R=!0;for(var r=S.length;r;){for(h=S,S=[];++D<r;)h&&h[D].run();D=-1,r=S.length}h=null,R=!1,function(n){if(L===clearTimeout)return clearTimeout(n);if((L===T||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(n);try{L(n)}catch{try{return L.call(null,n)}catch{return L.call(this,n)}}}(a)}}function E(a,r){this.fun=a,this.array=r}function i(){}C.nextTick=function(a){var r=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)r[n-1]=arguments[n];S.push(new E(a,r)),S.length!==1||R||g(p)},E.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=i,C.addListener=i,C.once=i,C.off=i,C.removeListener=i,C.removeAllListeners=i,C.emit=i,C.prependListener=i,C.prependOnceListener=i,C.listeners=function(a){return[]},C.binding=function(a){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(a){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Pe[123],Te([1,0,15,6]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function C(c){const l=c;return l?typeof l.read=="function":!1}e.isReadable=C;function A(c){const l=c;return l?[l.on,l.pause,l.resume,l.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=A;function T(c){const l=c;return l?A(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=T;function g(c,l){return new h(c,l)}e.newWriteableStream=g;class h{constructor(l,t){this.reducer=l,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l<"u"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(t=>t(l))}emitError(l){this.listeners.error.length===0?(0,I.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(t=>t(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,t){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(l,t){if(this.state.destroyed)return;let d;switch(l){case"data":d=this.listeners.data;break;case"end":d=this.listeners.end;break;case"error":d=this.listeners.error;break}if(d){const s=d.indexOf(t);s>=0&&d.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(d=>d())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(c,l){const t=[];let d;for(;(d=c.read())!==null;)t.push(d);return l(t)}e.consumeReadable=S;function R(c,l,t){const d=[];let s;for(;(s=c.read())!==null&&d.length<t;)d.push(s);return s===null&&d.length>0?l(d):{read:()=>{if(d.length>0)return d.shift();if(typeof s<"u"){const b=s;return s=void 0,b}return c.read()}}}e.peekReadable=R;function D(c,l){return new Promise((t,d)=>{const s=[];u(c,{onData:b=>{l&&s.push(b)},onError:b=>{l?d(b):t(void 0)},onEnd:()=>{t(l?l(s):void 0)}})})}e.consumeStream=D;function u(c,l,t){c.on("error",d=>{t?.isCancellationRequested||l.onError(d)}),c.on("end",()=>{t?.isCancellationRequested||l.onEnd()}),c.on("data",d=>{t?.isCancellationRequested||l.onData(d)})}e.listenStream=u;function p(c,l){return new Promise((t,d)=>{const s=new L.DisposableStore,b=[],_=P=>{if(b.push(P),b.length>l)return s.dispose(),c.pause(),t({stream:c,buffer:b,ended:!1})},f=P=>(s.dispose(),d(P)),w=()=>(s.dispose(),t({stream:c,buffer:b,ended:!0}));s.add((0,L.toDisposable)(()=>c.removeListener("error",f))),c.on("error",f),s.add((0,L.toDisposable)(()=>c.removeListener("end",w))),c.on("end",w),s.add((0,L.toDisposable)(()=>c.removeListener("data",_))),c.on("data",_)})}e.peekStream=p;function E(c,l){const t=g(l);return t.end(c),t}e.toStream=E;function i(){const c=g(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=i;function a(c){let l=!1;return{read:()=>l?null:(l=!0,c)}}e.toReadable=a;function r(c,l,t){const d=g(t);return u(c,{onData:s=>d.write(l.data(s)),onError:s=>d.error(l.error?l.error(s):s),onEnd:()=>d.end()}),d}e.transform=r;function n(c,l,t){let d=!1;return{read:()=>{const s=l.read();return d?s:(d=!0,s!==null?t([c,s]):c)}}}e.prefixedReadable=n;function o(c,l,t){let d=!1;const s=g(t);return u(l,{onData:b=>d?s.write(b):(d=!0,s.write(t([c,b]))),onError:b=>s.error(b),onEnd:()=>{d||(d=!0,s.write(c)),s.end()}}),s}e.prefixedStream=o}),define(Pe[23],Te([1,0,39,123]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const C=typeof Buffer<"u",A=new I.Lazy(()=>new Uint8Array(256));let T,g;class h{static alloc(y){return C?new h(Buffer.allocUnsafe(y)):new h(new Uint8Array(y))}static wrap(y){return C&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new h(y)}static fromString(y,O){return!(O?.dontUseNodeBuffer||!1)&&C?new h(Buffer.from(y)):(T||(T=new TextEncoder),new h(T.encode(y)))}static fromByteArray(y){const O=h.alloc(y.length);for(let N=0,q=y.length;N<q;N++)O.buffer[N]=y[N];return O}static concat(y,O){if(typeof O>"u"){O=0;for(let W=0,x=y.length;W<x;W++)O+=y[W].byteLength}const N=h.alloc(O);let q=0;for(let W=0,x=y.length;W<x;W++){const k=y[W];N.set(k,q),q+=k.byteLength}return N}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=h.alloc(this.byteLength);return y.set(this),y}toString(){return C?this.buffer.toString():(g||(g=new TextDecoder),g.decode(this.buffer))}slice(y,O){return new h(this.buffer.subarray(y,O))}set(y,O){if(y instanceof h)this.buffer.set(y.buffer,O);else if(y instanceof Uint8Array)this.buffer.set(y,O);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),O);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return u(this.buffer,y)}writeUInt32BE(y,O){p(this.buffer,y,O)}readUInt32LE(y){return E(this.buffer,y)}writeUInt32LE(y,O){i(this.buffer,y,O)}readUInt8(y){return a(this.buffer,y)}writeUInt8(y,O){r(this.buffer,y,O)}indexOf(y,O=0){return S(this.buffer,y instanceof h?y.buffer:y,O)}}e.VSBuffer=h;function S(v,y,O=0){const N=y.byteLength,q=v.byteLength;if(N===0)return 0;if(N===1)return v.indexOf(y[0]);if(N>q-O)return-1;const W=A.value;W.fill(y.length);for(let $=0;$<y.length;$++)W[y[$]]=y.length-$-1;let x=O+y.length-1,k=x,M=-1;for(;x<q;)if(v[x]===y[k]){if(k===0){M=x;break}x--,k--}else x+=Math.max(y.length-k,W[v[x]]),k=y.length-1;return M}e.binaryIndexOf=S;function R(v,y){return v[y+0]<<0>>>0|v[y+1]<<8>>>0}e.readUInt16LE=R;function D(v,y,O){v[O+0]=y&255,y=y>>>8,v[O+1]=y&255}e.writeUInt16LE=D;function u(v,y){return v[y]*2**24+v[y+1]*2**16+v[y+2]*2**8+v[y+3]}e.readUInt32BE=u;function p(v,y,O){v[O+3]=y,y=y>>>8,v[O+2]=y,y=y>>>8,v[O+1]=y,y=y>>>8,v[O]=y}e.writeUInt32BE=p;function E(v,y){return v[y+0]<<0>>>0|v[y+1]<<8>>>0|v[y+2]<<16>>>0|v[y+3]<<24>>>0}e.readUInt32LE=E;function i(v,y,O){v[O+0]=y&255,y=y>>>8,v[O+1]=y&255,y=y>>>8,v[O+2]=y&255,y=y>>>8,v[O+3]=y&255}e.writeUInt32LE=i;function a(v,y){return v[y]}e.readUInt8=a;function r(v,y,O){v[O]=y}e.writeUInt8=r;function n(v){return L.consumeReadable(v,y=>h.concat(y))}e.readableToBuffer=n;function o(v){return L.toReadable(v)}e.bufferToReadable=o;function c(v){return L.consumeStream(v,y=>h.concat(y))}e.streamToBuffer=c;async function l(v){return v.ended?h.concat(v.buffer):h.concat([...v.buffer,await c(v.stream)])}e.bufferedStreamToBuffer=l;function t(v){return L.toStream(v,y=>h.concat(y))}e.bufferToStream=t;function d(v){return L.transform(v,{data:y=>typeof y=="string"?h.fromString(y):h.wrap(y)},y=>h.concat(y))}e.streamToBufferReadableStream=d;function s(v){return L.newWriteableStream(y=>h.concat(y),v)}e.newWriteableBufferStream=s;function b(v,y){return L.prefixedReadable(v,y,O=>h.concat(O))}e.prefixedBufferReadable=b;function _(v,y){return L.prefixedStream(v,y,O=>h.concat(O))}e.prefixedBufferStream=_;function f(v){let y=0,O=0,N=0;const q=new Uint8Array(Math.floor(v.length/4*3)),W=k=>{switch(O){case 3:q[N++]=y|k,O=0;break;case 2:q[N++]=y|k>>>2,y=k<<6,O=3;break;case 1:q[N++]=y|k>>>4,y=k<<4,O=2;break;default:y=k<<2,O=1}};for(let k=0;k<v.length;k++){const M=v.charCodeAt(k);if(M>=65&&M<=90)W(M-65);else if(M>=97&&M<=122)W(M-97+26);else if(M>=48&&M<=57)W(M-48+52);else if(M===43||M===45)W(62);else if(M===47||M===95)W(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${v[k]}`)}}const x=N;for(;O>0;)W(0);return h.wrap(q).slice(0,x)}e.decodeBase64=f;const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function m({buffer:v},y=!0,O=!1){const N=O?P:w;let q="";const W=v.byteLength%3;let x=0;for(;x<v.byteLength-W;x+=3){const k=v[x+0],M=v[x+1],$=v[x+2];q+=N[k>>>2],q+=N[(k<<4|M>>>4)&63],q+=N[(M<<2|$>>>6)&63],q+=N[$&63]}if(W===1){const k=v[x+0];q+=N[k>>>2],q+=N[k<<4&63],y&&(q+="==")}else if(W===2){const k=v[x+0],M=v[x+1];q+=N[k>>>2],q+=N[(k<<4|M>>>4)&63],q+=N[M<<2&63],y&&(q+="=")}return q}e.encodeBase64=m}),define(Pe[124],Te([1,0,28,121,12]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function A(...fe){return function(_e,F){for(let V=0,j=fe.length;V<j;V++){const B=fe[V](_e,F);if(B)return B}return null}}e.or=A,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(fe,_e,F){if(!F||F.length<_e.length)return null;let V;return fe?V=C.startsWithIgnoreCase(F,_e):V=F.indexOf(_e)===0,V?_e.length>0?[{start:0,end:_e.length}]:[]:null}function g(fe,_e){const F=_e.toLowerCase().indexOf(fe.toLowerCase());return F===-1?null:[{start:F,end:F+fe.length}]}e.matchesContiguousSubString=g;function h(fe,_e){return S(fe.toLowerCase(),_e.toLowerCase(),0,0)}e.matchesSubString=h;function S(fe,_e,F,V){if(F===fe.length)return[];if(V===_e.length)return null;if(fe[F]===_e[V]){let j=null;return(j=S(fe,_e,F+1,V+1))?c({start:V,end:V+1},j):null}return S(fe,_e,F,V+1)}function R(fe){return 97<=fe&&fe<=122}function D(fe){return 65<=fe&&fe<=90}e.isUpper=D;function u(fe){return 48<=fe&&fe<=57}function p(fe){return fe===32||fe===9||fe===10||fe===13}const E=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(fe=>E.add(fe.charCodeAt(0)));function i(fe){return p(fe)||E.has(fe)}function a(fe,_e){return fe===_e||i(fe)&&i(_e)}const r=new Map;function n(fe){if(r.has(fe))return r.get(fe);let _e;const F=(0,L.getKoreanAltChars)(fe);return F&&(_e=F),r.set(fe,_e),_e}function o(fe){return R(fe)||D(fe)||u(fe)}function c(fe,_e){return _e.length===0?_e=[fe]:fe.end===_e[0].start?_e[0].start=fe.start:_e.unshift(fe),_e}function l(fe,_e){for(let F=_e;F<fe.length;F++){const V=fe.charCodeAt(F);if(D(V)||u(V)||F>0&&!o(fe.charCodeAt(F-1)))return F}return fe.length}function t(fe,_e,F,V){if(F===fe.length)return[];if(V===_e.length)return null;if(fe[F]!==_e[V].toLowerCase())return null;{let j=null,B=V+1;for(j=t(fe,_e,F+1,V+1);!j&&(B=l(_e,B))<_e.length;)j=t(fe,_e,F+1,B),B++;return j===null?null:c({start:V,end:V+1},j)}}function d(fe){let _e=0,F=0,V=0,j=0,B=0;for(let $e=0;$e<fe.length;$e++)B=fe.charCodeAt($e),D(B)&&_e++,R(B)&&F++,o(B)&&V++,u(B)&&j++;const X=_e/fe.length,Z=F/fe.length,Se=V/fe.length,Ne=j/fe.length;return{upperPercent:X,lowerPercent:Z,alphaPercent:Se,numericPercent:Ne}}function s(fe){const{upperPercent:_e,lowerPercent:F}=fe;return F===0&&_e>.6}function b(fe){const{upperPercent:_e,lowerPercent:F,alphaPercent:V,numericPercent:j}=fe;return F>.2&&_e<.8&&V>.6&&j<.2}function _(fe){let _e=0,F=0,V=0,j=0;for(let B=0;B<fe.length;B++)V=fe.charCodeAt(B),D(V)&&_e++,R(V)&&F++,p(V)&&j++;return(_e===0||F===0)&&j===0?fe.length<=30:_e<=5}function f(fe,_e){if(!_e||(_e=_e.trim(),_e.length===0)||!_(fe)||_e.length>60)return null;const F=d(_e);if(!b(F)){if(!s(F))return null;_e=_e.toLowerCase()}let V=null,j=0;for(fe=fe.toLowerCase();j<_e.length&&(V=t(fe,_e,0,j))===null;)j=l(_e,j+1);return V}e.matchesCamelCase=f;function w(fe,_e,F=!1){if(!_e||_e.length===0)return null;let V=null,j=0;for(fe=fe.toLowerCase(),_e=_e.toLowerCase();j<_e.length&&(V=P(fe,_e,0,j,F),V===null);)j=m(_e,j+1);return V}e.matchesWords=w;function P(fe,_e,F,V,j){let B=0;if(F===fe.length)return[];if(V===_e.length)return null;if(!a(fe.charCodeAt(F),_e.charCodeAt(V))){const Se=n(fe.charCodeAt(F));if(!Se)return null;for(let Ne=0;Ne<Se.length;Ne++)if(!a(Se[Ne],_e.charCodeAt(V+Ne)))return null;B+=Se.length-1}let X=null,Z=V+B+1;if(X=P(fe,_e,F+1,Z,j),!j)for(;!X&&(Z=m(_e,Z))<_e.length;)X=P(fe,_e,F+1,Z,j),Z++;if(!X)return null;if(fe.charCodeAt(F)!==_e.charCodeAt(V)){const Se=n(fe.charCodeAt(F));if(!Se)return X;for(let Ne=0;Ne<Se.length;Ne++)if(Se[Ne]!==_e.charCodeAt(V+Ne))return X}return c({start:V,end:V+B+1},X)}function m(fe,_e){for(let F=_e;F<fe.length;F++)if(i(fe.charCodeAt(F))||F>0&&i(fe.charCodeAt(F-1)))return F;return fe.length}const v=A(e.matchesPrefix,f,g),y=A(e.matchesPrefix,f,h),O=new I.LRUCache(1e4);function N(fe,_e,F=!1){if(typeof fe!="string"||typeof _e!="string")return null;let V=O.get(fe);V||(V=new RegExp(C.convertSimple2RegExpPattern(fe),"i"),O.set(fe,V));const j=V.exec(_e);return j?[{start:j.index,end:j.index+j[0].length}]:F?y(fe,_e):v(fe,_e)}e.matchesFuzzy=N;function q(fe,_e){const F=ce(fe,fe.toLowerCase(),0,_e,_e.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return F?x(F):null}e.matchesFuzzy2=q;function W(fe,_e,F,V,j,B){const X=Math.min(13,fe.length);for(;F<X;F++){const Z=ce(fe,_e,F,V,j,B,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Z)return Z}return[0,B]}e.anyScore=W;function x(fe){if(typeof fe>"u")return[];const _e=[],F=fe[1];for(let V=fe.length-1;V>1;V--){const j=fe[V]+F,B=_e[_e.length-1];B&&B.end===j?B.end=j+1:_e.push({start:j,end:j+1})}return _e}e.createMatches=x;const k=128;function M(){const fe=[],_e=[];for(let F=0;F<=k;F++)_e[F]=0;for(let F=0;F<=k;F++)fe.push(_e.slice(0));return fe}function $(fe){const _e=[];for(let F=0;F<=fe;F++)_e[F]=0;return _e}const oe=$(2*k),de=$(2*k),we=M(),ye=M(),le=M(),ve=!1;function ae(fe,_e,F,V,j){function B(Z,Se,Ne=" "){for(;Z.length<Se;)Z=Ne+Z;return Z}let X=` |   |${V.split("").map(Z=>B(Z,3)).join("|")}
`;for(let Z=0;Z<=F;Z++)Z===0?X+=" |":X+=`${_e[Z-1]}|`,X+=fe[Z].slice(0,j+1).map(Se=>B(Se.toString(),3)).join("|")+`
`;return X}function pe(fe,_e,F,V){fe=fe.substr(_e),F=F.substr(V),console.log(ae(ye,fe,fe.length,F,F.length)),console.log(ae(le,fe,fe.length,F,F.length)),console.log(ae(we,fe,fe.length,F,F.length))}function re(fe,_e){if(_e<0||_e>=fe.length)return!1;const F=fe.codePointAt(_e);switch(F){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!C.isEmojiImprecise(F)}}function J(fe,_e){if(_e<0||_e>=fe.length)return!1;switch(fe.charCodeAt(_e)){case 32:case 9:return!0;default:return!1}}function H(fe,_e,F){return _e[fe]!==F[fe]}function ne(fe,_e,F,V,j,B,X=!1){for(;_e<F&&j<B;)fe[_e]===V[j]&&(X&&(oe[_e]=j),_e+=1),j+=1;return _e===F}e.isPatternInWord=ne;var Ae;(function(fe){fe[fe.Diag=1]="Diag",fe[fe.Left=2]="Left",fe[fe.LeftLeft=3]="LeftLeft"})(Ae||(Ae={}));var Re;(function(fe){fe.Default=[-100,0];function _e(F){return!F||F.length===2&&F[0]===-100&&F[1]===0}fe.isDefault=_e})(Re||(e.FuzzyScore=Re={}));class ke{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(_e,F){this.firstMatchCanBeWeak=_e,this.boostFullMatch=F}}e.FuzzyScoreOptions=ke;function ce(fe,_e,F,V,j,B,X=ke.default){const Z=fe.length>k?k:fe.length,Se=V.length>k?k:V.length;if(F>=Z||B>=Se||Z-F>Se-B||!ne(_e,F,Z,j,B,Se,!0))return;te(Z,Se,F,B,_e,j);let Ne=1,$e=1,qe=F,Qe=B;const nt=[!1];for(Ne=1,qe=F;qe<Z;Ne++,qe++){const Be=oe[qe],gt=de[qe],Q=qe+1<Z?de[qe+1]:Se;for($e=Be-B+1,Qe=Be;Qe<Q;$e++,Qe++){let Y=Number.MIN_SAFE_INTEGER,Ee=!1;Qe<=gt&&(Y=K(fe,_e,qe,F,V,j,Qe,Se,B,we[Ne-1][$e-1]===0,nt));let ze=0;Y!==Number.MAX_SAFE_INTEGER&&(Ee=!0,ze=Y+ye[Ne-1][$e-1]);const Ge=Qe>Be,tt=Ge?ye[Ne][$e-1]+(we[Ne][$e-1]>0?-5:0):0,st=Qe>Be+1&&we[Ne][$e-1]>0,Fe=st?ye[Ne][$e-2]+(we[Ne][$e-2]>0?-5:0):0;if(st&&(!Ge||Fe>=tt)&&(!Ee||Fe>=ze))ye[Ne][$e]=Fe,le[Ne][$e]=3,we[Ne][$e]=0;else if(Ge&&(!Ee||tt>=ze))ye[Ne][$e]=tt,le[Ne][$e]=2,we[Ne][$e]=0;else if(Ee)ye[Ne][$e]=ze,le[Ne][$e]=1,we[Ne][$e]=we[Ne-1][$e-1]+1;else throw new Error("not possible")}}if(ve&&pe(fe,F,V,B),!nt[0]&&!X.firstMatchCanBeWeak)return;Ne--,$e--;const it=[ye[Ne][$e],B];let et=0,rt=0;for(;Ne>=1;){let Be=$e;do{const gt=le[Ne][Be];if(gt===3)Be=Be-2;else if(gt===2)Be=Be-1;else break}while(Be>=1);et>1&&_e[F+Ne-1]===j[B+$e-1]&&!H(Be+B-1,V,j)&&et+1>we[Ne][Be]&&(Be=$e),Be===$e?et++:et=1,rt||(rt=Be),Ne--,$e=Be-1,it.push($e)}Se===Z&&X.boostFullMatch&&(it[0]+=2);const ct=rt-Z;return it[0]-=ct,it}e.fuzzyScore=ce;function te(fe,_e,F,V,j,B){let X=fe-1,Z=_e-1;for(;X>=F&&Z>=V;)j[X]===B[Z]&&(de[X]=Z,X--),Z--}function K(fe,_e,F,V,j,B,X,Z,Se,Ne,$e){if(_e[F]!==B[X])return Number.MIN_SAFE_INTEGER;let qe=1,Qe=!1;return X===F-V?qe=fe[F]===j[X]?7:5:H(X,j,B)&&(X===0||!H(X-1,j,B))?(qe=fe[F]===j[X]?7:5,Qe=!0):re(B,X)&&(X===0||!re(B,X-1))?qe=5:(re(B,X-1)||J(B,X-1))&&(qe=5,Qe=!0),qe>1&&F===V&&($e[0]=!0),Qe||(Qe=H(X,j,B)||re(B,X-1)||J(B,X-1)),F===V?X>Se&&(qe-=Qe?3:5):Ne?qe+=Qe?2:0:qe+=Qe?0:1,X+1===Z&&(qe-=Qe?3:5),qe}function ee(fe,_e,F,V,j,B,X){return be(fe,_e,F,V,j,B,!0,X)}e.fuzzyScoreGracefulAggressive=ee;function ge(fe,_e,F,V,j,B,X){return be(fe,_e,F,V,j,B,!1,X)}e.fuzzyScoreGraceful=ge;function be(fe,_e,F,V,j,B,X,Z){let Se=ce(fe,_e,F,V,j,B,Z);if(Se&&!X)return Se;if(fe.length>=3){const Ne=Math.min(7,fe.length-1);for(let $e=F+1;$e<Ne;$e++){const qe=Le(fe,$e);if(qe){const Qe=ce(qe,qe.toLowerCase(),F,V,j,B,Z);Qe&&(Qe[0]-=3,(!Se||Qe[0]>Se[0])&&(Se=Qe))}}}return Se}function Le(fe,_e){if(_e+1>=fe.length)return;const F=fe[_e],V=fe[_e+1];if(F!==V)return fe.slice(0,_e)+V+F+fe.slice(_e+2)}}),define(Pe[32],Te([1,0,12]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(L||(L={})),function(C){const A="error",T="warning",g="warn",h="info",S="ignore";function R(u){return u?I.equalsIgnoreCase(A,u)?C.Error:I.equalsIgnoreCase(T,u)||I.equalsIgnoreCase(g,u)?C.Warning:I.equalsIgnoreCase(h,u)?C.Info:C.Ignore:C.Ignore}C.fromValue=R;function D(u){switch(u){case C.Error:return A;case C.Warning:return T;case C.Info:return h;default:return S}}C.toString=D}(L||(L={})),e.default=L}),define(Pe[125],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Pe[50],Te([1,0,18,12]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class C{constructor(){this._value="",this._pos=0}reset(p){return this._value=p,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(p){const E=p.charCodeAt(0),i=this._value.charCodeAt(this._pos);return E-i}value(){return this._value[this._pos]}}e.StringIterator=C;class A{constructor(p=!0){this._caseSensitive=p}reset(p){return this._value=p,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let p=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(p)this._from++;else break;else p=!1;return this}cmp(p){return this._caseSensitive?(0,L.compareSubstring)(p,this._value,0,p.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(p,this._value,0,p.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class T{constructor(p=!0,E=!0){this._splitOnBackslash=p,this._caseSensitive=E}reset(p){this._from=0,this._to=0,this._value=p,this._valueLen=p.length;for(let E=p.length-1;E>=0;E--,this._valueLen--){const i=this._value.charCodeAt(E);if(!(i===47||this._splitOnBackslash&&i===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let p=!0;for(;this._to<this._valueLen;this._to++){const E=this._value.charCodeAt(this._to);if(E===47||this._splitOnBackslash&&E===92)if(p)this._from++;else break;else p=!1}return this}cmp(p){return this._caseSensitive?(0,L.compareSubstring)(p,this._value,0,p.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(p,this._value,0,p.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=T;var g;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(g||(g={}));class h{constructor(p,E){this._ignorePathCasing=p,this._ignoreQueryAndFragment=E,this._states=[],this._stateIdx=0}reset(p){return this._value=p,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new T(!1,!this._ignorePathCasing(p)),this._pathIterator.reset(p.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(p)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(p){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(p,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(p,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(p);if(this._states[this._stateIdx]===4)return(0,L.compare)(p,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(p,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(R||(R={}));class D{static forUris(p=()=>!1,E=()=>!1){return new D(new h(p,E))}static forPaths(p=!1){return new D(new T(void 0,!p))}static forStrings(){return new D(new C)}static forConfigKeys(){return new D(new A)}constructor(p){this._iter=p}clear(){this._root=void 0}fill(p,E){if(E){const i=E.slice(0);(0,I.shuffle)(i);for(const a of i)this.set(a,p)}else{const i=p.slice(0);(0,I.shuffle)(i);for(const a of i)this.set(a[0],a[1])}}set(p,E){const i=this._iter.reset(p);let a;this._root||(this._root=new S,this._root.segment=i.value());const r=[];for(a=this._root;;){const o=i.cmp(a.segment);if(o>0)a.left||(a.left=new S,a.left.segment=i.value()),r.push([-1,a]),a=a.left;else if(o<0)a.right||(a.right=new S,a.right.segment=i.value()),r.push([1,a]),a=a.right;else if(i.hasNext())i.next(),a.mid||(a.mid=new S,a.mid.segment=i.value()),r.push([0,a]),a=a.mid;else break}const n=a.value;a.value=E,a.key=p;for(let o=r.length-1;o>=0;o--){const c=r[o][1];c.updateHeight();const l=c.balanceFactor();if(l<-1||l>1){const t=r[o][0],d=r[o+1][0];if(t===1&&d===1)r[o][1]=c.rotateLeft();else if(t===-1&&d===-1)r[o][1]=c.rotateRight();else if(t===1&&d===-1)c.right=r[o+1][1]=r[o+1][1].rotateRight(),r[o][1]=c.rotateLeft();else if(t===-1&&d===1)c.left=r[o+1][1]=r[o+1][1].rotateLeft(),r[o][1]=c.rotateRight();else throw new Error;if(o>0)switch(r[o-1][0]){case-1:r[o-1][1].left=r[o][1];break;case 1:r[o-1][1].right=r[o][1];break;case 0:r[o-1][1].mid=r[o][1];break}else this._root=r[0][1]}}return n}get(p){return this._getNode(p)?.value}_getNode(p){const E=this._iter.reset(p);let i=this._root;for(;i;){const a=E.cmp(i.segment);if(a>0)i=i.left;else if(a<0)i=i.right;else if(E.hasNext())E.next(),i=i.mid;else break}return i}has(p){const E=this._getNode(p);return!(E?.value===void 0&&E?.mid===void 0)}delete(p){return this._delete(p,!1)}deleteSuperstr(p){return this._delete(p,!0)}_delete(p,E){const i=this._iter.reset(p),a=[];let r=this._root;for(;r;){const n=i.cmp(r.segment);if(n>0)a.push([-1,r]),r=r.left;else if(n<0)a.push([1,r]),r=r.right;else if(i.hasNext())i.next(),a.push([0,r]),r=r.mid;else break}if(r){if(E?(r.left=void 0,r.mid=void 0,r.right=void 0,r.height=1):(r.key=void 0,r.value=void 0),!r.mid&&!r.value)if(r.left&&r.right){const n=this._min(r.right);if(n.key){const{key:o,value:c,segment:l}=n;this._delete(n.key,!1),r.key=o,r.value=c,r.segment=l}}else{const n=r.left??r.right;if(a.length>0){const[o,c]=a[a.length-1];switch(o){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this._root=n}for(let n=a.length-1;n>=0;n--){const o=a[n][1];o.updateHeight();const c=o.balanceFactor();if(c>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),a[n][1]=o.rotateLeft()):c<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),a[n][1]=o.rotateRight()),n>0)switch(a[n-1][0]){case-1:a[n-1][1].left=a[n][1];break;case 1:a[n-1][1].right=a[n][1];break;case 0:a[n-1][1].mid=a[n][1];break}else this._root=a[0][1]}}}_min(p){for(;p.left;)p=p.left;return p}findSubstr(p){const E=this._iter.reset(p);let i=this._root,a;for(;i;){const r=E.cmp(i.segment);if(r>0)i=i.left;else if(r<0)i=i.right;else if(E.hasNext())E.next(),a=i.value||a,i=i.mid;else break}return i&&i.value||a}findSuperstr(p){return this._findSuperstrOrElement(p,!1)}_findSuperstrOrElement(p,E){const i=this._iter.reset(p);let a=this._root;for(;a;){const r=i.cmp(a.segment);if(r>0)a=a.left;else if(r<0)a=a.right;else if(i.hasNext())i.next(),a=a.mid;else return a.mid?this._entries(a.mid):E?a.value:void 0}}hasElementOrSubtree(p){return this._findSuperstrOrElement(p,!0)!==void 0}forEach(p){for(const[E,i]of this)p(i,E)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(p){const E=[];return this._dfsEntries(p,E),E[Symbol.iterator]()}_dfsEntries(p,E){p&&(p.left&&this._dfsEntries(p.left,E),p.value&&E.push([p.key,p.value]),p.mid&&this._dfsEntries(p.mid,E),p.right&&this._dfsEntries(p.right,E))}_isBalanced(){const p=E=>{if(!E)return!0;const i=E.balanceFactor();return i<-1||i>1?!1:p(E.left)&&p(E.right)};return p(this._root)}}e.TernarySearchTree=D}),define(Pe[40],Te([1,0,90]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var L;(function(T){function g(h){return h&&typeof h=="object"&&typeof h.id=="string"}T.isThemeColor=g})(L||(e.ThemeColor=L={}));function C(T){return{id:T}}e.themeColorFromId=C;var A;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const g=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function h(n){const o=g.exec(n.id);if(!o)return h(I.Codicon.error);const[,c,l]=o,t=["codicon","codicon-"+c];return l&&t.push("codicon-modifier-"+l.substring(1)),t}T.asClassNameArray=h;function S(n){return h(n).join(" ")}T.asClassName=S;function R(n){return"."+h(n).join(".")}T.asCSSSelector=R;function D(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||L.isThemeColor(n.color))}T.isThemeIcon=D;const u=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function p(n){const o=u.exec(n);if(!o)return;const[,c]=o;return{id:c}}T.fromString=p;function E(n){return{id:n}}T.fromId=E;function i(n,o){let c=n.id;const l=c.lastIndexOf("~");return l!==-1&&(c=c.substring(0,l)),o&&(c=`${c}~${o}`),{id:c}}T.modify=i;function a(n){const o=n.id.lastIndexOf("~");if(o!==-1)return n.id.substring(o+1)}T.getModifier=a;function r(n,o){return n.id===o.id&&n.color?.id===o.color?.id}T.isEqual=r})(A||(e.ThemeIcon=A={}))}),define(Pe[126],Te([1,0,124,12,40]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const A="$(",T=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),g=new RegExp(`(\\\\)?${T.source}`,"g");function h(r){return r.replace(g,(n,o)=>o?n:`\\${n}`)}e.escapeIcons=h;const S=new RegExp(`\\\\${T.source}`,"g");function R(r){return r.replace(S,n=>`\\${n}`)}e.markdownEscapeEscapedIcons=R;const D=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function u(r){return r.indexOf(A)===-1?r:r.replace(D,(n,o,c,l)=>c?n:o||l||"")}e.stripIcons=u;function p(r){return r?r.replace(/\$\((.*?)\)/g,(n,o)=>` ${o} `).trim():""}e.getCodiconAriaLabel=p;const E=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function i(r){E.lastIndex=0;let n="";const o=[];let c=0;for(;;){const l=E.lastIndex,t=E.exec(r),d=r.substring(l,t?.index);if(d.length>0){n+=d;for(let s=0;s<d.length;s++)o.push(c)}if(!t)break;c+=t[0].length}return{text:n,iconOffsets:o}}e.parseLabelWithIcons=i;function a(r,n,o=!1){const{text:c,iconOffsets:l}=n;if(!l||l.length===0)return(0,I.matchesFuzzy)(r,c,o);const t=(0,L.ltrim)(c," "),d=c.length-t.length,s=(0,I.matchesFuzzy)(r,t,o);if(s)for(const b of s){const _=l[b.start+d]+d;b.start+=_,b.end+=_}return s}e.matchesFuzzyIconAware=a}),define(Pe[33],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(C){return I.test(C)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(g){for(let h=0;h<g.length;h++)g[h]=Math.floor(Math.random()*256);return g};const A=new Uint8Array(16),T=[];for(let g=0;g<256;g++)T.push(g.toString(16).padStart(2,"0"));return function(){C(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let h=0,S="";return S+=T[A[h++]],S+=T[A[h++]],S+=T[A[h++]],S+=T[A[h++]],S+="-",S+=T[A[h++]],S+=T[A[h++]],S+="-",S+=T[A[h++]],S+=T[A[h++]],S+="-",S+=T[A[h++]],S+=T[A[h++]],S+="-",S+=T[A[h++]],S+=T[A[h++]],S+=T[A[h++]],S+=T[A[h++]],S+=T[A[h++]],S+=T[A[h++]],S}}()}),define(Pe[127],Te([1,0,18,68,33]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.matchesMimeType=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function A(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.createStringDataTransferItem=A;function T(D,u,p){const E={id:(0,C.generateUuid)(),name:D,uri:u,data:p};return{asString:async()=>"",asFile:()=>E,value:void 0}}e.createFileDataTransferItem=T;class g{constructor(){this._entries=new Map}get size(){let u=0;for(const p of this._entries)u++;return u}has(u){return this._entries.has(this.toKey(u))}matches(u){const p=[...this._entries.keys()];return L.Iterable.some(this,([E,i])=>i.asFile())&&p.push("files"),R(h(u),p)}get(u){return this._entries.get(this.toKey(u))?.[0]}append(u,p){const E=this._entries.get(u);E?E.push(p):this._entries.set(this.toKey(u),[p])}replace(u,p){this._entries.set(this.toKey(u),[p])}delete(u){this._entries.delete(this.toKey(u))}*[Symbol.iterator](){for(const[u,p]of this._entries)for(const E of p)yield[u,E]}toKey(u){return h(u)}}e.VSDataTransfer=g;function h(D){return D.toLowerCase()}function S(D,u){return R(h(D),u.map(h))}e.matchesMimeType=S;function R(D,u){if(D==="*/*")return u.length>0;if(u.includes(D))return!0;const p=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[E,i,a]=p;return a==="*"?u.some(r=>r.startsWith(i+"/")):!1}e.UriList=Object.freeze({create:D=>(0,I.distinct)(D.map(u=>u.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.UriList.split(D).filter(u=>!u.startsWith("#"))})}),define(Pe[128],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.countEOL=e.StringEOL=void 0;var I;(function(C){C[C.Unknown=0]="Unknown",C[C.Invalid=3]="Invalid",C[C.LF=1]="LF",C[C.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function L(C){let A=0,T=0,g=0,h=0;for(let S=0,R=C.length;S<R;S++){const D=C.charCodeAt(S);D===13?(A===0&&(T=S),A++,S+1<R&&C.charCodeAt(S+1)===10?(h|=2,S++):h|=3,g=S+1):D===10&&(h|=1,A===0&&(T=S),A++,g=S+1)}return A===0&&(T=C.length),[A,T,C.length-g,h]}e.countEOL=L}),define(Pe[129],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[130],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var I;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class L{constructor(g){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=g.open,this.close=g.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(g.notIn))for(let h=0,S=g.notIn.length;h<S;h++)switch(g.notIn[h]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(g){switch(g){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(g,h){if(g.getTokenCount()===0)return!0;const S=g.findTokenIndexAtOffset(h-2),R=g.getStandardTokenType(S);return this.isOK(R)}_findNeutralCharacterInRange(g,h){for(let S=g;S<=h;S++){const R=String.fromCharCode(S);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=L;class C{constructor(g){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const h of g)A(this.autoClosingPairsOpenByStart,h.open.charAt(0),h),A(this.autoClosingPairsOpenByEnd,h.open.charAt(h.open.length-1),h),A(this.autoClosingPairsCloseByStart,h.close.charAt(0),h),A(this.autoClosingPairsCloseByEnd,h.close.charAt(h.close.length-1),h),h.close.length===1&&h.open.length===1&&A(this.autoClosingPairsCloseSingleChar,h.close,h)}}e.AutoClosingPairs=C;function A(T,g,h){T.has(g)?T.get(g).push(h):T.set(g,[h])}}),define(Pe[131],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.recomputeTreeMetadata=e.updateTreeMetadata=e.fixInsert=e.rbDelete=e.rightRotate=e.leftRotate=e.righttest=e.leftest=e.SENTINEL=e.NodeColor=e.TreeNode=void 0;class I{constructor(a,r){this.piece=a,this.color=r,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.SENTINEL)return C(this.right);let a=this;for(;a.parent!==e.SENTINEL&&a.parent.left!==a;)a=a.parent;return a.parent===e.SENTINEL?e.SENTINEL:a.parent}prev(){if(this.left!==e.SENTINEL)return A(this.left);let a=this;for(;a.parent!==e.SENTINEL&&a.parent.right!==a;)a=a.parent;return a.parent===e.SENTINEL?e.SENTINEL:a.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.TreeNode=I;var L;(function(i){i[i.Black=0]="Black",i[i.Red=1]="Red"})(L||(e.NodeColor=L={})),e.SENTINEL=new I(null,0),e.SENTINEL.parent=e.SENTINEL,e.SENTINEL.left=e.SENTINEL,e.SENTINEL.right=e.SENTINEL,e.SENTINEL.color=0;function C(i){for(;i.left!==e.SENTINEL;)i=i.left;return i}e.leftest=C;function A(i){for(;i.right!==e.SENTINEL;)i=i.right;return i}e.righttest=A;function T(i){return i===e.SENTINEL?0:i.size_left+i.piece.length+T(i.right)}function g(i){return i===e.SENTINEL?0:i.lf_left+i.piece.lineFeedCnt+g(i.right)}function h(){e.SENTINEL.parent=e.SENTINEL}function S(i,a){const r=a.right;r.size_left+=a.size_left+(a.piece?a.piece.length:0),r.lf_left+=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),a.right=r.left,r.left!==e.SENTINEL&&(r.left.parent=a),r.parent=a.parent,a.parent===e.SENTINEL?i.root=r:a.parent.left===a?a.parent.left=r:a.parent.right=r,r.left=a,a.parent=r}e.leftRotate=S;function R(i,a){const r=a.left;a.left=r.right,r.right!==e.SENTINEL&&(r.right.parent=a),r.parent=a.parent,a.size_left-=r.size_left+(r.piece?r.piece.length:0),a.lf_left-=r.lf_left+(r.piece?r.piece.lineFeedCnt:0),a.parent===e.SENTINEL?i.root=r:a===a.parent.right?a.parent.right=r:a.parent.left=r,r.right=a,a.parent=r}e.rightRotate=R;function D(i,a){let r,n;if(a.left===e.SENTINEL?(n=a,r=n.right):a.right===e.SENTINEL?(n=a,r=n.left):(n=C(a.right),r=n.right),n===i.root){i.root=r,r.color=0,a.detach(),h(),i.root.parent=e.SENTINEL;return}const o=n.color===1;if(n===n.parent.left?n.parent.left=r:n.parent.right=r,n===a?(r.parent=n.parent,E(i,r)):(n.parent===a?r.parent=n:r.parent=n.parent,E(i,r),n.left=a.left,n.right=a.right,n.parent=a.parent,n.color=a.color,a===i.root?i.root=n:a===a.parent.left?a.parent.left=n:a.parent.right=n,n.left!==e.SENTINEL&&(n.left.parent=n),n.right!==e.SENTINEL&&(n.right.parent=n),n.size_left=a.size_left,n.lf_left=a.lf_left,E(i,n)),a.detach(),r.parent.left===r){const l=T(r),t=g(r);if(l!==r.parent.size_left||t!==r.parent.lf_left){const d=l-r.parent.size_left,s=t-r.parent.lf_left;r.parent.size_left=l,r.parent.lf_left=t,p(i,r.parent,d,s)}}if(E(i,r.parent),o){h();return}let c;for(;r!==i.root&&r.color===0;)r===r.parent.left?(c=r.parent.right,c.color===1&&(c.color=0,r.parent.color=1,S(i,r.parent),c=r.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,r=r.parent):(c.right.color===0&&(c.left.color=0,c.color=1,R(i,c),c=r.parent.right),c.color=r.parent.color,r.parent.color=0,c.right.color=0,S(i,r.parent),r=i.root)):(c=r.parent.left,c.color===1&&(c.color=0,r.parent.color=1,R(i,r.parent),c=r.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,r=r.parent):(c.left.color===0&&(c.right.color=0,c.color=1,S(i,c),c=r.parent.left),c.color=r.parent.color,r.parent.color=0,c.left.color=0,R(i,r.parent),r=i.root));r.color=0,h()}e.rbDelete=D;function u(i,a){for(E(i,a);a!==i.root&&a.parent.color===1;)if(a.parent===a.parent.parent.left){const r=a.parent.parent.right;r.color===1?(a.parent.color=0,r.color=0,a.parent.parent.color=1,a=a.parent.parent):(a===a.parent.right&&(a=a.parent,S(i,a)),a.parent.color=0,a.parent.parent.color=1,R(i,a.parent.parent))}else{const r=a.parent.parent.left;r.color===1?(a.parent.color=0,r.color=0,a.parent.parent.color=1,a=a.parent.parent):(a===a.parent.left&&(a=a.parent,R(i,a)),a.parent.color=0,a.parent.parent.color=1,S(i,a.parent.parent))}i.root.color=0}e.fixInsert=u;function p(i,a,r,n){for(;a!==i.root&&a!==e.SENTINEL;)a.parent.left===a&&(a.parent.size_left+=r,a.parent.lf_left+=n),a=a.parent}e.updateTreeMetadata=p;function E(i,a){let r=0,n=0;if(a!==i.root){for(;a!==i.root&&a===a.parent.right;)a=a.parent;if(a!==i.root)for(a=a.parent,r=T(a.left)-a.size_left,n=g(a.left)-a.lf_left,a.size_left+=r,a.lf_left+=n;a!==i.root&&(r!==0||n!==0);)a.parent.left===a&&(a.parent.size_left+=r,a.parent.lf_left+=n),a=a.parent}}e.recomputeTreeMetadata=E}),define(Pe[91],Te([1,0,92,29,93,131,94]),function(me,e,I,L,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeBase=e.StringBuffer=e.Piece=e.createLineStarts=e.createLineStartsFast=void 0;const g=65535;function h(r){let n;return r[r.length-1]<65536?n=new Uint16Array(r.length):n=new Uint32Array(r.length),n.set(r,0),n}class S{constructor(n,o,c,l,t){this.lineStarts=n,this.cr=o,this.lf=c,this.crlf=l,this.isBasicASCII=t}}function R(r,n=!0){const o=[0];let c=1;for(let l=0,t=r.length;l<t;l++){const d=r.charCodeAt(l);d===13?l+1<t&&r.charCodeAt(l+1)===10?(o[c++]=l+2,l++):o[c++]=l+1:d===10&&(o[c++]=l+1)}return n?h(o):o}e.createLineStartsFast=R;function D(r,n){r.length=0,r[0]=0;let o=1,c=0,l=0,t=0,d=!0;for(let b=0,_=n.length;b<_;b++){const f=n.charCodeAt(b);f===13?b+1<_&&n.charCodeAt(b+1)===10?(t++,r[o++]=b+2,b++):(c++,r[o++]=b+1):f===10?(l++,r[o++]=b+1):d&&f!==9&&(f<32||f>126)&&(d=!1)}const s=new S(h(r),c,l,t,d);return r.length=0,s}e.createLineStarts=D;class u{constructor(n,o,c,l,t){this.bufferIndex=n,this.start=o,this.end=c,this.lineFeedCnt=l,this.length=t}}e.Piece=u;class p{constructor(n,o){this.buffer=n,this.lineStarts=o}}e.StringBuffer=p;class E{constructor(n,o){this._pieces=[],this._tree=n,this._BOM=o,this._index=0,n.root!==A.SENTINEL&&n.iterate(n.root,c=>(c!==A.SENTINEL&&this._pieces.push(c.piece),!0))}read(){return this._pieces.length===0?this._index===0?(this._index++,this._BOM):null:this._index>this._pieces.length-1?null:this._index===0?this._BOM+this._tree.getPieceContent(this._pieces[this._index++]):this._tree.getPieceContent(this._pieces[this._index++])}}class i{constructor(n){this._limit=n,this._cache=[]}get(n){for(let o=this._cache.length-1;o>=0;o--){const c=this._cache[o];if(c.nodeStartOffset<=n&&c.nodeStartOffset+c.node.piece.length>=n)return c}return null}get2(n){for(let o=this._cache.length-1;o>=0;o--){const c=this._cache[o];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<n&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=n)return c}return null}set(n){this._cache.length>=this._limit&&this._cache.shift(),this._cache.push(n)}validate(n){let o=!1;const c=this._cache;for(let l=0;l<c.length;l++){const t=c[l];if(t.node.parent===null||t.nodeStartOffset>=n){c[l]=null,o=!0;continue}}if(o){const l=[];for(const t of c)t!==null&&l.push(t);this._cache=l}}}class a{constructor(n,o,c){this.create(n,o,c)}create(n,o,c){this._buffers=[new p("",[0])],this._lastChangeBufferPos={line:0,column:0},this.root=A.SENTINEL,this._lineCnt=1,this._length=0,this._EOL=o,this._EOLLength=o.length,this._EOLNormalized=c;let l=null;for(let t=0,d=n.length;t<d;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=R(n[t].buffer));const s=new u(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this._buffers.push(n[t]),l=this.rbInsertRight(l,s)}this._searchCache=new i(1),this._lastVisitedLine={lineNumber:0,value:""},this.computeBufferMetadata()}normalizeEOL(n){const o=g,c=o-Math.floor(o/3),l=c*2;let t="",d=0;const s=[];if(this.iterate(this.root,b=>{const _=this.getNodeContent(b),f=_.length;if(d<=c||d+f<l)return t+=_,d+=f,!0;const w=t.replace(/\r\n|\r|\n/g,n);return s.push(new p(w,R(w))),t=_,d=f,!0}),d>0){const b=t.replace(/\r\n|\r|\n/g,n);s.push(new p(b,R(b)))}this.create(s,n,!0)}getEOL(){return this._EOL}setEOL(n){this._EOL=n,this._EOLLength=this._EOL.length,this.normalizeEOL(n)}createSnapshot(n){return new E(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let o=0;return this.iterate(this.root,l=>{if(l===A.SENTINEL)return!0;const t=this.getNodeContent(l),d=t.length,s=n.nodeAt(o),b=n.nodeAt(o+d),_=n.getValueInRange2(s,b);return o+=d,t===_})}getOffsetAt(n,o){let c=0,l=this.root;for(;l!==A.SENTINEL;)if(l.left!==A.SENTINEL&&l.lf_left+1>=n)l=l.left;else if(l.lf_left+l.piece.lineFeedCnt+1>=n){c+=l.size_left;const t=this.getAccumulatedValue(l,n-l.lf_left-2);return c+=t+o-1}else n-=l.lf_left+l.piece.lineFeedCnt,c+=l.size_left+l.piece.length,l=l.right;return c}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let o=this.root,c=0;const l=n;for(;o!==A.SENTINEL;)if(o.size_left!==0&&o.size_left>=n)o=o.left;else if(o.size_left+o.piece.length>=n){const t=this.getIndexOf(o,n-o.size_left);if(c+=o.lf_left+t.index,t.index===0){const d=this.getOffsetAt(c+1,1),s=l-d;return new I.Position(c+1,s+1)}return new I.Position(c+1,t.remainder+1)}else if(n-=o.size_left+o.piece.length,c+=o.lf_left+o.piece.lineFeedCnt,o.right===A.SENTINEL){const t=this.getOffsetAt(c+1,1),d=l-n-t;return new I.Position(c+1,d+1)}else o=o.right;return new I.Position(1,1)}getValueInRange(n,o){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const c=this.nodeAt2(n.startLineNumber,n.startColumn),l=this.nodeAt2(n.endLineNumber,n.endColumn),t=this.getValueInRange2(c,l);return o?o!==this._EOL||!this._EOLNormalized?t.replace(/\r\n|\r|\n/g,o):o===this.getEOL()&&this._EOLNormalized?t:t.replace(/\r\n|\r|\n/g,o):t}getValueInRange2(n,o){if(n.node===o.node){const s=n.node,b=this._buffers[s.piece.bufferIndex].buffer,_=this.offsetInBuffer(s.piece.bufferIndex,s.piece.start);return b.substring(_+n.remainder,_+o.remainder)}let c=n.node;const l=this._buffers[c.piece.bufferIndex].buffer,t=this.offsetInBuffer(c.piece.bufferIndex,c.piece.start);let d=l.substring(t+n.remainder,t+c.piece.length);for(c=c.next();c!==A.SENTINEL;){const s=this._buffers[c.piece.bufferIndex].buffer,b=this.offsetInBuffer(c.piece.bufferIndex,c.piece.start);if(c===o.node){d+=s.substring(b,b+o.remainder);break}else d+=s.substr(b,c.piece.length);c=c.next()}return d}getLinesContent(){const n=[];let o=0,c="",l=!1;return this.iterate(this.root,t=>{if(t===A.SENTINEL)return!0;const d=t.piece;let s=d.length;if(s===0)return!0;const b=this._buffers[d.bufferIndex].buffer,_=this._buffers[d.bufferIndex].lineStarts,f=d.start.line,w=d.end.line;let P=_[f]+d.start.column;if(l&&(b.charCodeAt(P)===10&&(P++,s--),n[o++]=c,c="",l=!1,s===0))return!0;if(f===w)return!this._EOLNormalized&&b.charCodeAt(P+s-1)===13?(l=!0,c+=b.substr(P,s-1)):c+=b.substr(P,s),!0;c+=this._EOLNormalized?b.substring(P,Math.max(P,_[f+1]-this._EOLLength)):b.substring(P,_[f+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=c;for(let m=f+1;m<w;m++)c=this._EOLNormalized?b.substring(_[m],_[m+1]-this._EOLLength):b.substring(_[m],_[m+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=c;return!this._EOLNormalized&&b.charCodeAt(_[w]+d.end.column-1)===13?(l=!0,d.end.column===0?o--:c=b.substr(_[w],d.end.column-1)):c=b.substr(_[w],d.end.column),!0}),l&&(n[o++]=c,c=""),n[o++]=c,n}getLength(){return this._length}getLineCount(){return this._lineCnt}getLineContent(n){return this._lastVisitedLine.lineNumber===n?this._lastVisitedLine.value:(this._lastVisitedLine.lineNumber=n,n===this._lineCnt?this._lastVisitedLine.value=this.getLineRawContent(n):this._EOLNormalized?this._lastVisitedLine.value=this.getLineRawContent(n,this._EOLLength):this._lastVisitedLine.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this._lastVisitedLine.value)}_getCharCode(n){if(n.remainder===n.node.piece.length){const o=n.node.next();if(!o)return 0;const c=this._buffers[o.piece.bufferIndex],l=this.offsetInBuffer(o.piece.bufferIndex,o.piece.start);return c.buffer.charCodeAt(l)}else{const o=this._buffers[n.node.piece.bufferIndex],l=this.offsetInBuffer(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return o.buffer.charCodeAt(l)}}getLineCharCode(n,o){const c=this.nodeAt2(n,o+1);return this._getCharCode(c)}getLineLength(n){if(n===this.getLineCount()){const o=this.getOffsetAt(n,1);return this.getLength()-o}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this._EOLLength}getCharCode(n){const o=this.nodeAt(n);return this._getCharCode(o)}findMatchesInNode(n,o,c,l,t,d,s,b,_,f,w){const P=this._buffers[n.piece.bufferIndex],m=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start),v=this.offsetInBuffer(n.piece.bufferIndex,t),y=this.offsetInBuffer(n.piece.bufferIndex,d);let O;const N={line:0,column:0};let q,W;o._wordSeparators?(q=P.buffer.substring(v,y),W=x=>x+v,o.reset(0)):(q=P.buffer,W=x=>x,o.reset(v));do if(O=o.next(q),O){if(W(O.index)>=y)return f;this.positionInBuffer(n,W(O.index)-m,N);const x=this.getLineFeedCnt(n.piece.bufferIndex,t,N),k=N.line===t.line?N.column-t.column+l:N.column+1,M=k+O[0].length;if(w[f++]=(0,T.createFindMatch)(new L.Range(c+x,k,c+x,M),O,b),W(O.index)+O[0].length>=y||f>=_)return f}while(O);return f}findMatchesLineByLine(n,o,c,l){const t=[];let d=0;const s=new T.Searcher(o.wordSeparators,o.regex);let b=this.nodeAt2(n.startLineNumber,n.startColumn);if(b===null)return[];const _=this.nodeAt2(n.endLineNumber,n.endColumn);if(_===null)return[];let f=this.positionInBuffer(b.node,b.remainder);const w=this.positionInBuffer(_.node,_.remainder);if(b.node===_.node)return this.findMatchesInNode(b.node,s,n.startLineNumber,n.startColumn,f,w,o,c,l,d,t),t;let P=n.startLineNumber,m=b.node;for(;m!==_.node;){const y=this.getLineFeedCnt(m.piece.bufferIndex,f,m.piece.end);if(y>=1){const N=this._buffers[m.piece.bufferIndex].lineStarts,q=this.offsetInBuffer(m.piece.bufferIndex,m.piece.start),W=N[f.line+y],x=P===n.startLineNumber?n.startColumn:1;if(d=this.findMatchesInNode(m,s,P,x,f,this.positionInBuffer(m,W-q),o,c,l,d,t),d>=l)return t;P+=y}const O=P===n.startLineNumber?n.startColumn-1:0;if(P===n.endLineNumber){const N=this.getLineContent(P).substring(O,n.endColumn-1);return d=this._findMatchesInLine(o,s,N,n.endLineNumber,O,d,t,c,l),t}if(d=this._findMatchesInLine(o,s,this.getLineContent(P).substr(O),P,O,d,t,c,l),d>=l)return t;P++,b=this.nodeAt2(P,1),m=b.node,f=this.positionInBuffer(b.node,b.remainder)}if(P===n.endLineNumber){const y=P===n.startLineNumber?n.startColumn-1:0,O=this.getLineContent(P).substring(y,n.endColumn-1);return d=this._findMatchesInLine(o,s,O,n.endLineNumber,y,d,t,c,l),t}const v=P===n.startLineNumber?n.startColumn:1;return d=this.findMatchesInNode(_.node,s,P,v,f,w,o,c,l,d,t),t}_findMatchesInLine(n,o,c,l,t,d,s,b,_){const f=n.wordSeparators;if(!b&&n.simpleSearch){const P=n.simpleSearch,m=P.length,v=c.length;let y=-m;for(;(y=c.indexOf(P,y+m))!==-1;)if((!f||(0,T.isValidMatch)(f,c,v,y,m))&&(s[d++]=new C.FindMatch(new L.Range(l,y+1+t,l,y+1+m+t),null),d>=_))return d;return d}let w;o.reset(0);do if(w=o.next(c),w&&(s[d++]=(0,T.createFindMatch)(new L.Range(l,w.index+1+t,l,w.index+1+w[0].length+t),w,b),d>=_))return d;while(w);return d}insert(n,o,c=!1){if(this._EOLNormalized=this._EOLNormalized&&c,this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",this.root!==A.SENTINEL){const{node:l,remainder:t,nodeStartOffset:d}=this.nodeAt(n),s=l.piece,b=s.bufferIndex,_=this.positionInBuffer(l,t);if(l.piece.bufferIndex===0&&s.end.line===this._lastChangeBufferPos.line&&s.end.column===this._lastChangeBufferPos.column&&d+s.length===n&&o.length<g){this.appendToNode(l,o),this.computeBufferMetadata();return}if(d===n)this.insertContentToNodeLeft(o,l),this._searchCache.validate(n);else if(d+l.piece.length>n){const f=[];let w=new u(s.bufferIndex,_,s.end,this.getLineFeedCnt(s.bufferIndex,_,s.end),this.offsetInBuffer(b,s.end)-this.offsetInBuffer(b,_));if(this.shouldCheckCRLF()&&this.endWithCR(o)&&this.nodeCharCodeAt(l,t)===10){const y={line:w.start.line+1,column:0};w=new u(w.bufferIndex,y,w.end,this.getLineFeedCnt(w.bufferIndex,y,w.end),w.length-1),o+=`
`}if(this.shouldCheckCRLF()&&this.startWithLF(o))if(this.nodeCharCodeAt(l,t-1)===13){const y=this.positionInBuffer(l,t-1);this.deleteNodeTail(l,y),o="\r"+o,l.piece.length===0&&f.push(l)}else this.deleteNodeTail(l,_);else this.deleteNodeTail(l,_);const P=this.createNewPieces(o);w.length>0&&this.rbInsertRight(l,w);let m=l;for(let v=0;v<P.length;v++)m=this.rbInsertRight(m,P[v]);this.deleteNodes(f)}else this.insertContentToNodeRight(o,l)}else{const l=this.createNewPieces(o);let t=this.rbInsertLeft(null,l[0]);for(let d=1;d<l.length;d++)t=this.rbInsertRight(t,l[d])}this.computeBufferMetadata()}delete(n,o){if(this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",o<=0||this.root===A.SENTINEL)return;const c=this.nodeAt(n),l=this.nodeAt(n+o),t=c.node,d=l.node;if(t===d){const P=this.positionInBuffer(t,c.remainder),m=this.positionInBuffer(t,l.remainder);if(c.nodeStartOffset===n){if(o===t.piece.length){const v=t.next();(0,A.rbDelete)(this,t),this.validateCRLFWithPrevNode(v),this.computeBufferMetadata();return}this.deleteNodeHead(t,m),this._searchCache.validate(n),this.validateCRLFWithPrevNode(t),this.computeBufferMetadata();return}if(c.nodeStartOffset+t.piece.length===n+o){this.deleteNodeTail(t,P),this.validateCRLFWithNextNode(t),this.computeBufferMetadata();return}this.shrinkNode(t,P,m),this.computeBufferMetadata();return}const s=[],b=this.positionInBuffer(t,c.remainder);this.deleteNodeTail(t,b),this._searchCache.validate(n),t.piece.length===0&&s.push(t);const _=this.positionInBuffer(d,l.remainder);this.deleteNodeHead(d,_),d.piece.length===0&&s.push(d);const f=t.next();for(let P=f;P!==A.SENTINEL&&P!==d;P=P.next())s.push(P);const w=t.piece.length===0?t.prev():t;this.deleteNodes(s),this.validateCRLFWithNextNode(w),this.computeBufferMetadata()}insertContentToNodeLeft(n,o){const c=[];if(this.shouldCheckCRLF()&&this.endWithCR(n)&&this.startWithLF(o)){const d=o.piece,s={line:d.start.line+1,column:0},b=new u(d.bufferIndex,s,d.end,this.getLineFeedCnt(d.bufferIndex,s,d.end),d.length-1);o.piece=b,n+=`
`,(0,A.updateTreeMetadata)(this,o,-1,-1),o.piece.length===0&&c.push(o)}const l=this.createNewPieces(n);let t=this.rbInsertLeft(o,l[l.length-1]);for(let d=l.length-2;d>=0;d--)t=this.rbInsertLeft(t,l[d]);this.validateCRLFWithPrevNode(t),this.deleteNodes(c)}insertContentToNodeRight(n,o){this.adjustCarriageReturnFromNext(n,o)&&(n+=`
`);const c=this.createNewPieces(n),l=this.rbInsertRight(o,c[0]);let t=l;for(let d=1;d<c.length;d++)t=this.rbInsertRight(t,c[d]);this.validateCRLFWithPrevNode(l)}positionInBuffer(n,o,c){const l=n.piece,t=n.piece.bufferIndex,d=this._buffers[t].lineStarts,b=d[l.start.line]+l.start.column+o;let _=l.start.line,f=l.end.line,w=0,P=0,m=0;for(;_<=f&&(w=_+(f-_)/2|0,m=d[w],w!==f);)if(P=d[w+1],b<m)f=w-1;else if(b>=P)_=w+1;else break;return c?(c.line=w,c.column=b-m,null):{line:w,column:b-m}}getLineFeedCnt(n,o,c){if(c.column===0)return c.line-o.line;const l=this._buffers[n].lineStarts;if(c.line===l.length-1)return c.line-o.line;const t=l[c.line+1],d=l[c.line]+c.column;if(t>d+1)return c.line-o.line;const s=d-1;return this._buffers[n].buffer.charCodeAt(s)===13?c.line-o.line+1:c.line-o.line}offsetInBuffer(n,o){return this._buffers[n].lineStarts[o.line]+o.column}deleteNodes(n){for(let o=0;o<n.length;o++)(0,A.rbDelete)(this,n[o])}createNewPieces(n){if(n.length>g){const f=[];for(;n.length>g;){const P=n.charCodeAt(g-1);let m;P===13||P>=55296&&P<=56319?(m=n.substring(0,g-1),n=n.substring(g-1)):(m=n.substring(0,g),n=n.substring(g));const v=R(m);f.push(new u(this._buffers.length,{line:0,column:0},{line:v.length-1,column:m.length-v[v.length-1]},v.length-1,m.length)),this._buffers.push(new p(m,v))}const w=R(n);return f.push(new u(this._buffers.length,{line:0,column:0},{line:w.length-1,column:n.length-w[w.length-1]},w.length-1,n.length)),this._buffers.push(new p(n,w)),f}let o=this._buffers[0].buffer.length;const c=R(n,!1);let l=this._lastChangeBufferPos;if(this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-1]===o&&o!==0&&this.startWithLF(n)&&this.endWithCR(this._buffers[0].buffer)){this._lastChangeBufferPos={line:this._lastChangeBufferPos.line,column:this._lastChangeBufferPos.column+1},l=this._lastChangeBufferPos;for(let f=0;f<c.length;f++)c[f]+=o+1;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(c.slice(1)),this._buffers[0].buffer+="_"+n,o+=1}else{if(o!==0)for(let f=0;f<c.length;f++)c[f]+=o;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(c.slice(1)),this._buffers[0].buffer+=n}const t=this._buffers[0].buffer.length,d=this._buffers[0].lineStarts.length-1,s=t-this._buffers[0].lineStarts[d],b={line:d,column:s},_=new u(0,l,b,this.getLineFeedCnt(0,l,b),t-o);return this._lastChangeBufferPos=b,[_]}getLinesRawContent(){return this.getContentOfSubTree(this.root)}getLineRawContent(n,o=0){let c=this.root,l="";const t=this._searchCache.get2(n);if(t){c=t.node;const d=this.getAccumulatedValue(c,n-t.nodeStartLineNumber-1),s=this._buffers[c.piece.bufferIndex].buffer,b=this.offsetInBuffer(c.piece.bufferIndex,c.piece.start);if(t.nodeStartLineNumber+c.piece.lineFeedCnt===n)l=s.substring(b+d,b+c.piece.length);else{const _=this.getAccumulatedValue(c,n-t.nodeStartLineNumber);return s.substring(b+d,b+_-o)}}else{let d=0;const s=n;for(;c!==A.SENTINEL;)if(c.left!==A.SENTINEL&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const b=this.getAccumulatedValue(c,n-c.lf_left-2),_=this.getAccumulatedValue(c,n-c.lf_left-1),f=this._buffers[c.piece.bufferIndex].buffer,w=this.offsetInBuffer(c.piece.bufferIndex,c.piece.start);return d+=c.size_left,this._searchCache.set({node:c,nodeStartOffset:d,nodeStartLineNumber:s-(n-1-c.lf_left)}),f.substring(w+b,w+_-o)}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const b=this.getAccumulatedValue(c,n-c.lf_left-2),_=this._buffers[c.piece.bufferIndex].buffer,f=this.offsetInBuffer(c.piece.bufferIndex,c.piece.start);l=_.substring(f+b,f+c.piece.length);break}else n-=c.lf_left+c.piece.lineFeedCnt,d+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==A.SENTINEL;){const d=this._buffers[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const s=this.getAccumulatedValue(c,0),b=this.offsetInBuffer(c.piece.bufferIndex,c.piece.start);return l+=d.substring(b,b+s-o),l}else{const s=this.offsetInBuffer(c.piece.bufferIndex,c.piece.start);l+=d.substr(s,c.piece.length)}c=c.next()}return l}computeBufferMetadata(){let n=this.root,o=1,c=0;for(;n!==A.SENTINEL;)o+=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;this._lineCnt=o,this._length=c,this._searchCache.validate(this._length)}getIndexOf(n,o){const c=n.piece,l=this.positionInBuffer(n,o),t=l.line-c.start.line;if(this.offsetInBuffer(c.bufferIndex,c.end)-this.offsetInBuffer(c.bufferIndex,c.start)===o){const d=this.getLineFeedCnt(n.piece.bufferIndex,c.start,l);if(d!==t)return{index:d,remainder:0}}return{index:t,remainder:l.column}}getAccumulatedValue(n,o){if(o<0)return 0;const c=n.piece,l=this._buffers[c.bufferIndex].lineStarts,t=c.start.line+o+1;return t>c.end.line?l[c.end.line]+c.end.column-l[c.start.line]-c.start.column:l[t]-l[c.start.line]-c.start.column}deleteNodeTail(n,o){const c=n.piece,l=c.lineFeedCnt,t=this.offsetInBuffer(c.bufferIndex,c.end),d=o,s=this.offsetInBuffer(c.bufferIndex,d),b=this.getLineFeedCnt(c.bufferIndex,c.start,d),_=b-l,f=s-t,w=c.length+f;n.piece=new u(c.bufferIndex,c.start,d,b,w),(0,A.updateTreeMetadata)(this,n,f,_)}deleteNodeHead(n,o){const c=n.piece,l=c.lineFeedCnt,t=this.offsetInBuffer(c.bufferIndex,c.start),d=o,s=this.getLineFeedCnt(c.bufferIndex,d,c.end),b=this.offsetInBuffer(c.bufferIndex,d),_=s-l,f=t-b,w=c.length+f;n.piece=new u(c.bufferIndex,d,c.end,s,w),(0,A.updateTreeMetadata)(this,n,f,_)}shrinkNode(n,o,c){const l=n.piece,t=l.start,d=l.end,s=l.length,b=l.lineFeedCnt,_=o,f=this.getLineFeedCnt(l.bufferIndex,l.start,_),w=this.offsetInBuffer(l.bufferIndex,o)-this.offsetInBuffer(l.bufferIndex,t);n.piece=new u(l.bufferIndex,l.start,_,f,w),(0,A.updateTreeMetadata)(this,n,w-s,f-b);const P=new u(l.bufferIndex,c,d,this.getLineFeedCnt(l.bufferIndex,c,d),this.offsetInBuffer(l.bufferIndex,d)-this.offsetInBuffer(l.bufferIndex,c)),m=this.rbInsertRight(n,P);this.validateCRLFWithPrevNode(m)}appendToNode(n,o){this.adjustCarriageReturnFromNext(o,n)&&(o+=`
`);const c=this.shouldCheckCRLF()&&this.startWithLF(o)&&this.endWithCR(n),l=this._buffers[0].buffer.length;this._buffers[0].buffer+=o;const t=R(o,!1);for(let m=0;m<t.length;m++)t[m]+=l;if(c){const m=this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-2];this._buffers[0].lineStarts.pop(),this._lastChangeBufferPos={line:this._lastChangeBufferPos.line-1,column:l-m}}this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(t.slice(1));const d=this._buffers[0].lineStarts.length-1,s=this._buffers[0].buffer.length-this._buffers[0].lineStarts[d],b={line:d,column:s},_=n.piece.length+o.length,f=n.piece.lineFeedCnt,w=this.getLineFeedCnt(0,n.piece.start,b),P=w-f;n.piece=new u(n.piece.bufferIndex,n.piece.start,b,w,_),this._lastChangeBufferPos=b,(0,A.updateTreeMetadata)(this,n,o.length,P)}nodeAt(n){let o=this.root;const c=this._searchCache.get(n);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:n-c.nodeStartOffset};let l=0;for(;o!==A.SENTINEL;)if(o.size_left>n)o=o.left;else if(o.size_left+o.piece.length>=n){l+=o.size_left;const t={node:o,remainder:n-o.size_left,nodeStartOffset:l};return this._searchCache.set(t),t}else n-=o.size_left+o.piece.length,l+=o.size_left+o.piece.length,o=o.right;return null}nodeAt2(n,o){let c=this.root,l=0;for(;c!==A.SENTINEL;)if(c.left!==A.SENTINEL&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const t=this.getAccumulatedValue(c,n-c.lf_left-2),d=this.getAccumulatedValue(c,n-c.lf_left-1);return l+=c.size_left,{node:c,remainder:Math.min(t+o-1,d),nodeStartOffset:l}}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const t=this.getAccumulatedValue(c,n-c.lf_left-2);if(t+o-1<=c.piece.length)return{node:c,remainder:t+o-1,nodeStartOffset:l};o-=c.piece.length-t;break}else n-=c.lf_left+c.piece.lineFeedCnt,l+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==A.SENTINEL;){if(c.piece.lineFeedCnt>0){const t=this.getAccumulatedValue(c,0),d=this.offsetOfNode(c);return{node:c,remainder:Math.min(o-1,t),nodeStartOffset:d}}else if(c.piece.length>=o-1){const t=this.offsetOfNode(c);return{node:c,remainder:o-1,nodeStartOffset:t}}else o-=c.piece.length;c=c.next()}return null}nodeCharCodeAt(n,o){if(n.piece.lineFeedCnt<1)return-1;const c=this._buffers[n.piece.bufferIndex],l=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start)+o;return c.buffer.charCodeAt(l)}offsetOfNode(n){if(!n)return 0;let o=n.size_left;for(;n!==this.root;)n.parent.right===n&&(o+=n.parent.size_left+n.parent.piece.length),n=n.parent;return o}shouldCheckCRLF(){return!(this._EOLNormalized&&this._EOL===`
`)}startWithLF(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===A.SENTINEL||n.piece.lineFeedCnt===0)return!1;const o=n.piece,c=this._buffers[o.bufferIndex].lineStarts,l=o.start.line,t=c[l]+o.start.column;return l===c.length-1||c[l+1]>t+1?!1:this._buffers[o.bufferIndex].buffer.charCodeAt(t)===10}endWithCR(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===A.SENTINEL||n.piece.lineFeedCnt===0?!1:this.nodeCharCodeAt(n,n.piece.length-1)===13}validateCRLFWithPrevNode(n){if(this.shouldCheckCRLF()&&this.startWithLF(n)){const o=n.prev();this.endWithCR(o)&&this.fixCRLF(o,n)}}validateCRLFWithNextNode(n){if(this.shouldCheckCRLF()&&this.endWithCR(n)){const o=n.next();this.startWithLF(o)&&this.fixCRLF(n,o)}}fixCRLF(n,o){const c=[],l=this._buffers[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:l[n.piece.end.line]-l[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const d=n.piece.length-1,s=n.piece.lineFeedCnt-1;n.piece=new u(n.piece.bufferIndex,n.piece.start,t,s,d),(0,A.updateTreeMetadata)(this,n,-1,-1),n.piece.length===0&&c.push(n);const b={line:o.piece.start.line+1,column:0},_=o.piece.length-1,f=this.getLineFeedCnt(o.piece.bufferIndex,b,o.piece.end);o.piece=new u(o.piece.bufferIndex,b,o.piece.end,f,_),(0,A.updateTreeMetadata)(this,o,-1,-1),o.piece.length===0&&c.push(o);const w=this.createNewPieces(`\r
`);this.rbInsertRight(n,w[0]);for(let P=0;P<c.length;P++)(0,A.rbDelete)(this,c[P])}adjustCarriageReturnFromNext(n,o){if(this.shouldCheckCRLF()&&this.endWithCR(n)){const c=o.next();if(this.startWithLF(c)){if(n+=`
`,c.piece.length===1)(0,A.rbDelete)(this,c);else{const l=c.piece,t={line:l.start.line+1,column:0},d=l.length-1,s=this.getLineFeedCnt(l.bufferIndex,t,l.end);c.piece=new u(l.bufferIndex,t,l.end,s,d),(0,A.updateTreeMetadata)(this,c,-1,-1)}return!0}}return!1}iterate(n,o){if(n===A.SENTINEL)return o(A.SENTINEL);const c=this.iterate(n.left,o);return c&&o(n)&&this.iterate(n.right,o)}getNodeContent(n){if(n===A.SENTINEL)return"";const o=this._buffers[n.piece.bufferIndex],c=n.piece,l=this.offsetInBuffer(c.bufferIndex,c.start),t=this.offsetInBuffer(c.bufferIndex,c.end);return o.buffer.substring(l,t)}getPieceContent(n){const o=this._buffers[n.bufferIndex],c=this.offsetInBuffer(n.bufferIndex,n.start),l=this.offsetInBuffer(n.bufferIndex,n.end);return o.buffer.substring(c,l)}rbInsertRight(n,o){const c=new A.TreeNode(o,1);if(c.left=A.SENTINEL,c.right=A.SENTINEL,c.parent=A.SENTINEL,c.size_left=0,c.lf_left=0,this.root===A.SENTINEL)this.root=c,c.color=0;else if(n.right===A.SENTINEL)n.right=c,c.parent=n;else{const t=(0,A.leftest)(n.right);t.left=c,c.parent=t}return(0,A.fixInsert)(this,c),c}rbInsertLeft(n,o){const c=new A.TreeNode(o,1);if(c.left=A.SENTINEL,c.right=A.SENTINEL,c.parent=A.SENTINEL,c.size_left=0,c.lf_left=0,this.root===A.SENTINEL)this.root=c,c.color=0;else if(n.left===A.SENTINEL)n.left=c,c.parent=n;else{const l=(0,A.righttest)(n.left);l.right=c,c.parent=l}return(0,A.fixInsert)(this,c),c}getContentOfSubTree(n){let o="";return this.iterate(n,c=>(o+=this.getNodeContent(c),!0)),o}}e.PieceTreeBase=a}),define(Pe[132],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class I{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(A){if(A&&this._dragOperations.has(A)){const T=this._dragOperations.get(A);return this._dragOperations.delete(A),T}}addDragOperationTransfer(A,T){this._dragOperations.set(A,T)}}e.TreeViewsDnDService=I;class L{constructor(A){this.identifier=A}}e.DraggedTreeItemsIdentifier=L}),define(Pe[133],Te([9,10]),function(me,e){return me.create("vs/base/common/actions",e)}),define(Pe[134],Te([1,0,5,6,133]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class A extends L.Disposable{constructor(u,p="",E="",i=!0,a){super(),this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=u,this._label=p,this._cssClass=E,this._enabled=i,this._actionCallback=a}get id(){return this._id}get label(){return this._label}set label(u){this._setLabel(u)}_setLabel(u){this._label!==u&&(this._label=u,this._onDidChange.fire({label:u}))}get tooltip(){return this._tooltip||""}set tooltip(u){this._setTooltip(u)}_setTooltip(u){this._tooltip!==u&&(this._tooltip=u,this._onDidChange.fire({tooltip:u}))}get class(){return this._cssClass}set class(u){this._setClass(u)}_setClass(u){this._cssClass!==u&&(this._cssClass=u,this._onDidChange.fire({class:u}))}get enabled(){return this._enabled}set enabled(u){this._setEnabled(u)}_setEnabled(u){this._enabled!==u&&(this._enabled=u,this._onDidChange.fire({enabled:u}))}get checked(){return this._checked}set checked(u){this._setChecked(u)}_setChecked(u){this._checked!==u&&(this._checked=u,this._onDidChange.fire({checked:u}))}async run(u,p){this._actionCallback&&await this._actionCallback(u)}}e.Action=A;class T extends L.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new I.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new I.Emitter),this.onDidRun=this._onDidRun.event}async run(u,p){if(!u.enabled)return;this._onWillRun.fire({action:u});let E;try{await this.runAction(u,p)}catch(i){E=i}this._onDidRun.fire({action:u,error:E})}async runAction(u,p){await u.run(p)}}e.ActionRunner=T;class g{constructor(){this.id=g.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let p=[];for(const E of u)E.length&&(p.length?p=[...p,new g,...E]:p=E);return p}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=g;class h{get actions(){return this._actions}constructor(u,p,E,i){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=p,this.class=i,this._actions=E}async run(){}}e.SubmenuAction=h;class S extends A{static{this.ID="vs.actions.empty"}constructor(){super(S.ID,C.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=S;function R(D){return{id:D.id,label:D.label,class:D.class,enabled:D.enabled??!0,checked:D.checked??!1,run:async(...u)=>D.run(...u),tooltip:D.label}}e.toAction=R}),define(Pe[135],Te([9,10]),function(me,e){return me.create("vs/base/common/date",e)}),define(Pe[136],Te([1,0,135]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,C=L*60,A=C*24,T=A*7,g=A*30,h=A*365;function S(D,u,p,E){typeof D!="number"&&(D=D.getTime());const i=Math.round((new Date().getTime()-D)/1e3);if(i<-30)return(0,I.localize)(0,null,S(new Date().getTime()+i*1e3,!1));if(!E&&i<30)return(0,I.localize)(1,null);let a;return i<L?(a=i,u?a===1?p?(0,I.localize)(2,null,a):(0,I.localize)(3,null,a):p?(0,I.localize)(4,null,a):(0,I.localize)(5,null,a):a===1?p?(0,I.localize)(6,null,a):(0,I.localize)(7,null,a):p?(0,I.localize)(8,null,a):(0,I.localize)(9,null,a)):i<C?(a=Math.floor(i/L),u?a===1?p?(0,I.localize)(10,null,a):(0,I.localize)(11,null,a):p?(0,I.localize)(12,null,a):(0,I.localize)(13,null,a):a===1?p?(0,I.localize)(14,null,a):(0,I.localize)(15,null,a):p?(0,I.localize)(16,null,a):(0,I.localize)(17,null,a)):i<A?(a=Math.floor(i/C),u?a===1?p?(0,I.localize)(18,null,a):(0,I.localize)(19,null,a):p?(0,I.localize)(20,null,a):(0,I.localize)(21,null,a):a===1?p?(0,I.localize)(22,null,a):(0,I.localize)(23,null,a):p?(0,I.localize)(24,null,a):(0,I.localize)(25,null,a)):i<T?(a=Math.floor(i/A),u?a===1?(0,I.localize)(26,null,a):(0,I.localize)(27,null,a):a===1?(0,I.localize)(28,null,a):(0,I.localize)(29,null,a)):i<g?(a=Math.floor(i/T),u?a===1?p?(0,I.localize)(30,null,a):(0,I.localize)(31,null,a):p?(0,I.localize)(32,null,a):(0,I.localize)(33,null,a):a===1?p?(0,I.localize)(34,null,a):(0,I.localize)(35,null,a):p?(0,I.localize)(36,null,a):(0,I.localize)(37,null,a)):i<h?(a=Math.floor(i/g),u?a===1?p?(0,I.localize)(38,null,a):(0,I.localize)(39,null,a):p?(0,I.localize)(40,null,a):(0,I.localize)(41,null,a):a===1?p?(0,I.localize)(42,null,a):(0,I.localize)(43,null,a):p?(0,I.localize)(44,null,a):(0,I.localize)(45,null,a)):(a=Math.floor(i/h),u?a===1?p?(0,I.localize)(46,null,a):(0,I.localize)(47,null,a):p?(0,I.localize)(48,null,a):(0,I.localize)(49,null,a):a===1?p?(0,I.localize)(50,null,a):(0,I.localize)(51,null,a):p?(0,I.localize)(52,null,a):(0,I.localize)(53,null,a))}e.fromNow=S;function R(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Pe[137],Te([9,10]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(Pe[41],Te([1,0,18,16,137]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(D,u){return u&&(D.stack||D.stacktrace)?C.localize(0,null,g(D),T(D.stack)||T(D.stacktrace)):g(D)}function T(D){return Array.isArray(D)?D.join(`
`):D}function g(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?C.localize(1,null,D.message):D.message||C.localize(2,null)}function h(D=null,u=!1){if(!D)return C.localize(3,null);if(Array.isArray(D)){const p=I.coalesce(D),E=h(p[0],u);return p.length>1?C.localize(4,null,E,p.length):E}if(L.isString(D))return D;if(D.detail){const p=D.detail;if(p.error)return A(p.error,u);if(p.exception)return A(p.exception,u)}return D.stack?A(D,u):D.message?D.message:C.localize(5,null)}e.toErrorMessage=h;function S(D){const u=D;return u instanceof Error&&Array.isArray(u.actions)}e.isErrorWithActions=S;function R(D,u){let p;return typeof D=="string"?p=new Error(D):p=D,p.actions=u,p}e.createErrorWithActions=R}),define(Pe[138],Te([1,0,39,19]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const C=new I.Lazy(()=>{const P=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:P,collatorIsNumeric:P.resolvedOptions().numeric}}),A=new I.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new I.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function g(P,m,v=!1){const y=P||"",O=m||"",N=C.value.collator.compare(y,O);return C.value.collatorIsNumeric&&N===0&&y!==O?y<O?-1:1:N}e.compareFileNames=g;function h(P,m){const v=A.value.collator;return P=P||"",m=m||"",c(v,P,m)}e.compareFileNamesDefault=h;function S(P,m){const v=A.value.collator;return P=P||"",m=m||"",s(P,m)||c(v,P,m)}e.compareFileNamesUpper=S;function R(P,m){const v=A.value.collator;return P=P||"",m=m||"",d(P,m)||c(v,P,m)}e.compareFileNamesLower=R;function D(P,m){return P=P||"",m=m||"",P===m?0:P<m?-1:1}e.compareFileNamesUnicode=D;function u(P,m){const[v,y]=n(P),[O,N]=n(m);let q=C.value.collator.compare(y,N);if(q===0){if(C.value.collatorIsNumeric&&y!==N)return y<N?-1:1;if(q=C.value.collator.compare(v,O),C.value.collatorIsNumeric&&q===0&&v!==O)return v<O?-1:1}return q}e.compareFileExtensions=u;function p(P,m){P=P||"",m=m||"";const v=o(P),y=o(m),O=A.value.collator,N=T.value.collator;return c(N,v,y)||c(O,P,m)}e.compareFileExtensionsDefault=p;function E(P,m){P=P||"",m=m||"";const v=o(P),y=o(m),O=A.value.collator,N=T.value.collator;return c(N,v,y)||s(P,m)||c(O,P,m)}e.compareFileExtensionsUpper=E;function i(P,m){P=P||"",m=m||"";const v=o(P),y=o(m),O=A.value.collator,N=T.value.collator;return c(N,v,y)||d(P,m)||c(O,P,m)}e.compareFileExtensionsLower=i;function a(P,m){P=P||"",m=m||"";const v=o(P).toLowerCase(),y=o(m).toLowerCase();return v!==y?v<y?-1:1:P!==m?P<m?-1:1:0}e.compareFileExtensionsUnicode=a;const r=/^(.*?)(\.([^.]*))?$/;function n(P,m=!1){const v=P?r.exec(P):[];let y=[v&&v[1]||"",v&&v[3]||""];return m&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function o(P){const m=P?r.exec(P):[];return m&&m[1]&&m[1].charAt(0)!=="."&&m[3]||""}function c(P,m,v){const y=P.compare(m,v);return y!==0?y:m.length!==v.length?m.length<v.length?-1:1:0}function l(P){const m=P.charAt(0);return m.toLocaleUpperCase()!==m}function t(P){const m=P.charAt(0);return m.toLocaleLowerCase()!==m}function d(P,m){return l(P)&&t(m)?-1:t(P)&&l(m)?1:0}function s(P,m){return t(P)&&l(m)?-1:l(P)&&t(m)?1:0}function b(P,m,v=!1){return v||(P=P&&P.toLowerCase(),m=m&&m.toLowerCase()),P===m?0:P<m?-1:1}function _(P,m,v=!1){const y=P.split(L.sep),O=m.split(L.sep),N=y.length-1,q=O.length-1;let W,x;for(let k=0;;k++){if(W=N===k,x=q===k,W&&x)return g(y[k],O[k],v);if(W)return-1;if(x)return 1;const M=b(y[k],O[k],v);if(M!==0)return M}}e.comparePaths=_;function f(P,m,v){const y=P.toLowerCase(),O=m.toLowerCase(),N=w(P,m,v);if(N)return N;const q=y.endsWith(v),W=O.endsWith(v);if(q!==W)return q?-1:1;const x=g(y,O);return x!==0?x:y.localeCompare(O)}e.compareAnything=f;function w(P,m,v){const y=P.toLowerCase(),O=m.toLowerCase(),N=y.startsWith(v),q=O.startsWith(v);if(N!==q)return N?-1:1;if(N&&q){if(y.length<O.length)return-1;if(y.length>O.length)return 1}return 0}e.compareByPrefix=w}),define(Pe[45],Te([1,0,19,21,12,16]),function(me,e,I,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(f){return f===47||f===92}e.isPathSeparator=T;function g(f){return f.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=g;function h(f){return f.indexOf("/")===-1&&(f=g(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}e.toPosixPath=h;function S(f,w=I.posix.sep){if(!f)return"";const P=f.length,m=f.charCodeAt(0);if(T(m)){if(T(f.charCodeAt(1))&&!T(f.charCodeAt(2))){let y=3;const O=y;for(;y<P&&!T(f.charCodeAt(y));y++);if(O!==y&&!T(f.charCodeAt(y+1))){for(y+=1;y<P;y++)if(T(f.charCodeAt(y)))return f.slice(0,y+1).replace(/[\\/]/g,w)}}return w}else if(r(m)&&f.charCodeAt(1)===58)return T(f.charCodeAt(2))?f.slice(0,2)+w:f.slice(0,2);let v=f.indexOf("://");if(v!==-1){for(v+=3;v<P;v++)if(T(f.charCodeAt(v)))return f.slice(0,v+1)}return""}e.getRoot=S;function R(f){if(!L.isWindows||!f||f.length<5)return!1;let w=f.charCodeAt(0);if(w!==92||(w=f.charCodeAt(1),w!==92))return!1;let P=2;const m=P;for(;P<f.length&&(w=f.charCodeAt(P),w!==92);P++);return!(m===P||(w=f.charCodeAt(P+1),isNaN(w)||w===92))}e.isUNC=R;const D=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function E(f,w=L.isWindows){const P=w?D:u;return!(!f||f.length===0||/^\s+$/.test(f)||(P.lastIndex=0,P.test(f))||w&&p.test(f)||f==="."||f===".."||w&&f[f.length-1]==="."||w&&f.length!==f.trim().length||f.length>255)}e.isValidBasename=E;function i(f,w,P){const m=f===w;return!P||m?m:!f||!w?!1:(0,C.equalsIgnoreCase)(f,w)}e.isEqual=i;function a(f,w,P,m=I.sep){if(f===w)return!0;if(!f||!w||w.length>f.length)return!1;if(P){if(!(0,C.startsWithIgnoreCase)(f,w))return!1;if(w.length===f.length)return!0;let y=w.length;return w.charAt(w.length-1)===m&&y--,f.charAt(y)===m}return w.charAt(w.length-1)!==m&&(w+=m),f.indexOf(w)===0}e.isEqualOrParent=a;function r(f){return f>=65&&f<=90||f>=97&&f<=122}e.isWindowsDriveLetter=r;function n(f,w){return L.isWindows&&f.endsWith(":")&&(f+=I.sep),(0,I.isAbsolute)(f)||(f=(0,I.join)(w,f)),f=(0,I.normalize)(f),L.isWindows?(f=(0,C.rtrim)(f,I.sep),f.endsWith(":")&&(f+=I.sep)):(f=(0,C.rtrim)(f,I.sep),f||(f=I.sep)),f}e.sanitizeFilePath=n;function o(f){const w=(0,I.normalize)(f);return L.isWindows?f.length>3?!1:c(w)&&(f.length===2||w.charCodeAt(2)===92):w===I.posix.sep}e.isRootOrDriveLetter=o;function c(f,w=L.isWindows){return w?r(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function l(f,w=L.isWindows){return c(f,w)?f[0]:void 0}e.getDriveLetter=l;function t(f,w,P){return w.length>f.length?-1:f===w?0:(P&&(f=f.toLowerCase(),w=w.toLowerCase()),f.indexOf(w))}e.indexOfPath=t;function d(f){const w=f.split(":");let P,m,v;for(const y of w){const O=Number(y);(0,A.isNumber)(O)?m===void 0?m=O:v===void 0&&(v=O):P=P?[P,y].join(":"):y}if(!P)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:P,line:m!==void 0?m:void 0,column:v!==void 0?v:m!==void 0?1:void 0}}e.parseLineAndColumnAware=d;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",b="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function _(f,w,P=8){let m="";for(let y=0;y<P;y++){let O;y===0&&L.isWindows&&!w&&(P===3||P===4)?O=b:O=s,m+=O.charAt(Math.floor(Math.random()*O.length))}let v;return w?v=`${w}-${m}`:v=m,f?(0,I.join)(f,v):v}e.randomPath=_}),define(Pe[69],Te([1,0,19]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(R){const D=(0,I.extname)(R),u=L[D.toLowerCase()];return u!==void 0?u:T(R)}e.getMediaOrTextMime=A;function T(R){const D=(0,I.extname)(R);return C[D.toLowerCase()]}e.getMediaMime=T;function g(R){for(const D in C)if(C[D]===R)return D}e.getExtensionForMimeType=g;const h=/^(.+)\/(.+?)(;.+)?$/;function S(R,D){const u=h.exec(R);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:D?void 0:R}e.normalizeMimeType=S}),define(Pe[51],Te([1,0,23,2]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function C(h){return JSON.stringify(h,T)}e.stringify=C;function A(h){let S=JSON.parse(h);return S=g(S),S}e.parse=A;function T(h,S){return S instanceof RegExp?{$mid:2,source:S.source,flags:S.flags}:S}function g(h,S=0){if(!h||S>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return L.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof I.VSBuffer||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let R=0;R<h.length;++R)h[R]=g(h[R],S+1);else for(const R in h)Object.hasOwnProperty.call(h,R)&&(h[R]=g(h[R],S+1))}return h}e.revive=g}),define(Pe[11],Te([1,0,15,21,12,2]),function(me,e,I,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.matchesSomeScheme=e.matchesScheme=e.Schemas=void 0;var T;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeManagedRemoteResource="vscode-managed-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.vscodeChatSesssion="vscode-chat-editor",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm"})(T||(e.Schemas=T={}));function g(u,p){return A.URI.isUri(u)?(0,C.equalsIgnoreCase)(u.scheme,p):(0,C.startsWithIgnoreCase)(u,p+":")}e.matchesScheme=g;function h(u,...p){return p.some(E=>g(u,E))}e.matchesSomeScheme=h,e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${T.vscodeRemoteResource}`}setPreferredWebSchema(p){this._preferredWebSchema=p}setDelegate(p){this._delegate=p}setServerRootPath(p){this._remoteResourcesPath=`${p}/${T.vscodeRemoteResource}`}set(p,E,i){this._hosts[p]=E,this._ports[p]=i}setConnectionToken(p,E){this._connectionTokens[p]=E}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(p){if(this._delegate)try{return this._delegate(p)}catch(o){return I.onUnexpectedError(o),p}const E=p.authority;let i=this._hosts[E];i&&i.indexOf(":")!==-1&&i.indexOf("[")===-1&&(i=`[${i}]`);const a=this._ports[E],r=this._connectionTokens[E];let n=`path=${encodeURIComponent(p.path)}`;return typeof r=="string"&&(n+=`&${e.connectionTokenQueryName}=${encodeURIComponent(r)}`),A.URI.from({scheme:L.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:`${i}:${a}`,path:this._remoteResourcesPath,query:n})}}e.RemoteAuthorities=new S,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class R{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(p){const E=this.toUri(p,me);return this.uriToBrowserUri(E)}uriToBrowserUri(p){return p.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(p):p.scheme===T.file&&(L.isNative||L.webWorkerOrigin===`${T.vscodeFileResource}://${R.FALLBACK_AUTHORITY}`)?p.with({scheme:T.vscodeFileResource,authority:p.authority||R.FALLBACK_AUTHORITY,query:null,fragment:null}):p}asFileUri(p){const E=this.toUri(p,me);return this.uriToFileUri(E)}uriToFileUri(p){return p.scheme===T.vscodeFileResource?p.with({scheme:T.file,authority:p.authority!==R.FALLBACK_AUTHORITY?p.authority:null,query:null,fragment:null}):p}toUri(p,E){return A.URI.isUri(p)?p:A.URI.parse(E.toUrl(p))}}e.FileAccess=new R;var D;(function(u){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(p.get("3"));const E="vscode-coi";function i(r){let n;typeof r=="string"?n=new URL(r).searchParams:r instanceof URL?n=r.searchParams:A.URI.isUri(r)&&(n=new URL(r.toString(!0)).searchParams);const o=n?.get(E);if(o)return p.get(o)}u.getHeadersFromQuery=i;function a(r,n,o){if(!globalThis.crossOriginIsolated)return;const c=n&&o?"3":o?"2":"1";r instanceof URLSearchParams?r.set(E,c):r[E]=c}u.addSearchParam=a})(D||(e.COI=D={}))}),define(Pe[25],Te([1,0,45,11,19,21,12,2]),function(me,e,I,L,C,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function h(p){return(0,g.uriToFsPath)(p,!0)}e.originalFSPath=h;class S{constructor(E){this._ignorePathCasing=E}compare(E,i,a=!1){return E===i?0:(0,T.compare)(this.getComparisonKey(E,a),this.getComparisonKey(i,a))}isEqual(E,i,a=!1){return E===i?!0:!E||!i?!1:this.getComparisonKey(E,a)===this.getComparisonKey(i,a)}getComparisonKey(E,i=!1){return E.with({path:this._ignorePathCasing(E)?E.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(E){return this._ignorePathCasing(E)}isEqualOrParent(E,i,a=!1){if(E.scheme===i.scheme){if(E.scheme===L.Schemas.file)return I.isEqualOrParent(h(E),h(i),this._ignorePathCasing(E))&&E.query===i.query&&(a||E.fragment===i.fragment);if((0,e.isEqualAuthority)(E.authority,i.authority))return I.isEqualOrParent(E.path,i.path,this._ignorePathCasing(E),"/")&&E.query===i.query&&(a||E.fragment===i.fragment)}return!1}joinPath(E,...i){return g.URI.joinPath(E,...i)}basenameOrAuthority(E){return(0,e.basename)(E)||E.authority}basename(E){return C.posix.basename(E.path)}extname(E){return C.posix.extname(E.path)}dirname(E){if(E.path.length===0)return E;let i;return E.scheme===L.Schemas.file?i=g.URI.file(C.dirname(h(E))).path:(i=C.posix.dirname(E.path),E.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${E.toString})) resulted in a relative path`),i="/")),E.with({path:i})}normalizePath(E){if(!E.path.length)return E;let i;return E.scheme===L.Schemas.file?i=g.URI.file(C.normalize(h(E))).path:i=C.posix.normalize(E.path),E.with({path:i})}relativePath(E,i){if(E.scheme!==i.scheme||!(0,e.isEqualAuthority)(E.authority,i.authority))return;if(E.scheme===L.Schemas.file){const n=C.relative(h(E),h(i));return A.isWindows?I.toSlashes(n):n}let a=E.path||"/";const r=i.path||"/";if(this._ignorePathCasing(E)){let n=0;for(const o=Math.min(a.length,r.length);n<o&&!(a.charCodeAt(n)!==r.charCodeAt(n)&&a.charAt(n).toLowerCase()!==r.charAt(n).toLowerCase());n++);a=r.substr(0,n)+a.substr(n)}return C.posix.relative(a,r)}resolvePath(E,i){if(E.scheme===L.Schemas.file){const a=g.URI.file(C.resolve(h(E),i));return E.with({authority:a.authority,path:a.path})}return i=I.toPosixPath(i),E.with({path:C.posix.resolve(E.path,i)})}isAbsolutePath(E){return!!E.path&&E.path[0]==="/"}isEqualAuthority(E,i){return E===i||E!==void 0&&i!==void 0&&(0,T.equalsIgnoreCase)(E,i)}hasTrailingPathSeparator(E,i=C.sep){if(E.scheme===L.Schemas.file){const a=h(E);return a.length>I.getRoot(a).length&&a[a.length-1]===i}else{const a=E.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(E.fsPath)}}removeTrailingPathSeparator(E,i=C.sep){return(0,e.hasTrailingPathSeparator)(E,i)?E.with({path:E.path.substr(0,E.path.length-1)}):E}addTrailingPathSeparator(E,i=C.sep){let a=!1;if(E.scheme===L.Schemas.file){const r=h(E);a=r!==void 0&&r.length===I.getRoot(r).length&&r[r.length-1]===i}else{i="/";const r=E.path;a=r.length===1&&r.charCodeAt(r.length-1)===47}return!a&&!(0,e.hasTrailingPathSeparator)(E,i)?E.with({path:E.path+"/"}):E}}e.ExtUri=S,e.extUri=new S(()=>!1),e.extUriBiasedIgnorePathCase=new S(p=>p.scheme===L.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new S(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(p,E){const i=[];for(let a=0;a<p.length;a++){const r=E(p[a]);p.some((n,o)=>o===a?!1:(0,e.isEqualOrParent)(r,E(n)))||i.push(p[a])}return i}e.distinctParents=R;var D;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function E(i){const a=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(o=>{const[c,l]=o.split(":");c&&l&&a.set(c,l)});const n=i.path.substring(0,i.path.indexOf(";"));return n&&a.set(p.META_DATA_MIME,n),a}p.parseMetaData=E})(D||(e.DataUri=D={}));function u(p,E,i){if(E){let a=p.path;return a&&a[0]!==C.posix.sep&&(a=C.posix.sep+a),p.with({scheme:i,authority:E,path:a})}return p.with({scheme:i})}e.toLocalResource=u}),define(Pe[13],Te([1,0,20,15,5,6,25,21,125,39]),function(me,e,I,L,C,A,T,g,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function R(ce){return!!ce&&typeof ce.then=="function"}e.isThenable=R;function D(ce){const te=new I.CancellationTokenSource,K=ce(te.token),ee=new Promise((ge,be)=>{const Le=te.token.onCancellationRequested(()=>{Le.dispose(),be(new L.CancellationError)});Promise.resolve(K).then(fe=>{Le.dispose(),te.dispose(),ge(fe)},fe=>{Le.dispose(),te.dispose(),be(fe)})});return new class{cancel(){te.cancel(),te.dispose()}then(ge,be){return ee.then(ge,be)}catch(ge){return this.then(void 0,ge)}finally(ge){return ee.finally(ge)}}}e.createCancelablePromise=D;function u(ce,te,K){return new Promise((ee,ge)=>{const be=te.onCancellationRequested(()=>{be.dispose(),ee(K)});ce.then(ee,ge).finally(()=>be.dispose())})}e.raceCancellation=u;function p(ce,te){return new Promise((K,ee)=>{const ge=te.onCancellationRequested(()=>{ge.dispose(),ee(new L.CancellationError)});ce.then(K,ee).finally(()=>ge.dispose())})}e.raceCancellationError=p;async function E(ce){let te=-1;const K=ce.map((ee,ge)=>ee.then(be=>(te=ge,be)));try{return await Promise.race(K)}finally{ce.forEach((ee,ge)=>{ge!==te&&ee.cancel()})}}e.raceCancellablePromises=E;function i(ce,te,K){let ee;const ge=setTimeout(()=>{ee?.(void 0),K?.()},te);return Promise.race([ce.finally(()=>clearTimeout(ge)),new Promise(be=>ee=be)])}e.raceTimeout=i;function a(ce){return new Promise((te,K)=>{const ee=ce();R(ee)?ee.then(te,K):te(ee)})}e.asPromise=a;class r{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(te){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=te,!this.queuedPromise){const K=()=>{if(this.queuedPromise=null,this.isDisposed)return;const ee=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ee};this.queuedPromise=new Promise(ee=>{this.activePromise.then(K,K).then(ee)})}return new Promise((K,ee)=>{this.queuedPromise.then(K,ee)})}return this.activePromise=te(),new Promise((K,ee)=>{this.activePromise.then(ge=>{this.activePromise=null,K(ge)},ge=>{this.activePromise=null,ee(ge)})})}dispose(){this.isDisposed=!0}}e.Throttler=r;class n{constructor(){this.current=Promise.resolve(null)}queue(te){return this.current=this.current.then(()=>te(),()=>te())}}e.Sequencer=n;class o{constructor(){this.promiseMap=new Map}queue(te,K){const ge=(this.promiseMap.get(te)??Promise.resolve()).catch(()=>{}).then(K).finally(()=>{this.promiseMap.get(te)===ge&&this.promiseMap.delete(te)});return this.promiseMap.set(te,ge),ge}}e.SequencerByKey=o;const c=(ce,te)=>{let K=!0;const ee=setTimeout(()=>{K=!1,te()},ce);return{isTriggered:()=>K,dispose:()=>{clearTimeout(ee),K=!1}}},l=ce=>{let te=!0;return queueMicrotask(()=>{te&&(te=!1,ce())}),{isTriggered:()=>te,dispose:()=>{te=!1}}};class t{constructor(te){this.defaultDelay=te,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(te,K=this.defaultDelay){this.task=te,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ge,be)=>{this.doResolve=ge,this.doReject=be}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ge=this.task;return this.task=null,ge()}}));const ee=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=K===h.MicrotaskDelay?l(ee):c(K,ee),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new L.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=t;class d{constructor(te){this.delayer=new t(te),this.throttler=new r}trigger(te,K){return this.delayer.trigger(()=>this.throttler.queue(te),K)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=d;class s{constructor(){this._isOpen=!1,this._promise=new Promise((te,K)=>{this._completePromise=te})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class b extends s{constructor(te){super(),this._timeout=setTimeout(()=>this.open(),te)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=b;function _(ce,te){return te?new Promise((K,ee)=>{const ge=setTimeout(()=>{be.dispose(),K()},ce),be=te.onCancellationRequested(()=>{clearTimeout(ge),be.dispose(),ee(new L.CancellationError)})}):D(K=>_(ce,K))}e.timeout=_;function f(ce,te=0,K){const ee=setTimeout(()=>{ce(),K&&ge.dispose()},te),ge=(0,A.toDisposable)(()=>{clearTimeout(ee),K?.deleteAndLeak(ge)});return K?.add(ge),ge}e.disposableTimeout=f;function w(ce){const te=[];let K=0;const ee=ce.length;function ge(){return K<ee?ce[K++]():null}function be(Le){Le!=null&&te.push(Le);const fe=ge();return fe?fe.then(be):Promise.resolve(te)}return Promise.resolve(null).then(be)}e.sequence=w;function P(ce,te=ee=>!!ee,K=null){let ee=0;const ge=ce.length,be=()=>{if(ee>=ge)return Promise.resolve(K);const Le=ce[ee++];return Promise.resolve(Le()).then(_e=>te(_e)?Promise.resolve(_e):be())};return be()}e.first=P;function m(ce,te=ee=>!!ee,K=null){if(ce.length===0)return Promise.resolve(K);let ee=ce.length;const ge=()=>{ee=-1;for(const be of ce)be.cancel?.()};return new Promise((be,Le)=>{for(const fe of ce)fe.then(_e=>{--ee>=0&&te(_e)?(ge(),be(_e)):ee===0&&be(K)}).catch(_e=>{--ee>=0&&(ge(),Le(_e))})})}e.firstParallel=m;class v{constructor(te){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=te,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new C.Emitter}whenIdle(){return this.size>0?C.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(te){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((K,ee)=>{this.outstandingPromises.push({factory:te,c:K,e:ee}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const te=this.outstandingPromises.shift();this.runningPromises++;const K=te.factory();K.then(te.c,te.e),K.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=v;class y extends v{constructor(){super(1)}}e.Queue=y;class O{constructor(){this.sequentializer=new ye,this.tasks=0}queue(te){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,te())):this.sequentializer.run(this.tasks++,te())}}e.LimitedQueue=O;class N{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const te=new ae;return this.drainers.add(te),te.p}isDrained(){for(const[,te]of this.queues)if(te.size>0)return!1;return!0}queueSize(te,K=T.extUri){const ee=K.getComparisonKey(te);return this.queues.get(ee)?.size??0}queueFor(te,K,ee=T.extUri){const ge=ee.getComparisonKey(te);let be=this.queues.get(ge);if(!be){be=new y;const Le=this.drainListenerCount++,fe=C.Event.once(be.onDrained)(()=>{be?.dispose(),this.queues.delete(ge),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(Le),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new A.DisposableMap),this.drainListeners.set(Le,fe),this.queues.set(ge,be)}return be.queue(K)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const te of this.drainers)te.complete();this.drainers.clear()}dispose(){for(const[,te]of this.queues)te.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=N;class q{constructor(te,K){this._token=-1,typeof te=="function"&&typeof K=="number"&&this.setIfNotSet(te,K)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(te,K){this.cancel(),this._token=setTimeout(()=>{this._token=-1,te()},K)}setIfNotSet(te,K){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,te()},K))}}e.TimeoutTimer=q;class W{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(te,K,ee=globalThis){this.cancel();const ge=ee.setInterval(()=>{te()},K);this.disposable=(0,A.toDisposable)(()=>{ee.clearInterval(ge),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=W;class x{constructor(te,K){this.timeoutToken=-1,this.runner=te,this.timeout=K,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(te=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,te)}get delay(){return this.timeout}set delay(te){this.timeout=te}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=x;class k{constructor(te,K){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.runner=te,this.timeout=K,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(te=this.timeout){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(te/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=k;class M extends x{constructor(te,K){super(te,K),this.units=[]}work(te){this.units.push(te),this.isScheduled()||this.schedule()}doRun(){const te=this.units;this.units=[],this.runner?.(te)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=M;class $ extends A.Disposable{constructor(te,K){super(),this.options=te,this.handler=K,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(te){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+te.length>this.options.maxBufferedWork)return!1}else if(this.pending+te.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const K of te)this.pendingWork.push(K);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new x(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=$,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(ce,te)=>{(0,g.setTimeout0)(()=>{if(K)return;const ee=Date.now()+15;te(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ee-Date.now())}}))});let K=!1;return{dispose(){K||(K=!0)}}}:e._runWhenIdle=(ce,te,K)=>{const ee=ce.requestIdleCallback(te,typeof K=="number"?{timeout:K}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,ce.cancelIdleCallback(ee))}}},e.runWhenGlobalIdle=ce=>(0,e._runWhenIdle)(globalThis,ce)}();class oe{constructor(te,K){this._didRun=!1,this._executor=()=>{try{this._value=K()}catch(ee){this._error=ee}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(te,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=oe;class de extends oe{constructor(te){super(globalThis,te)}}e.GlobalIdleValue=de;async function we(ce,te,K){let ee;for(let ge=0;ge<K;ge++)try{return await ce()}catch(be){ee=be,await _(te)}throw ee}e.retry=we;class ye{isRunning(te){return typeof te=="number"?this._running?.taskId===te:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(te,K,ee){return this._running={taskId:te,cancel:()=>ee?.(),promise:K},K.then(()=>this.doneRunning(te),()=>this.doneRunning(te)),K}doneRunning(te){this._running&&te===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const te=this._queued;this._queued=void 0,te.run().then(te.promiseResolve,te.promiseReject)}}queue(te){if(this._queued)this._queued.run=te;else{let K,ee;const ge=new Promise((be,Le)=>{K=be,ee=Le});this._queued={run:te,promise:ge,promiseResolve:K,promiseReject:ee}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=ye;class le{constructor(te,K=()=>Date.now()){this.interval=te,this.nowFn=K,this.lastIncrementTime=0,this.value=0}increment(){const te=this.nowFn();return te-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=te,this.value=0),this.value++,this.value}}e.IntervalCounter=le;var ve;(function(ce){ce[ce.Resolved=0]="Resolved",ce[ce.Rejected=1]="Rejected"})(ve||(ve={}));class ae{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((te,K)=>{this.completeCallback=te,this.errorCallback=K})}complete(te){return new Promise(K=>{this.completeCallback(te),this.outcome={outcome:0,value:te},K()})}error(te){return new Promise(K=>{this.errorCallback(te),this.outcome={outcome:1,value:te},K()})}cancel(){return this.error(new L.CancellationError)}}e.DeferredPromise=ae;var pe;(function(ce){async function te(ee){let ge;const be=await Promise.all(ee.map(Le=>Le.then(fe=>fe,fe=>{ge||(ge=fe)})));if(typeof ge<"u")throw ge;return be}ce.settled=te;function K(ee){return new Promise(async(ge,be)=>{try{await ee(ge,be)}catch(Le){be(Le)}})}ce.withAsyncBody=K})(pe||(e.Promises=pe={}));class re{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(te){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=te.then(K=>(this._value=K,this._isResolved=!0,K),K=>{throw this._error=K,this._isResolved=!0,K})}requireValue(){if(!this._isResolved)throw new L.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=re;class J{constructor(te){this._compute=te,this._promise=new S.Lazy(()=>new re(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=J;var H;(function(ce){ce[ce.Initial=0]="Initial",ce[ce.DoneOK=1]="DoneOK",ce[ce.DoneError=2]="DoneError"})(H||(H={}));class ne{static fromArray(te){return new ne(K=>{K.emitMany(te)})}static fromPromise(te){return new ne(async K=>{K.emitMany(await te)})}static fromPromises(te){return new ne(async K=>{await Promise.all(te.map(async ee=>K.emitOne(await ee)))})}static merge(te){return new ne(async K=>{await Promise.all(te.map(async ee=>{for await(const ge of ee)K.emitOne(ge)}))})}static{this.EMPTY=ne.fromArray([])}constructor(te){this._state=0,this._results=[],this._error=null,this._onStateChanged=new C.Emitter,queueMicrotask(async()=>{const K={emitOne:ee=>this.emitOne(ee),emitMany:ee=>this.emitMany(ee),reject:ee=>this.reject(ee)};try{await Promise.resolve(te(K)),this.resolve()}catch(ee){this.reject(ee)}finally{K.emitOne=void 0,K.emitMany=void 0,K.reject=void 0}})}[Symbol.asyncIterator](){let te=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(te<this._results.length)return{done:!1,value:this._results[te++]};if(this._state===1)return{done:!0,value:void 0};await C.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(te,K){return new ne(async ee=>{for await(const ge of te)ee.emitOne(K(ge))})}map(te){return ne.map(this,te)}static filter(te,K){return new ne(async ee=>{for await(const ge of te)K(ge)&&ee.emitOne(ge)})}filter(te){return ne.filter(this,te)}static coalesce(te){return ne.filter(te,K=>!!K)}coalesce(){return ne.coalesce(this)}static async toPromise(te){const K=[];for await(const ee of te)K.push(ee);return K}toPromise(){return ne.toPromise(this)}emitOne(te){this._state===0&&(this._results.push(te),this._onStateChanged.fire())}emitMany(te){this._state===0&&(this._results=this._results.concat(te),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(te){this._state===0&&(this._state=2,this._error=te,this._onStateChanged.fire())}}e.AsyncIterableObject=ne;class Ae extends ne{constructor(te,K){super(K),this._source=te}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Ae;function Re(ce){const te=new I.CancellationTokenSource,K=ce(te.token);return new Ae(te,async ee=>{const ge=te.token.onCancellationRequested(()=>{ge.dispose(),te.dispose(),ee.reject(new L.CancellationError)});try{for await(const be of K){if(te.token.isCancellationRequested)return;ee.emitOne(be)}ge.dispose(),te.dispose()}catch(be){ge.dispose(),te.dispose(),ee.reject(be)}})}e.createCancelableAsyncIterable=Re;class ke{constructor(){this._deferred=new ae,this._asyncIterable=new ne(ee=>{if(te){ee.reject(te);return}return K&&ee.emitMany(K),this._errorFn=ge=>ee.reject(ge),this._emitFn=ge=>ee.emitOne(ge),this._deferred.p});let te,K;this._emitFn=ee=>{K||(K=[]),K.push(ee)},this._errorFn=ee=>{te||(te=ee)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(te){this._errorFn(te),this._deferred.complete()}emitOne(te){this._emitFn(te)}}e.AsyncIterableSource=ke}),define(Pe[34],Te([1,0,18,13,45,28,19,21,12]),function(me,e,I,L,C,A,T,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",D="[^/\\\\]",u=/\//g;function p(de,we){switch(de){case 0:return"";case 1:return`${D}*?`;default:return`(?:${R}|${D}+${R}${we?`|${R}${D}+`:""})*?`}}function E(de,we){if(!de)return[];const ye=[];let le=!1,ve=!1,ae="";for(const pe of de){switch(pe){case we:if(!le&&!ve){ye.push(ae),ae="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":ve=!0;break;case"]":ve=!1;break}ae+=pe}return ae&&ye.push(ae),ye}e.splitGlobAware=E;function i(de){if(!de)return"";let we="";const ye=E(de,e.GLOB_SPLIT);if(ye.every(le=>le===e.GLOBSTAR))we=".*";else{let le=!1;ye.forEach((ve,ae)=>{if(ve===e.GLOBSTAR){if(le)return;we+=p(2,ae===ye.length-1)}else{let pe=!1,re="",J=!1,H="";for(const ne of ve){if(ne!=="}"&&pe){re+=ne;continue}if(J&&(ne!=="]"||!H)){let Ae;ne==="-"?Ae=ne:(ne==="^"||ne==="!")&&!H?Ae="^":ne===e.GLOB_SPLIT?Ae="":Ae=(0,h.escapeRegExpCharacters)(ne),H+=Ae;continue}switch(ne){case"{":pe=!0;continue;case"[":J=!0;continue;case"}":{const Re=`(?:${E(re,",").map(ke=>i(ke)).join("|")})`;we+=Re,pe=!1,re="";break}case"]":{we+="["+H+"]",J=!1,H="";break}case"?":we+=D;continue;case"*":we+=p(1);continue;default:we+=(0,h.escapeRegExpCharacters)(ne)}}ae<ye.length-1&&(ye[ae+1]!==e.GLOBSTAR||ae+2<ye.length)&&(we+=R)}le=ve===e.GLOBSTAR})}return we}const a=/^\*\*\/\*\.[\w\.-]+$/,r=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),d=function(){return!1},s=function(){return null};function b(de,we){if(!de)return s;let ye;typeof de!="string"?ye=de.pattern:ye=de,ye=ye.trim();const le=`${ye}_${!!we.trimForExclusions}`;let ve=t.get(le);if(ve)return _(ve,de);let ae;return a.test(ye)?ve=w(ye.substr(4),ye):(ae=r.exec(f(ye,we)))?ve=P(ae[1],ye):(we.trimForExclusions?o:n).test(ye)?ve=m(ye,we):(ae=c.exec(f(ye,we)))?ve=v(ae[1].substr(1),ye,!0):(ae=l.exec(f(ye,we)))?ve=v(ae[1],ye,!1):ve=y(ye),t.set(le,ve),_(ve,de)}function _(de,we){if(typeof we=="string")return de;const ye=function(le,ve){return(0,C.isEqualOrParent)(le,we.base,!g.isLinux)?de((0,h.ltrim)(le.substr(we.base.length),T.sep),ve):null};return ye.allBasenames=de.allBasenames,ye.allPaths=de.allPaths,ye.basenames=de.basenames,ye.patterns=de.patterns,ye}function f(de,we){return we.trimForExclusions&&de.endsWith("/**")?de.substr(0,de.length-2):de}function w(de,we){return function(ye,le){return typeof ye=="string"&&ye.endsWith(de)?we:null}}function P(de,we){const ye=`/${de}`,le=`\\${de}`,ve=function(pe,re){return typeof pe!="string"?null:re?re===de?we:null:pe===de||pe.endsWith(ye)||pe.endsWith(le)?we:null},ae=[de];return ve.basenames=ae,ve.patterns=[we],ve.allBasenames=ae,ve}function m(de,we){const ye=$(de.slice(1,-1).split(",").map(re=>b(re,we)).filter(re=>re!==s),de),le=ye.length;if(!le)return s;if(le===1)return ye[0];const ve=function(re,J){for(let H=0,ne=ye.length;H<ne;H++)if(ye[H](re,J))return de;return null},ae=ye.find(re=>!!re.allBasenames);ae&&(ve.allBasenames=ae.allBasenames);const pe=ye.reduce((re,J)=>J.allPaths?re.concat(J.allPaths):re,[]);return pe.length&&(ve.allPaths=pe),ve}function v(de,we,ye){const le=T.sep===T.posix.sep,ve=le?de:de.replace(u,T.sep),ae=T.sep+ve,pe=T.posix.sep+de;let re;return ye?re=function(J,H){return typeof J=="string"&&(J===ve||J.endsWith(ae)||!le&&(J===de||J.endsWith(pe)))?we:null}:re=function(J,H){return typeof J=="string"&&(J===ve||!le&&J===de)?we:null},re.allPaths=[(ye?"*/":"./")+de],re}function y(de){try{const we=new RegExp(`^${i(de)}$`);return function(ye){return we.lastIndex=0,typeof ye=="string"&&we.test(ye)?de:null}}catch{return s}}function O(de,we,ye){return!de||typeof we!="string"?!1:N(de)(we,void 0,ye)}e.match=O;function N(de,we={}){if(!de)return d;if(typeof de=="string"||q(de)){const ye=b(de,we);if(ye===s)return d;const le=function(ve,ae){return!!ye(ve,ae)};return ye.allBasenames&&(le.allBasenames=ye.allBasenames),ye.allPaths&&(le.allPaths=ye.allPaths),le}return k(de,we)}e.parse=N;function q(de){const we=de;return we?typeof we.base=="string"&&typeof we.pattern=="string":!1}e.isRelativePattern=q;function W(de){return de.allBasenames||[]}e.getBasenameTerms=W;function x(de){return de.allPaths||[]}e.getPathTerms=x;function k(de,we){const ye=$(Object.getOwnPropertyNames(de).map(re=>M(re,de[re],we)).filter(re=>re!==s)),le=ye.length;if(!le)return s;if(!ye.some(re=>!!re.requiresSiblings)){if(le===1)return ye[0];const re=function(ne,Ae){let Re;for(let ke=0,ce=ye.length;ke<ce;ke++){const te=ye[ke](ne,Ae);if(typeof te=="string")return te;(0,L.isThenable)(te)&&(Re||(Re=[]),Re.push(te))}return Re?(async()=>{for(const ke of Re){const ce=await ke;if(typeof ce=="string")return ce}return null})():null},J=ye.find(ne=>!!ne.allBasenames);J&&(re.allBasenames=J.allBasenames);const H=ye.reduce((ne,Ae)=>Ae.allPaths?ne.concat(Ae.allPaths):ne,[]);return H.length&&(re.allPaths=H),re}const ve=function(re,J,H){let ne,Ae;for(let Re=0,ke=ye.length;Re<ke;Re++){const ce=ye[Re];ce.requiresSiblings&&H&&(J||(J=(0,T.basename)(re)),ne||(ne=J.substr(0,J.length-(0,T.extname)(re).length)));const te=ce(re,J,ne,H);if(typeof te=="string")return te;(0,L.isThenable)(te)&&(Ae||(Ae=[]),Ae.push(te))}return Ae?(async()=>{for(const Re of Ae){const ke=await Re;if(typeof ke=="string")return ke}return null})():null},ae=ye.find(re=>!!re.allBasenames);ae&&(ve.allBasenames=ae.allBasenames);const pe=ye.reduce((re,J)=>J.allPaths?re.concat(J.allPaths):re,[]);return pe.length&&(ve.allPaths=pe),ve}function M(de,we,ye){if(we===!1)return s;const le=b(de,ye);if(le===s)return s;if(typeof we=="boolean")return le;if(we){const ve=we.when;if(typeof ve=="string"){const ae=(pe,re,J,H)=>{if(!H||!le(pe,re))return null;const ne=ve.replace("$(basename)",()=>J),Ae=H(ne);return(0,L.isThenable)(Ae)?Ae.then(Re=>Re?de:null):Ae?de:null};return ae.requiresSiblings=!0,ae}}return le}function $(de,we){const ye=de.filter(re=>!!re.basenames);if(ye.length<2)return de;const le=ye.reduce((re,J)=>{const H=J.basenames;return H?re.concat(H):re},[]);let ve;if(we){ve=[];for(let re=0,J=le.length;re<J;re++)ve.push(we)}else ve=ye.reduce((re,J)=>{const H=J.patterns;return H?re.concat(H):re},[]);const ae=function(re,J){if(typeof re!="string")return null;if(!J){let ne;for(ne=re.length;ne>0;ne--){const Ae=re.charCodeAt(ne-1);if(Ae===47||Ae===92)break}J=re.substr(ne)}const H=le.indexOf(J);return H!==-1?ve[H]:null};ae.basenames=le,ae.patterns=ve,ae.allBasenames=le;const pe=de.filter(re=>!re.basenames);return pe.push(ae),pe}function oe(de,we){return(0,I.equals)(de,we,(ye,le)=>typeof ye=="string"&&typeof le=="string"?ye===le:typeof ye!="string"&&typeof le!="string"?ye.base===le.base&&ye.pattern===le.pattern:!1)}e.patternsEquals=oe}),define(Pe[52],Te([1,0,15,126,25,12,2]),function(me,e,I,L,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.appendEscapedMarkdownCodeBlockFence=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var g;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(g||(e.MarkdownStringTextNewlineStyle=g={}));class h{constructor(n="",o=!1){if(this.value=n,typeof this.value!="string")throw(0,I.illegalArgument)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1,this.supportHtml=o.supportHtml??!1)}appendText(n,o=0){return this.value+=u(this.supportThemeIcons?(0,L.escapeIcons)(n):n).replace(/([ \t]+)/g,(c,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,o){return this.value+=`
${p(o,n)}
`,this}appendLink(n,o,c){return this.value+="[",this.value+=this._escape(o,"]"),this.value+="](",this.value+=this._escape(String(n),")"),c&&(this.value+=` "${this._escape(this._escape(c,'"'),")")}"`),this.value+=")",this}_escape(n,o){const c=new RegExp((0,A.escapeRegExpCharacters)(o),"g");return n.replace(c,(l,t)=>n.charAt(t-1)!=="\\"?`\\${l}`:l)}}e.MarkdownString=h;function S(r){return R(r)?!r.value:Array.isArray(r)?r.every(S):!0}e.isEmptyMarkdownString=S;function R(r){return r instanceof h?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||typeof r.isTrusted=="object"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function D(r,n){return r===n?!0:!r||!n?!1:r.value===n.value&&r.isTrusted===n.isTrusted&&r.supportThemeIcons===n.supportThemeIcons&&r.supportHtml===n.supportHtml&&(r.baseUri===n.baseUri||!!r.baseUri&&!!n.baseUri&&(0,C.isEqual)(T.URI.from(r.baseUri),T.URI.from(n.baseUri)))}e.markdownStringEqual=D;function u(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=u;function p(r,n){const o=r.match(/^`+/gm)?.reduce((l,t)=>l.length>t.length?l:t).length??0,c=o>=3?o+1:3;return[`${"`".repeat(c)}${n}`,r,`${"`".repeat(c)}`].join(`
`)}e.appendEscapedMarkdownCodeBlockFence=p;function E(r){return r.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=E;function i(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=i;function a(r){const n=[],o=r.split("|").map(l=>l.trim());r=o[0];const c=o[1];if(c){const l=/height=(\d+)/.exec(c),t=/width=(\d+)/.exec(c),d=l?l[1]:"",s=t?t[1]:"",b=isFinite(parseInt(s)),_=isFinite(parseInt(d));b&&n.push(`width="${s}"`),_&&n.push(`height="${d}"`)}return{href:r,dimensions:n}}e.parseHrefAndDimensions=a}),define(Pe[95],Te([1,0,18,45,19,21,25,12]),function(me,e,I,L,C,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function h(b,_){const{os:f,tildify:w,relative:P}=_;if(P){const y=S(b,P,f);if(typeof y=="string")return y}let m=b.fsPath;if(f===1&&!A.isWindows?m=m.replace(/\//g,"\\"):f!==1&&A.isWindows&&(m=m.replace(/\\/g,"/")),f!==1&&w?.userHome){const y=w.userHome.fsPath;let O;b.scheme!==w.userHome.scheme&&b.path[0]===C.posix.sep&&b.path[1]!==C.posix.sep?O=w.userHome.with({path:b.path}).fsPath:O=m,m=u(O,y,f)}return(f===1?C.win32:C.posix).normalize(R(m,f===1))}e.getPathLabel=h;function S(b,_,f){const w=f===1?C.win32:C.posix,P=f===3?T.extUri:T.extUriIgnorePathCase,m=_.getWorkspace(),v=(0,I.firstOrDefault)(m.folders);if(!v)return;b.scheme!==v.uri.scheme&&b.path[0]===C.posix.sep&&b.path[1]!==C.posix.sep&&(b=v.uri.with({path:b.path}));const y=_.getWorkspaceFolder(b);if(!y)return;let O;if(P.isEqual(y.uri,b)?O="":O=P.relativePath(y.uri,b)??"",O&&(O=w.normalize(O)),m.folders.length>1&&!_.noPrefix){const N=y.name?y.name:P.basenameOrAuthority(y.uri);O=O?`${N} \u2022 ${O}`:N}return O}function R(b,_=A.isWindows){return(0,L.hasDriveLetter)(b,_)?b.charAt(0).toUpperCase()+b.slice(1):b}e.normalizeDriveLetter=R;let D=Object.create(null);function u(b,_,f=A.OS){if(f===1||!b||!_)return b;let w=D.original===_?D.normalized:void 0;w||(w=_,A.isWindows&&(w=(0,L.toSlashes)(w)),w=`${(0,g.rtrim)(w,C.posix.sep)}${C.posix.sep}`,D={original:_,normalized:w});let P=b;return A.isWindows&&(P=(0,L.toSlashes)(P)),(f===3?P.startsWith(w):(0,g.startsWithIgnoreCase)(P,w))?`~/${P.substr(w.length)}`:b}e.tildify=u;function p(b,_){return b.replace(/^~($|\/|\\)/,`${_}$1`)}e.untildify=p;const E="\u2026",i="\\\\",a="~";function r(b,_=C.sep){const f=new Array(b.length);let w=!1;for(let P=0;P<b.length;P++){const m=b[P];if(m===""){f[P]=`.${_}`;continue}if(!m){f[P]=m;continue}w=!0;let v="",y=m;y.indexOf(i)===0?(v=y.substr(0,y.indexOf(i)+i.length),y=y.substr(y.indexOf(i)+i.length)):y.indexOf(_)===0?(v=y.substr(0,y.indexOf(_)+_.length),y=y.substr(y.indexOf(_)+_.length)):y.indexOf(a)===0&&(v=y.substr(0,y.indexOf(a)+a.length),y=y.substr(y.indexOf(a)+a.length));const O=y.split(_);for(let N=1;w&&N<=O.length;N++)for(let q=O.length-N;w&&q>=0;q--){w=!1;let W=O.slice(q,q+N).join(_);for(let x=0;!w&&x<b.length;x++)if(x!==P&&b[x]&&b[x].indexOf(W)>-1){const k=q+N===O.length,M=q>0&&b[x].indexOf(_)>-1?_+W:W,$=b[x].endsWith(M);w=!k||$}if(!w){let x="";(O[0].endsWith(":")||v!=="")&&(q===1&&(q=0,N++,W=O[0]+_+W),q>0&&(x=O[0]+_),x=v+x),q>0&&(x=x+E+_),x=x+W,q+N<O.length&&(x=x+_+E),f[P]=x}}w&&(f[P]=m)}return f}e.shorten=r;var n;(function(b){b[b.TEXT=0]="TEXT",b[b.VARIABLE=1]="VARIABLE",b[b.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function o(b,_=Object.create(null)){const f=[];let w=!1,P="";for(const m of b)if(m==="$"||w&&m==="{")P&&f.push({value:P,type:n.TEXT}),P="",w=!0;else if(m==="}"&&w){const v=_[P];if(typeof v=="string")v.length&&f.push({value:v,type:n.VARIABLE});else if(v){const y=f[f.length-1];(!y||y.type!==n.SEPARATOR)&&f.push({value:v.label,type:n.SEPARATOR})}P="",w=!1}else P+=m;return P&&!w&&f.push({value:P,type:n.TEXT}),f.filter((m,v)=>{if(m.type===n.SEPARATOR){const y=f[v-1],O=f[v+1];return[y,O].every(N=>N&&(N.type===n.VARIABLE||N.type===n.TEXT)&&N.value.length>0)}return!0}).map(m=>m.value).join("")}e.template=o;function c(b,_){return A.isMacintosh||_?b.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):b.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function l(b,_){return A.isMacintosh||_?b.replace(/\(&&\w\)|&&/g,""):A.isWindows?b.replace(/&&|&/g,f=>f==="&"?"&&":"&"):b.replace(/&&/g,"_")}e.mnemonicButtonLabel=l;function t(b){return b.replace(/&/g,"&&")}e.unmnemonicLabel=t;function d(b){if(b.endsWith("]")){const _=b.lastIndexOf(" [",b.length-2);if(_!==-1){const f=s(b.substring(0,_)),w=b.substring(_);return{name:f.name+w,parentPath:f.parentPath}}}return s(b)}e.splitRecentLabel=d;function s(b){const _=b.indexOf("/")!==-1?C.posix:C.win32,f=_.basename(b),w=_.dirname(b);return f.length?{name:f,parentPath:w}:{name:w,parentPath:""}}}),define(Pe[139],Te([1,0,23,2]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function C(D){return D.toJSON()}class A{constructor(u){this._uriTransformer=u}transformIncoming(u){const p=this._uriTransformer.transformIncoming(u);return p===u?u:C(L.URI.from(p))}transformOutgoing(u){const p=this._uriTransformer.transformOutgoing(u);return p===u?u:C(L.URI.from(p))}transformOutgoingURI(u){const p=this._uriTransformer.transformOutgoing(u);return p===u?u:L.URI.from(p)}transformOutgoingScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function T(D,u,p){if(!D||p>200)return null;if(typeof D=="object"){if(D instanceof L.URI)return u.transformOutgoing(D);for(const E in D)if(Object.hasOwnProperty.call(D,E)){const i=T(D[E],u,p+1);i!==null&&(D[E]=i)}}return null}function g(D,u){const p=T(D,u,0);return p===null?D:p}e.transformOutgoingURIs=g;function h(D,u,p,E){if(!D||E>200)return null;if(typeof D=="object"){if(D.$mid===1)return p?L.URI.revive(u.transformIncoming(D)):u.transformIncoming(D);if(D instanceof I.VSBuffer)return null;for(const i in D)if(Object.hasOwnProperty.call(D,i)){const a=h(D[i],u,p,E+1);a!==null&&(D[i]=a)}}return null}function S(D,u){const p=h(D,u,!1,0);return p===null?D:p}e.transformIncomingURIs=S;function R(D,u){const p=h(D,u,!0,0);return p===null?D:p}e.transformAndReviveIncomingURIs=R}),define(Pe[140],Te([1,0,12,21,23]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringBuilder=e.decodeUTF16LE=e.getPlatformTextDecoder=void 0;let A;function T(){return A||(A=new TextDecoder("UTF-16LE")),A}let g;function h(){return g||(g=new TextDecoder("UTF-16BE")),g}let S;function R(){return S||(S=L.isLittleEndian()?T():h()),S}e.getPlatformTextDecoder=R;function D(E,i,a){const r=new Uint16Array(E.buffer,i,a);return a>0&&(r[0]===65279||r[0]===65534)?u(E,i,a):T().decode(r)}e.decodeUTF16LE=D;function u(E,i,a){const r=[];let n=0;for(let o=0;o<a;o++){const c=C.readUInt16LE(E,i);i+=2,r[n++]=String.fromCharCode(c)}return r.join("")}class p{constructor(i){this._capacity=i|0,this._buffer=new Uint16Array(this._capacity),this._completedStrings=null,this._bufferLength=0}reset(){this._completedStrings=null,this._bufferLength=0}build(){return this._completedStrings!==null?(this._flushBuffer(),this._completedStrings.join("")):this._buildBuffer()}_buildBuffer(){if(this._bufferLength===0)return"";const i=new Uint16Array(this._buffer.buffer,0,this._bufferLength);return R().decode(i)}_flushBuffer(){const i=this._buildBuffer();this._bufferLength=0,this._completedStrings===null?this._completedStrings=[i]:this._completedStrings[this._completedStrings.length]=i}appendCharCode(i){const a=this._capacity-this._bufferLength;a<=1&&(a===0||I.isHighSurrogate(i))&&this._flushBuffer(),this._buffer[this._bufferLength++]=i}appendASCIICharCode(i){this._bufferLength===this._capacity&&this._flushBuffer(),this._buffer[this._bufferLength++]=i}appendString(i){const a=i.length;if(this._bufferLength+a>=this._capacity){this._flushBuffer(),this._completedStrings[this._completedStrings.length]=i;return}for(let r=0;r<a;r++)this._buffer[this._bufferLength++]=i.charCodeAt(r)}}e.StringBuilder=p}),define(Pe[141],Te([1,0,23,140]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressConsecutiveTextChanges=e.TextChange=void 0;function C(h){return h.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class A{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(S,R,D,u){this.oldPosition=S,this.oldText=R,this.newPosition=D,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${C(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${C(this.oldText)}")`:`(replace@${this.oldPosition} "${C(this.oldText)}" with "${C(this.newText)}")`}static _writeStringSize(S){return 4+2*S.length}static _writeString(S,R,D){const u=R.length;I.writeUInt32BE(S,u,D),D+=4;for(let p=0;p<u;p++)I.writeUInt16LE(S,R.charCodeAt(p),D),D+=2;return D}static _readString(S,R){const D=I.readUInt32BE(S,R);return R+=4,(0,L.decodeUTF16LE)(S,R,D)}writeSize(){return 4+4+A._writeStringSize(this.oldText)+A._writeStringSize(this.newText)}write(S,R){return I.writeUInt32BE(S,this.oldPosition,R),R+=4,I.writeUInt32BE(S,this.newPosition,R),R+=4,R=A._writeString(S,this.oldText,R),R=A._writeString(S,this.newText,R),R}static read(S,R,D){const u=I.readUInt32BE(S,R);R+=4;const p=I.readUInt32BE(S,R);R+=4;const E=A._readString(S,R);R+=A._writeStringSize(E);const i=A._readString(S,R);return R+=A._writeStringSize(i),D.push(new A(u,E,p,i)),R}}e.TextChange=A;function T(h,S){return h===null||h.length===0?S:new g(h,S).compress()}e.compressConsecutiveTextChanges=T;class g{constructor(S,R){this._prevEdits=S,this._currEdits=R,this._result=[],this._resultLen=0,this._prevLen=this._prevEdits.length,this._prevDeltaOffset=0,this._currLen=this._currEdits.length,this._currDeltaOffset=0}compress(){let S=0,R=0,D=this._getPrev(S),u=this._getCurr(R);for(;S<this._prevLen||R<this._currLen;){if(D===null){this._acceptCurr(u),u=this._getCurr(++R);continue}if(u===null){this._acceptPrev(D),D=this._getPrev(++S);continue}if(u.oldEnd<=D.newPosition){this._acceptCurr(u),u=this._getCurr(++R);continue}if(D.newEnd<=u.oldPosition){this._acceptPrev(D),D=this._getPrev(++S);continue}if(u.oldPosition<D.newPosition){const[r,n]=g._splitCurr(u,D.newPosition-u.oldPosition);this._acceptCurr(r),u=n;continue}if(D.newPosition<u.oldPosition){const[r,n]=g._splitPrev(D,u.oldPosition-D.newPosition);this._acceptPrev(r),D=n;continue}let i,a;if(u.oldEnd===D.newEnd)i=D,a=u,D=this._getPrev(++S),u=this._getCurr(++R);else if(u.oldEnd<D.newEnd){const[r,n]=g._splitPrev(D,u.oldLength);i=r,a=u,D=n,u=this._getCurr(++R)}else{const[r,n]=g._splitCurr(u,D.newLength);i=D,a=r,D=this._getPrev(++S),u=n}this._result[this._resultLen++]=new A(i.oldPosition,i.oldText,a.newPosition,a.newText),this._prevDeltaOffset+=i.newLength-i.oldLength,this._currDeltaOffset+=a.newLength-a.oldLength}const p=g._merge(this._result);return g._removeNoOps(p)}_acceptCurr(S){this._result[this._resultLen++]=g._rebaseCurr(this._prevDeltaOffset,S),this._currDeltaOffset+=S.newLength-S.oldLength}_getCurr(S){return S<this._currLen?this._currEdits[S]:null}_acceptPrev(S){this._result[this._resultLen++]=g._rebasePrev(this._currDeltaOffset,S),this._prevDeltaOffset+=S.newLength-S.oldLength}_getPrev(S){return S<this._prevLen?this._prevEdits[S]:null}static _rebaseCurr(S,R){return new A(R.oldPosition-S,R.oldText,R.newPosition,R.newText)}static _rebasePrev(S,R){return new A(R.oldPosition,R.oldText,R.newPosition+S,R.newText)}static _splitPrev(S,R){const D=S.newText.substr(0,R),u=S.newText.substr(R);return[new A(S.oldPosition,S.oldText,S.newPosition,D),new A(S.oldEnd,"",S.newPosition+R,u)]}static _splitCurr(S,R){const D=S.oldText.substr(0,R),u=S.oldText.substr(R);return[new A(S.oldPosition,D,S.newPosition,S.newText),new A(S.oldPosition+R,u,S.newEnd,"")]}static _merge(S){if(S.length===0)return S;const R=[];let D=0,u=S[0];for(let p=1;p<S.length;p++){const E=S[p];u.oldEnd===E.oldPosition?u=new A(u.oldPosition,u.oldText+E.oldText,u.newPosition,u.newText+E.newText):(R[D++]=u,u=E)}return R[D++]=u,R}static _removeNoOps(S){if(S.length===0)return S;const R=[];let D=0;for(let u=0;u<S.length;u++){const p=S[u];p.oldText!==p.newText&&(R[D++]=p)}return R}}}),define(Pe[142],Te([1,0,34,19]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function C(A,T,g,h,S,R){if(Array.isArray(A)){let D=0;for(const u of A){const p=C(u,T,g,h,S,R);if(p===10)return p;p>D&&(D=p)}return D}else{if(typeof A=="string")return h?A==="*"?5:A===g?10:0:0;if(A){const{language:D,pattern:u,scheme:p,hasAccessToAllModels:E,notebookType:i}=A;if(!h&&!E)return 0;i&&S&&(T=S);let a=0;if(p)if(p===T.scheme)a=10;else if(p==="*")a=5;else return 0;if(D)if(D===g)a=10;else if(D==="*")a=Math.max(a,5);else return 0;if(i)if(i===R)a=10;else if(i==="*"&&R!==void 0)a=Math.max(a,5);else return 0;if(u){let r;if(typeof u=="string"?r=u:r={...u,base:(0,L.normalize)(u.base)},r===T.fsPath||(0,I.match)(r,T.fsPath))a=10;else return 0}return a}else return 0}}e.score=C}),define(Pe[143],Te([1,0,5,12,29,93,91,128,141,6]),function(me,e,I,L,C,A,T,g,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBuffer=void 0;class R extends S.Disposable{constructor(u,p,E,i,a,r,n){super(),this._onDidChangeContent=this._register(new I.Emitter),this.onDidChangeContent=this._onDidChangeContent.event,this._BOM=p,this._mightContainNonBasicASCII=!r,this._mightContainRTL=i,this._mightContainUnusualLineTerminators=a,this._pieceTree=new T.PieceTreeBase(u,E,n)}equals(u){return!(u instanceof R)||this._BOM!==u._BOM||this.getEOL()!==u.getEOL()?!1:this._pieceTree.equal(u._pieceTree)}mightContainRTL(){return this._mightContainRTL}mightContainUnusualLineTerminators(){return this._mightContainUnusualLineTerminators}resetMightContainUnusualLineTerminators(){this._mightContainUnusualLineTerminators=!1}mightContainNonBasicASCII(){return this._mightContainNonBasicASCII}getBOM(){return this._BOM}getEOL(){return this._pieceTree.getEOL()}createSnapshot(u){return this._pieceTree.createSnapshot(u?this._BOM:"")}getOffsetAt(u,p){return this._pieceTree.getOffsetAt(u,p)}getPositionAt(u){return this._pieceTree.getPositionAt(u)}getRangeAt(u,p){const E=u+p,i=this.getPositionAt(u),a=this.getPositionAt(E);return new C.Range(i.lineNumber,i.column,a.lineNumber,a.column)}getValueInRange(u,p=0){if(u.isEmpty())return"";const E=this._getEndOfLine(p);return this._pieceTree.getValueInRange(u,E)}getValueLengthInRange(u,p=0){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const E=this.getOffsetAt(u.startLineNumber,u.startColumn),i=this.getOffsetAt(u.endLineNumber,u.endColumn);let a=0;const r=this._getEndOfLine(p),n=this.getEOL();if(r.length!==n.length){const o=r.length-n.length,c=u.endLineNumber-u.startLineNumber;a=o*c}return i-E+a}getCharacterCountInRange(u,p=0){if(this._mightContainNonBasicASCII){let E=0;const i=u.startLineNumber,a=u.endLineNumber;for(let r=i;r<=a;r++){const n=this.getLineContent(r),o=r===i?u.startColumn-1:0,c=r===a?u.endColumn-1:n.length;for(let l=o;l<c;l++)L.isHighSurrogate(n.charCodeAt(l))?(E=E+1,l=l+1):E=E+1}return E+=this._getEndOfLine(p).length*(a-i),E}return this.getValueLengthInRange(u,p)}getLength(){return this._pieceTree.getLength()}getLineCount(){return this._pieceTree.getLineCount()}getLinesContent(){return this._pieceTree.getLinesContent()}getLineContent(u){return this._pieceTree.getLineContent(u)}getLineCharCode(u,p){return this._pieceTree.getLineCharCode(u,p)}getCharCode(u){return this._pieceTree.getCharCode(u)}getLineLength(u){return this._pieceTree.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const p=L.firstNonWhitespaceIndex(this.getLineContent(u));return p===-1?0:p+1}getLineLastNonWhitespaceColumn(u){const p=L.lastNonWhitespaceIndex(this.getLineContent(u));return p===-1?0:p+2}_getEndOfLine(u){switch(u){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this._pieceTree.setEOL(u)}applyEdits(u,p,E){let i=this._mightContainRTL,a=this._mightContainUnusualLineTerminators,r=this._mightContainNonBasicASCII,n=!0,o=[];for(let _=0;_<u.length;_++){const f=u[_];n&&f._isTracked&&(n=!1);const w=f.range;if(f.text){let O=!0;r||(O=!L.isBasicASCII(f.text),r=O),!i&&O&&(i=L.containsRTL(f.text)),!a&&O&&(a=L.containsUnusualLineTerminators(f.text))}let P="",m=0,v=0,y=0;if(f.text){let O;[m,v,y,O]=(0,g.countEOL)(f.text);const N=this.getEOL();O===0||O===(N===`\r
`?2:1)?P=f.text:P=f.text.replace(/\r\n|\r|\n/g,N)}o[_]={sortIndex:_,identifier:f.identifier||null,range:w,rangeOffset:this.getOffsetAt(w.startLineNumber,w.startColumn),rangeLength:this.getValueLengthInRange(w),text:P,eolCount:m,firstLineLength:v,lastLineLength:y,forceMoveMarkers:!!f.forceMoveMarkers,isAutoWhitespaceEdit:f.isAutoWhitespaceEdit||!1}}o.sort(R._sortOpsAscending);let c=!1;for(let _=0,f=o.length-1;_<f;_++){const w=o[_].range.getEndPosition(),P=o[_+1].range.getStartPosition();if(P.isBeforeOrEqual(w)){if(P.isBefore(w))throw new Error("Overlapping ranges are not allowed!");c=!0}}n&&(o=this._reduceOperations(o));const l=E||p?R._getInverseEditRanges(o):[],t=[];if(p)for(let _=0;_<o.length;_++){const f=o[_],w=l[_];if(f.isAutoWhitespaceEdit&&f.range.isEmpty())for(let P=w.startLineNumber;P<=w.endLineNumber;P++){let m="";P===w.startLineNumber&&(m=this.getLineContent(f.range.startLineNumber),L.firstNonWhitespaceIndex(m)!==-1)||t.push({lineNumber:P,oldContent:m})}}let d=null;if(E){let _=0;d=[];for(let f=0;f<o.length;f++){const w=o[f],P=l[f],m=this.getValueInRange(w.range),v=w.rangeOffset+_;_+=w.text.length-m.length,d[f]={sortIndex:w.sortIndex,identifier:w.identifier,range:P,text:m,textChange:new h.TextChange(w.rangeOffset,m,v,w.text)}}c||d.sort((f,w)=>f.sortIndex-w.sortIndex)}this._mightContainRTL=i,this._mightContainUnusualLineTerminators=a,this._mightContainNonBasicASCII=r;const s=this._doApplyEdits(o);let b=null;if(p&&t.length>0){t.sort((_,f)=>f.lineNumber-_.lineNumber),b=[];for(let _=0,f=t.length;_<f;_++){const w=t[_].lineNumber;if(_>0&&t[_-1].lineNumber===w)continue;const P=t[_].oldContent,m=this.getLineContent(w);m.length===0||m===P||L.firstNonWhitespaceIndex(m)!==-1||b.push(w)}}return this._onDidChangeContent.fire(),new A.ApplyEditsResult(d,s,b)}_reduceOperations(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let p=!1;const E=u[0].range,i=u[u.length-1].range,a=new C.Range(E.startLineNumber,E.startColumn,i.endLineNumber,i.endColumn);let r=E.startLineNumber,n=E.startColumn;const o=[];for(let s=0,b=u.length;s<b;s++){const _=u[s],f=_.range;p=p||_.forceMoveMarkers,o.push(this.getValueInRange(new C.Range(r,n,f.startLineNumber,f.startColumn))),_.text.length>0&&o.push(_.text),r=f.endLineNumber,n=f.endColumn}const c=o.join(""),[l,t,d]=(0,g.countEOL)(c);return{sortIndex:0,identifier:u[0].identifier,range:a,rangeOffset:this.getOffsetAt(a.startLineNumber,a.startColumn),rangeLength:this.getValueLengthInRange(a,0),text:c,eolCount:l,firstLineLength:t,lastLineLength:d,forceMoveMarkers:p,isAutoWhitespaceEdit:!1}}_doApplyEdits(u){u.sort(R._sortOpsDescending);const p=[];for(let E=0;E<u.length;E++){const i=u[E],a=i.range.startLineNumber,r=i.range.startColumn,n=i.range.endLineNumber,o=i.range.endColumn;if(a===n&&r===o&&i.text.length===0)continue;i.text?(this._pieceTree.delete(i.rangeOffset,i.rangeLength),this._pieceTree.insert(i.rangeOffset,i.text,!0)):this._pieceTree.delete(i.rangeOffset,i.rangeLength);const c=new C.Range(a,r,n,o);p.push({range:c,rangeLength:i.rangeLength,text:i.text,rangeOffset:i.rangeOffset,forceMoveMarkers:i.forceMoveMarkers})}return p}findMatchesLineByLine(u,p,E,i){return this._pieceTree.findMatchesLineByLine(u,p,E,i)}getPieceTree(){return this._pieceTree}static _getInverseEditRange(u,p){const E=u.startLineNumber,i=u.startColumn,[a,r,n]=(0,g.countEOL)(p);let o;if(p.length>0){const c=a+1;c===1?o=new C.Range(E,i,E,i+r):o=new C.Range(E,i,E+c-1,n+1)}else o=new C.Range(E,i,E,i);return o}static _getInverseEditRanges(u){const p=[];let E=0,i=0,a=null;for(let r=0,n=u.length;r<n;r++){const o=u[r];let c,l;a?a.range.endLineNumber===o.range.startLineNumber?(c=E,l=i+(o.range.startColumn-a.range.endColumn)):(c=E+(o.range.startLineNumber-a.range.endLineNumber),l=o.range.startColumn):(c=o.range.startLineNumber,l=o.range.startColumn);let t;if(o.text.length>0){const d=o.eolCount+1;d===1?t=new C.Range(c,l,c,l+o.firstLineLength):t=new C.Range(c,l,c+d-1,o.lastLineLength+1)}else t=new C.Range(c,l,c,l);E=t.endLineNumber,i=t.endColumn,p.push(t),a=o}return p}static _sortOpsAscending(u,p){const E=C.Range.compareRangesUsingEnds(u.range,p.range);return E===0?u.sortIndex-p.sortIndex:E}static _sortOpsDescending(u,p){const E=C.Range.compareRangesUsingEnds(u.range,p.range);return E===0?p.sortIndex-u.sortIndex:-E}}e.PieceTreeTextBuffer=R}),define(Pe[144],Te([1,0,12,91,143]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBufferBuilder=void 0;class A{constructor(h,S,R,D,u,p,E,i,a){this._chunks=h,this._bom=S,this._cr=R,this._lf=D,this._crlf=u,this._containsRTL=p,this._containsUnusualLineTerminators=E,this._isBasicASCII=i,this._normalizeEOL=a}_getEOL(h){const S=this._cr+this._lf+this._crlf,R=this._cr+this._crlf;return S===0?h===1?`
`:`\r
`:R>S/2?`\r
`:`
`}create(h){const S=this._getEOL(h),R=this._chunks;if(this._normalizeEOL&&(S===`\r
`&&(this._cr>0||this._lf>0)||S===`
`&&(this._cr>0||this._crlf>0)))for(let u=0,p=R.length;u<p;u++){const E=R[u].buffer.replace(/\r\n|\r|\n/g,S),i=(0,L.createLineStartsFast)(E);R[u]=new L.StringBuffer(E,i)}const D=new C.PieceTreeTextBuffer(R,this._bom,S,this._containsRTL,this._containsUnusualLineTerminators,this._isBasicASCII,this._normalizeEOL);return{textBuffer:D,disposable:D}}getFirstLineText(h){return this._chunks[0].buffer.substr(0,h).split(/\r\n|\r|\n/)[0]}}class T{constructor(){this.chunks=[],this.BOM="",this._hasPreviousChar=!1,this._previousChar=0,this._tmpLineStarts=[],this.cr=0,this.lf=0,this.crlf=0,this.containsRTL=!1,this.containsUnusualLineTerminators=!1,this.isBasicASCII=!0}acceptChunk(h){if(h.length===0)return;this.chunks.length===0&&I.startsWithUTF8BOM(h)&&(this.BOM=I.UTF8_BOM_CHARACTER,h=h.substr(1));const S=h.charCodeAt(h.length-1);S===13||S>=55296&&S<=56319?(this._acceptChunk1(h.substr(0,h.length-1),!1),this._hasPreviousChar=!0,this._previousChar=S):(this._acceptChunk1(h,!1),this._hasPreviousChar=!1,this._previousChar=S)}_acceptChunk1(h,S){!S&&h.length===0||(this._hasPreviousChar?this._acceptChunk2(String.fromCharCode(this._previousChar)+h):this._acceptChunk2(h))}_acceptChunk2(h){const S=(0,L.createLineStarts)(this._tmpLineStarts,h);this.chunks.push(new L.StringBuffer(h,S.lineStarts)),this.cr+=S.cr,this.lf+=S.lf,this.crlf+=S.crlf,S.isBasicASCII||(this.isBasicASCII=!1,this.containsRTL||(this.containsRTL=I.containsRTL(h)),this.containsUnusualLineTerminators||(this.containsUnusualLineTerminators=I.containsUnusualLineTerminators(h)))}finish(h=!0){return this._finish(),new A(this.chunks,this.BOM,this.cr,this.lf,this.crlf,this.containsRTL,this.containsUnusualLineTerminators,this.isBasicASCII,h)}_finish(){if(this.chunks.length===0&&this._acceptChunk1("",!0),this._hasPreviousChar){this._hasPreviousChar=!1;const h=this.chunks[this.chunks.length-1];h.buffer+=String.fromCharCode(this._previousChar);const S=(0,L.createLineStartsFast)(h.buffer);h.lineStarts=S,this._previousChar===13&&this.cr++}}}e.PieceTreeTextBufferBuilder=T}),define(Pe[96],Te([1,0,23,21]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var C;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(C||(C={}));function A(D){for(let u=0,p=D.length;u<p;u+=4){const E=D[u+0],i=D[u+1],a=D[u+2],r=D[u+3];D[u+0]=r,D[u+1]=a,D[u+2]=i,D[u+3]=E}}function T(D){const u=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return L.isLittleEndian()||A(u),I.VSBuffer.wrap(u)}function g(D){const u=D.buffer;if(L.isLittleEndian()||A(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const p=new Uint8Array(u.byteLength);return p.set(u),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function h(D){const u=new Uint32Array(S(D));let p=0;if(u[p++]=D.id,D.type==="full")u[p++]=1,u[p++]=D.data.length,u.set(D.data,p),p+=D.data.length;else{u[p++]=2,u[p++]=D.deltas.length;for(const E of D.deltas)u[p++]=E.start,u[p++]=E.deleteCount,E.data?(u[p++]=E.data.length,u.set(E.data,p),p+=E.data.length):u[p++]=0}return T(u)}e.encodeSemanticTokensDto=h;function S(D){let u=0;if(u+=1+1,D.type==="full")u+=1+D.data.length;else{u+=1,u+=(1+1+1)*D.deltas.length;for(const p of D.deltas)p.data&&(u+=p.data.length)}return u}function R(D){const u=g(D);let p=0;const E=u[p++];if(u[p++]===1){const n=u[p++],o=u.subarray(p,p+n);return p+=n,{id:E,type:"full",data:o}}const a=u[p++],r=[];for(let n=0;n<a;n++){const o=u[p++],c=u[p++],l=u[p++];let t;l>0&&(t=u.subarray(p,p+l),p+=l),r[n]={start:o,deleteCount:c,data:t}}return{id:E,type:"delta",deltas:r}}e.decodeSemanticTokensDto=R}),define(Pe[145],Te([9,10]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(Pe[146],Te([1,0,18,26,21,129,147,145]),function(me,e,I,L,C,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var h;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(h||(e.EditorAutoIndentStrategy=h={})),e.MINIMAP_GUTTER_WIDTH=8;class S{constructor(Y){this._values=Y}hasChanged(Y){return this._values[Y]}}e.ConfigurationChangedEvent=S;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class D{constructor(Y,Ee,ze,Ge){this.id=Y,this.name=Ee,this.defaultValue=ze,this.schema=Ge}applyUpdate(Y,Ee){return p(Y,Ee)}compute(Y,Ee,ze){return ze}}class u{constructor(Y,Ee){this.newValue=Y,this.didChange=Ee}}e.ApplyUpdateResult=u;function p(Q,Y){if(typeof Q!="object"||typeof Y!="object"||!Q||!Y)return new u(Y,Q!==Y);if(Array.isArray(Q)||Array.isArray(Y)){const ze=Array.isArray(Q)&&Array.isArray(Y)&&I.equals(Q,Y);return new u(Y,!ze)}let Ee=!1;for(const ze in Y)if(Y.hasOwnProperty(ze)){const Ge=p(Q[ze],Y[ze]);Ge.didChange&&(Q[ze]=Ge.newValue,Ee=!0)}return new u(Q,Ee)}class E{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,Ee){return p(Y,Ee)}validate(Y){return this.defaultValue}}class i{constructor(Y,Ee,ze,Ge){this.id=Y,this.name=Ee,this.defaultValue=ze,this.schema=Ge}applyUpdate(Y,Ee){return p(Y,Ee)}validate(Y){return typeof Y>"u"?this.defaultValue:Y}compute(Y,Ee,ze){return ze}}function a(Q,Y){return typeof Q>"u"?Y:Q==="false"?!1:!!Q}e.boolean=a;class r extends i{constructor(Y,Ee,ze,Ge=void 0){typeof Ge<"u"&&(Ge.type="boolean",Ge.default=ze),super(Y,Ee,ze,Ge)}validate(Y){return a(Y,this.defaultValue)}}function n(Q,Y,Ee,ze){if(typeof Q>"u")return Y;let Ge=parseInt(Q,10);return isNaN(Ge)?Y:(Ge=Math.max(Ee,Ge),Ge=Math.min(ze,Ge),Ge|0)}e.clampedInt=n;class o extends i{static clampedInt(Y,Ee,ze,Ge){return n(Y,Ee,ze,Ge)}constructor(Y,Ee,ze,Ge,tt,st=void 0){typeof st<"u"&&(st.type="integer",st.default=ze,st.minimum=Ge,st.maximum=tt),super(Y,Ee,ze,st),this.minimum=Ge,this.maximum=tt}validate(Y){return o.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}function c(Q,Y,Ee,ze){if(typeof Q>"u")return Y;const Ge=l.float(Q,Y);return l.clamp(Ge,Ee,ze)}e.clampedFloat=c;class l extends i{static clamp(Y,Ee,ze){return Y<Ee?Ee:Y>ze?ze:Y}static float(Y,Ee){if(typeof Y=="number")return Y;if(typeof Y>"u")return Ee;const ze=parseFloat(Y);return isNaN(ze)?Ee:ze}constructor(Y,Ee,ze,Ge,tt){typeof tt<"u"&&(tt.type="number",tt.default=ze),super(Y,Ee,ze,tt),this.validationFn=Ge}validate(Y){return this.validationFn(l.float(Y,this.defaultValue))}}class t extends i{static string(Y,Ee){return typeof Y!="string"?Ee:Y}constructor(Y,Ee,ze,Ge=void 0){typeof Ge<"u"&&(Ge.type="string",Ge.default=ze),super(Y,Ee,ze,Ge)}validate(Y){return t.string(Y,this.defaultValue)}}function d(Q,Y,Ee,ze){return typeof Q!="string"?Y:ze&&Q in ze?ze[Q]:Ee.indexOf(Q)===-1?Y:Q}e.stringSet=d;class s extends i{constructor(Y,Ee,ze,Ge,tt=void 0){typeof tt<"u"&&(tt.type="string",tt.enum=Ge,tt.default=ze),super(Y,Ee,ze,tt),this._allowedValues=Ge}validate(Y){return d(Y,this.defaultValue,this._allowedValues)}}class b extends D{constructor(Y,Ee,ze,Ge,tt,st,Fe=void 0){typeof Fe<"u"&&(Fe.type="string",Fe.enum=tt,Fe.default=Ge),super(Y,Ee,ze,Fe),this._allowedValues=tt,this._convert=st}validate(Y){return typeof Y!="string"?this.defaultValue:this._allowedValues.indexOf(Y)===-1?this.defaultValue:this._convert(Y)}}function _(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",tags:["accessibility"],description:g.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,Ee,ze){return ze===0?Y.accessibilitySupport:ze}}class w extends D{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:g.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{insertSpace:a(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:a(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var P;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(P||(e.TextEditorCursorBlinkingStyle=P={}));function m(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var v;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(v||(e.TextEditorCursorStyle=v={}));function y(Q){switch(Q){case v.Line:return"line";case v.Block:return"block";case v.Underline:return"underline";case v.LineThin:return"line-thin";case v.BlockOutline:return"block-outline";case v.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=y;function O(Q){switch(Q){case"line":return v.Line;case"block":return v.Block;case"underline":return v.Underline;case"line-thin":return v.LineThin;case"block-outline":return v.BlockOutline;case"underline-thin":return v.UnderlineThin}}class N extends E{constructor(){super(140)}compute(Y,Ee,ze){const Ge=["monaco-editor"];return Ee.get(39)&&Ge.push(Ee.get(39)),Y.extraEditorClassName&&Ge.push(Y.extraEditorClassName),Ee.get(73)==="default"?Ge.push("mouse-default"):Ee.get(73)==="copy"&&Ge.push("mouse-copy"),Ee.get(110)&&Ge.push("showUnused"),Ee.get(138)&&Ge.push("showDeprecated"),Ge.join(" ")}}class q extends r{constructor(){super(37,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(Y,Ee,ze){return ze&&Y.emptySelectionClipboard}}class W extends D{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:g.localize(16,null),included:C.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:g.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{cursorMoveOnType:a(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":d(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":d(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:a(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:a(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:a(Ee.loop,this.defaultValue.loop)}}}class x extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",x.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"||Y.length===0?x.OFF:Y==="true"?x.ON:Y:Y?x.ON:x.OFF}}e.EditorFontLigatures=x;class k extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",k.OFF,{anyOf:[{type:"boolean",description:g.localize(22,null)},{type:"string",description:g.localize(23,null)}],description:g.localize(24,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?k.OFF:Y==="true"?k.TRANSLATE:Y:Y?k.TRANSLATE:k.OFF}compute(Y,Ee,ze){return Y.fontInfo.fontVariationSettings}}e.EditorFontVariations=k;class M extends E{constructor(){super(50)}compute(Y,Ee,ze){return Y.fontInfo}}class $ extends i{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(25,null)})}validate(Y){const Ee=l.float(Y,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(Ee,6,100)}compute(Y,Ee,ze){return Y.fontInfo.fontSize}}class oe extends D{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:oe.MINIMUM_VALUE,maximum:oe.MAXIMUM_VALUE,errorMessage:g.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:oe.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(27,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(o.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,oe.MINIMUM_VALUE,oe.MAXIMUM_VALUE))}}class de extends D{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[g.localize(28,null),g.localize(29,null),g.localize(30,null)]},ze=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(32,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(33,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:g.localize(34,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:g.localize(35,null),...Ee},"editor.gotoLocation.multipleReferences":{description:g.localize(36,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:ze,description:g.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:ze,description:g.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:ze,description:g.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:ze,description:g.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:ze,description:g.localize(41,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{multiple:d(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??d(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??d(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??d(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??d(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??d(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class we extends D{constructor(){const Y={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:g.localize(42,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:g.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:g.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Y.hidingDelay,description:g.localize(45,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:g.localize(46,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{enabled:a(Ee.enabled,this.defaultValue.enabled),delay:o.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:a(Ee.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(Ee.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:a(Ee.above,this.defaultValue.above)}}}var ye;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(ye||(e.RenderMinimap=ye={}));class le extends E{constructor(){super(143)}compute(Y,Ee,ze){return le.computeLayout(Ee,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio,glyphMarginDecorationLaneCount:Y.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Y){const Ee=Y.height/Y.lineHeight,ze=Math.floor(Y.paddingTop/Y.lineHeight);let Ge=Math.floor(Y.paddingBottom/Y.lineHeight);Y.scrollBeyondLastLine&&(Ge=Math.max(Ge,Ee-1));const tt=(ze+Y.viewLineCount+Ge)/(Y.pixelRatio*Y.height),st=Math.floor(Y.viewLineCount/tt);return{typicalViewportLineCount:Ee,extraLinesBeforeFirstLine:ze,extraLinesBeyondLastLine:Ge,desiredRatio:tt,minimapLineCount:st}}static _computeMinimapLayout(Y,Ee){const ze=Y.outerWidth,Ge=Y.outerHeight,tt=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(tt*Ge),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ge};const st=Ee.stableMinimapLayoutInput,Fe=st&&Y.outerHeight===st.outerHeight&&Y.lineHeight===st.lineHeight&&Y.typicalHalfwidthCharacterWidth===st.typicalHalfwidthCharacterWidth&&Y.pixelRatio===st.pixelRatio&&Y.scrollBeyondLastLine===st.scrollBeyondLastLine&&Y.paddingTop===st.paddingTop&&Y.paddingBottom===st.paddingBottom&&Y.minimap.enabled===st.minimap.enabled&&Y.minimap.side===st.minimap.side&&Y.minimap.size===st.minimap.size&&Y.minimap.showSlider===st.minimap.showSlider&&Y.minimap.renderCharacters===st.minimap.renderCharacters&&Y.minimap.maxColumn===st.minimap.maxColumn&&Y.minimap.scale===st.minimap.scale&&Y.verticalScrollbarWidth===st.verticalScrollbarWidth&&Y.isViewportWrapping===st.isViewportWrapping,Ut=Y.lineHeight,At=Y.typicalHalfwidthCharacterWidth,jt=Y.scrollBeyondLastLine,Ot=Y.minimap.renderCharacters;let _t=tt>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const Wt=Y.minimap.maxColumn,Ft=Y.minimap.size,Qt=Y.minimap.side,$t=Y.verticalScrollbarWidth,xt=Y.viewLineCount,Ye=Y.remainingWidth,Vt=Y.isViewportWrapping,Kt=Ot?2:3;let ut=Math.floor(tt*Ge);const pt=ut/tt;let Bt=!1,Gt=!1,St=Kt*_t,ht=_t/tt,It=1;if(Ft==="fill"||Ft==="fit"){const{typicalViewportLineCount:ft,extraLinesBeforeFirstLine:Lt,extraLinesBeyondLastLine:Pt,desiredRatio:zt,minimapLineCount:De}=le.computeContainedMinimapLineCount({viewLineCount:xt,scrollBeyondLastLine:jt,paddingTop:Y.paddingTop,paddingBottom:Y.paddingBottom,height:Ge,lineHeight:Ut,pixelRatio:tt});if(xt/De>1)Bt=!0,Gt=!0,_t=1,St=1,ht=_t/tt;else{let he=!1,G=_t+1;if(Ft==="fit"){const Ce=Math.ceil((Lt+xt+Pt)*St);Vt&&Fe&&Ye<=Ee.stableFitRemainingWidth?(he=!0,G=Ee.stableFitMaxMinimapScale):he=Ce>ut}if(Ft==="fill"||he){Bt=!0;const Ce=_t;St=Math.min(Ut*tt,Math.max(1,Math.floor(1/zt))),Vt&&Fe&&Ye<=Ee.stableFitRemainingWidth&&(G=Ee.stableFitMaxMinimapScale),_t=Math.min(G,Math.max(1,Math.floor(St/Kt))),_t>Ce&&(It=Math.min(2,_t/Ce)),ht=_t/tt/It,ut=Math.ceil(Math.max(ft,Lt+xt+Pt)*St),Vt?(Ee.stableMinimapLayoutInput=Y,Ee.stableFitRemainingWidth=Ye,Ee.stableFitMaxMinimapScale=_t):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const Zt=Math.floor(Wt*ht),kt=Math.min(Zt,Math.max(0,Math.floor((Ye-$t-2)*ht/(At+ht)))+e.MINIMAP_GUTTER_WIDTH);let Ve=Math.floor(tt*kt);const Rt=Ve/tt;Ve=Math.floor(Ve*It);const Nt=Ot?1:2,Xt=Qt==="left"?0:ze-kt-$t;return{renderMinimap:Nt,minimapLeft:Xt,minimapWidth:kt,minimapHeightIsEditorHeight:Bt,minimapIsSampling:Gt,minimapScale:_t,minimapLineHeight:St,minimapCanvasInnerWidth:Ve,minimapCanvasInnerHeight:ut,minimapCanvasOuterWidth:Rt,minimapCanvasOuterHeight:pt}}static computeLayout(Y,Ee){const ze=Ee.outerWidth|0,Ge=Ee.outerHeight|0,tt=Ee.lineHeight|0,st=Ee.lineNumbersDigitCount|0,Fe=Ee.typicalHalfwidthCharacterWidth,Ut=Ee.maxDigitWidth,At=Ee.pixelRatio,jt=Ee.viewLineCount,Ot=Y.get(135),_t=Ot==="inherit"?Y.get(134):Ot,Wt=_t==="inherit"?Y.get(130):_t,Ft=Y.get(133),Qt=Ee.isDominatedByLongLines,$t=Y.get(57),xt=Y.get(67).renderType!==0,Ye=Y.get(68),Vt=Y.get(104),Kt=Y.get(83),ut=Y.get(72),pt=Y.get(102),Bt=pt.verticalScrollbarSize,Gt=pt.verticalHasArrows,St=pt.arrowSize,ht=pt.horizontalScrollbarSize,It=Y.get(43),Zt=Y.get(109)!=="never";let kt=Y.get(65);It&&Zt&&(kt+=16);let Ve=0;if(xt){const Xe=Math.max(st,Ye);Ve=Math.round(Xe*Ut)}let Rt=0;$t&&(Rt=tt*Ee.glyphMarginDecorationLaneCount);let Nt=0,Xt=Nt+Rt,ft=Xt+Ve,Lt=ft+kt;const Pt=ze-Rt-Ve-kt;let zt=!1,De=!1,Oe=-1;_t==="inherit"&&Qt?(zt=!0,De=!0):Wt==="on"||Wt==="bounded"?De=!0:Wt==="wordWrapColumn"&&(Oe=Ft);const he=le._computeMinimapLayout({outerWidth:ze,outerHeight:Ge,lineHeight:tt,typicalHalfwidthCharacterWidth:Fe,pixelRatio:At,scrollBeyondLastLine:Vt,paddingTop:Kt.top,paddingBottom:Kt.bottom,minimap:ut,verticalScrollbarWidth:Bt,viewLineCount:jt,remainingWidth:Pt,isViewportWrapping:De},Ee.memory||new R);he.renderMinimap!==0&&he.minimapLeft===0&&(Nt+=he.minimapWidth,Xt+=he.minimapWidth,ft+=he.minimapWidth,Lt+=he.minimapWidth);const G=Pt-he.minimapWidth,Ce=Math.max(1,Math.floor((G-Bt-2)/Fe)),Ue=Gt?St:0;return De&&(Oe=Math.max(1,Ce),Wt==="bounded"&&(Oe=Math.min(Oe,Ft))),{width:ze,height:Ge,glyphMarginLeft:Nt,glyphMarginWidth:Rt,glyphMarginDecorationLaneCount:Ee.glyphMarginDecorationLaneCount,lineNumbersLeft:Xt,lineNumbersWidth:Ve,decorationsLeft:ft,decorationsWidth:kt,contentLeft:Lt,contentWidth:G,minimap:he,viewportColumn:Ce,isWordWrapMinified:zt,isViewportWrapping:De,wrappingColumn:Oe,verticalScrollbarWidth:Bt,horizontalScrollbarHeight:ht,overviewRuler:{top:Ue,width:Bt,height:Ge-2*Ue,right:0}}}}e.EditorLayoutInfoComputer=le;class ve extends D{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[g.localize(47,null),g.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:g.localize(49,null)}})}validate(Y){return d(Y,"simple",["simple","advanced"])}compute(Y,Ee,ze){return Ee.get(2)===2?"advanced":ze}}var ae;(function(Q){Q.Off="off",Q.OnCode="onCode",Q.On="on"})(ae||(e.ShowLightbulbIconMode=ae={}));class pe extends D{constructor(){const Y={enabled:ae.OnCode};super(64,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ae.Off,ae.OnCode,ae.On],default:Y.enabled,enumDescriptions:[g.localize(50,null),g.localize(51,null),g.localize(52,null)],description:g.localize(53,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:d(Y.enabled,this.defaultValue.enabled,[ae.Off,ae.OnCode,ae.On])}}}class re extends D{constructor(){const Y={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",Y,{"editor.stickyScroll.enabled":{type:"boolean",default:Y.enabled,description:g.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Y.maxLineCount,minimum:1,maximum:10,description:g.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Y.defaultModel,description:g.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Y.scrollWithEditor,description:g.localize(57,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{enabled:a(Ee.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(Ee.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:d(Ee.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:a(Ee.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class J extends D{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:g.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[g.localize(59,null),g.localize(60,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),g.localize(61,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),g.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:g.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:g.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:g.localize(65,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return typeof Ee.enabled=="boolean"&&(Ee.enabled=Ee.enabled?"on":"off"),{enabled:d(Ee.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ee.fontFamily,this.defaultValue.fontFamily),padding:a(Ee.padding,this.defaultValue.padding)}}}class H extends D{constructor(){super(65,"lineDecorationsWidth",10)}validate(Y){return typeof Y=="string"&&/^\d+(\.\d+)?ch$/.test(Y)?-parseFloat(Y.substring(0,Y.length-2)):o.clampedInt(Y,this.defaultValue,0,1e3)}compute(Y,Ee,ze){return ze<0?o.clampedInt(-ze*Y.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):ze}}class ne extends l{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>l.clamp(Y,0,150),{markdownDescription:g.localize(66,null)})}compute(Y,Ee,ze){return Y.fontInfo.lineHeight}}class Ae extends D{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:g.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Y.autohide,description:g.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(69,null),g.localize(70,null),g.localize(71,null)],default:Y.size,description:g.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:g.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:g.localize(74,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:g.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:g.localize(77,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{enabled:a(Ee.enabled,this.defaultValue.enabled),autohide:a(Ee.autohide,this.defaultValue.autohide),size:d(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:d(Ee.side,this.defaultValue.side,["right","left"]),showSlider:d(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:a(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(Ee.scale,1,1,3),maxColumn:o.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Re(Q){return Q==="ctrlCmd"?C.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ke extends D{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(79,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{top:o.clampedInt(Ee.top,0,0,1e3),bottom:o.clampedInt(Ee.bottom,0,0,1e3)}}}class ce extends D{constructor(){const Y={enabled:!0,cycle:!0};super(85,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:g.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:g.localize(81,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{enabled:a(Ee.enabled,this.defaultValue.enabled),cycle:a(Ee.cycle,this.defaultValue.cycle)}}}class te extends E{constructor(){super(141)}compute(Y,Ee,ze){return Y.pixelRatio}}class K extends D{constructor(){const Y={other:"on",comments:"off",strings:"off"},Ee=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[g.localize(82,null),g.localize(83,null),g.localize(84,null)]}];super(88,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ee,default:Y.strings,description:g.localize(85,null)},comments:{anyOf:Ee,default:Y.comments,description:g.localize(86,null)},other:{anyOf:Ee,default:Y.other,description:g.localize(87,null)}},default:Y,markdownDescription:g.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const At=Y?"on":"off";return{comments:At,strings:At,other:At}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:Ee,comments:ze,strings:Ge}=Y,tt=["on","inline","off"];let st,Fe,Ut;return typeof Ee=="boolean"?st=Ee?"on":"off":st=d(Ee,this.defaultValue.other,tt),typeof ze=="boolean"?Fe=ze?"on":"off":Fe=d(ze,this.defaultValue.comments,tt),typeof Ge=="boolean"?Ut=Ge?"on":"off":Ut=d(Ge,this.defaultValue.strings,tt),{other:st,comments:Fe,strings:Ut}}}var ee;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(ee||(e.RenderLineNumbersType=ee={}));class ge extends D{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(89,null),g.localize(90,null),g.localize(91,null),g.localize(92,null)],default:"on",description:g.localize(93,null)})}validate(Y){let Ee=this.defaultValue.renderType,ze=this.defaultValue.renderFn;return typeof Y<"u"&&(typeof Y=="function"?(Ee=4,ze=Y):Y==="interval"?Ee=3:Y==="relative"?Ee=2:Y==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:ze}}}function be(Q){const Y=Q.get(97);return Y==="editable"?Q.get(90):Y!=="on"}e.filterValidationDecorations=be;class Le extends D{constructor(){const Y=[],Ee={type:"number",description:g.localize(94,null)};super(101,"rulers",Y,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:g.localize(95,null),format:"color-hex"}}}]},default:Y,description:g.localize(96,null)})}validate(Y){if(Array.isArray(Y)){const Ee=[];for(const ze of Y)if(typeof ze=="number")Ee.push({column:o.clampedInt(ze,0,0,1e4),color:null});else if(ze&&typeof ze=="object"){const Ge=ze;Ee.push({column:o.clampedInt(Ge.column,0,0,1e4),color:Ge.color})}return Ee.sort((ze,Ge)=>ze.column-Ge.column),Ee}return this.defaultValue}}class fe extends D{constructor(){super(91,"readOnlyMessage",void 0)}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:Y}}function _e(Q,Y){if(typeof Q!="string")return Y;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class F extends D{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(97,null),g.localize(98,null),g.localize(99,null)],default:"auto",description:g.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(101,null),g.localize(102,null),g.localize(103,null)],default:"auto",description:g.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:g.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:g.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:g.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Y.ignoreHorizontalScrollbarInContentHeight,description:g.localize(108,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y,ze=o.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ge=o.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:_e(Ee.vertical,this.defaultValue.vertical),horizontal:_e(Ee.horizontal,this.defaultValue.horizontal),useShadows:a(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:a(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:a(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:a(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:a(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:ze,horizontalSliderSize:o.clampedInt(Ee.horizontalSliderSize,ze,0,1e3),verticalScrollbarSize:Ge,verticalSliderSize:o.clampedInt(Ee.verticalSliderSize,Ge,0,1e3),scrollByPage:a(Ee.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:a(Ee.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class V extends D{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:g.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:g.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:g.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:g.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:g.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:g.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:g.localize(115,null)}})}applyUpdate(Y,Ee){let ze=!1;Ee.allowedCharacters&&Y&&(L.equals(Y.allowedCharacters,Ee.allowedCharacters)||(Y={...Y,allowedCharacters:Ee.allowedCharacters},ze=!0)),Ee.allowedLocales&&Y&&(L.equals(Y.allowedLocales,Ee.allowedLocales)||(Y={...Y,allowedLocales:Ee.allowedLocales},ze=!0));const Ge=super.applyUpdate(Y,Ee);return ze?new u(Ge.newValue,!0):Ge}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{nonBasicASCII:Z(Ee.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:a(Ee.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:a(Ee.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Z(Ee.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Z(Ee.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Y.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Y,Ee){if(typeof Y!="object"||!Y)return Ee;const ze={};for(const[Ge,tt]of Object.entries(Y))tt===!0&&(ze[Ge]=!0);return ze}}class j extends D{constructor(){const Y={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:g.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Y.showToolbar,enum:["always","onHover","never"],enumDescriptions:[g.localize(117,null),g.localize(118,null),g.localize(119,null)],description:g.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Y.suppressSuggestions,description:g.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Y.fontFamily,description:g.localize(122,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{enabled:a(Ee.enabled,this.defaultValue.enabled),mode:d(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:d(Ee.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:a(Ee.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:a(Ee.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Ee.fontFamily,this.defaultValue.fontFamily)}}}class B extends D{constructor(){const Y={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:g.localize(123,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:g.localize(124,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{enabled:a(Ee.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:a(Ee.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class X extends D{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(125,null),g.localize(126,null),g.localize(127,null)],default:Y.bracketPairs,description:g.localize(128,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(129,null),g.localize(130,null),g.localize(131,null)],default:Y.bracketPairsHorizontal,description:g.localize(132,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:g.localize(133,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:g.localize(134,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[g.localize(135,null),g.localize(136,null),g.localize(137,null)],default:Y.highlightActiveIndentation,description:g.localize(138,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{bracketPairs:Z(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Z(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:a(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:a(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:Z(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Z(Q,Y,Ee){const ze=Ee.indexOf(Q);return ze===-1?Y:Ee[ze]}class Se extends D{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(139,null),g.localize(140,null)],default:Y.insertMode,description:g.localize(141,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:g.localize(142,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:g.localize(143,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:g.localize(144,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[g.localize(145,null),g.localize(146,null),g.localize(147,null),g.localize(148,null)],default:Y.selectionMode,markdownDescription:g.localize(149,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:g.localize(150,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:g.localize(151,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:g.localize(152,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:g.localize(153,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:g.localize(154,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(155,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(156,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(157,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(158,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(159,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(160,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:g.localize(161,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(162,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(163,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(164,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(165,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(166,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(167,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(168,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(169,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(170,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(171,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(172,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(173,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(174,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(175,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(176,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(177,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(178,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(179,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(180,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(181,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(182,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(183,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(184,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(185,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(186,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{insertMode:d(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:a(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:a(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:a(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:a(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:d(Ee.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:a(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:a(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:a(Ee.preview,this.defaultValue.preview),previewMode:d(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:a(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:a(Ee.showMethods,this.defaultValue.showMethods),showFunctions:a(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:a(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:a(Ee.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:a(Ee.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:a(Ee.showFields,this.defaultValue.showFields),showVariables:a(Ee.showVariables,this.defaultValue.showVariables),showClasses:a(Ee.showClasses,this.defaultValue.showClasses),showStructs:a(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:a(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:a(Ee.showModules,this.defaultValue.showModules),showProperties:a(Ee.showProperties,this.defaultValue.showProperties),showEvents:a(Ee.showEvents,this.defaultValue.showEvents),showOperators:a(Ee.showOperators,this.defaultValue.showOperators),showUnits:a(Ee.showUnits,this.defaultValue.showUnits),showValues:a(Ee.showValues,this.defaultValue.showValues),showConstants:a(Ee.showConstants,this.defaultValue.showConstants),showEnums:a(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:a(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:a(Ee.showKeywords,this.defaultValue.showKeywords),showWords:a(Ee.showWords,this.defaultValue.showWords),showColors:a(Ee.showColors,this.defaultValue.showColors),showFiles:a(Ee.showFiles,this.defaultValue.showFiles),showReferences:a(Ee.showReferences,this.defaultValue.showReferences),showFolders:a(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:a(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:a(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:a(Ee.showUsers,this.defaultValue.showUsers),showIssues:a(Ee.showIssues,this.defaultValue.showIssues)}}}class Ne extends D{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(187,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:g.localize(188,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:a(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:a(Y.selectSubwords,this.defaultValue.selectSubwords)}}}var $e;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})($e||(e.WrappingIndent=$e={}));class qe extends D{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[g.localize(189,null),g.localize(190,null),g.localize(191,null),g.localize(192,null)],description:g.localize(193,null),default:"same"}})}validate(Y){switch(Y){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Y,Ee,ze){return Ee.get(2)===2?0:ze}}class Qe extends E{constructor(){super(144)}compute(Y,Ee,ze){const Ge=Ee.get(143);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:Ge.isWordWrapMinified,isViewportWrapping:Ge.isViewportWrapping,wrappingColumn:Ge.wrappingColumn}}}class nt extends D{constructor(){const Y={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Y,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Y.enabled,markdownDescription:g.localize(194,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:g.localize(195,null),enum:["afterDrop","never"],enumDescriptions:[g.localize(196,null),g.localize(197,null)],default:"afterDrop"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{enabled:a(Ee.enabled,this.defaultValue.enabled),showDropSelector:d(Ee.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends D{constructor(){const Y={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",Y,{"editor.pasteAs.enabled":{type:"boolean",default:Y.enabled,markdownDescription:g.localize(198,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:g.localize(199,null),enum:["afterPaste","never"],enumDescriptions:[g.localize(200,null),g.localize(201,null)],default:"afterPaste"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{enabled:a(Ee.enabled,this.defaultValue.enabled),showPasteSelector:d(Ee.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const et="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",ct="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.isMacintosh?rt:C.isLinux?ct:et,fontWeight:"normal",fontSize:C.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var gt;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.ariaRequired=5]="ariaRequired",Q[Q.autoClosingBrackets=6]="autoClosingBrackets",Q[Q.autoClosingComments=7]="autoClosingComments",Q[Q.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Q[Q.autoClosingDelete=9]="autoClosingDelete",Q[Q.autoClosingOvertype=10]="autoClosingOvertype",Q[Q.autoClosingQuotes=11]="autoClosingQuotes",Q[Q.autoIndent=12]="autoIndent",Q[Q.automaticLayout=13]="automaticLayout",Q[Q.autoSurround=14]="autoSurround",Q[Q.bracketPairColorization=15]="bracketPairColorization",Q[Q.guides=16]="guides",Q[Q.codeLens=17]="codeLens",Q[Q.codeLensFontFamily=18]="codeLensFontFamily",Q[Q.codeLensFontSize=19]="codeLensFontSize",Q[Q.colorDecorators=20]="colorDecorators",Q[Q.colorDecoratorsLimit=21]="colorDecoratorsLimit",Q[Q.columnSelection=22]="columnSelection",Q[Q.comments=23]="comments",Q[Q.contextmenu=24]="contextmenu",Q[Q.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=26]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=28]="cursorStyle",Q[Q.cursorSurroundingLines=29]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=31]="cursorWidth",Q[Q.disableLayerHinting=32]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Q[Q.domReadOnly=34]="domReadOnly",Q[Q.dragAndDrop=35]="dragAndDrop",Q[Q.dropIntoEditor=36]="dropIntoEditor",Q[Q.emptySelectionClipboard=37]="emptySelectionClipboard",Q[Q.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Q[Q.extraEditorClassName=39]="extraEditorClassName",Q[Q.fastScrollSensitivity=40]="fastScrollSensitivity",Q[Q.find=41]="find",Q[Q.fixedOverflowWidgets=42]="fixedOverflowWidgets",Q[Q.folding=43]="folding",Q[Q.foldingStrategy=44]="foldingStrategy",Q[Q.foldingHighlight=45]="foldingHighlight",Q[Q.foldingImportsByDefault=46]="foldingImportsByDefault",Q[Q.foldingMaximumRegions=47]="foldingMaximumRegions",Q[Q.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=49]="fontFamily",Q[Q.fontInfo=50]="fontInfo",Q[Q.fontLigatures=51]="fontLigatures",Q[Q.fontSize=52]="fontSize",Q[Q.fontWeight=53]="fontWeight",Q[Q.fontVariations=54]="fontVariations",Q[Q.formatOnPaste=55]="formatOnPaste",Q[Q.formatOnType=56]="formatOnType",Q[Q.glyphMargin=57]="glyphMargin",Q[Q.gotoLocation=58]="gotoLocation",Q[Q.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Q[Q.hover=60]="hover",Q[Q.inDiffEditor=61]="inDiffEditor",Q[Q.inlineSuggest=62]="inlineSuggest",Q[Q.letterSpacing=63]="letterSpacing",Q[Q.lightbulb=64]="lightbulb",Q[Q.lineDecorationsWidth=65]="lineDecorationsWidth",Q[Q.lineHeight=66]="lineHeight",Q[Q.lineNumbers=67]="lineNumbers",Q[Q.lineNumbersMinChars=68]="lineNumbersMinChars",Q[Q.linkedEditing=69]="linkedEditing",Q[Q.links=70]="links",Q[Q.matchBrackets=71]="matchBrackets",Q[Q.minimap=72]="minimap",Q[Q.mouseStyle=73]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=75]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=77]="multiCursorModifier",Q[Q.multiCursorPaste=78]="multiCursorPaste",Q[Q.multiCursorLimit=79]="multiCursorLimit",Q[Q.occurrencesHighlight=80]="occurrencesHighlight",Q[Q.overviewRulerBorder=81]="overviewRulerBorder",Q[Q.overviewRulerLanes=82]="overviewRulerLanes",Q[Q.padding=83]="padding",Q[Q.pasteAs=84]="pasteAs",Q[Q.parameterHints=85]="parameterHints",Q[Q.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=88]="quickSuggestions",Q[Q.quickSuggestionsDelay=89]="quickSuggestionsDelay",Q[Q.readOnly=90]="readOnly",Q[Q.readOnlyMessage=91]="readOnlyMessage",Q[Q.renameOnType=92]="renameOnType",Q[Q.renderControlCharacters=93]="renderControlCharacters",Q[Q.renderFinalNewline=94]="renderFinalNewline",Q[Q.renderLineHighlight=95]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=97]="renderValidationDecorations",Q[Q.renderWhitespace=98]="renderWhitespace",Q[Q.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",Q[Q.roundedSelection=100]="roundedSelection",Q[Q.rulers=101]="rulers",Q[Q.scrollbar=102]="scrollbar",Q[Q.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=104]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=105]="scrollPredominantAxis",Q[Q.selectionClipboard=106]="selectionClipboard",Q[Q.selectionHighlight=107]="selectionHighlight",Q[Q.selectOnLineNumbers=108]="selectOnLineNumbers",Q[Q.showFoldingControls=109]="showFoldingControls",Q[Q.showUnused=110]="showUnused",Q[Q.snippetSuggestions=111]="snippetSuggestions",Q[Q.smartSelect=112]="smartSelect",Q[Q.smoothScrolling=113]="smoothScrolling",Q[Q.stickyScroll=114]="stickyScroll",Q[Q.stickyTabStops=115]="stickyTabStops",Q[Q.stopRenderingLineAfter=116]="stopRenderingLineAfter",Q[Q.suggest=117]="suggest",Q[Q.suggestFontSize=118]="suggestFontSize",Q[Q.suggestLineHeight=119]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",Q[Q.suggestSelection=121]="suggestSelection",Q[Q.tabCompletion=122]="tabCompletion",Q[Q.tabIndex=123]="tabIndex",Q[Q.unicodeHighlighting=124]="unicodeHighlighting",Q[Q.unusualLineTerminators=125]="unusualLineTerminators",Q[Q.useShadowDOM=126]="useShadowDOM",Q[Q.useTabStops=127]="useTabStops",Q[Q.wordBreak=128]="wordBreak",Q[Q.wordSeparators=129]="wordSeparators",Q[Q.wordWrap=130]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=133]="wordWrapColumn",Q[Q.wordWrapOverride1=134]="wordWrapOverride1",Q[Q.wordWrapOverride2=135]="wordWrapOverride2",Q[Q.wrappingIndent=136]="wrappingIndent",Q[Q.wrappingStrategy=137]="wrappingStrategy",Q[Q.showDeprecated=138]="showDeprecated",Q[Q.inlayHints=139]="inlayHints",Q[Q.editorClassName=140]="editorClassName",Q[Q.pixelRatio=141]="pixelRatio",Q[Q.tabFocusMode=142]="tabFocusMode",Q[Q.layoutInfo=143]="layoutInfo",Q[Q.wrappingInfo=144]="wrappingInfo",Q[Q.defaultColorDecorators=145]="defaultColorDecorators",Q[Q.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",Q[Q.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(gt||(e.EditorOption=gt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new r(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(202,null)})),acceptSuggestionOnEnter:Be(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(203,null),""],markdownDescription:g.localize(204,null)})),accessibilitySupport:Be(new f),accessibilityPageSize:Be(new o(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(205,null),tags:["accessibility"]})),ariaLabel:Be(new t(4,"ariaLabel",g.localize(206,null))),ariaRequired:Be(new r(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Be(new r(8,"screenReaderAnnounceInlineSuggestion",!0,{description:g.localize(207,null),tags:["accessibility"]})),autoClosingBrackets:Be(new s(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(208,null),g.localize(209,null),""],description:g.localize(210,null)})),autoClosingComments:Be(new s(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(211,null),g.localize(212,null),""],description:g.localize(213,null)})),autoClosingDelete:Be(new s(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(214,null),""],description:g.localize(215,null)})),autoClosingOvertype:Be(new s(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(216,null),""],description:g.localize(217,null)})),autoClosingQuotes:Be(new s(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(218,null),g.localize(219,null),""],description:g.localize(220,null)})),autoIndent:Be(new b(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],_,{enumDescriptions:[g.localize(221,null),g.localize(222,null),g.localize(223,null),g.localize(224,null),g.localize(225,null)],description:g.localize(226,null)})),automaticLayout:Be(new r(13,"automaticLayout",!1)),autoSurround:Be(new s(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(227,null),g.localize(228,null),g.localize(229,null),""],description:g.localize(230,null)})),bracketPairColorization:Be(new B),bracketPairGuides:Be(new X),stickyTabStops:Be(new r(115,"stickyTabStops",!1,{description:g.localize(231,null)})),codeLens:Be(new r(17,"codeLens",!0,{description:g.localize(232,null)})),codeLensFontFamily:Be(new t(18,"codeLensFontFamily","",{description:g.localize(233,null)})),codeLensFontSize:Be(new o(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(234,null)})),colorDecorators:Be(new r(20,"colorDecorators",!0,{description:g.localize(235,null)})),colorDecoratorActivatedOn:Be(new s(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[g.localize(236,null),g.localize(237,null),g.localize(238,null)],description:g.localize(239,null)})),colorDecoratorsLimit:Be(new o(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:g.localize(240,null)})),columnSelection:Be(new r(22,"columnSelection",!1,{description:g.localize(241,null)})),comments:Be(new w),contextmenu:Be(new r(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new r(25,"copyWithSyntaxHighlighting",!0,{description:g.localize(242,null)})),cursorBlinking:Be(new b(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],m,{description:g.localize(243,null)})),cursorSmoothCaretAnimation:Be(new s(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[g.localize(244,null),g.localize(245,null),g.localize(246,null)],description:g.localize(247,null)})),cursorStyle:Be(new b(28,"cursorStyle",v.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],O,{description:g.localize(248,null)})),cursorSurroundingLines:Be(new o(29,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(249,null)})),cursorSurroundingLinesStyle:Be(new s(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(250,null),g.localize(251,null)],markdownDescription:g.localize(252,null)})),cursorWidth:Be(new o(31,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(253,null)})),disableLayerHinting:Be(new r(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new r(33,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new r(34,"domReadOnly",!1)),dragAndDrop:Be(new r(35,"dragAndDrop",!0,{description:g.localize(254,null)})),emptySelectionClipboard:Be(new q),dropIntoEditor:Be(new nt),stickyScroll:Be(new re),experimentalWhitespaceRendering:Be(new s(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[g.localize(255,null),g.localize(256,null),g.localize(257,null)],description:g.localize(258,null)})),extraEditorClassName:Be(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Be(new l(40,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:g.localize(259,null)})),find:Be(new W),fixedOverflowWidgets:Be(new r(42,"fixedOverflowWidgets",!1)),folding:Be(new r(43,"folding",!0,{description:g.localize(260,null)})),foldingStrategy:Be(new s(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(261,null),g.localize(262,null)],description:g.localize(263,null)})),foldingHighlight:Be(new r(45,"foldingHighlight",!0,{description:g.localize(264,null)})),foldingImportsByDefault:Be(new r(46,"foldingImportsByDefault",!1,{description:g.localize(265,null)})),foldingMaximumRegions:Be(new o(47,"foldingMaximumRegions",5e3,10,65e3,{description:g.localize(266,null)})),unfoldOnClickAfterEndOfLine:Be(new r(48,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(267,null)})),fontFamily:Be(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(268,null)})),fontInfo:Be(new M),fontLigatures2:Be(new x),fontSize:Be(new $),fontWeight:Be(new oe),fontVariations:Be(new k),formatOnPaste:Be(new r(55,"formatOnPaste",!1,{description:g.localize(269,null)})),formatOnType:Be(new r(56,"formatOnType",!1,{description:g.localize(270,null)})),glyphMargin:Be(new r(57,"glyphMargin",!0,{description:g.localize(271,null)})),gotoLocation:Be(new de),hideCursorInOverviewRuler:Be(new r(59,"hideCursorInOverviewRuler",!1,{description:g.localize(272,null)})),hover:Be(new we),inDiffEditor:Be(new r(61,"inDiffEditor",!1)),letterSpacing:Be(new l(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>l.clamp(Q,-5,20),{description:g.localize(273,null)})),lightbulb:Be(new pe),lineDecorationsWidth:Be(new H),lineHeight:Be(new ne),lineNumbers:Be(new ge),lineNumbersMinChars:Be(new o(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new r(69,"linkedEditing",!1,{description:g.localize(274,null)})),links:Be(new r(70,"links",!0,{description:g.localize(275,null)})),matchBrackets:Be(new s(71,"matchBrackets","always",["always","near","never"],{description:g.localize(276,null)})),minimap:Be(new Ae),mouseStyle:Be(new s(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new l(74,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:g.localize(277,null)})),mouseWheelZoom:Be(new r(75,"mouseWheelZoom",!1,{markdownDescription:C.isMacintosh?g.localize(278,null):g.localize(279,null)})),multiCursorMergeOverlapping:Be(new r(76,"multiCursorMergeOverlapping",!0,{description:g.localize(280,null)})),multiCursorModifier:Be(new b(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Re,{markdownEnumDescriptions:[g.localize(281,null),g.localize(282,null)],markdownDescription:g.localize(283,null)})),multiCursorPaste:Be(new s(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(284,null),g.localize(285,null)],markdownDescription:g.localize(286,null)})),multiCursorLimit:Be(new o(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:g.localize(287,null)})),occurrencesHighlight:Be(new s(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[g.localize(288,null),g.localize(289,null),g.localize(290,null)],markdownDescription:g.localize(291,null)})),overviewRulerBorder:Be(new r(81,"overviewRulerBorder",!0,{description:g.localize(292,null)})),overviewRulerLanes:Be(new o(82,"overviewRulerLanes",3,0,3)),padding:Be(new ke),pasteAs:Be(new it),parameterHints:Be(new ce),peekWidgetDefaultFocus:Be(new s(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(293,null),g.localize(294,null)],description:g.localize(295,null)})),definitionLinkOpensInPeek:Be(new r(87,"definitionLinkOpensInPeek",!1,{description:g.localize(296,null)})),quickSuggestions:Be(new K),quickSuggestionsDelay:Be(new o(89,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(297,null)})),readOnly:Be(new r(90,"readOnly",!1)),readOnlyMessage:Be(new fe),renameOnType:Be(new r(92,"renameOnType",!1,{description:g.localize(298,null),markdownDeprecationMessage:g.localize(299,null)})),renderControlCharacters:Be(new r(93,"renderControlCharacters",!0,{description:g.localize(300,null),restricted:!0})),renderFinalNewline:Be(new s(94,"renderFinalNewline",C.isLinux?"dimmed":"on",["off","on","dimmed"],{description:g.localize(301,null)})),renderLineHighlight:Be(new s(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(302,null)],description:g.localize(303,null)})),renderLineHighlightOnlyWhenFocus:Be(new r(96,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(304,null)})),renderValidationDecorations:Be(new s(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new s(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(305,null),g.localize(306,null),g.localize(307,null),""],description:g.localize(308,null)})),revealHorizontalRightPadding:Be(new o(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new r(100,"roundedSelection",!0,{description:g.localize(309,null)})),rulers:Be(new Le),scrollbar:Be(new F),scrollBeyondLastColumn:Be(new o(103,"scrollBeyondLastColumn",4,0,1073741824,{description:g.localize(310,null)})),scrollBeyondLastLine:Be(new r(104,"scrollBeyondLastLine",!0,{description:g.localize(311,null)})),scrollPredominantAxis:Be(new r(105,"scrollPredominantAxis",!0,{description:g.localize(312,null)})),selectionClipboard:Be(new r(106,"selectionClipboard",!0,{description:g.localize(313,null),included:C.isLinux})),selectionHighlight:Be(new r(107,"selectionHighlight",!0,{description:g.localize(314,null)})),selectOnLineNumbers:Be(new r(108,"selectOnLineNumbers",!0)),showFoldingControls:Be(new s(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[g.localize(315,null),g.localize(316,null),g.localize(317,null)],description:g.localize(318,null)})),showUnused:Be(new r(110,"showUnused",!0,{description:g.localize(319,null)})),showDeprecated:Be(new r(138,"showDeprecated",!0,{description:g.localize(320,null)})),inlayHints:Be(new J),snippetSuggestions:Be(new s(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(321,null),g.localize(322,null),g.localize(323,null),g.localize(324,null)],description:g.localize(325,null)})),smartSelect:Be(new Ne),smoothScrolling:Be(new r(113,"smoothScrolling",!1,{description:g.localize(326,null)})),stopRenderingLineAfter:Be(new o(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Be(new Se),inlineSuggest:Be(new j),inlineCompletionsAccessibilityVerbose:Be(new r(147,"inlineCompletionsAccessibilityVerbose",!1,{description:g.localize(327,null)})),suggestFontSize:Be(new o(118,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(328,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new o(119,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(329,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new r(120,"suggestOnTriggerCharacters",!0,{description:g.localize(330,null)})),suggestSelection:Be(new s(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(331,null),g.localize(332,null),g.localize(333,null)],description:g.localize(334,null)})),tabCompletion:Be(new s(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(335,null),g.localize(336,null),g.localize(337,null)],description:g.localize(338,null)})),tabIndex:Be(new o(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Be(new V),unusualLineTerminators:Be(new s(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(339,null),g.localize(340,null),g.localize(341,null)],description:g.localize(342,null)})),useShadowDOM:Be(new r(126,"useShadowDOM",!0)),useTabStops:Be(new r(127,"useTabStops",!0,{description:g.localize(343,null)})),wordBreak:Be(new s(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[g.localize(344,null),g.localize(345,null)],description:g.localize(346,null)})),wordSeparators:Be(new t(129,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:g.localize(347,null)})),wordWrap:Be(new s(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(348,null),g.localize(349,null),g.localize(350,null),g.localize(351,null)],description:g.localize(352,null)})),wordWrapBreakAfterCharacters:Be(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new o(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(353,null)})),wordWrapOverride1:Be(new s(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new s(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new N),defaultColorDecorators:Be(new r(145,"defaultColorDecorators",!1,{markdownDescription:g.localize(354,null)})),pixelRatio:Be(new te),tabFocusMode:Be(new r(142,"tabFocusMode",!1,{markdownDescription:g.localize(355,null)})),layoutInfo:Be(new le),wrappingInfo:Be(new Qe),wrappingIndent:Be(new qe),wrappingStrategy:Be(new ve)}}),define(Pe[148],Te([9,10]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[149],Te([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[150],Te([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[151],Te([9,10]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[152],Te([9,10]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[153],Te([9,10]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(Pe[154],Te([9,10]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(Pe[155],Te([9,10]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[156],Te([9,10]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(Pe[157],Te([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Pe[158],Te([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[159],Te([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[160],Te([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[161],Te([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[162],Te([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[163],Te([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[164],Te([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[165],Te([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[166],Te([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[167],Te([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[168],Te([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[169],Te([9,10]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(Pe[170],Te([9,10]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(Pe[171],Te([9,10]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(Pe[172],Te([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[173],Te([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[174],Te([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[175],Te([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[176],Te([9,10]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[177],Te([9,10]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[178],Te([9,10]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[179],Te([9,10]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[180],Te([1,0,15,150]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var C;(function(S){S[S.LParen=0]="LParen",S[S.RParen=1]="RParen",S[S.Neg=2]="Neg",S[S.Eq=3]="Eq",S[S.NotEq=4]="NotEq",S[S.Lt=5]="Lt",S[S.LtEq=6]="LtEq",S[S.Gt=7]="Gt",S[S.GtEq=8]="GtEq",S[S.RegexOp=9]="RegexOp",S[S.RegexStr=10]="RegexStr",S[S.True=11]="True",S[S.False=12]="False",S[S.In=13]="In",S[S.Not=14]="Not",S[S.And=15]="And",S[S.Or=16]="Or",S[S.Str=17]="Str",S[S.QuotedStr=18]="QuotedStr",S[S.Error=19]="Error",S[S.EOF=20]="EOF"})(C||(e.TokenType=C={}));function A(...S){switch(S.length){case 1:return(0,L.localize)(0,null,S[0]);case 2:return(0,L.localize)(1,null,S[0],S[1]);case 3:return(0,L.localize)(2,null,S[0],S[1],S[2]);default:return}}const T=(0,L.localize)(3,null),g=(0,L.localize)(4,null);class h{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,I.illegalState)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(R){return this._input=R,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const D=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:D})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const D=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:D})}else this._match(126)?this._addToken(9):this._error(A("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(A("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(R){return this._isAtEnd()||this._input.charCodeAt(this._current)!==R?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(R){this._tokens.push({type:R,offset:this._start})}_error(R){const D=this._start,u=this._input.substring(this._start,this._current),p={type:19,offset:this._start,lexeme:u};this._errors.push({offset:D,lexeme:u,additionalInfo:R}),this._tokens.push(p)}_string(){this.stringRe.lastIndex=this._start;const R=this.stringRe.exec(this._input);if(R){this._current=this._start+R[0].length;const D=this._input.substring(this._start,this._current),u=h._keywords.get(D);u?this._addToken(u):this._tokens.push({type:17,lexeme:D,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(T);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let R=this._current,D=!1,u=!1;for(;;){if(R>=this._input.length){this._current=R,this._error(g);return}const E=this._input.charCodeAt(R);if(D)D=!1;else if(E===47&&!u){R++;break}else E===91?u=!0:E===92?D=!0:E===93&&(u=!1);R++}for(;R<this._input.length&&h._regexFlags.has(this._input.charCodeAt(R));)R++;this._current=R;const p=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:p,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=h}),define(Pe[181],Te([1,0,25,32,152,295]),function(me,e,I,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,g=/^-(\d{4})(\d{2})(\d{2})$/;function h(r){return r=r.trim(),r==="*"||T.test(r)}e.isValidVersionStr=h;function S(r){if(!h(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=r.match(T);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}e.parseVersion=S;function R(r){if(!r)return null;const n=r.majorBase,o=r.majorMustEqual,c=r.minorBase;let l=r.minorMustEqual;const t=r.patchBase;let d=r.patchMustEqual;r.hasCaret&&(n===0||(l=!1),d=!1);let s=0;if(r.preRelease){const b=g.exec(r.preRelease);if(b){const[,_,f,w]=b;s=Date.UTC(Number(_),Number(f)-1,Number(w))}}return{majorBase:n,majorMustEqual:o,minorBase:c,minorMustEqual:l,patchBase:t,patchMustEqual:d,isMinimum:r.hasGreaterEquals,notBefore:s}}e.normalizeVersion=R;function D(r,n,o){let c;typeof r=="string"?c=R(S(r)):c=r;let l;n instanceof Date?l=n.getTime():typeof n=="string"&&(l=new Date(n).getTime());let t;if(typeof o=="string"?t=R(S(o)):t=o,!c||!t)return!1;const d=c.majorBase,s=c.minorBase,b=c.patchBase;let _=t.majorBase,f=t.minorBase,w=t.patchBase;const P=t.notBefore;let m=t.majorMustEqual,v=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?d>_?!0:d<_?!1:s>f?!0:s<f||l&&l<P?!1:b>=w:(d===1&&_===0&&(!m||!v||!y)&&(_=1,f=0,w=0,m=!0,v=!1,y=!1),d<_?!1:d>_?!m:s<f?!1:s>f?!v:b<w?!1:b>w?!y:!(l&&l<P))}e.isValidVersion=D;function u(r,n,o,c,l){const t=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return t.push([L.default.Error,C.localize(0,null)]),t;if(typeof c.name!="string")return t.push([L.default.Error,C.localize(1,null,"name")]),t;if(typeof c.version!="string")return t.push([L.default.Error,C.localize(2,null,"version")]),t;if(!c.engines)return t.push([L.default.Error,C.localize(3,null,"engines")]),t;if(typeof c.engines.vscode!="string")return t.push([L.default.Error,C.localize(4,null,"engines.vscode")]),t;if(typeof c.extensionDependencies<"u"&&!a(c.extensionDependencies))return t.push([L.default.Error,C.localize(5,null,"extensionDependencies")]),t;if(typeof c.activationEvents<"u"){if(!a(c.activationEvents))return t.push([L.default.Error,C.localize(6,null,"activationEvents")]),t;if(typeof c.main>"u"&&typeof c.browser>"u")return t.push([L.default.Error,C.localize(7,null,"activationEvents","main","browser")]),t}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&t.push([L.default.Warning,C.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return t.push([L.default.Error,C.localize(9,null,"main")]),t;{const b=(0,I.joinPath)(o,c.main);(0,I.isEqualOrParent)(b,o)||t.push([L.default.Warning,C.localize(10,null,b.path,o.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return t.push([L.default.Error,C.localize(11,null,"browser")]),t;{const b=(0,I.joinPath)(o,c.browser);(0,I.isEqualOrParent)(b,o)||t.push([L.default.Warning,C.localize(12,null,b.path,o.path)])}}if(!A.valid(c.version))return t.push([L.default.Error,C.localize(13,null)]),t;const d=[];if(!p(r,n,c,l,d))for(const b of d)t.push([L.default.Error,b]);return t}e.validateExtensionManifest=u;function p(r,n,o,c,l){return c||typeof o.main>"u"&&typeof o.browser>"u"?!0:i(r,n,o.engines.vscode,l)}e.isValidExtensionVersion=p;function E(r,n,o){return r==="*"||i(n,o,r)}e.isEngineValid=E;function i(r,n,o,c=[]){const l=R(S(o));if(!l)return c.push(C.localize(14,null,o)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return c.push(C.localize(15,null,o)),!1}else if(!l.majorMustEqual)return c.push(C.localize(16,null,o)),!1;return D(r,n,l)?!0:(c.push(C.localize(17,null,r,o)),!1)}function a(r){if(!Array.isArray(r))return!1;for(let n=0,o=r.length;n<o;n++)if(typeof r[n]!="string")return!1;return!0}}),define(Pe[70],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class I{constructor(C,A=[],T=!1){this.ctor=C,this.staticArguments=A,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=I}),define(Pe[53],Te([1,0,70]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var C;(function(g){g[g.Eager=0]="Eager",g[g.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function A(g,h,S){h instanceof I.SyncDescriptor||(h=new I.SyncDescriptor(h,[],!!S)),L.push([g,h])}e.registerSingleton=A;function T(){return L}e.getSingletonServiceDescriptors=T}),define(Pe[182],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class I{constructor(A,T){this.key=A,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=I;class L{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const T of this._nodes.values())T.outgoing.size===0&&A.push(T);return A}insertEdge(A,T){const g=this.lookupOrInsertNode(A),h=this.lookupOrInsertNode(T);g.outgoing.set(h.key,h),h.incoming.set(g.key,g)}removeNode(A){const T=this._hashFn(A);this._nodes.delete(T);for(const g of this._nodes.values())g.outgoing.delete(T),g.incoming.delete(T)}lookupOrInsertNode(A){const T=this._hashFn(A);let g=this._nodes.get(T);return g||(g=new I(T,A),this._nodes.set(T,g)),g}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[T,g]of this._nodes)A.push(`${T}
	(-> incoming)[${[...g.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...g.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,T]of this._nodes){const g=new Set([A]),h=this._findCycle(T,g);if(h)return h}}_findCycle(A,T){for(const[g,h]of A.outgoing){if(T.has(g))return[...T,g].join(" -> ");T.add(g);const S=this._findCycle(h,T);if(S)return S;T.delete(g)}}}e.Graph=L}),define(Pe[4],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var I;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function g(h){return h[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=g})(I||(e._util=I={})),e.IInstantiationService=C("instantiationService");function L(T,g,h){g[I.DI_TARGET]===g?g[I.DI_DEPENDENCIES].push({id:T,index:h}):(g[I.DI_DEPENDENCIES]=[{id:T,index:h}],g[I.DI_TARGET]=g)}function C(T){if(I.serviceIds.has(T))return I.serviceIds.get(T);const g=function(h,S,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(g,h,R)};return g.toString=()=>T,I.serviceIds.set(T,g),g}e.createDecorator=C;function A(T){return T}e.refineServiceDecorator=A}),define(Pe[46],Te([1,0,16,2,4]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function A(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof L.URI)}e.isConfigurationOverrides=A;function T(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=T;var g;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})(g||(e.ConfigurationTarget=g={}));function h(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=h;function S(r){return r.applicationValue!==void 0||r.userValue!==void 0||r.userLocalValue!==void 0||r.userRemoteValue!==void 0||r.workspaceValue!==void 0||r.workspaceFolderValue!==void 0}e.isConfigured=S;function R(r,n){const o=Object.create(null);for(const c in r)D(o,c,r[c],n);return o}e.toValuesTree=R;function D(r,n,o,c){const l=n.split("."),t=l.pop();let d=r;for(let s=0;s<l.length;s++){const b=l[s];let _=d[b];switch(typeof _){case"undefined":_=d[b]=Object.create(null);break;case"object":break;default:c(`Ignoring ${n} as ${l.slice(0,s+1).join(".")} is ${JSON.stringify(_)}`);return}d=_}if(typeof d=="object"&&d!==null)try{d[t]=o}catch{c(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(d)}`)}else c(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=D;function u(r,n){const o=n.split(".");p(r,o)}e.removeFromValueTree=u;function p(r,n){const o=n.shift();if(n.length===0){delete r[o];return}if(Object.keys(r).indexOf(o)!==-1){const c=r[o];typeof c=="object"&&!Array.isArray(c)&&(p(c,n),Object.keys(c).length===0&&delete r[o])}}function E(r,n,o){function c(d,s){let b=d;for(const _ of s){if(typeof b!="object"||b===null)return;b=b[_]}return b}const l=n.split("."),t=c(r,l);return typeof t>"u"?o:t}e.getConfigurationValue=E;function i(r,n,o){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in r?I.isObject(r[c])&&I.isObject(n[c])?i(r[c],n[c],o):o&&(r[c]=n[c]):r[c]=n[c])})}e.merge=i;function a(r){return r.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=a}),define(Pe[35],Te([1,0,21,12,180,4,149,15]),function(me,e,I,L,C,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",I.isMacintosh),h.set("isLinux",I.isLinux),h.set("isWindows",I.isWindows),h.set("isWeb",I.isWeb),h.set("isMacNative",I.isMacintosh&&!I.isWeb),h.set("isEdge",I.isEdge),h.set("isFirefox",I.isFirefox),h.set("isChrome",I.isChrome),h.set("isSafari",I.isSafari);function S(J,H){if(h.get(J)!==void 0)throw(0,g.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(J,H)}e.setConstant=S;const R=Object.prototype.hasOwnProperty;var D;(function(J){J[J.False=0]="False",J[J.True=1]="True",J[J.Defined=2]="Defined",J[J.Not=3]="Not",J[J.Equals=4]="Equals",J[J.NotEquals=5]="NotEquals",J[J.And=6]="And",J[J.Regex=7]="Regex",J[J.NotRegex=8]="NotRegex",J[J.Or=9]="Or",J[J.In=10]="In",J[J.NotIn=11]="NotIn",J[J.Greater=12]="Greater",J[J.GreaterEquals=13]="GreaterEquals",J[J.Smaller=14]="Smaller",J[J.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const u={regexParsingWithErrorRecovery:!0},p=(0,T.localize)(0,null),E=(0,T.localize)(1,null),i=(0,T.localize)(2,null),a=(0,T.localize)(3,null),r=(0,T.localize)(4,null),n=(0,T.localize)(5,null),o=(0,T.localize)(6,null),c=(0,T.localize)(7,null);class l{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(H=u){this._config=H,this._scanner=new C.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(H){if(H===""){this._parsingErrors.push({message:p,offset:0,lexeme:"",additionalInfo:E});return}this._tokens=this._scanner.reset(H).scan(),this._current=0,this._parsingErrors=[];try{const ne=this._expr();if(!this._isAtEnd()){const Ae=this._peek(),Re=Ae.type===17?n:void 0;throw this._parsingErrors.push({message:r,offset:Ae.offset,lexeme:C.Scanner.getLexeme(Ae),additionalInfo:Re}),l._parseError}return ne}catch(ne){if(ne!==l._parseError)throw ne;return}}_expr(){return this._or()}_or(){const H=[this._and()];for(;this._matchOne(16);){const ne=this._and();H.push(ne)}return H.length===1?H[0]:t.or(...H)}_and(){const H=[this._term()];for(;this._matchOne(15);){const ne=this._term();H.push(ne)}return H.length===1?H[0]:t.and(...H)}_term(){if(this._matchOne(2)){const H=this._peek();switch(H.type){case 11:return this._advance(),_.INSTANCE;case 12:return this._advance(),f.INSTANCE;case 0:{this._advance();const ne=this._expr();return this._consume(1,a),ne?.negate()}case 17:return this._advance(),O.create(H.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",H)}}return this._primary()}_primary(){const H=this._peek();switch(H.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const ne=this._expr();return this._consume(1,a),ne}case 17:{const ne=H.lexeme;if(this._advance(),this._matchOne(9)){const Re=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),Re.type!==10)throw this._errExpectedButGot("REGEX",Re);const ke=Re.lexeme,ce=ke.lastIndexOf("/"),te=ce===ke.length-1?void 0:this._removeFlagsGY(ke.substring(ce+1));let K;try{K=new RegExp(ke.substring(1,ce),te)}catch{throw this._errExpectedButGot("REGEX",Re)}return M.create(ne,K)}switch(Re.type){case 10:case 19:{const ke=[Re.lexeme];this._advance();let ce=this._peek(),te=0;for(let Le=0;Le<Re.lexeme.length;Le++)Re.lexeme.charCodeAt(Le)===40?te++:Re.lexeme.charCodeAt(Le)===41&&te--;for(;!this._isAtEnd()&&ce.type!==15&&ce.type!==16;){switch(ce.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let Le=0;Le<ce.lexeme.length;Le++)ce.lexeme.charCodeAt(Le)===40?te++:Re.lexeme.charCodeAt(Le)===41&&te--}if(te<0)break;ke.push(C.Scanner.getLexeme(ce)),this._advance(),ce=this._peek()}const K=ke.join(""),ee=K.lastIndexOf("/"),ge=ee===K.length-1?void 0:this._removeFlagsGY(K.substring(ee+1));let be;try{be=new RegExp(K.substring(1,ee),ge)}catch{throw this._errExpectedButGot("REGEX",Re)}return t.regex(ne,be)}case 18:{const ke=Re.lexeme;this._advance();let ce=null;if(!(0,L.isFalsyOrWhitespace)(ke)){const te=ke.indexOf("/"),K=ke.lastIndexOf("/");if(te!==K&&te>=0){const ee=ke.slice(te+1,K),ge=ke[K+1]==="i"?"i":"";try{ce=new RegExp(ee,ge)}catch{throw this._errExpectedButGot("REGEX",Re)}}}if(ce===null)throw this._errExpectedButGot("REGEX",Re);return M.create(ne,ce)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,i);const Re=this._value();return t.notIn(ne,Re)}switch(this._peek().type){case 3:{this._advance();const Re=this._value();if(this._previous().type===18)return t.equals(ne,Re);switch(Re){case"true":return t.has(ne);case"false":return t.not(ne);default:return t.equals(ne,Re)}}case 4:{this._advance();const Re=this._value();if(this._previous().type===18)return t.notEquals(ne,Re);switch(Re){case"true":return t.not(ne);case"false":return t.has(ne);default:return t.notEquals(ne,Re)}}case 5:return this._advance(),x.create(ne,this._value());case 6:return this._advance(),k.create(ne,this._value());case 7:return this._advance(),q.create(ne,this._value());case 8:return this._advance(),W.create(ne,this._value());case 13:return this._advance(),t.in(ne,this._value());default:return t.has(ne)}}case 20:throw this._parsingErrors.push({message:o,offset:H.offset,lexeme:"",additionalInfo:c}),l._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const H=this._peek();switch(H.type){case 17:case 18:return this._advance(),H.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(H){return H.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(H){return this._check(H)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(H,ne){if(this._check(H))return this._advance();throw this._errExpectedButGot(ne,this._peek())}_errExpectedButGot(H,ne,Ae){const Re=(0,T.localize)(8,null,H,C.Scanner.getLexeme(ne)),ke=ne.offset,ce=C.Scanner.getLexeme(ne);return this._parsingErrors.push({message:Re,offset:ke,lexeme:ce,additionalInfo:Ae}),l._parseError}_check(H){return this._peek().type===H}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=l;class t{static false(){return _.INSTANCE}static true(){return f.INSTANCE}static has(H){return w.create(H)}static equals(H,ne){return P.create(H,ne)}static notEquals(H,ne){return y.create(H,ne)}static regex(H,ne){return M.create(H,ne)}static in(H,ne){return m.create(H,ne)}static notIn(H,ne){return v.create(H,ne)}static not(H){return O.create(H)}static and(...H){return de.create(H,null,!0)}static or(...H){return we.create(H,null,!0)}static greater(H,ne){return q.create(H,ne)}static greaterEquals(H,ne){return W.create(H,ne)}static smaller(H,ne){return x.create(H,ne)}static smallerEquals(H,ne){return k.create(H,ne)}static{this._parser=new l({regexParsingWithErrorRecovery:!1})}static deserialize(H){return H==null?void 0:this._parser.parse(H)}}e.ContextKeyExpr=t;function d(J){const H=new l({regexParsingWithErrorRecovery:!1});return J.map(ne=>(H.parse(ne),H.lexingErrors.length>0?H.lexingErrors.map(Ae=>({errorMessage:Ae.additionalInfo?(0,T.localize)(9,null,Ae.additionalInfo):(0,T.localize)(10,null),offset:Ae.offset,length:Ae.lexeme.length})):H.parsingErrors.length>0?H.parsingErrors.map(Ae=>({errorMessage:Ae.additionalInfo?`${Ae.message}. ${Ae.additionalInfo}`:Ae.message,offset:Ae.offset,length:Ae.lexeme.length})):[]))}e.validateWhenClauses=d;function s(J,H){const ne=J?J.substituteConstants():void 0,Ae=H?H.substituteConstants():void 0;return!ne&&!Ae?!0:!ne||!Ae?!1:ne.equals(Ae)}e.expressionsAreEqualWithConstantSubstitution=s;function b(J,H){return J.cmp(H)}class _{static{this.INSTANCE=new _}constructor(){this.type=0}cmp(H){return this.type-H.type}equals(H){return H.type===this.type}substituteConstants(){return this}evaluate(H){return!1}serialize(){return"false"}keys(){return[]}map(H){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=_;class f{static{this.INSTANCE=new f}constructor(){this.type=1}cmp(H){return this.type-H.type}equals(H){return H.type===this.type}substituteConstants(){return this}evaluate(H){return!0}serialize(){return"true"}keys(){return[]}map(H){return this}negate(){return _.INSTANCE}}e.ContextKeyTrueExpr=f;class w{static create(H,ne=null){const Ae=h.get(H);return typeof Ae=="boolean"?Ae?f.INSTANCE:_.INSTANCE:new w(H,ne)}constructor(H,ne){this.key=H,this.negated=ne,this.type=2}cmp(H){return H.type!==this.type?this.type-H.type:le(this.key,H.key)}equals(H){return H.type===this.type?this.key===H.key:!1}substituteConstants(){const H=h.get(this.key);return typeof H=="boolean"?H?f.INSTANCE:_.INSTANCE:this}evaluate(H){return!!H.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(H){return H.mapDefined(this.key)}negate(){return this.negated||(this.negated=O.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=w;class P{static create(H,ne,Ae=null){if(typeof ne=="boolean")return ne?w.create(H,Ae):O.create(H,Ae);const Re=h.get(H);return typeof Re=="boolean"?ne===(Re?"true":"false")?f.INSTANCE:_.INSTANCE:new P(H,ne,Ae)}constructor(H,ne,Ae){this.key=H,this.value=ne,this.negated=Ae,this.type=4}cmp(H){return H.type!==this.type?this.type-H.type:ve(this.key,this.value,H.key,H.value)}equals(H){return H.type===this.type?this.key===H.key&&this.value===H.value:!1}substituteConstants(){const H=h.get(this.key);if(typeof H=="boolean"){const ne=H?"true":"false";return this.value===ne?f.INSTANCE:_.INSTANCE}return this}evaluate(H){return H.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(H){return H.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=P;class m{static create(H,ne){return new m(H,ne)}constructor(H,ne){this.key=H,this.valueKey=ne,this.type=10,this.negated=null}cmp(H){return H.type!==this.type?this.type-H.type:ve(this.key,this.valueKey,H.key,H.valueKey)}equals(H){return H.type===this.type?this.key===H.key&&this.valueKey===H.valueKey:!1}substituteConstants(){return this}evaluate(H){const ne=H.getValue(this.valueKey),Ae=H.getValue(this.key);return Array.isArray(ne)?ne.includes(Ae):typeof Ae=="string"&&typeof ne=="object"&&ne!==null?R.call(ne,Ae):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(H){return H.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=v.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=m;class v{static create(H,ne){return new v(H,ne)}constructor(H,ne){this.key=H,this.valueKey=ne,this.type=11,this._negated=m.create(H,ne)}cmp(H){return H.type!==this.type?this.type-H.type:this._negated.cmp(H._negated)}equals(H){return H.type===this.type?this._negated.equals(H._negated):!1}substituteConstants(){return this}evaluate(H){return!this._negated.evaluate(H)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(H){return H.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=v;class y{static create(H,ne,Ae=null){if(typeof ne=="boolean")return ne?O.create(H,Ae):w.create(H,Ae);const Re=h.get(H);return typeof Re=="boolean"?ne===(Re?"true":"false")?_.INSTANCE:f.INSTANCE:new y(H,ne,Ae)}constructor(H,ne,Ae){this.key=H,this.value=ne,this.negated=Ae,this.type=5}cmp(H){return H.type!==this.type?this.type-H.type:ve(this.key,this.value,H.key,H.value)}equals(H){return H.type===this.type?this.key===H.key&&this.value===H.value:!1}substituteConstants(){const H=h.get(this.key);if(typeof H=="boolean"){const ne=H?"true":"false";return this.value===ne?_.INSTANCE:f.INSTANCE}return this}evaluate(H){return H.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(H){return H.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=P.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=y;class O{static create(H,ne=null){const Ae=h.get(H);return typeof Ae=="boolean"?Ae?_.INSTANCE:f.INSTANCE:new O(H,ne)}constructor(H,ne){this.key=H,this.negated=ne,this.type=3}cmp(H){return H.type!==this.type?this.type-H.type:le(this.key,H.key)}equals(H){return H.type===this.type?this.key===H.key:!1}substituteConstants(){const H=h.get(this.key);return typeof H=="boolean"?H?_.INSTANCE:f.INSTANCE:this}evaluate(H){return!H.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(H){return H.mapNot(this.key)}negate(){return this.negated||(this.negated=w.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=O;function N(J,H){if(typeof J=="string"){const ne=parseFloat(J);isNaN(ne)||(J=ne)}return typeof J=="string"||typeof J=="number"?H(J):_.INSTANCE}class q{static create(H,ne,Ae=null){return N(ne,Re=>new q(H,Re,Ae))}constructor(H,ne,Ae){this.key=H,this.value=ne,this.negated=Ae,this.type=12}cmp(H){return H.type!==this.type?this.type-H.type:ve(this.key,this.value,H.key,H.value)}equals(H){return H.type===this.type?this.key===H.key&&this.value===H.value:!1}substituteConstants(){return this}evaluate(H){return typeof this.value=="string"?!1:parseFloat(H.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(H){return H.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=k.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=q;class W{static create(H,ne,Ae=null){return N(ne,Re=>new W(H,Re,Ae))}constructor(H,ne,Ae){this.key=H,this.value=ne,this.negated=Ae,this.type=13}cmp(H){return H.type!==this.type?this.type-H.type:ve(this.key,this.value,H.key,H.value)}equals(H){return H.type===this.type?this.key===H.key&&this.value===H.value:!1}substituteConstants(){return this}evaluate(H){return typeof this.value=="string"?!1:parseFloat(H.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(H){return H.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=x.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=W;class x{static create(H,ne,Ae=null){return N(ne,Re=>new x(H,Re,Ae))}constructor(H,ne,Ae){this.key=H,this.value=ne,this.negated=Ae,this.type=14}cmp(H){return H.type!==this.type?this.type-H.type:ve(this.key,this.value,H.key,H.value)}equals(H){return H.type===this.type?this.key===H.key&&this.value===H.value:!1}substituteConstants(){return this}evaluate(H){return typeof this.value=="string"?!1:parseFloat(H.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(H){return H.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=W.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=x;class k{static create(H,ne,Ae=null){return N(ne,Re=>new k(H,Re,Ae))}constructor(H,ne,Ae){this.key=H,this.value=ne,this.negated=Ae,this.type=15}cmp(H){return H.type!==this.type?this.type-H.type:ve(this.key,this.value,H.key,H.value)}equals(H){return H.type===this.type?this.key===H.key&&this.value===H.value:!1}substituteConstants(){return this}evaluate(H){return typeof this.value=="string"?!1:parseFloat(H.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(H){return H.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=q.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=k;class M{static create(H,ne){return new M(H,ne)}constructor(H,ne){this.key=H,this.regexp=ne,this.type=7,this.negated=null}cmp(H){if(H.type!==this.type)return this.type-H.type;if(this.key<H.key)return-1;if(this.key>H.key)return 1;const ne=this.regexp?this.regexp.source:"",Ae=H.regexp?H.regexp.source:"";return ne<Ae?-1:ne>Ae?1:0}equals(H){if(H.type===this.type){const ne=this.regexp?this.regexp.source:"",Ae=H.regexp?H.regexp.source:"";return this.key===H.key&&ne===Ae}return!1}substituteConstants(){return this}evaluate(H){const ne=H.getValue(this.key);return this.regexp?this.regexp.test(ne):!1}serialize(){const H=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${H}`}keys(){return[this.key]}map(H){return H.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=$.create(this)),this.negated}}e.ContextKeyRegexExpr=M;class ${static create(H){return new $(H)}constructor(H){this._actual=H,this.type=8}cmp(H){return H.type!==this.type?this.type-H.type:this._actual.cmp(H._actual)}equals(H){return H.type===this.type?this._actual.equals(H._actual):!1}substituteConstants(){return this}evaluate(H){return!this._actual.evaluate(H)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(H){return new $(this._actual.map(H))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=$;function oe(J){let H=null;for(let ne=0,Ae=J.length;ne<Ae;ne++){const Re=J[ne].substituteConstants();if(J[ne]!==Re&&H===null){H=[];for(let ke=0;ke<ne;ke++)H[ke]=J[ke]}H!==null&&(H[ne]=Re)}return H===null?J:H}class de{static create(H,ne,Ae){return de._normalizeArr(H,ne,Ae)}constructor(H,ne){this.expr=H,this.negated=ne,this.type=6}cmp(H){if(H.type!==this.type)return this.type-H.type;if(this.expr.length<H.expr.length)return-1;if(this.expr.length>H.expr.length)return 1;for(let ne=0,Ae=this.expr.length;ne<Ae;ne++){const Re=b(this.expr[ne],H.expr[ne]);if(Re!==0)return Re}return 0}equals(H){if(H.type===this.type){if(this.expr.length!==H.expr.length)return!1;for(let ne=0,Ae=this.expr.length;ne<Ae;ne++)if(!this.expr[ne].equals(H.expr[ne]))return!1;return!0}return!1}substituteConstants(){const H=oe(this.expr);return H===this.expr?this:de.create(H,this.negated,!1)}evaluate(H){for(let ne=0,Ae=this.expr.length;ne<Ae;ne++)if(!this.expr[ne].evaluate(H))return!1;return!0}static _normalizeArr(H,ne,Ae){const Re=[];let ke=!1;for(const ce of H)if(ce){if(ce.type===1){ke=!0;continue}if(ce.type===0)return _.INSTANCE;if(ce.type===6){Re.push(...ce.expr);continue}Re.push(ce)}if(Re.length===0&&ke)return f.INSTANCE;if(Re.length!==0){if(Re.length===1)return Re[0];Re.sort(b);for(let ce=1;ce<Re.length;ce++)Re[ce-1].equals(Re[ce])&&(Re.splice(ce,1),ce--);if(Re.length===1)return Re[0];for(;Re.length>1;){const ce=Re[Re.length-1];if(ce.type!==9)break;Re.pop();const te=Re.pop(),K=Re.length===0,ee=we.create(ce.expr.map(ge=>de.create([ge,te],null,Ae)),null,K);ee&&(Re.push(ee),Re.sort(b))}if(Re.length===1)return Re[0];if(Ae){for(let ce=0;ce<Re.length;ce++)for(let te=ce+1;te<Re.length;te++)if(Re[ce].negate().equals(Re[te]))return _.INSTANCE;if(Re.length===1)return Re[0]}return new de(Re,ne)}}serialize(){return this.expr.map(H=>H.serialize()).join(" && ")}keys(){const H=[];for(const ne of this.expr)H.push(...ne.keys());return H}map(H){return new de(this.expr.map(ne=>ne.map(H)),null)}negate(){if(!this.negated){const H=[];for(const ne of this.expr)H.push(ne.negate());this.negated=we.create(H,this,!0)}return this.negated}}e.ContextKeyAndExpr=de;class we{static create(H,ne,Ae){return we._normalizeArr(H,ne,Ae)}constructor(H,ne){this.expr=H,this.negated=ne,this.type=9}cmp(H){if(H.type!==this.type)return this.type-H.type;if(this.expr.length<H.expr.length)return-1;if(this.expr.length>H.expr.length)return 1;for(let ne=0,Ae=this.expr.length;ne<Ae;ne++){const Re=b(this.expr[ne],H.expr[ne]);if(Re!==0)return Re}return 0}equals(H){if(H.type===this.type){if(this.expr.length!==H.expr.length)return!1;for(let ne=0,Ae=this.expr.length;ne<Ae;ne++)if(!this.expr[ne].equals(H.expr[ne]))return!1;return!0}return!1}substituteConstants(){const H=oe(this.expr);return H===this.expr?this:we.create(H,this.negated,!1)}evaluate(H){for(let ne=0,Ae=this.expr.length;ne<Ae;ne++)if(this.expr[ne].evaluate(H))return!0;return!1}static _normalizeArr(H,ne,Ae){let Re=[],ke=!1;if(H){for(let ce=0,te=H.length;ce<te;ce++){const K=H[ce];if(K){if(K.type===0){ke=!0;continue}if(K.type===1)return f.INSTANCE;if(K.type===9){Re=Re.concat(K.expr);continue}Re.push(K)}}if(Re.length===0&&ke)return _.INSTANCE;Re.sort(b)}if(Re.length!==0){if(Re.length===1)return Re[0];for(let ce=1;ce<Re.length;ce++)Re[ce-1].equals(Re[ce])&&(Re.splice(ce,1),ce--);if(Re.length===1)return Re[0];if(Ae){for(let ce=0;ce<Re.length;ce++)for(let te=ce+1;te<Re.length;te++)if(Re[ce].negate().equals(Re[te]))return f.INSTANCE;if(Re.length===1)return Re[0]}return new we(Re,ne)}}serialize(){return this.expr.map(H=>H.serialize()).join(" || ")}keys(){const H=[];for(const ne of this.expr)H.push(...ne.keys());return H}map(H){return new we(this.expr.map(ne=>ne.map(H)),null)}negate(){if(!this.negated){const H=[];for(const ne of this.expr)H.push(ne.negate());for(;H.length>1;){const ne=H.shift(),Ae=H.shift(),Re=[];for(const ke of re(ne))for(const ce of re(Ae))Re.push(de.create([ke,ce],null,!1));H.unshift(we.create(Re,null,!1))}this.negated=we.create(H,this,!0)}return this.negated}}e.ContextKeyOrExpr=we;class ye extends w{static{this._info=[]}static all(){return ye._info.values()}constructor(H,ne,Ae){super(H,null),this._defaultValue=ne,typeof Ae=="object"?ye._info.push({...Ae,key:H}):Ae!==!0&&ye._info.push({key:H,description:Ae,type:ne!=null?typeof ne:void 0})}bindTo(H){return H.createKey(this.key,this._defaultValue)}getValue(H){return H.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(H){return P.create(this.key,H)}notEqualsTo(H){return y.create(this.key,H)}}e.RawContextKey=ye,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function le(J,H){return J<H?-1:J>H?1:0}function ve(J,H,ne,Ae){return J<ne?-1:J>ne?1:H<Ae?-1:H>Ae?1:0}function ae(J,H){if(J.type===0||H.type===1)return!0;if(J.type===9)return H.type===9?pe(J.expr,H.expr):!1;if(H.type===9){for(const ne of H.expr)if(ae(J,ne))return!0;return!1}if(J.type===6){if(H.type===6)return pe(H.expr,J.expr);for(const ne of J.expr)if(ae(ne,H))return!0;return!1}return J.equals(H)}e.implies=ae;function pe(J,H){let ne=0,Ae=0;for(;ne<J.length&&Ae<H.length;){const Re=J[ne].cmp(H[Ae]);if(Re<0)return!1;Re===0&&ne++,Ae++}return ne===J.length}function re(J){return J.type===9?J.expr:[J]}}),define(Pe[183],Te([1,0,4]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,I.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,I.refineServiceDecorator)(e.IEnvironmentService)}),define(Pe[97],Te([1,0,151,4]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function C(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=C;function A(o){switch(o){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function T(o,c){switch(o){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":c==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function g(o,c){return c==="web"&&!o.includes("web")}e.isNotWebExtensionInWebTargetPlatform=g;function h(o,c,l){return g(c,l)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===l}e.isTargetPlatformCompatible=h;function S(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.isIExtensionIdentifier=S;var R;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var D;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(D||(e.SortOrder=D={}));var u;(function(o){o.Install="install",o.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var p;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var E;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.DownloadSignature="DownloadSignature",o.UpdateMetadata="UpdateMetadata",o.Extract="Extract",o.Scanning="Scanning",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.NotAllowed="NotAllowed",o.Gallery="Gallery",o.Unknown="Unknown",o.Internal="Internal"})(E||(e.ExtensionManagementErrorCode=E={}));var i;(function(o){o.UnknownError="UnknownError",o.PackageIsInvalidZip="PackageIsInvalidZip",o.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(i||(e.ExtensionSignaturetErrorCode=i={}));class a extends Error{constructor(c,l){super(c),this.code=l,this.name=l}}e.ExtensionManagementError=a;var r;(function(o){o.Timeout="Timeout",o.Cancelled="Cancelled",o.Failed="Failed"})(r||(e.ExtensionGalleryErrorCode=r={}));class n extends Error{constructor(c,l){super(c),this.code=l,this.name=l}}e.ExtensionGalleryError=n,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,I.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel=(0,I.localize2)(1,"Preferences")}),define(Pe[42],Te([1,0,50,19,12,16,2,153,4,21,11,39]),function(me,e,I,L,C,A,T,g,h,S,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.isFileSystemWatcher=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,h.createDecorator)("fileService");function u(ae){return ae.create===!0}e.isFileOpenForWriteOptions=u;var p;(function(ae){ae[ae.Unknown=0]="Unknown",ae[ae.File=1]="File",ae[ae.Directory=2]="Directory",ae[ae.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var E;(function(ae){ae[ae.Readonly=1]="Readonly",ae[ae.Locked=2]="Locked"})(E||(e.FilePermission=E={}));function i(ae){const pe=ae;return!!pe&&typeof pe.onDidChange=="function"}e.isFileSystemWatcher=i;var a;(function(ae){ae[ae.None=0]="None",ae[ae.FileReadWrite=2]="FileReadWrite",ae[ae.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ae[ae.FileReadStream=16]="FileReadStream",ae[ae.FileFolderCopy=8]="FileFolderCopy",ae[ae.PathCaseSensitive=1024]="PathCaseSensitive",ae[ae.Readonly=2048]="Readonly",ae[ae.Trash=4096]="Trash",ae[ae.FileWriteUnlock=8192]="FileWriteUnlock",ae[ae.FileAtomicRead=16384]="FileAtomicRead",ae[ae.FileAtomicWrite=32768]="FileAtomicWrite",ae[ae.FileAtomicDelete=65536]="FileAtomicDelete",ae[ae.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function r(ae){return!!(ae.capabilities&2)}e.hasReadWriteCapability=r;function n(ae){return!!(ae.capabilities&8)}e.hasFileFolderCopyCapability=n;function o(ae){return!!(ae.capabilities&131072)}e.hasFileCloneCapability=o;function c(ae){return!!(ae.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function l(ae){return!!(ae.capabilities&16)}e.hasFileReadStreamCapability=l;function t(ae){return r(ae)?!!(ae.capabilities&16384):!1}e.hasFileAtomicReadCapability=t;function d(ae){return r(ae)?!!(ae.capabilities&32768):!1}e.hasFileAtomicWriteCapability=d;function s(ae){return!!(ae.capabilities&65536)}e.hasFileAtomicDeleteCapability=s;function b(ae){return!!(ae.capabilities&2048)}e.hasReadonlyCapability=b;var _;(function(ae){ae.FileExists="EntryExists",ae.FileNotFound="EntryNotFound",ae.FileNotADirectory="EntryNotADirectory",ae.FileIsADirectory="EntryIsADirectory",ae.FileExceedsStorageQuota="EntryExceedsStorageQuota",ae.FileTooLarge="EntryTooLarge",ae.FileWriteLocked="EntryWriteLocked",ae.NoPermissions="NoPermissions",ae.Unavailable="Unavailable",ae.Unknown="Unknown"})(_||(e.FileSystemProviderErrorCode=_={}));class f extends Error{static create(pe,re){const J=new f(pe.toString(),re);return m(J,re),J}constructor(pe,re){super(pe),this.code=re}}e.FileSystemProviderError=f;function w(ae,pe){return f.create(ae,pe)}e.createFileSystemProviderError=w;function P(ae){return ae||w((0,g.localize)(0,null),_.Unknown)}e.ensureFileSystemProviderError=P;function m(ae,pe){return ae.name=pe?`${pe} (FileSystemError)`:"FileSystemError",ae}e.markAsFileSystemProviderError=m;function v(ae){if(!ae)return _.Unknown;if(ae instanceof f)return ae.code;const pe=/^(.+) \(FileSystemError\)$/.exec(ae.name);if(!pe)return _.Unknown;switch(pe[1]){case _.FileExists:return _.FileExists;case _.FileIsADirectory:return _.FileIsADirectory;case _.FileNotADirectory:return _.FileNotADirectory;case _.FileNotFound:return _.FileNotFound;case _.FileTooLarge:return _.FileTooLarge;case _.FileWriteLocked:return _.FileWriteLocked;case _.NoPermissions:return _.NoPermissions;case _.Unavailable:return _.Unavailable}return _.Unknown}e.toFileSystemProviderErrorCode=v;function y(ae){if(ae instanceof k)return ae.fileOperationResult;switch(v(ae)){case _.FileNotFound:return 1;case _.FileIsADirectory:return 0;case _.FileNotADirectory:return 9;case _.FileWriteLocked:return 5;case _.NoPermissions:return 6;case _.FileExists:return 4;case _.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=y;var O;(function(ae){ae[ae.CREATE=0]="CREATE",ae[ae.DELETE=1]="DELETE",ae[ae.MOVE=2]="MOVE",ae[ae.COPY=3]="COPY",ae[ae.WRITE=4]="WRITE"})(O||(e.FileOperation=O={}));class N{constructor(pe,re,J){this.resource=pe,this.operation=re,this.target=J}isOperation(pe){return this.operation===pe}}e.FileOperationEvent=N;var q;(function(ae){ae[ae.UPDATED=0]="UPDATED",ae[ae.ADDED=1]="ADDED",ae[ae.DELETED=2]="DELETED"})(q||(e.FileChangeType=q={}));class W{static{this.MIXED_CORRELATION=null}constructor(pe,re){this.ignorePathCasing=re,this.correlationId=void 0,this.added=new D.Lazy(()=>{const J=I.TernarySearchTree.forUris(()=>this.ignorePathCasing);return J.fill(this.rawAdded.map(H=>[H,!0])),J}),this.updated=new D.Lazy(()=>{const J=I.TernarySearchTree.forUris(()=>this.ignorePathCasing);return J.fill(this.rawUpdated.map(H=>[H,!0])),J}),this.deleted=new D.Lazy(()=>{const J=I.TernarySearchTree.forUris(()=>this.ignorePathCasing);return J.fill(this.rawDeleted.map(H=>[H,!0])),J}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const J of pe){switch(J.type){case 1:this.rawAdded.push(J.resource);break;case 0:this.rawUpdated.push(J.resource);break;case 2:this.rawDeleted.push(J.resource);break}this.correlationId!==W.MIXED_CORRELATION&&(typeof J.cId=="number"?this.correlationId===void 0?this.correlationId=J.cId:this.correlationId!==J.cId&&(this.correlationId=W.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=W.MIXED_CORRELATION))}}contains(pe,...re){return this.doContains(pe,{includeChildren:!1},...re)}affects(pe,...re){return this.doContains(pe,{includeChildren:!0},...re)}doContains(pe,re,...J){if(!pe)return!1;const H=J.length>0;return!!((!H||J.includes(1))&&(this.added.value.get(pe)||re.includeChildren&&this.added.value.findSuperstr(pe))||(!H||J.includes(0))&&(this.updated.value.get(pe)||re.includeChildren&&this.updated.value.findSuperstr(pe))||(!H||J.includes(2))&&(this.deleted.value.findSubstr(pe)||re.includeChildren&&this.deleted.value.findSuperstr(pe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(pe){return this.correlationId===pe}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=W;function x(ae,pe,re){return!ae||!pe||ae===pe||pe.length>ae.length?!1:(pe.charAt(pe.length-1)!==L.sep&&(pe+=L.sep),re?(0,C.startsWithIgnoreCase)(ae,pe):ae.indexOf(pe)===0)}e.isParent=x;class k extends Error{constructor(pe,re,J){super(pe),this.fileOperationResult=re,this.options=J}}e.FileOperationError=k;class M extends k{constructor(pe,re,J,H){super(pe,re,H),this.fileOperationResult=re,this.size=J}}e.TooLargeFileOperationError=M;class $ extends k{constructor(pe,re,J){super(pe,2,J),this.stat=re}}e.NotModifiedSinceFileOperationError=$;var oe;(function(ae){ae[ae.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ae[ae.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ae[ae.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ae[ae.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ae[ae.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ae[ae.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ae[ae.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ae[ae.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ae[ae.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ae[ae.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ae[ae.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(oe||(e.FileOperationResult=oe={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var de;(function(ae){ae[ae.FILE=0]="FILE",ae[ae.FOLDER=1]="FOLDER",ae[ae.ROOT_FOLDER=2]="ROOT_FOLDER"})(de||(e.FileKind=de={})),e.ETAG_DISABLED="";function we(ae){if(!(typeof ae.size!="number"||typeof ae.mtime!="number"))return ae.mtime.toString(29)+ae.size.toString(31)}e.etag=we;async function ye(ae,pe){if(!pe.hasProvider(T.URI.from({scheme:ae.scheme})))return new Promise(re=>{const J=pe.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===ae.scheme&&H.added&&(J.dispose(),re())})})}e.whenProviderRegistered=ye;class le{static{this.KB=1024}static{this.MB=le.KB*le.KB}static{this.GB=le.MB*le.KB}static{this.TB=le.GB*le.KB}static formatSize(pe){return(0,A.isNumber)(pe)||(pe=0),pe<le.KB?(0,g.localize)(1,null,pe.toFixed(0)):pe<le.MB?(0,g.localize)(2,null,(pe/le.KB).toFixed(2)):pe<le.GB?(0,g.localize)(3,null,(pe/le.MB).toFixed(2)):pe<le.TB?(0,g.localize)(4,null,(pe/le.GB).toFixed(2)):(0,g.localize)(5,null,(pe/le.TB).toFixed(2))}}e.ByteSize=le;function ve(ae){const pe=typeof ae=="string"||ae?.scheme===R.Schemas.vscodeRemote;return typeof ae!="string"&&ae?.scheme===R.Schemas.file?1024*le.MB:pe?10*le.MB:S.isWeb?50*le.MB:1024*le.MB}e.getLargeFileConfirmationLimit=ve}),define(Pe[71],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class I{constructor(...C){this._entries=new Map;for(const[A,T]of C)this.set(A,T)}set(C,A){const T=this._entries.get(C);return this._entries.set(C,A),T}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=I}),define(Pe[184],Te([1,0,13,15,6,70,182,4,71,185]),function(me,e,I,L,C,A,T,g,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const R=!1;class D extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class u{constructor(a=new h.ServiceCollection,r=!1,n,o=R){this._services=a,this._strict=r,this._parent=n,this._enableTracing=o,this._activeInstantiations=new Set,this._services.set(g.IInstantiationService,this),this._globalGraph=o?n?._globalGraph??new T.Graph(c=>c):void 0}createChild(a){return new u(a,this._strict,this,this._enableTracing)}invokeFunction(a,...r){const n=E.traceInvocation(this._enableTracing,a);let o=!1;try{return a({get:l=>{if(o)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(l,n);if(!t)throw new Error(`[invokeFunction] unknown service '${l}'`);return t}},...r)}finally{o=!0,n.stop()}}createInstance(a,...r){let n,o;return a instanceof A.SyncDescriptor?(n=E.traceCreation(this._enableTracing,a.ctor),o=this._createInstance(a.ctor,a.staticArguments.concat(r),n)):(n=E.traceCreation(this._enableTracing,a),o=this._createInstance(a,r,n)),n.stop(),o}_createInstance(a,r=[],n){const o=g._util.getServiceDependencies(a).sort((t,d)=>t.index-d.index),c=[];for(const t of o){const d=this._getOrCreateServiceInstance(t.id,n);d||this._throwIfStrict(`[createInstance] ${a.name} depends on UNKNOWN service ${t.id}.`,!1),c.push(d)}const l=o.length>0?o[0].index:r.length;if(r.length!==l){console.trace(`[createInstance] First service dependency of ${a.name} at position ${l+1} conflicts with ${r.length} static arguments`);const t=l-r.length;t>0?r=r.concat(new Array(t)):r=r.slice(0,l)}return Reflect.construct(a,r.concat(c))}_setServiceInstance(a,r){if(this._services.get(a)instanceof A.SyncDescriptor)this._services.set(a,r);else if(this._parent)this._parent._setServiceInstance(a,r);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){const r=this._services.get(a);return!r&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):r}_getOrCreateServiceInstance(a,r){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(a));const n=this._getServiceInstanceOrDescriptor(a);return n instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,n,r.branch(a,!0)):(r.branch(a,!1),n)}_safeCreateAndCacheServiceInstance(a,r,n){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,r,n)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,r,n){const o=new T.Graph(t=>t.id.toString());let c=0;const l=[{id:a,desc:r,_trace:n}];for(;l.length;){const t=l.pop();if(o.lookupOrInsertNode(t),c++>1e3)throw new D(o);for(const d of g._util.getServiceDependencies(t.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(d.id);if(s||this._throwIfStrict(`[createInstance] ${a} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(d.id)),s instanceof A.SyncDescriptor){const b={id:d.id,desc:s,_trace:t._trace.branch(d.id,!0)};o.insertEdge(t,b),l.push(b)}}}for(;;){const t=o.roots();if(t.length===0){if(!o.isEmpty())throw new D(o);break}for(const{data:d}of t){if(this._getServiceInstanceOrDescriptor(d.id)instanceof A.SyncDescriptor){const b=this._createServiceInstanceWithOwner(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this._setServiceInstance(d.id,b)}o.removeNode(d)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,r,n=[],o,c){if(this._services.get(a)instanceof A.SyncDescriptor)return this._createServiceInstance(a,r,n,o,c);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,r,n,o,c);throw new Error(`illegalState - creating UNKNOWN service instance ${r.name}`)}_createServiceInstance(a,r,n=[],o,c){if(o){const l=new u(void 0,this._strict,this,this._enableTracing);l._globalGraphImplicitDependency=String(a);const t=new Map,d=new I.GlobalIdleValue(()=>{const s=l._createInstance(r,n,c);for(const[b,_]of t){const f=s[b];if(typeof f=="function")for(const w of _)w.disposable=f.apply(s,w.listener)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,b){if(!d.isInitialized&&typeof b=="string"&&(b.startsWith("onDid")||b.startsWith("onWill"))){let w=t.get(b);return w||(w=new S.LinkedList,t.set(b,w)),(m,v,y)=>{if(d.isInitialized)return d.value[b](m,v,y);{const O={listener:[m,v,y],disposable:void 0},N=w.push(O);return(0,C.toDisposable)(()=>{N(),O.disposable?.dispose()})}}}if(b in s)return s[b];const _=d.value;let f=_[b];return typeof f!="function"||(f=f.bind(_),s[b]=f),f},set(s,b,_){return d.value[b]=_,!0},getPrototypeOf(s){return r.prototype}})}else return this._createInstance(r,n,c)}_throwIfStrict(a,r){if(r&&console.warn(a),this._strict)throw new Error(a)}}e.InstantiationService=u;var p;(function(i){i[i.None=0]="None",i[i.Creation=1]="Creation",i[i.Invocation=2]="Invocation",i[i.Branch=3]="Branch"})(p||(p={}));class E{static{this.all=new Set}static{this._None=new class extends E{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(a,r){return a?new E(2,r.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):E._None}static traceCreation(a,r){return a?new E(1,r.name):E._None}static{this._totals=0}constructor(a,r){this.type=a,this.name=r,this._start=Date.now(),this._dep=[]}branch(a,r){const n=new E(3,a.toString());return this._dep.push([a,r,n]),n}stop(){const a=Date.now()-this._start;E._totals+=a;let r=!1;function n(c,l){const t=[],d=new Array(c+1).join("	");for(const[s,b,_]of l._dep)if(b&&_){r=!0,t.push(`${d}CREATES -> ${s}`);const f=n(c+1,_);f&&t.push(f)}else t.push(`${d}uses -> ${s}`);return t.join(`
`)}const o=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(a>2||r)&&E.all.add(o.join(`
`))}}e.Trace=E}),define(Pe[14],Te([1,0,41,5,98,6,28,21,25,16,2,35,4]),function(me,e,I,L,C,A,T,g,h,S,R,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,u.createDecorator)("logService"),e.ILoggerService=(0,u.createDecorator)("loggerService");function p(){return new Date().toISOString()}function E(m){return(0,S.isNumber)(m)}e.isLogLevel=E;var i;(function(m){m[m.Off=0]="Off",m[m.Trace=1]="Trace",m[m.Debug=2]="Debug",m[m.Info=3]="Info",m[m.Warning=4]="Warning",m[m.Error=5]="Error"})(i||(e.LogLevel=i={})),e.DEFAULT_LOG_LEVEL=i.Info;function a(m,v,y){switch(v){case i.Trace:m.trace(y);break;case i.Debug:m.debug(y);break;case i.Info:m.info(y);break;case i.Warning:m.warn(y);break;case i.Error:m.error(y);break;case i.Off:break;default:throw new Error(`Invalid log level ${v}`)}}e.log=a;function r(m,v=!1){let y="";for(let O=0;O<m.length;O++){let N=m[O];if(N instanceof Error&&(N=(0,I.toErrorMessage)(N,v)),typeof N=="object")try{N=JSON.stringify(N)}catch{}y+=(O>0?" ":"")+N}return y}class n extends A.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(v){this.level!==v&&(this.level=v,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(v){return this.level!==i.Off&&this.level<=v}}e.AbstractLogger=n;class o extends n{constructor(v){super(),this.logAlways=v}checkLogLevel(v){return this.logAlways||super.checkLogLevel(v)}trace(v,...y){this.checkLogLevel(i.Trace)&&this.log(i.Trace,r([v,...y],!0))}debug(v,...y){this.checkLogLevel(i.Debug)&&this.log(i.Debug,r([v,...y]))}info(v,...y){this.checkLogLevel(i.Info)&&this.log(i.Info,r([v,...y]))}warn(v,...y){this.checkLogLevel(i.Warning)&&this.log(i.Warning,r([v,...y]))}error(v,...y){if(this.checkLogLevel(i.Error))if(v instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=v.stack,this.log(i.Error,r(O))}else this.log(i.Error,r([v,...y]))}flush(){}}e.AbstractMessageLogger=o;class c extends n{constructor(v=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(v),this.useColors=!g.isWindows}trace(v,...y){this.checkLogLevel(i.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,v,...y):console.log(`[main ${p()}]`,v,...y))}debug(v,...y){this.checkLogLevel(i.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,v,...y):console.log(`[main ${p()}]`,v,...y))}info(v,...y){this.checkLogLevel(i.Info)&&(this.useColors?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,v,...y):console.log(`[main ${p()}]`,v,...y))}warn(v,...y){this.checkLogLevel(i.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,v,...y):console.warn(`[main ${p()}]`,v,...y))}error(v,...y){this.checkLogLevel(i.Error)&&(this.useColors?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,v,...y):console.error(`[main ${p()}]`,v,...y))}flush(){}}e.ConsoleMainLogger=c;class l extends n{constructor(v=e.DEFAULT_LOG_LEVEL,y=!0){super(),this.useColors=y,this.setLevel(v)}trace(v,...y){this.checkLogLevel(i.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",v,...y):console.log(v,...y))}debug(v,...y){this.checkLogLevel(i.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",v,...y):console.log(v,...y))}info(v,...y){this.checkLogLevel(i.Info)&&(this.useColors?console.log("%c INFO","color: #33f",v,...y):console.log(v,...y))}warn(v,...y){this.checkLogLevel(i.Warning)&&(this.useColors?console.log("%c WARN","color: #993",v,...y):console.log(v,...y))}error(v,...y){this.checkLogLevel(i.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",v,...y):console.error(v,...y))}flush(){}}e.ConsoleLogger=l;class t extends n{constructor(v,y=e.DEFAULT_LOG_LEVEL){super(),this.adapter=v,this.setLevel(y)}trace(v,...y){this.checkLogLevel(i.Trace)&&this.adapter.log(i.Trace,[this.extractMessage(v),...y])}debug(v,...y){this.checkLogLevel(i.Debug)&&this.adapter.log(i.Debug,[this.extractMessage(v),...y])}info(v,...y){this.checkLogLevel(i.Info)&&this.adapter.log(i.Info,[this.extractMessage(v),...y])}warn(v,...y){this.checkLogLevel(i.Warning)&&this.adapter.log(i.Warning,[this.extractMessage(v),...y])}error(v,...y){this.checkLogLevel(i.Error)&&this.adapter.log(i.Error,[this.extractMessage(v),...y])}extractMessage(v){return typeof v=="string"?v:(0,I.toErrorMessage)(v,this.checkLogLevel(i.Trace))}flush(){}}e.AdapterLogger=t;class d extends n{constructor(v){super(),this.loggers=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const y of this.loggers)y.setLevel(v);super.setLevel(v)}trace(v,...y){for(const O of this.loggers)O.trace(v,...y)}debug(v,...y){for(const O of this.loggers)O.debug(v,...y)}info(v,...y){for(const O of this.loggers)O.info(v,...y)}warn(v,...y){for(const O of this.loggers)O.warn(v,...y)}error(v,...y){for(const O of this.loggers)O.error(v,...y)}flush(){for(const v of this.loggers)v.flush()}dispose(){for(const v of this.loggers)v.dispose();super.dispose()}}e.MultiplexLogger=d;class s extends A.Disposable{constructor(v,y,O){if(super(),this.logLevel=v,this.logsHome=y,this._loggers=new T.ResourceMap,this._onDidChangeLoggers=this._register(new L.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new L.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,O)for(const N of O)this._loggers.set(N.resource,{logger:void 0,info:N})}getLoggerEntry(v){return(0,S.isString)(v)?[...this._loggers.values()].find(y=>y.info.id===v):this._loggers.get(v)}getLogger(v){return this.getLoggerEntry(v)?.logger}createLogger(v,y){const O=this.toResource(v),N=(0,S.isString)(v)?v:y?.id??(0,C.hash)(O.toString()).toString(16);let q=this._loggers.get(O)?.logger;const W=y?.logLevel==="always"?i.Trace:y?.logLevel;q||(q=this.doCreateLogger(O,W??this.getLogLevel(O)??this.logLevel,{...y,id:N}));const x={logger:q,info:{resource:O,id:N,logLevel:W,name:y?.name,hidden:y?.hidden,extensionId:y?.extensionId,when:y?.when}};return this.registerLogger(x.info),this._loggers.set(O,x),q}toResource(v){return(0,S.isString)(v)?(0,h.joinPath)(this.logsHome,`${v}.log`):v}setLogLevel(v,y){if(R.URI.isUri(v)){const O=v,N=y,q=this._loggers.get(O);q&&N!==q.info.logLevel&&(q.info.logLevel=N===this.logLevel?void 0:N,q.logger?.setLevel(N),this._loggers.set(q.info.resource,q),this._onDidChangeLogLevel.fire([O,N]))}else{this.logLevel=v;for(const[O,N]of this._loggers.entries())this._loggers.get(O)?.info.logLevel===void 0&&N.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(v,y){const O=this.getLoggerEntry(v);O&&y!==!O.info.hidden&&(O.info.hidden=!y,this._loggers.set(O.info.resource,O),this._onDidChangeVisibility.fire([O.info.resource,y]))}getLogLevel(v){let y;return v&&(y=this._loggers.get(v)?.info.logLevel),y??this.logLevel}registerLogger(v){const y=this._loggers.get(v.resource);y?y.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this._loggers.set(v.resource,{info:v,logger:void 0}),this._onDidChangeLoggers.fire({added:[v],removed:[]}))}deregisterLogger(v){const y=this._loggers.get(v);y&&(y.logger&&y.logger.dispose(),this._loggers.delete(v),this._onDidChangeLoggers.fire({added:[],removed:[y.info]}))}*getRegisteredLoggers(){for(const v of this._loggers.values())yield v.info}getRegisteredLogger(v){return this._loggers.get(v)?.info}dispose(){this._loggers.forEach(v=>v.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=s;class b{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(v){}getLevel(){return i.Info}trace(v,...y){}debug(v,...y){}info(v,...y){}warn(v,...y){}error(v,...y){}critical(v,...y){}dispose(){}flush(){}}e.NullLogger=b;class _ extends b{}e.NullLogService=_;function f(m){if(m.verbose)return i.Trace;if(typeof m.logLevel=="string"){const v=P(m.logLevel.toLowerCase());if(v!==void 0)return v}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=f;function w(m){switch(m){case i.Trace:return"trace";case i.Debug:return"debug";case i.Info:return"info";case i.Warning:return"warn";case i.Error:return"error";case i.Off:return"off"}}e.LogLevelToString=w;function P(m){switch(m){case"trace":return i.Trace;case"debug":return i.Debug;case"info":return i.Info;case"warn":return i.Warning;case"error":return i.Error;case"critical":return i.Error;case"off":return i.Off}}e.parseLogLevel=P,e.CONTEXT_LOG_LEVEL=new D.RawContextKey("logLevel",w(i.Info))}),define(Pe[186],Te([1,0,6,14]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class C extends I.Disposable{constructor(T,g=[]){super(),this.logger=new L.MultiplexLogger([T,...g]),this._register(T.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(T){this.logger.setLevel(T)}getLevel(){return this.logger.getLevel()}trace(T,...g){this.logger.trace(T,...g)}debug(T,...g){this.logger.debug(T,...g)}info(T,...g){this.logger.info(T,...g)}warn(T,...g){this.logger.warn(T,...g)}error(T,...g){this.logger.error(T,...g)}flush(){this.logger.flush()}}e.LogService=C}),define(Pe[99],Te([1,0,32,154,4]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(h){h[h.Unnecessary=1]="Unnecessary",h[h.Deprecated=2]="Deprecated"})(A||(e.MarkerTag=A={}));var T;(function(h){h[h.Hint=1]="Hint",h[h.Info=2]="Info",h[h.Warning=4]="Warning",h[h.Error=8]="Error"})(T||(e.MarkerSeverity=T={})),function(h){function S(E,i){return i-E}h.compare=S;const R=Object.create(null);R[h.Error]=(0,L.localize)(0,null),R[h.Warning]=(0,L.localize)(1,null),R[h.Info]=(0,L.localize)(2,null);function D(E){return R[E]||""}h.toString=D;function u(E){switch(E){case I.default.Error:return h.Error;case I.default.Warning:return h.Warning;case I.default.Info:return h.Info;case I.default.Ignore:return h.Hint}}h.fromSeverity=u;function p(E){switch(E){case h.Error:return I.default.Error;case h.Warning:return I.default.Warning;case h.Info:return I.default.Info;case h.Hint:return I.default.Ignore}}h.toSeverity=p}(T||(e.MarkerSeverity=T={}));var g;(function(h){const S="";function R(u){return D(u,!0)}h.makeKey=R;function D(u,p){const E=[S];return u.source?E.push(u.source.replace("\xA6","\\\xA6")):E.push(S),u.code?typeof u.code=="string"?E.push(u.code.replace("\xA6","\\\xA6")):E.push(u.code.value.replace("\xA6","\\\xA6")):E.push(S),u.severity!==void 0&&u.severity!==null?E.push(T.toString(u.severity)):E.push(S),u.message&&p?E.push(u.message.replace("\xA6","\\\xA6")):E.push(S),u.startLineNumber!==void 0&&u.startLineNumber!==null?E.push(u.startLineNumber.toString()):E.push(S),u.startColumn!==void 0&&u.startColumn!==null?E.push(u.startColumn.toString()):E.push(S),u.endLineNumber!==void 0&&u.endLineNumber!==null?E.push(u.endLineNumber.toString()):E.push(S),u.endColumn!==void 0&&u.endColumn!==null?E.push(u.endColumn.toString()):E.push(S),E.push(S),E.join("\xA6")}h.makeKeyOptionalMessage=D})(g||(e.IMarkerData=g={})),e.IMarkerService=(0,C.createDecorator)("markerService")}),define(Pe[187],Te([1,0,5,32,4]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.isNotificationSource=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,C.createDecorator)("notificationService");var A;(function(D){D[D.DEFAULT=0]="DEFAULT",D[D.SILENT=1]="SILENT",D[D.URGENT=2]="URGENT"})(A||(e.NotificationPriority=A={}));var T;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.PROFILE=1]="PROFILE",D[D.APPLICATION=2]="APPLICATION"})(T||(e.NeverShowAgainScope=T={}));function g(D){if(D){const u=D;return typeof u.id=="string"&&typeof u.label=="string"}return!1}e.isNotificationSource=g;var h;(function(D){D[D.OFF=0]="OFF",D[D.ERROR=1]="ERROR"})(h||(e.NotificationsFilter=h={}));class S{constructor(){this.progress=new R,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.NoOpNotification=S;class R{infinite(){}done(){}total(u){}worked(u){}}e.NoOpProgress=R}),define(Pe[188],Te([1,0,4]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,I.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(me,e,I,L){var C=arguments.length,A=C<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,I):L,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(me,e,I,L);else for(var g=me.length-1;g>=0;g--)(T=me[g])&&(A=(C<3?T(A):C>3?T(e,I,A):T(e,I))||A);return C>3&&A&&Object.defineProperty(e,I,A),A},We=this&&this.__param||function(me,e){return function(I,L){e(I,L,me)}};define(Pe[72],Te([1,0,13,20,6,4]),function(me,e,I,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.AsyncProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var T;(function(D){D[D.Explorer=1]="Explorer",D[D.Scm=3]="Scm",D[D.Extensions=5]="Extensions",D[D.Window=10]="Window",D[D.Notification=15]="Notification",D[D.Dialog=20]="Dialog"})(T||(e.ProgressLocation=T={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class g{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(u){this.callback=u}report(u){this._value=u,this.callback(this._value)}}e.Progress=g;class h{get value(){return this._value}constructor(u){this.callback=u}report(u){this._asyncQueue?this._asyncQueue.push(u):this._asyncQueue=[u],this._processAsyncQueue()}async _processAsyncQueue(){if(!this._processingAsyncQueue)try{for(this._processingAsyncQueue=!0;this._asyncQueue&&this._asyncQueue.length;){const u=this._asyncQueue.shift();this._value=u,await this.callback(this._value)}}finally{this._processingAsyncQueue=!1;const u=this._drainListener;this._drainListener=void 0,u?.()}}drain(){return this._processingAsyncQueue?new Promise(u=>{const p=this._drainListener;this._drainListener=()=>{p?.(),u()}}):Promise.resolve()}}e.AsyncProgress=h;let S=class extends C.Disposable{constructor(u,p){super(),this.deferred=new I.DeferredPromise,p.withProgress(u,E=>(this.reporter=E,this.lastStep&&E.report(this.lastStep),this.deferred.p)),this._register((0,C.toDisposable)(()=>this.deferred.complete()))}report(u){this.reporter?this.reporter.report(u):this.lastStep=u}};e.UnmanagedProgress=S,e.UnmanagedProgress=S=Ke([We(1,e.IProgressService)],S);class R extends C.Disposable{constructor(u){super(),this.progressIndicator=u,this.currentOperationId=0,this.currentOperationDisposables=this._register(new C.DisposableStore)}start(u){this.stop();const p=++this.currentOperationId,E=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{p===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},u),this.currentOperationDisposables.add((0,C.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,C.toDisposable)(()=>E.cancel())),this.currentOperationDisposables.add((0,C.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:p,token:E.token,stop:()=>this.doStop(p),isCurrent:()=>this.currentOperationId===p}}stop(){this.doStop(this.currentOperationId)}doStop(u){this.currentOperationId===u&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=R,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(Pe[30],Te([1,0,54,16]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(T,g){I.ok(L.isString(T)),I.ok(L.isObject(g)),I.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,g)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new C}),define(Pe[73],Te([1,0,5,30]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(g){return g.length>0&&g.charAt(g.length-1)==="#"?g.substring(0,g.length-1):g}class A{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,S){this.schemasById[C(h)]=S,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new A;L.Registry.add(e.Extensions.JSONContribution,T)}),define(Pe[55],Te([1,0,18,5,16,148,46,73,30]),function(me,e,I,L,C,A,T,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(S||(e.EditPresentationTypes=S={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const D=h.Registry.as(g.Extensions.JSONContribution);class u{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,d=!0){this.registerConfigurations([t],d)}registerConfigurations(t,d=!0){const s=new Set;this.doRegisterConfigurations(t,d,s),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(t){const d=new Set;this.doDeregisterConfigurations(t,d),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d})}updateConfigurations({add:t,remove:d}){const s=new Set;this.doDeregisterConfigurations(d,s),this.doRegisterConfigurations(t,!1,s),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}registerDefaultConfigurations(t){const d=new Set;this.doRegisterDefaultConfigurations(t,d),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,d){const s=[];for(const{overrides:b,source:_}of t)for(const f in b)if(d.add(f),e.OVERRIDE_PROPERTY_REGEX.test(f)){const w=this.configurationDefaultsOverrides.get(f),P=w?.valuesSources??new Map;if(_)for(const O of Object.keys(b[f]))P.set(O,_);const m={...w?.value||{},...b[f]};this.configurationDefaultsOverrides.set(f,{source:_,value:m,valuesSources:P});const v=(0,T.getLanguageTagSettingPlainKey)(f),y={type:"object",default:m,description:A.localize(1,null,v),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:m,source:C.isString(_)?void 0:_,defaultValueSource:_};s.push(...i(f)),this.configurationProperties[f]=y,this.defaultLanguageConfigurationOverridesNode.properties[f]=y}else{this.configurationDefaultsOverrides.set(f,{value:b[f],source:_});const w=this.configurationProperties[f];w&&(this.updatePropertyDefaultValue(f,w),this.updateSchema(f,w))}this.doRegisterOverrideIdentifiers(s)}deregisterDefaultConfigurations(t){const d=new Set;this.doDeregisterDefaultConfigurations(t,d),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,d){for(const{overrides:s,source:b}of t)for(const _ in s){const f=this.configurationDefaultsOverrides.get(_),w=C.isString(b)?b:b?.id,P=C.isString(f?.source)?f?.source:f?.source?.id;if(w===P)if(d.add(_),this.configurationDefaultsOverrides.delete(_),e.OVERRIDE_PROPERTY_REGEX.test(_))delete this.configurationProperties[_],delete this.defaultLanguageConfigurationOverridesNode.properties[_];else{const m=this.configurationProperties[_];m&&(this.updatePropertyDefaultValue(_,m),this.updateSchema(_,m))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let d=!1;const s=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,s),d=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,s),d=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,s),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:d})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const d of t)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,d,s){t.forEach(b=>{this.validateAndRegisterProperties(b,d,b.extensionInfo,b.restrictedProperties,void 0,s),this.configurationContributors.push(b),this.registerJSONConfiguration(b)})}doDeregisterConfigurations(t,d){const s=b=>{if(b.properties)for(const _ in b.properties){d.add(_);const f=this.configurationProperties[_];f?.policy?.name&&this.policyConfigurations.delete(f.policy.name),delete this.configurationProperties[_],this.removeFromSchema(_,b.properties[_])}b.allOf?.forEach(_=>s(_))};for(const b of t){s(b);const _=this.configurationContributors.indexOf(b);_!==-1&&this.configurationContributors.splice(_,1)}}validateAndRegisterProperties(t,d=!0,s,b,_=3,f){_=C.isUndefinedOrNull(t.scope)?_:t.scope;const w=t.properties;if(w)for(const m in w){const v=w[m];if(d&&o(m,v)){delete w[m];continue}if(v.source=s,v.defaultDefaultValue=w[m].default,this.updatePropertyDefaultValue(m,v),e.OVERRIDE_PROPERTY_REGEX.test(m)?v.scope=void 0:(v.scope=C.isUndefinedOrNull(v.scope)?_:v.scope,v.restricted=C.isUndefinedOrNull(v.restricted)?!!b?.includes(m):v.restricted),w[m].hasOwnProperty("included")&&!w[m].included){this.excludedConfigurationProperties[m]=w[m],delete w[m];continue}else this.configurationProperties[m]=w[m],w[m].policy?.name&&this.policyConfigurations.set(w[m].policy.name,m);!w[m].deprecationMessage&&w[m].markdownDeprecationMessage&&(w[m].deprecationMessage=w[m].markdownDeprecationMessage),f.add(m)}const P=t.allOf;if(P)for(const m of P)this.validateAndRegisterProperties(m,d,s,b,_,f)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const d=s=>{const b=s.properties;if(b)for(const f in b)this.updateSchema(f,b[f]);s.allOf?.forEach(d)};d(t)}updateSchema(t,d){switch(e.allSettings.properties[t]=d,d.scope){case 1:e.applicationSettings.properties[t]=d;break;case 2:e.machineSettings.properties[t]=d;break;case 6:e.machineOverridableSettings.properties[t]=d;break;case 3:e.windowSettings.properties[t]=d;break;case 4:e.resourceSettings.properties[t]=d;break;case 5:e.resourceSettings.properties[t]=d,this.resourceLanguageSettingsSchema.properties[t]=d;break}}removeFromSchema(t,d){switch(delete e.allSettings.properties[t],d.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const d=`[${t}]`,s={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,s),e.allSettings.properties[d]=s,e.applicationSettings.properties[d]=s,e.machineSettings.properties[d]=s,e.machineOverridableSettings.properties[d]=s,e.windowSettings.properties[d]=s,e.resourceSettings.properties[d]=s}}registerOverridePropertyPatternKey(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,d){const s=this.configurationDefaultsOverrides.get(t);let b=s?.value,_=s?.source;C.isUndefined(b)&&(b=d.defaultDefaultValue,_=void 0),C.isUndefined(b)&&(b=r(d.type)),d.default=b,d.defaultValueSource=_}}const p="\\[([^\\]]+)\\]",E=new RegExp(p,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${p})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function i(l){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(l)){let d=E.exec(l);for(;d?.length;){const s=d[1].trim();s&&t.push(s),d=E.exec(l)}}return(0,I.distinct)(t)}e.overrideIdentifiersFromKey=i;function a(l){return l.reduce((t,d)=>`${t}[${d}]`,"")}e.keyFromOverrideIdentifiers=a;function r(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=r;const n=new u;h.Registry.add(e.Extensions.Configuration,n);function o(l,t){return l.trim()?e.OVERRIDE_PROPERTY_REGEX.test(l)?A.localize(7,null,l):n.getConfigurationProperties()[l]!==void 0?A.localize(8,null,l):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,l,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.validateProperty=o;function c(){const l=[],t=n.getConfigurationProperties();for(const d of Object.keys(t))l.push([d,t[d].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.getScopes=c}),define(Pe[189],Te([1,0,18,5,119,6,28,26,16,2,46,55,30]),function(me,e,I,L,C,A,T,g,h,S,R,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function p(d){return Object.isFrozen(d)?d:g.deepFreeze(d)}class E{constructor(s={},b=[],_=[],f){this._contents=s,this._keys=b,this._overrides=_,this.raw=f,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const s=this.raw.map(b=>{if(b instanceof E)return b;const _=new i("");return _.parseRaw(b),_.configurationModel});this._rawConfiguration=s.reduce((b,_)=>_===b?_:b.merge(_),s[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,R.getConfigurationValue)(this.contents,s):this.contents}inspect(s,b){const _=this.rawConfiguration.getValue(s),f=b?this.rawConfiguration.getOverrideValue(s,b):void 0,w=b?this.rawConfiguration.override(b).getValue(s):_;return{value:_,override:f,merged:w}}getOverrideValue(s,b){const _=this.getContentsForOverrideIdentifer(b);return _?s?(0,R.getConfigurationValue)(_,s):_:void 0}getKeysForOverrideIdentifier(s){const b=[];for(const _ of this.overrides)_.identifiers.includes(s)&&b.push(..._.keys);return I.distinct(b)}getAllOverrideIdentifiers(){const s=[];for(const b of this.overrides)s.push(...b.identifiers);return I.distinct(s)}override(s){let b=this.overrideConfigurations.get(s);return b||(b=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,b)),b}merge(...s){const b=g.deepClone(this.contents),_=g.deepClone(this.overrides),f=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const P of s)if(w.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.mergeContents(b,P.contents);for(const m of P.overrides){const[v]=_.filter(y=>I.equals(y.identifiers,m.identifiers));v?(this.mergeContents(v.contents,m.contents),v.keys.push(...m.keys),v.keys=I.distinct(v.keys)):_.push(g.deepClone(m))}for(const m of P.keys)f.indexOf(m)===-1&&f.push(m)}return new E(b,f,_,w.every(P=>P instanceof E)?void 0:w)}createOverrideConfigurationModel(s){const b=this.getContentsForOverrideIdentifer(s);if(!b||typeof b!="object"||!Object.keys(b).length)return this;const _={};for(const f of I.distinct([...Object.keys(this.contents),...Object.keys(b)])){let w=this.contents[f];const P=b[f];P&&(typeof w=="object"&&typeof P=="object"?(w=g.deepClone(w),this.mergeContents(w,P)):w=P),_[f]=w}return new E(_,this.keys,this.overrides)}mergeContents(s,b){for(const _ of Object.keys(b)){if(_ in s&&h.isObject(s[_])&&h.isObject(b[_])){this.mergeContents(s[_],b[_]);continue}s[_]=g.deepClone(b[_])}}getContentsForOverrideIdentifer(s){let b=null,_=null;const f=w=>{w&&(_?this.mergeContents(_,w):_=g.deepClone(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===s?b=w.contents:w.identifiers.includes(s)&&f(w.contents);return f(b),_}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,b){this.updateValue(s,b,!0)}setValue(s,b){this.updateValue(s,b,!1)}removeValue(s){const b=this.keys.indexOf(s);b!==-1&&(this.keys.splice(b,1),(0,R.removeFromValueTree)(this.contents,s),D.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(_=>I.equals(_.identifiers,(0,D.overrideIdentifiersFromKey)(s))),1))}updateValue(s,b,_){(0,R.addToValueTree)(this.contents,s,b,f=>console.error(f)),_=_||this.keys.indexOf(s)===-1,_&&this.keys.push(s),D.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,D.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,R.toValuesTree)(this.contents[s],f=>console.error(f))})}}e.ConfigurationModel=E;class i{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,b){if(!h.isUndefinedOrNull(s)){const _=this.doParseContent(s);this.parseRaw(_,b)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,b){this._raw=s;const{contents:_,keys:f,overrides:w,restricted:P,hasExcludedProperties:m}=this.doParseRaw(s,b);this._configurationModel=new E(_,f,w,m?[s]:void 0),this._restrictedConfigurations=P||[]}doParseContent(s){let b={},_=null,f=[];const w=[],P=[];function m(y){Array.isArray(f)?f.push(y):_!==null&&(f[_]=y)}const v={onObjectBegin:()=>{const y={};m(y),w.push(f),f=y,_=null},onObjectProperty:y=>{_=y},onObjectEnd:()=>{f=w.pop()},onArrayBegin:()=>{const y=[];m(y),w.push(f),f=y,_=null},onArrayEnd:()=>{f=w.pop()},onLiteralValue:m,onError:(y,O,N)=>{P.push({error:y,offset:O,length:N})}};if(s)try{C.visit(s,v),b=f[0]||{}}catch(y){console.error(`Error while parsing settings file ${this._name}: ${y}`),this._parseErrors=[y]}return b}doParseRaw(s,b){const _=u.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),f=this.filter(s,_,!0,b);s=f.raw;const w=(0,R.toValuesTree)(s,v=>console.error(`Conflict in settings file ${this._name}: ${v}`)),P=Object.keys(s),m=this.toOverrides(s,v=>console.error(`Conflict in settings file ${this._name}: ${v}`));return{contents:w,keys:P,overrides:m,restricted:f.restricted,hasExcludedProperties:f.hasExcludedProperties}}filter(s,b,_,f){let w=!1;if(!f?.scopes&&!f?.skipRestricted&&!f?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:w};const P={},m=[];for(const v in s)if(D.OVERRIDE_PROPERTY_REGEX.test(v)&&_){const y=this.filter(s[v],b,!1,f);P[v]=y.raw,w=w||y.hasExcludedProperties,m.push(...y.restricted)}else{const y=b[v],O=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&m.push(v),!f.exclude?.includes(v)&&(f.include?.includes(v)||(O===void 0||f.scopes===void 0||f.scopes.includes(O))&&!(f.skipRestricted&&y?.restricted))?P[v]=s[v]:w=!0}return{raw:P,restricted:m,hasExcludedProperties:w}}toOverrides(s,b){const _=[];for(const f of Object.keys(s))if(D.OVERRIDE_PROPERTY_REGEX.test(f)){const w={};for(const P in s[f])w[P]=s[f][P];_.push({identifiers:(0,D.overrideIdentifiersFromKey)(f),keys:Object.keys(w),contents:(0,R.toValuesTree)(w,b)})}return _}}e.ConfigurationModelParser=i;class a extends A.Disposable{constructor(s,b,_,f){super(),this.userSettingsResource=s,this.parseOptions=b,this.fileService=f,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new i(this.userSettingsResource.toString()),this._register(this.fileService.watch(_.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.any(L.Event.filter(this.fileService.onDidFilesChange,w=>w.contains(this.userSettingsResource)),L.Event.filter(this.fileService.onDidRunOperation,w=>(w.isOperation(0)||w.isOperation(3)||w.isOperation(1)||w.isOperation(4))&&_.isEqual(w.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new E}}reparse(s){return s&&(this.parseOptions=s),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=a;class r{constructor(s,b,_,f,w,P,m,v,y,O,N,q,W){this.key=s,this.overrides=b,this._value=_,this.overrideIdentifiers=f,this.defaultConfiguration=w,this.policyConfiguration=P,this.applicationConfiguration=m,this.userConfiguration=v,this.localUserConfiguration=y,this.remoteUserConfiguration=O,this.workspaceConfiguration=N,this.folderConfigurationModel=q,this.memoryConfigurationModel=W}get value(){return p(this._value)}inspect(s,b,_){const f=s.inspect(b,_);return{get value(){return p(f.value)},get override(){return p(f.override)},get merged(){return p(f.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class n{constructor(s,b,_,f,w=new E,P=new E,m=new T.ResourceMap,v=new E,y=new T.ResourceMap){this._defaultConfiguration=s,this._policyConfiguration=b,this._applicationConfiguration=_,this._localUserConfiguration=f,this._remoteUserConfiguration=w,this._workspaceConfiguration=P,this._folderConfigurations=m,this._memoryConfiguration=v,this._memoryConfigurationByResource=y,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(s,b,_){return this.getConsolidatedConfigurationModel(s,b,_).getValue(s)}updateValue(s,b,_={}){let f;_.resource?(f=this._memoryConfigurationByResource.get(_.resource),f||(f=new E,this._memoryConfigurationByResource.set(_.resource,f))):f=this._memoryConfiguration,b===void 0?f.removeValue(s):f.setValue(s,b),_.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,b,_){const f=this.getConsolidatedConfigurationModel(s,b,_),w=this.getFolderConfigurationModelForResource(b.resource,_),P=b.resource?this._memoryConfigurationByResource.get(b.resource)||this._memoryConfiguration:this._memoryConfiguration,m=new Set;for(const v of f.overrides)for(const y of v.identifiers)f.getOverrideValue(s,y)!==void 0&&m.add(y);return new r(s,b,f.getValue(s),m.size?[...m]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,_?this._workspaceConfiguration:void 0,w||void 0,P)}keys(s){const b=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:b?b.keys.slice(0):[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(s){this._policyConfiguration=s}updateApplicationConfiguration(s){this._applicationConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,b){this._folderConfigurations.set(s,b),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,b){const _=[];if(!b){const{added:f,updated:w,removed:P}=l(this._defaultConfiguration,s);b=[...f,...w,...P]}for(const f of b)for(const w of(0,D.overrideIdentifiersFromKey)(f)){const P=this._defaultConfiguration.getKeysForOverrideIdentifier(w),m=s.getKeysForOverrideIdentifier(w),v=[...m.filter(y=>P.indexOf(y)===-1),...P.filter(y=>m.indexOf(y)===-1),...P.filter(y=>!g.equals(this._defaultConfiguration.override(w).getValue(y),s.override(w).getValue(y)))];_.push([w,v])}return this.updateDefaultConfiguration(s),{keys:b,overrides:_}}compareAndUpdatePolicyConfiguration(s){const{added:b,updated:_,removed:f}=l(this._policyConfiguration,s),w=[...b,..._,...f];return w.length&&this.updatePolicyConfiguration(s),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:b,updated:_,removed:f,overrides:w}=l(this.applicationConfiguration,s),P=[...b,..._,...f];return P.length&&this.updateApplicationConfiguration(s),{keys:P,overrides:w}}compareAndUpdateLocalUserConfiguration(s){const{added:b,updated:_,removed:f,overrides:w}=l(this.localUserConfiguration,s),P=[...b,..._,...f];return P.length&&this.updateLocalUserConfiguration(s),{keys:P,overrides:w}}compareAndUpdateRemoteUserConfiguration(s){const{added:b,updated:_,removed:f,overrides:w}=l(this.remoteUserConfiguration,s),P=[...b,..._,...f];return P.length&&this.updateRemoteUserConfiguration(s),{keys:P,overrides:w}}compareAndUpdateWorkspaceConfiguration(s){const{added:b,updated:_,removed:f,overrides:w}=l(this.workspaceConfiguration,s),P=[...b,..._,...f];return P.length&&this.updateWorkspaceConfiguration(s),{keys:P,overrides:w}}compareAndUpdateFolderConfiguration(s,b){const _=this.folderConfigurations.get(s),{added:f,updated:w,removed:P,overrides:m}=l(_,b),v=[...f,...w,...P];return(v.length||!_)&&this.updateFolderConfiguration(s,b),{keys:v,overrides:m}}compareAndDeleteFolderConfiguration(s){const b=this.folderConfigurations.get(s);if(!b)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:_,updated:f,removed:w,overrides:P}=l(b,void 0);return{keys:[..._,...f,...w],overrides:P}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(s,b,_){let f=this.getConsolidatedConfigurationModelForResource(b,_);return b.overrideIdentifier&&(f=f.override(b.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(s)!==void 0&&(f=f.merge(this._policyConfiguration)),f}getConsolidatedConfigurationModelForResource({resource:s},b){let _=this.getWorkspaceConsolidatedConfiguration();if(b&&s){const f=b.getFolder(s);f&&(_=this.getFolderConsolidatedConfiguration(f.uri)||_);const w=this._memoryConfigurationByResource.get(s);w&&(_=_.merge(w))}return _}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let b=this._foldersConsolidatedConfigurations.get(s);if(!b){const _=this.getWorkspaceConsolidatedConfiguration(),f=this._folderConfigurations.get(s);f?(b=_.merge(f),this._foldersConsolidatedConfigurations.set(s,b)):b=_}return b}getFolderConfigurationModelForResource(s,b){if(b&&s){const _=b.getFolder(s);if(_)return this._folderConfigurations.get(_.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,b)=>{const{contents:_,overrides:f,keys:w}=this._folderConfigurations.get(b);return s.push([b,{contents:_,overrides:f,keys:w}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.keys.forEach(b=>s.add(b)),this.userConfiguration.keys.forEach(b=>s.add(b)),this._workspaceConfiguration.keys.forEach(b=>s.add(b)),this._folderConfigurations.forEach(b=>b.keys.forEach(_=>s.add(_))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(b=>s.add(b)),this.userConfiguration.getAllOverrideIdentifiers().forEach(b=>s.add(b)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(b=>s.add(b)),this._folderConfigurations.forEach(b=>b.getAllOverrideIdentifiers().forEach(_=>s.add(_))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const b=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(_=>b.add(_)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(_=>b.add(_)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(_=>b.add(_)),this._folderConfigurations.forEach(_=>_.getKeysForOverrideIdentifier(s).forEach(f=>b.add(f))),[...b.values()]}static parse(s){const b=this.parseConfigurationModel(s.defaults),_=this.parseConfigurationModel(s.policy),f=this.parseConfigurationModel(s.application),w=this.parseConfigurationModel(s.user),P=this.parseConfigurationModel(s.workspace),m=s.folders.reduce((v,y)=>(v.set(S.URI.revive(y[0]),this.parseConfigurationModel(y[1])),v),new T.ResourceMap);return new n(b,_,f,w,new E,P,m,new E,new T.ResourceMap)}static parseConfigurationModel(s){return new E(s.contents,s.keys,s.overrides)}}e.Configuration=n;function o(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const s=new Set,b=new Map;for(const f of d)f.keys.forEach(w=>s.add(w)),f.overrides.forEach(([w,P])=>{const m=(0,T.getOrSet)(b,w,new Set);P.forEach(v=>m.add(v))});const _=[];return b.forEach((f,w)=>_.push([w,[...f.values()]])),{keys:[...s.values()],overrides:_}}e.mergeChanges=o;class c{constructor(s,b,_,f){this.change=s,this.previous=b,this.currentConfiguraiton=_,this.currentWorkspace=f,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const w of s.keys)this.affectedKeys.add(w);for(const[,w]of s.overrides)for(const P of w)this.affectedKeys.add(P);this._affectsConfigStr=this._marker;for(const w of this.affectedKeys)this._affectsConfigStr+=w+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=n.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,b){const _=this._marker+s,f=this._affectsConfigStr.indexOf(_);if(f<0)return!1;const w=f+_.length;if(w>=this._affectsConfigStr.length)return!1;const P=this._affectsConfigStr.charCodeAt(w);if(P!==this._markerCode1&&P!==this._markerCode2)return!1;if(b){const m=this.previousConfiguration?this.previousConfiguration.getValue(s,b,this.previous?.workspace):void 0,v=this.currentConfiguraiton.getValue(s,b,this.currentWorkspace);return!g.equals(m,v)}return!0}}e.ConfigurationChangeEvent=c;function l(d,s){const{added:b,removed:_,updated:f}=t(s?.rawConfiguration,d?.rawConfiguration),w=[],P=d?.getAllOverrideIdentifiers()||[],m=s?.getAllOverrideIdentifiers()||[];if(s){const v=m.filter(y=>!P.includes(y));for(const y of v)w.push([y,s.getKeysForOverrideIdentifier(y)])}if(d){const v=P.filter(y=>!m.includes(y));for(const y of v)w.push([y,d.getKeysForOverrideIdentifier(y)])}if(s&&d){for(const v of P)if(m.includes(v)){const y=t({contents:d.getOverrideValue(void 0,v)||{},keys:d.getKeysForOverrideIdentifier(v)},{contents:s.getOverrideValue(void 0,v)||{},keys:s.getKeysForOverrideIdentifier(v)});w.push([v,[...y.added,...y.removed,...y.updated]])}}return{added:b,removed:_,updated:f,overrides:w}}function t(d,s){const b=d?s?d.keys.filter(w=>s.keys.indexOf(w)===-1):[...d.keys]:[],_=s?d?s.keys.filter(w=>d.keys.indexOf(w)===-1):[...s.keys]:[],f=[];if(d&&s){for(const w of s.keys)if(d.keys.indexOf(w)!==-1){const P=(0,R.getConfigurationValue)(s.contents,w),m=(0,R.getConfigurationValue)(d.contents,w);g.equals(P,m)||f.push(w)}}return{added:b,removed:_,updated:f}}}),define(Pe[100],Te([1,0,15,4]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var C;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class A{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=A;class T{constructor(D,u){this.host=D,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=T;var g;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(g||(e.RemoteAuthorityResolverErrorCode=g={}));class h extends I.ErrorNoTelemetry{static isNotAvailable(D){return D instanceof h&&D._code===g.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof h&&D._code===g.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof h&&D._code===g.NoResolverFound}static isInvalidAuthority(D){return D instanceof h&&D._code===g.InvalidAuthority}static isHandled(D){return D instanceof h&&D.isHandled}constructor(D,u=g.Unknown,p){super(D),this._message=D,this._code=u,this._detail=p,this.isHandled=u===g.NotAvailable&&p===!0,Object.setPrototypeOf(this,h.prototype)}}e.RemoteAuthorityResolverError=h;function S(R){const D=R.indexOf("+");return D===-1?R:R.substring(0,D)}e.getRemoteAuthorityPrefix=S}),define(Pe[56],Te([1,0,11]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(S){return S.scheme===I.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=L;function C(S){if(!S)return;const R=S.indexOf("+");return R<0?S:S.substr(0,R)}e.getRemoteName=C;function A(S){return`/${S.quality??"oss"}-${S.commit??"dev"}`}e.getRemoteServerRootPath=A;function T(S){const{host:R,port:D}=h(S);if(typeof D>"u")throw new Error(`Invalid remote authority: ${S}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:R,port:D}}e.parseAuthorityWithPort=T;function g(S,R){let{host:D,port:u}=h(S);return typeof u>"u"&&(u=R),{host:D,port:u}}e.parseAuthorityWithOptionalPort=g;function h(S){const R=S.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const D=S.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const u=S.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:S,port:void 0}}}),define(Pe[22],Te([1,0,12,4,56]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(T||(e.ExtensionType=T={}));var g;(function(i){i.WIN32_X64="win32-x64",i.WIN32_ARM64="win32-arm64",i.LINUX_X64="linux-x64",i.LINUX_ARM64="linux-arm64",i.LINUX_ARMHF="linux-armhf",i.LINUX_PPC64LE="linux-ppc64le",i.ALPINE_X64="alpine-x64",i.ALPINE_ARM64="alpine-arm64",i.DARWIN_X64="darwin-x64",i.DARWIN_ARM64="darwin-arm64",i.WEB="web",i.UNIVERSAL="universal",i.UNKNOWN="unknown",i.UNDEFINED="undefined"})(g||(e.TargetPlatform=g={}));class h{constructor(a){this.value=a,this._lower=a.toLowerCase()}static equals(a,r){if(typeof a>"u"||a===null)return typeof r>"u"||r===null;if(typeof r>"u"||r===null)return!1;if(typeof a=="string"||typeof r=="string"){const n=typeof a=="string"?a:a.value,o=typeof r=="string"?r:r.value;return I.equalsIgnoreCase(n,o)}return a._lower===r._lower}static toKey(a){return typeof a=="string"?a.toLowerCase():a._lower}}e.ExtensionIdentifier=h;class S{get size(){return this._set.size}constructor(a){if(this._set=new Set,a)for(const r of a)this.add(r)}add(a){this._set.add(h.toKey(a))}delete(a){return this._set.delete(h.toKey(a))}has(a){return this._set.has(h.toKey(a))}}e.ExtensionIdentifierSet=S;class R{constructor(){this._map=new Map}clear(){this._map.clear()}delete(a){this._map.delete(h.toKey(a))}get(a){return this._map.get(h.toKey(a))}has(a){return this._map.has(h.toKey(a))}set(a,r){this._map.set(h.toKey(a),r)}values(){return this._map.values()}forEach(a){this._map.forEach(a)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=R;function D(i){return u(i)}e.isApplicationScopedExtension=D;function u(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=u;function p(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=p;function E(i,a){if(a){const r=`onResolveRemoteAuthority:${(0,C.getRemoteName)(a)}`;return!!i.activationEvents?.includes(r)}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(Pe[101],Te([1,0,15,22]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class C{constructor(){this._generators=new Map,this._cache=new WeakMap}register(T,g){this._generators.set(T,g)}readActivationEvents(T){return this._cache.has(T)||this._cache.set(T,this._readActivationEvents(T)),this._cache.get(T)}createActivationEventsMap(T){const g=Object.create(null);for(const h of T){const S=this.readActivationEvents(h);S.length>0&&(g[L.ExtensionIdentifier.toKey(h.identifier)]=S)}return g}_readActivationEvents(T){if(typeof T.main>"u"&&typeof T.browser>"u")return[];const g=Array.isArray(T.activationEvents)?T.activationEvents.slice(0):[];for(let h=0;h<g.length;h++)g[h]==="onUri"&&(g[h]=`onUri:${L.ExtensionIdentifier.toKey(T.identifier)}`);if(!T.contributes)return g;for(const h in T.contributes){const S=this._generators.get(h);if(!S)continue;const R=T.contributes[h],D=Array.isArray(R)?R:[R];try{S(D,g)}catch(u){(0,I.onUnexpectedError)(u)}}return g}}e.ImplicitActivationEventsImpl=C,e.ImplicitActivationEvents=new C}),define(Pe[190],Te([1,0,21,74,33]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(h){if(I.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function T(h,S,R,D,u,p,E,i,a){const r=Object.create(null);r["common.machineId"]=p,r["common.sqmId"]=E,r.sessionID=(0,C.generateUuid)()+Date.now(),r.commitHash=D,r.version=u,r["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),r["common.platform"]=(0,I.PlatformToString)(I.platform),r["common.nodePlatform"]=L.platform,r["common.nodeArch"]=R,r["common.product"]=a||"desktop",i&&(r["common.msftInternal"]=i);let n=0;const o=Date.now();Object.defineProperties(r,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),I.isLinuxSnap&&(r["common.snap"]="true");const c=A(S);return c&&(r["common.platformDetail"]=c),r}e.resolveCommonProperties=T;function g(h){const S=L.env.USERDNSDOMAIN;if(!S)return!1;const R=S.toLowerCase();return h.some(D=>R===D)}e.verifyMicrosoftInternalDomain=g}),define(Pe[191],Te([1,0,4]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,I.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,I.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var C;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Pe[57],Te([1,0,26,16,56,190,191]),function(me,e,I,L,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class g{constructor(d){this.value=d,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=g;class h{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=h,e.NullTelemetryService=new h;class S{async publicLog(d,s,b){}async publicLogError(d,s,b){}}e.NullEndpointTelemetryService=S,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function R(t,d){return!d.isBuilt&&!d.disableTelemetry?!0:!(d.disableTelemetry||!t.enableTelemetry)}e.supportsTelemetry=R;function D(t,d){return d.extensionTestsLocationURI?!0:!(d.isBuilt||d.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.isLoggingOnly=D;function u(t){const d=t.getValue(T.TELEMETRY_SETTING_ID),s=t.getValue(T.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(t.getValue(T.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(d??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=u;function p(t){const d={},s={},b={};a(t,b);for(let _ in b){_=_.length>150?_.substr(_.length-149):_;const f=b[_];typeof f=="number"?s[_]=f:typeof f=="boolean"?s[_]=f?1:0:typeof f=="string"?(f.length>8192&&console.warn(`Telemetry property: ${_} has been trimmed to 8192, the original length is ${f.length}`),d[_]=f.substring(0,8191)):typeof f<"u"&&f!==null&&(d[_]=f)}return{properties:d,measurements:s}}e.validateTelemetryData=p;const E=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function i(t){if(!t)return"none";const d=(0,C.getRemoteName)(t);return E.has(d)?d:"other"}e.cleanRemoteAuthority=i;function a(t,d,s=0,b){if(t)for(const _ of Object.getOwnPropertyNames(t)){const f=t[_],w=b?b+_:_;Array.isArray(f)?d[w]=(0,I.safeStringify)(f):f instanceof Date?d[w]=f.toISOString():(0,L.isObject)(f)?s<2?a(f,d,s+1,w+"."):d[w]=(0,I.safeStringify)(f):d[w]=f}}function r(t,d){const s=t.msftInternalDomains||[],b=d.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(s)||b}e.isInternalTelemetry=r;function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.getPiiPathsFromEnvironment=n;function o(t,d){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const b=[];for(const P of d)for(;;){const m=P.exec(t);if(!m)break;b.push([m.index,P.lastIndex])}const _=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(s="";;){const P=f.exec(t);if(!P)break;const m=b.some(([v,y])=>P.index<y&&v<f.lastIndex);!_.test(P[0])&&!m&&(s+=t.substring(w,P.index)+"<REDACTED: user-file-path>",w=f.lastIndex)}return w<t.length&&(s+=t.substr(w)),s}function c(t){if(!t)return t;const d=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of d)if(s.regex.test(t))return`<REDACTED: ${s.label}>`;return t}function l(t,d){return(0,I.cloneAndChange)(t,s=>{if(s instanceof g||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let b=s.replaceAll("%20"," ");b=o(b,d);for(const _ of d)b=b.replace(_,"");return b=c(b),b}})}e.cleanData=l}),define(Pe[192],Te([1,0,12,97,22,21,2,15,74,57]),function(me,e,I,L,C,A,T,g,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function R(s,b){return s.uuid&&b.uuid?s.uuid===b.uuid:s.id===b.id?!0:(0,I.compareIgnoreCase)(s.id,b.id)===0}e.areSameExtensions=R;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(b){const _=b.manifest?b.manifest.version:b.version,f=b.manifest?b.targetPlatform:b.properties.targetPlatform;return new u(b.identifier,_,f)}static parse(b){const _=D.exec(b);return _&&_[1]&&_[2]?new u({id:_[1]},_[2],_[4]||void 0):null}constructor(b,_,f="undefined"){this.version=_,this.targetPlatform=f,this.id=b.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(b){return b instanceof u?R(this,b)&&this.version===b.version&&this.targetPlatform===b.targetPlatform:!1}}e.ExtensionKey=u;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(s){const b=p.exec(s);return b&&b[1]?[a(b[1]),b[2]]:[a(s),void 0]}e.getIdAndVersion=E;function i(s,b){return`${s}.${b}`}e.getExtensionId=i;function a(s){return s.toLowerCase()}e.adoptToGalleryExtensionId=a;function r(s,b){return a(i(s??C.UNDEFINED_PUBLISHER,b))}e.getGalleryExtensionId=r;function n(s,b){const _=[],f=w=>{for(const P of _)if(P.some(m=>R(b(m),b(w))))return P;return null};for(const w of s){const P=f(w);P?P.push(w):_.push([w])}return _}e.groupByExtension=n;function o(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=o;function c(s){return{id:new S.TelemetryTrustedValue(s.identifier.id),name:new S.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=c,e.BetterMergeId=new C.ExtensionIdentifier("pprice.better-merge");function l(s,b){const _=[],f=b.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const w=f.shift();if(w&&_.every(P=>!R(P.identifier,{id:w}))){const P=s.filter(m=>R(m.identifier,{id:w}));P.length===1&&(_.push(P[0]),f.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return _}e.getExtensionDependencies=l;async function t(s,b){if(!A.isLinux)return!1;let _;try{_=(await s.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{_=(await s.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(w){b.debug("Error while getting the os-release file.",(0,g.getErrorMessage)(w))}}return!!_&&(_.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function d(s,b){const _=await t(s,b),f=(0,L.getTargetPlatform)(_?"alpine":A.platform,h.arch);return b.debug("ComputeTargetPlatform:",f),f}e.computeTargetPlatform=d}),define(Pe[193],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function I(h){return[...h.entries()]}e.serializeEnvironmentVariableCollection=I;function L(h){return h?[...h.entries()]:[]}e.serializeEnvironmentDescriptionMap=L;function C(h){return new Map(h)}e.deserializeEnvironmentVariableCollection=C;function A(h){return new Map(h??[])}e.deserializeEnvironmentDescriptionMap=A;function T(h){return Array.from(h.entries()).map(S=>[S[0],I(S[1].map),L(S[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=T;function g(h){return new Map(h.map(S=>[S[0],{map:C(S[1]),descriptionMap:A(S[2])}]))}e.deserializeEnvironmentVariableCollections=g}),define(Pe[194],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class I{constructor(C){this._callback=C,this._terminalBufferMap=new Map}dispose(){for(const C of this._terminalBufferMap.values())C.dispose()}startBuffering(C,A,T=5){const g=A(h=>{const S=typeof h=="string"?h:h.data;let R=this._terminalBufferMap.get(C);if(R){R.data.push(S);return}const D=setTimeout(()=>this.flushBuffer(C),T);R={data:[S],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(C),g.dispose()}},this._terminalBufferMap.set(C,R)});return g}stopBuffering(C){this._terminalBufferMap.get(C)?.dispose()}flushBuffer(C){const A=this._terminalBufferMap.get(C);A&&(this._terminalBufferMap.delete(C),this._callback(C,A.data.join("")))}}e.TerminalDataBufferer=I}),define(Pe[195],Te([1,0,13,90,40,5,16,2,155,73,30]),function(me,e,I,L,C,A,T,g,h,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var D;(function(c){function l(t,d){let s=t.defaults;for(;C.ThemeIcon.isThemeIcon(s);){const b=E.getIcon(s.id);if(!b)return;s=b.defaults}return s}c.getDefinition=l})(D||(e.IconContribution=D={}));var u;(function(c){function l(d){return{weight:d.weight,style:d.style,src:d.src.map(s=>({format:s.format,location:s.location.toString()}))}}c.toJSONObject=l;function t(d){const s=b=>(0,T.isString)(b)?b:void 0;if(d&&Array.isArray(d.src)&&d.src.every(b=>(0,T.isString)(b.format)&&(0,T.isString)(b.location)))return{weight:s(d.weight),style:s(d.style),src:d.src.map(b=>({format:b.format,location:g.URI.parse(b.location)}))}}c.fromJSONObject=t})(u||(e.IconFontDefinition=u={}));class p{constructor(){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,h.localize)(0,null)},fontCharacter:{type:"string",description:(0,h.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(l,t,d,s){const b=this.iconsById[l];if(b){if(d&&!b.description){b.description=d,this.iconSchema.properties[l].markdownDescription=`${d} $(${l})`;const w=this.iconReferenceSchema.enum.indexOf(l);w!==-1&&(this.iconReferenceSchema.enumDescriptions[w]=d),this._onDidChange.fire()}return b}const _={id:l,description:d,defaults:t,deprecationMessage:s};this.iconsById[l]=_;const f={$ref:"#/definitions/icons"};return s&&(f.deprecationMessage=s),d&&(f.markdownDescription=`${d}: $(${l})`),this.iconSchema.properties[l]=f,this.iconReferenceSchema.enum.push(l),this.iconReferenceSchema.enumDescriptions.push(d||""),this._onDidChange.fire(),{id:l}}deregisterIcon(l){delete this.iconsById[l],delete this.iconSchema.properties[l];const t=this.iconReferenceSchema.enum.indexOf(l);t!==-1&&(this.iconReferenceSchema.enum.splice(t,1),this.iconReferenceSchema.enumDescriptions.splice(t,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(l=>this.iconsById[l])}getIcon(l){return this.iconsById[l]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(l,t){const d=this.iconFontsById[l];return d||(this.iconFontsById[l]=t,this._onDidChange.fire(),t)}deregisterIconFont(l){delete this.iconFontsById[l]}getIconFont(l){return this.iconFontsById[l]}toString(){const l=(b,_)=>b.id.localeCompare(_.id),t=b=>{for(;C.ThemeIcon.isThemeIcon(b.defaults);)b=this.iconsById[b.defaults.id];return`codicon codicon-${b?b.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.iconsById).map(b=>this.iconsById[b]);for(const b of s.filter(_=>!!_.description).sort(l))d.push(`|<i class="${t(b)}"></i>|${b.id}|${C.ThemeIcon.isThemeIcon(b.defaults)?b.defaults.id:b.id}|${b.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const b of s.filter(_=>!C.ThemeIcon.isThemeIcon(_.defaults)).sort(l))d.push(`|<i class="${t(b)}"></i>|${b.id}|`);return d.join(`
`)}}const E=new p;R.Registry.add(e.Extensions.IconContribution,E);function i(c,l,t,d){return E.registerIcon(c,l,t,d)}e.registerIcon=i;function a(){return E}e.getIconRegistry=a;function r(){const c=(0,L.getCodiconFontCharacters)();for(const l in c){const t="\\"+c[l].toString(16);E.registerIcon(l,{fontCharacter:t})}}r(),e.iconsSchemaId="vscode://schemas/icons";const n=R.Registry.as(S.Extensions.JSONContribution);n.registerSchema(e.iconsSchemaId,E.getIconSchema());const o=new I.RunOnceScheduler(()=>n.notifySchemaChanged(e.iconsSchemaId),200);E.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.widgetClose=i("widget-close",L.Codicon.close,(0,h.localize)(2,null)),e.gotoPreviousLocation=i("goto-previous-location",L.Codicon.arrowUp,(0,h.localize)(3,null)),e.gotoNextLocation=i("goto-next-location",L.Codicon.arrowDown,(0,h.localize)(4,null)),e.syncing=C.ThemeIcon.modify(L.Codicon.sync,"spin"),e.spinningLoading=C.ThemeIcon.modify(L.Codicon.loading,"spin")}),define(Pe[196],Te([1,0,5,46,4,14]),function(me,e,I,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,C.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,C.createDecorator)("sharedTunnelsService");var T;(function(a){a.Http="http",a.Https="https"})(T||(e.TunnelProtocol=T={}));var g;(function(a){a.ConstantPrivate="constantPrivate",a.Private="private",a.Public="public"})(g||(e.TunnelPrivacyId=g={}));function h(a){return!!a.forwardPort}e.isTunnelProvider=h;var S;(function(a){a[a.Notify=1]="Notify",a[a.OpenBrowser=2]="OpenBrowser",a[a.OpenPreview=3]="OpenPreview",a[a.Silent=4]="Silent",a[a.Ignore=5]="Ignore",a[a.OpenBrowserOnce=6]="OpenBrowserOnce"})(S||(e.ProvidedOnAutoForward=S={}));function R(a){if(a.scheme!=="http"&&a.scheme!=="https")return;const r=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(a.authority);if(r)return{address:r[1],port:+r[2]}}e.extractLocalHostUriMetaDataForPortMapping=R,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(a){return e.LOCALHOST_ADDRESSES.indexOf(a)>=0}e.isLocalhost=D,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function u(a){return e.ALL_INTERFACES_ADDRESSES.indexOf(a)>=0}e.isAllInterfaces=u;function p(a,r,n,o){if(n===1)return!1;if(n===2&&u(r)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(o);if(c?.length===4&&parseInt(c[1])>=18)return!1}return a<1024}e.isPortPrivileged=p;class E{constructor(r,n,o){this.remoteAddress=r,this.localAddress=n,this._dispose=o,this._onDispose=new I.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=E;let i=class{constructor(r,n){this.logService=r,this.configurationService=n,this._onTunnelOpened=new I.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new I.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new I.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const r=this.configurationService.getValue("remote.localPortHost");return!r||r==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(r){return this._tunnelProvider=r,r?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(r){this._canElevate=r.elevation,this._privacyOptions=r.privacyOptions,this._canChangeProtocol=r.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const r=[],n=Array.from(this._tunnels.values());for(const o of n){const c=Array.from(o.values());for(const l of c){const t=await l.value;t&&typeof t!="string"&&r.push(t)}}return r}async dispose(){for(const r of this._tunnels.values()){for(const{value:n}of r.values())await n.then(o=>typeof o!="string"?o?.dispose():void 0);r.clear()}this._tunnels.clear()}setEnvironmentTunnel(r,n,o,c,l){this.addTunnelToMap(r,n,Promise.resolve({tunnelRemoteHost:r,tunnelRemotePort:n,localAddress:o,privacy:c,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(r,n){(u(r)||D(r))&&(r=e.LOCALHOST_ADDRESSES[0]);const o=this.getTunnelFromMap(r,n);if(o)return++o.refcount,o.value}openTunnel(r,n,o,c,l,t=!1,d,s){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${o} on local port ${l}.`);const b=this._tunnelProvider??r;if(!b)return;if(n||(n="localhost"),c||(c=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(o)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const _=this.retainOrCreateTunnel(b,n,o,c,l,t,d,s);return _?_.then(f=>{if(f){if(typeof f=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(n,o),f}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(n,o);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const w=this.makeTunnel(f);return(f.tunnelRemoteHost!==n||f.tunnelRemotePort!==o)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),d&&f.privacy!==d&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(w),w}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),_)}makeTunnel(r){return{tunnelRemotePort:r.tunnelRemotePort,tunnelRemoteHost:r.tunnelRemoteHost,tunnelLocalPort:r.tunnelLocalPort,localAddress:r.localAddress,privacy:r.privacy,protocol:r.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${r.tunnelRemoteHost}:${r.tunnelRemotePort} `);const n=this._tunnels.get(r.tunnelRemoteHost);if(n){const o=n.get(r.tunnelRemotePort);o&&(o.refcount--,await this.tryDisposeTunnel(r.tunnelRemoteHost,r.tunnelRemotePort,o))}}}}async tryDisposeTunnel(r,n,o){if(o.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${r}:${n}.`);const c=o.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this._onTunnelClosed.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this._tunnels.has(r)&&this._tunnels.get(r).delete(n),c}}async closeTunnel(r,n){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${r}:${n} `);const o=this._tunnels.get(r);if(o&&o.has(n)){const c=o.get(n);c.refcount=0,await this.tryDisposeTunnel(r,n,c)}}addTunnelToMap(r,n,o){this._tunnels.has(r)||this._tunnels.set(r,new Map),this._tunnels.get(r).set(n,{refcount:1,value:o})}async removeEmptyOrErrorTunnelFromMap(r,n){const o=this._tunnels.get(r);if(o){const c=o.get(n),l=c?await c.value:void 0;(!l||typeof l=="string")&&o.delete(n),o.size===0&&this._tunnels.delete(r)}}getTunnelFromMap(r,n){const o=[r];D(r)?(o.push(...e.LOCALHOST_ADDRESSES),o.push(...e.ALL_INTERFACES_ADDRESSES)):u(r)&&o.push(...e.ALL_INTERFACES_ADDRESSES);const c=o.map(l=>this._tunnels.get(l));for(const l of c){const t=l?.get(n);if(t)return t}}canTunnel(r){return!!R(r)}createWithProvider(r,n,o,c,l,t,d){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${o} on local port ${c}.`);const s=o;this._factoryInProgress.add(s);const b=c===void 0?o:c,_={elevationRequired:l?this.isPortPrivileged(b):!1},f={remoteAddress:{host:n,port:o},localAddressPort:c,privacy:t,public:t?t!==g.Private:void 0,protocol:d},w=r.forwardPort(f,_);return w?(this.addTunnelToMap(n,o,w),w.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),w}};e.AbstractTunnelService=i,e.AbstractTunnelService=i=Ke([We(0,A.ILogService),We(1,L.IConfigurationService)],i)}),define(Pe[197],Te([1,0,4]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,I.createDecorator)("editSessionIdentityService");var L;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(L||(e.EditSessionIdentityMatch=L={}))}),define(Pe[198],Te([1,0,11]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function L(h){return h.scheme!==I.Schemas.file&&h.scheme!==I.Schemas.vscodeRemote}e.isVirtualResource=L;function C(h){if(h.folders.length)return h.folders.every(S=>L(S.uri))?h.folders[0].uri:void 0;if(h.configuration&&L(h.configuration))return h.configuration}e.getVirtualWorkspaceLocation=C;function A(h){return C(h)?.scheme}e.getVirtualWorkspaceScheme=A;function T(h){return C(h)?.authority}e.getVirtualWorkspaceAuthority=T;function g(h){return C(h)!==void 0}e.isVirtualWorkspace=g}),define(Pe[47],Te([1,0,156,19,50,25,2,4,11]),function(me,e,I,L,C,A,T,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,g.createDecorator)("contextService");function S(b){const _=b;return typeof _?.id=="string"&&T.URI.isUri(_.uri)}e.isSingleFolderWorkspaceIdentifier=S;function R(b){return typeof b?.id=="string"&&!S(b)&&!u(b)}e.isEmptyWorkspaceIdentifier=R,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function D(b,_){if(typeof b=="string"||typeof b>"u")return typeof b=="string"?{id:(0,L.basename)(b)}:_?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const f=b;return f.configuration?{id:f.id,configPath:f.configuration}:f.folders.length===1?{id:f.id,uri:f.folders[0].uri}:{id:f.id}}e.toWorkspaceIdentifier=D;function u(b){const _=b;return typeof _?.id=="string"&&T.URI.isUri(_.configPath)}e.isWorkspaceIdentifier=u;function p(b){const _=b;if(_?.uri)return{id:_.id,uri:T.URI.revive(_.uri)};const f=b;if(f?.configPath)return{id:f.id,configPath:T.URI.revive(f.configPath)};if(b?.id)return{id:b.id}}e.reviveIdentifier=p;var E;(function(b){b[b.EMPTY=1]="EMPTY",b[b.FOLDER=2]="FOLDER",b[b.WORKSPACE=3]="WORKSPACE"})(E||(e.WorkbenchState=E={}));function i(b){const _=b;return!!(_&&typeof _=="object"&&typeof _.id=="string"&&Array.isArray(_.folders))}e.isWorkspace=i;function a(b){const _=b;return!!(_&&typeof _=="object"&&T.URI.isUri(_.uri)&&typeof _.name=="string"&&typeof _.toResource=="function")}e.isWorkspaceFolder=a;class r{constructor(_,f,w,P,m){this._id=_,this._transient=w,this._configuration=P,this._ignorePathCasing=m,this._foldersMap=C.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=f}update(_){this._id=_.id,this._configuration=_.configuration,this._transient=_.transient,this._ignorePathCasing=_._ignorePathCasing,this.folders=_.folders}get folders(){return this._folders}set folders(_){this._folders=_,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(_){this._configuration=_}getFolder(_){return _&&this._foldersMap.findSubstr(_)||null}updateFoldersMap(){this._foldersMap=C.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const _ of this.folders)this._foldersMap.set(_.uri,_)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=r;class n{constructor(_,f){this.raw=f,this.uri=_.uri,this.index=_.index,this.name=_.name}toResource(_){return(0,A.joinPath)(this.uri,_)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function o(b){return new n({uri:b,index:0,name:(0,A.basenameOrAuthority)(b)},{uri:b.toString()})}e.toWorkspaceFolder=o,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function c(b,_){return A.extUriBiasedIgnorePathCase.isEqualOrParent(b,_.untitledWorkspacesHome)}e.isUntitledWorkspace=c;function l(b){let _;return T.URI.isUri(b)?_=b:_=b.configuration,_?.scheme===h.Schemas.tmp}e.isTemporaryWorkspace=l,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(b){return b.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function d(b,_){return!c(b,_)&&!l(b)}e.isSavedWorkspace=d;function s(b){return(typeof b=="string"?(0,L.extname)(b):(0,A.extname)(b))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(Pe[75],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class I{static{this.enableDebugLogging=!1}constructor(C){this.id=C,this._data=new Map,this._idPool=1}add(C){const A=this._idPool++;return this._data.set(A,C),this.logDebugInfo(),A}get(C,A){return this._data.has(C)?this._data.get(C)[A]:void 0}delete(C){this._data.delete(C),this.logDebugInfo()}logDebugInfo(){I.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=I}),define(Pe[43],Te([1,0,11,25,4]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(I.Schemas)),this._providerInfo=new Map,this.extUri=new L.ExtUri(g=>{const h=this._providerInfo.get(g.scheme);return!(h===void 0||h&1024)})}$acceptProviderInfos(g,h){h===null?this._providerInfo.delete(g.scheme):this._providerInfo.set(g.scheme,h)}isFreeScheme(g){return!this._providerInfo.has(g)&&!this._systemSchemes.has(g)}getCapabilities(g){return this._providerInfo.get(g)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,C.createDecorator)("IExtHostFileSystemInfo")}),define(Pe[27],Te([1,0,4]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,I.createDecorator)("IExtHostInitDataService")}),define(Pe[199],Te([1,0,161,14,186,27]),function(me,e,I,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let T=class extends C.LogService{constructor(h,S,R){const D=R.remote.isRemote?"remoteexthost":h?"workerexthost":"exthost",u=R.remote.isRemote?(0,I.localize)(0,null):h?(0,I.localize)(1,null):(0,I.localize)(2,null);super(S.createLogger(D,{name:u}))}};e.ExtHostLogService=T,e.ExtHostLogService=T=Ke([We(1,L.ILoggerService),We(2,A.IExtHostInitDataService)],T)}),define(Pe[200],Te([1,0,13]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(T,g,h){this._deferredPromises=new Map,this._id=T,this._shared=g,this._storage=h,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(S=>(this._value=S,this)),this._storageListener=this._storage.onDidChangeStorage(S=>{S.shared===this._shared&&S.key===this._id&&(this._value=S.value)}),this._scheduler=new I.RunOnceScheduler(()=>{const S=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of S.values())R.complete()}catch(R){for(const D of S.values())D.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,g){let h=this._value[T];return typeof h>"u"&&(h=g),h}update(T,g){this._value[T]=g;const h=this._deferredPromises.get(T);if(h!==void 0)return h.p;const S=new I.DeferredPromise;return this._deferredPromises.set(T,S),this._scheduler.isScheduled()||this._scheduler.schedule(),S.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class C extends L{setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}constructor(T,g){super(T.identifier.value,!0,g),this._extension=T}}e.ExtensionGlobalMemento=C}),define(Pe[201],Te([1,0,5,2]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class C{constructor(T){this._notebooksAndEditors=T,this._onDidSaveNotebookDocument=new I.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new I.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(T,g,h,S){const D=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(T)).acceptModelChanged(g.value,h,S);this._onDidChangeNotebookDocument.fire(D)}$acceptDirtyStateChanged(T,g){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(T)).acceptDirty(g)}$acceptModelSaved(T){const g=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(T));this._onDidSaveNotebookDocument.fire(g.apiNotebook)}}e.ExtHostNotebookDocuments=C}),define(Pe[17],Te([1,0,4]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,I.createDecorator)("IExtHostRpcService");class L{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=L}),define(Pe[202],Te([1,0,22,5]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class C{#e;constructor(T,g){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=I.ExtensionIdentifier.toKey(T.identifier),this.#e=g,this.#e.onDidChangePassword(h=>{h.extensionId===this._id&&this._onDidChange.fire({key:h.key})})}get(T){return this.#e.get(this._id,T)}store(T,g){return this.#e.store(this._id,T,g)}delete(T){return this.#e.delete(this._id,T)}}e.ExtensionSecrets=C}),define(Pe[58],Te([1,0,4]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,I.createDecorator)("IURITransformerService");class L{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=L}),define(Pe[203],Te([1,0,23]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(h){let S=this.buffers.indexOf(h);return S<0&&(S=this.buffers.length,this.buffers.push(h)),S}}function C(g,h){if(h.serializeBuffersForPostMessage){const S=new L,D=JSON.stringify(g,(p,E)=>{if(E instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:S.add(E)};if(ArrayBuffer.isView(E)){const i=A(E);if(i)return{$$vscode_array_buffer_reference$$:!0,index:S.add(E.buffer),view:{type:i,byteLength:E.byteLength,byteOffset:E.byteOffset}}}return E}),u=S.buffers.map(p=>{const E=new Uint8Array(p);return I.VSBuffer.wrap(E)});return{message:D,buffers:u}}else return{message:JSON.stringify(g),buffers:[]}}e.serializeWebviewMessage=C;function A(g){switch(g.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(g,h){const S=h.map(u=>{const p=new ArrayBuffer(u.byteLength);return new Uint8Array(p).set(u.buffer),p}),R=h.length?(u,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const E=p,{index:i}=E,a=S[i];if(E.view)switch(E.view.type){case 1:return new Int8Array(a,E.view.byteOffset,E.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(a,E.view.byteOffset,E.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(a,E.view.byteOffset,E.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(a,E.view.byteOffset,E.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(a,E.view.byteOffset,E.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(a,E.view.byteOffset,E.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(a,E.view.byteOffset,E.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(a,E.view.byteOffset,E.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(a,E.view.byteOffset,E.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(a,E.view.byteOffset,E.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(a,E.view.byteOffset,E.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return a}return p}:void 0;return{message:JSON.parse(g,R),arrayBuffers:S}}e.deserializeWebviewMessage=T}),define(Pe[102],Te([1,0,170,16,2,6,4,30,42,11,41,134,32]),function(me,e,I,L,C,A,T,g,h,S,R,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.preventEditorClose=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffListEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var p;(function(re){re[re.PROGRAMMATIC=1]="PROGRAMMATIC",re[re.USER=2]="USER",re[re.EDIT=3]="EDIT",re[re.NAVIGATION=4]="NAVIGATION",re[re.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var E;(function(re){re[re.IDENTICAL=1]="IDENTICAL",re[re.SIMILAR=2]="SIMILAR",re[re.DIFFERENT=3]="DIFFERENT"})(E||(e.EditorPaneSelectionCompareResult=E={}));function i(re){const J=re;return!!J&&typeof J.getSelection=="function"&&!!J.onDidChangeSelection}e.isEditorPaneWithSelection=i;function a(re,J,H){for(const ne of H.visibleEditorPanes)if(ne.group.id===J&&re.matches(ne.input))return ne.getViewState()}e.findViewStateForEditor=a;function r(re){if(w(re))return!1;const J=re;return C.URI.isUri(J?.resource)}e.isResourceEditorInput=r;function n(re){if(w(re))return!1;const J=re;return J?.original!==void 0&&J.modified!==void 0}e.isResourceDiffEditorInput=n;function o(re){if(w(re))return!1;const J=re;return!J||J.resources&&!Array.isArray(J.resources)?!1:!!J.resources||!!J.multiDiffSource}e.isResourceDiffListEditorInput=o;function c(re){if(w(re)||n(re))return!1;const J=re;return J?.primary!==void 0&&J.secondary!==void 0}e.isResourceSideBySideEditorInput=c;function l(re){if(w(re))return!1;const J=re;return J?J.resource===void 0||J.resource.scheme===S.Schemas.untitled||J.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=l;function t(re){if(w(re))return!1;const J=re;return C.URI.isUri(J?.base?.resource)&&C.URI.isUri(J?.input1?.resource)&&C.URI.isUri(J?.input2?.resource)&&C.URI.isUri(J?.result?.resource)}e.isResourceMergeEditorInput=t;var d;(function(re){re[re.SHORT=0]="SHORT",re[re.MEDIUM=1]="MEDIUM",re[re.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var s;(function(re){re[re.EXPLICIT=1]="EXPLICIT",re[re.AUTO=2]="AUTO",re[re.FOCUS_CHANGE=3]="FOCUS_CHANGE",re[re.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class b{constructor(){this.mapIdToSaveSource=new Map}registerSource(J,H){let ne=this.mapIdToSaveSource.get(J);return ne||(ne={source:J,label:H},this.mapIdToSaveSource.set(J,ne)),ne.source}getSourceLabel(J){return this.mapIdToSaveSource.get(J)?.label??J}}e.SaveSourceRegistry=new b;var _;(function(re){re[re.None=0]="None",re[re.Readonly=2]="Readonly",re[re.Untitled=4]="Untitled",re[re.Singleton=8]="Singleton",re[re.RequiresTrust=16]="RequiresTrust",re[re.CanSplitInGroup=32]="CanSplitInGroup",re[re.ForceDescription=64]="ForceDescription",re[re.CanDropIntoEditor=128]="CanDropIntoEditor",re[re.MultipleEditors=256]="MultipleEditors",re[re.Scratchpad=512]="Scratchpad",re[re.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(_||(e.EditorInputCapabilities=_={}));class f extends A.Disposable{}e.AbstractEditorInput=f;function w(re){return re instanceof f}e.isEditorInput=w;function P(re){const J=re;return C.URI.isUri(J?.preferredResource)}function m(re){const J=re;return w(J?.primary)&&w(J?.secondary)}e.isSideBySideEditorInput=m;function v(re){const J=re;return w(J?.modified)&&w(J?.original)}e.isDiffEditorInput=v;function y(re,J,H,ne,Ae){return pe(ne,[(0,D.toAction)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const Re={...H,limits:{size:Number.MAX_VALUE}};re.openEditor(J,Re)}}),(0,D.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>Ae.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}e.createTooLargeFileError=y;function O(re){return w(re?.editor)}e.isEditorInputWithOptions=O;function N(re){const J=re;return O(re)&&J?.group!==void 0}e.isEditorInputWithOptionsAndGroup=N;function q(re){const J=re;return typeof J?.groupId=="number"&&w(J.editor)}e.isEditorIdentifier=q;var W;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.REPLACE=1]="REPLACE",re[re.MOVE=2]="MOVE",re[re.UNPIN=3]="UNPIN"})(W||(e.EditorCloseContext=W={}));var x;(function(re){re[re.GROUP_ACTIVE=0]="GROUP_ACTIVE",re[re.GROUP_INDEX=1]="GROUP_INDEX",re[re.GROUP_LABEL=2]="GROUP_LABEL",re[re.GROUP_LOCKED=3]="GROUP_LOCKED",re[re.EDITOR_OPEN=4]="EDITOR_OPEN",re[re.EDITOR_CLOSE=5]="EDITOR_CLOSE",re[re.EDITOR_MOVE=6]="EDITOR_MOVE",re[re.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",re[re.EDITOR_LABEL=8]="EDITOR_LABEL",re[re.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",re[re.EDITOR_PIN=10]="EDITOR_PIN",re[re.EDITOR_STICKY=11]="EDITOR_STICKY",re[re.EDITOR_DIRTY=12]="EDITOR_DIRTY",re[re.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(x||(e.GroupModelChangeKind=x={}));var k;(function(re){re[re.PRIMARY=1]="PRIMARY",re[re.SECONDARY=2]="SECONDARY",re[re.BOTH=3]="BOTH",re[re.ANY=4]="ANY"})(k||(e.SideBySideEditor=k={}));class M{getOriginalUri(J,H){if(!J)return;if(t(J))return e.EditorResourceAccessor.getOriginalUri(J.result,H);if(H?.supportSideBySide){const{primary:Ae,secondary:Re}=this.getSideEditors(J);if(Ae&&Re){if(H?.supportSideBySide===k.BOTH)return{primary:this.getOriginalUri(Ae,{filterByScheme:H.filterByScheme}),secondary:this.getOriginalUri(Re,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===k.ANY)return this.getOriginalUri(Ae,{filterByScheme:H.filterByScheme})??this.getOriginalUri(Re,{filterByScheme:H.filterByScheme});J=H.supportSideBySide===k.PRIMARY?Ae:Re}}if(n(J)||o(J)||c(J)||t(J))return;const ne=P(J)?J.preferredResource:J.resource;return!ne||!H||!H.filterByScheme?ne:this.filterUri(ne,H.filterByScheme)}getSideEditors(J){return m(J)||c(J)?{primary:J.primary,secondary:J.secondary}:v(J)||n(J)?{primary:J.modified,secondary:J.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(J,H){if(!J)return;if(t(J))return e.EditorResourceAccessor.getCanonicalUri(J.result,H);if(H?.supportSideBySide){const{primary:Ae,secondary:Re}=this.getSideEditors(J);if(Ae&&Re){if(H?.supportSideBySide===k.BOTH)return{primary:this.getCanonicalUri(Ae,{filterByScheme:H.filterByScheme}),secondary:this.getCanonicalUri(Re,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===k.ANY)return this.getCanonicalUri(Ae,{filterByScheme:H.filterByScheme})??this.getCanonicalUri(Re,{filterByScheme:H.filterByScheme});J=H.supportSideBySide===k.PRIMARY?Ae:Re}}if(n(J)||o(J)||c(J)||t(J))return;const ne=J.resource;return!ne||!H||!H.filterByScheme?ne:this.filterUri(ne,H.filterByScheme)}filterUri(J,H){if(Array.isArray(H)){if(H.some(ne=>J.scheme===ne))return J}else if(H===J.scheme)return J}}var $;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.KEYBOARD=1]="KEYBOARD",re[re.MOUSE=2]="MOUSE"})($||(e.EditorCloseMethod=$={}));function oe(re,J,H,ne){if(!re.isSticky(J))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return H===$.MOUSE||H===$.KEYBOARD;case"mouse":return H===$.MOUSE;case"keyboard":return H===$.KEYBOARD}return!1}e.preventEditorClose=oe,e.EditorResourceAccessor=new M;var de;(function(re){re[re.LEFT=0]="LEFT",re[re.RIGHT=1]="RIGHT"})(de||(e.CloseDirection=de={}));class we{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(J){const H=this.instantiationService=J.get(T.IInstantiationService);for(const[ne,Ae]of this.editorSerializerConstructors)this.createEditorSerializer(ne,Ae,H);this.editorSerializerConstructors.clear()}createEditorSerializer(J,H,ne){const Ae=ne.createInstance(H);this.editorSerializerInstances.set(J,Ae)}registerFileEditorFactory(J){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=J}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(J,H){if(this.editorSerializerConstructors.has(J)||this.editorSerializerInstances.has(J))throw new Error(`A editor serializer with type ID '${J}' was already registered.`);return this.instantiationService?this.createEditorSerializer(J,H,this.instantiationService):this.editorSerializerConstructors.set(J,H),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(J),this.editorSerializerInstances.delete(J)})}getEditorSerializer(J){return this.editorSerializerInstances.get(typeof J=="string"?J:J.typeId)}}g.Registry.add(e.EditorExtensions.EditorFactory,new we);async function ye(re,J,H){return!re||!re.length?[]:await Promise.all(re.map(async ne=>{const Ae=C.URI.revive(ne.fileUri);if(!Ae){H.info("Cannot resolve the path because it is not valid.",ne);return}if(!await J.canHandleResource(Ae)){H.info("Cannot resolve the path because it cannot be handled",ne);return}let ke=ne.exists,ce=ne.type;if(typeof ke!="boolean"||typeof ce!="number")try{ce=(await J.stat(Ae)).isDirectory?h.FileType.Directory:h.FileType.Unknown,ke=!0}catch(K){H.error(K),ke=!1}if(!ke&&ne.openOnlyIfExists){H.info("Cannot resolve the path because it does not exist",ne);return}if(ce===h.FileType.Directory){H.info("Cannot resolve the path because it is a directory",ne);return}const te={...ne.options,pinned:!0};return ke?{resource:Ae,options:te}:{resource:Ae,options:te,forceUntitled:!0}}))}e.pathsToEditors=ye;var le;(function(re){re[re.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",re[re.SEQUENTIAL=1]="SEQUENTIAL"})(le||(e.EditorsOrder=le={}));function ve(re){const J=re;if(!J)return!1;const H=J;if(H.modified)return ve(H.modified);const ne=J;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.isTextEditorViewState=ve;function ae(re){return(0,R.isErrorWithActions)(re)}e.isEditorOpenError=ae;function pe(re,J,H){const ne=(0,R.createErrorWithActions)(re,J);return ne.forceMessage=H?.forceMessage,ne.forceSeverity=H?.forceSeverity,ne.allowDialog=H?.allowDialog,ne}e.createEditorOpenError=pe}),define(Pe[204],Te([1,0,5,171,4,6,28,30,18,26,90,195]),function(me,e,I,L,C,A,T,g,h,S,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=e.VIEWS_LOG_NAME=e.VIEWS_LOG_ID=void 0,e.VIEWS_LOG_ID="views",e.VIEWS_LOG_NAME=(0,L.localize)(0,null),e.defaultViewIcon=(0,D.registerIcon)("default-view-icon",R.Codicon.window,(0,L.localize)(1,null));var u;(function(d){d.ViewContainersRegistry="workbench.registry.view.containers",d.ViewsRegistry="workbench.registry.view"})(u||(e.Extensions=u={}));var p;(function(d){d[d.Sidebar=0]="Sidebar",d[d.Panel=1]="Panel",d[d.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.ViewContainerLocations=[0,1,2];function E(d){switch(d){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=E;class i extends A.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new I.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new I.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,h.flatten)([...this.viewContainers.values()])}registerViewContainer(s,b,_){const f=this.get(s.id);if(f)return f;const w=s;return w.openCommandActionDescriptor=_?.doNotRegisterOpenCommand?void 0:w.openCommandActionDescriptor??{id:w.id},(0,T.getOrSet)(this.viewContainers,b,[]).push(w),_?.isDefault&&this.defaultViewContainers.push(w),this._onDidRegister.fire({viewContainer:w,viewContainerLocation:b}),w}deregisterViewContainer(s){for(const b of this.viewContainers.keys()){const _=this.viewContainers.get(b),f=_?.indexOf(s);if(f!==-1){_?.splice(f,1),_.length===0&&this.viewContainers.delete(b),this._onDidDeregister.fire({viewContainer:s,viewContainerLocation:b});return}}}get(s){return this.all.filter(b=>b.id===s)[0]}getViewContainers(s){return[...this.viewContainers.get(s)||[]]}getViewContainerLocation(s){return[...this.viewContainers.keys()].filter(b=>this.getViewContainers(b).filter(_=>_?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.defaultViewContainers.find(b=>this.getViewContainerLocation(b)===s)}}g.Registry.add(u.ViewContainersRegistry,new i);var a;(function(d){d.Open="2_open",d.Debug="4_debug",d.SCM="5_scm",d.More="9_more"})(a||(e.ViewContentGroups=a={}));function r(d,s){const b=d.group??a.More,_=s.group??a.More;return b!==_?b.localeCompare(_):(d.order??5)-(s.order??5)}class n extends A.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new I.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new I.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new I.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new I.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new T.SetMap}registerViews(s,b){this.registerViews2([{views:s,viewContainer:b}])}registerViews2(s){s.forEach(({views:b,viewContainer:_})=>this.addViews(b,_)),this._onViewsRegistered.fire(s)}deregisterViews(s,b){const _=this.removeViews(s,b);_.length&&this._onViewsDeregistered.fire({views:_,viewContainer:b})}moveViews(s,b){for(const _ of this._views.keys())if(_!==b){const f=this.removeViews(s,_);f.length&&(this.addViews(f,b),this._onDidChangeContainer.fire({views:f,from:_,to:b}))}}getViews(s){return this._views.get(s)||[]}getView(s){for(const b of this._viewContainers){const _=(this._views.get(b)||[]).filter(f=>f.id===s)[0];if(_)return _}return null}getViewContainer(s){for(const b of this._viewContainers)if((this._views.get(b)||[]).filter(f=>f.id===s)[0])return b;return null}registerViewWelcomeContent(s,b){return this._viewWelcomeContents.add(s,b),this._onDidChangeViewWelcomeContent.fire(s),(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(s,b),this._onDidChangeViewWelcomeContent.fire(s)})}registerViewWelcomeContent2(s,b){const _=new Map;for(const[f,w]of b)this._viewWelcomeContents.add(s,w),_.set(f,(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(s,w),this._onDidChangeViewWelcomeContent.fire(s)}));return this._onDidChangeViewWelcomeContent.fire(s),_}getViewWelcomeContent(s){const b=[];return this._viewWelcomeContents.forEach(s,_=>b.push(_)),b.sort(r)}addViews(s,b){let _=this._views.get(b);_||(_=[],this._views.set(b,_),this._viewContainers.push(b));for(const f of s){if(this.getView(f.id)!==null)throw new Error((0,L.localize)(2,null,f.id));_.push(f)}}removeViews(s,b){const _=this._views.get(b);if(!_)return[];const f=[],w=[];for(const P of _)s.includes(P)?f.push(P):w.push(P);return f.length&&(w.length?this._views.set(b,w):(this._views.delete(b),this._viewContainers.splice(this._viewContainers.indexOf(b),1))),f}}g.Registry.add(u.ViewsRegistry,new n),e.IViewDescriptorService=(0,C.createDecorator)("viewDescriptorService");var o;(function(d){d[d.Default=0]="Default",d[d.Expand=1]="Expand"})(o||(e.ViewVisibilityState=o={}));var c;(function(d){d[d.None=0]="None",d[d.Collapsed=1]="Collapsed",d[d.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class l{constructor(s,b){this.resolved=!1,this._hasResolve=!1,(0,S.mixin)(this,s),this._hasResolve=!!b,this.resolve=async _=>{if(b&&!this.resolved){const f=await b(_);f&&(this.tooltip=this.tooltip??f.tooltip,this.command=this.command??f.command)}_.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=l;class t extends Error{constructor(s){super((0,L.localize)(3,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.NoTreeViewError=t}),define(Pe[205],Te([1,0,2,29,4]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KEYWORD_ACTIVIATION_SETTING_ID=e.IChatService=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.isIUsedContext=e.isIDocumentContext=void 0;function A(S){return!!S&&typeof S=="object"&&"uri"in S&&S.uri instanceof I.URI&&"version"in S&&typeof S.version=="number"&&"ranges"in S&&Array.isArray(S.ranges)&&S.ranges.every(L.Range.isIRange)}e.isIDocumentContext=A;function T(S){return!!S&&typeof S=="object"&&"documents"in S&&Array.isArray(S.documents)&&S.documents.every(A)}e.isIUsedContext=T;var g;(function(S){S[S.Down=0]="Down",S[S.Up=1]="Up"})(g||(e.InteractiveSessionVoteDirection=g={}));var h;(function(S){S[S.Action=1]="Action",S[S.Toolbar=2]="Toolbar"})(h||(e.ChatAgentCopyKind=h={})),e.IChatService=(0,C.createDecorator)("IChatService"),e.KEYWORD_ACTIVIATION_SETTING_ID="accessibility.voice.keywordActivation"}),define(Pe[206],Te([1,0,5,13,172]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new I.Emitter,this._onExit=new I.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(g){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=g}onEvent(g){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=g}onRequest(g){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=g}sendResponse(g){g.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${g.command}`)):this.internalSend("response",g)}sendRequest(g,h,S,R){const D={command:g};if(h&&Object.keys(h).length>0&&(D.arguments=h),this.internalSend("request",D),typeof R=="number"){const u=setTimeout(()=>{clearTimeout(u);const p=this.pendingRequests.get(D.seq);if(p){this.pendingRequests.delete(D.seq);const E={type:"response",seq:0,request_seq:D.seq,success:!1,command:g,message:(0,C.localize)(0,null,R,g)};p(E)}},R)}return S&&this.pendingRequests.set(D.seq,S),D.seq}acceptMessage(g){this.messageCallback?this.messageCallback(g):(this.queue.push(g),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(g,h){return g.type!=="event"||h.type!=="event"}async processQueue(){let g;for(;this.queue.length;){if((!g||this.needsTaskBoundaryBetween(this.queue[0],g))&&await(0,L.timeout)(0),g=this.queue.shift(),!g)return;switch(g.type){case"event":this.eventCallback?.(g);break;case"request":this.requestCallback?.(g);break;case"response":{const h=g,S=this.pendingRequests.get(h.request_seq);S&&(this.pendingRequests.delete(h.request_seq),S(h));break}}}}internalSend(g,h){h.type=g,h.seq=this.sequence++,this.sendMessage(h)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const g=new Map;this.pendingRequests.forEach((h,S)=>g.set(S,h)),await(0,L.timeout)(500),g.forEach((h,S)=>{h({type:"response",seq:0,request_seq:S,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(S)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(Pe[207],Te([1,0,2,173,35,4]),function(me,e,I,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.DebugVisualizationType=e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_NAME=e.CONTEXT_VARIABLE_TYPE=e.CONTEXT_VARIABLE_VALUE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new C.RawContextKey("debugType",void 0,{type:"string",description:L.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new C.RawContextKey("debugConfigurationType",void 0,{type:"string",description:L.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new C.RawContextKey("debugState","inactive",{type:"string",description:L.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new C.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:L.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new C.RawContextKey("hasDebugged",!1,{type:"boolean",description:L.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new C.RawContextKey("inDebugMode",!1,{type:"boolean",description:L.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new C.RawContextKey("inDebugRepl",!1,{type:"boolean",description:L.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new C.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:L.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new C.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:L.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new C.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:L.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new C.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:L.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new C.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:L.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new C.RawContextKey("variablesFocused",!0,{type:"boolean",description:L.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new C.RawContextKey("expressionSelected",!1,{type:"boolean",description:L.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new C.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:L.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new C.RawContextKey("callStackItemType",void 0,{type:"string",description:L.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new C.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:L.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new C.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:L.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new C.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:L.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new C.RawContextKey("watchItemType",void 0,{type:"string",description:L.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new C.RawContextKey("canViewMemory",void 0,{type:"boolean",description:L.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new C.RawContextKey("breakpointItemType",void 0,{type:"string",description:L.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new C.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:L.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new C.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:L.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new C.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:L.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new C.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:L.localize(25,null)}),e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=new C.RawContextKey("focusedSessionIsNoDebug",!1,{type:"boolean",description:L.localize(26,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new C.RawContextKey("stepBackSupported",!1,{type:"boolean",description:L.localize(27,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new C.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:L.localize(28,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new C.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:L.localize(29,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new C.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:L.localize(30,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new C.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:L.localize(31,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new C.RawContextKey("breakpointsExist",!1,{type:"boolean",description:L.localize(32,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new C.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:L.localize(33,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new C.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:L.localize(34,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new C.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:L.localize(35,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new C.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:L.localize(36,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new C.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:L.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new C.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:L.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new C.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:L.localize(39,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new C.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:L.localize(40,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new C.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:L.localize(41,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new C.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:L.localize(42,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new C.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:L.localize(43,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new C.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:L.localize(44,null)}),e.CONTEXT_VARIABLE_VALUE=new C.RawContextKey("variableValue",!1,{type:"string",description:L.localize(45,null)}),e.CONTEXT_VARIABLE_TYPE=new C.RawContextKey("variableType",!1,{type:"string",description:L.localize(46,null)}),e.CONTEXT_VARIABLE_NAME=new C.RawContextKey("variableName",!1,{type:"string",description:L.localize(47,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new C.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:L.localize(48,null)}),e.CONTEXT_MULTI_SESSION_REPL=new C.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:L.localize(49,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new C.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:L.localize(50,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new C.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:L.localize(51,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new C.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:L.localize(52,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new C.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:L.localize(53,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new C.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:L.localize(54,null)});const T=i=>L.localize(55,null,i);e.debuggerDisabledMessage=T,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:L.localize(56,null)};var g;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(g||(e.State=g={}));function h(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=h;var S;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(S||(e.MemoryRangeType=S={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var R;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(R||(e.DebugConfigurationProviderTriggerKind=R={}));var D;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(D||(e.DebuggerString=D={})),e.IDebugService=(0,A.createDecorator)("debugService");var u;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(u||(e.BreakpointWidgetContext=u={}));var p;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(p||(e.DebugVisualizationType=p={}));var E;(function(i){i.deserialize=a=>({id:a.id,name:a.name,iconPath:a.iconPath&&{light:I.URI.revive(a.iconPath.light),dark:I.URI.revive(a.iconPath.dark)},iconClass:a.iconClass,visualization:a.visualization}),i.serialize=a=>a})(E||(e.IDebugVisualization=E={}))}),define(Pe[208],Te([1,0,12,2,19,26,11,29,20,18]),function(me,e,I,L,C,A,T,g,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sourcesEqual=e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const R=/{([^}]+)}/g;function D(P,m,v){return P.replace(R,function(y,O){return m&&O.length>0&&O[0]!=="_"?y:v&&v.hasOwnProperty(O)?v[O]:y})}e.formatPII=D;function u(P){const m={};for(const v of Object.keys(P))v.startsWith("!")||(m[v]=P[v]);return m}e.filterExceptionsFromTelemetry=u;function p(P){return P.configuration.request==="attach"&&!E(P)&&(!P.parentSession||p(P.parentSession))}e.isSessionAttach=p;function E(P){let m=P.configuration.type;if(m)return m==="vslsShare"&&(m=P.configuration.adapterProxy.configuration.type),(0,I.equalsIgnoreCase)(m,"extensionhost")||(0,I.equalsIgnoreCase)(m,"pwa-extensionhost")?P:P.parentSession?E(P.parentSession):void 0}e.getExtensionHostDebugSession=E;function i(P){return P.type&&(P.label||P.program||P.runtime)}e.isDebuggerMainContribution=i;function a(P,m,v){let y,O=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let q=null;for(;q=N.exec(P);){const W=q.index+1,x=W+q[0].length;if(W<=m&&x>=v){y=q[0],O=W;break}}if(y){const W=/\w+/g;let x=null;for(;(x=W.exec(y))&&!(x.index+1+O+x[0].length>=v););x&&(y=y.substring(0,W.lastIndex))}return y?{start:O,end:O+y.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=a;async function r(P,m,v,y){if(P.evaluatableExpressionProvider.has(m)){const O=P.evaluatableExpressionProvider.ordered(m),N=(0,S.coalesce)(await Promise.all(O.map(async q=>{try{return await q.provideEvaluatableExpression(m,v,y??h.CancellationToken.None)}catch{return}})));if(N.length>0){let q=N[0].expression;const W=N[0].range;return q||(q=m.getLineContent(v.lineNumber).substring(W.startColumn-1,W.endColumn-1)),{range:W,matchingExpression:q}}}else{const O=m.getLineContent(v.lineNumber),{start:N,end:q}=a(O,v.column,v.column),W=O.substring(N-1,q);return{matchingExpression:W,range:new g.Range(v.lineNumber,N,v.lineNumber,N+W.length)}}return null}e.getEvaluatableExpressionAtPosition=r;const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function o(P){return!!(P&&P.match(n))}e.isUri=o;function c(P){if(typeof P.path=="string"&&!(typeof P.sourceReference=="number"&&P.sourceReference>0)){if(o(P.path))return L.URI.parse(P.path);if((0,C.isAbsolute)(P.path))return L.URI.file(P.path)}return P.path}function l(P){if(typeof P.path=="object"){const m=L.URI.revive(P.path);if(m)return m.scheme===T.Schemas.file?m.fsPath:m.toString()}return P.path}function t(P,m){const v=m?c:l,y=(0,A.deepClone)(P);return s(y,(O,N)=>{O&&N&&(N.path=v(N))}),y}e.convertToDAPaths=t;function d(P,m){const v=m?c:l,y=(0,A.deepClone)(P);return s(y,(O,N)=>{!O&&N&&(N.path=v(N))}),y}e.convertToVSCPaths=d;function s(P,m){switch(P.type){case"event":{const v=P;switch(v.event){case"output":m(!1,v.body.source);break;case"loadedSource":m(!1,v.body.source);break;case"breakpoint":m(!1,v.body.breakpoint.source);break;default:break}break}case"request":{const v=P;switch(v.command){case"setBreakpoints":m(!0,v.arguments.source);break;case"breakpointLocations":m(!0,v.arguments.source);break;case"source":m(!0,v.arguments.source);break;case"gotoTargets":m(!0,v.arguments.source);break;case"launchVSCode":v.arguments.args.forEach(y=>m(!1,y));break;default:break}break}case"response":{const v=P;if(v.success&&v.body)switch(v.command){case"stackTrace":v.body.stackFrames.forEach(y=>m(!1,y.source));break;case"loadedSources":v.body.sources.forEach(y=>m(!1,y));break;case"scopes":v.body.scopes.forEach(y=>m(!1,y.source));break;case"setFunctionBreakpoints":v.body.breakpoints.forEach(y=>m(!1,y.source));break;case"setBreakpoints":v.body.breakpoints.forEach(y=>m(!1,y.source));break;case"disassemble":v.body?.instructions.forEach(O=>m(!1,O.location));break;default:break}break}}}function b(P){return P.filter(m=>!m.presentation?.hidden).sort((m,v)=>m.presentation?v.presentation?m.presentation.group?v.presentation.group?m.presentation.group!==v.presentation.group?m.presentation.group.localeCompare(v.presentation.group):_(m.presentation.order,v.presentation.order):-1:v.presentation.group?1:_(m.presentation.order,v.presentation.order):-1:v.presentation?1:0)}e.getVisibleAndSorted=b;function _(P,m){return typeof P!="number"?typeof m!="number"?0:1:typeof m!="number"?-1:P-m}async function f(P,m){const v=P.getValue("debug.saveBeforeStart",{overrideIdentifier:m.activeTextEditorLanguageId});if(v!=="none"&&(await m.saveAll(),v==="allEditorsInActiveGroup")){const y=m.activeEditorPane;y&&y.input.resource?.scheme===T.Schemas.untitled&&await m.save({editor:y.input,groupId:y.group.id})}await P.reloadConfiguration()}e.saveAllBeforeDebugStart=f;const w=(P,m)=>!P||!m?P===m:P.name===m.name&&P.path===m.path&&P.sourceReference===m.sourceReference;e.sourcesEqual=w}),define(Pe[209],Te([1,0,4]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(L||(e.CellExecutionUpdateType=L={})),e.INotebookExecutionService=(0,I.createDecorator)("INotebookExecutionService")}),define(Pe[210],Te([1,0,4]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookKernelHistoryService=e.INotebookKernelService=e.ProxyKernelState=e.variablePageSize=void 0,e.variablePageSize=100;var L;(function(C){C[C.Disconnected=1]="Disconnected",C[C.Connected=2]="Connected",C[C.Initializing=3]="Initializing"})(L||(e.ProxyKernelState=L={})),e.INotebookKernelService=(0,I.createDecorator)("INotebookKernelService"),e.INotebookKernelHistoryService=(0,I.createDecorator)("INotebookKernelHistoryService")}),define(Pe[211],Te([1,0,6,29,144,94]),function(me,e,I,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CellSearchModel=void 0;class T extends I.Disposable{constructor(h,S,R){super(),this._source=h,this._inputTextBuffer=S,this._outputs=R,this._outputTextBuffers=void 0}_getFullModelRange(h){const S=h.getLineCount();return new L.Range(1,1,S,this._getLineMaxColumn(h,S))}_getLineMaxColumn(h,S){if(S<1||S>h.getLineCount())throw new Error("Illegal value for lineNumber");return h.getLineLength(S)+1}get inputTextBuffer(){if(!this._inputTextBuffer){const h=new C.PieceTreeTextBufferBuilder;h.acceptChunk(this._source);const S=h.finish(!0),{textBuffer:R,disposable:D}=S.create(1);this._inputTextBuffer=R,this._register(D)}return this._inputTextBuffer}get outputTextBuffers(){return this._outputTextBuffers||(this._outputTextBuffers=this._outputs.map(h=>{const S=new C.PieceTreeTextBufferBuilder;S.acceptChunk(h);const R=S.finish(!0),{textBuffer:D,disposable:u}=R.create(1);return this._register(u),D})),this._outputTextBuffers}findInInputs(h){const R=new A.SearchParams(h,!1,!1,null).parseSearchRequest();if(!R)return[];const D=this._getFullModelRange(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(D,R,!0,5e3)}findInOutputs(h){const R=new A.SearchParams(h,!1,!1,null).parseSearchRequest();return R?this.outputTextBuffers.map(D=>{const u=D.findMatchesLineByLine(this._getFullModelRange(D),R,!0,5e3);if(u.length!==0)return{textBuffer:D,matches:u}}).filter(D=>!!D):[]}}e.CellSearchModel=T}),define(Pe[48],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(A){A.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var L;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(L||(e.TestPosition=L={}));class C{static fromExtHostTestItem(T,g,h=T.parent){if(T._isRoot)return new C([g]);const S=[T.id];for(let R=h;R&&R.id!==g;R=R.parent)S.push(R.id);return S.push(g),new C(S.reverse())}static isRoot(T){return!T.includes("\0")}static root(T){const g=T.indexOf("\0");return g===-1?T:T.slice(0,g)}static fromString(T){return new C(T.split("\0"))}static join(T,g){return new C([...T.path,g])}static joinToString(T,g){return T.toString()+"\0"+g}static parentId(T){const g=T.lastIndexOf("\0");return g===-1?void 0:T.slice(0,g)}static localId(T){const g=T.lastIndexOf("\0");return g===-1?T:T.slice(g+1)}static isChild(T,g){return g.startsWith(T)&&g[T.length]==="\0"}static compare(T,g){return T===g?0:C.isChild(T,g)?2:C.isChild(g,T)?3:1}constructor(T,g=T.length){if(this.path=T,this.viewEnd=g,T.length===0||g<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.viewEnd>1?new C(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new C(this.path,T)}*idsToRoot(){for(let T=this.viewEnd;T>0;T--)yield new C(this.path,T)}compare(T){if(typeof T=="string")return C.compare(this.toString(),T);for(let g=0;g<T.viewEnd&&g<this.viewEnd;g++)if(T.path[g]!==this.path[g])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=C}),define(Pe[59],Te([1,0,2,92,29,48]),function(me,e,I,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.KEEP_N_LAST_COVERAGE_REPORTS=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var T;(function(k){k[k.Unset=0]="Unset",k[k.Queued=1]="Queued",k[k.Running=2]="Running",k[k.Passed=3]="Passed",k[k.Failed=4]="Failed",k[k.Skipped=5]="Skipped",k[k.Errored=6]="Errored"})(T||(e.TestResultState=T={}));var g;(function(k){k[k.Run=1]="Run",k[k.Debug=2]="Debug",k[k.Coverage=3]="Coverage"})(g||(e.ExtTestRunProfileKind=g={}));var h;(function(k){k[k.Run=2]="Run",k[k.Debug=4]="Debug",k[k.Coverage=8]="Coverage",k[k.HasNonDefaultProfile=16]="HasNonDefaultProfile",k[k.HasConfigurable=32]="HasConfigurable",k[k.SupportsContinuousRun=64]="SupportsContinuousRun"})(h||(e.TestRunProfileBitset=h={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const S=k=>"runId"in k;e.isStartControllerTests=S;var R;(function(k){k.serialize=M=>({range:M.range.toJSON(),uri:M.uri.toJSON()}),k.deserialize=(M,$)=>({range:C.Range.lift($.range),uri:M.asCanonicalUri(I.URI.revive($.uri))})})(R||(e.IRichLocation=R={}));var D;(function(k){k[k.Error=0]="Error",k[k.Output=1]="Output"})(D||(e.TestMessageType=D={}));var u;(function(k){k.serialize=M=>({message:M.message,type:0,expected:M.expected,actual:M.actual,contextValue:M.contextValue,location:M.location&&R.serialize(M.location)}),k.deserialize=(M,$)=>({message:$.message,type:0,expected:$.expected,actual:$.actual,contextValue:$.contextValue,location:$.location&&R.deserialize(M,$.location)})})(u||(e.ITestErrorMessage=u={}));const p=(k,M)=>`${M?"s":"e"}${k}`;e.getMarkId=p;var E;(function(k){k.serialize=M=>({message:M.message,type:1,offset:M.offset,length:M.length,location:M.location&&R.serialize(M.location)}),k.deserialize=(M,$)=>({message:$.message,type:1,offset:$.offset,length:$.length,location:$.location&&R.deserialize(M,$.location)})})(E||(e.ITestOutputMessage=E={}));var i;(function(k){k.serialize=M=>M.type===0?u.serialize(M):E.serialize(M),k.deserialize=(M,$)=>$.type===0?u.deserialize(M,$):E.deserialize(M,$)})(i||(e.ITestMessage=i={}));var a;(function(k){k.serializeWithoutMessages=M=>({state:M.state,duration:M.duration,messages:[]}),k.serialize=M=>({state:M.state,duration:M.duration,messages:M.messages.map(i.serialize)}),k.deserialize=(M,$)=>({state:$.state,duration:$.duration,messages:$.messages.map(oe=>i.deserialize(M,oe))})})(a||(e.ITestTaskState=a={}));const r="\0",n=(k,M)=>k+r+M;e.namespaceTestTag=n;const o=k=>{const M=k.indexOf(r);return{ctrlId:k.slice(0,M),tagId:k.slice(M+1)}};e.denamespaceTestTag=o;var c;(function(k){k.serialize=M=>({extId:M.extId,label:M.label,tags:M.tags,busy:M.busy,children:void 0,uri:M.uri?.toJSON(),range:M.range?.toJSON()||null,description:M.description,error:M.error,sortText:M.sortText}),k.deserialize=(M,$)=>({extId:$.extId,label:$.label,tags:$.tags,busy:$.busy,children:void 0,uri:$.uri?M.asCanonicalUri(I.URI.revive($.uri)):void 0,range:$.range?C.Range.lift($.range):null,description:$.description,error:$.error,sortText:$.sortText})})(c||(e.ITestItem=c={}));var l;(function(k){k[k.NotExpandable=0]="NotExpandable",k[k.Expandable=1]="Expandable",k[k.BusyExpanding=2]="BusyExpanding",k[k.Expanded=3]="Expanded"})(l||(e.TestItemExpandState=l={}));var t;(function(k){k.serialize=M=>({expand:M.expand,item:c.serialize(M.item)}),k.deserialize=(M,$)=>({controllerId:A.TestId.root($.item.extId),expand:$.expand,item:c.deserialize(M,$.item)})})(t||(e.InternalTestItem=t={}));var d;(function(k){k.serialize=M=>{let $;return M.item&&($={},M.item.label!==void 0&&($.label=M.item.label),M.item.tags!==void 0&&($.tags=M.item.tags),M.item.busy!==void 0&&($.busy=M.item.busy),M.item.uri!==void 0&&($.uri=M.item.uri?.toJSON()),M.item.range!==void 0&&($.range=M.item.range?.toJSON()),M.item.description!==void 0&&($.description=M.item.description),M.item.error!==void 0&&($.error=M.item.error),M.item.sortText!==void 0&&($.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:$}},k.deserialize=M=>{let $;return M.item&&($={},M.item.label!==void 0&&($.label=M.item.label),M.item.tags!==void 0&&($.tags=M.item.tags),M.item.busy!==void 0&&($.busy=M.item.busy),M.item.range!==void 0&&($.range=M.item.range?C.Range.lift(M.item.range):null),M.item.description!==void 0&&($.description=M.item.description),M.item.error!==void 0&&($.error=M.item.error),M.item.sortText!==void 0&&($.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:$}}})(d||(e.ITestItemUpdate=d={}));const s=(k,M)=>{M.expand!==void 0&&(k.expand=M.expand),M.item!==void 0&&(k.item=k.item?Object.assign(k.item,M.item):M.item)};e.applyTestItemUpdate=s;var b;(function(k){k.serializeWithoutMessages=M=>({...t.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(a.serializeWithoutMessages)}),k.serialize=M=>({...t.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(a.serialize)}),k.deserialize=(M,$)=>({...t.deserialize(M,$),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(oe=>a.deserialize(M,oe)),retired:!0})})(b||(e.TestResultItem=b={}));var _;(function(k){k.empty=()=>({covered:0,total:0}),k.sum=(M,$)=>{M.covered+=$.covered,M.total+=$.total}})(_||(e.ICoveredCount=_={}));var f;(function(k){k.serialize=M=>({statement:M.statement,branch:M.branch,function:M.function,details:M.details?.map(v.serialize),uri:M.uri.toJSON()}),k.deserialize=(M,$)=>({statement:$.statement,branch:$.branch,function:$.function,details:$.details?.map(v.deserialize),uri:M.asCanonicalUri(I.URI.revive($.uri))})})(f||(e.IFileCoverage=f={}));function w(k){return{...k,location:k.location?.toJSON()}}function P(k){return k.location=k.location?L.Position.isIPosition(k.location)?L.Position.lift(k.location):C.Range.lift(k.location):void 0,k}e.KEEP_N_LAST_COVERAGE_REPORTS=3;var m;(function(k){k[k.Function=0]="Function",k[k.Statement=1]="Statement",k[k.Branch=2]="Branch"})(m||(e.DetailType=m={}));var v;(function(k){k.serialize=M=>M.type===0?O.serialize(M):N.serialize(M),k.deserialize=M=>M.type===0?O.deserialize(M):N.deserialize(M)})(v||(e.CoverageDetails=v={}));var y;(function(k){k.serialize=w,k.deserialize=P})(y||(e.IBranchCoverage=y={}));var O;(function(k){k.serialize=w,k.deserialize=P})(O||(e.IFunctionCoverage=O={}));var N;(function(k){k.serialize=M=>({...w(M),branches:M.branches?.map(y.serialize)}),k.deserialize=M=>({...P(M),branches:M.branches?.map(y.deserialize)})})(N||(e.IStatementCoverage=N={}));var q;(function(k){k[k.Add=0]="Add",k[k.Update=1]="Update",k[k.DocumentSynced=2]="DocumentSynced",k[k.Remove=3]="Remove",k[k.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",k[k.Retire=5]="Retire",k[k.AddTag=6]="AddTag",k[k.RemoveTag=7]="RemoveTag"})(q||(e.TestDiffOpType=q={}));var W;(function(k){k.deserialize=(M,$)=>$.op===0?{op:$.op,item:t.deserialize(M,$.item)}:$.op===1?{op:$.op,item:d.deserialize($.item)}:$.op===2?{op:$.op,uri:M.asCanonicalUri(I.URI.revive($.uri)),docv:$.docv}:$,k.serialize=M=>M.op===0?{op:M.op,item:t.serialize(M.item)}:M.op===1?{op:M.op,item:d.serialize(M.item)}:M})(W||(e.TestsDiffOp=W={}));class x{constructor(M){this.uriIdentity=M,this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(M){const $=this.createChangeCollector();for(const oe of M)switch(oe.op){case 0:this.add(t.deserialize(this.uriIdentity,oe.item),$);break;case 1:this.update(d.deserialize(oe.item),$);break;case 3:this.remove(oe.itemId,$);break;case 5:this.retireTest(oe.itemId);break;case 4:this.updatePendingRoots(oe.amount);break;case 6:this._tags.set(oe.tag.id,oe.tag);break;case 7:this._tags.delete(oe.id);break}$.complete?.()}add(M,$){const oe=A.TestId.parentId(M.item.extId)?.toString();let de;if(!oe)de=this.createItem(M),this.roots.add(de),this.items.set(M.item.extId,de);else if(this.items.has(oe)){const we=this.items.get(oe);we.children.add(M.item.extId),de=this.createItem(M,we),this.items.set(M.item.extId,de)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(M)}`);return}return $.add?.(de),M.expand===2&&this.busyControllerCount++,de}update(M,$){const oe=this.items.get(M.extId);if(oe)return M.expand!==void 0&&(oe.expand===2&&this.busyControllerCount--,M.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(oe,M),$.update?.(oe),oe}remove(M,$){const oe=this.items.get(M);if(!oe)return;const de=A.TestId.parentId(oe.item.extId)?.toString();de?this.items.get(de).children.delete(oe.item.extId):this.roots.delete(oe);const we=[[M]];for(;we.length;)for(const ye of we.pop()){const le=this.items.get(ye);le&&(we.push(le.children),this.items.delete(ye),$.remove?.(le,le!==oe),le.expand===2&&this.busyControllerCount--)}}retireTest(M){}updatePendingRoots(M){this.pendingRootCount+=M}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=x}),define(Pe[76],Te([1,0,13,5,6,54,59,48]),function(me,e,I,L,C,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var h;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(h||(e.TestItemEventOp=h={}));const S=(n,o)=>n===o,D=Object.entries({range:(n,o)=>n===o?!0:!n||!o?!1:n.equalsRange(o),busy:S,label:S,description:S,error:S,sortText:S,tags:(n,o)=>!(n.length!==o.length||n.some(c=>!o.includes(c)))}),u=(n,o)=>{let c;for(const[l,t]of D)t(n[l],o[l])||(c?c[l]=o[l]:c={[l]:o[l]});return c};class p extends C.Disposable{get root(){return this.options.root}constructor(o){super(),this.options=o,this.debounceSendDiff=this._register(new I.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(o){this._resolveHandler=o;for(const c of this.tree.values())this.updateExpandability(c)}get resolveHandler(){return this._resolveHandler}collectDiff(){const o=this.diff;return this.diff=[],o}pushDiff(o){switch(o.op){case 2:{for(const c of this.diff)if(c.op===2&&c.uri===o.uri){c.docv=o.docv;return}break}case 1:{const c=this.diff[this.diff.length-1];if(c){if(c.op===1&&c.item.extId===o.item.extId){(0,T.applyTestItemUpdate)(c.item,o.item);return}if(c.op===0&&c.item.item.extId===o.item.extId){(0,T.applyTestItemUpdate)(c.item,o.item);return}}break}}this.diff.push(o),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(o,c){const l=this.tree.get(o);if(l){if((l.expandLevels===void 0||c>l.expandLevels)&&(l.expandLevels=c),l.expand===1){const t=this.resolveChildren(l);return t.isOpen()?this.expandChildren(l,c-1):t.wait().then(()=>this.expandChildren(l,c-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,c-1)):this.expandChildren(l,c-1)}}dispose(){for(const o of this.tree.values())this.options.getApiFor(o.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(o,c){switch(c.op){case 3:this.removeItem(g.TestId.joinToString(o.fullId,c.id));break;case 0:this.upsertItem(c.item,o);break;case 5:for(const l of c.ops)this.onTestItemEvent(o,l);break;case 1:this.diffTagRefs(c.new,c.old,o.fullId.toString());break;case 2:this.updateExpandability(o);break;case 4:this.pushDiff({op:1,item:{extId:o.fullId.toString(),item:c.update}});break;case 6:this.documentSynced(o.actual.uri);break;default:(0,A.assertNever)(c)}}documentSynced(o){o&&this.pushDiff({op:2,uri:o,docv:this.options.getDocumentVersion(o)})}upsertItem(o,c){const l=g.TestId.fromExtHostTestItem(o,this.root.id,c?.actual),t=this.options.getApiFor(o);t.parent&&t.parent!==c?.actual&&this.options.getChildren(t.parent).delete(o.id);let d=this.tree.get(l.toString());if(!d){d={fullId:l,actual:o,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},o.tags.forEach(this.incrementTagRefs,this),this.tree.set(d.fullId.toString(),d),this.setItemParent(o,c),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:d.expand,item:this.options.toITestItem(o)}}),this.connectItemAndChildren(o,d,c);return}if(d.actual===o){this.connectItem(o,d,c);return}if(d.actual.uri?.toString()!==o.uri?.toString())return this.removeItem(l.toString()),this.upsertItem(o,c);const s=this.options.getChildren(d.actual),b=d.actual,_=u(this.options.toITestItem(b),this.options.toITestItem(o));this.options.getApiFor(b).listener=void 0,d.actual=o,d.expand=0,_&&(_.hasOwnProperty("tags")&&(this.diffTagRefs(o.tags,b.tags,l.toString()),delete _.tags),this.onTestItemEvent(d,{op:4,update:_})),this.connectItemAndChildren(o,d,c);for(const[f,w]of s)this.options.getChildren(o).get(w.id)||this.removeItem(g.TestId.joinToString(l,w.id));this.documentSynced(d.actual.uri)}diffTagRefs(o,c,l){const t=new Set(c.map(d=>d.id));for(const d of o)t.delete(d.id)||this.incrementTagRefs(d);this.pushDiff({op:1,item:{extId:l,item:{tags:o.map(d=>(0,T.namespaceTestTag)(this.options.controllerId,d.id))}}}),t.forEach(this.decrementTagRefs,this)}incrementTagRefs(o){const c=this.tags.get(o.id);c?c.refCount++:(this.tags.set(o.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,T.namespaceTestTag)(this.options.controllerId,o.id)}}))}decrementTagRefs(o){const c=this.tags.get(o);c&&!--c.refCount&&(this.tags.delete(o),this.pushDiff({op:7,id:(0,T.namespaceTestTag)(this.options.controllerId,o)}))}setItemParent(o,c){this.options.getApiFor(o).parent=c&&c.actual!==this.root?c.actual:void 0}connectItem(o,c,l){this.setItemParent(o,l);const t=this.options.getApiFor(o);t.parent=l?.actual,t.listener=d=>this.onTestItemEvent(c,d),this.updateExpandability(c)}connectItemAndChildren(o,c,l){this.connectItem(o,c,l);for(const[t,d]of this.options.getChildren(o))this.upsertItem(d,c)}updateExpandability(o){let c;this._resolveHandler?o.resolveBarrier?c=o.resolveBarrier.isOpen()?3:2:c=o.actual.canResolveChildren?1:0:c=0,c!==o.expand&&(o.expand=c,this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:c}}),c===1&&o.expandLevels!==void 0&&this.resolveChildren(o))}expandChildren(o,c){if(c<0)return;const l=[];for(const[t,d]of this.options.getChildren(o.actual)){const s=this.expand(g.TestId.joinToString(o.fullId,d.id),c);(0,I.isThenable)(s)&&l.push(s)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(o){if(o.resolveBarrier)return o.resolveBarrier;if(!this._resolveHandler){const d=new I.Barrier;return d.open(),d}o.expand=2,this.pushExpandStateUpdate(o);const c=o.resolveBarrier=new I.Barrier,l=d=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,d)};let t;try{t=this._resolveHandler(o.actual===this.root?void 0:o.actual)}catch(d){l(d)}return(0,I.isThenable)(t)?t.catch(l).then(()=>{c.open(),this.updateExpandability(o)}):(c.open(),this.updateExpandability(o)),o.resolveBarrier}pushExpandStateUpdate(o){this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:o.expand}})}removeItem(o){const c=this.tree.get(o);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:o});const l=[c];for(;l.length;){const t=l.pop();if(t){this.options.getApiFor(t.actual).listener=void 0;for(const d of t.actual.tags)this.decrementTagRefs(d.id);this.tree.delete(t.fullId.toString());for(const[d,s]of this.options.getChildren(t.actual))l.push(this.tree.get(g.TestId.joinToString(t.fullId,s.id)))}}}flushDiff(){const o=this.collectDiff();o.length&&this.diffOpEmitter.fire(o)}}e.TestItemCollection=p;class E extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.DuplicateTestItemError=E;class i extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=i;class a extends Error{constructor(o,c,l){super(`TestItem with ID "${o}" is from controller "${c}" and cannot be added as a child of an item from controller "${l}".`)}}e.MixedTestItemController=a;const r=(n,o,c)=>{let l=new Map;return{get size(){return l.size},forEach(t,d){for(const s of l.values())t.call(d,s,this)},[Symbol.iterator](){return l.entries()},replace(t){const d=new Map,s=new Set(l.keys()),b={op:5,ops:[]};for(const _ of t){if(!(_ instanceof c))throw new i(_.id);const f=o(_).controllerId;if(f!==n.controllerId)throw new a(_.id,f,n.controllerId);if(d.has(_.id))throw new E(_.id);d.set(_.id,_),s.delete(_.id),b.ops.push({op:0,item:_})}for(const _ of s.keys())b.ops.push({op:3,id:_});n.listener?.(b),l=d},add(t){if(!(t instanceof c))throw new i(t.id);l.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){l.delete(t)&&n.listener?.({op:3,id:t})},get(t){return l.get(t)},toJSON(){return Array.from(l.values())}}};e.createTestItemChildren=r}),define(Pe[103],Te([1,0,76]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const L=new WeakMap,C=(T,g)=>{const h={controllerId:g};return L.set(T,h),h};e.createPrivateApiFor=C;const A=T=>{const g=L.get(T);if(!g)throw new I.InvalidTestItemError(T?.id||"<unknown>");return g};e.getPrivateApiFor=A}),define(Pe[77],Te([1,0,11,2]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function C(g,h){return g.scheme===I.Schemas.http||g.scheme===I.Schemas.https?g:(h&&h.authority&&h.isRemote&&g.scheme===I.Schemas.file&&(g=L.URI.from({scheme:I.Schemas.vscodeRemote,authority:h.authority,path:g.path})),L.URI.from({scheme:I.Schemas.https,authority:`${g.scheme}+${A(g.authority)}.${e.webviewRootResourceAuthority}`,path:g.path,fragment:g.fragment,query:g.query}))}e.asWebviewUri=C;function A(g){return g.replace(/./g,h=>{const S=h.charCodeAt(0);return S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57?h:"-"+S.toString(16).padStart(4,"0")})}function T(g){return g.replace(/-([0-9a-f]{4})/g,(h,S)=>String.fromCharCode(parseInt(S,16)))}e.decodeAuthority=T}),define(Pe[212],Te([1,0,5,6,77]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(g,h,S){this._proxy=g,this._editors=h,this._remoteInfo=S,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(h.onDidChangeVisibleTextEditors(()=>{const R=h.getVisibleTextEditors();for(const D of this._insets.values())R.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this._insets.forEach(g=>g.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(g,h,S,R,D){let u;for(const o of this._editors.getVisibleTextEditors(!0))if(o.value===g){u=o;break}if(!u)throw new Error("not a visible editor");const p=this,E=this._handlePool++,i=new I.Emitter,a=new I.Emitter,r=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(o){return(0,C.asWebviewUri)(o,p._remoteInfo)}get cspSource(){return C.webviewGenericCspSource}set options(o){this._options=o,p._proxy.$setOptions(E,o)}get options(){return this._options}set html(o){this._html=o,p._proxy.$setHtml(E,o)}get html(){return this._html}get onDidReceiveMessage(){return i.event}postMessage(o){return p._proxy.$postMessage(E,o)}},n=new class{constructor(){this.editor=g,this.line=h,this.height=S,this.webview=r,this.onDidDispose=a.event}dispose(){p._insets.has(E)&&(p._insets.delete(E),p._proxy.$disposeEditorInset(E),a.fire(),a.dispose(),i.dispose())}};return this._proxy.$createEditorInset(E,u.id,u.value.document.uri,h+1,S,R||{},D.identifier,D.extensionLocation),this._insets.set(E,{editor:g,inset:n,onDidReceiveMessage:i}),n}$onDidDispose(g){const h=this._insets.get(g);h&&h.inset.dispose()}$onDidReceiveMessage(g,h){this._insets.get(g)?.onDidReceiveMessage.fire(h)}}e.ExtHostEditorInsets=A}),define(Pe[213],Te([1,0,4]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,I.createDecorator)("configurationResolverService");var L;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator",A.PathSeparatorAlias="/"})(L||(e.VariableKind=L={}));class C extends Error{constructor(T,g){super(g),this.variable=T}}e.VariableError=C}),define(Pe[214],Te([1,0,19,74,16,26,21,95,176,213,12]),function(me,e,I,L,C,A,T,g,h,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(p,E,i,a){this._contributedVariables=new Map,this._context=p,this._labelService=E,this._userHomePromise=i,a&&(this._envVariablesPromise=a.then(r=>this.prepareEnv(r)))}prepareEnv(p){if(T.isWindows){const E=Object.create(null);return Object.keys(p).forEach(i=>{E[i.toLowerCase()]=p[i]}),E}return p}resolveWithEnvironment(p,E,i){return this.recursiveResolve({env:this.prepareEnv(p),userHome:void 0},E?E.uri:void 0,i)}async resolveAsync(p,E){const i={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(i,p?p.uri:void 0,E)}async resolveAnyBase(p,E,i,a){const r=A.deepClone(E);T.isWindows&&r.windows?Object.keys(r.windows).forEach(o=>r[o]=r.windows[o]):T.isMacintosh&&r.osx?Object.keys(r.osx).forEach(o=>r[o]=r.osx[o]):T.isLinux&&r.linux&&Object.keys(r.linux).forEach(o=>r[o]=r.linux[o]),delete r.windows,delete r.osx,delete r.linux;const n={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(n,p?p.uri:void 0,r,i,a)}async resolveAnyAsync(p,E,i){return this.resolveAnyBase(p,E,i)}async resolveAnyMap(p,E,i){const a=new Map;return{newConfig:await this.resolveAnyBase(p,E,i,a),resolvedVariables:a}}resolveWithInteractionReplace(p,E,i,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,E,i,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,E){if(this._contributedVariables.has(p))throw new Error("Variable "+p+" is contributed twice.");this._contributedVariables.set(p,E)}async recursiveResolve(p,E,i,a,r){if(C.isString(i))return this.resolveString(p,E,i,a,r);if(Array.isArray(i))return Promise.all(i.map(n=>this.recursiveResolve(p,E,n,a,r)));if(C.isObject(i)){const n=Object.create(null),o=await Promise.all(Object.keys(i).map(async c=>[await this.resolveString(p,E,c,a,r),await this.recursiveResolve(p,E,i[c],a,r)]));for(const[c,l]of o)n[c]=l;return n}return i}resolveString(p,E,i,a,r){return(0,R.replaceAsync)(i,D.VARIABLE_REGEXP,async(n,o)=>{if(o.includes(D.VARIABLE_LHS))return n;let c=await this.evaluateSingleVariable(p,n,o,E,a);return r?.set(o,c),c!==n&&C.isString(c)&&c.match(D.VARIABLE_REGEXP)&&(c=await this.resolveString(p,E,c,a,r)),c})}fsPath(p){return this._labelService?this._labelService.getUriLabel(p,{noPrefix:!0}):p.fsPath}async evaluateSingleVariable(p,E,i,a,r){let n;const o=i.split(":");o.length>1&&(i=o[0],n=o[1]);const c=d=>{const s=this._context.getFilePath();if(s)return(0,g.normalizeDriveLetter)(s);throw new S.VariableError(d,(0,h.localize)(0,null,E))},l=d=>{const s=c(d);if(this._context.getWorkspaceFolderPathForFile){const b=this._context.getWorkspaceFolderPathForFile();if(b)return(0,g.normalizeDriveLetter)(b)}throw new S.VariableError(d,(0,h.localize)(1,null,E,I.basename(s)))},t=d=>{if(n){const s=this._context.getFolderUri(n);if(s)return s;throw new S.VariableError(d,(0,h.localize)(2,null,E,n))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new S.VariableError(d,(0,h.localize)(3,null,E)):new S.VariableError(d,(0,h.localize)(4,null,E))};switch(i){case"env":if(n){if(p.env){const d=p.env[T.isWindows?n.toLowerCase():n];if(C.isString(d))return d}return""}throw new S.VariableError(S.VariableKind.Env,(0,h.localize)(5,null,E));case"config":if(n){const d=this._context.getConfigurationValue(a,n);if(C.isUndefinedOrNull(d))throw new S.VariableError(S.VariableKind.Config,(0,h.localize)(6,null,E,n));if(C.isObject(d))throw new S.VariableError(S.VariableKind.Config,(0,h.localize)(7,null,E,n));return d}throw new S.VariableError(S.VariableKind.Config,(0,h.localize)(8,null,E));case"command":return this.resolveFromMap(S.VariableKind.Command,E,n,r,"command");case"input":return this.resolveFromMap(S.VariableKind.Input,E,n,r,"input");case"extensionInstallFolder":if(n){const d=await this._context.getExtension(n);if(!d)throw new S.VariableError(S.VariableKind.ExtensionInstallFolder,(0,h.localize)(9,null,E,n));return this.fsPath(d.extensionLocation)}throw new S.VariableError(S.VariableKind.ExtensionInstallFolder,(0,h.localize)(10,null,E));default:switch(i){case"workspaceRoot":case"workspaceFolder":return(0,g.normalizeDriveLetter)(this.fsPath(t(S.VariableKind.WorkspaceFolder)));case"cwd":return a||n?(0,g.normalizeDriveLetter)(this.fsPath(t(S.VariableKind.Cwd))):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,g.normalizeDriveLetter)(I.basename(this.fsPath(t(S.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new S.VariableError(S.VariableKind.UserHome,(0,h.localize)(11,null,E))}case"lineNumber":{const d=this._context.getLineNumber();if(d)return d;throw new S.VariableError(S.VariableKind.LineNumber,(0,h.localize)(12,null,E))}case"selectedText":{const d=this._context.getSelectedText();if(d)return d;throw new S.VariableError(S.VariableKind.SelectedText,(0,h.localize)(13,null,E))}case"file":return c(S.VariableKind.File);case"fileWorkspaceFolder":return l(S.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return I.basename(l(S.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return a||n?I.relative(this.fsPath(t(S.VariableKind.RelativeFile)),c(S.VariableKind.RelativeFile)):c(S.VariableKind.RelativeFile);case"relativeFileDirname":{const d=I.dirname(c(S.VariableKind.RelativeFileDirname));if(a||n){const s=I.relative(this.fsPath(t(S.VariableKind.RelativeFileDirname)),d);return s.length===0?".":s}return d}case"fileDirname":return I.dirname(c(S.VariableKind.FileDirname));case"fileExtname":return I.extname(c(S.VariableKind.FileExtname));case"fileBasename":return I.basename(c(S.VariableKind.FileBasename));case"fileBasenameNoExtension":{const d=I.basename(c(S.VariableKind.FileBasenameNoExtension));return d.slice(0,d.length-I.extname(d).length)}case"fileDirnameBasename":return I.basename(I.dirname(c(S.VariableKind.FileDirnameBasename)));case"execPath":{const d=this._context.getExecPath();return d||E}case"execInstallFolder":{const d=this._context.getAppRoot();return d||E}case"pathSeparator":case"/":return I.sep;default:try{const d=n?`${i}:${n}`:i;return this.resolveFromMap(S.VariableKind.Unknown,E,d,r,void 0)}catch{return E}}}}resolveFromMap(p,E,i,a,r){if(i&&a){const n=r===void 0?a[i]:a[r+":"+i];if(typeof n=="string")return n;throw new S.VariableError(p,(0,h.localize)(14,null,E))}return E}}e.AbstractVariableResolverService=D}),define(Pe[104],Te([1,0,4,102]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,I.createDecorator)("editorGroupsService");var C;(function(E){E[E.UP=0]="UP",E[E.DOWN=1]="DOWN",E[E.LEFT=2]="LEFT",E[E.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var A;(function(E){E[E.HORIZONTAL=0]="HORIZONTAL",E[E.VERTICAL=1]="VERTICAL"})(A||(e.GroupOrientation=A={}));var T;(function(E){E[E.FIRST=0]="FIRST",E[E.LAST=1]="LAST",E[E.NEXT=2]="NEXT",E[E.PREVIOUS=3]="PREVIOUS"})(T||(e.GroupLocation=T={}));var g;(function(E){E[E.MAXIMIZE=0]="MAXIMIZE",E[E.EXPAND=1]="EXPAND",E[E.EVEN=2]="EVEN"})(g||(e.GroupsArrangement=g={}));var h;(function(E){E[E.COPY_EDITORS=0]="COPY_EDITORS",E[E.MOVE_EDITORS=1]="MOVE_EDITORS"})(h||(e.MergeGroupMode=h={}));function S(E){const i=E;return(0,L.isEditorInput)(i?.editor)&&(0,L.isEditorInput)(i?.replacement)}e.isEditorReplacement=S;var R;(function(E){E[E.CREATION_TIME=0]="CREATION_TIME",E[E.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",E[E.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var D;(function(E){E[E.NEW_EDITOR=1]="NEW_EDITOR",E[E.MOVE_EDITOR=2]="MOVE_EDITOR",E[E.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function u(E){const i=E;return!!i&&typeof i.id=="number"&&Array.isArray(i.editors)}e.isEditorGroup=u;function p(E){return E.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=p}),define(Pe[215],Te([1,0,4,104]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.AUX_WINDOW_GROUP=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,I.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2,e.AUX_WINDOW_GROUP=-3;function C(A){const T=A;return typeof A=="number"||(0,L.isEditorGroup)(T)}e.isPreferredGroup=C}),define(Pe[216],Te([1,0,4,183]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,I.refineServiceDecorator)(L.IEnvironmentService)}),define(Pe[105],Te([1,0,22,5,19,6]),function(me,e,I,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.ExtensionDescriptionRegistrySnapshot=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(r,n){this.versionId=r,this.removedDueToLooping=n}}e.DeltaExtensionsResult=T;class g{static isHostExtension(r,n,o){if(n.getExtensionDescription(r))return!1;const c=o.getExtensionDescription(r);return c?!!((c.main||c.browser)&&c.api==="none"):!1}constructor(r,n){this._activationEventsReader=r,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._versionId=0,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new I.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const r of this._extensionDescriptions){if(this._extensionsMap.has(r.identifier)){console.error("Extension `"+r.identifier.value+"` is already registered");continue}this._extensionsMap.set(r.identifier,r),this._extensionsArr.push(r);const n=this._activationEventsReader.readActivationEvents(r);for(const o of n)this._activationMap.has(o)||this._activationMap.set(o,[]),this._activationMap.get(o).push(r)}}set(r){return this._extensionDescriptions=r,this._initialize(),this._versionId++,this._onDidChange.fire(void 0),{versionId:this._versionId}}deltaExtensions(r,n){this._extensionDescriptions=i(this._extensionDescriptions,n),this._extensionDescriptions=this._extensionDescriptions.concat(r);const o=g._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=i(this._extensionDescriptions,o.map(c=>c.identifier)),this._initialize(),this._versionId++,this._onDidChange.fire(void 0),new T(this._versionId,o)}static _findLoopingExtensions(r){const n=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(d){this._nodesSet.has(d)||(this._nodesSet.add(d),this._nodesArr.push(d))}addArc(d,s){this.addNode(d),this.addNode(s),this._arcs.has(d)?this._arcs.get(d).push(s):this._arcs.set(d,[s])}getArcs(d){return this._arcs.has(d)?this._arcs.get(d):[]}hasOnlyGoodArcs(d,s){const b=n.getArcs(d);for(let _=0;_<b.length;_++)if(!s.has(b[_]))return!1;return!0}getNodes(){return this._nodesArr}},o=new I.ExtensionIdentifierMap;for(const d of r)if(o.set(d.identifier,d),d.extensionDependencies)for(const s of d.extensionDependencies)n.addArc(I.ExtensionIdentifier.toKey(d.identifier),I.ExtensionIdentifier.toKey(s));const c=new Set;n.getNodes().filter(d=>n.getArcs(d).length===0).forEach(d=>c.add(d));const l=n.getNodes().filter(d=>!c.has(d));let t;do{t=!1;for(let d=0;d<l.length;d++){const s=l[d];n.hasOnlyGoodArcs(s,c)&&(l.splice(d,1),d--,c.add(s),t=!0)}}while(t);return l.map(d=>o.get(d))}containsActivationEvent(r){return this._activationMap.has(r)}containsExtension(r){return this._extensionsMap.has(r)}getExtensionDescriptionsForActivationEvent(r){const n=this._activationMap.get(r);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getSnapshot(){return new h(this._versionId,this.getAllExtensionDescriptions())}getExtensionDescription(r){const n=this._extensionsMap.get(r);return n||void 0}getExtensionDescriptionByUUID(r){for(const n of this._extensionsArr)if(n.uuid===r)return n}getExtensionDescriptionByIdOrUUID(r,n){return this.getExtensionDescription(r)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.ExtensionDescriptionRegistry=g;class h{constructor(r,n){this.versionId=r,this.extensions=n}}e.ExtensionDescriptionRegistrySnapshot=h;class S{constructor(r){this._lock=new u,this._actual=new g(r,[])}async acquireLock(r){const n=await this._lock.acquire(r);return new R(this,n)}deltaExtensions(r,n,o){if(!r.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(n,o)}containsActivationEvent(r){return this._actual.containsActivationEvent(r)}containsExtension(r){return this._actual.containsExtension(r)}getExtensionDescriptionsForActivationEvent(r){return this._actual.getExtensionDescriptionsForActivationEvent(r)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getSnapshot(){return this._actual.getSnapshot()}getExtensionDescription(r){return this._actual.getExtensionDescription(r)}getExtensionDescriptionByUUID(r){return this._actual.getExtensionDescriptionByUUID(r)}getExtensionDescriptionByIdOrUUID(r,n){return this._actual.getExtensionDescriptionByIdOrUUID(r,n)}}e.LockableExtensionDescriptionRegistry=S;class R extends A.Disposable{constructor(r,n){super(),this._registry=r,this._isDisposed=!1,this._register(n)}isAcquiredFor(r){return!this._isDisposed&&this._registry===r}}e.ExtensionDescriptionRegistryLock=R;class D{constructor(r){this.name=r,this.promise=new Promise((n,o)=>{this._resolve=n})}resolve(r){this._resolve(r)}}class u{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(r){const n=new D(r);return this._pendingCustomers.push(n),this._advance(),n.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const r=this._pendingCustomers.shift();this._isLocked=!0;let n=!0;const o=setTimeout(()=>{n&&console.warn(`The customer named ${r.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),c=()=>{n&&(clearTimeout(o),n=!1,this._isLocked=!1,this._advance())};r.resolve((0,A.toDisposable)(c))}}var p;(function(a){a[a.Builtin=0]="Builtin",a[a.User=1]="User",a[a.Dev=2]="Dev"})(p||(p={}));function E(a,r){const n=a.isBuiltin?0:a.isUnderDevelopment?2:1,o=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(n!==o)return n-o;const c=C.posix.basename(a.extensionLocation.path),l=C.posix.basename(r.extensionLocation.path);return c<l?-1:c>l?1:0}function i(a,r){const n=new I.ExtensionIdentifierSet(r);return a.filter(o=>!n.has(o.identifier))}}),define(Pe[78],Te([1,0,23]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var L;(function(S){S[S.Desktop=1]="Desktop",S[S.Web=2]="Web"})(L||(e.UIKind=L={}));var C;(function(S){S[S.VersionMismatch=55]="VersionMismatch",S[S.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var A;(function(S){S[S.Initialized=0]="Initialized",S[S.Ready=1]="Ready",S[S.Terminate=2]="Terminate"})(A||(e.MessageType=A={}));function T(S){const R=I.VSBuffer.alloc(1);switch(S){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=T;function g(S,R){if(S.byteLength!==1)return!1;switch(S.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=g;var h;(function(S){S.Start="START_NATIVE_LOG",S.End="END_NATIVE_LOG"})(h||(e.NativeLogMarkers=h={}))}),define(Pe[60],Te([1,0,4,5,14,27,78,56,57,26,2,6,164]),function(me,e,I,L,C,A,T,g,h,S,R,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let p=class extends D.Disposable{constructor(r,n){super(),this.initData=r,this.loggerService=n,this._onDidChangeTelemetryEnabled=this._register(new L.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new L.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=R.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=n.createLogger(this.extHostTelemetryLogFile,{id:h.extensionTelemetryLogChannelId,name:(0,u.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(this._outputLogger),this._register(n.onDidChangeLogLevel(o=>{(0,C.isLogLevel)(o)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(r,n,o){const c=this.getTelemetryDetails(),l=new E(n,o,r,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(r),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),t=this._telemetryLoggers.get(r.identifier.value)??[];return this._telemetryLoggers.set(r.identifier.value,[...t,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(r,n,o){this._level=r,this._telemetryIsSupported=n,this._productConfig=o??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(r){const n=Object.create(null);switch(n["common.extname"]=`${r.publisher}.${r.name}`,n["common.extversion"]=r.version,n["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,n["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,n["common.sqmid"]=this.initData.telemetryInfo.sqmId,n["common.vscodeversion"]=this.initData.version,n["common.isnewappinstall"]=i(this.initData.telemetryInfo.firstSessionDate),n["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case T.UIKind.Web:n["common.uikind"]="web";break;case T.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,g.getRemoteName)((0,h.cleanRemoteAuthority)(this.initData.remote.authority)),n}$onDidChangeTelemetryLevel(r){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=r;const n=this.getTelemetryDetails();this._telemetryLoggers.forEach((o,c)=>{const l=o.filter(t=>!t.isDisposed);l.length===0?this._telemetryLoggers.delete(c):this._telemetryLoggers.set(c,l)}),this._telemetryLoggers.forEach(o=>{for(const c of o)c.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(r,n){const c=this._telemetryLoggers.get(r.value)?.filter(t=>!t.isDisposed);if(!c)return this._telemetryLoggers.delete(r.value),!1;let l=!1;for(const t of c)t.ignoreUnhandledExtHostErrors||(t.logError(n),l=!0);return l}};e.ExtHostTelemetry=p,e.ExtHostTelemetry=p=Ke([We(0,A.IExtHostInitDataService),We(1,C.ILoggerService)],p);class E{static validateSender(r){if(typeof r!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof r.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof r.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof r.flush<"u"&&typeof r.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(r,n,o,c,l,t,d){this._extension=o,this._logger=c,this._inLoggingOnlyMode=l,this._commonProperties=t,this._onDidChangeEnableStates=new L.Emitter,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=n?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=n?.additionalCommonProperties,this._sender=r,this._telemetryEnablements={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(r,n){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:r,isErrorsEnabled:n},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(r){let n="properties"in r?r.properties??{}:r;return n=(0,h.cleanData)(n,[]),this._additionalCommonProperties&&(n=(0,S.mixin)(n,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(n=(0,S.mixin)(n,this._commonProperties)),"properties"in r?r.properties=n:r=n,r}logEvent(r,n){this._sender&&(this._extension.publisher==="vscode"?r=this._extension.name+"/"+r:r=this._extension.identifier.value+"/"+r,n=this.mixInCommonPropsAndCleanData(n||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(r,n),this._logger.trace(r,n))}logUsage(r,n){this._telemetryEnablements.isUsageEnabled&&this.logEvent(r,n)}logError(r,n){if(!(!this._telemetryEnablements.isErrorsEnabled||!this._sender))if(typeof r=="string")this.logEvent(r,n);else{const o={name:r.name,message:r.message,stack:r.stack,cause:r.cause},c=(0,h.cleanData)(o,[]),l=new Error(c.message,{cause:c.cause});l.stack=c.stack,l.name=c.name,n=this.mixInCommonPropsAndCleanData(n||{}),this._inLoggingOnlyMode||this._sender.sendErrorData(l,n),this._logger.trace("exception",n)}}get apiTelemetryLogger(){if(!this._apiObject){const r=this,n={logUsage:r.logUsage.bind(r),get isUsageEnabled(){return r._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return r._telemetryEnablements.isErrorsEnabled},logError:r.logError.bind(r),dispose:r.dispose.bind(r),onDidChangeEnableStates:r._onDidChangeEnableStates.event.bind(r)};this._apiObject=Object.freeze(n)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let r=this._sender;this._sender=void 0,Promise.resolve(r.flush()).then(r=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=E;function i(a){const r=Date.now()-new Date(a).getTime();return isNaN(r)?!1:r<1e3*60*60*24}e.isNewAppInstall=i,e.IExtHostTelemetry=(0,I.createDecorator)("IExtHostTelemetry")}),define(Pe[24],Te([1,0,5,2,192,101,22,4]),function(me,e,I,L,C,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,g.createDecorator)("extensionService");class h{constructor(l){this.dependency=l}}e.MissingExtensionDependency=h;var S;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(S||(e.ExtensionHostStartup=S={}));class R{get versionId(){return this._versionId}get allExtensions(){return this._allExtensions}get myExtensions(){return this._myExtensions}constructor(l,t,d){this._versionId=l,this._allExtensions=t.slice(0),this._myExtensions=d.slice(0),this._myActivationEvents=null}toSnapshot(){return{versionId:this._versionId,allExtensions:this._allExtensions,myExtensions:this._myExtensions,activationEvents:A.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions)}}set(l,t,d){if(this._versionId>l)throw new Error(`ExtensionHostExtensions: invalid versionId ${l} (current: ${this._versionId})`);const s=[],b=[],_=[],f=[],w=D(this._allExtensions),P=D(t),m=(q,W)=>q.extensionLocation.toString()===W.extensionLocation.toString()||q.isBuiltin===W.isBuiltin||q.isUserBuiltin===W.isUserBuiltin||q.isUnderDevelopment===W.isUnderDevelopment;for(const q of this._allExtensions){const W=P.get(q.identifier);if(!W){s.push(q.identifier),w.delete(q.identifier);continue}if(!m(q,W)){s.push(q.identifier),w.delete(q.identifier);continue}}for(const q of t){const W=w.get(q.identifier);if(!W){b.push(q);continue}if(!m(W,q)){s.push(W.identifier),w.delete(W.identifier);continue}}const v=new T.ExtensionIdentifierSet(this._myExtensions),y=new T.ExtensionIdentifierSet(d);for(const q of this._myExtensions)y.has(q)||_.push(q);for(const q of d)v.has(q)||f.push(q);const O=A.ImplicitActivationEvents.createActivationEventsMap(b),N={versionId:l,toRemove:s,toAdd:b,addActivationEvents:O,myToRemove:_,myToAdd:f};return this.delta(N),N}delta(l){if(this._versionId>=l.versionId)return null;const{toRemove:t,toAdd:d,myToRemove:s,myToAdd:b}=l,_=new T.ExtensionIdentifierSet(t),f=new T.ExtensionIdentifierSet(s);for(let w=0;w<this._allExtensions.length;w++)_.has(this._allExtensions[w].identifier)&&(this._allExtensions.splice(w,1),w--);for(let w=0;w<this._myExtensions.length;w++)f.has(this._myExtensions[w])&&(this._myExtensions.splice(w,1),w--);for(const w of d)this._allExtensions.push(w);for(const w of b)this._myExtensions.push(w);return this._myActivationEvents=null,l}containsExtension(l){for(const t of this._myExtensions)if(T.ExtensionIdentifier.equals(t,l))return!0;return!1}containsActivationEvent(l){return this._myActivationEvents||(this._myActivationEvents=this._readMyActivationEvents()),this._myActivationEvents.has(l)}_readMyActivationEvents(){const l=new Set;for(const t of this._allExtensions){if(!this.containsExtension(t.identifier))continue;const d=A.ImplicitActivationEvents.readActivationEvents(t);for(const s of d)l.add(s)}return l}}e.ExtensionHostExtensions=R;function D(c){const l=new T.ExtensionIdentifierMap;for(const t of c)l.set(t.identifier,t);return l}function u(c,l){return c.enabledApiProposals?c.enabledApiProposals.includes(l):!1}e.isProposedApiEnabled=u;function p(c,l){if(!u(c,l))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.checkProposedApiEnabled=p;class E{constructor(l,t,d,s){this.codeLoadingTime=l,this.activateCallTime=t,this.activateResolvedTime=d,this.activationReason=s}}e.ActivationTimes=E;class i{constructor(l,t){this.description=l,this.value=t}}e.ExtensionPointContribution=i;var a;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(a||(e.ActivationKind=a={}));function r(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.toExtension=r;function n(c,l){return{identifier:new T.ExtensionIdentifier((0,C.getExtensionId)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!l,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform}}e.toExtensionDescription=n;class o{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activateById(l,t){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(l,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=o}),define(Pe[217],Te([1,0,15,105,22,24,14,13]),function(me,e,I,L,C,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class h{static{this.NONE=new h(!1,-1,-1,-1)}constructor(r,n,o,c){this.startup=r,this.codeLoadingTime=n,this.activateCallTime=o,this.activateResolvedTime=c}}e.ExtensionActivationTimes=h;class S{constructor(r){this._startup=r,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(r,n){return r===-1||n===-1?-1:n-r}build(){return new h(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class R{constructor(r,n,o,c,l,t){this.activationFailed=r,this.activationFailedError=n,this.activationTimes=o,this.module=c,this.exports=l,this.subscriptions=t}}e.ActivatedExtension=R;class D extends R{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=D;class u extends R{constructor(){super(!1,null,h.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=u;class p extends R{constructor(r){super(!0,r,h.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let E=class{constructor(r,n,o,c){this._logService=c,this._registry=r,this._globalRegistry=n,this._host=o,this._operations=new C.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[r,n]of this._operations)n.dispose()}async waitForActivatingExtensions(){const r=[];for(const[n,o]of this._operations)r.push(o.wait());await Promise.all(r)}isActivated(r){const n=this._operations.get(r);return!!(n&&n.value)}getActivatedExtension(r){const n=this._operations.get(r);if(!n||!n.value)throw new Error(`Extension '${r.value}' is not known or not activated`);return n.value}async activateByEvent(r,n){if(this._alreadyActivatedEvents[r])return;const o=this._registry.getExtensionDescriptionsForActivationEvent(r);await this._activateExtensions(o.map(c=>({id:c.identifier,reason:{startup:n,extensionId:c.identifier,activationEvent:r}}))),this._alreadyActivatedEvents[r]=!0}activateById(r,n){const o=this._registry.getExtensionDescription(r);if(!o)throw new Error(`Extension '${r}' is not known`);return this._activateExtensions([{id:o.identifier,reason:n}])}async _activateExtensions(r){const n=r.filter(o=>!this.isActivated(o.id)).map(o=>this._handleActivationRequest(o));await Promise.all(n.map(o=>o.wait()))}_handleActivationRequest(r){if(this._operations.has(r.id))return this._operations.get(r.id);if(this._isHostExtension(r.id))return this._createAndSaveOperation(r,null,[],null);const n=this._registry.getExtensionDescription(r.id);if(!n){const l=new Error(`Cannot activate unknown extension '${r.id.value}'`),t=this._createAndSaveOperation(r,null,[],new p(l));return this._host.onExtensionActivationError(r.id,l,new A.MissingExtensionDependency(r.id.value)),t}const o=[],c=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const l of c){if(this._isResolvedExtension(l))continue;const t=this._operations.get(l);if(t){o.push(t);continue}if(this._isHostExtension(l)){o.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(l).identifier,reason:r.reason}));continue}const d=this._registry.getExtensionDescription(l);if(d){if(!d.main&&!d.browser)continue;o.push(this._handleActivationRequest({id:d.identifier,reason:r.reason}));continue}const s=n.displayName||n.identifier.value,b=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${l}'`),_=this._createAndSaveOperation(r,n.displayName,[],new p(b));return this._host.onExtensionActivationError(n.identifier,b,new A.MissingExtensionDependency(l)),_}return this._createAndSaveOperation(r,n.displayName,o,null)}_createAndSaveOperation(r,n,o,c){const l=new i(r.id,n,r.reason,o,c,this._host,this._logService);return this._operations.set(r.id,l),l}_isHostExtension(r){return L.ExtensionDescriptionRegistry.isHostExtension(r,this._registry,this._globalRegistry)}_isResolvedExtension(r){const n=this._globalRegistry.getExtensionDescription(r);return n?!n.main&&!n.browser:!1}};e.ExtensionsActivator=E,e.ExtensionsActivator=E=Ke([We(3,T.ILogService)],E);let i=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(r,n,o,c,l,t,d){this._id=r,this._displayName=n,this._reason=o,this._deps=c,this._value=l,this._host=t,this._logService=d,this._barrier=new g.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let r=0;r<this._deps.length;r++){const n=this._deps[r];if(n.value&&!n.value.activationFailed){this._deps.splice(r,1),r--;continue}if(n.value&&n.value.activationFailed){const o=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);o.detail=n.value.activationFailedError,this._value=new p(o),this._host.onExtensionActivationError(this._id,o,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(r=>r.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(r){const n=new Error;if(r&&r.name&&(n.name=r.name),r&&r.message?n.message=`Activating extension '${this._id.value}' failed: ${r.message}.`:n.message=`Activating extension '${this._id.value}' failed: ${r}.`,r&&r.stack&&(n.stack=r.stack),this._value=new p(n),this._isDisposed&&I.isCancellationError(r))return;this._host.onExtensionActivationError(this._id,n,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(r)}}};i=Ke([We(6,T.ILogService)],i)}),define(Pe[218],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[219],Te([1,0,178,15,32,97,73,30,22,218,188,101]),function(me,e,I,L,C,A,T,g,h,S,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const u=g.Registry.as(T.Extensions.JSONContribution);class p{constructor(l,t,d){this._messageHandler=l,this._extension=t,this._extensionPointId=d}_msg(l,t){this._messageHandler({type:l,message:t,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(l){this._msg(C.default.Error,l)}warn(l){this._msg(C.default.Warning,l)}info(l){this._msg(C.default.Info,l)}}e.ExtensionMessageCollector=p;class E{static _toSet(l){const t=new h.ExtensionIdentifierSet;for(let d=0,s=l.length;d<s;d++)t.add(l[d].description.identifier);return t}static compute(l,t){if(!l||!l.length)return new E(t,[]);if(!t||!t.length)return new E([],l);const d=this._toSet(l),s=this._toSet(t),b=t.filter(f=>!d.has(f.description.identifier)),_=l.filter(f=>!s.has(f.description.identifier));return new E(b,_)}constructor(l,t){this.added=l,this.removed=t}}e.ExtensionPointUserDelta=E;class i{constructor(l,t){this.name=l,this.defaultExtensionKind=t,this._handler=null,this._users=null,this._delta=null}setHandler(l){if(this._handler!==null)throw new Error("Handler already set!");this._handler=l,this._handle()}acceptUsers(l){this._delta=E.compute(this._users,l),this._users=l,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(l){(0,L.onUnexpectedError)(l)}}}e.ExtensionPoint=i;const a={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},r="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:h.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals),markdownEnumDescriptions:Object.values(S.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:I.localize(42,null)},{label:"*",description:I.localize(43,null),body:"*"}]}},badges:{type:"array",description:I.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(45,null)},href:{type:"string",description:I.localize(46,null)},description:{type:"string",description:I.localize(47,null)}}}},markdown:{type:"string",description:I.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:I.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:I.localize(52,null),type:"array",items:a,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(53,null)},{body:["workspace"],description:I.localize(54,null)},{body:["ui","workspace"],description:I.localize(55,null)},{body:["workspace","ui"],description:I.localize(56,null)},{body:[],description:I.localize(57,null)}]},capabilities:{description:I.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(61,null),I.localize(62,null),I.localize(63,null)]},description:{type:"string",markdownDescription:I.localize(64,null)}}},untrustedWorkspaces:{description:I.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(67,null),I.localize(68,null),I.localize(69,null)]},restrictedConfigurations:{description:I.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(71,null)}}}}},sponsor:{description:I.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(74,null),type:"string"},"vscode:uninstall":{description:I.localize(75,null),type:"string"}}},icon:{type:"string",description:I.localize(76,null)},l10n:{type:"string",description:I.localize(77,null)},pricing:{type:"string",markdownDescription:I.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this._extensionPoints=new Map}registerExtensionPoint(l){if(this._extensionPoints.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const t=new i(l.extensionPoint,l.defaultExtensionKind);return this._extensionPoints.set(l.extensionPoint,t),l.activationEventsGenerator&&D.ImplicitActivationEvents.register(l.extensionPoint,l.activationEventsGenerator),e.schema.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,u.registerSchema(r,e.schema),t}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=n;const o={ExtensionsRegistry:"ExtensionsRegistry"};g.Registry.add(o.ExtensionsRegistry,new n),e.ExtensionsRegistry=g.Registry.as(o.ExtensionsRegistry),u.registerSchema(r,e.schema),u.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:I.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals),markdownEnumDescriptions:Object.values(S.allApiProposals)}}]}}}})}),define(Pe[220],Te([1,0,174,16,26,219,35,5]),function(me,e,I,L,C,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const h={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var S;(function(u){function p(E,i,a){if(!E)return;const r=L.isString(E.type)?E.type:void 0;if(!r||r.length===0){a.error(I.localize(3,null));return}const n=[];if(Array.isArray(E.required))for(const o of E.required)L.isString(o)&&n.push(o);return{extensionId:i.value,taskType:r,required:n,properties:E.properties?C.deepClone(E.properties):{},when:E.when?T.ContextKeyExpr.deserialize(E.when):void 0}}u.from=p})(S||(S={}));const R=A.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,p)=>{for(const E of u)E.type&&p.push(`onTaskType:${E.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:h}});class D{constructor(){this._onDefinitionsChanged=new g.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((p,E)=>{R.setHandler((i,a)=>{this._schema=void 0;try{for(const r of a.removed){const n=r.value;for(const o of n)this.taskTypes&&o.type&&this.taskTypes[o.type]&&delete this.taskTypes[o.type]}for(const r of a.added){const n=r.value;for(const o of n){const c=S.from(o,r.description.identifier,r.collector);c&&(this.taskTypes[c.taskType]=c)}}(a.removed.length>0||a.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}p(void 0)})})}onReady(){return this.readyPromise}get(p){return this.taskTypes[p]}all(){return Object.keys(this.taskTypes).map(p=>this.taskTypes[p])}getJsonSchema(){if(this._schema===void 0){const p=[];for(const E of this.all()){const i={type:"object",additionalProperties:!1};E.required.length>0&&(i.required=E.required.slice(0)),E.properties!==void 0?i.properties=C.deepClone(E.properties):i.properties=Object.create(null),i.properties.type={type:"string",enum:[E.taskType]},p.push(i)}this._schema={oneOf:p}}return this._schema}}e.TaskDefinitionRegistry=new D}),define(Pe[221],Te([1,0,175,16,25,26,35,220]),function(me,e,I,L,C,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new T.RawContextKey("taskRunning",!1,I.localize(0,null)),e.TASKS_CATEGORY={value:I.localize(1,null),original:"Tasks"};var h;(function(k){k[k.Escape=1]="Escape",k[k.Strong=2]="Strong",k[k.Weak=3]="Weak"})(h||(e.ShellQuoting=h={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(k){function M($){if(!$)return k.Strong;switch($.toLowerCase()){case"escape":return k.Escape;case"strong":return k.Strong;case"weak":return k.Weak;default:return k.Strong}}k.from=M}(h||(e.ShellQuoting=h={}));var S;(function(k){k.defaults={cwd:"${workspaceFolder}"}})(S||(e.CommandOptions=S={}));var R;(function(k){k[k.Always=1]="Always",k[k.Silent=2]="Silent",k[k.Never=3]="Never"})(R||(e.RevealKind=R={})),function(k){function M($){switch($.toLowerCase()){case"always":return k.Always;case"silent":return k.Silent;case"never":return k.Never;default:return k.Always}}k.fromString=M}(R||(e.RevealKind=R={}));var D;(function(k){k[k.Never=1]="Never",k[k.OnProblem=2]="OnProblem",k[k.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(k){function M($){switch($.toLowerCase()){case"always":return k.Always;case"never":return k.Never;case"onproblem":return k.OnProblem;default:return k.OnProblem}}k.fromString=M}(D||(e.RevealProblemKind=D={}));var u;(function(k){k[k.Shared=1]="Shared",k[k.Dedicated=2]="Dedicated",k[k.New=3]="New"})(u||(e.PanelKind=u={})),function(k){function M($){switch($.toLowerCase()){case"shared":return k.Shared;case"dedicated":return k.Dedicated;case"new":return k.New;default:return k.Shared}}k.fromString=M}(u||(e.PanelKind=u={}));var p;(function(k){k.defaults={echo:!0,reveal:R.Always,revealProblems:D.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var E;(function(k){k[k.Shell=1]="Shell",k[k.Process=2]="Process",k[k.CustomExecution=3]="CustomExecution"})(E||(e.RuntimeType=E={})),function(k){function M(oe){switch(oe.toLowerCase()){case"shell":return k.Shell;case"process":return k.Process;case"customExecution":return k.CustomExecution;default:return k.Process}}k.fromString=M;function $(oe){switch(oe){case k.Shell:return"shell";case k.Process:return"process";case k.CustomExecution:return"customExecution";default:return"process"}}k.toString=$}(E||(e.RuntimeType=E={}));var i;(function(k){function M($){return L.isString($)?$:$.value}k.value=M})(i||(e.CommandString=i={}));var a;(function(k){k.Clean={_id:"clean",isDefault:!1},k.Build={_id:"build",isDefault:!1},k.Rebuild={_id:"rebuild",isDefault:!1},k.Test={_id:"test",isDefault:!1};function M(oe){return oe===k.Clean._id||oe===k.Build._id||oe===k.Rebuild._id||oe===k.Test._id}k.is=M;function $(oe){if(oe!==void 0)return L.isString(oe)?M(oe)?{_id:oe,isDefault:!1}:void 0:oe}k.from=$})(a||(e.TaskGroup=a={}));var r;(function(k){k[k.Global=1]="Global",k[k.Workspace=2]="Workspace",k[k.Folder=3]="Folder"})(r||(e.TaskScope=r={}));var n;(function(k){k.Workspace="workspace",k.Extension="extension",k.InMemory="inMemory",k.WorkspaceFile="workspaceFile",k.User="user";function M($){switch($){case k.User:return 2;case k.WorkspaceFile:return 5;default:return 6}}k.toConfigurationTarget=M})(n||(e.TaskSourceKind=n={}));var o;(function(k){k.parallel="parallel",k.sequence="sequence"})(o||(e.DependsOrder=o={}));var c;(function(k){k[k.default=1]="default",k[k.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var l;(function(k){k.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(l||(e.RunOptions=l={}));class t{constructor(M,$,oe,de,we,ye){this._label="",this._id=M,$&&(this._label=$),oe&&(this.type=oe),this.runOptions=de,this.configurationProperties=we,this._source=ye}getDefinition(M){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const M={folder:this.getFolderId(),id:this._id};return JSON.stringify(M)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(M,$=!1){if(M===void 0)return!1;if(L.isString(M))return M===this._label||M===this.configurationProperties.identifier||$&&M===this._id;const oe=this.getDefinition(!0);return oe!==void 0&&oe._key===M._key}getQualifiedLabel(){const M=this.getWorkspaceFolder();return M?`${this._label} (${M.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(M){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),M&&(this._taskLoadMessages=this._taskLoadMessages.concat(M))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=t;class d extends t{constructor(M,$,oe,de,we,ye,le,ve){super(M,oe,void 0,le,ve,$),this.command={},this._source=$,this.hasDefinedMatchers=ye,we&&(this.command=we)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(M=!1){if(M&&this._source.customizes!==void 0)return this._source.customizes;{let $;switch(this.command?this.command.runtime:void 0){case E.Shell:$="shell";break;case E.Process:$="process";break;case E.CustomExecution:$="customExecution";break;case void 0:$="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:$,_key:this._id,id:this._id}}}static is(M){return M instanceof d}getMapKey(){const M=this._source.config.workspaceFolder;return M?`${M.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===n.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const M=this.getFolderId();if(!M)return;let $=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&($+=this._source.kind);const oe={type:e.CUSTOMIZED_TASK_TYPE,folder:M,id:$};return JSON.stringify(oe)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(M){return new d(M._id,M._source,M._label,M.type,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.CustomTask=d;class s extends t{constructor(M,$,oe,de,we,ye,le){super(M,oe,de,ye,le,$),this._source=$,this.configures=we}static is(M){return M instanceof s}fromObject(M){return M}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===n.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getKey(){const M=this.getFolderId();if(!M)return;let $=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&($+=this._source.kind);const oe={type:e.CUSTOMIZED_TASK_TYPE,folder:M,id:$};return JSON.stringify(oe)}}e.ConfiguringTask=s;class b extends t{constructor(M,$,oe,de,we,ye,le,ve,ae){super(M,oe,de,ve,ae,$),this.defines=we,this.hasDefinedMatchers=le,this.command=ye,this.icon=ae.icon,this.hide=ae.hide}clone(){return new b(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(M){return M instanceof b}getMapKey(){const M=this._source.workspaceFolder;return M?`${this._source.scope.toString()}|${M.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const M={type:"contributed",scope:this._source.scope,id:this._id};return M.folder=this.getFolderId(),JSON.stringify(M)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(M){return new b(M._id,M._source,M._label,M.type,M.defines,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.ContributedTask=b;class _ extends t{constructor(M,$,oe,de,we,ye){super(M,oe,de,we,ye,$),this._source=$}clone(){return new _(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(M){return M instanceof _}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(M){return new _(M._id,M._source,M._label,M.type,M.runOptions,M.configurationProperties)}}e.InMemoryTask=_;var f;(function(k){k[k.Process=1]="Process",k[k.Terminal=2]="Terminal"})(f||(e.ExecutionEngine=f={})),function(k){k._default=k.Terminal}(f||(e.ExecutionEngine=f={}));var w;(function(k){k[k.V0_1_0=1]="V0_1_0",k[k.V2_0_0=2]="V2_0_0"})(w||(e.JsonSchemaVersion=w={}));class P{constructor(M){this._order=new Map;for(let $=0;$<M.length;$++)this._order.set(M[$].uri.toString(),$)}compare(M,$){const oe=M.getWorkspaceFolder(),de=$.getWorkspaceFolder();if(oe&&de){let we=this._order.get(oe.uri.toString());we=we===void 0?0:we+1;let ye=this._order.get(de.uri.toString());return ye=ye===void 0?0:ye+1,we===ye?M._label.localeCompare($._label):we-ye}else return!oe&&de?-1:oe&&!de?1:0}}e.TaskSorter=P;var m;(function(k){k.DependsOnStarted="dependsOnStarted",k.AcquiredInput="acquiredInput",k.Start="start",k.ProcessStarted="processStarted",k.Active="active",k.Inactive="inactive",k.Changed="changed",k.Terminated="terminated",k.ProcessEnded="processEnded",k.End="end"})(m||(e.TaskEventKind=m={}));var v;(function(k){k.SingleRun="singleRun",k.Background="background"})(v||(e.TaskRunType=v={}));var y;(function(k){k[k.System=0]="System",k[k.User=1]="User",k[k.FolderOpen=2]="FolderOpen",k[k.ConfigurationChange=3]="ConfigurationChange",k[k.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var O;(function(k){function M(ve){return{taskId:ve._id,taskName:ve.configurationProperties.name,runType:ve.configurationProperties.isBackground?"background":"singleRun",group:ve.configurationProperties.group,__task:ve}}function $(ve,ae,pe){return{...M(ve),kind:"start",terminalId:ae,resolvedVariables:pe}}k.start=$;function oe(ve,ae,pe){return{...M(ve),kind:"processStarted",terminalId:ae,processId:pe}}k.processStarted=oe;function de(ve,ae,pe){return{...M(ve),kind:"processEnded",terminalId:ae,exitCode:pe}}k.processEnded=de;function we(ve,ae,pe){return{...M(ve),kind:"terminated",exitReason:pe,terminalId:ae}}k.terminated=we;function ye(ve,ae,pe){return{...M(ae),kind:ve,terminalId:pe}}k.general=ye;function le(){return{kind:"changed"}}k.changed=le})(O||(e.TaskEvent=O={}));var N;(function(k){function M(oe){const de=Object.keys(oe).sort();let we="";for(const ye of de){let le=oe[ye];le instanceof Object?le=M(le):typeof le=="string"&&(le=le.replace(/,/g,",,")),we+=ye+","+le+","}return we}function $(oe){const we={_key:M(oe),type:oe.taskType};return Object.assign(we,oe),we}k.create=$})(N||(e.KeyedTaskIdentifier=N={}));var q;(function(k){k.AutoDetect="task.autoDetect",k.SaveBeforeRun="task.saveBeforeRun",k.ShowDecorations="task.showDecorations",k.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",k.SlowProviderWarning="task.slowProviderWarning",k.QuickOpenHistory="task.quickOpen.history",k.QuickOpenDetail="task.quickOpen.detail",k.QuickOpenSkip="task.quickOpen.skip",k.QuickOpenShowAll="task.quickOpen.showAll",k.AllowAutomaticTasks="task.allowAutomaticTasks",k.Reconnection="task.reconnection",k.VerboseLogging="task.verboseLogging"})(q||(e.TaskSettingId=q={}));var W;(function(k){k.Tasks="tasks",k.SuppressTaskName="tasks.suppressTaskName",k.Windows="tasks.windows",k.Osx="tasks.osx",k.Linux="tasks.linux",k.ShowOutput="tasks.showOutput",k.IsShellCommand="tasks.isShellCommand",k.ServiceTestSetting="tasks.service.testSetting"})(W||(e.TasksSchemaProperties=W={}));var x;(function(k){function M($,oe){const de=g.TaskDefinitionRegistry.get($.type);if(de===void 0){const ve=A.deepClone($);return delete ve._key,N.create(ve)}const we=Object.create(null);we.type=de.taskType;const ye=new Set;de.required.forEach(ve=>ye.add(ve));const le=de.properties;for(const ve of Object.keys(le)){const ae=$[ve];if(ae!=null)we[ve]=ae;else if(ye.has(ve)){const pe=le[ve];if(pe.default!==void 0)we[ve]=A.deepClone(pe.default);else switch(pe.type){case"boolean":we[ve]=!1;break;case"number":case"integer":we[ve]=0;break;case"string":we[ve]="";break;default:oe.error(I.localize(2,null,JSON.stringify($,void 0,0),ve));return}}}return N.create(we)}k.createTaskIdentifier=M})(x||(e.TaskDefinition=x={}))}),define(Pe[222],Te([1,0,15]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,g)=>{this._actualOk=T,this._actualErr=g,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,I.onUnexpectedError)(T))}then(T,g){return this._ensureActual().then(T,g)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=L;class C extends L{constructor(){super(),this._hasErr=!0,this._err=new I.CancellationError}}e.CanceledLazyPromise=C}),define(Pe[49],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class I{static{this.count=0}constructor(h){this._proxyIdentifierBrand=void 0,this.sid=h,this.nid=++I.count}}e.ProxyIdentifier=I;const L=[];function C(g){const h=new I(g);return L[h.nid]=h,h}e.createProxyIdentifier=C;function A(g){return L[g].sid}e.getStringIdentifierForProxy=A;class T{constructor(h){this.value=h}}e.SerializableObjectWithBuffers=T}),define(Pe[3],Te([1,0,49]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var L;(function(i){i[i.Default=0]="Default",i[i.InCenter=1]="InCenter",i[i.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",i[i.AtTop=3]="AtTop"})(L||(e.TextEditorRevealType=L={}));var C;(function(i){i[i.UnknownInput=0]="UnknownInput",i[i.TextInput=1]="TextInput",i[i.TextDiffInput=2]="TextDiffInput",i[i.TextMergeInput=3]="TextMergeInput",i[i.NotebookInput=4]="NotebookInput",i[i.NotebookDiffInput=5]="NotebookDiffInput",i[i.CustomEditorInput=6]="CustomEditorInput",i[i.WebviewEditorInput=7]="WebviewEditorInput",i[i.TerminalEditorInput=8]="TerminalEditorInput",i[i.InteractiveEditorInput=9]="InteractiveEditorInput",i[i.ChatEditorInput=10]="ChatEditorInput"})(C||(e.TabInputKind=C={}));var A;(function(i){i[i.TAB_OPEN=0]="TAB_OPEN",i[i.TAB_CLOSE=1]="TAB_CLOSE",i[i.TAB_UPDATE=2]="TAB_UPDATE",i[i.TAB_MOVE=3]="TAB_MOVE"})(A||(e.TabModelOperationKind=A={}));var T;(function(i){i[i.Editable=0]="Editable",i[i.SupportsHotExit=1]="SupportsHotExit"})(T||(e.WebviewEditorCapabilities=T={}));var g;(function(i){i[i.Int8Array=1]="Int8Array",i[i.Uint8Array=2]="Uint8Array",i[i.Uint8ClampedArray=3]="Uint8ClampedArray",i[i.Int16Array=4]="Int16Array",i[i.Uint16Array=5]="Uint16Array",i[i.Int32Array=6]="Int32Array",i[i.Uint32Array=7]="Uint32Array",i[i.Float32Array=8]="Float32Array",i[i.Float64Array=9]="Float64Array",i[i.BigInt64Array=10]="BigInt64Array",i[i.BigUint64Array=11]="BigUint64Array"})(g||(e.WebviewMessageArrayBufferViewType=g={}));var h;(function(i){i[i.Text=1]="Text",i[i.Error=2]="Error",i[i.Rich=3]="Rich"})(h||(e.CellOutputKind=h={}));var S;(function(i){i[i.Default=0]="Default",i[i.InCenter=1]="InCenter",i[i.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",i[i.AtTop=3]="AtTop"})(S||(e.NotebookEditorRevealType=S={}));var R;(function(i){i[i.None=0]="None",i[i.Process=1]="Process",i[i.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class D{static{this._n=0}static mixin(a){return a._id=D._n++,a}}e.IdObject=D;var u;(function(i){i.label="a",i.kind="b",i.detail="c",i.documentation="d",i.sortText="e",i.filterText="f",i.preselect="g",i.insertText="h",i.insertTextRules="i",i.range="j",i.commitCharacters="k",i.additionalTextEdits="l",i.kindModifier="m",i.commandIdent="n",i.commandId="o",i.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var p;(function(i){i.defaultRanges="a",i.completions="b",i.isIncomplete="c",i.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var E;(function(i){i[i.Workspace=0]="Workspace",i[i.TextDocument=1]="TextDocument"})(E||(e.ExtHostTestingResource=E={})),e.MainContext={MainThreadAuthentication:(0,I.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadChatProvider:(0,I.createProxyIdentifier)("MainThreadChatProvider"),MainThreadChatAgents2:(0,I.createProxyIdentifier)("MainThreadChatAgents2"),MainThreadChatVariables:(0,I.createProxyIdentifier)("MainThreadChatVariables"),MainThreadClipboard:(0,I.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createProxyIdentifier)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,I.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,I.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,I.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createProxyIdentifier)("MainThreadStorage"),MainThreadSpeech:(0,I.createProxyIdentifier)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,I.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createProxyIdentifier)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,I.createProxyIdentifier)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,I.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,I.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,I.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.createProxyIdentifier)("MainThreadInteractive"),MainThreadChat:(0,I.createProxyIdentifier)("MainThreadChat"),MainThreadInlineChat:(0,I.createProxyIdentifier)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,I.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.createProxyIdentifier)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.createProxyIdentifier)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,I.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,I.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,I.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,I.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.createProxyIdentifier)("ExtHostOutputService"),ExtHostLabelService:(0,I.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.createProxyIdentifier)("ExtHostInteractive"),ExtHostInlineChat:(0,I.createProxyIdentifier)("ExtHostInlineChatShape"),ExtHostChat:(0,I.createProxyIdentifier)("ExtHostChat"),ExtHostChatAgents2:(0,I.createProxyIdentifier)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.createProxyIdentifier)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.createProxyIdentifier)("ExtHostChatProvider"),ExtHostSpeech:(0,I.createProxyIdentifier)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,I.createProxyIdentifier)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.createProxyIdentifier)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,I.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,I.createProxyIdentifier)("ExtHostIssueReporter")}}),define(Pe[79],Te([1,0,4,14,3,17]),function(me,e,I,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,I.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(h,S){this._extHostLogService=S,this._reportedUsages=new Set,this._telemetryShape=h.getProxy(C.MainContext.MainThreadTelemetry)}report(h,S,R){const D=this.getUsageKey(h,S);this._reportedUsages.has(D)||(this._reportedUsages.add(D),S.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${h}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:S.identifier.value,apiId:h}))}getUsageKey(h,S){return`${h}-${S.identifier.value}`}};e.ExtHostApiDeprecationService=T,e.ExtHostApiDeprecationService=T=Ke([We(0,A.IExtHostRpcService),We(1,L.ILogService)],T),e.NullApiDeprecationService=Object.freeze(new class{report(g,h,S){}})}),define(Pe[223],Te([1,0,3]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(A){const T=A.getProxy(I.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(g){return T.$writeText(g)}})}}e.ExtHostClipboard=L}),define(Pe[224],Te([1,0,26,3,27,17]),function(me,e,I,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let T=class{constructor(R,D){this._mainThreadConsole=R.getProxy(L.MainContext.MainThreadConsole),this._includeStack=D.consoleForward.includeStack,this._logNative=D.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("debug","debug"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(R,D){const u=this,p=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){u._handleConsoleCall(R,D,p,arguments)}})}_handleConsoleCall(R,D,u,p){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:D,arguments:h(p,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(R,u,p)}};e.AbstractExtHostConsoleForwarder=T,e.AbstractExtHostConsoleForwarder=T=Ke([We(0,A.IExtHostRpcService),We(1,C.IExtHostInitDataService)],T);const g=1e5;function h(S,R){const D=[];if(S.length)for(let u=0;u<S.length;u++){let p=S[u];if(typeof p>"u")p="undefined";else if(p instanceof Error){const E=p;E.stack?p=E.stack:p=E.toString()}D.push(p)}if(R){const u=new Error().stack;u&&D.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,I.safeStringify)(D);return u.length>g?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Pe[225],Te([1,0,2,3,24]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class A{constructor(g){this._proxy=g.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(g,h){return h?.allowUIResources&&(0,C.checkProposedApiEnabled)(g,"showLocal"),this._proxy.$showOpenDialog(h).then(S=>S?S.map(R=>I.URI.revive(R)):void 0)}showSaveDialog(g){return this._proxy.$showSaveDialog(g).then(h=>h?I.URI.revive(h):void 0)}}e.ExtHostDialogs=A}),define(Pe[226],Te([1,0,6,3]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class C{constructor(T){this._handlePool=0,this._proxy=T.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const g=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(g,T),(0,I.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(g)})}}e.ExtHostLabelService=C}),define(Pe[80],Te([1,0,21,12,2,4,14,3,27,17]),function(me,e,I,L,C,A,T,g,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let R=class{constructor(u,p,E){this.logService=E,this.bundleCache=new Map,this._proxy=p.getProxy(g.MainContext.MainThreadLocalization),this.currentLanguage=u.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===I.LANGUAGE_DEFAULT}getMessage(u,p){const{message:E,args:i,comment:a}=p;if(this.isDefaultLanguage)return(0,L.format2)(E,i??{});let r=E;a&&a.length>0&&(r+=`/${Array.isArray(a)?a.join(""):a}`);const n=this.bundleCache.get(u)?.contents[r];return n||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${r}`),(0,L.format2)(n??E,i??{})}getBundle(u){return this.bundleCache.get(u)?.contents}getBundleUri(u){return this.bundleCache.get(u)?.uri}async initializeLocalizedMessages(u){if(this.isDefaultLanguage||!u.l10n&&!u.isBuiltin||this.bundleCache.has(u.identifier.value))return;let p;const E=await this.getBundleLocation(u);if(!E){this.logService.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const i=await this._proxy.$fetchBundleContents(E),a=JSON.parse(i);p=u.isBuiltin?a.contents?.bundle:a}catch(i){this.logService.error(`Failed to load translations for ${u.identifier.value} from ${E}: ${i.message}`);return}p&&this.bundleCache.set(u.identifier.value,{contents:p,uri:E})}async getBundleLocation(u){if(u.isBuiltin){const p=await this._proxy.$fetchBuiltInBundleUri(u.identifier.value,this.currentLanguage);return C.URI.revive(p)}return u.l10n?C.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=R,e.ExtHostLocalizationService=R=Ke([We(0,h.IExtHostInitDataService),We(1,S.IExtHostRpcService),We(2,T.ILogService)],R),e.IExtHostLocalizationService=(0,A.createDecorator)("IExtHostLocalizationService")}),define(Pe[227],Te([1,0,14,3,27,17,2,51]),function(me,e,I,L,C,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let h=class extends I.AbstractLoggerService{constructor(D,u){super(u.logLevel,u.logsLocation,u.loggers.map(p=>(0,g.revive)(p))),this._proxy=D.getProxy(L.MainContext.MainThreadLogger)}$setLogLevel(D,u){u?this.setLogLevel(T.URI.revive(u),D):this.setLogLevel(D)}setVisibility(D,u){super.setVisibility(D,u),this._proxy.$setVisibility(D,u)}doCreateLogger(D,u,p){return new S(this._proxy,D,u,p)}};e.ExtHostLoggerService=h,e.ExtHostLoggerService=h=Ke([We(0,A.IExtHostRpcService),We(1,C.IExtHostInitDataService)],h);class S extends I.AbstractMessageLogger{constructor(D,u,p,E){super(E?.logLevel==="always"),this.proxy=D,this.file=u,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(p),this.proxy.$createLogger(u,E).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(D,u){const p=[[D,u]];this.isLoggerCreated?this.doLog(p):this.buffer.push(...p)}doLog(D){this.proxy.$log(this.file,D)}flush(){this.proxy.$flush(this.file)}}}),define(Pe[81],Te([1,0,3,4,6,17,23]),function(me,e,I,L,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,L.createDecorator)("IExtHostManagedSockets");let g=class{constructor(D){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=D.getProxy(I.MainContext.MainThreadManagedSockets)}setFactory(D,u){for(const p of this._managedRemoteSockets.values())p.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new h(D,u),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(D){if(!this._factory||this._factory.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const u=++this._remoteSocketIdCounter,p=await this._factory.makeConnection(),E=new C.DisposableStore;return this._managedRemoteSockets.set(u,new S(u,p,E)),E.add((0,C.toDisposable)(()=>this._managedRemoteSockets.delete(u))),E.add(p.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(u),E.dispose()})),E.add(p.onDidClose(i=>{this._proxy.$onDidManagedSocketClose(u,i?.stack??i?.message),E.dispose()})),E.add(p.onDidReceiveMessage(i=>this._proxy.$onDidManagedSocketHaveData(u,T.VSBuffer.wrap(i)))),u}$remoteSocketWrite(D,u){this._managedRemoteSockets.get(D)?.actual.send(u.buffer)}$remoteSocketEnd(D){const u=this._managedRemoteSockets.get(D);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(D){await this._managedRemoteSockets.get(D)?.actual.drain?.()}};e.ExtHostManagedSockets=g,e.ExtHostManagedSockets=g=Ke([We(0,A.IExtHostRpcService)],g);class h{constructor(D,u){this.socketFactoryId=D,this.makeConnection=u}}class S extends C.Disposable{constructor(D,u,p){super(),this.socketId=D,this.actual=u,this._register(p)}}}),define(Pe[228],Te([1,0,3,14,24]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(g){return g&&g.title}let T=class{constructor(h,S){this._logService=S,this._proxy=h.getProxy(I.MainContext.MainThreadMessageService)}showMessage(h,S,R,D,u){const p={source:{identifier:h.identifier,label:h.displayName||h.name}};let E;typeof D=="string"||A(D)?E=[D,...u]:(p.modal=D?.modal,p.useCustom=D?.useCustom,p.detail=D?.detail,E=u),p.useCustom&&(0,C.checkProposedApiEnabled)(h,"resolvers");const i=[];let a=!1;for(let r=0;r<E.length;r++){const n=E[r];if(typeof n=="string")i.push({title:n,handle:r,isCloseAffordance:!1});else if(typeof n=="object"){const{title:o,isCloseAffordance:c}=n;i.push({title:o,isCloseAffordance:!!c,handle:r}),c&&(a?this._logService.warn(`[${h.identifier}] Only one message item can have 'isCloseAffordance':`,n):a=!0)}else this._logService.warn(`[${h.identifier}] Invalid message item:`,n)}return this._proxy.$showMessage(S,R,p,i).then(r=>{if(typeof r=="number")return E[r]})}};e.ExtHostMessageService=T,e.ExtHostMessageService=T=Ke([We(1,L.ILogService)],T)}),define(Pe[229],Te([1,0,6,16,2,24,3]),function(me,e,I,L,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class g{constructor(S){this.handlers=new Map,this.proxy=S.getProxy(T.MainContext.MainThreadProfileContentHandlers)}registerProfileContentHandler(S,R,D){if((0,A.checkProposedApiEnabled)(S,"profileContentHandlers"),this.handlers.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.handlers.set(R,D),this.proxy.$registerProfileContentHandler(R,D.name,D.description,S.identifier.value),(0,I.toDisposable)(()=>{this.handlers.delete(R),this.proxy.$unregisterProfileContentHandler(R)})}async $saveProfile(S,R,D,u){const p=this.handlers.get(S);if(!p)throw new Error(`Unknown handler with id: ${S}`);return p.saveProfile(R,D,u)}async $readProfile(S,R,D){const u=this.handlers.get(S);if(!u)throw new Error(`Unknown handler with id: ${S}`);return u.readProfile((0,L.isString)(R)?R:C.URI.revive(R),D)}}e.ExtHostProfileContentHandlers=g}),define(Pe[82],Te([1,0,3,5,4]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(g){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=g.getProxy(I.MainContext.MainThreadSecretState)}async $onDidChangePassword(g){this._onDidChangePassword.fire(g)}get(g,h){return this._proxy.$getPassword(g,h)}store(g,h,S){return this._proxy.$setPassword(g,h,S)}delete(g,h){return this._proxy.$deletePassword(g,h)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,C.createDecorator)("IExtHostSecretState")}),define(Pe[230],Te([1,0,20,6,3]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSpeech=void 0;class A{static{this.ID_POOL=1}constructor(g){this.providers=new Map,this.sessions=new Map,this.proxy=g.getProxy(C.MainContext.MainThreadSpeech)}async $createSpeechToTextSession(g,h){const S=this.providers.get(g);if(!S)return;const R=new L.DisposableStore,D=new I.CancellationTokenSource;this.sessions.set(h,D);const u=R.add(S.provideSpeechToTextSession(D.token));R.add(u.onDidChange(p=>{D.token.isCancellationRequested||this.proxy.$emitSpeechToTextEvent(h,p)})),R.add(D.token.onCancellationRequested(()=>R.dispose()))}async $cancelSpeechToTextSession(g){this.sessions.get(g)?.dispose(!0),this.sessions.delete(g)}async $createKeywordRecognitionSession(g,h){const S=this.providers.get(g);if(!S)return;const R=new L.DisposableStore,D=new I.CancellationTokenSource;this.sessions.set(h,D);const u=R.add(S.provideKeywordRecognitionSession(D.token));R.add(u.onDidChange(p=>{D.token.isCancellationRequested||this.proxy.$emitKeywordRecognitionEvent(h,p)})),R.add(D.token.onCancellationRequested(()=>R.dispose()))}async $cancelKeywordRecognitionSession(g){this.sessions.get(g)?.dispose(!0),this.sessions.delete(g)}registerProvider(g,h,S){const R=A.ID_POOL++;return this.providers.set(R,S),this.proxy.$registerProvider(R,h,{extension:g,displayName:g.value}),(0,L.toDisposable)(()=>{this.proxy.$unregisterProvider(R),this.providers.delete(R)})}}e.ExtHostSpeech=A}),define(Pe[83],Te([1,0,3,5,4]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(g,h){this._logService=h,this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=g.getProxy(I.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(g,h){this._proxy.$registerExtensionStorageKeysToSync(g,h)}async initializeExtensionStorage(g,h,S){const R=await this._proxy.$initializeExtensionStorage(g,h);let D;return R&&(D=this.safeParseValue(g,h,R)),D||S}setValue(g,h,S){return this._proxy.$setValue(g,h,S)}$acceptValue(g,h,S){const R=this.safeParseValue(g,h,S);R&&this._onDidChangeStorage.fire({shared:g,key:h,value:R})}safeParseValue(g,h,S){try{return JSON.parse(S)}catch(R){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${h}, global: ${g}): ${R}`)}}}e.ExtHostStorage=A,e.IExtHostStorage=(0,C.createDecorator)("IExtHostStorage")}),define(Pe[231],Te([1,0,6,11,2,3]),function(me,e,I,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{static{this.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}constructor(h){this._openers=new Map,this._proxy=h.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(h,S,R,D){if(this._openers.has(S))throw new Error(`Opener with id '${S}' already registered`);const u=D.schemes.find(p=>!T.supportedSchemes.has(p));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this._openers.set(S,R),this._proxy.$registerUriOpener(S,D.schemes,h,D.label),(0,I.toDisposable)(()=>{this._openers.delete(S),this._proxy.$unregisterUriOpener(S)})}async $canOpenUri(h,S,R){const D=this._openers.get(h);if(!D)throw new Error(`Unknown opener with id: ${h}`);const u=C.URI.revive(S);return D.canOpenExternalUri(u,R)}async $openUri(h,S,R){const D=this._openers.get(h);if(!D)throw new Error(`Unknown opener id: '${h}'`);return D.openExternalUri(C.URI.revive(S.resolvedUri),{sourceUri:C.URI.revive(S.sourceUri)},R)}}e.ExtHostUriOpeners=T}),define(Pe[232],Te([1,0,3,2,6,15,22]),function(me,e,I,L,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class g{static{this.HandlePool=0}constructor(S){this.handles=new T.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=S.getProxy(I.MainContext.MainThreadUrls)}registerUriHandler(S,R){const D=S.identifier;if(this.handles.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const u=g.HandlePool++;return this.handles.add(D),this.handlers.set(u,R),this._proxy.$registerUriHandler(u,D,S.displayName||S.name),(0,C.toDisposable)(()=>{this.handles.delete(D),this.handlers.delete(u),this._proxy.$unregisterUriHandler(u)})}$handleExternalUri(S,R){const D=this.handlers.get(S);if(!D)return Promise.resolve(void 0);try{D.handleUri(L.URI.revive(R))}catch(u){(0,A.onUnexpectedError)(u)}return Promise.resolve(void 0)}async createAppUri(S){return L.URI.revive(await this._proxy.$createAppUri(S))}}e.ExtHostUrls=g}),define(Pe[61],Te([1,0,5,6,11,26,2,181,203,77,3]),function(me,e,I,L,C,A,T,g,h,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class D{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#h;constructor(c,l,t,d,s,b,_){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new I.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new I.Emitter,this._onDidDispose=this.#d.event,this.#e=c,this.#t=l,this.#o=t,this.#n=d,this.#s=s,this.#r=b,this.#u=u(b),this.#h=p(b),this.#i=_}#d;dispose(){this.#c=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#l=!0,(0,S.asWebviewUri)(c,this.#n)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===C.Schemas.https||c.scheme===C.Schemas.http){let l=c.toString();return l.endsWith("/")||(l+="/"),l+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#a}set html(c){this.assertNotDisposed(),this.#a!==c&&(this.#a=c,this.#h&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(c)))}get options(){return this.assertNotDisposed(),this.#o}set options(c){this.assertNotDisposed(),A.equals(this.#o,c)||this.#t.$setOptions(this.#e,a(this.#r,this.#s,c)),this.#o=c}async postMessage(c){if(this.#c)return!1;const l=(0,h.serializeWebviewMessage)(c,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,l.message,...l.buffers)}assertNotDisposed(){if(this.#c)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(c){if(!this.#h)return c;const l=this.#r.extensionLocation?.scheme===C.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(d,s,b,_,f,w)=>{const P=T.URI.from({scheme:_||"file",path:decodeURIComponent(f)}),m=(0,S.asWebviewUri)(P,{isRemote:l,authority:t}).toString();return`${s}${m}${w}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(d,s,b,_,f,w)=>{const P=T.URI.from({scheme:_||"file",path:decodeURIComponent(f)}),m=(0,S.asWebviewUri)(P,{isRemote:l,authority:t}).toString();return`${s}${m}${w}`})}}e.ExtHostWebview=D;function u(o){try{const c=(0,g.normalizeVersion)((0,g.parseVersion)(o.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=u;function p(o){try{const c=(0,g.normalizeVersion)((0,g.parseVersion)(o.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class E extends L.Disposable{constructor(c,l,t,d,s){super(),this.remoteInfo=l,this.workspace=t,this._logService=d,this._deprecationService=s,this._webviews=new Map,this._webviewProxy=c.getProxy(R.MainContext.MainThreadWebviews)}dispose(){super.dispose();for(const c of this._webviews.values())c.dispose();this._webviews.clear()}$onMessage(c,l,t){const d=this.getWebview(c);if(d){const{message:s}=(0,h.deserializeWebviewMessage)(l,t.value);d._onMessageEmitter.fire(s)}}$onMissingCsp(c,l){this._logService.warn(`${l} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,l,t){const d=new D(c,this._webviewProxy,r(l),this.remoteInfo,this.workspace,t,this._deprecationService);this._webviews.set(c,d);const s=d._onDidDispose(()=>{s.dispose(),this.deleteWebview(c)});return d}deleteWebview(c){this._webviews.delete(c)}getWebview(c){return this._webviews.get(c)}}e.ExtHostWebviews=E;function i(o){return{id:o.identifier,location:o.extensionLocation}}e.toExtensionData=i;function a(o,c,l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots||n(o,c)}}e.serializeWebviewOptions=a;function r(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(c=>T.URI.from(c))}}function n(o,c){return[...(c?.getWorkspaceFolders()||[]).map(l=>l.uri),o.extensionLocation]}}),define(Pe[106],Te([1,0,5,3,2,11,12,4,17,24]),function(me,e,I,L,C,A,T,g,h,S){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let D=class{static{R=this}static{this.InitialState={focused:!0,active:!0}}getState(p){const E=this._state;return{get focused(){return E.focused},get active(){return(0,S.checkProposedApiEnabled)(p,"windowActivity"),E.active}}}constructor(p){this._onDidChangeWindowState=new I.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=R.InitialState,this._proxy=p.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:E,isActive:i})=>{this.onDidChangeWindowProperty("focused",E),this.onDidChangeWindowProperty("active",i)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,E){E!==this._state[p]&&(this._state={...this._state,[p]:E},this._onDidChangeWindowState.fire(this._state))}openUri(p,E){let i;if(typeof p=="string"){i=p;try{p=C.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,T.isFalsyOrWhitespace)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this._proxy.$openUri(p,i,E)}async asExternalUri(p,E){if((0,T.isFalsyOrWhitespace)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const i=await this._proxy.$asExternalUri(p,E);return C.URI.from(i)}};e.ExtHostWindow=D,e.ExtHostWindow=D=R=Ke([We(0,h.IExtHostRpcService)],D),e.IExtHostWindow=(0,g.createDecorator)("IExtHostWindow")}),define(Pe[233],Te([1,0,224,27,17]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let A=class extends I.AbstractExtHostConsoleForwarder{constructor(g,h){super(g,h)}_nativeConsoleLogMessage(g,h,S){h.apply(console,S)}};e.ExtHostConsoleForwarder=A,e.ExtHostConsoleForwarder=A=Ke([We(0,C.IExtHostRpcService),We(1,L.IExtHostInitDataService)],A)}),define(Pe[234],Te([1,0,13,23,20,15,5,6,139,222,49]),function(me,e,I,L,C,A,T,g,h,S,R){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function u(y,O){try{return JSON.stringify(y,O)}catch{return"null"}}const p="$$ref$$",E={[p]:-1};class i{constructor(O,N){this.jsonString=O,this.referencedBuffers=N}}function a(y,O=null,N=!1){const q=[];return{jsonString:(N?u:JSON.stringify)(y,(x,k)=>{if(typeof k>"u")return E;if(typeof k=="object"){if(k instanceof L.VSBuffer){const M=q.push(k)-1;return{[p]:M}}if(O)return O(x,k)}return k}),referencedBuffers:q}}e.stringifyJsonWithBufferRefs=a;function r(y,O,N){return JSON.parse(y,(q,W)=>{if(W){const x=W[p];if(typeof x=="number")return O[x];if(N&&W.$mid===1)return N.transformIncoming(W)}return W})}e.parseJsonAndRestoreBufferRefs=r;function n(y,O){return JSON.stringify(y,O)}function o(y){return y?(O,N)=>N&&N.$mid===1?y.transformOutgoing(N):N:null}var c;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var l;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const t=()=>{},d=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class b extends g.Disposable{static{D=d}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(O,N=null,q=null){super(),this[D]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=O,this._logger=N,this._uriTransformer=q,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let W=0,x=R.ProxyIdentifier.count;W<x;W++)this._locals[W]=null,this._proxies[W]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new I.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(W=>this._receiveOneMessage(W))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(O=>{const N=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O],N.resolveErr(A.canceled())}),super.dispose()}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(O){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+b.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(O){this._unresponsiveTime=Date.now()+b.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(O){this._responsiveState!==O&&(this._responsiveState=O,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(O){return this._uriTransformer?(0,h.transformIncomingURIs)(O,this._uriTransformer):O}getProxy(O){const{nid:N,sid:q}=O;return this._proxies[N]||(this._proxies[N]=this._createProxy(N,q)),this._proxies[N]}_createProxy(O,N){const q={get:(W,x)=>(typeof x=="string"&&!W[x]&&x.charCodeAt(0)===36&&(W[x]=(...k)=>this._remoteCall(O,x,k)),x===s?N:W[x])};return new Proxy(Object.create(null),q)}set(O,N){return this._locals[O.nid]=N,N}assertRegistered(O){for(let N=0,q=O.length;N<q;N++){const W=O[N];if(!this._locals[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}_receiveOneMessage(O){if(this._isDisposed)return;const N=O.byteLength,q=f.read(O,0),W=q.readUInt8(),x=q.readUInt32();switch(W){case 1:case 2:{let{rpcId:k,method:M,args:$}=P.deserializeRequestJSONArgs(q);this._uriTransformer&&($=(0,h.transformIncomingURIs)($,this._uriTransformer)),this._receiveRequest(N,x,k,M,$,W===2);break}case 3:case 4:{let{rpcId:k,method:M,args:$}=P.deserializeRequestMixedArgs(q);this._uriTransformer&&($=(0,h.transformIncomingURIs)($,this._uriTransformer)),this._receiveRequest(N,x,k,M,$,W===4);break}case 5:{this._logger?.logIncoming(N,x,0,"ack"),this._onDidReceiveAcknowledge(x);break}case 6:{this._receiveCancel(N,x);break}case 7:{this._receiveReply(N,x,void 0);break}case 9:{let k=P.deserializeReplyOKJSON(q);this._uriTransformer&&(k=(0,h.transformIncomingURIs)(k,this._uriTransformer)),this._receiveReply(N,x,k);break}case 10:{const k=P.deserializeReplyOKJSONWithBuffers(q,this._uriTransformer);this._receiveReply(N,x,k);break}case 8:{const k=P.deserializeReplyOKVSBuffer(q);this._receiveReply(N,x,k);break}case 11:{let k=P.deserializeReplyErrError(q);this._uriTransformer&&(k=(0,h.transformIncomingURIs)(k,this._uriTransformer)),this._receiveReplyErr(N,x,k);break}case 12:{this._receiveReplyErr(N,x,void 0);break}default:console.error("received unexpected message"),console.error(O)}}_receiveRequest(O,N,q,W,x,k){this._logger?.logIncoming(O,N,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(q)}.${W}(`,x);const M=String(N);let $,oe;if(k){const we=new C.CancellationTokenSource;x.push(we.token),$=this._invokeHandler(q,W,x),oe=()=>we.cancel()}else $=this._invokeHandler(q,W,x),oe=t;this._cancelInvokedHandlers[M]=oe;const de=P.serializeAcknowledged(N);this._logger?.logOutgoing(de.byteLength,N,1,"ack"),this._protocol.send(de),$.then(we=>{delete this._cancelInvokedHandlers[M];const ye=P.serializeReplyOK(N,we,this._uriReplacer);this._logger?.logOutgoing(ye.byteLength,N,1,"reply:",we),this._protocol.send(ye)},we=>{delete this._cancelInvokedHandlers[M];const ye=P.serializeReplyErr(N,we);this._logger?.logOutgoing(ye.byteLength,N,1,"replyErr:",we),this._protocol.send(ye)})}_receiveCancel(O,N){this._logger?.logIncoming(O,N,1,"receiveCancel");const q=String(N);this._cancelInvokedHandlers[q]?.()}_receiveReply(O,N,q){this._logger?.logIncoming(O,N,0,"receiveReply:",q);const W=String(N);if(!this._pendingRPCReplies.hasOwnProperty(W))return;const x=this._pendingRPCReplies[W];delete this._pendingRPCReplies[W],x.resolveOk(q)}_receiveReplyErr(O,N,q){this._logger?.logIncoming(O,N,0,"receiveReplyErr:",q);const W=String(N);if(!this._pendingRPCReplies.hasOwnProperty(W))return;const x=this._pendingRPCReplies[W];delete this._pendingRPCReplies[W];let k;q&&(q.$isError?(k=new Error,k.name=q.name,k.message=q.message,k.stack=q.stack):k=q),x.resolveErr(k)}_invokeHandler(O,N,q){try{return Promise.resolve(this._doInvokeHandler(O,N,q))}catch(W){return Promise.reject(W)}}_doInvokeHandler(O,N,q){const W=this._locals[O];if(!W)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(O));const x=W[N];if(typeof x!="function")throw new Error("Unknown method "+N+" on actor "+(0,R.getStringIdentifierForProxy)(O));return x.apply(W,q)}_remoteCall(O,N,q){if(this._isDisposed)return new S.CanceledLazyPromise;let W=null;if(q.length>0&&C.CancellationToken.isCancellationToken(q[q.length-1])&&(W=q.pop()),W&&W.isCancellationRequested)return Promise.reject(A.canceled());const x=P.serializeRequestArguments(q,this._uriReplacer),k=++this._lastMessageId,M=String(k),$=new S.LazyPromise,oe=new g.DisposableStore;W&&oe.add(W.onCancellationRequested(()=>{const we=P.serializeCancel(k);this._logger?.logOutgoing(we.byteLength,k,0,"cancel"),this._protocol.send(P.serializeCancel(k))})),this._pendingRPCReplies[M]=new _($,oe),this._onWillSendRequest(k);const de=P.serializeRequest(k,O,N,x,!!W);return this._logger?.logOutgoing(de.byteLength,k,0,`request: ${(0,R.getStringIdentifierForProxy)(O)}.${N}(`,q),this._protocol.send(de),$}}e.RPCProtocol=b;class _{constructor(O,N){this._promise=O,this._disposable=N}resolveOk(O){this._promise.resolveOk(O),this._disposable.dispose()}resolveErr(O){this._promise.resolveErr(O),this._disposable.dispose()}}class f{static alloc(O,N,q){const W=new f(L.VSBuffer.alloc(q+1+4),0);return W.writeUInt8(O),W.writeUInt32(N),W}static read(O,N){return new f(O,N)}get buffer(){return this._buff}constructor(O,N){this._buff=O,this._offset=N}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(O){this._buff.writeUInt8(O,this._offset),this._offset+=1}readUInt8(){const O=this._buff.readUInt8(this._offset);return this._offset+=1,O}writeUInt32(O){this._buff.writeUInt32BE(O,this._offset),this._offset+=4}readUInt32(){const O=this._buff.readUInt32BE(this._offset);return this._offset+=4,O}static sizeShortString(O){return 1+O.byteLength}writeShortString(O){this._buff.writeUInt8(O.byteLength,this._offset),this._offset+=1,this._buff.set(O,this._offset),this._offset+=O.byteLength}readShortString(){const O=this._buff.readUInt8(this._offset);this._offset+=1;const q=this._buff.slice(this._offset,this._offset+O).toString();return this._offset+=O,q}static sizeLongString(O){return 4+O.byteLength}writeLongString(O){this._buff.writeUInt32BE(O.byteLength,this._offset),this._offset+=4,this._buff.set(O,this._offset),this._offset+=O.byteLength}readLongString(){const O=this._buff.readUInt32BE(this._offset);this._offset+=4;const q=this._buff.slice(this._offset,this._offset+O).toString();return this._offset+=O,q}writeBuffer(O){this._buff.writeUInt32BE(O.byteLength,this._offset),this._offset+=4,this._buff.set(O,this._offset),this._offset+=O.byteLength}static sizeVSBuffer(O){return 4+O.byteLength}writeVSBuffer(O){this._buff.writeUInt32BE(O.byteLength,this._offset),this._offset+=4,this._buff.set(O,this._offset),this._offset+=O.byteLength}readVSBuffer(){const O=this._buff.readUInt32BE(this._offset);this._offset+=4;const N=this._buff.slice(this._offset,this._offset+O);return this._offset+=O,N}static sizeMixedArray(O){let N=0;N+=1;for(let q=0,W=O.length;q<W;q++){const x=O[q];switch(N+=1,x.type){case 1:N+=this.sizeLongString(x.value);break;case 2:N+=this.sizeVSBuffer(x.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(x.value);for(let k=0;k<x.buffers.length;++k)N+=this.sizeVSBuffer(x.buffers[k]);break;case 4:break}}return N}writeMixedArray(O){this._buff.writeUInt8(O.length,this._offset),this._offset+=1;for(let N=0,q=O.length;N<q;N++){const W=O[N];switch(W.type){case 1:this.writeUInt8(1),this.writeLongString(W.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(W.value);break;case 3:this.writeUInt8(3),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let x=0;x<W.buffers.length;++x)this.writeBuffer(W.buffers[x]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const O=this._buff.readUInt8(this._offset);this._offset+=1;const N=new Array(O);for(let q=0;q<O;q++)switch(this.readUInt8()){case 1:N[q]=this.readLongString();break;case 2:N[q]=this.readVSBuffer();break;case 3:{const x=this.readUInt32(),k=this.readLongString(),M=[];for(let $=0;$<x;++$)M.push(this.readVSBuffer());N[q]=new R.SerializableObjectWithBuffers(r(k,M,null));break}case 4:N[q]=void 0;break}return N}}var w;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(w||(w={}));class P{static _useMixedArgSerialization(O){for(let N=0,q=O.length;N<q;N++)if(O[N]instanceof L.VSBuffer||O[N]instanceof R.SerializableObjectWithBuffers||typeof O[N]>"u")return!0;return!1}static serializeRequestArguments(O,N){if(this._useMixedArgSerialization(O)){const q=[];for(let W=0,x=O.length;W<x;W++){const k=O[W];if(k instanceof L.VSBuffer)q[W]={type:2,value:k};else if(typeof k>"u")q[W]={type:4};else if(k instanceof R.SerializableObjectWithBuffers){const{jsonString:M,referencedBuffers:$}=a(k.value,N);q[W]={type:3,value:L.VSBuffer.fromString(M),buffers:$}}else q[W]={type:1,value:L.VSBuffer.fromString(n(k,N))}}return{type:1,args:q}}return{type:0,args:n(O,N)}}static serializeRequest(O,N,q,W,x){switch(W.type){case 0:return this._requestJSONArgs(O,N,q,W.args,x);case 1:return this._requestMixedArgs(O,N,q,W.args,x)}}static _requestJSONArgs(O,N,q,W,x){const k=L.VSBuffer.fromString(q),M=L.VSBuffer.fromString(W);let $=0;$+=f.sizeUInt8(),$+=f.sizeShortString(k),$+=f.sizeLongString(M);const oe=f.alloc(x?2:1,O,$);return oe.writeUInt8(N),oe.writeShortString(k),oe.writeLongString(M),oe.buffer}static deserializeRequestJSONArgs(O){const N=O.readUInt8(),q=O.readShortString(),W=O.readLongString();return{rpcId:N,method:q,args:JSON.parse(W)}}static _requestMixedArgs(O,N,q,W,x){const k=L.VSBuffer.fromString(q);let M=0;M+=f.sizeUInt8(),M+=f.sizeShortString(k),M+=f.sizeMixedArray(W);const $=f.alloc(x?4:3,O,M);return $.writeUInt8(N),$.writeShortString(k),$.writeMixedArray(W),$.buffer}static deserializeRequestMixedArgs(O){const N=O.readUInt8(),q=O.readShortString(),W=O.readMixedArray(),x=new Array(W.length);for(let k=0,M=W.length;k<M;k++){const $=W[k];typeof $=="string"?x[k]=JSON.parse($):x[k]=$}return{rpcId:N,method:q,args:x}}static serializeAcknowledged(O){return f.alloc(5,O,0).buffer}static serializeCancel(O){return f.alloc(6,O,0).buffer}static serializeReplyOK(O,N,q){if(typeof N>"u")return this._serializeReplyOKEmpty(O);if(N instanceof L.VSBuffer)return this._serializeReplyOKVSBuffer(O,N);if(N instanceof R.SerializableObjectWithBuffers){const{jsonString:W,referencedBuffers:x}=a(N.value,q,!0);return this._serializeReplyOKJSONWithBuffers(O,W,x)}else return this._serializeReplyOKJSON(O,u(N,q))}static _serializeReplyOKEmpty(O){return f.alloc(7,O,0).buffer}static _serializeReplyOKVSBuffer(O,N){let q=0;q+=f.sizeVSBuffer(N);const W=f.alloc(8,O,q);return W.writeVSBuffer(N),W.buffer}static deserializeReplyOKVSBuffer(O){return O.readVSBuffer()}static _serializeReplyOKJSON(O,N){const q=L.VSBuffer.fromString(N);let W=0;W+=f.sizeLongString(q);const x=f.alloc(9,O,W);return x.writeLongString(q),x.buffer}static _serializeReplyOKJSONWithBuffers(O,N,q){const W=L.VSBuffer.fromString(N);let x=0;x+=f.sizeUInt32,x+=f.sizeLongString(W);for(const M of q)x+=f.sizeVSBuffer(M);const k=f.alloc(10,O,x);k.writeUInt32(q.length),k.writeLongString(W);for(const M of q)k.writeBuffer(M);return k.buffer}static deserializeReplyOKJSON(O){const N=O.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(O,N){const q=O.readUInt32(),W=O.readLongString(),x=[];for(let k=0;k<q;++k)x.push(O.readVSBuffer());return new R.SerializableObjectWithBuffers(r(W,x,N))}static serializeReplyErr(O,N){const q=N?u(A.transformErrorForSerialization(N),null):void 0;if(typeof q!="string")return this._serializeReplyErrEmpty(O);const W=L.VSBuffer.fromString(q);let x=0;x+=f.sizeLongString(W);const k=f.alloc(11,O,x);return k.writeLongString(W),k.buffer}static deserializeReplyErrError(O){const N=O.readLongString();return JSON.parse(N)}static _serializeReplyErrEmpty(O){return f.alloc(12,O,0).buffer}}var m;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var v;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(v||(v={}))}),define(Pe[235],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const I=function(A){const T=g=>{globalThis.removeEventListener("message",T);const h=g.data;Object.defineProperties(globalThis,{postMessage:{value(S,R){h.postMessage(S,R)}},onmessage:{get(){return h.onmessage},set(S){h.onmessage=S}}}),h.addEventListener("message",S=>{globalThis.dispatchEvent(new MessageEvent("message",{data:S.data,ports:S.ports?[...S.ports]:void 0}))}),h.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};globalThis.addEventListener("message",T)}.toString();class L extends EventTarget{constructor(A,T,g){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const h=`((${I})('${T}'))`,S=new Blob([h],{type:"application/javascript"}),R=URL.createObjectURL(S),D=new MessageChannel,u=R,p={type:"_newWorker",id:u,port:D.port2,url:R,options:g};A(p,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{A({type:"_terminateWorker",id:u}),URL.revokeObjectURL(R),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(E){D.port1.onmessage=E}},onmessageerror:{get(){return D.port1.onmessageerror},set(E){D.port1.onmessageerror=E}}}),D.port1.addEventListener("messageerror",E=>{const i=new MessageEvent("messageerror",{data:E.data});this.dispatchEvent(i)}),D.port1.addEventListener("message",E=>{const i=new MessageEvent("message",{data:E.data});this.dispatchEvent(i)}),D.port1.start()}}e.NestedWorker=L}),define(Pe[236],Te([1,0,23,28,11,53,4]),function(me,e,I,L,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookDocumentWorkbenchService=e.generate=e.parse=e.INotebookDocumentService=void 0,e.INotebookDocumentService=(0,T.createDecorator)("notebookDocumentService");const g=["W","X","Y","Z","a","b","c","d","e","f"],h=new RegExp(`^[${g.join("")}]+`),S=7;function R(p){if(p.scheme!==C.Schemas.vscodeNotebookCell)return;const E=p.fragment.indexOf("s");if(E<0)return;const i=parseInt(p.fragment.substring(0,E).replace(h,""),S),a=(0,I.decodeBase64)(p.fragment.substring(E+1)).toString();if(!isNaN(i))return{handle:i,notebook:p.with({scheme:a,fragment:null})}}e.parse=R;function D(p,E){const i=E.toString(S),r=`${i.length<g.length?g[i.length-1]:"z"}${i}s${(0,I.encodeBase64)(I.VSBuffer.fromString(p.scheme),!0,!0)}`;return p.with({scheme:C.Schemas.vscodeNotebookCell,fragment:r})}e.generate=D;class u{constructor(){this._documents=new L.ResourceMap}getNotebook(E){if(E.scheme===C.Schemas.vscodeNotebookCell){const i=R(E);if(i){const a=this._documents.get(i.notebook);if(a)return a}}return this._documents.get(E)}addNotebookDocument(E){this._documents.set(E.uri,E)}removeNotebookDocument(E){this._documents.delete(E.uri)}}e.NotebookDocumentWorkbenchService=u,(0,A.registerSingleton)(e.INotebookDocumentService,u,1)}),define(Pe[84],Te([1,0,23,34,68,69,11,19,21,35,236]),function(me,e,I,L,C,A,T,g,h,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var D;(function($){$[$.Markup=1]="Markup",$[$.Code=2]="Code"})(D||(e.CellKind=D={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",A.Mimes.latex,A.Mimes.markdown,"image/png","image/jpeg",A.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[A.Mimes.latex,A.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",A.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var u;(function($){$[$.Running=1]="Running",$[$.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var p;(function($){$[$.Unconfirmed=1]="Unconfirmed",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(p||(e.NotebookCellExecutionState=p={}));var E;(function($){$[$.Unconfirmed=1]="Unconfirmed",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(E||(e.NotebookExecutionState=E={}));var i;(function($){$[$.WithHardKernelDependency=0]="WithHardKernelDependency",$[$.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",$[$.Pure=2]="Pure",$[$.Never=3]="Never"})(i||(e.NotebookRendererMatch=i={}));var a;(function($){$.Always="always",$.Never="never",$.Optional="optional"})(a||(e.RendererMessagingSpec=a={}));var r;(function($){$[$.ModelChange=1]="ModelChange",$[$.Move=2]="Move",$[$.ChangeCellLanguage=5]="ChangeCellLanguage",$[$.Initialize=6]="Initialize",$[$.ChangeCellMetadata=7]="ChangeCellMetadata",$[$.Output=8]="Output",$[$.OutputItem=9]="OutputItem",$[$.ChangeCellContent=10]="ChangeCellContent",$[$.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",$[$.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",$[$.ChangeCellMime=13]="ChangeCellMime",$[$.Unknown=100]="Unknown"})(r||(e.NotebookCellsChangeType=r={}));var n;(function($){$[$.Handle=0]="Handle",$[$.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var o;(function($){$[$.Replace=1]="Replace",$[$.Output=2]="Output",$[$.Metadata=3]="Metadata",$[$.CellLanguage=4]="CellLanguage",$[$.DocumentMetadata=5]="DocumentMetadata",$[$.Move=6]="Move",$[$.OutputItems=7]="OutputItems",$[$.PartialMetadata=8]="PartialMetadata",$[$.PartialInternalMetadata=9]="PartialInternalMetadata"})(o||(e.CellEditType=o={}));var c;(function($){$.scheme=T.Schemas.vscodeNotebookCell;function oe(ae,pe){return(0,R.generate)(ae,pe)}$.generate=oe;function de(ae){return(0,R.parse)(ae)}$.parse=de;function we(ae,pe){return ae.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`op${pe??""},${ae.scheme!==T.Schemas.file?ae.scheme:""}`})}$.generateCellOutputUri=we;function ye(ae){if(ae.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const pe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ae.fragment);if(!pe)return;const re=pe[1]&&pe[1]!==""?pe[1]:void 0,J=pe[2];return{outputId:re,notebook:ae.with({scheme:J||T.Schemas.file,fragment:null})}}$.parseCellOutputUri=ye;function le(ae,pe,re){return $.generate(ae,pe).with({scheme:re})}$.generateCellPropertyUri=le;function ve(ae,pe){if(ae.scheme===pe)return $.parse(ae.with({scheme:$.scheme}))}$.parseCellPropertyUri=ve})(c||(e.CellUri=c={}));const l=$=>h.isWindows?$.replace(/\//g,"\\"):$;class t{constructor(oe=[],de=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=de,this.order=[...new Set(oe)].map(we=>({pattern:we,matches:L.parse(l(we))}))}sort(oe){const de=new Map(C.Iterable.map(oe,ye=>[ye,l(ye)]));let we=[];for(const{matches:ye}of this.order)for(const[le,ve]of de)if(ye(ve)){we.push(le),de.delete(le);break}return de.size&&(we=we.concat([...de.keys()].sort((ye,le)=>this.defaultOrder.indexOf(ye)-this.defaultOrder.indexOf(le)))),we}prioritize(oe,de){const we=this.findIndex(oe);if(we===-1){this.order.unshift({pattern:oe,matches:L.parse(l(oe))});return}const ye=new Set(de.map(ve=>this.findIndex(ve,we)));ye.delete(-1);const le=Array.from(ye).sort();this.order.splice(we+1,0,...le.map(ve=>this.order[ve]));for(let ve=le.length-1;ve>=0;ve--)this.order.splice(le[ve],1)}toArray(){return this.order.map(oe=>oe.pattern)}findIndex(oe,de=this.order.length){const we=l(oe);for(let ye=0;ye<de;ye++)if(this.order[ye].matches(we))return ye;return-1}}e.MimeTypeDisplayOrder=t;function d($,oe,de,we=(ye,le)=>ye===le){const ye=[];function le(pe,re,J){if(re===0&&J.length===0)return;const H=ye[ye.length-1];H&&H.start+H.deleteCount===pe?(H.deleteCount+=re,H.toInsert.push(...J)):ye.push({start:pe,deleteCount:re,toInsert:J})}let ve=0,ae=0;for(;;){if(ve===$.length){le(ve,0,oe.slice(ae));break}if(ae===oe.length){le(ve,$.length-ve,[]);break}const pe=$[ve],re=oe[ae];if(we(pe,re)){ve+=1,ae+=1;continue}de(re)?(le(ve,1,[]),ve+=1):(le(ve,0,[re]),ae+=1)}return ye}e.diff=d,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtLineBoundary","none");var s;(function($){$.default="default",$.option="option"})(s||(e.NotebookEditorPriority=s={}));function b($){const oe=$;return!!((typeof oe.include=="string"||L.isRelativePattern(oe.include))&&(typeof oe.exclude=="string"||L.isRelativePattern(oe.exclude)))}e.isDocumentExcludePattern=b;function _($,oe,de){if(Array.isArray($.viewType)&&$.viewType.indexOf(oe)>=0||$.viewType===oe)return!0;if($.filenamePattern){const we=b($.filenamePattern)?$.filenamePattern.include:$.filenamePattern,ye=b($.filenamePattern)?$.filenamePattern.exclude:void 0;if(L.match(we,(0,g.basename)(de.fsPath).toLowerCase()))return!(ye&&L.match(ye,(0,g.basename)(de.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=_,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var f;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(f||(e.CellStatusbarAlignment=f={}));class w{static{this._prefix="notebook/"}static create(oe){return`${w._prefix}${oe}`}static parse(oe){if(oe.startsWith(w._prefix))return oe.substring(w._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=w;function P($){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes($)}e.isTextStreamMime=P;const m=new TextDecoder;function v($){const oe=[];let de=!1;for(const ve of $)(oe.length===0||de)&&(oe.push(ve),de=!0);let we=N(oe);const ye=I.VSBuffer.concat(oe.map(ve=>I.VSBuffer.wrap(ve))),le=M(ye);return we=we||le.byteLength!==ye.byteLength,{data:le,didCompression:we}}e.compressOutputItemStreams=v,e.MOVE_CURSOR_1_LINE_COMMAND=`${String.fromCharCode(27)}[A`;const y=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map($=>$.charCodeAt(0)),O=10;function N($){let oe=!1;return $.forEach((de,we)=>{if(we===0||de.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const ye=$[we-1],le=de.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(le[0]===y[0]&&le[1]===y[1]&&le[2]===y[2]){const ve=ye.lastIndexOf(O);if(ve===-1)return;oe=!0,$[we-1]=ye.subarray(0,ve),$[we]=de.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),oe}function q($){let oe=$;do $=oe,oe=$.replace(/[^\n]\x08/gm,"");while(oe.length<$.length);return $}function W($){for($=$.replace(/\r+\n/gm,`
`);$.search(/\r[^$]/g)>-1;){const oe=$.match(/^(.*)\r+/m)[1];let de=$.match(/\r+(.*)$/m)[1];de=de+oe.slice(de.length,oe.length),$=$.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,de)}return $}const x="\b".charCodeAt(0),k="\r".charCodeAt(0);function M($){return!$.buffer.includes(x)&&!$.buffer.includes(k)?$:I.VSBuffer.fromString(W(q(m.decode($.buffer))))}}),define(Pe[7],Te([1,0,18,15,52,28,69,12,16,2,33,22,42,100,84]),function(me,e,I,L,C,A,T,g,h,S,R,D,u,p,E){"use strict";var i,a,r,n,o,c,l,t,d,s,b,_,f,w,P,m,v;Object.defineProperty(e,"__esModule",{value:!0}),e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.ChatMessage=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.ChatAgentCompletionItem=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.ChatEditorTabInput=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookVariablesRequestKind=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugVisualization=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.ThreadFocus=e.StackFrameFocus=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.asStatusBarItemIdentifier=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function y(z){return Object.assign(z,{apply:function(...se){if(se.length===0)return Reflect.construct(z,[]);{const Ie=se.length===1?[]:se[1];return Reflect.construct(z,Ie,se[0].constructor)}},call:function(...se){if(se.length===0)return Reflect.construct(z,[]);{const[Ie,...je]=se;return Reflect.construct(z,je,Ie.constructor)}}})}var O;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(O||(e.TerminalOutputAnchor=O={}));var N;(function(z){z[z.TerminalCommand=0]="TerminalCommand",z[z.Opener=1]="Opener",z[z.Command=3]="Command"})(N||(e.TerminalQuickFixType=N={}));let q=i=class{static from(...U){let se=U;return new i(function(){if(se){for(const Ie of se)Ie&&typeof Ie.dispose=="function"&&Ie.dispose();se=void 0}})}#e;constructor(U){this.#e=U}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=q,e.Disposable=q=i=Ke([y],q);let W=a=class{static Min(...U){if(U.length===0)throw new TypeError;let se=U[0];for(let Ie=1;Ie<U.length;Ie++){const je=U[Ie];je.isBefore(se)&&(se=je)}return se}static Max(...U){if(U.length===0)throw new TypeError;let se=U[0];for(let Ie=1;Ie<U.length;Ie++){const je=U[Ie];je.isAfter(se)&&(se=je)}return se}static isPosition(U){if(!U)return!1;if(U instanceof a)return!0;const{line:se,character:Ie}=U;return typeof se=="number"&&typeof Ie=="number"}static of(U){if(U instanceof a)return U;if(this.isPosition(U))return new a(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(U,se){if(U<0)throw(0,L.illegalArgument)("line must be non-negative");if(se<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=U,this._character=se}isBefore(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<U._character}isBeforeOrEqual(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<=U._character}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this._line===U._line&&this._character===U._character}compareTo(U){return this._line<U._line?-1:this._line>U.line?1:this._character<U._character?-1:this._character>U._character?1:0}translate(U,se=0){if(U===null||se===null)throw(0,L.illegalArgument)();let Ie;return typeof U>"u"?Ie=0:typeof U=="number"?Ie=U:(Ie=typeof U.lineDelta=="number"?U.lineDelta:0,se=typeof U.characterDelta=="number"?U.characterDelta:0),Ie===0&&se===0?this:new a(this.line+Ie,this.character+se)}with(U,se=this.character){if(U===null||se===null)throw(0,L.illegalArgument)();let Ie;return typeof U>"u"?Ie=this.line:typeof U=="number"?Ie=U:(Ie=typeof U.line=="number"?U.line:this.line,se=typeof U.character=="number"?U.character:this.character),Ie===this.line&&se===this.character?this:new a(Ie,se)}toJSON(){return{line:this.line,character:this.character}}};e.Position=W,e.Position=W=a=Ke([y],W);let x=r=class{static isRange(U){return U instanceof r?!0:U?W.isPosition(U.start)&&W.isPosition(U.end):!1}static of(U){if(U instanceof r)return U;if(this.isRange(U))return new r(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(U,se,Ie,je){let Je,lt;if(typeof U=="number"&&typeof se=="number"&&typeof Ie=="number"&&typeof je=="number"?(Je=new W(U,se),lt=new W(Ie,je)):W.isPosition(U)&&W.isPosition(se)&&(Je=W.of(U),lt=W.of(se)),!Je||!lt)throw new Error("Invalid arguments");Je.isBefore(lt)?(this._start=Je,this._end=lt):(this._start=lt,this._end=Je)}contains(U){return r.isRange(U)?this.contains(U.start)&&this.contains(U.end):W.isPosition(U)?!(W.of(U).isBefore(this._start)||this._end.isBefore(U)):!1}isEqual(U){return this._start.isEqual(U._start)&&this._end.isEqual(U._end)}intersection(U){const se=W.Max(U.start,this._start),Ie=W.Min(U.end,this._end);if(!se.isAfter(Ie))return new r(se,Ie)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const se=W.Min(U.start,this._start),Ie=W.Max(U.end,this.end);return new r(se,Ie)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(U,se=this.end){if(U===null||se===null)throw(0,L.illegalArgument)();let Ie;return U?W.isPosition(U)?Ie=U:(Ie=U.start||this.start,se=U.end||this.end):Ie=this.start,Ie.isEqual(this._start)&&se.isEqual(this.end)?this:new r(Ie,se)}toJSON(){return[this.start,this.end]}};e.Range=x,e.Range=x=r=Ke([y],x);let k=n=class extends x{static isSelection(U){return U instanceof n?!0:U?x.isRange(U)&&W.isPosition(U.anchor)&&W.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(U,se,Ie,je){let Je,lt;if(typeof U=="number"&&typeof se=="number"&&typeof Ie=="number"&&typeof je=="number"?(Je=new W(U,se),lt=new W(Ie,je)):W.isPosition(U)&&W.isPosition(se)&&(Je=W.of(U),lt=W.of(se)),!Je||!lt)throw new Error("Invalid arguments");super(Je,lt),this._anchor=Je,this._active=lt}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=k,e.Selection=k=n=Ke([y],k);const M=z=>{if(typeof z!="string"||z.length===0||!/^[0-9A-Za-z_\-]+$/.test(z))throw(0,L.illegalArgument)("connectionToken")};class ${static isResolvedAuthority(U){return U&&typeof U=="object"&&typeof U.host=="string"&&typeof U.port=="number"&&(U.connectionToken===void 0||typeof U.connectionToken=="string")}constructor(U,se,Ie){if(typeof U!="string"||U.length===0)throw(0,L.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,L.illegalArgument)("port");typeof Ie<"u"&&M(Ie),this.host=U,this.port=Math.round(se),this.connectionToken=Ie}}e.ResolvedAuthority=$;class oe{static isManagedResolvedAuthority(U){return U&&typeof U=="object"&&typeof U.makeConnection=="function"&&(U.connectionToken===void 0||typeof U.connectionToken=="string")}constructor(U,se){this.makeConnection=U,this.connectionToken=se,typeof se<"u"&&M(se)}}e.ManagedResolvedAuthority=oe;class de extends Error{static NotAvailable(U,se){return new de(U,p.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(U){return new de(U,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,se=p.RemoteAuthorityResolverErrorCode.Unknown,Ie){super(U),this._message=U,this._code=se,this._detail=Ie,Object.setPrototypeOf(this,de.prototype)}}e.RemoteAuthorityResolverError=de;var we;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(we||(e.EndOfLine=we={}));var ye;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(ye||(e.EnvironmentVariableMutatorType=ye={}));let le=o=class{static isTextEdit(U){return U instanceof o?!0:U?x.isRange(U)&&typeof U.newText=="string":!1}static replace(U,se){return new o(U,se)}static insert(U,se){return o.replace(new x(U,U),se)}static delete(U){return o.replace(U,"")}static setEndOfLine(U){const se=new o(new x(new W(0,0),new W(0,0)),"");return se.newEol=U,se}get range(){return this._range}set range(U){if(U&&!x.isRange(U))throw(0,L.illegalArgument)("range");this._range=U}get newText(){return this._newText||""}set newText(U){if(U&&typeof U!="string")throw(0,L.illegalArgument)("newText");this._newText=U}get newEol(){return this._newEol}set newEol(U){if(U&&typeof U!="number")throw(0,L.illegalArgument)("newEol");this._newEol=U}constructor(U,se){this._range=U,this._newText=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=le,e.TextEdit=le=o=Ke([y],le);let ve=c=class{static isNotebookCellEdit(U){return U instanceof c?!0:U?ni.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,se){return new c(U,se)}static insertCells(U,se){return new c(new ni(U,U),se)}static deleteCells(U){return new c(U,[])}static updateCellMetadata(U,se){const Ie=new c(new ni(U,U),[]);return Ie.newCellMetadata=se,Ie}static updateNotebookMetadata(U){const se=new c(new ni(0,0),[]);return se.newNotebookMetadata=U,se}constructor(U,se){this.range=U,this.newCells=se}};e.NotebookEdit=ve,e.NotebookEdit=ve=c=Ke([y],ve);class ae{static isSnippetTextEdit(U){return U instanceof ae?!0:U?x.isRange(U.range)&&J.isSnippetString(U.snippet):!1}static replace(U,se){return new ae(U,se)}static insert(U,se){return ae.replace(new x(U,U),se)}constructor(U,se){this.range=U,this.snippet=se}}e.SnippetTextEdit=ae;var pe;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(pe||(e.FileEditType=pe={}));let re=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(U,se,Ie,je){this._edits.push({_type:1,from:U,to:se,options:Ie,metadata:je})}createFile(U,se,Ie){this._edits.push({_type:1,from:void 0,to:U,options:se,metadata:Ie})}deleteFile(U,se,Ie){this._edits.push({_type:1,from:U,to:void 0,options:se,metadata:Ie})}replaceNotebookMetadata(U,se,Ie){this._edits.push({_type:3,metadata:Ie,uri:U,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(U,se,Ie,je){const Je=se.start,lt=se.end;(Je!==lt||Ie.length>0)&&this._edits.push({_type:5,uri:U,index:Je,count:lt-Je,cells:Ie,metadata:je})}replaceNotebookCellMetadata(U,se,Ie,je){this._edits.push({_type:3,metadata:je,uri:U,edit:{editType:3,index:se,metadata:Ie}})}replace(U,se,Ie,je){this._edits.push({_type:2,uri:U,edit:new le(se,Ie),metadata:je})}insert(U,se,Ie,je){this.replace(U,new x(se,se),Ie,je)}delete(U,se,Ie){this.replace(U,se,"",Ie)}has(U){return this._edits.some(se=>se._type===2&&se.uri.toString()===U.toString())}set(U,se){if(se)for(const Ie of se){if(!Ie)continue;let je,Je;Array.isArray(Ie)?(je=Ie[0],Je=Ie[1]):je=Ie,ve.isNotebookCellEdit(je)?je.newCellMetadata?this.replaceNotebookCellMetadata(U,je.range.start,je.newCellMetadata,Je):je.newNotebookMetadata?this.replaceNotebookMetadata(U,je.newNotebookMetadata,Je):this.replaceNotebookCells(U,je.range,je.newCells,Je):ae.isSnippetTextEdit(je)?this._edits.push({_type:6,uri:U,range:je.range,edit:je.snippet,metadata:Je}):this._edits.push({_type:2,uri:U,edit:je,metadata:Je})}else{for(let Ie=0;Ie<this._edits.length;Ie++){const je=this._edits[Ie];switch(je._type){case 2:case 6:case 3:case 5:je.uri.toString()===U.toString()&&(this._edits[Ie]=void 0);break}}(0,I.coalesceInPlace)(this._edits)}}get(U){const se=[];for(const Ie of this._edits)Ie._type===2&&Ie.uri.toString()===U.toString()&&se.push(Ie.edit);return se}entries(){const U=new A.ResourceMap;for(const se of this._edits)if(se._type===2){let Ie=U.get(se.uri);Ie||(Ie=[se.uri,[]],U.set(se.uri,Ie)),Ie[1].push(se.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=re,e.WorkspaceEdit=re=Ke([y],re);let J=l=class{static isSnippetString(U){return U instanceof l?!0:U?typeof U.value=="string":!1}static _escape(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this._tabstop=1,this.value=U||""}appendText(U){return this.value+=l._escape(U),this}appendTabstop(U=this._tabstop++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,se=this._tabstop++){if(typeof U=="function"){const Ie=new l;Ie._tabstop=this._tabstop,U(Ie),this._tabstop=Ie._tabstop,U=Ie.value}else U=l._escape(U);return this.value+="${",this.value+=se,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,se=this._tabstop++){const Ie=U.map(je=>je.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=Ie,this.value+="|}",this}appendVariable(U,se){if(typeof se=="function"){const Ie=new l;Ie._tabstop=this._tabstop,se(Ie),this._tabstop=Ie._tabstop,se=Ie.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,se&&(this.value+=":",this.value+=se),this.value+="}",this}};e.SnippetString=J,e.SnippetString=J=l=Ke([y],J);var H;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(H||(e.DiagnosticTag=H={}));var ne;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let Ae=t=class{static isLocation(U){return U instanceof t?!0:U?x.isRange(U.range)&&S.URI.isUri(U.uri):!1}constructor(U,se){if(this.uri=U,se)if(x.isRange(se))this.range=x.of(se);else if(W.isPosition(se))this.range=new x(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=Ae,e.Location=Ae=t=Ke([y],Ae);let Re=class{static is(U){return U?typeof U.message=="string"&&U.location&&x.isRange(U.location.range)&&S.URI.isUri(U.location.uri):!1}constructor(U,se){this.location=U,this.message=se}static isEqual(U,se){return U===se?!0:!U||!se?!1:U.message===se.message&&U.location.range.isEqual(se.location.range)&&U.location.uri.toString()===se.location.uri.toString()}};e.DiagnosticRelatedInformation=Re,e.DiagnosticRelatedInformation=Re=Ke([y],Re);let ke=class{constructor(U,se,Ie=ne.Error){if(!x.isRange(U))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=U,this.message=se,this.severity=Ie}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,se){return U===se?!0:!U||!se?!1:U.message===se.message&&U.severity===se.severity&&U.code===se.code&&U.severity===se.severity&&U.source===se.source&&U.range.isEqual(se.range)&&(0,I.equals)(U.tags,se.tags)&&(0,I.equals)(U.relatedInformation,se.relatedInformation,Re.isEqual)}};e.Diagnostic=ke,e.Diagnostic=ke=Ke([y],ke);let ce=class{constructor(U,se){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=se}};e.Hover=ce,e.Hover=ce=Ke([y],ce);var te;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(te||(e.DocumentHighlightKind=te={}));let K=class{constructor(U,se=te.Text){this.range=U,this.kind=se}toJSON(){return{range:this.range,kind:te[this.kind]}}};e.DocumentHighlight=K,e.DocumentHighlight=K=Ke([y],K);let ee=class{constructor(U,se){this.uri=U,this.highlights=se}toJSON(){return{uri:this.uri,highlights:this.highlights.map(U=>U.toJSON())}}};e.MultiDocumentHighlight=ee,e.MultiDocumentHighlight=ee=Ke([y],ee);var ge;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(ge||(e.SymbolKind=ge={}));var be;(function(z){z[z.Deprecated=1]="Deprecated"})(be||(e.SymbolTag=be={}));let Le=d=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,se,Ie,je,Je){this.name=U,this.kind=se,this.containerName=Je,typeof Ie=="string"&&(this.containerName=Ie),je instanceof Ae?this.location=je:Ie instanceof x&&(this.location=new Ae(je,Ie)),d.validate(this)}toJSON(){return{name:this.name,kind:ge[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=Le,e.SymbolInformation=Le=d=Ke([y],Le);let fe=s=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(s.validate)}constructor(U,se,Ie,je,Je){this.name=U,this.detail=se,this.kind=Ie,this.range=je,this.selectionRange=Je,this.children=[],s.validate(this)}};e.DocumentSymbol=fe,e.DocumentSymbol=fe=s=Ke([y],fe);var _e;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(_e||(e.CodeActionTriggerKind=_e={}));let F=class{constructor(U,se){this.title=U,this.kind=se}};e.CodeAction=F,e.CodeAction=F=Ke([y],F);let V=class{static{b=this}static{this.sep="."}constructor(U){this.value=U}append(U){return new b(this.value?this.value+b.sep+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+b.sep)}};e.CodeActionKind=V,e.CodeActionKind=V=b=Ke([y],V),V.Empty=new V(""),V.QuickFix=V.Empty.append("quickfix"),V.Refactor=V.Empty.append("refactor"),V.RefactorExtract=V.Refactor.append("extract"),V.RefactorInline=V.Refactor.append("inline"),V.RefactorMove=V.Refactor.append("move"),V.RefactorRewrite=V.Refactor.append("rewrite"),V.Source=V.Empty.append("source"),V.SourceOrganizeImports=V.Source.append("organizeImports"),V.SourceFixAll=V.Source.append("fixAll"),V.Notebook=V.Empty.append("notebook");let j=class{constructor(U,se){if(this.range=U,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=j,e.SelectionRange=j=Ke([y],j);class B{constructor(U,se,Ie,je,Je,lt){this.kind=U,this.name=se,this.detail=Ie,this.uri=je,this.range=Je,this.selectionRange=lt}}e.CallHierarchyItem=B;class X{constructor(U,se){this.fromRanges=se,this.from=U}}e.CallHierarchyIncomingCall=X;class Z{constructor(U,se){this.fromRanges=se,this.to=U}}e.CallHierarchyOutgoingCall=Z;var Se;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(Se||(e.LanguageStatusSeverity=Se={}));let Ne=class{constructor(U,se){this.range=U,this.command=se}get isResolved(){return!!this.command}};e.CodeLens=Ne,e.CodeLens=Ne=Ke([y],Ne);let $e=_=class{#e;static isMarkdownString(U){return U instanceof _?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,se=!1){this.#e=new C.MarkdownString(U,{supportThemeIcons:se})}get value(){return this.#e.value}set value(U){this.#e.value=U}get isTrusted(){return this.#e.isTrusted}set isTrusted(U){this.#e.isTrusted=U}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(U){this.#e.supportThemeIcons=U}get supportHtml(){return this.#e.supportHtml}set supportHtml(U){this.#e.supportHtml=U}get baseUri(){return this.#e.baseUri}set baseUri(U){this.#e.baseUri=U}appendText(U){return this.#e.appendText(U),this}appendMarkdown(U){return this.#e.appendMarkdown(U),this}appendCodeblock(U,se){return this.#e.appendCodeblock(se??"",U),this}};e.MarkdownString=$e,e.MarkdownString=$e=_=Ke([y],$e);let qe=class{constructor(U,se){this.label=U,this.documentation=se}};e.ParameterInformation=qe,e.ParameterInformation=qe=Ke([y],qe);let Qe=class{constructor(U,se){this.label=U,this.documentation=se,this.parameters=[]}};e.SignatureInformation=Qe,e.SignatureInformation=Qe=Ke([y],Qe);let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=nt,e.SignatureHelp=nt=Ke([y],nt);var it;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(it||(e.SignatureHelpTriggerKind=it={}));var et;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(et||(e.InlayHintKind=et={}));let rt=class{constructor(U){this.value=U}};e.InlayHintLabelPart=rt,e.InlayHintLabelPart=rt=Ke([y],rt);let ct=class{constructor(U,se,Ie){this.position=U,this.label=se,this.kind=Ie}};e.InlayHint=ct,e.InlayHint=ct=Ke([y],ct);var Be;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Be||(e.CompletionTriggerKind=Be={}));var gt;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(gt||(e.CompletionItemKind=gt={}));var Q;(function(z){z[z.Deprecated=1]="Deprecated"})(Q||(e.CompletionItemTag=Q={}));let Y=class{constructor(U,se){this.label=U,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&gt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=Y,e.CompletionItem=Y=Ke([y],Y);let Ee=class{constructor(U=[],se=!1){this.items=U,this.isIncomplete=se}};e.CompletionList=Ee,e.CompletionList=Ee=Ke([y],Ee);let ze=class{constructor(U,se,Ie){this.insertText=U,this.range=se,this.command=Ie}};e.InlineSuggestion=ze,e.InlineSuggestion=ze=Ke([y],ze);let Ge=class{constructor(U){this.commands=void 0,this.suppressSuggestions=void 0,this.items=U}};e.InlineSuggestionList=Ge,e.InlineSuggestionList=Ge=Ke([y],Ge);var tt;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(tt||(e.ViewColumn=tt={}));var st;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(st||(e.StatusBarAlignment=st={}));function Fe(z,U){return`${D.ExtensionIdentifier.toKey(z)}.${U}`}e.asStatusBarItemIdentifier=Fe;var Ut;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(Ut||(e.TextEditorLineNumbersStyle=Ut={}));var At;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(At||(e.TextDocumentSaveReason=At={}));var jt;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(jt||(e.TextEditorRevealType=jt={}));var Ot;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Ot||(e.TextEditorSelectionChangeKind=Ot={}));var _t;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(_t||(e.TextDocumentChangeReason=_t={}));var Wt;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(Wt||(e.DecorationRangeBehavior=Wt={})),function(z){function U(se){switch(se){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=U}(Ot||(e.TextEditorSelectionChangeKind=Ot={}));var Ft;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(Ft||(e.SyntaxTokenType=Ft={})),function(z){function U(se){switch(se){case z.Other:return"other";case z.Comment:return"comment";case z.String:return"string";case z.RegEx:return"regex"}return"other"}z.toString=U}(Ft||(e.SyntaxTokenType=Ft={}));let Qt=class{constructor(U,se){if(se&&!S.URI.isUri(se))throw(0,L.illegalArgument)("target");if(!x.isRange(U)||U.isEmpty)throw(0,L.illegalArgument)("range");this.range=U,this.target=se}};e.DocumentLink=Qt,e.DocumentLink=Qt=Ke([y],Qt);let $t=class{constructor(U,se,Ie,je){this.red=U,this.green=se,this.blue=Ie,this.alpha=je}};e.Color=$t,e.Color=$t=Ke([y],$t);let xt=class{constructor(U,se){if(se&&!(se instanceof $t))throw(0,L.illegalArgument)("color");if(!x.isRange(U)||U.isEmpty)throw(0,L.illegalArgument)("range");this.range=U,this.color=se}};e.ColorInformation=xt,e.ColorInformation=xt=Ke([y],xt);let Ye=class{constructor(U){if(!U||typeof U!="string")throw(0,L.illegalArgument)("label");this.label=U}};e.ColorPresentation=Ye,e.ColorPresentation=Ye=Ke([y],Ye);var Vt;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(Vt||(e.ColorFormat=Vt={}));var Kt;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(Kt||(e.SourceControlInputBoxValidationType=Kt={}));var ut;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(ut||(e.TerminalExitReason=ut={}));class pt{constructor(U,se,Ie){if(this.startIndex=U,this.length=se,this.tooltip=Ie,typeof U!="number"||U<0)throw(0,L.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,L.illegalArgument)("length");if(Ie!==void 0&&typeof Ie!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=pt;class Bt{constructor(U){this.uri=U}}e.TerminalQuickFixOpener=Bt;class Gt{constructor(U){this.terminalCommand=U}}e.TerminalQuickFixCommand=Gt;var St;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(St||(e.TerminalLocation=St={}));class ht{constructor(U){if(this.options=U,typeof U!="object")throw(0,L.illegalArgument)("options")}}e.TerminalProfile=ht;var It;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(It||(e.TaskRevealKind=It={}));var Zt;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(Zt||(e.TaskPanelKind=Zt={}));let kt=class{static{f=this}static{this.Clean=new f("clean","Clean")}static{this.Build=new f("build","Build")}static{this.Rebuild=new f("rebuild","Rebuild")}static{this.Test=new f("test","Test")}static from(U){switch(U){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}constructor(U,se){if(this.label=se,typeof U!="string"||typeof se!="string")throw(0,L.illegalArgument)("name");this._id=U}get id(){return this._id}};e.TaskGroup=kt,e.TaskGroup=kt=f=Ke([y],kt);function Ve(z){let U="";for(let se=0;se<z.length;se++)U+=z[se].replace(/,/g,",,")+",";return U}let Rt=class{constructor(U,se,Ie){if(typeof U!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=U,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=Ie):this._options=se)}get process(){return this._process}set process(U){if(typeof U!="string")throw(0,L.illegalArgument)("process");this._process=U}get args(){return this._args}set args(U){Array.isArray(U)||(U=[]),this._args=U}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("process"),this._process!==void 0&&U.push(this._process),this._args&&this._args.length>0)for(const se of this._args)U.push(se);return Ve(U)}};e.ProcessExecution=Rt,e.ProcessExecution=Rt=Ke([y],Rt);let Nt=class{constructor(U,se,Ie){if(this._args=[],Array.isArray(se)){if(!U)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,L.illegalArgument)("command");this._command=U,this._args=se,this._options=Ie}else{if(typeof U!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=U,this._options=se}}get commandLine(){return this._commandLine}set commandLine(U){if(typeof U!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=U}get command(){return this._command?this._command:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,L.illegalArgument)("command");this._command=U}get args(){return this._args}set args(U){this._args=U||[]}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("shell"),this._commandLine!==void 0&&U.push(this._commandLine),this._command!==void 0&&U.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const se of this._args)U.push(typeof se=="string"?se:se.value);return Ve(U)}};e.ShellExecution=Nt,e.ShellExecution=Nt=Ke([y],Nt);var Xt;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(Xt||(e.ShellQuoting=Xt={}));var ft;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(ft||(e.TaskScope=ft={}));class Lt{constructor(U){this._callback=U}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(U){this._callback=U}get callback(){return this._callback}}e.CustomExecution=Lt;let Pt=class{static{w=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor(U,se,Ie,je,Je,lt){this.__deprecated=!1,this._definition=this.definition=U;let mt;typeof se=="string"?(this._name=this.name=se,this._source=this.source=Ie,this.execution=je,mt=Je,this.__deprecated=!0):se===ft.Global||se===ft.Workspace?(this.target=se,this._name=this.name=Ie,this._source=this.source=je,this.execution=Je,mt=lt):(this.target=se,this._name=this.name=Ie,this._source=this.source=je,this.execution=Je,mt=lt),typeof mt=="string"?(this._problemMatchers=[mt],this._hasDefinedMatchers=!0):Array.isArray(mt)?(this._problemMatchers=mt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(U){this.__id=U}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Rt?this._definition={type:w.ProcessType,id:this._execution.computeId()}:this._execution instanceof Nt?this._definition={type:w.ShellType,id:this._execution.computeId()}:this._execution instanceof Lt?this._definition={type:w.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:w.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(U){if(U==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=U}get scope(){return this._scope}set target(U){this.clear(),this._scope=U}get name(){return this._name}set name(U){if(typeof U!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=U}get execution(){return this._execution}set execution(U){U===null&&(U=void 0),this.clear(),this._execution=U;const se=this._definition.type;(w.EmptyType===se||w.ProcessType===se||w.ShellType===se||w.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(U){if(Array.isArray(U))this.clear(),this._problemMatchers=U,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.clear(),this._isBackground=U}get source(){return this._source}set source(U){if(typeof U!="string"||U.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=U}get group(){return this._group}set group(U){U===null&&(U=void 0),this.clear(),this._group=U}get detail(){return this._detail}set detail(U){U===null&&(U=void 0),this._detail=U}get presentationOptions(){return this._presentationOptions}set presentationOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._presentationOptions=U}get runOptions(){return this._runOptions}set runOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._runOptions=U}};e.Task=Pt,e.Task=Pt=w=Ke([y],Pt);var zt;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(zt||(e.ProgressLocation=zt={}));var De;(function(z){function U(se){const Ie=se;return(0,h.isNumber)(Ie.value)?Ie.tooltip&&!(0,h.isString)(Ie.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ie.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ie.value),!1)}z.isViewBadge=U})(De||(e.ViewBadge=De={}));let Oe=P=class{static isTreeItem(U,se){const Ie=U;if(Ie.checkboxState!==void 0){const je=(0,h.isNumber)(Ie.checkboxState)?Ie.checkboxState:(0,h.isObject)(Ie.checkboxState)&&(0,h.isNumber)(Ie.checkboxState.state)?Ie.checkboxState.state:void 0,Je=!(0,h.isNumber)(Ie.checkboxState)&&(0,h.isObject)(Ie.checkboxState)?Ie.checkboxState.tooltip:void 0;if(je===void 0||je!==G.Checked&&je!==G.Unchecked||Je!==void 0&&!(0,h.isString)(Je))return console.log("INVALID tree item, invalid checkboxState",Ie.checkboxState),!1}if(U instanceof P)return!0;if(Ie.label!==void 0&&!(0,h.isString)(Ie.label)&&!Ie.label?.label)return console.log("INVALID tree item, invalid label",Ie.label),!1;if(Ie.id!==void 0&&!(0,h.isString)(Ie.id))return console.log("INVALID tree item, invalid id",Ie.id),!1;if(Ie.iconPath!==void 0&&!(0,h.isString)(Ie.iconPath)&&!S.URI.isUri(Ie.iconPath)&&(!Ie.iconPath||!(0,h.isString)(Ie.iconPath.id))){const je=Ie.iconPath;if(!je||!(0,h.isString)(je.light)&&!S.URI.isUri(je.light)&&!(0,h.isString)(je.dark)&&!S.URI.isUri(je.dark))return console.log("INVALID tree item, invalid iconPath",Ie.iconPath),!1}return Ie.description!==void 0&&!(0,h.isString)(Ie.description)&&typeof Ie.description!="boolean"?(console.log("INVALID tree item, invalid description",Ie.description),!1):Ie.resourceUri!==void 0&&!S.URI.isUri(Ie.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ie.resourceUri),!1):Ie.tooltip!==void 0&&!(0,h.isString)(Ie.tooltip)&&!(Ie.tooltip instanceof $e)?(console.log("INVALID tree item, invalid tooltip",Ie.tooltip),!1):Ie.command!==void 0&&!Ie.command.command?(console.log("INVALID tree item, invalid command",Ie.command),!1):Ie.collapsibleState!==void 0&&Ie.collapsibleState<he.None&&Ie.collapsibleState>he.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ie.collapsibleState),!1):Ie.contextValue!==void 0&&!(0,h.isString)(Ie.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ie.contextValue),!1):Ie.accessibilityInformation!==void 0&&!Ie.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ie.accessibilityInformation),!1):!0}constructor(U,se=he.None){this.collapsibleState=se,S.URI.isUri(U)?this.resourceUri=U:this.label=U}};e.TreeItem=Oe,e.TreeItem=Oe=P=Ke([y],Oe);var he;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(he||(e.TreeItemCollapsibleState=he={}));var G;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(G||(e.TreeItemCheckboxState=G={}));let Ce=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U){this.value=U}};e.DataTransferItem=Ce,e.DataTransferItem=Ce=Ke([y],Ce);class Ue extends Ce{}e.InternalDataTransferItem=Ue;class Xe extends Ue{#e;constructor(U){super(""),this.#e=U}asFile(){return this.#e}}e.InternalFileDataTransferItem=Xe;class He{constructor(U,se,Ie,je){this.name=U,this.uri=se,this._itemId=Ie,this._getData=je}data(){return this._getData()}}e.DataTransferFile=He;let ot=class{#e=new Map;constructor(U){for(const[se,Ie]of U??[]){const je=this.#e.get(this.#t(se));je?je.push(Ie):this.#e.set(this.#t(se),[Ie])}}get(U){return this.#e.get(this.#t(U))?.[0]}set(U,se){this.#e.set(this.#t(U),[se])}forEach(U,se){for(const[Ie,je]of this.#e)for(const Je of je)U.call(se,Je,Ie,this)}*[Symbol.iterator](){for(const[U,se]of this.#e)for(const Ie of se)yield[U,Ie]}#t(U){return U.toLowerCase()}};e.DataTransfer=ot,e.DataTransfer=ot=Ke([y],ot);let wt=class{constructor(U){this.insertText=U}};e.DocumentDropEdit=wt,e.DocumentDropEdit=wt=Ke([y],wt);let qt=class{constructor(U,se){this.label=se,this.insertText=U}};e.DocumentPasteEdit=qt,e.DocumentPasteEdit=qt=Ke([y],qt);let yt=class{constructor(U,se){this.id=U,this.color=se}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};e.ThemeIcon=yt,e.ThemeIcon=yt=Ke([y],yt),yt.File=new yt("file"),yt.Folder=new yt("folder");let Dt=class{constructor(U){this.id=U}};e.ThemeColor=Dt,e.ThemeColor=Dt=Ke([y],Dt);var bt;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(bt||(e.ConfigurationTarget=bt={}));let Di=class{get base(){return this._base}set base(U){this._base=U,this._baseUri=S.URI.file(U)}get baseUri(){return this._baseUri}set baseUri(U){this._baseUri=U,this._base=U.fsPath}constructor(U,se){if(typeof U!="string"&&(!U||!S.URI.isUri(U)&&!S.URI.isUri(U.uri)))throw(0,L.illegalArgument)("base");if(typeof se!="string")throw(0,L.illegalArgument)("pattern");typeof U=="string"?this.baseUri=S.URI.file(U):S.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=Di,e.RelativePattern=Di=Ke([y],Di);const ji=new WeakMap;function Ct(z,U){ji.set(z,U)}e.setBreakpointId=Ct;let si=class{constructor(U,se,Ie,je){this.enabled=typeof U=="boolean"?U:!0,typeof se=="string"&&(this.condition=se),typeof Ie=="string"&&(this.hitCondition=Ie),typeof je=="string"&&(this.logMessage=je)}get id(){return this._id||(this._id=ji.get(this)??(0,R.generateUuid)()),this._id}};e.Breakpoint=si,e.Breakpoint=si=Ke([y],si);let gi=class extends si{constructor(U,se,Ie,je,Je){if(super(se,Ie,je,Je),U===null)throw(0,L.illegalArgument)("location");this.location=U}};e.SourceBreakpoint=gi,e.SourceBreakpoint=gi=Ke([y],gi);let li=class extends si{constructor(U,se,Ie,je,Je){super(se,Ie,je,Je),this.functionName=U}};e.FunctionBreakpoint=li,e.FunctionBreakpoint=li=Ke([y],li);let Ii=class extends si{constructor(U,se,Ie,je,Je,lt,mt){if(super(je,Je,lt,mt),!se)throw(0,L.illegalArgument)("dataId");this.label=U,this.dataId=se,this.canPersist=Ie}};e.DataBreakpoint=Ii,e.DataBreakpoint=Ii=Ke([y],Ii);let Ci=class{constructor(U,se,Ie){this.command=U,this.args=se||[],this.options=Ie}};e.DebugAdapterExecutable=Ci,e.DebugAdapterExecutable=Ci=Ke([y],Ci);let Mt=class{constructor(U,se){this.port=U,this.host=se}};e.DebugAdapterServer=Mt,e.DebugAdapterServer=Mt=Ke([y],Mt);let pi=class{constructor(U){this.path=U}};e.DebugAdapterNamedPipeServer=pi,e.DebugAdapterNamedPipeServer=pi=Ke([y],pi);let ki=class{constructor(U){this.implementation=U}};e.DebugAdapterInlineImplementation=ki,e.DebugAdapterInlineImplementation=ki=Ke([y],ki);let ui=class{constructor(U,se,Ie){this.session=U,this.threadId=se,this.frameId=Ie}};e.StackFrameFocus=ui,e.StackFrameFocus=ui=Ke([y],ui);let di=class{constructor(U,se){this.session=U,this.threadId=se}};e.ThreadFocus=di,e.ThreadFocus=di=Ke([y],di);let dt=class{constructor(U,se){this.range=U,this.expression=se}};e.EvaluatableExpression=dt,e.EvaluatableExpression=dt=Ke([y],dt);var Ki;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Ki||(e.InlineCompletionTriggerKind=Ki={}));let ei=class{constructor(U,se){this.range=U,this.text=se}};e.InlineValueText=ei,e.InlineValueText=ei=Ke([y],ei);let oi=class{constructor(U,se,Ie=!0){this.range=U,this.variableName=se,this.caseSensitiveLookup=Ie}};e.InlineValueVariableLookup=oi,e.InlineValueVariableLookup=oi=Ke([y],oi);let vi=class{constructor(U,se){this.range=U,this.expression=se}};e.InlineValueEvaluatableExpression=vi,e.InlineValueEvaluatableExpression=vi=Ke([y],vi);let Pi=class{constructor(U,se){this.frameId=U,this.stoppedLocation=se}};e.InlineValueContext=Pi,e.InlineValueContext=Pi=Ke([y],Pi);var Gi;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(Gi||(e.FileChangeType=Gi={}));let Ti=m=class extends Error{static FileExists(U){return new m(U,u.FileSystemProviderErrorCode.FileExists,m.FileExists)}static FileNotFound(U){return new m(U,u.FileSystemProviderErrorCode.FileNotFound,m.FileNotFound)}static FileNotADirectory(U){return new m(U,u.FileSystemProviderErrorCode.FileNotADirectory,m.FileNotADirectory)}static FileIsADirectory(U){return new m(U,u.FileSystemProviderErrorCode.FileIsADirectory,m.FileIsADirectory)}static NoPermissions(U){return new m(U,u.FileSystemProviderErrorCode.NoPermissions,m.NoPermissions)}static Unavailable(U){return new m(U,u.FileSystemProviderErrorCode.Unavailable,m.Unavailable)}constructor(U,se=u.FileSystemProviderErrorCode.Unknown,Ie){super(S.URI.isUri(U)?U.toString(!0):U),this.code=Ie?.name??"Unknown",(0,u.markAsFileSystemProviderError)(this,se),Object.setPrototypeOf(this,m.prototype),typeof Error.captureStackTrace=="function"&&typeof Ie=="function"&&Error.captureStackTrace(this,Ie)}};e.FileSystemError=Ti,e.FileSystemError=Ti=m=Ke([y],Ti);let Ei=class{constructor(U,se,Ie){this.start=U,this.end=se,this.kind=Ie}};e.FoldingRange=Ei,e.FoldingRange=Ei=Ke([y],Ei);var Xi;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(Xi||(e.FoldingRangeKind=Xi={}));var Ai;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var hi;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(hi||(e.CommentMode=hi={}));var Qi;(function(z){z[z.Published=0]="Published",z[z.Draft=1]="Draft"})(Qi||(e.CommentState=Qi={}));var bi;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(bi||(e.CommentThreadState=bi={}));class Ri{constructor(U,se=[]){this.tokenTypes=U,this.tokenModifiers=se}}e.SemanticTokensLegend=Ri;function un(z){return typeof z>"u"||(0,h.isStringArray)(z)}class Li{constructor(U){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,U){this._hasLegend=!0;for(let se=0,Ie=U.tokenTypes.length;se<Ie;se++)this._tokenTypeStrToInt.set(U.tokenTypes[se],se);for(let se=0,Ie=U.tokenModifiers.length;se<Ie;se++)this._tokenModifierStrToInt.set(U.tokenModifiers[se],se)}}push(U,se,Ie,je,Je){if(typeof U=="number"&&typeof se=="number"&&typeof Ie=="number"&&typeof je=="number"&&(typeof Je=="number"||typeof Je>"u"))return typeof Je>"u"&&(Je=0),this._pushEncoded(U,se,Ie,je,Je);if(x.isRange(U)&&typeof se=="string"&&un(Ie))return this._push(U,se,Ie);throw(0,L.illegalArgument)()}_push(U,se,Ie){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const je=U.start.line,Je=U.start.character,lt=U.end.character-U.start.character,mt=this._tokenTypeStrToInt.get(se);let Ht=0;if(Ie)for(const Jt of Ie){if(!this._tokenModifierStrToInt.has(Jt))throw new Error("`tokenModifier` is not in the provided legend");const ii=this._tokenModifierStrToInt.get(Jt);Ht|=1<<ii>>>0}this._pushEncoded(je,Je,lt,mt,Ht)}_pushEncoded(U,se,Ie,je,Je){if(this._dataIsSortedAndDeltaEncoded&&(U<this._prevLine||U===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ht=this._data.length/5|0;let Jt=0,ii=0;for(let ri=0;ri<Ht;ri++){let ci=this._data[5*ri],Vi=this._data[5*ri+1];ci===0?(ci=Jt,Vi+=ii):ci+=Jt,this._data[5*ri]=ci,this._data[5*ri+1]=Vi,Jt=ci,ii=Vi}}let lt=U,mt=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(mt-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=mt,this._data[this._dataLen++]=Ie,this._data[this._dataLen++]=je,this._data[this._dataLen++]=Je,this._prevLine=U,this._prevChar=se}static _sortAndDeltaEncode(U){const se=[],Ie=U.length/5|0;for(let mt=0;mt<Ie;mt++)se[mt]=mt;se.sort((mt,Ht)=>{const Jt=U[5*mt],ii=U[5*Ht];if(Jt===ii){const ri=U[5*mt+1],ci=U[5*Ht+1];return ri-ci}return Jt-ii});const je=new Uint32Array(U.length);let Je=0,lt=0;for(let mt=0;mt<Ie;mt++){const Ht=5*se[mt],Jt=U[Ht+0],ii=U[Ht+1],ri=U[Ht+2],ci=U[Ht+3],Vi=U[Ht+4],kn=Jt-Je,Bn=kn===0?ii-lt:ii,qi=5*mt;je[qi+0]=kn,je[qi+1]=Bn,je[qi+2]=ri,je[qi+3]=ci,je[qi+4]=Vi,Je=Jt,lt=ii}return je}build(U){return this._dataIsSortedAndDeltaEncoded?new ai(new Uint32Array(this._data),U):new ai(Li._sortAndDeltaEncode(this._data),U)}}e.SemanticTokensBuilder=Li;class ai{constructor(U,se){this.resultId=se,this.data=U}}e.SemanticTokens=ai;class dn{constructor(U,se,Ie){this.start=U,this.deleteCount=se,this.data=Ie}}e.SemanticTokensEdit=dn;class hn{constructor(U,se){this.resultId=se,this.edits=U}}e.SemanticTokensEdits=hn;var Yi;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(Yi||(e.DebugConsoleMode=Yi={}));class Oi{constructor(U){this.name=U}}e.DebugVisualization=Oi;let Fi=class{static{this.Back={iconPath:new yt("arrow-left")}}constructor(){}};e.QuickInputButtons=Fi,e.QuickInputButtons=Fi=Ke([y],Fi);var Ji;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(Ji||(e.QuickPickItemKind=Ji={}));var wi;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(wi||(e.InputBoxValidationSeverity=wi={}));var Ni;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(Ni||(e.ExtensionKind=Ni={}));class fn{static validate(U){if(typeof U.badge=="string"){let se=(0,g.nextCharLength)(U.badge,0);if(se<U.badge.length&&(se+=(0,g.nextCharLength)(U.badge,se)),U.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!yt.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,se,Ie){this.badge=U,this.tooltip=se,this.color=Ie}}e.FileDecoration=fn;let _i=class{constructor(U){this.kind=U}};e.ColorTheme=_i,e.ColorTheme=_i=Ke([y],_i);var Mi;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(Mi||(e.ColorThemeKind=Mi={}));class ni{static isNotebookRange(U){return U instanceof ni?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(U,se){if(U<0)throw(0,L.illegalArgument)("start must be positive");if(se<0)throw(0,L.illegalArgument)("end must be positive");U<=se?(this._start=U,this._end=se):(this._start=se,this._end=U)}with(U){let se=this._start,Ie=this._end;return U.start!==void 0&&(se=U.start),U.end!==void 0&&(Ie=U.end),se===this._start&&Ie===this._end?this:new ni(se,Ie)}}e.NotebookRange=ni;class Si{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(se=>Si.isNotebookCellData(se))}static isNotebookCellData(U){return!0}constructor(U,se,Ie,je,Je,lt,mt){this.kind=U,this.value=se,this.languageId=Ie,this.mime=je,this.outputs=Je??[],this.metadata=lt,this.executionSummary=mt,Si.validate(this)}}e.NotebookCellData=Si;class mn{constructor(U){this.cells=U}}e.NotebookData=mn;class Yt{static isNotebookCellOutputItem(U){return U instanceof Yt?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const se={name:U.name,message:U.message,stack:U.stack};return Yt.json(se,"application/vnd.code.notebook.error")}static stdout(U){return Yt.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return Yt.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,se="application/octet-stream"){return new Yt(U,se)}static#e=new TextEncoder;static text(U,se=T.Mimes.text){const Ie=Yt.#e.encode(String(U));return new Yt(Ie,se)}static json(U,se="text/x-json"){const Ie=JSON.stringify(U,void 0,"	");return Yt.text(Ie,se)}constructor(U,se){this.data=U,this.mime=se;const Ie=(0,T.normalizeMimeType)(se,!0);if(!Ie)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ie}}e.NotebookCellOutputItem=Yt;class fi{static isNotebookCellOutput(U){return U instanceof fi?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,se=!1){const Ie=new Set,je=new Set;for(let Je=0;Je<U.length;Je++){const lt=U[Je],mt=(0,T.normalizeMimeType)(lt.mime);if(!Ie.has(mt)||(0,E.isTextStreamMime)(mt)){Ie.add(mt);continue}je.add(Je),se&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return je.size===0?U:U.filter((Je,lt)=>!je.has(lt))}constructor(U,se,Ie){this.items=fi.ensureUniqueMimeTypes(U,!0),typeof se=="string"?(this.id=se,this.metadata=Ie):(this.id=(0,R.generateUuid)(),this.metadata=se??Ie)}}e.NotebookCellOutput=fi;var Ui;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(Ui||(e.NotebookCellKind=Ui={}));var xe;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(xe||(e.NotebookCellExecutionState=xe={}));var ti;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(ti||(e.NotebookCellStatusBarAlignment=ti={}));var xi;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(xi||(e.NotebookEditorRevealType=xi={}));class Ze{constructor(U,se){this.text=U,this.alignment=se}}e.NotebookCellStatusBarItem=Ze;var vt;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(vt||(e.NotebookControllerAffinity=vt={}));var Zi;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(Zi||(e.NotebookControllerAffinity2=Zi={}));class gn{constructor(U,se=[]){this.uri=U,this.provides=(0,I.asArray)(se)}}e.NotebookRendererScript=gn;class en{constructor(U){this.label=U}}e.NotebookKernelSourceAction=en;var tn;(function(z){z[z.Named=1]="Named",z[z.Indexed=2]="Indexed"})(tn||(e.NotebookVariablesRequestKind=tn={}));let mi=class{constructor(U,se){this.label=U,this.timestamp=se}};e.TimelineItem=mi,e.TimelineItem=mi=Ke([y],mi);var nn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(nn||(e.ExtensionMode=nn={}));var rn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(rn||(e.ExtensionRuntime=rn={}));var sn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(sn||(e.StandardTokenType=sn={}));class on{constructor(U,se){this.ranges=U,this.wordPattern=se}}e.LinkedEditingRanges=on;class pn{constructor(U){this._autoForwardAction=U}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=pn;var an;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(an||(e.TestResultState=an={}));var cn;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(cn||(e.TestRunProfileKind=cn={}));let Bi=class{constructor(U=void 0,se=void 0,Ie=void 0,je=!1){this.include=U,this.exclude=se,this.profile=Ie,this.continuous=je}};e.TestRunRequest=Bi,e.TestRunRequest=Bi=Ke([y],Bi);let zi=v=class{static diff(U,se,Ie){const je=new v(U);return je.expectedOutput=se,je.actualOutput=Ie,je}constructor(U){this.message=U}};e.TestMessage=zi,e.TestMessage=zi=v=Ke([y],zi);let $i=class{constructor(U){this.id=U}};e.TestTag=$i,e.TestTag=$i=Ke([y],$i);class yi{constructor(U,se){this.covered=U,this.total=se}}e.CoveredCount=yi;const Hi=z=>{if(z&&z.covered>z.total)throw new Error(`The total number of covered items (${z.covered}) cannot be greater than the total (${z.total})`)};class Wi{static fromDetails(U,se){const Ie=new yi(0,0),je=new yi(0,0),Je=new yi(0,0);for(const mt of se)if("branches"in mt){Ie.total+=1,Ie.covered+=mt.executionCount>0?1:0;for(const Ht of mt.branches)je.total+=1,je.covered+=Ht.executionCount>0?1:0}else Je.total+=1,Je.covered+=mt.executionCount>0?1:0;const lt=new Wi(U,Ie,je.total>0?je:void 0,Je.total>0?Je:void 0);return lt.detailedCoverage=se,lt}constructor(U,se,Ie,je){this.uri=U,this.statementCoverage=se,this.branchCoverage=Ie,this.functionCoverage=je,Hi(se),Hi(Ie),Hi(je)}}e.FileCoverage=Wi;class vn{constructor(U,se,Ie=[]){this.executionCount=U,this.location=se,this.branches=Ie}}e.StatementCoverage=vn;class ie{constructor(U,se,Ie){this.executionCount=U,this.location=se,this.label=Ie}}e.BranchCoverage=ie;class ue{constructor(U,se,Ie){this.name=U,this.executionCount=se,this.location=Ie}}e.FunctionCoverage=ue;var Me;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(Me||(e.ExternalUriOpenerPriority=Me={}));var at;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(at||(e.WorkspaceTrustState=at={}));var Et;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(Et||(e.PortAutoForwardAction=Et={}));class Tt{constructor(U,se,Ie,je,Je,lt){this.kind=U,this.name=se,this.detail=Ie,this.uri=je,this.range=Je,this.selectionRange=lt}}e.TypeHierarchyItem=Tt;class ln{constructor(U){this.uri=U}}e.TextTabInput=ln;class Pn{constructor(U,se){this.original=U,this.modified=se}}e.TextDiffTabInput=Pn;class Tn{constructor(U,se,Ie,je){this.base=U,this.input1=se,this.input2=Ie,this.result=je}}e.TextMergeTabInput=Tn;class An{constructor(U,se){this.uri=U,this.viewType=se}}e.CustomEditorTabInput=An;class Rn{constructor(U){this.viewType=U}}e.WebviewEditorTabInput=Rn;class Ln{constructor(U,se){this.uri=U,this.notebookType=se}}e.NotebookEditorTabInput=Ln;class On{constructor(U,se,Ie){this.original=U,this.modified=se,this.notebookType=Ie}}e.NotebookDiffEditorTabInput=On;class Fn{constructor(){}}e.TerminalEditorTabInput=Fn;class Nn{constructor(U,se){this.uri=U,this.inputBoxUri=se}}e.InteractiveWindowInput=Nn;class Mn{constructor(U){this.providerId=U}}e.ChatEditorTabInput=Mn;var En;(function(z){z[z.Down=0]="Down",z[z.Up=1]="Up"})(En||(e.InteractiveSessionVoteDirection=En={}));var bn;(function(z){z[z.Action=1]="Action",z[z.Toolbar=2]="Toolbar"})(bn||(e.ChatAgentCopyKind=bn={}));var wn;(function(z){z[z.Short=1]="Short",z[z.Medium=2]="Medium",z[z.Full=3]="Full"})(wn||(e.ChatVariableLevel=wn={}));class Un{constructor(U,se){this.label=U,this.values=se}}e.ChatAgentCompletionItem=Un;var _n;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful",z[z.Undone=2]="Undone",z[z.Accepted=3]="Accepted",z[z.Bug=4]="Bug"})(_n||(e.InteractiveEditorResponseFeedbackKind=_n={}));var Sn;(function(z){z[z.System=0]="System",z[z.User=1]="User",z[z.Assistant=2]="Assistant",z[z.Function=3]="Function"})(Sn||(e.ChatMessageRole=Sn={}));class xn{constructor(U,se){this.role=U,this.content=se}}e.ChatMessage=xn;var yn;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful"})(yn||(e.ChatAgentResultFeedbackKind=yn={}));var Dn;(function(z){z[z.SymbolInformation=1]="SymbolInformation",z[z.CommandInformation=2]="CommandInformation",z[z.SearchInformation=3]="SearchInformation",z[z.SettingInformation=4]="SettingInformation"})(Dn||(e.RelatedInformationType=Dn={}));var In;(function(z){z[z.Started=1]="Started",z[z.Recognizing=2]="Recognizing",z[z.Recognized=3]="Recognized",z[z.Stopped=4]="Stopped"})(In||(e.SpeechToTextStatus=In={}));var Cn;(function(z){z[z.Recognized=1]="Recognized",z[z.Stopped=2]="Stopped"})(Cn||(e.KeywordRecognitionStatus=Cn={}))}),define(Pe[237],Te([1,0,3,7]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRelatedInformation=void 0;class C{constructor(T){this._relatedInformationProviders=new Map,this._nextHandle=0,this._proxy=T.getProxy(I.MainContext.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(T,g,h){if(this._relatedInformationProviders.size===0)throw new Error("No related information providers registered");const S=this._relatedInformationProviders.get(T);if(!S)throw new Error("related information provider not found");return await S.provideRelatedInformation(g,h)??[]}getRelatedInformation(T,g,h){return this._proxy.$getAiRelatedInformation(g,h)}registerRelatedInformationProvider(T,g,h){const S=this._nextHandle;return this._nextHandle++,this._relatedInformationProviders.set(S,h),this._proxy.$registerAiRelatedInformationProvider(S,g),new L.Disposable(()=>{this._proxy.$unregisterAiRelatedInformationProvider(S),this._relatedInformationProviders.delete(S)})}}e.ExtHostRelatedInformation=C}),define(Pe[238],Te([1,0,5,3,7,22]),function(me,e,I,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(S){this._authenticationProviders=new Map,this._onDidChangeSessions=new I.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new g,this._getSessionsTaskSingler=new g,this._proxy=S.getProxy(L.MainContext.MainThreadAuthentication)}async getSession(S,R,D,u={}){const p=A.ExtensionIdentifier.toKey(S.identifier),E=[...D].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${p} ${R} ${E}`,async()=>{await this._proxy.$ensureProvider(R);const i=S.displayName||S.name;return this._proxy.$getSession(R,D,p,i,u)})}async getSessions(S,R,D){const u=A.ExtensionIdentifier.toKey(S.identifier),p=[...D].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${u} ${p}`,async()=>{await this._proxy.$ensureProvider(R);const E=S.displayName||S.name;return this._proxy.$getSessions(R,D,u,E)})}async removeSession(S,R){const D=this._authenticationProviders.get(S);return D?D.provider.removeSession(R):this._proxy.$removeSession(S,R)}registerAuthenticationProvider(S,R,D,u){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:R,provider:D,options:u??{supportsMultipleAccounts:!1}});const p=D.onDidChangeSessions(E=>this._proxy.$sendDidChangeSessions(S,E));return this._proxy.$registerAuthenticationProvider(S,R,u?.supportsMultipleAccounts??!1),new C.Disposable(()=>{p.dispose(),this._authenticationProviders.delete(S),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,R,D){const u=this._authenticationProviders.get(S);if(u)return Promise.resolve(u.provider.createSession(R,D));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,R){const D=this._authenticationProviders.get(S);if(D)return Promise.resolve(D.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,R){const D=this._authenticationProviders.get(S);if(D)return Promise.resolve(D.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,R){return this._onDidChangeSessions.fire({provider:{id:S,label:R}}),Promise.resolve()}}e.ExtHostAuthentication=T;class g{constructor(){this._inFlightPromises=new Map}getOrCreate(S,R){const D=this._inFlightPromises.get(S);if(D)return D;const u=R().finally(()=>this._inFlightPromises.delete(S));return this._inFlightPromises.set(S,u),u}}}),define(Pe[107],Te([1,0,2,3,7,4,17,14,18,12,19,24]),function(me,e,I,L,C,A,T,g,h,S,R,D){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let p=class{static{u=this}static{this._handlePool=0}static{this._maxEventSize=250}constructor(i,a){this._logService=a,this._provider=new Map,this._proxy=i.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(i,a){const r=u._handlePool++;this._provider.set(r,{provider:i,extensionDescription:a}),this._proxy.$registerDecorationProvider(r,a.identifier.value);const n=i.onDidChangeFileDecorations&&i.onDidChangeFileDecorations(o=>{if(!o){this._proxy.$onDidChange(r,null);return}const c=(0,h.asArray)(o);if(c.length<=u._maxEventSize){this._proxy.$onDidChange(r,c);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.identifier.value,c.length);const l=c.map(s=>({uri:s,rank:(0,S.count)(s.path,"/")})),t=(0,h.groupBy)(l,(s,b)=>s.rank-b.rank||(0,S.compare)(s.uri.path,b.uri.path)),d=[];e:for(const s of t){let b;for(const _ of s){const f=(0,R.dirname)(_.uri.path);if(b!==f&&(b=f,d.push(_.uri)>=u._maxEventSize))break e}}this._proxy.$onDidChange(r,d)});return new C.Disposable(()=>{n?.dispose(),this._proxy.$unregisterDecorationProvider(r),this._provider.delete(r)})}async $provideDecorations(i,a,r){if(!this._provider.has(i))return Object.create(null);const n=Object.create(null),{provider:o,extensionDescription:c}=this._provider.get(i);return await Promise.all(a.map(async l=>{try{const{uri:t,id:d}=l,s=await Promise.resolve(o.provideFileDecoration(I.URI.revive(t),r));if(!s)return;try{C.FileDecoration.validate(s),s.badge&&typeof s.badge!="string"&&(0,D.checkProposedApiEnabled)(c,"codiconDecoration"),n[d]=[s.propagate,s.tooltip,s.badge,s.color]}catch(b){this._logService.warn(`INVALID decoration from extension '${c.identifier.value}': ${b}`)}}catch(t){this._logService.error(t)}})),n}};e.ExtHostDecorations=p,e.ExtHostDecorations=p=u=Ke([We(0,T.IExtHostRpcService),We(1,g.ILogService)],p),e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")}),define(Pe[239],Te([1,0,15,2,7,3,11,20,12]),function(me,e,I,L,C,A,T,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class S{static{this._handlePool=0}constructor(D,u,p){this._documentsAndEditors=u,this._logService=p,this._documentContentProviders=new Map,this._proxy=D.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,u){if(Object.keys(T.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const p=S._handlePool++;this._documentContentProviders.set(p,u),this._proxy.$registerTextContentProvider(p,D);let E;if(typeof u.onDidChange=="function"){let i;E=u.onDidChange(async a=>{if(a.scheme!==D){this._logService.warn(`Provider for scheme '${D}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}if(!this._documentsAndEditors.getDocument(a))return;i&&await i;const r=this.$provideTextDocumentContent(p,a).then(async n=>{if(!n&&typeof n!="string")return;const o=this._documentsAndEditors.getDocument(a);if(!o)return;const c=(0,h.splitLines)(n);if(!o.equalLines(c))return this._proxy.$onVirtualDocumentChange(a,n)}).catch(I.onUnexpectedError).finally(()=>{i===r&&(i=void 0)});i=r})}return new C.Disposable(()=>{this._documentContentProviders.delete(p)&&this._proxy.$unregisterTextContentProvider(p),E&&(E.dispose(),E=void 0)})}$provideTextDocumentContent(D,u){const p=this._documentContentProviders.get(D);return p?Promise.resolve(p.provideTextDocumentContent(L.URI.revive(u),g.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.ExtHostDocumentContentProvider=S}),define(Pe[108],Te([1,0,54,11,12,296,147,7,18]),function(me,e,I,L,C,A,T,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const S=new Map;function R(E,i){i?S.set(E,i):S.delete(E)}e.setWordDefinitionFor=R;function D(E){return S.get(E)}class u extends A.MirrorTextModel{constructor(i,a,r,n,o,c,l,t){super(a,r,n,o),this._proxy=i,this._languageId=c,this._isDirty=l,this.notebook=t,this._isDisposed=!1}dispose(){(0,I.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(i){return(0,h.equals)(this._lines,i)}get document(){if(!this._document){const i=this;this._document={get uri(){return i._uri},get fileName(){return i._uri.fsPath},get isUntitled(){return i._uri.scheme===L.Schemas.untitled},get languageId(){return i._languageId},get version(){return i._versionId},get isClosed(){return i._isDisposed},get isDirty(){return i._isDirty},save(){return i._save()},getText(a){return a?i._getTextInRange(a):i.getText()},get eol(){return i._eol===`
`?g.EndOfLine.LF:g.EndOfLine.CRLF},get lineCount(){return i._lines.length},lineAt(a){return i._lineAt(a)},offsetAt(a){return i._offsetAt(a)},positionAt(a){return i._positionAt(a)},validateRange(a){return i._validateRange(a)},validatePosition(a){return i._validatePosition(a)},getWordRangeAtPosition(a,r){return i._getWordRangeAtPosition(a,r)}}}return Object.freeze(this._document)}_acceptLanguageId(i){(0,I.ok)(!this._isDisposed),this._languageId=i}_acceptIsDirty(i){(0,I.ok)(!this._isDisposed),this._isDirty=i}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(i){const a=this._validateRange(i);if(a.isEmpty)return"";if(a.isSingleLine)return this._lines[a.start.line].substring(a.start.character,a.end.character);const r=this._eol,n=a.start.line,o=a.end.line,c=[];c.push(this._lines[n].substring(a.start.character));for(let l=n+1;l<o;l++)c.push(this._lines[l]);return c.push(this._lines[o].substring(0,a.end.character)),c.join(r)}_lineAt(i){let a;if(i instanceof g.Position?a=i.line:typeof i=="number"&&(a=i),typeof a!="number"||a<0||a>=this._lines.length||Math.floor(a)!==a)throw new Error("Illegal value for `line`");return new p(a,this._lines[a],a===this._lines.length-1)}_offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getPrefixSum(i.line-1)+i.character}_positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();const a=this._lineStarts.getIndexOf(i),r=this._lines[a.index].length;return new g.Position(a.index,Math.min(a.remainder,r))}_validateRange(i){if(!(i instanceof g.Range))throw new Error("Invalid argument");const a=this._validatePosition(i.start),r=this._validatePosition(i.end);return a===i.start&&r===i.end?i:new g.Range(a.line,a.character,r.line,r.character)}_validatePosition(i){if(!(i instanceof g.Position))throw new Error("Invalid argument");if(this._lines.length===0)return i.with(0,0);let{line:a,character:r}=i,n=!1;if(a<0)a=0,r=0,n=!0;else if(a>=this._lines.length)a=this._lines.length-1,r=this._lines[a].length,n=!0;else{const o=this._lines[a].length;r<0?(r=0,n=!0):r>o&&(r=o,n=!0)}return n?new g.Position(a,r):i}_getWordRangeAtPosition(i,a){const r=this._validatePosition(i);if(!a)a=D(this._languageId);else if((0,C.regExpLeadsToEndlessLoop)(a))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${a.source}' because it matches the empty string.`);const n=(0,T.getWordAtText)(r.character+1,(0,T.ensureValidWordDefinition)(a),this._lines[r.line],0);if(n)return new g.Range(r.line,n.startColumn-1,r.line,n.endColumn-1)}}e.ExtHostDocumentData=u;class p{constructor(i,a,r){this._line=i,this._text=a,this._isLastLine=r}get lineNumber(){return this._line}get text(){return this._text}get range(){return new g.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new g.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=p}),define(Pe[240],Te([1,0,3,7]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAiEmbeddingVector=void 0;class C{constructor(T){this._AiEmbeddingVectorProviders=new Map,this._nextHandle=0,this._proxy=T.getProxy(I.MainContext.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(T,g,h){if(this._AiEmbeddingVectorProviders.size===0)throw new Error("No embedding vector providers registered");const S=this._AiEmbeddingVectorProviders.get(T);if(!S)throw new Error("Embedding vector provider not found");const R=await S.provideEmbeddingVector(g,h);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(T,g,h){const S=this._nextHandle;return this._nextHandle++,this._AiEmbeddingVectorProviders.set(S,h),this._proxy.$registerAiEmbeddingVectorProvider(g,S),new L.Disposable(()=>{this._proxy.$unregisterAiEmbeddingVectorProvider(S),this._AiEmbeddingVectorProviders.delete(S)})}}e.ExtHostAiEmbeddingVector=C}),define(Pe[62],Te([1,0,3,42,7,23,4,17,43,6,13,25,11]),function(me,e,I,L,C,A,T,g,h,S,R,D,u){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let E=p=class{constructor(a,r){this._fileSystemProvider=new Map,this._writeQueue=new R.ResourceQueue,this._proxy=a.getProxy(I.MainContext.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(o){try{let c;const l=n._fileSystemProvider.get(o.scheme);return l?(await n._proxy.$ensureActivation(o.scheme),c=await l.impl.stat(o)):c=await n._proxy.$stat(o),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===L.FilePermission.Readonly?1:void 0}}catch(c){p._handleError(c)}},async readDirectory(o){try{const c=n._fileSystemProvider.get(o.scheme);return c?(await n._proxy.$ensureActivation(o.scheme),(await c.impl.readDirectory(o)).slice()):await n._proxy.$readdir(o)}catch(c){return p._handleError(c)}},async createDirectory(o){try{const c=n._fileSystemProvider.get(o.scheme);return c&&!c.isReadonly?(await n._proxy.$ensureActivation(o.scheme),await n.mkdirp(c.impl,c.extUri,o)):await n._proxy.$mkdir(o)}catch(c){return p._handleError(c)}},async readFile(o){try{const c=n._fileSystemProvider.get(o.scheme);return c?(await n._proxy.$ensureActivation(o.scheme),(await c.impl.readFile(o)).slice()):(await n._proxy.$readFile(o)).buffer}catch(c){return p._handleError(c)}},async writeFile(o,c){try{const l=n._fileSystemProvider.get(o.scheme);return l&&!l.isReadonly?(await n._proxy.$ensureActivation(o.scheme),await n.mkdirp(l.impl,l.extUri,l.extUri.dirname(o)),await n._writeQueue.queueFor(o,()=>Promise.resolve(l.impl.writeFile(o,c,{create:!0,overwrite:!0})))):await n._proxy.$writeFile(o,A.VSBuffer.wrap(c))}catch(l){return p._handleError(l)}},async delete(o,c){try{const l=n._fileSystemProvider.get(o.scheme);return l&&!l.isReadonly&&!c?.useTrash?(await n._proxy.$ensureActivation(o.scheme),await l.impl.delete(o,{recursive:!1,...c})):await n._proxy.$delete(o,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(l){return p._handleError(l)}},async rename(o,c,l){try{return await n._proxy.$rename(o,c,{overwrite:!1,...l})}catch(t){return p._handleError(t)}},async copy(o,c,l){try{return await n._proxy.$copy(o,c,{overwrite:!1,...l})}catch(t){return p._handleError(t)}},isWritableFileSystem(o){const c=r.getCapabilities(o);if(typeof c=="number")return!(c&2048)}})}async mkdirp(a,r,n){const o=[];for(;!r.isEqual(n,r.dirname(n));)try{if(!((await a.stat(n)).type&L.FileType.Directory))throw C.FileSystemError.FileExists(`Unable to create folder '${n.scheme===u.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(L.toFileSystemProviderErrorCode(c)!==L.FileSystemProviderErrorCode.FileNotFound)throw c;o.push(r.basename(n)),n=r.dirname(n)}for(let c=o.length-1;c>=0;c--){n=r.joinPath(n,o[c]);try{await a.createDirectory(n)}catch(l){if(L.toFileSystemProviderErrorCode(l)!==L.FileSystemProviderErrorCode.FileExists)throw l}}}static _handleError(a){if(a instanceof C.FileSystemError)throw a;if(a instanceof L.FileSystemProviderError)switch(a.code){case L.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(a.message);case L.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(a.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(a.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(a.message);case L.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(a.message);case L.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(a.message);default:throw new C.FileSystemError(a.message,a.name)}if(!(a instanceof Error))throw new C.FileSystemError(String(a));if(a.name==="ENOPRO"||a.message.includes("ENOPRO"))throw C.FileSystemError.Unavailable(a.message);switch(a.name){case L.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(a.message);case L.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(a.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(a.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(a.message);case L.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(a.message);case L.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(a.message);default:throw new C.FileSystemError(a.message,a.name)}}addFileSystemProvider(a,r,n){return this._fileSystemProvider.set(a,{impl:r,extUri:n?.isCaseSensitive?D.extUri:D.extUriIgnorePathCase,isReadonly:!!n?.isReadonly}),(0,S.toDisposable)(()=>this._fileSystemProvider.delete(a))}getFileSystemProviderExtUri(a){return this._fileSystemProvider.get(a)?.extUri??D.extUri}};e.ExtHostConsumerFileSystem=E,e.ExtHostConsumerFileSystem=E=p=Ke([We(0,g.IExtHostRpcService),We(1,h.IExtHostFileSystemInfo)],E),e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(Pe[241],Te([1,0,3,7]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class C{constructor(T){this._IssueUriRequestHandlers=new Map,this._IssueDataProviders=new Map,this._proxy=T.getProxy(I.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(T,g){if(this._IssueUriRequestHandlers.size===0)throw new Error("No issue request handlers registered");const h=this._IssueUriRequestHandlers.get(T);if(!h)throw new Error("Issue request handler not found");const S=await h.handleIssueUrlRequest();if(!S)throw new Error("Issue request handler returned no result");return S}async $getIssueReporterData(T,g){if(this._IssueDataProviders.size===0)throw new Error("No issue request handlers registered");const h=this._IssueDataProviders.get(T);if(!h)throw new Error("Issue data provider not found");const S=await h.provideIssueData(g);if(!S)throw new Error("Issue data provider returned no result");return S}async $getIssueReporterTemplate(T,g){if(this._IssueDataProviders.size===0)throw new Error("No issue request handlers registered");const h=this._IssueDataProviders.get(T);if(!h)throw new Error("Issue data provider not found");const S=await h.provideIssueTemplate(g);if(!S)throw new Error("Issue template provider returned no result");return S}registerIssueUriRequestHandler(T,g){const h=T.identifier.value;return this._IssueUriRequestHandlers.set(h,g),this._proxy.$registerIssueUriRequestHandler(h),new L.Disposable(()=>{this._proxy.$unregisterIssueUriRequestHandler(h),this._IssueUriRequestHandlers.delete(h)})}registerIssueDataProvider(T,g){const h=T.identifier.value;return this._IssueDataProviders.set(h,g),this._proxy.$registerIssueDataProvider(h),new L.Disposable(()=>{this._proxy.$unregisterIssueDataProvider(h),this._IssueDataProviders.delete(h)})}}e.ExtHostIssueReporter=C}),define(Pe[85],Te([1,0,4,27,14,62,2]),function(me,e,I,L,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,I.createDecorator)("IExtensionStoragePaths");let g=class{constructor(S,R,D){this._logService=R,this._extHostFileSystem=D,this._workspace=S.workspace??void 0,this._environment=S.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(u=>this._value=u)}async _getWorkspaceStorageURI(S){return T.URI.joinPath(this._environment.workspaceStorageHome,S)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const S=this._workspace.id,R=await this._getWorkspaceStorageURI(S);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(D){this._logService.error("[ExtHostStorage]",D);return}}workspaceValue(S){if(this._value)return T.URI.joinPath(this._value,S.identifier.value)}globalValue(S){return T.URI.joinPath(this._environment.globalStorageHome,S.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=g,e.ExtensionStoragePaths=g=Ke([We(0,L.IExtHostInitDataService),We(1,C.ILogService),We(2,A.IExtHostConsumerFileSystem)],g)}),define(Pe[242],Te([1,0,7,17,5]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(g){this._actual=new I.ColorTheme(I.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new C.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(g){let h;switch(g){case"light":h=I.ColorThemeKind.Light;break;case"hcDark":h=I.ColorThemeKind.HighContrast;break;case"hcLight":h=I.ColorThemeKind.HighContrastLight;break;default:h=I.ColorThemeKind.Dark}this._actual=new I.ColorTheme(h),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=A,e.ExtHostTheming=A=Ke([We(0,L.IExtHostRpcService)],A)}),define(Pe[86],Te([1,0,20,5,6,167,4,14,196,3,27,17,7]),function(me,e,I,L,C,A,T,g,h,S,R,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;class p extends h.DisposableTunnel{}var E;(function(a){function r(o){return{remoteAddress:o.remoteAddress,localAddress:o.localAddress,public:!!o.public,privacy:o.privacy??(o.public?h.TunnelPrivacyId.Public:h.TunnelPrivacyId.Private),protocol:o.protocol}}a.fromApiTunnel=r;function n(o){return{remoteAddress:{host:o.tunnelRemoteHost,port:o.tunnelRemotePort},localAddress:o.localAddress,public:o.privacy!==h.TunnelPrivacyId.ConstantPrivate&&o.privacy!==h.TunnelPrivacyId.ConstantPrivate,privacy:o.privacy,protocol:o.protocol}}a.fromServiceTunnel=n})(E||(e.TunnelDtoConverter=E={})),e.IExtHostTunnelService=(0,T.createDecorator)("IExtHostTunnelService");let i=class extends C.Disposable{constructor(r,n,o){super(),this.logService=o,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new L.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=r.getProxy(S.MainContext.MainThreadTunnelService)}async openTunnel(r,n){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${r.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const o=await this._proxy.$openTunnel(n,r.displayName);if(o){const c=new p(o.remoteAddress,o.localAddress,()=>this._proxy.$closeTunnel(o.remoteAddress));return this._register(c),c}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(r,n){const o=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(o,{selector:r,provider:n}),this._proxy.$registerPortsAttributesProvider(r,o),new u.Disposable(()=>{this._portAttributesProviders.delete(o),this._proxy.$unregisterPortsAttributesProvider(o)})}async $providePortAttributes(r,n,o,c,l){const t=[];for(const s of r){const b=this._portAttributesProviders.get(s);if(!b)return[];t.push(...await Promise.all(n.map(async _=>{let f;try{f=await b.provider.providePortAttributes({port:_,pid:o,commandLine:c},l)}catch{f=await b.provider.providePortAttributes(_,o,c,l)}return{providedAttributes:f,port:_}})))}const d=t.filter(s=>!!s.providedAttributes);return d.length>0?d.map(s=>({autoForwardAction:s.providedAttributes.autoForwardAction,port:s.port})):[]}async $registerCandidateFinder(r){}registerTunnelProvider(r,n){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(c,l)=>await r.provideTunnel(c,l,new I.CancellationTokenSource().token)??void 0;const o=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this._proxy.$setTunnelProvider(o),Promise.resolve((0,C.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(r,n){if(r){r.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(r.candidatePortSource),r.showCandidatePort&&(this._showCandidatePort=r.showCandidatePort,this._proxy.$setCandidateFilter());const o=r.tunnelFactory??(n?this.makeManagedTunnelFactory(n):void 0);if(o){this._forwardPortProvider=o;let c=r.tunnelFeatures?.privacyOptions??[];r.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:A.localize(0,null),themeIcon:"lock"},{id:"public",label:A.localize(1,null),themeIcon:"eye"}]);const l=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,public:!!r.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this._proxy.$setTunnelProvider(l)}}else this._forwardPortProvider=void 0;return(0,C.toDisposable)(()=>{this._forwardPortProvider=void 0})}makeManagedTunnelFactory(r){}async $closeTunnel(r,n){if(this._extensionTunnels.has(r.host)){const o=this._extensionTunnels.get(r.host);o.has(r.port)&&(n&&o.get(r.port).disposeListener.dispose(),await o.get(r.port).tunnel.dispose(),o.delete(r.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(r,n){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const o=this._forwardPortProvider(r,n);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),o!==void 0){const c=await o;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(r.remoteAddress.host)||this._extensionTunnels.set(r.remoteAddress.host,new Map);const l=this._register(c.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(c.remoteAddress))));return this._extensionTunnels.get(r.remoteAddress.host).set(r.remoteAddress.port,{tunnel:c,disposeListener:l}),E.fromApiTunnel(c)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(o){if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),o instanceof Error)return o.message}}async $applyCandidateFilter(r){const n=await Promise.all(r.map(c=>this._showCandidatePort(c.host,c.port,c.detail??""))),o=r.filter((c,l)=>n[l]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${r.map(c=>c.port).join(", ")} to ${o.map(c=>c.port).join(", ")}`),o}};e.ExtHostTunnelService=i,e.ExtHostTunnelService=i=Ke([We(0,D.IExtHostRpcService),We(1,R.IExtHostInitDataService),We(2,g.ILogService)],i)}),define(Pe[8],Te([1,0,18,23,127,243,52,28,120,51,69,26,16,2,29,87,99,103,102,84,48,59,215,24,7]),function(me,e,I,L,C,A,T,g,h,S,R,D,u,p,E,i,a,r,n,o,c,l,t,d,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatAgentRequest=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var b;(function(De){function Oe(G){const{selectionStartLineNumber:Ce,selectionStartColumn:Ue,positionLineNumber:Xe,positionColumn:He}=G,ot=new s.Position(Ce-1,Ue-1),wt=new s.Position(Xe-1,He-1);return new s.Selection(ot,wt)}De.to=Oe;function he(G){const{anchor:Ce,active:Ue}=G;return{selectionStartLineNumber:Ce.line+1,selectionStartColumn:Ce.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}De.from=he})(b||(e.Selection=b={}));var _;(function(De){function Oe(G){if(!G)return;const{start:Ce,end:Ue}=G;return{startLineNumber:Ce.line+1,startColumn:Ce.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}De.from=Oe;function he(G){if(!G)return;const{startLineNumber:Ce,startColumn:Ue,endLineNumber:Xe,endColumn:He}=G;return new s.Range(Ce-1,Ue-1,Xe-1,He-1)}De.to=he})(_||(e.Range=_={}));var f;(function(De){function Oe(he){return new s.Location(p.URI.revive(he.uri),_.to(he.range))}De.to=Oe})(f||(e.Location=f={}));var w;(function(De){function Oe(he){switch(he){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}De.to=Oe})(w||(e.TokenType=w={}));var P;(function(De){function Oe(G){return new s.Position(G.lineNumber-1,G.column-1)}De.to=Oe;function he(G){return{lineNumber:G.line+1,column:G.character+1}}De.from=he})(P||(e.Position=P={}));var m;(function(De){function Oe(Ce,Ue,Xe){return(0,I.coalesce)((0,I.asArray)(Ce).map(He=>he(He,Ue,Xe)))}De.from=Oe;function he(Ce,Ue,Xe){if(typeof Ce=="string")return{$serialized:!0,language:Ce,isBuiltin:Xe?.isBuiltin};if(Ce)return{$serialized:!0,language:Ce.language,scheme:G(Ce.scheme,Ue),pattern:Y.from(Ce.pattern)??void 0,exclusive:Ce.exclusive,notebookType:Ce.notebookType,isBuiltin:Xe?.isBuiltin}}function G(Ce,Ue){return Ue&&typeof Ce=="string"?Ue.transformOutgoingScheme(Ce):Ce}})(m||(e.DocumentSelector=m={}));var v;(function(De){function Oe(G){switch(G){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}De.from=Oe;function he(G){switch(G){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}De.to=he})(v||(e.DiagnosticTag=v={}));var y;(function(De){function Oe(G){let Ce;return G.code&&((0,u.isString)(G.code)||(0,u.isNumber)(G.code)?Ce=String(G.code):Ce={value:String(G.code.value),target:G.code.target}),{..._.from(G.range),message:G.message,source:G.source,code:Ce,severity:N.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(O.from),tags:Array.isArray(G.tags)?(0,I.coalesce)(G.tags.map(v.from)):void 0}}De.from=Oe;function he(G){const Ce=new s.Diagnostic(_.to(G),G.message,N.to(G.severity));return Ce.source=G.source,Ce.code=(0,u.isString)(G.code)?G.code:G.code?.value,Ce.relatedInformation=G.relatedInformation&&G.relatedInformation.map(O.to),Ce.tags=G.tags&&(0,I.coalesce)(G.tags.map(v.to)),Ce}De.to=he})(y||(e.Diagnostic=y={}));var O;(function(De){function Oe(G){return{..._.from(G.location.range),message:G.message,resource:G.location.uri}}De.from=Oe;function he(G){return new s.DiagnosticRelatedInformation(new s.Location(G.resource,_.to(G)),G.message)}De.to=he})(O||(e.DiagnosticRelatedInformation=O={}));var N;(function(De){function Oe(G){switch(G){case s.DiagnosticSeverity.Error:return a.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return a.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return a.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return a.MarkerSeverity.Hint}return a.MarkerSeverity.Error}De.from=Oe;function he(G){switch(G){case a.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case a.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case a.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case a.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}De.to=he})(N||(e.DiagnosticSeverity=N={}));var q;(function(De){function Oe(G){return typeof G=="number"&&G>=s.ViewColumn.One?G-1:G===s.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}De.from=Oe;function he(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}De.to=he})(q||(e.ViewColumn=q={}));function W(De){return typeof De.range<"u"}function x(De){return De.length===0?!0:!!W(De[0])}e.isDecorationOptionsArr=x;var k;(function(De){function Oe(He){return He.map(De.from)}De.fromMany=Oe;function he(He){return He&&typeof He=="object"&&typeof He.language=="string"&&typeof He.value=="string"}function G(He){let ot;if(he(He)){const{language:Dt,value:bt}=He;ot={value:"```"+Dt+`
`+bt+"\n```\n"}}else s.MarkdownString.isMarkdownString(He)?ot={value:He.value,isTrusted:He.isTrusted,supportThemeIcons:He.supportThemeIcons,supportHtml:He.supportHtml,baseUri:He.baseUri}:typeof He=="string"?ot={value:He}:ot={value:""};const wt=Object.create(null);ot.uris=wt;const qt=Dt=>{try{let bt=p.URI.parse(Dt,!0);bt=bt.with({query:Ce(bt.query,wt)}),wt[Dt]=bt}catch{}return""},yt=new h.marked.Renderer;return yt.link=qt,yt.image=Dt=>typeof Dt=="string"?qt(T.parseHrefAndDimensions(Dt).href):"",(0,h.marked)(ot.value,{renderer:yt}),ot}De.from=G;function Ce(He,ot){if(!He)return He;let wt;try{wt=(0,S.parse)(He)}catch{}if(!wt)return He;let qt=!1;return wt=(0,D.cloneAndChange)(wt,yt=>{if(p.URI.isUri(yt)){const Dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[Dt]=yt,qt=!0,Dt}else return}),qt?JSON.stringify(wt):He}function Ue(He){const ot=new s.MarkdownString(He.value,He.supportThemeIcons);return ot.isTrusted=He.isTrusted,ot.supportHtml=He.supportHtml,ot.baseUri=He.baseUri?p.URI.from(He.baseUri):void 0,ot}De.to=Ue;function Xe(He){if(He)return typeof He=="string"?He:De.from(He)}De.fromStrict=Xe})(k||(e.MarkdownString=k={}));function M(De){return x(De)?De.map(Oe=>({range:_.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?k.fromMany(Oe.hoverMessage):Oe.hoverMessage?k.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):De.map(Oe=>({range:_.from(Oe)}))}e.fromRangeOrRangeWithMessage=M;function $(De){return typeof De>"u"?De:typeof De=="string"?p.URI.file(De):De}e.pathOrURIToURI=$;var oe;(function(De){function Oe(he){return typeof he>"u"?he:{contentText:he.contentText,contentIconPath:he.contentIconPath?$(he.contentIconPath):void 0,border:he.border,borderColor:he.borderColor,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,color:he.color,backgroundColor:he.backgroundColor,margin:he.margin,width:he.width,height:he.height}}De.from=Oe})(oe||(e.ThemableDecorationAttachmentRenderOptions=oe={}));var de;(function(De){function Oe(he){return typeof he>"u"?he:{backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?$(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?oe.from(he.before):void 0,after:he.after?oe.from(he.after):void 0}}De.from=Oe})(de||(e.ThemableDecorationRenderOptions=de={}));var we;(function(De){function Oe(he){if(typeof he>"u")return he;switch(he){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}De.from=Oe})(we||(e.DecorationRangeBehavior=we={}));var ye;(function(De){function Oe(he){return{isWholeLine:he.isWholeLine,rangeBehavior:he.rangeBehavior?we.from(he.rangeBehavior):void 0,overviewRulerLane:he.overviewRulerLane,light:he.light?de.from(he.light):void 0,dark:he.dark?de.from(he.dark):void 0,backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?$(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?oe.from(he.before):void 0,after:he.after?oe.from(he.after):void 0}}De.from=Oe})(ye||(e.DecorationRenderOptions=ye={}));var le;(function(De){function Oe(G){return{text:G.newText,eol:G.newEol&&rt.from(G.newEol),range:_.from(G.range)}}De.from=Oe;function he(G){const Ce=new s.TextEdit(_.to(G.range),G.text);return Ce.newEol=typeof G.eol>"u"?void 0:rt.to(G.eol),Ce}De.to=he})(le||(e.TextEdit=le={}));var ve;(function(De){function Oe(G,Ce){const Ue={edits:[]};if(G instanceof s.WorkspaceEdit){const Xe=new g.ResourceSet;for(const He of G._allEntries())He._type===1&&p.URI.isUri(He.to)&&He.from===void 0&&Xe.add(He.to);for(const He of G._allEntries())if(He._type===1){let ot;He.options?.contents&&(ArrayBuffer.isView(He.options.contents)?ot={type:"base64",value:(0,L.encodeBase64)(L.VSBuffer.wrap(He.options.contents))}:ot={type:"dataTransferItem",id:He.options.contents._itemId}),Ue.edits.push({oldResource:He.from,newResource:He.to,options:{...He.options,contents:ot},metadata:He.metadata})}else He._type===2?Ue.edits.push({resource:He.uri,textEdit:le.from(He.edit),versionId:Xe.has(He.uri)?void 0:Ce?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===6?Ue.edits.push({resource:He.uri,textEdit:{range:_.from(He.range),text:He.edit.value,insertAsSnippet:!0},versionId:Xe.has(He.uri)?void 0:Ce?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===3?Ue.edits.push({metadata:He.metadata,resource:He.uri,cellEdit:He.edit,notebookMetadata:He.notebookMetadata,notebookVersionId:Ce?.getNotebookDocumentVersion(He.uri)}):He._type===5&&Ue.edits.push({metadata:He.metadata,resource:He.uri,notebookVersionId:Ce?.getNotebookDocumentVersion(He.uri),cellEdit:{editType:1,index:He.index,count:He.count,cells:He.cells.map(At.from)}})}return Ue}De.from=Oe;function he(G){const Ce=new s.WorkspaceEdit,Ue=new g.ResourceMap;for(const Xe of G.edits)if(Xe.textEdit){const He=Xe,ot=p.URI.revive(He.resource),wt=_.to(He.textEdit.range),qt=He.textEdit.text,yt=He.textEdit.insertAsSnippet;let Dt;yt?Dt=s.SnippetTextEdit.replace(wt,new s.SnippetString(qt)):Dt=s.TextEdit.replace(wt,qt);const bt=Ue.get(ot);bt?bt.push(Dt):Ue.set(ot,[Dt])}else Ce.renameFile(p.URI.revive(Xe.oldResource),p.URI.revive(Xe.newResource),Xe.options);for(const[Xe,He]of Ue)Ce.set(Xe,He);return Ce}De.to=he})(ve||(e.WorkspaceEdit=ve={}));var ae;(function(De){const Oe=Object.create(null);Oe[s.SymbolKind.File]=0,Oe[s.SymbolKind.Module]=1,Oe[s.SymbolKind.Namespace]=2,Oe[s.SymbolKind.Package]=3,Oe[s.SymbolKind.Class]=4,Oe[s.SymbolKind.Method]=5,Oe[s.SymbolKind.Property]=6,Oe[s.SymbolKind.Field]=7,Oe[s.SymbolKind.Constructor]=8,Oe[s.SymbolKind.Enum]=9,Oe[s.SymbolKind.Interface]=10,Oe[s.SymbolKind.Function]=11,Oe[s.SymbolKind.Variable]=12,Oe[s.SymbolKind.Constant]=13,Oe[s.SymbolKind.String]=14,Oe[s.SymbolKind.Number]=15,Oe[s.SymbolKind.Boolean]=16,Oe[s.SymbolKind.Array]=17,Oe[s.SymbolKind.Object]=18,Oe[s.SymbolKind.Key]=19,Oe[s.SymbolKind.Null]=20,Oe[s.SymbolKind.EnumMember]=21,Oe[s.SymbolKind.Struct]=22,Oe[s.SymbolKind.Event]=23,Oe[s.SymbolKind.Operator]=24,Oe[s.SymbolKind.TypeParameter]=25;function he(Ce){return typeof Oe[Ce]=="number"?Oe[Ce]:6}De.from=he;function G(Ce){for(const Ue in Oe)if(Oe[Ue]===Ce)return Number(Ue);return s.SymbolKind.Property}De.to=G})(ae||(e.SymbolKind=ae={}));var pe;(function(De){function Oe(G){switch(G){case s.SymbolTag.Deprecated:return 1}}De.from=Oe;function he(G){switch(G){case 1:return s.SymbolTag.Deprecated}}De.to=he})(pe||(e.SymbolTag=pe={}));var re;(function(De){function Oe(G){return{name:G.name,kind:ae.from(G.kind),tags:G.tags&&G.tags.map(pe.from),containerName:G.containerName,location:Re.from(G.location)}}De.from=Oe;function he(G){const Ce=new s.SymbolInformation(G.name,ae.to(G.kind),G.containerName,Re.to(G.location));return Ce.tags=G.tags&&G.tags.map(pe.to),Ce}De.to=he})(re||(e.WorkspaceSymbol=re={}));var J;(function(De){function Oe(G){const Ce={name:G.name||"!!MISSING: name!!",detail:G.detail,range:_.from(G.range),selectionRange:_.from(G.selectionRange),kind:ae.from(G.kind),tags:G.tags?.map(pe.from)??[]};return G.children&&(Ce.children=G.children.map(Oe)),Ce}De.from=Oe;function he(G){const Ce=new s.DocumentSymbol(G.name,G.detail,ae.to(G.kind),_.to(G.range),_.to(G.selectionRange));return(0,I.isNonEmptyArray)(G.tags)&&(Ce.tags=G.tags.map(pe.to)),G.children&&(Ce.children=G.children.map(he)),Ce}De.to=he})(J||(e.DocumentSymbol=J={}));var H;(function(De){function Oe(G){const Ce=new s.CallHierarchyItem(ae.to(G.kind),G.name,G.detail||"",p.URI.revive(G.uri),_.to(G.range),_.to(G.selectionRange));return Ce._sessionId=G._sessionId,Ce._itemId=G._itemId,Ce}De.to=Oe;function he(G,Ce,Ue){if(Ce=Ce??G._sessionId,Ue=Ue??G._itemId,Ce===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Ue,name:G.name,detail:G.detail,kind:ae.from(G.kind),uri:G.uri,range:_.from(G.range),selectionRange:_.from(G.selectionRange),tags:G.tags?.map(pe.from)}}De.from=he})(H||(e.CallHierarchyItem=H={}));var ne;(function(De){function Oe(he){return new s.CallHierarchyIncomingCall(H.to(he.from),he.fromRanges.map(G=>_.to(G)))}De.to=Oe})(ne||(e.CallHierarchyIncomingCall=ne={}));var Ae;(function(De){function Oe(he){return new s.CallHierarchyOutgoingCall(H.to(he.to),he.fromRanges.map(G=>_.to(G)))}De.to=Oe})(Ae||(e.CallHierarchyOutgoingCall=Ae={}));var Re;(function(De){function Oe(G){return{range:G.range&&_.from(G.range),uri:G.uri}}De.from=Oe;function he(G){return new s.Location(p.URI.revive(G.uri),_.to(G.range))}De.to=he})(Re||(e.location=Re={}));var ke;(function(De){function Oe(G){const Ce=G,Ue=G;return{originSelectionRange:Ce.originSelectionRange?_.from(Ce.originSelectionRange):void 0,uri:Ce.targetUri?Ce.targetUri:Ue.uri,range:_.from(Ce.targetRange?Ce.targetRange:Ue.range),targetSelectionRange:Ce.targetSelectionRange?_.from(Ce.targetSelectionRange):void 0}}De.from=Oe;function he(G){return{targetUri:p.URI.revive(G.uri),targetRange:_.to(G.range),targetSelectionRange:G.targetSelectionRange?_.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?_.to(G.originSelectionRange):void 0}}De.to=he})(ke||(e.DefinitionLink=ke={}));var ce;(function(De){function Oe(G){return{range:_.from(G.range),contents:k.fromMany(G.contents)}}De.from=Oe;function he(G){return new s.Hover(G.contents.map(k.to),_.to(G.range))}De.to=he})(ce||(e.Hover=ce={}));var te;(function(De){function Oe(G){return{range:_.from(G.range),expression:G.expression}}De.from=Oe;function he(G){return new s.EvaluatableExpression(_.to(G.range),G.expression)}De.to=he})(te||(e.EvaluatableExpression=te={}));var K;(function(De){function Oe(G){if(G instanceof s.InlineValueText)return{type:"text",range:_.from(G.range),text:G.text};if(G instanceof s.InlineValueVariableLookup)return{type:"variable",range:_.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof s.InlineValueEvaluatableExpression)return{type:"expression",range:_.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}De.from=Oe;function he(G){switch(G.type){case"text":return{range:_.to(G.range),text:G.text};case"variable":return{range:_.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:_.to(G.range),expression:G.expression}}}De.to=he})(K||(e.InlineValue=K={}));var ee;(function(De){function Oe(G){return{frameId:G.frameId,stoppedLocation:_.from(G.stoppedLocation)}}De.from=Oe;function he(G){return new s.InlineValueContext(G.frameId,_.to(G.stoppedLocation))}De.to=he})(ee||(e.InlineValueContext=ee={}));var ge;(function(De){function Oe(G){return{range:_.from(G.range),kind:G.kind}}De.from=Oe;function he(G){return new s.DocumentHighlight(_.to(G.range),G.kind)}De.to=he})(ge||(e.DocumentHighlight=ge={}));var be;(function(De){function Oe(G){return{uri:G.uri,highlights:G.highlights.map(ge.from)}}De.from=Oe;function he(G){return new s.MultiDocumentHighlight(p.URI.revive(G.uri),G.highlights.map(ge.to))}De.to=he})(be||(e.MultiDocumentHighlight=be={}));var Le;(function(De){function Oe(he){switch(he){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}De.to=Oe})(Le||(e.CompletionTriggerKind=Le={}));var fe;(function(De){function Oe(he){return{triggerKind:Le.to(he.triggerKind),triggerCharacter:he.triggerCharacter}}De.to=Oe})(fe||(e.CompletionContext=fe={}));var _e;(function(De){function Oe(G){switch(G){case s.CompletionItemTag.Deprecated:return 1}}De.from=Oe;function he(G){switch(G){case 1:return s.CompletionItemTag.Deprecated}}De.to=he})(_e||(e.CompletionItemTag=_e={}));var F;(function(De){const Oe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function he(Ue){return Oe.get(Ue)??9}De.from=he;const G=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Ce(Ue){return G.get(Ue)??s.CompletionItemKind.Property}De.to=Ce})(F||(e.CompletionItemKind=F={}));var V;(function(De){function Oe(he,G){const Ce=new s.CompletionItem(he.label);return Ce.insertText=he.insertText,Ce.kind=F.to(he.kind),Ce.tags=he.tags?.map(_e.to),Ce.detail=he.detail,Ce.documentation=T.isMarkdownString(he.documentation)?k.to(he.documentation):he.documentation,Ce.sortText=he.sortText,Ce.filterText=he.filterText,Ce.preselect=he.preselect,Ce.commitCharacters=he.commitCharacters,E.Range.isIRange(he.range)?Ce.range=_.to(he.range):typeof he.range=="object"&&(Ce.range={inserting:_.to(he.range.insert),replacing:_.to(he.range.replace)}),Ce.keepWhitespace=typeof he.insertTextRules>"u"?!1:!!(he.insertTextRules&1),typeof he.insertTextRules<"u"&&he.insertTextRules&4?Ce.insertText=new s.SnippetString(he.insertText):(Ce.insertText=he.insertText,Ce.textEdit=Ce.range instanceof s.Range?new s.TextEdit(Ce.range,Ce.insertText):void 0),he.additionalTextEdits&&he.additionalTextEdits.length>0&&(Ce.additionalTextEdits=he.additionalTextEdits.map(Ue=>le.to(Ue))),Ce.command=G&&he.command?G.fromInternal(he.command):void 0,Ce}De.to=Oe})(V||(e.CompletionItem=V={}));var j;(function(De){function Oe(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:k.fromStrict(G.documentation)}}De.from=Oe;function he(G){return{label:G.label,documentation:T.isMarkdownString(G.documentation)?k.to(G.documentation):G.documentation}}De.to=he})(j||(e.ParameterInformation=j={}));var B;(function(De){function Oe(G){return{label:G.label,documentation:k.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(j.from):[],activeParameter:G.activeParameter}}De.from=Oe;function he(G){return{label:G.label,documentation:T.isMarkdownString(G.documentation)?k.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(j.to):[],activeParameter:G.activeParameter}}De.to=he})(B||(e.SignatureInformation=B={}));var X;(function(De){function Oe(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(B.from):[]}}De.from=Oe;function he(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(B.to):[]}}De.to=he})(X||(e.SignatureHelp=X={}));var Z;(function(De){function Oe(he,G){const Ce=new s.InlayHint(P.to(G.position),typeof G.label=="string"?G.label:G.label.map(Se.to.bind(void 0,he)),G.kind&&Ne.to(G.kind));return Ce.textEdits=G.textEdits&&G.textEdits.map(le.to),Ce.tooltip=T.isMarkdownString(G.tooltip)?k.to(G.tooltip):G.tooltip,Ce.paddingLeft=G.paddingLeft,Ce.paddingRight=G.paddingRight,Ce}De.to=Oe})(Z||(e.InlayHint=Z={}));var Se;(function(De){function Oe(he,G){const Ce=new s.InlayHintLabelPart(G.label);return Ce.tooltip=T.isMarkdownString(G.tooltip)?k.to(G.tooltip):G.tooltip,i.Command.is(G.command)&&(Ce.command=he.fromInternal(G.command)),G.location&&(Ce.location=Re.to(G.location)),Ce}De.to=Oe})(Se||(e.InlayHintLabelPart=Se={}));var Ne;(function(De){function Oe(G){return G}De.from=Oe;function he(G){return G}De.to=he})(Ne||(e.InlayHintKind=Ne={}));var $e;(function(De){function Oe(G){return{range:_.from(G.range),url:G.target,tooltip:G.tooltip}}De.from=Oe;function he(G){let Ce;if(G.url)try{Ce=typeof G.url=="string"?p.URI.parse(G.url,!0):p.URI.revive(G.url)}catch{}return new s.DocumentLink(_.to(G.range),Ce)}De.to=he})($e||(e.DocumentLink=$e={}));var qe;(function(De){function Oe(G){const Ce=new s.ColorPresentation(G.label);return G.textEdit&&(Ce.textEdit=le.to(G.textEdit)),G.additionalTextEdits&&(Ce.additionalTextEdits=G.additionalTextEdits.map(Ue=>le.to(Ue))),Ce}De.to=Oe;function he(G){return{label:G.label,textEdit:G.textEdit?le.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Ce=>le.from(Ce)):void 0}}De.from=he})(qe||(e.ColorPresentation=qe={}));var Qe;(function(De){function Oe(G){return new s.Color(G[0],G[1],G[2],G[3])}De.to=Oe;function he(G){return[G.red,G.green,G.blue,G.alpha]}De.from=he})(Qe||(e.Color=Qe={}));var nt;(function(De){function Oe(G){return{range:_.from(G.range)}}De.from=Oe;function he(G){return new s.SelectionRange(_.to(G.range))}De.to=he})(nt||(e.SelectionRange=nt={}));var it;(function(De){function Oe(he){switch(he){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}De.to=Oe})(it||(e.TextDocumentSaveReason=it={}));var et;(function(De){function Oe(G){switch(G){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}De.from=Oe;function he(G){switch(G){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}De.to=he})(et||(e.TextEditorLineNumbersStyle=et={}));var rt;(function(De){function Oe(G){if(G===s.EndOfLine.CRLF)return 1;if(G===s.EndOfLine.LF)return 0}De.from=Oe;function he(G){if(G===1)return s.EndOfLine.CRLF;if(G===0)return s.EndOfLine.LF}De.to=he})(rt||(e.EndOfLine=rt={}));var ct;(function(De){function Oe(he){if(typeof he=="object")return he.viewId;switch(he){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}De.from=Oe})(ct||(e.ProgressLocation=ct={}));var Be;(function(De){function Oe(G){const Ce={start:G.start+1,end:G.end+1};return G.kind&&(Ce.kind=gt.from(G.kind)),Ce}De.from=Oe;function he(G){const Ce={start:G.start-1,end:G.end-1};return G.kind&&(Ce.kind=gt.to(G.kind)),Ce}De.to=he})(Be||(e.FoldingRange=Be={}));var gt;(function(De){function Oe(G){if(G)switch(G){case s.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}De.from=Oe;function he(G){if(G)switch(G.value){case i.FoldingRangeKind.Comment.value:return s.FoldingRangeKind.Comment;case i.FoldingRangeKind.Imports.value:return s.FoldingRangeKind.Imports;case i.FoldingRangeKind.Region.value:return s.FoldingRangeKind.Region}}De.to=he})(gt||(e.FoldingRangeKind=gt={}));var Q;(function(De){function Oe(he){if(he)return{pinned:typeof he.preview=="boolean"?!he.preview:void 0,inactive:he.background,preserveFocus:he.preserveFocus,selection:typeof he.selection=="object"?_.from(he.selection):void 0,override:typeof he.override=="boolean"?n.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}De.from=Oe})(Q||(e.TextEditorOpenOptions=Q={}));var Y;(function(De){function Oe(Ue){return Ue instanceof s.RelativePattern?Ue.toJSON():typeof Ue=="string"?Ue:he(Ue)||G(Ue)?new s.RelativePattern(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}De.from=Oe;function he(Ue){const Xe=Ue;return Xe?p.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function G(Ue){const Xe=Ue;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Ce(Ue){return typeof Ue=="string"?Ue:new s.RelativePattern(p.URI.revive(Ue.baseUri),Ue.pattern)}De.to=Ce})(Y||(e.GlobPattern=Y={}));var Ee;(function(De){function Oe(he){if(he){if(Array.isArray(he))return he.map(Oe);if(typeof he=="string")return he;{const G=he;return{language:G.language,scheme:G.scheme,pattern:Y.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}De.from=Oe})(Ee||(e.LanguageSelector=Ee={}));var ze;(function(De){function Oe(G){return!!G&&typeof G=="object"&&"documents"in G&&Array.isArray(G.documents)&&G.documents.every(Ce=>Array.isArray(Ce)&&Ce.every(Ue=>Ue&&typeof Ue=="object"&&"uri"in Ue&&p.URI.isUri(Ue.uri)&&"version"in Ue&&typeof Ue.version=="number"&&"ranges"in Ue&&Array.isArray(Ue.ranges)&&Ue.ranges.every(Xe=>Xe instanceof s.Range)))}De.is=Oe;function he(G){return{documents:G.documents.map(Ce=>Ce.map(Ue=>({uri:p.URI.from(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Xe=>_.from(Xe))})))}}De.from=he})(ze||(e.MappedEditsContext=ze={}));var Ge;(function(De){function Oe(G){return{start:G.start,end:G.end}}De.from=Oe;function he(G){return new s.NotebookRange(G.start,G.end)}De.to=he})(Ge||(e.NotebookRange=Ge={}));var tt;(function(De){function Oe(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}De.to=Oe;function he(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}De.from=he})(tt||(e.NotebookCellExecutionSummary=tt={}));var st;(function(De){function Oe(he){if(he===o.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(he===o.NotebookCellExecutionState.Pending)return;if(he===o.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${he}`)}De.to=Oe})(st||(e.NotebookCellExecutionState=st={}));var Fe;(function(De){function Oe(G){switch(G){case s.NotebookCellKind.Markup:return o.CellKind.Markup;case s.NotebookCellKind.Code:default:return o.CellKind.Code}}De.from=Oe;function he(G){switch(G){case o.CellKind.Markup:return s.NotebookCellKind.Markup;case o.CellKind.Code:default:return s.NotebookCellKind.Code}}De.to=he})(Fe||(e.NotebookCellKind=Fe={}));var Ut;(function(De){function Oe(G){const Ce={metadata:G.metadata??Object.create(null),cells:[]};for(const Ue of G.cells)s.NotebookCellData.validate(Ue),Ce.cells.push(At.from(Ue));return Ce}De.from=Oe;function he(G){const Ce=new s.NotebookData(G.cells.map(At.to));return(0,u.isEmptyObject)(G.metadata)||(Ce.metadata=G.metadata),Ce}De.to=he})(Ut||(e.NotebookData=Ut={}));var At;(function(De){function Oe(G){return{cellKind:Fe.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:tt.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Ot.from):[]}}De.from=Oe;function he(G){return new s.NotebookCellData(Fe.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Ot.to):void 0,G.metadata,G.internalMetadata?tt.to(G.internalMetadata):void 0)}De.to=he})(At||(e.NotebookCellData=At={}));var jt;(function(De){function Oe(G){return{mime:G.mime,valueBytes:L.VSBuffer.wrap(G.data)}}De.from=Oe;function he(G){return new s.NotebookCellOutputItem(G.valueBytes.buffer,G.mime)}De.to=he})(jt||(e.NotebookCellOutputItem=jt={}));var Ot;(function(De){function Oe(G){return{outputId:G.id,items:G.items.map(jt.from),metadata:G.metadata}}De.from=Oe;function he(G){const Ce=G.items.map(jt.to);return new s.NotebookCellOutput(Ce,G.outputId,G.metadata)}De.to=he})(Ot||(e.NotebookCellOutput=Ot={}));var _t;(function(De){function Oe(Ce){return G(Ce)?{include:Y.from(Ce.include)??void 0,exclude:Y.from(Ce.exclude)??void 0}:Y.from(Ce)??void 0}De.from=Oe;function he(Ce){return G(Ce)?{include:Y.to(Ce.include),exclude:Y.to(Ce.exclude)}:Y.to(Ce)}De.to=he;function G(Ce){const Ue=Ce;return Ue?!(0,u.isUndefinedOrNull)(Ue.include)&&!(0,u.isUndefinedOrNull)(Ue.exclude):!1}})(_t||(e.NotebookExclusiveDocumentPattern=_t={}));var Wt;(function(De){function Oe(he,G,Ce){const Ue=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{alignment:he.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Ue,Ce),text:he.text,tooltip:he.tooltip,accessibilityInformation:he.accessibilityInformation,priority:he.priority}}De.from=Oe})(Wt||(e.NotebookStatusBarItem=Wt={}));var Ft;(function(De){function Oe(he,G,Ce){const Ue=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{command:G.toInternal(Ue,Ce),label:he.label,description:he.description,detail:he.detail,documentation:he.documentation}}De.from=Oe})(Ft||(e.NotebookKernelSourceAction=Ft={}));var Qt;(function(De){function Oe(he){return{transientOutputs:he?.transientOutputs??!1,transientCellMetadata:he?.transientCellMetadata??{},transientDocumentMetadata:he?.transientDocumentMetadata??{},cellContentMetadata:he?.cellContentMetadata??{}}}De.from=Oe})(Qt||(e.NotebookDocumentContentOptions=Qt={}));var $t;(function(De){function Oe(G){return{uri:G.uri,provides:G.provides}}De.from=Oe;function he(G){return new s.NotebookRendererScript(p.URI.revive(G.uri),G.provides)}De.to=he})($t||(e.NotebookRendererScript=$t={}));var xt;(function(De){function Oe(G){return{message:k.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,contextValue:G.contextValue,location:G.location&&{range:_.from(G.location.range),uri:G.location.uri}}}De.from=Oe;function he(G){const Ce=new s.TestMessage(typeof G.message=="string"?G.message:k.to(G.message));return Ce.actualOutput=G.actual,Ce.expectedOutput=G.expected,Ce.contextValue=G.contextValue,Ce.location=G.location?Re.to(G.location):void 0,Ce}De.to=he})(xt||(e.TestMessage=xt={}));var Ye;(function(De){De.namespace=l.namespaceTestTag,De.denamespace=l.denamespaceTestTag})(Ye||(e.TestTag=Ye={}));var Vt;(function(De){function Oe(G){const Ce=(0,r.getPrivateApiFor)(G).controllerId;return{extId:c.TestId.fromExtHostTestItem(G,Ce).toString(),label:G.label,uri:p.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(Ue=>Ye.namespace(Ce,Ue.id)),range:E.Range.lift(_.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&k.fromStrict(G.error)||null}}De.from=Oe;function he(G){return{parent:void 0,error:void 0,id:c.TestId.fromString(G.extId).localId,label:G.label,uri:p.URI.revive(G.uri),tags:(G.tags||[]).map(Ce=>{const{tagId:Ue}=Ye.denamespace(Ce);return new s.TestTag(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:_.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}De.toPlain=he})(Vt||(e.TestItem=Vt={})),function(De){function Oe(G){return{id:G.id}}De.from=Oe;function he(G){return new s.TestTag(G.id)}De.to=he}(Ye||(e.TestTag=Ye={}));var Kt;(function(De){const Oe=(G,Ce)=>{const Ue=[];for(const[He,ot]of Ce)c.TestId.compare(ot.item.extId,He)===2&&(Ce.delete(He),Ue.push(ot));const Xe={...Vt.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(He=>({state:He.state,duration:He.duration,messages:He.messages.filter(ot=>ot.type===0).map(xt.to)})),children:Ue.map(He=>Oe(He,Ce))};for(const He of Xe.children)He.parent=Xe;return Xe};function he(G){const Ce=[],Ue=new Map;for(const Xe of G.items){Ue.set(Xe.item.extId,Xe);const He=c.TestId.root(Xe.item.extId);G.request.targets.some(ot=>ot.controllerId===He&&ot.testIds.includes(Xe.item.extId))&&Ce.push(Xe)}return{completedAt:G.completedAt,results:Ce.map(Xe=>Oe(Xe,Ue))}}De.to=he})(Kt||(e.TestResults=Kt={}));var ut;(function(De){function Oe(Ue){return{covered:Ue.covered,total:Ue.total}}function he(Ue){return"line"in Ue?P.from(Ue):_.from(Ue)}function G(Ue){return"branches"in Ue?{count:Ue.executionCount,location:he(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(Xe=>({count:Xe.executionCount,location:Xe.location&&he(Xe.location),label:Xe.label})):void 0}:{type:0,name:Ue.name,count:Ue.executionCount,location:he(Ue.location)}}De.fromDetailed=G;function Ce(Ue){return{uri:Ue.uri,statement:Oe(Ue.statementCoverage),branch:Ue.branchCoverage&&Oe(Ue.branchCoverage),function:Ue.functionCoverage&&Oe(Ue.functionCoverage),details:Ue.detailedCoverage?.map(G)}}De.fromFile=Ce})(ut||(e.TestCoverage=ut={}));var pt;(function(De){function Oe(he){switch(he){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}De.to=Oe})(pt||(e.CodeActionTriggerKind=pt={}));var Bt;(function(De){function Oe(G){const Ce=new s.TypeHierarchyItem(ae.to(G.kind),G.name,G.detail||"",p.URI.revive(G.uri),_.to(G.range),_.to(G.selectionRange));return Ce._sessionId=G._sessionId,Ce._itemId=G._itemId,Ce}De.to=Oe;function he(G,Ce,Ue){if(Ce=Ce??G._sessionId,Ue=Ue??G._itemId,Ce===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Ue,kind:ae.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:_.from(G.range),selectionRange:_.from(G.selectionRange),tags:G.tags?.map(pe.from)}}De.from=he})(Bt||(e.TypeHierarchyItem=Bt={}));var Gt;(function(De){function Oe(he){if(he)return{value:he.value,tooltip:he.tooltip}}De.from=Oe})(Gt||(e.ViewBadge=Gt={}));var St;(function(De){function Oe(Ue,Xe,He){const ot=Xe.fileData;return ot?new s.InternalFileDataTransferItem(new s.DataTransferFile(ot.name,p.URI.revive(ot.uri),ot.id,(0,A.createSingleCallFunction)(()=>He(ot.id)))):Ue===R.Mimes.uriList&&Xe.uriListData?new s.InternalDataTransferItem(Ce(Xe.uriListData)):new s.InternalDataTransferItem(Xe.asString)}De.to=Oe;async function he(Ue,Xe){const He=await Xe.asString();if(Ue===R.Mimes.uriList)return{asString:He,fileData:void 0,uriListData:G(He)};const ot=Xe.asFile();return{asString:He,fileData:ot?{name:ot.name,uri:ot.uri,id:ot._itemId??ot.id}:void 0}}De.from=he;function G(Ue){return C.UriList.split(Ue).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return p.URI.parse(Xe)}catch{}return Xe})}function Ce(Ue){return C.UriList.create(Ue.map(Xe=>typeof Xe=="string"?Xe:p.URI.revive(Xe)))}})(St||(e.DataTransferItem=St={}));var ht;(function(De){function Oe(G,Ce){const Ue=G.items.map(([Xe,He])=>[Xe,St.to(Xe,He,Ce)]);return new s.DataTransfer(Ue)}De.toDataTransfer=Oe;async function he(G){const Ce={items:[]},Ue=[];for(const[Xe,He]of G)Ue.push((async()=>{Ce.items.push([Xe,await St.from(Xe,He)])})());return await Promise.all(Ue),Ce}De.from=he})(ht||(e.DataTransfer=ht={}));var It;(function(De){function Oe(he){return{kind:"reply",message:he.message,title:he.title,tooltip:he.tooltip}}De.from=Oe})(It||(e.ChatReplyFollowup=It={}));var Zt;(function(De){function Oe(he){return typeof he=="string"?{title:he,message:he,kind:"reply"}:"commandId"in he?{kind:"command",title:he.title??"",commandId:he.commandId??"",when:he.when??"",args:he.args}:It.from(he)}De.from=Oe})(Zt||(e.ChatFollowup=Zt={}));var kt;(function(De){function Oe(G){const Ce=new s.ChatMessage(Ve.to(G.role),G.content);return Ce.name=G.name,Ce}De.to=Oe;function he(G){return{role:Ve.from(G.role),content:G.content,name:G.name}}De.from=he})(kt||(e.ChatMessage=kt={}));var Ve;(function(De){function Oe(G){switch(G){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}De.to=Oe;function he(G){switch(G){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}De.from=he})(Ve||(e.ChatMessageRole=Ve={}));var Rt;(function(De){function Oe(Ce){const Ue={};for(const Xe of Object.keys(Ce))Ue[Xe]=Ce[Xe].map(De.to);return Ue}De.objectTo=Oe;function he(Ce){return{level:Nt.to(Ce.level),kind:Ce.kind,value:(0,p.isUriComponents)(Ce.value)?p.URI.revive(Ce.value):Ce.value,description:Ce.description}}De.to=he;function G(Ce){return{level:Nt.from(Ce.level),kind:Ce.kind,value:Ce.value,description:Ce.description}}De.from=G})(Rt||(e.ChatVariable=Rt={}));var Nt;(function(De){function Oe(G){switch(G){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}De.to=Oe;function he(G){switch(G){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}De.from=he})(Nt||(e.ChatVariableLevel=Nt={}));var Xt;(function(De){function Oe(he){switch(he){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}De.to=Oe})(Xt||(e.InteractiveEditorResponseFeedbackKind=Xt={}));var ft;(function(De){function Oe(Ce,Ue){return"markdownContent"in Ue?((0,d.checkProposedApiEnabled)(Ce,"chatAgents2Additions"),{content:k.from(Ue.markdownContent),kind:"markdownContent"}):"content"in Ue?"vulnerabilities"in Ue&&Ue.vulnerabilities?((0,d.checkProposedApiEnabled)(Ce,"chatAgents2Additions"),{content:Ue.content,vulnerabilities:Ue.vulnerabilities,kind:"vulnerability"}):typeof Ue.content=="string"?{content:Ue.content,kind:"content"}:((0,d.checkProposedApiEnabled)(Ce,"chatAgents2Additions"),{content:k.from(Ue.content),kind:"markdownContent"}):"documents"in Ue?{documents:Ue.documents.map(Xe=>({uri:Xe.uri,version:Xe.version,ranges:Xe.ranges.map(He=>_.from(He))})),kind:"usedContext"}:"reference"in Ue?{reference:"uri"in Ue.reference?{uri:Ue.reference.uri,range:_.from(Ue.reference.range)}:Ue.reference,kind:"reference"}:"inlineReference"in Ue?{inlineReference:"uri"in Ue.inlineReference?{uri:Ue.inlineReference.uri,range:_.from(Ue.inlineReference.range)}:Ue.inlineReference,name:Ue.title,kind:"inlineReference"}:"agentName"in Ue?((0,d.checkProposedApiEnabled)(Ce,"chatAgents2Additions"),{agentName:Ue.agentName,command:Ue.command,kind:"agentDetection"}):"treeData"in Ue?{treeData:Ue.treeData,kind:"treeData"}:"message"in Ue?{content:k.from(Ue.message),kind:"progressMessage"}:void 0}De.from=Oe;function he(Ce){switch(Ce.kind){case"markdownContent":case"inlineReference":case"treeData":return De.to(Ce);case"content":return{content:Ce.content};case"usedContext":return{documents:Ce.documents.map(Ue=>({uri:p.URI.revive(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Xe=>_.to(Xe))}))};case"reference":return{reference:(0,p.isUriComponents)(Ce.reference)?p.URI.revive(Ce.reference):f.to(Ce.reference)};case"agentDetection":return;case"progressMessage":return{message:Ce.content.value};case"vulnerability":return{content:Ce.content,vulnerabilities:Ce.vulnerabilities};default:return}}De.to=he;function G(Ce){switch(Ce.kind){case"markdownContent":return{content:Ce.content.value};case"inlineReference":return{inlineReference:(0,p.isUriComponents)(Ce.inlineReference)?p.URI.revive(Ce.inlineReference):f.to(Ce.inlineReference),title:Ce.name};case"treeData":return{treeData:(0,S.revive)(Ce.treeData)};default:return}}De.toProgressContent=G})(ft||(e.ChatResponseProgress=ft={}));var Lt;(function(De){function Oe(he,G){return{prompt:he.message,variables:Rt.objectTo(he.variables),slashCommand:G,subCommand:he.command,agentId:he.agentId}}De.to=Oe})(Lt||(e.ChatAgentRequest=Lt={}));var Pt;(function(De){function Oe(he){return{label:he.label,values:he.values.map(Rt.from),insertText:he.insertText,detail:he.detail,documentation:he.documentation}}De.from=Oe})(Pt||(e.ChatAgentCompletionItem=Pt={}));var zt;(function(De){function Oe(he,G,Ce){return"terminalCommand"in he?{terminalCommand:he.terminalCommand,shouldExecute:he.shouldExecute}:"uri"in he?{uri:he.uri}:G.toInternal(he,Ce)}De.from=Oe})(zt||(e.TerminalQuickFix=zt={}))}),define(Pe[244],Te([1,0,3,17,8]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(g,h){this._proxy=g.getProxy(I.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:S=>h.getDocument(S)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(g,h,S){const R=C.WorkspaceEdit.from(g,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(R,void 0,S?.isRefactoring??!1)}};e.ExtHostBulkEdits=A,e.ExtHostBulkEdits=A=Ke([We(0,L.IExtHostRpcService)],A)}),define(Pe[245],Te([1,0,68,6,3,8]),function(me,e,I,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChat=void 0;class T{static{this._pool=0}constructor(S,R){this.extension=S,this.provider=R,this.handle=T._pool++}}class g{static{this._nextId=0}constructor(S){this._chatProvider=new Map,this._chatSessions=new Map,this._proxy=S.getProxy(C.MainContext.MainThreadChat)}registerChatProvider(S,R,D){const u=new T(S,D);return this._chatProvider.set(u.handle,u),this._proxy.$registerChatProvider(u.handle,R),(0,L.toDisposable)(()=>{this._proxy.$unregisterChatProvider(u.handle),this._chatProvider.delete(u.handle)})}transferChatSession(S,R){const D=I.Iterable.find(this._chatSessions.keys(),u=>this._chatSessions.get(u)===S)??0;typeof D=="number"&&this._proxy.$transferChatSession(D,R)}sendInteractiveRequestToProvider(S,R){this._proxy.$sendRequestToProvider(S,R)}async $prepareChat(S,R){const D=this._chatProvider.get(S);if(!D)return;const u=await D.provider.prepareSession(R);if(!u)return;const p=g._nextId++;return this._chatSessions.set(p,u),{id:p,requesterUsername:u.requester?.name,requesterAvatarIconUri:u.requester?.icon,responderUsername:u.responder?.name,responderAvatarIconUri:u.responder?.icon,inputPlaceholder:u.inputPlaceholder}}async $provideWelcomeMessage(S,R){const D=this._chatProvider.get(S);if(!D||!D.provider.provideWelcomeMessage)return;const u=await D.provider.provideWelcomeMessage(R);if(u)return u.map(p=>typeof p=="string"?p:Array.isArray(p)?p.map(E=>A.ChatReplyFollowup.from(E)):A.MarkdownString.from(p))}async $provideSampleQuestions(S,R){const D=this._chatProvider.get(S);if(!D||!D.provider.provideSampleQuestions)return;const u=await D.provider.provideSampleQuestions(R);if(u)return u?.map(p=>A.ChatReplyFollowup.from(p))}$releaseSession(S){this._chatSessions.delete(S)}}e.ExtHostChat=g}),define(Pe[246],Te([1,0,18,13,20,41,5,63,16,2,157,72,3,8,7,205,24]),function(me,e,I,L,C,A,T,g,h,S,R,D,u,p,E,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatAgents2=void 0;class r{static{this._idPool=0}constructor(c,l,t){this._extHostChatProvider=l,this._logService=t,this._agents=new Map,this._previousResultMap=new Map,this._resultsBySessionAndRequestId=new Map,this._proxy=c.getProxy(u.MainContext.MainThreadChatAgents2)}createChatAgent(c,l,t){const d=r._idPool++,s=new n(c,l,this._proxy,d,t);return this._agents.set(d,s),this._proxy.$registerAgent(d,l,{}),s.apiAgent}async $invokeAgent(c,l,t,d){this._previousResultMap.delete(l.sessionId);const s=this._agents.get(c);if(!s)throw new Error(`[CHAT](${c}) CANNOT invoke agent because the agent is not registered`);let b=!1;function _(){if(b)throw new Error("Only valid while executing the command")}const f=new L.DeferredPromise;d.onCancellationRequested(()=>f.complete()),this._extHostChatProvider.allowListExtensionWhile(s.extension.identifier,f.p);const w=l.command?await s.validateSlashCommand(l.command):void 0,P=g.StopWatch.create(!1);let m;try{const v=await this.prepareHistory(s,l,t),y=s.invoke(p.ChatAgentRequest.to(l,w),{history:v},new D.Progress(O=>{_(),typeof m>"u"&&"content"in O&&(m=P.elapsed());const N=p.ChatResponseProgress.from(s.extension,O);if(!N){this._logService.error("Unknown progress type: "+JSON.stringify(O));return}"placeholder"in O&&"resolvedContent"in O||this._proxy.$handleProgressChunk(l.requestId,N)}),d);return await(0,L.raceCancellation)(Promise.resolve(y).then(O=>{if(O){this._previousResultMap.set(l.sessionId,O);let N=this._resultsBySessionAndRequestId.get(l.sessionId);N||(N=new Map,this._resultsBySessionAndRequestId.set(l.sessionId,N)),N.set(l.requestId,O);const q={firstProgress:m,totalElapsed:P.elapsed()};return{errorDetails:O.errorDetails,timings:q}}else this._previousResultMap.delete(l.sessionId)}),d)}catch(v){return this._logService.error(v,s.extension),{errorDetails:{message:(0,R.localize)(0,null,(0,A.toErrorMessage)(v)),responseIsIncomplete:!0}}}finally{b=!0,f.complete()}}async prepareHistory(c,l,t){return(0,I.coalesce)(await Promise.all(t.history.map(async d=>{const s=l.agentId===d.request.agentId&&this._resultsBySessionAndRequestId.get(l.sessionId)?.get(d.request.requestId)||d.result;return{request:p.ChatAgentRequest.to(d.request,void 0),response:(0,I.coalesce)(d.response.map(b=>p.ChatResponseProgress.toProgressContent(b))),result:s}})))}$releaseSession(c){this._previousResultMap.delete(c),this._resultsBySessionAndRequestId.delete(c)}async $provideSlashCommands(c,l){const t=this._agents.get(c);return t?t.provideSlashCommand(l):[]}$provideFollowups(c,l,t){const d=this._agents.get(c);if(!d)return Promise.resolve([]);const s=this._previousResultMap.get(l);return s?d.provideFollowups(s,t):Promise.resolve([])}$acceptFeedback(c,l,t,d,s){const b=this._agents.get(c);if(!b)return;const _=this._resultsBySessionAndRequestId.get(l)?.get(t);if(!_)return;let f;switch(d){case i.InteractiveSessionVoteDirection.Down:f=E.ChatAgentResultFeedbackKind.Unhelpful;break;case i.InteractiveSessionVoteDirection.Up:f=E.ChatAgentResultFeedbackKind.Helpful;break}b.acceptFeedback(Object.freeze(s?{result:_,kind:f,reportIssue:s}:{result:_,kind:f}))}$acceptAction(c,l,t,d){const s=this._agents.get(c);if(!s)return;const b=this._resultsBySessionAndRequestId.get(l)?.get(t);b&&d.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:d.action,result:b}))}async $invokeCompletionProvider(c,l,t){const d=this._agents.get(c);return d?(await d.invokeCompletionProvider(l,t)).map(p.ChatAgentCompletionItem.from):[]}}e.ExtHostChatAgents2=r;class n{constructor(c,l,t,d,s){this.extension=c,this.id=l,this._proxy=t,this._handle=d,this._callback=s,this._onDidReceiveFeedback=new T.Emitter,this._onDidPerformAction=new T.Emitter}acceptFeedback(c){this._onDidReceiveFeedback.fire(c)}acceptAction(c){this._onDidPerformAction.fire(c)}async invokeCompletionProvider(c,l){return this._agentVariableProvider?await this._agentVariableProvider.provider.provideCompletionItems(c,l)??[]:[]}async validateSlashCommand(c){this._lastSlashCommands||(await this.provideSlashCommand(C.CancellationToken.None),(0,h.assertType)(this._lastSlashCommands));const l=this._lastSlashCommands.find(t=>t.name===c);if(!l)throw new Error(`Unknown slashCommand: ${c}`);return l}async provideSlashCommand(c){if(!this._slashCommandProvider)return[];const l=await this._slashCommandProvider.provideSubCommands(c);return l?(this._lastSlashCommands=l,l.map(t=>({name:t.name,description:t.description,followupPlaceholder:t.followupPlaceholder,shouldRepopulate:t.shouldRepopulate,sampleRequest:t.sampleRequest}))):[]}async provideFollowups(c,l){if(!this._followupProvider)return[];const t=await this._followupProvider.provideFollowups(c,l);return t?t.map(d=>p.ChatFollowup.from(d)):[]}get apiAgent(){let c=!1,l=!1;const t=()=>{c||l||(l=!0,queueMicrotask(()=>{this._proxy.$updateAgent(this._handle,{description:this._description??"",fullName:this._fullName,icon:this._iconPath?this._iconPath instanceof S.URI?this._iconPath:"light"in this._iconPath?this._iconPath.light:void 0:void 0,iconDark:this._iconPath&&"dark"in this._iconPath?this._iconPath.dark:void 0,themeIcon:this._iconPath instanceof E.ThemeIcon?this._iconPath:void 0,hasSlashCommands:this._slashCommandProvider!==void 0,hasFollowups:this._followupProvider!==void 0,isDefault:this._isDefault,isSecondary:this._isSecondary,helpTextPrefix:!this._helpTextPrefix||typeof this._helpTextPrefix=="string"?this._helpTextPrefix:p.MarkdownString.from(this._helpTextPrefix),helpTextPostfix:!this._helpTextPostfix||typeof this._helpTextPostfix=="string"?this._helpTextPostfix:p.MarkdownString.from(this._helpTextPostfix),sampleRequest:this._sampleRequest,supportIssueReporting:this._supportIssueReporting}),l=!1}))},d=this;return{get name(){return d.id},get description(){return d._description??""},set description(s){d._description=s,t()},get fullName(){return d._fullName??d.extension.displayName??d.extension.name},set fullName(s){d._fullName=s,t()},get iconPath(){return d._iconPath},set iconPath(s){d._iconPath=s,t()},get subCommandProvider(){return d._slashCommandProvider},set subCommandProvider(s){d._slashCommandProvider=s,t()},get followupProvider(){return d._followupProvider},set followupProvider(s){d._followupProvider=s,t()},get isDefault(){return(0,a.checkProposedApiEnabled)(d.extension,"defaultChatAgent"),d._isDefault},set isDefault(s){(0,a.checkProposedApiEnabled)(d.extension,"defaultChatAgent"),d._isDefault=s,t()},get helpTextPrefix(){return(0,a.checkProposedApiEnabled)(d.extension,"defaultChatAgent"),d._helpTextPrefix},set helpTextPrefix(s){if((0,a.checkProposedApiEnabled)(d.extension,"defaultChatAgent"),!d._isDefault)throw new Error("helpTextPrefix is only available on the default chat agent");d._helpTextPrefix=s,t()},get helpTextPostfix(){return(0,a.checkProposedApiEnabled)(d.extension,"defaultChatAgent"),d._helpTextPostfix},set helpTextPostfix(s){if((0,a.checkProposedApiEnabled)(d.extension,"defaultChatAgent"),!d._isDefault)throw new Error("helpTextPostfix is only available on the default chat agent");d._helpTextPostfix=s,t()},get isSecondary(){return(0,a.checkProposedApiEnabled)(d.extension,"defaultChatAgent"),d._isSecondary},set isSecondary(s){(0,a.checkProposedApiEnabled)(d.extension,"defaultChatAgent"),d._isSecondary=s,t()},get sampleRequest(){return d._sampleRequest},set sampleRequest(s){d._sampleRequest=s,t()},get supportIssueReporting(){return(0,a.checkProposedApiEnabled)(d.extension,"chatAgents2Additions"),d._supportIssueReporting},set supportIssueReporting(s){(0,a.checkProposedApiEnabled)(d.extension,"chatAgents2Additions"),d._supportIssueReporting=s,t()},get onDidReceiveFeedback(){return d._onDidReceiveFeedback.event},set agentVariableProvider(s){if(d._agentVariableProvider=s,s){if(!s.triggerCharacters.length)throw new Error("triggerCharacters are required");d._proxy.$registerAgentCompletionsProvider(d._handle,s.triggerCharacters)}else d._proxy.$unregisterAgentCompletionsProvider(d._handle)},get agentVariableProvider(){return d._agentVariableProvider},onDidPerformAction:(0,a.isProposedApiEnabled)(this.extension,"chatAgents2Additions")?this._onDidPerformAction.event:void 0,dispose(){c=!0,d._slashCommandProvider=void 0,d._followupProvider=void 0,d._onDidReceiveFeedback.dispose(),d._proxy.$unregisterAgent(d._handle)}}}invoke(c,l,t,d){return this._callback(c,l,t,d)}}}),define(Pe[247],Te([1,0,20,6,3,8,72,22,13,5]),function(me,e,I,L,C,A,T,g,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatProvider=void 0;class R{constructor(E,i){this.stream=new h.AsyncIterableSource,this.stream=i??new h.AsyncIterableSource;const a=this;this.apiObj={option:E,response:a.stream.asyncIterable}}}class D{constructor(E,i){this._onDidStart=new S.Emitter,this._responseStreams=new Map,this._defaultStream=new h.AsyncIterableSource,this._isDone=!1;const a=this;this.apiObject={result:E,response:a._defaultStream.asyncIterable,onDidStartResponseStream:a._onDidStart.event,cancel(){i.cancel()}},E.finally(()=>{if(this._isDone=!0,this._responseStreams.size>0)for(const[,r]of this._responseStreams)r.stream.resolve();else this._defaultStream.resolve()})}handleFragment(E){if(this._isDone)return;let i=this._responseStreams.get(E.index);i||(this._responseStreams.size===0?i=new R(E.index,this._defaultStream):i=new R(E.index),this._responseStreams.set(E.index,i),this._onDidStart.fire(i.apiObj)),i.stream.emitOne(E.part)}}class u{static{this._idPool=1}constructor(E,i){this._logService=i,this._providers=new Map,this._pendingRequest=new Map,this._chatAccessAllowList=new g.ExtensionIdentifierMap,this._proxy=E.getProxy(C.MainContext.MainThreadChatProvider)}registerProvider(E,i,a,r){const n=u._idPool++;return this._providers.set(n,{extension:E,provider:a}),this._proxy.$registerProvider(n,i,{extension:E,model:r.name??""}),(0,L.toDisposable)(()=>{this._proxy.$unregisterProvider(n),this._providers.delete(n)})}async $provideChatResponse(E,i,a,r,n){const o=this._providers.get(E);if(!o)return;const c=new T.Progress(async l=>{if(n.isCancellationRequested){this._logService.warn(`[CHAT](${o.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this._proxy.$handleProgressChunk(i,{index:l.index,part:l.part})});return o.provider.provideChatResponse(a.map(A.ChatMessage.to),r,c,n)}allowListExtensionWhile(E,i){this._chatAccessAllowList.set(E,i),i.finally(()=>this._chatAccessAllowList.delete(E))}async requestChatResponseProvider(E,i){if(!this._chatAccessAllowList.has(E))throw new Error("Extension is NOT allowed to make chat requests");const a=await this._proxy.$prepareChatAccess(i);if(!a)throw new Error(`ChatAccess '${i}' NOT found`);const r=this;return{get model(){return a.model},get isRevoked(){return!r._chatAccessAllowList.has(E)},makeRequest(n,o,c){if(!r._chatAccessAllowList.has(E))throw new Error("Access to chat has been revoked");const l=new I.CancellationTokenSource(c),t=Math.random()*1e6|0,d=r._proxy.$fetchResponse(E,i,t,n.map(A.ChatMessage.from),o??{},l.token),s=new D(d,l);return r._pendingRequest.set(t,{res:s}),d.finally(()=>{r._pendingRequest.delete(t)}),s.apiObject}}}async $handleResponseFragment(E,i){const a=this._pendingRequest.get(E);a&&a.res.handleFragment(i)}}e.ExtHostChatProvider=u}),define(Pe[248],Te([1,0,6,3,15,8]),function(me,e,I,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatVariables=void 0;class T{static{this._idPool=0}constructor(h){this._resolver=new Map,this._proxy=h.getProxy(L.MainContext.MainThreadChatVariables)}async $resolveVariable(h,S,R){const D=this._resolver.get(h);if(D)try{const u=await D.resolver.resolve(D.data.name,{prompt:S},R);if(u)return u.map(A.ChatVariable.from)}catch(u){(0,C.onUnexpectedExternalError)(u)}}registerVariableResolver(h,S,R,D){const u=T._idPool++;return this._resolver.set(u,{extension:h.identifier,data:{name:S,description:R},resolver:D}),this._proxy.$registerVariable(u,{name:S,description:R}),(0,I.toDisposable)(()=>{this._resolver.delete(u),this._proxy.$unregisterVariable(u)})}}e.ExtHostChatVariables=T}),define(Pe[249],Te([1,0,13,67,5,6,2,87,22,8,7,3,24]),function(me,e,I,L,C,A,T,g,h,S,R,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function p(E,i,a){const r=E.getProxy(D.MainContext.MainThreadComments);class n{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new h.ExtensionIdentifierMap,i.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const w=this._commentControllers.get(f.handle);return w?w.value:f}else if(f&&f.$mid===7){const w=this._commentControllers.get(f.commentControlHandle);if(!w)return f;const P=w.getCommentThread(f.commentThreadHandle);return P?P.value:f}else if(f&&(f.$mid===9||f.$mid===8)){const w=this._commentControllers.get(f.thread.commentControlHandle);if(!w)return f;const P=w.getCommentThread(f.thread.commentThreadHandle);return P?f.$mid===8?P.value:{thread:P.value,text:f.text}:f}else if(f&&f.$mid===10){const w=this._commentControllers.get(f.thread.commentControlHandle);if(!w)return f;const P=w.getCommentThread(f.thread.commentThreadHandle);if(!P)return f;const m=f.commentUniqueId,v=P.getCommentByUniqueId(m);return v||f}else if(f&&f.$mid===11){const w=this._commentControllers.get(f.thread.commentControlHandle);if(!w)return f;const P=w.getCommentThread(f.thread.commentThreadHandle);if(!P)return f;const m=f.text,v=f.commentUniqueId,y=P.getCommentByUniqueId(v);return y?(typeof y.body=="string"?y.body=m:y.body=new R.MarkdownString(m),y):f}return f}})}createCommentController(f,w,P){const m=n.handlePool++,v=new c(f,m,w,P);this._commentControllers.set(v.handle,v);const y=this._commentControllersByExtension.get(f.identifier)||[];return y.push(v),this._commentControllersByExtension.set(f.identifier,y),v.value}async $createCommentThreadTemplate(f,w,P){const m=this._commentControllers.get(f);m&&m.$createCommentThreadTemplate(w,P)}async $updateCommentThreadTemplate(f,w,P){const m=this._commentControllers.get(f);m&&m.$updateCommentThreadTemplate(w,P)}$deleteCommentThread(f,w){this._commentControllers.get(f)?.$deleteCommentThread(w)}$provideCommentingRanges(f,w,P){const m=this._commentControllers.get(f);if(!m||!m.commentingRangeProvider)return Promise.resolve(void 0);const v=a.getDocument(T.URI.revive(w));return(0,I.asPromise)(async()=>{const y=await m.commentingRangeProvider.provideCommentingRanges(v,P);let O;return Array.isArray(y)?O={ranges:y,fileComments:!1}:y?O={ranges:y.ranges||[],fileComments:y.fileComments||!1}:O=y??void 0,O}).then(y=>{let O;return y&&(O={ranges:y.ranges.map(N=>S.Range.from(N)),fileComments:y.fileComments}),O})}$toggleReaction(f,w,P,m,v){const y=this._commentControllers.get(f);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,I.asPromise)(()=>{const O=y.getCommentThread(w);if(O){const N=O.getCommentByUniqueId(m.uniqueIdInThread);if(y!==void 0&&N&&y.reactionHandler)return y.reactionHandler(N,d(v))}return Promise.resolve(void 0)})}}class o{static{this._handlePool=0}set threadId(f){this._id=f}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(f){(f===void 0!=(this._range===void 0)||!f||!this._range||!f.isEqual(this._range))&&(this._range=f,this.modifications.range=f,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(f){this._canReply!==f&&(this._canReply=f,this.modifications.canReply=f,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(f){this._label=f,this.modifications.label=f,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(f){this._contextValue=f,this.modifications.contextValue=f,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(f){this._comments=f,this.modifications.comments=f,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(f){this._collapseState=f,this.modifications.collapsibleState=f,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(f){this._state=f,this.modifications.state=f,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(f,w,P,m,v,y,O,N){this._commentControllerHandle=w,this._id=P,this._uri=m,this._range=v,this._comments=y,this.extensionDescription=O,this._isTemplate=N,this.handle=o._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new C.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${f}.${this.handle}`),r.$createCommentThread(w,this.handle,this._id,this._uri,S.Range.from(this._range),O.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this._localDisposables.push({dispose:()=>{r.$deleteCommentThread(w,this.handle)}});const q=this;this.value={get uri(){return q.uri},get range(){return q.range},set range(W){q.range=W},get comments(){return q.comments},set comments(W){q.comments=W},get collapsibleState(){return q.collapsibleState},set collapsibleState(W){q.collapsibleState=W},get canReply(){return q.canReply},set canReply(W){q.canReply=W},get contextValue(){return q.contextValue},set contextValue(W){q.contextValue=W},get label(){return q.label},set label(W){q.label=W},get state(){return q.state},set state(W){q.state=W},dispose:()=>{q.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const f=P=>Object.prototype.hasOwnProperty.call(this.modifications,P),w={};f("range")&&(w.range=S.Range.from(this._range)),f("label")&&(w.label=this.label),f("contextValue")&&(w.contextValue=this.contextValue??null),f("comments")&&(w.comments=this._comments.map(P=>l(this,P,this._commentsMap,this.extensionDescription))),f("collapsibleState")&&(w.collapseState=s(this._collapseState)),f("canReply")&&(w.canReply=this.canReply),f("state")&&(w.state=b(this._state)),f("isTemplate")&&(w.isTemplate=this._isTemplate),this.modifications={},r.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,w)}getCommentByUniqueId(f){for(const w of this._commentsMap){const P=w[0],m=w[1];if(f===m)return P}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(f=>f.dispose())}}Ke([(0,L.debounce)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(f){this._commentingRangeProvider=f,r.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(f){this._reactionHandler=f,r.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this._options}set options(f){this._options=f,r.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(f,w,P,m){this._extension=f,this._handle=w,this._id=P,this._label=m,this._threads=new Map,r.$registerCommentController(this.handle,P,m,this._extension.identifier.value);const v=this;this.value=Object.freeze({id:v.id,label:v.label,get options(){return v.options},set options(y){v.options=y},get commentingRangeProvider(){return v.commentingRangeProvider},set commentingRangeProvider(y){v.commentingRangeProvider=y},get reactionHandler(){return v.reactionHandler},set reactionHandler(y){v.reactionHandler=y},createCommentThread(y,O,N){return v.createCommentThread(y,O,N).value},dispose:()=>{v.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{r.$unregisterCommentController(this.handle)}})}createCommentThread(f,w,P){w===void 0&&(0,u.checkProposedApiEnabled)(this._extension,"fileComments");const m=new o(this.id,this.handle,void 0,f,w,P,this._extension,!1);return this._threads.set(m.handle,m),m}$createCommentThreadTemplate(f,w){const P=new o(this.id,this.handle,void 0,T.URI.revive(f),S.Range.to(w),[],this._extension,!0);return P.collapsibleState=g.CommentThreadCollapsibleState.Expanded,this._threads.set(P.handle,P),P}$updateCommentThreadTemplate(f,w){const P=this._threads.get(f);P&&(P.range=S.Range.to(w))}$deleteCommentThread(f){this._threads.get(f)?.dispose(),this._threads.delete(f)}getCommentThread(f){return this._threads.get(f)}dispose(){this._threads.forEach(f=>{f.dispose()}),this._localDisposables.forEach(f=>f.dispose())}}function l(_,f,w,P){let m=w.get(f);return m||(m=++_.commentHandle,w.set(f,m)),f.state!==void 0&&(0,u.checkProposedApiEnabled)(P,"commentsDraftState"),f.reactions?.some(v=>v.reactors!==void 0)&&(0,u.checkProposedApiEnabled)(P,"commentReactor"),{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:m,body:typeof f.body=="string"?f.body:S.MarkdownString.from(f.body),userName:f.author.name,userIconPath:f.author.iconPath,label:f.label,commentReactions:f.reactions?f.reactions.map(v=>t(v)):void 0,state:f.state,timestamp:f.timestamp?.toJSON()}}function t(_){return{label:_.label,iconPath:_.iconPath?S.pathOrURIToURI(_.iconPath):void 0,count:_.count,hasReacted:_.authorHasReacted,reactors:_.reactors&&_.reactors.length>0&&typeof _.reactors[0]!="string"?_.reactors.map(f=>f.name):_.reactors}}function d(_){return{label:_.label||"",count:_.count||0,iconPath:_.iconPath?T.URI.revive(_.iconPath):"",authorHasReacted:_.hasReacted||!1,reactors:_.reactors?.map(f=>({name:f}))}}function s(_){if(_!==void 0)switch(_){case R.CommentThreadCollapsibleState.Expanded:return g.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return g.CommentThreadCollapsibleState.Collapsed}return g.CommentThreadCollapsibleState.Collapsed}function b(_){if(_!==void 0)switch(_){case R.CommentThreadState.Unresolved:return g.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return g.CommentThreadState.Resolved}return g.CommentThreadState.Unresolved}return new n}e.createExtHostComments=p}),define(Pe[250],Te([1,0,20,98,6,11,25,2,8,61,75,3,7]),function(me,e,I,L,C,A,T,g,h,S,R,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class p{constructor(d,s){this.document=d,this._storagePath=s,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(d){return this._edits.add([d])}async undo(d,s){await this.getEdit(d).undo(),s||this.disposeBackup()}async redo(d,s){await this.getEdit(d).redo(),s||this.disposeBackup()}disposeEdits(d){for(const s of d)this._edits.delete(s)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const d=l(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,d)}updateBackup(d){this._backup?.delete(),this._backup=d}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(d){const s=this._edits.get(d,0);if(!s)throw new Error("No edit found");return s}}class E{constructor(){this._documents=new Map}get(d,s){return this._documents.get(this.key(d,s))}add(d,s,b){const _=this.key(d,s.uri);if(this._documents.has(_))throw new Error(`Document already exists for viewType:${d} resource:${s.uri}`);const f=new p(s,b);return this._documents.set(_,f),f}delete(d,s){const b=this.key(d,s.uri);this._documents.delete(b)}key(d,s){return`${d}@@@${s}`}}var i;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(i||(i={}));class a{constructor(){this._providers=new Map}addTextProvider(d,s,b){return this.add(0,d,s,b)}addCustomProvider(d,s,b){return this.add(1,d,s,b)}get(d){return this._providers.get(d)}add(d,s,b,_){if(this._providers.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this._providers.set(s,{type:d,extension:b,provider:_}),new u.Disposable(()=>this._providers.delete(s))}}class r{constructor(d,s,b,_,f){this._extHostDocuments=s,this._extensionStoragePaths=b,this._extHostWebview=_,this._extHostWebviewPanels=f,this._editorProviders=new a,this._documents=new E,this._proxy=d.getProxy(D.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(d,s,b,_){const f=new C.DisposableStore;return o(b)?(f.add(this._editorProviders.addTextProvider(s,d,b)),this._proxy.$registerTextEditorProvider((0,S.toExtensionData)(d),s,_.webviewOptions||{},{supportsMove:!!b.moveCustomTextEditor},(0,S.shouldSerializeBuffersForPostMessage)(d))):(f.add(this._editorProviders.addCustomProvider(s,d,b)),n(b)&&f.add(b.onDidChangeCustomDocument(w=>{const P=this.getCustomDocumentEntry(s,w.document.uri);if(c(w)){const m=P.addEdit(w);this._proxy.$onDidEdit(w.document.uri,s,m,w.label)}else this._proxy.$onContentChange(w.document.uri,s)})),this._proxy.$registerCustomEditorProvider((0,S.toExtensionData)(d),s,_.webviewOptions||{},!!_.supportsMultipleEditorsPerDocument,(0,S.shouldSerializeBuffersForPostMessage)(d))),u.Disposable.from(f,new u.Disposable(()=>{this._proxy.$unregisterEditorProvider(s)}))}async $createCustomDocument(d,s,b,_,f){const w=this._editorProviders.get(s);if(!w)throw new Error(`No provider found for '${s}'`);if(w.type!==1)throw new Error(`Invalid provide type for '${s}'`);const P=g.URI.revive(d),m=await w.provider.openCustomDocument(P,{backupId:b,untitledDocumentData:_?.buffer},f);let v;return n(w.provider)&&this._extensionStoragePaths&&(v=this._extensionStoragePaths.workspaceValue(w.extension)??this._extensionStoragePaths.globalValue(w.extension)),this._documents.add(s,m,v),{editable:n(w.provider)}}async $disposeCustomDocument(d,s){const b=this._editorProviders.get(s);if(!b)throw new Error(`No provider found for '${s}'`);if(b.type!==1)throw new Error(`Invalid provider type for '${s}'`);const _=g.URI.revive(d),{document:f}=this.getCustomDocumentEntry(s,_);this._documents.delete(s,f),f.dispose()}async $resolveCustomEditor(d,s,b,_,f,w){const P=this._editorProviders.get(b);if(!P)throw new Error(`No provider found for '${b}'`);const m=h.ViewColumn.to(f),v=this._extHostWebview.createNewWebview(s,_.contentOptions,P.extension),y=this._extHostWebviewPanels.createNewWebviewPanel(s,b,_.title,m,_.options,v,_.active),O=g.URI.revive(d);switch(P.type){case 1:{const{document:N}=this.getCustomDocumentEntry(b,O);return P.provider.resolveCustomEditor(N,y,w)}case 0:{const N=this._extHostDocuments.getDocument(O);return P.provider.resolveCustomTextEditor(N,y,w)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(d,s,b){this.getCustomDocumentEntry(s,d).disposeEdits(b)}async $onMoveCustomEditor(d,s,b){const _=this._editorProviders.get(b);if(!_)throw new Error(`No provider found for '${b}'`);if(!_.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${b}'`);const f=this._extHostWebviewPanels.getWebviewPanel(d);if(!f)throw new Error("No webview found");const w=g.URI.revive(s),P=this._extHostDocuments.getDocument(w);await _.provider.moveCustomTextEditor(P,f,I.CancellationToken.None)}async $undo(d,s,b,_){return this.getCustomDocumentEntry(s,d).undo(b,_)}async $redo(d,s,b,_){return this.getCustomDocumentEntry(s,d).redo(b,_)}async $revert(d,s,b){const _=this.getCustomDocumentEntry(s,d);await this.getCustomEditorProvider(s).revertCustomDocument(_.document,b),_.disposeBackup()}async $onSave(d,s,b){const _=this.getCustomDocumentEntry(s,d);await this.getCustomEditorProvider(s).saveCustomDocument(_.document,b),_.disposeBackup()}async $onSaveAs(d,s,b,_){const f=this.getCustomDocumentEntry(s,d);return this.getCustomEditorProvider(s).saveCustomDocumentAs(f.document,g.URI.revive(b),_)}async $backup(d,s,b){const _=this.getCustomDocumentEntry(s,d),w=await this.getCustomEditorProvider(s).backupCustomDocument(_.document,{destination:_.getNewBackupUri()},b);return _.updateBackup(w),w.id}getCustomDocumentEntry(d,s){const b=this._documents.get(d,g.URI.revive(s));if(!b)throw new Error("No custom document found");return b}getCustomEditorProvider(d){const b=this._editorProviders.get(d)?.provider;if(!b||!n(b))throw new Error("Custom document is not editable");return b}}e.ExtHostCustomEditors=r;function n(t){return!!t.onDidChangeCustomDocument}function o(t){return typeof t.resolveCustomTextEditor=="function"}function c(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function l(t){const d=t.scheme===A.Schemas.file||t.scheme===A.Schemas.untitled?t.fsPath:t.toString();return(0,L.hash)(d)+""}}),define(Pe[251],Te([1,0,158,99,2,3,7,8,5,14,28,43]),function(me,e,I,L,C,A,T,g,h,S,R,D){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class p{#e;#t;#i;constructor(a,r,n,o,c,l,t,d){this._name=a,this._owner=r,this._maxDiagnosticsTotal=n,this._maxDiagnosticsPerFile=o,this._modelVersionIdProvider=c,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(o,n),this.#i=new R.ResourceMap(s=>l.getComparisonKey(s)),this.#e=t,this.#t=d}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,r){if(!a){this.clear();return}this._checkDisposed();let n=[];if(C.URI.isUri(a)){if(!r){this.delete(a);return}this.#i.set(a,r.slice()),n=[a]}else if(Array.isArray(a)){n=[];let l;a=[...a].sort(p._compareIndexedTuplesByUri);for(const t of a){const[d,s]=t;if((!l||d.toString()!==l.toString())&&(l&&this.#i.get(l).length===0&&this.#i.delete(l),l=d,n.push(d),this.#i.set(d,[])),s)this.#i.get(d)?.push(...s);else{const b=this.#i.get(d);b&&(b.length=0)}}}if(this.#t.fire(n),!this.#e)return;const o=[];let c=0;for(const l of n){let t=[];const d=this.#i.get(l);if(d)if(d.length>this._maxDiagnosticsPerFile){t=[];const s=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let b=0;b<4;b++)for(const _ of d)if(_.severity===s[b]&&t.push({...g.Diagnostic.from(_),modelVersionId:this._modelVersionIdProvider(l)})===this._maxDiagnosticsPerFile)break e;t.push({severity:L.MarkerSeverity.Info,message:(0,I.localize)(0,null,d.length-this._maxDiagnosticsPerFile),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=d.map(s=>({...g.Diagnostic.from(s),modelVersionId:this._modelVersionIdProvider(l)}));if(o.push([l,t]),c+=t.length,c>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,o)}delete(a){this._checkDisposed(),this.#t.fire([a]),this.#i.delete(a),this.#e?.$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(a,r){this._checkDisposed();for(const[n,o]of this)a.call(r,n,o,this)}*[Symbol.iterator](){this._checkDisposed();for(const a of this.#i.keys())yield[a,this.get(a)]}get(a){this._checkDisposed();const r=this.#i.get(a);return Array.isArray(r)?Object.freeze(r.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(this.#i.get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,r){return a[0].toString()<r[0].toString()?-1:a[0].toString()>r[0].toString()?1:0}}e.DiagnosticCollection=p;let E=class{static{u=this}static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*u._maxDiagnosticsPerFile}static _mapper(a){const r=new R.ResourceMap;for(const n of a)r.set(n,n);return{uris:Object.freeze(Array.from(r.values()))}}constructor(a,r,n,o){this._logService=r,this._fileSystemInfoService=n,this._extHostDocumentsAndEditors=o,this._collections=new Map,this._onDidChangeDiagnostics=new h.DebounceEmitter({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=h.Event.map(this._onDidChangeDiagnostics.event,u._mapper),this._proxy=a.getProxy(A.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(a,r){const{_collections:n,_proxy:o,_onDidChangeDiagnostics:c,_logService:l,_fileSystemInfoService:t,_extHostDocumentsAndEditors:d}=this,s=new class{$changeMany(f,w){o.$changeMany(f,w),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,f,w.length===0?"CLEARING":w)}$clear(f){o.$clear(f),l.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,f)}dispose(){o.dispose()}};let b;if(!r)r="_generated_diagnostic_collection_name_#"+u._idPool++,b=r;else if(!n.has(r))b=r;else{this._logService.warn(`DiagnosticCollection with name '${r}' does already exist.`);do b=r+u._idPool++;while(n.has(b))}return new class extends p{constructor(){super(r,b,u._maxDiagnosticsTotal,u._maxDiagnosticsPerFile,f=>d.getDocument(f)?.version,t.extUri,s,c),n.set(b,this)}dispose(){super.dispose(),n.delete(b)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const r=new Map,n=[];for(const o of this._collections.values())o.forEach((c,l)=>{let t=r.get(c.toString());typeof t>"u"&&(t=n.length,r.set(c.toString(),t),n.push([c,[]])),n[t][1]=n[t][1].concat(...l)});return n}}_getDiagnostics(a){let r=[];for(const n of this._collections.values())n.has(a)&&(r=r.concat(n.get(a)));return r}$acceptMarkersChange(a){if(!this._mirrorCollection){const r="_generated_mirror",n=new p(r,r,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,o=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(r,n),this._mirrorCollection=n}for(const[r,n]of a)this._mirrorCollection.set(C.URI.revive(r),n.map(g.Diagnostic.to))}};e.ExtHostDiagnostics=E,e.ExtHostDiagnostics=E=u=Ke([We(1,S.ILogService),We(2,D.IExtHostFileSystemInfo)],E)}),define(Pe[252],Te([1,0,2,15,7,8,185]),function(me,e,I,L,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class g{constructor(S,R,D,u={timeout:1500,errors:3}){this._logService=S,this._documents=R,this._mainThreadBulkEdits=D,this._thresholds=u,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(S){return(R,D,u)=>{const E={dispose:this._callbacks.push([R,D,S])};return Array.isArray(u)&&u.push(E),E}}async $participateInSave(S,R){const D=I.URI.revive(S);let u=!1;const p=setTimeout(()=>u=!0,this._thresholds.timeout),E=[];try{for(const i of[...this._callbacks]){if(u)break;const a=this._documents.getDocument(D),r=await this._deliverEventAsyncAndBlameBadListeners(i,{document:a,reason:A.TextDocumentSaveReason.to(R)});E.push(r)}}finally{clearTimeout(p)}return E}_deliverEventAsyncAndBlameBadListeners([S,R,D],u){const p=this._badListeners.get(S);return typeof p=="number"&&p>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(D,S,R,u).then(()=>!0,E=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this._logService.error(E),!(E instanceof Error)||E.message!=="concurrent_edits"){const i=this._badListeners.get(S);this._badListeners.set(S,i?i+1:1),typeof i=="number"&&i>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(S,R,D,u){const p=[],E=Date.now(),{document:i,reason:a}=u,{version:r}=i,n=Object.freeze({document:i,reason:a,waitUntil(o){if(Object.isFrozen(p))throw(0,L.illegalState)("waitUntil can not be called async");p.push(Promise.resolve(o))}});try{R.apply(D,[n])}catch(o){return Promise.reject(o)}return Object.freeze(p),new Promise((o,c)=>{const l=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(p).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' finished after ${Date.now()-E}ms`),clearTimeout(l),o(t)}).catch(t=>{clearTimeout(l),c(t)})}).then(o=>{const c={edits:[]};for(const l of o)if(Array.isArray(l)&&l.every(t=>t instanceof C.TextEdit))for(const{newText:t,newEol:d,range:s}of l)c.edits.push({resource:i.uri,versionId:void 0,textEdit:{range:s&&A.Range.from(s),text:t,eol:d&&A.EndOfLine.from(d)}});if(c.edits.length!==0)return r===i.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=g}),define(Pe[253],Te([1,0,5,6,2,3,108,8,16,26,7]),function(me,e,I,L,C,A,T,g,h,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class D{constructor(p,E){this._onDidAddDocument=new I.Emitter,this._onDidRemoveDocument=new I.Emitter,this._onDidChangeDocument=new I.Emitter,this._onDidSaveDocument=new I.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=p.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=E,this._documentsAndEditors.onDidRemoveDocuments(i=>{for(const a of i)this._onDidRemoveDocument.fire(a.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(i=>{for(const a of i)this._onDidAddDocument.fire(a.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(p){if(!p)return;const E=this._documentsAndEditors.getDocument(p);if(E)return E}getDocument(p){const E=this.getDocumentData(p);if(!E?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return E.document}ensureDocumentData(p){const E=this._documentsAndEditors.getDocument(p);if(E)return Promise.resolve(E);let i=this._documentLoader.get(p.toString());return i||(i=this._proxy.$tryOpenDocument(p).then(a=>{this._documentLoader.delete(p.toString());const r=C.URI.revive(a);return(0,h.assertIsDefined)(this._documentsAndEditors.getDocument(r))},a=>(this._documentLoader.delete(p.toString()),Promise.reject(a))),this._documentLoader.set(p.toString(),i)),i}createDocumentData(p){return this._proxy.$tryCreateDocument(p).then(E=>C.URI.revive(E))}$acceptModelLanguageChanged(p,E){const i=C.URI.revive(p),a=this._documentsAndEditors.getDocument(i);if(!a)throw new Error("unknown document");this._onDidRemoveDocument.fire(a.document),a._acceptLanguageId(E),this._onDidAddDocument.fire(a.document)}$acceptModelSaved(p){const E=C.URI.revive(p),i=this._documentsAndEditors.getDocument(E);if(!i)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this._onDidSaveDocument.fire(i.document)}$acceptDirtyStateChanged(p,E){const i=C.URI.revive(p),a=this._documentsAndEditors.getDocument(i);if(!a)throw new Error("unknown document");a._acceptIsDirty(E),this._onDidChangeDocument.fire({document:a.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,E,i){const a=C.URI.revive(p),r=this._documentsAndEditors.getDocument(a);if(!r)throw new Error("unknown document");r._acceptIsDirty(i),r.onEvents(E);let n;E.isUndoing?n=R.TextDocumentChangeReason.Undo:E.isRedoing&&(n=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,S.deepFreeze)({document:r.document,contentChanges:E.changes.map(o=>({range:g.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:n}))}setWordDefinitionFor(p,E){(0,T.setWordDefinitionFor)(p,E)}}e.ExtHostDocuments=D}),define(Pe[64],Te([1,0,254,5,16,2,4,3,17,8,7]),function(me,e,I,L,C,A,T,g,h,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,T.createDecorator)("IExtHostEditorTabs");class D{constructor(a,r,n){this._activeTabIdGetter=n,this._parentGroup=r,this.acceptDtoUpdate(a)}get apiObject(){if(!this._apiObject){const a=this,r={get isActive(){return a._dto.id===a._activeTabIdGetter()},get label(){return a._dto.label},get input(){return a._input},get isDirty(){return a._dto.isDirty},get isPinned(){return a._dto.isPinned},get isPreview(){return a._dto.isPreview},get group(){return a._parentGroup.apiObject}};this._apiObject=Object.freeze(r)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(a){this._dto=a,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new R.TextTabInput(A.URI.revive(this._dto.input.uri));case 2:return new R.TextDiffTabInput(A.URI.revive(this._dto.input.original),A.URI.revive(this._dto.input.modified));case 3:return new R.TextMergeTabInput(A.URI.revive(this._dto.input.base),A.URI.revive(this._dto.input.input1),A.URI.revive(this._dto.input.input2),A.URI.revive(this._dto.input.result));case 6:return new R.CustomEditorTabInput(A.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new R.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new R.NotebookEditorTabInput(A.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new R.NotebookDiffEditorTabInput(A.URI.revive(this._dto.input.original),A.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new R.TerminalEditorTabInput;case 9:return new R.InteractiveWindowInput(A.URI.revive(this._dto.input.uri),A.URI.revive(this._dto.input.inputBoxUri));case 10:return new R.ChatEditorTabInput(this._dto.input.providerId);default:return}}}class u{constructor(a,r){this._tabs=[],this._activeTabId="",this._dto=a,this._activeGroupIdGetter=r;for(const n of a.tabs)n.isActive&&(this._activeTabId=n.id),this._tabs.push(new D(n,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const a=this,r={get isActive(){return a._dto.groupId===a._activeGroupIdGetter()},get viewColumn(){return S.ViewColumn.to(a._dto.viewColumn)},get activeTab(){return a._tabs.find(n=>n.tabId===a._activeTabId)?.apiObject},get tabs(){return Object.freeze(a._tabs.map(n=>n.apiObject))}};this._apiObject=Object.freeze(r)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(a){this._dto=a}acceptTabOperation(a){if(a.kind===0){const n=new D(a.tabDto,this,()=>this.activeTabId());return this._tabs.splice(a.index,0,n),a.tabDto.isActive&&(this._activeTabId=n.tabId),n}else if(a.kind===1){const n=this._tabs.splice(a.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${a.index} which does not exist`);return n.tabId===this._activeTabId&&(this._activeTabId=""),n}else if(a.kind===3){if(a.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this._tabs.splice(a.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${a.oldIndex} which does not exist`);return this._tabs.splice(a.index,0,n),n}const r=this._tabs.find(n=>n.tabId===a.tabDto.id);if(!r)throw new Error("INVALID tab");return a.tabDto.isActive?this._activeTabId=a.tabDto.id:this._activeTabId===a.tabDto.id&&!a.tabDto.isActive&&(this._activeTabId=""),r.acceptDtoUpdate(a.tabDto),r}activeTabId(){return this._activeTabId}}let p=class{constructor(a){this._onDidChangeTabs=new L.Emitter,this._onDidChangeTabGroups=new L.Emitter,this._extHostTabGroups=[],this._proxy=a.getProxy(g.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const a=this,r={onDidChangeTabGroups:a._onDidChangeTabGroups.event,onDidChangeTabs:a._onDidChangeTabs.event,get all(){return Object.freeze(a._extHostTabGroups.map(n=>n.apiObject))},get activeTabGroup(){const n=a._activeGroupId;return(0,C.assertIsDefined)(a._extHostTabGroups.find(c=>c.groupId===n)?.apiObject)},close:async(n,o)=>{const c=Array.isArray(n)?n:[n];return c.length?E(c[0])?this._closeGroups(c,o):this._closeTabs(c,o):!0}};this._apiObject=Object.freeze(r)}return this._apiObject}$acceptEditorTabModel(a){const r=new Set(this._extHostTabGroups.map(s=>s.groupId)),n=new Set(a.map(s=>s.groupId)),o=(0,I.diffSets)(r,n),c=this._extHostTabGroups.filter(s=>o.removed.includes(s.groupId)).map(s=>s.apiObject),l=[],t=[];this._extHostTabGroups=a.map(s=>{const b=new u(s,()=>this._activeGroupId);return o.added.includes(b.groupId)?l.push(b.apiObject):t.push(b.apiObject),b});const d=(0,C.assertIsDefined)(a.find(s=>s.isActive===!0)?.groupId);d!==void 0&&this._activeGroupId!==d&&(this._activeGroupId=d),this._onDidChangeTabGroups.fire(Object.freeze({opened:l,closed:c,changed:t}))}$acceptTabGroupUpdate(a){const r=this._extHostTabGroups.find(n=>n.groupId===a.groupId);if(!r)throw new Error("Update Group IPC call received before group creation.");r.acceptGroupDtoUpdate(a),a.isActive&&(this._activeGroupId=a.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[r.apiObject],opened:[],closed:[]}))}$acceptTabOperation(a){const r=this._extHostTabGroups.find(o=>o.groupId===a.groupId);if(!r)throw new Error("Update Tabs IPC call received before group creation.");const n=r.acceptTabOperation(a);switch(a.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}_findExtHostTabFromApi(a){for(const r of this._extHostTabGroups)for(const n of r.tabs)if(n.apiObject===a)return n}_findExtHostTabGroupFromApi(a){return this._extHostTabGroups.find(r=>r.apiObject===a)}async _closeTabs(a,r){const n=[];for(const o of a){const c=this._findExtHostTabFromApi(o);if(!c)throw new Error("Tab close: Invalid tab not found!");n.push(c.tabId)}return this._proxy.$closeTab(n,r)}async _closeGroups(a,r){const n=[];for(const o of a){const c=this._findExtHostTabGroupFromApi(o);if(!c)throw new Error("Group close: Invalid group not found!");n.push(c.groupId)}return this._proxy.$closeGroup(n,r)}};e.ExtHostEditorTabs=p,e.ExtHostEditorTabs=p=Ke([We(0,h.IExtHostRpcService)],p);function E(i){return i.tabs!==void 0}}),define(Pe[255],Te([1,0,2,3,6,7,8,297,12,23,24,52]),function(me,e,I,L,C,A,T,g,h,S,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class u{constructor(){this._schemes=[]}add(i){this._stateMachine=void 0,this._schemes.push(i)}delete(i){const a=this._schemes.indexOf(i);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const i=this._schemes.sort(),a=[];let r,n,o=14,c=14;for(const l of i){let t=r?(0,h.commonPrefixLength)(r,l):0;for(t===0?n=1:n=c;t<l.length;t++)t+1===l.length?(o=c,c=9):c+=1,a.push([n,l.toUpperCase().charCodeAt(t),c]),a.push([n,l.toLowerCase().charCodeAt(t),c]),n=c;r=l,c=o}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new g.StateMachine(a)}}provideDocumentLinks(i){this._initStateMachine();const a=[],r=g.LinkComputer.computeLinks({getLineContent(n){return i.lineAt(n-1).text},getLineCount(){return i.lineCount}},this._stateMachine);for(const n of r){const o=T.DocumentLink.to(n);o.target&&a.push(o)}return a}}class p{constructor(i,a){this._extHostLanguageFeatures=a,this._linkProvider=new u,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=i.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(i,a,r,n={}){if(p._validateFileSystemProvider(r),this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(i,"*",this._linkProvider));const o=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(o,r);let c=2;n.isCaseSensitive&&(c+=1024),n.isReadonly&&(c+=2048),typeof r.copy=="function"&&(c+=8),typeof r.open=="function"&&typeof r.close=="function"&&typeof r.read=="function"&&typeof r.write=="function"&&((0,R.checkProposedApiEnabled)(i,"fsChunks"),c+=4);let l;n.isReadonly&&(0,D.isMarkdownString)(n.isReadonly)&&n.isReadonly.value!==""&&(l={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this._proxy.$registerFileSystemProvider(o,a,c,l).catch(d=>{console.error(`FAILED to register filesystem provider of ${i.identifier.value}-extension for the scheme ${a}`),console.error(d)});const t=r.onDidChangeFile(d=>{const s=[];for(const b of d){const{uri:_,type:f}=b;if(_.scheme!==a)continue;let w;switch(f){case A.FileChangeType.Changed:w=0;break;case A.FileChangeType.Created:w=1;break;case A.FileChangeType.Deleted:w=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:_,type:w})}this._proxy.$onFileSystemChange(o,s)});return(0,C.toDisposable)(()=>{t.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(o),this._proxy.$unregisterProvider(o)})}static _validateFileSystemProvider(i){if(!i)throw new Error("MISSING provider");if(typeof i.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof i.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof i.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof i.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof i.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof i.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof i.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof i.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(i){const{type:a,ctime:r,mtime:n,size:o,permissions:c}=i;return{type:a,ctime:r,mtime:n,size:o,permissions:c}}$stat(i,a){return Promise.resolve(this._getFsProvider(i).stat(I.URI.revive(a))).then(r=>p._asIStat(r))}$readdir(i,a){return Promise.resolve(this._getFsProvider(i).readDirectory(I.URI.revive(a)))}$readFile(i,a){return Promise.resolve(this._getFsProvider(i).readFile(I.URI.revive(a))).then(r=>S.VSBuffer.wrap(r))}$writeFile(i,a,r,n){return Promise.resolve(this._getFsProvider(i).writeFile(I.URI.revive(a),r.buffer,n))}$delete(i,a,r){return Promise.resolve(this._getFsProvider(i).delete(I.URI.revive(a),r))}$rename(i,a,r,n){return Promise.resolve(this._getFsProvider(i).rename(I.URI.revive(a),I.URI.revive(r),n))}$copy(i,a,r,n){const o=this._getFsProvider(i);if(!o.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(o.copy(I.URI.revive(a),I.URI.revive(r),n))}$mkdir(i,a){return Promise.resolve(this._getFsProvider(i).createDirectory(I.URI.revive(a)))}$watch(i,a,r,n){const o=this._getFsProvider(i).watch(I.URI.revive(r),n);this._watches.set(a,o)}$unwatch(i,a){const r=this._watches.get(a);r&&(r.dispose(),this._watches.delete(a))}$open(i,a,r){const n=this._getFsProvider(i);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(I.URI.revive(a),r))}$close(i,a){const r=this._getFsProvider(i);if(!r.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(r.close(a))}$read(i,a,r,n){const o=this._getFsProvider(i);if(!o.read)throw new Error('FileSystemProvider does not implement "read"');const c=S.VSBuffer.alloc(n);return Promise.resolve(o.read(a,r,c.buffer,0,n)).then(l=>c.slice(0,l))}$write(i,a,r,n){const o=this._getFsProvider(i);if(!o.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(o.write(a,r,n.buffer,0,n.byteLength))}_getFsProvider(i){const a=this._fsProvider.get(i);if(!a){const r=new Error;throw r.name="ENOPRO",r.message="no provider",r}return a}}e.ExtHostFileSystem=p}),define(Pe[256],Te([1,0,5,34,2,3,8,7,39]),function(me,e,I,L,C,A,T,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(p,E,i,a,r,n){this.session=Math.random(),this._onDidCreate=new I.Emitter,this._onDidChange=new I.Emitter,this._onDidDelete=new I.Emitter,this._config=0,n?.ignoreCreateEvents&&(this._config+=1),n?.ignoreChangeEvents&&(this._config+=2),n?.ignoreDeleteEvents&&(this._config+=4);const o=(0,L.parse)(r),c=typeof r=="string",l=n?.correlate,t=a(d=>{if(!(typeof d.session=="number"&&d.session!==this.session)&&!(l&&typeof d.session>"u")){if(!n?.ignoreCreateEvents)for(const s of d.created){const b=C.URI.revive(s);o(b.fsPath)&&(!c||E.getWorkspaceFolder(b))&&this._onDidCreate.fire(b)}if(!n?.ignoreChangeEvents)for(const s of d.changed){const b=C.URI.revive(s);o(b.fsPath)&&(!c||E.getWorkspaceFolder(b))&&this._onDidChange.fire(b)}if(!n?.ignoreDeleteEvents)for(const s of d.deleted){const b=C.URI.revive(s);o(b.fsPath)&&(!c||E.getWorkspaceFolder(b))&&this._onDidDelete.fire(b)}}});this._disposable=g.Disposable.from(this.ensureWatching(p,i,r,n,n?.correlate),this._onDidCreate,this._onDidChange,this._onDidDelete,t)}ensureWatching(p,E,i,a,r){const n=g.Disposable.from();if(typeof i=="string")return n;const o=p.getProxy(A.MainContext.MainThreadFileSystemEventService);let c=!1;return(i.pattern.includes(L.GLOBSTAR)||i.pattern.includes(L.GLOB_SPLIT))&&(c=!0),o.$watch(E.identifier.value,this.session,i.baseUri,{recursive:c,excludes:a?.excludes??[]},!!r),g.Disposable.from({dispose:()=>o.$unwatch(this.session)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class R{constructor(p){this._events=p,this.session=this._events.session,this._created=new h.Lazy(()=>this._events.created.map(C.URI.revive)),this._changed=new h.Lazy(()=>this._events.changed.map(C.URI.revive)),this._deleted=new h.Lazy(()=>this._events.deleted.map(C.URI.revive))}get created(){return this._created.value}get changed(){return this._changed.value}get deleted(){return this._deleted.value}}class D{constructor(p,E,i){this._mainContext=p,this._logService=E,this._extHostDocumentsAndEditors=i,this._onFileSystemEvent=new I.Emitter,this._onDidRenameFile=new I.Emitter,this._onDidCreateFile=new I.Emitter,this._onDidDeleteFile=new I.Emitter,this._onWillRenameFile=new I.AsyncEmitter,this._onWillCreateFile=new I.AsyncEmitter,this._onWillDeleteFile=new I.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(p,E,i,a){return new S(this._mainContext,p,E,this._onFileSystemEvent.event,T.GlobPattern.from(i),a)}$onFileEvent(p){this._onFileSystemEvent.fire(new R(p))}$onDidRunFileOperation(p,E){switch(p){case 2:this._onDidRenameFile.fire(Object.freeze({files:E.map(i=>({oldUri:C.URI.revive(i.source),newUri:C.URI.revive(i.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:E.map(i=>C.URI.revive(i.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:E.map(i=>C.URI.revive(i.target))}));break;default:}}getOnWillRenameFileEvent(p){return this._createWillExecuteEvent(p,this._onWillRenameFile)}getOnWillCreateFileEvent(p){return this._createWillExecuteEvent(p,this._onWillCreateFile)}getOnWillDeleteFileEvent(p){return this._createWillExecuteEvent(p,this._onWillDeleteFile)}_createWillExecuteEvent(p,E){return(i,a,r)=>{const n=function(c){i.call(a,c)};return n.extension=p,E.event(n,void 0,r)}}async $onWillRunFileOperation(p,E,i,a){switch(p){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:E.map(r=>({oldUri:C.URI.revive(r.source),newUri:C.URI.revive(r.target)}))},i,a);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:E.map(r=>C.URI.revive(r.target))},i,a);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:E.map(r=>C.URI.revive(r.target))},i,a)}}async _fireWillEvent(p,E,i,a){const r=new Set,n=[];if(await p.fireAsync(E,a,async(c,l)=>{const t=Date.now(),d=await Promise.resolve(c);d instanceof g.WorkspaceEdit&&(n.push([l.extension,d]),r.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-t>i&&this._logService.warn("SLOW file-participant",l.extension.identifier)}),a.isCancellationRequested||n.length===0)return;const o={edits:[]};for(const[,c]of n){const{edits:l}=T.WorkspaceEdit.from(c,{getTextDocumentVersion:t=>this._extHostDocumentsAndEditors.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(l)}return{edit:o,extensionNames:Array.from(r)}}}e.ExtHostFileSystemEventService=D}),define(Pe[257],Te([1,0,2,26,8,7,87,3,12,29,18,16,298,20,22,6,96,89,75,63,15,13,24,160]),function(me,e,I,L,C,A,T,g,h,S,R,D,u,p,E,i,a,r,n,o,c,l,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class s{constructor(F,V){this._documents=F,this._provider=V}async provideDocumentSymbols(F,V){const j=this._documents.getDocument(F),B=await this._provider.provideDocumentSymbols(j,V);if(!(0,R.isFalsyOrEmpty)(B))return B[0]instanceof A.DocumentSymbol?B.map(C.DocumentSymbol.from):s._asDocumentSymbolTree(B)}static _asDocumentSymbolTree(F){F=F.slice(0).sort((B,X)=>{let Z=B.location.range.start.compareTo(X.location.range.start);return Z===0&&(Z=X.location.range.end.compareTo(B.location.range.end)),Z});const V=[],j=[];for(const B of F){const X={name:B.name||"!!MISSING: name!!",kind:C.SymbolKind.from(B.kind),tags:B.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:B.containerName,range:C.Range.from(B.location.range),selectionRange:C.Range.from(B.location.range),children:[]};for(;;){if(j.length===0){j.push(X),V.push(X);break}const Z=j[j.length-1];if(S.Range.containsRange(Z.range,X.range)&&!S.Range.equalsRange(Z.range,X.range)){Z.children?.push(X),j.push(X);break}j.pop()}}return V}}class b{constructor(F,V,j,B,X,Z){this._documents=F,this._commands=V,this._provider=j,this._extension=B,this._extTelemetry=X,this._logService=Z,this._cache=new n.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(F,V){const j=this._documents.getDocument(F),B=await this._provider.provideCodeLenses(j,V);if(!B||V.isCancellationRequested)return;const X=this._cache.add(B),Z=new i.DisposableStore;this._disposables.set(X,Z);const Se={cacheId:X,lenses:[]};for(let Ne=0;Ne<B.length;Ne++)Se.lenses.push({cacheId:[X,Ne],range:C.Range.from(B[Ne].range),command:this._commands.toInternal(B[Ne].command,Z)});return Se}async resolveCodeLens(F,V){const j=F.cacheId&&this._cache.get(...F.cacheId);if(!j)return;let B;if(typeof this._provider.resolveCodeLens!="function"||j.isResolved?B=j:B=await this._provider.resolveCodeLens(j,V),B||(B=j),V.isCancellationRequested)return;const X=F.cacheId&&this._disposables.get(F.cacheId[0]);if(X){if(!B.command){const Z=new Error("INVALID code lens resolved, lacks command: "+this._extension.identifier.value);this._extTelemetry.onExtensionError(this._extension.identifier,Z),this._logService.error(Z);return}return F.command=this._commands.toInternal(B.command,X),F}}releaseCodeLenses(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}}function _(_e){return Array.isArray(_e)?_e.map(C.DefinitionLink.from):_e?[C.DefinitionLink.from(_e)]:[]}class f{constructor(F,V){this._documents=F,this._provider=V}async provideDefinition(F,V,j){const B=this._documents.getDocument(F),X=C.Position.to(V),Z=await this._provider.provideDefinition(B,X,j);return _(Z)}}class w{constructor(F,V){this._documents=F,this._provider=V}async provideDeclaration(F,V,j){const B=this._documents.getDocument(F),X=C.Position.to(V),Z=await this._provider.provideDeclaration(B,X,j);return _(Z)}}class P{constructor(F,V){this._documents=F,this._provider=V}async provideImplementation(F,V,j){const B=this._documents.getDocument(F),X=C.Position.to(V),Z=await this._provider.provideImplementation(B,X,j);return _(Z)}}class m{constructor(F,V){this._documents=F,this._provider=V}async provideTypeDefinition(F,V,j){const B=this._documents.getDocument(F),X=C.Position.to(V),Z=await this._provider.provideTypeDefinition(B,X,j);return _(Z)}}class v{constructor(F,V){this._documents=F,this._provider=V}async provideHover(F,V,j){const B=this._documents.getDocument(F),X=C.Position.to(V),Z=await this._provider.provideHover(B,X,j);if(!(!Z||(0,R.isFalsyOrEmpty)(Z.contents)))return Z.range||(Z.range=B.getWordRangeAtPosition(X)),Z.range||(Z.range=new A.Range(X,X)),C.Hover.from(Z)}}class y{constructor(F,V){this._documents=F,this._provider=V}async provideEvaluatableExpression(F,V,j){const B=this._documents.getDocument(F),X=C.Position.to(V),Z=await this._provider.provideEvaluatableExpression(B,X,j);if(Z)return C.EvaluatableExpression.from(Z)}}class O{constructor(F,V){this._documents=F,this._provider=V}async provideInlineValues(F,V,j,B){const X=this._documents.getDocument(F),Z=await this._provider.provideInlineValues(X,C.Range.to(V),C.InlineValueContext.to(j),B);if(Array.isArray(Z))return Z.map(Se=>C.InlineValue.from(Se))}}class N{constructor(F,V){this._documents=F,this._provider=V}async provideDocumentHighlights(F,V,j){const B=this._documents.getDocument(F),X=C.Position.to(V),Z=await this._provider.provideDocumentHighlights(B,X,j);if(Array.isArray(Z))return Z.map(C.DocumentHighlight.from)}}class q{constructor(F,V){this._documents=F,this._provider=V}async provideMultiDocumentHighlights(F,V,j,B){const X=this._documents.getDocument(F),Z=j.map($e=>this._documents.getDocument($e)),Se=C.Position.to(V),Ne=await this._provider.provideMultiDocumentHighlights(X,Se,Z,B);if(Array.isArray(Ne))return Ne.map(C.MultiDocumentHighlight.from)}}class W{constructor(F,V){this._documents=F,this._provider=V}async provideLinkedEditingRanges(F,V,j){const B=this._documents.getDocument(F),X=C.Position.to(V),Z=await this._provider.provideLinkedEditingRanges(B,X,j);if(Z&&Array.isArray(Z.ranges))return{ranges:(0,R.coalesce)(Z.ranges.map(C.Range.from)),wordPattern:Z.wordPattern}}}class x{constructor(F,V){this._documents=F,this._provider=V}async provideReferences(F,V,j,B){const X=this._documents.getDocument(F),Z=C.Position.to(V),Se=await this._provider.provideReferences(X,Z,j,B);if(Array.isArray(Se))return Se.map(C.location.from)}}class k{static{this._maxCodeActionsPerFile=1e3}constructor(F,V,j,B,X,Z,Se){this._documents=F,this._commands=V,this._diagnostics=j,this._provider=B,this._logService=X,this._extension=Z,this._apiDeprecation=Se,this._cache=new n.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(F,V,j,B){const X=this._documents.getDocument(F),Z=u.Selection.isISelection(V)?C.Selection.to(V):C.Range.to(V),Se=[];for(const it of this._diagnostics.getDiagnostics(F))if(Z.intersection(it.range)&&Se.push(it)>k._maxCodeActionsPerFile)break;const Ne={diagnostics:Se,only:j.only?new A.CodeActionKind(j.only):void 0,triggerKind:C.CodeActionTriggerKind.to(j.trigger)},$e=await this._provider.provideCodeActions(X,Z,Ne,B);if(!(0,R.isNonEmptyArray)($e)||B.isCancellationRequested)return;const qe=this._cache.add($e),Qe=new i.DisposableStore;this._disposables.set(qe,Qe);const nt=[];for(let it=0;it<$e.length;it++){const et=$e[it];if(et)if(k._isCommand(et))this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:et.title,command:this._commands.toInternal(et,Qe)});else{Ne.only&&(et.kind?Ne.only.contains(et.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const rt=et.ranges??[];nt.push({cacheId:[qe,it],title:et.title,command:et.command&&this._commands.toInternal(et.command,Qe),diagnostics:et.diagnostics&&et.diagnostics.map(C.Diagnostic.from),edit:et.edit&&C.WorkspaceEdit.from(et.edit,void 0),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,isAI:(0,t.isProposedApiEnabled)(this._extension,"codeActionAI")?et.isAI:!1,ranges:(0,t.isProposedApiEnabled)(this._extension,"codeActionRanges")?(0,R.coalesce)(rt.map(C.Range.from)):void 0,disabled:et.disabled?.reason})}}return{cacheId:qe,actions:nt}}async resolveCodeAction(F,V){const[j,B]=F,X=this._cache.get(j,B);if(!X||k._isCommand(X))return{};if(!this._provider.resolveCodeAction)return{};const Z=await this._provider.resolveCodeAction(X,V)??X;let Se;Z.edit&&(Se=C.WorkspaceEdit.from(Z.edit,void 0));let Ne;if(Z.command){const $e=this._disposables.get(j);$e&&(Ne=this._commands.toInternal(Z.command,$e))}return{edit:Se,command:Ne}}releaseCodeActions(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}static _isCommand(F){return typeof F.command=="string"&&typeof F.title=="string"}}class M{static toInternalProviderId(F,V){return F+"."+V}constructor(F,V,j,B,X){this._proxy=F,this._documents=V,this._provider=j,this._handle=B,this._extension=X}async prepareDocumentPaste(F,V,j,B){if(!this._provider.prepareDocumentPaste)return;const X=this._documents.getDocument(F),Z=V.map($e=>C.Range.to($e)),Se=C.DataTransfer.toDataTransfer(j,()=>{throw new c.NotImplementedError});if(await this._provider.prepareDocumentPaste(X,Z,Se,B),B.isCancellationRequested)return;const Ne=Array.from(Se).filter(([,$e])=>!($e instanceof A.InternalDataTransferItem));return C.DataTransfer.from(Ne)}async providePasteEdits(F,V,j,B,X){if(!this._provider.provideDocumentPasteEdits)return;const Z=this._documents.getDocument(V),Se=j.map(qe=>C.Range.to(qe)),Ne=C.DataTransfer.toDataTransfer(B,async qe=>(await this._proxy.$resolvePasteFileData(this._handle,F,qe)).buffer),$e=await this._provider.provideDocumentPasteEdits(Z,Se,Ne,X);if($e)return{label:$e.label??(0,d.localize)(0,null,this._extension.displayName||this._extension.name),detail:this._extension.displayName||this._extension.name,yieldTo:$e.yieldTo?.map(qe=>"mimeType"in qe?qe:{providerId:M.toInternalProviderId(qe.extensionId,qe.providerId)}),insertText:typeof $e.insertText=="string"?$e.insertText:{snippet:$e.insertText.value},additionalEdit:$e.additionalEdit?C.WorkspaceEdit.from($e.additionalEdit,void 0):void 0}}}class ${constructor(F,V){this._documents=F,this._provider=V}async provideDocumentFormattingEdits(F,V,j){const B=this._documents.getDocument(F),X=await this._provider.provideDocumentFormattingEdits(B,V,j);if(Array.isArray(X))return X.map(C.TextEdit.from)}}class oe{constructor(F,V){this._documents=F,this._provider=V}async provideDocumentRangeFormattingEdits(F,V,j,B){const X=this._documents.getDocument(F),Z=C.Range.to(V),Se=await this._provider.provideDocumentRangeFormattingEdits(X,Z,j,B);if(Array.isArray(Se))return Se.map(C.TextEdit.from)}async provideDocumentRangesFormattingEdits(F,V,j,B){(0,D.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const X=this._documents.getDocument(F),Z=V.map(C.Range.to),Se=await this._provider.provideDocumentRangesFormattingEdits(X,Z,j,B);if(Array.isArray(Se))return Se.map(C.TextEdit.from)}}class de{constructor(F,V){this._documents=F,this._provider=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,V,j,B,X){const Z=this._documents.getDocument(F),Se=C.Position.to(V),Ne=await this._provider.provideOnTypeFormattingEdits(Z,Se,j,B,X);if(Array.isArray(Ne))return Ne.map(C.TextEdit.from)}}class we{constructor(F,V){this._provider=F,this._logService=V,this._cache=new n.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(F,V){const j=await this._provider.provideWorkspaceSymbols(F,V);if(!(0,R.isNonEmptyArray)(j))return{symbols:[]};const B=this._cache.add(j),X={cacheId:B,symbols:[]};for(let Z=0;Z<j.length;Z++){const Se=j[Z];if(!Se||!Se.name){this._logService.warn("INVALID SymbolInformation",Se);continue}X.symbols.push({...C.WorkspaceSymbol.from(Se),cacheId:[B,Z]})}return X}async resolveWorkspaceSymbol(F,V){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const j=this._cache.get(...F.cacheId);if(j){const B=await this._provider.resolveWorkspaceSymbol(j,V);return B&&(0,L.mixin)(F,C.WorkspaceSymbol.from(B),!0)}}releaseWorkspaceSymbols(F){this._cache.delete(F)}}class ye{static supportsResolving(F){return typeof F.prepareRename=="function"}constructor(F,V,j){this._documents=F,this._provider=V,this._logService=j}async provideRenameEdits(F,V,j,B){const X=this._documents.getDocument(F),Z=C.Position.to(V);try{const Se=await this._provider.provideRenameEdits(X,Z,j,B);return Se?C.WorkspaceEdit.from(Se):void 0}catch(Se){const Ne=ye._asMessage(Se);return Ne?{rejectReason:Ne,edits:void 0}:Promise.reject(Se)}}async resolveRenameLocation(F,V,j){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const B=this._documents.getDocument(F),X=C.Position.to(V);try{const Z=await this._provider.prepareRename(B,X,j);let Se,Ne;if(A.Range.isRange(Z)?(Se=Z,Ne=B.getText(Z)):(0,D.isObject)(Z)&&(Se=Z.range,Ne=Z.placeholder),!Se||!Ne)return;if(Se.start.line>X.line||Se.end.line<X.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(Se),text:Ne}}catch(Z){const Se=ye._asMessage(Z);return Se?{rejectReason:Se,range:void 0,text:void 0}:Promise.reject(Z)}}static _asMessage(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class le{constructor(F,V){this.resultId=F,this.tokens=V}}class ve{constructor(F,V){this._documents=F,this._provider=V,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(F,V,j){const B=this._documents.getDocument(F),X=V!==0?this._previousResults.get(V):null;let Z=typeof X?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(B,X.resultId,j):await this._provider.provideDocumentSemanticTokens(B,j);return X&&this._previousResults.delete(V),Z?(Z=ve._fixProvidedSemanticTokens(Z),this._send(ve._convertToEdits(X,Z),Z)):null}async releaseDocumentSemanticColoring(F){this._previousResults.delete(F)}static _fixProvidedSemanticTokens(F){return ve._isSemanticTokens(F)?ve._isCorrectSemanticTokens(F)?F:new A.SemanticTokens(new Uint32Array(F.data),F.resultId):ve._isSemanticTokensEdits(F)?ve._isCorrectSemanticTokensEdits(F)?F:new A.SemanticTokensEdits(F.edits.map(V=>new A.SemanticTokensEdit(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),F.resultId):F}static _isSemanticTokens(F){return F&&!!F.data}static _isCorrectSemanticTokens(F){return F.data instanceof Uint32Array}static _isSemanticTokensEdits(F){return F&&Array.isArray(F.edits)}static _isCorrectSemanticTokensEdits(F){for(const V of F.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(F,V){if(!ve._isSemanticTokens(V)||!F||!F.tokens)return V;const j=F.tokens,B=j.length,X=V.data,Z=X.length;let Se=0;const Ne=Math.min(B,Z);for(;Se<Ne&&j[Se]===X[Se];)Se++;if(Se===B&&Se===Z)return new A.SemanticTokensEdits([],V.resultId);let $e=0;const qe=Ne-Se;for(;$e<qe&&j[B-$e-1]===X[Z-$e-1];)$e++;return new A.SemanticTokensEdits([{start:Se,deleteCount:B-Se-$e,data:X.subarray(Se,Z-$e)}],V.resultId)}_send(F,V){if(ve._isSemanticTokens(F)){const j=this._nextResultId++;return this._previousResults.set(j,new le(F.resultId,F.data)),(0,a.encodeSemanticTokensDto)({id:j,type:"full",data:F.data})}if(ve._isSemanticTokensEdits(F)){const j=this._nextResultId++;return ve._isSemanticTokens(V)?this._previousResults.set(j,new le(V.resultId,V.data)):this._previousResults.set(j,new le(F.resultId)),(0,a.encodeSemanticTokensDto)({id:j,type:"delta",deltas:(F.edits||[]).map(B=>({start:B.start,deleteCount:B.deleteCount,data:B.data}))})}return null}}class ae{constructor(F,V){this._documents=F,this._provider=V}async provideDocumentRangeSemanticTokens(F,V,j){const B=this._documents.getDocument(F),X=await this._provider.provideDocumentRangeSemanticTokens(B,C.Range.to(V),j);return X?this._send(X):null}_send(F){return(0,a.encodeSemanticTokensDto)({id:0,type:"full",data:F.data})}}class pe{static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}constructor(F,V,j,B,X){this._documents=F,this._commands=V,this._provider=j,this._apiDeprecation=B,this._extension=X,this._cache=new n.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(F,V,j,B){const X=this._documents.getDocument(F),Z=C.Position.to(V),Se=X.getWordRangeAtPosition(Z)||new A.Range(Z,Z),Ne=Se.with({end:Z}),$e=new o.StopWatch,qe=await this._provider.provideCompletionItems(X,Z,B,C.CompletionContext.to(j));if(!qe||B.isCancellationRequested)return;const Qe=Array.isArray(qe)?new A.CompletionList(qe):qe,nt=pe.supportsResolving(this._provider)?this._cache.add(Qe.items):this._cache.add([]),it=new i.DisposableStore;this._disposables.set(nt,it);const et=[],rt={x:nt,b:et,a:{replace:C.Range.from(Se),insert:C.Range.from(Ne)},c:Qe.isIncomplete||void 0,d:$e.elapsed()};for(let ct=0;ct<Qe.items.length;ct++){const Be=Qe.items[ct],gt=this._convertCompletionItem(Be,[nt,ct],Ne,Se);et.push(gt)}return rt}async resolveCompletionItem(F,V){if(typeof this._provider.resolveCompletionItem!="function")return;const j=this._cache.get(...F);if(!j)return;const B=this._convertCompletionItem(j,F),X=await this._provider.resolveCompletionItem(j,V);if(!X)return;const Z=this._convertCompletionItem(X,F);return(B.h!==Z.h||B.i!==Z.i)&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(B.n!==Z.n||B.o!==Z.o||!(0,L.equals)(B.p,Z.p))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...B,d:Z.d,c:Z.c,l:Z.l,h:Z.h,i:Z.i,n:Z.n,o:Z.o,p:Z.p}}releaseCompletionItems(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}_convertCompletionItem(F,V,j,B){const X=this._disposables.get(V[0]);if(!X)throw Error("DisposableStore is missing...");const Z=this._commands.toInternal(F.command,X),Se={x:V,a:F.label,b:F.kind!==void 0?C.CompletionItemKind.from(F.kind):void 0,m:F.tags&&F.tags.map(C.CompletionItemTag.from),c:F.detail,d:typeof F.documentation>"u"?void 0:C.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters?.join(""),l:F.additionalTextEdits&&F.additionalTextEdits.map(C.TextEdit.from),n:Z?.$ident,o:Z?.id,p:Z?.$ident?void 0:Z?.arguments};F.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Se.h=F.textEdit.newText):typeof F.insertText=="string"?Se.h=F.insertText:F.insertText instanceof A.SnippetString&&(Se.h=F.insertText.value,Se.i|=4);let Ne;return F.textEdit?Ne=F.textEdit.range:F.range&&(Ne=F.range),A.Range.isRange(Ne)?Se.j=C.Range.from(Ne):Ne&&(!j?.isEqual(Ne.inserting)||!B?.isEqual(Ne.replacing))&&(Se.j={insert:C.Range.from(Ne.inserting),replace:C.Range.from(Ne.replacing)}),Se}}class re{async provideInlineCompletions(F,V,j,B){}disposeCompletions(F){}handleDidShowCompletionItem(F,V,j){}handlePartialAccept(F,V,j){}}class J extends re{constructor(F,V,j,B){super(),this._extension=F,this._documents=V,this._provider=j,this._commands=B,this._references=new H,this._isAdditionsProposedApiEnabled=(0,t.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[T.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKind.Automatic,[T.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(F,V,j,B){const X=this._documents.getDocument(F),Z=C.Position.to(V),Se=await this._provider.provideInlineCompletionItems(X,Z,{selectedCompletionInfo:j.selectedSuggestionInfo?{range:C.Range.to(j.selectedSuggestionInfo.range),text:j.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[j.triggerKind]},B);if(!Se||B.isCancellationRequested)return;const Ne=Array.isArray(Se)?Se:Se.items,$e=this._isAdditionsProposedApiEnabled?Array.isArray(Se)?[]:Se.commands||[]:[],qe=this._isAdditionsProposedApiEnabled&&!Array.isArray(Se)?Se.enableForwardStability:void 0;let Qe;return{pid:this._references.createReferenceId({dispose(){Qe?.dispose()},items:Ne}),items:Ne.map((it,et)=>{let rt;it.command&&(Qe||(Qe=new i.DisposableStore),rt=this._commands.toInternal(it.command,Qe));const ct=it.insertText;return{insertText:typeof ct=="string"?ct:{snippet:ct.value},filterText:it.filterText,range:it.range?C.Range.from(it.range):void 0,command:rt,idx:et,completeBracketPairs:this._isAdditionsProposedApiEnabled?it.completeBracketPairs:!1}}),commands:$e.map(it=>(Qe||(Qe=new i.DisposableStore),this._commands.toInternal(it,Qe))),suppressSuggestions:!1,enableForwardStability:qe}}disposeCompletions(F){this._references.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,V,j){const B=this._references.get(F)?.items[V];B&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(B,j)}handlePartialAccept(F,V,j){const B=this._references.get(F)?.items[V];B&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(B,j)}}class H{constructor(){this._references=new Map,this._idPool=1}createReferenceId(F){const V=this._idPool++;return this._references.set(V,F),V}disposeReferenceId(F){const V=this._references.get(F);return this._references.delete(F),V}get(F){return this._references.get(F)}}class ne{constructor(F,V){this._documents=F,this._provider=V,this._cache=new n.Cache("SignatureHelp")}async provideSignatureHelp(F,V,j,B){const X=this._documents.getDocument(F),Z=C.Position.to(V),Se=this.reviveContext(j),Ne=await this._provider.provideSignatureHelp(X,Z,B,Se);if(Ne){const $e=this._cache.add([Ne]);return{...C.SignatureHelp.from(Ne),id:$e}}}reviveContext(F){let V;if(F.activeSignatureHelp){const j=C.SignatureHelp.to(F.activeSignatureHelp),B=this._cache.get(F.activeSignatureHelp.id,0);B?(V=B,V.activeSignature=j.activeSignature,V.activeParameter=j.activeParameter):V=j}return{...F,activeSignatureHelp:V}}releaseSignatureHelp(F){this._cache.delete(F)}}class Ae{constructor(F,V,j,B,X){this._documents=F,this._commands=V,this._provider=j,this._logService=B,this._extension=X,this._cache=new n.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(F,V,j){const B=this._documents.getDocument(F),X=C.Range.to(V),Z=await this._provider.provideInlayHints(B,X,j);if(!Array.isArray(Z)||Z.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(V)}`);return}if(j.isCancellationRequested)return;const Se=this._cache.add(Z);this._disposables.set(Se,new i.DisposableStore);const Ne={hints:[],cacheId:Se};for(let $e=0;$e<Z.length;$e++)this._isValidInlayHint(Z[$e],X)&&Ne.hints.push(this._convertInlayHint(Z[$e],[Se,$e]));return this._logService.trace(`[InlayHints] ${Ne.hints.length} inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(V)}`),Ne}async resolveInlayHint(F,V){if(typeof this._provider.resolveInlayHint!="function")return;const j=this._cache.get(...F);if(!j)return;const B=await this._provider.resolveInlayHint(j,V);if(B&&this._isValidInlayHint(B))return this._convertInlayHint(B,F)}releaseHints(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}_isValidInlayHint(F,V){return F.label.length===0||Array.isArray(F.label)&&F.label.every(j=>j.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!(V&&!V.contains(F.position))}_convertInlayHint(F,V){const j=this._disposables.get(V[0]);if(!j)throw Error("DisposableStore is missing...");const B={label:"",cacheId:V,tooltip:C.MarkdownString.fromStrict(F.tooltip),position:C.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(C.TextEdit.from),kind:F.kind&&C.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};if(typeof F.label=="string")B.label=F.label;else{const X=[];B.label=X;for(const Z of F.label){if(!Z.value){console.warn("INVALID inlay hint, empty label part",this._extension.identifier.value);continue}const Se={label:Z.value,tooltip:C.MarkdownString.fromStrict(Z.tooltip)};A.Location.isLocation(Z.location)&&(Se.location=C.location.from(Z.location)),Z.command&&(Se.command=this._commands.toInternal(Z.command,j)),X.push(Se)}}return B}}class Re{constructor(F,V){this._documents=F,this._provider=V,this._cache=new n.Cache("DocumentLink")}async provideLinks(F,V){const j=this._documents.getDocument(F),B=await this._provider.provideDocumentLinks(j,V);if(!(!Array.isArray(B)||B.length===0)&&!V.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:B.filter(Re._validateLink).map(C.DocumentLink.from)};{const X=this._cache.add(B),Z={links:[],cacheId:X};for(let Se=0;Se<B.length;Se++){if(!Re._validateLink(B[Se]))continue;const Ne=C.DocumentLink.from(B[Se]);Ne.cacheId=[X,Se],Z.links.push(Ne)}return Z}}}static _validateLink(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,V){if(typeof this._provider.resolveDocumentLink!="function")return;const j=this._cache.get(...F);if(!j)return;const B=await this._provider.resolveDocumentLink(j,V);if(!(!B||!Re._validateLink(B)))return C.DocumentLink.from(B)}releaseLinks(F){this._cache.delete(F)}}class ke{constructor(F,V){this._documents=F,this._provider=V}async provideColors(F,V){const j=this._documents.getDocument(F),B=await this._provider.provideDocumentColors(j,V);return Array.isArray(B)?B.map(Z=>({color:C.Color.from(Z.color),range:C.Range.from(Z.range)})):[]}async provideColorPresentations(F,V,j){const B=this._documents.getDocument(F),X=C.Range.to(V.range),Z=C.Color.to(V.color),Se=await this._provider.provideColorPresentations(Z,{document:B,range:X},j);if(Array.isArray(Se))return Se.map(C.ColorPresentation.from)}}class ce{constructor(F,V){this._documents=F,this._provider=V}async provideFoldingRanges(F,V,j){const B=this._documents.getDocument(F),X=await this._provider.provideFoldingRanges(B,V,j);if(Array.isArray(X))return X.map(C.FoldingRange.from)}}class te{constructor(F,V,j){this._documents=F,this._provider=V,this._logService=j}async provideSelectionRanges(F,V,j){const B=this._documents.getDocument(F),X=V.map(C.Position.to),Z=await this._provider.provideSelectionRanges(B,X,j);if(!(0,R.isNonEmptyArray)(Z))return[];if(Z.length!==X.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Se=[];for(let Ne=0;Ne<X.length;Ne++){const $e=[];Se.push($e);let qe=X[Ne],Qe=Z[Ne];for(;;){if(!Qe.range.contains(qe))throw new Error("INVALID selection range, must contain the previous range");if($e.push(C.SelectionRange.from(Qe)),!Qe.parent)break;qe=Qe.range,Qe=Qe.parent}}return Se}}class K{constructor(F,V){this._documents=F,this._provider=V,this._idPool=new r.IdGenerator(""),this._cache=new Map}async prepareSession(F,V,j){const B=this._documents.getDocument(F),X=C.Position.to(V),Z=await this._provider.prepareCallHierarchy(B,X,j);if(!Z)return;const Se=this._idPool.nextId();return this._cache.set(Se,new Map),Array.isArray(Z)?Z.map(Ne=>this._cacheAndConvertItem(Se,Ne)):[this._cacheAndConvertItem(Se,Z)]}async provideCallsTo(F,V,j){const B=this._itemFromCache(F,V);if(!B)throw new Error("missing call hierarchy item");const X=await this._provider.provideCallHierarchyIncomingCalls(B,j);if(X)return X.map(Z=>({from:this._cacheAndConvertItem(F,Z.from),fromRanges:Z.fromRanges.map(Se=>C.Range.from(Se))}))}async provideCallsFrom(F,V,j){const B=this._itemFromCache(F,V);if(!B)throw new Error("missing call hierarchy item");const X=await this._provider.provideCallHierarchyOutgoingCalls(B,j);if(X)return X.map(Z=>({to:this._cacheAndConvertItem(F,Z.to),fromRanges:Z.fromRanges.map(Se=>C.Range.from(Se))}))}releaseSession(F){this._cache.delete(F)}_cacheAndConvertItem(F,V){const j=this._cache.get(F),B=C.CallHierarchyItem.from(V,F,j.size.toString(36));return j.set(B._itemId,V),B}_itemFromCache(F,V){return this._cache.get(F)?.get(V)}}class ee{constructor(F,V){this._documents=F,this._provider=V,this._idPool=new r.IdGenerator(""),this._cache=new Map}async prepareSession(F,V,j){const B=this._documents.getDocument(F),X=C.Position.to(V),Z=await this._provider.prepareTypeHierarchy(B,X,j);if(!Z)return;const Se=this._idPool.nextId();return this._cache.set(Se,new Map),Array.isArray(Z)?Z.map(Ne=>this._cacheAndConvertItem(Se,Ne)):[this._cacheAndConvertItem(Se,Z)]}async provideSupertypes(F,V,j){const B=this._itemFromCache(F,V);if(!B)throw new Error("missing type hierarchy item");const X=await this._provider.provideTypeHierarchySupertypes(B,j);if(X)return X.map(Z=>this._cacheAndConvertItem(F,Z))}async provideSubtypes(F,V,j){const B=this._itemFromCache(F,V);if(!B)throw new Error("missing type hierarchy item");const X=await this._provider.provideTypeHierarchySubtypes(B,j);if(X)return X.map(Z=>this._cacheAndConvertItem(F,Z))}releaseSession(F){this._cache.delete(F)}_cacheAndConvertItem(F,V){const j=this._cache.get(F),B=C.TypeHierarchyItem.from(V,F,j.size.toString(36));return j.set(B._itemId,V),B}_itemFromCache(F,V){return this._cache.get(F)?.get(V)}}class ge{static toInternalProviderId(F,V){return F+"."+V}constructor(F,V,j,B,X){this._proxy=F,this._documents=V,this._provider=j,this._handle=B,this._extension=X}async provideDocumentOnDropEdits(F,V,j,B,X){const Z=this._documents.getDocument(V),Se=C.Position.to(j),Ne=C.DataTransfer.toDataTransfer(B,async qe=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,F,qe)).buffer),$e=await this._provider.provideDocumentDropEdits(Z,Se,Ne,X);if($e)return{label:$e.label??(0,d.localize)(1,null,this._extension.displayName||this._extension.name),yieldTo:$e.yieldTo?.map(qe=>"mimeType"in qe?qe:{providerId:ge.toInternalProviderId(qe.extensionId,qe.providerId)}),insertText:typeof $e.insertText=="string"?$e.insertText:{snippet:$e.insertText.value},additionalEdit:$e.additionalEdit?C.WorkspaceEdit.from($e.additionalEdit,void 0):void 0}}}class be{constructor(F,V){this._documents=F,this._provider=V}async provideMappedEdits(F,V,j,B){const X=I.URI.revive(F),Z=this._documents.getDocument(X),Se=j.documents.map(qe=>qe.map(Qe=>({uri:I.URI.revive(Qe.uri),version:Qe.version,ranges:Qe.ranges.map(nt=>C.Range.to(nt))}))),Ne={documents:Se,selections:Se[0]?.[0]?.ranges??[]},$e=await this._provider.provideMappedEdits(Z,V,Ne,B);return $e?C.WorkspaceEdit.from($e):null}}class Le{constructor(F,V){this.adapter=F,this.extension=V}}class fe{static{this._handlePool=0}constructor(F,V,j,B,X,Z,Se,Ne){this._uriTransformer=V,this._documents=j,this._commands=B,this._diagnostics=X,this._logService=Z,this._apiDeprecation=Se,this._extensionTelemetry=Ne,this._adapter=new Map,this._proxy=F.getProxy(g.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(F,V){return C.DocumentSelector.from(F,this._uriTransformer,V)}_createDisposable(F){return new A.Disposable(()=>{this._adapter.delete(F),this._proxy.$unregister(F)})}_nextHandle(){return fe._handlePool++}async _withAdapter(F,V,j,B,X,Z=!1){const Se=this._adapter.get(F);if(!Se||!(Se.adapter instanceof V))return B;const Ne=Date.now();Z||this._logService.trace(`[${Se.extension.identifier.value}] INVOKE provider '${j.toString().replace(/[\r\n]/g,"")}'`);const $e=j(Se.adapter,Se.extension);return Promise.resolve($e).catch(qe=>{(0,c.isCancellationError)(qe)||(this._logService.error(`[${Se.extension.identifier.value}] provider FAILED`),this._logService.error(qe),this._extensionTelemetry.onExtensionError(Se.extension.identifier,qe))}).finally(()=>{Z||this._logService.trace(`[${Se.extension.identifier.value}] provider DONE after ${Date.now()-Ne}ms`)}),p.CancellationToken.isCancellationToken(X)?(0,l.raceCancellationError)($e,X):$e}_addNewAdapter(F,V){const j=this._nextHandle();return this._adapter.set(j,new Le(F,V)),j}static _extLabel(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,V,j,B){const X=this._addNewAdapter(new s(this._documents,j),F),Z=B&&B.label||fe._extLabel(F);return this._proxy.$registerDocumentSymbolProvider(X,this._transformDocumentSelector(V,F),Z),this._createDisposable(X)}$provideDocumentSymbols(F,V,j){return this._withAdapter(F,s,B=>B.provideDocumentSymbols(I.URI.revive(V),j),void 0,j)}registerCodeLensProvider(F,V,j){const B=this._nextHandle(),X=typeof j.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(B,new Le(new b(this._documents,this._commands.converter,j,F,this._extensionTelemetry,this._logService),F)),this._proxy.$registerCodeLensSupport(B,this._transformDocumentSelector(V,F),X);let Z=this._createDisposable(B);if(X!==void 0){const Se=j.onDidChangeCodeLenses(Ne=>this._proxy.$emitCodeLensEvent(X));Z=A.Disposable.from(Z,Se)}return Z}$provideCodeLenses(F,V,j){return this._withAdapter(F,b,B=>B.provideCodeLenses(I.URI.revive(V),j),void 0,j)}$resolveCodeLens(F,V,j){return this._withAdapter(F,b,B=>B.resolveCodeLens(V,j),void 0,void 0)}$releaseCodeLenses(F,V){this._withAdapter(F,b,j=>Promise.resolve(j.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(F,V,j){const B=this._addNewAdapter(new f(this._documents,j),F);return this._proxy.$registerDefinitionSupport(B,this._transformDocumentSelector(V,F)),this._createDisposable(B)}$provideDefinition(F,V,j,B){return this._withAdapter(F,f,X=>X.provideDefinition(I.URI.revive(V),j,B),[],B)}registerDeclarationProvider(F,V,j){const B=this._addNewAdapter(new w(this._documents,j),F);return this._proxy.$registerDeclarationSupport(B,this._transformDocumentSelector(V,F)),this._createDisposable(B)}$provideDeclaration(F,V,j,B){return this._withAdapter(F,w,X=>X.provideDeclaration(I.URI.revive(V),j,B),[],B)}registerImplementationProvider(F,V,j){const B=this._addNewAdapter(new P(this._documents,j),F);return this._proxy.$registerImplementationSupport(B,this._transformDocumentSelector(V,F)),this._createDisposable(B)}$provideImplementation(F,V,j,B){return this._withAdapter(F,P,X=>X.provideImplementation(I.URI.revive(V),j,B),[],B)}registerTypeDefinitionProvider(F,V,j){const B=this._addNewAdapter(new m(this._documents,j),F);return this._proxy.$registerTypeDefinitionSupport(B,this._transformDocumentSelector(V,F)),this._createDisposable(B)}$provideTypeDefinition(F,V,j,B){return this._withAdapter(F,m,X=>X.provideTypeDefinition(I.URI.revive(V),j,B),[],B)}registerHoverProvider(F,V,j,B){const X=this._addNewAdapter(new v(this._documents,j),F);return this._proxy.$registerHoverProvider(X,this._transformDocumentSelector(V,F)),this._createDisposable(X)}$provideHover(F,V,j,B){return this._withAdapter(F,v,X=>X.provideHover(I.URI.revive(V),j,B),void 0,B)}registerEvaluatableExpressionProvider(F,V,j,B){const X=this._addNewAdapter(new y(this._documents,j),F);return this._proxy.$registerEvaluatableExpressionProvider(X,this._transformDocumentSelector(V,F)),this._createDisposable(X)}$provideEvaluatableExpression(F,V,j,B){return this._withAdapter(F,y,X=>X.provideEvaluatableExpression(I.URI.revive(V),j,B),void 0,B)}registerInlineValuesProvider(F,V,j,B){const X=typeof j.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Z=this._addNewAdapter(new O(this._documents,j),F);this._proxy.$registerInlineValuesProvider(Z,this._transformDocumentSelector(V,F),X);let Se=this._createDisposable(Z);if(X!==void 0){const Ne=j.onDidChangeInlineValues($e=>this._proxy.$emitInlineValuesEvent(X));Se=A.Disposable.from(Se,Ne)}return Se}$provideInlineValues(F,V,j,B,X){return this._withAdapter(F,O,Z=>Z.provideInlineValues(I.URI.revive(V),j,B,X),void 0,X)}registerDocumentHighlightProvider(F,V,j){const B=this._addNewAdapter(new N(this._documents,j),F);return this._proxy.$registerDocumentHighlightProvider(B,this._transformDocumentSelector(V,F)),this._createDisposable(B)}registerMultiDocumentHighlightProvider(F,V,j){const B=this._addNewAdapter(new q(this._documents,j),F);return this._proxy.$registerMultiDocumentHighlightProvider(B,this._transformDocumentSelector(V,F)),this._createDisposable(B)}$provideDocumentHighlights(F,V,j,B){return this._withAdapter(F,N,X=>X.provideDocumentHighlights(I.URI.revive(V),j,B),void 0,B)}$provideMultiDocumentHighlights(F,V,j,B,X){return this._withAdapter(F,q,Z=>Z.provideMultiDocumentHighlights(I.URI.revive(V),j,B.map(Se=>I.URI.revive(Se)),X),void 0,X)}registerLinkedEditingRangeProvider(F,V,j){const B=this._addNewAdapter(new W(this._documents,j),F);return this._proxy.$registerLinkedEditingRangeProvider(B,this._transformDocumentSelector(V,F)),this._createDisposable(B)}$provideLinkedEditingRanges(F,V,j,B){return this._withAdapter(F,W,async X=>{const Z=await X.provideLinkedEditingRanges(I.URI.revive(V),j,B);if(Z)return{ranges:Z.ranges,wordPattern:Z.wordPattern?fe._serializeRegExp(Z.wordPattern):void 0}},void 0,B)}registerReferenceProvider(F,V,j){const B=this._addNewAdapter(new x(this._documents,j),F);return this._proxy.$registerReferenceSupport(B,this._transformDocumentSelector(V,F)),this._createDisposable(B)}$provideReferences(F,V,j,B,X){return this._withAdapter(F,x,Z=>Z.provideReferences(I.URI.revive(V),j,B,X),void 0,X)}registerCodeActionProvider(F,V,j,B){const X=new i.DisposableStore,Z=this._addNewAdapter(new k(this._documents,this._commands.converter,this._diagnostics,j,this._logService,F,this._apiDeprecation),F);return this._proxy.$registerQuickFixSupport(Z,this._transformDocumentSelector(V,F),{providedKinds:B?.providedCodeActionKinds?.map(Se=>Se.value),documentation:B?.documentation?.map(Se=>({kind:Se.kind.value,command:this._commands.converter.toInternal(Se.command,X)}))},fe._extLabel(F),!!j.resolveCodeAction),X.add(this._createDisposable(Z)),X}$provideCodeActions(F,V,j,B,X){return this._withAdapter(F,k,Z=>Z.provideCodeActions(I.URI.revive(V),j,B,X),void 0,X)}$resolveCodeAction(F,V,j){return this._withAdapter(F,k,B=>B.resolveCodeAction(V,j),{},void 0)}$releaseCodeActions(F,V){this._withAdapter(F,k,j=>Promise.resolve(j.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(F,V,j){const B=this._addNewAdapter(new $(this._documents,j),F);return this._proxy.$registerDocumentFormattingSupport(B,this._transformDocumentSelector(V,F),F.identifier,F.displayName||F.name),this._createDisposable(B)}$provideDocumentFormattingEdits(F,V,j,B){return this._withAdapter(F,$,X=>X.provideDocumentFormattingEdits(I.URI.revive(V),j,B),void 0,B)}registerDocumentRangeFormattingEditProvider(F,V,j){const B=typeof j.provideDocumentRangesFormattingEdits=="function",X=this._addNewAdapter(new oe(this._documents,j),F);return this._proxy.$registerRangeFormattingSupport(X,this._transformDocumentSelector(V,F),F.identifier,F.displayName||F.name,B),this._createDisposable(X)}$provideDocumentRangeFormattingEdits(F,V,j,B,X){return this._withAdapter(F,oe,Z=>Z.provideDocumentRangeFormattingEdits(I.URI.revive(V),j,B,X),void 0,X)}$provideDocumentRangesFormattingEdits(F,V,j,B,X){return this._withAdapter(F,oe,Z=>Z.provideDocumentRangesFormattingEdits(I.URI.revive(V),j,B,X),void 0,X)}registerOnTypeFormattingEditProvider(F,V,j,B){const X=this._addNewAdapter(new de(this._documents,j),F);return this._proxy.$registerOnTypeFormattingSupport(X,this._transformDocumentSelector(V,F),B,F.identifier),this._createDisposable(X)}$provideOnTypeFormattingEdits(F,V,j,B,X,Z){return this._withAdapter(F,de,Se=>Se.provideOnTypeFormattingEdits(I.URI.revive(V),j,B,X,Z),void 0,Z)}registerWorkspaceSymbolProvider(F,V){const j=this._addNewAdapter(new we(V,this._logService),F);return this._proxy.$registerNavigateTypeSupport(j,typeof V.resolveWorkspaceSymbol=="function"),this._createDisposable(j)}$provideWorkspaceSymbols(F,V,j){return this._withAdapter(F,we,B=>B.provideWorkspaceSymbols(V,j),{symbols:[]},j)}$resolveWorkspaceSymbol(F,V,j){return this._withAdapter(F,we,B=>B.resolveWorkspaceSymbol(V,j),void 0,void 0)}$releaseWorkspaceSymbols(F,V){this._withAdapter(F,we,j=>j.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(F,V,j){const B=this._addNewAdapter(new ye(this._documents,j,this._logService),F);return this._proxy.$registerRenameSupport(B,this._transformDocumentSelector(V,F),ye.supportsResolving(j)),this._createDisposable(B)}$provideRenameEdits(F,V,j,B,X){return this._withAdapter(F,ye,Z=>Z.provideRenameEdits(I.URI.revive(V),j,B,X),void 0,X)}$resolveRenameLocation(F,V,j,B){return this._withAdapter(F,ye,X=>X.resolveRenameLocation(I.URI.revive(V),j,B),void 0,B)}registerDocumentSemanticTokensProvider(F,V,j,B){const X=this._addNewAdapter(new ve(this._documents,j),F),Z=typeof j.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(X,this._transformDocumentSelector(V,F),B,Z);let Se=this._createDisposable(X);if(Z){const Ne=j.onDidChangeSemanticTokens($e=>this._proxy.$emitDocumentSemanticTokensEvent(Z));Se=A.Disposable.from(Se,Ne)}return Se}$provideDocumentSemanticTokens(F,V,j,B){return this._withAdapter(F,ve,X=>X.provideDocumentSemanticTokens(I.URI.revive(V),j,B),null,B)}$releaseDocumentSemanticTokens(F,V){this._withAdapter(F,ve,j=>j.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,V,j,B){const X=this._addNewAdapter(new ae(this._documents,j),F);return this._proxy.$registerDocumentRangeSemanticTokensProvider(X,this._transformDocumentSelector(V,F),B),this._createDisposable(X)}$provideDocumentRangeSemanticTokens(F,V,j,B){return this._withAdapter(F,ae,X=>X.provideDocumentRangeSemanticTokens(I.URI.revive(V),j,B),null,B)}registerCompletionItemProvider(F,V,j,B){const X=this._addNewAdapter(new pe(this._documents,this._commands.converter,j,this._apiDeprecation,F),F);return this._proxy.$registerCompletionsProvider(X,this._transformDocumentSelector(V,F),B,pe.supportsResolving(j),F.identifier),this._createDisposable(X)}$provideCompletionItems(F,V,j,B,X){return this._withAdapter(F,pe,Z=>Z.provideCompletionItems(I.URI.revive(V),j,B,X),void 0,X)}$resolveCompletionItem(F,V,j){return this._withAdapter(F,pe,B=>B.resolveCompletionItem(V,j),void 0,j)}$releaseCompletionItems(F,V){this._withAdapter(F,pe,j=>j.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(F,V,j,B){const X=new J(F,this._documents,j,this._commands.converter),Z=this._addNewAdapter(X,F);return this._proxy.$registerInlineCompletionsSupport(Z,this._transformDocumentSelector(V,F),X.supportsHandleEvents,E.ExtensionIdentifier.toKey(F.identifier.value),B?.yieldTo?.map(Se=>E.ExtensionIdentifier.toKey(Se))||[]),this._createDisposable(Z)}$provideInlineCompletions(F,V,j,B,X){return this._withAdapter(F,re,Z=>Z.provideInlineCompletions(I.URI.revive(V),j,B,X),void 0,X)}$handleInlineCompletionDidShow(F,V,j,B){this._withAdapter(F,re,async X=>{X.handleDidShowCompletionItem(V,j,B)},void 0,void 0)}$handleInlineCompletionPartialAccept(F,V,j,B){this._withAdapter(F,re,async X=>{X.handlePartialAccept(V,j,B)},void 0,void 0)}$freeInlineCompletionsList(F,V){this._withAdapter(F,re,async j=>{j.disposeCompletions(V)},void 0,void 0)}registerSignatureHelpProvider(F,V,j,B){const X=Array.isArray(B)?{triggerCharacters:B,retriggerCharacters:[]}:B,Z=this._addNewAdapter(new ne(this._documents,j),F);return this._proxy.$registerSignatureHelpProvider(Z,this._transformDocumentSelector(V,F),X),this._createDisposable(Z)}$provideSignatureHelp(F,V,j,B,X){return this._withAdapter(F,ne,Z=>Z.provideSignatureHelp(I.URI.revive(V),j,B,X),void 0,X)}$releaseSignatureHelp(F,V){this._withAdapter(F,ne,j=>j.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(F,V,j){const B=typeof j.onDidChangeInlayHints=="function"?this._nextHandle():void 0,X=this._addNewAdapter(new Ae(this._documents,this._commands.converter,j,this._logService,F),F);this._proxy.$registerInlayHintsProvider(X,this._transformDocumentSelector(V,F),typeof j.resolveInlayHint=="function",B,fe._extLabel(F));let Z=this._createDisposable(X);if(B!==void 0){const Se=j.onDidChangeInlayHints(Ne=>this._proxy.$emitInlayHintsEvent(B));Z=A.Disposable.from(Z,Se)}return Z}$provideInlayHints(F,V,j,B){return this._withAdapter(F,Ae,X=>X.provideInlayHints(I.URI.revive(V),j,B),void 0,B)}$resolveInlayHint(F,V,j){return this._withAdapter(F,Ae,B=>B.resolveInlayHint(V,j),void 0,j)}$releaseInlayHints(F,V){this._withAdapter(F,Ae,j=>j.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(F,V,j){const B=this._addNewAdapter(new Re(this._documents,j),F);return this._proxy.$registerDocumentLinkProvider(B,this._transformDocumentSelector(V,F),typeof j.resolveDocumentLink=="function"),this._createDisposable(B)}$provideDocumentLinks(F,V,j){return this._withAdapter(F,Re,B=>B.provideLinks(I.URI.revive(V),j),void 0,j,V.scheme==="output")}$resolveDocumentLink(F,V,j){return this._withAdapter(F,Re,B=>B.resolveLink(V,j),void 0,void 0,!0)}$releaseDocumentLinks(F,V){this._withAdapter(F,Re,j=>j.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(F,V,j){const B=this._addNewAdapter(new ke(this._documents,j),F);return this._proxy.$registerDocumentColorProvider(B,this._transformDocumentSelector(V,F)),this._createDisposable(B)}$provideDocumentColors(F,V,j){return this._withAdapter(F,ke,B=>B.provideColors(I.URI.revive(V),j),[],j)}$provideColorPresentations(F,V,j,B){return this._withAdapter(F,ke,X=>X.provideColorPresentations(I.URI.revive(V),j,B),void 0,B)}registerFoldingRangeProvider(F,V,j){const B=this._nextHandle(),X=typeof j.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(B,new Le(new ce(this._documents,j),F)),this._proxy.$registerFoldingRangeProvider(B,this._transformDocumentSelector(V,F),F.identifier,X);let Z=this._createDisposable(B);if(X!==void 0){const Se=j.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(X));Z=A.Disposable.from(Z,Se)}return Z}$provideFoldingRanges(F,V,j,B){return this._withAdapter(F,ce,X=>X.provideFoldingRanges(I.URI.revive(V),j,B),void 0,B)}registerSelectionRangeProvider(F,V,j){const B=this._addNewAdapter(new te(this._documents,j,this._logService),F);return this._proxy.$registerSelectionRangeProvider(B,this._transformDocumentSelector(V,F)),this._createDisposable(B)}$provideSelectionRanges(F,V,j,B){return this._withAdapter(F,te,X=>X.provideSelectionRanges(I.URI.revive(V),j,B),[],B)}registerCallHierarchyProvider(F,V,j){const B=this._addNewAdapter(new K(this._documents,j),F);return this._proxy.$registerCallHierarchyProvider(B,this._transformDocumentSelector(V,F)),this._createDisposable(B)}$prepareCallHierarchy(F,V,j,B){return this._withAdapter(F,K,X=>Promise.resolve(X.prepareSession(I.URI.revive(V),j,B)),void 0,B)}$provideCallHierarchyIncomingCalls(F,V,j,B){return this._withAdapter(F,K,X=>X.provideCallsTo(V,j,B),void 0,B)}$provideCallHierarchyOutgoingCalls(F,V,j,B){return this._withAdapter(F,K,X=>X.provideCallsFrom(V,j,B),void 0,B)}$releaseCallHierarchy(F,V){this._withAdapter(F,K,j=>Promise.resolve(j.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(F,V,j){const B=this._addNewAdapter(new ee(this._documents,j),F);return this._proxy.$registerTypeHierarchyProvider(B,this._transformDocumentSelector(V,F)),this._createDisposable(B)}$prepareTypeHierarchy(F,V,j,B){return this._withAdapter(F,ee,X=>Promise.resolve(X.prepareSession(I.URI.revive(V),j,B)),void 0,B)}$provideTypeHierarchySupertypes(F,V,j,B){return this._withAdapter(F,ee,X=>X.provideSupertypes(V,j,B),void 0,B)}$provideTypeHierarchySubtypes(F,V,j,B){return this._withAdapter(F,ee,X=>X.provideSubtypes(V,j,B),void 0,B)}$releaseTypeHierarchy(F,V){this._withAdapter(F,ee,j=>Promise.resolve(j.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(F,V,j,B){const X=this._nextHandle();this._adapter.set(X,new Le(new ge(this._proxy,this._documents,j,X,F),F));const Z=(0,t.isProposedApiEnabled)(F,"dropMetadata")&&B?ge.toInternalProviderId(F.identifier.value,B.id):void 0;return this._proxy.$registerDocumentOnDropEditProvider(X,this._transformDocumentSelector(V,F),Z,(0,t.isProposedApiEnabled)(F,"dropMetadata")?B:void 0),this._createDisposable(X)}$provideDocumentOnDropEdits(F,V,j,B,X,Z){return this._withAdapter(F,ge,Se=>Promise.resolve(Se.provideDocumentOnDropEdits(V,I.URI.revive(j),B,X,Z)),void 0,void 0)}registerMappedEditsProvider(F,V,j){const B=this._addNewAdapter(new be(this._documents,j),F);return this._proxy.$registerMappedEditsProvider(B,this._transformDocumentSelector(V,F)),this._createDisposable(B)}$provideMappedEdits(F,V,j,B,X){return this._withAdapter(F,be,Z=>Promise.resolve(Z.provideMappedEdits(V,j,B,X)),null,X)}registerDocumentPasteEditProvider(F,V,j,B){const X=this._nextHandle();this._adapter.set(X,new Le(new M(this._proxy,this._documents,j,X,F),F));const Z=M.toInternalProviderId(F.identifier.value,B.id);return this._proxy.$registerPasteEditProvider(X,this._transformDocumentSelector(V,F),Z,{supportsCopy:!!j.prepareDocumentPaste,supportsPaste:!!j.provideDocumentPasteEdits,copyMimeTypes:B.copyMimeTypes,pasteMimeTypes:B.pasteMimeTypes}),this._createDisposable(X)}$prepareDocumentPaste(F,V,j,B,X){return this._withAdapter(F,M,Z=>Z.prepareDocumentPaste(I.URI.revive(V),j,B,X),void 0,X)}$providePasteEdits(F,V,j,B,X,Z){return this._withAdapter(F,M,Se=>Se.providePasteEdits(V,I.URI.revive(j),B,X,Z),void 0,Z)}static _serializeRegExp(F){return{pattern:F.source,flags:F.flags}}static _serializeIndentationRule(F){return{decreaseIndentPattern:fe._serializeRegExp(F.decreaseIndentPattern),increaseIndentPattern:fe._serializeRegExp(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?fe._serializeRegExp(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?fe._serializeRegExp(F.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(F){return{beforeText:fe._serializeRegExp(F.beforeText),afterText:F.afterText?fe._serializeRegExp(F.afterText):void 0,previousLineText:F.previousLineText?fe._serializeRegExp(F.previousLineText):void 0,action:F.action}}static _serializeOnEnterRules(F){return F.map(fe._serializeOnEnterRule)}static _serializeAutoClosingPair(F){return{open:F.open,close:F.close,notIn:F.notIn?F.notIn.map(V=>A.SyntaxTokenType.toString(V)):void 0}}static _serializeAutoClosingPairs(F){return F.map(fe._serializeAutoClosingPair)}setLanguageConfiguration(F,V,j){const{wordPattern:B}=j;if(B&&(0,h.regExpLeadsToEndlessLoop)(B))throw new Error(`Invalid language configuration: wordPattern '${B}' is not allowed to match the empty string.`);B?this._documents.setWordDefinitionFor(V,B):this._documents.setWordDefinitionFor(V,void 0),j.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),j.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",F,"Do not use.");const X=this._nextHandle(),Z={comments:j.comments,brackets:j.brackets,wordPattern:j.wordPattern?fe._serializeRegExp(j.wordPattern):void 0,indentationRules:j.indentationRules?fe._serializeIndentationRule(j.indentationRules):void 0,onEnterRules:j.onEnterRules?fe._serializeOnEnterRules(j.onEnterRules):void 0,__electricCharacterSupport:j.__electricCharacterSupport,__characterPairSupport:j.__characterPairSupport,autoClosingPairs:j.autoClosingPairs?fe._serializeAutoClosingPairs(j.autoClosingPairs):void 0};return this._proxy.$setLanguageConfiguration(X,V,Z),this._createDisposable(X)}$setWordDefinitions(F){for(const V of F)this._documents.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.ExtHostLanguageFeatures=fe}),define(Pe[258],Te([1,0,3,8,7,32,13,6,24]),function(me,e,I,L,C,A,T,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(D,u,p,E){this._documents=u,this._commands=p,this._uriTransformer=E,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=D.getProxy(I.MainContext.MainThreadLanguages)}$acceptLanguageIds(D){this._languageIds=D}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(D,u){await this._proxy.$changeLanguage(D,u);const p=this._documents.getDocumentData(D);if(!p)throw new Error(`document '${D.toString()}' NOT found`);return p.document}async tokenAtPosition(D,u){const p=D.version,E=L.Position.from(u),i=await this._proxy.$tokensAtPosition(D.uri,E),a={type:C.StandardTokenType.Other,range:D.getWordRangeAtPosition(u)??new C.Range(u.line,u.character,u.line,u.character)};if(!i)return a;const r={range:L.Range.to(i.range),type:L.TokenType.to(i.type)};return!r.range.contains(u)||p!==D.version?a:r}createLanguageStatusItem(D,u,p){const E=this._handlePool++,i=this._proxy,a=this._ids,r=`${D.identifier.value}/${u}`;if(a.has(r))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);a.add(r);const n={selector:p,id:u,name:D.displayName??D.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let o;const c=new g.DisposableStore,l=()=>{if(o?.dispose(),!a.has(r)){console.warn(`LanguageStatusItem (${u}) from ${D.identifier.value} has been disposed and CANNOT be updated anymore`);return}o=(0,T.disposableTimeout)(()=>{c.clear(),this._proxy.$setLanguageStatus(E,{id:r,name:n.name??D.displayName??D.name,source:D.displayName??D.name,selector:L.DocumentSelector.from(n.selector,this._uriTransformer),label:n.text,detail:n.detail??"",severity:n.severity===C.LanguageStatusSeverity.Error?A.default.Error:n.severity===C.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:n.command&&this._commands.toInternal(n.command,c),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){c.dispose(),o?.dispose(),i.$removeLanguageStatus(E),a.delete(r)},get id(){return n.id},get name(){return n.name},set name(d){n.name=d,l()},get selector(){return n.selector},set selector(d){n.selector=d,l()},get text(){return n.text},set text(d){n.text=d,l()},set text2(d){(0,h.checkProposedApiEnabled)(D,"languageStatusText"),n.text=d,l()},get text2(){return(0,h.checkProposedApiEnabled)(D,"languageStatusText"),n.text},get detail(){return n.detail},set detail(d){n.detail=d,l()},get severity(){return n.severity},set severity(d){n.severity=d,l()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(d){n.accessibilityInformation=d,l()},get command(){return n.command},set command(d){n.command=d,l()},get busy(){return n.busy},set busy(d){n.busy=d,l()}};return l(),t}}e.ExtHostLanguages=S}),define(Pe[259],Te([1,0,11,2,8,7,84]),function(me,e,I,L,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class g{constructor(D,u,p,E){this.start=D,this.deletedCount=u,this.deletedItems=p,this.items=E}asApiEvent(){return{range:new A.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class h{static asModelAddData(D,u){return{EOL:u.eol,lines:u.source,languageId:u.language,uri:u.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,u,p){this.notebook=D,this._extHostDocument=u,this._cellData=p,this.handle=p.handle,this.uri=L.URI.revive(p.uri),this.cellKind=p.cellKind,this._outputs=p.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=p.internalMetadata??{},this._metadata=Object.freeze(p.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const D=this,u=this._extHostDocument.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:u.document,get mime(){return D._mime},set mime(E){D._mime=E},get outputs(){return D._outputs.slice(0)},get metadata(){return D._metadata},get executionSummary(){return D._previousResult}};this._apiCell=Object.freeze(p)}return this._apiCell}setOutputs(D){this._outputs=D.map(C.NotebookCellOutput.to)}setOutputItems(D,u,p){const E=p.map(C.NotebookCellOutputItem.to),i=this._outputs.find(a=>a.id===D);if(i&&(u||(i.items.length=0),i.items.push(...E),i.items.length>1&&i.items.every(a=>T.isTextStreamMime(a.mime)))){const a=new Map,r=[];i.items.forEach(n=>{let o;a.has(n.mime)?o=a.get(n.mime):(o=[],a.set(n.mime,o),r.push(n.mime)),o.push(n.data)}),i.items.length=0,r.forEach(n=>{const o=T.compressOutputItemStreams(a.get(n));i.items.push({mime:n,data:o.data.buffer})})}}setMetadata(D){this._metadata=Object.freeze(D)}setInternalMetadata(D){this._internalMetadata=D,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.ExtHostCell=h;class S{static{this._handlePool=0}constructor(D,u,p,E,i){this._proxy=D,this._textDocumentsAndEditors=u,this._textDocuments=p,this.uri=E,this.handle=S._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=i.viewType,this._metadata=Object.freeze(i.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,i.cells]],!0,void 0),this._versionId=i.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const D=this,u={get uri(){return D.uri},get version(){return D._versionId},get notebookType(){return D._notebookType},get isDirty(){return D._isDirty},get isUntitled(){return D.uri.scheme===I.Schemas.untitled},get isClosed(){return D._disposed},get metadata(){return D._metadata},get cellCount(){return D._cells.length},cellAt(p){return p=D._validateIndex(p),D._cells[p].apiCell},getCells(p){return(p?D._getCells(p):D._cells).map(i=>i.apiCell)},save(){return D._save()}};this._notebook=Object.freeze(u)}return this._notebook}acceptDocumentPropertiesChanged(D){D.metadata&&(this._metadata=Object.freeze({...this._metadata,...D.metadata}))}acceptDirty(D){this._isDirty=D}acceptModelChanged(D,u,p){this._versionId=D.versionId,this._isDirty=u,this.acceptDocumentPropertiesChanged({metadata:p});const E={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},i=[];for(const r of D.rawEvents)r.kind===T.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(r.changes,!1,E.contentChanges):r.kind===T.NotebookCellsChangeType.Move?this._moveCells(r.index,r.length,r.newIdx,E.contentChanges):r.kind===T.NotebookCellsChangeType.Output?(this._setCellOutputs(r.index,r.outputs),i.push({cell:this._cells[r.index].apiCell,outputs:this._cells[r.index].apiCell.outputs})):r.kind===T.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(r.index,r.outputId,r.append,r.outputItems),i.push({cell:this._cells[r.index].apiCell,outputs:this._cells[r.index].apiCell.outputs})):r.kind===T.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(r.index,r.language),i.push({cell:this._cells[r.index].apiCell,document:this._cells[r.index].apiCell.document})):r.kind===T.NotebookCellsChangeType.ChangeCellContent?i.push({cell:this._cells[r.index].apiCell,document:this._cells[r.index].apiCell.document}):r.kind===T.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(r.index,r.mime):r.kind===T.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(r.index,r.metadata),i.push({cell:this._cells[r.index].apiCell,metadata:this._cells[r.index].apiCell.metadata})):r.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(r.index,r.internalMetadata),i.push({cell:this._cells[r.index].apiCell,executionSummary:this._cells[r.index].apiCell.executionSummary}));const a=new Map;for(let r=0;r<i.length;r++){const n=i[r],o=a.get(n.cell);if(o===void 0){const c=E.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});a.set(n.cell,c-1)}else E.cellChanges[o]={...E.cellChanges[o],...n}}return Object.freeze(E),Object.freeze(E.cellChanges),Object.freeze(E.contentChanges),E}_validateIndex(D){return D=D|0,D<0?0:D>=this._cells.length?this._cells.length-1:D}_validateRange(D){let u=D.start|0,p=D.end|0;return u<0&&(u=0),p>this._cells.length&&(p=this._cells.length),D.with({start:u,end:p})}_getCells(D){D=this._validateRange(D);const u=[];for(let p=D.start;p<D.end;p++)u.push(this._cells[p]);return u}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(D,u,p){if(this._disposed)return;const E=[],i=[],a=[];if(D.reverse().forEach(r=>{const o=r[2].map(t=>{const d=new h(this,this._textDocumentsAndEditors,t);return u||i.push(h.asModelAddData(this.apiNotebook,t)),d}),c=new g(r[0],r[1],[],o),l=this._cells.splice(r[0],r[1],...o);for(const t of l)a.push(t.uri),c.deletedItems.push(t.apiCell);E.push(c)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:i,removedDocuments:a}),p)for(const r of E)p.push(r.asApiEvent())}_moveCells(D,u,p,E){const i=this._cells.splice(D,u);this._cells.splice(p,0,...i);const a=[new g(D,u,i.map(r=>r.apiCell),[]),new g(p,0,[],i)];for(const r of a)E.push(r.asApiEvent())}_setCellOutputs(D,u){this._cells[D].setOutputs(u)}_setCellOutputItems(D,u,p,E){this._cells[D].setOutputItems(u,p,E)}_changeCellLanguage(D,u){const p=this._cells[D];p.apiCell.document.languageId!==u&&this._textDocuments.$acceptModelLanguageChanged(p.uri,u)}_changeCellMime(D,u){const p=this._cells[D];p.apiCell.mime=u}_changeCellMetadata(D,u){this._cells[D].setMetadata(u)}_changeCellInternalMetadata(D,u){this._cells[D].setInternalMetadata(u)}getCellFromApiCell(D){return this._cells.find(u=>u.apiCell===D)}getCellFromIndex(D){return this._cells[D]}getCell(D){return this._cells.find(u=>u.handle===D)}getCellIndex(D){return this._cells.indexOf(D)}}e.ExtHostNotebookDocument=S}),define(Pe[260],Te([1,0,5,2,8,7]),function(me,e,I,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class T{constructor(h,S,R,D={timeout:1500,errors:3}){this._logService=h,this._notebooksAndEditors=S,this._mainThreadBulkEdits=R,this._thresholds=D,this._onWillSaveNotebookDocumentEvent=new I.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(h){return(S,R,D)=>{const u=function(E){S.call(R,E)};return u.extension=h,this._onWillSaveNotebookDocumentEvent.event(u,void 0,D)}}async $participateInSave(h,S,R){const D=L.URI.revive(h),u=this._notebooksAndEditors.getNotebookDocument(D);if(!u)throw new Error("Unable to resolve notebook document");const p=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:u.apiNotebook,reason:C.TextDocumentSaveReason.to(S)},R,async(i,a)=>{const r=Date.now(),n=await await Promise.resolve(i);Date.now()-r>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier),!R.isCancellationRequested&&n&&(n instanceof A.WorkspaceEdit?p.push(n):this._logService.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(p.length===0)return!0;const E={edits:[]};for(const i of p){const{edits:a}=C.WorkspaceEdit.from(i);E.edits=E.edits.concat(a)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(E)}}e.ExtHostNotebookDocumentSaveParticipant=T}),define(Pe[109],Te([1,0,15,8,7]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{static{this.apiEditorsToExtHost=new WeakMap}constructor(g,h,S,R,D,u){this.id=g,this._proxy=h,this.notebookData=S,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=D,this._visibleRanges=R,this._viewColumn=u}get apiEditor(){if(!this._editor){const g=this;this._editor={get notebook(){return g.notebookData.apiNotebook},get selection(){return g._selections[0]},set selection(h){this.selections=[h]},get selections(){return g._selections},set selections(h){if(!Array.isArray(h)||!h.every(C.NotebookRange.isNotebookRange))throw(0,I.illegalArgument)("selections");g._selections=h,g._trySetSelections(h)},get visibleRanges(){return g._visibleRanges},revealRange(h,S){g._proxy.$tryRevealRange(g.id,L.NotebookRange.from(h),S??C.NotebookEditorRevealType.Default)},get viewColumn(){return g._viewColumn}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(g){this._visible=g}_acceptVisibleRanges(g){this._visibleRanges=g}_acceptSelections(g){this._selections=g}_trySetSelections(g){this._proxy.$trySetSelections(this.id,g.map(L.NotebookRange.from))}_acceptViewColumn(g){this._viewColumn=g}}e.ExtHostNotebookEditor=A}),define(Pe[261],Te([1,0,5,14,8]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let A=class{constructor(g,h){this._logService=g,this._notebooksAndEditors=h,this._onDidChangeNotebookEditorSelection=new I.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new I.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(g,h){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",g,h);const S=this._notebooksAndEditors.getEditorById(g);h.visibleRanges&&S._acceptVisibleRanges(h.visibleRanges.ranges.map(C.NotebookRange.to)),h.selections&&S._acceptSelections(h.selections.selections.map(C.NotebookRange.to)),h.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:S.apiEditor,visibleRanges:S.apiEditor.visibleRanges}),h.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:S.apiEditor,selections:S.apiEditor.selections}))}$acceptEditorViewColumns(g){for(const h in g)this._notebooksAndEditors.getEditorById(h)._acceptViewColumn(C.ViewColumn.to(g[h]))}};e.ExtHostNotebookEditors=A,e.ExtHostNotebookEditors=A=Ke([We(0,L.ILogService)],A)}),define(Pe[262],Te([1,0,5,3,109]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(g,h){this._extHostNotebook=h,this._rendererMessageEmitters=new Map,this.proxy=g.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(g,h,S){const R=this._extHostNotebook.getEditorById(g);this._rendererMessageEmitters.get(h)?.fire({editor:R.apiEditor,message:S})}createRendererMessaging(g,h){if(!g.contributes?.notebookRenderer?.some(R=>R.id===h))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${h})`);return{onDidReceiveMessage:(R,D,u)=>this.getOrCreateEmitterFor(h).event(R,D,u),postMessage:(R,D)=>{C.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,D]=[D,R]);const u=D&&C.ExtHostNotebookEditor.apiEditorsToExtHost.get(D);return this.proxy.$postMessage(u?.id,h,R)}}}getOrCreateEmitterFor(g){let h=this._rendererMessageEmitters.get(g);return h||(h=new I.Emitter({onDidRemoveLastListener:()=>{h?.dispose(),this._rendererMessageEmitters.delete(g)}}),this._rendererMessageEmitters.set(g,h),h)}}e.ExtHostNotebookRenderers=A}),define(Pe[263],Te([1,0,8,72,20,67,15]),function(me,e,I,L,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class g{constructor(D){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=D}async withProgress(D,u,p){const E=this._handles++,{title:i,location:a,cancellable:r}=u,n={label:D.displayName||D.name,id:D.identifier.value};return this._proxy.$startProgress(E,{location:I.ProgressLocation.from(a),title:i,source:n,cancellable:r},D.isUnderDevelopment?void 0:D.identifier.value).catch(T.onUnexpectedExternalError),this._withProgress(E,p,!!r)}_withProgress(D,u,p){let E;p&&(E=new C.CancellationTokenSource,this._mapHandleToCancellationSource.set(D,E));const i=r=>{this._proxy.$progressEnd(r),this._mapHandleToCancellationSource.delete(r),E?.dispose()};let a;try{a=u(new S(this._proxy,D),p&&E?E.token:C.CancellationToken.None)}catch(r){throw i(D),r}return a.then(r=>i(D),r=>i(D)),a}$acceptProgressCanceled(D){const u=this._mapHandleToCancellationSource.get(D);u&&(u.cancel(),this._mapHandleToCancellationSource.delete(D))}}e.ExtHostProgress=g;function h(R,D){return R.message=D.message,typeof D.increment=="number"&&(typeof R.increment=="number"?R.increment+=D.increment:R.increment=D.increment),R}class S extends L.Progress{constructor(D,u){super(p=>this.throttledReport(p)),this._proxy=D,this._handle=u}throttledReport(D){this._proxy.$progressReport(this._handle,D)}}Ke([(0,A.throttle)(100,(R,D)=>h(R,D),()=>Object.create(null))],S.prototype,"throttledReport",null)}),define(Pe[264],Te([1,0,2,3,13,8]),function(me,e,I,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class T{static{this.handlePool=0}constructor(h,S){this.uriTransformer=S,this.providers=new Map,this.proxy=h.getProxy(L.MainContext.MainThreadQuickDiff)}$provideOriginalResource(h,S,R){const D=I.URI.revive(S),u=this.providers.get(h);return u?(0,C.asPromise)(()=>u.provideOriginalResource(D,R)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider(h,S,R,D){const u=T.handlePool++;return this.providers.set(u,S),this.proxy.$registerQuickDiffProvider(u,A.DocumentSelector.from(h,this.uriTransformer),R,D),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(u),this.providers.delete(u)}}}}e.ExtHostQuickDiff=T}),define(Pe[265],Te([1,0,20,5,6,3,2,7,15,18,32,40,24,8]),function(me,e,I,L,C,A,T,g,h,S,R,D,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function E(i,a,r){const n=i.getProxy(A.MainContext.MainThreadQuickOpen);class o{constructor(w,P){this._sessions=new Map,this._instances=0,this._workspace=w,this._commands=P}showQuickPick(w,P,m,v=I.CancellationToken.None){this._onDidSelectItem=void 0;const y=Promise.resolve(P),O=++this._instances,N=n.$show(O,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},v),q={},W=N.then(()=>q);return Promise.race([W,y]).then(x=>{if(x===q)return;const k=(0,u.isProposedApiEnabled)(w,"quickPickItemTooltip");return y.then(M=>{const $=[];for(let oe=0;oe<M.length;oe++){const de=M[oe];if(typeof de=="string")$.push({label:de,handle:oe});else if(de.kind===g.QuickPickItemKind.Separator)$.push({type:"separator",label:de.label});else{de.tooltip&&!k&&console.warn(`Extension '${w.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`);const we=de.iconPath?s(de.iconPath):void 0;$.push({label:de.label,iconPath:we?.iconPath,iconClass:we?.iconClass,description:de.description,detail:de.detail,picked:de.picked,alwaysShow:de.alwaysShow,tooltip:k?p.MarkdownString.fromStrict(de.tooltip):void 0,handle:oe})}}return m&&typeof m.onDidSelectItem=="function"&&(this._onDidSelectItem=oe=>{m.onDidSelectItem(M[oe])}),n.$setItems(O,$),N.then(oe=>{if(typeof oe=="number")return M[oe];if(Array.isArray(oe))return oe.map(de=>M[de])})})}).then(void 0,x=>{if(!(0,h.isCancellationError)(x))return n.$setError(O,x),Promise.reject(x)})}$onItemSelected(w){this._onDidSelectItem?.(w)}showInput(w,P=I.CancellationToken.None){return this._validateInput=w?.validateInput,n.$input(w,typeof this._validateInput=="function",P).then(void 0,m=>{if(!(0,h.isCancellationError)(m))return Promise.reject(m)})}async $validateInput(w){if(!this._validateInput)return;const P=await this._validateInput(w);if(!P||typeof P=="string")return P;let m;switch(P.severity){case g.InputBoxValidationSeverity.Info:m=R.default.Info;break;case g.InputBoxValidationSeverity.Warning:m=R.default.Warning;break;case g.InputBoxValidationSeverity.Error:m=R.default.Error;break;default:m=P.message?R.default.Error:R.default.Ignore;break}return{content:P.message,severity:m}}async showWorkspaceFolderPick(w,P=I.CancellationToken.None){const m=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[w]);if(!m)return;const v=await this._workspace.getWorkspaceFolders2();if(v)return v.find(y=>y.uri.toString()===m.uri.toString())}createQuickPick(w){const P=new b(w,()=>this._sessions.delete(P._id));return this._sessions.set(P._id,P),P}createInputBox(w){const P=new _(w,()=>this._sessions.delete(P._id));return this._sessions.set(P._id,P),P}$onDidChangeValue(w,P){this._sessions.get(w)?._fireDidChangeValue(P)}$onDidAccept(w){this._sessions.get(w)?._fireDidAccept()}$onDidChangeActive(w,P){const m=this._sessions.get(w);m instanceof b&&m._fireDidChangeActive(P)}$onDidChangeSelection(w,P){const m=this._sessions.get(w);m instanceof b&&m._fireDidChangeSelection(P)}$onDidTriggerButton(w,P){this._sessions.get(w)?._fireDidTriggerButton(P)}$onDidTriggerItemButton(w,P,m){const v=this._sessions.get(w);v instanceof b&&v._fireDidTriggerItemButton(P,m)}$onDidHide(w){this._sessions.get(w)?._fireDidHide()}}class c{static{this._nextId=1}constructor(w,P){this._extensionId=w,this._onDidDispose=P,this._id=b._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new L.Emitter,this._onDidChangeValueEmitter=new L.Emitter,this._onDidTriggerButtonEmitter=new L.Emitter,this._onDidHideEmitter=new L.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(w){this._title=w,this.update({title:w})}get step(){return this._steps}set step(w){this._steps=w,this.update({step:w})}get totalSteps(){return this._totalSteps}set totalSteps(w){this._totalSteps=w,this.update({totalSteps:w})}get enabled(){return this._enabled}set enabled(w){this._enabled=w,this.update({enabled:w})}get busy(){return this._busy}set busy(w){this._busy=w,this.update({busy:w})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(w){this._ignoreFocusOut=w,this.update({ignoreFocusOut:w})}get value(){return this._value}set value(w){this._value=w,this.update({value:w})}get placeholder(){return this._placeholder}set placeholder(w){this._placeholder=w,this.update({placeholder:w})}get buttons(){return this._buttons}set buttons(w){this._buttons=w.slice(),this._handlesToButtons.clear(),w.forEach((P,m)=>{const v=P===g.QuickInputButtons.Back?-1:m;this._handlesToButtons.set(v,P)}),this.update({buttons:w.map((P,m)=>({...s(P.iconPath),tooltip:P.tooltip,handle:P===g.QuickInputButtons.Back?-1:m}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(w){this._value=w,this._onDidChangeValueEmitter.fire(w)}_fireDidTriggerButton(w){const P=this._handlesToButtons.get(w);P&&this._onDidTriggerButtonEmitter.fire(P)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),n.$dispose(this._id))}update(w){if(!this._disposed){for(const P of Object.keys(w)){const m=w[P];this._pendingUpdate[P]=m===void 0?null:m}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){n.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function l(f){if(f instanceof g.ThemeIcon)return{id:f.id};const w=d(f),P=t(f);return{dark:typeof w=="string"?T.URI.file(w):w,light:typeof P=="string"?T.URI.file(P):P}}function t(f){return typeof f=="object"&&"light"in f?f.light:f}function d(f){return typeof f=="object"&&"dark"in f?f.dark:f}function s(f){const w=l(f);let P,m;return"id"in w?m=D.ThemeIcon.asClassName(w):P=w,{iconPath:P,iconClass:m}}class b extends c{constructor(w,P){super(w.identifier,P),this.extension=w,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new L.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new L.Emitter,this._onDidTriggerItemButtonEmitter=new L.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(w){this._items=w.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),w.forEach((v,y)=>{this._handlesToItems.set(y,v),this._itemsToHandles.set(v,y)});const P=(0,u.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),m=[];for(let v=0;v<w.length;v++){const y=w[v];if(y.kind===g.QuickPickItemKind.Separator)m.push({type:"separator",label:y.label});else{y.tooltip&&!P&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`);const O=y.iconPath?s(y.iconPath):void 0;m.push({handle:v,label:y.label,iconPath:O?.iconPath,iconClass:O?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:P?p.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((N,q)=>({...s(N.iconPath),tooltip:N.tooltip,handle:q}))})}}this.update({items:m})}get canSelectMany(){return this._canSelectMany}set canSelectMany(w){this._canSelectMany=w,this.update({canSelectMany:w})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(w){this._matchOnDescription=w,this.update({matchOnDescription:w})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(w){this._matchOnDetail=w,this.update({matchOnDetail:w})}get sortByLabel(){return this._sortByLabel}set sortByLabel(w){this._sortByLabel=w,this.update({sortByLabel:w})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(w){this._keepScrollPosition=w,this.update({keepScrollPosition:w})}get activeItems(){return this._activeItems}set activeItems(w){this._activeItems=w.filter(P=>this._itemsToHandles.has(P)),this.update({activeItems:this._activeItems.map(P=>this._itemsToHandles.get(P))})}get selectedItems(){return this._selectedItems}set selectedItems(w){this._selectedItems=w.filter(P=>this._itemsToHandles.has(P)),this.update({selectedItems:this._selectedItems.map(P=>this._itemsToHandles.get(P))})}_fireDidChangeActive(w){const P=(0,S.coalesce)(w.map(m=>this._handlesToItems.get(m)));this._activeItems=P,this._onDidChangeActiveEmitter.fire(P)}_fireDidChangeSelection(w){const P=(0,S.coalesce)(w.map(m=>this._handlesToItems.get(m)));this._selectedItems=P,this._onDidChangeSelectionEmitter.fire(P)}_fireDidTriggerItemButton(w,P){const m=this._handlesToItems.get(w);if(!m||!m.buttons||!m.buttons.length)return;const v=m.buttons[P];v&&this._onDidTriggerItemButtonEmitter.fire({button:v,item:m})}}class _ extends c{constructor(w,P){super(w.identifier,P),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(w){this._password=w,this.update({password:w})}get prompt(){return this._prompt}set prompt(w){this._prompt=w,this.update({prompt:w})}get valueSelection(){return this._valueSelection}set valueSelection(w){this._valueSelection=w,this.update({valueSelection:w})}get validationMessage(){return this._validationMessage}set validationMessage(w){this._validationMessage=w,w?typeof w=="string"?this.update({validationMessage:w,severity:R.default.Error}):this.update({validationMessage:w.message,severity:w.severity??R.default.Error}):this.update({validationMessage:void 0,severity:R.default.Ignore})}}return new o(a,r)}e.createExtHostQuickOpen=E}),define(Pe[266],Te([1,0,2,5,67,6,13,3,18,138,14,22,40,8,24,11,21]),function(me,e,I,L,C,A,T,g,h,S,R,D,u,p,E,i,a){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function n(O){return O instanceof I.URI}function o(O,N){return O.scheme===i.Schemas.file&&N.scheme===i.Schemas.file&&a.isLinux?O.toString()===N.toString():O.toString().toLowerCase()===N.toString().toLowerCase()}function c(O){if(O)return typeof O.iconPath=="string"?I.URI.file(O.iconPath):I.URI.isUri(O.iconPath)||u.ThemeIcon.isThemeIcon(O.iconPath)?O.iconPath:void 0}function l(O){if(O.icon){if(I.URI.isUri(O.icon))return O.icon;if(u.ThemeIcon.isThemeIcon(O.icon))return O.icon;{const N=O.icon;return{light:N.light,dark:N.dark}}}else return}function t(O,N){if(!O.iconPath&&!N.iconPath)return 0;if(O.iconPath){if(!N.iconPath)return 1}else return-1;const q=typeof O.iconPath=="string"?O.iconPath:I.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id,W=typeof N.iconPath=="string"?N.iconPath:I.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id;return(0,S.comparePaths)(q,W)}function d(O,N){let q=0;if(O.strikeThrough!==N.strikeThrough)return O.strikeThrough?1:-1;if(O.faded!==N.faded)return O.faded?1:-1;if(O.tooltip!==N.tooltip)return(O.tooltip||"").localeCompare(N.tooltip||"");if(q=t(O,N),q!==0)return q;if(O.light&&N.light)q=t(O.light,N.light);else{if(O.light)return 1;if(N.light)return-1}if(q!==0)return q;if(O.dark&&N.dark)q=t(O.dark,N.dark);else{if(O.dark)return 1;if(N.dark)return-1}return q}function s(O,N){if(O.command!==N.command)return O.command<N.command?-1:1;if(O.title!==N.title)return O.title<N.title?-1:1;if(O.tooltip!==N.tooltip){if(O.tooltip!==void 0&&N.tooltip!==void 0)return O.tooltip<N.tooltip?-1:1;if(O.tooltip!==void 0)return 1;if(N.tooltip!==void 0)return-1}if(O.arguments===N.arguments)return 0;if(O.arguments)if(N.arguments){if(O.arguments.length!==N.arguments.length)return O.arguments.length-N.arguments.length}else return 1;else return-1;for(let q=0;q<O.arguments.length;q++){const W=O.arguments[q],x=N.arguments[q];if(W!==x&&!(n(W)&&n(x)&&o(W,x)))return W<x?-1:1}return 0}function b(O,N){let q=(0,S.comparePaths)(O.resourceUri.fsPath,N.resourceUri.fsPath,!0);if(q!==0)return q;if(O.command&&N.command)q=s(O.command,N.command);else{if(O.command)return 1;if(N.command)return-1}if(q!==0)return q;if(O.decorations&&N.decorations)q=d(O.decorations,N.decorations);else{if(O.decorations)return 1;if(N.decorations)return-1}if(O.multiFileDiffEditorModifiedUri&&N.multiFileDiffEditorModifiedUri)q=(0,S.comparePaths)(O.multiFileDiffEditorModifiedUri.fsPath,N.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(O.multiFileDiffEditorModifiedUri)return 1;if(N.multiFileDiffEditorModifiedUri)return-1}if(O.multiDiffEditorOriginalUri&&N.multiDiffEditorOriginalUri)q=(0,S.comparePaths)(O.multiDiffEditorOriginalUri.fsPath,N.multiDiffEditorOriginalUri.fsPath,!0);else{if(O.multiDiffEditorOriginalUri)return 1;if(N.multiDiffEditorOriginalUri)return-1}return q}function _(O,N){for(let q=0;q<O.length;q++)if(O[q]!==N[q])return!1;return!0}function f(O,N){return O.command===N.command&&O.title===N.title&&O.tooltip===N.tooltip&&(O.arguments&&N.arguments?_(O.arguments,N.arguments):O.arguments===N.arguments)}function w(O,N){return(0,h.equals)(O,N,f)}class P{#e;#t;get value(){return this._value}set value(N){N=N??"",this.#e.$setInputBoxValue(this._sourceControlHandle,N),this.updateValue(N)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(N){this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,N),this._placeholder=N}get validateInput(){return(0,E.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(N){if((0,E.checkProposedApiEnabled)(this._extension,"scmValidation"),N&&typeof N!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=N,this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!N)}get enabled(){return this._enabled}set enabled(N){N=!!N,this._enabled!==N&&(this._enabled=N,this.#e.$setInputBoxEnablement(this._sourceControlHandle,N))}get visible(){return this._visible}set visible(N){N=!!N,this._visible!==N&&(this._visible=N,this.#e.$setInputBoxVisibility(this._sourceControlHandle,N))}get document(){return(0,E.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(N,q,W,x,k){this._extension=N,this._sourceControlHandle=x,this._documentUri=k,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this.#t=q,this.#e=W}showValidationMessage(N,q){(0,E.checkProposedApiEnabled)(this._extension,"scmValidation"),this.#e.$showValidationMessage(this._sourceControlHandle,N,q)}$onInputBoxValueChange(N){this.updateValue(N)}updateValue(N){this._value=N,this._onDidChange.fire(N)}}e.ExtHostSCMInputBox=P;class m{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(N){this._label=N,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,N)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(N){this._hideWhenEmpty=N,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(N){this._resourceStates=[...N],this._onDidUpdateResourceStates.fire()}constructor(N,q,W,x,k,M,$){this._proxy=N,this._commands=q,this._sourceControlHandle=W,this._id=x,this._label=k,this.multiDiffEditorEnableViewChanges=M,this._extension=$,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=m._handlePool++}getResourceState(N){return this._resourceStatesMap.get(N)}$executeResourceCommand(N,q){const W=this._resourceStatesCommandsMap.get(N);return W?(0,T.asPromise)(()=>this._commands.executeCommand(W.command,...W.arguments||[],q)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const N=[...this._resourceStates].sort(b),W=(0,h.sortedDiff)(this._resourceSnapshot,N,b).map(M=>{const $=M.toInsert.map(oe=>{const de=this._resourceHandlePool++;this._resourceStatesMap.set(de,oe);const we=oe.resourceUri;let ye;if(oe.command)if(oe.command.command==="vscode.open"||oe.command.command==="vscode.diff"||oe.command.command==="vscode.changes"){const te=new A.DisposableStore;ye=this._commands.converter.toInternal(oe.command,te),this._resourceStatesDisposablesMap.set(de,te)}else this._resourceStatesCommandsMap.set(de,oe.command);const le=(0,E.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor"),ve=le?oe.multiDiffEditorOriginalUri:void 0,ae=le?oe.multiFileDiffEditorModifiedUri:void 0,pe=c(oe.decorations),re=oe.decorations&&c(oe.decorations.light)||pe,J=oe.decorations&&c(oe.decorations.dark)||pe,H=[re,J],ne=oe.decorations&&oe.decorations.tooltip||"",Ae=oe.decorations&&!!oe.decorations.strikeThrough,Re=oe.decorations&&!!oe.decorations.faded,ke=oe.contextValue||"";return{rawResource:[de,we,H,ne,Ae,Re,ke,ye,ve,ae],handle:de}});return{start:M.start,deleteCount:M.deleteCount,toInsert:$}}),x=W.map(({start:M,deleteCount:$,toInsert:oe})=>[M,$,oe.map(de=>de.rawResource)]),k=W.reverse();for(const{start:M,deleteCount:$,toInsert:oe}of k){const de=oe.map(ye=>ye.handle),we=this._handlesSnapshot.splice(M,$,...de);for(const ye of we)this._resourceStatesMap.delete(ye),this._resourceStatesCommandsMap.delete(ye),this._resourceStatesDisposablesMap.get(ye)?.dispose(),this._resourceStatesDisposablesMap.delete(ye)}return this._resourceSnapshot=N,x}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class v{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(N){this._count!==N&&(this._count=N,this.#e.$updateSourceControl(this.handle,{count:N}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(N){this._quickDiffProvider=N;let q;(0,E.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(q=N?.label),this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!N,quickDiffLabel:q})}get historyProvider(){return(0,E.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider}set historyProvider(N){(0,E.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider=N,this._historyProviderDisposable.value=new A.DisposableStore,this.#e.$updateSourceControl(this.handle,{hasHistoryProvider:!!N}),N&&this._historyProviderDisposable.value.add(N.onDidChangeCurrentHistoryItemGroup(()=>{this._historyProviderCurrentHistoryItemGroup=N?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.handle,this._historyProviderCurrentHistoryItemGroup)}))}get commitTemplate(){return this._commitTemplate}set commitTemplate(N){N!==this._commitTemplate&&(this._commitTemplate=N,this.#e.$updateSourceControl(this.handle,{commitTemplate:N}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(N){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=N;const q=this._commands.converter.toInternal(N,this._acceptInputDisposables.value);this.#e.$updateSourceControl(this.handle,{acceptInputCommand:q})}get actionButton(){return(0,E.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(N){(0,E.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=N;const q=N!==void 0?{command:this._commands.converter.toInternal(N.command,this._actionButtonDisposables.value),secondaryCommands:N.secondaryCommands?.map(W=>W.map(x=>this._commands.converter.toInternal(x,this._actionButtonDisposables.value))),description:N.description,enabled:N.enabled}:void 0;this.#e.$updateSourceControl(this.handle,{actionButton:q??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(N){if(this._statusBarCommands&&N&&w(this._statusBarCommands,N))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=N;const q=(N||[]).map(W=>this._commands.converter.toInternal(W,this._statusBarDisposables.value));this.#e.$updateSourceControl(this.handle,{statusBarCommands:q})}get selected(){return this._selected}constructor(N,q,W,x,k,M,$){this._extension=N,this._commands=x,this._id=k,this._label=M,this._rootUri=$,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._historyProviderDisposable=new A.MutableDisposable,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=v._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=W;const oe=I.URI.from({scheme:i.Schemas.vscodeSourceControl,path:`${k}/scm${this.handle}/input`,query:$?`rootUri=${encodeURIComponent($.toString())}`:void 0});this._inputBox=new P(N,q,this.#e,this.handle,oe),this.#e.$registerSourceControl(this.handle,k,M,$,oe)}createResourceGroup(N,q,W){const x=(0,E.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor")&&W?.multiDiffEditorEnableViewChanges===!0,k=new m(this.#e,this._commands,this.handle,N,q,x,this._extension),M=L.Event.once(k.onDidDispose)(()=>this.createdResourceGroups.delete(k));return this.createdResourceGroups.set(k,M),this.eventuallyAddResourceGroups(),k}eventuallyAddResourceGroups(){const N=[],q=[];for(const[W,x]of this.createdResourceGroups){x.dispose();const k=W.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(W),this.eventuallyUpdateResourceStates()});L.Event.once(W.onDidDispose)(()=>{this.updatedResourceGroups.delete(W),k.dispose(),this._groups.delete(W.handle),this.#e.$unregisterGroup(this.handle,W.handle)}),N.push([W.handle,W.id,W.label,W.features,W.multiDiffEditorEnableViewChanges]);const M=W._takeResourceStateSnapshot();M.length>0&&q.push([W.handle,M]),this._groups.set(W.handle,W)}this.#e.$registerGroups(this.handle,N,q),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const N=[];this.updatedResourceGroups.forEach(q=>{const W=q._takeResourceStateSnapshot();W.length!==0&&N.push([q.handle,W])}),N.length>0&&this.#e.$spliceResourceStates(this.handle,N),this.updatedResourceGroups.clear()}getResourceGroup(N){return this._groups.get(N)}setSelectionState(N){this._selected=N,this._onDidChangeSelection.fire(N)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(N=>N.dispose()),this.#e.$unregisterSourceControl(this.handle)}}Ke([(0,C.debounce)(100)],v.prototype,"eventuallyAddResourceGroups",null),Ke([(0,C.debounce)(100)],v.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{r=this}static{this._handlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(N,q,W,x){this._commands=q,this._extHostDocuments=W,this.logService=x,this._sourceControls=new Map,this._sourceControlsByExtension=new D.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=N.getProxy(g.MainContext.MainThreadSCM),this._telemetry=N.getProxy(g.MainContext.MainThreadTelemetry),q.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===3){const M=this._sourceControls.get(k.sourceControlHandle);if(!M)return k;const $=M.getResourceGroup(k.groupHandle);return $?$.getResourceState(k.handle):k}else if(k&&k.$mid===4){const M=this._sourceControls.get(k.sourceControlHandle);return M?M.getResourceGroup(k.groupHandle):k}else if(k&&k.$mid===5){const M=this._sourceControls.get(k.handle);return M||k}return k}})}createSourceControl(N,q,W,x){this.logService.trace("ExtHostSCM#createSourceControl",N.identifier.value,q,W,x),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:N.identifier.value});const k=r._handlePool++,M=new v(N,this._extHostDocuments,this._proxy,this._commands,q,W,x);this._sourceControls.set(k,M);const $=this._sourceControlsByExtension.get(N.identifier)||[];return $.push(M),this._sourceControlsByExtension.set(N.identifier,$),M}getLastInputBox(N){this.logService.trace("ExtHostSCM#getLastInputBox",N.identifier.value);const q=this._sourceControlsByExtension.get(N.identifier),W=q&&q[q.length-1];return W&&W.inputBox}$provideOriginalResource(N,q,W){const x=I.URI.revive(q);this.logService.trace("ExtHostSCM#$provideOriginalResource",N,x.toString());const k=this._sourceControls.get(N);return!k||!k.quickDiffProvider||!k.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>k.quickDiffProvider.provideOriginalResource(x,W)).then(M=>M||null)}$onInputBoxValueChange(N,q){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",N);const W=this._sourceControls.get(N);return W&&W.inputBox.$onInputBoxValueChange(q),Promise.resolve(void 0)}$executeResourceCommand(N,q,W,x){this.logService.trace("ExtHostSCM#$executeResourceCommand",N,q,W);const k=this._sourceControls.get(N);if(!k)return Promise.resolve(void 0);const M=k.getResourceGroup(q);return M?M.$executeResourceCommand(W,x):Promise.resolve(void 0)}$validateInput(N,q,W){this.logService.trace("ExtHostSCM#$validateInput",N);const x=this._sourceControls.get(N);return!x||!x.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>x.inputBox.validateInput(q,W)).then(k=>{if(!k)return Promise.resolve(void 0);const M=p.MarkdownString.fromStrict(k.message);return M?Promise.resolve([M,k.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(N){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",N),N!==void 0&&this._sourceControls.get(N)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=N,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(N,q,W,x){return await this._sourceControls.get(N)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(q,W,x)??void 0}async $provideHistoryItems(N,q,W,x){return(await this._sourceControls.get(N)?.historyProvider?.provideHistoryItems(q,W,x))?.map($=>({...$,icon:l($)}))??void 0}async $provideHistoryItemSummary(N,q,W,x){const k=this._sourceControls.get(N)?.historyProvider;if(typeof k?.provideHistoryItemSummary!="function")return;const M=await k.provideHistoryItemSummary(q,W,x);return M?{...M,icon:l(M)}:void 0}async $provideHistoryItemChanges(N,q,W,x){return await this._sourceControls.get(N)?.historyProvider?.provideHistoryItemChanges(q,W,x)??void 0}};e.ExtHostSCM=y,e.ExtHostSCM=y=r=Ke([We(3,R.ILogService)],y)}),define(Pe[267],Te([1,0,3,8,2]),function(me,e,I,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class A{static{this.handlePool=0}constructor(g,h){this.uriTransformer=h,this.providers=new Map,this.proxy=g.getProxy(I.MainContext.MainThreadShare)}async $provideShare(g,h,S){return await this.providers.get(g)?.provideShare({selection:L.Range.to(h.selection),resourceUri:C.URI.revive(h.resourceUri)},S)??void 0}registerShareProvider(g,h){const S=A.handlePool++;return this.providers.set(S,h),this.proxy.$registerShareProvider(S,L.DocumentSelector.from(g,this.uriTransformer),h.id,h.label,h.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(S),this.providers.delete(S)}}}}e.ExtHostShare=A}),define(Pe[268],Te([1,0,7,3,163,6,8,16]),function(me,e,I,L,C,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class h{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new I.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(u,p,E,i,a,r=I.StatusBarAlignment.Left,n){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new A.DisposableStore,this.#e=u,this.#t=p,a&&i){this._entryId=(0,I.asStatusBarItemIdentifier)(i.identifier,a);const o=E.get(this._entryId);o&&(r=o.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,n=o.priority,this._visible=!0,this.name=o.name,this.text=o.text,this.tooltip=o.tooltip,this.command=o.command,this.accessibilityInformation=o.accessibilityInformation)}else this._entryId=String(h.ID_GEN++);this._extension=i,this._id=a,this._alignment=r,this._priority=this.validatePriority(n)}validatePriority(u){if((0,g.isNumber)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(u){this._text=u,this.update()}set name(u){this._name=u,this.update()}set tooltip(u){this._tooltip=u,this.update()}set color(u){this._color=u,this.update()}set backgroundColor(u){u&&!h.ALLOWED_BACKGROUND_COLORS.has(u.id)&&(u=void 0),this._backgroundColor=u,this.update()}set command(u){this._command?.fromApi!==u&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new A.DisposableStore,typeof u=="string"?this._command={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this._latestCommandRegistration)}:u?this._command={fromApi:u,internal:this.#t.toInternal(u,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(u){this._accessibilityInformation=u,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let u;this._extension?this._id?u=`${this._extension.identifier.value}.${this._id}`:u=this._extension.identifier.value:u=this._id;let p;this._name?p=this._name:p=(0,C.localize)(0,null,this._extension.displayName||this._extension.name);let E=this._color;this._backgroundColor&&(E=h.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const i=T.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,u,this._extension?.identifier.value,p,this._text,i,this._command?.internal,E,this._backgroundColor,this._alignment===I.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=h;class S{constructor(u){this._messages=[],this._item=u.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,C.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(u){const p={message:u};return this._messages.unshift(p),this._update(),new I.Disposable(()=>{const E=this._messages.indexOf(p);E>=0&&(this._messages.splice(E,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class R{constructor(u,p){this._existingItems=new Map,this._proxy=u.getProxy(L.MainContext.MainThreadStatusBar),this._commands=p,this._statusMessage=new S(this)}$acceptStaticEntries(u){for(const p of u)this._existingItems.set(p.entryId,p)}createStatusBarEntry(u,p,E,i){return new h(this._proxy,this._commands,this._existingItems,u,p,E,i)}setStatusBarMessage(u,p){const E=this._statusMessage.setMessage(u);let i;return typeof p=="number"?i=setTimeout(()=>E.dispose(),p):typeof p<"u"&&p.then(()=>E.dispose(),()=>E.dispose()),new I.Disposable(()=>{E.dispose(),clearTimeout(i)})}}e.ExtHostStatusBar=R}),define(Pe[110],Te([1,0,29,103,48,76,59,8,2]),function(me,e,I,L,C,A,T,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const S=(o,c,l,t)=>{let d=c;return{enumerable:!0,configurable:!1,get(){return d},set(s){if(!l(d,s)){const b=d;d=s,o.listener?.(t(s,b))}}}},R=(o,c)=>o===c,D={range:(o,c)=>o===c?!0:!o||!c?!1:o.isEqual(c),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(o,c)=>!(o.length!==c.length||o.some(l=>!c.find(t=>l.id===t.id)))},u=o=>c=>({op:4,update:o(c)}),p=(o,c)=>({range:(()=>{let l;const t=u(d=>({range:I.Range.lift(g.Range.from(d))}));return{enumerable:!0,configurable:!1,get(){return l},set(d){o.listener?.({op:6}),D.range(l,d)||(l=d,o.listener?.(t(d)))}}})(),label:S(o,c,D.label,u(l=>({label:l}))),description:S(o,void 0,D.description,u(l=>({description:l}))),sortText:S(o,void 0,D.sortText,u(l=>({sortText:l}))),canResolveChildren:S(o,!1,D.canResolveChildren,l=>({op:2,state:l})),busy:S(o,!1,D.busy,u(l=>({busy:l}))),error:S(o,void 0,D.error,u(l=>({error:g.MarkdownString.fromStrict(l)||null}))),tags:S(o,[],D.tags,(l,t)=>({op:1,new:l.map(g.TestTag.from),old:t.map(g.TestTag.from)}))}),E=o=>{const c=C.TestId.fromString(o.extId),l=new a(c.controllerId,c.localId,o.label,h.URI.revive(o.uri)||void 0);return l.range=g.Range.to(o.range||void 0),l.description=o.description||void 0,l.sortText=o.sortText||void 0,l.tags=o.tags.map(t=>g.TestTag.to({id:(0,T.denamespaceTestTag)(t).tagId})),l},i=o=>{let c;for(const l of o.tests){const t=E(l.item);(0,L.getPrivateApiFor)(t).parent=c,c=t}return c};e.toItemFromContext=i;class a{constructor(c,l,t,d){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const s=(0,L.createPrivateApiFor)(this,c);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof r?void 0:s.parent}},children:{value:(0,A.createTestItemChildren)(s,L.getPrivateApiFor,a),enumerable:!0,writable:!1},...p(s,t)})}}e.TestItemImpl=a;class r extends a{constructor(c,l){super(c,c,l,void 0),this._isRoot=!0}}e.TestItemRootImpl=r;class n extends A.TestItemCollection{constructor(c,l,t){super({controllerId:c,getDocumentVersion:d=>d&&t.getDocument(d)?.version,getApiFor:L.getPrivateApiFor,getChildren:d=>d.children,root:new r(c,l),toITestItem:g.TestItem.from})}}e.ExtHostTestItemCollection=n}),define(Pe[31],Te([1,0,16,7,8,26,3,18,14,51,29,92,2,6,4,17,110,23,49,41,63,57,60,33]),function(me,e,I,L,C,A,T,g,h,S,R,D,u,p,E,i,a,r,n,o,c,l,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let s=class{#e;#t;#i;constructor(m,v,y){this._commands=new Map,this._apiCommands=new Map,this.#e=m.getProxy(T.MainContext.MainThreadCommands),this._logService=v,this.#i=y,this.#t=m.getProxy(T.MainContext.MainThreadTelemetry),this.converter=new b(this,O=>{const N=this._apiCommands.get(O);return N?.result===f.Void?N:void 0},v),this._argumentProcessors=[{processArgument(O){return(0,S.revive)(O)}},{processArgument(O){return(0,A.cloneAndChange)(O,function(N){if(R.Range.isIRange(N))return C.Range.to(N);if(D.Position.isIPosition(N))return C.Position.to(N);if(R.Range.isIRange(N.range)&&u.URI.isUri(N.uri))return C.location.to(N);if(N instanceof r.VSBuffer)return N.buffer.buffer;if(!Array.isArray(N))return N})}}]}registerArgumentProcessor(m){this._argumentProcessors.push(m)}registerApiCommand(m){const v=this.registerCommand(!1,m.id,async(...y)=>{const O=m.args.map((q,W)=>{if(!q.validate(y[W]))throw new Error(`Invalid argument '${q.name}' when running '${m.id}', received: ${typeof y[W]=="object"?JSON.stringify(y[W],null,"	"):y[W]} `);return q.convert(y[W])}),N=await this.executeCommand(m.internalId,...O);return m.result.convert(N,y,this.converter)},void 0,{description:m.description,args:m.args,returns:m.result.description});return this._apiCommands.set(m.id,m),new L.Disposable(()=>{v.dispose(),this._apiCommands.delete(m.id)})}registerCommand(m,v,y,O,N,q){if(this._logService.trace("ExtHostCommands#registerCommand",v),!v.trim().length)throw new Error("invalid id");if(this._commands.has(v))throw new Error(`command '${v}' already exists`);return this._commands.set(v,{callback:y,thisArg:O,metadata:N,extension:q}),m&&this.#e.$registerCommand(v),new L.Disposable(()=>{this._commands.delete(v)&&m&&this.#e.$unregisterCommand(v)})}executeCommand(m,...v){return this._logService.trace("ExtHostCommands#executeCommand",m),this._doExecuteCommand(m,v,!0)}async _doExecuteCommand(m,v,y){if(this._commands.has(m))return this.#e.$fireCommandActivationEvent(m),this._executeContributedCommand(m,v,!1);{let O=!1;const N=(0,A.cloneAndChange)(v,function(q){if(q instanceof L.Position)return C.Position.from(q);if(q instanceof L.Range)return C.Range.from(q);if(q instanceof L.Location)return C.location.from(q);if(L.NotebookRange.isNotebookRange(q))return C.NotebookRange.from(q);if(q instanceof ArrayBuffer)return O=!0,r.VSBuffer.wrap(new Uint8Array(q));if(q instanceof Uint8Array)return O=!0,r.VSBuffer.wrap(q);if(q instanceof r.VSBuffer)return O=!0,q;if(!Array.isArray(q))return q});try{const q=await this.#e.$executeCommand(m,O?new n.SerializableObjectWithBuffers(N):N,y);return(0,S.revive)(q)}catch(q){if(q instanceof Error&&q.message==="$executeCommand:retry")return this._doExecuteCommand(m,v,!1);throw q}}}async _executeContributedCommand(m,v,y){const O=this._commands.get(m);if(!O)throw new Error("Unknown command");const{callback:N,thisArg:q,metadata:W}=O;if(W?.args)for(let k=0;k<W.args.length;k++)try{(0,I.validateConstraint)(v[k],W.args[k].constraint)}catch{throw new Error(`Running the contributed command: '${m}' failed. Illegal argument '${W.args[k].name}' - ${W.args[k].description}`)}const x=c.StopWatch.create();try{return await N.apply(q,v)}catch(k){if(m===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(...v);M&&(m=M.command)}if(this._logService.error(k,m,O.extension?.identifier),!y)throw k;if(O.extension?.identifier){const M=this.#i.onExtensionError(O.extension.identifier,k);this._logService.trace("forwarded error to extension?",M,O.extension?.identifier)}throw new class extends Error{constructor(){super((0,o.toErrorMessage)(k)),this.id=m,this.source=O.extension?.displayName??O.extension?.name}}}finally{this._reportTelemetry(O,m,x.elapsed())}}_reportTelemetry(m,v,y){m.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:m.extension.identifier.value,id:new l.TelemetryTrustedValue(v),duration:y})}$executeContributedCommand(m,...v){this._logService.trace("ExtHostCommands#$executeContributedCommand",m);const y=this._commands.get(m);return y?(v=v.map(O=>this._argumentProcessors.reduce((N,q)=>q.processArgument(N,y.extension?.identifier),O)),this._executeContributedCommand(m,v,!0)):Promise.reject(new Error(`Contributed command '${m}' does not exist.`))}getCommands(m=!1){return this._logService.trace("ExtHostCommands#getCommands",m),this.#e.$getCommands().then(v=>(m&&(v=v.filter(y=>y[0]!=="_")),v))}$getContributedCommandMetadata(){const m=Object.create(null);for(const[v,y]of this._commands){const{metadata:O}=y;O&&(m[v]=O)}return Promise.resolve(m)}};e.ExtHostCommands=s,e.ExtHostCommands=s=Ke([We(0,i.IExtHostRpcService),We(1,h.ILogService),We(2,t.IExtHostTelemetry)],s),e.IExtHostCommands=(0,E.createDecorator)("IExtHostCommands");class b{constructor(m,v,y){this._commands=m,this._lookupApiCommand=v,this._logService=y,this.delegatingCommandId=`__vsc${(0,d.generateUuid)()}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(m,v){if(!m)return;const y={$ident:void 0,id:m.command,title:m.title,tooltip:m.tooltip};if(!m.command)return y;const O=this._lookupApiCommand(m.command);if(O)y.id=O.internalId,y.arguments=O.args.map((N,q)=>N.convert(m.arguments&&m.arguments[q]));else if((0,g.isNonEmptyArray)(m.arguments)){const N=`${m.command} /${++this._cachIdPool}`;this._cache.set(N,m),v.add((0,p.toDisposable)(()=>{this._cache.delete(N),this._logService.trace("CommandsConverter#DISPOSE",N)})),y.$ident=N,y.id=this.delegatingCommandId,y.arguments=[N],this._logService.trace("CommandsConverter#CREATE",m.command,N)}return y}fromInternal(m){return typeof m.$ident=="string"?this._cache.get(m.$ident):{command:m.id,title:m.title,arguments:m.arguments}}getActualCommand(...m){return this._cache.get(m[0])}_executeConvertedCommand(...m){const v=this.getActualCommand(...m);return this._logService.trace("CommandsConverter#EXECUTE",m[0],v?v.command:"MISSING"),v?this._commands.executeCommand(v.command,...v.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${m[0]}`)}}e.CommandsConverter=b;class _{static{this.Uri=new _("uri","Uri of a text document",m=>u.URI.isUri(m),m=>m)}static{this.Position=new _("position","A position in a text document",m=>L.Position.isPosition(m),C.Position.from)}static{this.Range=new _("range","A range in a text document",m=>L.Range.isRange(m),C.Range.from)}static{this.Selection=new _("selection","A selection in a text document",m=>L.Selection.isSelection(m),C.Selection.from)}static{this.Number=new _("number","",m=>typeof m=="number",m=>m)}static{this.String=new _("string","",m=>typeof m=="string",m=>m)}static{this.StringArray=_.Arr(_.String)}static Arr(m){return new _(`${m.name}_array`,`Array of ${m.name}, ${m.description}`,v=>Array.isArray(v)&&v.every(y=>m.validate(y)),v=>v.map(y=>m.convert(y)))}static{this.CallHierarchyItem=new _("item","A call hierarchy item",m=>m instanceof L.CallHierarchyItem,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new _("item","A type hierarchy item",m=>m instanceof L.TypeHierarchyItem,C.TypeHierarchyItem.from)}static{this.TestItem=new _("testItem","A VSCodium TestItem",m=>m instanceof a.TestItemImpl,C.TestItem.from)}constructor(m,v,y,O){this.name=m,this.description=v,this.validate=y,this.convert=O}optional(){return new _(this.name,`(optional) ${this.description}`,m=>m==null||this.validate(m),m=>m===void 0?void 0:m===null?null:this.convert(m))}with(m,v){return new _(m??this.name,v??this.description,this.validate,this.convert)}}e.ApiCommandArgument=_;class f{static{this.Void=new f("no result",m=>m)}constructor(m,v){this.description=m,this.convert=v}}e.ApiCommandResult=f;class w{constructor(m,v,y,O,N){this.id=m,this.internalId=v,this.description=y,this.args=O,this.result=N}}e.ApiCommand=w}),define(Pe[269],Te([1,0,18,11,2,87,96,35,31,8,7]),function(me,e,I,L,C,A,T,g,h,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new h.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",p(S.DocumentHighlight.to))),new h.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(i,a)=>{if((0,I.isFalsyOrEmpty)(i))return;class r extends R.SymbolInformation{static to(o){const c=new r(o.name,S.SymbolKind.to(o.kind),o.containerName||"",new R.Location(a[0],S.Range.to(o.range)));return c.detail=o.detail,c.range=c.location.range,c.selectionRange=S.Range.to(o.selectionRange),c.children=o.children?o.children.map(r.to):[],c}}return i.map(r.to)})),new h.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[h.ApiCommandArgument.Uri,new h.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new h.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(S.TextEdit.to))),new h.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range,new h.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new h.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(S.TextEdit.to))),new h.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,new h.ApiCommandArgument("ch","Trigger character",i=>typeof i=="string",i=>i),new h.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new h.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(S.TextEdit.to))),new h.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new h.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new h.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new h.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new h.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location-instances.",p(S.location.to))),new h.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Hover-instances.",p(S.Hover.to))),new h.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[h.ApiCommandArgument.Uri,new h.ApiCommandArgument("position","A position in a text document",i=>Array.isArray(i)&&i.every(a=>R.Position.isPosition(a)),i=>i.map(S.Position.from))],new h.ApiCommandResult("A promise that resolves to an array of ranges.",i=>i.map(a=>{let r;for(const n of a.reverse())r=new R.SelectionRange(S.Range.to(n),r);return r}))),new h.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[h.ApiCommandArgument.String.with("query","Search string")],new h.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",i=>i.map(S.WorkspaceSymbol.to))),new h.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",i=>i.map(S.CallHierarchyItem.to))),new h.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[h.ApiCommandArgument.CallHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",i=>i.map(S.CallHierarchyIncomingCall.to))),new h.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[h.ApiCommandArgument.CallHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",i=>i.map(S.CallHierarchyOutgoingCall.to))),new h.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to a range and placeholder text.",i=>{if(i)return{range:S.Range.to(i.range),placeholder:i.text}})),new h.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,h.ApiCommandArgument.String.with("newName","The new symbol name")],new h.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",i=>{if(i){if(i.rejectReason)throw new Error(i.rejectReason);return S.WorkspaceEdit.to(i)}})),new h.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new h.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",i=>i.map(S.DocumentLink.to))),new h.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(i)return new R.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new h.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const a=(0,T.decodeSemanticTokensDto)(i);if(a.type==="full")return new R.SemanticTokens(a.data,void 0)})),new h.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range.optional()],new h.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(i)return new R.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new h.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range],new h.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const a=(0,T.decodeSemanticTokensDto)(i);if(a.type==="full")return new R.SemanticTokens(a.data,void 0)})),new h.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,h.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),h.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new h.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(i,a,r)=>{if(!i)return new R.CompletionList([]);const n=i.suggestions.map(o=>S.CompletionItem.to(o,r));return new R.CompletionList(n,i.incomplete)})),new h.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,h.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new h.ApiCommandResult("A promise that resolves to SignatureHelp.",i=>{if(i)return S.SignatureHelp.to(i)})),new h.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new h.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(i,a,r)=>p(n=>new R.CodeLens(S.Range.to(n.range),n.command&&r.fromInternal(n.command)))(i))),new h.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[h.ApiCommandArgument.Uri,new h.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",i=>R.Range.isRange(i),i=>R.Selection.isSelection(i)?S.Selection.from(i):S.Range.from(i)),h.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),h.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new h.ApiCommandResult("A promise that resolves to an array of Command-instances.",(i,a,r)=>p(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return r.fromInternal(n.command)}else{const o=new R.CodeAction(n.title,n.kind?new R.CodeActionKind(n.kind):void 0);return n.edit&&(o.edit=S.WorkspaceEdit.to(n.edit)),n.command&&(o.command=r.fromInternal(n.command)),o.isPreferred=n.isPreferred,o}})(i))),new h.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",i=>i?i.map(a=>new R.ColorInformation(S.Range.to(a.range),S.Color.to(a.color))):[])),new h.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new h.ApiCommandArgument("color","The color to show and insert",i=>i instanceof R.Color,S.Color.from),new h.ApiCommandArgument("context","Context object with uri and range",i=>!0,i=>({uri:i.uri,range:S.Range.from(i.range)}))],new h.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",i=>i?i.map(S.ColorPresentation.to):[])),new h.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range],new h.ApiCommandResult("A promise that resolves to an array of Inlay objects",(i,a,r)=>i.map(S.InlayHint.to.bind(void 0,r)))),new h.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(i,a)=>{if(i)return i.map(S.FoldingRange.to)})),new h.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new h.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",p(i=>({viewType:i.viewType,displayName:i.displayName,options:{transientOutputs:i.options.transientOutputs,transientCellMetadata:i.options.transientCellMetadata,transientDocumentMetadata:i.options.transientDocumentMetadata},filenamePattern:i.filenamePattern.map(a=>S.NotebookExclusiveDocumentPattern.to(a))})))),new h.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range,new h.ApiCommandArgument("context","An InlineValueContext",i=>i&&typeof i.frameId=="number"&&i.stoppedLocation instanceof R.Range,i=>S.InlineValueContext.from(i))],new h.ApiCommandResult("A promise that resolves to an array of InlineValue objects",i=>i.map(S.InlineValue.to))),new h.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new h.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",i=>C.URI.isUri(i)||typeof i=="string"&&(0,L.matchesSomeScheme)(i,L.Schemas.http,L.Schemas.https),i=>i),new h.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[S.ViewColumn.from(i),void 0]:[S.ViewColumn.from(i.viewColumn),S.TextEditorOpenOptions.from(i)])).optional(),h.ApiCommandArgument.String.with("label","").optional()],h.ApiCommandResult.Void),new h.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[h.ApiCommandArgument.Uri.with("resource","Resource to open"),h.ApiCommandArgument.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VSCodium's default text editor"),new h.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[S.ViewColumn.from(i),void 0]:[S.ViewColumn.from(i.viewColumn),S.TextEditorOpenOptions.from(i)])).optional()],h.ApiCommandResult.Void),new h.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[h.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),h.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),h.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new h.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="object",i=>i&&[S.ViewColumn.from(i.viewColumn),S.TextEditorOpenOptions.from(i)]).optional()],h.ApiCommandResult.Void),new h.ApiCommand("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[h.ApiCommandArgument.String.with("title","Human readable title for the changes editor"),new h.ApiCommandArgument("resourceList","List of resources to compare",i=>{for(const a of i){if(a.length!==3)return!1;const[r,n,o]=a;if(!C.URI.isUri(r)||!C.URI.isUri(n)&&n!==void 0&&n!==null||!C.URI.isUri(o)&&o!==void 0&&o!==null)return!1}return!0},i=>i)],h.ApiCommandResult.Void),new h.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",i=>i.map(S.TypeHierarchyItem.to))),new h.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[h.ApiCommandArgument.TypeHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",i=>i.map(S.TypeHierarchyItem.to))),new h.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[h.ApiCommandArgument.TypeHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",i=>i.map(S.TypeHierarchyItem.to))),new h.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[h.ApiCommandArgument.TestItem],h.ApiCommandResult.Void),new h.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[h.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],h.ApiCommandResult.Void),new h.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[h.ApiCommandArgument.String.with("name","The context key name"),new h.ApiCommandArgument("value","The context key value",()=>!0,i=>i)],h.ApiCommandResult.Void),new h.ApiCommand("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.StringArray,new h.ApiCommandArgument("MappedEditsContext","Mapped Edits Context",i=>S.MappedEditsContext.is(i),i=>S.MappedEditsContext.from(i))],new h.ApiCommandResult("A promise that resolves to a workspace edit or null",i=>i?S.WorkspaceEdit.to(i):null))];class u{static register(a){D.forEach(a.registerApiCommand,a),this._registerValidateWhenClausesCommand(a)}static _registerValidateWhenClausesCommand(a){a.registerCommand(!1,"_validateWhenClauses",g.validateWhenClauses)}}e.ExtHostApiCommands=u;function p(i){return a=>{if(Array.isArray(a))return a.map(i)}}function E(i){if(!Array.isArray(i))return;const a=[];for(const r of i)A.isLocationLink(r)?a.push(S.DefinitionLink.to(r)):a.push(S.location.to(r));return a}}),define(Pe[270],Te([1,0,6,2,3,8,7,31,13]),function(me,e,I,L,C,A,T,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class S{static{this._pool=0}constructor(p,E){this.extension=p,this.provider=E,this.handle=S._pool++}}class R{constructor(p){this.session=p,this.responses=[]}}class D{static{this._nextId=0}constructor(p,E,i,a){this._documents=i,this._logService=a,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=p.getProxy(C.MainContext.MainThreadInlineChat),E.registerApiCommand(new g.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new g.ApiCommandArgument("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?A.Range.from(r.initialRange):void 0,initialSelection:T.Selection.isSelection(r.initialSelection)?A.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?A.Position.from(r.position):void 0}})],g.ApiCommandResult.Void))}registerProvider(p,E,i){const a=new S(p,E);return this._inputProvider.set(a.handle,a),this._proxy.$registerInteractiveEditorProvider(a.handle,i?.label??p.displayName??p.name,p.identifier.value,typeof E.handleInteractiveEditorResponseFeedback=="function",typeof E.provideFollowups=="function",i?.supportReportIssue??!1),(0,I.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(a.handle),this._inputProvider.delete(a.handle)})}async $prepareSession(p,E,i,a){const r=this._inputProvider.get(p);if(!r){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this._documents.getDocument(L.URI.revive(E)),o=A.Selection.to(i),c=await r.provider.prepareInteractiveEditorSession({document:n,selection:o},a);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(o))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const l=D._nextId++;return this._inputSessions.set(l,new R(c)),{id:l,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:A.Range.from(c.wholeRange),message:c.message}}async $provideResponse(p,E,i,a){const r=this._inputProvider.get(p);if(!r)return;const n=this._inputSessions.get(E.id);if(!n)return;const o={prompt:i.prompt,selection:A.Selection.to(i.selection),wholeRange:A.Range.to(i.wholeRange),attempt:i.attempt,live:i.live,withIntentDetection:i.withIntentDetection};let c=!1;const l={report:async P=>{if(!i.live&&P.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||a.isCancellationRequested||await this._proxy.$handleProgressChunk(i.requestId,{message:P.message,edits:P.edits?.map(A.TextEdit.from),editsShouldBeInstant:P.editsShouldBeInstant,slashCommand:P.slashCommand?.command,markdownFragment:T.MarkdownString.isMarkdownString(P.content)?P.content.value:P.content})}},t=Promise.resolve(r.provider.provideInteractiveEditorResponse(n.session,o,l,a));let d;try{d=await(0,h.raceCancellation)(t,a)}finally{c=!0}if(!d)return;const s=n.responses.push(d)-1,b={wholeRange:A.Range.from(d.wholeRange),placeholder:d.placeholder};if(!D._isEditResponse(d))return{...b,id:s,type:"editorEdit",message:A.MarkdownString.from(d.contents),edits:[]};const{edits:_,contents:f}=d,w=f!==void 0?A.MarkdownString.from(f):void 0;return _ instanceof T.WorkspaceEdit?{...b,id:s,type:"bulkEdit",edits:A.WorkspaceEdit.from(_),message:w}:{...b,id:s,type:"editorEdit",edits:_.map(A.TextEdit.from),message:w}}async $provideFollowups(p,E,i,a){const r=this._inputProvider.get(p),n=this._inputSessions.get(E),o=n?.responses[i];if(r&&o&&r.provider.provideFollowups){const c=Promise.resolve(r.provider.provideFollowups(n.session,o,a));return(await(0,h.raceCancellation)(c,a))?.map(A.ChatFollowup.from)}}$handleFeedback(p,E,i,a){const r=this._inputProvider.get(p),n=this._inputSessions.get(E),o=n?.responses[i];if(r&&o){const c=A.InteractiveEditorResponseFeedbackKind.to(a);r.provider.handleInteractiveEditorResponseFeedback?.(n.session,o,c)}}$releaseSession(p,E){}static _isEditResponse(p){return typeof p=="object"&&typeof p.edits=="object"}}e.ExtHostInteractiveEditor=D}),define(Pe[271],Te([1,0,2,31]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class C{constructor(T,g,h,S,R){this._extHostNotebooks=g,this._textDocumentsAndEditors=h,this._commands=S;const D=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",u=>!0,u=>u),new L.ApiCommandArgument("resource","Interactive resource Uri",u=>!0,u=>u),new L.ApiCommandArgument("controllerId","Notebook controller Id",u=>!0,u=>u),new L.ApiCommandArgument("title","Interactive editor title",u=>!0,u=>u)],new L.ApiCommandResult("Notebook and input URI",u=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const p=this._extHostNotebooks.getEditorById(u.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:I.URI.revive(u.notebookUri),inputUri:I.URI.revive(u.inputUri),notebookEditor:p.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:I.URI.revive(u.notebookUri),inputUri:I.URI.revive(u.inputUri)}}));this._commands.registerApiCommand(D)}$willAddInteractiveDocument(T,g,h,S){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:g,lines:[""],languageId:h,uri:T,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(I.URI.revive(S))?.apiNotebook}]})}$willRemoveInteractiveDocument(T,g){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.ExtHostInteractive=C}),define(Pe[272],Te([1,0,18,13,20,5,6,28,2,22,14,3,31,8,7,77,209,24,49,210]),function(me,e,I,L,C,A,T,g,h,S,R,D,u,p,E,i,a,r,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let c=class{constructor(w,P,m,v,y){this._initData=P,this._extHostNotebook=m,this._commands=v,this._logService=y,this._activeExecutions=new g.ResourceMap,this._activeNotebookExecutions=new g.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this.id=0,this.variableStore={},this._proxy=w.getProxy(D.MainContext.MainThreadNotebookKernels);const O=new u.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.ApiCommandArgument("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const q=this._extHostNotebook.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:q}}else if(N&&"notebookEditor"in N){const q=this._extHostNotebook.getIdByEditor(N.notebookEditor);if(q===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:q}}return N})],u.ApiCommandResult.Void);this._commands.registerApiCommand(O)}createNotebookController(w,P,m,v,y,O){for(const pe of this._kernelData.values())if(pe.controller.id===P&&S.ExtensionIdentifier.equals(w.identifier,pe.extensionId))throw new Error(`notebook controller with id '${P}' ALREADY exist`);const N=this._handlePool++,q=this;this._logService.trace(`NotebookController[${N}], CREATED by ${w.identifier.value}, ${P}`);const W=()=>console.warn(`NO execute handler from notebook controller '${$.id}' of extension: '${w.identifier}'`);let x=!1;const k=new A.Emitter,M=new A.Emitter,$={id:_(w.identifier,P),notebookType:m,extensionId:w.identifier,extensionLocation:w.extensionLocation,label:v||w.identifier.value,preloads:O?O.map(p.NotebookRendererScript.from):[]};let oe=y??W,de,we;this._proxy.$addKernel(N,$).catch(pe=>{console.log(pe),x=!0});let ye=0;const le=()=>{if(x)return;const pe=++ye;Promise.resolve().then(()=>{pe===ye&&this._proxy.$updateKernel(N,$)})},ve=new g.ResourceMap,ae={get id(){return P},get notebookType(){return $.notebookType},onDidChangeSelectedNotebooks:k.event,get label(){return $.label},set label(pe){$.label=pe??w.displayName??w.name,le()},get detail(){return $.detail??""},set detail(pe){$.detail=pe,le()},get description(){return $.description??""},set description(pe){$.description=pe,le()},get supportedLanguages(){return $.supportedLanguages},set supportedLanguages(pe){$.supportedLanguages=pe,le()},get supportsExecutionOrder(){return $.supportsExecutionOrder??!1},set supportsExecutionOrder(pe){$.supportsExecutionOrder=pe,le()},get rendererScripts(){return $.preloads?$.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return oe},set executeHandler(pe){oe=pe??W},get interruptHandler(){return de},set interruptHandler(pe){de=pe,$.supportsInterrupt=!!pe,le()},set variableProvider(pe){(0,r.checkProposedApiEnabled)(w,"notebookVariableProvider"),we=pe,$.hasVariableProvider=!!pe,pe?.onDidChangeVariables(re=>q._proxy.$variablesUpdated(re.uri)),le()},get variableProvider(){return we},createNotebookCellExecution(pe){if(x)throw new Error("notebook controller is DISPOSED");if(!ve.has(pe.notebook.uri))throw q._logService.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ve.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.notebook.uri.toString()}`);return q._createNotebookCellExecution(pe,_(w.identifier,this.id))},createNotebookExecution(pe){if((0,r.checkProposedApiEnabled)(w,"notebookExecution"),x)throw new Error("notebook controller is DISPOSED");if(!ve.has(pe.uri))throw q._logService.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ve.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.uri.toString()}`);return q._createNotebookExecution(pe,_(w.identifier,this.id))},dispose:()=>{x||(this._logService.trace(`NotebookController[${N}], DISPOSED`),x=!0,this._kernelData.delete(N),k.dispose(),M.dispose(),this._proxy.$removeKernel(N))},updateNotebookAffinity(pe,re){re===E.NotebookControllerAffinity2.Hidden&&(0,r.checkProposedApiEnabled)(w,"notebookControllerAffinityHidden"),q._proxy.$updateNotebookPriority(N,pe.uri,re)},onDidReceiveMessage:M.event,postMessage(pe,re){return(0,r.checkProposedApiEnabled)(w,"notebookMessaging"),q._proxy.$postMessage(N,re&&q._extHostNotebook.getIdByEditor(re),pe)},asWebviewUri(pe){return(0,r.checkProposedApiEnabled)(w,"notebookMessaging"),(0,i.asWebviewUri)(pe,q._initData.remote)}};return this._kernelData.set(N,{extensionId:w.identifier,controller:ae,onDidReceiveMessage:M,onDidChangeSelection:k,associatedNotebooks:ve}),ae}getIdByController(w){for(const[P,m]of this._kernelData)if(m.controller===w)return _(m.extensionId,w.id);return null}createNotebookControllerDetectionTask(w,P){const m=this._kernelDetectionTaskHandlePool++,v=this;this._logService.trace(`NotebookControllerDetectionTask[${m}], CREATED by ${w.identifier.value}`),this._proxy.$addKernelDetectionTask(m,P);const y={dispose:()=>{this._kernelDetectionTask.delete(m),v._proxy.$removeKernelDetectionTask(m)}};return this._kernelDetectionTask.set(m,y),y}registerKernelSourceActionProvider(w,P,m){const v=this._kernelSourceActionProviderHandlePool++,y=typeof m.onDidChangeNotebookKernelSourceActions=="function"?v:void 0,O=this;this._kernelSourceActionProviders.set(v,m),this._logService.trace(`NotebookKernelSourceActionProvider[${v}], CREATED by ${w.identifier.value}`),this._proxy.$addKernelSourceActionProvider(v,v,P);let N;return y!==void 0&&(N=m.onDidChangeNotebookKernelSourceActions(q=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this._kernelSourceActionProviders.delete(v),O._proxy.$removeKernelSourceActionProvider(v,v),N?.dispose()}}}async $provideKernelSourceActions(w,P){const m=this._kernelSourceActionProviders.get(w);if(m){const v=new T.DisposableStore;return(await m.provideNotebookKernelSourceActions(P)??[]).map(O=>p.NotebookKernelSourceAction.from(O,this._commands.converter,v))}return[]}$acceptNotebookAssociation(w,P,m){const v=this._kernelData.get(w);if(v){const y=this._extHostNotebook.getNotebookDocument(h.URI.revive(P));m?v.associatedNotebooks.set(y.uri,!0):v.associatedNotebooks.delete(y.uri),this._logService.trace(`NotebookController[${w}] ASSOCIATE notebook`,y.uri.toString(),m),v.onDidChangeSelection.fire({selected:m,notebook:y.apiNotebook})}}async $executeCells(w,P,m){const v=this._kernelData.get(w);if(!v)return;const y=this._extHostNotebook.getNotebookDocument(h.URI.revive(P)),O=[];for(const N of m){const q=y.getCell(N);q&&O.push(q.apiCell)}try{this._logService.trace(`NotebookController[${w}] EXECUTE cells`,y.uri.toString(),O.length),await v.controller.executeHandler.call(v.controller,O,y.apiNotebook,v.controller)}catch(N){this._logService.error(`NotebookController[${w}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(w,P,m){const v=this._kernelData.get(w);if(!v)return;const y=this._extHostNotebook.getNotebookDocument(h.URI.revive(P));if(v.controller.interruptHandler)await v.controller.interruptHandler.call(v.controller,y.apiNotebook);else for(const O of m){const N=y.getCell(O);N&&this._activeExecutions.get(N.uri)?.cancel()}if(v.controller.interruptHandler){const O=this._activeNotebookExecutions.get(y.uri);m.length&&Array.isArray(O)&&O.length&&O.forEach(N=>N.dispose())}}async $provideVariables(w,P,m,v,y,O,N){const q=this._kernelData.get(w);if(!q)return;const W=this._extHostNotebook.getNotebookDocument(h.URI.revive(m)),x=q.controller.variableProvider;if(!x)return;let k;if(v!==void 0){if(k=this.variableStore[v],!k)return}else this.variableStore={};const M=y==="named"?E.NotebookVariablesRequestKind.Named:E.NotebookVariablesRequestKind.Indexed,$=x.provideVariables(W.apiNotebook,k,M,O,N);let oe=0;for await(const de of $){if(N.isCancellationRequested)return;const we={id:this.id++,name:de.variable.name,value:de.variable.value,type:de.variable.type,hasNamedChildren:de.hasNamedChildren,indexedChildrenCount:de.indexedChildrenCount};if(this.variableStore[we.id]=de.variable,this._proxy.$receiveVariable(P,we),oe++>=o.variablePageSize)return}}$acceptKernelMessageFromRenderer(w,P,m){const v=this._kernelData.get(w);if(!v)return;const y=this._extHostNotebook.getEditorById(P);v.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:m}))}$cellExecutionChanged(w,P,m){const y=this._extHostNotebook.getNotebookDocument(h.URI.revive(w)).getCell(P);if(y){const O=m?p.NotebookCellExecutionState.to(m):E.NotebookCellExecutionState.Idle;O!==void 0&&this._onDidChangeCellExecutionState.fire({cell:y.apiCell,state:O})}}_createNotebookCellExecution(w,P){if(w.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const v=this._extHostNotebook.getNotebookDocument(w.notebook.uri).getCellFromApiCell(w);if(!v)throw new Error("invalid cell");if(this._activeExecutions.has(v.uri))throw new Error(`duplicate execution for ${v.uri}`);const y=new t(P,v,this._proxy);this._activeExecutions.set(v.uri,y);const O=y.onDidChangeState(()=>{y.state===l.Resolved&&(y.dispose(),O.dispose(),this._activeExecutions.delete(v.uri))});return y.asApiObject()}_createNotebookExecution(w,P){const m=this._extHostNotebook.getNotebookDocument(w.uri),v=w.getCells().find(N=>{const q=m.getCellFromApiCell(N);return q&&this._activeExecutions.has(q.uri)});if(v)throw new Error(`duplicate cell execution for ${v.document.uri}`);if(this._activeNotebookExecutions.has(m.uri))throw new Error(`duplicate notebook execution for ${m.uri}`);const y=new s(P,m,this._proxy),O=y.onDidChangeState(()=>{y.state===d.Resolved&&(y.dispose(),O.dispose(),this._activeNotebookExecutions.delete(m.uri))});return this._activeNotebookExecutions.set(m.uri,[y,O]),y.asApiObject()}};e.ExtHostNotebookKernels=c,e.ExtHostNotebookKernels=c=Ke([We(4,R.ILogService)],c);var l;(function(f){f[f.Init=0]="Init",f[f.Started=1]="Started",f[f.Resolved=2]="Resolved"})(l||(l={}));class t extends T.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(w,P,m){super(),this._cell=P,this._proxy=m,this._handle=t.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=l.Init,this._tokenSource=this._register(new C.CancellationTokenSource),this._collector=new b(10,v=>this.update(v)),this._executionOrder=P.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,w,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(w){await this._collector.addItem(w)}async update(w){const P=Array.isArray(w)?w:[w];return this._proxy.$updateExecution(this._handle,new n.SerializableObjectWithBuffers(P))}verifyStateForOutput(){if(this._state===l.Init)throw new Error("Must call start before modifying cell output");if(this._state===l.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(w){let P=this._cell;if(w&&(P=this._cell.notebook.getCellFromApiCell(w)),!P)throw new Error("INVALID cell");return P.handle}validateAndConvertOutputs(w){return w.map(P=>{const m=E.NotebookCellOutput.ensureUniqueMimeTypes(P.items,!0);return m===P.items?p.NotebookCellOutput.from(P):p.NotebookCellOutput.from({items:m,id:P.id,metadata:P.metadata})})}async updateOutputs(w,P,m){const v=this.cellIndexToHandle(P),y=this.validateAndConvertOutputs((0,I.asArray)(w));return this.updateSoon({editType:a.CellExecutionUpdateType.Output,cellHandle:v,append:m,outputs:y})}async updateOutputItems(w,P,m){return w=E.NotebookCellOutput.ensureUniqueMimeTypes((0,I.asArray)(w),!0),this.updateSoon({editType:a.CellExecutionUpdateType.OutputItems,items:w.map(p.NotebookCellOutputItem.from),outputId:P.id,append:m})}asApiObject(){const w=this;return Object.freeze({get token(){return w._tokenSource.token},get cell(){return w._cell.apiCell},get executionOrder(){return w._executionOrder},set executionOrder(m){w._executionOrder=m,w.update([{editType:a.CellExecutionUpdateType.ExecutionState,executionOrder:w._executionOrder}])},start(m){if(w._state===l.Resolved||w._state===l.Started)throw new Error("Cannot call start again");w._state=l.Started,w._onDidChangeState.fire(),w.update({editType:a.CellExecutionUpdateType.ExecutionState,runStartTime:m})},end(m,v){if(w._state===l.Resolved)throw new Error("Cannot call resolve twice");w._state=l.Resolved,w._onDidChangeState.fire(),w._collector.flush(),w._proxy.$completeExecution(w._handle,new n.SerializableObjectWithBuffers({runEndTime:v,lastRunSuccess:m}))},clearOutput(m){return w.verifyStateForOutput(),w.updateOutputs([],m,!1)},appendOutput(m,v){return w.verifyStateForOutput(),w.updateOutputs(m,v,!0)},replaceOutput(m,v){return w.verifyStateForOutput(),w.updateOutputs(m,v,!1)},appendOutputItems(m,v){return w.verifyStateForOutput(),w.updateOutputItems(m,v,!0)},replaceOutputItems(m,v){return w.verifyStateForOutput(),w.updateOutputItems(m,v,!1)}})}}var d;(function(f){f[f.Init=0]="Init",f[f.Started=1]="Started",f[f.Resolved=2]="Resolved"})(d||(d={}));class s extends T.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(w,P,m){super(),this._notebook=P,this._proxy=m,this._handle=s.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=d.Init,this._tokenSource=this._register(new C.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,w,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===d.Resolved||this._state===d.Started)throw new Error("Cannot call start again");this._state=d.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===d.Resolved)throw new Error("Cannot call resolve twice");this._state=d.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class b{constructor(w,P){this.delay=w,this.callback=P,this.batch=[],this.startedTimer=Date.now()}addItem(w){return this.batch.push(w),this.currentDeferred||(this.currentDeferred=new L.DeferredPromise,this.startedTimer=Date.now(),(0,L.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const w=this.currentDeferred;this.currentDeferred=void 0;const P=this.batch;return this.batch=[],this.callback(P).finally(()=>w.complete())}}function _(f,w){return`${f.value}/${w}`}e.createKernelId=_}),define(Pe[65],Te([1,0,5,3,4,2,17,6,7,165,15,193,20,33,194,40,13,8,31]),function(me,e,I,L,C,A,T,g,h,S,R,D,u,p,E,i,a,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,C.createDecorator)("IExtHostTerminalService");class o{constructor(m,v,y,O){this._proxy=m,this._id=v,this._creationOptions=y,this._name=O,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(q=>this._pidPromiseComplete=q);const N=this;this.value={get name(){return N._name||""},get processId(){return N._pidPromise},get creationOptions(){return N._creationOptions},get exitStatus(){return N._exitStatus},get state(){return N._state},get selection(){return N._selection},sendText(q,W=!0){N._checkDisposed(),N._proxy.$sendText(N._id,q,W)},show(q){N._checkDisposed(),N._proxy.$show(N._id,q)},hide(){N._checkDisposed(),N._proxy.$hide(N._id)},dispose(){N._disposed||(N._disposed=!0,N._proxy.$dispose(N._id))},get dimensions(){if(!(N._cols===void 0||N._rows===void 0))return{columns:N._cols,rows:N._rows}}}}async create(m,v){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:m.name,shellPath:m.shellPath??void 0,shellArgs:m.shellArgs??void 0,cwd:m.cwd??v?.cwd??void 0,env:m.env??void 0,icon:_(m.iconPath)??void 0,color:i.ThemeColor.isThemeColor(m.color)?m.color.id:void 0,initialText:m.message??void 0,strictEnv:m.strictEnv??void 0,hideFromUser:m.hideFromUser??void 0,isFeatureTerminal:v?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:v?.useShellEnvironment??void 0,location:v?.location||this._serializeParentTerminal(m.location,v?.resolvedExtHostIdentifier),isTransient:m.isTransient??void 0})}async createExtensionTerminal(m,v,y,O,N){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:O,color:i.ThemeColor.isThemeColor(N)?N.id:void 0,location:v?.location||this._serializeParentTerminal(m,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(m,v){return typeof m=="object"?"parentTerminal"in m&&m.parentTerminal&&v?{parentTerminal:v}:"viewColumn"in m?{viewColumn:r.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus}:void 0:m}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(m){this._name=m}setExitStatus(m,v){this._exitStatus=Object.freeze({code:m,reason:v})}setDimensions(m,v){return m===this._cols&&v===this._rows||m===0||v===0?!1:(this._cols=m,this._rows=v,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(m){this._selection=m}_setProcessId(m){this._pidPromiseComplete?(this._pidPromiseComplete(m),this._pidPromiseComplete=void 0):this._pidPromise.then(v=>{v!==m&&(this._pidPromise=Promise.resolve(m))})}}e.ExtHostTerminal=o;class c{get onProcessReady(){return this._onProcessReady.event}constructor(m){this._pty=m,this.id=0,this.shouldPersist=!1,this._onProcessData=new I.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new I.Emitter,this._onDidChangeProperty=new I.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new I.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(m){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${m}`)}updateProperty(m,v){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${m}, value: ${v}`)}async start(){}shutdown(){this._pty.close()}input(m){this._pty.handleInput?.(m)}resize(m,v){this._pty.setDimensions?.({columns:m,rows:v})}clearBuffer(){}async processBinary(m){}acknowledgeDataEvent(m){}async setUnicodeVersion(m){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(m){this._pty.onDidWrite(v=>this._onProcessData.fire(v)),this._pty.onDidClose?.((v=void 0)=>{this._onProcessExit.fire(v===void 0?void 0:v)}),this._pty.onDidOverrideDimensions?.(v=>{v&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:v.columns,rows:v.rows}})}),this._pty.onDidChangeName?.(v=>{this._onDidChangeProperty.fire({type:"title",value:v})}),this._pty.open(m||void 0),m&&this._pty.setDimensions?.(m),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,t=class extends g.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(m=>m.value)}constructor(m,v,y){super(),this._extHostCommands=v,this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._lastQuickFixCommands=this._register(new g.MutableDisposable),this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new I.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new I.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new I.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new I.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new I.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new I.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._onDidWriteTerminalData=new I.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this._onDidWriteTerminalData.event,this._onDidExecuteCommand=new I.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this._onDidExecuteCommand.event,this._proxy=y.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new E.TerminalDataBufferer(this._proxy.$sendProcessData),this._proxy.$registerProcessSupport(m),this._extHostCommands.registerArgumentProcessor({processArgument:O=>{const N=q=>{const W=q;return this._getTerminalById(W.instanceId)?.value};switch(O?.$mid){case 15:return N(O);default:{if(Array.isArray(O))for(let q=0;q<O.length&&O[q].$mid===15;q++)O[q]=N(O[q]);return O}}}}),this._register({dispose:()=>{for(const[O,N]of this._terminalProcesses)N.shutdown(!0)}})}getDefaultShell(m){return(m?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(m){return(m?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(m,v){const y=new o(this._proxy,(0,p.generateUuid)(),m,m.name),O=new c(m.pty);return y.createExtensionTerminal(m.location,v,this._serializeParentTerminal(m,v).resolvedExtHostIdentifier,_(m.iconPath),f(m.color)).then(N=>{const q=this._setupExtHostProcessListeners(N,O);this._terminalProcessDisposables[N]=q}),this._terminals.push(y),y.value}_serializeParentTerminal(m,v){if(v=v||{},m.location&&typeof m.location=="object"&&"parentTerminal"in m.location){const y=m.location.parentTerminal;if(y){const O=this._terminals.find(N=>N.value===y);O&&(v.resolvedExtHostIdentifier=O._id)}}else m.location&&typeof m.location!="object"?v.location=m.location:v.location&&typeof v.location=="object"&&"splitActiveTerminal"in v.location&&(v.location={splitActiveTerminal:!0});return v}attachPtyToTerminal(m,v){if(!this._getTerminalById(m))throw new Error(`Cannot resolve terminal with id ${m} for virtual process`);const O=new c(v),N=this._setupExtHostProcessListeners(m,O);this._terminalProcessDisposables[m]=N}async $acceptActiveTerminalChanged(m){const v=this._activeTerminal;if(m===null){this._activeTerminal=void 0,v!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const y=this._getTerminalById(m);y&&(this._activeTerminal=y,v!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(m,v){const y=this._getTerminalById(m);y&&this._onDidWriteTerminalData.fire({terminal:y.value,data:v})}async $acceptTerminalDimensions(m,v,y){const O=this._getTerminalById(m);O&&O.setDimensions(v,y)&&this._onDidChangeTerminalDimensions.fire({terminal:O.value,dimensions:O.value.dimensions})}async $acceptDidExecuteCommand(m,v){const y=this._getTerminalById(m);y&&this._onDidExecuteCommand.fire({terminal:y.value,...v})}async $acceptTerminalMaximumDimensions(m,v,y){this._terminalProcesses.get(m)?.resize(v,y)}async $acceptTerminalTitleChange(m,v){const y=this._getTerminalById(m);y&&(y.name=v)}async $acceptTerminalClosed(m,v,y){const O=this._getTerminalObjectIndexById(this._terminals,m);if(O!==null){const N=this._terminals.splice(O,1)[0];N.setExitStatus(v,y),this._onDidCloseTerminal.fire(N.value)}}$acceptTerminalOpened(m,v,y,O){if(v){const W=this._getTerminalObjectIndexById(this._terminals,v);if(W!==null){this._terminals[W]._id=m,this._onDidOpenTerminal.fire(this.terminals[W]),this._terminals[W].isOpen=!0;return}}const N={name:O.name,shellPath:O.executable,shellArgs:O.args,cwd:typeof O.cwd=="string"?O.cwd:A.URI.revive(O.cwd),env:O.env,hideFromUser:O.hideFromUser},q=new o(this._proxy,m,N,y);this._terminals.push(q),this._onDidOpenTerminal.fire(q.value),q.isOpen=!0}async $acceptTerminalProcessId(m,v){this._getTerminalById(m)?._setProcessId(v)}async $startExtensionTerminal(m,v){const y=this._getTerminalById(m);if(!y)return{message:(0,S.localize)(0,null,m)};y.isOpen||await new Promise(N=>{const q=this.onDidOpenTerminal(async W=>{W===y.value&&(q.dispose(),N())})});const O=this._terminalProcesses.get(m);O?O.startSendingEvents(v):this._extensionTerminalAwaitingStart[m]={initialDimensions:v}}_setupExtHostProcessListeners(m,v){const y=new g.DisposableStore;y.add(v.onProcessReady(N=>this._proxy.$sendProcessReady(m,N.pid,N.cwd,N.windowsPty))),y.add(v.onDidChangeProperty(N=>this._proxy.$sendProcessProperty(m,N))),this._bufferer.startBuffering(m,v.onProcessData),y.add(v.onProcessExit(N=>this._onProcessExit(m,N))),this._terminalProcesses.set(m,v);const O=this._extensionTerminalAwaitingStart[m];return O&&v instanceof c&&(v.startSendingEvents(O.initialDimensions),delete this._extensionTerminalAwaitingStart[m]),y}$acceptProcessAckDataEvent(m,v){this._terminalProcesses.get(m)?.acknowledgeDataEvent(v)}$acceptProcessInput(m,v){this._terminalProcesses.get(m)?.input(v)}$acceptTerminalInteraction(m){const v=this._getTerminalById(m);v?.setInteractedWith()&&this._onDidChangeTerminalState.fire(v.value)}$acceptTerminalSelection(m,v){this._getTerminalById(m)?.setSelection(v)}$acceptProcessResize(m,v,y){try{this._terminalProcesses.get(m)?.resize(v,y)}catch(O){if(O.code!=="EPIPE"&&O.code!=="ERR_IPC_CHANNEL_CLOSED")throw O}}$acceptProcessShutdown(m,v){this._terminalProcesses.get(m)?.shutdown(v)}$acceptProcessRequestInitialCwd(m){this._terminalProcesses.get(m)?.getInitialCwd().then(v=>this._proxy.$sendProcessProperty(m,{type:"initialCwd",value:v}))}$acceptProcessRequestCwd(m){this._terminalProcesses.get(m)?.getCwd().then(v=>this._proxy.$sendProcessProperty(m,{type:"cwd",value:v}))}$acceptProcessRequestLatency(m){return Promise.resolve(m)}registerLinkProvider(m){return this._linkProviders.add(m),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new h.Disposable(()=>{this._linkProviders.delete(m),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(m,v,y){if(this._profileProviders.has(v))throw new Error(`Terminal profile provider "${v}" already registered`);return this._profileProviders.set(v,y),this._proxy.$registerProfileProvider(v,m.identifier.value),new h.Disposable(()=>{this._profileProviders.delete(v),this._proxy.$unregisterProfileProvider(v)})}registerTerminalQuickFixProvider(m,v,y){if(this._quickFixProviders.has(m))throw new Error(`Terminal quick fix provider "${m}" is already registered`);return this._quickFixProviders.set(m,y),this._proxy.$registerQuickFixProvider(m,v),new h.Disposable(()=>{this._quickFixProviders.delete(m),this._proxy.$unregisterQuickFixProvider(m)})}async $provideTerminalQuickFixes(m,v){const y=new u.CancellationTokenSource().token;if(y.isCancellationRequested)return;const O=this._quickFixProviders.get(m);if(!O)return;const N=await O.provideTerminalQuickFixes(v,y);if(N===null||Array.isArray(N)&&N.length===0)return;const q=new g.DisposableStore;if(this._lastQuickFixCommands.value=q,!Array.isArray(N))return N?r.TerminalQuickFix.from(N,this._extHostCommands.converter,q):void 0;const W=[];for(const x of N){const k=r.TerminalQuickFix.from(x,this._extHostCommands.converter,q);k&&W.push(k)}return W}async $createContributedProfileTerminal(m,v){const y=new u.CancellationTokenSource().token;let O=await this._profileProviders.get(m)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(O&&!("options"in O)&&(O={options:O}),!O||!("options"in O))throw new Error(`No terminal profile options provided for id "${m}"`);if("pty"in O.options){this.createExtensionTerminal(O.options,v);return}this.createTerminalFromOptions(O.options,v)}}async $provideLinks(m,v){const y=this._getTerminalById(m);if(!y)return[];this._terminalLinkCache.delete(m),this._terminalLinkCancellationSource.get(m)?.dispose(!0);const N=new u.CancellationTokenSource;this._terminalLinkCancellationSource.set(m,N);const q=[],W={terminal:y.value,line:v},x=[];for(const $ of this._linkProviders)x.push(a.Promises.withAsyncBody(async oe=>{N.token.onCancellationRequested(()=>oe({provider:$,links:[]}));const de=await $.provideTerminalLinks(W,N.token)||[];N.token.isCancellationRequested||oe({provider:$,links:de})}));const k=await Promise.all(x);if(N.token.isCancellationRequested)return[];const M=new Map;for(const $ of k)$&&$.links.length>0&&q.push(...$.links.map(oe=>{const de={id:l++,startIndex:oe.startIndex,length:oe.length,label:oe.tooltip};return M.set(de.id,{provider:$.provider,link:oe}),de}));return this._terminalLinkCache.set(m,M),q}$activateLink(m,v){const y=this._terminalLinkCache.get(m)?.get(v);y&&y.provider.handleTerminalLink(y.link)}_onProcessExit(m,v){this._bufferer.stopBuffering(m),this._terminalProcesses.delete(m),delete this._extensionTerminalAwaitingStart[m];const y=this._terminalProcessDisposables[m];y&&(y.dispose(),delete this._terminalProcessDisposables[m]),this._proxy.$sendProcessExit(m,v)}_getTerminalById(m){return this._getTerminalObjectById(this._terminals,m)}_getTerminalObjectById(m,v){const y=this._getTerminalObjectIndexById(m,v);return y!==null?m[y]:null}_getTerminalObjectIndexById(m,v){const y=m.findIndex(O=>O._id===v);return y===-1?null:y}getEnvironmentVariableCollection(m){let v=this._environmentVariableCollections.get(m.identifier.value);return v||(v=new d,this._setEnvironmentVariableCollection(m.identifier.value,v)),v.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(m,v){const y=(0,D.serializeEnvironmentVariableCollection)(v.map),O=(0,D.serializeEnvironmentDescriptionMap)(v.descriptionMap);this._proxy.$setEnvironmentVariableCollection(m,v.persistent,y.length===0?void 0:y,O)}$initEnvironmentVariableCollections(m){m.forEach(v=>{const y=v[0],O=new d(v[1]);this._setEnvironmentVariableCollection(y,O)})}$acceptDefaultProfile(m,v){const y=this._defaultProfile;this._defaultProfile=m,this._defaultAutomationProfile=v,y?.path!==m.path&&this._onDidChangeShell.fire(m.path)}_setEnvironmentVariableCollection(m,v){this._environmentVariableCollections.set(m,v),v.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(m,v)})}};e.BaseExtHostTerminalService=t,e.BaseExtHostTerminalService=t=Ke([We(1,n.IExtHostCommands),We(2,T.IExtHostRpcService)],t);class d{get persistent(){return this._persistent}set persistent(m){this._persistent=m,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(m){this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new I.Emitter,this.map=new Map(m)}getScopedEnvironmentVariableCollection(m){const v=this.getScopeKey(m);let y=this.scopedCollections.get(v);return y||(y=new s(this,m),this.scopedCollections.set(v,y),y.onDidChangeCollection(()=>this._onDidChangeCollection.fire())),y}replace(m,v,y,O){this._setIfDiffers(m,{value:v,type:h.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:O})}append(m,v,y,O){this._setIfDiffers(m,{value:v,type:h.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:O})}prepend(m,v,y,O){this._setIfDiffers(m,{value:v,type:h.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:O})}_setIfDiffers(m,v){if(v.options&&v.options.applyAtProcessCreation===!1&&!v.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.getKey(m,v.scope),O=this.map.get(y),N=v.options?{applyAtProcessCreation:v.options.applyAtProcessCreation??!1,applyAtShellIntegration:v.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!O||O.value!==v.value||O.type!==v.type||O.options?.applyAtProcessCreation!==N.applyAtProcessCreation||O.options?.applyAtShellIntegration!==N.applyAtShellIntegration||O.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index){const q=this.getKey(m,v.scope),W={variable:m,...v,options:N};this.map.set(q,W),this._onDidChangeCollection.fire()}}get(m,v){const y=this.getKey(m,v),O=this.map.get(y);return O?w(O):void 0}getKey(m,v){const y=this.getScopeKey(v);return y.length?`${m}:::${y}`:m}getScopeKey(m){return this.getWorkspaceKey(m?.workspaceFolder)??""}getWorkspaceKey(m){return m?m.uri.toString():void 0}getVariableMap(m){const v=new Map;for(const[y,O]of this.map)this.getScopeKey(O.scope)===this.getScopeKey(m)&&v.set(O.variable,w(O));return v}delete(m,v){const y=this.getKey(m,v);this.map.delete(y),this._onDidChangeCollection.fire()}clear(m){if(m?.workspaceFolder){for(const[v,y]of this.map)y.scope?.workspaceFolder?.index===m.workspaceFolder.index&&this.map.delete(v);this.clearDescription(m)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(m,v){const y=this.getScopeKey(v),O=this.descriptionMap.get(y);if(!O||O.description!==m){let N;typeof m=="string"?N=m:N=m?.value.split(`

`)[0];const q={description:N,scope:v};this.descriptionMap.set(y,q),this._onDidChangeCollection.fire()}}getDescription(m){const v=this.getScopeKey(m);return this.descriptionMap.get(v)?.description}clearDescription(m){const v=this.getScopeKey(m);this.descriptionMap.delete(v)}}class s{get persistent(){return this.collection.persistent}set persistent(m){this.collection.persistent=m}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(m,v){this.collection=m,this.scope=v,this._onDidChangeCollection=new I.Emitter}getScoped(m){return this.collection.getScopedEnvironmentVariableCollection(m)}replace(m,v,y){this.collection.replace(m,v,y,this.scope)}append(m,v,y){this.collection.append(m,v,y,this.scope)}prepend(m,v,y){this.collection.prepend(m,v,y,this.scope)}get(m){return this.collection.get(m,this.scope)}forEach(m,v){this.collection.getVariableMap(this.scope).forEach((y,O)=>m.call(v,O,y,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(m){this.collection.delete(m,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(m){this.collection.setDescription(m,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let b=class extends t{constructor(m,v){super(!1,m,v)}createTerminal(m,v,y){throw new R.NotSupportedError}createTerminalFromOptions(m,v){throw new R.NotSupportedError}};e.WorkerExtHostTerminalService=b,e.WorkerExtHostTerminalService=b=Ke([We(0,n.IExtHostCommands),We(1,T.IExtHostRpcService)],b);function _(P){if(!(!P||typeof P=="string"))return"id"in P?{id:P.id,color:P.color}:P}function f(P){return i.ThemeColor.isThemeColor(P)?P:void 0}function w(P){const m={...P};return delete m.scope,m.options=m.options??void 0,delete m.variable,m}}),define(Pe[273],Te([1,0,13,23,20,5,243,98,6,26,16,33,14,3,17,110,8,7,48,76,59,24]),function(me,e,I,L,C,A,T,g,h,S,R,D,u,p,E,i,a,r,n,o,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let t=class extends h.Disposable{constructor(x,k,M,$){super(),this.editors=$,this.resultsChangedEmitter=this._register(new A.Emitter),this.controllers=new Map,this.defaultProfilesChangedEmitter=this._register(new A.Emitter),this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=x.getProxy(p.MainContext.MainThreadTesting),this.observer=new y(this.proxy),this.runTracker=new _(this.proxy,k),M.registerArgumentProcessor({processArgument:oe=>{switch(oe?.$mid){case 16:{const de=oe,we=de.tests[de.tests.length-1].item.extId;return this.controllers.get(n.TestId.root(we))?.collection.tree.get(we)?.actual??(0,i.toItemFromContext)(oe)}case 18:{const{extId:de,message:we}=oe;return{test:this.controllers.get(n.TestId.root(de))?.collection.tree.get(de)?.actual,message:a.TestMessage.to(we)}}default:return oe}}}),M.registerCommand(!1,"testing.getExplorerSelection",async()=>{const oe=await M.executeCommand("_testing.getExplorerSelection"),de=we=>{const ye=this.controllers.get(n.TestId.root(we));if(ye)return n.TestId.isRoot(we)?ye.controller:ye.collection.tree.get(we)?.actual};return{include:oe?.include.map(de).filter(R.isDefined)||[],exclude:oe?.exclude.map(de).filter(R.isDefined)||[]}})}createTestController(x,k,M,$){if(this.controllers.has(k))throw new Error(`Attempt to insert a duplicate controller with ID "${k}"`);const oe=new h.DisposableStore,de=oe.add(new i.ExtHostTestItemCollection(k,M,this.editors));de.root.label=M;const we=new Map,ye=new Set,le=this.proxy,ve={items:de.root.children,get label(){return M},set label(pe){M=pe,de.root.label=pe,le.$updateController(k,{label:M})},get refreshHandler(){return $},set refreshHandler(pe){$=pe,le.$updateController(k,{canRefresh:!!pe})},get id(){return k},createRunProfile:(pe,re,J,H,ne,Ae)=>{let Re=(0,g.hash)(pe);for(;we.has(Re);)Re++;return new N(this.proxy,we,ye,this.defaultProfilesChangedEmitter.event,k,Re,pe,re,J,H,ne,Ae)},createTestItem(pe,re,J){return new i.TestItemImpl(k,pe,re,J)},createTestRun:(pe,re,J=!0)=>this.runTracker.createTestRun(x,k,de,pe,re,J),invalidateTestResults:pe=>{if(pe===void 0)this.proxy.$markTestRetired(void 0);else{const re=pe instanceof Array?pe:[pe];this.proxy.$markTestRetired(re.map(J=>n.TestId.fromExtHostTestItem(J,k).toString()))}},set resolveHandler(pe){de.resolveHandler=pe},get resolveHandler(){return de.resolveHandler},dispose:()=>{oe.dispose()}};le.$registerTestController(k,M,!!$),oe.add((0,h.toDisposable)(()=>le.$unregisterTestController(k)));const ae={controller:ve,collection:de,profiles:we,extension:x,activeProfiles:ye};return this.controllers.set(k,ae),oe.add((0,h.toDisposable)(()=>this.controllers.delete(k))),oe.add(de.onDidGenerateDiff(pe=>le.$publishDiff(k,pe.map(c.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.observer.checkout()}async runTests(x,k=C.CancellationToken.None){const M=f(x);if(!M)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const $=this.controllers.get(M.controllerId);if(!$)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:x.include?.map(oe=>n.TestId.fromExtHostTestItem(oe,$.collection.root.id).toString())??[$.collection.root.id],profileGroup:q[M.kind],profileId:M.profileId,controllerId:M.controllerId}],exclude:x.exclude?.map(oe=>oe.id)},k)}$syncTests(){for(const{collection:x}of this.controllers.values())x.flushDiff();return Promise.resolve()}async $provideFileCoverage(x,k,M){return await this.runTracker.getCoverageReport(x,k)?.provideFileCoverage(M)??[]}async $resolveFileCoverage(x,k,M,$){return await this.runTracker.getCoverageReport(x,k)?.resolveFileCoverage(M,$)??[]}$configureRunProfile(x,k){this.controllers.get(x)?.profiles.get(k)?.configureHandler?.()}$setDefaultRunProfiles(x){const k=new Map;for(const[M,$]of Object.entries(x)){const oe=this.controllers.get(M);if(!oe)continue;const de=new Map,we=$.filter(le=>!oe.activeProfiles.has(le)),ye=[...oe.activeProfiles].filter(le=>!$.includes(le));for(const le of we)de.set(le,!0),oe.activeProfiles.add(le);for(const le of ye)de.set(le,!1),oe.activeProfiles.delete(le);de.size&&k.set(M,de)}this.defaultProfilesChangedEmitter.fire(k)}async $refreshTests(x,k){await this.controllers.get(x)?.controller.refreshHandler?.(k)}$publishTestResults(x){this.results=Object.freeze(x.map(k=>(0,S.deepFreeze)(a.TestResults.to(k))).concat(this.results).sort((k,M)=>M.completedAt-k.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(x,k){const M=this.controllers.get(n.TestId.fromString(x).controllerId)?.collection;M&&(await M.expand(x,k<0?1/0:k),M.flushDiff())}$acceptDiff(x){this.observer.applyDiff(x.map(k=>c.TestsDiffOp.deserialize({asCanonicalUri:M=>M},k)))}async $runControllerTests(x,k){return Promise.all(x.map(M=>this.runControllerTestRequest(M,!1,k)))}async $startContinuousRun(x,k){const M=new C.CancellationTokenSource(k),$=await Promise.all(x.map(oe=>this.runControllerTestRequest(oe,!0,M.token)));return!k.isCancellationRequested&&!$.some(oe=>oe.error)&&await new Promise(oe=>k.onCancellationRequested(oe)),M.dispose(!0),$}async runControllerTestRequest(x,k,M){const $=this.controllers.get(x.controllerId);if(!$)return{};const{collection:oe,profiles:de,extension:we}=$,ye=de.get(x.profileId);if(!ye)return{};const le=x.testIds.map(re=>oe.tree.get(re)).filter(R.isDefined),ve=x.excludeExtIds.map(re=>$.collection.tree.get(re)).filter(R.isDefined).filter(re=>le.some(J=>J.fullId.compare(re.fullId)===2));if(!le.length)return{};const ae=new r.TestRunRequest(le.some(re=>re.actual instanceof i.TestItemRootImpl)?void 0:le.map(re=>re.actual),ve.map(re=>re.actual),ye,k),pe=(0,c.isStartControllerTests)(x)&&this.runTracker.prepareForMainThreadTestRun(ae,w.fromInternal(x,$.collection),we,M);try{return await ye.runHandler(ae,M),{}}catch(re){return{error:String(re)}}finally{pe&&(pe.hasRunningTasks&&!M.isCancellationRequested&&await A.Event.toPromise(pe.onEnd),pe.dispose())}}$cancelExtensionTestRun(x){x===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(x)}};e.ExtHostTesting=t,e.ExtHostTesting=t=Ke([We(0,E.IExtHostRpcService),We(1,u.ILogService)],t);const d=1e4;var s;(function(W){W[W.Running=0]="Running",W[W.Cancelling=1]="Cancelling",W[W.Ended=2]="Ended"})(s||(s={}));class b extends h.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor(x,k,M,$,oe){super(),this.dto=x,this.proxy=k,this.extension=M,this.logService=$,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.coverageEmitter=this._register(new A.Emitter),this.onDidCoverage=this.coverageEmitter.event,this.onEnd=this.endEmitter.event,this.cts=this._register(new C.CancellationTokenSource(oe));const de=this._register(new I.RunOnceScheduler(()=>this.forciblyEndTasks(),d));this._register(this.cts.token.onCancellationRequested(()=>de.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}createRun(x){const k=this.dto.id,M=this.dto.controllerId,$=(0,D.generateUuid)(),oe=this.extension,de=this.coverageEmitter;let we;const ye=pe=>(re,...J)=>{if(ve){this.logService.warn(`Setting the state of test "${re.id}" is a no-op after the run ends.`);return}this.dto.isIncluded(re)&&(this.ensureTestIsKnown(re),pe(re,...J))},le=(pe,re)=>{const J=re instanceof Array?re.map(a.TestMessage.from):[a.TestMessage.from(re)];if(pe.uri&&pe.range){const H={range:a.Range.from(pe.range),uri:pe.uri};for(const ne of J)ne.location=ne.location||H}this.proxy.$appendTestMessagesInRun(k,$,n.TestId.fromExtHostTestItem(pe,M).toString(),J)};let ve=!1;const ae={isPersisted:this.dto.isPersisted,token:this.cts.token,name:x,get coverageProvider(){return we?.provider},set coverageProvider(pe){(0,l.checkProposedApiEnabled)(oe,"testCoverage"),we=pe&&new P(pe),de.fire({taskId:$,runId:k,coverage:we})},enqueued:ye(pe=>{this.proxy.$updateTestStateInRun(k,$,n.TestId.fromExtHostTestItem(pe,M).toString(),1)}),skipped:ye(pe=>{this.proxy.$updateTestStateInRun(k,$,n.TestId.fromExtHostTestItem(pe,M).toString(),5)}),started:ye(pe=>{this.proxy.$updateTestStateInRun(k,$,n.TestId.fromExtHostTestItem(pe,M).toString(),2)}),errored:ye((pe,re,J)=>{le(pe,re),this.proxy.$updateTestStateInRun(k,$,n.TestId.fromExtHostTestItem(pe,M).toString(),6,J)}),failed:ye((pe,re,J)=>{le(pe,re),this.proxy.$updateTestStateInRun(k,$,n.TestId.fromExtHostTestItem(pe,M).toString(),4,J)}),passed:ye((pe,re)=>{this.proxy.$updateTestStateInRun(k,$,n.TestId.fromExtHostTestItem(pe,this.dto.controllerId).toString(),3,re)}),appendOutput:(pe,re,J)=>{ve||(J&&(this.dto.isIncluded(J)?this.ensureTestIsKnown(J):J=void 0),this.proxy.$appendOutputToRun(k,$,L.VSBuffer.fromString(pe),re&&a.location.from(re),J&&n.TestId.fromExtHostTestItem(J,M).toString()))},end:()=>{ve||(ve=!0,this.proxy.$finishedTestRunTask(k,$),this.tasks.delete($),this.tasks.size||this.markEnded())}};return this.tasks.set($,{run:ae}),this.proxy.$startedTestRunTask(k,{id:$,name:x,running:!0}),ae}forciblyEndTasks(){for(const{run:x}of this.tasks.values())x.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(x){if(!(x instanceof i.TestItemImpl))throw new o.InvalidTestItemError(x.id);if(this.sharedTestIds.has(n.TestId.fromExtHostTestItem(x,this.dto.controllerId).toString()))return;const k=[],M=this.dto.colllection.root;for(;;){const $=a.TestItem.from(x);if(k.unshift($),this.sharedTestIds.has($.extId)||(this.sharedTestIds.add($.extId),x===M))break;x=x.parent||M}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,k)}dispose(){this.markEnded(),super.dispose()}}class _{get trackers(){return this.tracked.values()}constructor(x,k){this.proxy=x,this.logService=k,this.tracked=new Map,this.coverageReports=[]}getCoverageReport(x,k){return this.coverageReports.find(M=>M.runId===x)?.coverage.get(k)}prepareForMainThreadTestRun(x,k,M,$){return this.getTracker(x,k,M,$)}cancelRunById(x){for(const k of this.tracked.values())if(k.id===x){k.cancel();return}}cancelAllRuns(){for(const x of this.tracked.values())x.cancel()}createTestRun(x,k,M,$,oe,de){const we=this.tracked.get($);if(we)return we.createRun(oe);const ye=w.fromPublic(k,M,$,de),le=f($);this.proxy.$startedExtensionTestRun({controllerId:k,continuous:!!$.continuous,profile:le&&{group:q[le.kind],id:le.profileId},exclude:$.exclude?.map(ae=>n.TestId.fromExtHostTestItem(ae,M.root.id).toString())??[],id:ye.id,include:$.include?.map(ae=>n.TestId.fromExtHostTestItem(ae,M.root.id).toString())??[M.root.id],persist:de});const ve=this.getTracker($,ye,x);return A.Event.once(ve.onEnd)(()=>{this.proxy.$finishedExtensionTestRun(ye.id),ve.dispose()}),ve.createRun(oe)}getTracker(x,k,M,$){const oe=new b(k,this.proxy,M,this.logService,$);this.tracked.set(x,oe);let de;const we=oe.onDidCoverage(({runId:ye,taskId:le,coverage:ve})=>{de||(de={runId:ye,coverage:new Map},this.coverageReports.unshift(de),this.coverageReports.length>c.KEEP_N_LAST_COVERAGE_REPORTS&&this.coverageReports.pop()),de.coverage.set(le,ve),this.proxy.$signalCoverageAvailable(ye,le,!!ve)});return A.Event.once(oe.onEnd)(()=>{this.tracked.delete(x),we.dispose()}),oe}}e.TestRunCoordinator=_;const f=W=>{if(W.profile){if(!(W.profile instanceof N))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return W.profile}};class w{static fromPublic(x,k,M,$){return new w(x,(0,D.generateUuid)(),M.include?.map(oe=>n.TestId.fromExtHostTestItem(oe,x).toString())??[x],M.exclude?.map(oe=>n.TestId.fromExtHostTestItem(oe,x).toString())??[],$,k)}static fromInternal(x,k){return new w(x.controllerId,x.runId,x.testIds,x.excludeExtIds,!0,k)}constructor(x,k,M,$,oe,de){this.controllerId=x,this.id=k,this.isPersisted=oe,this.colllection=de,this.includePrefix=M.map(we=>we+"\0"),this.excludePrefix=$.map(we=>we+"\0")}isIncluded(x){const k=n.TestId.fromExtHostTestItem(x,this.controllerId).toString()+"\0";for(const M of this.excludePrefix)if(k===M||k.startsWith(M))return!1;for(const M of this.includePrefix)if(k===M||k.startsWith(M))return!0;return!1}}e.TestRunDto=w;class P{constructor(x){this.provider=x}async provideFileCoverage(x){this.fileCoverage||(this.fileCoverage=(async()=>this.provider.provideFileCoverage(x))());try{return(await this.fileCoverage)?.map(a.TestCoverage.fromFile)??[]}catch(k){throw this.fileCoverage=void 0,k}}async resolveFileCoverage(x,k){const M=await this.fileCoverage;let $=M?.[x];return!this.provider||!M||!$?[]:($.detailedCoverage||($=M[x]=await this.provider.resolveFileCoverage?.($,k)??$),$.detailedCoverage?.map(a.TestCoverage.fromDetailed)??[])}}class m{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(x){this.emitter=x,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(x){this.added.add(x)}update(x){Object.assign(x.revived,a.TestItem.toPlain(x.item)),this.added.has(x)||this.updated.add(x)}remove(x){if(this.added.has(x)){this.added.delete(x);return}this.updated.delete(x);const k=n.TestId.parentId(x.item.extId);if(k&&this.alreadyRemoved.has(k.toString())){this.alreadyRemoved.add(x.item.extId);return}this.removed.add(x)}getChangeEvent(){const{added:x,updated:k,removed:M}=this;return{get added(){return[...x].map($=>$.revived)},get updated(){return[...k].map($=>$.revived)},get removed(){return[...M].map($=>$.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class v extends c.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return this.roots}getMirroredTestDataById(x){return this.items.get(x)}getMirroredTestDataByReference(x){return this.items.get(x.id)}createItem(x,k){return{...x,revived:a.TestItem.toPlain(x.item),depth:k?k.depth+1:0,children:new Set}}createChangeCollector(){return new m(this.changeEmitter)}}class y{constructor(x){this.proxy=x}checkout(){this.current||(this.current=this.createObserverData());const x=this.current;return x.observers++,{onDidChangeTest:x.tests.onDidChangeTests,get tests(){return[...x.tests.rootTests].map(k=>k.revived)},dispose:(0,T.createSingleCallFunction)(()=>{--x.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(x){return this.current?.tests.getMirroredTestDataByReference(x)}applyDiff(x){this.current?.tests.apply(x)}createObserverData(){const x=new v({asCanonicalUri:k=>k});return this.proxy.$subscribeToDiffs(),{observers:0,tests:x}}}const O=(W,x,k,M)=>{k?Object.assign(k,M):x.$updateTestRunConfig(W.controllerId,W.profileId,M)};class N{#e;#t;#i;#n;#s;get label(){return this._label}set label(x){x!==this._label&&(this._label=x,O(this,this.#e,this.#n,{label:x}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(x){x!==this._supportsContinuousRun&&(this._supportsContinuousRun=x,O(this,this.#e,this.#n,{supportsContinuousRun:x}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(x){x!==this.isDefault&&(x?this.#t.add(this.profileId):this.#t.delete(this.profileId),O(this,this.#e,this.#n,{isDefault:x}))}get tag(){return this._tag}set tag(x){x?.id!==this._tag?.id&&(this._tag=x,O(this,this.#e,this.#n,{tag:x?a.TestTag.namespace(this.controllerId,x.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(x){x!==this._configureHandler&&(this._configureHandler=x,O(this,this.#e,this.#n,{hasConfigurationHandler:!!x}))}get onDidChangeDefault(){return A.Event.chain(this.#i,x=>x.map(k=>k.get(this.controllerId)?.get(this.profileId)).filter(R.isDefined))}constructor(x,k,M,$,oe,de,we,ye,le,ve=!1,ae=void 0,pe=!1){this.controllerId=oe,this.profileId=de,this._label=we,this.kind=ye,this.runHandler=le,this._tag=ae,this._supportsContinuousRun=pe,this.#e=x,this.#s=k,this.#t=M,this.#i=$,k.set(de,this);const re=q[ye];if(typeof re!="number")throw new Error(`Unknown TestRunProfile.group ${ye}`);ve&&M.add(de),this.#n={profileId:de,controllerId:oe,tag:ae?a.TestTag.namespace(this.controllerId,ae.id):null,label:we,group:re,isDefault:ve,hasConfigurationHandler:!1,supportsContinuousRun:pe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.TestRunProfileImpl=N;const q={[r.TestRunProfileKind.Coverage]:8,[r.TestRunProfileKind.Debug]:4,[r.TestRunProfileKind.Run]:2}}),define(Pe[111],Te([1,0,54,15,89,8,7]),function(me,e,I,L,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class g{static{this._Keys=new C.IdGenerator("TextEditorDecorationType")}constructor(u,p,E){const i=g._Keys.nextId();u.$registerTextEditorDecorationType(p.identifier,i,A.DecorationRenderOptions.from(E)),this.value=Object.freeze({key:i,dispose(){u.$removeTextEditorDecorationType(i)}})}}e.TextEditorDecorationType=g;class h{constructor(u,p){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=u,this._documentVersionId=u.version,this._undoStopBefore=p.undoStopBefore,this._undoStopAfter=p.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(u,p){this._throwIfFinalized();let E=null;if(u instanceof T.Position)E=new T.Range(u,u);else if(u instanceof T.Range)E=u;else throw new Error("Unrecognized location");this._pushEdit(E,p,!1)}insert(u,p){this._throwIfFinalized(),this._pushEdit(new T.Range(u,u),p,!0)}delete(u){this._throwIfFinalized();let p=null;if(u instanceof T.Range)p=u;else throw new Error("Unrecognized location");this._pushEdit(p,null,!0)}_pushEdit(u,p,E){const i=this._document.validateRange(u);this._collectedEdits.push({range:i,text:p,forceMoveMarkers:E})}setEndOfLine(u){if(this._throwIfFinalized(),u!==T.EndOfLine.LF&&u!==T.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=u}}class S{constructor(u,p,E,i){this._proxy=u,this._id=p,this._accept(E),this._logService=i;const a=this;this.value={get tabSize(){return a._tabSize},set tabSize(r){a._setTabSize(r)},get indentSize(){return a._indentSize},set indentSize(r){a._setIndentSize(r)},get insertSpaces(){return a._insertSpaces},set insertSpaces(r){a._setInsertSpaces(r)},get cursorStyle(){return a._cursorStyle},set cursorStyle(r){a._setCursorStyle(r)},get lineNumbers(){return a._lineNumbers},set lineNumbers(r){a._setLineNumbers(r)}}}_accept(u){this._tabSize=u.tabSize,this._indentSize=u.indentSize,this._originalIndentSize=u.originalIndentSize,this._insertSpaces=u.insertSpaces,this._cursorStyle=u.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(u.lineNumbers)}_validateTabSize(u){if(u==="auto")return"auto";if(typeof u=="number"){const p=Math.floor(u);return p>0?p:null}if(typeof u=="string"){const p=parseInt(u,10);return isNaN(p)?null:p>0?p:null}return null}_setTabSize(u){const p=this._validateTabSize(u);if(p!==null){if(typeof p=="number"){if(this._tabSize===p)return;this._tabSize=p}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:p}))}}_validateIndentSize(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const p=Math.floor(u);return p>0?p:null}if(typeof u=="string"){const p=parseInt(u,10);return isNaN(p)?null:p>0?p:null}return null}_setIndentSize(u){const p=this._validateIndentSize(u);if(p!==null){if(typeof p=="number"){if(this._originalIndentSize===p)return;this._indentSize=p,this._originalIndentSize=p}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:p}))}}_validateInsertSpaces(u){return u==="auto"?"auto":u==="false"?!1:!!u}_setInsertSpaces(u){const p=this._validateInsertSpaces(u);if(typeof p=="boolean"){if(this._insertSpaces===p)return;this._insertSpaces=p}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:p}))}_setCursorStyle(u){this._cursorStyle!==u&&(this._cursorStyle=u,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:u})))}_setLineNumbers(u){this._lineNumbers!==u&&(this._lineNumbers=u,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(u)})))}assign(u){const p={};let E=!1;if(typeof u.tabSize<"u"){const i=this._validateTabSize(u.tabSize);i==="auto"?(E=!0,p.tabSize=i):typeof i=="number"&&this._tabSize!==i&&(this._tabSize=i,E=!0,p.tabSize=i)}if(typeof u.indentSize<"u"){const i=this._validateIndentSize(u.indentSize);i==="tabSize"?(E=!0,p.indentSize=i):typeof i=="number"&&this._originalIndentSize!==i&&(this._indentSize=i,this._originalIndentSize=i,E=!0,p.indentSize=i)}if(typeof u.insertSpaces<"u"){const i=this._validateInsertSpaces(u.insertSpaces);i==="auto"?(E=!0,p.insertSpaces=i):this._insertSpaces!==i&&(this._insertSpaces=i,E=!0,p.insertSpaces=i)}typeof u.cursorStyle<"u"&&this._cursorStyle!==u.cursorStyle&&(this._cursorStyle=u.cursorStyle,E=!0,p.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this._lineNumbers!==u.lineNumbers&&(this._lineNumbers=u.lineNumbers,E=!0,p.lineNumbers=A.TextEditorLineNumbersStyle.from(u.lineNumbers)),E&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,p))}_warnOnError(u,p){p.catch(E=>{this._logService.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this._logService.warn(E)})}}e.ExtHostTextEditorOptions=S;class R{constructor(u,p,E,i,a,r,n,o){this.id=u,this._proxy=p,this._logService=E,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=a,this._options=new S(this._proxy,this.id,r,E),this._visibleRanges=n,this._viewColumn=o;const c=this;this.value=Object.freeze({get document(){return i.value},set document(l){throw new L.ReadonlyError("document")},get selection(){return c._selections&&c._selections[0]},set selection(l){if(!(l instanceof T.Selection))throw(0,L.illegalArgument)("selection");c._selections=[l],c._trySetSelection()},get selections(){return c._selections},set selections(l){if(!Array.isArray(l)||l.some(t=>!(t instanceof T.Selection)))throw(0,L.illegalArgument)("selections");c._selections=l,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(l){throw new L.ReadonlyError("visibleRanges")},get options(){return c._options.value},set options(l){c._disposed||c._options.assign(l)},get viewColumn(){return c._viewColumn},set viewColumn(l){throw new L.ReadonlyError("viewColumn")},edit(l,t={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new h(i.value,t);return l(d),c._applyEdit(d)},insertSnippet(l,t,d={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=c._selections.map(b=>A.Range.from(b));else if(t instanceof T.Position){const{lineNumber:b,column:_}=A.Position.from(t);s=[{startLineNumber:b,startColumn:_,endLineNumber:b,endColumn:_}]}else if(t instanceof T.Range)s=[A.Range.from(t)];else{s=[];for(const b of t)if(b instanceof T.Range)s.push(A.Range.from(b));else{const{lineNumber:_,column:f}=A.Position.from(b);s.push({startLineNumber:_,startColumn:f,endLineNumber:_,endColumn:f})}}return p.$tryInsertSnippet(u,i.value.version,l.value,s,d)},setDecorations(l,t){const d=t.length===0;d&&!c._hasDecorationsForKey.has(l.key)||(d?c._hasDecorationsForKey.delete(l.key):c._hasDecorationsForKey.add(l.key),c._runOnProxy(()=>{if(A.isDecorationOptionsArr(t))return p.$trySetDecorations(u,l.key,A.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let b=0,_=t.length;b<_;b++){const f=t[b];s[4*b]=f.start.line+1,s[4*b+1]=f.start.character+1,s[4*b+2]=f.end.line+1,s[4*b+3]=f.end.character+1}return p.$trySetDecorationsFast(u,l.key,s)}}))},revealRange(l,t){c._runOnProxy(()=>p.$tryRevealRange(u,A.Range.from(l),t||T.TextEditorRevealType.Default))},show(l){p.$tryShowEditor(u,A.ViewColumn.from(l))},hide(){p.$tryHideEditor(u)}})}dispose(){(0,I.ok)(!this._disposed),this._disposed=!0}_acceptOptions(u){(0,I.ok)(!this._disposed),this._options._accept(u)}_acceptVisibleRanges(u){(0,I.ok)(!this._disposed),this._visibleRanges=u}_acceptViewColumn(u){(0,I.ok)(!this._disposed),this._viewColumn=u}_acceptSelections(u){(0,I.ok)(!this._disposed),this._selections=u}async _trySetSelection(){const u=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,u)),this.value}_applyEdit(u){const p=u.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const E=p.edits.map(a=>a.range);E.sort((a,r)=>a.end.line===r.end.line?a.end.character===r.end.character?a.start.line===r.start.line?a.start.character-r.start.character:a.start.line-r.start.line:a.end.character-r.end.character:a.end.line-r.end.line);for(let a=0,r=E.length-1;a<r;a++){const n=E[a].end;if(E[a+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const i=p.edits.map(a=>({range:A.Range.from(a.range),text:a.text,forceMoveMarkers:a.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,p.documentVersionId,i,{setEndOfLine:typeof p.setEndOfLine=="number"?A.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}_runOnProxy(u){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this._logService.warn(p),null))}}e.ExtHostTextEditor=R}),define(Pe[66],Te([1,0,54,5,6,2,4,3,108,17,111,8,14,28,11,68,39]),function(me,e,I,L,C,A,T,g,h,S,R,D,u,p,E,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class r{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let n=class{constructor(c,l){this._extHostRpc=c,this._logService=l,this._activeEditorId=null,this._editors=new Map,this._documents=new p.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const l=[],t=[],d=[];if(c.removedDocuments)for(const s of c.removedDocuments){const b=A.URI.revive(s),_=this._documents.get(b);_?.unref()&&(this._documents.delete(b),l.push(_.value))}if(c.addedDocuments)for(const s of c.addedDocuments){const b=A.URI.revive(s.uri);let _=this._documents.get(b);if(_&&b.scheme!==E.Schemas.vscodeNotebookCell&&b.scheme!==E.Schemas.vscodeInteractiveInput)throw new Error(`document '${b} already exists!'`);_||(_=new r(new h.ExtHostDocumentData(this._extHostRpc.getProxy(g.MainContext.MainThreadDocuments),b,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this._documents.set(b,_),t.push(_.value)),_.ref()}if(c.removedEditors)for(const s of c.removedEditors){const b=this._editors.get(s);this._editors.delete(s),b&&d.push(b)}if(c.addedEditors)for(const s of c.addedEditors){const b=A.URI.revive(s.documentUri);I.ok(this._documents.has(b),`document '${b}' does not exist`),I.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const _=this._documents.get(b).value,f=new R.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(g.MainContext.MainThreadTextEditors),this._logService,new a.Lazy(()=>_.document),s.selections.map(D.Selection.to),s.options,s.visibleRanges.map(w=>D.Range.to(w)),typeof s.editorPosition=="number"?D.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,f)}c.newActiveEditor!==void 0&&(I.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,C.dispose)(l),(0,C.dispose)(d),c.removedDocuments&&this._onDidRemoveDocuments.fire(l),c.addedDocuments&&this._onDidAddDocuments.fire(t),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){return this._documents.get(c)?.value}allDocuments(){return i.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!this._activeEditorId)return;const l=this._editors.get(this._activeEditorId);return c?l:l?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=n,e.ExtHostDocumentsAndEditors=n=Ke([We(0,S.IExtHostRpcService),We(1,u.ILogService)],n),e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(Pe[274],Te([1,0,18,5,3,111,8,7]),function(me,e,I,L,C,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class h{constructor(R,D){this._extHostDocumentsAndEditors=D,this._onDidChangeTextEditorSelection=new L.Emitter,this._onDidChangeTextEditorOptions=new L.Emitter,this._onDidChangeTextEditorVisibleRanges=new L.Emitter,this._onDidChangeTextEditorViewColumn=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(C.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(u=>this._onDidChangeVisibleTextEditors.fire(u)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(u=>this._onDidChangeActiveTextEditor.fire(u))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const D=this._extHostDocumentsAndEditors.allEditors();return R?D:D.map(u=>u.value)}async showTextDocument(R,D,u){let p;typeof D=="number"?p={position:T.ViewColumn.from(D),preserveFocus:u}:typeof D=="object"?p={position:T.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?T.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:p={preserveFocus:!1};const E=await this._proxy.$tryShowTextDocument(R.uri,p),i=E&&this._extHostDocumentsAndEditors.getEditor(E);if(i)return i.value;throw E?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,D){return new A.TextEditorDecorationType(this._proxy,R,D).value}$acceptEditorPropertiesChanged(R,D){const u=this._extHostDocumentsAndEditors.getEditor(R);if(!u)throw new Error("unknown text editor");if(D.options&&u._acceptOptions(D.options),D.selections){const p=D.selections.selections.map(T.Selection.to);u._acceptSelections(p)}if(D.visibleRanges){const p=I.coalesce(D.visibleRanges.map(T.Range.to));u._acceptVisibleRanges(p)}if(D.options&&this._onDidChangeTextEditorOptions.fire({textEditor:u.value,options:{...D.options,lineNumbers:T.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const p=g.TextEditorSelectionChangeKind.fromValue(D.selections.source),E=D.selections.selections.map(T.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:u.value,selections:E,kind:p})}if(D.visibleRanges){const p=I.coalesce(D.visibleRanges.map(T.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:u.value,visibleRanges:p})}}$acceptEditorPositionData(R){for(const D in R){const u=this._extHostDocumentsAndEditors.getEditor(D);if(!u)throw new Error("Unknown text editor");const p=T.ViewColumn.to(R[D]);u.value.viewColumn!==p&&(u._acceptViewColumn(p),this._onDidChangeTextEditorViewColumn.fire({textEditor:u.value,viewColumn:p}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=h}),define(Pe[275],Te([1,0,2,4,3,6,7,8,22,16]),function(me,e,I,L,C,A,T,g,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class R{constructor(p,E){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=p.getProxy(C.MainContext.MainThreadTimeline),E.registerArgumentProcessor({processArgument:(i,a)=>{if(i&&i.$mid===12)if(this._providers.get(i.source)&&h.ExtensionIdentifier.equals(a,this._providers.get(i.source)?.extension)){const r=i.uri===void 0?void 0:I.URI.revive(i.uri);return this._itemsBySourceAndUriMap.get(i.source)?.get(D(r))?.get(i.handle)}else return;return i}})}async $getTimeline(p,E,i,a){return this._providers.get(p)?.provider.provideTimeline(I.URI.revive(E),i,a)}registerTimelineProvider(p,E,i,a){const r=new A.DisposableStore,n=this.convertTimelineItem(E.id,a,r).bind(this);let o;E.onDidChange&&(o=E.onDidChange(l=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:E.id}),this));const c=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...E,scheme:p,onDidChange:void 0,async provideTimeline(l,t,d){t?.resetCache&&(r.clear(),c.get(E.id)?.clear());const s=await E.provideTimeline(l,t,d);if(s==null)return;const b=n(l,t);return{...s,source:E.id,items:s.items.map(b)}},dispose(){for(const l of c.values())l.get(E.id)?.clear();o?.dispose(),r.dispose()}},i)}convertTimelineItem(p,E,i){return(a,r)=>{let n;if(r?.cacheResults){let o=this._itemsBySourceAndUriMap.get(p);o===void 0&&(o=new Map,this._itemsBySourceAndUriMap.set(p,o));const c=D(a);n=o.get(c),n===void 0&&(n=new Map,o.set(c,n))}return o=>{const{iconPath:c,...l}=o,t=`${p}|${o.id??o.timestamp}`;n?.set(t,o);let d,s,b;o.iconPath&&(c instanceof T.ThemeIcon?b={id:c.id,color:c.color}:I.URI.isUri(c)?(d=c,s=c):{light:d,dark:s}=c);let _;return T.MarkdownString.isMarkdownString(l.tooltip)?_=g.MarkdownString.from(l.tooltip):(0,S.isString)(l.tooltip)?_=l.tooltip:T.MarkdownString.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),_=g.MarkdownString.from(l.detail)):(0,S.isString)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),_=l.detail),{...l,id:l.id??void 0,handle:t,source:p,command:o.command?E.toInternal(o.command,i):void 0,icon:d,iconDark:s,themeIcon:b,tooltip:_,accessibilityInformation:o.accessibilityInformation}}}}registerTimelineProviderCore(p,E){if(this._providers.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this._proxy.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this._providers.set(p.id,{provider:p,extension:E}),(0,A.toDisposable)(()=>{for(const a of this._itemsBySourceAndUriMap.values())a.get(p.id)?.clear();this._providers.delete(p.id),this._proxy.$unregisterTimelineProvider(p.id),p.dispose()})}}e.ExtHostTimeline=R;function D(u){return u?.toString()}}),define(Pe[276],Te([1,0,166,25,2,5,6,204,13,7,16,18,8,52,20,132,24]),function(me,e,I,L,C,A,T,g,h,S,R,D,u,p,E,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function r(c,l){if((0,R.isString)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let t;return Array.isArray(c.highlights)&&(t=c.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),t=t.length?t:void 0),{label:c.label,highlights:t}}}class n extends T.Disposable{constructor(l,t,d){super(),this._proxy=l,this.commands=t,this.logService=d,this.treeViews=new Map,this.treeDragAndDropService=new i.TreeViewsDnDService;function s(b){return b&&b.$treeViewId&&(b.$treeItemHandle||b.$selectedTreeItems||b.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:b=>s(b)?this.convertArgument(b):Array.isArray(b)&&b.length>0?b.map(_=>s(_)?this.convertArgument(_):_):b})}registerTreeDataProvider(l,t,d){const s=this.createTreeView(l,{treeDataProvider:t},d);return{dispose:()=>s.dispose()}}createTreeView(l,t,d){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=t.dragAndDropController?.dropMimeTypes??[],b=t.dragAndDropController?.dragMimeTypes??[],_=!!t.dragAndDropController?.handleDrag,f=!!t.dragAndDropController?.handleDrop,w=this.createExtHostTreeView(l,t,d),P={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:s,dragMimeTypes:b,hasHandleDrag:_,hasHandleDrop:f,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},m=this._proxy.$registerTreeViewDataProvider(l,P),v={get onDidCollapseElement(){return w.onDidCollapseElement},get onDidExpandElement(){return w.onDidExpandElement},get selection(){return w.selectedElements},get onDidChangeSelection(){return w.onDidChangeSelection},get activeItem(){return(0,a.checkProposedApiEnabled)(d,"treeViewActiveItem"),w.focusedElement},get onDidChangeActiveItem(){return(0,a.checkProposedApiEnabled)(d,"treeViewActiveItem"),w.onDidChangeActiveItem},get visible(){return w.visible},get onDidChangeVisibility(){return w.onDidChangeVisibility},get onDidChangeCheckboxState(){return w.onDidChangeCheckboxState},get message(){return w.message},set message(y){(0,p.isMarkdownString)(y)&&(0,a.checkProposedApiEnabled)(d,"treeViewMarkdownMessage"),w.message=y},get title(){return w.title},set title(y){w.title=y},get description(){return w.description},set description(y){w.description=y},get badge(){return w.badge},set badge(y){y!==void 0&&S.ViewBadge.isViewBadge(y)?w.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(w.badge=void 0)},reveal:(y,O)=>w.reveal(y,O),dispose:async()=>{await m,this.treeViews.delete(l),w.dispose()}};return this._register(v),v}$getChildren(l,t){const d=this.treeViews.get(l);return d?d.getChildren(t):Promise.reject(new g.NoTreeViewError(l))}async $handleDrop(l,t,d,s,b,_,f,w){const P=this.treeViews.get(l);if(!P)return Promise.reject(new g.NoTreeViewError(l));const m=u.DataTransfer.toDataTransfer(d,async v=>(await this._proxy.$resolveDropFileData(l,t,v)).buffer);return f===l&&w&&await this.addAdditionalTransferItems(m,P,w,b,_),P.onDrop(m,s,b)}async addAdditionalTransferItems(l,t,d,s,b){const _=this.treeDragAndDropService.removeDragOperationTransfer(b);if(_)(await _)?.forEach((f,w)=>{f&&l.set(w,f)});else if(b&&t.handleDrag){const f=t.handleDrag(d,l,s);this.treeDragAndDropService.addDragOperationTransfer(b,f),await f}return l}async $handleDrag(l,t,d,s){const b=this.treeViews.get(l);if(!b)return Promise.reject(new g.NoTreeViewError(l));const _=await this.addAdditionalTransferItems(new S.DataTransfer,b,t,s,d);if(!(!_||s.isCancellationRequested))return u.DataTransfer.from(_)}async $hasResolve(l){const t=this.treeViews.get(l);if(!t)throw new g.NoTreeViewError(l);return t.hasResolve}$resolve(l,t,d){const s=this.treeViews.get(l);if(!s)throw new g.NoTreeViewError(l);return s.resolveTreeItem(t,d)}$setExpanded(l,t,d){const s=this.treeViews.get(l);if(!s)throw new g.NoTreeViewError(l);s.setExpanded(t,d)}$setSelectionAndFocus(l,t,d){const s=this.treeViews.get(l);if(!s)throw new g.NoTreeViewError(l);s.setSelectionAndFocus(t,d)}$setVisible(l,t){const d=this.treeViews.get(l);if(!d){if(!t)return;throw new g.NoTreeViewError(l)}d.setVisible(t)}$changeCheckboxState(l,t){const d=this.treeViews.get(l);if(!d)throw new g.NoTreeViewError(l);d.setCheckboxState(t)}createExtHostTreeView(l,t,d){const s=this._register(new o(l,t,this._proxy,this.commands.converter,this.logService,d));return this.treeViews.set(l,s),s}convertArgument(l){const t=this.treeViews.get(l.$treeViewId);return t&&"$treeItemHandle"in l?t.getExtensionElement(l.$treeItemHandle):t&&"$focusedTreeItem"in l&&l.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=n;class o extends T.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(l=>this.getExtensionElement(l)).filter(l=>!(0,R.isUndefinedOrNull)(l))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(l,t,d,s,b,_){if(super(),this.viewId=l,this.proxy=d,this.commands=s,this.logService=b,this.extension=_,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new A.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new A.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new E.CancellationTokenSource,_.contributes&&_.contributes.views)for(const m in _.contributes.views)for(const v of _.contributes.views[m])v.id===l&&(this._title=v.name);this.dataProvider=t.treeDataProvider,this.dndController=t.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(m=>this._onDidChangeData.fire({message:!1,element:m})));let f,w;const P=A.Event.debounce(this._onDidChangeData.event,(m,v)=>(m||(m={message:!1,elements:[]}),v.element!==!1&&(f||(f=new Promise(y=>w=y),this.refreshPromise=this.refreshPromise.then(()=>f)),Array.isArray(v.element)?m.elements.push(...v.element):m.elements.push(v.element)),v.message&&(m.message=!0),m),200,!0);this._register(P(({message:m,elements:v})=>{v.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const y=w;return f=null,this.refresh(v).then(()=>y())})),m&&this.proxy.$setMessage(this.viewId,u.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(l){const t=l?this.getExtensionElement(l):void 0;if(l&&!t)return this.logService.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let d=this.getChildrenNodes(l);return d||(d=await this.fetchChildrenNodes(t)),d?d.map(s=>s.item):void 0}getExtensionElement(l){return this.elements.get(l)}reveal(l,t){t=t||{select:!0,focus:!1};const d=(0,R.isUndefinedOrNull)(t.select)?!0:t.select,s=(0,R.isUndefinedOrNull)(t.focus)?!1:t.focus,b=(0,R.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.refreshPromise.then(()=>this.resolveUnknownParentChain(l)).then(_=>this.resolveTreeNode(l,_[_.length-1]).then(f=>this.proxy.$reveal(this.viewId,{item:f.item,parentChain:_.map(w=>w.item)},{select:d,focus:s,expand:b})),_=>this.logService.error(_)):this.proxy.$reveal(this.viewId,void 0,{select:d,focus:s,expand:b})}get message(){return this._message}set message(l){this._message=l,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(l){this._title=l,this.proxy.$setTitle(this.viewId,l,this._description)}get description(){return this._description}set description(l){this._description=l,this.proxy.$setTitle(this.viewId,this._title,l)}get badge(){return this._badge}set badge(l){this._badge?.value===l?.value&&this._badge?.tooltip===l?.tooltip||(this._badge=u.ViewBadge.from(l),this.proxy.$setBadge(this.viewId,l))}setExpanded(l,t){const d=this.getExtensionElement(l);d&&(t?this._onDidExpandElement.fire(Object.freeze({element:d})):this._onDidCollapseElement.fire(Object.freeze({element:d})))}setSelectionAndFocus(l,t){const d=!(0,D.equals)(this._selectedHandles,l);this._selectedHandles=l;const s=this._focusedHandle!==t;this._focusedHandle=t,d&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),s&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(l){l!==this._visible&&(this._visible=l,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(l){const t=(await Promise.all(l.map(async d=>{const s=this.getExtensionElement(d.treeItemHandle);return s?{extensionItem:s,treeItem:await this.dataProvider.getTreeItem(s),newState:d.newState?S.TreeItemCheckboxState.Checked:S.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(d=>d!==void 0);t.forEach(d=>{d.treeItem.checkboxState=d.newState?S.TreeItemCheckboxState.Checked:S.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:t.map(d=>[d.extensionItem,d.newState])})}async handleDrag(l,t,d){const s=[];for(const b of l){const _=this.getExtensionElement(b);_&&s.push(_)}if(!(!this.dndController?.handleDrag||s.length===0))return await this.dndController.handleDrag(s,t,d),t}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(l,t,d){const s=t?this.getExtensionElement(t):void 0;if(!(!s&&t||!this.dndController?.handleDrop))return(0,h.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(s,l,d):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(l,t){if(!this.dataProvider.resolveTreeItem)return;const d=this.elements.get(l);if(d){const s=this.nodes.get(d);if(s){const b=await this.dataProvider.resolveTreeItem(s.extensionItem,d,t)??s.extensionItem;return this.validateTreeItem(b),s.item.tooltip=this.getTooltip(b.tooltip),s.item.command=this.getCommand(s.disposableStore,b.command),s.item}}}resolveUnknownParentChain(l){return this.resolveParent(l).then(t=>t?this.resolveUnknownParentChain(t).then(d=>this.resolveTreeNode(t,d[d.length-1]).then(s=>(d.push(s),d))):Promise.resolve([]))}resolveParent(l){const t=this.nodes.get(l);return t?Promise.resolve(t.parent?this.elements.get(t.parent.item.handle):void 0):(0,h.asPromise)(()=>this.dataProvider.getParent(l))}resolveTreeNode(l,t){const d=this.nodes.get(l);return d?Promise.resolve(d):(0,h.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(s=>this.createHandle(l,s,t,!0)).then(s=>this.getChildren(t?t.item.handle:void 0).then(()=>{const b=this.getExtensionElement(s);if(b){const _=this.nodes.get(b);if(_)return Promise.resolve(_)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(l){if(l){let t;if(typeof l=="string"){const d=this.getExtensionElement(l);t=d?this.nodes.get(d):void 0}else t=l;return t&&t.children||void 0}return this.roots}async fetchChildrenNodes(l){this.clearChildren(l);const t=new E.CancellationTokenSource(this._refreshCancellationSource.token);try{const d=l?this.nodes.get(l):void 0,s=await this.dataProvider.getChildren(l);if(t.token.isCancellationRequested)return;const b=(0,D.coalesce)(s||[]),_=await Promise.all((0,D.coalesce)(b).map(w=>this.dataProvider.getTreeItem(w)));if(t.token.isCancellationRequested)return;const f=_.map((w,P)=>w?this.createAndRegisterTreeNode(b[P],w,d):null);return(0,D.coalesce)(f)}finally{t.dispose()}}refresh(l){if(l.some(d=>!d))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new E.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const d=this.getHandlesToRefresh(l);if(d.length)return this.refreshHandles(d)}return Promise.resolve(void 0)}getHandlesToRefresh(l){const t=new Set,d=l.map(b=>this.nodes.get(b));for(const b of d)if(b&&!t.has(b.item.handle)){let _=b;for(;_&&_.parent&&d.findIndex(f=>_&&_.parent&&f&&f.item.handle===_.parent.item.handle)===-1;){const f=this.elements.get(_.parent.item.handle);_=f?this.nodes.get(f):void 0}_&&!_.parent&&t.add(b.item.handle)}const s=[];return t.forEach(b=>{const _=this.elements.get(b);if(_){const f=this.nodes.get(_);f&&(!f.parent||!t.has(f.parent.item.handle))&&s.push(b)}}),s}refreshHandles(l){const t={};return Promise.all(l.map(d=>this.refreshNode(d).then(s=>{s&&(t[d]=s.item)}))).then(()=>Object.keys(t).length?this.proxy.$refresh(this.viewId,t):void 0)}refreshNode(l){const t=this.getExtensionElement(l);if(t){const d=this.nodes.get(t);if(d)return this.clearChildren(t),(0,h.asPromise)(()=>this.dataProvider.getTreeItem(t)).then(s=>{if(s){const b=this.createTreeNode(t,s,d.parent);return this.updateNodeCache(t,b,d,d.parent),d.dispose(),b}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(l,t,d){const s=this.createTreeNode(l,t,d);if(t.id&&this.elements.has(s.item.handle))throw new Error((0,I.localize)(0,null,t.id));return this.addNodeToCache(l,s),this.addNodeToParentCache(s,d),s}getTooltip(l){return S.MarkdownString.isMarkdownString(l)?u.MarkdownString.from(l):l}getCommand(l,t){return t?{...this.commands.toInternal(t,l),originalId:t.command}:void 0}getCheckbox(l){if(l.checkboxState===void 0)return;let t,d,s;return typeof l.checkboxState=="number"?t=l.checkboxState:(t=l.checkboxState.state,d=l.checkboxState.tooltip,s=l.checkboxState.accessibilityInformation),{isChecked:t===S.TreeItemCheckboxState.Checked,tooltip:d,accessibilityInformation:s}}validateTreeItem(l){if(!S.TreeItem.isTreeItem(l,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(l,t,d){this.validateTreeItem(t);const s=this._register(new T.DisposableStore),b=this.createHandle(l,t,d),_=this.getLightIconPath(t);return{item:{handle:b,parentHandle:d?d.item.handle:void 0,label:r(t.label,this.extension),description:t.description,resourceUri:t.resourceUri,tooltip:this.getTooltip(t.tooltip),command:this.getCommand(s,t.command),contextValue:t.contextValue,icon:_,iconDark:this.getDarkIconPath(t)||_,themeIcon:this.getThemeIcon(t),collapsibleState:(0,R.isUndefinedOrNull)(t.collapsibleState)?S.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.getCheckbox(t)},extensionItem:t,parent:d,children:void 0,disposableStore:s,dispose(){s.dispose()}}}getThemeIcon(l){return l.iconPath instanceof S.ThemeIcon?l.iconPath:void 0}createHandle(l,{id:t,label:d,resourceUri:s},b,_){if(t)return`${o.ID_HANDLE_PREFIX}/${t}`;const f=r(d,this.extension),w=b?b.item.handle:o.LABEL_HANDLE_PREFIX;let P=f?f.label:s?(0,L.basename)(s):"";P=P.indexOf("/")!==-1?P.replace("/","//"):P;const m=this.nodes.has(l)?this.nodes.get(l).item.handle:void 0,v=this.getChildrenNodes(b)||[];let y,O=0;do{if(y=`${w}/${O}:${P}`,_||!this.elements.has(y)||m===y)break;O++}while(O<=v.length);return y}getLightIconPath(l){if(l.iconPath&&!(l.iconPath instanceof S.ThemeIcon))return typeof l.iconPath=="string"||C.URI.isUri(l.iconPath)?this.getIconPath(l.iconPath):this.getIconPath(l.iconPath.light)}getDarkIconPath(l){if(l.iconPath&&!(l.iconPath instanceof S.ThemeIcon)&&l.iconPath.dark)return this.getIconPath(l.iconPath.dark)}getIconPath(l){return C.URI.isUri(l)?l:C.URI.file(l)}addNodeToCache(l,t){this.elements.set(t.item.handle,l),this.nodes.set(l,t)}updateNodeCache(l,t,d,s){this.elements.delete(t.item.handle),this.nodes.delete(l),t.item.handle!==d.item.handle&&this.elements.delete(d.item.handle),this.addNodeToCache(l,t);const b=this.getChildrenNodes(s)||[],_=b.filter(f=>f.item.handle===d.item.handle)[0];_&&b.splice(b.indexOf(_),1,t)}addNodeToParentCache(l,t){t?(t.children||(t.children=[]),t.children.push(l)):(this.roots||(this.roots=[]),this.roots.push(l))}clearChildren(l){if(l){const t=this.nodes.get(l);if(t){if(t.children)for(const d of t.children){const s=this.elements.get(d.item.handle);s&&this.clear(s)}t.children=void 0}}else this.clearAll()}clear(l){const t=this.nodes.get(l);if(t){if(t.children)for(const d of t.children){const s=this.elements.get(d.item.handle);s&&this.clear(s)}this.nodes.delete(l),this.elements.delete(t.item.handle),t.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(l=>l.dispose()),this.nodes.clear()}dispose(){super.dispose(),this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(Pe[277],Te([1,0,5,6,2,33,8,61,3,7]),function(me,e,I,L,C,A,T,g,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class R extends L.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#h;#d;constructor(E,i,a,r){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#h=this._register(new I.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new I.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=E,this.#t=i,this.#n=a,this.#i=r.viewType,this.#s=r.panelOptions,this.#o=r.viewColumn,this.#r=r.title,this.#l=r.active}dispose(){this.#u||(this.#u=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#n}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#r}set title(E){this.assertNotDisposed(),this.#r!==E&&(this.#r=E,this.#t.$setTitle(this.#e,E))}get iconPath(){return this.assertNotDisposed(),this.#a}set iconPath(E){this.assertNotDisposed(),this.#a!==E&&(this.#a=E,this.#t.$setIconPath(this.#e,C.URI.isUri(E)?{light:E,dark:E}:E))}get options(){return this.#s}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.assertNotDisposed(),this.#l}get visible(){return this.assertNotDisposed(),this.#c}_updateViewState(E){this.#u||(this.active!==E.active||this.visible!==E.visible||this.viewColumn!==E.viewColumn)&&(this.#l=E.active,this.#c=E.visible,this.#o=E.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(E,i){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof E>"u"?void 0:T.ViewColumn.from(E),preserveFocus:!!i})}assertNotDisposed(){if(this.#u)throw new Error("Webview is disposed")}}class D extends L.Disposable{static newHandle(){return(0,A.generateUuid)()}constructor(E,i,a){super(),this.webviews=i,this.workspace=a,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=E.getProxy(h.MainContext.MainThreadWebviewPanels)}dispose(){super.dispose(),this._webviewPanels.forEach(E=>E.dispose()),this._webviewPanels.clear()}createWebviewPanel(E,i,a,r,n={}){const o=typeof r=="object"?r.viewColumn:r,c={viewColumn:T.ViewColumn.from(o),preserveFocus:typeof r=="object"&&!!r.preserveFocus},l=(0,g.shouldSerializeBuffersForPostMessage)(E),t=D.newHandle();this._proxy.$createWebviewPanel((0,g.toExtensionData)(E),t,i,{title:a,panelOptions:u(n),webviewOptions:(0,g.serializeWebviewOptions)(E,this.workspace,n),serializeBuffersForPostMessage:l},c);const d=this.webviews.createNewWebview(t,n,E);return this.createNewWebviewPanel(t,i,a,o,n,d,!0)}$onDidChangeWebviewPanelViewStates(E){const i=Object.keys(E);i.sort((a,r)=>{const n=E[a],o=E[r];return n.active?1:o.active?-1:+n.visible-+o.visible});for(const a of i){const r=this.getWebviewPanel(a);if(!r)continue;const n=E[a];r._updateViewState({active:n.active,visible:n.visible,viewColumn:T.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(E){this.getWebviewPanel(E)?.dispose(),this._webviewPanels.delete(E),this.webviews.deleteWebview(E)}registerWebviewPanelSerializer(E,i,a){if(this._serializers.has(i))throw new Error(`Serializer for '${i}' already registered`);return this._serializers.set(i,{serializer:a,extension:E}),this._proxy.$registerSerializer(i,{serializeBuffersForPostMessage:(0,g.shouldSerializeBuffersForPostMessage)(E)}),new S.Disposable(()=>{this._serializers.delete(i),this._proxy.$unregisterSerializer(i)})}async $deserializeWebviewPanel(E,i,a,r){const n=this._serializers.get(i);if(!n)throw new Error(`No serializer found for '${i}'`);const{serializer:o,extension:c}=n,l=this.webviews.createNewWebview(E,a.webviewOptions,c),t=this.createNewWebviewPanel(E,i,a.title,r,a.panelOptions,l,a.active);await o.deserializeWebviewPanel(t,a.state)}createNewWebviewPanel(E,i,a,r,n,o,c){const l=new R(E,this._proxy,o,{viewType:i,title:a,viewColumn:r,panelOptions:n,active:c});return this._webviewPanels.set(E,l),l}getWebviewPanel(E){return this._webviewPanels.get(E)}}e.ExtHostWebviewPanels=D;function u(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}}),define(Pe[278],Te([1,0,5,6,61,8,3,7]),function(me,e,I,L,C,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class h extends L.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(D,u,p,E,i,a){super(),this.#s=!1,this.#l=this._register(new I.Emitter),this.onDidChangeVisibility=this.#l.event,this.#u=this._register(new I.Emitter),this.onDidDispose=this.#u.event,this.#i=p,this.#a=E,this.#e=D,this.#t=u,this.#n=i,this.#r=a}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.assertNotDisposed(),this.#a}set title(D){this.assertNotDisposed(),this.#a!==D&&(this.#a=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.assertNotDisposed(),this.#o}set description(D){this.assertNotDisposed(),this.#o!==D&&(this.#o=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(D){D===this.#r||this.#s||(this.#r=D,this.#l.fire())}get badge(){return this.assertNotDisposed(),this.#c}set badge(D){this.assertNotDisposed(),!(D?.value===this.#c?.value&&D?.tooltip===this.#c?.tooltip)&&(this.#c=A.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.assertNotDisposed(),this.#t.$show(this.#e,!!D)}assertNotDisposed(){if(this.#s)throw new Error("Webview is disposed")}}class S{constructor(D,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=D.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(D,u,p,E){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:p,extension:D}),this._proxy.$registerWebviewViewProvider((0,C.toExtensionData)(D),u,{retainContextWhenHidden:E?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(D)}),new g.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(D,u,p,E,i){const a=this._viewProviders.get(u);if(!a)throw new Error(`No view provider found for '${u}'`);const{provider:r,extension:n}=a,o=this._extHostWebview.createNewWebview(D,{},n),c=new h(D,this._proxy,u,p,o,!0);this._webviewViews.set(D,c),await r.resolveWebviewView(c,{state:E},i)}async $onDidChangeWebviewViewVisibility(D,u){this.getWebviewView(D)._setVisible(u)}async $disposeWebviewView(D){const u=this.getWebviewView(D);this._webviewViews.delete(D),u.dispose(),this._extHostWebview.deleteWebview(D)}getWebviewView(D){const u=this._webviewViews.get(D);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=S}),define(Pe[279],Te([1,0,5,30,35,4]),function(me,e,I,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_FILE_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new C.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_FILE_OUTPUT=new C.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new C.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,A.createDecorator)("outputService");var T;(function(h){h[h.Append=1]="Append",h[h.Replace=2]="Replace",h[h.Clear=3]="Clear"})(T||(e.OutputChannelUpdateMode=T={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class g{constructor(){this.channels=new Map,this._onDidRegisterChannel=new I.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new I.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(S){this.channels.has(S.id)||(this.channels.set(S.id,S),this._onDidRegisterChannel.fire(S.id))}getChannels(){const S=[];return this.channels.forEach(R=>S.push(R)),S}getChannel(S){return this.channels.get(S)}removeChannel(S){this.channels.delete(S),this._onDidRemoveChannel.fire(S)}}L.Registry.add(e.Extensions.OutputChannels,new g),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new C.RawContextKey("activeOutputChannel","")}),define(Pe[112],Te([1,0,3,4,17,22,14,279,62,27,43,136,23,16,42,5,6]),function(me,e,I,L,C,A,T,g,h,S,R,D,u,p,E,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class r extends T.AbstractMessageLogger{get disposed(){return this._disposed}constructor(l,t,d,s,b){super(),this.id=l,this.name=t,this.logger=d,this.proxy=s,this.extension=b,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(d.getLevel()),this._register(d.onDidChangeLogLevel(_=>this.setLevel(_)))}get logLevel(){return this.getLevel()}appendLine(l){this.append(l+`
`)}append(l){this.info(l)}clear(){const l=this.offset;this.logger.flush(),this.proxy.$update(this.id,g.OutputChannelUpdateMode.Clear,l)}replace(l){const t=this.offset;this.info(l),this.proxy.$update(this.id,g.OutputChannelUpdateMode.Replace,t),this.visible&&this.logger.flush()}show(l,t){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof l=="boolean"?l:t))}hide(){this.proxy.$close(this.id)}log(l,t){this.offset+=u.VSBuffer.fromString(t).byteLength,(0,T.log)(this.logger,l,t),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,g.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class n extends r{appendLine(l){this.append(l)}}let o=class{constructor(l,t,d,s,b,_){this.initData=t,this.extHostFileSystem=d,this.extHostFileSystemInfo=s,this.loggerService=b,this.logService=_,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=l.getProxy(I.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(t.logsLocation,`output_logging_${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(l){this.visibleChannelId=l;for(const[t,d]of this.channels)d.visible=t===this.visibleChannelId}createOutputChannel(l,t,d){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");const s=typeof t=="object"&&t.log,b=(0,p.isString)(t)?t:void 0;if((0,p.isString)(b)&&!b.trim())throw new Error("illegal argument `languageId`. must not be empty");let _;const f=this.initData.environment.extensionLogLevel?.find(([P])=>A.ExtensionIdentifier.equals(d.identifier,P))?.[1];f&&(_=(0,T.parseLogLevel)(f));const w=s?this.doCreateLogOutputChannel(l,_,d):this.doCreateOutputChannel(l,b,d);return w.then(P=>{this.channels.set(P.id,P),P.visible=P.id===this.visibleChannelId}),s?this.createExtHostLogOutputChannel(l,_??this.logService.getLevel(),w):this.createExtHostOutputChannel(l,w)}async doCreateOutputChannel(l,t,d){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const s=await this.outputDirectoryPromise,b=this.extHostFileSystemInfo.extUri.joinPath(s,`${this.namePool++}-${l.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),_=this.loggerService.createLogger(b,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),f=await this.proxy.$register(l,b,t,d.identifier.value);return new r(f,l,_,this.proxy,d)}async doCreateLogOutputChannel(l,t,d){const s=await this.createExtensionLogDirectory(d),b=l.replace(/[\\/:\*\?"<>\|]/g,""),_=this.extHostFileSystemInfo.extUri.joinPath(s,`${b}.log`),f=`${d.identifier.value}.${b}`,w=this.loggerService.createLogger(_,{id:f,name:l,logLevel:t,extensionId:d.identifier.value});return new n(f,l,w,this.proxy,d)}createExtensionLogDirectory(l){let t=this.extensionLogDirectoryPromise.get(l.identifier.value);if(!t){const d=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,l.identifier.value);this.extensionLogDirectoryPromise.set(l.identifier.value,t=(async()=>{try{await this.extHostFileSystem.value.createDirectory(d)}catch(s){if((0,E.toFileSystemProviderErrorCode)(s)!==E.FileSystemProviderErrorCode.FileExists)throw s}return d})())}return t}createExtHostOutputChannel(l,t){let d=!1;const s=()=>{if(d)throw new Error("Channel has been closed")};return{get name(){return l},append(b){s(),t.then(_=>_.append(b))},appendLine(b){s(),t.then(_=>_.appendLine(b))},clear(){s(),t.then(b=>b.clear())},replace(b){s(),t.then(_=>_.replace(b))},show(b,_){s(),t.then(f=>f.show(b,_))},hide(){s(),t.then(b=>b.hide())},dispose(){d=!0,t.then(b=>b.dispose())}}}createExtHostLogOutputChannel(l,t,d){const s=new a.DisposableStore,b=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},_=s.add(new i.Emitter);function f(w){t=w,_.fire(w)}return d.then(w=>{s.add(w),w.logLevel!==t&&f(w.logLevel),s.add(w.onDidChangeLogLevel(P=>f(P)))}),{...this.createExtHostOutputChannel(l,d),get logLevel(){return t},onDidChangeLogLevel:_.event,trace(w,...P){b(),d.then(m=>m.trace(w,...P))},debug(w,...P){b(),d.then(m=>m.debug(w,...P))},info(w,...P){b(),d.then(m=>m.info(w,...P))},warn(w,...P){b(),d.then(m=>m.warn(w,...P))},error(w,...P){b(),d.then(m=>m.error(w,...P))},dispose(){s.dispose()}}}};e.ExtHostOutputService=o,e.ExtHostOutputService=o=Ke([We(0,C.IExtHostRpcService),We(1,S.IExtHostInitDataService),We(2,h.IExtHostConsumerFileSystem),We(3,R.IExtHostFileSystemInfo),We(4,T.ILoggerService),We(5,T.ILogService)],o),e.IExtHostOutputService=(0,L.createDecorator)("IExtHostOutputService")}),define(Pe[113],Te([1,0,4,13]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,I.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let A=1/0;for(let g=0;g<this.maxSampleCount;g++){const h=await C.getRoundTripTime();if(h===void 0)return;A=Math.min(A,h/2),await(0,L.timeout)(this.sampleDelay)}this.average.push(A),this.average.length>this.maxAverageCount&&this.average.shift();let T;return this.initial.length<this.maxInitialCount?this.initial.push(A):T=this.initial.reduce((g,h)=>g+h,0)/this.initial.length,this.lastMeasurement={initial:T,current:A,average:this.average.reduce((g,h)=>g+h,0)/this.average.length,high:(()=>typeof T>"u"?!1:A>this.highLatencyMaxThreshold||A>this.highLatencyMinThreshold&&A>T*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Pe[280],Te([1,0,169,55,30,47,46,6,5,113,21,26]),function(me,e,I,L,C,A,T,g,h,S,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DynamicWorkbenchConfigurationWorkbenchContribution=e.ConfigurationMigrationWorkbenchContribution=e.Extensions=e.problemsConfigurationNodeBase=e.securityConfigurationNodeBase=e.workbenchConfigurationNodeBase=e.applicationConfigurationNodeBase=void 0,e.applicationConfigurationNodeBase=Object.freeze({id:"application",order:100,title:(0,I.localize)(0,null),type:"object"}),e.workbenchConfigurationNodeBase=Object.freeze({id:"workbench",order:7,title:(0,I.localize)(1,null),type:"object"}),e.securityConfigurationNodeBase=Object.freeze({id:"security",scope:1,title:(0,I.localize)(2,null),type:"object",order:7}),e.problemsConfigurationNodeBase=Object.freeze({id:"problems",title:(0,I.localize)(3,null),type:"object",order:101}),e.Extensions={ConfigurationMigration:"base.contributions.configuration.migration"};class u{constructor(){this.migrations=[],this._onDidRegisterConfigurationMigrations=new h.Emitter,this.onDidRegisterConfigurationMigration=this._onDidRegisterConfigurationMigrations.event}registerConfigurationMigrations(r){this.migrations.push(...r)}}const p=new u;C.Registry.add(e.Extensions.ConfigurationMigration,p);let E=class extends g.Disposable{constructor(r,n){super(),this.configurationService=r,this.workspaceService=n,this._register(this.workspaceService.onDidChangeWorkspaceFolders(async o=>{for(const c of o.added)await this.migrateConfigurationsForFolder(c,p.migrations)})),this.migrateConfigurations(p.migrations),this._register(p.onDidRegisterConfigurationMigration(o=>this.migrateConfigurations(o)))}async migrateConfigurations(r){await this.migrateConfigurationsForFolder(void 0,r);for(const n of this.workspaceService.getWorkspace().folders)await this.migrateConfigurationsForFolder(n,r)}async migrateConfigurationsForFolder(r,n){await Promise.all([n.map(o=>this.migrateConfigurationsForFolderAndOverride(o,r?.uri))])}async migrateConfigurationsForFolderAndOverride(r,n){const o=this.configurationService.inspect(r.key,{resource:n}),c=this.workspaceService.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[l,t]of c){const d=[];for(const b of o.overrideIdentifiers??[]){const _=await this.runMigration(r,{resource:n,overrideIdentifier:b},l);for(const f of _??[]){let w=d.find(([[P,m]])=>P===f[0]&&(0,D.equals)(m.value,f[1].value));w||d.push(w=[f,[]]),w[1].push(b)}}const s=await this.runMigration(r,{resource:n},l,o);for(const b of s??[])d.push([b,[]]);d.length&&await Promise.allSettled(d.map(async([[b,_],f])=>this.configurationService.updateValue(b,_.value,{resource:n,overrideIdentifiers:f},t)))}}async runMigration(r,n,o,c){const l=b=>t(this.configurationService.inspect(b,n)),t=b=>{const _=b[o];return n.overrideIdentifier?_?.override:_?.value},d=c?t(c):l(r.key);if(d===void 0)return;const s=await r.migrateFn(d,l);return Array.isArray(s)?s:[[r.key,s]]}};e.ConfigurationMigrationWorkbenchContribution=E,e.ConfigurationMigrationWorkbenchContribution=E=Ke([We(0,T.IConfigurationService),We(1,A.IWorkspaceContextService)],E);let i=class extends g.Disposable{constructor(r){super(),(async()=>{if(!R.isWindows&&(await r.getEnvironment())?.os!==1)return;C.Registry.as(L.Extensions.Configuration).registerConfiguration({...e.securityConfigurationNodeBase,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,I.localize)(4,null)},default:[],markdownDescription:(0,I.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,I.localize)(6,null),scope:2}}})})()}};e.DynamicWorkbenchConfigurationWorkbenchContribution=i,e.DynamicWorkbenchConfigurationWorkbenchContribution=i=Ke([We(0,S.IRemoteAgentService)],i)}),define(Pe[281],Te([1,0,34,11,19,25,177,280,55,4,30]),function(me,e,I,L,C,A,T,g,h,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.globMatchesResource=e.priorityToRank=e.ResolvedStatus=e.RegisteredEditorPriority=e.editorsAssociationsSettingId=e.IEditorResolverService=void 0,e.IEditorResolverService=(0,S.createDecorator)("editorResolverService"),e.editorsAssociationsSettingId="workbench.editorAssociations";const D=R.Registry.as(h.Extensions.Configuration),u={...g.workbenchConfigurationNodeBase,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,T.localize)(0,null),additionalProperties:{type:"string"}}}};D.registerConfiguration(u);var p;(function(r){r.builtin="builtin",r.option="option",r.exclusive="exclusive",r.default="default"})(p||(e.RegisteredEditorPriority=p={}));var E;(function(r){r[r.ABORT=1]="ABORT",r[r.NONE=2]="NONE"})(E||(e.ResolvedStatus=E={}));function i(r){switch(r){case p.exclusive:return 5;case p.default:return 4;case p.builtin:return 3;case p.option:default:return 1}}e.priorityToRank=i;function a(r,n){if(new Set([L.Schemas.extension,L.Schemas.webviewPanel,L.Schemas.vscodeWorkspaceTrust,L.Schemas.vscodeSettings]).has(n.scheme))return!1;const l=typeof r=="string"&&r.indexOf(C.posix.sep)>=0?`${n.scheme}:${n.path}`:(0,A.basename)(n);return I.match(typeof r=="string"?r.toLowerCase():r,l.toLowerCase())}e.globMatchesResource=a}),define(Pe[282],Te([1,0,45,11,19,21,25,2,4,198,47,216,113]),function(me,e,I,L,C,A,T,g,h,S,R,D,u){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,h.createDecorator)("pathService");let E=p=class{constructor(a,r,n,o){this.localUserHome=a,this.remoteAgentService=r,this.environmentService=n,this.contextService=o,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||A.OS)(),this.resolveUserHome=(async()=>{const c=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=c?.userHome??a})()}hasValidBasename(a,r,n){return typeof r=="string"||typeof r>"u"?this.resolveOS.then(o=>this.doHasValidBasename(a,o,r)):this.doHasValidBasename(a,r,n)}doHasValidBasename(a,r,n){return a.scheme===L.Schemas.file||a.scheme===L.Schemas.vscodeRemote?(0,I.isValidBasename)(n??(0,T.basename)(a),r===1):!0}get defaultUriScheme(){return p.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(a,r){if(a.remoteAuthority)return L.Schemas.vscodeRemote;const n=(0,S.getVirtualWorkspaceScheme)(r.getWorkspace());if(n)return n;const o=r.getWorkspace().folders[0];if(o)return o.uri.scheme;const c=r.getWorkspace().configuration;return c?c.scheme:L.Schemas.file}userHome(a){return a?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(a=>a===1?C.win32:C.posix)}async fileURI(a){let r="";if(await this.resolveOS===1&&(a=a.replace(/\\/g,"/")),a[0]==="/"&&a[1]==="/"){const o=a.indexOf("/",2);o===-1?(r=a.substring(2),a="/"):(r=a.substring(2,o),a=a.substring(o)||"/")}return g.URI.from({scheme:L.Schemas.file,authority:r,path:a,query:"",fragment:""})}};e.AbstractPathService=E,e.AbstractPathService=E=p=Ke([We(1,u.IRemoteAgentService),We(2,D.IWorkbenchEnvironmentService),We(3,R.IWorkspaceContextService)],E)}),define(Pe[114],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class I{constructor(T,g){this.line=T,this.character=g}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,g){return new I(0,0)}with(T){return new I(0,0)}}e.Position=I;class L{constructor(T,g,h,S){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(T,g),this.end=new I(h,S)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new L(0,0,0,0)}with(T){return new L(0,0,0,0)}}e.Range=L;var C;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Pe[44],Te([1,0,18,34,26,45,12,4,19,15,114,13]),function(me,e,I,L,C,A,T,g,h,S,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.SEARCH_RESULT_LANGUAGE_ID=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_RESULT_LANGUAGE_ID="search-result",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const u="\u27EA ",p=" characters skipped \u27EB",E=(u.length+p.length+5)*2;e.ISearchService=(0,g.createDecorator)("searchService");var i;(function(le){le[le.file=0]="file",le[le.text=1]="text"})(i||(e.SearchProviderType=i={}));var a;(function(le){le[le.File=1]="File",le[le.Text=2]="Text"})(a||(e.QueryType=a={}));function r(le){return!!le.preview}e.resultIsMatch=r;function n(le){return!!le.resource}e.isFileMatch=n;function o(le){return!!le.message}e.isProgressMessage=o;var c;(function(le){le[le.Normal=0]="Normal",le[le.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class l{constructor(ve){this.resource=ve,this.results=[]}}e.FileMatch=l;class t{constructor(ve,ae,pe,re){this.ranges=ae,this.webviewIndex=re;const J=Array.isArray(ae)?ae:[ae];if(pe&&pe.matchLines===1&&d(J)){ve=(0,T.getNLines)(ve,pe.matchLines);let H="",ne=0,Ae=0;const Re=Math.floor(pe.charsPerLine/5),ke=[];for(const ce of J){const te=Math.max(ce.startColumn-Re,0),K=ce.startColumn+pe.charsPerLine;if(te>Ae+Re+E){const ee=u+(te-Ae)+p;H+=ee+ve.slice(te,K),ne+=te-(Ae+ee.length)}else H+=ve.slice(Ae,K);ke.push(new b(0,ce.startColumn-ne,ce.endColumn-ne)),Ae=K}this.preview={text:H,matches:Array.isArray(this.ranges)?ke:ke[0]}}else{const H=Array.isArray(ae)?ae[0].startLineNumber:ae.startLineNumber;this.preview={text:ve,matches:(0,I.mapArrayOrNot)(ae,ne=>new s(ne.startLineNumber-H,ne.startColumn,ne.endLineNumber-H,ne.endColumn))}}}}e.TextSearchMatch=t;function d(le){const ve=le[0].startLineNumber;for(const ae of le)if(ae.startLineNumber!==ve||ae.endLineNumber!==ve)return!1;return!0}class s{constructor(ve,ae,pe,re){this.startLineNumber=ve,this.startColumn=ae,this.endLineNumber=pe,this.endColumn=re}}e.SearchRange=s;class b extends s{constructor(ve,ae,pe){super(ve,ae,ve,pe)}}e.OneLineRange=b;var _;(function(le){le.List="list",le.Tree="tree"})(_||(e.ViewMode=_={}));var f;(function(le){le.Default="default",le.FileNames="fileNames",le.Type="type",le.Modified="modified",le.CountDescending="countDescending",le.CountAscending="countAscending"})(f||(e.SearchSortOrder=f={}));function w(le,ve=!0){const ae=le&&le.files&&le.files.exclude,pe=ve&&le&&le.search&&le.search.exclude;if(!ae&&!pe)return;if(!ae||!pe)return ae||pe;let re=Object.create(null);return re=C.mixin(re,C.deepClone(ae)),re=C.mixin(re,C.deepClone(pe),!0),re}e.getExcludes=w;function P(le,ve){return le.excludePattern&&L.match(le.excludePattern,ve)?!1:le.includePattern||le.usingSearchPaths?le.includePattern&&L.match(le.includePattern,ve)?!0:le.usingSearchPaths?!!le.folderQueries&&le.folderQueries.some(ae=>{const pe=ae.folder.fsPath;if(A.isEqualOrParent(ve,pe)){const re=h.relative(pe,ve);return!ae.includePattern||!!L.match(ae.includePattern,re)}else return!1}):!1:!0}e.pathIncludedInQuery=P;var m;(function(le){le[le.unknownEncoding=1]="unknownEncoding",le[le.regexParseError=2]="regexParseError",le[le.globParseError=3]="globParseError",le[le.invalidLiteral=4]="invalidLiteral",le[le.rgProcessError=5]="rgProcessError",le[le.other=6]="other",le[le.canceled=7]="canceled"})(m||(e.SearchErrorCode=m={}));class v extends Error{constructor(ve,ae){super(ve),this.code=ae}}e.SearchError=v;function y(le){const ve=le.message;if((0,S.isCancellationError)(le))return new v(ve,m.canceled);try{const ae=JSON.parse(ve);return new v(ae.message,ae.code)}catch{return new v(ve,m.other)}}e.deserializeSearchError=y;function O(le){const ve={message:le.message,code:le.code};return new Error(JSON.stringify(ve))}e.serializeSearchError=O;function N(le){return le.type==="error"?!0:le.type==="success"}e.isSerializedSearchComplete=N;function q(le){return le.type==="success"}e.isSerializedSearchSuccess=q;function W(le){return!!le.path}e.isSerializedFileMatch=W;function x(le,ve){const ae=le.searchPath?le.searchPath:le.relativePath;return(0,T.fuzzyContains)(ae,ve)}e.isFilePatternMatch=x;class k{constructor(ve){this.path=ve,this.results=[]}addMatch(ve){this.results.push(ve)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=k;function M(le,ve){const ae={...le||{},...ve||{}};return Object.keys(ae).filter(pe=>{const re=ae[pe];return typeof re=="boolean"&&re})}e.resolvePatternsForProvider=M;class ${constructor(ve,ae){this._parsedIncludeExpression=null,this._excludeExpression={...ve.excludePattern||{},...ae.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let pe=ve.includePattern;ae.includePattern&&(pe?pe={...pe,...ae.includePattern}:pe=ae.includePattern),pe&&(this._parsedIncludeExpression=L.parse(pe))}matchesExcludesSync(ve,ae,pe){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ve,ae,pe))}includedInQuerySync(ve,ae,pe){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ve,ae,pe)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ve,ae,pe))}includedInQuery(ve,ae,pe){const re=this._parsedExcludeExpression(ve,ae,pe),J=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ve,ae,pe):!0;return(0,D.isThenable)(re)?re.then(H=>H?!1:J()):J()}hasSiblingExcludeClauses(){return oe(this._excludeExpression)}}e.QueryGlobTester=$;function oe(le){for(const ve in le)if(typeof le[ve]!="boolean")return!0;return!1}function de(le){if(!le)return;let ve;return ae=>(ve||(ve=(le()||Promise.resolve([])).then(pe=>pe?ye(pe):{})),ve.then(pe=>!!pe[ae]))}e.hasSiblingPromiseFn=de;function we(le){if(!le)return;let ve;return ae=>{if(!ve){const pe=le();ve=pe?ye(pe):{}}return!!ve[ae]}}e.hasSiblingFn=we;function ye(le){const ve={};for(const ae of le)ve[ae]=!0;return ve}}),define(Pe[36],Te([1,0,18,13,20,5,6,50,11,122,25,12,2,168,4,14,187,47,43,27,17,8,7,58,44,3,51]),function(me,e,I,L,C,A,T,g,h,S,R,D,u,p,E,i,a,r,n,o,c,l,t,d,s,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function f(q,W,x){return new R.ExtUri(k=>v(k,x)).isEqual(q,W)}function w(q,W,x){return f(q.uri,W.uri,x)?0:(0,D.compare)(q.uri.toString(),W.uri.toString())}function P(q,W,x){return q.index!==W.index?q.index<W.index?-1:1:f(q.uri,W.uri,x)?(0,D.compare)(q.name,W.name):(0,D.compare)(q.uri.toString(),W.uri.toString())}function m(q,W,x,k){const M=q.slice(0).sort((oe,de)=>x(oe,de,k)),$=W.slice(0).sort((oe,de)=>x(oe,de,k));return(0,I.delta)(M,$,(oe,de)=>x(oe,de,k))}function v(q,W){const x=W.getCapabilities(q.scheme);return!(x&&x&1024)}class y extends r.Workspace{static toExtHostWorkspace(W,x,k,M){if(!W)return{workspace:null,added:[],removed:[]};const{id:$,name:oe,folders:de,configuration:we,transient:ye,isUntitled:le}=W,ve=[],ae=x;x?de.forEach((H,ne)=>{const Ae=u.URI.revive(H.uri),Re=y._findFolder(k||x,Ae,M);Re?(Re.name=H.name,Re.index=H.index,ve.push(Re)):ve.push({uri:Ae,name:H.name,index:ne})}):ve.push(...de.map(({uri:H,name:ne,index:Ae})=>({uri:u.URI.revive(H),name:ne,index:Ae}))),ve.sort((H,ne)=>H.index<ne.index?-1:1);const pe=new y($,oe,ve,!!ye,we?u.URI.revive(we):null,!!le,H=>v(H,M)),{added:re,removed:J}=m(ae?ae.workspaceFolders:[],pe.workspaceFolders,w,M);return{workspace:pe,added:re,removed:J}}static _findFolder(W,x,k){for(let M=0;M<W.folders.length;M++){const $=W.workspaceFolders[M];if(f($.uri,x,k))return $}}constructor(W,x,k,M,$,oe,de){super(W,k.map(we=>new r.WorkspaceFolder(we)),M,$,de),this._name=x,this._isUntitled=oe,this._workspaceFolders=[],this._structure=g.TernarySearchTree.forUris(de),k.forEach(we=>{this._workspaceFolders.push(we),this._structure.set(we.uri,we)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(W,x){return x&&this._structure.get(W)&&(W=(0,R.dirname)(W)),this._structure.findSubstr(W)}resolveWorkspaceFolder(W){return this._structure.get(W)}}let O=class{constructor(W,x,k,M,$){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new A.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=M,this._extHostFileSystemInfo=k,this._uriTransformerService=$,this._requestIdProvider=new S.Counter,this._barrier=new L.Barrier,this._proxy=W.getProxy(b.MainContext.MainThreadWorkspace),this._messageService=W.getProxy(b.MainContext.MainThreadMessageService);const oe=x.workspace;this._confirmedWorkspace=oe?new y(oe.id,oe.name,[],!!oe.transient,oe.configuration?u.URI.revive(oe.configuration):null,!!oe.isUntitled,de=>v(de,k)):void 0}$initializeWorkspace(W,x){this._trusted=x,this.$acceptWorkspaceData(W),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?u.URI.from({scheme:h.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(W,x,k,...M){const $=[];if(Array.isArray(M)&&M.forEach(le=>{u.URI.isUri(le.uri)&&!$.some(ve=>f(ve.uri,le.uri,this._extHostFileSystemInfo))&&$.push({uri:le.uri,name:le.name||(0,R.basenameOrAuthority)(le.uri)})}),this._unconfirmedWorkspace||[x,k].some(le=>typeof le!="number"||le<0)||k===0&&$.length===0)return!1;const oe=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(x+k>oe.length)return!1;const de=oe.slice(0);de.splice(x,k,...$.map(le=>({uri:le.uri,name:le.name||(0,R.basenameOrAuthority)(le.uri),index:void 0})));for(let le=0;le<de.length;le++){const ve=de[le];if(de.some((ae,pe)=>pe!==le&&f(ve.uri,ae.uri,this._extHostFileSystemInfo)))return!1}de.forEach((le,ve)=>le.index=ve);const{added:we,removed:ye}=m(oe,de,P,this._extHostFileSystemInfo);if(we.length===0&&ye.length===0)return!1;if(this._proxy){const le=W.displayName||W.name;this._proxy.$updateWorkspaceFolders(le,x,k,$).then(void 0,ve=>{this._unconfirmedWorkspace=void 0;const ae={source:{identifier:W.identifier,label:W.displayName||W.name}};this._messageService.$showMessage(a.Severity.Error,(0,p.localize)(0,null,le,ve.toString()),ae,[])})}return this.trySetWorkspaceFolders(de),!0}getWorkspaceFolder(W,x){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(W,x)}async getWorkspaceFolder2(W,x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(W,x)}async resolveWorkspaceFolder(W){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(W)}getPath(){if(!this._actualWorkspace)return;const{folders:W}=this._actualWorkspace;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,x){let k,M="";if(typeof W=="string"?(k=u.URI.file(W),M=W):typeof W<"u"&&(k=W,M=W.fsPath),!k)return M;const $=this.getWorkspaceFolder(k,!0);if(!$)return M;typeof x>"u"&&this._actualWorkspace&&(x=this._actualWorkspace.folders.length>1);let oe=(0,R.relativePath)($.uri,k);return x&&$.name&&(oe=`${$.name}/${oe}`),oe}trySetWorkspaceFolders(W){this._actualWorkspace&&(this._unconfirmedWorkspace=y.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:W,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:x,added:k,removed:M}=y.toExtHostWorkspace(W,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=x||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:k,removed:M}))}findFiles(W,x,k,M,$=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${M.value}, entryPoint: findFiles`);let oe;if(x===null?oe=!1:x&&(typeof x=="string"?oe=x:oe=x.pattern),$&&$.isCancellationRequested)return Promise.resolve([]);const{includePattern:de,folder:we}=N(l.GlobPattern.from(W));return this._proxy.$startFileSearch(de??null,we??null,oe??null,k??null,$).then(ye=>Array.isArray(ye)?ye.map(le=>u.URI.revive(le)):[])}async findTextInFiles(W,x,k,M,$=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${M.value}, entryPoint: findTextInFiles`);const oe=this._requestIdProvider.getNext(),de=typeof x.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:x.previewOptions,{includePattern:we,folder:ye}=N(l.GlobPattern.from(x.include)),le=typeof x.exclude=="string"?x.exclude:x.exclude?x.exclude.pattern:void 0,ve={ignoreSymlinks:typeof x.followSymlinks=="boolean"?!x.followSymlinks:void 0,disregardIgnoreFiles:typeof x.useIgnoreFiles=="boolean"?!x.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof x.useGlobalIgnoreFiles=="boolean"?!x.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof x.useParentIgnoreFiles=="boolean"?!x.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof x.useDefaultExcludes=="boolean"?!x.useDefaultExcludes:!0,fileEncoding:x.encoding,maxResults:x.maxResults,previewOptions:de,afterContext:x.afterContext,beforeContext:x.beforeContext,includePattern:we,excludePattern:le},ae=!1;if(this._activeSearchCallbacks[oe]=pe=>{if(ae)return;const re=u.URI.revive(pe.resource);pe.results.forEach(J=>{const H=(0,_.revive)(J);(0,s.resultIsMatch)(H)?k({uri:re,preview:{text:H.preview.text,matches:(0,I.mapArrayOrNot)(H.preview.matches,ne=>new t.Range(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,I.mapArrayOrNot)(H.ranges,ne=>new t.Range(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):k({uri:re,text:H.text,lineNumber:H.lineNumber})})},$.isCancellationRequested)return{};try{const pe=await this._proxy.$startTextSearch(W,ye??null,ve,oe,$);return delete this._activeSearchCallbacks[oe],pe||{}}catch(pe){throw delete this._activeSearchCallbacks[oe],pe}}$handleTextSearchResult(W,x){this._activeSearchCallbacks[x]?.(W)}async save(W){const x=await this._proxy.$save(W,{saveAs:!1});return u.URI.revive(x)}async saveAs(W){const x=await this._proxy.$save(W,{saveAs:!0});return u.URI.revive(x)}saveAll(W){return this._proxy.$saveAll(W)}resolveProxy(W){return this._proxy.$resolveProxy(W)}loadCertificates(){return this._proxy.$loadCertificates()}get trusted(){return this._trusted}requestWorkspaceTrust(W){return this._proxy.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(W,x){if(this._editSessionIdentityProviders.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this._editSessionIdentityProviders.set(W,x);const k=this._uriTransformerService.transformOutgoingScheme(W),M=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(M,k),(0,T.toDisposable)(()=>{this._editSessionIdentityProviders.delete(W),this._proxy.$unregisterEditSessionIdentityProvider(M)})}async $getEditSessionIdentifier(W,x){this._logService.info("Getting edit session identifier for workspaceFolder",W);const k=await this.resolveWorkspaceFolder(u.URI.revive(W));if(!k){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",k);const M=this._editSessionIdentityProviders.get(k.uri.scheme);if(this._logService.info(`Provider for scheme ${k.uri.scheme} is defined: `,!!M),!M)return;const $=await M.provideEditSessionIdentity(k,x);if(this._logService.info("Provider returned edit session identifier: ",$),!!$)return $}async $provideEditSessionIdentityMatch(W,x,k,M){this._logService.info("Getting edit session identifier for workspaceFolder",W);const $=await this.resolveWorkspaceFolder(u.URI.revive(W));if(!$){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",$);const oe=this._editSessionIdentityProviders.get($.uri.scheme);if(this._logService.info(`Provider for scheme ${$.uri.scheme} is defined: `,!!oe),!oe)return;const de=await oe.provideEditSessionIdentityMatch?.(x,k,M);if(this._logService.info("Provider returned edit session identifier match result: ",de),!!de)return de}getOnWillCreateEditSessionIdentityEvent(W){return(x,k,M)=>{const $=function(de){x.call(k,de)};return $.extension=W,this._onWillCreateEditSessionIdentityEvent.event($,void 0,M)}}async $onWillCreateEditSessionIdentity(W,x,k){const M=await this.resolveWorkspaceFolder(u.URI.revive(W));if(M===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:M},x,async($,oe)=>{const de=Date.now();await Promise.resolve($),Date.now()-de>k&&this._logService.warn("SLOW edit session create-participant",oe.extension.identifier)}),x.isCancellationRequested}registerCanonicalUriProvider(W,x){if(this._canonicalUriProviders.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this._canonicalUriProviders.set(W,x);const k=this._uriTransformerService.transformOutgoingScheme(W),M=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(M,k),(0,T.toDisposable)(()=>{this._canonicalUriProviders.delete(W),this._proxy.$unregisterCanonicalUriProvider(M)})}async provideCanonicalUri(W,x,k){const M=this._canonicalUriProviders.get(W.scheme);if(!M)return;const $=await M.provideCanonicalUri?.(u.URI.revive(W),x,k);if($)return $}async $provideCanonicalUri(W,x,k){return this.provideCanonicalUri(u.URI.revive(W),{targetScheme:x},k)}};e.ExtHostWorkspace=O,e.ExtHostWorkspace=O=Ke([We(0,c.IExtHostRpcService),We(1,o.IExtHostInitDataService),We(2,n.IExtHostFileSystemInfo),We(3,i.ILogService),We(4,d.IURITransformerService)],O),e.IExtHostWorkspace=(0,E.createDecorator)("IExtHostWorkspace");function N(q){let W,x;return q&&(typeof q=="string"?W=q:(W=q.pattern,x=u.URI.revive(q.baseUri))),{includePattern:W,folder:x}}}),define(Pe[37],Te([1,0,26,5,36,3,7,189,55,16,13,4,17,14,2]),function(me,e,I,L,C,A,T,g,h,S,R,D,u,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function i(d,s){if(s){const b=s.split(".");let _=d;for(let f=0;_&&f<b.length;f++)_=_[b[f]];return _}}function a(d){return d instanceof E.URI}function r(d){return d&&d.uri instanceof E.URI&&d.languageId&&typeof d.languageId=="string"}function n(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function o(d){return d&&d.uri instanceof E.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function c(d){if(a(d))return{resource:d};if(r(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(n(d))return{overrideIdentifier:d.languageId};if(o(d))return{resource:d.uri};if(d===null)return{resource:null}}let l=class{constructor(s,b,_){this._proxy=s.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=b,this._logService=_,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,b){this.getConfigProvider().then(_=>_.$acceptConfigurationChanged(s,b))}};e.ExtHostConfiguration=l,e.ExtHostConfiguration=l=Ke([We(0,u.IExtHostRpcService),We(1,C.IExtHostWorkspace),We(2,p.ILogService)],l);class t{constructor(s,b,_,f){this._onDidChangeConfiguration=new L.Emitter,this._proxy=s,this._logService=f,this._extHostWorkspace=b,this._configuration=g.Configuration.parse(_),this._configurationScopes=this._toMap(_.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,b){const _={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=g.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(b,_))}getConfiguration(s,b,_){const f=c(b)||{},w=this._toReadonlyValue(s?i(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,f,_?.identifier);function P(v){if(v==null)return null;if(typeof v=="boolean")return v?2:5;switch(v){case T.ConfigurationTarget.Global:return 2;case T.ConfigurationTarget.Workspace:return 5;case T.ConfigurationTarget.WorkspaceFolder:return 6}}const m={has(v){return typeof i(w,v)<"u"},get:(v,y)=>{this._validateConfigurationAccess(s?`${s}.${v}`:v,f,_?.identifier);let O=i(w,v);if(typeof O>"u")O=y;else{let N;const q=(W,x)=>{if((0,S.isObject)(W)){let k;const M=()=>{N=N||(0,I.deepClone)(w),k=k||i(N,x)};return new Proxy(W,{get:($,oe)=>{if(typeof oe=="string"&&oe.toLowerCase()==="tojson")return M(),()=>k;if(N)return k=k||i(N,x),k[oe];const de=$[oe];return typeof oe=="string"?q(de,`${x}.${oe}`):de},set:($,oe,de)=>(M(),k&&(k[oe]=de),!0),deleteProperty:($,oe)=>(M(),k&&delete k[oe],!0),defineProperty:($,oe,de)=>(M(),k&&Object.defineProperty(k,oe,de),!0)})}return Array.isArray(W)?(0,I.deepClone)(W):W};O=q(O,v)}return O},update:(v,y,O,N)=>{v=s?`${s}.${v}`:v;const q=P(O);return y!==void 0?this._proxy.$updateConfigurationOption(q,v,y,f,N):this._proxy.$removeConfigurationOption(q,v,f,N)},inspect:v=>{v=s?`${s}.${v}`:v;const y=this._configuration.inspect(v,f,this._extHostWorkspace.workspace);if(y)return{key:v,defaultValue:(0,I.deepClone)(y.policy?.value??y.default?.value),globalValue:(0,I.deepClone)(y.user?.value??y.application?.value),workspaceValue:(0,I.deepClone)(y.workspace?.value),workspaceFolderValue:(0,I.deepClone)(y.workspaceFolder?.value),defaultLanguageValue:(0,I.deepClone)(y.default?.override),globalLanguageValue:(0,I.deepClone)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,I.deepClone)(y.workspace?.override),workspaceFolderLanguageValue:(0,I.deepClone)(y.workspaceFolder?.override),languageIds:(0,I.deepClone)(y.overrideIdentifiers)}}};return typeof w=="object"&&(0,I.mixin)(m,w,!1),Object.freeze(m)}_toReadonlyValue(s){const b=_=>(0,S.isObject)(_)?new Proxy(_,{get:(f,w)=>b(f[w]),set:(f,w,P)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(w)}' of object`)},deleteProperty:(f,w)=>{throw new Error(`TypeError: Cannot delete read only property '${String(w)}' of object`)},defineProperty:(f,w)=>{throw new Error(`TypeError: Cannot define property '${String(w)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):_;return b(s)}_validateConfigurationAccess(s,b,_){const f=h.OVERRIDE_PROPERTY_REGEX.test(s)?4:this._configurationScopes.get(s),w=_?`[${_.value}] `:"";if(f===4){typeof b?.resource>"u"&&this._logService.warn(`${w}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){b?.resource&&this._logService.warn(`${w}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,b){const _=new g.ConfigurationChangeEvent(s,b,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,w)=>_.affectsConfiguration(f,c(w))})}_toMap(s){return s.reduce((b,_)=>(b.set(_[0],_[1]),b),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,D.createDecorator)("IExtHostConfiguration")}),define(Pe[115],Te([1,0,2,13,5,3,7,36,66,37,20,65,17,27,4,11,21,14,79,221,15]),function(me,e,I,L,C,A,T,g,h,S,R,D,u,p,E,i,a,r,n,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var l;(function(q){function W(k){if(k!=null)return k}q.from=W;function x(k){if(k!=null)return k}q.to=x})(l||(l={}));var t;(function(q){function W(k){if(k!=null)return k}q.from=W;function x(k){if(k!=null)return k}q.to=x})(t||(t={}));var d;(function(q){function W(k){if(k!=null)return k}q.from=W;function x(k){if(k!=null)return k}q.to=x})(d||(d={}));var s;(function(q){function W(M){if(M){const $=M;return $&&!!$.process}else return!1}q.is=W;function x(M){if(M==null)return;const $={process:M.process,args:M.args};return M.options&&($.options=d.from(M.options)),$}q.from=x;function k(M){if(M!=null)return new T.ProcessExecution(M.process,M.args,M.options)}q.to=k})(s||(s={}));var b;(function(q){function W(k){if(k!=null)return k}q.from=W;function x(k){if(k!=null)return k}q.to=x})(b||(b={}));var _;(function(q){function W(M){if(M){const $=M;return $&&(!!$.commandLine||!!$.command)}else return!1}q.is=W;function x(M){if(M==null)return;const $={};return M.commandLine!==void 0?$.commandLine=M.commandLine:($.command=M.command,$.args=M.args),M.options&&($.options=b.from(M.options)),$}q.from=x;function k(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new T.ShellExecution(M.commandLine,M.options):new T.ShellExecution(M.command,M.args?M.args:[],M.options)}q.to=k})(_||(_={}));var f;(function(q){function W(M){if(M){const $=M;return $&&$.customExecution==="customExecution"}else return!1}q.is=W;function x(M){return{customExecution:"customExecution"}}q.from=x;function k(M,$){return $.get(M)}q.to=k})(f||(e.CustomExecutionDTO=f={}));var w;(function(q){function W(x,k){let M;return x.scope!==void 0&&typeof x.scope!="number"?M=x.scope.uri:x.scope!==void 0&&typeof x.scope=="number"&&(x.scope===T.TaskScope.Workspace&&k&&k.workspaceFile?M=k.workspaceFile:M=o.USER_TASKS_GROUP_KEY),{id:x._id,workspaceFolder:M}}q.from=W})(w||(e.TaskHandleDTO=w={}));var P;(function(q){function W(x){if(x!=null)return{_id:x.id,isDefault:x.isDefault}}q.from=W})(P||(P={}));var m;(function(q){function W(M,$){if(M==null)return[];const oe=[];for(const de of M){const we=x(de,$);we&&oe.push(we)}return oe}q.fromMany=W;function x(M,$){if(M==null)return;let oe;M.execution instanceof T.ProcessExecution?oe=s.from(M.execution):M.execution instanceof T.ShellExecution?oe=_.from(M.execution):M.execution&&M.execution instanceof T.CustomExecution&&(oe=f.from(M.execution));const de=l.from(M.definition);let we;return M.scope?typeof M.scope=="number"?we=M.scope:we=M.scope.uri:we=T.TaskScope.Workspace,!de||!we?void 0:{_id:M._id,definition:de,name:M.name,source:{extensionId:$.identifier.value,label:M.source,scope:we},execution:oe,isBackground:M.isBackground,group:P.from(M.group),presentationOptions:t.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}q.from=x;async function k(M,$,oe){if(M==null)return;let de;s.is(M.execution)?de=s.to(M.execution):_.is(M.execution)?de=_.to(M.execution):f.is(M.execution)&&(de=f.to(M._id,oe));const we=l.to(M.definition);let ye;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?ye=M.source.scope:ye=await $.resolveWorkspaceFolder(I.URI.revive(M.source.scope)):ye=T.TaskScope.Workspace),!we||!ye)return;const le=new T.Task(we,ye,M.name,M.source.label,de,M.problemMatchers);return M.isBackground!==void 0&&(le.isBackground=M.isBackground),M.group!==void 0&&(le.group=T.TaskGroup.from(M.group._id),le.group&&M.group.isDefault&&(le.group=new T.TaskGroup(le.group.id,le.group.label),M.group.isDefault===!0&&(le.group.isDefault=M.group.isDefault))),M.presentationOptions&&(le.presentationOptions=t.to(M.presentationOptions)),M._id&&(le._id=M._id),M.detail&&(le.detail=M.detail),le}q.to=k})(m||(e.TaskDTO=m={}));var v;(function(q){function W(k){return k}q.from=W;function x(k){if(k)return Object.assign(Object.create(null),k)}q.to=x})(v||(v={}));class y{#e;constructor(W,x,k){this._id=x,this._task=k,this.#e=W}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}let O=class{constructor(W,x,k,M,$,oe,de,we){this._onDidExecuteTask=new C.Emitter,this._onDidTerminateTask=new C.Emitter,this._onDidTaskProcessStarted=new C.Emitter,this._onDidTaskProcessEnded=new C.Emitter,this._proxy=W.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=k,this._editorService=M,this._configurationService=$,this._terminalService=oe,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=de,this._deprecationService=we,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(W,x,k){if(!k)return new T.Disposable(()=>{});const M=this.nextHandle();return this._handlers.set(M,{type:x,provider:k,extension:W}),this._proxy.$registerTaskProvider(M,x),new T.Disposable(()=>{this._handlers.delete(M),this._proxy.$unregisterTaskProvider(M)})}registerTaskSystem(W,x){this._proxy.$registerTaskSystem(W,x)}fetchTasks(W){return this._proxy.$fetchTasks(v.from(W)).then(async x=>{const k=[];for(const M of x){const $=await m.to(M,this._workspaceProvider,this._providedCustomExecutions2);$&&k.push($)}return k})}get taskExecutions(){const W=[];return this._taskExecutions.forEach(x=>W.push(x)),W}terminateTask(W){if(!(W instanceof y))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(W._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(W,x,k){const M=this._providedCustomExecutions2.get(W.id);M&&(this._activeCustomExecutions2.set(W.id,M),this._terminalService.attachPtyToTerminal(x,await M.callback(k))),this._lastStartedTask=W.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(W)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(W){if(!this._taskExecutionPromises.has(W.id))return;const x=await this.getTaskExecution(W);this._taskExecutionPromises.delete(W.id),this._taskExecutions.delete(W.id),this.customExecutionComplete(W),this._onDidTerminateTask.fire({execution:x})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(W){const x=await this.getTaskExecution(W.id);this._onDidTaskProcessStarted.fire({execution:x,processId:W.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(W){const x=await this.getTaskExecution(W.id);this._onDidTaskProcessEnded.fire({execution:x,exitCode:W.exitCode})}$provideTasks(W,x){const k=this._handlers.get(W);if(!k)return Promise.reject(new Error("no handler found"));const M=[],$=(0,L.asPromise)(()=>k.provider.provideTasks(R.CancellationToken.None)).then(oe=>this.provideTasksInternal(x,M,k,oe));return new Promise(oe=>{$.then(de=>{Promise.all(M).then(()=>{oe(de)})})})}async $resolveTask(W,x){const k=this._handlers.get(W);if(!k)return Promise.reject(new Error("no handler found"));if(x.definition.type!==k.type)throw new Error(`Unexpected: Task of type [${x.definition.type}] cannot be resolved by provider of type [${k.type}].`);const M=await m.to(x,this._workspaceProvider,this._providedCustomExecutions2);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const $=await k.provider.resolveTask(M,R.CancellationToken.None);if(!$)return;this.checkDeprecation($,k);const oe=m.from($,k.extension);if(!oe)throw new Error("Unexpected: Task cannot be resolved.");if($.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return f.is(oe.execution)&&await this.addCustomExecution(oe,$,!0),await this.resolveTaskInternal(oe)}nextHandle(){return this._handleCounter++}async addCustomExecution(W,x,k){const M=await this._proxy.$createTaskId(W);!k&&!this._providedCustomExecutions2.has(M)&&(this._notProvidedCustomExecutions.add(M),this._activeCustomExecutions2.set(M,x.execution)),this._providedCustomExecutions2.set(M,x.execution)}async getTaskExecution(W,x){if(typeof W=="string"){const $=this._taskExecutionPromises.get(W);if(!$)throw new c.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return $}const k=this._taskExecutionPromises.get(W.id);if(k)return k;let M;return x?M=Promise.resolve(new y(this,W.id,x)):M=m.to(W.task,this._workspaceProvider,this._providedCustomExecutions2).then($=>{if(!$)throw new c.ErrorNoTelemetry("Unexpected: Task does not exist.");return new y(this,W.id,$)}),this._taskExecutionPromises.set(W.id,M),M.then($=>(this._taskExecutions.set(W.id,$),$))}checkDeprecation(W,x){W._deprecated&&this._deprecationService.report("Task.constructor",x.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(W){this._activeCustomExecutions2.get(W.id)&&this._activeCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.has(W.id)&&this._lastStartedTask!==W.id&&(this._providedCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.delete(W.id));const k=this._notProvidedCustomExecutions.values();let M=k.next();for(;!M.done;)!this._activeCustomExecutions2.has(M.value)&&this._lastStartedTask!==M.value&&(this._providedCustomExecutions2.delete(M.value),this._notProvidedCustomExecutions.delete(M.value)),M=k.next()}};e.ExtHostTaskBase=O,e.ExtHostTaskBase=O=Ke([We(0,u.IExtHostRpcService),We(1,p.IExtHostInitDataService),We(2,g.IExtHostWorkspace),We(3,h.IExtHostDocumentsAndEditors),We(4,S.IExtHostConfiguration),We(5,D.IExtHostTerminalService),We(6,r.ILogService),We(7,n.IExtHostApiDeprecationService)],O);let N=class extends O{constructor(W,x,k,M,$,oe,de,we){super(W,x,k,M,$,oe,de,we),this.registerTaskSystem(i.Schemas.vscodeRemote,{scheme:i.Schemas.vscodeRemote,authority:"",platform:a.PlatformToString(0)})}async executeTask(W,x){if(!x.execution)throw new Error("Tasks to execute must include an execution");const k=m.from(x,W);if(k===void 0)throw new Error("Task is not valid");if(f.is(k.execution))await this.addCustomExecution(k,x,!1);else throw new c.NotSupportedError;const M=await this.getTaskExecution(await this._proxy.$getTaskExecution(k),x);return this._proxy.$executeTask(k).catch($=>{throw new Error($)}),M}provideTasksInternal(W,x,k,M){const $=[];if(M)for(const oe of M){if(this.checkDeprecation(oe,k),!oe.definition||!W[oe.definition.type]){const we=oe.source?oe.source:"No task source";this._logService.warn(`The task [${we}, ${oe.name}] uses an undefined task type. The task will be ignored in the future.`)}const de=m.from(oe,k.extension);de&&f.is(de.execution)?($.push(de),x.push(this.addCustomExecution(de,oe,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:$,extension:k.extension}}async resolveTaskInternal(W){if(f.is(W.execution))return W;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(W,x){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,x,k){}};e.WorkerExtHostTask=N,e.WorkerExtHostTask=N=Ke([We(0,u.IExtHostRpcService),We(1,p.IExtHostInitDataService),We(2,g.IExtHostWorkspace),We(3,h.IExtHostDocumentsAndEditors),We(4,S.IExtHostConfiguration),We(5,D.IExtHostTerminalService),We(6,r.ILogService),We(7,n.IExtHostApiDeprecationService)],N),e.IExtHostTask=(0,E.createDecorator)("IExtHostTask")}),define(Pe[283],Te([1,0,44,29]),function(me,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.genericCellMatchesToTextSearchMatches=e.rawCellPrefix=e.isINotebookFileMatchNoModel=void 0;function C(T){return"cellResults"in T}e.isINotebookFileMatchNoModel=C,e.rawCellPrefix="rawCell#";function A(T,g){let h=-1;const S=[];let R=[];return T.forEach(u=>{u.range.startLineNumber!==h&&R.length>0&&(S.push([...R]),R=[]),R.push(u),h=u.range.endLineNumber}),R.length>0&&S.push([...R]),S.map(u=>{const p=[],E=u[0].range.startLineNumber,i=u[u.length-1].range.endLineNumber;for(let a=E;a<=i;a++)p.push(g.getLineContent(a));return new I.TextSearchMatch(p.join(`
`)+`
`,u.map(a=>new L.Range(a.range.startLineNumber-1,a.range.startColumn-1,a.range.endLineNumber-1,a.range.endColumn-1)))})}e.genericCellMatchesToTextSearchMatches=A}),define(Pe[284],Te([1,0,162,23,5,6,28,12,16,2,42,75,3,31,8,7,49,259,109,26,11,211,283,281]),function(me,e,I,L,C,A,T,g,h,S,R,D,u,p,E,i,a,r,n,o,c,l,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class s{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(_=>_.apiEditor)}constructor(_,f,w,P,m,v){this._textDocumentsAndEditors=w,this._textDocuments=P,this._extHostFileSystem=m,this._extHostSearch=v,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new C.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new C.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new C.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new C.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new D.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=_.getProxy(u.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=_.getProxy(u.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=_.getProxy(u.MainContext.MainThreadNotebookEditors),this._commandsConverter=f.converter,f.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const O=y.notebookEditor?.notebookUri,N=y.cell.handle,W=this._documents.get(O)?.getCell(N);if(W)return W.apiCell}if(y&&y.$mid===14){const O=y.uri,N=this._documents.get(O);if(N)return N.apiNotebook}return y}}),s._registerApiCommands(f)}getEditorById(_){const f=this._editors.get(_);if(!f)throw new Error(`unknown text editor: ${_}. known editors: ${[...this._editors.keys()]} `);return f}getIdByEditor(_){for(const[f,w]of this._editors)if(w.apiEditor===_)return f}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(_,f){const w=this._documents.get(_);if(!w&&!f)throw new Error(`NO notebook document for '${_}'`);return w}static _convertNotebookRegistrationData(_,f){if(!f)return;const w=f.filenamePattern.map(P=>E.NotebookExclusiveDocumentPattern.from(P)).filter(P=>P!==void 0);if(f.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${f.filenamePattern}`);return}return{extension:_.identifier,providerDisplayName:_.displayName||_.name,displayName:f.displayName,filenamePattern:w,exclusive:f.exclusive||!1}}registerNotebookCellStatusBarItemProvider(_,f,w){const P=s._notebookStatusBarItemProviderHandlePool++,m=typeof w.onDidChangeCellStatusBarItems=="function"?s._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(P,w),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(P,m,f);let v;return m!==void 0&&(v=w.onDidChangeCellStatusBarItems(y=>this._notebookProxy.$emitCellStatusBarEvent(m))),new i.Disposable(()=>{this._notebookStatusBarItemProviders.delete(P),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(P,m),v?.dispose()})}async createNotebookDocument(_){const f=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:_.viewType,content:_.content&&E.NotebookData.from(_.content)});return S.URI.revive(f)}async openNotebookDocument(_){const f=this._documents.get(_);if(f)return f.apiNotebook;const w=await this._notebookDocumentsProxy.$tryOpenNotebook(_),P=this._documents.get(S.URI.revive(w));return(0,h.assertIsDefined)(P?.apiNotebook)}async showNotebookDocument(_,f){S.URI.isUri(_)&&(_=await this.openNotebookDocument(_));let w;typeof f=="object"?w={position:E.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus,selections:f.selections&&f.selections.map(E.NotebookRange.from),pinned:typeof f.preview=="boolean"?!f.preview:void 0}:w={preserveFocus:!1};const P=await this._notebookEditorsProxy.$tryShowNotebookDocument(_.uri,_.notebookType,w),m=P&&this._editors.get(P)?.apiEditor;if(m)return m;throw P?new Error(`Could NOT open editor for "${_.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${_.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(_,f,w,P){const m=this._notebookStatusBarItemProviders.get(_),v=S.URI.revive(f),y=this._documents.get(v);if(!y||!m)return;const O=y.getCellFromIndex(w);if(!O)return;const N=await m.provideCellStatusBarItems(O.apiCell,P);if(!N)return;const q=new A.DisposableStore,W=this._statusBarCache.add([q]),k=(Array.isArray(N)?N:[N]).map(M=>E.NotebookStatusBarItem.from(M,this._commandsConverter,q));return{cacheId:W,items:k}}$releaseNotebookCellStatusBarItems(_){this._statusBarCache.delete(_)}registerNotebookSerializer(_,f,w,P,m){if((0,g.isFalsyOrWhitespace)(f))throw new Error("viewType cannot be empty or just whitespace");const v=this._handlePool++;return this._notebookSerializer.set(v,{viewType:f,serializer:w,options:P}),this._notebookProxy.$registerNotebookSerializer(v,{id:_.identifier,location:_.extensionLocation},f,E.NotebookDocumentContentOptions.from(P),s._convertNotebookRegistrationData(_,m)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(v)})}async $dataToNotebook(_,f,w){const P=this._notebookSerializer.get(_);if(!P)throw new Error("NO serializer found");const m=await P.serializer.deserializeNotebook(f.buffer,w);return new a.SerializableObjectWithBuffers(E.NotebookData.from(m))}async $notebookToData(_,f,w){const P=this._notebookSerializer.get(_);if(!P)throw new Error("NO serializer found");const m=await P.serializer.serializeNotebook(E.NotebookData.to(f.value),w);return L.VSBuffer.wrap(m)}async $saveNotebook(_,f,w,P,m){const v=S.URI.revive(f),y=this._notebookSerializer.get(_);if(!y)throw new Error("NO serializer found");const O=this._documents.get(v);if(!O)throw new Error("Document NOT found");if(O.versionId!==w)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(v.scheme))throw new R.FileOperationError((0,I.localize)(0,null,this._resourceForError(v)),6);await this._validateWriteFile(v,P);const N={metadata:(0,o.filter)(O.apiNotebook.metadata,M=>!(y.options?.transientDocumentMetadata??{})[M]),cells:[]};for(const M of O.apiNotebook.getCells()){const $=new i.NotebookCellData(M.kind,M.document.getText(),M.document.languageId,M.mime,y.options?.transientOutputs?[]:[...M.outputs],M.metadata,M.executionSummary);$.metadata=(0,o.filter)(M.metadata,oe=>!(y.options?.transientCellMetadata??{})[oe]),N.cells.push($)}const q=await y.serializer.serializeNotebook(N,m);await this._extHostFileSystem.value.writeFile(v,q);const W=this._extHostFileSystem.getFileSystemProviderExtUri(v.scheme),x=await this._extHostFileSystem.value.stat(v);return{name:W.basename(v),isFile:(x.type&R.FileType.File)!==0,isDirectory:(x.type&R.FileType.Directory)!==0,isSymbolicLink:(x.type&R.FileType.SymbolicLink)!==0,mtime:x.mtime,ctime:x.ctime,size:x.size,readonly:!!((x.permissions??0)&R.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(v.scheme),locked:!!((x.permissions??0)&R.FilePermission.Locked),etag:R.etag({mtime:x.mtime,size:x.size}),children:void 0}}async $searchInNotebooks(_,f,w,P,m){const v=this._notebookSerializer.get(_)?.serializer;if(!v)return{limitHit:!1,results:[]};const y=new T.ResourceSet;await(async(x,k,M)=>{await Promise.all(x.map(async $=>await Promise.all($.filenamePatterns.map(oe=>{const de={_reason:M._reason,folderQueries:M.folderQueries,includePattern:M.includePattern,excludePattern:M.excludePattern,maxResults:M.maxResults,type:1,filePattern:oe};return this._extHostSearch.doInternalFileSearchWithCustomCallback(de,k,we=>{we.forEach(ye=>{y.has(ye)||P.some(ve=>$.isFromSettings&&!ve.isFromSettings?!1:ve.filenamePatterns.some(ae=>(0,d.globMatchesResource)(ae,ye)))||y.add(ye)})})}))))})(w,m,f);const N=new T.ResourceMap;let q=!1;const W=Array.from(y).map(async x=>{const k=[];try{if(m.isCancellationRequested)return;if(f.maxResults&&[...N.values()].reduce((de,we)=>de+we.cellResults.length,0)>f.maxResults){q=!0;return}const M=[],$=this._documents.get(x);if($)$.apiNotebook.getCells().forEach(we=>M.push({input:we.document.getText(),outputs:we.outputs.flatMap(ye=>ye.items.map(le=>le.data.toString()))}));else{const de=await this._extHostFileSystem.value.readFile(x),we=L.VSBuffer.fromString(de.toString()),ye=await v.deserializeNotebook(we.buffer,m);if(m.isCancellationRequested)return;E.NotebookData.from(ye).cells.forEach(ve=>M.push({input:ve.source,outputs:ve.outputs.flatMap(ae=>ae.items.map(pe=>pe.valueBytes.toString()))}))}if(m.isCancellationRequested)return;M.forEach((de,we)=>{const ye=f.contentPattern.pattern,le=new l.CellSearchModel(de.input,void 0,de.outputs),ve=le.findInInputs(ye),ae=le.findInOutputs(ye),pe=ae.flatMap(re=>(0,t.genericCellMatchesToTextSearchMatches)(re.matches,re.textBuffer)).map((re,J)=>(re.webviewIndex=J,re));if(ve.length>0||ae.length>0){const re={index:we,contentResults:(0,t.genericCellMatchesToTextSearchMatches)(ve,le.inputTextBuffer),webviewResults:pe};k.push(re)}});const oe={resource:x,cellResults:k};N.set(x,oe);return}catch{return}});return await Promise.all(W),{limitHit:q,results:[...N.values()]}}async _validateWriteFile(_,f){const w=await this._extHostFileSystem.value.stat(_);if(typeof f?.mtime=="number"&&typeof f.etag=="string"&&f.etag!==R.ETAG_DISABLED&&typeof w.mtime=="number"&&typeof w.size=="number"&&f.mtime<w.mtime&&f.etag!==R.etag({mtime:f.mtime,size:w.size}))throw new R.FileOperationError((0,I.localize)(1,null),3,f)}_resourceForError(_){return _.scheme===c.Schemas.file?_.fsPath:_.toString()}_createExtHostEditor(_,f,w){if(this._editors.has(f))throw new Error(`editor with id ALREADY EXSIST: ${f}`);const P=new n.ExtHostNotebookEditor(f,this._notebookEditorsProxy,_,w.visibleRanges.map(E.NotebookRange.to),w.selections.map(E.NotebookRange.to),typeof w.viewColumn=="number"?E.ViewColumn.to(w.viewColumn):void 0);this._editors.set(f,P)}$acceptDocumentAndEditorsDelta(_){if(_.value.removedDocuments)for(const w of _.value.removedDocuments){const P=S.URI.revive(w),m=this._documents.get(P);m&&(m.dispose(),this._documents.delete(P),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:m.apiNotebook.getCells().map(v=>v.document.uri)}),this._onDidCloseNotebookDocument.fire(m.apiNotebook));for(const v of this._editors.values())v.notebookData.uri.toString()===P.toString()&&this._editors.delete(v.id)}if(_.value.addedDocuments){const w=[];for(const P of _.value.addedDocuments){const m=S.URI.revive(P.uri);if(this._documents.has(m))throw new Error(`adding EXISTING notebook ${m} `);const v=new r.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,m,P);w.push(...P.cells.map(y=>r.ExtHostCell.asModelAddData(v.apiNotebook,y))),this._documents.get(m)?.dispose(),this._documents.set(m,v),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this._onDidOpenNotebookDocument.fire(v.apiNotebook)}}if(_.value.addedEditors)for(const w of _.value.addedEditors){if(this._editors.has(w.id))return;const P=S.URI.revive(w.documentUri),m=this._documents.get(P);m&&this._createExtHostEditor(m,w.id,w)}const f=[];if(_.value.removedEditors)for(const w of _.value.removedEditors){const P=this._editors.get(w);P&&(this._editors.delete(w),this._activeNotebookEditor?.id===P.id&&(this._activeNotebookEditor=void 0),f.push(P))}if(_.value.visibleEditors){this._visibleNotebookEditors=_.value.visibleEditors.map(P=>this._editors.get(P)).filter(P=>!!P);const w=new Set;this._visibleNotebookEditors.forEach(P=>w.add(P.id));for(const P of this._editors.values()){const m=w.has(P.id);P._acceptVisibility(m)}this._visibleNotebookEditors=[...this._editors.values()].map(P=>P).filter(P=>P.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}_.value.newActiveEditor===null?this._activeNotebookEditor=void 0:_.value.newActiveEditor&&(this._editors.get(_.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${_.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(_.value.newActiveEditor)),_.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(_){const f=p.ApiCommandArgument.String.with("notebookType","A notebook type"),w=new p.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[f,new p.ApiCommandArgument("data","Bytes to convert to data",m=>m instanceof Uint8Array,m=>L.VSBuffer.wrap(m))],new p.ApiCommandResult("Notebook Data",m=>E.NotebookData.to(m.value))),P=new p.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[f,new p.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",m=>!0,m=>new a.SerializableObjectWithBuffers(E.NotebookData.from(m)))],new p.ApiCommandResult("Bytes",m=>m.buffer));_.registerApiCommand(w),_.registerApiCommand(P)}}e.ExtHostNotebookController=s}),define(Pe[285],Te([1,0,19,20,41,34,25,63,44]),function(me,e,I,L,C,A,T,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class S{constructor(u,p,E){this.config=u,this.provider=p,this.sessionToken=E,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=u.filePattern,this.includePattern=u.includePattern&&A.parse(u.includePattern),this.maxResults=u.maxResults||void 0,this.exists=u.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=u.excludePattern&&A.parse(u.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(u=>u.cancel()),this.activeCancellationTokens=new Set}search(u){const p=this.config.folderQueries||[];return new Promise((E,i)=>{const a=r=>{this.resultCount++,u(r)};if(this.isCanceled)return E({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(r=>{const n=r.toString(),o=I.basename(n);this.globalExcludePattern&&this.globalExcludePattern(n,o)||this.matchFile(a,{base:r,basename:o})}),Promise.all(p.map(r=>this.searchInFolder(r,a))).then(r=>{E({limitHit:this.isLimitHit,stats:r[0]||void 0})},r=>{i(new Error((0,C.toErrorMessage)(r)))})})}async searchInFolder(u,p){const E=new L.CancellationTokenSource,i=this.getSearchOptionsForFolder(u),a=this.initDirectoryTree(),r=new h.QueryGlobTester(this.config,u),n=!r.hasSiblingExcludeClauses();let o;try{this.activeCancellationTokens.add(E),o=g.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},i,E.token),l=o.elapsed(),t=g.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(d=>{const s=I.posix.relative(u.folder.path,d.path);if(n){const b=I.basename(d.path);this.matchFile(p,{base:u.folder,relativePath:s,basename:b});return}this.addDirectoryEntries(a,u.folder,s,p)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(a,r,p),{providerTime:l,postProcessTime:t.elapsed()})}finally{E.dispose(),this.activeCancellationTokens.delete(E)}}getSearchOptionsForFolder(u){const p=(0,h.resolvePatternsForProvider)(this.config.includePattern,u.includePattern),E=(0,h.resolvePatternsForProvider)(this.config.excludePattern,u.excludePattern);return{folder:u.folder,excludes:E,includes:p,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}addDirectoryEntries({pathToEntries:u},p,E,i){if(E===this.filePattern){const r=I.basename(this.filePattern);this.matchFile(i,{base:p,relativePath:this.filePattern,basename:r})}function a(r){const n=I.basename(r),o=I.dirname(r);let c=u[o];c||(c=u[o]=[],a(o)),c.push({base:p,relativePath:r,basename:n})}a(E)}matchDirectoryTree({rootEntries:u,pathToEntries:p},E,i){const a=this,r=this.filePattern;function n(o){const c=(0,h.hasSiblingFn)(()=>o.map(l=>l.basename));for(let l=0,t=o.length;l<t;l++){const d=o[l],{relativePath:s,basename:b}=d;if(E.matchesExcludesSync(s,b,r!==b?c:void 0))continue;const _=p[s];if(_)n(_);else{if(s===r)continue;a.matchFile(i,d)}if(a.isLimitHit)break}}n(u)}matchFile(u,p){(!this.includePattern||p.relativePath&&this.includePattern(p.relativePath,p.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||u(p))}}class R{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(u,p,E,i){const a=this.getSessionTokenSource(u.cacheKey),r=new S(u,p,a&&a.token);let n=0;const o=c=>{n+=c.length,E(c.map(l=>this.rawMatchToSearchItem(l)))};return this.doSearch(r,R.BATCH_SIZE,o,i).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:c.stats}}))}clearCache(u){this.getSessionTokenSource(u)?.cancel()}getSessionTokenSource(u){if(u)return this.sessions.has(u)||this.sessions.set(u,new L.CancellationTokenSource),this.sessions.get(u)}rawMatchToSearchItem(u){return u.relativePath?{resource:T.joinPath(u.base,u.relativePath)}:{resource:u.base}}doSearch(u,p,E,i){const a=i.onCancellationRequested(()=>{u.cancel()}),r=o=>{o&&(n.push(o),p>0&&n.length>=p&&(E(n),n=[]))};let n=[];return u.search(r).then(o=>(n.length&&E(n),a.dispose(),o),o=>(n.length&&E(n),a.dispose(),Promise.reject(o)))}}e.FileSearchManager=R}),define(Pe[286],Te([1,0,18,254,34,95,28,11,19,25,12,16,2,94,179,46,14,47,104,282,44]),function(me,e,I,L,C,A,T,g,h,S,R,D,u,p,E,i,a,r,n,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let l=class{constructor(v,y,O,N,q){this.configurationService=v,this.workspaceContextService=y,this.editorGroupsService=O,this.logService=N,this.pathService=q}text(v,y,O={}){v=this.getContentPattern(v,O);const N=this.configurationService.getValue(),q=y&&y.some(x=>!this.configurationService.getValue({resource:x}).search.useRipgrep);return{...this.commonQuery(y?.map(r.toWorkspaceFolder),O),type:2,contentPattern:v,previewOptions:O.previewOptions,maxFileSize:O.maxFileSize,usePCRE2:N.search.usePCRE2||q||!1,beforeContext:O.beforeContext,afterContext:O.afterContext,userDisabledExcludesAndIgnoreFiles:O.disregardExcludeSettings&&O.disregardIgnoreFiles}}getContentPattern(v,y){const O=this.configurationService.getValue();v.isRegExp&&(v.pattern=v.pattern.replace(/\r?\n/g,"\\n"));const N={...v,wordSeparators:O.editor.wordSeparators};return this.isCaseSensitive(v,y)&&(N.isCaseSensitive=!0),this.isMultiline(v)&&(N.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),N}file(v,y={}){return{...this.commonQuery(v,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey}}handleIncludeExclude(v,y){return v?(v=Array.isArray(v)?v.map(_):_(v),y?this.parseSearchPaths(v):{pattern:d(...Array.isArray(v)?v:[v])}):{}}commonQuery(v=[],y={}){const O=this.handleIncludeExclude(y.includePattern,y.expandPatterns),N=this.handleIncludeExclude(y.excludePattern,y.expandPatterns),q=v.length>1,W=(O.searchPaths&&O.searchPaths.length?O.searchPaths.map(M=>this.getFolderQueryForSearchPath(M,y,N)):v.map(M=>this.getFolderQueryForRoot(M,y,N,q))).filter(M=>!!M),x={_reason:y._reason,folderQueries:W,usingSearchPaths:!!(O.searchPaths&&O.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:N.pattern,includePattern:O.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const M=I.coalesce(I.flatten(this.editorGroupsService.groups.map(de=>de.editors.map(we=>we.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(M));const $=M.filter(de=>(0,c.pathIncludedInQuery)(x,de.fsPath)),oe=this.commonQueryFromFileList($);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(oe)),{...x,...oe}}const k=y.extraFileResources&&y.extraFileResources.filter(M=>(0,c.pathIncludedInQuery)(x,M.fsPath));return x.extraFileResources=k&&k.length?k:void 0,x}commonQueryFromFileList(v){const y=[],O=new T.ResourceMap,N={};let q=!1;return v.forEach(W=>{if(W.scheme===g.Schemas.walkThrough)return;if((0,S.isAbsolutePath)(W)){const k=this.workspaceContextService.getWorkspaceFolder(W)?.uri??W.with({path:h.dirname(W.fsPath)});let M=O.get(k);M||(q=!0,M={folder:k,includePattern:{}},y.push(M),O.set(k,M));const $=h.relative(k.fsPath,W.fsPath);(0,D.assertIsDefined)(M.includePattern)[$.replace(/\\/g,"/")]=!0}else W.fsPath&&(q=!0,N[W.fsPath]=!0)}),{folderQueries:y,includePattern:N,usingSearchPaths:!0,excludePattern:q?void 0:{"**/*":!0}}}isCaseSensitive(v,y){if(y.isSmartCase){if(v.isRegExp){if(R.containsUppercaseCharacter(v.pattern,!0))return!0}else if(R.containsUppercaseCharacter(v.pattern))return!0}return!!v.isCaseSensitive}isMultiline(v){return v.isMultiline||v.isRegExp&&(0,p.isMultilineRegexSource)(v.pattern)||v.pattern.indexOf(`
`)>=0?!0:!!v.isMultiline}parseSearchPaths(v){const y=oe=>h.isAbsolute(oe)||/^\.\.?([\/\\]|$)/.test(oe),N=(Array.isArray(v)?v:s(v)).map(oe=>{const de=this.pathService.resolvedUserHome;return de?(0,A.untildify)(oe,de.scheme===g.Schemas.file?de.fsPath:de.path):oe}),q=L.groupBy(N,oe=>y(oe)?"searchPaths":"exprSegments"),W=(q.exprSegments||[]).map(oe=>R.rtrim(oe,"/")).map(oe=>R.rtrim(oe,"\\")).map(oe=>(oe[0]==="."&&(oe="*"+oe),b(oe))),x={},k=this.expandSearchPathPatterns(q.searchPaths||[]);k&&k.length&&(x.searchPaths=k);const M=I.flatten(W),$=d(...M);return $&&(x.pattern=$),x}getExcludesForFolder(v,y){return y.disregardExcludeSettings?void 0:(0,c.getExcludes)(v,!y.disregardSearchExcludeSettings)}expandSearchPathPatterns(v){if(!v||!v.length)return[];const y=v.flatMap(N=>{let{pathPortion:q,globPortion:W}=t(N);return W&&(W=f(W)),this.expandOneSearchPath(q).flatMap(k=>this.resolveOneSearchPathPattern(k,W))}),O=new Map;return y.forEach(N=>{const q=N.searchPath.toString(),W=O.get(q);W?N.pattern&&(W.pattern=W.pattern||{},W.pattern[N.pattern]=!0):O.set(q,{searchPath:N.searchPath,pattern:N.pattern?d(N.pattern):void 0})}),Array.from(O.values())}expandOneSearchPath(v){if(h.isAbsolute(v)){const y=this.workspaceContextService.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==g.Schemas.file?[{searchPath:y[0].uri.with({path:v})}]:[{searchPath:u.URI.file(h.normalize(v))}]}if(this.workspaceContextService.getWorkbenchState()===2){const y=this.workspaceContextService.getWorkspace().folders[0].uri;if(v=_(v),v.startsWith("../")||v===".."){const N=h.posix.resolve(y.path,v);return[{searchPath:y.with({path:N})}]}const O=f(v);return[{searchPath:y,pattern:O}]}else{if(v==="./"||v===".\\")return[];{const y=v.replace(/^\.[\/\\]/,""),N=this.workspaceContextService.getWorkspace().folders.map(q=>{const W=y.match(new RegExp(`^${R.escapeRegExpCharacters(q.name)}(?:/(.*)|$)`));return W?{match:W,folder:q}:null}).filter(D.isDefined);if(N.length)return N.map(q=>{const W=q.match[1];return{searchPath:q.folder.uri,pattern:W&&f(W)}});{const q=v.match(/\.[\/\\](.+)[\/\\]?/),W=q?q[1]:v,x=E.localize(0,null,W);throw new Error(x)}}}}resolveOneSearchPathPattern(v,y){const O=v.pattern&&y?`${v.pattern}/${y}`:v.pattern||y,N=[{searchPath:v.searchPath,pattern:O}];return O&&!O.endsWith("**")&&N.push({searchPath:v.searchPath,pattern:O+"/**"}),N}getFolderQueryForSearchPath(v,y,O){const N=this.getFolderQueryForRoot((0,r.toWorkspaceFolder)(v.searchPath),y,O,!1);return N?{...N,includePattern:v.pattern}:null}getFolderQueryForRoot(v,y,O,N){let q;const W=u.URI.isUri(v)?v:v.uri;if(O.searchPaths){const oe=O.searchPaths.filter(de=>(0,S.isEqual)(de.searchPath,W))[0];if(oe&&!oe.pattern)return null;oe&&(q=oe.pattern)}const x=this.configurationService.getValue({resource:W}),M={...this.getExcludesForFolder(x,y)||{},...q||{}},$=u.URI.isUri(v)?(0,S.basename)(v):v.name;return{folder:W,folderName:N?$:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:x.files&&x.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!x.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!x.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!x.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!x.search.followSymlinks}}};e.QueryBuilder=l,e.QueryBuilder=l=Ke([We(0,i.IConfigurationService),We(1,r.IWorkspaceContextService),We(2,n.IEditorGroupsService),We(3,a.ILogService),We(4,o.IPathService)],l);function t(m){const v=m.match(/[\*\{\}\(\)\[\]\?]/);if(v){const y=v.index,O=m.substr(0,y).match(/[/|\\][^/\\]*$/);if(O){let N=m.substr(0,O.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:m.substr((O.index||0)+1)}}}return{pathPortion:m}}function d(...m){return m.length?m.reduce((v,y)=>(v[y]=!0,v),Object.create(null)):void 0}function s(m){return C.splitGlobAware(m,",").map(v=>v.trim()).filter(v=>!!v.length)}function b(m){return[`**/${m}/**`,`**/${m}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function _(m){return m.replace(/\\/g,"/")}function f(m){return _(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function w(m){return m.replace(/([?*[\]])/g,"[$1]")}function P(m,v){m=I.distinct(m,N=>N.toString());const y=[],O=v.getWorkspace();return m&&m.forEach(N=>{let q;if(v.getWorkbenchState()===2)q=(0,S.relativePath)(O.folders[0].uri,N),q&&q!=="."&&(q="./"+q);else{const W=v.getWorkspaceFolder(N);if(W){const x=W.name;if(O.folders.filter(M=>M.name===x).length===1){const M=(0,S.relativePath)(W.uri,N);M===""?q=`./${W.name}`:q=`./${W.name}/${M}`}else q=N.fsPath}}q&&y.push(w(q))}),y}e.resolveResourcesForSearchIncludes=P}),define(Pe[287],Te([1,0,25,2,20,15,4,286,44,47]),function(me,e,I,L,C,A,T,g,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function D(i,a){const r=a.activationEvents;if(!r)return Promise.resolve(void 0);const n=[],o=[];for(const b of r)if(/^workspaceContains:/.test(b)){const _=b.substr(18);_.indexOf("*")>=0||_.indexOf("?")>=0||i.forceUsingSearch?o.push(_):n.push(_)}if(n.length===0&&o.length===0)return Promise.resolve(void 0);let c;const l=new Promise((b,_)=>{c=b}),t=b=>c({activationEvent:b}),d=Promise.all(n.map(b=>u(i,b,t))).then(()=>{}),s=p(i,a.identifier,o,t);return Promise.all([d,s]).then(()=>{c(void 0)}),l}e.checkActivateWorkspaceContainsExtension=D;async function u(i,a,r){for(const n of i.folders)if(await i.exists(I.joinPath(L.URI.revive(n),a))){r(`workspaceContains:${a}`);return}}async function p(i,a,r,n){if(r.length===0)return Promise.resolve(void 0);const o=new C.CancellationTokenSource,c=i.checkExists(i.folders,r,o.token),l=setTimeout(async()=>{o.cancel(),i.logService.info(`Not activating extension '${a.value}': Timed out while searching for 'workspaceContains' pattern ${r.join(",")}`)},R);let t=!1;try{t=await c}catch(d){A.isCancellationError(d)||A.onUnexpectedError(d)}o.dispose(),clearTimeout(l),t&&n(`workspaceContains:${r.join(",")}`)}function E(i,a,r,n){const o=i.get(T.IInstantiationService),c=i.get(h.ISearchService),t=o.createInstance(g.QueryBuilder).file(a.map(d=>(0,S.toWorkspaceFolder)(L.URI.revive(d))),{_reason:"checkExists",includePattern:r,exists:!0});return c.fileSearch(t,n).then(d=>!!d.limitHit,d=>A.isCancellationError(d)?!1:Promise.reject(d))}e.checkGlobFileExists=E}),define(Pe[38],Te([1,0,159,19,88,25,13,6,50,2,14,3,37,217,83,36,24,105,15,22,23,200,7,100,4,27,85,17,71,86,65,5,287,82,202,11,80,63,21,81]),function(me,e,I,L,C,A,T,g,h,S,R,D,u,p,E,i,a,r,n,o,c,l,t,d,s,b,_,f,w,P,m,v,y,O,N,q,W,x,k,M){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let oe=$=class extends g.Disposable{constructor(J,H,ne,Ae,Re,ke,ce,te,K,ee,ge,be){super(),this._extHostManagedSockets=be,this._onDidChangeRemoteConnectionData=this._register(new v.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=H,this._extHostContext=ne,this._initData=ce,this._extHostWorkspace=Ae,this._extHostConfiguration=Re,this._logService=ke,this._extHostTunnelService=K,this._extHostTerminalService=ee,this._extHostLocalizationService=ge,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(D.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(D.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(D.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._activationEventsReader=new pe(this._initData.extensions.activationEvents),this._globalRegistry=new r.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.extensions.allExtensions);const Le=new o.ExtensionIdentifierSet(this._initData.extensions.myExtensions);this._myRegistry=new r.ExtensionDescriptionRegistry(this._activationEventsReader,ve(this._globalRegistry,Le)),k.isCI&&(this._logService.info(`Creating extension host with the following global extensions: ${ye(this._globalRegistry)}`),this._logService.info(`Creating extension host with the following local extensions: ${ye(this._myRegistry)}`)),this._storage=new E.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new O.ExtHostSecretState(this._extHostContext),this._storagePath=te,this._instaService=J.createChild(new w.ServiceCollection([E.IExtHostStorage,this._storage],[O.IExtHostSecretState,this._secretState])),this._activator=this._register(new p.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(fe,_e,F)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(fe,n.transformErrorForSerialization(_e),F)},actualActivateExtension:async(fe,_e)=>{if(r.ExtensionDescriptionRegistry.isHostExtension(fe,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(fe,_e),new p.HostExtension;const F=this._myRegistry.getExtensionDescription(fe);return this._activateExtension(F,_e)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),C.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(J){n.onUnexpectedError(J)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let J=[];try{J=this._myRegistry.getAllExtensionDescriptions().map(Re=>Re.identifier).filter(Re=>this.isActivated(Re)).map(Re=>this._deactivate(Re))}catch{}await Promise.all(J)}terminate(J,H=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${J}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),n.setUnexpectedErrorHandler(Ae=>{this._logService.error(Ae)}),this._extHostContext.dispose();const ne=this._deactivateAll();Promise.race([(0,T.timeout)(5e3),ne]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${H}`):this._logService.info(`Extension host exiting with code ${H}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(H)})}isActivated(J){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(J):!1}async getExtension(J){const H=await this._mainThreadExtensionsProxy.$getExtension(J);return H&&{...H,identifier:new o.ExtensionIdentifier(H.identifier.value),extensionLocation:S.URI.revive(H.extensionLocation)}}_activateByEvent(J,H){return this._activator.activateByEvent(J,H)}_activateById(J,H){return this._activator.activateById(J,H)}activateByIdWithErrors(J,H){return this._activateById(J,H).then(()=>{const ne=this._activator.getActivatedExtension(J);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(J=>this._myRegistry)}getExtensionExports(J){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(J).exports;try{return this._activator.getActivatedExtension(J).exports}catch{return null}}async _realPathExtensionUri(J){if(J.scheme===q.Schemas.file&&this._hostUtils.fsRealpath){const H=await this._hostUtils.fsRealpath(J.fsPath);return S.URI.file(H)}return J}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(J=>new ae(J))),this._extensionPathIndex}async _createExtensionPathIndex(J){const H=h.TernarySearchTree.forUris(ne=>A.extUriBiasedIgnorePathCase.ignorePathCasing(ne));return await Promise.all(J.map(async ne=>{if(this._getEntryPoint(ne)){const Ae=await this._realPathExtensionUri(ne.extensionLocation);H.set(Ae,ne)}})),H}_deactivate(J){let H=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(J))return H;const ne=this._activator.getActivatedExtension(J);if(!ne)return H;try{typeof ne.module.deactivate=="function"&&(H=Promise.resolve(ne.module.deactivate()).then(void 0,Ae=>(this._logService.error(Ae),Promise.resolve(void 0))))}catch(Ae){this._logService.error(`An error occurred when deactivating the extension '${J.value}':`),this._logService.error(Ae)}try{(0,g.dispose)(ne.subscriptions)}catch(Ae){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${J.value}':`),this._logService.error(Ae)}return H}async _activateExtension(J,H){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(J.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(J.identifier),this._doActivateExtension(J,H).then(ne=>{const Ae=ne.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(J.identifier,Ae.codeLoadingTime,Ae.activateCallTime,Ae.activateResolvedTime,H),this._logExtensionActivationTimes(J,H,"success",Ae),ne},ne=>{throw this._logExtensionActivationTimes(J,H,"failure"),ne})}_logExtensionActivationTimes(J,H,ne,Ae){const Re=we(J,H);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Re,...Ae||{},outcome:ne})}_doActivateExtension(J,H){const ne=we(J,H);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ne);const Ae=this._getEntryPoint(J);if(!Ae)return Promise.resolve(new p.EmptyExtension(p.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${J.identifier.value}, startup: ${H.startup}, activationEvent: '${H.activationEvent}'${J.identifier.value!==H.extensionId.value?`, root cause: ${H.extensionId.value}`:""}`),this._logService.flush();const Re=new p.ExtensionActivationTimesBuilder(H.startup);return Promise.all([this._loadCommonJSModule(J,(0,A.joinPath)(J.extensionLocation,Ae),Re),this._loadExtensionContext(J)]).then(ke=>(C.mark(`code/extHost/willActivateExtension/${J.identifier.value}`),$._callActivate(this._logService,J.identifier,ke[0],ke[1],Re))).then(ke=>(C.mark(`code/extHost/didActivateExtension/${J.identifier.value}`),ke))}_loadExtensionContext(J){const H=new l.ExtensionGlobalMemento(J,this._storage),ne=new l.ExtensionMemento(J.identifier.value,!1,this._storage),Ae=new N.ExtensionSecrets(J,this._secretState),Re=J.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ke=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${J.identifier.value}`),Promise.all([H.whenReady,ne.whenReady,this._storagePath.whenReady]).then(()=>{const ce=this;let te,K;const ee=(0,a.isProposedApiEnabled)(J,"ipc")?this._initData.messagePorts?.get(o.ExtensionIdentifier.toKey(J.identifier)):void 0;return Object.freeze({globalState:H,workspaceState:ne,secrets:Ae,subscriptions:[],get extensionUri(){return J.extensionLocation},get extensionPath(){return J.extensionLocation.fsPath},asAbsolutePath(ge){return L.join(J.extensionLocation.fsPath,ge)},get storagePath(){return ce._storagePath.workspaceValue(J)?.fsPath},get globalStoragePath(){return ce._storagePath.globalValue(J).fsPath},get logPath(){return L.join(ce._initData.logsLocation.fsPath,J.identifier.value)},get logUri(){return S.URI.joinPath(ce._initData.logsLocation,J.identifier.value)},get storageUri(){return ce._storagePath.workspaceValue(J)},get globalStorageUri(){return ce._storagePath.globalValue(J)},get extensionMode(){return Re},get extension(){return te===void 0&&(te=new le(ce,J.identifier,J,ke,!1)),te},get extensionRuntime(){return(0,a.checkProposedApiEnabled)(J,"extensionRuntime"),ce.extensionRuntime},get environmentVariableCollection(){return ce._extHostTerminalService.getEnvironmentVariableCollection(J)},get messagePassingProtocol(){if(!K){if(!ee)return;const ge=v.Event.buffer(v.Event.fromDOMEventEmitter(ee,"message",be=>be.data));ee.start(),K={onDidReceiveMessage:ge,postMessage:ee.postMessage.bind(ee)}}return K}})})}static _callActivate(J,H,ne,Ae,Re){return ne=ne||{activate:void 0,deactivate:void 0},this._callActivateOptional(J,H,ne,Ae,Re).then(ke=>new p.ActivatedExtension(!1,null,Re.build(),ne,ke,Ae.subscriptions))}static _callActivateOptional(J,H,ne,Ae,Re){if(typeof ne.activate=="function")try{Re.activateCallStart(),J.trace(`ExtensionService#_callActivateOptional ${H.value}`);const ke=typeof global=="object"?global:self,ce=ne.activate.apply(ke,[Ae]);return Re.activateCallStop(),Re.activateResolveStart(),Promise.resolve(ce).then(te=>(Re.activateResolveStop(),te))}catch(ke){return Promise.reject(ke)}else return Promise.resolve(ne)}_activateOneStartupFinished(J,H){this._activateById(J.identifier,{startup:!1,extensionId:J.identifier,activationEvent:H}).then(void 0,ne=>{this._logService.error(ne)})}_activateAllStartupFinishedDeferred(J,H=0){const Ae=Date.now();(0,k.setTimeout0)(()=>{for(let Re=H;Re<J.length;Re+=1){const ke=J[Re];for(const ce of ke.activationEvents??[])if(ce==="onStartupFinished")if(Date.now()-Ae>50){this._activateAllStartupFinishedDeferred(J,Re);break}else this._activateOneStartupFinished(ke,ce)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(C.getMarks()),this._extHostConfiguration.getConfigProvider().then(J=>{const H=J.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this._myRegistry.getAllExtensionDescriptions();if(H)this._activateAllStartupFinishedDeferred(ne);else for(const Ae of ne)if(Ae.activationEvents)for(const Re of Ae.activationEvents)Re==="onStartupFinished"&&this._activateOneStartupFinished(Ae,Re)})}_handleEagerExtensions(){const J=this._activateByEvent("*",!0).then(void 0,ke=>{this._logService.error(ke)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ke=>this._handleWorkspaceContainsEagerExtensions(ke.added)));const H=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ne=this._handleWorkspaceContainsEagerExtensions(H),Ae=this._handleRemoteResolverEagerExtensions(),Re=Promise.all([Ae,J,ne]).then(()=>{});return Promise.race([Re,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Re}_handleWorkspaceContainsEagerExtensions(J){return J.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(H=>this._handleWorkspaceContainsEagerExtension(J,H))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(J,H){if(this.isActivated(H.identifier))return;const ne=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Ae={logService:this._logService,folders:J.map(ke=>ke.uri),forceUsingSearch:ne||!this._hostUtils.fsExists,exists:ke=>this._hostUtils.fsExists(ke.fsPath),checkExists:(ke,ce,te)=>this._mainThreadWorkspaceProxy.$checkExists(ke,ce,te)},Re=await(0,y.checkActivateWorkspaceContainsExtension)(Ae,H);if(Re)return this._activateById(H.identifier,{startup:!0,extensionId:H.identifier,activationEvent:Re.activationEvent}).then(void 0,ke=>this._logService.error(ke))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(J){throw console.error(J),J}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:J,extensionTestsLocationURI:H}=this._initData.environment;if(!J||!H)throw new Error(I.localize(0,null));const ne=await this._loadCommonJSModule(null,H,new p.ExtensionActivationTimesBuilder(!1));if(!ne||typeof ne.run!="function")throw new Error(I.localize(1,null,H.toString()));return new Promise((Ae,Re)=>{const ke=(K,ee)=>{K?(k.isCI&&this._logService.error("Test runner called back with error",K),Re(K)):(k.isCI&&(ee?this._logService.info(`Test runner called back with ${ee} failures.`):this._logService.info("Test runner called back with successful outcome.")),Ae(typeof ee=="number"&&ee>0?1:0))},ce=(0,A.originalFSPath)(H),te=ne.run(ce,ke);te&&te.then&&te.then(()=>{k.isCI&&this._logService.info("Test runner finished successfully."),Ae(0)}).catch(K=>{k.isCI&&this._logService.error("Test runner finished with error",K),Re(K instanceof Error&&K.stack?K.stack:String(K))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,T.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(J,H){return this._resolvers[J]=H,(0,g.toDisposable)(()=>{delete this._resolvers[J]})}async getRemoteExecServer(J){const{resolver:H}=await this._activateAndGetResolver(J);return H?.resolveExecServer?.(J,{resolveAttempt:0})}async _activateAndGetResolver(J){const H=J.indexOf("+");if(H===-1)throw new t.RemoteAuthorityResolverError("Not an authority that can be resolved!",d.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=J.substr(0,H);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this._resolvers[ne]}}async $resolveAuthority(J,H){const ne=x.StopWatch.create(!1),Ae=()=>`[resolveAuthority(${(0,d.getRemoteAuthorityPrefix)(J)},${H})][${ne.elapsed()}ms] `,Re=j=>this._logService.info(`${Ae()}${j}`),ke=j=>this._logService.warn(`${Ae()}${j}`),ce=(j,B=void 0)=>this._logService.error(`${Ae()}${j}`,B),te=j=>{if(j instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:j._code,message:j._message,detail:j._detail}};throw j},K=async j=>{Re(`activating resolver for ${j}...`);const{resolver:B,authorityPrefix:X}=await this._activateAndGetResolver(j);if(!B)throw ce(`no resolver for ${X}`),new t.RemoteAuthorityResolverError(`No remote extension installed to resolve ${X}.`,d.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:B,authorityPrefix:X,remoteAuthority:j}},ee=J.split(/@|%40/g).reverse();Re(`activating remote resolvers ${ee.join(" -> ")}`);let ge;try{ge=await Promise.all(ee.map(K)).catch(async j=>{if(!(j instanceof t.RemoteAuthorityResolverError)||j._code!==d.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw j;return ke(`resolving nested authorities failed: ${j.message}`),[await K(J)]})}catch(j){return te(j)}const be=new T.IntervalTimer;be.cancelAndSet(()=>Re("waiting..."),1e3);let Le,fe;for(const[j,{authorityPrefix:B,resolver:X,remoteAuthority:Z}]of ge.entries())try{if(j===ge.length-1)Re("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${B}`),Le=await X.resolve(Z,{resolveAttempt:H,execServer:fe}),C.mark(`code/extHost/didResolveAuthorityOK/${B}`),Re("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(X,t.ManagedResolvedAuthority.isManagedResolvedAuthority(Le)?Le:void 0));else{if(Re(`invoking resolveExecServer() for ${Z}`),C.mark(`code/extHost/willResolveExecServer/${B}`),fe=await X.resolveExecServer?.(Z,{resolveAttempt:H,execServer:fe}),!fe)throw new t.RemoteAuthorityResolverError(`Exec server was not available for ${Z}`,d.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${B}`)}}catch(Se){return C.mark(`code/extHost/didResolveAuthorityError/${B}`),ce("returned an error",Se),be.dispose(),te(Se)}be.dispose();const _e={environmentTunnels:Le.environmentTunnels,features:Le.tunnelFeatures?{elevation:Le.tunnelFeatures.elevation,privacyOptions:Le.tunnelFeatures.privacyOptions,protocol:Le.tunnelFeatures.protocol===void 0?!0:Le.tunnelFeatures.protocol}:void 0},F={extensionHostEnv:Le.extensionHostEnv,isTrusted:Le.isTrusted,authenticationSession:Le.authenticationSessionForInitializingExtensions?{id:Le.authenticationSessionForInitializingExtensions.id,providerId:Le.authenticationSessionForInitializingExtensions.providerId}:void 0};Re(`returned ${t.ManagedResolvedAuthority.isManagedResolvedAuthority(Le)?"managed authority":`${Le.host}:${Le.port}`}`);let V;if(t.ManagedResolvedAuthority.isManagedResolvedAuthority(Le)){const j=H;this._extHostManagedSockets.setFactory(j,Le.makeConnection),V={authority:J,connectTo:new d.ManagedRemoteConnection(j),connectionToken:Le.connectionToken}}else V={authority:J,connectTo:new d.WebSocketRemoteConnection(Le.host,Le.port),connectionToken:Le.connectionToken};return{type:"ok",value:{authority:V,options:F,tunnelInformation:_e}}}async $getCanonicalURI(J,H){this._logService.info(`$getCanonicalURI invoked for authority (${(0,d.getRemoteAuthorityPrefix)(J)})`);const{resolver:ne}=await this._activateAndGetResolver(J);if(!ne)return null;const Ae=S.URI.revive(H);if(typeof ne.getCanonicalURI>"u")return Ae;const Re=await(0,T.asPromise)(()=>ne.getCanonicalURI(Ae));return Re||Ae}$startExtensionHost(J){J.toAdd.forEach(Ae=>Ae.extensionLocation=S.URI.revive(Ae.extensionLocation));const{globalRegistry:H,myExtensions:ne}=de(this._activationEventsReader,this._globalRegistry,this._myRegistry,J);return this._globalRegistry.set(H.getAllExtensionDescriptions()),this._myRegistry.set(ne),k.isCI&&(this._logService.info(`$startExtensionHost: global extensions: ${ye(this._globalRegistry)}`),this._logService.info(`$startExtensionHost: local extensions: ${ye(this._myRegistry)}`)),this._startExtensionHost()}$activateByEvent(J,H){return H===1?this._almostReadyToRunExtensions.wait().then(ne=>this._activateByEvent(J,!1)):this._readyToRunExtensions.wait().then(ne=>this._activateByEvent(J,!1))}async $activate(J,H){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(J)?(await this._activateById(J,H),!0):!1}async $deltaExtensions(J){J.toAdd.forEach(ke=>ke.extensionLocation=S.URI.revive(ke.extensionLocation));const{globalRegistry:H,myExtensions:ne}=de(this._activationEventsReader,this._globalRegistry,this._myRegistry,J),Ae=await this._createExtensionPathIndex(ne);return(await this.getExtensionPathIndex()).setSearchTree(Ae),this._globalRegistry.set(H.getAllExtensionDescriptions()),this._myRegistry.set(ne),k.isCI&&(this._logService.info(`$deltaExtensions: global extensions: ${ye(this._globalRegistry)}`),this._logService.info(`$deltaExtensions: local extensions: ${ye(this._myRegistry)}`)),Promise.resolve(void 0)}async $test_latency(J){return J}async $test_up(J){return J.byteLength}async $test_down(J){const H=c.VSBuffer.alloc(J),ne=Math.random()%256;for(let Ae=0;Ae<J;Ae++)H.writeUInt8(ne,Ae);return H}async $updateRemoteConnectionData(J){this._remoteConnectionData=J,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=oe,e.AbstractExtHostExtensionService=oe=$=Ke([We(0,s.IInstantiationService),We(1,e.IHostUtils),We(2,f.IExtHostRpcService),We(3,i.IExtHostWorkspace),We(4,u.IExtHostConfiguration),We(5,R.ILogService),We(6,b.IExtHostInitDataService),We(7,_.IExtensionStoragePaths),We(8,P.IExtHostTunnelService),We(9,m.IExtHostTerminalService),We(10,W.IExtHostLocalizationService),We(11,M.IExtHostManagedSockets)],oe);function de(re,J,H,ne){re.addActivationEvents(ne.addActivationEvents);const Ae=new r.ExtensionDescriptionRegistry(re,J.getAllExtensionDescriptions());Ae.deltaExtensions(ne.toAdd,ne.toRemove);const Re=new o.ExtensionIdentifierSet(H.getAllExtensionDescriptions().map(ce=>ce.identifier));for(const ce of ne.myToRemove)Re.delete(ce);for(const ce of ne.myToAdd)Re.add(ce);const ke=ve(Ae,Re);return{globalRegistry:Ae,myExtensions:ke}}function we(re,J){return{id:re.identifier.value,name:re.name,extensionVersion:re.version,publisherDisplayName:re.publisher,activationEvents:re.activationEvents?re.activationEvents.join(","):null,isBuiltin:re.isBuiltin,reason:J.activationEvent,reasonId:J.extensionId.value}}function ye(re){return re.getAllExtensionDescriptions().map(J=>J.identifier.value).join(",")}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class le{#e;#t;#i;constructor(J,H,ne,Ae,Re){this.#e=J,this.#t=H,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=L.normalize((0,A.originalFSPath)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=Ae,this.isFromDifferentExtensionHost=Re}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=le;function ve(re,J){return re.getAllExtensionDescriptions().filter(H=>J.has(H.identifier))}class ae{constructor(J){this._searchTree=J}setSearchTree(J){this._searchTree=J}findSubstr(J){return this._searchTree.findSubstr(J)}forEach(J){return this._searchTree.forEach(J)}}e.ExtensionPaths=ae;class pe{constructor(J){this._map=new o.ExtensionIdentifierMap,this.addActivationEvents(J)}readActivationEvents(J){return this._map.get(J.identifier)??[]}addActivationEvents(J){for(const H of Object.keys(J))this._map.set(H,J[H])}}}),define(Pe[288],Te([1,0,88,2,3,37,24,22,17,27,4,38,14,12]),function(me,e,I,L,C,A,T,g,h,S,R,D,u,p){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let i=class{constructor(c,l,t,d,s,b,_){this._apiFactory=c,this._extensionRegistry=l,this._instaService=t,this._extHostConfiguration=d,this._extHostExtensionService=s,this._initData=b,this._logService=_,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),I.mark("code/extHost/willWaitForConfig");const c=await this._extHostConfiguration.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const l=await this._extHostExtensionService.getExtensionPathIndex();this.register(new r(this._apiFactory,l,this._extensionRegistry,c,this._logService)),this.register(this._instaService.createInstance(a)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(n,l,this._initData.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const l of c.nodeModuleName)this._factories.set(l,c);else this._factories.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this._alternatives.push(l=>c.alternativeModuleName(l))}};e.RequireInterceptor=i,e.RequireInterceptor=i=Ke([We(2,R.IInstantiationService),We(3,A.IExtHostConfiguration),We(4,D.IExtHostExtensionService),We(5,S.IExtHostInitDataService),We(6,u.ILogService)],i);let a=class{static{E=this}static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&E.aliased.size){const l=(0,p.escapeRegExpCharacters)(this.forceForwardSlashes(c.environment.appRoot.fsPath)),t="[a-z0-9_.-]",d=`@${t}+\\/${t}+|${t}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${l}/${s}\\/)(${d})(.*)$`,"i")}}alternativeModuleName(c){if(!this.re)return;const l=this.re.exec(this.forceForwardSlashes(c));if(!l)return;const[,t,d,s]=l,b=E.aliased.get(d);if(b!==void 0)return console.warn(`${d} as been renamed to ${b}, please update your imports`),t+b+s}forceForwardSlashes(c){return c.replace(/\\/g,"/")}};a=E=Ke([We(0,S.IExtHostInitDataService)],a);class r{constructor(c,l,t,d,s){this._apiFactory=c,this._extensionPaths=l,this._extensionRegistry=t,this._configProvider=d,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new g.ExtensionIdentifierMap}load(c,l){const t=this._extensionPaths.findSubstr(l);if(t){let d=this._extApiImpl.get(t.identifier);return d||(d=this._apiFactory(t,this._extensionRegistry,this._configProvider),this._extApiImpl.set(t.identifier,d)),d}if(!this._defaultApiImpl){let d="";this._extensionPaths.forEach((s,b)=>d+=`	${b} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${l}. These are the extension path mappings: 
${d}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let n=class{constructor(c,l,t){this._extensionPaths=c,this._appUriScheme=l,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=t.getProxy(C.MainContext.MainThreadTelemetry);const d=t.getProxy(C.MainContext.MainThreadWindow);this._impl=(s,b)=>{const _=L.URI.parse(s);return b?this.callOriginal(s,b):_.scheme==="http"||_.scheme==="https"?d.$openUri(_,s,{allowTunneling:!0}):_.scheme==="mailto"||_.scheme===this._appUriScheme?d.$openUri(_,s,{}):this.callOriginal(s,b)}}load(c,l,t){const d=this._extensionPaths.findSubstr(l);return d&&(this._extensionId=d.identifier.value,this.sendShimmingTelemetry()),this._original=t(c),this._impl}callOriginal(c,l){return this.sendNoForwardTelemetry(),this._original(c,l)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};n=Ke([We(2,h.IExtHostRpcService)],n)}),define(Pe[116],Te([1,0,39,6,19,74,4,66,64,38,7,36,214,37]),function(me,e,I,L,C,A,T,g,h,S,R,D,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,T.createDecorator)("IExtHostVariableResolverProvider");class E extends u.AbstractVariableResolverService{constructor(r,n,o,c,l,t,d){function s(){if(o){const b=o.activeEditor();if(b)return b.document.uri;const _=c.tabGroups.all.find(f=>f.isActive)?.activeTab;if(_!==void 0){if(_.input instanceof R.TextDiffTabInput||_.input instanceof R.NotebookDiffEditorTabInput)return _.input.modified;if(_.input instanceof R.TextTabInput||_.input instanceof R.NotebookEditorTabInput||_.input instanceof R.CustomEditorTabInput)return _.input.uri}}}super({getFolderUri:b=>{const _=t.folders.filter(f=>f.name===b);if(_&&_.length>0)return _[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(b,_)=>l.getConfiguration(void 0,b).get(_),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const b=s();if(b)return C.normalize(b.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const b=s();if(b){const _=n.getWorkspaceFolder(b);if(_)return C.normalize(_.uri.fsPath)}}},getSelectedText:()=>{if(o){const b=o.activeEditor();if(b&&!b.selection.isEmpty)return b.document.getText(b.selection)}},getLineNumber:()=>{if(o){const b=o.activeEditor();if(b)return String(b.selection.end.line+1)}},getExtension:b=>r.getExtension(b)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(A.env))}}let i=class extends L.Disposable{constructor(r,n,o,c,l){super(),this.extensionService=r,this.workspaceService=n,this.editorService=o,this.configurationService=c,this.editorTabs=l,this._resolver=new I.Lazy(async()=>{const t=await this.configurationService.getConfigProvider(),s={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async b=>{s.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new E(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,t,s,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=i,e.ExtHostVariableResolverProviderService=i=Ke([We(0,S.IExtHostExtensionService),We(1,D.IExtHostWorkspace),We(2,g.IExtHostDocumentsAndEditors),We(3,p.IExtHostConfiguration),We(4,h.IExtHostEditorTabs)],i)}),define(Pe[117],Te([1,0,13,5,2,22,4,3,64,38,17,7,36,206,208,37,116,6,40,31]),function(me,e,I,L,C,A,T,g,h,S,R,D,u,p,E,i,a,r,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,T.createDecorator)("IExtHostDebugService");let c=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(f,w,P,m,v,y,O){this._workspaceService=w,this._extensionService=P,this._configurationService=m,this._editorTabs=v,this._variableResolver=y,this._commands=O,this._debugSessions=new Map,this._debugVisualizationProviders=new Map,this._visualizers=new Map,this._visualizerIdCounter=0,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new L.Emitter,this._onDidTerminateDebugSession=new L.Emitter,this._onDidChangeActiveDebugSession=new L.Emitter,this._onDidReceiveDebugSessionCustomEvent=new L.Emitter,this._debugServiceProxy=f.getProxy(g.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new L.Emitter,this._onDidChangeStackFrameFocus=new L.Emitter,this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then(N=>{N.onDidChange(q=>{this.registerAllDebugTypes(N)}),this.registerAllDebugTypes(N)})}asDebugSourceUri(f,w){const P=f;if(typeof P.sourceReference=="number"&&P.sourceReference>0){let m=`debug:${encodeURIComponent(P.path||"")}`,v="?";return w&&(m+=`${v}session=${encodeURIComponent(w.id)}`,v="&"),m+=`${v}ref=${P.sourceReference}`,C.URI.parse(m)}else{if(P.path)return C.URI.file(P.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(f){const w=[];for(const P of f.getAllExtensionDescriptions())if(P.contributes){const m=P.contributes.debuggers;if(m&&m.length>0)for(const v of m)(0,E.isDebuggerMainContribution)(v)&&w.push(v.type)}this._debugServiceProxy.$registerDebugTypes(w)}get stackFrameFocus(){return this._stackFrameFocus}get onDidChangeStackFrameFocus(){return this._onDidChangeStackFrameFocus.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const f=[];return this._breakpoints.forEach(w=>f.push(w)),f}async $resolveDebugVisualizer(f,w){const P=this._visualizers.get(f);if(!P)throw new Error(`No debug visualizer found with id '${f}'`);let{v:m,provider:v}=P;if(m.visualization||(m=await v.resolveDebugVisualization?.(m,w)||m,P.v=m),!m.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${v}'`);return this.serializeVisualization(m.visualization)}async $executeDebugVisualizerCommand(f){const w=this._visualizers.get(f);if(!w)throw new Error(`No debug visualizer found with id '${f}'`);const P=w.v.visualization;P&&"command"in P&&this._commands.executeCommand(P.command,...P.arguments||[])}async $provideDebugVisualizers(f,w,P,m){const v=this._debugSessions.get(P.sessionId),y=this.extensionVisKey(f,w),O=this._debugVisualizationProviders.get(y);if(!v||!O)return[];const N=await O.provideDebugVisualization({session:v,variable:P.variable,containerId:P.containerId,frameId:P.frameId,threadId:P.threadId},m);return N?N.map(q=>{const W=++this._visualizerIdCounter;this._visualizers.set(W,{v:q,provider:O});const x=q.iconPath?this.getIconPathOrClass(q.iconPath):void 0;return{id:W,name:q.name,iconClass:x?.iconClass,iconPath:x?.iconPath,visualization:this.serializeVisualization(q.visualization)}}):[]}$disposeDebugVisualizers(f){for(const w of f)this._visualizers.delete(w)}registerDebugVisualizationProvider(f,w,P){if(!f.contributes?.debugVisualizers?.some(y=>y.id===w))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${w})`);const m=A.ExtensionIdentifier.toKey(f.identifier),v=this.extensionVisKey(m,w);if(this._debugVisualizationProviders.has(v))throw new Error(`A debug visualization provider with id '${w}' is already registered`);return this._debugVisualizationProviders.set(v,P),this._debugServiceProxy.$registerDebugVisualizer(m,w),(0,r.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizer(m,w),this._debugVisualizationProviders.delete(w)})}addBreakpoints(f){const w=f.filter(v=>{const y=v.id;return this._breakpoints.has(y)?!1:(this._breakpoints.set(y,v),!0)});this.fireBreakpointChanges(w,[],[]);const P=[],m=new Map;for(const v of w)if(v instanceof D.SourceBreakpoint){let y=m.get(v.location.uri.toString());y||(y={type:"sourceMulti",uri:v.location.uri,lines:[]},m.set(v.location.uri.toString(),y),P.push(y)),y.lines.push({id:v.id,enabled:v.enabled,condition:v.condition,hitCondition:v.hitCondition,logMessage:v.logMessage,line:v.location.range.start.line,character:v.location.range.start.character})}else v instanceof D.FunctionBreakpoint&&P.push({type:"function",id:v.id,enabled:v.enabled,hitCondition:v.hitCondition,logMessage:v.logMessage,condition:v.condition,functionName:v.functionName});return this._debugServiceProxy.$registerBreakpoints(P)}removeBreakpoints(f){const w=f.filter(y=>this._breakpoints.delete(y.id));this.fireBreakpointChanges([],w,[]);const P=w.filter(y=>y instanceof D.SourceBreakpoint).map(y=>y.id),m=w.filter(y=>y instanceof D.FunctionBreakpoint).map(y=>y.id),v=w.filter(y=>y instanceof D.DataBreakpoint).map(y=>y.id);return this._debugServiceProxy.$unregisterBreakpoints(P,m,v)}startDebugging(f,w,P){return this._debugServiceProxy.$startDebugging(f?f.uri:void 0,w,{parentSessionID:P.parentSession?P.parentSession.id:void 0,lifecycleManagedByParent:P.lifecycleManagedByParent,repl:P.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:P.noDebug,compact:P.compact,suppressSaveBeforeStart:P.suppressSaveBeforeStart,suppressDebugStatusbar:P.suppressDebugStatusbar??P.debugUI?.simple,suppressDebugToolbar:P.suppressDebugToolbar??P.debugUI?.simple,suppressDebugView:P.suppressDebugView??P.debugUI?.simple})}stopDebugging(f){return this._debugServiceProxy.$stopDebugging(f?f.id:void 0)}registerDebugConfigurationProvider(f,w,P){if(!w)return new D.Disposable(()=>{});const m=this._configProviderHandleCounter++;return this._configProviders.push({type:f,handle:m,provider:w}),this._debugServiceProxy.$registerDebugConfigurationProvider(f,P,!!w.provideDebugConfigurations,!!w.resolveDebugConfiguration,!!w.resolveDebugConfigurationWithSubstitutedVariables,m),new D.Disposable(()=>{this._configProviders=this._configProviders.filter(v=>v.provider!==w),this._debugServiceProxy.$unregisterDebugConfigurationProvider(m)})}registerDebugAdapterDescriptorFactory(f,w,P){if(!P)return new D.Disposable(()=>{});if(!this.definesDebugType(f,w))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${w}' debugger.`);if(this.getAdapterDescriptorFactoryByType(w))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const m=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:w,handle:m,factory:P}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(w,m),new D.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(v=>v.factory!==P),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(m)})}registerDebugAdapterTrackerFactory(f,w){if(!w)return new D.Disposable(()=>{});const P=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:f,handle:P,factory:w}),new D.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(m=>m.factory!==w)})}async $runInTerminal(f,w){return Promise.resolve(void 0)}async $substituteVariables(f,w){let P;const m=await this.getFolder(f);return m&&(P={uri:m.uri,name:m.name,index:m.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(P,w)}createDebugAdapter(f,w){if(f.type==="implementation")return new s(f.implementation)}createSignService(){}async $startDASession(f,w){const P=this,m=await this.getSession(w);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(m.type),m).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}' (extension might have failed to activate)`);const y=this.convertToDto(v),O=this.createDebugAdapter(y,m);if(!O)throw new Error(`Couldn't create a debug adapter for type '${m.type}'.`);const N=O;return this._debugAdapters.set(f,N),this.getDebugAdapterTrackers(m).then(q=>(q&&this._debugAdaptersTrackers.set(f,q),N.onMessage(async W=>{if(W.type==="request"&&W.command==="handshake"){const x=W,k={type:"response",seq:0,command:x.command,request_seq:x.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const M=await this._signService.sign(x.arguments.value);k.body={signature:M},N.sendResponse(k)}else throw new Error("no signer")}catch(M){k.success=!1,k.message=M.message,N.sendResponse(k)}}else q&&q.onDidSendMessage&&q.onDidSendMessage(W),W=(0,E.convertToVSCPaths)(W,!0),P._debugServiceProxy.$acceptDAMessage(f,W)}),N.onError(W=>{q&&q.onError&&q.onError(W),this._debugServiceProxy.$acceptDAError(f,W.name,W.message,W.stack)}),N.onExit(W=>{q&&q.onExit&&q.onExit(W??void 0,void 0),this._debugServiceProxy.$acceptDAExit(f,W??void 0,void 0)}),q&&q.onWillStartSession&&q.onWillStartSession(),N.startSession()))})}$sendDAMessage(f,w){w=(0,E.convertToDAPaths)(w,!1);const P=this._debugAdaptersTrackers.get(f);P&&P.onWillReceiveMessage&&P.onWillReceiveMessage(w),this._debugAdapters.get(f)?.sendMessage(w)}$stopDASession(f){const w=this._debugAdaptersTrackers.get(f);this._debugAdaptersTrackers.delete(f),w&&w.onWillStopSession&&w.onWillStopSession();const P=this._debugAdapters.get(f);return this._debugAdapters.delete(f),P?P.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(f){const w=[],P=[],m=[];if(f.added)for(const v of f.added){const y=v.id;if(y&&!this._breakpoints.has(y)){let O;if(v.type==="function")O=new D.FunctionBreakpoint(v.functionName,v.enabled,v.condition,v.hitCondition,v.logMessage);else if(v.type==="data")O=new D.DataBreakpoint(v.label,v.dataId,v.canPersist,v.enabled,v.hitCondition,v.condition,v.logMessage);else{const N=C.URI.revive(v.uri);O=new D.SourceBreakpoint(new D.Location(N,new D.Position(v.line,v.character)),v.enabled,v.condition,v.hitCondition,v.logMessage)}(0,D.setBreakpointId)(O,y),this._breakpoints.set(y,O),w.push(O)}}if(f.removed)for(const v of f.removed){const y=this._breakpoints.get(v);y&&(this._breakpoints.delete(v),P.push(y))}if(f.changed){for(const v of f.changed)if(v.id){const y=this._breakpoints.get(v.id);if(y){if(y instanceof D.FunctionBreakpoint&&v.type==="function"){const O=y;O.enabled=v.enabled,O.condition=v.condition,O.hitCondition=v.hitCondition,O.logMessage=v.logMessage,O.functionName=v.functionName}else if(y instanceof D.SourceBreakpoint&&v.type==="source"){const O=y;O.enabled=v.enabled,O.condition=v.condition,O.hitCondition=v.hitCondition,O.logMessage=v.logMessage,O.location=new D.Location(C.URI.revive(v.uri),new D.Position(v.line,v.character))}m.push(y)}}}this.fireBreakpointChanges(w,P,m)}async $acceptStackFrameFocus(f){let w;const P=f.sessionId?await this.getSession(f.sessionId):void 0;if(!P)throw new Error("no DebugSession found for debug focus context");f.kind==="thread"?w=new D.ThreadFocus(P,f.threadId):w=new D.StackFrameFocus(P,f.threadId,f.frameId),this._stackFrameFocus=w,this._onDidChangeStackFrameFocus.fire(this._stackFrameFocus)}$provideDebugConfigurations(f,w,P){return(0,I.asPromise)(async()=>{const m=this.getConfigProviderByHandle(f);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const v=await this.getFolder(w);return m.provideDebugConfigurations(v,P)}).then(m=>{if(!m)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return m})}$resolveDebugConfiguration(f,w,P,m){return(0,I.asPromise)(async()=>{const v=this.getConfigProviderByHandle(f);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const y=await this.getFolder(w);return v.resolveDebugConfiguration(y,P,m)})}$resolveDebugConfigurationWithSubstitutedVariables(f,w,P,m){return(0,I.asPromise)(async()=>{const v=this.getConfigProviderByHandle(f);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const y=await this.getFolder(w);return v.resolveDebugConfigurationWithSubstitutedVariables(y,P,m)})}async $provideDebugAdapter(f,w){const P=this.getAdapterDescriptorFactoryByHandle(f);if(!P)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const m=await this.getSession(w);return this.getAdapterDescriptor(P,m).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}'`);return this.convertToDto(v)})}async $acceptDebugSessionStarted(f){const w=await this.getSession(f);this._onDidStartDebugSession.fire(w)}async $acceptDebugSessionTerminated(f){const w=await this.getSession(f);w&&(this._onDidTerminateDebugSession.fire(w),this._debugSessions.delete(w.id))}async $acceptDebugSessionActiveChanged(f){this._activeDebugSession=f?await this.getSession(f):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(f,w){(await this.getSession(f))?._acceptNameChanged(w)}async $acceptDebugSessionCustomEvent(f,w){const m={session:await this.getSession(f),event:w.event,body:w.body};this._onDidReceiveDebugSessionCustomEvent.fire(m)}convertToDto(f){if(f instanceof D.DebugAdapterExecutable)return{type:"executable",command:f.command,args:f.args,options:f.options};if(f instanceof D.DebugAdapterServer)return{type:"server",port:f.port,host:f.host};if(f instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:f.path};if(f instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:f.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(f){const w=this._adapterFactories.filter(P=>P.type===f);if(w.length>0)return w[0].factory}getAdapterDescriptorFactoryByHandle(f){const w=this._adapterFactories.filter(P=>P.handle===f);if(w.length>0)return w[0].factory}getConfigProviderByHandle(f){const w=this._configProviders.filter(P=>P.handle===f);if(w.length>0)return w[0].provider}definesDebugType(f,w){if(f.contributes){const P=f.contributes.debuggers;if(P&&P.length>0){for(const m of P)if(m.label&&m.type&&m.type===w)return!0}}return!1}getDebugAdapterTrackers(f){const P=f.configuration.type,m=this._trackerFactories.filter(v=>v.type===P||v.type==="*").map(v=>(0,I.asPromise)(()=>v.factory.createDebugAdapterTracker(f)).then(y=>y,y=>null));return Promise.race([Promise.all(m).then(v=>{const y=v.filter(O=>!!O);if(y.length>0)return new d(y)}),new Promise(v=>setTimeout(()=>v(void 0),1e3))]).catch(v=>{})}async getAdapterDescriptor(f,w){const P=w.configuration.debugServer;if(typeof P=="number")return Promise.resolve(new D.DebugAdapterServer(P));if(f){const v=await this._extensionService.getExtensionRegistry();return(0,I.asPromise)(()=>f.createDebugAdapterDescriptor(w,this.daExecutableFromPackage(w,v))).then(y=>{if(y)return y})}const m=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(w,m))}daExecutableFromPackage(f,w){}fireBreakpointChanges(f,w,P){(f.length>0||w.length>0||P.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:f,removed:w,changed:P}))}async getSession(f){if(f)if(typeof f=="string"){const w=this._debugSessions.get(f);if(w)return w}else{let w=this._debugSessions.get(f.id);if(!w){const P=await this.getFolder(f.folderUri),m=f.parent?this._debugSessions.get(f.parent):void 0;w=new l(this._debugServiceProxy,f.id,f.type,f.name,P,f.configuration,m),this._debugSessions.set(w.id,w),this._debugServiceProxy.$sessionCached(w.id)}return w}throw new Error("cannot find session")}getFolder(f){if(f){const w=C.URI.revive(f);return this._workspaceService.resolveWorkspaceFolder(w)}return Promise.resolve(void 0)}extensionVisKey(f,w){return`${f}\0${w}`}serializeVisualization(f){if(f){if("title"in f&&"command"in f)return{type:0};throw new Error("Unsupported debug visualization type")}}getIconPathOrClass(f){const w=this.getIconUris(f);let P,m;return"id"in w?m=n.ThemeIcon.asClassName(w):P=w,{iconPath:P,iconClass:m}}getIconUris(f){if(f instanceof D.ThemeIcon)return{id:f.id};const w=typeof f=="object"&&"dark"in f?f.dark:f,P=typeof f=="object"&&"light"in f?f.light:f;return{dark:typeof w=="string"?C.URI.file(w):w,light:typeof P=="string"?C.URI.file(P):P}}};e.ExtHostDebugServiceBase=c,e.ExtHostDebugServiceBase=c=Ke([We(0,R.IExtHostRpcService),We(1,u.IExtHostWorkspace),We(2,S.IExtHostExtensionService),We(3,i.IExtHostConfiguration),We(4,h.IExtHostEditorTabs),We(5,a.IExtHostVariableResolverProvider),We(6,o.IExtHostCommands)],c);class l{constructor(f,w,P,m,v,y,O){this._debugServiceProxy=f,this._id=w,this._type=P,this._name=m,this._workspaceFolder=v,this._configuration=y,this._parentSession=O}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(f){this._name=f,this._debugServiceProxy.$setDebugSessionName(this._id,f)}get parentSession(){return this._parentSession}_acceptNameChanged(f){this._name=f}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(f,w){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,f,w)}getDebugProtocolBreakpoint(f){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,f.id)}}e.ExtHostDebugSession=l;class t{constructor(f){this.value=Object.freeze({append(w){f.$appendDebugConsole(w)},appendLine(w){this.append(w+`
`)}})}}e.ExtHostDebugConsole=t;class d{constructor(f){this.trackers=f}onWillStartSession(){this.trackers.forEach(f=>f.onWillStartSession?f.onWillStartSession():void 0)}onWillReceiveMessage(f){this.trackers.forEach(w=>w.onWillReceiveMessage?w.onWillReceiveMessage(f):void 0)}onDidSendMessage(f){this.trackers.forEach(w=>w.onDidSendMessage?w.onDidSendMessage(f):void 0)}onWillStopSession(){this.trackers.forEach(f=>f.onWillStopSession?f.onWillStopSession():void 0)}onError(f){this.trackers.forEach(w=>w.onError?w.onError(f):void 0)}onExit(f,w){this.trackers.forEach(P=>P.onExit?P.onExit(f,w):void 0)}}class s extends p.AbstractDebugAdapter{constructor(f){super(),this.implementation=f,f.onDidSendMessage(w=>{this.acceptMessage(w)})}startSession(){return Promise.resolve(void 0)}sendMessage(f){this.implementation.handleMessage(f)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let b=class extends c{constructor(f,w,P,m,v,y,O){super(f,w,P,m,v,y,O)}};e.WorkerExtHostDebugService=b,e.WorkerExtHostDebugService=b=Ke([We(0,R.IExtHostRpcService),We(1,u.IExtHostWorkspace),We(2,S.IExtHostExtensionService),We(3,i.IExtHostConfiguration),We(4,h.IExtHostEditorTabs),We(5,a.IExtHostVariableResolverProvider),We(6,o.IExtHostCommands)],b)}),define(Pe[289],Te([1,0,15,88,2,3,234,14,53,71,27,184,17,58,38,60]),function(me,e,I,L,C,A,T,g,h,S,R,D,u,p,E,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0;class a{static async installEarlyHandler(o){Error.stackTraceLimit=100;const c=o.get(g.ILogService),t=o.get(u.IExtHostRpcService).getProxy(A.MainContext.MainThreadErrors);I.setUnexpectedErrorHandler(d=>{c.error(d);const s=I.transformErrorForSerialization(d);t.$onUnexpectedError(s)})}static async installFullHandler(o){const c=o.get(g.ILogService),l=o.get(u.IExtHostRpcService),t=o.get(E.IExtHostExtensionService),d=o.get(i.IExtHostTelemetry),s=l.getProxy(A.MainContext.MainThreadExtensionService),b=l.getProxy(A.MainContext.MainThreadErrors),_=await t.getExtensionPathIndex(),f=new WeakMap;function w(v,y){if(f.has(v))return f.get(v).stack;let O="",N,q;for(const x of y)O+=`
	at ${x.toString()}`,q=x.getFileName(),!N&&q&&(N=_.findSubstr(C.URI.file(q)));const W=`${v.name||"Error"}: ${v.message||""}${O}`;return f.set(v,{extensionIdentifier:N?.identifier,stack:W}),W}const P=Symbol("prepareStackTrace wrapped");let m=w;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return m},set(v){if(v===w||!v||v[P]){m=v||w;return}m=function(y,O){return w(y,O),v.call(Error,y,O)},Object.assign(m,{[P]:!0})}}),I.setUnexpectedErrorHandler(v=>{c.error(v);const y=I.transformErrorForSerialization(v),O=f.get(v);if(!O?.extensionIdentifier){b.$onUnexpectedError(y);return}s.$onExtensionRuntimeError(O.extensionIdentifier,y);const N=d.onExtensionError(O.extensionIdentifier,v);c.trace("forwarded error to extension?",N,O)})}}e.ErrorHandler=a;class r{constructor(o,c,l,t,d){this._hostUtils=l,this._rpcProtocol=new T.RPCProtocol(o,null,t),c=r._transform(c,this._rpcProtocol);const s=new S.ServiceCollection(...(0,h.getSingletonServiceDescriptors)());s.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...c,messagePorts:d}),s.set(u.IExtHostRpcService,new u.ExtHostRpcService(this._rpcProtocol)),s.set(p.IURITransformerService,new p.URITransformerService(t)),s.set(E.IHostUtils,l);const b=new D.InstantiationService(s,!0);b.invokeFunction(a.installEarlyHandler),this._logService=b.invokeFunction(_=>_.get(g.ILogService)),L.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",c),this._extensionService=b.invokeFunction(_=>_.get(E.IExtHostExtensionService)),this._extensionService.initialize(),b.invokeFunction(a.installFullHandler)}async asBrowserUri(o){const c=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService);return C.URI.revive(await c.$asBrowserUri(o))}terminate(o){this._extensionService.terminate(o)}static _transform(o,c){o.extensions.allExtensions.forEach(t=>{t.extensionLocation=C.URI.revive(c.transformIncomingURIs(t.extensionLocation))}),o.environment.appRoot=C.URI.revive(c.transformIncomingURIs(o.environment.appRoot));const l=o.environment.extensionDevelopmentLocationURI;return l&&(o.environment.extensionDevelopmentLocationURI=l.map(t=>C.URI.revive(c.transformIncomingURIs(t)))),o.environment.extensionTestsLocationURI=C.URI.revive(c.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=C.URI.revive(c.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=C.URI.revive(c.transformIncomingURIs(o.environment.workspaceStorageHome)),o.environment.extensionTelemetryLogResource=C.URI.revive(c.transformIncomingURIs(o.environment.extensionTelemetryLogResource)),o.nlsBaseUrl=C.URI.revive(c.transformIncomingURIs(o.nlsBaseUrl)),o.logsLocation=C.URI.revive(c.transformIncomingURIs(o.logsLocation)),o.workspace=c.transformIncomingURIs(o.workspace),o}}e.ExtensionHostMain=r}),define(Pe[290],Te([1,0,18,13,20,41,11,19,25,2,44]),function(me,e,I,L,C,A,T,g,h,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class D{constructor(n,o,c,l){this.query=n,this.provider=o,this.fileUtils=c,this.processType=l,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(n,o){const c=this.query.folderQueries||[],l=new C.CancellationTokenSource(o);return new Promise((t,d)=>{this.collector=new p(n);let s=!1;const b=(_,f)=>{if(!s&&!this.isLimitHit){const w=this.resultSize(_);i(_)&&typeof this.query.maxResults=="number"&&this.resultCount+w>this.query.maxResults&&(this.isLimitHit=!0,s=!0,l.cancel(),_=this.trimResultToSize(_,this.query.maxResults-this.resultCount));const P=this.resultSize(_);this.resultCount+=P,(P>0||!i(_))&&this.collector.add(_,f)}};Promise.all(c.map((_,f)=>this.searchInFolder(_,w=>b(w,f),l.token))).then(_=>{l.dispose(),this.collector.flush();const f=_.some(w=>!!w&&!!w.limitHit);t({limitHit:this.isLimitHit||f,messages:(0,I.flatten)(_.map(w=>w?.message?Array.isArray(w.message)?w.message:[w.message]:[])),stats:{type:this.processType}})},_=>{l.dispose();const f=(0,A.toErrorMessage)(_);d(new Error(f))})})}resultSize(n){return i(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}trimResultToSize(n,o){const c=Array.isArray(n.ranges)?n.ranges:[n.ranges],l=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:c.slice(0,o),preview:{matches:l.slice(0,o),text:n.preview.text},uri:n.uri}}async searchInFolder(n,o,c){const l=new R.QueryGlobTester(this.query,n),t=[],d={report:_=>{if(!this.validateProviderResult(_))return;const f=n.folder.scheme===T.Schemas.file?(0,R.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(h.dirname(_.uri))):void 0,w=h.relativePath(n.folder,_.uri);if(w){const P=l.includedInQuery(w,g.basename(w),f);(0,L.isThenable)(P)?t.push(P.then(m=>{m&&o(_)})):P&&o(_)}}},s=this.getSearchOptionsForFolder(n),b=await this.provider.provideTextSearchResults(u(this.query.contentPattern),s,d,c);return t.length&&await Promise.all(t),b}validateProviderResult(n){if(i(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(n){const o=(0,R.resolvePatternsForProvider)(this.query.includePattern,n.includePattern),c=(0,R.resolvePatternsForProvider)(this.query.excludePattern,n.excludePattern),l={folder:S.URI.from(n.folder),excludes:c,includes:o,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.fileUtils.toCanonicalName(n.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return l.usePCRE2=this.query.usePCRE2,l}}e.TextSearchManager=D;function u(r){return{isCaseSensitive:r.isCaseSensitive||!1,isRegExp:r.isRegExp||!1,isWordMatch:r.isWordMatch||!1,isMultiline:r.isMultiline||!1,pattern:r.pattern}}class p{constructor(n){this._onResult=n,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new a(512,o=>this.sendItems(o))}add(n,o){this._currentFileMatch&&(this._currentFolderIdx!==o||!h.isEqual(this._currentUri,n.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=o,this._currentFileMatch={resource:n.uri,results:[]}),this._currentFileMatch.results.push(E(n))}pushToCollector(){const n=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,n)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(n){this._onResult(n)}}e.TextSearchResultsCollector=p;function E(r){return i(r)?{preview:{matches:(0,I.mapArrayOrNot)(r.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:r.preview.text},ranges:(0,I.mapArrayOrNot)(r.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:r.text,lineNumber:r.lineNumber}}function i(r){return!!r.preview}e.extensionResultIsMatch=i;class a{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(n,o){this.maxBatchSize=n,this.cb=o,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(n,o){n&&this.addItemToBatch(n,o)}addItems(n,o){n&&this.addItemsToBatch(n,o)}addItemToBatch(n,o){this.batch.push(n),this.batchSize+=o,this.onUpdate()}addItemsToBatch(n,o){this.batch=this.batch.concat(n),this.batchSize+=o,this.onUpdate()}onUpdate(){this.totalNumberCompleted<a.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},a.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=a}),define(Pe[118],Te([1,0,6,3,4,285,17,58,14,2,290]),function(me,e,I,L,C,A,T,g,h,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,C.createDecorator)("IExtHostSearch");let D=class{constructor(i,a,r){this.extHostRpc=i,this._uriTransformer=a,this._logService=r,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(i){return this._uriTransformer.transformOutgoingScheme(i)}registerTextSearchProvider(i,a){if(this._textSearchUsedSchemes.has(i))throw new Error(`a text search provider for the scheme '${i}' is already registered`);this._textSearchUsedSchemes.add(i);const r=this._handlePool++;return this._textSearchProvider.set(r,a),this._proxy.$registerTextSearchProvider(r,this._transformScheme(i)),(0,I.toDisposable)(()=>{this._textSearchUsedSchemes.delete(i),this._textSearchProvider.delete(r),this._proxy.$unregisterProvider(r)})}registerFileSearchProvider(i,a){if(this._fileSearchUsedSchemes.has(i))throw new Error(`a file search provider for the scheme '${i}' is already registered`);this._fileSearchUsedSchemes.add(i);const r=this._handlePool++;return this._fileSearchProvider.set(r,a),this._proxy.$registerFileSearchProvider(r,this._transformScheme(i)),(0,I.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(i),this._fileSearchProvider.delete(r),this._proxy.$unregisterProvider(r)})}$provideFileSearchResults(i,a,r,n){const o=u(r),c=this._fileSearchProvider.get(i);if(c)return this._fileSearchManager.fileSearch(o,c,l=>{this._proxy.$handleFileMatch(i,a,l.map(t=>t.resource))},n);throw new Error("unknown provider: "+i)}async doInternalFileSearchWithCustomCallback(i,a,r){return{messages:[]}}$clearCache(i){return this._fileSearchManager.clearCache(i),Promise.resolve(void 0)}$provideTextSearchResults(i,a,r,n){const o=this._textSearchProvider.get(i);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${i}`);const c=u(r);return this.createTextSearchManager(c,o).search(t=>this._proxy.$handleTextMatch(i,a,t),n)}$enableExtensionHostSearch(){}createTextSearchManager(i,a){return new R.TextSearchManager(i,a,{readdir:r=>Promise.resolve([]),toCanonicalName:r=>r},"textSearchProvider")}};e.ExtHostSearch=D,e.ExtHostSearch=D=Ke([We(0,T.IExtHostRpcService),We(1,g.IURITransformerService),We(2,h.ILogService)],D);function u(E){return{...E,folderQueries:E.folderQueries&&E.folderQueries.map(p),extraFileResources:E.extraFileResources&&E.extraFileResources.map(i=>S.URI.revive(i))}}e.reviveQuery=u;function p(E){return{...E,folder:S.URI.revive(E.folder)}}}),define(Pe[291],Te([1,0,20,15,5,6,11,32,2,146,142,130,93,22,42,14,56,57,197,3,237,269,79,238,244,245,246,247,248,223,212,31,249,37,250,117,107,251,225,239,252,253,66,64,240,38,255,62,256,43,27,270,271,241,226,257,258,80,81,228,284,260,201,261,272,262,112,229,263,264,265,17,266,118,82,267,230,268,83,85,115,60,65,273,274,242,275,276,86,8,7,231,58,232,61,277,278,106,36,207,78,24,114]),function(me,e,I,L,C,A,T,g,h,S,R,D,u,p,E,i,a,r,n,o,c,l,t,d,s,b,_,f,w,P,m,v,y,O,N,q,W,x,k,M,$,oe,de,we,ye,le,ve,ae,pe,re,J,H,ne,Ae,Re,ke,ce,te,K,ee,ge,be,Le,fe,_e,F,V,j,B,X,Z,Se,Ne,$e,qe,Qe,nt,it,et,rt,ct,Be,gt,Q,Y,Ee,ze,Ge,tt,st,Fe,Ut,At,jt,Ot,_t,Wt,Ft,Qt,$t,xt,Ye,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Kt(ut){const pt=ut.get(J.IExtHostInitDataService),Bt=ut.get(re.IExtHostFileSystemInfo),Gt=ut.get(ae.IExtHostConsumerFileSystem),St=ut.get(le.IExtHostExtensionService),ht=ut.get(Qt.IExtHostWorkspace),It=ut.get(Be.IExtHostTelemetry),Zt=ut.get(O.IExtHostConfiguration),kt=ut.get(At.IURITransformerService),Ve=ut.get(Se.IExtHostRpcService),Rt=ut.get(et.IExtHostStorage),Nt=ut.get(rt.IExtensionStoragePaths),Xt=ut.get(i.ILoggerService),ft=ut.get(i.ILogService),Lt=ut.get(tt.IExtHostTunnelService),Pt=ut.get(t.IExtHostApiDeprecationService),zt=ut.get(Ft.IExtHostWindow),De=ut.get(qe.IExtHostSecretState),Oe=ut.get(we.IExtHostEditorTabs),he=ut.get(K.IExtHostManagedSockets);Ve.set(o.ExtHostContext.ExtHostFileSystemInfo,Bt),Ve.set(o.ExtHostContext.ExtHostLogLevelServiceShape,Xt),Ve.set(o.ExtHostContext.ExtHostWorkspace,ht),Ve.set(o.ExtHostContext.ExtHostConfiguration,Zt),Ve.set(o.ExtHostContext.ExtHostExtensionService,St),Ve.set(o.ExtHostContext.ExtHostStorage,Rt),Ve.set(o.ExtHostContext.ExtHostTunnelService,Lt),Ve.set(o.ExtHostContext.ExtHostWindow,zt),Ve.set(o.ExtHostContext.ExtHostSecretState,De),Ve.set(o.ExtHostContext.ExtHostTelemetry,It),Ve.set(o.ExtHostContext.ExtHostEditorTabs,Oe),Ve.set(o.ExtHostContext.ExtHostManagedSockets,he);const G=Ve.set(o.ExtHostContext.ExtHostDecorations,ut.get(W.IExtHostDecorations)),Ce=Ve.set(o.ExtHostContext.ExtHostDocumentsAndEditors,ut.get(de.IExtHostDocumentsAndEditors)),Ue=Ve.set(o.ExtHostContext.ExtHostCommands,ut.get(v.IExtHostCommands)),Xe=Ve.set(o.ExtHostContext.ExtHostTerminalService,ut.get(gt.IExtHostTerminalService)),He=Ve.set(o.ExtHostContext.ExtHostDebugService,ut.get(q.IExtHostDebugService)),ot=Ve.set(o.ExtHostContext.ExtHostSearch,ut.get($e.IExtHostSearch)),wt=Ve.set(o.ExtHostContext.ExtHostTask,ut.get(ct.IExtHostTask)),qt=Ve.set(o.ExtHostContext.ExtHostOutputService,ut.get(V.IExtHostOutputService)),yt=Ve.set(o.ExtHostContext.ExtHostLocalization,ut.get(te.IExtHostLocalizationService)),Dt=Ve.set(o.ExtHostContext.ExtHostUrls,new jt.ExtHostUrls(Ve)),bt=Ve.set(o.ExtHostContext.ExtHostDocuments,new oe.ExtHostDocuments(Ve,Ce)),Di=Ve.set(o.ExtHostContext.ExtHostDocumentContentProviders,new M.ExtHostDocumentContentProvider(Ve,Ce,ft)),ji=Ve.set(o.ExtHostContext.ExtHostDocumentSaveParticipant,new $.ExtHostDocumentSaveParticipant(ft,bt,Ve.getProxy(o.MainContext.MainThreadBulkEdits))),Ct=Ve.set(o.ExtHostContext.ExtHostNotebook,new ge.ExtHostNotebookController(Ve,Ue,Ce,bt,Gt,ot)),si=Ve.set(o.ExtHostContext.ExtHostNotebookDocuments,new Le.ExtHostNotebookDocuments(Ct)),gi=Ve.set(o.ExtHostContext.ExtHostNotebookEditors,new fe.ExtHostNotebookEditors(ft,Ct)),li=Ve.set(o.ExtHostContext.ExtHostNotebookKernels,new _e.ExtHostNotebookKernels(Ve,pt,Ct,Ue,ft)),Ii=Ve.set(o.ExtHostContext.ExtHostNotebookRenderers,new F.ExtHostNotebookRenderers(Ve,Ct)),Ci=Ve.set(o.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new be.ExtHostNotebookDocumentSaveParticipant(ft,Ct,Ve.getProxy(o.MainContext.MainThreadBulkEdits))),Mt=Ve.set(o.ExtHostContext.ExtHostEditors,new Y.ExtHostEditors(Ve,Ce)),pi=Ve.set(o.ExtHostContext.ExtHostTreeViews,new Ge.ExtHostTreeViews(Ve.getProxy(o.MainContext.MainThreadTreeViews),Ue,ft)),ki=Ve.set(o.ExtHostContext.ExtHostEditorInsets,new m.ExtHostEditorInsets(Ve.getProxy(o.MainContext.MainThreadEditorInsets),Mt,pt.remote)),ui=Ve.set(o.ExtHostContext.ExtHostDiagnostics,new x.ExtHostDiagnostics(Ve,ft,Bt,Ce)),di=Ve.set(o.ExtHostContext.ExtHostLanguages,new ce.ExtHostLanguages(Ve,bt,Ue.converter,kt)),dt=Ve.set(o.ExtHostContext.ExtHostLanguageFeatures,new ke.ExtHostLanguageFeatures(Ve,kt,bt,Ue,ui,ft,Pt,It)),Ki=Ve.set(o.ExtHostContext.ExtHostFileSystem,new ve.ExtHostFileSystem(Ve,dt)),ei=Ve.set(o.ExtHostContext.ExtHostFileSystemEventService,new pe.ExtHostFileSystemEventService(Ve,ft,Ce)),oi=Ve.set(o.ExtHostContext.ExtHostQuickOpen,(0,Z.createExtHostQuickOpen)(Ve,ht,Ue)),vi=Ve.set(o.ExtHostContext.ExtHostSCM,new Ne.ExtHostSCM(Ve,Ue,bt,ft)),Pi=Ve.set(o.ExtHostContext.ExtHostQuickDiff,new X.ExtHostQuickDiff(Ve,kt)),Gi=Ve.set(o.ExtHostContext.ExtHostShare,new Qe.ExtHostShare(Ve,kt)),Ti=Ve.set(o.ExtHostContext.ExtHostComments,(0,y.createExtHostComments)(Ve,Ue,bt)),Ei=Ve.set(o.ExtHostContext.ExtHostProgress,new B.ExtHostProgress(Ve.getProxy(o.MainContext.MainThreadProgress))),Xi=Ve.set(o.ExtHostContext.ExtHostLabelService,new Re.ExtHostLabelService(Ve)),Ai=Ve.set(o.ExtHostContext.ExtHostTheming,new Ee.ExtHostTheming(Ve)),hi=Ve.set(o.ExtHostContext.ExtHostAuthentication,new d.ExtHostAuthentication(Ve)),Qi=Ve.set(o.ExtHostContext.ExtHostTimeline,new ze.ExtHostTimeline(Ve,Ue)),bi=Ve.set(o.ExtHostContext.ExtHostWebviews,new Ot.ExtHostWebviews(Ve,pt.remote,ht,ft,Pt)),Ri=Ve.set(o.ExtHostContext.ExtHostWebviewPanels,new _t.ExtHostWebviewPanels(Ve,bi,ht)),un=Ve.set(o.ExtHostContext.ExtHostCustomEditors,new N.ExtHostCustomEditors(Ve,bt,Nt,bi,Ri)),Li=Ve.set(o.ExtHostContext.ExtHostWebviewViews,new Wt.ExtHostWebviewViews(Ve,bi)),ai=Ve.set(o.ExtHostContext.ExtHostTesting,new Q.ExtHostTesting(Ve,ft,Ue,Ce)),dn=Ve.set(o.ExtHostContext.ExtHostUriOpeners,new Ut.ExtHostUriOpeners(Ve)),hn=Ve.set(o.ExtHostContext.ExtHostProfileContentHandlers,new j.ExtHostProfileContentHandlers(Ve));Ve.set(o.ExtHostContext.ExtHostInteractive,new ne.ExtHostInteractive(Ve,Ct,Ce,Ue,ft));const Yi=Ve.set(o.ExtHostContext.ExtHostInlineChat,new H.ExtHostInteractiveEditor(Ve,Ue,bt,ft)),Oi=Ve.set(o.ExtHostContext.ExtHostChatProvider,new f.ExtHostChatProvider(Ve,ft)),Fi=Ve.set(o.ExtHostContext.ExtHostChatAgents2,new _.ExtHostChatAgents2(Ve,Oi,ft)),Ji=Ve.set(o.ExtHostContext.ExtHostChatVariables,new w.ExtHostChatVariables(Ve)),wi=Ve.set(o.ExtHostContext.ExtHostChat,new b.ExtHostChat(Ve)),Ni=Ve.set(o.ExtHostContext.ExtHostAiRelatedInformation,new c.ExtHostRelatedInformation(Ve)),fn=Ve.set(o.ExtHostContext.ExtHostAiEmbeddingVector,new ye.ExtHostAiEmbeddingVector(Ve)),_i=Ve.set(o.ExtHostContext.ExtHostIssueReporter,new Ae.ExtHostIssueReporter(Ve)),Mi=Ve.set(o.ExtHostContext.ExtHostStatusBar,new it.ExtHostStatusBar(Ve,Ue.converter)),ni=Ve.set(o.ExtHostContext.ExtHostSpeech,new nt.ExtHostSpeech(Ve)),Si=Object.values(o.ExtHostContext);Ve.assertRegistered(Si);const mn=new s.ExtHostBulkEdits(Ve,Ce),Yt=new P.ExtHostClipboard(Ve),fi=new ee.ExtHostMessageService(Ve,ft),Ui=new k.ExtHostDialogs(Ve);return l.ExtHostApiCommands.register(Ue),function(xe,ti,xi){function Ze(ie){return(ue,Me,at)=>{const Et=ie(Tt=>{try{ue.call(Me,Tt)}catch(ln){L.onUnexpectedExternalError(new Error(`[ExtensionListenerError] Extension '${xe.identifier.value}' FAILED to handle event`,{cause:ln})),It.onExtensionError(xe.identifier,ln)}});return at?.push(Et),Et}}const vt=function(){let ie=!xe.isUnderDevelopment;function ue(){ie||(ft.info(`Extension '${xe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Me(at){if(Array.isArray(at))at.forEach(Me);else if(typeof at=="string")ue();else{const Et=at;typeof Et.scheme>"u"&&ue(),typeof Et.exclusive=="boolean"&&(0,Ye.checkProposedApiEnabled)(xe,"documentFiltersExclusive")}return at}}(),Zi={getSession(ie,ue,Me){return hi.getSession(xe,ie,ue,Me)},getSessions(ie,ue){return(0,Ye.checkProposedApiEnabled)(xe,"authGetSessions"),hi.getSessions(xe,ie,ue)},async hasSession(ie,ue){return(0,Ye.checkProposedApiEnabled)(xe,"authSession"),!!await hi.getSession(xe,ie,ue,{silent:!0})},get onDidChangeSessions(){return Ze(hi.onDidChangeSessions)},registerAuthenticationProvider(ie,ue,Me,at){return hi.registerAuthenticationProvider(ie,ue,Me,at)}},gn={registerCommand(ie,ue,Me){return Ue.registerCommand(!0,ie,ue,Me,void 0,xe)},registerTextEditorCommand(ie,ue,Me){return Ue.registerCommand(!0,ie,(...at)=>{const Et=Mt.getActiveTextEditor();if(!Et){ft.warn("Cannot execute "+ie+" because there is no active text editor.");return}return Et.edit(Tt=>{ue.apply(Me,[Et,Tt,...at])}).then(Tt=>{Tt||ft.warn("Edits from command "+ie+" were not applied.")},Tt=>{ft.warn("An error occurred while running command "+ie,Tt)})},void 0,void 0,xe)},registerDiffInformationCommand:(ie,ue,Me)=>((0,Ye.checkProposedApiEnabled)(xe,"diffCommand"),Ue.registerCommand(!0,ie,async(...at)=>{const Et=Ce.activeEditor(!0);if(!Et){ft.warn("Cannot execute "+ie+" because there is no active text editor.");return}const Tt=await Mt.getDiffInformation(Et.id);ue.apply(Me,[Tt,...at])},void 0,void 0,xe)),executeCommand(ie,...ue){return Ue.executeCommand(ie,...ue)},getCommands(ie=!1){return Ue.getCommands(ie)}},en={get machineId(){return pt.telemetryInfo.machineId},get sessionId(){return pt.telemetryInfo.sessionId},get language(){return pt.environment.appLanguage},get appName(){return pt.environment.appName},get appRoot(){return pt.environment.appRoot?.fsPath??""},get appHost(){return pt.environment.appHost},get uriScheme(){return pt.environment.appUriScheme},get clipboard(){return Yt.value},get shell(){return Xe.getDefaultShell(!1)},get onDidChangeShell(){return Ze(Xe.onDidChangeShell)},get isTelemetryEnabled(){return It.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ze(It.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ye.checkProposedApiEnabled)(xe,"telemetry"),It.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.checkProposedApiEnabled)(xe,"telemetry"),Ze(It.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Be.isNewAppInstall)(pt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ie,ue){return Be.ExtHostTelemetryLogger.validateSender(ie),It.instantiateLogger(xe,ie,ue)},openExternal(ie,ue){return zt.openUri(ie,{allowTunneling:!!pt.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===pt.environment.appUriScheme)return Dt.createAppUri(ie);try{return await zt.asExternalUri(ie,{allowTunneling:!!pt.remote.authority})}catch(ue){if((0,T.matchesScheme)(ie,T.Schemas.http)||(0,T.matchesScheme)(ie,T.Schemas.https))return ie;throw ue}},get remoteName(){return(0,a.getRemoteName)(pt.remote.authority)},get remoteAuthority(){return(0,Ye.checkProposedApiEnabled)(xe,"resolvers"),pt.remote.authority},get uiKind(){return pt.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return Ze(ft.onDidChangeLogLevel)},registerIssueUriRequestHandler(ie){return(0,Ye.checkProposedApiEnabled)(xe,"handleIssueUri"),_i.registerIssueUriRequestHandler(xe,ie)},registerIssueDataProvider(ie){return(0,Ye.checkProposedApiEnabled)(xe,"handleIssueUri"),_i.registerIssueDataProvider(xe,ie)},get appQuality(){return(0,Ye.checkProposedApiEnabled)(xe,"resolvers"),pt.quality},get appCommit(){return(0,Ye.checkProposedApiEnabled)(xe,"resolvers"),pt.commit}};pt.environment.extensionTestsLocationURI||Object.freeze(en);const tn={createTestController(ie,ue,Me){return ai.createTestController(xe,ie,ue,Me)},createTestObserver(){return(0,Ye.checkProposedApiEnabled)(xe,"testObserver"),ai.createTestObserver()},runTests(ie){return(0,Ye.checkProposedApiEnabled)(xe,"testObserver"),ai.runTests(ie)},get onDidChangeTestResults(){return(0,Ye.checkProposedApiEnabled)(xe,"testObserver"),Ze(ai.onResultsChanged)},get testResults(){return(0,Ye.checkProposedApiEnabled)(xe,"testObserver"),ai.results}},mi=pt.remote.isRemote?Fe.ExtensionKind.Workspace:Fe.ExtensionKind.UI,nn={getExtension(ie,ue){(0,Ye.isProposedApiEnabled)(xe,"extensionsAny")||(ue=!1);const Me=ti.mine.getExtensionDescription(ie);if(Me)return new le.Extension(St,xe.identifier,Me,mi,!1);if(ue){const at=ti.all.getExtensionDescription(ie);if(at)return new le.Extension(St,xe.identifier,at,mi,!0)}},get all(){const ie=[];for(const ue of ti.mine.getAllExtensionDescriptions())ie.push(new le.Extension(St,xe.identifier,ue,mi,!1));return ie},get allAcrossExtensionHosts(){(0,Ye.checkProposedApiEnabled)(xe,"extensionsAny");const ie=new p.ExtensionIdentifierSet(ti.mine.getAllExtensionDescriptions().map(Me=>Me.identifier)),ue=[];for(const Me of ti.all.getAllExtensionDescriptions()){const at=!ie.has(Me.identifier);ue.push(new le.Extension(St,xe.identifier,Me,mi,at))}return ue},get onDidChange(){return(0,Ye.isProposedApiEnabled)(xe,"extensionsAny")?Ze(C.Event.any(ti.mine.onDidChange,ti.all.onDidChange)):Ze(ti.mine.onDidChange)}},rn={createDiagnosticCollection(ie){return ui.createDiagnosticCollection(xe.identifier,ie)},get onDidChangeDiagnostics(){return Ze(ui.onDidChangeDiagnostics)},getDiagnostics:ie=>ui.getDiagnostics(ie),getLanguages(){return di.getLanguages()},setTextDocumentLanguage(ie,ue){return di.changeLanguage(ie.uri,ue)},match(ie,ue){const Me=bt.getDocumentData(ue.uri)?.notebook;return(0,R.score)(st.LanguageSelector.from(ie),ue.uri,ue.languageId,!0,Me?.uri,Me?.notebookType)},registerCodeActionsProvider(ie,ue,Me){return dt.registerCodeActionProvider(xe,vt(ie),ue,Me)},registerDocumentPasteEditProvider(ie,ue,Me){return(0,Ye.checkProposedApiEnabled)(xe,"documentPaste"),dt.registerDocumentPasteEditProvider(xe,vt(ie),ue,Me)},registerCodeLensProvider(ie,ue){return dt.registerCodeLensProvider(xe,vt(ie),ue)},registerDefinitionProvider(ie,ue){return dt.registerDefinitionProvider(xe,vt(ie),ue)},registerDeclarationProvider(ie,ue){return dt.registerDeclarationProvider(xe,vt(ie),ue)},registerImplementationProvider(ie,ue){return dt.registerImplementationProvider(xe,vt(ie),ue)},registerTypeDefinitionProvider(ie,ue){return dt.registerTypeDefinitionProvider(xe,vt(ie),ue)},registerHoverProvider(ie,ue){return dt.registerHoverProvider(xe,vt(ie),ue,xe.identifier)},registerEvaluatableExpressionProvider(ie,ue){return dt.registerEvaluatableExpressionProvider(xe,vt(ie),ue,xe.identifier)},registerInlineValuesProvider(ie,ue){return dt.registerInlineValuesProvider(xe,vt(ie),ue,xe.identifier)},registerDocumentHighlightProvider(ie,ue){return dt.registerDocumentHighlightProvider(xe,vt(ie),ue)},registerMultiDocumentHighlightProvider(ie,ue){return dt.registerMultiDocumentHighlightProvider(xe,vt(ie),ue)},registerLinkedEditingRangeProvider(ie,ue){return dt.registerLinkedEditingRangeProvider(xe,vt(ie),ue)},registerReferenceProvider(ie,ue){return dt.registerReferenceProvider(xe,vt(ie),ue)},registerRenameProvider(ie,ue){return dt.registerRenameProvider(xe,vt(ie),ue)},registerDocumentSymbolProvider(ie,ue,Me){return dt.registerDocumentSymbolProvider(xe,vt(ie),ue,Me)},registerWorkspaceSymbolProvider(ie){return dt.registerWorkspaceSymbolProvider(xe,ie)},registerDocumentFormattingEditProvider(ie,ue){return dt.registerDocumentFormattingEditProvider(xe,vt(ie),ue)},registerDocumentRangeFormattingEditProvider(ie,ue){return dt.registerDocumentRangeFormattingEditProvider(xe,vt(ie),ue)},registerOnTypeFormattingEditProvider(ie,ue,Me,...at){return dt.registerOnTypeFormattingEditProvider(xe,vt(ie),ue,[Me].concat(at))},registerDocumentSemanticTokensProvider(ie,ue,Me){return dt.registerDocumentSemanticTokensProvider(xe,vt(ie),ue,Me)},registerDocumentRangeSemanticTokensProvider(ie,ue,Me){return dt.registerDocumentRangeSemanticTokensProvider(xe,vt(ie),ue,Me)},registerSignatureHelpProvider(ie,ue,Me,...at){return typeof Me=="object"?dt.registerSignatureHelpProvider(xe,vt(ie),ue,Me):dt.registerSignatureHelpProvider(xe,vt(ie),ue,typeof Me>"u"?[]:[Me,...at])},registerCompletionItemProvider(ie,ue,...Me){return dt.registerCompletionItemProvider(xe,vt(ie),ue,Me)},registerInlineCompletionItemProvider(ie,ue,Me){return ue.handleDidShowCompletionItem&&(0,Ye.checkProposedApiEnabled)(xe,"inlineCompletionsAdditions"),ue.handleDidPartiallyAcceptCompletionItem&&(0,Ye.checkProposedApiEnabled)(xe,"inlineCompletionsAdditions"),Me&&(0,Ye.checkProposedApiEnabled)(xe,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(xe,vt(ie),ue,Me)},registerDocumentLinkProvider(ie,ue){return dt.registerDocumentLinkProvider(xe,vt(ie),ue)},registerColorProvider(ie,ue){return dt.registerColorProvider(xe,vt(ie),ue)},registerFoldingRangeProvider(ie,ue){return dt.registerFoldingRangeProvider(xe,vt(ie),ue)},registerSelectionRangeProvider(ie,ue){return dt.registerSelectionRangeProvider(xe,ie,ue)},registerCallHierarchyProvider(ie,ue){return dt.registerCallHierarchyProvider(xe,ie,ue)},registerTypeHierarchyProvider(ie,ue){return dt.registerTypeHierarchyProvider(xe,ie,ue)},setLanguageConfiguration:(ie,ue)=>dt.setLanguageConfiguration(xe,ie,ue),getTokenInformationAtPosition(ie,ue){return(0,Ye.checkProposedApiEnabled)(xe,"tokenInformation"),di.tokenAtPosition(ie,ue)},registerInlayHintsProvider(ie,ue){return dt.registerInlayHintsProvider(xe,ie,ue)},createLanguageStatusItem(ie,ue){return di.createLanguageStatusItem(xe,ie,ue)},registerDocumentDropEditProvider(ie,ue,Me){return dt.registerDocumentOnDropEditProvider(xe,ie,ue,(0,Ye.isProposedApiEnabled)(xe,"dropMetadata")?Me:void 0)}},sn={get activeTextEditor(){return Mt.getActiveTextEditor()},get visibleTextEditors(){return Mt.getVisibleTextEditors()},get activeTerminal(){return Xe.activeTerminal},get terminals(){return Xe.terminals},async showTextDocument(ie,ue,Me){const at=await(h.URI.isUri(ie)?Promise.resolve(on.openTextDocument(ie)):Promise.resolve(ie));return Mt.showTextDocument(at,ue,Me)},createTextEditorDecorationType(ie){return Mt.createTextEditorDecorationType(xe,ie)},onDidChangeActiveTextEditor(ie,ue,Me){return Ze(Mt.onDidChangeActiveTextEditor)(ie,ue,Me)},onDidChangeVisibleTextEditors(ie,ue,Me){return Ze(Mt.onDidChangeVisibleTextEditors)(ie,ue,Me)},onDidChangeTextEditorSelection(ie,ue,Me){return Ze(Mt.onDidChangeTextEditorSelection)(ie,ue,Me)},onDidChangeTextEditorOptions(ie,ue,Me){return Ze(Mt.onDidChangeTextEditorOptions)(ie,ue,Me)},onDidChangeTextEditorVisibleRanges(ie,ue,Me){return Ze(Mt.onDidChangeTextEditorVisibleRanges)(ie,ue,Me)},onDidChangeTextEditorViewColumn(ie,ue,Me){return Ze(Mt.onDidChangeTextEditorViewColumn)(ie,ue,Me)},onDidCloseTerminal(ie,ue,Me){return Ze(Xe.onDidCloseTerminal)(ie,ue,Me)},onDidOpenTerminal(ie,ue,Me){return Ze(Xe.onDidOpenTerminal)(ie,ue,Me)},onDidChangeActiveTerminal(ie,ue,Me){return Ze(Xe.onDidChangeActiveTerminal)(ie,ue,Me)},onDidChangeTerminalDimensions(ie,ue,Me){return(0,Ye.checkProposedApiEnabled)(xe,"terminalDimensions"),Ze(Xe.onDidChangeTerminalDimensions)(ie,ue,Me)},onDidChangeTerminalState(ie,ue,Me){return Ze(Xe.onDidChangeTerminalState)(ie,ue,Me)},onDidWriteTerminalData(ie,ue,Me){return(0,Ye.checkProposedApiEnabled)(xe,"terminalDataWriteEvent"),Ze(Xe.onDidWriteTerminalData)(ie,ue,Me)},onDidExecuteTerminalCommand(ie,ue,Me){return(0,Ye.checkProposedApiEnabled)(xe,"terminalExecuteCommandEvent"),Ze(Xe.onDidExecuteTerminalCommand)(ie,ue,Me)},get state(){return zt.getState(xe)},onDidChangeWindowState(ie,ue,Me){return Ze(zt.onDidChangeWindowState)(ie,ue,Me)},showInformationMessage(ie,...ue){return fi.showMessage(xe,g.default.Info,ie,ue[0],ue.slice(1))},showWarningMessage(ie,...ue){return fi.showMessage(xe,g.default.Warning,ie,ue[0],ue.slice(1))},showErrorMessage(ie,...ue){return fi.showMessage(xe,g.default.Error,ie,ue[0],ue.slice(1))},showQuickPick(ie,ue,Me){return oi.showQuickPick(xe,ie,ue,Me)},showWorkspaceFolderPick(ie){return oi.showWorkspaceFolderPick(ie)},showInputBox(ie,ue){return oi.showInput(ie,ue)},showOpenDialog(ie){return Ui.showOpenDialog(xe,ie)},showSaveDialog(ie){return Ui.showSaveDialog(ie)},createStatusBarItem(ie,ue,Me){let at,Et,Tt;return typeof ie=="string"?(at=ie,Et=ue,Tt=Me):(Et=ie,Tt=ue),Mi.createStatusBarEntry(xe,at,Et,Tt)},setStatusBarMessage(ie,ue){return Mi.setStatusBarMessage(ie,ue)},withScmProgress(ie){return Pt.report("window.withScmProgress",xe,"Use 'withProgress' instead."),Ei.withProgress(xe,{location:Fe.ProgressLocation.SourceControl},(ue,Me)=>ie({report(at){}}))},withProgress(ie,ue){return Ei.withProgress(xe,ie,ue)},createOutputChannel(ie,ue){return qt.createOutputChannel(ie,ue,xe)},createWebviewPanel(ie,ue,Me,at){return Ri.createWebviewPanel(xe,ie,ue,Me,at)},createWebviewTextEditorInset(ie,ue,Me,at){return(0,Ye.checkProposedApiEnabled)(xe,"editorInsets"),ki.createWebviewEditorInset(ie,ue,Me,at,xe)},createTerminal(ie,ue,Me){return typeof ie=="object"?"pty"in ie?Xe.createExtensionTerminal(ie):Xe.createTerminalFromOptions(ie):Xe.createTerminal(ie,ue,Me)},registerTerminalLinkProvider(ie){return Xe.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,ue){return Xe.registerProfileProvider(xe,ie,ue)},registerTerminalQuickFixProvider(ie,ue){return(0,Ye.checkProposedApiEnabled)(xe,"terminalQuickFixProvider"),Xe.registerTerminalQuickFixProvider(ie,xe.identifier.value,ue)},registerTreeDataProvider(ie,ue){return pi.registerTreeDataProvider(ie,ue,xe)},createTreeView(ie,ue){return pi.createTreeView(ie,ue,xe)},registerWebviewPanelSerializer:(ie,ue)=>Ri.registerWebviewPanelSerializer(xe,ie,ue),registerCustomEditorProvider:(ie,ue,Me={})=>un.registerCustomEditorProvider(xe,ie,ue,Me),registerFileDecorationProvider(ie){return G.registerFileDecorationProvider(ie,xe)},registerUriHandler(ie){return Dt.registerUriHandler(xe,ie)},createQuickPick(){return oi.createQuickPick(xe)},createInputBox(){return oi.createInputBox(xe)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(ie,ue,Me){return Ze(Ai.onDidChangeActiveColorTheme)(ie,ue,Me)},registerWebviewViewProvider(ie,ue,Me){return Li.registerWebviewViewProvider(xe,ie,ue,Me?.webviewOptions)},get activeNotebookEditor(){return Ct.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,ue,Me){return Ze(Ct.onDidChangeActiveNotebookEditor)(ie,ue,Me)},get visibleNotebookEditors(){return Ct.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Ze(Ct.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ie,ue,Me){return Ze(gi.onDidChangeNotebookEditorSelection)(ie,ue,Me)},onDidChangeNotebookEditorVisibleRanges(ie,ue,Me){return Ze(gi.onDidChangeNotebookEditorVisibleRanges)(ie,ue,Me)},showNotebookDocument(ie,ue){return Ct.showNotebookDocument(ie,ue)},registerExternalUriOpener(ie,ue,Me){return(0,Ye.checkProposedApiEnabled)(xe,"externalUriOpener"),dn.registerExternalUriOpener(xe.identifier,ie,ue,Me)},registerProfileContentHandler(ie,ue){return(0,Ye.checkProposedApiEnabled)(xe,"profileContentHandlers"),hn.registerProfileContentHandler(xe,ie,ue)},registerQuickDiffProvider(ie,ue,Me,at){return(0,Ye.checkProposedApiEnabled)(xe,"quickDiffProvider"),Pi.registerQuickDiffProvider(vt(ie),ue,Me,at)},get tabGroups(){return Oe.tabGroups},registerShareProvider(ie,ue){return(0,Ye.checkProposedApiEnabled)(xe,"shareProvider"),Gi.registerShareProvider(vt(ie),ue)}},on={get rootPath(){return Pt.report("workspace.rootPath",xe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(ie){throw new L.ReadonlyError("rootPath")},getWorkspaceFolder(ie){return ht.getWorkspaceFolder(ie)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(ie){throw new L.ReadonlyError("name")},get workspaceFile(){return ht.workspaceFile},set workspaceFile(ie){throw new L.ReadonlyError("workspaceFile")},updateWorkspaceFolders:(ie,ue,...Me)=>ht.updateWorkspaceFolders(xe,ie,ue||0,...Me),onDidChangeWorkspaceFolders:function(ie,ue,Me){return Ze(ht.onDidChangeWorkspace)(ie,ue,Me)},asRelativePath:(ie,ue)=>ht.getRelativePath(ie,ue),findFiles:(ie,ue,Me,at)=>ht.findFiles(ie,ue,Me,xe.identifier,at),findTextInFiles:(ie,ue,Me,at)=>{(0,Ye.checkProposedApiEnabled)(xe,"findTextInFiles");let Et,Tt;return typeof ue=="object"?(Et=ue,Tt=Me):(Et={},Tt=ue,at=Me),ht.findTextInFiles(ie,Et||{},Tt,xe.identifier,at)},save:ie=>ht.save(ie),saveAs:ie=>ht.saveAs(ie),saveAll:ie=>ht.saveAll(ie),applyEdit(ie,ue){return mn.applyWorkspaceEdit(ie,xe,ue)},createFileSystemWatcher:(ie,ue,Me,at)=>{let Et;return typeof ue=="boolean"?Et={ignoreCreateEvents:!!ue,ignoreChangeEvents:!!Me,ignoreDeleteEvents:!!at,correlate:!1}:ue&&((0,Ye.checkProposedApiEnabled)(xe,"createFileSystemWatcher"),Et={...ue,correlate:!0}),ei.createFileSystemWatcher(ht,xe,ie,Et)},get textDocuments(){return bt.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw new L.ReadonlyError("textDocuments")},openTextDocument(ie){let ue;const Me=ie;if(typeof ie=="string")ue=Promise.resolve(h.URI.file(ie));else if(h.URI.isUri(ie))ue=Promise.resolve(ie);else if(!Me||typeof Me=="object")ue=bt.createDocumentData(Me);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(at=>bt.ensureDocumentData(at).then(Et=>Et.document))},onDidOpenTextDocument:(ie,ue,Me)=>Ze(bt.onDidAddDocument)(ie,ue,Me),onDidCloseTextDocument:(ie,ue,Me)=>Ze(bt.onDidRemoveDocument)(ie,ue,Me),onDidChangeTextDocument:(ie,ue,Me)=>Ze(bt.onDidChangeDocument)(ie,ue,Me),onDidSaveTextDocument:(ie,ue,Me)=>Ze(bt.onDidSaveDocument)(ie,ue,Me),onWillSaveTextDocument:(ie,ue,Me)=>Ze(ji.getOnWillSaveTextDocumentEvent(xe))(ie,ue,Me),get notebookDocuments(){return Ct.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,ue){let Me;if(h.URI.isUri(ie))Me=ie,await Ct.openNotebookDocument(ie);else if(typeof ie=="string")Me=h.URI.revive(await Ct.createNotebookDocument({viewType:ie,content:ue}));else throw new Error("Invalid arguments");return Ct.getNotebookDocument(Me).apiNotebook},onDidSaveNotebookDocument(ie,ue,Me){return Ze(si.onDidSaveNotebookDocument)(ie,ue,Me)},onDidChangeNotebookDocument(ie,ue,Me){return Ze(si.onDidChangeNotebookDocument)(ie,ue,Me)},onWillSaveNotebookDocument(ie,ue,Me){return Ze(Ci.getOnWillSaveNotebookDocumentEvent(xe))(ie,ue,Me)},get onDidOpenNotebookDocument(){return Ze(Ct.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return Ze(Ct.onDidCloseNotebookDocument)},registerNotebookSerializer(ie,ue,Me,at){return Ct.registerNotebookSerializer(xe,ie,ue,Me,(0,Ye.isProposedApiEnabled)(xe,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(ie,ue,Me)=>Ze(xi.onDidChangeConfiguration)(ie,ue,Me),getConfiguration(ie,ue){return ue=arguments.length===1?void 0:ue,xi.getConfiguration(ie,ue,xe)},registerTextDocumentContentProvider(ie,ue){return Di.registerTextDocumentContentProvider(ie,ue)},registerTaskProvider:(ie,ue)=>(Pt.report("window.registerTaskProvider",xe,"Use the corresponding function on the 'tasks' namespace instead"),wt.registerTaskProvider(xe,ie,ue)),registerFileSystemProvider(ie,ue,Me){return(0,A.combinedDisposable)(Ki.registerFileSystemProvider(xe,ie,ue,Me),Gt.addFileSystemProvider(ie,ue,Me))},get fs(){return Gt.value},registerFileSearchProvider:(ie,ue)=>((0,Ye.checkProposedApiEnabled)(xe,"fileSearchProvider"),ot.registerFileSearchProvider(ie,ue)),registerTextSearchProvider:(ie,ue)=>((0,Ye.checkProposedApiEnabled)(xe,"textSearchProvider"),ot.registerTextSearchProvider(ie,ue)),registerRemoteAuthorityResolver:(ie,ue)=>((0,Ye.checkProposedApiEnabled)(xe,"resolvers"),St.registerRemoteAuthorityResolver(ie,ue)),registerResourceLabelFormatter:ie=>((0,Ye.checkProposedApiEnabled)(xe,"resolvers"),Xi.$registerResourceLabelFormatter(ie)),getRemoteExecServer:ie=>((0,Ye.checkProposedApiEnabled)(xe,"resolvers"),St.getRemoteExecServer(ie)),onDidCreateFiles:(ie,ue,Me)=>Ze(ei.onDidCreateFile)(ie,ue,Me),onDidDeleteFiles:(ie,ue,Me)=>Ze(ei.onDidDeleteFile)(ie,ue,Me),onDidRenameFiles:(ie,ue,Me)=>Ze(ei.onDidRenameFile)(ie,ue,Me),onWillCreateFiles:(ie,ue,Me)=>Ze(ei.getOnWillCreateFileEvent(xe))(ie,ue,Me),onWillDeleteFiles:(ie,ue,Me)=>Ze(ei.getOnWillDeleteFileEvent(xe))(ie,ue,Me),onWillRenameFiles:(ie,ue,Me)=>Ze(ei.getOnWillRenameFileEvent(xe))(ie,ue,Me),openTunnel:ie=>((0,Ye.checkProposedApiEnabled)(xe,"tunnels"),Lt.openTunnel(xe,ie).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,Ye.checkProposedApiEnabled)(xe,"tunnels"),Lt.getTunnels()},onDidChangeTunnels:(ie,ue,Me)=>((0,Ye.checkProposedApiEnabled)(xe,"tunnels"),Ze(Lt.onDidChangeTunnels)(ie,ue,Me)),registerPortAttributesProvider:(ie,ue)=>((0,Ye.checkProposedApiEnabled)(xe,"portsAttributes"),Lt.registerPortsAttributesProvider(ie,ue)),registerTunnelProvider:(ie,ue)=>((0,Ye.checkProposedApiEnabled)(xe,"tunnelFactory"),Lt.registerTunnelProvider(ie,ue)),registerTimelineProvider:(ie,ue)=>((0,Ye.checkProposedApiEnabled)(xe,"timeline"),Qi.registerTimelineProvider(ie,ue,xe.identifier,Ue.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:ie=>((0,Ye.checkProposedApiEnabled)(xe,"workspaceTrust"),ht.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,ue,Me)=>Ze(ht.onDidGrantWorkspaceTrust)(ie,ue,Me),registerEditSessionIdentityProvider:(ie,ue)=>((0,Ye.checkProposedApiEnabled)(xe,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(ie,ue)),onWillCreateEditSessionIdentity:(ie,ue,Me)=>((0,Ye.checkProposedApiEnabled)(xe,"editSessionIdentityProvider"),Ze(ht.getOnWillCreateEditSessionIdentityEvent(xe))(ie,ue,Me)),registerCanonicalUriProvider:(ie,ue)=>((0,Ye.checkProposedApiEnabled)(xe,"canonicalUriProvider"),ht.registerCanonicalUriProvider(ie,ue)),getCanonicalUri:(ie,ue,Me)=>((0,Ye.checkProposedApiEnabled)(xe,"canonicalUriProvider"),ht.provideCanonicalUri(ie,ue,Me))},pn={get inputBox(){return Pt.report("scm.inputBox",xe,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(xe)},createSourceControl(ie,ue,Me){return vi.createSourceControl(xe,ie,ue,Me)}},an={createCommentController(ie,ue){return Ti.createCommentController(xe,ie,ue)}},cn={get activeDebugSession(){return He.activeDebugSession},get activeDebugConsole(){return He.activeDebugConsole},get breakpoints(){return He.breakpoints},get stackFrameFocus(){return He.stackFrameFocus},registerDebugVisualizationProvider(ie,ue){return(0,Ye.checkProposedApiEnabled)(xe,"debugVisualization"),He.registerDebugVisualizationProvider(xe,ie,ue)},onDidStartDebugSession(ie,ue,Me){return Ze(He.onDidStartDebugSession)(ie,ue,Me)},onDidTerminateDebugSession(ie,ue,Me){return Ze(He.onDidTerminateDebugSession)(ie,ue,Me)},onDidChangeActiveDebugSession(ie,ue,Me){return Ze(He.onDidChangeActiveDebugSession)(ie,ue,Me)},onDidReceiveDebugSessionCustomEvent(ie,ue,Me){return Ze(He.onDidReceiveDebugSessionCustomEvent)(ie,ue,Me)},onDidChangeBreakpoints(ie,ue,Me){return Ze(He.onDidChangeBreakpoints)(ie,ue,Me)},onDidChangeStackFrameFocus(ie,ue,Me){return(0,Ye.checkProposedApiEnabled)(xe,"debugFocus"),Ze(He.onDidChangeStackFrameFocus)(ie,ue,Me)},registerDebugConfigurationProvider(ie,ue,Me){return He.registerDebugConfigurationProvider(ie,ue,Me||$t.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,ue){return He.registerDebugAdapterDescriptorFactory(xe,ie,ue)},registerDebugAdapterTrackerFactory(ie,ue){return He.registerDebugAdapterTrackerFactory(ie,ue)},startDebugging(ie,ue,Me){return!Me||typeof Me=="object"&&"configuration"in Me?He.startDebugging(ie,ue,{parentSession:Me}):He.startDebugging(ie,ue,Me||{})},stopDebugging(ie){return He.stopDebugging(ie)},addBreakpoints(ie){return He.addBreakpoints(ie)},removeBreakpoints(ie){return He.removeBreakpoints(ie)},asDebugSourceUri(ie,ue){return He.asDebugSourceUri(ie,ue)}},Bi={registerTaskProvider:(ie,ue)=>wt.registerTaskProvider(xe,ie,ue),fetchTasks:ie=>wt.fetchTasks(ie),executeTask:ie=>wt.executeTask(xe,ie),get taskExecutions(){return wt.taskExecutions},onDidStartTask:(ie,ue,Me)=>Ze(wt.onDidStartTask)(ie,ue,Me),onDidEndTask:(ie,ue,Me)=>Ze(wt.onDidEndTask)(ie,ue,Me),onDidStartTaskProcess:(ie,ue,Me)=>Ze(wt.onDidStartTaskProcess)(ie,ue,Me),onDidEndTaskProcess:(ie,ue,Me)=>Ze(wt.onDidEndTaskProcess)(ie,ue,Me)},zi={createNotebookController(ie,ue,Me,at,Et){return li.createNotebookController(xe,ie,ue,Me,at,(0,Ye.isProposedApiEnabled)(xe,"notebookMessaging")?Et:void 0)},registerNotebookCellStatusBarItemProvider:(ie,ue)=>Ct.registerNotebookCellStatusBarItemProvider(xe,ie,ue),createRendererMessaging(ie){return Ii.createRendererMessaging(xe,ie)},createNotebookControllerDetectionTask(ie){return(0,Ye.checkProposedApiEnabled)(xe,"notebookKernelSource"),li.createNotebookControllerDetectionTask(xe,ie)},registerKernelSourceActionProvider(ie,ue){return(0,Ye.checkProposedApiEnabled)(xe,"notebookKernelSource"),li.registerKernelSourceActionProvider(xe,ie,ue)},onDidChangeNotebookCellExecutionState(ie,ue,Me){return(0,Ye.checkProposedApiEnabled)(xe,"notebookCellExecutionState"),Ze(li.onDidChangeNotebookCellExecutionState)(ie,ue,Me)}},$i={t(...ie){if(typeof ie[0]=="string"){const ue=ie.shift(),Me=!ie||typeof ie[0]!="object"?ie:ie[0];return yt.getMessage(xe.identifier.value,{message:ue,args:Me})}return yt.getMessage(xe.identifier.value,ie[0])},get bundle(){return yt.getBundle(xe.identifier.value)},get uri(){return yt.getBundleUri(xe.identifier.value)}},yi={_version:1,registerInteractiveEditorSessionProvider(ie,ue){return(0,Ye.checkProposedApiEnabled)(xe,"interactive"),Yi.registerProvider(xe,ie,ue)},registerInteractiveSessionProvider(ie,ue){return(0,Ye.checkProposedApiEnabled)(xe,"interactive"),wi.registerChatProvider(xe,ie,ue)},sendInteractiveRequestToProvider(ie,ue){return(0,Ye.checkProposedApiEnabled)(xe,"interactive"),wi.sendInteractiveRequestToProvider(ie,ue)},transferChatSession(ie,ue){return(0,Ye.checkProposedApiEnabled)(xe,"interactive"),wi.transferChatSession(ie,ue)}},Hi={getRelatedInformation(ie,ue){return(0,Ye.checkProposedApiEnabled)(xe,"aiRelatedInformation"),Ni.getRelatedInformation(xe,ie,ue)},registerRelatedInformationProvider(ie,ue){return(0,Ye.checkProposedApiEnabled)(xe,"aiRelatedInformation"),Ni.registerRelatedInformationProvider(xe,ie,ue)},registerEmbeddingVectorProvider(ie,ue){return(0,Ye.checkProposedApiEnabled)(xe,"aiRelatedInformation"),fn.registerEmbeddingVectorProvider(xe,ie,ue)}},Wi={registerChatResponseProvider(ie,ue,Me){return(0,Ye.checkProposedApiEnabled)(xe,"chatProvider"),Oi.registerProvider(xe.identifier,ie,ue,Me)},requestChatAccess(ie){return(0,Ye.checkProposedApiEnabled)(xe,"chatRequestAccess"),Oi.requestChatResponseProvider(xe.identifier,ie)},registerVariable(ie,ue,Me){return(0,Ye.checkProposedApiEnabled)(xe,"chatAgents2"),Ji.registerVariableResolver(xe,ie,ue,Me)},registerMappedEditsProvider(ie,ue){return(0,Ye.checkProposedApiEnabled)(xe,"mappedEditsProvider"),dt.registerMappedEditsProvider(xe,ie,ue)},createChatAgent(ie,ue){return(0,Ye.checkProposedApiEnabled)(xe,"chatAgents2"),Fi.createChatAgent(xe,ie,ue)}},vn={registerSpeechProvider(ie,ue){return(0,Ye.checkProposedApiEnabled)(xe,"speech"),ni.registerProvider(xe.identifier,ie,ue)}};return{version:pt.version,ai:Hi,authentication:Zi,commands:gn,comments:an,chat:Wi,debug:cn,env:en,extensions:nn,interactive:yi,l10n:$i,languages:rn,notebooks:zi,scm:pn,speech:vn,tasks:Bi,tests:tn,window:sn,workspace:on,Breakpoint:Fe.Breakpoint,TerminalOutputAnchor:Fe.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Fe.ChatAgentResultFeedbackKind,ChatMessage:Fe.ChatMessage,ChatMessageRole:Fe.ChatMessageRole,ChatVariableLevel:Fe.ChatVariableLevel,ChatAgentCompletionItem:Fe.ChatAgentCompletionItem,CallHierarchyIncomingCall:Fe.CallHierarchyIncomingCall,CallHierarchyItem:Fe.CallHierarchyItem,CallHierarchyOutgoingCall:Fe.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:I.CancellationTokenSource,CandidatePortSource:o.CandidatePortSource,CodeAction:Fe.CodeAction,CodeActionKind:Fe.CodeActionKind,CodeActionTriggerKind:Fe.CodeActionTriggerKind,CodeLens:Fe.CodeLens,Color:Fe.Color,ColorInformation:Fe.ColorInformation,ColorPresentation:Fe.ColorPresentation,ColorThemeKind:Fe.ColorThemeKind,CommentMode:Fe.CommentMode,CommentState:Fe.CommentState,CommentThreadCollapsibleState:Fe.CommentThreadCollapsibleState,CommentThreadState:Fe.CommentThreadState,CompletionItem:Fe.CompletionItem,CompletionItemKind:Fe.CompletionItemKind,CompletionItemTag:Fe.CompletionItemTag,CompletionList:Fe.CompletionList,CompletionTriggerKind:Fe.CompletionTriggerKind,ConfigurationTarget:Fe.ConfigurationTarget,CustomExecution:Fe.CustomExecution,DebugAdapterExecutable:Fe.DebugAdapterExecutable,DebugAdapterInlineImplementation:Fe.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:Fe.DebugAdapterNamedPipeServer,DebugAdapterServer:Fe.DebugAdapterServer,DebugConfigurationProviderTriggerKind:$t.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Fe.DebugConsoleMode,DebugVisualization:Fe.DebugVisualization,DecorationRangeBehavior:Fe.DecorationRangeBehavior,Diagnostic:Fe.Diagnostic,DiagnosticRelatedInformation:Fe.DiagnosticRelatedInformation,DiagnosticSeverity:Fe.DiagnosticSeverity,DiagnosticTag:Fe.DiagnosticTag,Disposable:Fe.Disposable,DocumentHighlight:Fe.DocumentHighlight,DocumentHighlightKind:Fe.DocumentHighlightKind,MultiDocumentHighlight:Fe.MultiDocumentHighlight,DocumentLink:Fe.DocumentLink,DocumentSymbol:Fe.DocumentSymbol,EndOfLine:Fe.EndOfLine,EnvironmentVariableMutatorType:Fe.EnvironmentVariableMutatorType,EvaluatableExpression:Fe.EvaluatableExpression,InlineValueText:Fe.InlineValueText,InlineValueVariableLookup:Fe.InlineValueVariableLookup,InlineValueEvaluatableExpression:Fe.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:Fe.InlineCompletionTriggerKind,EventEmitter:C.Emitter,ExtensionKind:Fe.ExtensionKind,ExtensionMode:Fe.ExtensionMode,ExternalUriOpenerPriority:Fe.ExternalUriOpenerPriority,FileChangeType:Fe.FileChangeType,FileDecoration:Fe.FileDecoration,FileDecoration2:Fe.FileDecoration,FileSystemError:Fe.FileSystemError,FileType:E.FileType,FilePermission:E.FilePermission,FoldingRange:Fe.FoldingRange,FoldingRangeKind:Fe.FoldingRangeKind,FunctionBreakpoint:Fe.FunctionBreakpoint,InlineCompletionItem:Fe.InlineSuggestion,InlineCompletionList:Fe.InlineSuggestionList,Hover:Fe.Hover,IndentAction:D.IndentAction,Location:Fe.Location,MarkdownString:Fe.MarkdownString,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:Fe.ParameterInformation,PortAutoForwardAction:Fe.PortAutoForwardAction,Position:Fe.Position,ProcessExecution:Fe.ProcessExecution,ProgressLocation:Fe.ProgressLocation,QuickInputButtons:Fe.QuickInputButtons,Range:Fe.Range,RelativePattern:Fe.RelativePattern,Selection:Fe.Selection,SelectionRange:Fe.SelectionRange,SemanticTokens:Fe.SemanticTokens,SemanticTokensBuilder:Fe.SemanticTokensBuilder,SemanticTokensEdit:Fe.SemanticTokensEdit,SemanticTokensEdits:Fe.SemanticTokensEdits,SemanticTokensLegend:Fe.SemanticTokensLegend,ShellExecution:Fe.ShellExecution,ShellQuoting:Fe.ShellQuoting,SignatureHelp:Fe.SignatureHelp,SignatureHelpTriggerKind:Fe.SignatureHelpTriggerKind,SignatureInformation:Fe.SignatureInformation,SnippetString:Fe.SnippetString,SourceBreakpoint:Fe.SourceBreakpoint,StandardTokenType:Fe.StandardTokenType,StatusBarAlignment:Fe.StatusBarAlignment,SymbolInformation:Fe.SymbolInformation,SymbolKind:Fe.SymbolKind,SymbolTag:Fe.SymbolTag,Task:Fe.Task,TaskGroup:Fe.TaskGroup,TaskPanelKind:Fe.TaskPanelKind,TaskRevealKind:Fe.TaskRevealKind,TaskScope:Fe.TaskScope,TerminalLink:Fe.TerminalLink,TerminalQuickFixTerminalCommand:Fe.TerminalQuickFixCommand,TerminalQuickFixOpener:Fe.TerminalQuickFixOpener,TerminalLocation:Fe.TerminalLocation,TerminalProfile:Fe.TerminalProfile,TerminalExitReason:Fe.TerminalExitReason,TextDocumentSaveReason:Fe.TextDocumentSaveReason,TextEdit:Fe.TextEdit,SnippetTextEdit:Fe.SnippetTextEdit,TextEditorCursorStyle:S.TextEditorCursorStyle,TextEditorLineNumbersStyle:Fe.TextEditorLineNumbersStyle,TextEditorRevealType:Fe.TextEditorRevealType,TextEditorSelectionChangeKind:Fe.TextEditorSelectionChangeKind,SyntaxTokenType:Fe.SyntaxTokenType,TextDocumentChangeReason:Fe.TextDocumentChangeReason,ThemeColor:Fe.ThemeColor,ThemeIcon:Fe.ThemeIcon,TreeItem:Fe.TreeItem,TreeItemCheckboxState:Fe.TreeItemCheckboxState,TreeItemCollapsibleState:Fe.TreeItemCollapsibleState,TypeHierarchyItem:Fe.TypeHierarchyItem,UIKind:xt.UIKind,Uri:h.URI,ViewColumn:Fe.ViewColumn,WorkspaceEdit:Fe.WorkspaceEdit,DocumentDropEdit:Fe.DocumentDropEdit,DocumentPasteEdit:Fe.DocumentPasteEdit,InlayHint:Fe.InlayHint,InlayHintLabelPart:Fe.InlayHintLabelPart,InlayHintKind:Fe.InlayHintKind,RemoteAuthorityResolverError:Fe.RemoteAuthorityResolverError,ResolvedAuthority:Fe.ResolvedAuthority,ManagedResolvedAuthority:Fe.ManagedResolvedAuthority,SourceControlInputBoxValidationType:Fe.SourceControlInputBoxValidationType,ExtensionRuntime:Fe.ExtensionRuntime,TimelineItem:Fe.TimelineItem,NotebookRange:Fe.NotebookRange,NotebookCellKind:Fe.NotebookCellKind,NotebookCellExecutionState:Fe.NotebookCellExecutionState,NotebookCellData:Fe.NotebookCellData,NotebookData:Fe.NotebookData,NotebookRendererScript:Fe.NotebookRendererScript,NotebookCellStatusBarAlignment:Fe.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Fe.NotebookEditorRevealType,NotebookCellOutput:Fe.NotebookCellOutput,NotebookCellOutputItem:Fe.NotebookCellOutputItem,NotebookCellStatusBarItem:Fe.NotebookCellStatusBarItem,NotebookControllerAffinity:Fe.NotebookControllerAffinity,NotebookControllerAffinity2:Fe.NotebookControllerAffinity2,NotebookEdit:Fe.NotebookEdit,NotebookKernelSourceAction:Fe.NotebookKernelSourceAction,NotebookVariablesRequestKind:Fe.NotebookVariablesRequestKind,PortAttributes:Fe.PortAttributes,LinkedEditingRanges:Fe.LinkedEditingRanges,TestResultState:Fe.TestResultState,TestRunRequest:Fe.TestRunRequest,TestMessage:Fe.TestMessage,TestMessage2:Fe.TestMessage,TestTag:Fe.TestTag,TestRunProfileKind:Fe.TestRunProfileKind,TextSearchCompleteMessageType:Vt.TextSearchCompleteMessageType,DataTransfer:Fe.DataTransfer,DataTransferItem:Fe.DataTransferItem,CoveredCount:Fe.CoveredCount,FileCoverage:Fe.FileCoverage,StatementCoverage:Fe.StatementCoverage,BranchCoverage:Fe.BranchCoverage,FunctionCoverage:Fe.FunctionCoverage,WorkspaceTrustState:Fe.WorkspaceTrustState,LanguageStatusSeverity:Fe.LanguageStatusSeverity,QuickPickItemKind:Fe.QuickPickItemKind,InputBoxValidationSeverity:Fe.InputBoxValidationSeverity,TabInputText:Fe.TextTabInput,TabInputTextDiff:Fe.TextDiffTabInput,TabInputTextMerge:Fe.TextMergeTabInput,TabInputCustom:Fe.CustomEditorTabInput,TabInputNotebook:Fe.NotebookEditorTabInput,TabInputNotebookDiff:Fe.NotebookDiffEditorTabInput,TabInputWebview:Fe.WebviewEditorTabInput,TabInputTerminal:Fe.TerminalEditorTabInput,TabInputInteractiveWindow:Fe.InteractiveWindowInput,TabInputChat:Fe.ChatEditorTabInput,TelemetryTrustedValue:r.TelemetryTrustedValue,LogLevel:i.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Fe.InteractiveSessionVoteDirection,ChatAgentCopyKind:Fe.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Fe.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Fe.StackFrameFocus,ThreadFocus:Fe.ThreadFocus,RelatedInformationType:Fe.RelatedInformationType,SpeechToTextStatus:Fe.SpeechToTextStatus,KeywordRecognitionStatus:Fe.KeywordRecognitionStatus}}}e.createApiFactoryAndRegisterActors=Kt}),define(Pe[292],Te([1,0,53,112,36,107,37,31,66,65,115,117,118,83,86,79,106,62,43,82,60,64,227,14,116,80,81]),function(me,e,I,L,C,A,T,g,h,S,R,D,u,p,E,i,a,r,n,o,c,l,t,d,s,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.registerSingleton)(b.IExtHostLocalizationService,b.ExtHostLocalizationService,1),(0,I.registerSingleton)(d.ILoggerService,t.ExtHostLoggerService,1),(0,I.registerSingleton)(i.IExtHostApiDeprecationService,i.ExtHostApiDeprecationService,1),(0,I.registerSingleton)(g.IExtHostCommands,g.ExtHostCommands,0),(0,I.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration,0),(0,I.registerSingleton)(r.IExtHostConsumerFileSystem,r.ExtHostConsumerFileSystem,0),(0,I.registerSingleton)(D.IExtHostDebugService,D.WorkerExtHostDebugService,0),(0,I.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations,0),(0,I.registerSingleton)(h.IExtHostDocumentsAndEditors,h.ExtHostDocumentsAndEditors,0),(0,I.registerSingleton)(_.IExtHostManagedSockets,_.ExtHostManagedSockets,0),(0,I.registerSingleton)(n.IExtHostFileSystemInfo,n.ExtHostFileSystemInfo,0),(0,I.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService,1),(0,I.registerSingleton)(u.IExtHostSearch,u.ExtHostSearch,0),(0,I.registerSingleton)(p.IExtHostStorage,p.ExtHostStorage,0),(0,I.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask,0),(0,I.registerSingleton)(S.IExtHostTerminalService,S.WorkerExtHostTerminalService,0),(0,I.registerSingleton)(E.IExtHostTunnelService,E.ExtHostTunnelService,0),(0,I.registerSingleton)(a.IExtHostWindow,a.ExtHostWindow,0),(0,I.registerSingleton)(C.IExtHostWorkspace,C.ExtHostWorkspace,0),(0,I.registerSingleton)(o.IExtHostSecretState,o.ExtHostSecretState,0),(0,I.registerSingleton)(c.IExtHostTelemetry,c.ExtHostTelemetry,0),(0,I.registerSingleton)(l.IExtHostEditorTabs,l.ExtHostEditorTabs,0),(0,I.registerSingleton)(s.IExtHostVariableResolverProvider,s.ExtHostVariableResolverProviderService,0)}),define(Pe[293],Te([1,0,291,38,2,288,7,13,233]),function(me,e,I,L,C,A,T,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class S extends A.RequireInterceptor{_installInterceptor(){}getModule(p,E){for(const i of this._alternatives){const a=i(p);if(a){p=a;break}}if(this._factories.has(p))return this._factories.get(p).load(p,E,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends L.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(h.ExtHostConsoleForwarder);const p=this._instaService.invokeFunction(I.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(S,p,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(p){return p.browser}async _loadCommonJSModule(p,E,i){E=E.with({path:D(E.path,".js")});const a=p?.identifier.value;a&&performance.mark(`code/extHost/willFetchExtensionCode/${a}`);const r=C.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(E)),n=await fetch(r.toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a}`),n.status!==200)throw new Error(n.statusText);const o=await n.text(),c=`${E.toString(!0)}#vscode-extension`,l=`${o}
//# sourceURL=${c}`;let t;try{t=new Function("module","exports","require",l)}catch(_){throw console.error(a?`Loading code for extension ${a} failed: ${_.message}`:`Loading code failed: ${_.message}`),console.error(`${E.toString(!0)}${typeof _.line=="number"?` line ${_.line}`:""}${typeof _.column=="number"?` column ${_.column}`:""}`),console.error(_),_}p&&await this._extHostLocalizationService.initializeLocalizedMessages(p);const d={},s={exports:d},b=_=>{const f=this._fakeModules.getModule(_,E);if(f===void 0)throw new Error(`Cannot load module '${_}'`);return f};try{return i.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a}`),t(s,d,b),s.exports!==d?s.exports:d}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a}`),i.codeLoadingStop()}}async $setRemoteEnvironment(p){}async _waitForDebuggerAttachment(p=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const E=Date.now()+p;for(;Date.now()<E&&!("__jsDebugIsReady"in globalThis);)await(0,g.timeout)(10)}}e.ExtHostExtensionService=R;function D(u,p){return u.endsWith(p)?u:u+p}}),define(Pe[294],Te([1,0,70,53,14,38,199,85,293]),function(me,e,I,L,C,A,T,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,L.registerSingleton)(C.ILogService,new I.SyncDescriptor(T.ExtHostLogService,[!0],!0)),(0,L.registerSingleton)(A.IExtHostExtensionService,h.ExtHostExtensionService,0),(0,L.registerSingleton)(g.IExtensionStoragePaths,g.ExtensionStoragePaths,0)}),define(Pe[299],Te([1,0,23,5,78,289,235,19,88,11,2,292,294]),function(me,e,I,L,C,A,T,g,h,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(t){return/^(file|vscode-remote):/i.test(t)}const E=fetch.bind(self);function i(t){self.fetch=async function(d,s){return d instanceof Request||p(String(d))&&(d=(await t(R.URI.parse(String(d)))).toString(!0)),E(d,s)},self.XMLHttpRequest=class extends XMLHttpRequest{open(d,s,b,_,f){(async()=>(p(s.toString())&&(s=(await t(R.URI.parse(s.toString()))).toString(!0)),super.open(d,s,b??!0,_,f)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(d,s){if(/^file:/i.test(d.toString()))d=S.FileAccess.uriToBrowserUri(R.URI.parse(d.toString())).toString(!0);else if(/^vscode-remote:/i.test(d.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const _=`(${function(m){function v(N){return typeof N=="string"||N instanceof URL?String(N).replace(/^file:\/\//i,"vscode-file://vscode-app"):N}const y=fetch.bind(self);self.fetch=function(N,q){return N instanceof Request?y(N,q):y(v(N),q)},self.XMLHttpRequest=class extends XMLHttpRequest{open(N,q,W,x,k){return super.open(N,v(q),W??!0,x,k)}};const O=importScripts.bind(self);self.importScripts=(...N)=>{O(...N.map(v))},O(m)}.toString()}('${d}'))`;s=s||{},s.name=s.name||g.basename(d.toString());const f=new Blob([_],{type:"application/javascript"}),w=URL.createObjectURL(f);return new t(w,s)}}else self.Worker=class extends T.NestedWorker{constructor(t,d){super(u,t,{name:g.basename(t.toString()),...d})}};const a=new class{constructor(){this.pid=void 0}exit(t){D()}};class r{constructor(){const d=new MessageChannel,s=new L.Emitter;let b=!1;u(d.port2,[d.port2]),d.port1.onmessage=_=>{const{data:f}=_;if(!(f instanceof ArrayBuffer)){console.warn("UNKNOWN data received",f);return}const w=I.VSBuffer.wrap(new Uint8Array(f,0,f.byteLength));if((0,C.isMessageOfType)(w,2)){b=!0,o("received terminate message from renderer");return}s.fire(w)},this.protocol={onMessage:s.event,send:_=>{if(!b){const f=_.buffer.buffer.slice(_.buffer.byteOffset,_.buffer.byteOffset+_.buffer.byteLength);d.port1.postMessage(f,[f])}}}}}function n(t){return new Promise(d=>{const s=t.onMessage(b=>{s.dispose();const _=JSON.parse(b.toString());t.send((0,C.createMessageOfType)(0)),d({protocol:t,initData:_})});t.send((0,C.createMessageOfType)(1))})}let o=t=>D();function c(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function l(){h.mark("code/extHost/willConnectToRenderer");const t=new r;return{onmessage(d){c(d)&&n(t.protocol).then(s=>{h.mark("code/extHost/didWaitForInitData");const b=new A.ExtensionHostMain(s.protocol,s.initData,a,null,d.data);i(_=>b.asBrowserUri(_)),o=_=>b.terminate(_)})}}}e.create=l})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/27d855b2b4105a2aca2445223c8f3dc4694fbd58/core/vs/workbench/api/worker/extensionHostWorker.js.map
